/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var De=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/errors","vs/base/common/async","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/platform","vs/platform/log/common/log","vs/workbench/api/common/extHostTypeConverters","vs/base/common/strings","vs/base/common/path","vs/base/common/network","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/base/node/pfs","vs/platform/files/common/files","vs/base/common/uuid","vs/base/common/extpath","vs/workbench/api/common/extHostCommands","vs/editor/common/core/range","vs/base/common/glob","vs/workbench/services/search/common/search","vs/base/common/stopwatch","vs/base/common/severity","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/platform/contextkey/common/contextkey","vs/platform/registry/common/platform","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/errorMessage","vs/base/common/process","child_process","vs/platform/configuration/common/configuration","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/hash","fs","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/decorators","vs/base/common/assert","vs/base/common/themables","net","vs/editor/common/core/position","vs/base/common/marshalling","os","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/files/common/watcher","vs/platform/progress/common/progress","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/arraysFind","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/product/common/productService","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/cache","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChat","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Ce=function(me){for(var e=[],C=0,T=me.length;C<T;C++)e[C]=De[me[C]];return e};define(De[156],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=e.$S=void 0,e.$S=!1;class C{static get(){const d=new Map,M=new Map,A=new Map,b=new Map;function E(y,D){y.has(D.detail)||y.set(D.detail,-D.timestamp)}function w(y,D){const v=y.get(D.detail);v&&(v>=0||y.set(D.detail,v+D.timestamp))}let R=[];typeof me=="function"&&typeof me.getStats=="function"&&(R=me.getStats().slice(0).sort((y,D)=>y.timestamp-D.timestamp));for(const y of R)switch(y.type){case 10:E(d,y);break;case 11:case 12:w(d,y);break;case 21:E(M,y);break;case 22:w(M,y);break;case 33:E(A,y);break;case 34:w(A,y);break;case 31:E(b,y);break;case 32:w(b,y);break}let I=0;A.forEach(y=>I+=y);function p(y){const D=[];return y.forEach((v,l)=>D.push([l,v])),D}return{amdLoad:p(d),amdInvoke:p(M),nodeRequire:p(A),nodeEval:p(b),nodeRequireTotal:I}}static toMarkdownTable(d,M){let A="";const b=[];return d.forEach((E,w)=>{b[w]=E.length}),M.forEach(E=>{E.forEach((w,R)=>{typeof w>"u"&&(w=E[R]="-");const I=w.toString().length;b[R]=Math.max(I,b[R])})}),d.forEach((E,w)=>{A+=`| ${E+" ".repeat(b[w]-E.toString().length)} `}),A+=`|
`,d.forEach((E,w)=>{A+=`| ${"-".repeat(b[w])} `}),A+=`|
`,M.forEach(E=>{E.forEach((w,R)=>{typeof w<"u"&&(A+=`| ${w+" ".repeat(b[R]-w.toString().length)} `)}),A+=`|
`}),A}}e.$T=C}),define(De[118],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=e.$eb=void 0;function C(v,l,s){const r=T(v,l);if(r!==-1)return v[r]}e.$eb=C;function T(v,l,s=v.length-1){for(let r=s;r>=0;r--){const c=v[r];if(l(c))return r}return-1}e.$fb=T;function d(v,l){const s=M(v,l);return s===-1?void 0:v[s]}e.$gb=d;function M(v,l,s=0,r=v.length){let c=s,m=r;for(;c<m;){const h=Math.floor((c+m)/2);l(v[h])?c=h+1:m=h}return c-1}e.$hb=M;function A(v,l){const s=b(v,l);return s===v.length?void 0:v[s]}e.$ib=A;function b(v,l,s=0,r=v.length){let c=s,m=r;for(;c<m;){const h=Math.floor((c+m)/2);l(v[h])?m=h:c=h+1}return c}e.$jb=b;function E(v,l,s=0,r=v.length){const c=b(v,l,s,r);return c===v.length?-1:c}e.$kb=E;class w{static{this.assertInvariants=!1}constructor(l){this.e=l,this.c=0}findLastMonotonous(l){if(w.assertInvariants){if(this.d){for(const r of this.e)if(this.d(r)&&!l(r))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=l}const s=M(this.e,l,this.c);return this.c=s+1,s===-1?void 0:this.e[s]}}e.$lb=w;function R(v,l){if(v.length===0)return;let s=v[0];for(let r=1;r<v.length;r++){const c=v[r];l(c,s)>0&&(s=c)}return s}e.$mb=R;function I(v,l){if(v.length===0)return;let s=v[0];for(let r=1;r<v.length;r++){const c=v[r];l(c,s)>=0&&(s=c)}return s}e.$nb=I;function p(v,l){return R(v,(s,r)=>-l(s,r))}e.$ob=p;function y(v,l){if(v.length===0)return-1;let s=0;for(let r=1;r<v.length;r++){const c=v[r];l(c,v[s])>0&&(s=r)}return s}e.$pb=y;function D(v,l){for(const s of v){const r=l(s);if(r!==void 0)return r}}e.$qb=D}),define(De[73],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M=e.$L=e.$K=e.$J=void 0;function C(A,b){const E=Object.create(null);for(const w of A){const R=b(w);let I=E[R];I||(I=E[R]=[]),I.push(w)}return E}e.$J=C;function T(A,b){const E=[],w=[];for(const R of A)b.has(R)||E.push(R);for(const R of b)A.has(R)||w.push(R);return{removed:E,added:w}}e.$K=T;function d(A,b){const E=[],w=[];for(const[R,I]of A)b.has(R)||E.push(I);for(const[R,I]of b)A.has(R)||w.push(I);return{removed:E,added:w}}e.$L=d;function M(A,b){const E=new Set;for(const w of b)A.has(w)&&E.add(w);return E}e.$M=M}),define(De[57],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hh=e.$gh=e.$fh=void 0;function C(A){return(b,E,w)=>{let R=null,I=null;if(typeof w.value=="function"?(R="value",I=w.value):typeof w.get=="function"&&(R="get",I=w.get),!I)throw new Error("not supported");w[R]=A(I,E)}}function T(A,b,E){let w=null,R=null;if(typeof E.value=="function"?(w="value",R=E.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof E.get=="function"&&(w="get",R=E.get),!R)throw new Error("not supported");const I=`$memoize$${b}`;E[w]=function(...p){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,p)}),this[I]}}e.$fh=T;function d(A,b,E){return C((w,R)=>{const I=`$debounce$${R}`,p=`$debounce$result$${R}`;return function(...y){this[p]||(this[p]=E?E():void 0),clearTimeout(this[I]),b&&(this[p]=b(this[p],...y),y=[this[p]]),this[I]=setTimeout(()=>{w.apply(this,y),this[p]=E?E():void 0},A)}})}e.$gh=d;function M(A,b,E){return C((w,R)=>{const I=`$throttle$timer$${R}`,p=`$throttle$result$${R}`,y=`$throttle$lastRun$${R}`,D=`$throttle$pending$${R}`;return function(...v){if(this[p]||(this[p]=E?E():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),b&&(this[p]=b(this[p],...v)),this[D])return;const l=this[y]+A;l<=Date.now()?(this[y]=Date.now(),w.apply(this,[this[p]]),this[p]=E?E():void 0):(this[D]=!0,this[I]=setTimeout(()=>{this[D]=!1,this[y]=Date.now(),w.apply(this,[this[p]]),this[p]=E?E():void 0},l-Date.now()))}})}e.$hh=M}),define(De[8],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.$Y=e.setUnexpectedErrorHandler=e.$W=e.$V=void 0;class C{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?c.isErrorNoTelemetry(t)?new c(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(n=>{n(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$V=C,e.$W=new C;function T(h){e.$W.setUnexpectedErrorHandler(h)}e.setUnexpectedErrorHandler=T;function d(h){if(!h||typeof h!="object")return!1;const t=h;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$Y=d;function M(h){w(h)||e.$W.onUnexpectedError(h)}e.$Z=M;function A(h){w(h)||e.$W.onUnexpectedExternalError(h)}e.$1=A;function b(h){if(h instanceof Error){const{name:t,message:n}=h,o=h.stacktrace||h.stack;return{$isError:!0,name:t,message:n,stack:o,noTelemetry:c.isErrorNoTelemetry(h)}}return h}e.$2=b;const E="Canceled";function w(h){return h instanceof R?!0:h instanceof Error&&h.name===E&&h.message===E}e.$3=w;class R extends Error{constructor(){super(E),this.name=this.message}}e.$4=R;function I(){const h=new Error(E);return h.name=h.message,h}e.$5=I;function p(h){return h?new Error(`Illegal argument: ${h}`):new Error("Illegal argument")}e.$6=p;function y(h){return h?new Error(`Illegal state: ${h}`):new Error("Illegal state")}e.$7=y;class D extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$8=D;function v(h){return h?h.message?h.message:h.stack?h.stack.split(`
`)[0]:String(h):"Error"}e.$9=v;class l extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$0=l;class s extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$$=s;class r extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$_=r;class c extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof c)return t;const n=new c;return n.message=t.message,n.stack=t.stack,n}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$ab=c;class m extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,m.prototype)}}e.$bb=m}),define(De[19],Ce([1,0,8,118]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.$6b=e.CompareResult=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.$Fb=e.top=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=e.$rb=void 0;function d(_,ie=0){return _[_.length-(1+ie)]}e.$rb=d;function M(_){if(_.length===0)throw new Error("Invalid tail call");return[_.slice(0,_.length-1),_[_.length-1]]}e.$sb=M;function A(_,ie,re=(Ee,oe)=>Ee===oe){if(_===ie)return!0;if(!_||!ie||_.length!==ie.length)return!1;for(let Ee=0,oe=_.length;Ee<oe;Ee++)if(!re(_[Ee],ie[Ee]))return!1;return!0}e.$tb=A;function b(_,ie){const re=_.length-1;ie<re&&(_[ie]=_[re]),_.pop()}e.$ub=b;function E(_,ie,re){return w(_.length,Ee=>re(_[Ee],ie))}e.$vb=E;function w(_,ie){let re=0,Ee=_-1;for(;re<=Ee;){const oe=(re+Ee)/2|0,he=ie(oe);if(he<0)re=oe+1;else if(he>0)Ee=oe-1;else return oe}return-(re+1)}e.$wb=w;function R(_,ie,re){if(_=_|0,_>=ie.length)throw new TypeError("invalid index");const Ee=ie[Math.floor(ie.length*Math.random())],oe=[],he=[],ee=[];for(const le of ie){const $e=re(le,Ee);$e<0?oe.push(le):$e>0?he.push(le):ee.push(le)}return _<oe.length?R(_,oe,re):_<oe.length+ee.length?ee[0]:R(_-(oe.length+ee.length),he,re)}e.$xb=R;function I(_,ie){const re=[];let Ee;for(const oe of _.slice(0).sort(ie))!Ee||ie(Ee[0],oe)!==0?(Ee=[oe],re.push(Ee)):Ee.push(oe);return re}e.$yb=I;function*p(_,ie){let re,Ee;for(const oe of _)Ee!==void 0&&ie(Ee,oe)?re.push(oe):(re&&(yield re),re=[oe]),Ee=oe;re&&(yield re)}e.$zb=p;function y(_,ie){for(let re=0;re<=_.length;re++)ie(re===0?void 0:_[re-1],re===_.length?void 0:_[re])}e.$Ab=y;function D(_,ie){for(let re=0;re<_.length;re++)ie(re===0?void 0:_[re-1],_[re],re+1===_.length?void 0:_[re+1])}e.$Bb=D;function v(_,ie,re){const Ee=[];function oe(le,$e,Pe){if($e===0&&Pe.length===0)return;const B=Ee[Ee.length-1];B&&B.start+B.deleteCount===le?(B.deleteCount+=$e,B.toInsert.push(...Pe)):Ee.push({start:le,deleteCount:$e,toInsert:Pe})}let he=0,ee=0;for(;;){if(he===_.length){oe(he,0,ie.slice(ee));break}if(ee===ie.length){oe(he,_.length-he,[]);break}const le=_[he],$e=ie[ee],Pe=re(le,$e);Pe===0?(he+=1,ee+=1):Pe<0?(oe(he,1,[]),he+=1):Pe>0&&(oe(he,0,[$e]),ee+=1)}return Ee}e.$Cb=v;function l(_,ie,re){const Ee=v(_,ie,re),oe=[],he=[];for(const ee of Ee)oe.push(..._.slice(ee.start,ee.start+ee.deleteCount)),he.push(...ee.toInsert);return{removed:oe,added:he}}e.$Db=l;function s(_,ie,re){if(re===0)return[];const Ee=_.slice(0,re).sort(ie);return c(_,ie,Ee,re,_.length),Ee}e.top=s;function r(_,ie,re,Ee,oe){return re===0?Promise.resolve([]):new Promise((he,ee)=>{(async()=>{const le=_.length,$e=_.slice(0,re).sort(ie);for(let Pe=re,B=Math.min(re+Ee,le);Pe<le;Pe=B,B=Math.min(B+Ee,le)){if(Pe>re&&await new Promise(Q=>setTimeout(Q)),oe&&oe.isCancellationRequested)throw new C.$4;c(_,ie,$e,Pe,B)}return $e})().then(he,ee)})}e.$Fb=r;function c(_,ie,re,Ee,oe){for(const he=re.length;Ee<oe;Ee++){const ee=_[Ee];if(ie(ee,re[he-1])<0){re.pop();const le=(0,T.$jb)(re,$e=>ie(ee,$e)<0);re.splice(le,0,ee)}}}function m(_){return _.filter(ie=>!!ie)}e.$Gb=m;function h(_){let ie=0;for(let re=0;re<_.length;re++)_[re]&&(_[ie]=_[re],ie+=1);_.length=ie}e.$Hb=h;function t(_,ie,re){_.splice(re,0,_.splice(ie,1)[0])}e.$Ib=t;function n(_){return!Array.isArray(_)||_.length===0}e.$Jb=n;function o(_){return Array.isArray(_)&&_.length>0}e.$Kb=o;function i(_,ie=re=>re){const re=new Set;return _.filter(Ee=>{const oe=ie(Ee);return re.has(oe)?!1:(re.add(oe),!0)})}e.$Lb=i;function a(_){const ie=new Set;return re=>{const Ee=_(re);return ie.has(Ee)?!1:(ie.add(Ee),!0)}}e.$Mb=a;function u(_,ie){return _.length>0?_[0]:ie}e.$Nb=u;function k(_,ie){return _.length>0?_[_.length-1]:ie}e.$Ob=k;function S(_,ie,re=(Ee,oe)=>Ee===oe){let Ee=0;for(let oe=0,he=Math.min(_.length,ie.length);oe<he&&re(_[oe],ie[oe]);oe++)Ee++;return Ee}e.$Pb=S;function $(_){return[].concat(..._)}e.$Qb=$;function g(_,ie){let re=typeof ie=="number"?_:0;typeof ie=="number"?re=_:(re=0,ie=_);const Ee=[];if(re<=ie)for(let oe=re;oe<ie;oe++)Ee.push(oe);else for(let oe=re;oe>ie;oe--)Ee.push(oe);return Ee}e.$Rb=g;function f(_,ie,re){return _.reduce((Ee,oe)=>(Ee[ie(oe)]=re?re(oe):oe,Ee),Object.create(null))}e.$Sb=f;function P(_,ie){return _.push(ie),()=>N(_,ie)}e.$Tb=P;function N(_,ie){const re=_.indexOf(ie);if(re>-1)return _.splice(re,1),ie}e.$Ub=N;function O(_,ie,re){const Ee=_.slice(0,ie),oe=_.slice(ie);return Ee.concat(re,oe)}e.$Vb=O;function L(_,ie){let re;if(typeof ie=="number"){let Ee=ie;re=()=>{const oe=Math.sin(Ee++)*179426549;return oe-Math.floor(oe)}}else re=Math.random;for(let Ee=_.length-1;Ee>0;Ee-=1){const oe=Math.floor(re()*(Ee+1)),he=_[Ee];_[Ee]=_[oe],_[oe]=he}}e.$Wb=L;function j(_,ie){const re=_.indexOf(ie);re>-1&&(_.splice(re,1),_.unshift(ie))}e.$Xb=j;function z(_,ie){const re=_.indexOf(ie);re>-1&&(_.splice(re,1),_.push(ie))}e.$Yb=z;function F(_,ie){for(const re of ie)_.push(re)}e.$Zb=F;function H(_,ie){return Array.isArray(_)?_.map(ie):ie(_)}e.$1b=H;function K(_){return Array.isArray(_)?_:[_]}e.$2b=K;function fe(_){return _[Math.floor(Math.random()*_.length)]}e.$3b=fe;function x(_,ie,re){const Ee=q(_,ie),oe=_.length,he=re.length;_.length=oe+he;for(let ee=oe-1;ee>=Ee;ee--)_[ee+he]=_[ee];for(let ee=0;ee<he;ee++)_[ee+Ee]=re[ee]}e.$4b=x;function Z(_,ie,re,Ee){const oe=q(_,ie);let he=_.splice(oe,re);return he===void 0&&(he=[]),x(_,oe,Ee),he}e.$5b=Z;function q(_,ie){return ie<0?Math.max(ie+_.length,0):Math.min(ie,_.length)}var Y;(function(_){function ie(he){return he<0}_.isLessThan=ie;function re(he){return he<=0}_.isLessThanOrEqual=re;function Ee(he){return he>0}_.isGreaterThan=Ee;function oe(he){return he===0}_.isNeitherLessOrGreaterThan=oe,_.greaterThan=1,_.lessThan=-1,_.neitherLessOrGreaterThan=0})(Y||(e.CompareResult=Y={}));function be(_,ie){return(re,Ee)=>ie(_(re),_(Ee))}e.$6b=be;function ue(..._){return(ie,re)=>{for(const Ee of _){const oe=Ee(ie,re);if(!Y.isNeitherLessOrGreaterThan(oe))return oe}return Y.neitherLessOrGreaterThan}}e.$7b=ue;const ve=(_,ie)=>_-ie;e.$8b=ve;const J=(_,ie)=>(0,e.$8b)(_?1:0,ie?1:0);e.$9b=J;function U(_){return(ie,re)=>-_(ie,re)}e.$0b=U;class V{constructor(ie){this.g=ie,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(ie){let re=this.c;for(;re<this.g.length&&ie(this.g[re]);)re++;const Ee=re===this.c?null:this.g.slice(this.c,re);return this.c=re,Ee}takeFromEndWhile(ie){let re=this.d;for(;re>=0&&ie(this.g[re]);)re--;const Ee=re===this.d?null:this.g.slice(re+1,this.d+1);return this.d=re,Ee}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const ie=this.g[this.c];return this.c++,ie}removeLast(){const ie=this.g[this.d];return this.d--,ie}takeCount(ie){const re=this.g.slice(this.c,this.c+ie);return this.c+=ie,re}}e.$$b=V;class ge{static{this.empty=new ge(ie=>{})}constructor(ie){this.iterate=ie}forEach(ie){this.iterate(re=>(ie(re),!0))}toArray(){const ie=[];return this.iterate(re=>(ie.push(re),!0)),ie}filter(ie){return new ge(re=>this.iterate(Ee=>ie(Ee)?re(Ee):!0))}map(ie){return new ge(re=>this.iterate(Ee=>re(ie(Ee))))}some(ie){let re=!1;return this.iterate(Ee=>(re=ie(Ee),!re)),re}findFirst(ie){let re;return this.iterate(Ee=>ie(Ee)?(re=Ee,!1):!0),re}findLast(ie){let re;return this.iterate(Ee=>(ie(Ee)&&(re=Ee),!0)),re}findLastMaxBy(ie){let re,Ee=!0;return this.iterate(oe=>((Ee||Y.isGreaterThan(ie(oe,re)))&&(Ee=!1,re=oe),!0)),re}}e.$_b=ge}),define(De[58],Ce([1,0,8]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=e.$5c=e.$4c=e.$3c=e.ok=void 0;function T(E,w){if(!E)throw new Error(w?`Assertion failed (${w})`:"Assertion Failed")}e.ok=T;function d(E,w="Unreachable"){throw new Error(w)}e.$3c=d;function M(E){if(!E)throw new C.$bb("Assertion Failed")}e.$4c=M;function A(E){if(!E()){debugger;E(),(0,C.$Z)(new C.$bb("Assertion Failed"))}}e.$5c=A;function b(E,w){let R=0;for(;R<E.length-1;){const I=E[R],p=E[R+1];if(!w(I,p))return!1;R++}return!0}e.$6c=b}),define(De[74],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=void 0;function C(T){const d=this;let M=!1,A;return function(){return M||(M=!0,A=T.apply(d,arguments)),A}}e.$cb=C}),define(De[119],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gM=e.$fM=void 0;class C{constructor(d){this.a=d,this.b=0}nextId(){return this.a+ ++this.b}}e.$fM=C,e.$gM=new C("id#")}),define(De[50],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var C;(function(T){function d(h){return h&&typeof h=="object"&&typeof h[Symbol.iterator]=="function"}T.is=d;const M=Object.freeze([]);function A(){return M}T.empty=A;function*b(h){yield h}T.single=b;function E(h){return d(h)?h:b(h)}T.wrap=E;function w(h){return h||M}T.from=w;function*R(h){for(let t=h.length-1;t>=0;t--)yield h[t]}T.reverse=R;function I(h){return!h||h[Symbol.iterator]().next().done===!0}T.isEmpty=I;function p(h){return h[Symbol.iterator]().next().value}T.first=p;function y(h,t){for(const n of h)if(t(n))return!0;return!1}T.some=y;function D(h,t){for(const n of h)if(t(n))return n}T.find=D;function*v(h,t){for(const n of h)t(n)&&(yield n)}T.filter=v;function*l(h,t){let n=0;for(const o of h)yield t(o,n++)}T.map=l;function*s(...h){for(const t of h)for(const n of t)yield n}T.concat=s;function r(h,t,n){let o=n;for(const i of h)o=t(o,i);return o}T.reduce=r;function*c(h,t,n=h.length){for(t<0&&(t+=h.length),n<0?n+=h.length:n>h.length&&(n=h.length);t<n;t++)yield h[t]}T.slice=c;function m(h,t=Number.POSITIVE_INFINITY){const n=[];if(t===0)return[n,h];const o=h[Symbol.iterator]();for(let i=0;i<t;i++){const a=o.next();if(a.done)return[n,T.empty()];n.push(a.value)}return[n,{[Symbol.iterator](){return o}}]}T.consume=m})(C||(e.Iterable=C={}))}),define(De[157],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.$Vm=e.$Um=e.$Tm=e.$Sm=e.$Rm=e.$Qm=e.$Pm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var C;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(C||(e.ScanError=C={}));var T;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(T||(e.SyntaxKind=T={}));var d;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(d||(e.ParseErrorCode=d={}));var M;(function(t){t.DEFAULT={allowTrailingComma:!0}})(M||(e.ParseOptions=M={}));function A(t,n=!1){let o=0;const i=t.length;let a="",u=0,k=16,S=0;function $(j){let z=0,F=0;for(;z<j;){const H=t.charCodeAt(o);if(H>=48&&H<=57)F=F*16+H-48;else if(H>=65&&H<=70)F=F*16+H-65+10;else if(H>=97&&H<=102)F=F*16+H-97+10;else break;o++,z++}return z<j&&(F=-1),F}function g(j){o=j,a="",u=0,k=16,S=0}function f(){const j=o;if(t.charCodeAt(o)===48)o++;else for(o++;o<t.length&&w(t.charCodeAt(o));)o++;if(o<t.length&&t.charCodeAt(o)===46)if(o++,o<t.length&&w(t.charCodeAt(o)))for(o++;o<t.length&&w(t.charCodeAt(o));)o++;else return S=3,t.substring(j,o);let z=o;if(o<t.length&&(t.charCodeAt(o)===69||t.charCodeAt(o)===101))if(o++,(o<t.length&&t.charCodeAt(o)===43||t.charCodeAt(o)===45)&&o++,o<t.length&&w(t.charCodeAt(o))){for(o++;o<t.length&&w(t.charCodeAt(o));)o++;z=o}else S=3;return t.substring(j,z)}function P(){let j="",z=o;for(;;){if(o>=i){j+=t.substring(z,o),S=2;break}const F=t.charCodeAt(o);if(F===34){j+=t.substring(z,o),o++;break}if(F===92){if(j+=t.substring(z,o),o++,o>=i){S=2;break}switch(t.charCodeAt(o++)){case 34:j+='"';break;case 92:j+="\\";break;case 47:j+="/";break;case 98:j+="\b";break;case 102:j+="\f";break;case 110:j+=`
`;break;case 114:j+="\r";break;case 116:j+="	";break;case 117:{const K=$(4);K>=0?j+=String.fromCharCode(K):S=4;break}default:S=5}z=o;continue}if(F>=0&&F<=31)if(E(F)){j+=t.substring(z,o),S=2;break}else S=6;o++}return j}function N(){if(a="",S=0,u=o,o>=i)return u=i,k=17;let j=t.charCodeAt(o);if(b(j)){do o++,a+=String.fromCharCode(j),j=t.charCodeAt(o);while(b(j));return k=15}if(E(j))return o++,a+=String.fromCharCode(j),j===13&&t.charCodeAt(o)===10&&(o++,a+=`
`),k=14;switch(j){case 123:return o++,k=1;case 125:return o++,k=2;case 91:return o++,k=3;case 93:return o++,k=4;case 58:return o++,k=6;case 44:return o++,k=5;case 34:return o++,a=P(),k=10;case 47:{const z=o-1;if(t.charCodeAt(o+1)===47){for(o+=2;o<i&&!E(t.charCodeAt(o));)o++;return a=t.substring(z,o),k=12}if(t.charCodeAt(o+1)===42){o+=2;const F=i-1;let H=!1;for(;o<F;){if(t.charCodeAt(o)===42&&t.charCodeAt(o+1)===47){o+=2,H=!0;break}o++}return H||(o++,S=1),a=t.substring(z,o),k=13}return a+=String.fromCharCode(j),o++,k=16}case 45:if(a+=String.fromCharCode(j),o++,o===i||!w(t.charCodeAt(o)))return k=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=f(),k=11;default:for(;o<i&&O(j);)o++,j=t.charCodeAt(o);if(u!==o){switch(a=t.substring(u,o),a){case"true":return k=8;case"false":return k=9;case"null":return k=7}return k=16}return a+=String.fromCharCode(j),o++,k=16}}function O(j){if(b(j)||E(j))return!1;switch(j){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function L(){let j;do j=N();while(j>=12&&j<=15);return j}return{setPosition:g,getPosition:()=>o,scan:n?L:N,getToken:()=>k,getTokenValue:()=>a,getTokenOffset:()=>u,getTokenLength:()=>o-u,getTokenError:()=>S}}e.$Pm=A;function b(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function E(t){return t===10||t===13||t===8232||t===8233}function w(t){return t>=48&&t<=57}var R;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(R||(R={}));function I(t,n){const o=[],i=new Object;let a;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let k=!1;function S($,g,f,P){u.value=$,u.offset=g,u.length=f,u.type=P,u.colonOffset=void 0,a=u}try{c(t,{onObjectBegin:($,g)=>{if(n<=$)throw i;a=void 0,k=n>$,o.push("")},onObjectProperty:($,g,f)=>{if(n<g||(S($,g,f,"property"),o[o.length-1]=$,n<=g+f))throw i},onObjectEnd:($,g)=>{if(n<=$)throw i;a=void 0,o.pop()},onArrayBegin:($,g)=>{if(n<=$)throw i;a=void 0,o.push(0)},onArrayEnd:($,g)=>{if(n<=$)throw i;a=void 0,o.pop()},onLiteralValue:($,g,f)=>{if(n<g||(S($,g,f,h($)),n<=g+f))throw i},onSeparator:($,g,f)=>{if(n<=g)throw i;if($===":"&&a&&a.type==="property")a.colonOffset=g,k=!1,a=void 0;else if($===","){const P=o[o.length-1];typeof P=="number"?o[o.length-1]=P+1:(k=!0,o[o.length-1]=""),a=void 0}}})}catch($){if($!==i)throw $}return{path:o,previousNode:a,isAtPropertyKey:k,matches:$=>{let g=0;for(let f=0;g<$.length&&f<o.length;f++)if($[g]===o[f]||$[g]==="*")g++;else if($[g]!=="**")return!1;return g===$.length}}}e.$Qm=I;function p(t,n=[],o=M.DEFAULT){let i=null,a=[];const u=[];function k($){Array.isArray(a)?a.push($):i!==null&&(a[i]=$)}return c(t,{onObjectBegin:()=>{const $={};k($),u.push(a),a=$,i=null},onObjectProperty:$=>{i=$},onObjectEnd:()=>{a=u.pop()},onArrayBegin:()=>{const $=[];k($),u.push(a),a=$,i=null},onArrayEnd:()=>{a=u.pop()},onLiteralValue:k,onError:($,g,f)=>{n.push({error:$,offset:g,length:f})}},o),a[0]}e.$Rm=p;function y(t,n=[],o=M.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a($){i.type==="property"&&(i.length=$-i.offset,i=i.parent)}function u($){return i.children.push($),$}c(t,{onObjectBegin:$=>{i=u({type:"object",offset:$,length:-1,parent:i,children:[]})},onObjectProperty:($,g,f)=>{i=u({type:"property",offset:g,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:$,offset:g,length:f,parent:i})},onObjectEnd:($,g)=>{i.length=$+g-i.offset,i=i.parent,a($+g)},onArrayBegin:($,g)=>{i=u({type:"array",offset:$,length:-1,parent:i,children:[]})},onArrayEnd:($,g)=>{i.length=$+g-i.offset,i=i.parent,a($+g)},onLiteralValue:($,g,f)=>{u({type:h($),offset:g,length:f,parent:i,value:$}),a(g+f)},onSeparator:($,g,f)=>{i.type==="property"&&($===":"?i.colonOffset=g:$===","&&a(g))},onError:($,g,f)=>{n.push({error:$,offset:g,length:f})}},o);const S=i.children[0];return S&&delete S.parent,S}e.$Sm=y;function D(t,n){if(!t)return;let o=t;for(const i of n)if(typeof i=="string"){if(o.type!=="object"||!Array.isArray(o.children))return;let a=!1;for(const u of o.children)if(Array.isArray(u.children)&&u.children[0].value===i){o=u.children[1],a=!0;break}if(!a)return}else{const a=i;if(o.type!=="array"||a<0||!Array.isArray(o.children)||a>=o.children.length)return;o=o.children[a]}return o}e.$Tm=D;function v(t){if(!t.parent||!t.parent.children)return[];const n=v(t.parent);if(t.parent.type==="property"){const o=t.parent.children[0].value;n.push(o)}else if(t.parent.type==="array"){const o=t.parent.children.indexOf(t);o!==-1&&n.push(o)}return n}e.$Um=v;function l(t){switch(t.type){case"array":return t.children.map(l);case"object":{const n=Object.create(null);for(const o of t.children){const i=o.children[1];i&&(n[o.children[0].value]=l(i))}return n}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$Vm=l;function s(t,n,o=!1){return n>=t.offset&&n<t.offset+t.length||o&&n===t.offset+t.length}e.$Wm=s;function r(t,n,o=!1){if(s(t,n,o)){const i=t.children;if(Array.isArray(i))for(let a=0;a<i.length&&i[a].offset<=n;a++){const u=r(i[a],n,o);if(u)return u}return t}}e.$Xm=r;function c(t,n,o=M.DEFAULT){const i=A(t,!1);function a(be){return be?()=>be(i.getTokenOffset(),i.getTokenLength()):()=>!0}function u(be){return be?ue=>be(ue,i.getTokenOffset(),i.getTokenLength()):()=>!0}const k=a(n.onObjectBegin),S=u(n.onObjectProperty),$=a(n.onObjectEnd),g=a(n.onArrayBegin),f=a(n.onArrayEnd),P=u(n.onLiteralValue),N=u(n.onSeparator),O=a(n.onComment),L=u(n.onError),j=o&&o.disallowComments,z=o&&o.allowTrailingComma;function F(){for(;;){const be=i.scan();switch(i.getTokenError()){case 4:H(14);break;case 5:H(15);break;case 3:H(13);break;case 1:j||H(11);break;case 2:H(12);break;case 6:H(16);break}switch(be){case 12:case 13:j?H(10):O();break;case 16:H(1);break;case 15:case 14:break;default:return be}}}function H(be,ue=[],ve=[]){if(L(be),ue.length+ve.length>0){let J=i.getToken();for(;J!==17;){if(ue.indexOf(J)!==-1){F();break}else if(ve.indexOf(J)!==-1)break;J=F()}}}function K(be){const ue=i.getTokenValue();return be?P(ue):S(ue),F(),!0}function fe(){switch(i.getToken()){case 11:{let be=0;try{be=JSON.parse(i.getTokenValue()),typeof be!="number"&&(H(2),be=0)}catch{H(2)}P(be);break}case 7:P(null);break;case 8:P(!0);break;case 9:P(!1);break;default:return!1}return F(),!0}function x(){return i.getToken()!==10?(H(3,[],[2,5]),!1):(K(!1),i.getToken()===6?(N(":"),F(),Y()||H(4,[],[2,5])):H(5,[],[2,5]),!0)}function Z(){k(),F();let be=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(be||H(4,[],[]),N(","),F(),i.getToken()===2&&z)break}else be&&H(6,[],[]);x()||H(4,[],[2,5]),be=!0}return $(),i.getToken()!==2?H(7,[2],[]):F(),!0}function q(){g(),F();let be=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(be||H(4,[],[]),N(","),F(),i.getToken()===4&&z)break}else be&&H(6,[],[]);Y()||H(4,[],[4,5]),be=!0}return f(),i.getToken()!==4?H(8,[4],[]):F(),!0}function Y(){switch(i.getToken()){case 3:return q();case 1:return Z();case 10:return K(!0);default:return fe()}}return F(),i.getToken()===17?o.allowEmptyContent?!0:(H(4,[],[]),!1):Y()?(i.getToken()!==17&&H(9,[],[]),!0):(H(4,[],[]),!1)}e.$Ym=c;function m(t,n){const o=A(t),i=[];let a,u=0,k;do switch(k=o.getPosition(),a=o.scan(),a){case 12:case 13:case 17:u!==k&&i.push(t.substring(u,k)),n!==void 0&&i.push(o.getTokenValue().replace(/[^\r\n]/g,n)),u=o.getPosition();break}while(a!==17);return i.join("")}e.$Zm=m;function h(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$1m=h}),define(De[51],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=void 0;class C{constructor(d){this.d=d,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(d){this.c=d}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$U=C}),define(De[75],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1c=void 0;class C{static{this.Undefined=new C(void 0)}constructor(M){this.element=M,this.next=C.Undefined,this.prev=C.Undefined}}class T{constructor(){this.a=C.Undefined,this.b=C.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===C.Undefined}clear(){let M=this.a;for(;M!==C.Undefined;){const A=M.next;M.prev=C.Undefined,M.next=C.Undefined,M=A}this.a=C.Undefined,this.b=C.Undefined,this.c=0}unshift(M){return this.d(M,!1)}push(M){return this.d(M,!0)}d(M,A){const b=new C(M);if(this.a===C.Undefined)this.a=b,this.b=b;else if(A){const w=this.b;this.b=b,b.prev=w,w.next=b}else{const w=this.a;this.a=b,b.next=w,w.prev=b}this.c+=1;let E=!1;return()=>{E||(E=!0,this.e(b))}}shift(){if(this.a!==C.Undefined){const M=this.a.element;return this.e(this.a),M}}pop(){if(this.b!==C.Undefined){const M=this.b.element;return this.e(this.b),M}}e(M){if(M.prev!==C.Undefined&&M.next!==C.Undefined){const A=M.prev;A.next=M.next,M.next.prev=A}else M.prev===C.Undefined&&M.next===C.Undefined?(this.a=C.Undefined,this.b=C.Undefined):M.next===C.Undefined?(this.b=this.b.prev,this.b.next=C.Undefined):M.prev===C.Undefined&&(this.a=this.a.next,this.a.prev=C.Undefined);this.c-=1}*[Symbol.iterator](){let M=this.a;for(;M!==C.Undefined;)yield M.element,M=M.next}}e.$1c=T}),define(De[28],Ce([1,0]),function(me,e){"use strict";var C,T,d;Object.defineProperty(e,"__esModule",{value:!0}),e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.$Bc=e.Touch=e.$Ac=e.$zc=e.$yc=e.$xc=e.$wc=void 0;function M(r,c,m){let h=r.get(c);return h===void 0&&(h=m,r.set(c,h)),h}e.$wc=M;function A(r){const c=[];return r.forEach((m,h)=>{c.push(`${h} => ${m}`)}),`Map(${r.size}) {${c.join(", ")}}`}e.$xc=A;function b(r){const c=[];return r.forEach(m=>{c.push(m)}),`Set(${r.size}) {${c.join(", ")}}`}e.$yc=b;class E{constructor(c,m){this.uri=c,this.value=m}}function w(r){return Array.isArray(r)}class R{static{this.a=c=>c.toString()}constructor(c,m){if(this[C]="ResourceMap",c instanceof R)this.b=new Map(c.b),this.c=m??R.a;else if(w(c)){this.b=new Map,this.c=m??R.a;for(const[h,t]of c)this.set(h,t)}else this.b=new Map,this.c=c??R.a}set(c,m){return this.b.set(this.c(c),new E(c,m)),this}get(c){return this.b.get(this.c(c))?.value}has(c){return this.b.has(this.c(c))}get size(){return this.b.size}clear(){this.b.clear()}delete(c){return this.b.delete(this.c(c))}forEach(c,m){typeof m<"u"&&(c=c.bind(m));for(const[h,t]of this.b)c(t.value,t.uri,this)}*values(){for(const c of this.b.values())yield c.value}*keys(){for(const c of this.b.values())yield c.uri}*entries(){for(const c of this.b.values())yield[c.uri,c.value]}*[(C=Symbol.toStringTag,Symbol.iterator)](){for(const[,c]of this.b)yield[c.uri,c.value]}}e.$zc=R;class I{constructor(c,m){this[T]="ResourceSet",!c||typeof c=="function"?this.a=new R(c):(this.a=new R(m),c.forEach(this.add,this))}get size(){return this.a.size}add(c){return this.a.set(c,c),this}clear(){this.a.clear()}delete(c){return this.a.delete(c)}forEach(c,m){this.a.forEach((h,t)=>c.call(m,t,t,this))}has(c){return this.a.has(c)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Ac=I;var p;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(p||(e.Touch=p={}));class y{constructor(){this[d]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(c){return this.a.has(c)}get(c,m=0){const h=this.a.get(c);if(h)return m!==0&&this.j(h,m),h.value}set(c,m,h=0){let t=this.a.get(c);if(t)t.value=m,h!==0&&this.j(t,h);else{switch(t={key:c,value:m,next:void 0,previous:void 0},h){case 0:this.h(t);break;case 1:this.g(t);break;case 2:this.h(t);break;default:this.h(t);break}this.a.set(c,t),this.d++}return this}delete(c){return!!this.remove(c)}remove(c){const m=this.a.get(c);if(m)return this.a.delete(c),this.i(m),this.d--,m.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const c=this.b;return this.a.delete(c.key),this.i(c),this.d--,c.value}forEach(c,m){const h=this.e;let t=this.b;for(;t;){if(m?c.bind(m)(t.value,t.key,this):c(t.value,t.key,this),this.e!==h)throw new Error("LinkedMap got modified during iteration.");t=t.next}}keys(){const c=this,m=this.e;let h=this.b;const t={[Symbol.iterator](){return t},next(){if(c.e!==m)throw new Error("LinkedMap got modified during iteration.");if(h){const n={value:h.key,done:!1};return h=h.next,n}else return{value:void 0,done:!0}}};return t}values(){const c=this,m=this.e;let h=this.b;const t={[Symbol.iterator](){return t},next(){if(c.e!==m)throw new Error("LinkedMap got modified during iteration.");if(h){const n={value:h.value,done:!1};return h=h.next,n}else return{value:void 0,done:!0}}};return t}entries(){const c=this,m=this.e;let h=this.b;const t={[Symbol.iterator](){return t},next(){if(c.e!==m)throw new Error("LinkedMap got modified during iteration.");if(h){const n={value:[h.key,h.value],done:!1};return h=h.next,n}else return{value:void 0,done:!0}}};return t}[(d=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(c){if(c>=this.size)return;if(c===0){this.clear();return}let m=this.b,h=this.size;for(;m&&h>c;)this.a.delete(m.key),m=m.next,h--;this.b=m,this.d=h,m&&(m.previous=void 0),this.e++}g(c){if(!this.b&&!this.c)this.c=c;else if(this.b)c.next=this.b,this.b.previous=c;else throw new Error("Invalid list");this.b=c,this.e++}h(c){if(!this.b&&!this.c)this.b=c;else if(this.c)c.previous=this.c,this.c.next=c;else throw new Error("Invalid list");this.c=c,this.e++}i(c){if(c===this.b&&c===this.c)this.b=void 0,this.c=void 0;else if(c===this.b){if(!c.next)throw new Error("Invalid list");c.next.previous=void 0,this.b=c.next}else if(c===this.c){if(!c.previous)throw new Error("Invalid list");c.previous.next=void 0,this.c=c.previous}else{const m=c.next,h=c.previous;if(!m||!h)throw new Error("Invalid list");m.previous=h,h.next=m}c.next=void 0,c.previous=void 0,this.e++}j(c,m){if(!this.b||!this.c)throw new Error("Invalid list");if(!(m!==1&&m!==2)){if(m===1){if(c===this.b)return;const h=c.next,t=c.previous;c===this.c?(t.next=void 0,this.c=t):(h.previous=t,t.next=h),c.previous=void 0,c.next=this.b,this.b.previous=c,this.b=c,this.e++}else if(m===2){if(c===this.c)return;const h=c.next,t=c.previous;c===this.b?(h.previous=void 0,this.b=h):(h.previous=t,t.next=h),c.next=void 0,c.previous=this.c,this.c.next=c,this.c=c,this.e++}}}toJSON(){const c=[];return this.forEach((m,h)=>{c.push([h,m])}),c}fromJSON(c){this.clear();for(const[m,h]of c)this.set(m,h)}}e.$Bc=y;class D extends y{constructor(c,m=1){super(),this.k=c,this.l=Math.min(Math.max(0,m),1)}get limit(){return this.k}set limit(c){this.k=c,this.m()}get ratio(){return this.l}set ratio(c){this.l=Math.min(Math.max(0,c),1),this.m()}get(c,m=2){return super.get(c,m)}peek(c){return super.get(c,0)}set(c,m){return super.set(c,m,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Cc=D;class v{constructor(){this.a=new Map}add(c){return this.a.set(c,(this.a.get(c)||0)+1),this}delete(c){let m=this.a.get(c)||0;return m===0?!1:(m--,m===0?this.a.delete(c):this.a.set(c,m),!0)}has(c){return this.a.has(c)}}e.$Dc=v;class l{constructor(c){if(this.a=new Map,this.b=new Map,c)for(const[m,h]of c)this.set(m,h)}clear(){this.a.clear(),this.b.clear()}set(c,m){this.a.set(c,m),this.b.set(m,c)}get(c){return this.a.get(c)}getKey(c){return this.b.get(c)}delete(c){const m=this.a.get(c);return m===void 0?!1:(this.a.delete(c),this.b.delete(m),!0)}forEach(c,m){this.a.forEach((h,t)=>{c.call(m,h,t,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Ec=l;class s{constructor(){this.a=new Map}add(c,m){let h=this.a.get(c);h||(h=new Set,this.a.set(c,h)),h.add(m)}delete(c,m){const h=this.a.get(c);h&&(h.delete(m),h.size===0&&this.a.delete(c))}forEach(c,m){const h=this.a.get(c);h&&h.forEach(m)}get(c){const m=this.a.get(c);return m||new Set}}e.$Fc=s}),define(De[3],Ce([1,0,19,73,28,74,50]),function(me,e,C,T,d,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.$Gc=void 0;const b=!1;let E=null;class w{constructor(){this.b=new Map}static{this.a=0}c(f){let P=this.b.get(f);return P||(P={parent:null,source:null,isSingleton:!1,value:f,idx:w.a++},this.b.set(f,P)),P}trackDisposable(f){const P=this.c(f);P.source||(P.source=new Error().stack)}setParent(f,P){const N=this.c(f);N.parent=P}markAsDisposed(f){this.b.delete(f)}markAsSingleton(f){this.c(f).isSingleton=!0}f(f,P){const N=P.get(f);if(N)return N;const O=f.parent?this.f(this.c(f.parent),P):f;return P.set(f,O),O}getTrackedDisposables(){const f=new Map;return[...this.b.entries()].filter(([,N])=>N.source!==null&&!this.f(N,f).isSingleton).flatMap(([N])=>N)}computeLeakingDisposables(f=10,P){let N;if(P)N=P;else{const F=new Map,H=[...this.b.values()].filter(fe=>fe.source!==null&&!this.f(fe,F).isSingleton);if(H.length===0)return;const K=new Set(H.map(fe=>fe.value));if(N=H.filter(fe=>!(fe.parent&&K.has(fe.parent))),N.length===0)throw new Error("There are cyclic diposable chains!")}if(!N)return;function O(F){function H(fe,x){for(;fe.length>0&&x.some(Z=>typeof Z=="string"?Z===fe[0]:fe[0].match(Z));)fe.shift()}const K=F.source.split(`
`).map(fe=>fe.trim().replace("at ","")).filter(fe=>fe!=="");return H(K,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),K.reverse()}const L=new d.$Fc;for(const F of N){const H=O(F);for(let K=0;K<=H.length;K++)L.add(H.slice(0,K).join(`
`),F)}N.sort((0,C.$6b)(F=>F.idx,C.$8b));let j="",z=0;for(const F of N.slice(0,f)){z++;const H=O(F),K=[];for(let fe=0;fe<H.length;fe++){let x=H[fe];x=`(shared with ${L.get(H.slice(0,fe+1).join(`
`)).size}/${N.length} leaks) at ${x}`;const q=L.get(H.slice(0,fe).join(`
`)),Y=(0,T.$J)([...q].map(be=>O(be)[fe]),be=>be);delete Y[H[fe]];for(const[be,ue]of Object.entries(Y))K.unshift(`    - stacktraces of ${ue.length} other leaks continue with ${be}`);K.unshift(x)}j+=`


==================== Leaking disposable ${z}/${N.length}: ${F.value.constructor.name} ====================
${K.join(`
`)}
============================================================

`}return N.length>f&&(j+=`


... and ${N.length-f} more leaking disposables

`),{leaks:N,details:j}}}e.$Gc=w;function R(g){E=g}if(e.$Hc=R,b){const g="__is_disposable_tracked__";R(new class{trackDisposable(f){const P=new Error("Potentially leaked disposable").stack;setTimeout(()=>{f[g]||console.log(P)},3e3)}setParent(f,P){if(f&&f!==t.None)try{f[g]=!0}catch{}}markAsDisposed(f){if(f&&f!==t.None)try{f[g]=!0}catch{}}markAsSingleton(f){}})}function I(g){return E?.trackDisposable(g),g}e.$Ic=I;function p(g){E?.markAsDisposed(g)}e.$Jc=p;function y(g,f){E?.setParent(g,f)}function D(g,f){if(E)for(const P of g)E.setParent(P,f)}function v(g){return E?.markAsSingleton(g),g}e.$Kc=v;function l(g){return typeof g.dispose=="function"&&g.dispose.length===0}e.$Lc=l;function s(g){if(A.Iterable.is(g)){const f=[];for(const P of g)if(P)try{P.dispose()}catch(N){f.push(N)}if(f.length===1)throw f[0];if(f.length>1)throw new AggregateError(f,"Encountered errors while disposing of store");return Array.isArray(g)?[]:g}else if(g)return g.dispose(),g}e.$Mc=s;function r(g){for(const f of g)l(f)&&f.dispose();return[]}e.$Nc=r;function c(...g){const f=m(()=>s(g));return D(g,f),f}e.$Oc=c;function m(g){const f=I({dispose:(0,M.$cb)(()=>{p(f),g()})});return f}e.$Pc=m;class h{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,I(this)}dispose(){this.g||(p(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{s(this.f)}finally{this.f.clear()}}add(f){if(!f)return f;if(f===this)throw new Error("Cannot register a disposable on itself!");return y(f,this),this.g?h.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(f),f}delete(f){if(f){if(f===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(f),f.dispose()}}deleteAndLeak(f){f&&this.f.has(f)&&(this.f.delete(f),y(f,null))}}e.$Qc=h;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new h,I(this),y(this.q,this)}dispose(){p(this),this.q.dispose()}B(f){if(f===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(f)}}e.$Rc=t;class n{constructor(){this.b=!1,I(this)}get value(){return this.b?void 0:this.a}set value(f){this.b||f===this.a||(this.a?.dispose(),f&&y(f,this),this.a=f)}clear(){this.value=void 0}dispose(){this.b=!0,p(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const f=this.a;return this.a=void 0,f&&y(f,null),f}}e.$Sc=n;class o{constructor(f){this.b=f,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Tc=o;class i{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,I(this)}set(f){let P=f;return this.unset=()=>P=void 0,this.isset=()=>P!==void 0,this.dispose=()=>{P&&(P(),P=void 0,p(this))},this}}e.$Uc=i;class a{constructor(){this.a=new Map}acquire(f,...P){let N=this.a.get(f);N||(N={counter:0,object:this.b(f,...P)},this.a.set(f,N));const{object:O}=N,L=(0,M.$cb)(()=>{--N.counter===0&&(this.c(f,N.object),this.a.delete(f))});return N.counter++,{object:O,dispose:L}}}e.$Vc=a;class u{constructor(f){this.a=f}async acquire(f,...P){const N=this.a.acquire(f,...P);try{return{object:await N.object,dispose:()=>N.dispose()}}catch(O){throw N.dispose(),O}}}e.$Wc=u;class k{constructor(f){this.object=f}dispose(){}}e.$Xc=k;function S(g){const f=new h;try{g(f)}finally{f.dispose()}}e.$Yc=S;class ${constructor(){this.a=new Map,this.b=!1,I(this)}dispose(){p(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{s(this.a.values())}finally{this.a.clear()}}has(f){return this.a.has(f)}get size(){return this.a.size}get(f){return this.a.get(f)}set(f,P,N=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),N||this.a.get(f)?.dispose(),this.a.set(f,P)}deleteAndDispose(f){this.a.get(f)?.dispose(),this.a.delete(f)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$Zc=$}),function(me,e){typeof define=="function"&&define.amd?define(De[158],Ce([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(me=typeof globalThis<"u"?globalThis:me||self,e(me.marked={}))}(this,function(me){"use strict";function e(ie,re){for(var Ee=0;Ee<re.length;Ee++){var oe=re[Ee];oe.enumerable=oe.enumerable||!1,oe.configurable=!0,"value"in oe&&(oe.writable=!0),Object.defineProperty(ie,oe.key,oe)}}function C(ie,re,Ee){return re&&e(ie.prototype,re),Ee&&e(ie,Ee),Object.defineProperty(ie,"prototype",{writable:!1}),ie}function T(ie,re){if(ie){if(typeof ie=="string")return d(ie,re);var Ee=Object.prototype.toString.call(ie).slice(8,-1);if(Ee==="Object"&&ie.constructor&&(Ee=ie.constructor.name),Ee==="Map"||Ee==="Set")return Array.from(ie);if(Ee==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ee))return d(ie,re)}}function d(ie,re){(re==null||re>ie.length)&&(re=ie.length);for(var Ee=0,oe=new Array(re);Ee<re;Ee++)oe[Ee]=ie[Ee];return oe}function M(ie,re){var Ee=typeof Symbol<"u"&&ie[Symbol.iterator]||ie["@@iterator"];if(Ee)return(Ee=Ee.call(ie)).next.bind(Ee);if(Array.isArray(ie)||(Ee=T(ie))||re&&ie&&typeof ie.length=="number"){Ee&&(ie=Ee);var oe=0;return function(){return oe>=ie.length?{done:!0}:{done:!1,value:ie[oe++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}me.defaults=A();function b(ie){me.defaults=ie}var E=/[&<>"']/,w=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,I=/[<>"']|&(?!#?\w+;)/g,p={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},y=function(re){return p[re]};function D(ie,re){if(re){if(E.test(ie))return ie.replace(w,y)}else if(R.test(ie))return ie.replace(I,y);return ie}var v=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function l(ie){return ie.replace(v,function(re,Ee){return Ee=Ee.toLowerCase(),Ee==="colon"?":":Ee.charAt(0)==="#"?Ee.charAt(1)==="x"?String.fromCharCode(parseInt(Ee.substring(2),16)):String.fromCharCode(+Ee.substring(1)):""})}var s=/(^|[^\[])\^/g;function r(ie,re){ie=typeof ie=="string"?ie:ie.source,re=re||"";var Ee={replace:function(he,ee){return ee=ee.source||ee,ee=ee.replace(s,"$1"),ie=ie.replace(he,ee),Ee},getRegex:function(){return new RegExp(ie,re)}};return Ee}var c=/[^\w:]/g,m=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function h(ie,re,Ee){if(ie){var oe;try{oe=decodeURIComponent(l(Ee)).replace(c,"").toLowerCase()}catch{return null}if(oe.indexOf("javascript:")===0||oe.indexOf("vbscript:")===0||oe.indexOf("data:")===0)return null}re&&!m.test(Ee)&&(Ee=a(re,Ee));try{Ee=encodeURI(Ee).replace(/%25/g,"%")}catch{return null}return Ee}var t={},n=/^[^:]+:\/*[^/]*$/,o=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function a(ie,re){t[" "+ie]||(n.test(ie)?t[" "+ie]=ie+"/":t[" "+ie]=$(ie,"/",!0)),ie=t[" "+ie];var Ee=ie.indexOf(":")===-1;return re.substring(0,2)==="//"?Ee?re:ie.replace(o,"$1")+re:re.charAt(0)==="/"?Ee?re:ie.replace(i,"$1")+re:ie+re}var u={exec:function(){}};function k(ie){for(var re=1,Ee,oe;re<arguments.length;re++){Ee=arguments[re];for(oe in Ee)Object.prototype.hasOwnProperty.call(Ee,oe)&&(ie[oe]=Ee[oe])}return ie}function S(ie,re){var Ee=ie.replace(/\|/g,function(ee,le,$e){for(var Pe=!1,B=le;--B>=0&&$e[B]==="\\";)Pe=!Pe;return Pe?"|":" |"}),oe=Ee.split(/ \|/),he=0;if(oe[0].trim()||oe.shift(),oe.length>0&&!oe[oe.length-1].trim()&&oe.pop(),oe.length>re)oe.splice(re);else for(;oe.length<re;)oe.push("");for(;he<oe.length;he++)oe[he]=oe[he].trim().replace(/\\\|/g,"|");return oe}function $(ie,re,Ee){var oe=ie.length;if(oe===0)return"";for(var he=0;he<oe;){var ee=ie.charAt(oe-he-1);if(ee===re&&!Ee)he++;else if(ee!==re&&Ee)he++;else break}return ie.slice(0,oe-he)}function g(ie,re){if(ie.indexOf(re[1])===-1)return-1;for(var Ee=ie.length,oe=0,he=0;he<Ee;he++)if(ie[he]==="\\")he++;else if(ie[he]===re[0])oe++;else if(ie[he]===re[1]&&(oe--,oe<0))return he;return-1}function f(ie){ie&&ie.sanitize&&!ie.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function P(ie,re){if(re<1)return"";for(var Ee="";re>1;)re&1&&(Ee+=ie),re>>=1,ie+=ie;return Ee+ie}function N(ie,re,Ee,oe){var he=re.href,ee=re.title?D(re.title):null,le=ie[1].replace(/\\([\[\]])/g,"$1");if(ie[0].charAt(0)!=="!"){oe.state.inLink=!0;var $e={type:"link",raw:Ee,href:he,title:ee,text:le,tokens:oe.inlineTokens(le)};return oe.state.inLink=!1,$e}return{type:"image",raw:Ee,href:he,title:ee,text:D(le)}}function O(ie,re){var Ee=ie.match(/^(\s+)(?:```)/);if(Ee===null)return re;var oe=Ee[1];return re.split(`
`).map(function(he){var ee=he.match(/^\s+/);if(ee===null)return he;var le=ee[0];return le.length>=oe.length?he.slice(oe.length):he}).join(`
`)}var L=function(){function ie(Ee){this.options=Ee||me.defaults}var re=ie.prototype;return re.space=function(oe){var he=this.rules.block.newline.exec(oe);if(he&&he[0].length>0)return{type:"space",raw:he[0]}},re.code=function(oe){var he=this.rules.block.code.exec(oe);if(he){var ee=he[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:he[0],codeBlockStyle:"indented",text:this.options.pedantic?ee:$(ee,`
`)}}},re.fences=function(oe){var he=this.rules.block.fences.exec(oe);if(he){var ee=he[0],le=O(ee,he[3]||"");return{type:"code",raw:ee,lang:he[2]?he[2].trim():he[2],text:le}}},re.heading=function(oe){var he=this.rules.block.heading.exec(oe);if(he){var ee=he[2].trim();if(/#$/.test(ee)){var le=$(ee,"#");(this.options.pedantic||!le||/ $/.test(le))&&(ee=le.trim())}return{type:"heading",raw:he[0],depth:he[1].length,text:ee,tokens:this.lexer.inline(ee)}}},re.hr=function(oe){var he=this.rules.block.hr.exec(oe);if(he)return{type:"hr",raw:he[0]}},re.blockquote=function(oe){var he=this.rules.block.blockquote.exec(oe);if(he){var ee=he[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:he[0],tokens:this.lexer.blockTokens(ee,[]),text:ee}}},re.list=function(oe){var he=this.rules.block.list.exec(oe);if(he){var ee,le,$e,Pe,B,Q,te,se,X,de,ye,je,We=he[1].trim(),_e=We.length>1,Ye={type:"list",raw:"",ordered:_e,start:_e?+We.slice(0,-1):"",loose:!1,items:[]};We=_e?"\\d{1,9}\\"+We.slice(-1):"\\"+We,this.options.pedantic&&(We=_e?We:"[*+-]");for(var it=new RegExp("^( {0,3}"+We+")((?:[	 ][^\\n]*)?(?:\\n|$))");oe&&(je=!1,!(!(he=it.exec(oe))||this.rules.block.hr.test(oe)));){if(ee=he[0],oe=oe.substring(ee.length),se=he[2].split(`
`,1)[0],X=oe.split(`
`,1)[0],this.options.pedantic?(Pe=2,ye=se.trimLeft()):(Pe=he[2].search(/[^ ]/),Pe=Pe>4?1:Pe,ye=se.slice(Pe),Pe+=he[1].length),Q=!1,!se&&/^ *$/.test(X)&&(ee+=X+`
`,oe=oe.substring(X.length+1),je=!0),!je)for(var et=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Ae=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Ne=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}(?:```|~~~)"),qe=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}#");oe&&(de=oe.split(`
`,1)[0],se=de,this.options.pedantic&&(se=se.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Ne.test(se)||qe.test(se)||et.test(se)||Ae.test(oe)));){if(se.search(/[^ ]/)>=Pe||!se.trim())ye+=`
`+se.slice(Pe);else if(!Q)ye+=`
`+se;else break;!Q&&!se.trim()&&(Q=!0),ee+=de+`
`,oe=oe.substring(de.length+1)}Ye.loose||(te?Ye.loose=!0:/\n *\n *$/.test(ee)&&(te=!0)),this.options.gfm&&(le=/^\[[ xX]\] /.exec(ye),le&&($e=le[0]!=="[ ] ",ye=ye.replace(/^\[[ xX]\] +/,""))),Ye.items.push({type:"list_item",raw:ee,task:!!le,checked:$e,loose:!1,text:ye}),Ye.raw+=ee}Ye.items[Ye.items.length-1].raw=ee.trimRight(),Ye.items[Ye.items.length-1].text=ye.trimRight(),Ye.raw=Ye.raw.trimRight();var Me=Ye.items.length;for(B=0;B<Me;B++){this.lexer.state.top=!1,Ye.items[B].tokens=this.lexer.blockTokens(Ye.items[B].text,[]);var Ze=Ye.items[B].tokens.filter(function(ae){return ae.type==="space"}),ce=Ze.every(function(ae){for(var Ie=ae.raw.split(""),Ve=0,ze=M(Ie),Xe;!(Xe=ze()).done;){var rt=Xe.value;if(rt===`
`&&(Ve+=1),Ve>1)return!0}return!1});!Ye.loose&&Ze.length&&ce&&(Ye.loose=!0,Ye.items[B].loose=!0)}return Ye}},re.html=function(oe){var he=this.rules.block.html.exec(oe);if(he){var ee={type:"html",raw:he[0],pre:!this.options.sanitizer&&(he[1]==="pre"||he[1]==="script"||he[1]==="style"),text:he[0]};if(this.options.sanitize){var le=this.options.sanitizer?this.options.sanitizer(he[0]):D(he[0]);ee.type="paragraph",ee.text=le,ee.tokens=this.lexer.inline(le)}return ee}},re.def=function(oe){var he=this.rules.block.def.exec(oe);if(he){he[3]&&(he[3]=he[3].substring(1,he[3].length-1));var ee=he[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ee,raw:he[0],href:he[2],title:he[3]}}},re.table=function(oe){var he=this.rules.block.table.exec(oe);if(he){var ee={type:"table",header:S(he[1]).map(function(te){return{text:te}}),align:he[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:he[3]&&he[3].trim()?he[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ee.header.length===ee.align.length){ee.raw=he[0];var le=ee.align.length,$e,Pe,B,Q;for($e=0;$e<le;$e++)/^ *-+: *$/.test(ee.align[$e])?ee.align[$e]="right":/^ *:-+: *$/.test(ee.align[$e])?ee.align[$e]="center":/^ *:-+ *$/.test(ee.align[$e])?ee.align[$e]="left":ee.align[$e]=null;for(le=ee.rows.length,$e=0;$e<le;$e++)ee.rows[$e]=S(ee.rows[$e],ee.header.length).map(function(te){return{text:te}});for(le=ee.header.length,Pe=0;Pe<le;Pe++)ee.header[Pe].tokens=this.lexer.inline(ee.header[Pe].text);for(le=ee.rows.length,Pe=0;Pe<le;Pe++)for(Q=ee.rows[Pe],B=0;B<Q.length;B++)Q[B].tokens=this.lexer.inline(Q[B].text);return ee}}},re.lheading=function(oe){var he=this.rules.block.lheading.exec(oe);if(he)return{type:"heading",raw:he[0],depth:he[2].charAt(0)==="="?1:2,text:he[1],tokens:this.lexer.inline(he[1])}},re.paragraph=function(oe){var he=this.rules.block.paragraph.exec(oe);if(he){var ee=he[1].charAt(he[1].length-1)===`
`?he[1].slice(0,-1):he[1];return{type:"paragraph",raw:he[0],text:ee,tokens:this.lexer.inline(ee)}}},re.text=function(oe){var he=this.rules.block.text.exec(oe);if(he)return{type:"text",raw:he[0],text:he[0],tokens:this.lexer.inline(he[0])}},re.escape=function(oe){var he=this.rules.inline.escape.exec(oe);if(he)return{type:"escape",raw:he[0],text:D(he[1])}},re.tag=function(oe){var he=this.rules.inline.tag.exec(oe);if(he)return!this.lexer.state.inLink&&/^<a /i.test(he[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(he[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(he[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(he[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:he[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(he[0]):D(he[0]):he[0]}},re.link=function(oe){var he=this.rules.inline.link.exec(oe);if(he){var ee=he[2].trim();if(!this.options.pedantic&&/^</.test(ee)){if(!/>$/.test(ee))return;var le=$(ee.slice(0,-1),"\\");if((ee.length-le.length)%2===0)return}else{var $e=g(he[2],"()");if($e>-1){var Pe=he[0].indexOf("!")===0?5:4,B=Pe+he[1].length+$e;he[2]=he[2].substring(0,$e),he[0]=he[0].substring(0,B).trim(),he[3]=""}}var Q=he[2],te="";if(this.options.pedantic){var se=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Q);se&&(Q=se[1],te=se[3])}else te=he[3]?he[3].slice(1,-1):"";return Q=Q.trim(),/^</.test(Q)&&(this.options.pedantic&&!/>$/.test(ee)?Q=Q.slice(1):Q=Q.slice(1,-1)),N(he,{href:Q&&Q.replace(this.rules.inline._escapes,"$1"),title:te&&te.replace(this.rules.inline._escapes,"$1")},he[0],this.lexer)}},re.reflink=function(oe,he){var ee;if((ee=this.rules.inline.reflink.exec(oe))||(ee=this.rules.inline.nolink.exec(oe))){var le=(ee[2]||ee[1]).replace(/\s+/g," ");if(le=he[le.toLowerCase()],!le||!le.href){var $e=ee[0].charAt(0);return{type:"text",raw:$e,text:$e}}return N(ee,le,ee[0],this.lexer)}},re.emStrong=function(oe,he,ee){ee===void 0&&(ee="");var le=this.rules.inline.emStrong.lDelim.exec(oe);if(le&&!(le[3]&&ee.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var $e=le[1]||le[2]||"";if(!$e||$e&&(ee===""||this.rules.inline.punctuation.exec(ee))){var Pe=le[0].length-1,B,Q,te=Pe,se=0,X=le[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(X.lastIndex=0,he=he.slice(-1*oe.length+Pe);(le=X.exec(he))!=null;)if(B=le[1]||le[2]||le[3]||le[4]||le[5]||le[6],!!B){if(Q=B.length,le[3]||le[4]){te+=Q;continue}else if((le[5]||le[6])&&Pe%3&&!((Pe+Q)%3)){se+=Q;continue}if(te-=Q,!(te>0)){if(Q=Math.min(Q,Q+te+se),Math.min(Pe,Q)%2){var de=oe.slice(1,Pe+le.index+Q);return{type:"em",raw:oe.slice(0,Pe+le.index+Q+1),text:de,tokens:this.lexer.inlineTokens(de)}}var ye=oe.slice(2,Pe+le.index+Q-1);return{type:"strong",raw:oe.slice(0,Pe+le.index+Q+1),text:ye,tokens:this.lexer.inlineTokens(ye)}}}}}},re.codespan=function(oe){var he=this.rules.inline.code.exec(oe);if(he){var ee=he[2].replace(/\n/g," "),le=/[^ ]/.test(ee),$e=/^ /.test(ee)&&/ $/.test(ee);return le&&$e&&(ee=ee.substring(1,ee.length-1)),ee=D(ee,!0),{type:"codespan",raw:he[0],text:ee}}},re.br=function(oe){var he=this.rules.inline.br.exec(oe);if(he)return{type:"br",raw:he[0]}},re.del=function(oe){var he=this.rules.inline.del.exec(oe);if(he)return{type:"del",raw:he[0],text:he[2],tokens:this.lexer.inlineTokens(he[2])}},re.autolink=function(oe,he){var ee=this.rules.inline.autolink.exec(oe);if(ee){var le,$e;return ee[2]==="@"?(le=D(this.options.mangle?he(ee[1]):ee[1]),$e="mailto:"+le):(le=D(ee[1]),$e=le),{type:"link",raw:ee[0],text:le,href:$e,tokens:[{type:"text",raw:le,text:le}]}}},re.url=function(oe,he){var ee;if(ee=this.rules.inline.url.exec(oe)){var le,$e;if(ee[2]==="@")le=D(this.options.mangle?he(ee[0]):ee[0]),$e="mailto:"+le;else{var Pe;do Pe=ee[0],ee[0]=this.rules.inline._backpedal.exec(ee[0])[0];while(Pe!==ee[0]);le=D(ee[0]),ee[1]==="www."?$e="http://"+le:$e=le}return{type:"link",raw:ee[0],text:le,href:$e,tokens:[{type:"text",raw:le,text:le}]}}},re.inlineText=function(oe,he){var ee=this.rules.inline.text.exec(oe);if(ee){var le;return this.lexer.state.inRawBlock?le=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ee[0]):D(ee[0]):ee[0]:le=D(this.options.smartypants?he(ee[0]):ee[0]),{type:"text",raw:ee[0],text:le}}},ie}(),j={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:u,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};j._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,j._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,j.def=r(j.def).replace("label",j._label).replace("title",j._title).getRegex(),j.bullet=/(?:[*+-]|\d{1,9}[.)])/,j.listItemStart=r(/^( *)(bull) */).replace("bull",j.bullet).getRegex(),j.list=r(j.list).replace(/bull/g,j.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+j.def.source+")").getRegex(),j._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",j._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,j.html=r(j.html,"i").replace("comment",j._comment).replace("tag",j._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),j.paragraph=r(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.blockquote=r(j.blockquote).replace("paragraph",j.paragraph).getRegex(),j.normal=k({},j),j.gfm=k({},j.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),j.gfm.table=r(j.gfm.table).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.gfm.paragraph=r(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",j.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.pedantic=k({},j.normal,{html:r(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",j._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:u,paragraph:r(j.normal._paragraph).replace("hr",j.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",j.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var z={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:u,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:u,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};z._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",z.punctuation=r(z.punctuation).replace(/punctuation/g,z._punctuation).getRegex(),z.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,z.escapedEmSt=/\\\*|\\_/g,z._comment=r(j._comment).replace("(?:-->|$)","-->").getRegex(),z.emStrong.lDelim=r(z.emStrong.lDelim).replace(/punct/g,z._punctuation).getRegex(),z.emStrong.rDelimAst=r(z.emStrong.rDelimAst,"g").replace(/punct/g,z._punctuation).getRegex(),z.emStrong.rDelimUnd=r(z.emStrong.rDelimUnd,"g").replace(/punct/g,z._punctuation).getRegex(),z._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,z._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,z._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,z.autolink=r(z.autolink).replace("scheme",z._scheme).replace("email",z._email).getRegex(),z._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,z.tag=r(z.tag).replace("comment",z._comment).replace("attribute",z._attribute).getRegex(),z._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,z._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,z._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,z.link=r(z.link).replace("label",z._label).replace("href",z._href).replace("title",z._title).getRegex(),z.reflink=r(z.reflink).replace("label",z._label).replace("ref",j._label).getRegex(),z.nolink=r(z.nolink).replace("ref",j._label).getRegex(),z.reflinkSearch=r(z.reflinkSearch,"g").replace("reflink",z.reflink).replace("nolink",z.nolink).getRegex(),z.normal=k({},z),z.pedantic=k({},z.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:r(/^!?\[(label)\]\((.*?)\)/).replace("label",z._label).getRegex(),reflink:r(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",z._label).getRegex()}),z.gfm=k({},z.normal,{escape:r(z.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),z.gfm.url=r(z.gfm.url,"i").replace("email",z.gfm._extended_email).getRegex(),z.breaks=k({},z.gfm,{br:r(z.br).replace("{2,}","*").getRegex(),text:r(z.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function F(ie){return ie.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function H(ie){var re="",Ee,oe,he=ie.length;for(Ee=0;Ee<he;Ee++)oe=ie.charCodeAt(Ee),Math.random()>.5&&(oe="x"+oe.toString(16)),re+="&#"+oe+";";return re}var K=function(){function ie(Ee){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ee||me.defaults,this.options.tokenizer=this.options.tokenizer||new L,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var oe={block:j.normal,inline:z.normal};this.options.pedantic?(oe.block=j.pedantic,oe.inline=z.pedantic):this.options.gfm&&(oe.block=j.gfm,this.options.breaks?oe.inline=z.breaks:oe.inline=z.gfm),this.tokenizer.rules=oe}ie.lex=function(oe,he){var ee=new ie(he);return ee.lex(oe)},ie.lexInline=function(oe,he){var ee=new ie(he);return ee.inlineTokens(oe)};var re=ie.prototype;return re.lex=function(oe){oe=oe.replace(/\r\n|\r/g,`
`),this.blockTokens(oe,this.tokens);for(var he;he=this.inlineQueue.shift();)this.inlineTokens(he.src,he.tokens);return this.tokens},re.blockTokens=function(oe,he){var ee=this;he===void 0&&(he=[]),this.options.pedantic?oe=oe.replace(/\t/g,"    ").replace(/^ +$/gm,""):oe=oe.replace(/^( *)(\t+)/gm,function(te,se,X){return se+"    ".repeat(X.length)});for(var le,$e,Pe,B;oe;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(te){return(le=te.call({lexer:ee},oe,he))?(oe=oe.substring(le.raw.length),he.push(le),!0):!1}))){if(le=this.tokenizer.space(oe)){oe=oe.substring(le.raw.length),le.raw.length===1&&he.length>0?he[he.length-1].raw+=`
`:he.push(le);continue}if(le=this.tokenizer.code(oe)){oe=oe.substring(le.raw.length),$e=he[he.length-1],$e&&($e.type==="paragraph"||$e.type==="text")?($e.raw+=`
`+le.raw,$e.text+=`
`+le.text,this.inlineQueue[this.inlineQueue.length-1].src=$e.text):he.push(le);continue}if(le=this.tokenizer.fences(oe)){oe=oe.substring(le.raw.length),he.push(le);continue}if(le=this.tokenizer.heading(oe)){oe=oe.substring(le.raw.length),he.push(le);continue}if(le=this.tokenizer.hr(oe)){oe=oe.substring(le.raw.length),he.push(le);continue}if(le=this.tokenizer.blockquote(oe)){oe=oe.substring(le.raw.length),he.push(le);continue}if(le=this.tokenizer.list(oe)){oe=oe.substring(le.raw.length),he.push(le);continue}if(le=this.tokenizer.html(oe)){oe=oe.substring(le.raw.length),he.push(le);continue}if(le=this.tokenizer.def(oe)){oe=oe.substring(le.raw.length),$e=he[he.length-1],$e&&($e.type==="paragraph"||$e.type==="text")?($e.raw+=`
`+le.raw,$e.text+=`
`+le.raw,this.inlineQueue[this.inlineQueue.length-1].src=$e.text):this.tokens.links[le.tag]||(this.tokens.links[le.tag]={href:le.href,title:le.title});continue}if(le=this.tokenizer.table(oe)){oe=oe.substring(le.raw.length),he.push(le);continue}if(le=this.tokenizer.lheading(oe)){oe=oe.substring(le.raw.length),he.push(le);continue}if(Pe=oe,this.options.extensions&&this.options.extensions.startBlock&&function(){var te=1/0,se=oe.slice(1),X=void 0;ee.options.extensions.startBlock.forEach(function(de){X=de.call({lexer:this},se),typeof X=="number"&&X>=0&&(te=Math.min(te,X))}),te<1/0&&te>=0&&(Pe=oe.substring(0,te+1))}(),this.state.top&&(le=this.tokenizer.paragraph(Pe))){$e=he[he.length-1],B&&$e.type==="paragraph"?($e.raw+=`
`+le.raw,$e.text+=`
`+le.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=$e.text):he.push(le),B=Pe.length!==oe.length,oe=oe.substring(le.raw.length);continue}if(le=this.tokenizer.text(oe)){oe=oe.substring(le.raw.length),$e=he[he.length-1],$e&&$e.type==="text"?($e.raw+=`
`+le.raw,$e.text+=`
`+le.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=$e.text):he.push(le);continue}if(oe){var Q="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(Q);break}else throw new Error(Q)}}return this.state.top=!0,he},re.inline=function(oe,he){return he===void 0&&(he=[]),this.inlineQueue.push({src:oe,tokens:he}),he},re.inlineTokens=function(oe,he){var ee=this;he===void 0&&(he=[]);var le,$e,Pe,B=oe,Q,te,se;if(this.tokens.links){var X=Object.keys(this.tokens.links);if(X.length>0)for(;(Q=this.tokenizer.rules.inline.reflinkSearch.exec(B))!=null;)X.includes(Q[0].slice(Q[0].lastIndexOf("[")+1,-1))&&(B=B.slice(0,Q.index)+"["+P("a",Q[0].length-2)+"]"+B.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Q=this.tokenizer.rules.inline.blockSkip.exec(B))!=null;)B=B.slice(0,Q.index)+"["+P("a",Q[0].length-2)+"]"+B.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Q=this.tokenizer.rules.inline.escapedEmSt.exec(B))!=null;)B=B.slice(0,Q.index)+"++"+B.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;oe;)if(te||(se=""),te=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ye){return(le=ye.call({lexer:ee},oe,he))?(oe=oe.substring(le.raw.length),he.push(le),!0):!1}))){if(le=this.tokenizer.escape(oe)){oe=oe.substring(le.raw.length),he.push(le);continue}if(le=this.tokenizer.tag(oe)){oe=oe.substring(le.raw.length),$e=he[he.length-1],$e&&le.type==="text"&&$e.type==="text"?($e.raw+=le.raw,$e.text+=le.text):he.push(le);continue}if(le=this.tokenizer.link(oe)){oe=oe.substring(le.raw.length),he.push(le);continue}if(le=this.tokenizer.reflink(oe,this.tokens.links)){oe=oe.substring(le.raw.length),$e=he[he.length-1],$e&&le.type==="text"&&$e.type==="text"?($e.raw+=le.raw,$e.text+=le.text):he.push(le);continue}if(le=this.tokenizer.emStrong(oe,B,se)){oe=oe.substring(le.raw.length),he.push(le);continue}if(le=this.tokenizer.codespan(oe)){oe=oe.substring(le.raw.length),he.push(le);continue}if(le=this.tokenizer.br(oe)){oe=oe.substring(le.raw.length),he.push(le);continue}if(le=this.tokenizer.del(oe)){oe=oe.substring(le.raw.length),he.push(le);continue}if(le=this.tokenizer.autolink(oe,H)){oe=oe.substring(le.raw.length),he.push(le);continue}if(!this.state.inLink&&(le=this.tokenizer.url(oe,H))){oe=oe.substring(le.raw.length),he.push(le);continue}if(Pe=oe,this.options.extensions&&this.options.extensions.startInline&&function(){var ye=1/0,je=oe.slice(1),We=void 0;ee.options.extensions.startInline.forEach(function(_e){We=_e.call({lexer:this},je),typeof We=="number"&&We>=0&&(ye=Math.min(ye,We))}),ye<1/0&&ye>=0&&(Pe=oe.substring(0,ye+1))}(),le=this.tokenizer.inlineText(Pe,F)){oe=oe.substring(le.raw.length),le.raw.slice(-1)!=="_"&&(se=le.raw.slice(-1)),te=!0,$e=he[he.length-1],$e&&$e.type==="text"?($e.raw+=le.raw,$e.text+=le.text):he.push(le);continue}if(oe){var de="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(de);break}else throw new Error(de)}}return he},C(ie,null,[{key:"rules",get:function(){return{block:j,inline:z}}}]),ie}(),fe=function(){function ie(Ee){this.options=Ee||me.defaults}var re=ie.prototype;return re.code=function(oe,he,ee){var le=(he||"").match(/\S*/)[0];if(this.options.highlight){var $e=this.options.highlight(oe,le);$e!=null&&$e!==oe&&(ee=!0,oe=$e)}return oe=oe.replace(/\n$/,"")+`
`,le?'<pre><code class="'+this.options.langPrefix+D(le,!0)+'">'+(ee?oe:D(oe,!0))+`</code></pre>
`:"<pre><code>"+(ee?oe:D(oe,!0))+`</code></pre>
`},re.blockquote=function(oe){return`<blockquote>
`+oe+`</blockquote>
`},re.html=function(oe){return oe},re.heading=function(oe,he,ee,le){if(this.options.headerIds){var $e=this.options.headerPrefix+le.slug(ee);return"<h"+he+' id="'+$e+'">'+oe+"</h"+he+`>
`}return"<h"+he+">"+oe+"</h"+he+`>
`},re.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},re.list=function(oe,he,ee){var le=he?"ol":"ul",$e=he&&ee!==1?' start="'+ee+'"':"";return"<"+le+$e+`>
`+oe+"</"+le+`>
`},re.listitem=function(oe){return"<li>"+oe+`</li>
`},re.checkbox=function(oe){return"<input "+(oe?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},re.paragraph=function(oe){return"<p>"+oe+`</p>
`},re.table=function(oe,he){return he&&(he="<tbody>"+he+"</tbody>"),`<table>
<thead>
`+oe+`</thead>
`+he+`</table>
`},re.tablerow=function(oe){return`<tr>
`+oe+`</tr>
`},re.tablecell=function(oe,he){var ee=he.header?"th":"td",le=he.align?"<"+ee+' align="'+he.align+'">':"<"+ee+">";return le+oe+("</"+ee+`>
`)},re.strong=function(oe){return"<strong>"+oe+"</strong>"},re.em=function(oe){return"<em>"+oe+"</em>"},re.codespan=function(oe){return"<code>"+oe+"</code>"},re.br=function(){return this.options.xhtml?"<br/>":"<br>"},re.del=function(oe){return"<del>"+oe+"</del>"},re.link=function(oe,he,ee){if(oe=h(this.options.sanitize,this.options.baseUrl,oe),oe===null)return ee;var le='<a href="'+D(oe)+'"';return he&&(le+=' title="'+he+'"'),le+=">"+ee+"</a>",le},re.image=function(oe,he,ee){if(oe=h(this.options.sanitize,this.options.baseUrl,oe),oe===null)return ee;var le='<img src="'+oe+'" alt="'+ee+'"';return he&&(le+=' title="'+he+'"'),le+=this.options.xhtml?"/>":">",le},re.text=function(oe){return oe},ie}(),x=function(){function ie(){}var re=ie.prototype;return re.strong=function(oe){return oe},re.em=function(oe){return oe},re.codespan=function(oe){return oe},re.del=function(oe){return oe},re.html=function(oe){return oe},re.text=function(oe){return oe},re.link=function(oe,he,ee){return""+ee},re.image=function(oe,he,ee){return""+ee},re.br=function(){return""},ie}(),Z=function(){function ie(){this.seen={}}var re=ie.prototype;return re.serialize=function(oe){return oe.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},re.getNextSafeSlug=function(oe,he){var ee=oe,le=0;if(this.seen.hasOwnProperty(ee)){le=this.seen[oe];do le++,ee=oe+"-"+le;while(this.seen.hasOwnProperty(ee))}return he||(this.seen[oe]=le,this.seen[ee]=0),ee},re.slug=function(oe,he){he===void 0&&(he={});var ee=this.serialize(oe);return this.getNextSafeSlug(ee,he.dryrun)},ie}(),q=function(){function ie(Ee){this.options=Ee||me.defaults,this.options.renderer=this.options.renderer||new fe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new x,this.slugger=new Z}ie.parse=function(oe,he){var ee=new ie(he);return ee.parse(oe)},ie.parseInline=function(oe,he){var ee=new ie(he);return ee.parseInline(oe)};var re=ie.prototype;return re.parse=function(oe,he){he===void 0&&(he=!0);var ee="",le,$e,Pe,B,Q,te,se,X,de,ye,je,We,_e,Ye,it,et,Ae,Ne,qe,Me=oe.length;for(le=0;le<Me;le++){if(ye=oe[le],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ye.type]&&(qe=this.options.extensions.renderers[ye.type].call({parser:this},ye),qe!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ye.type))){ee+=qe||"";continue}switch(ye.type){case"space":continue;case"hr":{ee+=this.renderer.hr();continue}case"heading":{ee+=this.renderer.heading(this.parseInline(ye.tokens),ye.depth,l(this.parseInline(ye.tokens,this.textRenderer)),this.slugger);continue}case"code":{ee+=this.renderer.code(ye.text,ye.lang,ye.escaped);continue}case"table":{for(X="",se="",B=ye.header.length,$e=0;$e<B;$e++)se+=this.renderer.tablecell(this.parseInline(ye.header[$e].tokens),{header:!0,align:ye.align[$e]});for(X+=this.renderer.tablerow(se),de="",B=ye.rows.length,$e=0;$e<B;$e++){for(te=ye.rows[$e],se="",Q=te.length,Pe=0;Pe<Q;Pe++)se+=this.renderer.tablecell(this.parseInline(te[Pe].tokens),{header:!1,align:ye.align[Pe]});de+=this.renderer.tablerow(se)}ee+=this.renderer.table(X,de);continue}case"blockquote":{de=this.parse(ye.tokens),ee+=this.renderer.blockquote(de);continue}case"list":{for(je=ye.ordered,We=ye.start,_e=ye.loose,B=ye.items.length,de="",$e=0;$e<B;$e++)it=ye.items[$e],et=it.checked,Ae=it.task,Ye="",it.task&&(Ne=this.renderer.checkbox(et),_e?it.tokens.length>0&&it.tokens[0].type==="paragraph"?(it.tokens[0].text=Ne+" "+it.tokens[0].text,it.tokens[0].tokens&&it.tokens[0].tokens.length>0&&it.tokens[0].tokens[0].type==="text"&&(it.tokens[0].tokens[0].text=Ne+" "+it.tokens[0].tokens[0].text)):it.tokens.unshift({type:"text",text:Ne}):Ye+=Ne),Ye+=this.parse(it.tokens,_e),de+=this.renderer.listitem(Ye,Ae,et);ee+=this.renderer.list(de,je,We);continue}case"html":{ee+=this.renderer.html(ye.text);continue}case"paragraph":{ee+=this.renderer.paragraph(this.parseInline(ye.tokens));continue}case"text":{for(de=ye.tokens?this.parseInline(ye.tokens):ye.text;le+1<Me&&oe[le+1].type==="text";)ye=oe[++le],de+=`
`+(ye.tokens?this.parseInline(ye.tokens):ye.text);ee+=he?this.renderer.paragraph(de):de;continue}default:{var Ze='Token with "'+ye.type+'" type was not found.';if(this.options.silent){console.error(Ze);return}else throw new Error(Ze)}}}return ee},re.parseInline=function(oe,he){he=he||this.renderer;var ee="",le,$e,Pe,B=oe.length;for(le=0;le<B;le++){if($e=oe[le],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[$e.type]&&(Pe=this.options.extensions.renderers[$e.type].call({parser:this},$e),Pe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes($e.type))){ee+=Pe||"";continue}switch($e.type){case"escape":{ee+=he.text($e.text);break}case"html":{ee+=he.html($e.text);break}case"link":{ee+=he.link($e.href,$e.title,this.parseInline($e.tokens,he));break}case"image":{ee+=he.image($e.href,$e.title,$e.text);break}case"strong":{ee+=he.strong(this.parseInline($e.tokens,he));break}case"em":{ee+=he.em(this.parseInline($e.tokens,he));break}case"codespan":{ee+=he.codespan($e.text);break}case"br":{ee+=he.br();break}case"del":{ee+=he.del(this.parseInline($e.tokens,he));break}case"text":{ee+=he.text($e.text);break}default:{var Q='Token with "'+$e.type+'" type was not found.';if(this.options.silent){console.error(Q);return}else throw new Error(Q)}}}return ee},ie}();function Y(ie,re,Ee){if(typeof ie>"u"||ie===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ie!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ie)+", string expected");if(typeof re=="function"&&(Ee=re,re=null),re=k({},Y.defaults,re||{}),f(re),Ee){var oe=re.highlight,he;try{he=K.lex(ie,re)}catch(B){return Ee(B)}var ee=function(Q){var te;if(!Q)try{re.walkTokens&&Y.walkTokens(he,re.walkTokens),te=q.parse(he,re)}catch(se){Q=se}return re.highlight=oe,Q?Ee(Q):Ee(null,te)};if(!oe||oe.length<3||(delete re.highlight,!he.length))return ee();var le=0;Y.walkTokens(he,function(B){B.type==="code"&&(le++,setTimeout(function(){oe(B.text,B.lang,function(Q,te){if(Q)return ee(Q);te!=null&&te!==B.text&&(B.text=te,B.escaped=!0),le--,le===0&&ee()})},0))}),le===0&&ee();return}function $e(B){if(B.message+=`
Please report this to https://github.com/markedjs/marked.`,re.silent)return"<p>An error occurred:</p><pre>"+D(B.message+"",!0)+"</pre>";throw B}try{var Pe=K.lex(ie,re);if(re.walkTokens){if(re.async)return Promise.all(Y.walkTokens(Pe,re.walkTokens)).then(function(){return q.parse(Pe,re)}).catch($e);Y.walkTokens(Pe,re.walkTokens)}return q.parse(Pe,re)}catch(B){$e(B)}}Y.options=Y.setOptions=function(ie){return k(Y.defaults,ie),b(Y.defaults),Y},Y.getDefaults=A,Y.defaults=me.defaults,Y.use=function(){for(var ie=arguments.length,re=new Array(ie),Ee=0;Ee<ie;Ee++)re[Ee]=arguments[Ee];var oe=k.apply(void 0,[{}].concat(re)),he=Y.defaults.extensions||{renderers:{},childTokens:{}},ee;re.forEach(function(le){if(le.extensions&&(ee=!0,le.extensions.forEach(function(Pe){if(!Pe.name)throw new Error("extension name required");if(Pe.renderer){var B=he.renderers?he.renderers[Pe.name]:null;B?he.renderers[Pe.name]=function(){for(var Q=arguments.length,te=new Array(Q),se=0;se<Q;se++)te[se]=arguments[se];var X=Pe.renderer.apply(this,te);return X===!1&&(X=B.apply(this,te)),X}:he.renderers[Pe.name]=Pe.renderer}if(Pe.tokenizer){if(!Pe.level||Pe.level!=="block"&&Pe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");he[Pe.level]?he[Pe.level].unshift(Pe.tokenizer):he[Pe.level]=[Pe.tokenizer],Pe.start&&(Pe.level==="block"?he.startBlock?he.startBlock.push(Pe.start):he.startBlock=[Pe.start]:Pe.level==="inline"&&(he.startInline?he.startInline.push(Pe.start):he.startInline=[Pe.start]))}Pe.childTokens&&(he.childTokens[Pe.name]=Pe.childTokens)})),le.renderer&&function(){var Pe=Y.defaults.renderer||new fe,B=function(se){var X=Pe[se];Pe[se]=function(){for(var de=arguments.length,ye=new Array(de),je=0;je<de;je++)ye[je]=arguments[je];var We=le.renderer[se].apply(Pe,ye);return We===!1&&(We=X.apply(Pe,ye)),We}};for(var Q in le.renderer)B(Q);oe.renderer=Pe}(),le.tokenizer&&function(){var Pe=Y.defaults.tokenizer||new L,B=function(se){var X=Pe[se];Pe[se]=function(){for(var de=arguments.length,ye=new Array(de),je=0;je<de;je++)ye[je]=arguments[je];var We=le.tokenizer[se].apply(Pe,ye);return We===!1&&(We=X.apply(Pe,ye)),We}};for(var Q in le.tokenizer)B(Q);oe.tokenizer=Pe}(),le.walkTokens){var $e=Y.defaults.walkTokens;oe.walkTokens=function(Pe){var B=[];return B.push(le.walkTokens.call(this,Pe)),$e&&(B=B.concat($e.call(this,Pe))),B}}ee&&(oe.extensions=he),Y.setOptions(oe)})},Y.walkTokens=function(ie,re){for(var Ee=[],oe=function(){var $e=ee.value;switch(Ee=Ee.concat(re.call(Y,$e)),$e.type){case"table":{for(var Pe=M($e.header),B;!(B=Pe()).done;){var Q=B.value;Ee=Ee.concat(Y.walkTokens(Q.tokens,re))}for(var te=M($e.rows),se;!(se=te()).done;)for(var X=se.value,de=M(X),ye;!(ye=de()).done;){var je=ye.value;Ee=Ee.concat(Y.walkTokens(je.tokens,re))}break}case"list":{Ee=Ee.concat(Y.walkTokens($e.items,re));break}default:Y.defaults.extensions&&Y.defaults.extensions.childTokens&&Y.defaults.extensions.childTokens[$e.type]?Y.defaults.extensions.childTokens[$e.type].forEach(function(We){Ee=Ee.concat(Y.walkTokens($e[We],re))}):$e.tokens&&(Ee=Ee.concat(Y.walkTokens($e.tokens,re)))}},he=M(ie),ee;!(ee=he()).done;)oe();return Ee},Y.parseInline=function(ie,re){if(typeof ie>"u"||ie===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ie!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ie)+", string expected");re=k({},Y.defaults,re||{}),f(re);try{var Ee=K.lexInline(ie,re);return re.walkTokens&&Y.walkTokens(Ee,re.walkTokens),q.parseInline(Ee,re)}catch(oe){if(oe.message+=`
Please report this to https://github.com/markedjs/marked.`,re.silent)return"<p>An error occurred:</p><pre>"+D(oe.message+"",!0)+"</pre>";throw oe}},Y.Parser=q,Y.parser=q.parse,Y.Renderer=fe,Y.TextRenderer=x,Y.Lexer=K,Y.lexer=K.lex,Y.Tokenizer=L,Y.Slugger=Z,Y.parse=Y;var be=Y.options,ue=Y.setOptions,ve=Y.use,J=Y.walkTokens,U=Y.parseInline,V=Y,ge=q.parse,_=K.lex;me.Lexer=K,me.Parser=q,me.Renderer=fe,me.Slugger=Z,me.TextRenderer=x,me.Tokenizer=L,me.getDefaults=A,me.lexer=_,me.marked=Y,me.options=be,me.parse=V,me.parseInline=U,me.parser=ge,me.setOptions=ue,me.use=ve,me.walkTokens=J,Object.defineProperty(me,"__esModule",{value:!0})}),define(De[76],Ce([1,0,28]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ml=e.$ll=e.$kl=void 0;const T=new C.$Cc(1e4);function d(w){return E(w,"NFC",T)}e.$kl=d;const M=new C.$Cc(1e4);function A(w){return E(w,"NFD",M)}e.$ll=A;const b=/[^\u0000-\u0080]/;function E(w,R,I){if(!w)return w;const p=I.get(w);if(p)return p;let y;return b.test(w)?y=w.normalize(R):y=w,I.set(w,y),y}e.$ml=function(){const w=/[\u0300-\u036f]/g;return function(R){return A(R).replace(w,"")}}()}),define(De[120],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ol=e.$Nl=e.$Ml=e.rot=e.$Kl=void 0;function C(b,E,w){return Math.min(Math.max(b,E),w)}e.$Kl=C;function T(b,E){return(E+b%E)%E}e.rot=T;class d{constructor(){this.a=0}getNext(){return this.a++}}e.$Ml=d;class M{constructor(){this.a=1,this.b=0}update(E){return this.b=this.b+(E-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Nl=M;class A{constructor(E){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(E),this.c.fill(0,0,E)}update(E){const w=this.c[this.d];return this.c[this.d]=E,this.d=(this.d+1)%this.c.length,this.e-=w,this.e+=E,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Ol=A}),function(){function me(d){const M=[];typeof d=="number"&&M.push("code/timeOrigin",d);function A(E){M.push(E,Date.now())}function b(){const E=[];for(let w=0;w<M.length;w+=2)E.push({name:M[w],startTime:M[w+1]});return E}return{mark:A,getMarks:b}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?me():{mark(d){performance.mark(d)},getMarks(){let d=performance.timeOrigin;typeof d!="number"&&(d=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(d)}];for(const A of performance.getEntriesByType("mark"))M.push({name:A.name,startTime:Math.round(d+A.startTime)});return M}};if(typeof process=="object"){const d=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return me(d)}else return console.trace("perf-util loaded in UNKNOWN environment"),me()}function C(d){return d.MonacoPerformanceMarks||(d.MonacoPerformanceMarks=e()),d.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return C(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=C(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=C(T))}(),function(me,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var C=e();for(var T in C)(typeof exports=="object"?exports:me)[T]=C[T]}}(typeof self<"u"?self:this,function(){return function(me){var e={};function C(T){if(e[T])return e[T].exports;var d=e[T]={i:T,l:!1,exports:{}};return me[T].call(d.exports,d,d.exports,C),d.l=!0,d.exports}return C.m=me,C.c=e,C.d=function(T,d,M){C.o(T,d)||Object.defineProperty(T,d,{enumerable:!0,get:M})},C.r=function(T){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(T,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(T,"__esModule",{value:!0})},C.t=function(T,d){if(1&d&&(T=C(T)),8&d||4&d&&typeof T=="object"&&T&&T.__esModule)return T;var M=Object.create(null);if(C.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:T}),2&d&&typeof T!="string")for(var A in T)C.d(M,A,function(b){return T[b]}.bind(null,A));return M},C.n=function(T){var d=T&&T.__esModule?function(){return T.default}:function(){return T};return C.d(d,"a",d),d},C.o=function(T,d){return Object.prototype.hasOwnProperty.call(T,d)},C.p="",C(C.s=0)}([function(me,e,C){(function(T){var d;e=me.exports=ve,d=typeof T=="object"&&T.env&&T.env.NODE_DEBUG&&/\bsemver\b/i.test(T.env.NODE_DEBUG)?function(){var X=Array.prototype.slice.call(arguments,0);X.unshift("SEMVER"),console.log.apply(console,X)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,b=e.re=[],E=e.src=[],w=0,R=w++;E[R]="0|[1-9]\\d*";var I=w++;E[I]="[0-9]+";var p=w++;E[p]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var y=w++;E[y]="("+E[R]+")\\.("+E[R]+")\\.("+E[R]+")";var D=w++;E[D]="("+E[I]+")\\.("+E[I]+")\\.("+E[I]+")";var v=w++;E[v]="(?:"+E[R]+"|"+E[p]+")";var l=w++;E[l]="(?:"+E[I]+"|"+E[p]+")";var s=w++;E[s]="(?:-("+E[v]+"(?:\\."+E[v]+")*))";var r=w++;E[r]="(?:-?("+E[l]+"(?:\\."+E[l]+")*))";var c=w++;E[c]="[0-9A-Za-z-]+";var m=w++;E[m]="(?:\\+("+E[c]+"(?:\\."+E[c]+")*))";var h=w++,t="v?"+E[y]+E[s]+"?"+E[m]+"?";E[h]="^"+t+"$";var n="[v=\\s]*"+E[D]+E[r]+"?"+E[m]+"?",o=w++;E[o]="^"+n+"$";var i=w++;E[i]="((?:<|>)?=?)";var a=w++;E[a]=E[I]+"|x|X|\\*";var u=w++;E[u]=E[R]+"|x|X|\\*";var k=w++;E[k]="[v=\\s]*("+E[u]+")(?:\\.("+E[u]+")(?:\\.("+E[u]+")(?:"+E[s]+")?"+E[m]+"?)?)?";var S=w++;E[S]="[v=\\s]*("+E[a]+")(?:\\.("+E[a]+")(?:\\.("+E[a]+")(?:"+E[r]+")?"+E[m]+"?)?)?";var $=w++;E[$]="^"+E[i]+"\\s*"+E[k]+"$";var g=w++;E[g]="^"+E[i]+"\\s*"+E[S]+"$";var f=w++;E[f]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var P=w++;E[P]="(?:~>?)";var N=w++;E[N]="(\\s*)"+E[P]+"\\s+",b[N]=new RegExp(E[N],"g");var O=w++;E[O]="^"+E[P]+E[k]+"$";var L=w++;E[L]="^"+E[P]+E[S]+"$";var j=w++;E[j]="(?:\\^)";var z=w++;E[z]="(\\s*)"+E[j]+"\\s+",b[z]=new RegExp(E[z],"g");var F=w++;E[F]="^"+E[j]+E[k]+"$";var H=w++;E[H]="^"+E[j]+E[S]+"$";var K=w++;E[K]="^"+E[i]+"\\s*("+n+")$|^$";var fe=w++;E[fe]="^"+E[i]+"\\s*("+t+")$|^$";var x=w++;E[x]="(\\s*)"+E[i]+"\\s*("+n+"|"+E[k]+")",b[x]=new RegExp(E[x],"g");var Z=w++;E[Z]="^\\s*("+E[k]+")\\s+-\\s+("+E[k]+")\\s*$";var q=w++;E[q]="^\\s*("+E[S]+")\\s+-\\s+("+E[S]+")\\s*$";var Y=w++;E[Y]="(<|>)?=?\\s*\\*";for(var be=0;be<35;be++)d(be,E[be]),b[be]||(b[be]=new RegExp(E[be]));function ue(X,de){if(X instanceof ve)return X;if(typeof X!="string"||X.length>M||!(de?b[o]:b[h]).test(X))return null;try{return new ve(X,de)}catch{return null}}function ve(X,de){if(X instanceof ve){if(X.loose===de)return X;X=X.version}else if(typeof X!="string")throw new TypeError("Invalid Version: "+X);if(X.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof ve))return new ve(X,de);d("SemVer",X,de),this.loose=de;var ye=X.trim().match(de?b[o]:b[h]);if(!ye)throw new TypeError("Invalid Version: "+X);if(this.raw=X,this.major=+ye[1],this.minor=+ye[2],this.patch=+ye[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");ye[4]?this.prerelease=ye[4].split(".").map(function(je){if(/^[0-9]+$/.test(je)){var We=+je;if(We>=0&&We<A)return We}return je}):this.prerelease=[],this.build=ye[5]?ye[5].split("."):[],this.format()}e.parse=ue,e.valid=function(X,de){var ye=ue(X,de);return ye?ye.version:null},e.clean=function(X,de){var ye=ue(X.trim().replace(/^[=v]+/,""),de);return ye?ye.version:null},e.SemVer=ve,ve.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ve.prototype.toString=function(){return this.version},ve.prototype.compare=function(X){return d("SemVer.compare",this.version,this.loose,X),X instanceof ve||(X=new ve(X,this.loose)),this.compareMain(X)||this.comparePre(X)},ve.prototype.compareMain=function(X){return X instanceof ve||(X=new ve(X,this.loose)),U(this.major,X.major)||U(this.minor,X.minor)||U(this.patch,X.patch)},ve.prototype.comparePre=function(X){if(X instanceof ve||(X=new ve(X,this.loose)),this.prerelease.length&&!X.prerelease.length)return-1;if(!this.prerelease.length&&X.prerelease.length)return 1;if(!this.prerelease.length&&!X.prerelease.length)return 0;var de=0;do{var ye=this.prerelease[de],je=X.prerelease[de];if(d("prerelease compare",de,ye,je),ye===void 0&&je===void 0)return 0;if(je===void 0)return 1;if(ye===void 0)return-1;if(ye!==je)return U(ye,je)}while(++de)},ve.prototype.inc=function(X,de){switch(X){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",de);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",de);break;case"prepatch":this.prerelease.length=0,this.inc("patch",de),this.inc("pre",de);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",de),this.inc("pre",de);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ye=this.prerelease.length;--ye>=0;)typeof this.prerelease[ye]=="number"&&(this.prerelease[ye]++,ye=-2);ye===-1&&this.prerelease.push(0)}de&&(this.prerelease[0]===de?isNaN(this.prerelease[1])&&(this.prerelease=[de,0]):this.prerelease=[de,0]);break;default:throw new Error("invalid increment argument: "+X)}return this.format(),this.raw=this.version,this},e.inc=function(X,de,ye,je){typeof ye=="string"&&(je=ye,ye=void 0);try{return new ve(X,ye).inc(de,je).version}catch{return null}},e.diff=function(X,de){if(ie(X,de))return null;var ye=ue(X),je=ue(de);if(ye.prerelease.length||je.prerelease.length){for(var We in ye)if((We==="major"||We==="minor"||We==="patch")&&ye[We]!==je[We])return"pre"+We;return"prerelease"}for(var We in ye)if((We==="major"||We==="minor"||We==="patch")&&ye[We]!==je[We])return We},e.compareIdentifiers=U;var J=/^[0-9]+$/;function U(X,de){var ye=J.test(X),je=J.test(de);return ye&&je&&(X=+X,de=+de),ye&&!je?-1:je&&!ye?1:X<de?-1:X>de?1:0}function V(X,de,ye){return new ve(X,ye).compare(new ve(de,ye))}function ge(X,de,ye){return V(X,de,ye)>0}function _(X,de,ye){return V(X,de,ye)<0}function ie(X,de,ye){return V(X,de,ye)===0}function re(X,de,ye){return V(X,de,ye)!==0}function Ee(X,de,ye){return V(X,de,ye)>=0}function oe(X,de,ye){return V(X,de,ye)<=0}function he(X,de,ye,je){var We;switch(de){case"===":typeof X=="object"&&(X=X.version),typeof ye=="object"&&(ye=ye.version),We=X===ye;break;case"!==":typeof X=="object"&&(X=X.version),typeof ye=="object"&&(ye=ye.version),We=X!==ye;break;case"":case"=":case"==":We=ie(X,ye,je);break;case"!=":We=re(X,ye,je);break;case">":We=ge(X,ye,je);break;case">=":We=Ee(X,ye,je);break;case"<":We=_(X,ye,je);break;case"<=":We=oe(X,ye,je);break;default:throw new TypeError("Invalid operator: "+de)}return We}function ee(X,de){if(X instanceof ee){if(X.loose===de)return X;X=X.value}if(!(this instanceof ee))return new ee(X,de);d("comparator",X,de),this.loose=de,this.parse(X),this.semver===le?this.value="":this.value=this.operator+this.semver.version,d("comp",this)}e.rcompareIdentifiers=function(X,de){return U(de,X)},e.major=function(X,de){return new ve(X,de).major},e.minor=function(X,de){return new ve(X,de).minor},e.patch=function(X,de){return new ve(X,de).patch},e.compare=V,e.compareLoose=function(X,de){return V(X,de,!0)},e.rcompare=function(X,de,ye){return V(de,X,ye)},e.sort=function(X,de){return X.sort(function(ye,je){return e.compare(ye,je,de)})},e.rsort=function(X,de){return X.sort(function(ye,je){return e.rcompare(ye,je,de)})},e.gt=ge,e.lt=_,e.eq=ie,e.neq=re,e.gte=Ee,e.lte=oe,e.cmp=he,e.Comparator=ee;var le={};function $e(X,de){if(X instanceof $e)return X.loose===de?X:new $e(X.raw,de);if(X instanceof ee)return new $e(X.value,de);if(!(this instanceof $e))return new $e(X,de);if(this.loose=de,this.raw=X,this.set=X.split(/\s*\|\|\s*/).map(function(ye){return this.parseRange(ye.trim())},this).filter(function(ye){return ye.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+X);this.format()}function Pe(X){return!X||X.toLowerCase()==="x"||X==="*"}function B(X,de,ye,je,We,_e,Ye,it,et,Ae,Ne,qe,Me){return((de=Pe(ye)?"":Pe(je)?">="+ye+".0.0":Pe(We)?">="+ye+"."+je+".0":">="+de)+" "+(it=Pe(et)?"":Pe(Ae)?"<"+(+et+1)+".0.0":Pe(Ne)?"<"+et+"."+(+Ae+1)+".0":qe?"<="+et+"."+Ae+"."+Ne+"-"+qe:"<="+it)).trim()}function Q(X,de){for(var ye=0;ye<X.length;ye++)if(!X[ye].test(de))return!1;if(de.prerelease.length){for(ye=0;ye<X.length;ye++)if(d(X[ye].semver),X[ye].semver!==le&&X[ye].semver.prerelease.length>0){var je=X[ye].semver;if(je.major===de.major&&je.minor===de.minor&&je.patch===de.patch)return!0}return!1}return!0}function te(X,de,ye){try{de=new $e(de,ye)}catch{return!1}return de.test(X)}function se(X,de,ye,je){var We,_e,Ye,it,et;switch(X=new ve(X,je),de=new $e(de,je),ye){case">":We=ge,_e=oe,Ye=_,it=">",et=">=";break;case"<":We=_,_e=Ee,Ye=ge,it="<",et="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(te(X,de,je))return!1;for(var Ae=0;Ae<de.set.length;++Ae){var Ne=de.set[Ae],qe=null,Me=null;if(Ne.forEach(function(Ze){Ze.semver===le&&(Ze=new ee(">=0.0.0")),qe=qe||Ze,Me=Me||Ze,We(Ze.semver,qe.semver,je)?qe=Ze:Ye(Ze.semver,Me.semver,je)&&(Me=Ze)}),qe.operator===it||qe.operator===et||(!Me.operator||Me.operator===it)&&_e(X,Me.semver)||Me.operator===et&&Ye(X,Me.semver))return!1}return!0}ee.prototype.parse=function(X){var de=this.loose?b[K]:b[fe],ye=X.match(de);if(!ye)throw new TypeError("Invalid comparator: "+X);this.operator=ye[1],this.operator==="="&&(this.operator=""),ye[2]?this.semver=new ve(ye[2],this.loose):this.semver=le},ee.prototype.toString=function(){return this.value},ee.prototype.test=function(X){return d("Comparator.test",X,this.loose),this.semver===le||(typeof X=="string"&&(X=new ve(X,this.loose)),he(X,this.operator,this.semver,this.loose))},ee.prototype.intersects=function(X,de){if(!(X instanceof ee))throw new TypeError("a Comparator is required");var ye;if(this.operator==="")return ye=new $e(X.value,de),te(this.value,ye,de);if(X.operator==="")return ye=new $e(this.value,de),te(X.semver,ye,de);var je=!(this.operator!==">="&&this.operator!==">"||X.operator!==">="&&X.operator!==">"),We=!(this.operator!=="<="&&this.operator!=="<"||X.operator!=="<="&&X.operator!=="<"),_e=this.semver.version===X.semver.version,Ye=!(this.operator!==">="&&this.operator!=="<="||X.operator!==">="&&X.operator!=="<="),it=he(this.semver,"<",X.semver,de)&&(this.operator===">="||this.operator===">")&&(X.operator==="<="||X.operator==="<"),et=he(this.semver,">",X.semver,de)&&(this.operator==="<="||this.operator==="<")&&(X.operator===">="||X.operator===">");return je||We||_e&&Ye||it||et},e.Range=$e,$e.prototype.format=function(){return this.range=this.set.map(function(X){return X.join(" ").trim()}).join("||").trim(),this.range},$e.prototype.toString=function(){return this.range},$e.prototype.parseRange=function(X){var de=this.loose;X=X.trim(),d("range",X,de);var ye=de?b[q]:b[Z];X=X.replace(ye,B),d("hyphen replace",X),X=X.replace(b[x],"$1$2$3"),d("comparator trim",X,b[x]),X=(X=(X=X.replace(b[N],"$1~")).replace(b[z],"$1^")).split(/\s+/).join(" ");var je=de?b[K]:b[fe],We=X.split(" ").map(function(_e){return function(Ye,it){return d("comp",Ye),Ye=function(et,Ae){return et.trim().split(/\s+/).map(function(Ne){return function(qe,Me){d("caret",qe,Me);var Ze=Me?b[H]:b[F];return qe.replace(Ze,function(ce,ae,Ie,Ve,ze){var Xe;return d("caret",qe,ce,ae,Ie,Ve,ze),Pe(ae)?Xe="":Pe(Ie)?Xe=">="+ae+".0.0 <"+(+ae+1)+".0.0":Pe(Ve)?Xe=ae==="0"?">="+ae+"."+Ie+".0 <"+ae+"."+(+Ie+1)+".0":">="+ae+"."+Ie+".0 <"+(+ae+1)+".0.0":ze?(d("replaceCaret pr",ze),ze.charAt(0)!=="-"&&(ze="-"+ze),Xe=ae==="0"?Ie==="0"?">="+ae+"."+Ie+"."+Ve+ze+" <"+ae+"."+Ie+"."+(+Ve+1):">="+ae+"."+Ie+"."+Ve+ze+" <"+ae+"."+(+Ie+1)+".0":">="+ae+"."+Ie+"."+Ve+ze+" <"+(+ae+1)+".0.0"):(d("no pr"),Xe=ae==="0"?Ie==="0"?">="+ae+"."+Ie+"."+Ve+" <"+ae+"."+Ie+"."+(+Ve+1):">="+ae+"."+Ie+"."+Ve+" <"+ae+"."+(+Ie+1)+".0":">="+ae+"."+Ie+"."+Ve+" <"+(+ae+1)+".0.0"),d("caret return",Xe),Xe})}(Ne,Ae)}).join(" ")}(Ye,it),d("caret",Ye),Ye=function(et,Ae){return et.trim().split(/\s+/).map(function(Ne){return function(qe,Me){var Ze=Me?b[L]:b[O];return qe.replace(Ze,function(ce,ae,Ie,Ve,ze){var Xe;return d("tilde",qe,ce,ae,Ie,Ve,ze),Pe(ae)?Xe="":Pe(Ie)?Xe=">="+ae+".0.0 <"+(+ae+1)+".0.0":Pe(Ve)?Xe=">="+ae+"."+Ie+".0 <"+ae+"."+(+Ie+1)+".0":ze?(d("replaceTilde pr",ze),ze.charAt(0)!=="-"&&(ze="-"+ze),Xe=">="+ae+"."+Ie+"."+Ve+ze+" <"+ae+"."+(+Ie+1)+".0"):Xe=">="+ae+"."+Ie+"."+Ve+" <"+ae+"."+(+Ie+1)+".0",d("tilde return",Xe),Xe})}(Ne,Ae)}).join(" ")}(Ye,it),d("tildes",Ye),Ye=function(et,Ae){return d("replaceXRanges",et,Ae),et.split(/\s+/).map(function(Ne){return function(qe,Me){qe=qe.trim();var Ze=Me?b[g]:b[$];return qe.replace(Ze,function(ce,ae,Ie,Ve,ze,Xe){d("xRange",qe,ce,ae,Ie,Ve,ze,Xe);var rt=Pe(Ie),ot=rt||Pe(Ve),wt=ot||Pe(ze);return ae==="="&&wt&&(ae=""),rt?ce=ae===">"||ae==="<"?"<0.0.0":"*":ae&&wt?(ot&&(Ve=0),wt&&(ze=0),ae===">"?(ae=">=",ot?(Ie=+Ie+1,Ve=0,ze=0):wt&&(Ve=+Ve+1,ze=0)):ae==="<="&&(ae="<",ot?Ie=+Ie+1:Ve=+Ve+1),ce=ae+Ie+"."+Ve+"."+ze):ot?ce=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":wt&&(ce=">="+Ie+"."+Ve+".0 <"+Ie+"."+(+Ve+1)+".0"),d("xRange return",ce),ce})}(Ne,Ae)}).join(" ")}(Ye,it),d("xrange",Ye),Ye=function(et,Ae){return d("replaceStars",et,Ae),et.trim().replace(b[Y],"")}(Ye,it),d("stars",Ye),Ye}(_e,de)}).join(" ").split(/\s+/);return this.loose&&(We=We.filter(function(_e){return!!_e.match(je)})),We=We.map(function(_e){return new ee(_e,de)})},$e.prototype.intersects=function(X,de){if(!(X instanceof $e))throw new TypeError("a Range is required");return this.set.some(function(ye){return ye.every(function(je){return X.set.some(function(We){return We.every(function(_e){return je.intersects(_e,de)})})})})},e.toComparators=function(X,de){return new $e(X,de).set.map(function(ye){return ye.map(function(je){return je.value}).join(" ").trim().split(" ")})},$e.prototype.test=function(X){if(!X)return!1;typeof X=="string"&&(X=new ve(X,this.loose));for(var de=0;de<this.set.length;de++)if(Q(this.set[de],X))return!0;return!1},e.satisfies=te,e.maxSatisfying=function(X,de,ye){var je=null,We=null;try{var _e=new $e(de,ye)}catch{return null}return X.forEach(function(Ye){_e.test(Ye)&&(je&&We.compare(Ye)!==-1||(We=new ve(je=Ye,ye)))}),je},e.minSatisfying=function(X,de,ye){var je=null,We=null;try{var _e=new $e(de,ye)}catch{return null}return X.forEach(function(Ye){_e.test(Ye)&&(je&&We.compare(Ye)!==1||(We=new ve(je=Ye,ye)))}),je},e.validRange=function(X,de){try{return new $e(X,de).range||"*"}catch{return null}},e.ltr=function(X,de,ye){return se(X,de,"<",ye)},e.gtr=function(X,de,ye){return se(X,de,">",ye)},e.outside=se,e.prerelease=function(X,de){var ye=ue(X,de);return ye&&ye.prerelease.length?ye.prerelease:null},e.intersects=function(X,de,ye){return X=new $e(X,ye),de=new $e(de,ye),X.intersects(de)},e.coerce=function(X){if(X instanceof ve)return X;if(typeof X!="string")return null;var de=X.match(b[f]);return de==null?null:ue((de[1]||"0")+"."+(de[2]||"0")+"."+(de[3]||"0"))}}).call(this,C(1))},function(me,e){var C,T,d=me.exports={};function M(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function b(l){if(C===setTimeout)return setTimeout(l,0);if((C===M||!C)&&setTimeout)return C=setTimeout,setTimeout(l,0);try{return C(l,0)}catch{try{return C.call(null,l,0)}catch{return C.call(this,l,0)}}}(function(){try{C=typeof setTimeout=="function"?setTimeout:M}catch{C=M}try{T=typeof clearTimeout=="function"?clearTimeout:A}catch{T=A}})();var E,w=[],R=!1,I=-1;function p(){R&&E&&(R=!1,E.length?w=E.concat(w):I=-1,w.length&&y())}function y(){if(!R){var l=b(p);R=!0;for(var s=w.length;s;){for(E=w,w=[];++I<s;)E&&E[I].run();I=-1,s=w.length}E=null,R=!1,function(r){if(T===clearTimeout)return clearTimeout(r);if((T===A||!T)&&clearTimeout)return T=clearTimeout,clearTimeout(r);try{T(r)}catch{try{return T.call(null,r)}catch{return T.call(this,r)}}}(l)}}function D(l,s){this.fun=l,this.array=s}function v(){}d.nextTick=function(l){var s=new Array(arguments.length-1);if(arguments.length>1)for(var r=1;r<arguments.length;r++)s[r-1]=arguments[r];w.push(new D(l,s)),w.length!==1||R||b(y)},D.prototype.run=function(){this.fun.apply(null,this.array)},d.title="browser",d.browser=!0,d.env={},d.argv=[],d.version="",d.versions={},d.on=v,d.addListener=v,d.once=v,d.off=v,d.removeListener=v,d.removeAllListeners=v,d.emit=v,d.prependListener=v,d.prependOnceListener=v,d.listeners=function(l){return[]},d.binding=function(l){throw new Error("process.binding is not supported")},d.cwd=function(){return"/"},d.chdir=function(l){throw new Error("process.chdir is not supported")},d.umask=function(){return 0}}])}),define(De[37],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Id=void 0;const C=globalThis.performance&&typeof globalThis.performance.now=="function";class T{static create(M){return new T(M)}constructor(M){this.c=C&&M===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Id=T}),define(De[4],Ce([1,0,8,74,3,75,37]),function(me,e,C,T,d,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.$Kd=e.Event=void 0;const b=!1,E=!1;var w;(function($){$.None=()=>d.$Rc.None;function g(he){if(E){const{onDidAddListener:ee}=he,le=D.create();let $e=0;he.onDidAddListener=()=>{++$e===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),le.print()),ee?.()}}}function f(he,ee){return fe(he,()=>{},0,void 0,!0,void 0,ee)}$.defer=f;function P(he){return(ee,le=null,$e)=>{let Pe=!1,B;return B=he(Q=>{if(!Pe)return B?B.dispose():Pe=!0,ee.call(le,Q)},null,$e),Pe&&B.dispose(),B}}$.once=P;function N(he,ee,le){return H(($e,Pe=null,B)=>he(Q=>$e.call(Pe,ee(Q)),null,B),le)}$.map=N;function O(he,ee,le){return H(($e,Pe=null,B)=>he(Q=>{ee(Q),$e.call(Pe,Q)},null,B),le)}$.forEach=O;function L(he,ee,le){return H(($e,Pe=null,B)=>he(Q=>ee(Q)&&$e.call(Pe,Q),null,B),le)}$.filter=L;function j(he){return he}$.signal=j;function z(...he){return(ee,le=null,$e)=>{const Pe=(0,d.$Oc)(...he.map(B=>B(Q=>ee.call(le,Q))));return K(Pe,$e)}}$.any=z;function F(he,ee,le,$e){let Pe=le;return N(he,B=>(Pe=ee(Pe,B),Pe),$e)}$.reduce=F;function H(he,ee){let le;const $e={onWillAddFirstListener(){le=he(Pe.fire,Pe)},onDidRemoveLastListener(){le?.dispose()}};ee||g($e);const Pe=new c($e);return ee?.add(Pe),Pe.event}function K(he,ee){return ee instanceof Array?ee.push(he):ee&&ee.add(he),he}function fe(he,ee,le=100,$e=!1,Pe=!1,B,Q){let te,se,X,de=0,ye;const je={leakWarningThreshold:B,onWillAddFirstListener(){te=he(_e=>{de++,se=ee(se,_e),$e&&!X&&(We.fire(se),se=void 0),ye=()=>{const Ye=se;se=void 0,X=void 0,(!$e||de>1)&&We.fire(Ye),de=0},typeof le=="number"?(clearTimeout(X),X=setTimeout(ye,le)):X===void 0&&(X=0,queueMicrotask(ye))})},onWillRemoveListener(){Pe&&de>0&&ye?.()},onDidRemoveLastListener(){ye=void 0,te.dispose()}};Q||g(je);const We=new c(je);return Q?.add(We),We.event}$.debounce=fe;function x(he,ee=0,le){return $.debounce(he,($e,Pe)=>$e?($e.push(Pe),$e):[Pe],ee,void 0,!0,void 0,le)}$.accumulate=x;function Z(he,ee=($e,Pe)=>$e===Pe,le){let $e=!0,Pe;return L(he,B=>{const Q=$e||!ee(B,Pe);return $e=!1,Pe=B,Q},le)}$.latch=Z;function q(he,ee,le){return[$.filter(he,ee,le),$.filter(he,$e=>!ee($e),le)]}$.split=q;function Y(he,ee=!1,le=[],$e){let Pe=le.slice(),B=he(se=>{Pe?Pe.push(se):te.fire(se)});$e&&$e.add(B);const Q=()=>{Pe?.forEach(se=>te.fire(se)),Pe=null},te=new c({onWillAddFirstListener(){B||(B=he(se=>te.fire(se)),$e&&$e.add(B))},onDidAddFirstListener(){Pe&&(ee?setTimeout(Q):Q())},onDidRemoveLastListener(){B&&B.dispose(),B=null}});return $e&&$e.add(te),te.event}$.buffer=Y;function be(he,ee){return($e,Pe,B)=>{const Q=ee(new ve);return he(function(te){const se=Q.evaluate(te);se!==ue&&$e.call(Pe,se)},void 0,B)}}$.chain=be;const ue=Symbol("HaltChainable");class ve{constructor(){this.f=[]}map(ee){return this.f.push(ee),this}forEach(ee){return this.f.push(le=>(ee(le),le)),this}filter(ee){return this.f.push(le=>ee(le)?le:ue),this}reduce(ee,le){let $e=le;return this.f.push(Pe=>($e=ee($e,Pe),$e)),this}latch(ee=(le,$e)=>le===$e){let le=!0,$e;return this.f.push(Pe=>{const B=le||!ee(Pe,$e);return le=!1,$e=Pe,B?Pe:ue}),this}evaluate(ee){for(const le of this.f)if(ee=le(ee),ee===ue)break;return ee}}function J(he,ee,le=$e=>$e){const $e=(...te)=>Q.fire(le(...te)),Pe=()=>he.on(ee,$e),B=()=>he.removeListener(ee,$e),Q=new c({onWillAddFirstListener:Pe,onDidRemoveLastListener:B});return Q.event}$.fromNodeEventEmitter=J;function U(he,ee,le=$e=>$e){const $e=(...te)=>Q.fire(le(...te)),Pe=()=>he.addEventListener(ee,$e),B=()=>he.removeEventListener(ee,$e),Q=new c({onWillAddFirstListener:Pe,onDidRemoveLastListener:B});return Q.event}$.fromDOMEventEmitter=U;function V(he){return new Promise(ee=>P(he)(ee))}$.toPromise=V;function ge(he){const ee=new c;return he.then(le=>{ee.fire(le)},()=>{ee.fire(void 0)}).finally(()=>{ee.dispose()}),ee.event}$.fromPromise=ge;function _(he,ee){return ee(void 0),he(le=>ee(le))}$.runAndSubscribe=_;function ie(he,ee){let le=null;function $e(B){le?.dispose(),le=new d.$Qc,ee(B,le)}$e(void 0);const Pe=he(B=>$e(B));return(0,d.$Pc)(()=>{Pe.dispose(),le?.dispose()})}$.runAndSubscribeWithStore=ie;class re{constructor(ee,le){this._observable=ee,this.f=0,this.g=!1;const $e={onWillAddFirstListener:()=>{ee.addObserver(this)},onDidRemoveLastListener:()=>{ee.removeObserver(this)}};le||g($e),this.emitter=new c($e),le&&le.add(this.emitter)}beginUpdate(ee){this.f++}handlePossibleChange(ee){}handleChange(ee,le){this.g=!0}endUpdate(ee){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function Ee(he,ee){return new re(he,ee).emitter.event}$.fromObservable=Ee;function oe(he){return ee=>{let le=0,$e=!1;const Pe={beginUpdate(){le++},endUpdate(){le--,le===0&&(he.reportChanges(),$e&&($e=!1,ee()))},handlePossibleChange(){},handleChange(){$e=!0}};return he.addObserver(Pe),he.reportChanges(),{dispose(){he.removeObserver(Pe)}}}}$.fromObservableLight=oe})(w||(e.Event=w={}));class R{static{this.all=new Set}static{this.f=0}constructor(g){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${g}_${R.f++}`,R.all.add(this)}start(g){this.g=new A.$Id,this.listenerCount=g}stop(){if(this.g){const g=this.g.elapsed();this.durations.push(g),this.elapsedOverall+=g,this.invocationCount+=1,this.g=void 0}}}e.$Kd=R;let I=-1;function p($){const g=I;return I=$,{dispose(){I=g}}}e.$Ld=p;class y{constructor(g,f=Math.random().toString(18).slice(2,5)){this.threshold=g,this.name=f,this.g=0}dispose(){this.f?.clear()}check(g,f){const P=this.threshold;if(P<=0||f<P)return;this.f||(this.f=new Map);const N=this.f.get(g.value)||0;if(this.f.set(g.value,N+1),this.g-=1,this.g<=0){this.g=P*.5;let O,L=0;for(const[j,z]of this.f)(!O||L<z)&&(O=j,L=z);console.warn(`[${this.name}] potential listener LEAK detected, having ${f} listeners already. MOST frequent listener (${L}):`),console.warn(O)}return()=>{const O=this.f.get(g.value)||0;this.f.set(g.value,O-1)}}}class D{static create(){return new D(new Error().stack??"")}constructor(g){this.value=g}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let v=0;class l{constructor(g){this.value=g,this.id=v++}}const s=2,r=($,g)=>{if($ instanceof l)g($);else for(let f=0;f<$.length;f++){const P=$[f];P&&g(P)}};class c{constructor(g){this.w=0,this.f=g,this.g=I>0||this.f?.leakWarningThreshold?new y(this.f?.leakWarningThreshold??I):void 0,this.j=this.f?._profName?new R(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(b){const g=this.t;queueMicrotask(()=>{r(g,f=>f.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(g,f,P)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),d.$Rc.None;if(this.m)return d.$Rc.None;f&&(g=g.bind(f));const N=new l(g);let O,L;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(N.stack=D.create(),O=this.g.check(N.stack,this.w+1)),b&&(N.stack=L??D.create()),this.t?this.t instanceof l?(this.u??=new h,this.t=[this.t,N]):this.t.push(N):(this.f?.onWillAddFirstListener?.(this),this.t=N,this.f?.onDidAddFirstListener?.(this)),this.w++;const j=(0,d.$Pc)(()=>{O?.(),this.x(N)});return P instanceof d.$Qc?P.add(j):Array.isArray(P)&&P.push(j),j},this.q}x(g){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const f=this.t,P=f.indexOf(g);if(P===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,f[P]=void 0;const N=this.u.current===this;if(this.w*s<=f.length){let O=0;for(let L=0;L<f.length;L++)f[L]?f[O++]=f[L]:N&&(this.u.end--,O<this.u.i&&this.u.i--);f.length=O}}y(g,f){if(!g)return;const P=this.f?.onListenerError||C.$Z;if(!P){g.value(f);return}try{g.value(f)}catch(N){P(N)}}z(g){const f=g.current.t;for(;g.i<g.end;)this.y(f[g.i++],g.value);g.reset()}fire(g){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof l)this.y(this.t,g);else{const f=this.u;f.enqueue(this,g,this.t.length),this.z(f)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Md=c;const m=()=>new h;e.$Nd=m;class h{constructor(){this.i=-1,this.end=0}enqueue(g,f,P){this.i=0,this.end=P,this.current=g,this.value=f}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends c{async fireAsync(g,f,P){if(this.t)for(this.h||(this.h=new M.$1c),r(this.t,N=>this.h.push([N.value,g]));this.h.size>0&&!f.isCancellationRequested;){const[N,O]=this.h.shift(),L=[],j={...O,token:f,waitUntil:z=>{if(Object.isFrozen(L))throw new Error("waitUntil can NOT be called asynchronous");P&&(z=P(z,N)),L.push(z)}};try{N(j)}catch(z){(0,C.$Z)(z);continue}Object.freeze(L),await Promise.allSettled(L).then(z=>{for(const F of z)F.status==="rejected"&&(0,C.$Z)(F.reason)})}}}e.$Od=t;class n extends c{get isPaused(){return this.h!==0}constructor(g){super(g),this.h=0,this.s=new M.$1c,this.A=g?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const g=Array.from(this.s);this.s.clear(),super.fire(this.A(g))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(g){this.w&&(this.h!==0?this.s.push(g):super.fire(g))}}e.$Pd=n;class o extends n{constructor(g){super(g),this.k=g.delay??100}fire(g){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(g)}}e.$Qd=o;class i extends c{constructor(g){super(g),this.h=[],this.k=g?.merge}fire(g){this.hasListeners()&&(this.h.push(g),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(f=>super.fire(f)),this.h=[]}))}}e.$Rd=i;class a{constructor(){this.g=!1,this.h=[],this.f=new c({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(g){const f={event:g,listener:null};this.h.push(f),this.g&&this.m(f);const P=()=>{this.g&&this.o(f);const N=this.h.indexOf(f);this.h.splice(N,1)};return(0,d.$Pc)((0,T.$cb)(P))}j(){this.g=!0,this.h.forEach(g=>this.m(g))}k(){this.g=!1,this.h.forEach(g=>this.o(g))}m(g){g.listener=g.event(f=>this.f.fire(f))}o(g){g.listener&&g.listener.dispose(),g.listener=null}dispose(){this.f.dispose()}}e.$Sd=a;class u{constructor(g,f,P,N){this.f=new d.$Qc;const O=this.f.add(new a),L=this.f.add(new d.$Zc);function j(z){L.set(z,O.add(N(z)))}for(const z of g)j(z);this.f.add(f(z=>{j(z)})),this.f.add(P(z=>{L.deleteAndDispose(z)})),this.event=O.event}dispose(){this.f.dispose()}}e.$Td=u;class k{constructor(){this.f=[]}wrapEvent(g){return(f,P,N)=>g(O=>{const L=this.f[this.f.length-1];L?L.push(()=>f.call(P,O)):f.call(P,O)},void 0,N)}bufferEvents(g){const f=[];this.f.push(f);const P=g();return this.f.pop(),f.forEach(N=>N()),P}}e.$Ud=k;class S{constructor(){this.f=!1,this.g=w.None,this.h=d.$Rc.None,this.j=new c({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(g){this.g=g,this.f&&(this.h.dispose(),this.h=g(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$Vd=S}),define(De[21],Ce([1,0,4]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wd=e.CancellationToken=void 0;const T=Object.freeze(function(b,E){const w=setTimeout(b.bind(E),0);return{dispose(){clearTimeout(w)}}});var d;(function(b){function E(w){return w===b.None||w===b.Cancelled||w instanceof M?!0:!w||typeof w!="object"?!1:typeof w.isCancellationRequested=="boolean"&&typeof w.onCancellationRequested=="function"}b.isCancellationToken=E,b.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:C.Event.None}),b.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:T})})(d||(e.CancellationToken=d={}));class M{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?T:(this.b||(this.b=new C.$Md),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class A{constructor(E){this.f=void 0,this.g=void 0,this.g=E&&E.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new M),this.f}cancel(){this.f?this.f instanceof M&&this.f.cancel():this.f=d.Cancelled}dispose(E=!1){E&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof M&&this.f.dispose():this.f=d.None}}e.$Wd=A}),define(De[159],Ce([1,0,21]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xe=e.$we=e.$ve=void 0;class T{constructor(b){this.b=b,this.a=null}get(){if(this.a)return this.a;const b=new C.$Wd,E=this.b(b.token);return this.a={promise:E,dispose:()=>{this.a=null,b.cancel(),b.dispose()}},this.a}}e.$ve=T;class d{constructor(b){this.c=b,this.a=void 0,this.b=void 0}get(b){const E=JSON.stringify(b);return this.b!==E&&(this.b=E,this.a=this.c(b)),this.a}}e.$we=d;class M{get cachedValues(){return this.a}constructor(b){this.b=b,this.a=new Map}get(b){if(this.a.has(b))return this.a.get(b);const E=this.b(b);return this.a.set(b,E),E}}e.$xe=M}),define(De[96],Ce([1,0,8,3]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=void 0;function d(m){const h=m;return h?typeof h.read=="function":!1}e.$Xd=d;function M(m){const h=m;return h?[h.on,h.pause,h.resume,h.destroy].every(t=>typeof t=="function"):!1}e.$Yd=M;function A(m){const h=m;return h?M(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}e.$Zd=A;function b(m,h){return new E(m,h)}e.$1d=b;class E{constructor(h,t){this.e=h,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(h){if(!this.a.destroyed){if(this.a.flowing)this.g(h);else if(this.b.data.push(h),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(h){this.a.destroyed||(this.a.flowing?this.h(h):this.b.error.push(h))}end(h){this.a.destroyed||(typeof h<"u"&&this.write(h),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(h){this.c.data.slice(0).forEach(t=>t(h))}h(h){this.c.error.length===0?(0,C.$Z)(h):this.c.error.slice(0).forEach(t=>t(h))}i(){this.c.end.slice(0).forEach(h=>h())}on(h,t){if(!this.a.destroyed)switch(h){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(h,t){if(this.a.destroyed)return;let n;switch(h){case"data":n=this.c.data;break;case"end":n=this.c.end;break;case"error":n=this.c.error;break}if(n){const o=n.indexOf(t);o>=0&&n.splice(o,1)}}j(){if(this.b.data.length>0){const h=this.e(this.b.data);this.g(h),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(n=>n())}}k(){if(this.c.error.length>0){for(const h of this.b.error)this.h(h);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function w(m,h){const t=[];let n;for(;(n=m.read())!==null;)t.push(n);return h(t)}e.$2d=w;function R(m,h,t){const n=[];let o;for(;(o=m.read())!==null&&n.length<t;)n.push(o);return o===null&&n.length>0?h(n):{read:()=>{if(n.length>0)return n.shift();if(typeof o<"u"){const i=o;return o=void 0,i}return m.read()}}}e.$3d=R;function I(m,h){return new Promise((t,n)=>{const o=[];p(m,{onData:i=>{h&&o.push(i)},onError:i=>{h?n(i):t(void 0)},onEnd:()=>{t(h?h(o):void 0)}})})}e.$4d=I;function p(m,h,t){m.on("error",n=>{t?.isCancellationRequested||h.onError(n)}),m.on("end",()=>{t?.isCancellationRequested||h.onEnd()}),m.on("data",n=>{t?.isCancellationRequested||h.onData(n)})}e.$5d=p;function y(m,h){return new Promise((t,n)=>{const o=new T.$Qc,i=[],a=S=>{if(i.push(S),i.length>h)return o.dispose(),m.pause(),t({stream:m,buffer:i,ended:!1})},u=S=>(o.dispose(),n(S)),k=()=>(o.dispose(),t({stream:m,buffer:i,ended:!0}));o.add((0,T.$Pc)(()=>m.removeListener("error",u))),m.on("error",u),o.add((0,T.$Pc)(()=>m.removeListener("end",k))),m.on("end",k),o.add((0,T.$Pc)(()=>m.removeListener("data",a))),m.on("data",a)})}e.$6d=y;function D(m,h){const t=b(h);return t.end(m),t}e.$7d=D;function v(){const m=b(()=>{throw new Error("not supported")});return m.end(),m}e.$8d=v;function l(m){let h=!1;return{read:()=>h?null:(h=!0,m)}}e.$9d=l;function s(m,h,t){const n=b(t);return p(m,{onData:o=>n.write(h.data(o)),onError:o=>n.error(h.error?h.error(o):o),onEnd:()=>n.end()}),n}e.$0d=s;function r(m,h,t){let n=!1;return{read:()=>{const o=h.read();return n?o:(n=!0,o!==null?t([m,o]):m)}}}e.$$d=r;function c(m,h,t){let n=!1;const o=b(t);return p(h,{onData:i=>n?o.write(i):(n=!0,o.write(t([m,i]))),onError:i=>o.error(i),onEnd:()=>{n||(n=!0,o.write(m)),o.end()}}),o}e.$_d=c}),define(De[22],Ce([1,0,51,96]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=void 0;const d=typeof Buffer<"u",M=new C.$U(()=>new Uint8Array(256));let A,b;class E{static alloc(f){return d?new E(Buffer.allocUnsafe(f)):new E(new Uint8Array(f))}static wrap(f){return d&&!Buffer.isBuffer(f)&&(f=Buffer.from(f.buffer,f.byteOffset,f.byteLength)),new E(f)}static fromString(f,P){return!(P?.dontUseNodeBuffer||!1)&&d?new E(Buffer.from(f)):(A||(A=new TextEncoder),new E(A.encode(f)))}static fromByteArray(f){const P=E.alloc(f.length);for(let N=0,O=f.length;N<O;N++)P.buffer[N]=f[N];return P}static concat(f,P){if(typeof P>"u"){P=0;for(let L=0,j=f.length;L<j;L++)P+=f[L].byteLength}const N=E.alloc(P);let O=0;for(let L=0,j=f.length;L<j;L++){const z=f[L];N.set(z,O),O+=z.byteLength}return N}constructor(f){this.buffer=f,this.byteLength=this.buffer.byteLength}clone(){const f=E.alloc(this.byteLength);return f.set(this),f}toString(){return d?this.buffer.toString():(b||(b=new TextDecoder),b.decode(this.buffer))}slice(f,P){return new E(this.buffer.subarray(f,P))}set(f,P){if(f instanceof E)this.buffer.set(f.buffer,P);else if(f instanceof Uint8Array)this.buffer.set(f,P);else if(f instanceof ArrayBuffer)this.buffer.set(new Uint8Array(f),P);else if(ArrayBuffer.isView(f))this.buffer.set(new Uint8Array(f.buffer,f.byteOffset,f.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(f){return p(this.buffer,f)}writeUInt32BE(f,P){y(this.buffer,f,P)}readUInt32LE(f){return D(this.buffer,f)}writeUInt32LE(f,P){v(this.buffer,f,P)}readUInt8(f){return l(this.buffer,f)}writeUInt8(f,P){s(this.buffer,f,P)}indexOf(f,P=0){return w(this.buffer,f instanceof E?f.buffer:f,P)}}e.$ae=E;function w(g,f,P=0){const N=f.byteLength,O=g.byteLength;if(N===0)return 0;if(N===1)return g.indexOf(f[0]);if(N>O-P)return-1;const L=M.value;L.fill(f.length);for(let H=0;H<f.length;H++)L[f[H]]=f.length-H-1;let j=P+f.length-1,z=j,F=-1;for(;j<O;)if(g[j]===f[z]){if(z===0){F=j;break}j--,z--}else j+=Math.max(f.length-z,L[g[j]]),z=f.length-1;return F}e.$be=w;function R(g,f){return g[f+0]<<0>>>0|g[f+1]<<8>>>0}e.$ce=R;function I(g,f,P){g[P+0]=f&255,f=f>>>8,g[P+1]=f&255}e.$de=I;function p(g,f){return g[f]*2**24+g[f+1]*2**16+g[f+2]*2**8+g[f+3]}e.$ee=p;function y(g,f,P){g[P+3]=f,f=f>>>8,g[P+2]=f,f=f>>>8,g[P+1]=f,f=f>>>8,g[P]=f}e.$fe=y;function D(g,f){return g[f+0]<<0>>>0|g[f+1]<<8>>>0|g[f+2]<<16>>>0|g[f+3]<<24>>>0}e.$ge=D;function v(g,f,P){g[P+0]=f&255,f=f>>>8,g[P+1]=f&255,f=f>>>8,g[P+2]=f&255,f=f>>>8,g[P+3]=f&255}e.$he=v;function l(g,f){return g[f]}e.$ie=l;function s(g,f,P){g[P]=f}e.$je=s;function r(g){return T.$2d(g,f=>E.concat(f))}e.$ke=r;function c(g){return T.$9d(g)}e.$le=c;function m(g){return T.$4d(g,f=>E.concat(f))}e.$me=m;async function h(g){return g.ended?E.concat(g.buffer):E.concat([...g.buffer,await m(g.stream)])}e.$ne=h;function t(g){return T.$7d(g,f=>E.concat(f))}e.$oe=t;function n(g){return T.$0d(g,{data:f=>typeof f=="string"?E.fromString(f):E.wrap(f)},f=>E.concat(f))}e.$pe=n;function o(g){return T.$1d(f=>E.concat(f),g)}e.$qe=o;function i(g,f){return T.$$d(g,f,P=>E.concat(P))}e.$re=i;function a(g,f){return T.$_d(g,f,P=>E.concat(P))}e.$se=a;function u(g){let f=0,P=0,N=0;const O=new Uint8Array(Math.floor(g.length/4*3)),L=z=>{switch(P){case 3:O[N++]=f|z,P=0;break;case 2:O[N++]=f|z>>>2,f=z<<6,P=3;break;case 1:O[N++]=f|z>>>4,f=z<<4,P=2;break;default:f=z<<2,P=1}};for(let z=0;z<g.length;z++){const F=g.charCodeAt(z);if(F>=65&&F<=90)L(F-65);else if(F>=97&&F<=122)L(F-97+26);else if(F>=48&&F<=57)L(F-48+52);else if(F===43||F===45)L(62);else if(F===47||F===95)L(63);else{if(F===61)break;throw new SyntaxError(`Unexpected base64 character ${g[z]}`)}}const j=N;for(;P>0;)L(0);return E.wrap(O).slice(0,j)}e.$te=u;const k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function $({buffer:g},f=!0,P=!1){const N=P?S:k;let O="";const L=g.byteLength%3;let j=0;for(;j<g.byteLength-L;j+=3){const z=g[j+0],F=g[j+1],H=g[j+2];O+=N[z>>>2],O+=N[(z<<4|F>>>4)&63],O+=N[(F<<2|H>>>6)&63],O+=N[H&63]}if(L===1){const z=g[j+0];O+=N[z>>>2],O+=N[z<<4&63],f&&(O+="==")}else if(L===2){const z=g[j+0],F=g[j+1];O+=N[z>>>2],O+=N[(z<<4|F>>>4)&63],O+=N[F<<2&63],f&&(O+="=")}return O}e.$ue=$}),define(De[15],Ce([1,0,159,51]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wf=e.$vf=e.$uf=e.$tf=e.GraphemeBreakType=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=void 0;function d(Ae){return!Ae||typeof Ae!="string"?!0:Ae.trim().length===0}e.$Ae=d;const M=/{(\d+)}/g;function A(Ae,...Ne){return Ne.length===0?Ae:Ae.replace(M,function(qe,Me){const Ze=parseInt(Me,10);return isNaN(Ze)||Ze<0||Ze>=Ne.length?qe:Ne[Ze]})}e.$Be=A;const b=/{([^}]+)}/g;function E(Ae,Ne){return Ae.replace(b,(qe,Me)=>Ne[Me]??qe)}e.$Ce=E;function w(Ae){return Ae.replace(/[<>&]/g,function(Ne){switch(Ne){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ne}})}e.$De=w;function R(Ae){return Ae.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Ee=R;function I(Ae,Ne){let qe=0;const Me=Ne.charCodeAt(0);for(let Ze=Ae.length-1;Ze>=0;Ze--)Ae.charCodeAt(Ze)===Me&&qe++;return qe}e.$Fe=I;function p(Ae,Ne,qe="\u2026"){return Ae.length<=Ne?Ae:`${Ae.substr(0,Ne)}${qe}`}e.$Ge=p;function y(Ae,Ne=" "){const qe=D(Ae,Ne);return v(qe,Ne)}e.$He=y;function D(Ae,Ne){if(!Ae||!Ne)return Ae;const qe=Ne.length;if(qe===0||Ae.length===0)return Ae;let Me=0;for(;Ae.indexOf(Ne,Me)===Me;)Me=Me+qe;return Ae.substring(Me)}e.$Ie=D;function v(Ae,Ne){if(!Ae||!Ne)return Ae;const qe=Ne.length,Me=Ae.length;if(qe===0||Me===0)return Ae;let Ze=Me,ce=-1;for(;ce=Ae.lastIndexOf(Ne,Ze-1),!(ce===-1||ce+qe!==Ze);){if(ce===0)return"";Ze=ce}return Ae.substring(0,Ze)}e.$Je=v;function l(Ae){return Ae.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Ke=l;function s(Ae){return Ae.replace(/\*/g,"")}e.$Le=s;function r(Ae,Ne,qe={}){if(!Ae)throw new Error("Cannot create regex from empty string");Ne||(Ae=R(Ae)),qe.wholeWord&&(/\B/.test(Ae.charAt(0))||(Ae="\\b"+Ae),/\B/.test(Ae.charAt(Ae.length-1))||(Ae=Ae+"\\b"));let Me="";return qe.global&&(Me+="g"),qe.matchCase||(Me+="i"),qe.multiline&&(Me+="m"),qe.unicode&&(Me+="u"),new RegExp(Ae,Me)}e.$Me=r;function c(Ae){return Ae.source==="^"||Ae.source==="^$"||Ae.source==="$"||Ae.source==="^\\s*$"?!1:!!(Ae.exec("")&&Ae.lastIndex===0)}e.$Ne=c;function m(Ae){return Ae.split(/\r\n|\r|\n/)}e.$Oe=m;function h(Ae){for(let Ne=0,qe=Ae.length;Ne<qe;Ne++){const Me=Ae.charCodeAt(Ne);if(Me!==32&&Me!==9)return Ne}return-1}e.$Pe=h;function t(Ae,Ne=0,qe=Ae.length){for(let Me=Ne;Me<qe;Me++){const Ze=Ae.charCodeAt(Me);if(Ze!==32&&Ze!==9)return Ae.substring(Ne,Me)}return Ae.substring(Ne,qe)}e.$Qe=t;function n(Ae,Ne=Ae.length-1){for(let qe=Ne;qe>=0;qe--){const Me=Ae.charCodeAt(qe);if(Me!==32&&Me!==9)return qe}return-1}e.$Re=n;function o(Ae,Ne,qe){const Me=[];let Ze=0;for(const ce of Ae.matchAll(Ne)){if(Me.push(Ae.slice(Ze,ce.index)),ce.index===void 0)throw new Error("match.index should be defined");Ze=ce.index+ce[0].length,Me.push(qe(ce[0],...ce.slice(1),ce.index,Ae,ce.groups))}return Me.push(Ae.slice(Ze)),Promise.all(Me).then(ce=>ce.join(""))}e.$Se=o;function i(Ae,Ne){return Ae<Ne?-1:Ae>Ne?1:0}e.$Te=i;function a(Ae,Ne,qe=0,Me=Ae.length,Ze=0,ce=Ne.length){for(;qe<Me&&Ze<ce;qe++,Ze++){const Ve=Ae.charCodeAt(qe),ze=Ne.charCodeAt(Ze);if(Ve<ze)return-1;if(Ve>ze)return 1}const ae=Me-qe,Ie=ce-Ze;return ae<Ie?-1:ae>Ie?1:0}e.$Ue=a;function u(Ae,Ne){return k(Ae,Ne,0,Ae.length,0,Ne.length)}e.$Ve=u;function k(Ae,Ne,qe=0,Me=Ae.length,Ze=0,ce=Ne.length){for(;qe<Me&&Ze<ce;qe++,Ze++){let Ve=Ae.charCodeAt(qe),ze=Ne.charCodeAt(Ze);if(Ve===ze)continue;if(Ve>=128||ze>=128)return a(Ae.toLowerCase(),Ne.toLowerCase(),qe,Me,Ze,ce);$(Ve)&&(Ve-=32),$(ze)&&(ze-=32);const Xe=Ve-ze;if(Xe!==0)return Xe}const ae=Me-qe,Ie=ce-Ze;return ae<Ie?-1:ae>Ie?1:0}e.$We=k;function S(Ae){return Ae>=48&&Ae<=57}e.$Xe=S;function $(Ae){return Ae>=97&&Ae<=122}e.$Ye=$;function g(Ae){return Ae>=65&&Ae<=90}e.$Ze=g;function f(Ae,Ne){return Ae.length===Ne.length&&k(Ae,Ne)===0}e.$1e=f;function P(Ae,Ne){const qe=Ne.length;return Ne.length>Ae.length?!1:k(Ae,Ne,0,qe)===0}e.$2e=P;function N(Ae,Ne){const qe=Math.min(Ae.length,Ne.length);let Me;for(Me=0;Me<qe;Me++)if(Ae.charCodeAt(Me)!==Ne.charCodeAt(Me))return Me;return qe}e.$3e=N;function O(Ae,Ne){const qe=Math.min(Ae.length,Ne.length);let Me;const Ze=Ae.length-1,ce=Ne.length-1;for(Me=0;Me<qe;Me++)if(Ae.charCodeAt(Ze-Me)!==Ne.charCodeAt(ce-Me))return Me;return qe}e.$4e=O;function L(Ae){return 55296<=Ae&&Ae<=56319}e.$5e=L;function j(Ae){return 56320<=Ae&&Ae<=57343}e.$6e=j;function z(Ae,Ne){return(Ae-55296<<10)+(Ne-56320)+65536}e.$7e=z;function F(Ae,Ne,qe){const Me=Ae.charCodeAt(qe);if(L(Me)&&qe+1<Ne){const Ze=Ae.charCodeAt(qe+1);if(j(Ze))return z(Me,Ze)}return Me}e.$8e=F;function H(Ae,Ne){const qe=Ae.charCodeAt(Ne-1);if(j(qe)&&Ne>1){const Me=Ae.charCodeAt(Ne-2);if(L(Me))return z(Me,qe)}return qe}class K{get offset(){return this.e}constructor(Ne,qe=0){this.c=Ne,this.d=Ne.length,this.e=qe}setOffset(Ne){this.e=Ne}prevCodePoint(){const Ne=H(this.c,this.e);return this.e-=Ne>=65536?2:1,Ne}nextCodePoint(){const Ne=F(this.c,this.d,this.e);return this.e+=Ne>=65536?2:1,Ne}eol(){return this.e>=this.d}}e.$9e=K;class fe{get offset(){return this.c.offset}constructor(Ne,qe=0){this.c=new K(Ne,qe)}nextGraphemeLength(){const Ne=de.getInstance(),qe=this.c,Me=qe.offset;let Ze=Ne.getGraphemeBreakType(qe.nextCodePoint());for(;!qe.eol();){const ce=qe.offset,ae=Ne.getGraphemeBreakType(qe.nextCodePoint());if(se(Ze,ae)){qe.setOffset(ce);break}Ze=ae}return qe.offset-Me}prevGraphemeLength(){const Ne=de.getInstance(),qe=this.c,Me=qe.offset;let Ze=Ne.getGraphemeBreakType(qe.prevCodePoint());for(;qe.offset>0;){const ce=qe.offset,ae=Ne.getGraphemeBreakType(qe.prevCodePoint());if(se(ae,Ze)){qe.setOffset(ce);break}Ze=ae}return Me-qe.offset}eol(){return this.c.eol()}}e.$0e=fe;function x(Ae,Ne){return new fe(Ae,Ne).nextGraphemeLength()}e.$$e=x;function Z(Ae,Ne){return new fe(Ae,Ne).prevGraphemeLength()}e.$_e=Z;function q(Ae,Ne){Ne>0&&j(Ae.charCodeAt(Ne))&&Ne--;const qe=Ne+x(Ae,Ne);return[qe-Z(Ae,qe),qe]}e.$af=q;function Y(Ae){const Ne=new fe(Ae);let qe=0;for(;!Ne.eol();)qe++,Ne.nextGraphemeLength();return qe}e.$bf=Y;let be;function ue(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ve(Ae){return be||(be=ue()),be.test(Ae)}e.$cf=ve;const J=/^[\t\n\r\x20-\x7E]*$/;function U(Ae){return J.test(Ae)}e.$df=U,e.$ef=/[\u2028\u2029]/;function V(Ae){return e.$ef.test(Ae)}e.$ff=V;function ge(Ae){return Ae>=11904&&Ae<=55215||Ae>=63744&&Ae<=64255||Ae>=65281&&Ae<=65374}e.$gf=ge;function _(Ae){return Ae>=127462&&Ae<=127487||Ae===8986||Ae===8987||Ae===9200||Ae===9203||Ae>=9728&&Ae<=10175||Ae===11088||Ae===11093||Ae>=127744&&Ae<=128591||Ae>=128640&&Ae<=128764||Ae>=128992&&Ae<=129008||Ae>=129280&&Ae<=129535||Ae>=129648&&Ae<=129782}e.$hf=_;function ie(Ae,Ne){if(Ae.length<Ne)return Ae;const qe=/\b/g;let Me=0;for(;qe.test(Ae)&&!(Ae.length-qe.lastIndex<Ne);)Me=qe.lastIndex,qe.lastIndex+=1;return Ae.substring(Me).replace(/^\s/,"")}e.$if=ie;const re=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,Ee=/\x1b\].*?\x07/g;function oe(Ae){return Ae&&(Ae=Ae.replace(re,"").replace(Ee,"")),Ae}e.$jf=oe,e.$kf=String.fromCharCode(65279);function he(Ae){return!!(Ae&&Ae.length>0&&Ae.charCodeAt(0)===65279)}e.$lf=he;function ee(Ae){return he(Ae)?Ae.substr(1):Ae}e.$mf=ee;function le(Ae,Ne){if(!Ae||!Ne||Ae.length<Ne.length)return!1;const qe=Ne.length,Me=Ae.toLowerCase();let Ze=0,ce=-1;for(;Ze<qe;){const ae=Me.indexOf(Ne[Ze],ce+1);if(ae<0)return!1;ce=ae,Ze++}return!0}e.$nf=le;function $e(Ae,Ne=!1){return Ae?(Ne&&(Ae=Ae.replace(/\\./g,"")),Ae.toLowerCase()!==Ae):!1}e.$of=$e;function Pe(Ae){return Ae.charAt(0).toUpperCase()+Ae.slice(1)}e.$pf=Pe;function B(Ae,Ne=1){if(Ne===0)return"";let qe=-1;do qe=Ae.indexOf(`
`,qe+1),Ne--;while(Ne>0&&qe>=0);return qe===-1?Ae:(Ae[qe-1]==="\r"&&qe--,Ae.substr(0,qe))}e.$qf=B;function Q(Ae){return Ae=Ae%(2*26),Ae<26?String.fromCharCode(97+Ae):String.fromCharCode(65+Ae-26)}e.$rf=Q;function te(Ae){return de.getInstance().getGraphemeBreakType(Ae)}e.$sf=te;function se(Ae,Ne){return Ae===0?Ne!==5&&Ne!==7:Ae===2&&Ne===3?!1:Ae===4||Ae===2||Ae===3||Ne===4||Ne===2||Ne===3?!0:!(Ae===8&&(Ne===8||Ne===9||Ne===11||Ne===12)||(Ae===11||Ae===9)&&(Ne===9||Ne===10)||(Ae===12||Ae===10)&&Ne===10||Ne===5||Ne===13||Ne===7||Ae===1||Ae===13&&Ne===14||Ae===6&&Ne===6)}var X;(function(Ae){Ae[Ae.Other=0]="Other",Ae[Ae.Prepend=1]="Prepend",Ae[Ae.CR=2]="CR",Ae[Ae.LF=3]="LF",Ae[Ae.Control=4]="Control",Ae[Ae.Extend=5]="Extend",Ae[Ae.Regional_Indicator=6]="Regional_Indicator",Ae[Ae.SpacingMark=7]="SpacingMark",Ae[Ae.L=8]="L",Ae[Ae.V=9]="V",Ae[Ae.T=10]="T",Ae[Ae.LV=11]="LV",Ae[Ae.LVT=12]="LVT",Ae[Ae.ZWJ=13]="ZWJ",Ae[Ae.Extended_Pictographic=14]="Extended_Pictographic"})(X||(e.GraphemeBreakType=X={}));class de{static{this.c=null}static getInstance(){return de.c||(de.c=new de),de.c}constructor(){this.d=ye()}getGraphemeBreakType(Ne){if(Ne<32)return Ne===10?3:Ne===13?2:4;if(Ne<127)return 0;const qe=this.d,Me=qe.length/3;let Ze=1;for(;Ze<=Me;)if(Ne<qe[3*Ze])Ze=2*Ze;else if(Ne>qe[3*Ze+1])Ze=2*Ze+1;else return qe[3*Ze+2];return 0}}function ye(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function je(Ae,Ne){if(Ae===0)return 0;const qe=We(Ae,Ne);if(qe!==void 0)return qe;const Me=new K(Ne,Ae);return Me.prevCodePoint(),Me.offset}e.$tf=je;function We(Ae,Ne){const qe=new K(Ne,Ae);let Me=qe.prevCodePoint();for(;_e(Me)||Me===65039||Me===8419;){if(qe.offset===0)return;Me=qe.prevCodePoint()}if(!_(Me))return;let Ze=qe.offset;return Ze>0&&qe.prevCodePoint()===8205&&(Ze=qe.offset),Ze}function _e(Ae){return 127995<=Ae&&Ae<=127999}var Ye;(function(Ae){Ae[Ae.zwj=8205]="zwj",Ae[Ae.emojiVariantSelector=65039]="emojiVariantSelector",Ae[Ae.enclosingKeyCap=8419]="enclosingKeyCap"})(Ye||(Ye={})),e.$uf="\xA0";class it{static{this.c=new T.$U(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new C.$we(Ne=>{function qe(Xe){const rt=new Map;for(let ot=0;ot<Xe.length;ot+=2)rt.set(Xe[ot],Xe[ot+1]);return rt}function Me(Xe,rt){const ot=new Map(Xe);for(const[wt,Et]of rt)ot.set(wt,Et);return ot}function Ze(Xe,rt){if(!Xe)return rt;const ot=new Map;for(const[wt,Et]of Xe)rt.has(wt)&&ot.set(wt,Et);return ot}const ce=this.c.value;let ae=Ne.filter(Xe=>!Xe.startsWith("_")&&Xe in ce);ae.length===0&&(ae=["_default"]);let Ie;for(const Xe of ae){const rt=qe(ce[Xe]);Ie=Ze(Ie,rt)}const Ve=qe(ce._common),ze=Me(Ve,Ie);return new it(ze)})}static getInstance(Ne){return it.d.get(Array.from(Ne))}static{this.e=new T.$U(()=>Object.keys(it.c.value).filter(Ne=>!Ne.startsWith("_")))}static getLocales(){return it.e.value}constructor(Ne){this.f=Ne}isAmbiguous(Ne){return this.f.has(Ne)}getPrimaryConfusable(Ne){return this.f.get(Ne)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$vf=it;class et{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(et.c())),this.d}static isInvisibleCharacter(Ne){return et.e().has(Ne)}static get codePoints(){return et.e()}}e.$wf=et}),define(De[121],Ce([1,0,28,15]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.FuzzyScore=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.or=void 0;function d(...ee){return function(le,$e){for(let Pe=0,B=ee.length;Pe<B;Pe++){const Q=ee[Pe](le,$e);if(Q)return Q}return null}}e.or=d,e.$Aj=M.bind(void 0,!1),e.$Bj=M.bind(void 0,!0);function M(ee,le,$e){if(!$e||$e.length<le.length)return null;let Pe;return ee?Pe=T.$2e($e,le):Pe=$e.indexOf(le)===0,Pe?le.length>0?[{start:0,end:le.length}]:[]:null}function A(ee,le){const $e=le.toLowerCase().indexOf(ee.toLowerCase());return $e===-1?null:[{start:$e,end:$e+ee.length}]}e.$Cj=A;function b(ee,le){return E(ee.toLowerCase(),le.toLowerCase(),0,0)}e.$Dj=b;function E(ee,le,$e,Pe){if($e===ee.length)return[];if(Pe===le.length)return null;if(ee[$e]===le[Pe]){let B=null;return(B=E(ee,le,$e+1,Pe+1))?s({start:Pe,end:Pe+1},B):null}return E(ee,le,$e,Pe+1)}function w(ee){return 97<=ee&&ee<=122}function R(ee){return 65<=ee&&ee<=90}e.$Ej=R;function I(ee){return 48<=ee&&ee<=57}function p(ee){return ee===32||ee===9||ee===10||ee===13}const y=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ee=>y.add(ee.charCodeAt(0)));function D(ee){return p(ee)||y.has(ee)}function v(ee,le){return ee===le||D(ee)&&D(le)}function l(ee){return w(ee)||R(ee)||I(ee)}function s(ee,le){return le.length===0?le=[ee]:ee.end===le[0].start?le[0].start=ee.start:le.unshift(ee),le}function r(ee,le){for(let $e=le;$e<ee.length;$e++){const Pe=ee.charCodeAt($e);if(R(Pe)||I(Pe)||$e>0&&!l(ee.charCodeAt($e-1)))return $e}return ee.length}function c(ee,le,$e,Pe){if($e===ee.length)return[];if(Pe===le.length)return null;if(ee[$e]!==le[Pe].toLowerCase())return null;{let B=null,Q=Pe+1;for(B=c(ee,le,$e+1,Pe+1);!B&&(Q=r(le,Q))<le.length;)B=c(ee,le,$e+1,Q),Q++;return B===null?null:s({start:Pe,end:Pe+1},B)}}function m(ee){let le=0,$e=0,Pe=0,B=0,Q=0;for(let ye=0;ye<ee.length;ye++)Q=ee.charCodeAt(ye),R(Q)&&le++,w(Q)&&$e++,l(Q)&&Pe++,I(Q)&&B++;const te=le/ee.length,se=$e/ee.length,X=Pe/ee.length,de=B/ee.length;return{upperPercent:te,lowerPercent:se,alphaPercent:X,numericPercent:de}}function h(ee){const{upperPercent:le,lowerPercent:$e}=ee;return $e===0&&le>.6}function t(ee){const{upperPercent:le,lowerPercent:$e,alphaPercent:Pe,numericPercent:B}=ee;return $e>.2&&le<.8&&Pe>.6&&B<.2}function n(ee){let le=0,$e=0,Pe=0,B=0;for(let Q=0;Q<ee.length;Q++)Pe=ee.charCodeAt(Q),R(Pe)&&le++,w(Pe)&&$e++,p(Pe)&&B++;return(le===0||$e===0)&&B===0?ee.length<=30:le<=5}function o(ee,le){if(!le||(le=le.trim(),le.length===0)||!n(ee)||le.length>60)return null;const $e=m(le);if(!t($e)){if(!h($e))return null;le=le.toLowerCase()}let Pe=null,B=0;for(ee=ee.toLowerCase();B<le.length&&(Pe=c(ee,le,0,B))===null;)B=r(le,B+1);return Pe}e.$Fj=o;function i(ee,le,$e=!1){if(!le||le.length===0)return null;let Pe=null,B=0;for(ee=ee.toLowerCase(),le=le.toLowerCase();B<le.length&&(Pe=a(ee,le,0,B,$e))===null;)B=u(le,B+1);return Pe}e.$Gj=i;function a(ee,le,$e,Pe,B){if($e===ee.length)return[];if(Pe===le.length)return null;if(v(ee.charCodeAt($e),le.charCodeAt(Pe))){let Q=null,te=Pe+1;if(Q=a(ee,le,$e+1,Pe+1,B),!B)for(;!Q&&(te=u(le,te))<le.length;)Q=a(ee,le,$e+1,te,B),te++;return Q?ee.charCodeAt($e)!==le.charCodeAt(Pe)?Q:s({start:Pe,end:Pe+1},Q):null}else return null}function u(ee,le){for(let $e=le;$e<ee.length;$e++)if(D(ee.charCodeAt($e))||$e>0&&D(ee.charCodeAt($e-1)))return $e;return ee.length}const k=d(e.$Bj,o,A),S=d(e.$Bj,o,b),$=new C.$Cc(1e4);function g(ee,le,$e=!1){if(typeof ee!="string"||typeof le!="string")return null;let Pe=$.get(ee);Pe||(Pe=new RegExp(T.$Ke(ee),"i"),$.set(ee,Pe));const B=Pe.exec(le);return B?[{start:B.index,end:B.index+B[0].length}]:$e?S(ee,le):k(ee,le)}e.$Hj=g;function f(ee,le){const $e=ge(ee,ee.toLowerCase(),0,le,le.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return $e?N($e):null}e.$Ij=f;function P(ee,le,$e,Pe,B,Q){const te=Math.min(13,ee.length);for(;$e<te;$e++){const se=ge(ee,le,$e,Pe,B,Q,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(se)return se}return[0,Q]}e.$Jj=P;function N(ee){if(typeof ee>"u")return[];const le=[],$e=ee[1];for(let Pe=ee.length-1;Pe>1;Pe--){const B=ee[Pe]+$e,Q=le[le.length-1];Q&&Q.end===B?Q.end=B+1:le.push({start:B,end:B+1})}return le}e.$Kj=N;const O=128;function L(){const ee=[],le=[];for(let $e=0;$e<=O;$e++)le[$e]=0;for(let $e=0;$e<=O;$e++)ee.push(le.slice(0));return ee}function j(ee){const le=[];for(let $e=0;$e<=ee;$e++)le[$e]=0;return le}const z=j(2*O),F=j(2*O),H=L(),K=L(),fe=L(),x=!1;function Z(ee,le,$e,Pe,B){function Q(se,X,de=" "){for(;se.length<X;)se=de+se;return se}let te=` |   |${Pe.split("").map(se=>Q(se,3)).join("|")}
`;for(let se=0;se<=$e;se++)se===0?te+=" |":te+=`${le[se-1]}|`,te+=ee[se].slice(0,B+1).map(X=>Q(X.toString(),3)).join("|")+`
`;return te}function q(ee,le,$e,Pe){ee=ee.substr(le),$e=$e.substr(Pe),console.log(Z(K,ee,ee.length,$e,$e.length)),console.log(Z(fe,ee,ee.length,$e,$e.length)),console.log(Z(H,ee,ee.length,$e,$e.length))}function Y(ee,le){if(le<0||le>=ee.length)return!1;const $e=ee.codePointAt(le);switch($e){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!T.$hf($e)}}function be(ee,le){if(le<0||le>=ee.length)return!1;switch(ee.charCodeAt(le)){case 32:case 9:return!0;default:return!1}}function ue(ee,le,$e){return le[ee]!==$e[ee]}function ve(ee,le,$e,Pe,B,Q,te=!1){for(;le<$e&&B<Q;)ee[le]===Pe[B]&&(te&&(z[le]=B),le+=1),B+=1;return le===$e}e.$Lj=ve;var J;(function(ee){ee[ee.Diag=1]="Diag",ee[ee.Left=2]="Left",ee[ee.LeftLeft=3]="LeftLeft"})(J||(J={}));var U;(function(ee){ee.Default=[-100,0];function le($e){return!$e||$e.length===2&&$e[0]===-100&&$e[1]===0}ee.isDefault=le})(U||(e.FuzzyScore=U={}));class V{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(le,$e){this.firstMatchCanBeWeak=le,this.boostFullMatch=$e}}e.$Mj=V;function ge(ee,le,$e,Pe,B,Q,te=V.default){const se=ee.length>O?O:ee.length,X=Pe.length>O?O:Pe.length;if($e>=se||Q>=X||se-$e>X-Q||!ve(le,$e,se,B,Q,X,!0))return;_(se,X,$e,Q,le,B);let de=1,ye=1,je=$e,We=Q;const _e=[!1];for(de=1,je=$e;je<se;de++,je++){const Ne=z[je],qe=F[je],Me=je+1<se?F[je+1]:X;for(ye=Ne-Q+1,We=Ne;We<Me;ye++,We++){let Ze=Number.MIN_SAFE_INTEGER,ce=!1;We<=qe&&(Ze=ie(ee,le,je,$e,Pe,B,We,X,Q,H[de-1][ye-1]===0,_e));let ae=0;Ze!==Number.MAX_SAFE_INTEGER&&(ce=!0,ae=Ze+K[de-1][ye-1]);const Ie=We>Ne,Ve=Ie?K[de][ye-1]+(H[de][ye-1]>0?-5:0):0,ze=We>Ne+1&&H[de][ye-1]>0,Xe=ze?K[de][ye-2]+(H[de][ye-2]>0?-5:0):0;if(ze&&(!Ie||Xe>=Ve)&&(!ce||Xe>=ae))K[de][ye]=Xe,fe[de][ye]=3,H[de][ye]=0;else if(Ie&&(!ce||Ve>=ae))K[de][ye]=Ve,fe[de][ye]=2,H[de][ye]=0;else if(ce)K[de][ye]=ae,fe[de][ye]=1,H[de][ye]=H[de-1][ye-1]+1;else throw new Error("not possible")}}if(x&&q(ee,$e,Pe,Q),!_e[0]&&!te.firstMatchCanBeWeak)return;de--,ye--;const Ye=[K[de][ye],Q];let it=0,et=0;for(;de>=1;){let Ne=ye;do{const qe=fe[de][Ne];if(qe===3)Ne=Ne-2;else if(qe===2)Ne=Ne-1;else break}while(Ne>=1);it>1&&le[$e+de-1]===B[Q+ye-1]&&!ue(Ne+Q-1,Pe,B)&&it+1>H[de][Ne]&&(Ne=ye),Ne===ye?it++:it=1,et||(et=Ne),de--,ye=Ne-1,Ye.push(ye)}X===se&&te.boostFullMatch&&(Ye[0]+=2);const Ae=et-se;return Ye[0]-=Ae,Ye}e.$Nj=ge;function _(ee,le,$e,Pe,B,Q){let te=ee-1,se=le-1;for(;te>=$e&&se>=Pe;)B[te]===Q[se]&&(F[te]=se,te--),se--}function ie(ee,le,$e,Pe,B,Q,te,se,X,de,ye){if(le[$e]!==Q[te])return Number.MIN_SAFE_INTEGER;let je=1,We=!1;return te===$e-Pe?je=ee[$e]===B[te]?7:5:ue(te,B,Q)&&(te===0||!ue(te-1,B,Q))?(je=ee[$e]===B[te]?7:5,We=!0):Y(Q,te)&&(te===0||!Y(Q,te-1))?je=5:(Y(Q,te-1)||be(Q,te-1))&&(je=5,We=!0),je>1&&$e===Pe&&(ye[0]=!0),We||(We=ue(te,B,Q)||Y(Q,te-1)||be(Q,te-1)),$e===Pe?te>X&&(je-=We?3:5):de?je+=We?2:0:je+=We?0:1,te+1===se&&(je-=We?3:5),je}function re(ee,le,$e,Pe,B,Q,te){return oe(ee,le,$e,Pe,B,Q,!0,te)}e.$Oj=re;function Ee(ee,le,$e,Pe,B,Q,te){return oe(ee,le,$e,Pe,B,Q,!1,te)}e.$Pj=Ee;function oe(ee,le,$e,Pe,B,Q,te,se){let X=ge(ee,le,$e,Pe,B,Q,se);if(X&&!te)return X;if(ee.length>=3){const de=Math.min(7,ee.length-1);for(let ye=$e+1;ye<de;ye++){const je=he(ee,ye);if(je){const We=ge(je,je.toLowerCase(),$e,Pe,B,Q,se);We&&(We[0]-=3,(!X||We[0]>X[0])&&(X=We))}}}return X}function he(ee,le){if(le+1>=ee.length)return;const $e=ee[le],Pe=ee[le+1];if($e!==Pe)return ee.slice(0,le)+Pe+$e+ee.slice(le+2)}}),define(De[52],Ce([1,0,15]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=void 0;function T(s){return d(s,0)}e.$Bi=T;function d(s,r){switch(typeof s){case"object":return s===null?M(349,r):Array.isArray(s)?E(s,r):w(s,r);case"string":return b(s,r);case"boolean":return A(s,r);case"number":return M(s,r);case"undefined":return M(937,r);default:return M(617,r)}}e.$Ci=d;function M(s,r){return(r<<5)-r+s|0}e.$Di=M;function A(s,r){return M(s?433:863,r)}function b(s,r){r=M(149417,r);for(let c=0,m=s.length;c<m;c++)r=M(s.charCodeAt(c),r);return r}e.$Ei=b;function E(s,r){return r=M(104579,r),s.reduce((c,m)=>d(m,c),r)}function w(s,r){return r=M(181387,r),Object.keys(s).sort().reduce((c,m)=>(c=b(m,c),d(s[m],c)),r)}class R{constructor(){this.g=0}get value(){return this.g}hash(r){return this.g=d(r,this.g),this.g}}e.$Fi=R;var I;(function(s){s[s.BLOCK_SIZE=64]="BLOCK_SIZE",s[s.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function p(s,r,c=32){const m=c-r,h=~((1<<m)-1);return(s<<r|(h&s)>>>m)>>>0}function y(s,r=0,c=s.byteLength,m=0){for(let h=0;h<c;h++)s[r+h]=m}function D(s,r,c="0"){for(;s.length<r;)s=c+s;return s}function v(s,r=32){return s instanceof ArrayBuffer?Array.from(new Uint8Array(s)).map(c=>c.toString(16).padStart(2,"0")).join(""):D((s>>>0).toString(16),r/4)}e.$Gi=v;class l{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(r){const c=r.length;if(c===0)return;const m=this.p;let h=this.r,t=this.u,n,o;for(t!==0?(n=t,o=-1,t=0):(n=r.charCodeAt(0),o=0);;){let i=n;if(C.$5e(n))if(o+1<c){const a=r.charCodeAt(o+1);C.$6e(a)?(o++,i=C.$7e(n,a)):i=65533}else{t=n;break}else C.$6e(n)&&(i=65533);if(h=this.w(m,h,i),o++,o<c)n=r.charCodeAt(o);else break}this.r=h,this.u=t}w(r,c,m){return m<128?r[c++]=m:m<2048?(r[c++]=192|(m&1984)>>>6,r[c++]=128|(m&63)>>>0):m<65536?(r[c++]=224|(m&61440)>>>12,r[c++]=128|(m&4032)>>>6,r[c++]=128|(m&63)>>>0):(r[c++]=240|(m&1835008)>>>18,r[c++]=128|(m&258048)>>>12,r[c++]=128|(m&4032)>>>6,r[c++]=128|(m&63)>>>0),c>=64&&(this.y(),c-=64,this.t+=64,r[0]=r[64+0],r[1]=r[64+1],r[2]=r[64+2]),c}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),v(this.h)+v(this.l)+v(this.m)+v(this.n)+v(this.o)}x(){this.p[this.r++]=128,y(this.p,this.r),this.r>56&&(this.y(),y(this.p));const r=8*this.t;this.q.setUint32(56,Math.floor(r/4294967296),!1),this.q.setUint32(60,r%4294967296,!1),this.y()}y(){const r=l.g,c=this.q;for(let k=0;k<64;k+=4)r.setUint32(k,c.getUint32(k,!1),!1);for(let k=64;k<320;k+=4)r.setUint32(k,p(r.getUint32(k-12,!1)^r.getUint32(k-32,!1)^r.getUint32(k-56,!1)^r.getUint32(k-64,!1),1),!1);let m=this.h,h=this.l,t=this.m,n=this.n,o=this.o,i,a,u;for(let k=0;k<80;k++)k<20?(i=h&t|~h&n,a=1518500249):k<40?(i=h^t^n,a=1859775393):k<60?(i=h&t|h&n|t&n,a=2400959708):(i=h^t^n,a=3395469782),u=p(m,5)+i+o+a+r.getUint32(k*4,!1)&4294967295,o=n,n=t,t=p(h,30),h=m,m=u;this.h=this.h+m&4294967295,this.l=this.l+h&4294967295,this.m=this.m+t&4294967295,this.n=this.n+n&4294967295,this.o=this.o+o&4294967295}}e.$Hi=l}),define(De[38],Ce([1,0,15]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var T;(function(d){d[d.Ignore=0]="Ignore",d[d.Info=1]="Info",d[d.Warning=2]="Warning",d[d.Error=3]="Error"})(T||(T={})),function(d){const M="error",A="warning",b="warn",E="info",w="ignore";function R(p){return p?C.$1e(M,p)?d.Error:C.$1e(A,p)||C.$1e(b,p)?d.Warning:C.$1e(E,p)?d.Info:d.Ignore:d.Ignore}d.fromValue=R;function I(p){switch(p){case d.Error:return M;case d.Warning:return A;case d.Info:return E;default:return w}}d.toString=I}(T||(T={})),e.default=T}),define(De[160],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jd=void 0,e.$Jd=Symbol("MicrotaskDelay")}),define(De[77],Ce([1,0,19,15]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=void 0;class d{constructor(){this.b="",this.c=0}reset(y){return this.b=y,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(y){const D=y.charCodeAt(0),v=this.b.charCodeAt(this.c);return D-v}value(){return this.b[this.c]}}e.$Ph=d;class M{constructor(y=!0){this.e=y}reset(y){return this.b=y,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let y=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(y)this.c++;else break;else y=!1;return this}cmp(y){return this.e?(0,T.$Ue)(y,this.b,0,y.length,this.c,this.d):(0,T.$We)(y,this.b,0,y.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Qh=M;class A{constructor(y=!0,D=!0){this.f=y,this.g=D}reset(y){this.d=0,this.e=0,this.b=y,this.c=y.length;for(let D=y.length-1;D>=0;D--,this.c--){const v=this.b.charCodeAt(D);if(!(v===47||this.f&&v===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let y=!0;for(;this.e<this.c;this.e++){const D=this.b.charCodeAt(this.e);if(D===47||this.f&&D===92)if(y)this.d++;else break;else y=!1}return this}cmp(y){return this.g?(0,T.$Ue)(y,this.b,0,y.length,this.d,this.e):(0,T.$We)(y,this.b,0,y.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Rh=A;var b;(function(p){p[p.Scheme=1]="Scheme",p[p.Authority=2]="Authority",p[p.Path=3]="Path",p[p.Query=4]="Query",p[p.Fragment=5]="Fragment"})(b||(b={}));class E{constructor(y,D){this.f=y,this.g=D,this.d=[],this.e=0}reset(y){return this.c=y,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(y)),this.b.reset(y.path),this.b.value()&&this.d.push(3)),this.g(y)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(y){if(this.d[this.e]===1)return(0,T.$Ve)(y,this.c.scheme);if(this.d[this.e]===2)return(0,T.$Ve)(y,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(y);if(this.d[this.e]===4)return(0,T.$Te)(y,this.c.query);if(this.d[this.e]===5)return(0,T.$Te)(y,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Sh=E;class w{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const y=this.right;return this.right=y.left,y.left=this,this.updateHeight(),y.updateHeight(),y}rotateRight(){const y=this.left;return this.left=y.right,y.right=this,this.updateHeight(),y.updateHeight(),y}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var R;(function(p){p[p.Left=-1]="Left",p[p.Mid=0]="Mid",p[p.Right=1]="Right"})(R||(R={}));class I{static forUris(y=()=>!1,D=()=>!1){return new I(new E(y,D))}static forPaths(y=!1){return new I(new A(void 0,!y))}static forStrings(){return new I(new d)}static forConfigKeys(){return new I(new M)}constructor(y){this.b=y}clear(){this.c=void 0}fill(y,D){if(D){const v=D.slice(0);(0,C.$Wb)(v);for(const l of v)this.set(l,y)}else{const v=y.slice(0);(0,C.$Wb)(v);for(const l of v)this.set(l[0],l[1])}}set(y,D){const v=this.b.reset(y);let l;this.c||(this.c=new w,this.c.segment=v.value());const s=[];for(l=this.c;;){const c=v.cmp(l.segment);if(c>0)l.left||(l.left=new w,l.left.segment=v.value()),s.push([-1,l]),l=l.left;else if(c<0)l.right||(l.right=new w,l.right.segment=v.value()),s.push([1,l]),l=l.right;else if(v.hasNext())v.next(),l.mid||(l.mid=new w,l.mid.segment=v.value()),s.push([0,l]),l=l.mid;else break}const r=l.value;l.value=D,l.key=y;for(let c=s.length-1;c>=0;c--){const m=s[c][1];m.updateHeight();const h=m.balanceFactor();if(h<-1||h>1){const t=s[c][0],n=s[c+1][0];if(t===1&&n===1)s[c][1]=m.rotateLeft();else if(t===-1&&n===-1)s[c][1]=m.rotateRight();else if(t===1&&n===-1)m.right=s[c+1][1]=s[c+1][1].rotateRight(),s[c][1]=m.rotateLeft();else if(t===-1&&n===1)m.left=s[c+1][1]=s[c+1][1].rotateLeft(),s[c][1]=m.rotateRight();else throw new Error;if(c>0)switch(s[c-1][0]){case-1:s[c-1][1].left=s[c][1];break;case 1:s[c-1][1].right=s[c][1];break;case 0:s[c-1][1].mid=s[c][1];break}else this.c=s[0][1]}}return r}get(y){return this.d(y)?.value}d(y){const D=this.b.reset(y);let v=this.c;for(;v;){const l=D.cmp(v.segment);if(l>0)v=v.left;else if(l<0)v=v.right;else if(D.hasNext())D.next(),v=v.mid;else break}return v}has(y){const D=this.d(y);return!(D?.value===void 0&&D?.mid===void 0)}delete(y){return this.e(y,!1)}deleteSuperstr(y){return this.e(y,!0)}e(y,D){const v=this.b.reset(y),l=[];let s=this.c;for(;s;){const r=v.cmp(s.segment);if(r>0)l.push([-1,s]),s=s.left;else if(r<0)l.push([1,s]),s=s.right;else if(v.hasNext())v.next(),l.push([0,s]),s=s.mid;else break}if(s){if(D?(s.left=void 0,s.mid=void 0,s.right=void 0,s.height=1):(s.key=void 0,s.value=void 0),!s.mid&&!s.value)if(s.left&&s.right){const r=this.f(s.right);if(r.key){const{key:c,value:m,segment:h}=r;this.e(r.key,!1),s.key=c,s.value=m,s.segment=h}}else{const r=s.left??s.right;if(l.length>0){const[c,m]=l[l.length-1];switch(c){case-1:m.left=r;break;case 0:m.mid=r;break;case 1:m.right=r;break}}else this.c=r}for(let r=l.length-1;r>=0;r--){const c=l[r][1];c.updateHeight();const m=c.balanceFactor();if(m>1?(c.right.balanceFactor()>=0||(c.right=c.right.rotateRight()),l[r][1]=c.rotateLeft()):m<-1&&(c.left.balanceFactor()<=0||(c.left=c.left.rotateLeft()),l[r][1]=c.rotateRight()),r>0)switch(l[r-1][0]){case-1:l[r-1][1].left=l[r][1];break;case 1:l[r-1][1].right=l[r][1];break;case 0:l[r-1][1].mid=l[r][1];break}else this.c=l[0][1]}}}f(y){for(;y.left;)y=y.left;return y}findSubstr(y){const D=this.b.reset(y);let v=this.c,l;for(;v;){const s=D.cmp(v.segment);if(s>0)v=v.left;else if(s<0)v=v.right;else if(D.hasNext())D.next(),l=v.value||l,v=v.mid;else break}return v&&v.value||l}findSuperstr(y){return this.g(y,!1)}g(y,D){const v=this.b.reset(y);let l=this.c;for(;l;){const s=v.cmp(l.segment);if(s>0)l=l.left;else if(s<0)l=l.right;else if(v.hasNext())v.next(),l=l.mid;else return l.mid?this.h(l.mid):D?l.value:void 0}}hasElementOrSubtree(y){return this.g(y,!0)!==void 0}forEach(y){for(const[D,v]of this)y(v,D)}*[Symbol.iterator](){yield*this.h(this.c)}h(y){const D=[];return this.j(y,D),D[Symbol.iterator]()}j(y,D){y&&(y.left&&this.j(y.left,D),y.value&&D.push([y.key,y.value]),y.mid&&this.j(y.mid,D),y.right&&this.j(y.right,D))}_isBalanced(){const y=D=>{if(!D)return!0;const v=D.balanceFactor();return v<-1||v>1?!1:y(D.left)&&y(D.right)};return y(this.c)}}e.$Th=I}),define(De[18],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=e.$xf=void 0;function C(h){return typeof h=="string"}e.$xf=C;function T(h){return Array.isArray(h)&&h.every(t=>C(t))}e.$yf=T;function d(h){return typeof h=="object"&&h!==null&&!Array.isArray(h)&&!(h instanceof RegExp)&&!(h instanceof Date)}e.$zf=d;function M(h){const t=Object.getPrototypeOf(Uint8Array);return typeof h=="object"&&h instanceof t}e.$Af=M;function A(h){return typeof h=="number"&&!isNaN(h)}e.$Bf=A;function b(h){return!!h&&typeof h[Symbol.iterator]=="function"}e.$Cf=b;function E(h){return h===!0||h===!1}e.$Df=E;function w(h){return typeof h>"u"}e.$Ef=w;function R(h){return!I(h)}e.$Ff=R;function I(h){return w(h)||h===null}e.$Gf=I;function p(h,t){if(!h)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$Hf=p;function y(h){if(I(h))throw new Error("Assertion Failed: argument is undefined or null");return h}e.$If=y;function D(...h){const t=[];for(let n=0;n<h.length;n++){const o=h[n];if(I(o))throw new Error(`Assertion Failed: argument at index ${n} is undefined or null`);t.push(o)}return t}e.$Jf=D;const v=Object.prototype.hasOwnProperty;function l(h){if(!d(h))return!1;for(const t in h)if(v.call(h,t))return!1;return!0}e.$Kf=l;function s(h){return typeof h=="function"}e.$Lf=s;function r(...h){return h.length>0&&h.every(s)}e.$Mf=r;function c(h,t){const n=Math.min(h.length,t.length);for(let o=0;o<n;o++)m(h[o],t[o])}e.$Nf=c;function m(h,t){if(C(t)){if(typeof h!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(s(t)){try{if(h instanceof t)return}catch{}if(!I(h)&&h.constructor===t||t.length===1&&t.call(void 0,h)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Of=m}),define(De[78],Ce([1,0,18]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sj=e.$Rj=e.$Qj=void 0;const T=Object.create(null);function d(b,E){if((0,C.$xf)(E)){const w=T[E];if(w===void 0)throw new Error(`${b} references an unknown codicon: ${E}`);E=w}return T[b]=E,{id:b}}function M(){return T}e.$Qj=M;function A(){return Object.values(e.$Sj)}e.$Rj=A,e.$Sj={add:d("add",6e4),plus:d("plus",6e4),gistNew:d("gist-new",6e4),repoCreate:d("repo-create",6e4),lightbulb:d("lightbulb",60001),lightBulb:d("light-bulb",60001),repo:d("repo",60002),repoDelete:d("repo-delete",60002),gistFork:d("gist-fork",60003),repoForked:d("repo-forked",60003),gitPullRequest:d("git-pull-request",60004),gitPullRequestAbandoned:d("git-pull-request-abandoned",60004),recordKeys:d("record-keys",60005),keyboard:d("keyboard",60005),tag:d("tag",60006),tagAdd:d("tag-add",60006),tagRemove:d("tag-remove",60006),gitPullRequestLabel:d("git-pull-request-label",60006),person:d("person",60007),personFollow:d("person-follow",60007),personOutline:d("person-outline",60007),personFilled:d("person-filled",60007),gitBranch:d("git-branch",60008),gitBranchCreate:d("git-branch-create",60008),gitBranchDelete:d("git-branch-delete",60008),sourceControl:d("source-control",60008),mirror:d("mirror",60009),mirrorPublic:d("mirror-public",60009),star:d("star",60010),starAdd:d("star-add",60010),starDelete:d("star-delete",60010),starEmpty:d("star-empty",60010),comment:d("comment",60011),commentAdd:d("comment-add",60011),alert:d("alert",60012),warning:d("warning",60012),search:d("search",60013),searchSave:d("search-save",60013),logOut:d("log-out",60014),signOut:d("sign-out",60014),logIn:d("log-in",60015),signIn:d("sign-in",60015),eye:d("eye",60016),eyeUnwatch:d("eye-unwatch",60016),eyeWatch:d("eye-watch",60016),circleFilled:d("circle-filled",60017),primitiveDot:d("primitive-dot",60017),closeDirty:d("close-dirty",60017),debugBreakpoint:d("debug-breakpoint",60017),debugBreakpointDisabled:d("debug-breakpoint-disabled",60017),debugHint:d("debug-hint",60017),primitiveSquare:d("primitive-square",60018),edit:d("edit",60019),pencil:d("pencil",60019),info:d("info",60020),issueOpened:d("issue-opened",60020),gistPrivate:d("gist-private",60021),gitForkPrivate:d("git-fork-private",60021),lock:d("lock",60021),mirrorPrivate:d("mirror-private",60021),close:d("close",60022),removeClose:d("remove-close",60022),x:d("x",60022),repoSync:d("repo-sync",60023),sync:d("sync",60023),clone:d("clone",60024),desktopDownload:d("desktop-download",60024),beaker:d("beaker",60025),microscope:d("microscope",60025),vm:d("vm",60026),deviceDesktop:d("device-desktop",60026),file:d("file",60027),fileText:d("file-text",60027),more:d("more",60028),ellipsis:d("ellipsis",60028),kebabHorizontal:d("kebab-horizontal",60028),mailReply:d("mail-reply",60029),reply:d("reply",60029),organization:d("organization",60030),organizationFilled:d("organization-filled",60030),organizationOutline:d("organization-outline",60030),newFile:d("new-file",60031),fileAdd:d("file-add",60031),newFolder:d("new-folder",60032),fileDirectoryCreate:d("file-directory-create",60032),trash:d("trash",60033),trashcan:d("trashcan",60033),history:d("history",60034),clock:d("clock",60034),folder:d("folder",60035),fileDirectory:d("file-directory",60035),symbolFolder:d("symbol-folder",60035),logoGithub:d("logo-github",60036),markGithub:d("mark-github",60036),github:d("github",60036),terminal:d("terminal",60037),console:d("console",60037),repl:d("repl",60037),zap:d("zap",60038),symbolEvent:d("symbol-event",60038),error:d("error",60039),stop:d("stop",60039),variable:d("variable",60040),symbolVariable:d("symbol-variable",60040),array:d("array",60042),symbolArray:d("symbol-array",60042),symbolModule:d("symbol-module",60043),symbolPackage:d("symbol-package",60043),symbolNamespace:d("symbol-namespace",60043),symbolObject:d("symbol-object",60043),symbolMethod:d("symbol-method",60044),symbolFunction:d("symbol-function",60044),symbolConstructor:d("symbol-constructor",60044),symbolBoolean:d("symbol-boolean",60047),symbolNull:d("symbol-null",60047),symbolNumeric:d("symbol-numeric",60048),symbolNumber:d("symbol-number",60048),symbolStructure:d("symbol-structure",60049),symbolStruct:d("symbol-struct",60049),symbolParameter:d("symbol-parameter",60050),symbolTypeParameter:d("symbol-type-parameter",60050),symbolKey:d("symbol-key",60051),symbolText:d("symbol-text",60051),symbolReference:d("symbol-reference",60052),goToFile:d("go-to-file",60052),symbolEnum:d("symbol-enum",60053),symbolValue:d("symbol-value",60053),symbolRuler:d("symbol-ruler",60054),symbolUnit:d("symbol-unit",60054),activateBreakpoints:d("activate-breakpoints",60055),archive:d("archive",60056),arrowBoth:d("arrow-both",60057),arrowDown:d("arrow-down",60058),arrowLeft:d("arrow-left",60059),arrowRight:d("arrow-right",60060),arrowSmallDown:d("arrow-small-down",60061),arrowSmallLeft:d("arrow-small-left",60062),arrowSmallRight:d("arrow-small-right",60063),arrowSmallUp:d("arrow-small-up",60064),arrowUp:d("arrow-up",60065),bell:d("bell",60066),bold:d("bold",60067),book:d("book",60068),bookmark:d("bookmark",60069),debugBreakpointConditionalUnverified:d("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:d("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:d("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:d("debug-breakpoint-data-unverified",60072),debugBreakpointData:d("debug-breakpoint-data",60073),debugBreakpointDataDisabled:d("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:d("debug-breakpoint-log-unverified",60074),debugBreakpointLog:d("debug-breakpoint-log",60075),debugBreakpointLogDisabled:d("debug-breakpoint-log-disabled",60075),briefcase:d("briefcase",60076),broadcast:d("broadcast",60077),browser:d("browser",60078),bug:d("bug",60079),calendar:d("calendar",60080),caseSensitive:d("case-sensitive",60081),check:d("check",60082),checklist:d("checklist",60083),chevronDown:d("chevron-down",60084),dropDownButton:d("drop-down-button",60084),chevronLeft:d("chevron-left",60085),chevronRight:d("chevron-right",60086),chevronUp:d("chevron-up",60087),chromeClose:d("chrome-close",60088),chromeMaximize:d("chrome-maximize",60089),chromeMinimize:d("chrome-minimize",60090),chromeRestore:d("chrome-restore",60091),circle:d("circle",60092),circleOutline:d("circle-outline",60092),debugBreakpointUnverified:d("debug-breakpoint-unverified",60092),circleSlash:d("circle-slash",60093),circuitBoard:d("circuit-board",60094),clearAll:d("clear-all",60095),clippy:d("clippy",60096),closeAll:d("close-all",60097),cloudDownload:d("cloud-download",60098),cloudUpload:d("cloud-upload",60099),code:d("code",60100),collapseAll:d("collapse-all",60101),colorMode:d("color-mode",60102),commentDiscussion:d("comment-discussion",60103),compareChanges:d("compare-changes",60157),creditCard:d("credit-card",60105),dash:d("dash",60108),dashboard:d("dashboard",60109),database:d("database",60110),debugContinue:d("debug-continue",60111),debugDisconnect:d("debug-disconnect",60112),debugPause:d("debug-pause",60113),debugRestart:d("debug-restart",60114),debugStart:d("debug-start",60115),debugStepInto:d("debug-step-into",60116),debugStepOut:d("debug-step-out",60117),debugStepOver:d("debug-step-over",60118),debugStop:d("debug-stop",60119),debug:d("debug",60120),deviceCameraVideo:d("device-camera-video",60121),deviceCamera:d("device-camera",60122),deviceMobile:d("device-mobile",60123),diffAdded:d("diff-added",60124),diffIgnored:d("diff-ignored",60125),diffModified:d("diff-modified",60126),diffRemoved:d("diff-removed",60127),diffRenamed:d("diff-renamed",60128),diff:d("diff",60129),discard:d("discard",60130),editorLayout:d("editor-layout",60131),emptyWindow:d("empty-window",60132),exclude:d("exclude",60133),extensions:d("extensions",60134),eyeClosed:d("eye-closed",60135),fileBinary:d("file-binary",60136),fileCode:d("file-code",60137),fileMedia:d("file-media",60138),filePdf:d("file-pdf",60139),fileSubmodule:d("file-submodule",60140),fileSymlinkDirectory:d("file-symlink-directory",60141),fileSymlinkFile:d("file-symlink-file",60142),fileZip:d("file-zip",60143),files:d("files",60144),filter:d("filter",60145),flame:d("flame",60146),foldDown:d("fold-down",60147),foldUp:d("fold-up",60148),fold:d("fold",60149),folderActive:d("folder-active",60150),folderOpened:d("folder-opened",60151),gear:d("gear",60152),gift:d("gift",60153),gistSecret:d("gist-secret",60154),gist:d("gist",60155),gitCommit:d("git-commit",60156),gitCompare:d("git-compare",60157),gitMerge:d("git-merge",60158),githubAction:d("github-action",60159),githubAlt:d("github-alt",60160),globe:d("globe",60161),grabber:d("grabber",60162),graph:d("graph",60163),gripper:d("gripper",60164),heart:d("heart",60165),home:d("home",60166),horizontalRule:d("horizontal-rule",60167),hubot:d("hubot",60168),inbox:d("inbox",60169),issueClosed:d("issue-closed",60324),issueReopened:d("issue-reopened",60171),issues:d("issues",60172),italic:d("italic",60173),jersey:d("jersey",60174),json:d("json",60175),bracket:d("bracket",60175),kebabVertical:d("kebab-vertical",60176),key:d("key",60177),law:d("law",60178),lightbulbAutofix:d("lightbulb-autofix",60179),linkExternal:d("link-external",60180),link:d("link",60181),listOrdered:d("list-ordered",60182),listUnordered:d("list-unordered",60183),liveShare:d("live-share",60184),loading:d("loading",60185),location:d("location",60186),mailRead:d("mail-read",60187),mail:d("mail",60188),markdown:d("markdown",60189),megaphone:d("megaphone",60190),mention:d("mention",60191),milestone:d("milestone",60192),gitPullRequestMilestone:d("git-pull-request-milestone",60192),mortarBoard:d("mortar-board",60193),move:d("move",60194),multipleWindows:d("multiple-windows",60195),mute:d("mute",60196),noNewline:d("no-newline",60197),note:d("note",60198),octoface:d("octoface",60199),openPreview:d("open-preview",60200),package:d("package",60201),paintcan:d("paintcan",60202),pin:d("pin",60203),play:d("play",60204),run:d("run",60204),plug:d("plug",60205),preserveCase:d("preserve-case",60206),preview:d("preview",60207),project:d("project",60208),pulse:d("pulse",60209),question:d("question",60210),quote:d("quote",60211),radioTower:d("radio-tower",60212),reactions:d("reactions",60213),references:d("references",60214),refresh:d("refresh",60215),regex:d("regex",60216),remoteExplorer:d("remote-explorer",60217),remote:d("remote",60218),remove:d("remove",60219),replaceAll:d("replace-all",60220),replace:d("replace",60221),repoClone:d("repo-clone",60222),repoForcePush:d("repo-force-push",60223),repoPull:d("repo-pull",60224),repoPush:d("repo-push",60225),report:d("report",60226),requestChanges:d("request-changes",60227),rocket:d("rocket",60228),rootFolderOpened:d("root-folder-opened",60229),rootFolder:d("root-folder",60230),rss:d("rss",60231),ruby:d("ruby",60232),saveAll:d("save-all",60233),saveAs:d("save-as",60234),save:d("save",60235),screenFull:d("screen-full",60236),screenNormal:d("screen-normal",60237),searchStop:d("search-stop",60238),server:d("server",60240),settingsGear:d("settings-gear",60241),settings:d("settings",60242),shield:d("shield",60243),smiley:d("smiley",60244),sortPrecedence:d("sort-precedence",60245),splitHorizontal:d("split-horizontal",60246),splitVertical:d("split-vertical",60247),squirrel:d("squirrel",60248),starFull:d("star-full",60249),starHalf:d("star-half",60250),symbolClass:d("symbol-class",60251),symbolColor:d("symbol-color",60252),symbolCustomColor:d("symbol-customcolor",60252),symbolConstant:d("symbol-constant",60253),symbolEnumMember:d("symbol-enum-member",60254),symbolField:d("symbol-field",60255),symbolFile:d("symbol-file",60256),symbolInterface:d("symbol-interface",60257),symbolKeyword:d("symbol-keyword",60258),symbolMisc:d("symbol-misc",60259),symbolOperator:d("symbol-operator",60260),symbolProperty:d("symbol-property",60261),wrench:d("wrench",60261),wrenchSubaction:d("wrench-subaction",60261),symbolSnippet:d("symbol-snippet",60262),tasklist:d("tasklist",60263),telescope:d("telescope",60264),textSize:d("text-size",60265),threeBars:d("three-bars",60266),thumbsdown:d("thumbsdown",60267),thumbsup:d("thumbsup",60268),tools:d("tools",60269),triangleDown:d("triangle-down",60270),triangleLeft:d("triangle-left",60271),triangleRight:d("triangle-right",60272),triangleUp:d("triangle-up",60273),twitter:d("twitter",60274),unfold:d("unfold",60275),unlock:d("unlock",60276),unmute:d("unmute",60277),unverified:d("unverified",60278),verified:d("verified",60279),versions:d("versions",60280),vmActive:d("vm-active",60281),vmOutline:d("vm-outline",60282),vmRunning:d("vm-running",60283),watch:d("watch",60284),whitespace:d("whitespace",60285),wholeWord:d("whole-word",60286),window:d("window",60287),wordWrap:d("word-wrap",60288),zoomIn:d("zoom-in",60289),zoomOut:d("zoom-out",60290),listFilter:d("list-filter",60291),listFlat:d("list-flat",60292),listSelection:d("list-selection",60293),selection:d("selection",60293),listTree:d("list-tree",60294),debugBreakpointFunctionUnverified:d("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:d("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:d("debug-breakpoint-function-disabled",60296),debugStackframeActive:d("debug-stackframe-active",60297),circleSmallFilled:d("circle-small-filled",60298),debugStackframeDot:d("debug-stackframe-dot",60298),debugStackframe:d("debug-stackframe",60299),debugStackframeFocused:d("debug-stackframe-focused",60299),debugBreakpointUnsupported:d("debug-breakpoint-unsupported",60300),symbolString:d("symbol-string",60301),debugReverseContinue:d("debug-reverse-continue",60302),debugStepBack:d("debug-step-back",60303),debugRestartFrame:d("debug-restart-frame",60304),callIncoming:d("call-incoming",60306),callOutgoing:d("call-outgoing",60307),menu:d("menu",60308),expandAll:d("expand-all",60309),feedback:d("feedback",60310),gitPullRequestReviewer:d("git-pull-request-reviewer",60310),groupByRefType:d("group-by-ref-type",60311),ungroupByRefType:d("ungroup-by-ref-type",60312),account:d("account",60313),gitPullRequestAssignee:d("git-pull-request-assignee",60313),bellDot:d("bell-dot",60314),debugConsole:d("debug-console",60315),library:d("library",60316),output:d("output",60317),runAll:d("run-all",60318),syncIgnored:d("sync-ignored",60319),pinned:d("pinned",60320),githubInverted:d("github-inverted",60321),debugAlt:d("debug-alt",60305),serverProcess:d("server-process",60322),serverEnvironment:d("server-environment",60323),pass:d("pass",60324),stopCircle:d("stop-circle",60325),playCircle:d("play-circle",60326),record:d("record",60327),debugAltSmall:d("debug-alt-small",60328),vmConnect:d("vm-connect",60329),cloud:d("cloud",60330),merge:d("merge",60331),exportIcon:d("export",60332),graphLeft:d("graph-left",60333),magnet:d("magnet",60334),notebook:d("notebook",60335),redo:d("redo",60336),checkAll:d("check-all",60337),pinnedDirty:d("pinned-dirty",60338),passFilled:d("pass-filled",60339),circleLargeFilled:d("circle-large-filled",60340),circleLarge:d("circle-large",60341),circleLargeOutline:d("circle-large-outline",60341),combine:d("combine",60342),gather:d("gather",60342),table:d("table",60343),variableGroup:d("variable-group",60344),typeHierarchy:d("type-hierarchy",60345),typeHierarchySub:d("type-hierarchy-sub",60346),typeHierarchySuper:d("type-hierarchy-super",60347),gitPullRequestCreate:d("git-pull-request-create",60348),runAbove:d("run-above",60349),runBelow:d("run-below",60350),notebookTemplate:d("notebook-template",60351),debugRerun:d("debug-rerun",60352),workspaceTrusted:d("workspace-trusted",60353),workspaceUntrusted:d("workspace-untrusted",60354),workspaceUnspecified:d("workspace-unspecified",60355),terminalCmd:d("terminal-cmd",60356),terminalDebian:d("terminal-debian",60357),terminalLinux:d("terminal-linux",60358),terminalPowershell:d("terminal-powershell",60359),terminalTmux:d("terminal-tmux",60360),terminalUbuntu:d("terminal-ubuntu",60361),terminalBash:d("terminal-bash",60362),arrowSwap:d("arrow-swap",60363),copy:d("copy",60364),personAdd:d("person-add",60365),filterFilled:d("filter-filled",60366),wand:d("wand",60367),debugLineByLine:d("debug-line-by-line",60368),inspect:d("inspect",60369),layers:d("layers",60370),layersDot:d("layers-dot",60371),layersActive:d("layers-active",60372),compass:d("compass",60373),compassDot:d("compass-dot",60374),compassActive:d("compass-active",60375),azure:d("azure",60376),issueDraft:d("issue-draft",60377),gitPullRequestClosed:d("git-pull-request-closed",60378),gitPullRequestDraft:d("git-pull-request-draft",60379),debugAll:d("debug-all",60380),debugCoverage:d("debug-coverage",60381),runErrors:d("run-errors",60382),folderLibrary:d("folder-library",60383),debugContinueSmall:d("debug-continue-small",60384),beakerStop:d("beaker-stop",60385),graphLine:d("graph-line",60386),graphScatter:d("graph-scatter",60387),pieChart:d("pie-chart",60388),bracketDot:d("bracket-dot",60389),bracketError:d("bracket-error",60390),lockSmall:d("lock-small",60391),azureDevops:d("azure-devops",60392),verifiedFilled:d("verified-filled",60393),newLine:d("newline",60394),layout:d("layout",60395),layoutActivitybarLeft:d("layout-activitybar-left",60396),layoutActivitybarRight:d("layout-activitybar-right",60397),layoutPanelLeft:d("layout-panel-left",60398),layoutPanelCenter:d("layout-panel-center",60399),layoutPanelJustify:d("layout-panel-justify",60400),layoutPanelRight:d("layout-panel-right",60401),layoutPanel:d("layout-panel",60402),layoutSidebarLeft:d("layout-sidebar-left",60403),layoutSidebarRight:d("layout-sidebar-right",60404),layoutStatusbar:d("layout-statusbar",60405),layoutMenubar:d("layout-menubar",60406),layoutCentered:d("layout-centered",60407),layoutSidebarRightOff:d("layout-sidebar-right-off",60416),layoutPanelOff:d("layout-panel-off",60417),layoutSidebarLeftOff:d("layout-sidebar-left-off",60418),target:d("target",60408),indent:d("indent",60409),recordSmall:d("record-small",60410),errorSmall:d("error-small",60411),arrowCircleDown:d("arrow-circle-down",60412),arrowCircleLeft:d("arrow-circle-left",60413),arrowCircleRight:d("arrow-circle-right",60414),arrowCircleUp:d("arrow-circle-up",60415),heartFilled:d("heart-filled",60420),map:d("map",60421),mapFilled:d("map-filled",60422),circleSmall:d("circle-small",60423),bellSlash:d("bell-slash",60424),bellSlashDot:d("bell-slash-dot",60425),commentUnresolved:d("comment-unresolved",60426),gitPullRequestGoToChanges:d("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:d("git-pull-request-new-changes",60428),searchFuzzy:d("search-fuzzy",60429),commentDraft:d("comment-draft",60430),send:d("send",60431),sparkle:d("sparkle",60432),insert:d("insert",60433),mic:d("mic",60434),dialogError:d("dialog-error","error"),dialogWarning:d("dialog-warning","warning"),dialogInfo:d("dialog-info","info"),dialogClose:d("dialog-close","close"),treeItemExpanded:d("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:d("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:d("tree-filter-on-type-off","list-selection"),treeFilterClear:d("tree-filter-clear","close"),treeItemLoading:d("tree-item-loading","loading"),menuSelection:d("menu-selection","check"),menuSubmenu:d("menu-submenu","chevron-right"),menuBarMore:d("menubar-more","more"),scrollbarButtonLeft:d("scrollbar-button-left","triangle-left"),scrollbarButtonRight:d("scrollbar-button-right","triangle-right"),scrollbarButtonUp:d("scrollbar-button-up","triangle-up"),scrollbarButtonDown:d("scrollbar-button-down","triangle-down"),toolBarMore:d("toolbar-more","more"),quickInputBack:d("quick-input-back","arrow-left")}}),define(De[23],Ce([1,0,18]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$an=e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=void 0;function T(s){if(!s||typeof s!="object"||s instanceof RegExp)return s;const r=Array.isArray(s)?[]:{};return Object.entries(s).forEach(([c,m])=>{r[c]=m&&typeof m=="object"?T(m):m}),r}e.$2m=T;function d(s){if(!s||typeof s!="object")return s;const r=[s];for(;r.length>0;){const c=r.shift();Object.freeze(c);for(const m in c)if(M.call(c,m)){const h=c[m];typeof h=="object"&&!Object.isFrozen(h)&&!(0,C.$Af)(h)&&r.push(h)}}return s}e.$3m=d;const M=Object.prototype.hasOwnProperty;function A(s,r){return b(s,r,new Set)}e.$4m=A;function b(s,r,c){if((0,C.$Gf)(s))return s;const m=r(s);if(typeof m<"u")return m;if(Array.isArray(s)){const h=[];for(const t of s)h.push(b(t,r,c));return h}if((0,C.$zf)(s)){if(c.has(s))throw new Error("Cannot clone recursive data-structure");c.add(s);const h={};for(const t in s)M.call(s,t)&&(h[t]=b(s[t],r,c));return c.delete(s),h}return s}function E(s,r,c=!0){return(0,C.$zf)(s)?((0,C.$zf)(r)&&Object.keys(r).forEach(m=>{m in s?c&&((0,C.$zf)(s[m])&&(0,C.$zf)(r[m])?E(s[m],r[m],c):s[m]=r[m]):s[m]=r[m]}),s):r}e.$5m=E;function w(s,r){if(s===r)return!0;if(s==null||r===null||r===void 0||typeof s!=typeof r||typeof s!="object"||Array.isArray(s)!==Array.isArray(r))return!1;let c,m;if(Array.isArray(s)){if(s.length!==r.length)return!1;for(c=0;c<s.length;c++)if(!w(s[c],r[c]))return!1}else{const h=[];for(m in s)h.push(m);h.sort();const t=[];for(m in r)t.push(m);if(t.sort(),!w(h,t))return!1;for(c=0;c<h.length;c++)if(!w(s[h[c]],r[h[c]]))return!1}return!0}e.$6m=w;function R(s){const r=new Set;return JSON.stringify(s,(c,m)=>{if((0,C.$zf)(m)||Array.isArray(m)){if(r.has(m))return"[Circular]";r.add(m)}return m})}e.$7m=R;function I(s,r){const c=Object.create(null);return!s||!r||Object.keys(r).forEach(h=>{const t=s[h],n=r[h];w(t,n)||(c[h]=n)}),c}e.$8m=I;function p(s,r){const c=r.toLowerCase(),m=Object.keys(s).find(h=>h.toLowerCase()===c);return m?s[m]:s[r]}e.$9m=p;function y(s,r){const c=Object.create(null);for(const[m,h]of Object.entries(s))r(m,h)&&(c[m]=h);return c}e.$0m=y;function D(s){let r=[];for(;Object.prototype!==s;)r=r.concat(Object.getOwnPropertyNames(s)),s=Object.getPrototypeOf(s);return r}e.$$m=D;function v(s){const r=[];for(const c of D(s))typeof s[c]=="function"&&r.push(c);return r}e.$_m=v;function l(s,r){const c=h=>function(){const t=Array.prototype.slice.call(arguments,0);return r(h,t)},m={};for(const h of s)m[h]=c(h);return m}e.$an=l}),define(De[59],Ce([1,0,78]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Tj=e.ThemeColor=void 0;var T;(function(A){function b(E){return E&&typeof E=="object"&&typeof E.id=="string"}A.isThemeColor=b})(T||(e.ThemeColor=T={}));function d(A){return{id:A}}e.$Tj=d;var M;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const b=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function E(r){const c=b.exec(r.id);if(!c)return E(C.$Sj.error);const[,m,h]=c,t=["codicon","codicon-"+m];return h&&t.push("codicon-modifier-"+h.substring(1)),t}A.asClassNameArray=E;function w(r){return E(r).join(" ")}A.asClassName=w;function R(r){return"."+E(r).join(".")}A.asCSSSelector=R;function I(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color>"u"||T.isThemeColor(r.color))}A.isThemeIcon=I;const p=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function y(r){const c=p.exec(r);if(!c)return;const[,m]=c;return{id:m}}A.fromString=y;function D(r){return{id:r}}A.fromId=D;function v(r,c){let m=r.id;const h=m.lastIndexOf("~");return h!==-1&&(m=m.substring(0,h)),c&&(m=`${m}~${c}`),{id:m}}A.modify=v;function l(r){const c=r.id.lastIndexOf("~");if(c!==-1)return r.id.substring(c+1)}A.getModifier=l;function s(r,c){return r.id===c.id&&r.color?.id===c.color?.id}A.isEqual=s})(M||(e.ThemeIcon=M={}))}),define(De[161],Ce([1,0,121,15,59]),function(me,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=void 0;const M="$(",A=new RegExp(`\\$\\(${d.ThemeIcon.iconNameExpression}(?:${d.ThemeIcon.iconModifierExpression})?\\)`,"g"),b=new RegExp(`(\\\\)?${A.source}`,"g");function E(s){return s.replace(b,(r,c)=>c?r:`\\${r}`)}e.$Uj=E;const w=new RegExp(`\\\\${A.source}`,"g");function R(s){return s.replace(w,r=>`\\${r}`)}e.$Vj=R;const I=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function p(s){return s.indexOf(M)===-1?s:s.replace(I,(r,c,m,h)=>m?r:c||h||"")}e.$Wj=p;function y(s){return s?s.replace(/\$\((.*?)\)/g,(r,c)=>` ${c} `).trim():""}e.$Xj=y;const D=new RegExp(`\\$\\(${d.ThemeIcon.iconNameCharacter}+\\)`,"g");function v(s){D.lastIndex=0;let r="";const c=[];let m=0;for(;;){const h=D.lastIndex,t=D.exec(s),n=s.substring(h,t?.index);if(n.length>0){r+=n;for(let o=0;o<n.length;o++)c.push(m)}if(!t)break;m+=t[0].length}return{text:r,iconOffsets:c}}e.$Yj=v;function l(s,r,c=!1){const{text:m,iconOffsets:h}=r;if(!h||h.length===0)return(0,C.$Hj)(s,m,c);const t=(0,T.$Ie)(m," "),n=m.length-t.length,o=(0,C.$Hj)(s,t,c);if(o)for(const i of o){const a=h[i.start+n]+n;i.start+=a,i.end+=a}return o}e.$Zj=l}),define(De[122],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=e.$ye=e.Constants=void 0;var C;(function(M){M[M.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",M[M.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",M[M.MAX_UINT_8=255]="MAX_UINT_8",M[M.MAX_UINT_16=65535]="MAX_UINT_16",M[M.MAX_UINT_32=4294967295]="MAX_UINT_32",M[M.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(C||(e.Constants=C={}));function T(M){return M<0?0:M>255?255:M|0}e.$ye=T;function d(M){return M<0?0:M>4294967295?4294967295:M|0}e.$ze=d}),define(De[31],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dg=e.$cg=void 0;const C=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function T(d){return C.test(d)}e.$cg=T,e.$dg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let d;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?d=crypto.getRandomValues.bind(crypto):d=function(b){for(let E=0;E<b.length;E++)b[E]=Math.floor(Math.random()*256);return b};const M=new Uint8Array(16),A=[];for(let b=0;b<256;b++)A.push(b.toString(16).padStart(2,"0"));return function(){d(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let E=0,w="";return w+=A[M[E++]],w+=A[M[E++]],w+=A[M[E++]],w+=A[M[E++]],w+="-",w+=A[M[E++]],w+=A[M[E++]],w+="-",w+=A[M[E++]],w+=A[M[E++]],w+="-",w+=A[M[E++]],w+=A[M[E++]],w+="-",w+=A[M[E++]],w+=A[M[E++]],w+=A[M[E++]],w+=A[M[E++]],w+=A[M[E++]],w+=A[M[E++]],w}}()}),define(De[162],Ce([1,0,19,50,31]),function(me,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xs=e.$Ws=e.$Vs=e.$Us=e.$Ts=void 0;function M(I){return{asString:async()=>I,asFile:()=>{},value:typeof I=="string"?I:void 0}}e.$Ts=M;function A(I,p,y){const D={id:(0,d.$dg)(),name:I,uri:p,data:y};return{asString:async()=>"",asFile:()=>D,value:void 0}}e.$Us=A;class b{constructor(){this.a=new Map}get size(){let p=0;for(const y of this.a)p++;return p}has(p){return this.a.has(this.b(p))}matches(p){const y=[...this.a.keys()];return T.Iterable.some(this,([D,v])=>v.asFile())&&y.push("files"),R(E(p),y)}get(p){return this.a.get(this.b(p))?.[0]}append(p,y){const D=this.a.get(p);D?D.push(y):this.a.set(this.b(p),[y])}replace(p,y){this.a.set(this.b(p),[y])}delete(p){this.a.delete(this.b(p))}*[Symbol.iterator](){for(const[p,y]of this.a)for(const D of y)yield[p,D]}b(p){return E(p)}}e.$Vs=b;function E(I){return I.toLowerCase()}function w(I,p){return R(E(I),p.map(E))}e.$Ws=w;function R(I,p){if(I==="*/*")return p.length>0;if(p.includes(I))return!0;const y=I.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!y)return!1;const[D,v,l]=y;return l==="*"?p.some(s=>s.startsWith(v+"/")):!1}e.$Xs=Object.freeze({create:I=>(0,C.$Lb)(I.map(p=>p.toString())).join(`\r
`),split:I=>I.split(`\r
`),parse:I=>e.$Xs.split(I).filter(p=>!p.startsWith("#"))})}),define(De[163],Ce([1,0,60]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hg=e.$gg=e.$fg=void 0;function T(b,E,w,R=1){let I=!1;return new Promise(p=>{const y=setTimeout(()=>{if(!I)return I=!0,p(0)},w);d(b,E,R,D=>{if(!I)return I=!0,clearTimeout(y),p(D)})})}e.$fg=T;function d(b,E,w,R){if(E===0)return R(0);const I=new C.Socket;I.once("connect",()=>(A(I),d(b+w,E-1,w,R))),I.once("data",()=>{}),I.once("error",p=>(A(I),p.code!=="ECONNREFUSED"?d(b+w,E-1,w,R):R(b))),I.connect(b,"127.0.0.1")}e.$gg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function M(b,E,w,R="127.0.0.1"){let I=!1,p,y=1;const D=C.createServer({pauseOnConnect:!0});function v(l,s){I||(I=!0,D.removeAllListeners(),D.close(),p&&clearTimeout(p),s(l))}return new Promise(l=>{p=setTimeout(()=>{v(0,l)},w),D.on("listening",()=>{v(b,l)}),D.on("error",s=>{s&&(s.code==="EADDRINUSE"||s.code==="EACCES")&&y<E?(b++,y++,D.listen(b,R)):v(0,l)}),D.on("close",()=>{v(0,l)}),D.listen(b,R)})}e.$hg=M;function A(b){try{b.removeAllListeners("connect"),b.removeAllListeners("error"),b.end(),b.destroy(),b.unref()}catch(E){console.error(E)}}}),define(De[123],Ce([1,0,122]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ms=e.$Ls=void 0;class T{constructor(b){const E=(0,C.$ye)(b);this.c=E,this.a=T.d(E),this.b=new Map}static d(b){const E=new Uint8Array(256);return E.fill(b),E}set(b,E){const w=(0,C.$ye)(E);b>=0&&b<256?this.a[b]=w:this.b.set(b,w)}get(b){return b>=0&&b<256?this.a[b]:this.b.get(b)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$Ls=T;var d;(function(A){A[A.False=0]="False",A[A.True=1]="True"})(d||(d={}));class M{constructor(){this.a=new T(0)}add(b){this.a.set(b,1)}has(b){return this.a.get(b)===1}clear(){return this.a.clear()}}e.$Ms=M}),define(De[61],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ns=void 0;class C{constructor(d,M){this.lineNumber=d,this.column=M}with(d=this.lineNumber,M=this.column){return d===this.lineNumber&&M===this.column?this:new C(d,M)}delta(d=0,M=0){return this.with(this.lineNumber+d,this.column+M)}equals(d){return C.equals(this,d)}static equals(d,M){return!d&&!M?!0:!!d&&!!M&&d.lineNumber===M.lineNumber&&d.column===M.column}isBefore(d){return C.isBefore(this,d)}static isBefore(d,M){return d.lineNumber<M.lineNumber?!0:M.lineNumber<d.lineNumber?!1:d.column<M.column}isBeforeOrEqual(d){return C.isBeforeOrEqual(this,d)}static isBeforeOrEqual(d,M){return d.lineNumber<M.lineNumber?!0:M.lineNumber<d.lineNumber?!1:d.column<=M.column}static compare(d,M){const A=d.lineNumber|0,b=M.lineNumber|0;if(A===b){const E=d.column|0,w=M.column|0;return E-w}return A-b}clone(){return new C(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(d){return new C(d.lineNumber,d.column)}static isIPosition(d){return d&&typeof d.lineNumber=="number"&&typeof d.column=="number"}}e.$ns=C}),define(De[34],Ce([1,0,61]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$os=void 0;class T{constructor(M,A,b,E){M>b||M===b&&A>E?(this.startLineNumber=b,this.startColumn=E,this.endLineNumber=M,this.endColumn=A):(this.startLineNumber=M,this.startColumn=A,this.endLineNumber=b,this.endColumn=E)}isEmpty(){return T.isEmpty(this)}static isEmpty(M){return M.startLineNumber===M.endLineNumber&&M.startColumn===M.endColumn}containsPosition(M){return T.containsPosition(this,M)}static containsPosition(M,A){return!(A.lineNumber<M.startLineNumber||A.lineNumber>M.endLineNumber||A.lineNumber===M.startLineNumber&&A.column<M.startColumn||A.lineNumber===M.endLineNumber&&A.column>M.endColumn)}static strictContainsPosition(M,A){return!(A.lineNumber<M.startLineNumber||A.lineNumber>M.endLineNumber||A.lineNumber===M.startLineNumber&&A.column<=M.startColumn||A.lineNumber===M.endLineNumber&&A.column>=M.endColumn)}containsRange(M){return T.containsRange(this,M)}static containsRange(M,A){return!(A.startLineNumber<M.startLineNumber||A.endLineNumber<M.startLineNumber||A.startLineNumber>M.endLineNumber||A.endLineNumber>M.endLineNumber||A.startLineNumber===M.startLineNumber&&A.startColumn<M.startColumn||A.endLineNumber===M.endLineNumber&&A.endColumn>M.endColumn)}strictContainsRange(M){return T.strictContainsRange(this,M)}static strictContainsRange(M,A){return!(A.startLineNumber<M.startLineNumber||A.endLineNumber<M.startLineNumber||A.startLineNumber>M.endLineNumber||A.endLineNumber>M.endLineNumber||A.startLineNumber===M.startLineNumber&&A.startColumn<=M.startColumn||A.endLineNumber===M.endLineNumber&&A.endColumn>=M.endColumn)}plusRange(M){return T.plusRange(this,M)}static plusRange(M,A){let b,E,w,R;return A.startLineNumber<M.startLineNumber?(b=A.startLineNumber,E=A.startColumn):A.startLineNumber===M.startLineNumber?(b=A.startLineNumber,E=Math.min(A.startColumn,M.startColumn)):(b=M.startLineNumber,E=M.startColumn),A.endLineNumber>M.endLineNumber?(w=A.endLineNumber,R=A.endColumn):A.endLineNumber===M.endLineNumber?(w=A.endLineNumber,R=Math.max(A.endColumn,M.endColumn)):(w=M.endLineNumber,R=M.endColumn),new T(b,E,w,R)}intersectRanges(M){return T.intersectRanges(this,M)}static intersectRanges(M,A){let b=M.startLineNumber,E=M.startColumn,w=M.endLineNumber,R=M.endColumn;const I=A.startLineNumber,p=A.startColumn,y=A.endLineNumber,D=A.endColumn;return b<I?(b=I,E=p):b===I&&(E=Math.max(E,p)),w>y?(w=y,R=D):w===y&&(R=Math.min(R,D)),b>w||b===w&&E>R?null:new T(b,E,w,R)}equalsRange(M){return T.equalsRange(this,M)}static equalsRange(M,A){return!M&&!A?!0:!!M&&!!A&&M.startLineNumber===A.startLineNumber&&M.startColumn===A.startColumn&&M.endLineNumber===A.endLineNumber&&M.endColumn===A.endColumn}getEndPosition(){return T.getEndPosition(this)}static getEndPosition(M){return new C.$ns(M.endLineNumber,M.endColumn)}getStartPosition(){return T.getStartPosition(this)}static getStartPosition(M){return new C.$ns(M.startLineNumber,M.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(M,A){return new T(this.startLineNumber,this.startColumn,M,A)}setStartPosition(M,A){return new T(M,A,this.endLineNumber,this.endColumn)}collapseToStart(){return T.collapseToStart(this)}static collapseToStart(M){return new T(M.startLineNumber,M.startColumn,M.startLineNumber,M.startColumn)}collapseToEnd(){return T.collapseToEnd(this)}static collapseToEnd(M){return new T(M.endLineNumber,M.endColumn,M.endLineNumber,M.endColumn)}delta(M){return new T(this.startLineNumber+M,this.startColumn,this.endLineNumber+M,this.endColumn)}static fromPositions(M,A=M){return new T(M.lineNumber,M.column,A.lineNumber,A.column)}static lift(M){return M?new T(M.startLineNumber,M.startColumn,M.endLineNumber,M.endColumn):null}static isIRange(M){return M&&typeof M.startLineNumber=="number"&&typeof M.startColumn=="number"&&typeof M.endLineNumber=="number"&&typeof M.endColumn=="number"}static areIntersectingOrTouching(M,A){return!(M.endLineNumber<A.startLineNumber||M.endLineNumber===A.startLineNumber&&M.endColumn<A.startColumn||A.endLineNumber<M.startLineNumber||A.endLineNumber===M.startLineNumber&&A.endColumn<M.startColumn)}static areIntersecting(M,A){return!(M.endLineNumber<A.startLineNumber||M.endLineNumber===A.startLineNumber&&M.endColumn<=A.startColumn||A.endLineNumber<M.startLineNumber||A.endLineNumber===M.startLineNumber&&A.endColumn<=M.startColumn)}static compareRangesUsingStarts(M,A){if(M&&A){const w=M.startLineNumber|0,R=A.startLineNumber|0;if(w===R){const I=M.startColumn|0,p=A.startColumn|0;if(I===p){const y=M.endLineNumber|0,D=A.endLineNumber|0;if(y===D){const v=M.endColumn|0,l=A.endColumn|0;return v-l}return y-D}return I-p}return w-R}return(M?1:0)-(A?1:0)}static compareRangesUsingEnds(M,A){return M.endLineNumber===A.endLineNumber?M.endColumn===A.endColumn?M.startLineNumber===A.startLineNumber?M.startColumn-A.startColumn:M.startLineNumber-A.startLineNumber:M.endColumn-A.endColumn:M.endLineNumber-A.endLineNumber}static spansMultipleLines(M){return M.endLineNumber>M.startLineNumber}toJSON(){return this}}e.$os=T}),define(De[164],Ce([1,0,34]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ps=void 0;class T{static insert(M,A){return{range:new C.$os(M.lineNumber,M.column,M.lineNumber,M.column),text:A,forceMoveMarkers:!0}}static delete(M){return{range:M,text:null}}static replace(M,A){return{range:M,text:A}}static replaceMove(M,A){return{range:M,text:A,forceMoveMarkers:!0}}}e.$ps=T}),define(De[165],Ce([1,0,61,34]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qs=e.SelectionDirection=void 0;var d;(function(A){A[A.LTR=0]="LTR",A[A.RTL=1]="RTL"})(d||(e.SelectionDirection=d={}));class M extends T.$os{constructor(b,E,w,R){super(b,E,w,R),this.selectionStartLineNumber=b,this.selectionStartColumn=E,this.positionLineNumber=w,this.positionColumn=R}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(b){return M.selectionsEqual(this,b)}static selectionsEqual(b,E){return b.selectionStartLineNumber===E.selectionStartLineNumber&&b.selectionStartColumn===E.selectionStartColumn&&b.positionLineNumber===E.positionLineNumber&&b.positionColumn===E.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(b,E){return this.getDirection()===0?new M(this.startLineNumber,this.startColumn,b,E):new M(b,E,this.startLineNumber,this.startColumn)}getPosition(){return new C.$ns(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new C.$ns(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(b,E){return this.getDirection()===0?new M(b,E,this.endLineNumber,this.endColumn):new M(this.endLineNumber,this.endColumn,b,E)}static fromPositions(b,E=b){return new M(b.lineNumber,b.column,E.lineNumber,E.column)}static fromRange(b,E){return E===0?new M(b.startLineNumber,b.startColumn,b.endLineNumber,b.endColumn):new M(b.endLineNumber,b.endColumn,b.startLineNumber,b.startColumn)}static liftSelection(b){return new M(b.selectionStartLineNumber,b.selectionStartColumn,b.positionLineNumber,b.positionColumn)}static selectionsArrEqual(b,E){if(b&&!E||!b&&E)return!1;if(!b&&!E)return!0;if(b.length!==E.length)return!1;for(let w=0,R=b.length;w<R;w++)if(!this.selectionsEqual(b[w],E[w]))return!1;return!0}static isISelection(b){return b&&typeof b.selectionStartLineNumber=="number"&&typeof b.selectionStartColumn=="number"&&typeof b.positionLineNumber=="number"&&typeof b.positionColumn=="number"}static createWithDirection(b,E,w,R,I){return I===0?new M(b,E,w,R):new M(w,R,b,E)}}e.$qs=M}),define(De[166],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yr=void 0,e.$Yr={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(De[167],Ce([1,0,123]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Os=e.$Ns=e.WordCharacterClass=void 0;var T;(function(A){A[A.Regular=0]="Regular",A[A.Whitespace=1]="Whitespace",A[A.WordSeparator=2]="WordSeparator"})(T||(e.WordCharacterClass=T={}));class d extends C.$Ls{constructor(b){super(0);for(let E=0,w=b.length;E<w;E++)this.set(b.charCodeAt(E),2);this.set(32,1),this.set(9,1)}}e.$Ns=d;function M(A){const b={};return E=>(b.hasOwnProperty(E)||(b[E]=A(E)),b[E])}e.$Os=M(A=>new d(A))}),define(De[124],Ce([1,0,50,3,75]),function(me,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4r=e.$3r=e.$2r=e.$1r=e.$Zr=void 0,e.$Zr="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function M(I=""){let p="(-?\\d*\\.\\d\\w*)|([^";for(const y of e.$Zr)I.indexOf(y)>=0||(p+="\\"+y);return p+="\\s]+)",new RegExp(p,"g")}e.$1r=M();function A(I){let p=e.$1r;if(I&&I instanceof RegExp)if(I.global)p=I;else{let y="g";I.ignoreCase&&(y+="i"),I.multiline&&(y+="m"),I.unicode&&(y+="u"),p=new RegExp(I.source,y)}return p.lastIndex=0,p}e.$2r=A;const b=new d.$1c;b.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function E(I){const p=b.unshift(I);return(0,T.$Pc)(p)}e.$3r=E;function w(I,p,y,D,v){if(v||(v=C.Iterable.first(b)),y.length>v.maxLen){let m=I-v.maxLen/2;return m<0?m=0:D+=m,y=y.substring(m,I+v.maxLen/2),w(I,p,y,D,v)}const l=Date.now(),s=I-1-D;let r=-1,c=null;for(let m=1;!(Date.now()-l>=v.timeBudget);m++){const h=s-v.windowSize*m;p.lastIndex=Math.max(0,h);const t=R(p,y,s,r);if(!t&&c||(c=t,h<=0))break;r=h}if(c){const m={word:c[0],startColumn:D+1+c.index,endColumn:D+1+c.index+c[0].length};return p.lastIndex=0,m}return null}e.$4r=w;function R(I,p,y,D){let v;for(;v=I.exec(p);){const l=v.index||0;if(l<=y&&I.lastIndex>=y)return v;if(D>0&&l>D)return null}return null}}),define(De[168],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lt=e.$kt=e.IndentAction=void 0;var C;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(C||(e.IndentAction=C={}));class T{constructor(b){if(this.e=null,this.f=!1,this.open=b.open,this.close=b.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(b.notIn))for(let E=0,w=b.notIn.length;E<w;E++)switch(b.notIn[E]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(b){switch(b){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(b,E){if(b.getTokenCount()===0)return!0;const w=b.findTokenIndexAtOffset(E-2),R=b.getStandardTokenType(w);return this.isOK(R)}g(b,E){for(let w=b;w<=E;w++){const R=String.fromCharCode(w);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$kt=T;class d{constructor(b){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const E of b)M(this.autoClosingPairsOpenByStart,E.open.charAt(0),E),M(this.autoClosingPairsOpenByEnd,E.open.charAt(E.open.length-1),E),M(this.autoClosingPairsCloseByStart,E.close.charAt(0),E),M(this.autoClosingPairsCloseByEnd,E.close.charAt(E.close.length-1),E),E.close.length===1&&E.open.length===1&&M(this.autoClosingPairsCloseSingleChar,E.close,E)}}e.$lt=d;function M(A,b,E){A.has(b)?A.get(b).push(E):A.set(b,[E])}}),define(De[169],Ce([1,0,123]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UY=e.$TY=e.$SY=e.State=void 0;var T;(function(y){y[y.Invalid=0]="Invalid",y[y.Start=1]="Start",y[y.H=2]="H",y[y.HT=3]="HT",y[y.HTT=4]="HTT",y[y.HTTP=5]="HTTP",y[y.F=6]="F",y[y.FI=7]="FI",y[y.FIL=8]="FIL",y[y.BeforeColon=9]="BeforeColon",y[y.AfterColon=10]="AfterColon",y[y.AlmostThere=11]="AlmostThere",y[y.End=12]="End",y[y.Accept=13]="Accept",y[y.LastKnownState=14]="LastKnownState"})(T||(e.State=T={}));class d{constructor(D,v,l){const s=new Uint8Array(D*v);for(let r=0,c=D*v;r<c;r++)s[r]=l;this.a=s,this.rows=D,this.cols=v}get(D,v){return this.a[D*this.cols+v]}set(D,v,l){this.a[D*this.cols+v]=l}}class M{constructor(D){let v=0,l=0;for(let r=0,c=D.length;r<c;r++){const[m,h,t]=D[r];h>v&&(v=h),m>l&&(l=m),t>l&&(l=t)}v++,l++;const s=new d(l,v,0);for(let r=0,c=D.length;r<c;r++){const[m,h,t]=D[r];s.set(m,h,t)}this.a=s,this.b=v}nextState(D,v){return v<0||v>=this.b?0:this.a.get(D,v)}}e.$SY=M;let A=null;function b(){return A===null&&(A=new M([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),A}var E;(function(y){y[y.None=0]="None",y[y.ForceTermination=1]="ForceTermination",y[y.CannotEndIn=2]="CannotEndIn"})(E||(E={}));let w=null;function R(){if(w===null){w=new C.$Ls(0);const y=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let v=0;v<y.length;v++)w.set(y.charCodeAt(v),1);const D=".,;:";for(let v=0;v<D.length;v++)w.set(D.charCodeAt(v),2)}return w}class I{static a(D,v,l,s,r){let c=r-1;do{const m=v.charCodeAt(c);if(D.get(m)!==2)break;c--}while(c>s);if(s>0){const m=v.charCodeAt(s-1),h=v.charCodeAt(c);(m===40&&h===41||m===91&&h===93||m===123&&h===125)&&c--}return{range:{startLineNumber:l,startColumn:s+1,endLineNumber:l,endColumn:c+2},url:v.substring(s,c+1)}}static computeLinks(D,v=b()){const l=R(),s=[];for(let r=1,c=D.getLineCount();r<=c;r++){const m=D.getLineContent(r),h=m.length;let t=0,n=0,o=0,i=1,a=!1,u=!1,k=!1,S=!1;for(;t<h;){let $=!1;const g=m.charCodeAt(t);if(i===13){let f;switch(g){case 40:a=!0,f=0;break;case 41:f=a?0:1;break;case 91:k=!0,u=!0,f=0;break;case 93:k=!1,f=u?0:1;break;case 123:S=!0,f=0;break;case 125:f=S?0:1;break;case 39:case 34:case 96:o===g?f=1:o===39||o===34||o===96?f=0:f=1;break;case 42:f=o===42?1:0;break;case 124:f=o===124?1:0;break;case 32:f=k?0:1;break;default:f=l.get(g)}f===1&&(s.push(I.a(l,m,r,n,t)),$=!0)}else if(i===12){let f;g===91?(u=!0,f=0):f=l.get(g),f===1?$=!0:i=13}else i=v.nextState(i,g),i===0&&($=!0);$&&(i=1,a=!1,u=!1,S=!1,n=t+1,o=g),t++}i===13&&s.push(I.a(l,m,r,n,h))}return s}}e.$TY=I;function p(y){return!y||typeof y.getLineCount!="function"||typeof y.getLineContent!="function"?[]:I.computeLinks(y)}e.$UY=p}),define(De[125],Ce([1,0,23]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ku=e.$Ju=e.$Iu=e.$Hu=e.ModelConstants=e.PositionAffinity=e.$Gu=e.TrackedRangeStickiness=e.$Fu=e.$Eu=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0;var T;(function(m){m[m.Left=1]="Left",m[m.Center=2]="Center",m[m.Right=4]="Right",m[m.Full=7]="Full"})(T||(e.OverviewRulerLane=T={}));var d;(function(m){m[m.Left=1]="Left",m[m.Right=2]="Right"})(d||(e.GlyphMarginLane=d={}));var M;(function(m){m[m.Inline=1]="Inline",m[m.Gutter=2]="Gutter"})(M||(e.MinimapPosition=M={}));var A;(function(m){m[m.Both=0]="Both",m[m.Right=1]="Right",m[m.Left=2]="Left",m[m.None=3]="None"})(A||(e.InjectedTextCursorStops=A={}));var b;(function(m){m[m.TextDefined=0]="TextDefined",m[m.LF=1]="LF",m[m.CRLF=2]="CRLF"})(b||(e.EndOfLinePreference=b={}));var E;(function(m){m[m.LF=1]="LF",m[m.CRLF=2]="CRLF"})(E||(e.DefaultEndOfLine=E={}));var w;(function(m){m[m.LF=0]="LF",m[m.CRLF=1]="CRLF"})(w||(e.EndOfLineSequence=w={}));class R{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(h){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,h.tabSize|0),h.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,h.indentSize|0),this.a=!1),this.insertSpaces=!!h.insertSpaces,this.defaultEOL=h.defaultEOL|0,this.trimAutoWhitespace=!!h.trimAutoWhitespace,this.bracketPairColorizationOptions=h.bracketPairColorizationOptions}equals(h){return this.tabSize===h.tabSize&&this.a===h.a&&this.indentSize===h.indentSize&&this.insertSpaces===h.insertSpaces&&this.defaultEOL===h.defaultEOL&&this.trimAutoWhitespace===h.trimAutoWhitespace&&(0,C.$6m)(this.bracketPairColorizationOptions,h.bracketPairColorizationOptions)}createChangeEvent(h){return{tabSize:this.tabSize!==h.tabSize,indentSize:this.indentSize!==h.indentSize,insertSpaces:this.insertSpaces!==h.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==h.trimAutoWhitespace}}}e.$Eu=R;class I{constructor(h,t){this._findMatchBrand=void 0,this.range=h,this.matches=t}}e.$Fu=I;var p;(function(m){m[m.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",m[m.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",m[m.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",m[m.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(p||(e.TrackedRangeStickiness=p={}));function y(m){return m&&typeof m.read=="function"}e.$Gu=y;var D;(function(m){m[m.Left=0]="Left",m[m.Right=1]="Right",m[m.None=2]="None",m[m.LeftOfInjectedText=3]="LeftOfInjectedText",m[m.RightOfInjectedText=4]="RightOfInjectedText"})(D||(e.PositionAffinity=D={}));var v;(function(m){m[m.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(v||(e.ModelConstants=v={}));class l{constructor(h,t,n,o,i,a){this.identifier=h,this.range=t,this.text=n,this.forceMoveMarkers=o,this.isAutoWhitespaceEdit=i,this._isTracked=a}}e.$Hu=l;class s{constructor(h,t,n){this.regex=h,this.wordSeparators=t,this.simpleSearch=n}}e.$Iu=s;class r{constructor(h,t,n){this.reverseEdits=h,this.changes=t,this.trimAutoWhitespaceLineNumbers=n}}e.$Ju=r;function c(m){return!m.isTooLargeForSyncing()&&!m.isForSimpleWidget}e.$Ku=c}),define(De[170],Ce([1,0,19,122]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pu=e.$Ou=e.$Nu=void 0;class d{constructor(E){this.a=E,this.b=new Uint32Array(E.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(E,w){E=(0,T.$ze)(E);const R=this.a,I=this.b,p=w.length;return p===0?!1:(this.a=new Uint32Array(R.length+p),this.a.set(R.subarray(0,E),0),this.a.set(R.subarray(E),E+p),this.a.set(w,E),E-1<this.c[0]&&(this.c[0]=E-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(I.subarray(0,this.c[0]+1)),!0)}setValue(E,w){return E=(0,T.$ze)(E),w=(0,T.$ze)(w),this.a[E]===w?!1:(this.a[E]=w,E-1<this.c[0]&&(this.c[0]=E-1),!0)}removeValues(E,w){E=(0,T.$ze)(E),w=(0,T.$ze)(w);const R=this.a,I=this.b;if(E>=R.length)return!1;const p=R.length-E;return w>=p&&(w=p),w===0?!1:(this.a=new Uint32Array(R.length-w),this.a.set(R.subarray(0,E),0),this.a.set(R.subarray(E+w),E),this.b=new Uint32Array(this.a.length),E-1<this.c[0]&&(this.c[0]=E-1),this.c[0]>=0&&this.b.set(I.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(E){return E<0?0:(E=(0,T.$ze)(E),this.d(E))}d(E){if(E<=this.c[0])return this.b[E];let w=this.c[0]+1;w===0&&(this.b[0]=this.a[0],w++),E>=this.a.length&&(E=this.a.length-1);for(let R=w;R<=E;R++)this.b[R]=this.b[R-1]+this.a[R];return this.c[0]=Math.max(this.c[0],E),this.b[E]}getIndexOf(E){E=Math.floor(E),this.getTotalSum();let w=0,R=this.a.length-1,I=0,p=0,y=0;for(;w<=R;)if(I=w+(R-w)/2|0,p=this.b[I],y=p-this.a[I],E<y)R=I-1;else if(E>=p)w=I+1;else break;return new A(I,E-y)}}e.$Nu=d;class M{constructor(E){this.a=E,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(E){return this.g(),E===0?0:this.d[E-1]}getIndexOf(E){this.g();const w=this.e[E],R=w>0?this.d[w-1]:0;return new A(w,E-R)}removeValues(E,w){this.a.splice(E,w),this.f(E)}insertValues(E,w){this.a=(0,C.$Vb)(this.a,E,w),this.f(E)}f(E){this.b=!1,this.c=Math.min(this.c,E-1)}g(){if(!this.b){for(let E=this.c+1,w=this.a.length;E<w;E++){const R=this.a[E],I=E>0?this.d[E-1]:0;this.d[E]=I+R;for(let p=0;p<R;p++)this.e[I+p]=E}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(E,w){this.a[E]!==w&&(this.a[E]=w,this.f(E))}}e.$Ou=M;class A{constructor(E,w){this.index=E,this.remainder=w,this._prefixSumIndexOfResultBrand=void 0,this.index=E,this.remainder=w}}e.$Pu=A}),define(De[171],Ce([1,0,15,61,170]),function(me,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qu=void 0;class M{constructor(b,E,w,R){this.d=b,this.f=E,this.g=w,this.h=R,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(b){b.eol&&b.eol!==this.g&&(this.g=b.eol,this.j=null);const E=b.changes;for(const w of E)this.o(w.range),this.p(new T.$ns(w.range.startLineNumber,w.range.startColumn),w.text);this.h=b.versionId,this.k=null}l(){if(!this.j){const b=this.g.length,E=this.f.length,w=new Uint32Array(E);for(let R=0;R<E;R++)w[R]=this.f[R].length+b;this.j=new d.$Nu(w)}}n(b,E){this.f[b]=E,this.j&&this.j.setValue(b,this.f[b].length+this.g.length)}o(b){if(b.startLineNumber===b.endLineNumber){if(b.startColumn===b.endColumn)return;this.n(b.startLineNumber-1,this.f[b.startLineNumber-1].substring(0,b.startColumn-1)+this.f[b.startLineNumber-1].substring(b.endColumn-1));return}this.n(b.startLineNumber-1,this.f[b.startLineNumber-1].substring(0,b.startColumn-1)+this.f[b.endLineNumber-1].substring(b.endColumn-1)),this.f.splice(b.startLineNumber,b.endLineNumber-b.startLineNumber),this.j&&this.j.removeValues(b.startLineNumber,b.endLineNumber-b.startLineNumber)}p(b,E){if(E.length===0)return;const w=(0,C.$Oe)(E);if(w.length===1){this.n(b.lineNumber-1,this.f[b.lineNumber-1].substring(0,b.column-1)+w[0]+this.f[b.lineNumber-1].substring(b.column-1));return}w[w.length-1]+=this.f[b.lineNumber-1].substring(b.column-1),this.n(b.lineNumber-1,this.f[b.lineNumber-1].substring(0,b.column-1)+w[0]);const R=new Uint32Array(w.length-1);for(let I=1;I<w.length;I++)this.f.splice(b.lineNumber+I-1,0,w[I]),R[I-1]=w[I].length+this.g.length;this.j&&this.j.insertValues(b.lineNumber,R)}}e.$Qu=M}),define(De[172],Ce([1,0,15,167,61,34,125]),function(me,e,C,T,d,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sB=e.$rB=e.$qB=e.$pB=e.$oB=e.$nB=void 0;const b=999;class E{constructor(r,c,m,h){this.searchString=r,this.isRegex=c,this.matchCase=m,this.wordSeparators=h}parseSearchRequest(){if(this.searchString==="")return null;let r;this.isRegex?r=w(this.searchString):r=this.searchString.indexOf(`
`)>=0;let c=null;try{c=C.$Me(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:r,global:!0,unicode:!0})}catch{return null}if(!c)return null;let m=!this.isRegex&&!r;return m&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(m=this.matchCase),new A.$Iu(c,this.wordSeparators?(0,T.$Os)(this.wordSeparators):null,m?this.searchString:null)}}e.$nB=E;function w(s){if(!s||s.length===0)return!1;for(let r=0,c=s.length;r<c;r++){const m=s.charCodeAt(r);if(m===10)return!0;if(m===92){if(r++,r>=c)break;const h=s.charCodeAt(r);if(h===110||h===114||h===87)return!0}}return!1}e.$oB=w;function R(s,r,c){if(!c)return new A.$Fu(s,null);const m=[];for(let h=0,t=r.length;h<t;h++)m[h]=r[h];return new A.$Fu(s,m)}e.$pB=R;class I{constructor(r){const c=[];let m=0;for(let h=0,t=r.length;h<t;h++)r.charCodeAt(h)===10&&(c[m++]=h);this.a=c}findLineFeedCountBeforeOffset(r){const c=this.a;let m=0,h=c.length-1;if(h===-1||r<=c[0])return 0;for(;m<h;){const t=m+((h-m)/2>>0);c[t]>=r?h=t-1:c[t+1]>=r?(m=t,h=t):m=t+1}return m+1}}class p{static findMatches(r,c,m,h,t){const n=c.parseSearchRequest();return n?n.regex.multiline?this.b(r,m,new l(n.wordSeparators,n.regex),h,t):this.c(r,m,n,h,t):[]}static a(r,c,m,h,t,n){let o,i=0;h?(i=h.findLineFeedCountBeforeOffset(t),o=c+t+i):o=c+t;let a;if(h){const $=h.findLineFeedCountBeforeOffset(t+n.length)-i;a=o+n.length+$}else a=o+n.length;const u=r.getPositionAt(o),k=r.getPositionAt(a);return new M.$os(u.lineNumber,u.column,k.lineNumber,k.column)}static b(r,c,m,h,t){const n=r.getOffsetAt(c.getStartPosition()),o=r.getValueInRange(c,1),i=r.getEOL()===`\r
`?new I(o):null,a=[];let u=0,k;for(m.reset(0);k=m.next(o);)if(a[u++]=R(this.a(r,n,o,i,k.index,k[0]),k,h),u>=t)return a;return a}static c(r,c,m,h,t){const n=[];let o=0;if(c.startLineNumber===c.endLineNumber){const a=r.getLineContent(c.startLineNumber).substring(c.startColumn-1,c.endColumn-1);return o=this.d(m,a,c.startLineNumber,c.startColumn-1,o,n,h,t),n}const i=r.getLineContent(c.startLineNumber).substring(c.startColumn-1);o=this.d(m,i,c.startLineNumber,c.startColumn-1,o,n,h,t);for(let a=c.startLineNumber+1;a<c.endLineNumber&&o<t;a++)o=this.d(m,r.getLineContent(a),a,0,o,n,h,t);if(o<t){const a=r.getLineContent(c.endLineNumber).substring(0,c.endColumn-1);o=this.d(m,a,c.endLineNumber,0,o,n,h,t)}return n}static d(r,c,m,h,t,n,o,i){const a=r.wordSeparators;if(!o&&r.simpleSearch){const S=r.simpleSearch,$=S.length,g=c.length;let f=-$;for(;(f=c.indexOf(S,f+$))!==-1;)if((!a||v(a,c,g,f,$))&&(n[t++]=new A.$Fu(new M.$os(m,f+1+h,m,f+1+$+h),null),t>=i))return t;return t}const u=new l(r.wordSeparators,r.regex);let k;u.reset(0);do if(k=u.next(c),k&&(n[t++]=R(new M.$os(m,k.index+1+h,m,k.index+1+k[0].length+h),k,o),t>=i))return t;while(k);return t}static findNextMatch(r,c,m,h){const t=c.parseSearchRequest();if(!t)return null;const n=new l(t.wordSeparators,t.regex);return t.regex.multiline?this.e(r,m,n,h):this.f(r,m,n,h)}static e(r,c,m,h){const t=new d.$ns(c.lineNumber,1),n=r.getOffsetAt(t),o=r.getLineCount(),i=r.getValueInRange(new M.$os(t.lineNumber,t.column,o,r.getLineMaxColumn(o)),1),a=r.getEOL()===`\r
`?new I(i):null;m.reset(c.column-1);const u=m.next(i);return u?R(this.a(r,n,i,a,u.index,u[0]),u,h):c.lineNumber!==1||c.column!==1?this.e(r,new d.$ns(1,1),m,h):null}static f(r,c,m,h){const t=r.getLineCount(),n=c.lineNumber,o=r.getLineContent(n),i=this.g(m,o,n,c.column,h);if(i)return i;for(let a=1;a<=t;a++){const u=(n+a-1)%t,k=r.getLineContent(u+1),S=this.g(m,k,u+1,1,h);if(S)return S}return null}static g(r,c,m,h,t){r.reset(h-1);const n=r.next(c);return n?R(new M.$os(m,n.index+1,m,n.index+1+n[0].length),n,t):null}static findPreviousMatch(r,c,m,h){const t=c.parseSearchRequest();if(!t)return null;const n=new l(t.wordSeparators,t.regex);return t.regex.multiline?this.h(r,m,n,h):this.j(r,m,n,h)}static h(r,c,m,h){const t=this.b(r,new M.$os(1,1,c.lineNumber,c.column),m,h,10*b);if(t.length>0)return t[t.length-1];const n=r.getLineCount();return c.lineNumber!==n||c.column!==r.getLineMaxColumn(n)?this.h(r,new d.$ns(n,r.getLineMaxColumn(n)),m,h):null}static j(r,c,m,h){const t=r.getLineCount(),n=c.lineNumber,o=r.getLineContent(n).substring(0,c.column-1),i=this.k(m,o,n,h);if(i)return i;for(let a=1;a<=t;a++){const u=(t+n-a-1)%t,k=r.getLineContent(u+1),S=this.k(m,k,u+1,h);if(S)return S}return null}static k(r,c,m,h){let t=null,n;for(r.reset(0);n=r.next(c);)t=R(new M.$os(m,n.index+1,m,n.index+1+n[0].length),n,h);return t}}e.$qB=p;function y(s,r,c,m,h){if(m===0)return!0;const t=r.charCodeAt(m-1);if(s.get(t)!==0||t===13||t===10)return!0;if(h>0){const n=r.charCodeAt(m);if(s.get(n)!==0)return!0}return!1}function D(s,r,c,m,h){if(m+h===c)return!0;const t=r.charCodeAt(m+h);if(s.get(t)!==0||t===13||t===10)return!0;if(h>0){const n=r.charCodeAt(m+h-1);if(s.get(n)!==0)return!0}return!1}function v(s,r,c,m,h){return y(s,r,c,m,h)&&D(s,r,c,m,h)}e.$rB=v;class l{constructor(r,c){this._wordSeparators=r,this.a=c,this.b=-1,this.c=0}reset(r){this.a.lastIndex=r,this.b=-1,this.c=0}next(r){const c=r.length;let m;do{if(this.b+this.c===c||(m=this.a.exec(r),!m))return null;const h=m.index,t=m[0].length;if(h===this.b&&t===this.c){if(t===0){C.$8e(r,c,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=h,this.c=t,!this._wordSeparators||v(this._wordSeparators,r,c,h,t))return m}while(m);return null}}e.$sB=l}),define(De[173],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G7=e.$F7=void 0;class C{constructor(){this.a=new Map}removeDragOperationTransfer(M){if(M&&this.a.has(M)){const A=this.a.get(M);return this.a.delete(M),A}}addDragOperationTransfer(M,A){this.a.set(M,A)}}e.$F7=C;class T{constructor(M){this.identifier=M}}e.$G7=T}),define(De[174],Ce([1,0,4,3]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zs=void 0;class d{constructor(){this.a=new Map,this.b=new Map,this.c=new C.$Md,this.onDidChange=this.c.event,this.d=null}handleChange(b){this.c.fire({changedLanguages:b,changedColorMap:!1})}register(b,E){return this.a.set(b,E),this.handleChange([b]),(0,T.$Pc)(()=>{this.a.get(b)===E&&(this.a.delete(b),this.handleChange([b]))})}get(b){return this.a.get(b)||null}registerFactory(b,E){this.b.get(b)?.dispose();const w=new M(this,b,E);return this.b.set(b,w),(0,T.$Pc)(()=>{const R=this.b.get(b);!R||R!==w||(this.b.delete(b),R.dispose())})}async getOrCreate(b){const E=this.get(b);if(E)return E;const w=this.b.get(b);return!w||w.isResolved?null:(await w.resolve(),this.get(b))}isResolved(b){if(this.get(b))return!0;const w=this.b.get(b);return!!(!w||w.isResolved)}setColorMap(b){this.d=b,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$Zs=d;class M extends T.$Rc{get isResolved(){return this.c}constructor(b,E,w){super(),this.f=b,this.g=E,this.h=w,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const b=await this.h.tokenizationSupport;this.c=!0,b&&!this.a&&this.B(this.f.register(this.g,b))}}}),define(De[175],Ce([10,11]),function(me,e){return me.create("vs/base/common/actions",e)}),define(De[176],Ce([1,0,4,3,175]),function(me,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=void 0;class M extends T.$Rc{constructor(p,y="",D="",v=!0,l){super(),this.h=this.B(new C.$Md),this.onDidChange=this.h.event,this.w=!0,this.j=p,this.m=y,this.u=D,this.w=v,this.C=l}get id(){return this.j}get label(){return this.m}set label(p){this.D(p)}D(p){this.m!==p&&(this.m=p,this.h.fire({label:p}))}get tooltip(){return this.n||""}set tooltip(p){this.F(p)}F(p){this.n!==p&&(this.n=p,this.h.fire({tooltip:p}))}get class(){return this.u}set class(p){this.G(p)}G(p){this.u!==p&&(this.u=p,this.h.fire({class:p}))}get enabled(){return this.w}set enabled(p){this.H(p)}H(p){this.w!==p&&(this.w=p,this.h.fire({enabled:p}))}get checked(){return this.z}set checked(p){this.I(p)}I(p){this.z!==p&&(this.z=p,this.h.fire({checked:p}))}async run(p,y){this.C&&await this.C(p)}}e.$si=M;class A extends T.$Rc{constructor(){super(...arguments),this.f=this.B(new C.$Md),this.onWillRun=this.f.event,this.m=this.B(new C.$Md),this.onDidRun=this.m.event}async run(p,y){if(!p.enabled)return;this.f.fire({action:p});let D;try{await this.u(p,y)}catch(v){D=v}this.m.fire({action:p,error:D})}async u(p,y){await p.run(y)}}e.$ti=A;class b{constructor(){this.id=b.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...p){let y=[];for(const D of p)D.length&&(y.length?y=[...y,new b,...D]:y=D);return y}static{this.ID="vs.actions.separator"}async run(){}}e.$ui=b;class E{get actions(){return this.a}constructor(p,y,D,v){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=p,this.label=y,this.class=v,this.a=D}async run(){}}e.$vi=E;class w extends M{static{this.ID="vs.actions.empty"}constructor(){super(w.ID,d.localize(0,null),void 0,!1)}}e.$wi=w;function R(I){return{id:I.id,label:I.label,class:void 0,enabled:I.enabled??!0,checked:I.checked??!1,run:async(...p)=>I.run(...p),tooltip:I.label}}e.$xi=R}),define(De[177],Ce([10,11]),function(me,e){return me.create("vs/base/common/date",e)}),define(De[178],Ce([1,0,177]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$am=e.$_l=void 0;const T=60,d=T*60,M=d*24,A=M*7,b=M*30,E=M*365;function w(I,p,y,D){typeof I!="number"&&(I=I.getTime());const v=Math.round((new Date().getTime()-I)/1e3);if(v<-30)return(0,C.localize)(0,null,w(new Date().getTime()+v*1e3,!1));if(!D&&v<30)return(0,C.localize)(1,null);let l;return v<T?(l=v,p?l===1?y?(0,C.localize)(2,null,l):(0,C.localize)(3,null,l):y?(0,C.localize)(4,null,l):(0,C.localize)(5,null,l):l===1?y?(0,C.localize)(6,null,l):(0,C.localize)(7,null,l):y?(0,C.localize)(8,null,l):(0,C.localize)(9,null,l)):v<d?(l=Math.floor(v/T),p?l===1?y?(0,C.localize)(10,null,l):(0,C.localize)(11,null,l):y?(0,C.localize)(12,null,l):(0,C.localize)(13,null,l):l===1?y?(0,C.localize)(14,null,l):(0,C.localize)(15,null,l):y?(0,C.localize)(16,null,l):(0,C.localize)(17,null,l)):v<M?(l=Math.floor(v/d),p?l===1?y?(0,C.localize)(18,null,l):(0,C.localize)(19,null,l):y?(0,C.localize)(20,null,l):(0,C.localize)(21,null,l):l===1?y?(0,C.localize)(22,null,l):(0,C.localize)(23,null,l):y?(0,C.localize)(24,null,l):(0,C.localize)(25,null,l)):v<A?(l=Math.floor(v/M),p?l===1?(0,C.localize)(26,null,l):(0,C.localize)(27,null,l):l===1?(0,C.localize)(28,null,l):(0,C.localize)(29,null,l)):v<b?(l=Math.floor(v/A),p?l===1?y?(0,C.localize)(30,null,l):(0,C.localize)(31,null,l):y?(0,C.localize)(32,null,l):(0,C.localize)(33,null,l):l===1?y?(0,C.localize)(34,null,l):(0,C.localize)(35,null,l):y?(0,C.localize)(36,null,l):(0,C.localize)(37,null,l)):v<E?(l=Math.floor(v/b),p?l===1?y?(0,C.localize)(38,null,l):(0,C.localize)(39,null,l):y?(0,C.localize)(40,null,l):(0,C.localize)(41,null,l):l===1?y?(0,C.localize)(42,null,l):(0,C.localize)(43,null,l):y?(0,C.localize)(44,null,l):(0,C.localize)(45,null,l)):(l=Math.floor(v/E),p?l===1?y?(0,C.localize)(46,null,l):(0,C.localize)(47,null,l):y?(0,C.localize)(48,null,l):(0,C.localize)(49,null,l):l===1?y?(0,C.localize)(50,null,l):(0,C.localize)(51,null,l):y?(0,C.localize)(52,null,l):(0,C.localize)(53,null,l))}e.$_l=w;function R(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$am=R}),define(De[179],Ce([10,11]),function(me,e){return me.create("vs/base/common/errorMessage",e)}),define(De[46],Ce([1,0,19,18,179]),function(me,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ai=e.$zi=e.$yi=void 0;function M(I,p){return p&&(I.stack||I.stacktrace)?d.localize(0,null,b(I),A(I.stack)||A(I.stacktrace)):b(I)}function A(I){return Array.isArray(I)?I.join(`
`):I}function b(I){return I.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${I.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?d.localize(1,null,I.message):I.message||d.localize(2,null)}function E(I=null,p=!1){if(!I)return d.localize(3,null);if(Array.isArray(I)){const y=C.$Gb(I),D=E(y[0],p);return y.length>1?d.localize(4,null,D,y.length):D}if(T.$xf(I))return I;if(I.detail){const y=I.detail;if(y.error)return M(y.error,p);if(y.exception)return M(y.exception,p)}return I.stack?M(I,p):I.message?I.message:d.localize(5,null)}e.$yi=E;function w(I){const p=I;return p instanceof Error&&Array.isArray(p.actions)}e.$zi=w;function R(I,p){let y;return typeof I=="string"?y=new Error(I):y=I,y.actions=p,y}e.$Ai=R}),define(De[180],Ce([10,11]),function(me,e){return me.create("vs/base/common/platform",e)}),define(De[12],Ce([1,0,180]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$h=e.$g=void 0,e.$g="en";let T=!1,d=!1,M=!1,A=!1,b=!1,E=!1,w=!1,R=!1,I=!1,p=!1,y,D=e.$g,v=e.$g,l,s;e.$h=typeof self=="object"?self:typeof global=="object"?global:{};let r;typeof e.$h.vscode<"u"&&typeof e.$h.vscode.process<"u"?r=e.$h.vscode.process:typeof process<"u"&&(r=process);const c=typeof r?.versions?.electron=="string",m=c&&r?.type==="renderer";if(typeof navigator=="object"&&!m)s=navigator.userAgent,T=s.indexOf("Windows")>=0,d=s.indexOf("Macintosh")>=0,R=(s.indexOf("Macintosh")>=0||s.indexOf("iPad")>=0||s.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,M=s.indexOf("Linux")>=0,p=s?.indexOf("Mobi")>=0,E=!0,y=C.getConfiguredDefaultLocale(C.localize(0,null))||e.$g,D=y,v=navigator.language;else if(typeof r=="object"){T=r.platform==="win32",d=r.platform==="darwin",M=r.platform==="linux",A=M&&!!r.env.SNAP&&!!r.env.SNAP_REVISION,w=c,I=!!r.env.CI||!!r.env.BUILD_ARTIFACTSTAGINGDIRECTORY,y=e.$g,D=e.$g;const S=r.env.VSCODE_NLS_CONFIG;if(S)try{const $=JSON.parse(S),g=$.availableLanguages["*"];y=$.locale,v=$.osLocale,D=g||e.$g,l=$._translationsConfigFile}catch{}b=!0}else console.error("Unable to resolve platform.");var h;(function(S){S[S.Web=0]="Web",S[S.Mac=1]="Mac",S[S.Linux=2]="Linux",S[S.Windows=3]="Windows"})(h||(e.Platform=h={}));function t(S){switch(S){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$i=t;let n=0;d?n=1:T?n=3:M&&(n=2),e.$j=T,e.$k=d,e.$l=M,e.$m=A,e.$n=b,e.$o=w,e.$p=E,e.$q=E&&typeof e.$h.importScripts=="function",e.$r=R,e.$s=p,e.$t=I,e.$u=n,e.$v=s,e.$w=D;var o;(function(S){function $(){return e.$w}S.value=$;function g(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}S.isDefaultVariant=g;function f(){return e.$w==="en"}S.isDefault=f})(o||(e.Language=o={})),e.$x=y,e.$y=v,e.$z=l,e.$A=typeof e.$h.postMessage=="function"&&!e.$h.importScripts,e.$B=(()=>{if(e.$A){const S=[];e.$h.addEventListener("message",g=>{if(g.data&&g.data.vscodeScheduleAsyncWork)for(let f=0,P=S.length;f<P;f++){const N=S[f];if(N.id===g.data.vscodeScheduleAsyncWork){S.splice(f,1),N.callback();return}}});let $=0;return g=>{const f=++$;S.push({id:f,callback:g}),e.$h.postMessage({vscodeScheduleAsyncWork:f},"*")}}return S=>setTimeout(S)})();var i;(function(S){S[S.Windows=1]="Windows",S[S.Macintosh=2]="Macintosh",S[S.Linux=3]="Linux"})(i||(e.OperatingSystem=i={})),e.OS=d||R?2:T?1:3;let a=!0,u=!1;function k(){if(!u){u=!0;const S=new Uint8Array(2);S[0]=1,S[1]=2,a=new Uint16Array(S.buffer)[0]===(2<<8)+1}return a}e.$D=k,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0)}),define(De[47],Ce([1,0,12]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dc=e.$cc=e.env=e.cwd=void 0;let T;if(typeof C.$h.vscode<"u"&&typeof C.$h.vscode.process<"u"){const d=C.$h.vscode.process;T={get platform(){return d.platform},get arch(){return d.arch},get env(){return d.env},cwd(){return d.cwd()}}}else typeof process<"u"?T={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:T={get platform(){return C.$j?"win32":C.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=T.cwd,e.env=T.env,e.$cc=T.platform,e.$dc=T.arch}),define(De[16],Ce([1,0,47]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sc=e.sep=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=e.$ec=void 0;const T=65,d=97,M=90,A=122,b=46,E=47,w=92,R=58,I=63;class p extends Error{constructor(n,o,i){let a;typeof o=="string"&&o.indexOf("not ")===0?(a="must not be",o=o.replace(/^not /,"")):a="must be";const u=n.indexOf(".")!==-1?"property":"argument";let k=`The "${n}" ${u} ${a} of type ${o}`;k+=`. Received type ${typeof i}`,super(k),this.code="ERR_INVALID_ARG_TYPE"}}function y(t,n){if(t===null||typeof t!="object")throw new p(n,"Object",t)}function D(t,n){if(typeof t!="string")throw new p(n,"string",t)}const v=C.$cc==="win32";function l(t){return t===E||t===w}function s(t){return t===E}function r(t){return t>=T&&t<=M||t>=d&&t<=A}function c(t,n,o,i){let a="",u=0,k=-1,S=0,$=0;for(let g=0;g<=t.length;++g){if(g<t.length)$=t.charCodeAt(g);else{if(i($))break;$=E}if(i($)){if(!(k===g-1||S===1))if(S===2){if(a.length<2||u!==2||a.charCodeAt(a.length-1)!==b||a.charCodeAt(a.length-2)!==b){if(a.length>2){const f=a.lastIndexOf(o);f===-1?(a="",u=0):(a=a.slice(0,f),u=a.length-1-a.lastIndexOf(o)),k=g,S=0;continue}else if(a.length!==0){a="",u=0,k=g,S=0;continue}}n&&(a+=a.length>0?`${o}..`:"..",u=2)}else a.length>0?a+=`${o}${t.slice(k+1,g)}`:a=t.slice(k+1,g),u=g-k-1;k=g,S=0}else $===b&&S!==-1?++S:S=-1}return a}function m(t,n){y(n,"pathObject");const o=n.dir||n.root,i=n.base||`${n.name||""}${n.ext||""}`;return o?o===n.root?`${o}${i}`:`${o}${t}${i}`:i}e.$ec={resolve(...t){let n="",o="",i=!1;for(let a=t.length-1;a>=-1;a--){let u;if(a>=0){if(u=t[a],D(u,"path"),u.length===0)continue}else n.length===0?u=C.cwd():(u=C.env[`=${n}`]||C.cwd(),(u===void 0||u.slice(0,2).toLowerCase()!==n.toLowerCase()&&u.charCodeAt(2)===w)&&(u=`${n}\\`));const k=u.length;let S=0,$="",g=!1;const f=u.charCodeAt(0);if(k===1)l(f)&&(S=1,g=!0);else if(l(f))if(g=!0,l(u.charCodeAt(1))){let P=2,N=P;for(;P<k&&!l(u.charCodeAt(P));)P++;if(P<k&&P!==N){const O=u.slice(N,P);for(N=P;P<k&&l(u.charCodeAt(P));)P++;if(P<k&&P!==N){for(N=P;P<k&&!l(u.charCodeAt(P));)P++;(P===k||P!==N)&&($=`\\\\${O}\\${u.slice(N,P)}`,S=P)}}}else S=1;else r(f)&&u.charCodeAt(1)===R&&($=u.slice(0,2),S=2,k>2&&l(u.charCodeAt(2))&&(g=!0,S=3));if($.length>0)if(n.length>0){if($.toLowerCase()!==n.toLowerCase())continue}else n=$;if(i){if(n.length>0)break}else if(o=`${u.slice(S)}\\${o}`,i=g,g&&n.length>0)break}return o=c(o,!i,"\\",l),i?`${n}\\${o}`:`${n}${o}`||"."},normalize(t){D(t,"path");const n=t.length;if(n===0)return".";let o=0,i,a=!1;const u=t.charCodeAt(0);if(n===1)return s(u)?"\\":t;if(l(u))if(a=!0,l(t.charCodeAt(1))){let S=2,$=S;for(;S<n&&!l(t.charCodeAt(S));)S++;if(S<n&&S!==$){const g=t.slice($,S);for($=S;S<n&&l(t.charCodeAt(S));)S++;if(S<n&&S!==$){for($=S;S<n&&!l(t.charCodeAt(S));)S++;if(S===n)return`\\\\${g}\\${t.slice($)}\\`;S!==$&&(i=`\\\\${g}\\${t.slice($,S)}`,o=S)}}}else o=1;else r(u)&&t.charCodeAt(1)===R&&(i=t.slice(0,2),o=2,n>2&&l(t.charCodeAt(2))&&(a=!0,o=3));let k=o<n?c(t.slice(o),!a,"\\",l):"";return k.length===0&&!a&&(k="."),k.length>0&&l(t.charCodeAt(n-1))&&(k+="\\"),i===void 0?a?`\\${k}`:k:a?`${i}\\${k}`:`${i}${k}`},isAbsolute(t){D(t,"path");const n=t.length;if(n===0)return!1;const o=t.charCodeAt(0);return l(o)||n>2&&r(o)&&t.charCodeAt(1)===R&&l(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let n,o;for(let u=0;u<t.length;++u){const k=t[u];D(k,"path"),k.length>0&&(n===void 0?n=o=k:n+=`\\${k}`)}if(n===void 0)return".";let i=!0,a=0;if(typeof o=="string"&&l(o.charCodeAt(0))){++a;const u=o.length;u>1&&l(o.charCodeAt(1))&&(++a,u>2&&(l(o.charCodeAt(2))?++a:i=!1))}if(i){for(;a<n.length&&l(n.charCodeAt(a));)a++;a>=2&&(n=`\\${n.slice(a)}`)}return e.$ec.normalize(n)},relative(t,n){if(D(t,"from"),D(n,"to"),t===n)return"";const o=e.$ec.resolve(t),i=e.$ec.resolve(n);if(o===i||(t=o.toLowerCase(),n=i.toLowerCase(),t===n))return"";let a=0;for(;a<t.length&&t.charCodeAt(a)===w;)a++;let u=t.length;for(;u-1>a&&t.charCodeAt(u-1)===w;)u--;const k=u-a;let S=0;for(;S<n.length&&n.charCodeAt(S)===w;)S++;let $=n.length;for(;$-1>S&&n.charCodeAt($-1)===w;)$--;const g=$-S,f=k<g?k:g;let P=-1,N=0;for(;N<f;N++){const L=t.charCodeAt(a+N);if(L!==n.charCodeAt(S+N))break;L===w&&(P=N)}if(N!==f){if(P===-1)return i}else{if(g>f){if(n.charCodeAt(S+N)===w)return i.slice(S+N+1);if(N===2)return i.slice(S+N)}k>f&&(t.charCodeAt(a+N)===w?P=N:N===2&&(P=3)),P===-1&&(P=0)}let O="";for(N=a+P+1;N<=u;++N)(N===u||t.charCodeAt(N)===w)&&(O+=O.length===0?"..":"\\..");return S+=P,O.length>0?`${O}${i.slice(S,$)}`:(i.charCodeAt(S)===w&&++S,i.slice(S,$))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const n=e.$ec.resolve(t);if(n.length<=2)return t;if(n.charCodeAt(0)===w){if(n.charCodeAt(1)===w){const o=n.charCodeAt(2);if(o!==I&&o!==b)return`\\\\?\\UNC\\${n.slice(2)}`}}else if(r(n.charCodeAt(0))&&n.charCodeAt(1)===R&&n.charCodeAt(2)===w)return`\\\\?\\${n}`;return t},dirname(t){D(t,"path");const n=t.length;if(n===0)return".";let o=-1,i=0;const a=t.charCodeAt(0);if(n===1)return l(a)?t:".";if(l(a)){if(o=i=1,l(t.charCodeAt(1))){let S=2,$=S;for(;S<n&&!l(t.charCodeAt(S));)S++;if(S<n&&S!==$){for($=S;S<n&&l(t.charCodeAt(S));)S++;if(S<n&&S!==$){for($=S;S<n&&!l(t.charCodeAt(S));)S++;if(S===n)return t;S!==$&&(o=i=S+1)}}}}else r(a)&&t.charCodeAt(1)===R&&(o=n>2&&l(t.charCodeAt(2))?3:2,i=o);let u=-1,k=!0;for(let S=n-1;S>=i;--S)if(l(t.charCodeAt(S))){if(!k){u=S;break}}else k=!1;if(u===-1){if(o===-1)return".";u=o}return t.slice(0,u)},basename(t,n){n!==void 0&&D(n,"ext"),D(t,"path");let o=0,i=-1,a=!0,u;if(t.length>=2&&r(t.charCodeAt(0))&&t.charCodeAt(1)===R&&(o=2),n!==void 0&&n.length>0&&n.length<=t.length){if(n===t)return"";let k=n.length-1,S=-1;for(u=t.length-1;u>=o;--u){const $=t.charCodeAt(u);if(l($)){if(!a){o=u+1;break}}else S===-1&&(a=!1,S=u+1),k>=0&&($===n.charCodeAt(k)?--k===-1&&(i=u):(k=-1,i=S))}return o===i?i=S:i===-1&&(i=t.length),t.slice(o,i)}for(u=t.length-1;u>=o;--u)if(l(t.charCodeAt(u))){if(!a){o=u+1;break}}else i===-1&&(a=!1,i=u+1);return i===-1?"":t.slice(o,i)},extname(t){D(t,"path");let n=0,o=-1,i=0,a=-1,u=!0,k=0;t.length>=2&&t.charCodeAt(1)===R&&r(t.charCodeAt(0))&&(n=i=2);for(let S=t.length-1;S>=n;--S){const $=t.charCodeAt(S);if(l($)){if(!u){i=S+1;break}continue}a===-1&&(u=!1,a=S+1),$===b?o===-1?o=S:k!==1&&(k=1):o!==-1&&(k=-1)}return o===-1||a===-1||k===0||k===1&&o===a-1&&o===i+1?"":t.slice(o,a)},format:m.bind(null,"\\"),parse(t){D(t,"path");const n={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return n;const o=t.length;let i=0,a=t.charCodeAt(0);if(o===1)return l(a)?(n.root=n.dir=t,n):(n.base=n.name=t,n);if(l(a)){if(i=1,l(t.charCodeAt(1))){let P=2,N=P;for(;P<o&&!l(t.charCodeAt(P));)P++;if(P<o&&P!==N){for(N=P;P<o&&l(t.charCodeAt(P));)P++;if(P<o&&P!==N){for(N=P;P<o&&!l(t.charCodeAt(P));)P++;P===o?i=P:P!==N&&(i=P+1)}}}}else if(r(a)&&t.charCodeAt(1)===R){if(o<=2)return n.root=n.dir=t,n;if(i=2,l(t.charCodeAt(2))){if(o===3)return n.root=n.dir=t,n;i=3}}i>0&&(n.root=t.slice(0,i));let u=-1,k=i,S=-1,$=!0,g=t.length-1,f=0;for(;g>=i;--g){if(a=t.charCodeAt(g),l(a)){if(!$){k=g+1;break}continue}S===-1&&($=!1,S=g+1),a===b?u===-1?u=g:f!==1&&(f=1):u!==-1&&(f=-1)}return S!==-1&&(u===-1||f===0||f===1&&u===S-1&&u===k+1?n.base=n.name=t.slice(k,S):(n.name=t.slice(k,u),n.base=t.slice(k,S),n.ext=t.slice(u,S))),k>0&&k!==i?n.dir=t.slice(0,k-1):n.dir=n.root,n},sep:"\\",delimiter:";",win32:null,posix:null};const h=(()=>{if(v){const t=/\\/g;return()=>{const n=C.cwd().replace(t,"/");return n.slice(n.indexOf("/"))}}return()=>C.cwd()})();e.$fc={resolve(...t){let n="",o=!1;for(let i=t.length-1;i>=-1&&!o;i--){const a=i>=0?t[i]:h();D(a,"path"),a.length!==0&&(n=`${a}/${n}`,o=a.charCodeAt(0)===E)}return n=c(n,!o,"/",s),o?`/${n}`:n.length>0?n:"."},normalize(t){if(D(t,"path"),t.length===0)return".";const n=t.charCodeAt(0)===E,o=t.charCodeAt(t.length-1)===E;return t=c(t,!n,"/",s),t.length===0?n?"/":o?"./":".":(o&&(t+="/"),n?`/${t}`:t)},isAbsolute(t){return D(t,"path"),t.length>0&&t.charCodeAt(0)===E},join(...t){if(t.length===0)return".";let n;for(let o=0;o<t.length;++o){const i=t[o];D(i,"path"),i.length>0&&(n===void 0?n=i:n+=`/${i}`)}return n===void 0?".":e.$fc.normalize(n)},relative(t,n){if(D(t,"from"),D(n,"to"),t===n||(t=e.$fc.resolve(t),n=e.$fc.resolve(n),t===n))return"";const o=1,i=t.length,a=i-o,u=1,k=n.length-u,S=a<k?a:k;let $=-1,g=0;for(;g<S;g++){const P=t.charCodeAt(o+g);if(P!==n.charCodeAt(u+g))break;P===E&&($=g)}if(g===S)if(k>S){if(n.charCodeAt(u+g)===E)return n.slice(u+g+1);if(g===0)return n.slice(u+g)}else a>S&&(t.charCodeAt(o+g)===E?$=g:g===0&&($=0));let f="";for(g=o+$+1;g<=i;++g)(g===i||t.charCodeAt(g)===E)&&(f+=f.length===0?"..":"/..");return`${f}${n.slice(u+$)}`},toNamespacedPath(t){return t},dirname(t){if(D(t,"path"),t.length===0)return".";const n=t.charCodeAt(0)===E;let o=-1,i=!0;for(let a=t.length-1;a>=1;--a)if(t.charCodeAt(a)===E){if(!i){o=a;break}}else i=!1;return o===-1?n?"/":".":n&&o===1?"//":t.slice(0,o)},basename(t,n){n!==void 0&&D(n,"ext"),D(t,"path");let o=0,i=-1,a=!0,u;if(n!==void 0&&n.length>0&&n.length<=t.length){if(n===t)return"";let k=n.length-1,S=-1;for(u=t.length-1;u>=0;--u){const $=t.charCodeAt(u);if($===E){if(!a){o=u+1;break}}else S===-1&&(a=!1,S=u+1),k>=0&&($===n.charCodeAt(k)?--k===-1&&(i=u):(k=-1,i=S))}return o===i?i=S:i===-1&&(i=t.length),t.slice(o,i)}for(u=t.length-1;u>=0;--u)if(t.charCodeAt(u)===E){if(!a){o=u+1;break}}else i===-1&&(a=!1,i=u+1);return i===-1?"":t.slice(o,i)},extname(t){D(t,"path");let n=-1,o=0,i=-1,a=!0,u=0;for(let k=t.length-1;k>=0;--k){const S=t.charCodeAt(k);if(S===E){if(!a){o=k+1;break}continue}i===-1&&(a=!1,i=k+1),S===b?n===-1?n=k:u!==1&&(u=1):n!==-1&&(u=-1)}return n===-1||i===-1||u===0||u===1&&n===i-1&&n===o+1?"":t.slice(n,i)},format:m.bind(null,"/"),parse(t){D(t,"path");const n={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return n;const o=t.charCodeAt(0)===E;let i;o?(n.root="/",i=1):i=0;let a=-1,u=0,k=-1,S=!0,$=t.length-1,g=0;for(;$>=i;--$){const f=t.charCodeAt($);if(f===E){if(!S){u=$+1;break}continue}k===-1&&(S=!1,k=$+1),f===b?a===-1?a=$:g!==1&&(g=1):a!==-1&&(g=-1)}if(k!==-1){const f=u===0&&o?1:u;a===-1||g===0||g===1&&a===k-1&&a===u+1?n.base=n.name=t.slice(f,k):(n.name=t.slice(f,a),n.base=t.slice(f,k),n.ext=t.slice(a,k))}return u>0?n.dir=t.slice(0,u-1):o&&(n.dir="/"),n},sep:"/",delimiter:":",win32:null,posix:null},e.$fc.win32=e.$ec.win32=e.$ec,e.$fc.posix=e.$ec.posix=e.$fc,e.$gc=v?e.$ec.normalize:e.$fc.normalize,e.$hc=v?e.$ec.isAbsolute:e.$fc.isAbsolute,e.$ic=v?e.$ec.join:e.$fc.join,e.$jc=v?e.$ec.resolve:e.$fc.resolve,e.$kc=v?e.$ec.relative:e.$fc.relative,e.$lc=v?e.$ec.dirname:e.$fc.dirname,e.$mc=v?e.$ec.basename:e.$fc.basename,e.$nc=v?e.$ec.extname:e.$fc.extname,e.$oc=v?e.$ec.format:e.$fc.format,e.$pc=v?e.$ec.parse:e.$fc.parse,e.$qc=v?e.$ec.toNamespacedPath:e.$fc.toNamespacedPath,e.sep=v?e.$ec.sep:e.$fc.sep,e.$sc=v?e.$ec.delimiter:e.$fc.delimiter}),define(De[126],Ce([1,0,51,16]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pq=e.$oq=e.$nq=e.$mq=e.$lq=e.$kq=e.$jq=e.$iq=e.$hq=e.$gq=e.$fq=e.$eq=e.$dq=void 0;const d=new C.$U(()=>{const S=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:S,collatorIsNumeric:S.resolvedOptions().numeric}}),M=new C.$U(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new C.$U(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function b(S,$,g=!1){const f=S||"",P=$||"",N=d.value.collator.compare(f,P);return d.value.collatorIsNumeric&&N===0&&f!==P?f<P?-1:1:N}e.$dq=b;function E(S,$){const g=M.value.collator;return S=S||"",$=$||"",m(g,S,$)}e.$eq=E;function w(S,$){const g=M.value.collator;return S=S||"",$=$||"",o(S,$)||m(g,S,$)}e.$fq=w;function R(S,$){const g=M.value.collator;return S=S||"",$=$||"",n(S,$)||m(g,S,$)}e.$gq=R;function I(S,$){return S=S||"",$=$||"",S===$?0:S<$?-1:1}e.$hq=I;function p(S,$){const[g,f]=r(S),[P,N]=r($);let O=d.value.collator.compare(f,N);if(O===0){if(d.value.collatorIsNumeric&&f!==N)return f<N?-1:1;if(O=d.value.collator.compare(g,P),d.value.collatorIsNumeric&&O===0&&g!==P)return g<P?-1:1}return O}e.$iq=p;function y(S,$){S=S||"",$=$||"";const g=c(S),f=c($),P=M.value.collator,N=A.value.collator;return m(N,g,f)||m(P,S,$)}e.$jq=y;function D(S,$){S=S||"",$=$||"";const g=c(S),f=c($),P=M.value.collator,N=A.value.collator;return m(N,g,f)||o(S,$)||m(P,S,$)}e.$kq=D;function v(S,$){S=S||"",$=$||"";const g=c(S),f=c($),P=M.value.collator,N=A.value.collator;return m(N,g,f)||n(S,$)||m(P,S,$)}e.$lq=v;function l(S,$){S=S||"",$=$||"";const g=c(S).toLowerCase(),f=c($).toLowerCase();return g!==f?g<f?-1:1:S!==$?S<$?-1:1:0}e.$mq=l;const s=/^(.*?)(\.([^.]*))?$/;function r(S,$=!1){const g=S?s.exec(S):[];let f=[g&&g[1]||"",g&&g[3]||""];return $&&(!f[0]&&f[1]||f[0]&&f[0].charAt(0)===".")&&(f=[f[0]+"."+f[1],""]),f}function c(S){const $=S?s.exec(S):[];return $&&$[1]&&$[1].charAt(0)!=="."&&$[3]||""}function m(S,$,g){const f=S.compare($,g);return f!==0?f:$.length!==g.length?$.length<g.length?-1:1:0}function h(S){const $=S.charAt(0);return $.toLocaleUpperCase()!==$}function t(S){const $=S.charAt(0);return $.toLocaleLowerCase()!==$}function n(S,$){return h(S)&&t($)?-1:t(S)&&h($)?1:0}function o(S,$){return t(S)&&h($)?-1:h(S)&&t($)?1:0}function i(S,$,g=!1){return g||(S=S&&S.toLowerCase(),$=$&&$.toLowerCase()),S===$?0:S<$?-1:1}function a(S,$,g=!1){const f=S.split(T.sep),P=$.split(T.sep),N=f.length-1,O=P.length-1;let L,j;for(let z=0;;z++){if(L=N===z,j=O===z,L&&j)return b(f[z],P[z],g);if(L)return-1;if(j)return 1;const F=i(f[z],P[z],g);if(F!==0)return F}}e.$nq=a;function u(S,$,g){const f=S.toLowerCase(),P=$.toLowerCase(),N=k(S,$,g);if(N)return N;const O=f.endsWith(g),L=P.endsWith(g);if(O!==L)return O?-1:1;const j=b(f,P);return j!==0?j:f.localeCompare(P)}e.$oq=u;function k(S,$,g){const f=S.toLowerCase(),P=$.toLowerCase(),N=f.startsWith(g),O=P.startsWith(g);if(N!==O)return N?-1:1;if(N&&O){if(f.length<P.length)return-1;if(f.length>P.length)return 1}return 0}e.$pq=k}),define(De[32],Ce([1,0,16,12,15,18]),function(me,e,C,T,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=void 0;function A(u){return u===47||u===92}e.$Pf=A;function b(u){return u.replace(/[\\/]/g,C.$fc.sep)}e.$Qf=b;function E(u){return u.indexOf("/")===-1&&(u=b(u)),/^[a-zA-Z]:(\/|$)/.test(u)&&(u="/"+u),u}e.$Rf=E;function w(u,k=C.$fc.sep){if(!u)return"";const S=u.length,$=u.charCodeAt(0);if(A($)){if(A(u.charCodeAt(1))&&!A(u.charCodeAt(2))){let f=3;const P=f;for(;f<S&&!A(u.charCodeAt(f));f++);if(P!==f&&!A(u.charCodeAt(f+1))){for(f+=1;f<S;f++)if(A(u.charCodeAt(f)))return u.slice(0,f+1).replace(/[\\/]/g,k)}}return k}else if(s($)&&u.charCodeAt(1)===58)return A(u.charCodeAt(2))?u.slice(0,2)+k:u.slice(0,2);let g=u.indexOf("://");if(g!==-1){for(g+=3;g<S;g++)if(A(u.charCodeAt(g)))return u.slice(0,g+1)}return""}e.$Sf=w;function R(u){if(!T.$j||!u||u.length<5)return!1;let k=u.charCodeAt(0);if(k!==92||(k=u.charCodeAt(1),k!==92))return!1;let S=2;const $=S;for(;S<u.length&&(k=u.charCodeAt(S),k!==92);S++);return!($===S||(k=u.charCodeAt(S+1),isNaN(k)||k===92))}e.$Tf=R;const I=/[\\/:\*\?"<>\|]/g,p=/[\\/]/g,y=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function D(u,k=T.$j){const S=k?I:p;return!(!u||u.length===0||/^\s+$/.test(u)||(S.lastIndex=0,S.test(u))||k&&y.test(u)||u==="."||u===".."||k&&u[u.length-1]==="."||k&&u.length!==u.trim().length||u.length>255)}e.$Uf=D;function v(u,k,S){const $=u===k;return!S||$?$:!u||!k?!1:(0,d.$1e)(u,k)}e.$Vf=v;function l(u,k,S,$=C.sep){if(u===k)return!0;if(!u||!k||k.length>u.length)return!1;if(S){if(!(0,d.$2e)(u,k))return!1;if(k.length===u.length)return!0;let f=k.length;return k.charAt(k.length-1)===$&&f--,u.charAt(f)===$}return k.charAt(k.length-1)!==$&&(k+=$),u.indexOf(k)===0}e.$Wf=l;function s(u){return u>=65&&u<=90||u>=97&&u<=122}e.$Xf=s;function r(u,k){return T.$j&&u.endsWith(":")&&(u+=C.sep),(0,C.$hc)(u)||(u=(0,C.$ic)(k,u)),u=(0,C.$gc)(u),T.$j?(u=(0,d.$Je)(u,C.sep),u.endsWith(":")&&(u+=C.sep)):(u=(0,d.$Je)(u,C.sep),u||(u=C.sep)),u}e.$Yf=r;function c(u){const k=(0,C.$gc)(u);return T.$j?u.length>3?!1:m(k)&&(u.length===2||k.charCodeAt(2)===92):k===C.$fc.sep}e.$Zf=c;function m(u,k=T.$j){return k?s(u.charCodeAt(0))&&u.charCodeAt(1)===58:!1}e.$1f=m;function h(u,k=T.$j){return m(u,k)?u[0]:void 0}e.$2f=h;function t(u,k,S){return k.length>u.length?-1:u===k?0:(S&&(u=u.toLowerCase(),k=k.toLowerCase()),u.indexOf(k))}e.$3f=t;function n(u){const k=u.split(":");let S,$,g;for(const f of k){const P=Number(f);(0,M.$Bf)(P)?$===void 0?$=P:g===void 0&&(g=P):S=S?[S,f].join(":"):f}if(!S)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:S,line:$!==void 0?$:void 0,column:g!==void 0?g:$!==void 0?1:void 0}}e.$4f=n;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function a(u,k,S=8){let $="";for(let f=0;f<S;f++){let P;f===0&&T.$j&&!k&&(S===3||S===4)?P=i:P=o,$+=P.charAt(Math.floor(Math.random()*P.length))}let g;return k?g=`${k}-${$}`:g=$,u?(0,C.$ic)(u,g):g}e.$5f=a}),define(De[127],Ce([1,0,126,121,52,16,12,15]),function(me,e,C,T,d,M,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vq=e.$uq=e.$tq=e.$sq=e.$rq=e.$qq=void 0;const E=0,w=[E,[]];function R(H,K,fe,x){if(!H||!K)return w;const Z=H.length,q=K.length;if(Z<q)return w;const Y=H.toLowerCase();return I(K,fe,q,H,Y,Z,x)}e.$qq=R;function I(H,K,fe,x,Z,q,Y){const be=[],ue=[];for(let V=0;V<fe;V++){const ge=V*q,_=ge-q,ie=V>0,re=H[V],Ee=K[V];for(let oe=0;oe<q;oe++){const he=oe>0,ee=ge+oe,le=ee-1,$e=_+oe-1,Pe=he?be[le]:0,B=ie&&he?be[$e]:0,Q=ie&&he?ue[$e]:0;let te;!B&&ie?te=0:te=p(re,Ee,x,Z,oe,Q),te&&B+te>=Pe&&(Y||ie||Z.startsWith(K,oe))?(ue[ee]=Q+1,be[ee]=B+te):(ue[ee]=E,be[ee]=Pe)}}const ve=[];let J=fe-1,U=q-1;for(;J>=0&&U>=0;){const V=J*q+U;ue[V]===E||(ve.push(U),J--),U--}return[be[fe*q-1],ve.reverse()]}function p(H,K,fe,x,Z,q){let Y=0;if(!y(K,x[Z]))return Y;if(Y+=1,q>0&&(Y+=q*5),H===fe[Z]&&(Y+=1),Z===0)Y+=8;else{const be=D(fe.charCodeAt(Z-1));be?Y+=be:(0,T.$Ej)(fe.charCodeAt(Z))&&q===0&&(Y+=2)}return Y}function y(H,K){return H===K?!0:H==="/"||H==="\\"?K==="/"||K==="\\":!1}function D(H){switch(H){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const v=[void 0,[]];function l(H,K,fe=0,x=0){const Z=K;return Z.values&&Z.values.length>1?s(H,Z.values,fe,x):r(H,K,fe,x)}e.$rq=l;function s(H,K,fe,x){let Z=0;const q=[];for(const Y of K){const[be,ue]=r(H,Y,fe,x);if(typeof be!="number")return v;Z+=be,q.push(...ue)}return[Z,S(q)]}function r(H,K,fe,x){const Z=(0,T.$Nj)(K.original,K.originalLowercase,fe,H,H.toLowerCase(),x,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Z?[Z[0],(0,T.$Kj)(Z)]:v}const c=Object.freeze({score:0}),m=1<<18,h=1<<17,t=1<<16;function n(H,K,fe,x){const Z=x.values?x.values:[x];return(0,d.$Bi)({[x.normalized]:{values:Z.map(Y=>({value:Y.normalized,expectContiguousMatch:Y.expectContiguousMatch})),label:H,description:K,allowNonContiguousMatches:fe}})}function o(H,K,fe,x,Z){if(!H||!K.normalized)return c;const q=x.getItemLabel(H);if(!q)return c;const Y=x.getItemDescription(H),be=n(q,Y,fe,K),ue=Z[be];if(ue)return ue;const ve=i(q,Y,x.getItemPath(H),K,fe);return Z[be]=ve,ve}e.$sq=o;function i(H,K,fe,x,Z){const q=!fe||!x.containsPathSeparator;return fe&&(A.$l?x.pathNormalized===fe:(0,b.$1e)(x.pathNormalized,fe))?{score:m,labelMatch:[{start:0,end:H.length}],descriptionMatch:K?[{start:0,end:K.length}]:void 0}:x.values&&x.values.length>1?a(H,K,fe,x.values,q,Z):u(H,K,fe,x,q,Z)}function a(H,K,fe,x,Z,q){let Y=0;const be=[],ue=[];for(const ve of x){const{score:J,labelMatch:U,descriptionMatch:V}=u(H,K,fe,ve,Z,q);if(J===E)return c;Y+=J,U&&be.push(...U),V&&ue.push(...V)}return{score:Y,labelMatch:S(be),descriptionMatch:S(ue)}}function u(H,K,fe,x,Z,q){if(Z||!K){const[Y,be]=R(H,x.normalized,x.normalizedLowercase,q&&!x.expectContiguousMatch);if(Y){const ue=(0,T.$Bj)(x.normalized,H);let ve;if(ue){ve=h;const J=Math.round(x.normalized.length/H.length*100);ve+=J}else ve=t;return{score:ve+Y,labelMatch:ue||k(be)}}}if(K){let Y=K;fe&&(Y=`${K}${M.sep}`);const be=Y.length,ue=`${Y}${H}`,[ve,J]=R(ue,x.normalized,x.normalizedLowercase,q&&!x.expectContiguousMatch);if(ve){const U=k(J),V=[],ge=[];return U.forEach(_=>{_.start<be&&_.end>be?(V.push({start:0,end:_.end-be}),ge.push({start:_.start,end:be})):_.start>=be?V.push({start:_.start-be,end:_.end-be}):ge.push(_)}),{score:ve,labelMatch:V,descriptionMatch:ge}}}return c}function k(H){const K=[];if(!H)return K;let fe;for(const x of H)fe&&fe.end===x?fe.end+=1:(fe={start:x,end:x+1},K.push(fe));return K}function S(H){const K=H.sort((Z,q)=>Z.start-q.start),fe=[];let x;for(const Z of K)!x||!$(x,Z)?(x=Z,fe.push(Z)):(x.start=Math.min(x.start,Z.start),x.end=Math.max(x.end,Z.end));return fe}function $(H,K){return!(H.end<K.start||K.end<H.start)}function g(H,K,fe,x,Z,q){const Y=o(H,fe,x,Z,q),be=o(K,fe,x,Z,q),ue=Y.score,ve=be.score;if((ue===m||ve===m)&&ue!==ve)return ue===m?-1:1;if(ue>t||ve>t){if(ue!==ve)return ue>ve?-1:1;if(ue<h&&ve<h){const re=P(Y.labelMatch,be.labelMatch);if(re!==0)return re}const _=Z.getItemLabel(H)||"",ie=Z.getItemLabel(K)||"";if(_.length!==ie.length)return _.length-ie.length}if(ue!==ve)return ue>ve?-1:1;const J=Array.isArray(Y.labelMatch)&&Y.labelMatch.length>0,U=Array.isArray(be.labelMatch)&&be.labelMatch.length>0;if(J&&!U)return-1;if(U&&!J)return 1;const V=f(H,Y,Z),ge=f(K,be,Z);return V&&ge&&V!==ge?ge>V?-1:1:N(H,K,fe,Z)}e.$tq=g;function f(H,K,fe){let x=-1,Z=-1;if(K.descriptionMatch&&K.descriptionMatch.length?x=K.descriptionMatch[0].start:K.labelMatch&&K.labelMatch.length&&(x=K.labelMatch[0].start),K.labelMatch&&K.labelMatch.length){if(Z=K.labelMatch[K.labelMatch.length-1].end,K.descriptionMatch&&K.descriptionMatch.length){const q=fe.getItemDescription(H);q&&(Z+=q.length)}}else K.descriptionMatch&&K.descriptionMatch.length&&(Z=K.descriptionMatch[K.descriptionMatch.length-1].end);return Z-x}function P(H,K){if(!H&&!K||(!H||!H.length)&&(!K||!K.length))return 0;if(!K||!K.length)return-1;if(!H||!H.length)return 1;const fe=H[0].start,Z=H[H.length-1].end-fe,q=K[0].start,be=K[K.length-1].end-q;return Z===be?0:be<Z?1:-1}function N(H,K,fe,x){const Z=x.getItemLabel(H)||"",q=x.getItemLabel(K)||"",Y=x.getItemDescription(H),be=x.getItemDescription(K),ue=Z.length+(Y?Y.length:0),ve=q.length+(be?be.length:0);if(ue!==ve)return ue-ve;const J=x.getItemPath(H),U=x.getItemPath(K);return J&&U&&J.length!==U.length?J.length-U.length:Z!==q?(0,C.$oq)(Z,q,fe.normalized):Y&&be&&Y!==be?(0,C.$oq)(Y,be,fe.normalized):J&&U&&J!==U?(0,C.$oq)(J,U,fe.normalized):0}function O(H){return H.startsWith('"')&&H.endsWith('"')}const L=" ";function j(H){typeof H!="string"&&(H="");const K=H.toLowerCase(),{pathNormalized:fe,normalized:x,normalizedLowercase:Z}=z(H),q=fe.indexOf(M.sep)>=0,Y=O(H);let be;const ue=H.split(L);if(ue.length>1)for(const ve of ue){const J=O(ve),{pathNormalized:U,normalized:V,normalizedLowercase:ge}=z(ve);V&&(be||(be=[]),be.push({original:ve,originalLowercase:ve.toLowerCase(),pathNormalized:U,normalized:V,normalizedLowercase:ge,expectContiguousMatch:J}))}return{original:H,originalLowercase:K,pathNormalized:fe,normalized:x,normalizedLowercase:Z,values:be,containsPathSeparator:q,expectContiguousMatch:Y}}e.$uq=j;function z(H){let K;A.$j?K=H.replace(/\//g,M.sep):K=H.replace(/\\/g,M.sep);const fe=(0,b.$Le)(K).replace(/\s|"/g,"");return{pathNormalized:K,normalized:fe,normalizedLowercase:fe.toLowerCase()}}function F(H){return Array.isArray(H)?j(H.map(K=>K.original).join(L)):j(H.original)}e.$vq=F}),define(De[97],Ce([1,0,16]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pr=e.$Or=e.$Nr=e.$Mr=e.$Lr=void 0,e.$Lr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const T={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},d={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function M(R){const I=(0,C.$nc)(R),p=T[I.toLowerCase()];return p!==void 0?p:A(R)}e.$Mr=M;function A(R){const I=(0,C.$nc)(R);return d[I.toLowerCase()]}e.$Nr=A;function b(R){for(const I in d)if(d[I]===R)return I}e.$Or=b;const E=/^(.+)\/(.+?)(;.+)?$/;function w(R,I){const p=E.exec(R);return p?`${p[1].toLowerCase()}/${p[2].toLowerCase()}${p[3]??""}`:I?void 0:R}e.$Pr=w}),define(De[98],Ce([1,0,12]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wl=e.$vl=e.TerminateResponseCode=e.Source=void 0;var T;(function(b){b[b.stdout=0]="stdout",b[b.stderr=1]="stderr"})(T||(e.Source=T={}));var d;(function(b){b[b.Success=0]="Success",b[b.Unknown=1]="Unknown",b[b.AccessDenied=2]="AccessDenied",b[b.ProcessNotFound=3]="ProcessNotFound"})(d||(e.TerminateResponseCode=d={}));function M(b,...E){const w=E.reduce((p,y)=>(p[y]=!0,p),{}),R=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(b).filter(p=>!w[p]).forEach(p=>{for(let y=0;y<R.length;y++)if(p.search(R[y])!==-1){delete b[p];break}})}e.$vl=M;function A(b){b&&(delete b.DEBUG,C.$k&&delete b.DYLD_LIBRARY_PATH,C.$l&&delete b.LD_PRELOAD)}e.$wl=A}),define(De[2],Ce([1,0,16,12]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vc=e.$uc=e.URI=void 0;const d=/^\w[\w\d+.-]*$/,M=/^\//,A=/^\/\//;function b(i,a){if(!i.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!d.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!M.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function E(i,a){return!i&&!a?"file":i}function w(i,a){switch(i){case"https":case"http":case"file":a?a[0]!==I&&(a=I+a):a=I;break}return a}const R="",I="/",p=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class y{static isUri(a){return a instanceof y?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}constructor(a,u,k,S,$,g=!1){typeof a=="object"?(this.scheme=a.scheme||R,this.authority=a.authority||R,this.path=a.path||R,this.query=a.query||R,this.fragment=a.fragment||R):(this.scheme=E(a,g),this.authority=u||R,this.path=w(this.scheme,k||R),this.query=S||R,this.fragment=$||R,b(this,g))}get fsPath(){return m(this,!1)}with(a){if(!a)return this;let{scheme:u,authority:k,path:S,query:$,fragment:g}=a;return u===void 0?u=this.scheme:u===null&&(u=R),k===void 0?k=this.authority:k===null&&(k=R),S===void 0?S=this.path:S===null&&(S=R),$===void 0?$=this.query:$===null&&($=R),g===void 0?g=this.fragment:g===null&&(g=R),u===this.scheme&&k===this.authority&&S===this.path&&$===this.query&&g===this.fragment?this:new l(u,k,S,$,g)}static parse(a,u=!1){const k=p.exec(a);return k?new l(k[2]||R,o(k[4]||R),o(k[5]||R),o(k[7]||R),o(k[9]||R),u):new l(R,R,R,R,R)}static file(a){let u=R;if(T.$j&&(a=a.replace(/\\/g,I)),a[0]===I&&a[1]===I){const k=a.indexOf(I,2);k===-1?(u=a.substring(2),a=I):(u=a.substring(2,k),a=a.substring(k)||I)}return new l("file",u,a,R,R)}static from(a,u){return new l(a.scheme,a.authority,a.path,a.query,a.fragment,u)}static joinPath(a,...u){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let k;return T.$j&&a.scheme==="file"?k=y.file(C.$ec.join(m(a,!0),...u)).path:k=C.$fc.join(a.path,...u),a.with({path:k})}toString(a=!1){return h(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof y)return a;{const u=new l(a);return u._formatted=a.external??null,u._fsPath=a._sep===v?a.fsPath??null:null,u}}else return a}}e.URI=y;function D(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}e.$uc=D;const v=T.$j?1:void 0;class l extends y{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=m(this,!1)),this._fsPath}toString(a=!1){return a?h(this,!0):(this._formatted||(this._formatted=h(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=v),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const s={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function r(i,a,u){let k,S=-1;for(let $=0;$<i.length;$++){const g=i.charCodeAt($);if(g>=97&&g<=122||g>=65&&g<=90||g>=48&&g<=57||g===45||g===46||g===95||g===126||a&&g===47||u&&g===91||u&&g===93||u&&g===58)S!==-1&&(k+=encodeURIComponent(i.substring(S,$)),S=-1),k!==void 0&&(k+=i.charAt($));else{k===void 0&&(k=i.substr(0,$));const f=s[g];f!==void 0?(S!==-1&&(k+=encodeURIComponent(i.substring(S,$)),S=-1),k+=f):S===-1&&(S=$)}}return S!==-1&&(k+=encodeURIComponent(i.substring(S))),k!==void 0?k:i}function c(i){let a;for(let u=0;u<i.length;u++){const k=i.charCodeAt(u);k===35||k===63?(a===void 0&&(a=i.substr(0,u)),a+=s[k]):a!==void 0&&(a+=i[u])}return a!==void 0?a:i}function m(i,a){let u;return i.authority&&i.path.length>1&&i.scheme==="file"?u=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?a?u=i.path.substr(1):u=i.path[1].toLowerCase()+i.path.substr(2):u=i.path,T.$j&&(u=u.replace(/\//g,"\\")),u}e.$vc=m;function h(i,a){const u=a?c:r;let k="",{scheme:S,authority:$,path:g,query:f,fragment:P}=i;if(S&&(k+=S,k+=":"),($||S==="file")&&(k+=I,k+=I),$){let N=$.indexOf("@");if(N!==-1){const O=$.substr(0,N);$=$.substr(N+1),N=O.lastIndexOf(":"),N===-1?k+=u(O,!1,!1):(k+=u(O.substr(0,N),!1,!1),k+=":",k+=u(O.substr(N+1),!1,!0)),k+="@"}$=$.toLowerCase(),N=$.lastIndexOf(":"),N===-1?k+=u($,!1,!0):(k+=u($.substr(0,N),!1,!0),k+=$.substr(N))}if(g){if(g.length>=3&&g.charCodeAt(0)===47&&g.charCodeAt(2)===58){const N=g.charCodeAt(1);N>=65&&N<=90&&(g=`/${String.fromCharCode(N+32)}:${g.substr(3)}`)}else if(g.length>=2&&g.charCodeAt(1)===58){const N=g.charCodeAt(0);N>=65&&N<=90&&(g=`${String.fromCharCode(N+32)}:${g.substr(2)}`)}k+=u(g,!0,!1)}return f&&(k+="?",k+=u(f,!1,!1)),P&&(k+="#",k+=a?P:r(P,!1,!1)),k}function t(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+t(i.substr(3)):i}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function o(i){return i.match(n)?i.replace(n,a=>t(a)):i}}),define(De[181],Ce([1,0,2]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Vp=e.$Up=e.$Tp=void 0;function T(w){const R=w;return R&&typeof R.type=="string"&&typeof R.severity=="string"}e.$Tp=T;function d(w){const R=[];let I;try{const p=JSON.parse(w.arguments),y=p[p.length-1];y&&y.__$stack&&(p.pop(),I=y.__$stack),R.push(...p)}catch{R.push("Unable to log remote console arguments",w.arguments)}return{args:R,stack:I}}e.$Up=d;function M(w){if(typeof w!="string")return M(d(w).stack);const R=w;if(R){const I=A(R),p=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(p&&p.length===4)return{uri:C.URI.file(p[1]),line:Number(p[2]),column:Number(p[3])}}}e.$Vp=M;function A(w){if(!w)return w;const R=w.indexOf(`
`);return R===-1?w:w.substring(0,R)}function b(w,R){const{args:I,stack:p}=d(w),y=typeof I[0]=="string"&&I.length===1;let D=A(p);D&&(D=`(${D.trim()})`);let v=[];if(typeof I[0]=="string"?D&&y?v=[`%c[${R}] %c${I[0]} %c${D}`,E("blue"),E(""),E("grey")]:v=[`%c[${R}] %c${I[0]}`,E("blue"),E(""),...I.slice(1)]:v=[`%c[${R}]%`,E("blue"),...I],D&&!y&&v.push(D),typeof console[w.severity]!="function")throw new Error("Unknown console method");console[w.severity].apply(console,v)}e.log=b;function E(w){return`color: ${w}`}}),define(De[62],Ce([1,0,22,2]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kh=e.$jh=e.$ih=void 0;function d(E){return JSON.stringify(E,A)}e.$ih=d;function M(E){let w=JSON.parse(E);return w=b(w),w}e.$jh=M;function A(E,w){return w instanceof RegExp?{$mid:2,source:w.source,flags:w.flags}:w}function b(E,w=0){if(!E||w>200)return E;if(typeof E=="object"){switch(E.$mid){case 1:return T.URI.revive(E);case 2:return new RegExp(E.source,E.flags);case 17:return new Date(E.source)}if(E instanceof C.$ae||E instanceof Uint8Array)return E;if(Array.isArray(E))for(let R=0;R<E.length;++R)E[R]=b(E[R],w+1);else for(const R in E)Object.hasOwnProperty.call(E,R)&&(E[R]=b(E[R],w+1))}return E}e.$kh=b}),define(De[17],Ce([1,0,8,12,2]),function(me,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.Schemas=void 0;var M;(function(w){w.inMemory="inmemory",w.vscode="vscode",w.internal="private",w.walkThrough="walkThrough",w.walkThroughSnippet="walkThroughSnippet",w.http="http",w.https="https",w.file="file",w.mailto="mailto",w.untitled="untitled",w.data="data",w.command="command",w.vscodeRemote="vscode-remote",w.vscodeRemoteResource="vscode-remote-resource",w.vscodeManagedRemoteResource="vscode-managed-remote-resource",w.vscodeUserData="vscode-userdata",w.vscodeCustomEditor="vscode-custom-editor",w.vscodeNotebookCell="vscode-notebook-cell",w.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",w.vscodeNotebookCellOutput="vscode-notebook-cell-output",w.vscodeInteractiveInput="vscode-interactive-input",w.vscodeSettings="vscode-settings",w.vscodeWorkspaceTrust="vscode-workspace-trust",w.vscodeTerminal="vscode-terminal",w.vscodeChatSesssion="vscode-chat-editor",w.webviewPanel="webview-panel",w.vscodeWebview="vscode-webview",w.extension="extension",w.vscodeFileResource="vscode-file",w.tmp="tmp",w.vsls="vsls",w.vscodeSourceControl="vscode-scm"})(M||(e.Schemas=M={})),e.$6f="vscode-tkn",e.$7f="tkn";class A{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${M.vscodeRemoteResource}`}setPreferredWebSchema(R){this.d=R}setDelegate(R){this.e=R}setServerRootPath(R){this.f=`${R}/${M.vscodeRemoteResource}`}set(R,I,p){this.a[R]=I,this.b[R]=p}setConnectionToken(R,I){this.c[R]=I}getPreferredWebSchema(){return this.d}rewrite(R){if(this.e)try{return this.e(R)}catch(l){return C.$Z(l),R}const I=R.authority;let p=this.a[I];p&&p.indexOf(":")!==-1&&p.indexOf("[")===-1&&(p=`[${p}]`);const y=this.b[I],D=this.c[I];let v=`path=${encodeURIComponent(R.path)}`;return typeof D=="string"&&(v+=`&${e.$7f}=${encodeURIComponent(D)}`),d.URI.from({scheme:T.$p?this.d:M.vscodeRemoteResource,authority:`${p}:${y}`,path:this.f,query:v})}}e.$8f=new A,e.$9f="vs/../../extensions",e.$0f="vs/../../node_modules",e.$$f="vs/../../node_modules.asar",e.$_f="vs/../../node_modules.asar.unpacked",e.$ag="vscode-app";class b{static{this.a=e.$ag}asBrowserUri(R){const I=this.b(R,me);return this.uriToBrowserUri(I)}uriToBrowserUri(R){return R.scheme===M.vscodeRemote?e.$8f.rewrite(R):R.scheme===M.file&&(T.$n||T.$q&&T.$h.origin===`${M.vscodeFileResource}://${b.a}`)?R.with({scheme:M.vscodeFileResource,authority:R.authority||b.a,query:null,fragment:null}):R}asFileUri(R){const I=this.b(R,me);return this.uriToFileUri(I)}uriToFileUri(R){return R.scheme===M.vscodeFileResource?R.with({scheme:M.file,authority:R.authority!==b.a?R.authority:null,query:null,fragment:null}):R}b(R,I){return d.URI.isUri(R)?R:d.URI.parse(I.toUrl(R))}}e.$bg=new b;var E;(function(w){const R=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);w.CoopAndCoep=Object.freeze(R.get("3"));const I="vscode-coi";function p(D){let v;typeof D=="string"?v=new URL(D).searchParams:D instanceof URL?v=D.searchParams:d.URI.isUri(D)&&(v=new URL(D.toString(!0)).searchParams);const l=v?.get(I);if(l)return R.get(l)}w.getHeadersFromQuery=p;function y(D,v,l){if(!globalThis.crossOriginIsolated)return;const s=v&&l?"3":l?"2":"1";D instanceof URLSearchParams?D.set(I,s):D[I]=s}w.addSearchParam=y})(E||(e.COI=E={}))}),define(De[182],Ce([1,0,156,17,12,2]),function(me,e,C,T,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gC=void 0;class A{constructor(p,y,D){this.id=p,this.dependencies=y,this.callback=D}}class b{static{this.INSTANCE=new b}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(p,y,D)=>{typeof p!="string"&&(D=y,y=p,p=null),(typeof y!="object"||!Array.isArray(y))&&(D=y,y=null),this.c.push(new A(p,y,D))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(p){if(p.startsWith(window.location.origin)||p.startsWith("vscode-file://vscode-app"))return p;throw new Error(`[trusted_script_src] Invalid script url: ${p}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(p){return p}})))}async load(p){this.g();const y=await(this.a?this.i(p):this.b?this.h(p):this.j(p));if(!y)throw new Error(`Did not receive a define call from script ${p}`);if(Array.isArray(y.dependencies)&&y.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${p}. The dependencies are: ${y.dependencies.join(", ")}`);return typeof y.callback=="function"?y.callback([]):y.callback}h(p){return new Promise((y,D)=>{const v=document.createElement("script");v.setAttribute("async","async"),v.setAttribute("type","text/javascript");const l=()=>{v.removeEventListener("load",s),v.removeEventListener("error",r)},s=c=>{l(),y(this.c.pop())},r=c=>{l(),D(c)};v.addEventListener("load",s),v.addEventListener("error",r),this.f&&(p=this.f.createScriptURL(p)),v.setAttribute("src",p),document.getElementsByTagName("head")[0].appendChild(v)})}i(p){return new Promise((y,D)=>{try{this.f&&(p=this.f.createScriptURL(p)),importScripts(p),y(this.c.pop())}catch(v){D(v)}})}async j(p){try{const y=globalThis._VSCODE_NODE_MODULES.fs,D=globalThis._VSCODE_NODE_MODULES.vm,v=globalThis._VSCODE_NODE_MODULES.module,l=M.URI.parse(p).fsPath,s=y.readFileSync(l).toString(),r=v.wrap(s.replace(/^#!.*/,""));return new D.Script(r).runInThisContext().apply(),this.c.pop()}catch(y){throw y}}}const E=new Map;let w={};typeof globalThis.require=="object"&&(w=globalThis.require.paths??{});async function R(I,p,y){if(C.$S){y===void 0&&(y=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),w[I]&&(I=w[I]);const D=`${I}/${p}`;if(E.has(D))return E.get(D);let v;if(/^\w[\w\d+.-]*:\/\//.test(D))v=D;else{const c=`${y&&!d.$p?T.$$f:T.$0f}/${D}`;v=T.$bg.asBrowserUri(c).toString(!0)}const l=b.INSTANCE.load(v);return E.set(D,l),l}else return await new Promise((D,v)=>{me([I],D,v)})}e.$gC=R}),define(De[24],Ce([1,0,32,17,16,12,15,2]),function(me,e,C,T,d,M,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eg=e.DataUri=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=void 0;function E(y){return(0,b.$vc)(y,!0)}e.$ig=E;class w{constructor(D){this.a=D}compare(D,v,l=!1){return D===v?0:(0,A.$Te)(this.getComparisonKey(D,l),this.getComparisonKey(v,l))}isEqual(D,v,l=!1){return D===v?!0:!D||!v?!1:this.getComparisonKey(D,l)===this.getComparisonKey(v,l)}getComparisonKey(D,v=!1){return D.with({path:this.a(D)?D.path.toLowerCase():void 0,fragment:v?null:void 0}).toString()}ignorePathCasing(D){return this.a(D)}isEqualOrParent(D,v,l=!1){if(D.scheme===v.scheme){if(D.scheme===T.Schemas.file)return C.$Wf(E(D),E(v),this.a(D))&&D.query===v.query&&(l||D.fragment===v.fragment);if((0,e.$zg)(D.authority,v.authority))return C.$Wf(D.path,v.path,this.a(D),"/")&&D.query===v.query&&(l||D.fragment===v.fragment)}return!1}joinPath(D,...v){return b.URI.joinPath(D,...v)}basenameOrAuthority(D){return(0,e.$rg)(D)||D.authority}basename(D){return d.$fc.basename(D.path)}extname(D){return d.$fc.extname(D.path)}dirname(D){if(D.path.length===0)return D;let v;return D.scheme===T.Schemas.file?v=b.URI.file(d.$lc(E(D))).path:(v=d.$fc.dirname(D.path),D.authority&&v.length&&v.charCodeAt(0)!==47&&(console.error(`dirname("${D.toString})) resulted in a relative path`),v="/")),D.with({path:v})}normalizePath(D){if(!D.path.length)return D;let v;return D.scheme===T.Schemas.file?v=b.URI.file(d.$gc(E(D))).path:v=d.$fc.normalize(D.path),D.with({path:v})}relativePath(D,v){if(D.scheme!==v.scheme||!(0,e.$zg)(D.authority,v.authority))return;if(D.scheme===T.Schemas.file){const r=d.$kc(E(D),E(v));return M.$j?C.$Qf(r):r}let l=D.path||"/";const s=v.path||"/";if(this.a(D)){let r=0;for(const c=Math.min(l.length,s.length);r<c&&!(l.charCodeAt(r)!==s.charCodeAt(r)&&l.charAt(r).toLowerCase()!==s.charAt(r).toLowerCase());r++);l=s.substr(0,r)+l.substr(r)}return d.$fc.relative(l,s)}resolvePath(D,v){if(D.scheme===T.Schemas.file){const l=b.URI.file(d.$jc(E(D),v));return D.with({authority:l.authority,path:l.path})}return v=C.$Rf(v),D.with({path:d.$fc.resolve(D.path,v)})}isAbsolutePath(D){return!!D.path&&D.path[0]==="/"}isEqualAuthority(D,v){return D===v||D!==void 0&&v!==void 0&&(0,A.$1e)(D,v)}hasTrailingPathSeparator(D,v=d.sep){if(D.scheme===T.Schemas.file){const l=E(D);return l.length>C.$Sf(l).length&&l[l.length-1]===v}else{const l=D.path;return l.length>1&&l.charCodeAt(l.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(D.fsPath)}}removeTrailingPathSeparator(D,v=d.sep){return(0,e.$Ag)(D,v)?D.with({path:D.path.substr(0,D.path.length-1)}):D}addTrailingPathSeparator(D,v=d.sep){let l=!1;if(D.scheme===T.Schemas.file){const s=E(D);l=s!==void 0&&s.length===C.$Sf(s).length&&s[s.length-1]===v}else{v="/";const s=D.path;l=s.length===1&&s.charCodeAt(s.length-1)===47}return!l&&!(0,e.$Ag)(D,v)?D.with({path:D.path+"/"}):D}}e.$jg=w,e.$kg=new w(()=>!1),e.$lg=new w(y=>y.scheme===T.Schemas.file?!M.$l:!0),e.$mg=new w(y=>!0),e.$ng=e.$kg.isEqual.bind(e.$kg),e.$og=e.$kg.isEqualOrParent.bind(e.$kg),e.$pg=e.$kg.getComparisonKey.bind(e.$kg),e.$qg=e.$kg.basenameOrAuthority.bind(e.$kg),e.$rg=e.$kg.basename.bind(e.$kg),e.$sg=e.$kg.extname.bind(e.$kg),e.$tg=e.$kg.dirname.bind(e.$kg),e.$ug=e.$kg.joinPath.bind(e.$kg),e.$vg=e.$kg.normalizePath.bind(e.$kg),e.$wg=e.$kg.relativePath.bind(e.$kg),e.$xg=e.$kg.resolvePath.bind(e.$kg),e.$yg=e.$kg.isAbsolutePath.bind(e.$kg),e.$zg=e.$kg.isEqualAuthority.bind(e.$kg),e.$Ag=e.$kg.hasTrailingPathSeparator.bind(e.$kg),e.$Bg=e.$kg.removeTrailingPathSeparator.bind(e.$kg),e.$Cg=e.$kg.addTrailingPathSeparator.bind(e.$kg);function R(y,D){const v=[];for(let l=0;l<y.length;l++){const s=D(y[l]);y.some((r,c)=>c===l?!1:(0,e.$og)(s,D(r)))||v.push(y[l])}return v}e.$Dg=R;var I;(function(y){y.META_DATA_LABEL="label",y.META_DATA_DESCRIPTION="description",y.META_DATA_SIZE="size",y.META_DATA_MIME="mime";function D(v){const l=new Map;v.path.substring(v.path.indexOf(";")+1,v.path.lastIndexOf(";")).split(";").forEach(c=>{const[m,h]=c.split(":");m&&h&&l.set(m,h)});const r=v.path.substring(0,v.path.indexOf(";"));return r&&l.set(y.META_DATA_MIME,r),l}y.parseMetaData=D})(I||(e.DataUri=I={}));function p(y,D,v){if(D){let l=y.path;return l&&l[0]!==d.$fc.sep&&(l=d.$fc.sep+l),y.with({scheme:v,authority:D,path:l})}return y.with({scheme:v})}e.$Eg=p}),define(De[9],Ce([1,0,21,8,4,3,24,12,160]),function(me,e,C,T,d,M,A,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eh=e.$dh=e.$ch=e.Promises=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=void 0;function w(U){return!!U&&typeof U.then=="function"}e.$Fg=w;function R(U){const V=new C.$Wd,ge=U(V.token),_=new Promise((ie,re)=>{const Ee=V.token.onCancellationRequested(()=>{Ee.dispose(),V.dispose(),re(new T.$4)});Promise.resolve(ge).then(oe=>{Ee.dispose(),V.dispose(),ie(oe)},oe=>{Ee.dispose(),V.dispose(),re(oe)})});return new class{cancel(){V.cancel()}then(ie,re){return _.then(ie,re)}catch(ie){return this.then(void 0,ie)}finally(ie){return _.finally(ie)}}}e.$Gg=R;function I(U,V,ge){return new Promise((_,ie)=>{const re=V.onCancellationRequested(()=>{re.dispose(),_(ge)});U.then(_,ie).finally(()=>re.dispose())})}e.$Hg=I;function p(U,V){return new Promise((ge,_)=>{const ie=V.onCancellationRequested(()=>{ie.dispose(),_(new T.$4)});U.then(ge,_).finally(()=>ie.dispose())})}e.$Ig=p;async function y(U){let V=-1;const ge=U.map((_,ie)=>_.then(re=>(V=ie,re)));try{return await Promise.race(ge)}finally{U.forEach((_,ie)=>{ie!==V&&_.cancel()})}}e.$Jg=y;function D(U,V,ge){let _;const ie=setTimeout(()=>{_?.(void 0),ge?.()},V);return Promise.race([U.finally(()=>clearTimeout(ie)),new Promise(re=>_=re)])}e.$Kg=D;function v(U){return new Promise((V,ge)=>{const _=U();w(_)?_.then(V,ge):V(_)})}e.$Lg=v;class l{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(V){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=V,!this.b){const ge=()=>{if(this.b=null,this.f)return;const _=this.queue(this.d);return this.d=null,_};this.b=new Promise(_=>{this.a.then(ge,ge).then(_)})}return new Promise((ge,_)=>{this.b.then(ge,_)})}return this.a=V(),new Promise((ge,_)=>{this.a.then(ie=>{this.a=null,ge(ie)},ie=>{this.a=null,_(ie)})})}dispose(){this.f=!0}}e.$Mg=l;class s{constructor(){this.a=Promise.resolve(null)}queue(V){return this.a=this.a.then(()=>V(),()=>V())}}e.$Ng=s;class r{constructor(){this.a=new Map}queue(V,ge){const ie=(this.a.get(V)??Promise.resolve()).catch(()=>{}).then(ge).finally(()=>{this.a.get(V)===ie&&this.a.delete(V)});return this.a.set(V,ie),ie}}e.$Og=r;const c=(U,V)=>{let ge=!0;const _=setTimeout(()=>{ge=!1,V()},U);return{isTriggered:()=>ge,dispose:()=>{clearTimeout(_),ge=!1}}},m=U=>{let V=!0;return queueMicrotask(()=>{V&&(V=!1,U())}),{isTriggered:()=>V,dispose:()=>{V=!1}}};class h{constructor(V){this.defaultDelay=V,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(V,ge=this.defaultDelay){this.g=V,this.h(),this.b||(this.b=new Promise((ie,re)=>{this.d=ie,this.f=re}).then(()=>{if(this.b=null,this.d=null,this.g){const ie=this.g;return this.g=null,ie()}}));const _=()=>{this.a=null,this.d?.(null)};return this.a=ge===E.$Jd?m(_):c(ge,_),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new T.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Pg=h;class t{constructor(V){this.a=new h(V),this.b=new l}trigger(V,ge){return this.a.trigger(()=>this.b.queue(V),ge)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Qg=t;class n{constructor(){this.a=!1,this.b=new Promise((V,ge)=>{this.d=V})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Rg=n;class o extends n{constructor(V){super(),this.f=setTimeout(()=>this.open(),V)}open(){clearTimeout(this.f),super.open()}}e.$Sg=o;function i(U,V){return V?new Promise((ge,_)=>{const ie=setTimeout(()=>{re.dispose(),ge()},U),re=V.onCancellationRequested(()=>{clearTimeout(ie),re.dispose(),_(new T.$4)})}):R(ge=>i(U,ge))}e.$Tg=i;function a(U,V=0,ge){const _=setTimeout(()=>{U(),ge&&ie.dispose()},V),ie=(0,M.$Pc)(()=>{clearTimeout(_),ge?.deleteAndLeak(ie)});return ge?.add(ie),ie}e.$Ug=a;function u(U){const V=[];let ge=0;const _=U.length;function ie(){return ge<_?U[ge++]():null}function re(Ee){Ee!=null&&V.push(Ee);const oe=ie();return oe?oe.then(re):Promise.resolve(V)}return Promise.resolve(null).then(re)}e.$Vg=u;function k(U,V=_=>!!_,ge=null){let _=0;const ie=U.length,re=()=>{if(_>=ie)return Promise.resolve(ge);const Ee=U[_++];return Promise.resolve(Ee()).then(he=>V(he)?Promise.resolve(he):re())};return re()}e.$Wg=k;function S(U,V=_=>!!_,ge=null){if(U.length===0)return Promise.resolve(ge);let _=U.length;const ie=()=>{_=-1;for(const re of U)re.cancel?.()};return new Promise((re,Ee)=>{for(const oe of U)oe.then(he=>{--_>=0&&V(he)?(ie(),re(he)):_===0&&re(ge)}).catch(he=>{--_>=0&&(ie(),Ee(he))})})}e.$Xg=S;class ${constructor(V){this.a=0,this.d=V,this.f=[],this.b=0,this.g=new d.$Md}get onDrained(){return this.g.event}get size(){return this.a}queue(V){return this.a++,new Promise((ge,_)=>{this.f.push({factory:V,c:ge,e:_}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const V=this.f.shift();this.b++;const ge=V.factory();ge.then(V.c,V.e),ge.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Yg=$;class g extends ${constructor(){super(1)}}e.$Zg=g;class f{constructor(){this.a=new fe,this.b=0}queue(V){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,V())):this.a.run(this.b++,V())}}e.$1g=f;class P{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const V=new q;return this.b.add(V),V.p}g(){for(const[,V]of this.a)if(V.size>0)return!1;return!0}queueFor(V,ge=A.$kg){const _=ge.getComparisonKey(V);let ie=this.a.get(_);if(!ie){ie=new g;const re=this.f++,Ee=d.Event.once(ie.onDrained)(()=>{ie?.dispose(),this.a.delete(_),this.h(),this.d?.deleteAndDispose(re),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new M.$Zc),this.d.set(re,Ee),this.a.set(_,ie)}return ie}h(){this.g()&&this.j()}j(){for(const V of this.b)V.complete();this.b.clear()}dispose(){for(const[,V]of this.a)V.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$2g=P;class N{constructor(V,ge){this.a=-1,typeof V=="function"&&typeof ge=="number"&&this.setIfNotSet(V,ge)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(V,ge){this.cancel(),this.a=setTimeout(()=>{this.a=-1,V()},ge)}setIfNotSet(V,ge){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,V()},ge))}}e.$3g=N;class O{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(V,ge){this.cancel(),this.a=setInterval(()=>{V()},ge)}}e.$4g=O;class L{constructor(V,ge){this.b=-1,this.a=V,this.d=ge,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(V=this.d){this.cancel(),this.b=setTimeout(this.f,V)}get delay(){return this.d}set delay(V){this.d=V}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$5g=L;class j{constructor(V,ge){ge%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ge}ms is not a multiple of 1000ms.`),this.a=V,this.b=ge,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(V=this.b){V%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${V}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(V/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$6g=j;class z extends L{constructor(V,ge){super(V,ge),this.j=[]}work(V){this.j.push(V),this.isScheduled()||this.schedule()}h(){const V=this.j;this.j=[],this.a?.(V)}dispose(){this.j=[],super.dispose()}}e.$7g=z;class F extends M.$Rc{constructor(V,ge){super(),this.g=V,this.h=ge,this.a=[],this.b=this.B(new M.$Sc),this.f=!1}get pending(){return this.a.length}work(V){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+V.length>this.g.maxBufferedWork)return!1}else if(this.pending+V.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ge of V)this.a.push(ge);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new L(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$8g=F,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$9g=U=>{(0,b.$B)(()=>{if(V)return;const ge=Date.now()+15;U(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ge-Date.now())}}))});let V=!1;return{dispose(){V||(V=!0)}}}:e.$9g=(U,V)=>{const ge=requestIdleCallback(U,typeof V=="number"?{timeout:V}:void 0);let _=!1;return{dispose(){_||(_=!0,cancelIdleCallback(ge))}}}}();class H{constructor(V){this.d=!1,this.a=()=>{try{this.f=V()}catch(ge){this.g=ge}finally{this.d=!0}},this.b=(0,e.$9g)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$0g=H;async function K(U,V,ge){let _;for(let ie=0;ie<ge;ie++)try{return await U()}catch(re){_=re,await i(V)}throw _}e.$$g=K;class fe{isRunning(V){return typeof V=="number"?this.a?.taskId===V:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(V,ge,_){return this.a={taskId:V,cancel:()=>_?.(),promise:ge},ge.then(()=>this.d(V),()=>this.d(V)),ge}d(V){this.a&&V===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const V=this.b;this.b=void 0,V.run().then(V.promiseResolve,V.promiseReject)}}queue(V){if(this.b)this.b.run=V;else{let ge,_;const ie=new Promise((re,Ee)=>{ge=re,_=Ee});this.b={run:V,promise:ie,promiseResolve:ge,promiseReject:_}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$_g=fe;class x{constructor(V,ge=()=>Date.now()){this.d=V,this.f=ge,this.a=0,this.b=0}increment(){const V=this.f();return V-this.a>this.d&&(this.a=V,this.b=0),this.b++,this.b}}e.$ah=x;var Z;(function(U){U[U.Resolved=0]="Resolved",U[U.Rejected=1]="Rejected"})(Z||(Z={}));class q{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((V,ge)=>{this.a=V,this.b=ge})}complete(V){return new Promise(ge=>{this.a(V),this.d={outcome:0,value:V},ge()})}error(V){return new Promise(ge=>{this.b(V),this.d={outcome:1,value:V},ge()})}cancel(){return this.error(new T.$4)}}e.$bh=q;var Y;(function(U){async function V(_){let ie;const re=await Promise.all(_.map(Ee=>Ee.then(oe=>oe,oe=>{ie||(ie=oe)})));if(typeof ie<"u")throw ie;return re}U.settled=V;function ge(_){return new Promise(async(ie,re)=>{try{await _(ie,re)}catch(Ee){re(Ee)}})}U.withAsyncBody=ge})(Y||(e.Promises=Y={}));var be;(function(U){U[U.Initial=0]="Initial",U[U.DoneOK=1]="DoneOK",U[U.DoneError=2]="DoneError"})(be||(be={}));class ue{static fromArray(V){return new ue(ge=>{ge.emitMany(V)})}static fromPromise(V){return new ue(async ge=>{ge.emitMany(await V)})}static fromPromises(V){return new ue(async ge=>{await Promise.all(V.map(async _=>ge.emitOne(await _)))})}static merge(V){return new ue(async ge=>{await Promise.all(V.map(async _=>{for await(const ie of _)ge.emitOne(ie)}))})}static{this.EMPTY=ue.fromArray([])}constructor(V){this.a=0,this.b=[],this.d=null,this.f=new d.$Md,queueMicrotask(async()=>{const ge={emitOne:_=>this.g(_),emitMany:_=>this.h(_),reject:_=>this.k(_)};try{await Promise.resolve(V(ge)),this.j()}catch(_){this.k(_)}finally{ge.emitOne=void 0,ge.emitMany=void 0,ge.reject=void 0}})}[Symbol.asyncIterator](){let V=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(V<this.b.length)return{done:!1,value:this.b[V++]};if(this.a===1)return{done:!0,value:void 0};await d.Event.toPromise(this.f.event)}while(!0)}}}static map(V,ge){return new ue(async _=>{for await(const ie of V)_.emitOne(ge(ie))})}map(V){return ue.map(this,V)}static filter(V,ge){return new ue(async _=>{for await(const ie of V)ge(ie)&&_.emitOne(ie)})}filter(V){return ue.filter(this,V)}static coalesce(V){return ue.filter(V,ge=>!!ge)}coalesce(){return ue.coalesce(this)}static async toPromise(V){const ge=[];for await(const _ of V)ge.push(_);return ge}toPromise(){return ue.toPromise(this)}g(V){this.a===0&&(this.b.push(V),this.f.fire())}h(V){this.a===0&&(this.b=this.b.concat(V),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(V){this.a===0&&(this.a=2,this.d=V,this.f.fire())}}e.$ch=ue;class ve extends ue{constructor(V,ge){super(ge),this.l=V}cancel(){this.l.cancel()}}e.$dh=ve;function J(U){const V=new C.$Wd,ge=U(V.token);return new ve(V,async _=>{const ie=V.token.onCancellationRequested(()=>{ie.dispose(),V.dispose(),_.reject(new T.$4)});try{for await(const re of ge){if(V.token.isCancellationRequested)return;_.emitOne(re)}ie.dispose(),V.dispose()}catch(re){ie.dispose(),V.dispose(),_.reject(re)}})}e.$eh=J}),define(De[35],Ce([1,0,19,9,32,28,16,12,15]),function(me,e,C,T,d,M,A,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=void 0;function w(){return Object.create(null)}e.$pj=w,e.$qj="**",e.$rj="/";const R="[/\\\\]",I="[^/\\\\]",p=/\//g;function y(fe,x){switch(fe){case 0:return"";case 1:return`${I}*?`;default:return`(?:${R}|${I}+${R}${x?`|${R}${I}+`:""})*?`}}function D(fe,x){if(!fe)return[];const Z=[];let q=!1,Y=!1,be="";for(const ue of fe){switch(ue){case x:if(!q&&!Y){Z.push(be),be="";continue}break;case"{":q=!0;break;case"}":q=!1;break;case"[":Y=!0;break;case"]":Y=!1;break}be+=ue}return be&&Z.push(be),Z}e.$sj=D;function v(fe){if(!fe)return"";let x="";const Z=D(fe,e.$rj);if(Z.every(q=>q===e.$qj))x=".*";else{let q=!1;Z.forEach((Y,be)=>{if(Y===e.$qj){if(q)return;x+=y(2,be===Z.length-1)}else{let ue=!1,ve="",J=!1,U="";for(const V of Y){if(V!=="}"&&ue){ve+=V;continue}if(J&&(V!=="]"||!U)){let ge;V==="-"?ge=V:(V==="^"||V==="!")&&!U?ge="^":V===e.$rj?ge="":ge=(0,E.$Ee)(V),U+=ge;continue}switch(V){case"{":ue=!0;continue;case"[":J=!0;continue;case"}":{const _=`(?:${D(ve,",").map(ie=>v(ie)).join("|")})`;x+=_,ue=!1,ve="";break}case"]":{x+="["+U+"]",J=!1,U="";break}case"?":x+=I;continue;case"*":x+=y(1);continue;default:x+=(0,E.$Ee)(V)}}be<Z.length-1&&(Z[be+1]!==e.$qj||be+2<Z.length)&&(x+=R)}q=Y===e.$qj})}return x}const l=/^\*\*\/\*\.[\w\.-]+$/,s=/^\*\*\/([\w\.-]+)\/?$/,r=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,c=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,m=/^\*\*((\/[\w\.-]+)+)\/?$/,h=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new M.$Cc(1e4),n=function(){return!1},o=function(){return null};function i(fe,x){if(!fe)return o;let Z;typeof fe!="string"?Z=fe.pattern:Z=fe,Z=Z.trim();const q=`${Z}_${!!x.trimForExclusions}`;let Y=t.get(q);if(Y)return a(Y,fe);let be;return l.test(Z)?Y=k(Z.substr(4),Z):(be=s.exec(u(Z,x)))?Y=S(be[1],Z):(x.trimForExclusions?c:r).test(Z)?Y=$(Z,x):(be=m.exec(u(Z,x)))?Y=g(be[1].substr(1),Z,!0):(be=h.exec(u(Z,x)))?Y=g(be[1],Z,!1):Y=f(Z),t.set(q,Y),a(Y,fe)}function a(fe,x){if(typeof x=="string")return fe;const Z=function(q,Y){return(0,d.$Wf)(q,x.base,!b.$l)?fe((0,E.$Ie)(q.substr(x.base.length),A.sep),Y):null};return Z.allBasenames=fe.allBasenames,Z.allPaths=fe.allPaths,Z.basenames=fe.basenames,Z.patterns=fe.patterns,Z}function u(fe,x){return x.trimForExclusions&&fe.endsWith("/**")?fe.substr(0,fe.length-2):fe}function k(fe,x){return function(Z,q){return typeof Z=="string"&&Z.endsWith(fe)?x:null}}function S(fe,x){const Z=`/${fe}`,q=`\\${fe}`,Y=function(ue,ve){return typeof ue!="string"?null:ve?ve===fe?x:null:ue===fe||ue.endsWith(Z)||ue.endsWith(q)?x:null},be=[fe];return Y.basenames=be,Y.patterns=[x],Y.allBasenames=be,Y}function $(fe,x){const Z=H(fe.slice(1,-1).split(",").map(ve=>i(ve,x)).filter(ve=>ve!==o),fe),q=Z.length;if(!q)return o;if(q===1)return Z[0];const Y=function(ve,J){for(let U=0,V=Z.length;U<V;U++)if(Z[U](ve,J))return fe;return null},be=Z.find(ve=>!!ve.allBasenames);be&&(Y.allBasenames=be.allBasenames);const ue=Z.reduce((ve,J)=>J.allPaths?ve.concat(J.allPaths):ve,[]);return ue.length&&(Y.allPaths=ue),Y}function g(fe,x,Z){const q=A.sep===A.$fc.sep,Y=q?fe:fe.replace(p,A.sep),be=A.sep+Y,ue=A.$fc.sep+fe;let ve;return Z?ve=function(J,U){return typeof J=="string"&&(J===Y||J.endsWith(be)||!q&&(J===fe||J.endsWith(ue)))?x:null}:ve=function(J,U){return typeof J=="string"&&(J===Y||!q&&J===fe)?x:null},ve.allPaths=[(Z?"*/":"./")+fe],ve}function f(fe){try{const x=new RegExp(`^${v(fe)}$`);return function(Z){return x.lastIndex=0,typeof Z=="string"&&x.test(Z)?fe:null}}catch{return o}}function P(fe,x,Z){return!fe||typeof x!="string"?!1:N(fe)(x,void 0,Z)}e.$tj=P;function N(fe,x={}){if(!fe)return n;if(typeof fe=="string"||O(fe)){const Z=i(fe,x);if(Z===o)return n;const q=function(Y,be){return!!Z(Y,be)};return Z.allBasenames&&(q.allBasenames=Z.allBasenames),Z.allPaths&&(q.allPaths=Z.allPaths),q}return z(fe,x)}e.$uj=N;function O(fe){const x=fe;return x?typeof x.base=="string"&&typeof x.pattern=="string":!1}e.$vj=O;function L(fe){return fe.allBasenames||[]}e.$wj=L;function j(fe){return fe.allPaths||[]}e.$xj=j;function z(fe,x){const Z=H(Object.getOwnPropertyNames(fe).map(ve=>F(ve,fe[ve],x)).filter(ve=>ve!==o)),q=Z.length;if(!q)return o;if(!Z.some(ve=>!!ve.requiresSiblings)){if(q===1)return Z[0];const ve=function(V,ge){let _;for(let ie=0,re=Z.length;ie<re;ie++){const Ee=Z[ie](V,ge);if(typeof Ee=="string")return Ee;(0,T.$Fg)(Ee)&&(_||(_=[]),_.push(Ee))}return _?(async()=>{for(const ie of _){const re=await ie;if(typeof re=="string")return re}return null})():null},J=Z.find(V=>!!V.allBasenames);J&&(ve.allBasenames=J.allBasenames);const U=Z.reduce((V,ge)=>ge.allPaths?V.concat(ge.allPaths):V,[]);return U.length&&(ve.allPaths=U),ve}const Y=function(ve,J,U){let V,ge;for(let _=0,ie=Z.length;_<ie;_++){const re=Z[_];re.requiresSiblings&&U&&(J||(J=(0,A.$mc)(ve)),V||(V=J.substr(0,J.length-(0,A.$nc)(ve).length)));const Ee=re(ve,J,V,U);if(typeof Ee=="string")return Ee;(0,T.$Fg)(Ee)&&(ge||(ge=[]),ge.push(Ee))}return ge?(async()=>{for(const _ of ge){const ie=await _;if(typeof ie=="string")return ie}return null})():null},be=Z.find(ve=>!!ve.allBasenames);be&&(Y.allBasenames=be.allBasenames);const ue=Z.reduce((ve,J)=>J.allPaths?ve.concat(J.allPaths):ve,[]);return ue.length&&(Y.allPaths=ue),Y}function F(fe,x,Z){if(x===!1)return o;const q=i(fe,Z);if(q===o)return o;if(typeof x=="boolean")return q;if(x){const Y=x.when;if(typeof Y=="string"){const be=(ue,ve,J,U)=>{if(!U||!q(ue,ve))return null;const V=Y.replace("$(basename)",()=>J),ge=U(V);return(0,T.$Fg)(ge)?ge.then(_=>_?fe:null):ge?fe:null};return be.requiresSiblings=!0,be}}return q}function H(fe,x){const Z=fe.filter(ve=>!!ve.basenames);if(Z.length<2)return fe;const q=Z.reduce((ve,J)=>{const U=J.basenames;return U?ve.concat(U):ve},[]);let Y;if(x){Y=[];for(let ve=0,J=q.length;ve<J;ve++)Y.push(x)}else Y=Z.reduce((ve,J)=>{const U=J.patterns;return U?ve.concat(U):ve},[]);const be=function(ve,J){if(typeof ve!="string")return null;if(!J){let V;for(V=ve.length;V>0;V--){const ge=ve.charCodeAt(V-1);if(ge===47||ge===92)break}J=ve.substr(V)}const U=q.indexOf(J);return U!==-1?Y[U]:null};be.basenames=q,be.patterns=Y,be.allBasenames=q;const ue=fe.filter(ve=>!ve.basenames);return ue.push(be),ue}function K(fe,x){return(0,C.$tb)(fe,x,(Z,q)=>typeof Z=="string"&&typeof q=="string"?Z===q:typeof Z!="string"&&typeof q!="string"?Z.base===q.base&&Z.pattern===q.pattern:!1)}e.$yj=K}),define(De[79],Ce([1,0,8,161,24,15,2]),function(me,e,C,T,d,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8j=e.$7j=e.$6j=e.$5j=e.$4j=e.$3j=e.$2j=e.$1j=e.MarkdownStringTextNewlineStyle=void 0;var b;(function(l){l[l.Paragraph=0]="Paragraph",l[l.Break=1]="Break"})(b||(e.MarkdownStringTextNewlineStyle=b={}));class E{constructor(s="",r=!1){if(this.value=s,typeof this.value!="string")throw(0,C.$6)("value");typeof r=="boolean"?(this.isTrusted=r,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=r.isTrusted??void 0,this.supportThemeIcons=r.supportThemeIcons??!1,this.supportHtml=r.supportHtml??!1)}appendText(s,r=0){return this.value+=p(this.supportThemeIcons?(0,T.$Uj)(s):s).replace(/([ \t]+)/g,(c,m)=>"&nbsp;".repeat(m.length)).replace(/\>/gm,"\\>").replace(/\n/g,r===1?`\\
`:`

`),this}appendMarkdown(s){return this.value+=s,this}appendCodeblock(s,r){return this.value+="\n```",this.value+=s,this.value+=`
`,this.value+=r,this.value+="\n```\n",this}appendLink(s,r,c){return this.value+="[",this.value+=this.c(r,"]"),this.value+="](",this.value+=this.c(String(s),")"),c&&(this.value+=` "${this.c(this.c(c,'"'),")")}"`),this.value+=")",this}c(s,r){const c=new RegExp((0,M.$Ee)(r),"g");return s.replace(c,(m,h)=>s.charAt(h-1)!=="\\"?`\\${m}`:m)}}e.$1j=E;function w(l){return R(l)?!l.value:Array.isArray(l)?l.every(w):!0}e.$2j=w;function R(l){return l instanceof E?!0:l&&typeof l=="object"?typeof l.value=="string"&&(typeof l.isTrusted=="boolean"||typeof l.isTrusted=="object"||l.isTrusted===void 0)&&(typeof l.supportThemeIcons=="boolean"||l.supportThemeIcons===void 0):!1}e.$3j=R;function I(l,s){return l===s?!0:!l||!s?!1:l.value===s.value&&l.isTrusted===s.isTrusted&&l.supportThemeIcons===s.supportThemeIcons&&l.supportHtml===s.supportHtml&&(l.baseUri===s.baseUri||!!l.baseUri&&!!s.baseUri&&(0,d.$ng)(A.URI.from(l.baseUri),A.URI.from(s.baseUri)))}e.$4j=I;function p(l){return l.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$5j=p;function y(l){return l.replace(/"/g,"&quot;")}e.$6j=y;function D(l){return l&&l.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$7j=D;function v(l){const s=[],r=l.split("|").map(m=>m.trim());l=r[0];const c=r[1];if(c){const m=/height=(\d+)/.exec(c),h=/width=(\d+)/.exec(c),t=m?m[1]:"",n=h?h[1]:"",o=isFinite(parseInt(n)),i=isFinite(parseInt(t));o&&s.push(`width="${n}"`),i&&s.push(`height="${t}"`)}return{href:l,dimensions:s}}e.$8j=v}),define(De[99],Ce([1,0,19,32,16,12,24,15]),function(me,e,C,T,d,M,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uv=e.$tv=e.$sv=e.$rv=e.$qv=e.$pv=e.$ov=e.$nv=e.$mv=e.$lv=void 0;function E(i,a){const{os:u,tildify:k,relative:S}=a;if(S){const f=w(i,S,u);if(typeof f=="string")return f}let $=i.fsPath;if(u===1&&!M.$j?$=$.replace(/\//g,"\\"):u!==1&&M.$j&&($=$.replace(/\\/g,"/")),u!==1&&k?.userHome){const f=k.userHome.fsPath;let P;i.scheme!==k.userHome.scheme&&i.path.startsWith(d.$fc.sep)?P=k.userHome.with({path:i.path}).fsPath:P=i.fsPath,$=p(P,f,u)}return(u===1?d.$ec:d.$fc).normalize(R($,u===1))}e.$lv=E;function w(i,a,u){const k=u===1?d.$ec:d.$fc,S=u===3?A.$kg:A.$mg,$=a.getWorkspace(),g=(0,C.$Nb)($.folders);if(!g)return;i.scheme!==g.uri.scheme&&i.path.startsWith(d.$fc.sep)&&(i=g.uri.with({path:i.path}));const f=a.getWorkspaceFolder(i);if(!f)return;let P;if(S.isEqual(f.uri,i)?P="":P=S.relativePath(f.uri,i)??"",P&&(P=k.normalize(P)),$.folders.length>1&&!a.noPrefix){const N=f.name?f.name:S.basenameOrAuthority(f.uri);P=P?`${N} \u2022 ${P}`:N}return P}function R(i,a=M.$j){return(0,T.$1f)(i,a)?i.charAt(0).toUpperCase()+i.slice(1):i}e.$mv=R;let I=Object.create(null);function p(i,a,u=M.OS){if(u===1||!i||!a)return i;let k=I.original===a?I.normalized:void 0;k||(k=a,M.$j&&(k=(0,T.$Qf)(k)),k=`${(0,b.$Je)(k,d.$fc.sep)}${d.$fc.sep}`,I={original:a,normalized:k});let S=i;return M.$j&&(S=(0,T.$Qf)(S)),(u===3?S.startsWith(k):(0,b.$2e)(S,k))?`~/${S.substr(k.length)}`:i}e.$nv=p;function y(i,a){return i.replace(/^~($|\/|\\)/,`${a}$1`)}e.$ov=y;const D="\u2026",v="\\\\",l="~";function s(i,a=d.sep){const u=new Array(i.length);let k=!1;for(let S=0;S<i.length;S++){const $=i[S];if($===""){u[S]=`.${a}`;continue}if(!$){u[S]=$;continue}k=!0;let g="",f=$;f.indexOf(v)===0?(g=f.substr(0,f.indexOf(v)+v.length),f=f.substr(f.indexOf(v)+v.length)):f.indexOf(a)===0?(g=f.substr(0,f.indexOf(a)+a.length),f=f.substr(f.indexOf(a)+a.length)):f.indexOf(l)===0&&(g=f.substr(0,f.indexOf(l)+l.length),f=f.substr(f.indexOf(l)+l.length));const P=f.split(a);for(let N=1;k&&N<=P.length;N++)for(let O=P.length-N;k&&O>=0;O--){k=!1;let L=P.slice(O,O+N).join(a);for(let j=0;!k&&j<i.length;j++)if(j!==S&&i[j]&&i[j].indexOf(L)>-1){const z=O+N===P.length,F=O>0&&i[j].indexOf(a)>-1?a+L:L,H=i[j].endsWith(F);k=!z||H}if(!k){let j="";(P[0].endsWith(":")||g!=="")&&(O===1&&(O=0,N++,L=P[0]+a+L),O>0&&(j=P[0]+a),j=g+j),O>0&&(j=j+D+a),j=j+L,O+N<P.length&&(j=j+a+D),u[S]=j}}k&&(u[S]=$)}return u}e.$pv=s;var r;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(r||(r={}));function c(i,a=Object.create(null)){const u=[];let k=!1,S="";for(const $ of i)if($==="$"||k&&$==="{")S&&u.push({value:S,type:r.TEXT}),S="",k=!0;else if($==="}"&&k){const g=a[S];if(typeof g=="string")g.length&&u.push({value:g,type:r.VARIABLE});else if(g){const f=u[u.length-1];(!f||f.type!==r.SEPARATOR)&&u.push({value:g.label,type:r.SEPARATOR})}S="",k=!1}else S+=$;return S&&!k&&u.push({value:S,type:r.TEXT}),u.filter(($,g)=>{if($.type===r.SEPARATOR){const f=u[g-1],P=u[g+1];return[f,P].every(N=>N&&(N.type===r.VARIABLE||N.type===r.TEXT)&&N.value.length>0)}return!0}).map($=>$.value).join("")}e.$qv=c;function m(i,a){return M.$k||a?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.$k?"&":"&&"):i.replace(/&&|&/g,u=>u==="&"?"&&":"&")}e.$rv=m;function h(i,a){return M.$k||a?i.replace(/\(&&\w\)|&&/g,""):M.$j?i.replace(/&&|&/g,u=>u==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.$sv=h;function t(i){return i.replace(/&/g,"&&")}e.$tv=t;function n(i){if(i.endsWith("]")){const a=i.lastIndexOf(" [",i.length-2);if(a!==-1){const u=o(i.substring(0,a));return{name:u.name,parentPath:u.parentPath+i.substring(a)}}}return o(i)}e.$uv=n;function o(i){const a=i.indexOf("/")!==-1?d.$fc:d.$ec,u=a.basename(i),k=a.dirname(i);return u.length?{name:u,parentPath:k}:{name:k,parentPath:""}}}),define(De[128],Ce([1,0,22,2]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lm=e.$Km=e.$Jm=e.$Im=e.$Hm=void 0;function d(I){return I.toJSON()}class M{constructor(p){this.a=p}transformIncoming(p){const y=this.a.transformIncoming(p);return y===p?p:d(T.URI.from(y))}transformOutgoing(p){const y=this.a.transformOutgoing(p);return y===p?p:d(T.URI.from(y))}transformOutgoingURI(p){const y=this.a.transformOutgoing(p);return y===p?p:T.URI.from(y)}transformOutgoingScheme(p){return this.a.transformOutgoingScheme(p)}}e.$Hm=M,e.$Im=new class{transformIncoming(I){return I}transformOutgoing(I){return I}transformOutgoingURI(I){return I}transformOutgoingScheme(I){return I}};function A(I,p,y){if(!I||y>200)return null;if(typeof I=="object"){if(I instanceof T.URI)return p.transformOutgoing(I);for(const D in I)if(Object.hasOwnProperty.call(I,D)){const v=A(I[D],p,y+1);v!==null&&(I[D]=v)}}return null}function b(I,p){const y=A(I,p,0);return y===null?I:y}e.$Jm=b;function E(I,p,y,D){if(!I||D>200)return null;if(typeof I=="object"){if(I.$mid===1)return y?T.URI.revive(p.transformIncoming(I)):p.transformIncoming(I);if(I instanceof C.$ae)return null;for(const v in I)if(Object.hasOwnProperty.call(I,v)){const l=E(I[v],p,y,D+1);l!==null&&(I[v]=l)}}return null}function w(I,p){const y=E(I,p,!1,0);return y===null?I:y}e.$Km=w;function R(I,p){const y=E(I,p,!0,0);return y===null?I:y}e.$Lm=R}),define(De[29],Ce([1,0,53,63,370,9,32,76,16,12,24,2]),function(me,e,C,T,d,M,A,b,E,w,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var p;(function(F){F[F.UNLINK=0]="UNLINK",F[F.MOVE=1]="MOVE"})(p||(e.RimRafMode=p={}));async function y(F,H=p.UNLINK,K){if((0,A.$Zf)(F))throw new Error("rimraf - will refuse to recursively delete root");return H===p.UNLINK?v(F):D(F,K)}async function D(F,H=(0,A.$5f)((0,T.tmpdir)())){try{try{await C.promises.rename(F,H)}catch(K){return K.code==="ENOENT"?void 0:v(F)}v(H).catch(K=>{})}catch(K){if(K.code!=="ENOENT")throw K}}async function v(F){return(0,d.promisify)(C.rm)(F,{recursive:!0,force:!0,maxRetries:3})}function l(F){if((0,A.$Zf)(F))throw new Error("rimraf - will refuse to recursively delete root");C.rmSync(F,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=l;async function s(F,H){return m(await(H?r(F):(0,d.promisify)(C.readdir)(F)))}async function r(F){try{return await(0,d.promisify)(C.readdir)(F,{withFileTypes:!0})}catch(fe){console.warn("[node.js fs] readdir with filetypes failed with error: ",fe)}const H=[],K=await s(F);for(const fe of K){let x=!1,Z=!1,q=!1;try{const Y=await e.Promises.lstat((0,E.$ic)(F,fe));x=Y.isFile(),Z=Y.isDirectory(),q=Y.isSymbolicLink()}catch(Y){console.warn("[node.js fs] unexpected error from lstat after readdir: ",Y)}H.push({name:fe,isFile:()=>x,isDirectory:()=>Z,isSymbolicLink:()=>q})}return H}function c(F){return m(C.readdirSync(F))}e.readdirSync=c;function m(F){return F.map(H=>typeof H=="string"?w.$k?(0,b.$kl)(H):H:(H.name=w.$k?(0,b.$kl)(H.name):H.name,H))}async function h(F){const H=await s(F),K=[];for(const fe of H)await n.existsDirectory((0,E.$ic)(F,fe))&&K.push(fe);return K}function t(F,H=1e3){return new Promise(K=>{let fe=!1;const x=setInterval(()=>{fe||(fe=!0,C.access(F,Z=>{fe=!1,Z&&(clearInterval(x),K(void 0))}))},H)})}e.whenDeleted=t;var n;(function(F){async function H(x){let Z;try{if(Z=await e.Promises.lstat(x),!Z.isSymbolicLink())return{stat:Z}}catch{}try{return{stat:await e.Promises.stat(x),symbolicLink:Z?.isSymbolicLink()?{dangling:!1}:void 0}}catch(q){if(q.code==="ENOENT"&&Z)return{stat:Z,symbolicLink:{dangling:!0}};if(w.$j&&q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(x)),symbolicLink:{dangling:!1}}}catch(Y){if(Y.code==="ENOENT"&&Z)return{stat:Z,symbolicLink:{dangling:!0}};throw Y}throw q}}F.stat=H;async function K(x){try{const{stat:Z,symbolicLink:q}=await F.stat(x);return Z.isFile()&&q?.dangling!==!0}catch{}return!1}F.existsFile=K;async function fe(x){try{const{stat:Z,symbolicLink:q}=await F.stat(x);return Z.isDirectory()&&q?.dangling!==!0}catch{}return!1}F.existsDirectory=fe})(n||(e.SymlinkSupport=n={}));const o=new M.$2g;function i(F,H,K){return o.queueFor(I.URI.file(F),R.$lg).queue(()=>{const fe=$(K);return new Promise((x,Z)=>k(F,H,fe,q=>q?Z(q):x()))})}let a=!0;function u(F){a=F}e.configureFlushOnWrite=u;function k(F,H,K,fe){if(!a)return C.writeFile(F,H,{mode:K.mode,flag:K.flag},fe);C.open(F,K.flag,K.mode,(x,Z)=>{if(x)return fe(x);C.writeFile(Z,H,q=>{if(q)return C.close(Z,()=>fe(q));C.fdatasync(Z,Y=>(Y&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",Y),u(!1)),C.close(Z,be=>fe(be))))})})}function S(F,H,K){const fe=$(K);if(!a)return C.writeFileSync(F,H,{mode:fe.mode,flag:fe.flag});const x=C.openSync(F,fe.flag,fe.mode);try{C.writeFileSync(x,H);try{C.fdatasyncSync(x)}catch(Z){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",Z),u(!1)}}finally{C.closeSync(x)}}e.writeFileSync=S;function $(F){return F?{mode:typeof F.mode=="number"?F.mode:438,flag:typeof F.flag=="string"?F.flag:"w"}:{mode:438,flag:"w"}}async function g(F,H,K=6e4){if(F!==H)try{w.$j&&typeof K=="number"?await f(F,H,Date.now(),K):await(0,d.promisify)(C.rename)(F,H)}catch(fe){if(F.toLowerCase()!==H.toLowerCase()&&fe.code==="EXDEV"||F.endsWith("."))await P(F,H,{preserveSymlinks:!1}),await y(F,p.MOVE);else throw fe}}async function f(F,H,K,fe,x=0){try{return await(0,d.promisify)(C.rename)(F,H)}catch(Z){if(Z.code!=="EACCES"&&Z.code!=="EPERM"&&Z.code!=="EBUSY")throw Z;if(Date.now()-K>=fe)throw console.error(`[node.js fs] rename failed after ${x} retries with error: ${Z}`),Z;if(x===0){let q=!1;try{const{stat:Y}=await n.stat(H);Y.isFile()||(q=!0)}catch{}if(q)throw Z}return await(0,M.$Tg)(Math.min(100,x*10)),f(F,H,K,fe,x+1)}}async function P(F,H,K){return O(F,H,{root:{source:F,target:H},options:K,handledSourcePaths:new Set})}const N=511;async function O(F,H,K){if(K.handledSourcePaths.has(F))return;K.handledSourcePaths.add(F);const{stat:fe,symbolicLink:x}=await n.stat(F);if(x){if(K.options.preserveSymlinks)try{return await z(F,H,K)}catch(Z){console.warn("[node.js fs] copy of symlink failed: ",Z)}if(x.dangling)return}return fe.isDirectory()?L(F,H,fe.mode&N,K):j(F,H,fe.mode&N)}async function L(F,H,K,fe){await e.Promises.mkdir(H,{recursive:!0,mode:K});const x=await s(F);for(const Z of x)await O((0,E.$ic)(F,Z),(0,E.$ic)(H,Z),fe)}async function j(F,H,K){await e.Promises.copyFile(F,H),await e.Promises.chmod(H,K)}async function z(F,H,K){let fe=await e.Promises.readlink(F);(0,A.$Wf)(fe,K.root.source,!w.$l)&&(fe=(0,E.$ic)(K.root.target,fe.substr(K.root.source.length+1))),await e.Promises.symlink(fe,H)}e.Promises=new class{get access(){return(0,d.promisify)(C.access)}get stat(){return(0,d.promisify)(C.stat)}get lstat(){return(0,d.promisify)(C.lstat)}get utimes(){return(0,d.promisify)(C.utimes)}get read(){return(F,H,K,fe,x)=>new Promise((Z,q)=>{C.read(F,H,K,fe,x,(Y,be,ue)=>Y?q(Y):Z({bytesRead:be,buffer:ue}))})}get readFile(){return(0,d.promisify)(C.readFile)}get write(){return(F,H,K,fe,x)=>new Promise((Z,q)=>{C.write(F,H,K,fe,x,(Y,be,ue)=>Y?q(Y):Z({bytesWritten:be,buffer:ue}))})}get appendFile(){return(0,d.promisify)(C.appendFile)}get fdatasync(){return(0,d.promisify)(C.fdatasync)}get truncate(){return(0,d.promisify)(C.truncate)}get copyFile(){return(0,d.promisify)(C.copyFile)}get open(){return(0,d.promisify)(C.open)}get close(){return(0,d.promisify)(C.close)}get symlink(){return(0,d.promisify)(C.symlink)}get readlink(){return(0,d.promisify)(C.readlink)}get chmod(){return(0,d.promisify)(C.chmod)}get mkdir(){return(0,d.promisify)(C.mkdir)}get unlink(){return(0,d.promisify)(C.unlink)}get rmdir(){return(0,d.promisify)(C.rmdir)}get realpath(){return(0,d.promisify)(C.realpath)}async exists(F){try{return await e.Promises.access(F),!0}catch{return!1}}get readdir(){return s}get readDirsInDir(){return h}get writeFile(){return i}get rm(){return y}get rename(){return g}get copy(){return P}}}),define(De[100],Ce([1,0,53,16,12,15,29]),function(me,e,C,T,d,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4p=e.$3p=e.$2p=e.$1p=void 0;function b(p){if(d.$l)return p;const y=(0,T.$lc)(p);if(p===y)return p;const D=((0,T.$mc)(p)||p).toLowerCase();try{const l=(0,A.readdirSync)(y).filter(s=>s.toLowerCase()===D);if(l.length===1){const s=b(y);if(s)return(0,T.$ic)(s,l[0])}else if(l.length>1){const s=l.indexOf(D);if(s>=0){const r=b(y);if(r)return(0,T.$ic)(r,l[s])}}}catch{}return null}e.$1p=b;async function E(p){if(d.$l)return p;const y=(0,T.$lc)(p);if(p===y)return p;const D=((0,T.$mc)(p)||p).toLowerCase();try{const l=(await A.Promises.readdir(y)).filter(s=>s.toLowerCase()===D);if(l.length===1){const s=await E(y);if(s)return(0,T.$ic)(s,l[0])}else if(l.length>1){const s=l.indexOf(D);if(s>=0){const r=await E(y);if(r)return(0,T.$ic)(r,l[s])}}}catch{}return null}e.$2p=E;async function w(p){try{return await A.Promises.realpath(p)}catch{const D=I(p);return await A.Promises.access(D,C.constants.R_OK),D}}e.$3p=w;function R(p){try{return C.realpathSync(p)}catch{const D=I(p);return C.accessSync(D,C.constants.R_OK),D}}e.$4p=R;function I(p){return(0,M.$Je)((0,T.$gc)(p),T.sep)}}),define(De[101],Ce([1,0,16,12,47,98,18,29]),function(me,e,C,T,d,M,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$yl=e.$xl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return M.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return M.TerminateResponseCode}});function E(I=d.env){return I.comspec||"cmd.exe"}e.$xl=E;function w(I){let p=[],y=!1;const D=function(v){if(y){p.push(v);return}(!I.send(v,s=>{if(s&&console.error(s),y=!1,p.length>0){const r=p.slice(0);p=[],r.forEach(c=>D(c))}})||T.$j)&&(y=!0)};return{send:D}}e.$yl=w;var R;(function(I){async function p(y,D,v){if(C.$hc(y))return y;if(D===void 0&&(D=d.cwd()),C.$lc(y)!=="."||(v===void 0&&A.$xf(d.env.PATH)&&(v=d.env.PATH.split(C.$sc)),v===void 0||v.length===0))return C.$ic(D,y);async function s(r){if(await b.Promises.exists(r)){let c;try{c=await b.Promises.stat(r)}catch(m){m.message.startsWith("EACCES")&&(c=await b.Promises.lstat(r))}return c?!c.isDirectory():!1}return!1}for(const r of v){let c;if(C.$hc(r)?c=C.$ic(r,y):c=C.$ic(D,r,y),await s(c))return c;let m=c+".com";if(await s(m)||(m=c+".exe",await s(m)))return m}return C.$ic(D,y)}I.findExecutable=p})(R||(e.win32=R={}))});var He=this&&this.__decorate||function(me,e,C,T){var d=arguments.length,M=d<3?e:T===null?T=Object.getOwnPropertyDescriptor(e,C):T,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(me,e,C,T);else for(var b=me.length-1;b>=0;b--)(A=me[b])&&(M=(d<3?A(M):d>3?A(e,C,M):A(e,C))||M);return d>3&&M&&Object.defineProperty(e,C,M),M};define(De[80],Ce([1,0,19,9,22,21,57,8,4,3,62,15,18]),function(me,e,C,T,d,M,A,b,E,w,R,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wh=e.ProxyChannel=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.RequestInitiator=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=void 0;var y;(function(x){x[x.Promise=100]="Promise",x[x.PromiseCancel=101]="PromiseCancel",x[x.EventListen=102]="EventListen",x[x.EventDispose=103]="EventDispose"})(y||(y={}));function D(x){switch(x){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var v;(function(x){x[x.Initialize=200]="Initialize",x[x.PromiseSuccess=201]="PromiseSuccess",x[x.PromiseError=202]="PromiseError",x[x.PromiseErrorObj=203]="PromiseErrorObj",x[x.EventFire=204]="EventFire"})(v||(v={}));function l(x){switch(x){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var s;(function(x){x[x.Uninitialized=0]="Uninitialized",x[x.Idle=1]="Idle"})(s||(s={}));function r(x){let Z=0;for(let q=0;;q+=7){const Y=x.read(1);if(Z|=(Y.buffer[0]&127)<<q,!(Y.buffer[0]&128))return Z}}const c=o(0);function m(x,Z){if(Z===0){x.write(c);return}let q=0;for(let be=Z;be!==0;be=be>>>7)q++;const Y=d.$ae.alloc(q);for(let be=0;Z!==0;be++)Y.buffer[be]=Z&127,Z=Z>>>7,Z>0&&(Y.buffer[be]|=128);x.write(Y)}class h{constructor(Z){this.b=Z,this.a=0}read(Z){const q=this.b.slice(this.a,this.a+Z);return this.a+=q.byteLength,q}}e.$lh=h;class t{constructor(){this.a=[]}get buffer(){return d.$ae.concat(this.a)}write(Z){this.a.push(Z)}}e.$mh=t;var n;(function(x){x[x.Undefined=0]="Undefined",x[x.String=1]="String",x[x.Buffer=2]="Buffer",x[x.VSBuffer=3]="VSBuffer",x[x.Array=4]="Array",x[x.Object=5]="Object",x[x.Int=6]="Int"})(n||(n={}));function o(x){const Z=d.$ae.alloc(1);return Z.writeUInt8(x,0),Z}const i={Undefined:o(n.Undefined),String:o(n.String),Buffer:o(n.Buffer),VSBuffer:o(n.VSBuffer),Array:o(n.Array),Object:o(n.Object),Uint:o(n.Int)},a=typeof Buffer<"u";function u(x,Z){if(typeof Z>"u")x.write(i.Undefined);else if(typeof Z=="string"){const q=d.$ae.fromString(Z);x.write(i.String),m(x,q.byteLength),x.write(q)}else if(a&&Buffer.isBuffer(Z)){const q=d.$ae.wrap(Z);x.write(i.Buffer),m(x,q.byteLength),x.write(q)}else if(Z instanceof d.$ae)x.write(i.VSBuffer),m(x,Z.byteLength),x.write(Z);else if(Array.isArray(Z)){x.write(i.Array),m(x,Z.length);for(const q of Z)u(x,q)}else if(typeof Z=="number"&&(Z|0)===Z)x.write(i.Uint),m(x,Z);else{const q=d.$ae.fromString(JSON.stringify(Z));x.write(i.Object),m(x,q.byteLength),x.write(q)}}e.$nh=u;function k(x){switch(x.read(1).readUInt8(0)){case n.Undefined:return;case n.String:return x.read(r(x)).toString();case n.Buffer:return x.read(r(x)).buffer;case n.VSBuffer:return x.read(r(x));case n.Array:{const q=r(x),Y=[];for(let be=0;be<q;be++)Y.push(k(x));return Y}case n.Object:return JSON.parse(x.read(r(x)).toString());case n.Int:return r(x)}}e.$oh=k;class S{constructor(Z,q,Y=null,be=1e3){this.h=Z,this.j=q,this.k=Y,this.l=be,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ue=>this.q(ue)),this.m({type:200})}registerChannel(Z,q){this.b.set(Z,q),setTimeout(()=>this.w(Z),0)}m(Z){switch(Z.type){case 200:{const q=this.o([Z.type]);this.k?.logOutgoing(q,0,1,l(Z.type));return}case 201:case 202:case 204:case 203:{const q=this.o([Z.type,Z.id],Z.data);this.k?.logOutgoing(q,Z.id,1,l(Z.type),Z.data);return}}}o(Z,q=void 0){const Y=new t;return u(Y,Z),u(Y,q),this.p(Y.buffer)}p(Z){try{return this.h.send(Z),Z.byteLength}catch{return 0}}q(Z){const q=new h(Z),Y=k(q),be=k(q),ue=Y[0];switch(ue){case 100:return this.k?.logIncoming(Z.byteLength,Y[1],1,`${D(ue)}: ${Y[2]}.${Y[3]}`,be),this.s({type:ue,id:Y[1],channelName:Y[2],name:Y[3],arg:be});case 102:return this.k?.logIncoming(Z.byteLength,Y[1],1,`${D(ue)}: ${Y[2]}.${Y[3]}`,be),this.t({type:ue,id:Y[1],channelName:Y[2],name:Y[3],arg:be});case 101:return this.k?.logIncoming(Z.byteLength,Y[1],1,`${D(ue)}`),this.u({type:ue,id:Y[1]});case 103:return this.k?.logIncoming(Z.byteLength,Y[1],1,`${D(ue)}`),this.u({type:ue,id:Y[1]})}}s(Z){const q=this.b.get(Z.channelName);if(!q){this.v(Z);return}const Y=new M.$Wd;let be;try{be=q.call(this.j,Z.name,Z.arg,Y.token)}catch(J){be=Promise.reject(J)}const ue=Z.id;be.then(J=>{this.m({id:ue,data:J,type:201})},J=>{J instanceof Error?this.m({id:ue,data:{message:J.message,name:J.name,stack:J.stack?J.stack.split?J.stack.split(`
`):J.stack:void 0},type:202}):this.m({id:ue,data:J,type:203})}).finally(()=>{ve.dispose(),this.d.delete(Z.id)});const ve=(0,w.$Pc)(()=>Y.cancel());this.d.set(Z.id,ve)}t(Z){const q=this.b.get(Z.channelName);if(!q){this.v(Z);return}const Y=Z.id,ue=q.listen(this.j,Z.name,Z.arg)(ve=>this.m({id:Y,data:ve,type:204}));this.d.set(Z.id,ue)}u(Z){const q=this.d.get(Z.id);q&&(q.dispose(),this.d.delete(Z.id))}v(Z){let q=this.g.get(Z.channelName);q||(q=[],this.g.set(Z.channelName,q));const Y=setTimeout(()=>{console.error(`Unknown channel: ${Z.channelName}`),Z.type===100&&this.m({id:Z.id,data:{name:"Unknown channel",message:`Channel name '${Z.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);q.push({request:Z,timeoutTimer:Y})}w(Z){const q=this.g.get(Z);if(q){for(const Y of q)switch(clearTimeout(Y.timeoutTimer),Y.request.type){case 100:this.s(Y.request);break;case 102:this.t(Y.request);break}this.g.delete(Z)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,w.$Mc)(this.d.values()),this.d.clear()}}e.$ph=S;var $;(function(x){x[x.LocalSide=0]="LocalSide",x[x.OtherSide=1]="OtherSide"})($||(e.RequestInitiator=$={}));class g{constructor(Z,q=null){this.l=Z,this.a=!1,this.b=s.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new E.$Md,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(Y=>this.s(Y)),this.j=q}getChannel(Z){const q=this;return{call(Y,be,ue){return q.a?Promise.reject(new b.$4):q.m(Z,Y,be,ue)},listen(Y,be){return q.a?E.Event.None:q.o(Z,Y,be)}}}m(Z,q,Y,be=M.CancellationToken.None){const ue=this.g++,J={id:ue,type:100,channelName:Z,name:q,arg:Y};if(be.isCancellationRequested)return Promise.reject(new b.$4);let U;return new Promise((ge,_)=>{if(be.isCancellationRequested)return _(new b.$4);const ie=()=>{const he=ee=>{switch(ee.type){case 201:this.f.delete(ue),ge(ee.data);break;case 202:{this.f.delete(ue);const le=new Error(ee.data.message);le.stack=Array.isArray(ee.data.stack)?ee.data.stack.join(`
`):ee.data.stack,le.name=ee.data.name,_(le);break}case 203:this.f.delete(ue),_(ee.data);break}};this.f.set(ue,he),this.p(J)};let re=null;this.b===s.Idle?ie():(re=(0,T.$Gg)(he=>this.u()),re.then(()=>{re=null,ie()}));const Ee=()=>{re?(re.cancel(),re=null):this.p({id:ue,type:101}),_(new b.$4)},oe=be.onCancellationRequested(Ee);U=(0,w.$Oc)((0,w.$Pc)(Ee),oe),this.d.add(U)}).finally(()=>{U.dispose(),this.d.delete(U)})}o(Z,q,Y){const be=this.g++,ve={id:be,type:102,channelName:Z,name:q,arg:Y};let J=null;const U=new E.$Md({onWillAddFirstListener:()=>{J=(0,T.$Gg)(ge=>this.u()),J.then(()=>{J=null,this.d.add(U),this.p(ve)})},onDidRemoveLastListener:()=>{J?(J.cancel(),J=null):(this.d.delete(U),this.p({id:be,type:103}))}}),V=ge=>U.fire(ge.data);return this.f.set(be,V),U.event}p(Z){switch(Z.type){case 100:case 102:{const q=this.q([Z.type,Z.id,Z.channelName,Z.name],Z.arg);this.j?.logOutgoing(q,Z.id,0,`${D(Z.type)}: ${Z.channelName}.${Z.name}`,Z.arg);return}case 101:case 103:{const q=this.q([Z.type,Z.id]);this.j?.logOutgoing(q,Z.id,0,D(Z.type));return}}}q(Z,q=void 0){const Y=new t;return u(Y,Z),u(Y,q),this.r(Y.buffer)}r(Z){try{return this.l.send(Z),Z.byteLength}catch{return 0}}s(Z){const q=new h(Z),Y=k(q),be=k(q),ue=Y[0];switch(ue){case 200:return this.j?.logIncoming(Z.byteLength,0,0,l(ue)),this.t({type:Y[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(Z.byteLength,Y[1],0,l(ue),be),this.t({type:Y[0],id:Y[1],data:be})}}t(Z){if(Z.type===200){this.b=s.Idle,this.k.fire();return}this.f.get(Z.id)?.(Z)}get onDidInitializePromise(){return E.Event.toPromise(this.onDidInitialize)}u(){return this.b===s.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,w.$Mc)(this.d.values()),this.d.clear()}}e.$qh=g,He([A.$fh],g.prototype,"onDidInitializePromise",null);class f{get connections(){const Z=[];return this.f.forEach(q=>Z.push(q)),Z}constructor(Z){this.a=new Map,this.f=new Set,this.g=new E.$Md,this.onDidAddConnection=this.g.event,this.h=new E.$Md,this.onDidRemoveConnection=this.h.event,this.j=new w.$Qc,this.j.add(Z(({protocol:q,onDidClientDisconnect:Y})=>{const be=E.Event.once(q.onMessage);this.j.add(be(ue=>{const ve=new h(ue),J=k(ve),U=new S(q,J),V=new g(q);this.a.forEach((_,ie)=>U.registerChannel(ie,_));const ge={channelServer:U,channelClient:V,ctx:J};this.f.add(ge),this.g.fire(ge),this.j.add(Y(()=>{U.dispose(),V.dispose(),this.f.delete(ge),this.h.fire(ge)}))}))}))}getChannel(Z,q){const Y=this;return{call(be,ue,ve){let J;if((0,p.$Lf)(q)){const V=(0,C.$3b)(Y.connections.filter(q));J=V?Promise.resolve(V):E.Event.toPromise(E.Event.filter(Y.onDidAddConnection,q))}else J=q.routeCall(Y,be,ue);const U=J.then(V=>V.channelClient.getChannel(Z));return N(U).call(be,ue,ve)},listen(be,ue){if((0,p.$Lf)(q))return Y.k(Z,q,be,ue);const ve=q.routeEvent(Y,be,ue).then(J=>J.channelClient.getChannel(Z));return N(ve).listen(be,ue)}}}k(Z,q,Y,be){const ue=this;let ve;const J=new E.$Md({onWillAddFirstListener:()=>{ve=new w.$Qc;const U=new E.$Sd,V=new Map,ge=ie=>{const Ee=ie.channelClient.getChannel(Z).listen(Y,be),oe=U.add(Ee);V.set(ie,oe)},_=ie=>{const re=V.get(ie);re&&(re.dispose(),V.delete(ie))};ue.connections.filter(q).forEach(ge),E.Event.filter(ue.onDidAddConnection,q)(ge,void 0,ve),ue.onDidRemoveConnection(_,void 0,ve),U.event(J.fire,J,ve),ve.add(U)},onDidRemoveLastListener:()=>{ve?.dispose(),ve=void 0}});return J.event}registerChannel(Z,q){this.a.set(Z,q);for(const Y of this.f)Y.channelServer.registerChannel(Z,q)}dispose(){this.j.dispose();for(const Z of this.f)Z.channelClient.dispose(),Z.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$rh=f;class P{constructor(Z,q,Y=null){const be=new t;u(be,q),Z.send(be.buffer),this.a=new g(Z,Y),this.d=new S(Z,q,Y)}getChannel(Z){return this.a.getChannel(Z)}registerChannel(Z,q){this.d.registerChannel(Z,q)}dispose(){this.a.dispose(),this.d.dispose()}}e.$sh=P;function N(x){return{call(Z,q,Y){return x.then(be=>be.call(Z,q,Y))},listen(Z,q){const Y=new E.$Vd;return x.then(be=>Y.input=be.listen(Z,q)),Y.event}}}e.$th=N;function O(x){let Z=!1;return{call(q,Y,be){return Z?x.call(q,Y,be):(0,T.$Tg)(0).then(()=>Z=!0).then(()=>x.call(q,Y,be))},listen(q,Y){if(Z)return x.listen(q,Y);const be=new E.$Vd;return(0,T.$Tg)(0).then(()=>Z=!0).then(()=>be.input=x.listen(q,Y)),be.event}}}e.$uh=O;class L{constructor(Z){this.a=Z}routeCall(Z){return this.b(Z)}routeEvent(Z){return this.b(Z)}async b(Z){for(const q of Z.connections)if(await Promise.resolve(this.a(q.ctx)))return Promise.resolve(q);return await E.Event.toPromise(Z.onDidAddConnection),await this.b(Z)}}e.$vh=L;var j;(function(x){function Z(ue,ve,J){const U=ue,V=J&&J.disableMarshalling,ge=new Map;for(const _ in U)Y(_)&&ge.set(_,E.Event.buffer(U[_],!0,void 0,ve));return new class{listen(_,ie,re){const Ee=ge.get(ie);if(Ee)return Ee;if(be(ie)){const oe=U[ie];if(typeof oe=="function")return oe.call(U,re)}throw new b.$ab(`Event not found: ${ie}`)}call(_,ie,re){const Ee=U[ie];if(typeof Ee=="function"){if(!V&&Array.isArray(re))for(let he=0;he<re.length;he++)re[he]=(0,R.$kh)(re[he]);let oe=Ee.apply(U,re);return oe instanceof Promise||(oe=Promise.resolve(oe)),oe}throw new b.$ab(`Method not found: ${ie}`)}}}x.fromService=Z;function q(ue,ve){const J=ve&&ve.disableMarshalling;return new Proxy({},{get(U,V){if(typeof V=="string")return ve?.properties?.has(V)?ve.properties.get(V):be(V)?function(ge){return ue.listen(V,ge)}:Y(V)?ue.listen(V):async function(...ge){let _;ve&&!(0,p.$Gf)(ve.context)?_=[ve.context,...ge]:_=ge;const ie=await ue.call(V,_);return J?ie:(0,R.$kh)(ie)};throw new b.$ab(`Property not found: ${String(V)}`)}})}x.toService=q;function Y(ue){return ue[0]==="o"&&ue[1]==="n"&&I.$Ze(ue.charCodeAt(2))}function be(ue){return/^onDynamic/.test(ue)&&I.$Ze(ue.charCodeAt(9))}})(j||(e.ProxyChannel=j={}));const z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function F(x){if(Array.isArray(x))return x;if(x&&typeof x=="object"&&typeof x.toString=="function"){const Z=x.toString();if(Z!=="[object Object]")return Z}return x}function H(x){return Array.isArray(x)?x.map(F):F(x)}function K(x,Z,q,Y,be,ue,ve){ve=H(ve);const J=z[be],U=J[Y%J.length];let V=[`%c[${x}]%c[${String(Z).padStart(7," ")}]%c[len: ${String(q).padStart(5," ")}]%c${String(Y).padStart(5," ")} - ${ue}`,"color: darkgreen","color: grey","color: grey",`color: ${U}`];/\($/.test(ue)?(V=V.concat(ve),V.push(")")):V.push(ve),console.log.apply(console,V)}class fe{constructor(Z,q){this.d=Z,this.f=q,this.a=0,this.b=0}logOutgoing(Z,q,Y,be,ue){this.b+=Z,K(this.d,this.b,Z,q,Y,be,ue)}logIncoming(Z,q,Y,be,ue){this.a+=Z,K(this.f,this.a,Z,q,Y,be,ue)}}e.$wh=fe}),define(De[81],Ce([1,0,22,4,3,80]),function(me,e,C,T,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bh=e.$Ah=e.$zh=e.$yh=e.ProtocolConstants=e.$xh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(A||(e.SocketDiagnosticsEventType=A={}));var b;(function(i){i.enableDiagnostics=!1,i.records=[];const a=new WeakMap;let u=0;function k($,g){if(!a.has($)){const f=String(++u);a.set($,f)}return a.get($)}function S($,g,f,P){if(!i.enableDiagnostics)return;const N=k($,g);if(P instanceof C.$ae||P instanceof Uint8Array||P instanceof ArrayBuffer||ArrayBuffer.isView(P)){const O=C.$ae.alloc(P.byteLength);O.set(P),i.records.push({timestamp:Date.now(),id:N,label:g,type:f,buff:O})}else i.records.push({timestamp:Date.now(),id:N,label:g,type:f,data:P})}i.traceSocketEvent=S})(b||(e.SocketDiagnostics=b={}));var E;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(E||(e.SocketCloseEventType=E={}));let w=null;function R(){return w||(w=C.$ae.alloc(0)),w}class I{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(a){this.a.push(a),this.b+=a.byteLength}read(a){return this.c(a,!0)}peek(a){return this.c(a,!1)}c(a,u){if(a===0)return R();if(a>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===a){const g=this.a[0];return u&&(this.a.shift(),this.b-=a),g}if(this.a[0].byteLength>a){const g=this.a[0].slice(0,a);return u&&(this.a[0]=this.a[0].slice(a),this.b-=a),g}const k=C.$ae.alloc(a);let S=0,$=0;for(;a>0;){const g=this.a[$];if(g.byteLength>a){const f=g.slice(0,a);k.set(f,S),S+=a,u&&(this.a[$]=g.slice(a),this.b-=a),a-=a}else k.set(g,S),S+=g.byteLength,u?(this.a.shift(),this.b-=g.byteLength):$++,a-=g.byteLength}return k}}e.$xh=I;var p;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(p||(p={}));function y(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var D;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(D||(e.ProtocolConstants=D={}));class v{constructor(a,u,k,S){this.type=a,this.id=u,this.ack=k,this.data=S,this.writtenTime=0}get size(){return this.data.byteLength}}class l extends d.$Rc{constructor(a){super(),this.f=this.B(new T.$Md),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=a,this.b=!1,this.c=new I,this.B(this.a.onData(u=>this.acceptChunk(u))),this.lastReadTime=Date.now()}acceptChunk(a){if(!(!a||a.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(a);this.c.byteLength>=this.g.readLen;){const u=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=u.readUInt32BE(9),this.g.messageType=u.readUInt8(0),this.g.id=u.readUInt32BE(1),this.g.ack=u.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:y(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const k=this.g.messageType,S=this.g.id,$=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",u),this.f.fire(new v(k,S,$,u)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class s{constructor(a){this.k=null,this.a=!1,this.b=!1,this.c=a,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(a){if(this.a)return;a.writtenTime=Date.now(),this.lastWriteTime=Date.now();const u=C.$ae.alloc(13);u.writeUInt8(a.type,0),u.writeUInt32BE(a.id,1),u.writeUInt32BE(a.ack,5),u.writeUInt32BE(a.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:y(a.type),id:a.id,ack:a.ack,messageSize:a.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",a.data),this.j(u,a.data)}g(a,u){const k=this.f===0;return this.d.push(a,u),this.f+=a.byteLength+u.byteLength,k}h(){const a=C.$ae.concat(this.d,this.f);return this.d.length=0,this.f=0,a}j(a,u){this.g(a,u)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const a=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:a.byteLength}),this.c.write(a)}}class r extends d.$Rc{constructor(a){super(),this.f=new T.$Md,this.onMessage=this.f.event,this.g=new T.$Md,this.onDidDispose=this.g.event,this.a=a,this.b=this.B(new s(this.a)),this.c=this.B(new l(this.a)),this.B(this.c.onMessage(u=>{u.type===1&&this.f.fire(u.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(a){this.b.write(new v(1,0,0,a))}}e.$yh=r;class c extends M.$sh{static fromSocket(a,u){return new c(new r(a),u)}get onDidDispose(){return this.b.onDidDispose}constructor(a,u,k=null){super(a,u,k),this.b=a}dispose(){super.dispose();const a=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),a.end()}}e.$zh=c;class m{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new T.$Md({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(a){this.b?this.d.length>0?this.d.push(a):this.a.fire(a):this.d.push(a)}flushBuffer(){this.d=[]}}e.$Ah=m;class h{constructor(a){this.data=a,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let a=0,u=this.a;for(;u;)u=u.next,a++;return a}peek(){return this.a?this.a.data:null}toArray(){const a=[];let u=0,k=this.a;for(;k;)a[u++]=k.data,k=k.next;return a}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(a){const u=new h(a);if(!this.a){this.a=u,this.b=u;return}this.b.next=u,this.b=u}}class n{static{this.a=10}static{this.b=null}static getInstance(){return n.b||(n.b=new n),n.b}constructor(){this.c=[];const a=Date.now();for(let u=0;u<n.a;u++)this.c[u]=a-1e3*u;setInterval(()=>{for(let u=n.a;u>=1;u--)this.c[u]=this.c[u-1];this.c[0]=Date.now()},1e3)}d(){const a=Date.now(),u=(1+n.a)*1e3;let k=0;for(let S=0;S<n.a;S++)a-this.c[S]<=u&&k++;return 1-k/n.a}hasHighLoad(){return this.d()>=.5}}class o{get unacknowledgedCount(){return this.c-this.d}constructor(a){this.u=new m,this.onControlMessage=this.u.event,this.v=new m,this.onMessage=this.v.event,this.w=new m,this.onDidDispose=this.w.event,this.x=new m,this.onSocketClose=this.x.event,this.y=new m,this.onSocketTimeout=this.y.event,this.s=a.loadEstimator??n.getInstance(),this.t=a.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new d.$Qc,this.o=a.socket,this.p=this.r.add(new s(this.o)),this.q=this.r.add(new l(this.o)),this.r.add(this.q.onMessage(u=>this.z(u))),this.r.add(this.o.onClose(u=>this.x.fire(u))),a.initialChunk&&this.q.acceptChunk(a.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const a=new v(5,0,0,R());this.p.write(a),this.p.flush()}sendPause(){const a=new v(7,0,0,R());this.p.write(a)}sendResume(){const a=new v(8,0,0,R());this.p.write(a)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(a,u){this.a=!0,this.r.dispose(),this.r=new d.$Qc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=a,this.p=this.r.add(new s(this.o)),this.q=this.r.add(new l(this.o)),this.r.add(this.q.onMessage(k=>this.z(k))),this.r.add(this.o.onClose(k=>this.x.fire(k))),this.q.acceptChunk(u)}endAcceptReconnection(){this.a=!1,this.h=this.g;const a=new v(3,0,this.h,R());this.p.write(a);const u=this.b.toArray();for(let k=0,S=u.length;k<S;k++)this.p.write(u[k]);this.B()}acceptDisconnect(){this.w.fire()}z(a){if(a.ack>this.d){this.d=a.ack;do{const u=this.b.peek();if(u&&u.id<=a.ack)this.b.pop();else break}while(!0)}switch(a.type){case 0:break;case 1:{if(a.id>this.g)if(a.id!==this.g+1){const u=Date.now();u-this.m>1e4&&(this.m=u,this.p.write(new v(6,0,0,R())))}else this.g=a.id,this.j=Date.now(),this.A(),this.v.fire(a.data);break}case 2:{this.u.fire(a.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const u=this.b.toArray();for(let k=0,S=u.length;k<S;k++)this.p.write(u[k]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(a){const u=++this.c;this.h=this.g;const k=new v(1,u,this.h,a);this.b.push(k),this.a||(this.p.write(k),this.B())}sendControl(a){const u=new v(2,0,0,a);this.p.write(u)}A(){if(this.g<=this.h||this.k)return;const a=Date.now()-this.j;if(a>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-a+5)}B(){if(this.c<=this.d||this.f||this.a)return;const a=this.b.peek(),u=Date.now()-a.writtenTime,k=Date.now()-this.q.lastReadTime,S=Date.now()-this.n;if(u>=2e4&&k>=2e4&&S>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:u,timeSinceLastReceivedSomeData:k});return}const $=Math.max(2e4-u,2e4-k,2e4-S,500);this.f=setTimeout(()=>{this.f=null,this.B()},$)}C(){if(this.g<=this.h)return;this.h=this.g;const a=new v(3,0,this.h,R());this.p.write(a)}D(){this.h=this.g;const a=new v(9,0,this.h,R());this.p.write(a)}}e.$Bh=o}),define(De[183],Ce([1,0,48,9,22,21,181,8,4,3,23,101,98,80]),function(me,e,C,T,d,M,A,b,E,w,R,I,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yp=e.$Xp=void 0;class D extends y.$ph{constructor(s){super({send:r=>{try{process.send?.(r.buffer.toString("base64"))}catch{}},onMessage:E.Event.fromNodeEventEmitter(process,"message",r=>d.$ae.wrap(Buffer.from(r,"base64")))},s),process.once("disconnect",()=>this.dispose())}}e.$Xp=D;class v{constructor(s,r){this.i=s,this.j=r,this.c=new Set,this.g=new Map,this.h=new E.$Md,this.onDidProcessExit=this.h.event;const c=r&&r.timeout?r.timeout:6e4;this.b=new T.$Pg(c),this.d=null,this.f=null}getChannel(s){const r=this;return{call(c,m,h){return r.k(s,c,m,h)},listen(c,m){return r.l(s,c,m)}}}k(s,r,c,m=M.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(m.isCancellationRequested)return Promise.reject(b.$5());this.b.cancel();const h=this.n(s),t=(0,T.$Gg)(i=>h.call(r,c,i)),n=m.onCancellationRequested(()=>t.cancel()),o=(0,w.$Pc)(()=>t.cancel());return this.c.add(o),t.finally(()=>{n.dispose(),this.c.delete(o),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(s,r,c){if(!this.b)return E.Event.None;this.b.cancel();let m;const h=new E.$Md({onWillAddFirstListener:()=>{m=this.n(s).listen(r,c)(h.fire,h),this.c.add(m)},onDidRemoveLastListener:()=>{this.c.delete(m),m.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return h.event}get m(){if(!this.f){const s=this.j&&this.j.args?this.j.args:[],r=Object.create(null);r.env={...(0,R.$2m)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(r.env={...r.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(r.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(r.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(r.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),r.execArgv===void 0&&(r.execArgv=process.execArgv.filter(a=>!/^--inspect(-brk)?=/.test(a)).filter(a=>!a.startsWith("--vscode-"))),(0,p.$wl)(r.env),this.d=(0,C.fork)(this.i,s,r);const c=new E.$Md;E.Event.fromNodeEventEmitter(this.d,"message",a=>a)(a=>{if((0,A.$Tp)(a)){(0,A.log)(a,`IPC Library: ${this.j.serverName}`);return}c.fire(d.$ae.wrap(Buffer.from(a,"base64")))});const h=this.j.useQueue?(0,I.$yl)(this.d):this.d,t=a=>this.d&&this.d.connected&&h.send(a.buffer.toString("base64")),n=c.event,o={send:t,onMessage:n};this.f=new y.$qh(o);const i=()=>this.o();process.once("exit",i),this.d.on("error",a=>console.warn('IPC "'+this.j.serverName+'" errored with '+a)),this.d.on("exit",(a,u)=>{process.removeListener("exit",i),this.c.forEach(k=>(0,w.$Mc)(k)),this.c.clear(),a!==0&&u!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+a+" and signal "+u),this.b?.cancel(),this.o(),this.h.fire({code:a,signal:u})})}return this.f}n(s){let r=this.g.get(s);return r||(r=this.m.getChannel(s),this.g.set(s,r)),r}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Yp=v}),define(De[184],Ce([1,0,9,4,3,62,18]),function(me,e,C,T,d,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yo=e.$Xo=e.StorageState=e.$Wo=e.StorageHint=void 0;var b;(function(p){p[p.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",p[p.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(b||(e.StorageHint=b={}));function E(p){const y=p;return y?.changed instanceof Map||y?.deleted instanceof Set}e.$Wo=E;var w;(function(p){p[p.None=0]="None",p[p.Initialized=1]="Initialized",p[p.Closed=2]="Closed"})(w||(e.StorageState=w={}));class R extends d.$Rc{static{this.a=100}constructor(y,D=Object.create(null)){super(),this.r=y,this.s=D,this.b=this.B(new T.$Pd),this.onDidChangeStorage=this.b.event,this.c=w.None,this.f=new Map,this.g=this.B(new C.$Qg(R.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(y=>this.u(y)))}u(y){this.b.pause();try{y.changed?.forEach((D,v)=>this.w(v,D)),y.deleted?.forEach(D=>this.w(D,void 0))}finally{this.b.resume()}}w(y,D){if(this.c===w.Closed)return;let v=!1;(0,A.$Gf)(D)?v=this.f.delete(y):this.f.get(y)!==D&&(this.f.set(y,D),v=!0),v&&this.b.fire({key:y,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===w.None&&(this.c=w.Initialized,this.s.hint!==b.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(y,D){const v=this.f.get(y);return(0,A.$Gf)(v)?D:v}getBoolean(y,D){const v=this.get(y);return(0,A.$Gf)(v)?D:v==="true"}getNumber(y,D){const v=this.get(y);return(0,A.$Gf)(v)?D:parseInt(v,10)}getObject(y,D){const v=this.get(y);return(0,A.$Gf)(v)?D:(0,M.$jh)(v)}async set(y,D,v=!1){if(this.c===w.Closed)return;if((0,A.$Gf)(D))return this.delete(y,v);const l=(0,A.$zf)(D)||Array.isArray(D)?(0,M.$ih)(D):String(D);if(this.f.get(y)!==l)return this.f.set(y,l),this.j.set(y,l),this.h.delete(y),this.b.fire({key:y,external:v}),this.D()}async delete(y,D=!1){if(!(this.c===w.Closed||!this.f.delete(y)))return this.h.has(y)||this.h.add(y),this.j.delete(y),this.b.fire({key:y,external:D}),this.D()}async optimize(){if(this.c!==w.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=w.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const y={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(y).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(y){if(this.z)return this.D(y)}async D(y){return this.s.hint===b.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),y)}async whenFlushed(){if(this.z)return new Promise(y=>this.n.push(y))}isInMemory(){return this.s.hint===b.STORAGE_IN_MEMORY}}e.$Xo=R;class I{constructor(){this.onDidChangeItemsExternal=T.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(y){y.insert?.forEach((D,v)=>this.a.set(v,D)),y.delete?.forEach(D=>this.a.delete(D))}async optimize(){}async close(){}}e.$Yo=I}),define(De[185],Ce([1,0,35,16]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mE=void 0;function d(M,A,b,E,w,R){if(Array.isArray(M)){let I=0;for(const p of M){const y=d(p,A,b,E,w,R);if(y===10)return y;y>I&&(I=y)}return I}else{if(typeof M=="string")return E?M==="*"?5:M===b?10:0:0;if(M){const{language:I,pattern:p,scheme:y,hasAccessToAllModels:D,notebookType:v}=M;if(!E&&!D)return 0;v&&w&&(A=w);let l=0;if(y)if(y===A.scheme)l=10;else if(y==="*")l=5;else return 0;if(I)if(I===b)l=10;else if(I==="*")l=Math.max(l,5);else return 0;if(v)if(v===R)l=10;else if(v==="*"&&R!==void 0)l=Math.max(l,5);else return 0;if(p){let s;if(typeof p=="string"?s=p:s={...p,base:(0,T.$gc)(p.base)},s===A.fsPath||(0,C.$tj)(s,A.fsPath))l=10;else return 0}return l}else return 0}}e.$mE=d}),define(De[129],Ce([1,0,22,12]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q0=e.$P0=void 0;var d;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(d||(d={}));function M(I){for(let p=0,y=I.length;p<y;p+=4){const D=I[p+0],v=I[p+1],l=I[p+2],s=I[p+3];I[p+0]=s,I[p+1]=l,I[p+2]=v,I[p+3]=D}}function A(I){const p=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return T.$D()||M(p),C.$ae.wrap(p)}function b(I){const p=I.buffer;if(T.$D()||M(p),p.byteOffset%4===0)return new Uint32Array(p.buffer,p.byteOffset,p.length/4);{const y=new Uint8Array(p.byteLength);return y.set(p),new Uint32Array(y.buffer,y.byteOffset,y.length/4)}}function E(I){const p=new Uint32Array(w(I));let y=0;if(p[y++]=I.id,I.type==="full")p[y++]=1,p[y++]=I.data.length,p.set(I.data,y),y+=I.data.length;else{p[y++]=2,p[y++]=I.deltas.length;for(const D of I.deltas)p[y++]=D.start,p[y++]=D.deleteCount,D.data?(p[y++]=D.data.length,p.set(D.data,y),y+=D.data.length):p[y++]=0}return A(p)}e.$P0=E;function w(I){let p=0;if(p+=1+1,I.type==="full")p+=1+I.data.length;else{p+=1,p+=(1+1+1)*I.deltas.length;for(const y of I.deltas)y.data&&(p+=y.data.length)}return p}function R(I){const p=b(I);let y=0;const D=p[y++];if(p[y++]===1){const r=p[y++],c=p.subarray(y,y+r);return y+=r,{id:D,type:"full",data:c}}const l=p[y++],s=[];for(let r=0;r<l;r++){const c=p[y++],m=p[y++],h=p[y++];let t;h>0&&(t=p.subarray(y,y+h),y+=h),s[r]={start:c,deleteCount:m,data:t}}return{id:D,type:"delta",deltas:s}}e.$Q0=R}),define(De[186],Ce([10,11]),function(me,e){return me.create("vs/editor/common/config/editorOptions",e)}),define(De[130],Ce([1,0,19,23,12,166,124,186]),function(me,e,C,T,d,M,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var E;(function(ce){ce[ce.None=0]="None",ce[ce.Keep=1]="Keep",ce[ce.Brackets=2]="Brackets",ce[ce.Advanced=3]="Advanced",ce[ce.Full=4]="Full"})(E||(e.EditorAutoIndentStrategy=E={})),e.MINIMAP_GUTTER_WIDTH=8;class w{constructor(ae){this.c=ae}hasChanged(ae){return this.c[ae]}}e.ConfigurationChangedEvent=w;class R{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=R;class I{constructor(ae,Ie,Ve,ze){this.id=ae,this.name=Ie,this.defaultValue=Ve,this.schema=ze}applyUpdate(ae,Ie){return y(ae,Ie)}compute(ae,Ie,Ve){return Ve}}class p{constructor(ae,Ie){this.newValue=ae,this.didChange=Ie}}e.ApplyUpdateResult=p;function y(ce,ae){if(typeof ce!="object"||typeof ae!="object"||!ce||!ae)return new p(ae,ce!==ae);if(Array.isArray(ce)||Array.isArray(ae)){const Ve=Array.isArray(ce)&&Array.isArray(ae)&&C.$tb(ce,ae);return new p(ae,!Ve)}let Ie=!1;for(const Ve in ae)if(ae.hasOwnProperty(Ve)){const ze=y(ce[Ve],ae[Ve]);ze.didChange&&(ce[Ve]=ze.newValue,Ie=!0)}return new p(ce,Ie)}class D{constructor(ae){this.schema=void 0,this.id=ae,this.name="_never_",this.defaultValue=void 0}applyUpdate(ae,Ie){return y(ae,Ie)}validate(ae){return this.defaultValue}}class v{constructor(ae,Ie,Ve,ze){this.id=ae,this.name=Ie,this.defaultValue=Ve,this.schema=ze}applyUpdate(ae,Ie){return y(ae,Ie)}validate(ae){return typeof ae>"u"?this.defaultValue:ae}compute(ae,Ie,Ve){return Ve}}function l(ce,ae){return typeof ce>"u"?ae:ce==="false"?!1:!!ce}e.boolean=l;class s extends v{constructor(ae,Ie,Ve,ze=void 0){typeof ze<"u"&&(ze.type="boolean",ze.default=Ve),super(ae,Ie,Ve,ze)}validate(ae){return l(ae,this.defaultValue)}}function r(ce,ae,Ie,Ve){if(typeof ce>"u")return ae;let ze=parseInt(ce,10);return isNaN(ze)?ae:(ze=Math.max(Ie,ze),ze=Math.min(Ve,ze),ze|0)}e.clampedInt=r;class c extends v{static clampedInt(ae,Ie,Ve,ze){return r(ae,Ie,Ve,ze)}constructor(ae,Ie,Ve,ze,Xe,rt=void 0){typeof rt<"u"&&(rt.type="integer",rt.default=Ve,rt.minimum=ze,rt.maximum=Xe),super(ae,Ie,Ve,rt),this.minimum=ze,this.maximum=Xe}validate(ae){return c.clampedInt(ae,this.defaultValue,this.minimum,this.maximum)}}function m(ce,ae,Ie,Ve){if(typeof ce>"u")return ae;const ze=h.float(ce,ae);return h.clamp(ze,Ie,Ve)}e.clampedFloat=m;class h extends v{static clamp(ae,Ie,Ve){return ae<Ie?Ie:ae>Ve?Ve:ae}static float(ae,Ie){if(typeof ae=="number")return ae;if(typeof ae>"u")return Ie;const Ve=parseFloat(ae);return isNaN(Ve)?Ie:Ve}constructor(ae,Ie,Ve,ze,Xe){typeof Xe<"u"&&(Xe.type="number",Xe.default=Ve),super(ae,Ie,Ve,Xe),this.validationFn=ze}validate(ae){return this.validationFn(h.float(ae,this.defaultValue))}}class t extends v{static string(ae,Ie){return typeof ae!="string"?Ie:ae}constructor(ae,Ie,Ve,ze=void 0){typeof ze<"u"&&(ze.type="string",ze.default=Ve),super(ae,Ie,Ve,ze)}validate(ae){return t.string(ae,this.defaultValue)}}function n(ce,ae,Ie,Ve){return typeof ce!="string"?ae:Ve&&ce in Ve?Ve[ce]:Ie.indexOf(ce)===-1?ae:ce}e.stringSet=n;class o extends v{constructor(ae,Ie,Ve,ze,Xe=void 0){typeof Xe<"u"&&(Xe.type="string",Xe.enum=ze,Xe.default=Ve),super(ae,Ie,Ve,Xe),this.c=ze}validate(ae){return n(ae,this.defaultValue,this.c)}}class i extends I{constructor(ae,Ie,Ve,ze,Xe,rt,ot=void 0){typeof ot<"u"&&(ot.type="string",ot.enum=Xe,ot.default=ze),super(ae,Ie,Ve,ot),this.c=Xe,this.d=rt}validate(ae){return typeof ae!="string"?this.defaultValue:this.c.indexOf(ae)===-1?this.defaultValue:this.d(ae)}}function a(ce){switch(ce){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class u extends I{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[b.localize(0,null),b.localize(1,null),b.localize(2,null)],default:"auto",tags:["accessibility"],description:b.localize(3,null)})}validate(ae){switch(ae){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ae,Ie,Ve){return Ve===0?ae.accessibilitySupport:Ve}}class k extends I{constructor(){const ae={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",ae,{"editor.comments.insertSpace":{type:"boolean",default:ae.insertSpace,description:b.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ae.ignoreEmptyLines,description:b.localize(5,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{insertSpace:l(Ie.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:l(Ie.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var S;(function(ce){ce[ce.Hidden=0]="Hidden",ce[ce.Blink=1]="Blink",ce[ce.Smooth=2]="Smooth",ce[ce.Phase=3]="Phase",ce[ce.Expand=4]="Expand",ce[ce.Solid=5]="Solid"})(S||(e.TextEditorCursorBlinkingStyle=S={}));function $(ce){switch(ce){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var g;(function(ce){ce[ce.Line=1]="Line",ce[ce.Block=2]="Block",ce[ce.Underline=3]="Underline",ce[ce.LineThin=4]="LineThin",ce[ce.BlockOutline=5]="BlockOutline",ce[ce.UnderlineThin=6]="UnderlineThin"})(g||(e.TextEditorCursorStyle=g={}));function f(ce){switch(ce){case g.Line:return"line";case g.Block:return"block";case g.Underline:return"underline";case g.LineThin:return"line-thin";case g.BlockOutline:return"block-outline";case g.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=f;function P(ce){switch(ce){case"line":return g.Line;case"block":return g.Block;case"underline":return g.Underline;case"line-thin":return g.LineThin;case"block-outline":return g.BlockOutline;case"underline-thin":return g.UnderlineThin}}class N extends D{constructor(){super(140)}compute(ae,Ie,Ve){const ze=["monaco-editor"];return Ie.get(39)&&ze.push(Ie.get(39)),ae.extraEditorClassName&&ze.push(ae.extraEditorClassName),Ie.get(73)==="default"?ze.push("mouse-default"):Ie.get(73)==="copy"&&ze.push("mouse-copy"),Ie.get(110)&&ze.push("showUnused"),Ie.get(138)&&ze.push("showDeprecated"),ze.join(" ")}}class O extends s{constructor(){super(37,"emptySelectionClipboard",!0,{description:b.localize(6,null)})}compute(ae,Ie,Ve){return Ve&&ae.emptySelectionClipboard}}class L extends I{constructor(){const ae={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",ae,{"editor.find.cursorMoveOnType":{type:"boolean",default:ae.cursorMoveOnType,description:b.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ae.seedSearchStringFromSelection,enumDescriptions:[b.localize(8,null),b.localize(9,null),b.localize(10,null)],description:b.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ae.autoFindInSelection,enumDescriptions:[b.localize(12,null),b.localize(13,null),b.localize(14,null)],description:b.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ae.globalFindClipboard,description:b.localize(16,null),included:d.$k},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ae.addExtraSpaceOnTop,description:b.localize(17,null)},"editor.find.loop":{type:"boolean",default:ae.loop,description:b.localize(18,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{cursorMoveOnType:l(Ie.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ae.seedSearchStringFromSelection=="boolean"?ae.seedSearchStringFromSelection?"always":"never":n(Ie.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ae.autoFindInSelection=="boolean"?ae.autoFindInSelection?"always":"never":n(Ie.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:l(Ie.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:l(Ie.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:l(Ie.loop,this.defaultValue.loop)}}}class j extends I{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",j.OFF,{anyOf:[{type:"boolean",description:b.localize(19,null)},{type:"string",description:b.localize(20,null)}],description:b.localize(21,null),default:!1})}validate(ae){return typeof ae>"u"?this.defaultValue:typeof ae=="string"?ae==="false"?j.OFF:ae==="true"?j.ON:ae:ae?j.ON:j.OFF}}e.EditorFontLigatures=j;class z extends I{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",z.OFF,{anyOf:[{type:"boolean",description:b.localize(22,null)},{type:"string",description:b.localize(23,null)}],description:b.localize(24,null),default:!1})}validate(ae){return typeof ae>"u"?this.defaultValue:typeof ae=="string"?ae==="false"?z.OFF:ae==="true"?z.TRANSLATE:ae:ae?z.TRANSLATE:z.OFF}compute(ae,Ie,Ve){return ae.fontInfo.fontVariationSettings}}e.EditorFontVariations=z;class F extends D{constructor(){super(50)}compute(ae,Ie,Ve){return ae.fontInfo}}class H extends v{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:b.localize(25,null)})}validate(ae){const Ie=h.float(ae,this.defaultValue);return Ie===0?e.EDITOR_FONT_DEFAULTS.fontSize:h.clamp(Ie,6,100)}compute(ae,Ie,Ve){return ae.fontInfo.fontSize}}class K extends I{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:K.d,maximum:K.e,errorMessage:b.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:K.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:b.localize(27,null)})}validate(ae){return ae==="normal"||ae==="bold"?ae:String(c.clampedInt(ae,e.EDITOR_FONT_DEFAULTS.fontWeight,K.d,K.e))}}class fe extends I{constructor(){const ae={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ie={type:"string",enum:["peek","gotoAndPeek","goto"],default:ae.multiple,enumDescriptions:[b.localize(28,null),b.localize(29,null),b.localize(30,null)]},Ve=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",ae,{"editor.gotoLocation.multiple":{deprecationMessage:b.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:b.localize(32,null),...Ie},"editor.gotoLocation.multipleTypeDefinitions":{description:b.localize(33,null),...Ie},"editor.gotoLocation.multipleDeclarations":{description:b.localize(34,null),...Ie},"editor.gotoLocation.multipleImplementations":{description:b.localize(35,null),...Ie},"editor.gotoLocation.multipleReferences":{description:b.localize(36,null),...Ie},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ae.alternativeDefinitionCommand,enum:Ve,description:b.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ae.alternativeTypeDefinitionCommand,enum:Ve,description:b.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ae.alternativeDeclarationCommand,enum:Ve,description:b.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ae.alternativeImplementationCommand,enum:Ve,description:b.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ae.alternativeReferenceCommand,enum:Ve,description:b.localize(41,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{multiple:n(Ie.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ie.multipleDefinitions??n(Ie.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ie.multipleTypeDefinitions??n(Ie.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ie.multipleDeclarations??n(Ie.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ie.multipleImplementations??n(Ie.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ie.multipleReferences??n(Ie.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(Ie.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(Ie.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(Ie.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(Ie.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(Ie.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class x extends I{constructor(){const ae={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",ae,{"editor.hover.enabled":{type:"boolean",default:ae.enabled,description:b.localize(42,null)},"editor.hover.delay":{type:"number",default:ae.delay,minimum:0,maximum:1e4,description:b.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:ae.sticky,description:b.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:ae.hidingDelay,description:b.localize(45,null)},"editor.hover.above":{type:"boolean",default:ae.above,description:b.localize(46,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{enabled:l(Ie.enabled,this.defaultValue.enabled),delay:c.clampedInt(Ie.delay,this.defaultValue.delay,0,1e4),sticky:l(Ie.sticky,this.defaultValue.sticky),hidingDelay:c.clampedInt(Ie.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:l(Ie.above,this.defaultValue.above)}}}var Z;(function(ce){ce[ce.None=0]="None",ce[ce.Text=1]="Text",ce[ce.Blocks=2]="Blocks"})(Z||(e.RenderMinimap=Z={}));class q extends D{constructor(){super(143)}compute(ae,Ie,Ve){return q.computeLayout(Ie,{memory:ae.memory,outerWidth:ae.outerWidth,outerHeight:ae.outerHeight,isDominatedByLongLines:ae.isDominatedByLongLines,lineHeight:ae.fontInfo.lineHeight,viewLineCount:ae.viewLineCount,lineNumbersDigitCount:ae.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ae.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ae.fontInfo.maxDigitWidth,pixelRatio:ae.pixelRatio,glyphMarginDecorationLaneCount:ae.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(ae){const Ie=ae.height/ae.lineHeight,Ve=Math.floor(ae.paddingTop/ae.lineHeight);let ze=Math.floor(ae.paddingBottom/ae.lineHeight);ae.scrollBeyondLastLine&&(ze=Math.max(ze,Ie-1));const Xe=(Ve+ae.viewLineCount+ze)/(ae.pixelRatio*ae.height),rt=Math.floor(ae.viewLineCount/Xe);return{typicalViewportLineCount:Ie,extraLinesBeforeFirstLine:Ve,extraLinesBeyondLastLine:ze,desiredRatio:Xe,minimapLineCount:rt}}static c(ae,Ie){const Ve=ae.outerWidth,ze=ae.outerHeight,Xe=ae.pixelRatio;if(!ae.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Xe*ze),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:ze};const rt=Ie.stableMinimapLayoutInput,ot=rt&&ae.outerHeight===rt.outerHeight&&ae.lineHeight===rt.lineHeight&&ae.typicalHalfwidthCharacterWidth===rt.typicalHalfwidthCharacterWidth&&ae.pixelRatio===rt.pixelRatio&&ae.scrollBeyondLastLine===rt.scrollBeyondLastLine&&ae.paddingTop===rt.paddingTop&&ae.paddingBottom===rt.paddingBottom&&ae.minimap.enabled===rt.minimap.enabled&&ae.minimap.side===rt.minimap.side&&ae.minimap.size===rt.minimap.size&&ae.minimap.showSlider===rt.minimap.showSlider&&ae.minimap.renderCharacters===rt.minimap.renderCharacters&&ae.minimap.maxColumn===rt.minimap.maxColumn&&ae.minimap.scale===rt.minimap.scale&&ae.verticalScrollbarWidth===rt.verticalScrollbarWidth&&ae.isViewportWrapping===rt.isViewportWrapping,wt=ae.lineHeight,Et=ae.typicalHalfwidthCharacterWidth,Yt=ae.scrollBeyondLastLine,Kt=ae.minimap.renderCharacters;let pt=Xe>=2?Math.round(ae.minimap.scale*2):ae.minimap.scale;const Ut=ae.minimap.maxColumn,Ft=ae.minimap.size,Bt=ae.minimap.side,Pt=ae.verticalScrollbarWidth,At=ae.viewLineCount,Nt=ae.remainingWidth,Wt=ae.isViewportWrapping,Ht=Kt?2:3;let qt=Math.floor(Xe*ze);const ct=qt/Xe;let lt=!1,Jt=!1,It=Ht*pt,kt=pt/Xe,ft=1;if(Ft==="fill"||Ft==="fit"){const{typicalViewportLineCount:Le,extraLinesBeforeFirstLine:Te,extraLinesBeyondLastLine:Se,desiredRatio:ne,minimapLineCount:Fe}=q.computeContainedMinimapLineCount({viewLineCount:At,scrollBeyondLastLine:Yt,paddingTop:ae.paddingTop,paddingBottom:ae.paddingBottom,height:ze,lineHeight:wt,pixelRatio:Xe});if(At/Fe>1)lt=!0,Jt=!0,pt=1,It=1,kt=pt/Xe;else{let xe=!1,Je=pt+1;if(Ft==="fit"){const nt=Math.ceil((Te+At+Se)*It);Wt&&ot&&Nt<=Ie.stableFitRemainingWidth?(xe=!0,Je=Ie.stableFitMaxMinimapScale):xe=nt>qt}if(Ft==="fill"||xe){lt=!0;const nt=pt;It=Math.min(wt*Xe,Math.max(1,Math.floor(1/ne))),Wt&&ot&&Nt<=Ie.stableFitRemainingWidth&&(Je=Ie.stableFitMaxMinimapScale),pt=Math.min(Je,Math.max(1,Math.floor(It/Ht))),pt>nt&&(ft=Math.min(2,pt/nt)),kt=pt/Xe/ft,qt=Math.ceil(Math.max(Le,Te+At+Se)*It),Wt?(Ie.stableMinimapLayoutInput=ae,Ie.stableFitRemainingWidth=Nt,Ie.stableFitMaxMinimapScale=pt):(Ie.stableMinimapLayoutInput=null,Ie.stableFitRemainingWidth=0)}}}const Dt=Math.floor(Ut*kt),Tt=Math.min(Dt,Math.max(0,Math.floor((Nt-Pt-2)*kt/(Et+kt)))+e.MINIMAP_GUTTER_WIDTH);let yt=Math.floor(Xe*Tt);const Ge=yt/Xe;yt=Math.floor(yt*ft);const Ot=Kt?1:2,jt=Bt==="left"?0:Ve-Tt-Pt;return{renderMinimap:Ot,minimapLeft:jt,minimapWidth:Tt,minimapHeightIsEditorHeight:lt,minimapIsSampling:Jt,minimapScale:pt,minimapLineHeight:It,minimapCanvasInnerWidth:yt,minimapCanvasInnerHeight:qt,minimapCanvasOuterWidth:Ge,minimapCanvasOuterHeight:ct}}static computeLayout(ae,Ie){const Ve=Ie.outerWidth|0,ze=Ie.outerHeight|0,Xe=Ie.lineHeight|0,rt=Ie.lineNumbersDigitCount|0,ot=Ie.typicalHalfwidthCharacterWidth,wt=Ie.maxDigitWidth,Et=Ie.pixelRatio,Yt=Ie.viewLineCount,Kt=ae.get(135),pt=Kt==="inherit"?ae.get(134):Kt,Ut=pt==="inherit"?ae.get(130):pt,Ft=ae.get(133),Bt=Ie.isDominatedByLongLines,Pt=ae.get(57),At=ae.get(67).renderType!==0,Nt=ae.get(68),Wt=ae.get(104),Ht=ae.get(83),qt=ae.get(72),ct=ae.get(102),lt=ct.verticalScrollbarSize,Jt=ct.verticalHasArrows,It=ct.arrowSize,kt=ct.horizontalScrollbarSize,ft=ae.get(43),Dt=ae.get(109)!=="never";let Tt=ae.get(65);ft&&Dt&&(Tt+=16);let yt=0;if(At){const gt=Math.max(rt,Nt);yt=Math.round(gt*wt)}let Ge=0;Pt&&(Ge=Xe*Ie.glyphMarginDecorationLaneCount);let Ot=0,jt=Ot+Ge,Le=jt+yt,Te=Le+Tt;const Se=Ve-Ge-yt-Tt;let ne=!1,Fe=!1,Ke=-1;pt==="inherit"&&Bt?(ne=!0,Fe=!0):Ut==="on"||Ut==="bounded"?Fe=!0:Ut==="wordWrapColumn"&&(Ke=Ft);const xe=q.c({outerWidth:Ve,outerHeight:ze,lineHeight:Xe,typicalHalfwidthCharacterWidth:ot,pixelRatio:Et,scrollBeyondLastLine:Wt,paddingTop:Ht.top,paddingBottom:Ht.bottom,minimap:qt,verticalScrollbarWidth:lt,viewLineCount:Yt,remainingWidth:Se,isViewportWrapping:Fe},Ie.memory||new R);xe.renderMinimap!==0&&xe.minimapLeft===0&&(Ot+=xe.minimapWidth,jt+=xe.minimapWidth,Le+=xe.minimapWidth,Te+=xe.minimapWidth);const Je=Se-xe.minimapWidth,nt=Math.max(1,Math.floor((Je-lt-2)/ot)),mt=Jt?It:0;return Fe&&(Ke=Math.max(1,nt),Ut==="bounded"&&(Ke=Math.min(Ke,Ft))),{width:Ve,height:ze,glyphMarginLeft:Ot,glyphMarginWidth:Ge,glyphMarginDecorationLaneCount:Ie.glyphMarginDecorationLaneCount,lineNumbersLeft:jt,lineNumbersWidth:yt,decorationsLeft:Le,decorationsWidth:Tt,contentLeft:Te,contentWidth:Je,minimap:xe,viewportColumn:nt,isWordWrapMinified:ne,isViewportWrapping:Fe,wrappingColumn:Ke,verticalScrollbarWidth:lt,horizontalScrollbarHeight:kt,overviewRuler:{top:mt,width:lt,height:ze-2*mt,right:0}}}}e.EditorLayoutInfoComputer=q;class Y extends I{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[b.localize(47,null),b.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:b.localize(49,null)}})}validate(ae){return n(ae,"simple",["simple","advanced"])}compute(ae,Ie,Ve){return Ie.get(2)===2?"advanced":Ve}}class be extends I{constructor(){const ae={enabled:!0};super(64,"lightbulb",ae,{"editor.lightbulb.enabled":{type:"boolean",default:ae.enabled,description:b.localize(50,null)}})}validate(ae){return!ae||typeof ae!="object"?this.defaultValue:{enabled:l(ae.enabled,this.defaultValue.enabled)}}}class ue extends I{constructor(){const ae={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",ae,{"editor.stickyScroll.enabled":{type:"boolean",default:ae.enabled,description:b.localize(51,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:ae.maxLineCount,minimum:1,maximum:10,description:b.localize(52,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:ae.defaultModel,description:b.localize(53,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:ae.scrollWithEditor,description:b.localize(54,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{enabled:l(Ie.enabled,this.defaultValue.enabled),maxLineCount:c.clampedInt(Ie.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:n(Ie.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:l(Ie.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class ve extends I{constructor(){const ae={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",ae,{"editor.inlayHints.enabled":{type:"string",default:ae.enabled,description:b.localize(55,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[b.localize(56,null),b.localize(57,null,d.$k?"Ctrl+Option":"Ctrl+Alt"),b.localize(58,null,d.$k?"Ctrl+Option":"Ctrl+Alt"),b.localize(59,null)]},"editor.inlayHints.fontSize":{type:"number",default:ae.fontSize,markdownDescription:b.localize(60,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:ae.fontFamily,markdownDescription:b.localize(61,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:ae.padding,description:b.localize(62,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return typeof Ie.enabled=="boolean"&&(Ie.enabled=Ie.enabled?"on":"off"),{enabled:n(Ie.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:c.clampedInt(Ie.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(Ie.fontFamily,this.defaultValue.fontFamily),padding:l(Ie.padding,this.defaultValue.padding)}}}class J extends I{constructor(){super(65,"lineDecorationsWidth",10)}validate(ae){return typeof ae=="string"&&/^\d+(\.\d+)?ch$/.test(ae)?-parseFloat(ae.substring(0,ae.length-2)):c.clampedInt(ae,this.defaultValue,0,1e3)}compute(ae,Ie,Ve){return Ve<0?c.clampedInt(-Ve*ae.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ve}}class U extends h{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ae=>h.clamp(ae,0,150),{markdownDescription:b.localize(63,null)})}compute(ae,Ie,Ve){return ae.fontInfo.lineHeight}}class V extends I{constructor(){const ae={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",ae,{"editor.minimap.enabled":{type:"boolean",default:ae.enabled,description:b.localize(64,null)},"editor.minimap.autohide":{type:"boolean",default:ae.autohide,description:b.localize(65,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[b.localize(66,null),b.localize(67,null),b.localize(68,null)],default:ae.size,description:b.localize(69,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ae.side,description:b.localize(70,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ae.showSlider,description:b.localize(71,null)},"editor.minimap.scale":{type:"number",default:ae.scale,minimum:1,maximum:3,enum:[1,2,3],description:b.localize(72,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ae.renderCharacters,description:b.localize(73,null)},"editor.minimap.maxColumn":{type:"number",default:ae.maxColumn,description:b.localize(74,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{enabled:l(Ie.enabled,this.defaultValue.enabled),autohide:l(Ie.autohide,this.defaultValue.autohide),size:n(Ie.size,this.defaultValue.size,["proportional","fill","fit"]),side:n(Ie.side,this.defaultValue.side,["right","left"]),showSlider:n(Ie.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:l(Ie.renderCharacters,this.defaultValue.renderCharacters),scale:c.clampedInt(Ie.scale,1,1,3),maxColumn:c.clampedInt(Ie.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ge(ce){return ce==="ctrlCmd"?d.$k?"metaKey":"ctrlKey":"altKey"}class _ extends I{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(75,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(76,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{top:c.clampedInt(Ie.top,0,0,1e3),bottom:c.clampedInt(Ie.bottom,0,0,1e3)}}}class ie extends I{constructor(){const ae={enabled:!0,cycle:!0};super(85,"parameterHints",ae,{"editor.parameterHints.enabled":{type:"boolean",default:ae.enabled,description:b.localize(77,null)},"editor.parameterHints.cycle":{type:"boolean",default:ae.cycle,description:b.localize(78,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{enabled:l(Ie.enabled,this.defaultValue.enabled),cycle:l(Ie.cycle,this.defaultValue.cycle)}}}class re extends D{constructor(){super(141)}compute(ae,Ie,Ve){return ae.pixelRatio}}class Ee extends I{constructor(){const ae={other:"on",comments:"off",strings:"off"},Ie=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[b.localize(79,null),b.localize(80,null),b.localize(81,null)]}];super(88,"quickSuggestions",ae,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ie,default:ae.strings,description:b.localize(82,null)},comments:{anyOf:Ie,default:ae.comments,description:b.localize(83,null)},other:{anyOf:Ie,default:ae.other,description:b.localize(84,null)}},default:ae,markdownDescription:b.localize(85,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=ae}validate(ae){if(typeof ae=="boolean"){const Et=ae?"on":"off";return{comments:Et,strings:Et,other:Et}}if(!ae||typeof ae!="object")return this.defaultValue;const{other:Ie,comments:Ve,strings:ze}=ae,Xe=["on","inline","off"];let rt,ot,wt;return typeof Ie=="boolean"?rt=Ie?"on":"off":rt=n(Ie,this.defaultValue.other,Xe),typeof Ve=="boolean"?ot=Ve?"on":"off":ot=n(Ve,this.defaultValue.comments,Xe),typeof ze=="boolean"?wt=ze?"on":"off":wt=n(ze,this.defaultValue.strings,Xe),{other:rt,comments:ot,strings:wt}}}var oe;(function(ce){ce[ce.Off=0]="Off",ce[ce.On=1]="On",ce[ce.Relative=2]="Relative",ce[ce.Interval=3]="Interval",ce[ce.Custom=4]="Custom"})(oe||(e.RenderLineNumbersType=oe={}));class he extends I{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[b.localize(86,null),b.localize(87,null),b.localize(88,null),b.localize(89,null)],default:"on",description:b.localize(90,null)})}validate(ae){let Ie=this.defaultValue.renderType,Ve=this.defaultValue.renderFn;return typeof ae<"u"&&(typeof ae=="function"?(Ie=4,Ve=ae):ae==="interval"?Ie=3:ae==="relative"?Ie=2:ae==="on"?Ie=1:Ie=0),{renderType:Ie,renderFn:Ve}}}function ee(ce){const ae=ce.get(97);return ae==="editable"?ce.get(90):ae!=="on"}e.filterValidationDecorations=ee;class le extends I{constructor(){const ae=[],Ie={type:"number",description:b.localize(91,null)};super(101,"rulers",ae,{type:"array",items:{anyOf:[Ie,{type:["object"],properties:{column:Ie,color:{type:"string",description:b.localize(92,null),format:"color-hex"}}}]},default:ae,description:b.localize(93,null)})}validate(ae){if(Array.isArray(ae)){const Ie=[];for(const Ve of ae)if(typeof Ve=="number")Ie.push({column:c.clampedInt(Ve,0,0,1e4),color:null});else if(Ve&&typeof Ve=="object"){const ze=Ve;Ie.push({column:c.clampedInt(ze.column,0,0,1e4),color:ze.color})}return Ie.sort((Ve,ze)=>Ve.column-ze.column),Ie}return this.defaultValue}}class $e extends I{constructor(){super(91,"readOnlyMessage",void 0)}validate(ae){return!ae||typeof ae!="object"?this.defaultValue:ae}}function Pe(ce,ae){if(typeof ce!="string")return ae;switch(ce){case"hidden":return 2;case"visible":return 3;default:return 1}}class B extends I{constructor(){const ae={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(102,"scrollbar",ae,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[b.localize(94,null),b.localize(95,null),b.localize(96,null)],default:"auto",description:b.localize(97,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[b.localize(98,null),b.localize(99,null),b.localize(100,null)],default:"auto",description:b.localize(101,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ae.verticalScrollbarSize,description:b.localize(102,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ae.horizontalScrollbarSize,description:b.localize(103,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ae.scrollByPage,description:b.localize(104,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae,Ve=c.clampedInt(Ie.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),ze=c.clampedInt(Ie.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:c.clampedInt(Ie.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Pe(Ie.vertical,this.defaultValue.vertical),horizontal:Pe(Ie.horizontal,this.defaultValue.horizontal),useShadows:l(Ie.useShadows,this.defaultValue.useShadows),verticalHasArrows:l(Ie.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:l(Ie.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:l(Ie.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:l(Ie.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ve,horizontalSliderSize:c.clampedInt(Ie.horizontalSliderSize,Ve,0,1e3),verticalScrollbarSize:ze,verticalSliderSize:c.clampedInt(Ie.verticalSliderSize,ze,0,1e3),scrollByPage:l(Ie.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Q extends I{constructor(){const ae={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",ae,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ae.nonBasicASCII,description:b.localize(105,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:ae.invisibleCharacters,description:b.localize(106,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:ae.ambiguousCharacters,description:b.localize(107,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ae.includeComments,description:b.localize(108,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ae.includeStrings,description:b.localize(109,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:ae.allowedCharacters,description:b.localize(110,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:ae.allowedLocales,description:b.localize(111,null)}})}applyUpdate(ae,Ie){let Ve=!1;Ie.allowedCharacters&&ae&&(T.$6m(ae.allowedCharacters,Ie.allowedCharacters)||(ae={...ae,allowedCharacters:Ie.allowedCharacters},Ve=!0)),Ie.allowedLocales&&ae&&(T.$6m(ae.allowedLocales,Ie.allowedLocales)||(ae={...ae,allowedLocales:Ie.allowedLocales},Ve=!0));const ze=super.applyUpdate(ae,Ie);return Ve?new p(ze.newValue,!0):ze}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{nonBasicASCII:de(Ie.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:l(Ie.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:l(Ie.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:de(Ie.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:de(Ie.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(ae.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(ae.allowedLocales,this.defaultValue.allowedLocales)}}c(ae,Ie){if(typeof ae!="object"||!ae)return Ie;const Ve={};for(const[ze,Xe]of Object.entries(ae))Xe===!0&&(Ve[ze]=!0);return Ve}}class te extends I{constructor(){const ae={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",ae,{"editor.inlineSuggest.enabled":{type:"boolean",default:ae.enabled,description:b.localize(112,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:ae.showToolbar,enum:["always","onHover"],enumDescriptions:[b.localize(113,null),b.localize(114,null)],description:b.localize(115,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:ae.suppressSuggestions,description:b.localize(116,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{enabled:l(Ie.enabled,this.defaultValue.enabled),mode:n(Ie.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:n(Ie.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:l(Ie.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:l(Ie.keepOnBlur,this.defaultValue.keepOnBlur)}}}class se extends I{constructor(){const ae={enabled:M.$Yr.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:M.$Yr.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",ae,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ae.enabled,markdownDescription:b.localize(117,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:ae.independentColorPoolPerBracketType,description:b.localize(118,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{enabled:l(Ie.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:l(Ie.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class X extends I{constructor(){const ae={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",ae,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[b.localize(119,null),b.localize(120,null),b.localize(121,null)],default:ae.bracketPairs,description:b.localize(122,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[b.localize(123,null),b.localize(124,null),b.localize(125,null)],default:ae.bracketPairsHorizontal,description:b.localize(126,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ae.highlightActiveBracketPair,description:b.localize(127,null)},"editor.guides.indentation":{type:"boolean",default:ae.indentation,description:b.localize(128,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[b.localize(129,null),b.localize(130,null),b.localize(131,null)],default:ae.highlightActiveIndentation,description:b.localize(132,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{bracketPairs:de(Ie.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:de(Ie.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:l(Ie.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:l(Ie.indentation,this.defaultValue.indentation),highlightActiveIndentation:de(Ie.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function de(ce,ae,Ie){const Ve=Ie.indexOf(ce);return Ve===-1?ae:Ie[Ve]}class ye extends I{constructor(){const ae={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",ae,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[b.localize(133,null),b.localize(134,null)],default:ae.insertMode,description:b.localize(135,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ae.filterGraceful,description:b.localize(136,null)},"editor.suggest.localityBonus":{type:"boolean",default:ae.localityBonus,description:b.localize(137,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ae.shareSuggestSelections,markdownDescription:b.localize(138,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[b.localize(139,null),b.localize(140,null),b.localize(141,null),b.localize(142,null)],default:ae.selectionMode,markdownDescription:b.localize(143,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ae.snippetsPreventQuickSuggestions,description:b.localize(144,null)},"editor.suggest.showIcons":{type:"boolean",default:ae.showIcons,description:b.localize(145,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ae.showStatusBar,description:b.localize(146,null)},"editor.suggest.preview":{type:"boolean",default:ae.preview,description:b.localize(147,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ae.showInlineDetails,description:b.localize(148,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:b.localize(149,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:b.localize(150,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:b.localize(151,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:b.localize(152,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:b.localize(153,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:b.localize(154,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:b.localize(155,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:b.localize(156,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:b.localize(157,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:b.localize(158,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:b.localize(159,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:b.localize(160,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:b.localize(161,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:b.localize(162,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:b.localize(163,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:b.localize(164,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:b.localize(165,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:b.localize(166,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:b.localize(167,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:b.localize(168,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:b.localize(169,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:b.localize(170,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:b.localize(171,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:b.localize(172,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:b.localize(173,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:b.localize(174,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:b.localize(175,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:b.localize(176,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:b.localize(177,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:b.localize(178,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:b.localize(179,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:b.localize(180,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{insertMode:n(Ie.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:l(Ie.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:l(Ie.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:l(Ie.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:l(Ie.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:n(Ie.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:l(Ie.showIcons,this.defaultValue.showIcons),showStatusBar:l(Ie.showStatusBar,this.defaultValue.showStatusBar),preview:l(Ie.preview,this.defaultValue.preview),previewMode:n(Ie.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:l(Ie.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:l(Ie.showMethods,this.defaultValue.showMethods),showFunctions:l(Ie.showFunctions,this.defaultValue.showFunctions),showConstructors:l(Ie.showConstructors,this.defaultValue.showConstructors),showDeprecated:l(Ie.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:l(Ie.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:l(Ie.showFields,this.defaultValue.showFields),showVariables:l(Ie.showVariables,this.defaultValue.showVariables),showClasses:l(Ie.showClasses,this.defaultValue.showClasses),showStructs:l(Ie.showStructs,this.defaultValue.showStructs),showInterfaces:l(Ie.showInterfaces,this.defaultValue.showInterfaces),showModules:l(Ie.showModules,this.defaultValue.showModules),showProperties:l(Ie.showProperties,this.defaultValue.showProperties),showEvents:l(Ie.showEvents,this.defaultValue.showEvents),showOperators:l(Ie.showOperators,this.defaultValue.showOperators),showUnits:l(Ie.showUnits,this.defaultValue.showUnits),showValues:l(Ie.showValues,this.defaultValue.showValues),showConstants:l(Ie.showConstants,this.defaultValue.showConstants),showEnums:l(Ie.showEnums,this.defaultValue.showEnums),showEnumMembers:l(Ie.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:l(Ie.showKeywords,this.defaultValue.showKeywords),showWords:l(Ie.showWords,this.defaultValue.showWords),showColors:l(Ie.showColors,this.defaultValue.showColors),showFiles:l(Ie.showFiles,this.defaultValue.showFiles),showReferences:l(Ie.showReferences,this.defaultValue.showReferences),showFolders:l(Ie.showFolders,this.defaultValue.showFolders),showTypeParameters:l(Ie.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:l(Ie.showSnippets,this.defaultValue.showSnippets),showUsers:l(Ie.showUsers,this.defaultValue.showUsers),showIssues:l(Ie.showIssues,this.defaultValue.showIssues)}}}class je extends I{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:b.localize(181,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:b.localize(182,null),default:!0,type:"boolean"}})}validate(ae){return!ae||typeof ae!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:l(ae.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:l(ae.selectSubwords,this.defaultValue.selectSubwords)}}}var We;(function(ce){ce[ce.None=0]="None",ce[ce.Same=1]="Same",ce[ce.Indent=2]="Indent",ce[ce.DeepIndent=3]="DeepIndent"})(We||(e.WrappingIndent=We={}));class _e extends I{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[b.localize(183,null),b.localize(184,null),b.localize(185,null),b.localize(186,null)],description:b.localize(187,null),default:"same"}})}validate(ae){switch(ae){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(ae,Ie,Ve){return Ie.get(2)===2?0:Ve}}class Ye extends D{constructor(){super(144)}compute(ae,Ie,Ve){const ze=Ie.get(143);return{isDominatedByLongLines:ae.isDominatedByLongLines,isWordWrapMinified:ze.isWordWrapMinified,isViewportWrapping:ze.isViewportWrapping,wrappingColumn:ze.wrappingColumn}}}class it extends I{constructor(){const ae={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",ae,{"editor.dropIntoEditor.enabled":{type:"boolean",default:ae.enabled,markdownDescription:b.localize(188,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:b.localize(189,null),enum:["afterDrop","never"],enumDescriptions:[b.localize(190,null),b.localize(191,null)],default:"afterDrop"}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{enabled:l(Ie.enabled,this.defaultValue.enabled),showDropSelector:n(Ie.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class et extends I{constructor(){const ae={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",ae,{"editor.pasteAs.enabled":{type:"boolean",default:ae.enabled,markdownDescription:b.localize(192,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:b.localize(193,null),enum:["afterPaste","never"],enumDescriptions:[b.localize(194,null),b.localize(195,null)],default:"afterPaste"}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{enabled:l(Ie.enabled,this.defaultValue.enabled),showPasteSelector:n(Ie.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const Ae="Consolas, 'Courier New', monospace",Ne="Menlo, Monaco, 'Courier New', monospace",qe="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:d.$k?Ne:d.$l?qe:Ae,fontWeight:"normal",fontSize:d.$k?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Me(ce){return e.editorOptionsRegistry[ce.id]=ce,ce}var Ze;(function(ce){ce[ce.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ce[ce.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ce[ce.accessibilitySupport=2]="accessibilitySupport",ce[ce.accessibilityPageSize=3]="accessibilityPageSize",ce[ce.ariaLabel=4]="ariaLabel",ce[ce.ariaRequired=5]="ariaRequired",ce[ce.autoClosingBrackets=6]="autoClosingBrackets",ce[ce.autoClosingComments=7]="autoClosingComments",ce[ce.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",ce[ce.autoClosingDelete=9]="autoClosingDelete",ce[ce.autoClosingOvertype=10]="autoClosingOvertype",ce[ce.autoClosingQuotes=11]="autoClosingQuotes",ce[ce.autoIndent=12]="autoIndent",ce[ce.automaticLayout=13]="automaticLayout",ce[ce.autoSurround=14]="autoSurround",ce[ce.bracketPairColorization=15]="bracketPairColorization",ce[ce.guides=16]="guides",ce[ce.codeLens=17]="codeLens",ce[ce.codeLensFontFamily=18]="codeLensFontFamily",ce[ce.codeLensFontSize=19]="codeLensFontSize",ce[ce.colorDecorators=20]="colorDecorators",ce[ce.colorDecoratorsLimit=21]="colorDecoratorsLimit",ce[ce.columnSelection=22]="columnSelection",ce[ce.comments=23]="comments",ce[ce.contextmenu=24]="contextmenu",ce[ce.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",ce[ce.cursorBlinking=26]="cursorBlinking",ce[ce.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",ce[ce.cursorStyle=28]="cursorStyle",ce[ce.cursorSurroundingLines=29]="cursorSurroundingLines",ce[ce.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",ce[ce.cursorWidth=31]="cursorWidth",ce[ce.disableLayerHinting=32]="disableLayerHinting",ce[ce.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",ce[ce.domReadOnly=34]="domReadOnly",ce[ce.dragAndDrop=35]="dragAndDrop",ce[ce.dropIntoEditor=36]="dropIntoEditor",ce[ce.emptySelectionClipboard=37]="emptySelectionClipboard",ce[ce.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",ce[ce.extraEditorClassName=39]="extraEditorClassName",ce[ce.fastScrollSensitivity=40]="fastScrollSensitivity",ce[ce.find=41]="find",ce[ce.fixedOverflowWidgets=42]="fixedOverflowWidgets",ce[ce.folding=43]="folding",ce[ce.foldingStrategy=44]="foldingStrategy",ce[ce.foldingHighlight=45]="foldingHighlight",ce[ce.foldingImportsByDefault=46]="foldingImportsByDefault",ce[ce.foldingMaximumRegions=47]="foldingMaximumRegions",ce[ce.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",ce[ce.fontFamily=49]="fontFamily",ce[ce.fontInfo=50]="fontInfo",ce[ce.fontLigatures=51]="fontLigatures",ce[ce.fontSize=52]="fontSize",ce[ce.fontWeight=53]="fontWeight",ce[ce.fontVariations=54]="fontVariations",ce[ce.formatOnPaste=55]="formatOnPaste",ce[ce.formatOnType=56]="formatOnType",ce[ce.glyphMargin=57]="glyphMargin",ce[ce.gotoLocation=58]="gotoLocation",ce[ce.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",ce[ce.hover=60]="hover",ce[ce.inDiffEditor=61]="inDiffEditor",ce[ce.inlineSuggest=62]="inlineSuggest",ce[ce.letterSpacing=63]="letterSpacing",ce[ce.lightbulb=64]="lightbulb",ce[ce.lineDecorationsWidth=65]="lineDecorationsWidth",ce[ce.lineHeight=66]="lineHeight",ce[ce.lineNumbers=67]="lineNumbers",ce[ce.lineNumbersMinChars=68]="lineNumbersMinChars",ce[ce.linkedEditing=69]="linkedEditing",ce[ce.links=70]="links",ce[ce.matchBrackets=71]="matchBrackets",ce[ce.minimap=72]="minimap",ce[ce.mouseStyle=73]="mouseStyle",ce[ce.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",ce[ce.mouseWheelZoom=75]="mouseWheelZoom",ce[ce.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",ce[ce.multiCursorModifier=77]="multiCursorModifier",ce[ce.multiCursorPaste=78]="multiCursorPaste",ce[ce.multiCursorLimit=79]="multiCursorLimit",ce[ce.occurrencesHighlight=80]="occurrencesHighlight",ce[ce.overviewRulerBorder=81]="overviewRulerBorder",ce[ce.overviewRulerLanes=82]="overviewRulerLanes",ce[ce.padding=83]="padding",ce[ce.pasteAs=84]="pasteAs",ce[ce.parameterHints=85]="parameterHints",ce[ce.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",ce[ce.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",ce[ce.quickSuggestions=88]="quickSuggestions",ce[ce.quickSuggestionsDelay=89]="quickSuggestionsDelay",ce[ce.readOnly=90]="readOnly",ce[ce.readOnlyMessage=91]="readOnlyMessage",ce[ce.renameOnType=92]="renameOnType",ce[ce.renderControlCharacters=93]="renderControlCharacters",ce[ce.renderFinalNewline=94]="renderFinalNewline",ce[ce.renderLineHighlight=95]="renderLineHighlight",ce[ce.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",ce[ce.renderValidationDecorations=97]="renderValidationDecorations",ce[ce.renderWhitespace=98]="renderWhitespace",ce[ce.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",ce[ce.roundedSelection=100]="roundedSelection",ce[ce.rulers=101]="rulers",ce[ce.scrollbar=102]="scrollbar",ce[ce.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",ce[ce.scrollBeyondLastLine=104]="scrollBeyondLastLine",ce[ce.scrollPredominantAxis=105]="scrollPredominantAxis",ce[ce.selectionClipboard=106]="selectionClipboard",ce[ce.selectionHighlight=107]="selectionHighlight",ce[ce.selectOnLineNumbers=108]="selectOnLineNumbers",ce[ce.showFoldingControls=109]="showFoldingControls",ce[ce.showUnused=110]="showUnused",ce[ce.snippetSuggestions=111]="snippetSuggestions",ce[ce.smartSelect=112]="smartSelect",ce[ce.smoothScrolling=113]="smoothScrolling",ce[ce.stickyScroll=114]="stickyScroll",ce[ce.stickyTabStops=115]="stickyTabStops",ce[ce.stopRenderingLineAfter=116]="stopRenderingLineAfter",ce[ce.suggest=117]="suggest",ce[ce.suggestFontSize=118]="suggestFontSize",ce[ce.suggestLineHeight=119]="suggestLineHeight",ce[ce.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",ce[ce.suggestSelection=121]="suggestSelection",ce[ce.tabCompletion=122]="tabCompletion",ce[ce.tabIndex=123]="tabIndex",ce[ce.unicodeHighlighting=124]="unicodeHighlighting",ce[ce.unusualLineTerminators=125]="unusualLineTerminators",ce[ce.useShadowDOM=126]="useShadowDOM",ce[ce.useTabStops=127]="useTabStops",ce[ce.wordBreak=128]="wordBreak",ce[ce.wordSeparators=129]="wordSeparators",ce[ce.wordWrap=130]="wordWrap",ce[ce.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",ce[ce.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",ce[ce.wordWrapColumn=133]="wordWrapColumn",ce[ce.wordWrapOverride1=134]="wordWrapOverride1",ce[ce.wordWrapOverride2=135]="wordWrapOverride2",ce[ce.wrappingIndent=136]="wrappingIndent",ce[ce.wrappingStrategy=137]="wrappingStrategy",ce[ce.showDeprecated=138]="showDeprecated",ce[ce.inlayHints=139]="inlayHints",ce[ce.editorClassName=140]="editorClassName",ce[ce.pixelRatio=141]="pixelRatio",ce[ce.tabFocusMode=142]="tabFocusMode",ce[ce.layoutInfo=143]="layoutInfo",ce[ce.wrappingInfo=144]="wrappingInfo",ce[ce.defaultColorDecorators=145]="defaultColorDecorators",ce[ce.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",ce[ce.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(Ze||(e.EditorOption=Ze={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Me(new s(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:b.localize(196,null)})),acceptSuggestionOnEnter:Me(new o(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",b.localize(197,null),""],markdownDescription:b.localize(198,null)})),accessibilitySupport:Me(new u),accessibilityPageSize:Me(new c(3,"accessibilityPageSize",10,1,1073741824,{description:b.localize(199,null),tags:["accessibility"]})),ariaLabel:Me(new t(4,"ariaLabel",b.localize(200,null))),ariaRequired:Me(new s(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Me(new s(8,"screenReaderAnnounceInlineSuggestion",!0,{description:b.localize(201,null),tags:["accessibility"]})),autoClosingBrackets:Me(new o(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(202,null),b.localize(203,null),""],description:b.localize(204,null)})),autoClosingComments:Me(new o(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(205,null),b.localize(206,null),""],description:b.localize(207,null)})),autoClosingDelete:Me(new o(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",b.localize(208,null),""],description:b.localize(209,null)})),autoClosingOvertype:Me(new o(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",b.localize(210,null),""],description:b.localize(211,null)})),autoClosingQuotes:Me(new o(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(212,null),b.localize(213,null),""],description:b.localize(214,null)})),autoIndent:Me(new i(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],a,{enumDescriptions:[b.localize(215,null),b.localize(216,null),b.localize(217,null),b.localize(218,null),b.localize(219,null)],description:b.localize(220,null)})),automaticLayout:Me(new s(13,"automaticLayout",!1)),autoSurround:Me(new o(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[b.localize(221,null),b.localize(222,null),b.localize(223,null),""],description:b.localize(224,null)})),bracketPairColorization:Me(new se),bracketPairGuides:Me(new X),stickyTabStops:Me(new s(115,"stickyTabStops",!1,{description:b.localize(225,null)})),codeLens:Me(new s(17,"codeLens",!0,{description:b.localize(226,null)})),codeLensFontFamily:Me(new t(18,"codeLensFontFamily","",{description:b.localize(227,null)})),codeLensFontSize:Me(new c(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:b.localize(228,null)})),colorDecorators:Me(new s(20,"colorDecorators",!0,{description:b.localize(229,null)})),colorDecoratorActivatedOn:Me(new o(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[b.localize(230,null),b.localize(231,null),b.localize(232,null)],description:b.localize(233,null)})),colorDecoratorsLimit:Me(new c(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:b.localize(234,null)})),columnSelection:Me(new s(22,"columnSelection",!1,{description:b.localize(235,null)})),comments:Me(new k),contextmenu:Me(new s(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Me(new s(25,"copyWithSyntaxHighlighting",!0,{description:b.localize(236,null)})),cursorBlinking:Me(new i(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],$,{description:b.localize(237,null)})),cursorSmoothCaretAnimation:Me(new o(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[b.localize(238,null),b.localize(239,null),b.localize(240,null)],description:b.localize(241,null)})),cursorStyle:Me(new i(28,"cursorStyle",g.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],P,{description:b.localize(242,null)})),cursorSurroundingLines:Me(new c(29,"cursorSurroundingLines",0,0,1073741824,{description:b.localize(243,null)})),cursorSurroundingLinesStyle:Me(new o(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[b.localize(244,null),b.localize(245,null)],markdownDescription:b.localize(246,null)})),cursorWidth:Me(new c(31,"cursorWidth",0,0,1073741824,{markdownDescription:b.localize(247,null)})),disableLayerHinting:Me(new s(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Me(new s(33,"disableMonospaceOptimizations",!1)),domReadOnly:Me(new s(34,"domReadOnly",!1)),dragAndDrop:Me(new s(35,"dragAndDrop",!0,{description:b.localize(248,null)})),emptySelectionClipboard:Me(new O),dropIntoEditor:Me(new it),stickyScroll:Me(new ue),experimentalWhitespaceRendering:Me(new o(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[b.localize(249,null),b.localize(250,null),b.localize(251,null)],description:b.localize(252,null)})),extraEditorClassName:Me(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Me(new h(40,"fastScrollSensitivity",5,ce=>ce<=0?5:ce,{markdownDescription:b.localize(253,null)})),find:Me(new L),fixedOverflowWidgets:Me(new s(42,"fixedOverflowWidgets",!1)),folding:Me(new s(43,"folding",!0,{description:b.localize(254,null)})),foldingStrategy:Me(new o(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[b.localize(255,null),b.localize(256,null)],description:b.localize(257,null)})),foldingHighlight:Me(new s(45,"foldingHighlight",!0,{description:b.localize(258,null)})),foldingImportsByDefault:Me(new s(46,"foldingImportsByDefault",!1,{description:b.localize(259,null)})),foldingMaximumRegions:Me(new c(47,"foldingMaximumRegions",5e3,10,65e3,{description:b.localize(260,null)})),unfoldOnClickAfterEndOfLine:Me(new s(48,"unfoldOnClickAfterEndOfLine",!1,{description:b.localize(261,null)})),fontFamily:Me(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:b.localize(262,null)})),fontInfo:Me(new F),fontLigatures2:Me(new j),fontSize:Me(new H),fontWeight:Me(new K),fontVariations:Me(new z),formatOnPaste:Me(new s(55,"formatOnPaste",!1,{description:b.localize(263,null)})),formatOnType:Me(new s(56,"formatOnType",!1,{description:b.localize(264,null)})),glyphMargin:Me(new s(57,"glyphMargin",!0,{description:b.localize(265,null)})),gotoLocation:Me(new fe),hideCursorInOverviewRuler:Me(new s(59,"hideCursorInOverviewRuler",!1,{description:b.localize(266,null)})),hover:Me(new x),inDiffEditor:Me(new s(61,"inDiffEditor",!1)),letterSpacing:Me(new h(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ce=>h.clamp(ce,-5,20),{description:b.localize(267,null)})),lightbulb:Me(new be),lineDecorationsWidth:Me(new J),lineHeight:Me(new U),lineNumbers:Me(new he),lineNumbersMinChars:Me(new c(68,"lineNumbersMinChars",5,1,300)),linkedEditing:Me(new s(69,"linkedEditing",!1,{description:b.localize(268,null)})),links:Me(new s(70,"links",!0,{description:b.localize(269,null)})),matchBrackets:Me(new o(71,"matchBrackets","always",["always","near","never"],{description:b.localize(270,null)})),minimap:Me(new V),mouseStyle:Me(new o(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Me(new h(74,"mouseWheelScrollSensitivity",1,ce=>ce===0?1:ce,{markdownDescription:b.localize(271,null)})),mouseWheelZoom:Me(new s(75,"mouseWheelZoom",!1,{markdownDescription:b.localize(272,null)})),multiCursorMergeOverlapping:Me(new s(76,"multiCursorMergeOverlapping",!0,{description:b.localize(273,null)})),multiCursorModifier:Me(new i(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ge,{markdownEnumDescriptions:[b.localize(274,null),b.localize(275,null)],markdownDescription:b.localize(276,null)})),multiCursorPaste:Me(new o(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[b.localize(277,null),b.localize(278,null)],markdownDescription:b.localize(279,null)})),multiCursorLimit:Me(new c(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:b.localize(280,null)})),occurrencesHighlight:Me(new s(80,"occurrencesHighlight",!0,{description:b.localize(281,null)})),overviewRulerBorder:Me(new s(81,"overviewRulerBorder",!0,{description:b.localize(282,null)})),overviewRulerLanes:Me(new c(82,"overviewRulerLanes",3,0,3)),padding:Me(new _),pasteAs:Me(new et),parameterHints:Me(new ie),peekWidgetDefaultFocus:Me(new o(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[b.localize(283,null),b.localize(284,null)],description:b.localize(285,null)})),definitionLinkOpensInPeek:Me(new s(87,"definitionLinkOpensInPeek",!1,{description:b.localize(286,null)})),quickSuggestions:Me(new Ee),quickSuggestionsDelay:Me(new c(89,"quickSuggestionsDelay",10,0,1073741824,{description:b.localize(287,null)})),readOnly:Me(new s(90,"readOnly",!1)),readOnlyMessage:Me(new $e),renameOnType:Me(new s(92,"renameOnType",!1,{description:b.localize(288,null),markdownDeprecationMessage:b.localize(289,null)})),renderControlCharacters:Me(new s(93,"renderControlCharacters",!0,{description:b.localize(290,null),restricted:!0})),renderFinalNewline:Me(new o(94,"renderFinalNewline",d.$l?"dimmed":"on",["off","on","dimmed"],{description:b.localize(291,null)})),renderLineHighlight:Me(new o(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",b.localize(292,null)],description:b.localize(293,null)})),renderLineHighlightOnlyWhenFocus:Me(new s(96,"renderLineHighlightOnlyWhenFocus",!1,{description:b.localize(294,null)})),renderValidationDecorations:Me(new o(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Me(new o(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",b.localize(295,null),b.localize(296,null),b.localize(297,null),""],description:b.localize(298,null)})),revealHorizontalRightPadding:Me(new c(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Me(new s(100,"roundedSelection",!0,{description:b.localize(299,null)})),rulers:Me(new le),scrollbar:Me(new B),scrollBeyondLastColumn:Me(new c(103,"scrollBeyondLastColumn",4,0,1073741824,{description:b.localize(300,null)})),scrollBeyondLastLine:Me(new s(104,"scrollBeyondLastLine",!0,{description:b.localize(301,null)})),scrollPredominantAxis:Me(new s(105,"scrollPredominantAxis",!0,{description:b.localize(302,null)})),selectionClipboard:Me(new s(106,"selectionClipboard",!0,{description:b.localize(303,null),included:d.$l})),selectionHighlight:Me(new s(107,"selectionHighlight",!0,{description:b.localize(304,null)})),selectOnLineNumbers:Me(new s(108,"selectOnLineNumbers",!0)),showFoldingControls:Me(new o(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[b.localize(305,null),b.localize(306,null),b.localize(307,null)],description:b.localize(308,null)})),showUnused:Me(new s(110,"showUnused",!0,{description:b.localize(309,null)})),showDeprecated:Me(new s(138,"showDeprecated",!0,{description:b.localize(310,null)})),inlayHints:Me(new ve),snippetSuggestions:Me(new o(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[b.localize(311,null),b.localize(312,null),b.localize(313,null),b.localize(314,null)],description:b.localize(315,null)})),smartSelect:Me(new je),smoothScrolling:Me(new s(113,"smoothScrolling",!1,{description:b.localize(316,null)})),stopRenderingLineAfter:Me(new c(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Me(new ye),inlineSuggest:Me(new te),inlineCompletionsAccessibilityVerbose:Me(new s(147,"inlineCompletionsAccessibilityVerbose",!1,{description:b.localize(317,null)})),suggestFontSize:Me(new c(118,"suggestFontSize",0,0,1e3,{markdownDescription:b.localize(318,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Me(new c(119,"suggestLineHeight",0,0,1e3,{markdownDescription:b.localize(319,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Me(new s(120,"suggestOnTriggerCharacters",!0,{description:b.localize(320,null)})),suggestSelection:Me(new o(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[b.localize(321,null),b.localize(322,null),b.localize(323,null)],description:b.localize(324,null)})),tabCompletion:Me(new o(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[b.localize(325,null),b.localize(326,null),b.localize(327,null)],description:b.localize(328,null)})),tabIndex:Me(new c(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:Me(new Q),unusualLineTerminators:Me(new o(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[b.localize(329,null),b.localize(330,null),b.localize(331,null)],description:b.localize(332,null)})),useShadowDOM:Me(new s(126,"useShadowDOM",!0)),useTabStops:Me(new s(127,"useTabStops",!0,{description:b.localize(333,null)})),wordBreak:Me(new o(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[b.localize(334,null),b.localize(335,null)],description:b.localize(336,null)})),wordSeparators:Me(new t(129,"wordSeparators",A.$Zr,{description:b.localize(337,null)})),wordWrap:Me(new o(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[b.localize(338,null),b.localize(339,null),b.localize(340,null),b.localize(341,null)],description:b.localize(342,null)})),wordWrapBreakAfterCharacters:Me(new t(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Me(new t(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Me(new c(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:b.localize(343,null)})),wordWrapOverride1:Me(new o(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Me(new o(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Me(new N),defaultColorDecorators:Me(new s(145,"defaultColorDecorators",!1,{markdownDescription:b.localize(344,null)})),pixelRatio:Me(new re),tabFocusMode:Me(new s(142,"tabFocusMode",!1,{markdownDescription:b.localize(345,null)})),layoutInfo:Me(new q),wrappingInfo:Me(new Ye),wrappingIndent:Me(new _e),wrappingStrategy:Me(new Y)}}),define(De[187],Ce([10,11]),function(me,e){return me.create("vs/editor/common/languages",e)}),define(De[82],Ce([1,0,78,2,164,34,174,187]),function(me,e,C,T,d,M,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.$ft=e.$et=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.$dt=e.$ct=e.SymbolKinds=e.SymbolTag=e.$bt=e.$at=e.SymbolKind=e.$_s=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.$$s=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$0s=e.$9s=e.$8s=void 0;class E{constructor(j,z,F){this.offset=j,this.type=z,this.language=F,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$8s=E;class w{constructor(j,z){this.tokens=j,this.endState=z,this._tokenizationResultBrand=void 0}}e.$9s=w;class R{constructor(j,z){this.tokens=j,this.endState=z,this._encodedTokenizationResultBrand=void 0}}e.$0s=R;var I;(function(L){L[L.Method=0]="Method",L[L.Function=1]="Function",L[L.Constructor=2]="Constructor",L[L.Field=3]="Field",L[L.Variable=4]="Variable",L[L.Class=5]="Class",L[L.Struct=6]="Struct",L[L.Interface=7]="Interface",L[L.Module=8]="Module",L[L.Property=9]="Property",L[L.Event=10]="Event",L[L.Operator=11]="Operator",L[L.Unit=12]="Unit",L[L.Value=13]="Value",L[L.Constant=14]="Constant",L[L.Enum=15]="Enum",L[L.EnumMember=16]="EnumMember",L[L.Keyword=17]="Keyword",L[L.Text=18]="Text",L[L.Color=19]="Color",L[L.File=20]="File",L[L.Reference=21]="Reference",L[L.Customcolor=22]="Customcolor",L[L.Folder=23]="Folder",L[L.TypeParameter=24]="TypeParameter",L[L.User=25]="User",L[L.Issue=26]="Issue",L[L.Snippet=27]="Snippet"})(I||(e.CompletionItemKind=I={}));var p;(function(L){const j=new Map;j.set(0,C.$Sj.symbolMethod),j.set(1,C.$Sj.symbolFunction),j.set(2,C.$Sj.symbolConstructor),j.set(3,C.$Sj.symbolField),j.set(4,C.$Sj.symbolVariable),j.set(5,C.$Sj.symbolClass),j.set(6,C.$Sj.symbolStruct),j.set(7,C.$Sj.symbolInterface),j.set(8,C.$Sj.symbolModule),j.set(9,C.$Sj.symbolProperty),j.set(10,C.$Sj.symbolEvent),j.set(11,C.$Sj.symbolOperator),j.set(12,C.$Sj.symbolUnit),j.set(13,C.$Sj.symbolValue),j.set(15,C.$Sj.symbolEnum),j.set(14,C.$Sj.symbolConstant),j.set(15,C.$Sj.symbolEnum),j.set(16,C.$Sj.symbolEnumMember),j.set(17,C.$Sj.symbolKeyword),j.set(27,C.$Sj.symbolSnippet),j.set(18,C.$Sj.symbolText),j.set(19,C.$Sj.symbolColor),j.set(20,C.$Sj.symbolFile),j.set(21,C.$Sj.symbolReference),j.set(22,C.$Sj.symbolCustomColor),j.set(23,C.$Sj.symbolFolder),j.set(24,C.$Sj.symbolTypeParameter),j.set(25,C.$Sj.account),j.set(26,C.$Sj.issues);function z(K){let fe=j.get(K);return fe||(console.info("No codicon found for CompletionItemKind "+K),fe=C.$Sj.symbolProperty),fe}L.toIcon=z;const F=new Map;F.set("method",0),F.set("function",1),F.set("constructor",2),F.set("field",3),F.set("variable",4),F.set("class",5),F.set("struct",6),F.set("interface",7),F.set("module",8),F.set("property",9),F.set("event",10),F.set("operator",11),F.set("unit",12),F.set("value",13),F.set("constant",14),F.set("enum",15),F.set("enum-member",16),F.set("enumMember",16),F.set("keyword",17),F.set("snippet",27),F.set("text",18),F.set("color",19),F.set("file",20),F.set("reference",21),F.set("customcolor",22),F.set("folder",23),F.set("type-parameter",24),F.set("typeParameter",24),F.set("account",25),F.set("issue",26);function H(K,fe){let x=F.get(K);return typeof x>"u"&&!fe&&(x=9),x}L.fromString=H})(p||(e.CompletionItemKinds=p={}));var y;(function(L){L[L.Deprecated=1]="Deprecated"})(y||(e.CompletionItemTag=y={}));var D;(function(L){L[L.None=0]="None",L[L.KeepWhitespace=1]="KeepWhitespace",L[L.InsertAsSnippet=4]="InsertAsSnippet"})(D||(e.CompletionItemInsertTextRule=D={}));var v;(function(L){L[L.Invoke=0]="Invoke",L[L.TriggerCharacter=1]="TriggerCharacter",L[L.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(v||(e.CompletionTriggerKind=v={}));var l;(function(L){L[L.Automatic=0]="Automatic",L[L.Explicit=1]="Explicit"})(l||(e.InlineCompletionTriggerKind=l={}));class s{constructor(j,z,F,H){this.range=j,this.text=z,this.completionKind=F,this.isSnippetText=H}equals(j){return M.$os.lift(this.range).equalsRange(j.range)&&this.text===j.text&&this.completionKind===j.completionKind&&this.isSnippetText===j.isSnippetText}}e.$$s=s;var r;(function(L){L[L.Invoke=1]="Invoke",L[L.Auto=2]="Auto"})(r||(e.CodeActionTriggerType=r={}));var c;(function(L){L[L.Invoke=1]="Invoke",L[L.TriggerCharacter=2]="TriggerCharacter",L[L.ContentChange=3]="ContentChange"})(c||(e.SignatureHelpTriggerKind=c={}));var m;(function(L){L[L.Text=0]="Text",L[L.Read=1]="Read",L[L.Write=2]="Write"})(m||(e.DocumentHighlightKind=m={}));function h(L){return L&&T.URI.isUri(L.uri)&&M.$os.isIRange(L.range)&&(M.$os.isIRange(L.originSelectionRange)||M.$os.isIRange(L.targetSelectionRange))}e.$_s=h;var t;(function(L){L[L.File=0]="File",L[L.Module=1]="Module",L[L.Namespace=2]="Namespace",L[L.Package=3]="Package",L[L.Class=4]="Class",L[L.Method=5]="Method",L[L.Property=6]="Property",L[L.Field=7]="Field",L[L.Constructor=8]="Constructor",L[L.Enum=9]="Enum",L[L.Interface=10]="Interface",L[L.Function=11]="Function",L[L.Variable=12]="Variable",L[L.Constant=13]="Constant",L[L.String=14]="String",L[L.Number=15]="Number",L[L.Boolean=16]="Boolean",L[L.Array=17]="Array",L[L.Object=18]="Object",L[L.Key=19]="Key",L[L.Null=20]="Null",L[L.EnumMember=21]="EnumMember",L[L.Struct=22]="Struct",L[L.Event=23]="Event",L[L.Operator=24]="Operator",L[L.TypeParameter=25]="TypeParameter"})(t||(e.SymbolKind=t={})),e.$at={[17]:(0,b.localize)(0,null),[16]:(0,b.localize)(1,null),[4]:(0,b.localize)(2,null),[13]:(0,b.localize)(3,null),[8]:(0,b.localize)(4,null),[9]:(0,b.localize)(5,null),[21]:(0,b.localize)(6,null),[23]:(0,b.localize)(7,null),[7]:(0,b.localize)(8,null),[0]:(0,b.localize)(9,null),[11]:(0,b.localize)(10,null),[10]:(0,b.localize)(11,null),[19]:(0,b.localize)(12,null),[5]:(0,b.localize)(13,null),[1]:(0,b.localize)(14,null),[2]:(0,b.localize)(15,null),[20]:(0,b.localize)(16,null),[15]:(0,b.localize)(17,null),[18]:(0,b.localize)(18,null),[24]:(0,b.localize)(19,null),[3]:(0,b.localize)(20,null),[6]:(0,b.localize)(21,null),[14]:(0,b.localize)(22,null),[22]:(0,b.localize)(23,null),[25]:(0,b.localize)(24,null),[12]:(0,b.localize)(25,null)};function n(L,j){return(0,b.localize)(26,null,L,e.$at[j])}e.$bt=n;var o;(function(L){L[L.Deprecated=1]="Deprecated"})(o||(e.SymbolTag=o={}));var i;(function(L){const j=new Map;j.set(0,C.$Sj.symbolFile),j.set(1,C.$Sj.symbolModule),j.set(2,C.$Sj.symbolNamespace),j.set(3,C.$Sj.symbolPackage),j.set(4,C.$Sj.symbolClass),j.set(5,C.$Sj.symbolMethod),j.set(6,C.$Sj.symbolProperty),j.set(7,C.$Sj.symbolField),j.set(8,C.$Sj.symbolConstructor),j.set(9,C.$Sj.symbolEnum),j.set(10,C.$Sj.symbolInterface),j.set(11,C.$Sj.symbolFunction),j.set(12,C.$Sj.symbolVariable),j.set(13,C.$Sj.symbolConstant),j.set(14,C.$Sj.symbolString),j.set(15,C.$Sj.symbolNumber),j.set(16,C.$Sj.symbolBoolean),j.set(17,C.$Sj.symbolArray),j.set(18,C.$Sj.symbolObject),j.set(19,C.$Sj.symbolKey),j.set(20,C.$Sj.symbolNull),j.set(21,C.$Sj.symbolEnumMember),j.set(22,C.$Sj.symbolStruct),j.set(23,C.$Sj.symbolEvent),j.set(24,C.$Sj.symbolOperator),j.set(25,C.$Sj.symbolTypeParameter);function z(F){let H=j.get(F);return H||(console.info("No codicon found for SymbolKind "+F),H=C.$Sj.symbolProperty),H}L.toIcon=z})(i||(e.SymbolKinds=i={}));class a{static asEditOperation(j){return d.$ps.replace(M.$os.lift(j.range),j.text)}}e.$ct=a;class u{static{this.Comment=new u("comment")}static{this.Imports=new u("imports")}static{this.Region=new u("region")}static fromValue(j){switch(j){case"comment":return u.Comment;case"imports":return u.Imports;case"region":return u.Region}return new u(j)}constructor(j){this.value=j}}e.$dt=u;var k;(function(L){function j(z){return!z||typeof z!="object"?!1:typeof z.id=="string"&&typeof z.title=="string"}L.is=j})(k||(e.Command=k={}));var S;(function(L){L[L.Collapsed=0]="Collapsed",L[L.Expanded=1]="Expanded"})(S||(e.CommentThreadCollapsibleState=S={}));var $;(function(L){L[L.Unresolved=0]="Unresolved",L[L.Resolved=1]="Resolved"})($||(e.CommentThreadState=$={}));var g;(function(L){L[L.Editing=0]="Editing",L[L.Preview=1]="Preview"})(g||(e.CommentMode=g={}));var f;(function(L){L[L.Published=0]="Published",L[L.Draft=1]="Draft"})(f||(e.CommentState=f={}));var P;(function(L){L[L.Type=1]="Type",L[L.Parameter=2]="Parameter"})(P||(e.InlayHintKind=P={}));class N{constructor(j){this.b=j,this.a=null}dispose(){this.a&&this.a.then(j=>{j&&j.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$et=N,e.$ft=new A.$Zs;var O;(function(L){L[L.None=0]="None",L[L.Option=1]="Option",L[L.Default=2]="Default",L[L.Preferred=3]="Preferred"})(O||(e.ExternalUriOpenerPriority=O={}))}),define(De[188],Ce([10,11]),function(me,e){return me.create("vs/platform/configuration/common/configurationRegistry",e)}),define(De[189],Ce([10,11]),function(me,e){return me.create("vs/platform/contextkey/common/contextkey",e)}),define(De[190],Ce([10,11]),function(me,e){return me.create("vs/platform/contextkey/common/scanner",e)}),define(De[191],Ce([10,11]),function(me,e){return me.create("vs/platform/dialogs/common/dialogs",e)}),define(De[192],Ce([10,11]),function(me,e){return me.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(De[193],Ce([10,11]),function(me,e){return me.create("vs/platform/extensions/common/extensionValidator",e)}),define(De[194],Ce([10,11]),function(me,e){return me.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(De[195],Ce([10,11]),function(me,e){return me.create("vs/platform/files/common/files",e)}),define(De[196],Ce([10,11]),function(me,e){return me.create("vs/platform/files/common/io",e)}),define(De[197],Ce([10,11]),function(me,e){return me.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(De[198],Ce([10,11]),function(me,e){return me.create("vs/platform/markers/common/markers",e)}),define(De[199],Ce([10,11]),function(me,e){return me.create("vs/platform/theme/common/iconRegistry",e)}),define(De[200],Ce([10,11]),function(me,e){return me.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(De[201],Ce([10,11]),function(me,e){return me.create("vs/platform/workspace/common/workspace",e)}),define(De[202],Ce([10,11]),function(me,e){return me.create("vs/workbench/api/common/extHostChat",e)}),define(De[203],Ce([10,11]),function(me,e){return me.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(De[204],Ce([10,11]),function(me,e){return me.create("vs/workbench/api/common/extHostExtensionService",e)}),define(De[205],Ce([10,11]),function(me,e){return me.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(De[206],Ce([10,11]),function(me,e){return me.create("vs/workbench/api/common/extHostLogService",e)}),define(De[207],Ce([10,11]),function(me,e){return me.create("vs/workbench/api/common/extHostNotebook",e)}),define(De[208],Ce([10,11]),function(me,e){return me.create("vs/workbench/api/common/extHostProgress",e)}),define(De[209],Ce([10,11]),function(me,e){return me.create("vs/workbench/api/common/extHostStatusBar",e)}),define(De[210],Ce([10,11]),function(me,e){return me.create("vs/workbench/api/common/extHostTelemetry",e)}),define(De[211],Ce([10,11]),function(me,e){return me.create("vs/workbench/api/common/extHostTerminalService",e)}),define(De[212],Ce([10,11]),function(me,e){return me.create("vs/workbench/api/common/extHostTreeViews",e)}),define(De[213],Ce([10,11]),function(me,e){return me.create("vs/workbench/api/common/extHostTunnelService",e)}),define(De[214],Ce([10,11]),function(me,e){return me.create("vs/workbench/api/common/extHostWorkspace",e)}),define(De[215],Ce([10,11]),function(me,e){return me.create("vs/workbench/api/node/extHostDebugService",e)}),define(De[216],Ce([10,11]),function(me,e){return me.create("vs/workbench/common/editor",e)}),define(De[217],Ce([10,11]),function(me,e){return me.create("vs/workbench/common/views",e)}),define(De[218],Ce([10,11]),function(me,e){return me.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(De[219],Ce([10,11]),function(me,e){return me.create("vs/workbench/contrib/debug/common/debug",e)}),define(De[220],Ce([10,11]),function(me,e){return me.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(De[221],Ce([10,11]),function(me,e){return me.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(De[222],Ce([10,11]),function(me,e){return me.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(De[223],Ce([10,11]),function(me,e){return me.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(De[224],Ce([10,11]),function(me,e){return me.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(De[225],Ce([10,11]),function(me,e){return me.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(De[226],Ce([10,11]),function(me,e){return me.create("vs/workbench/services/search/common/queryBuilder",e)}),define(De[227],Ce([1,0,8,190]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=e.TokenType=void 0;var d;(function(w){w[w.LParen=0]="LParen",w[w.RParen=1]="RParen",w[w.Neg=2]="Neg",w[w.Eq=3]="Eq",w[w.NotEq=4]="NotEq",w[w.Lt=5]="Lt",w[w.LtEq=6]="LtEq",w[w.Gt=7]="Gt",w[w.GtEq=8]="GtEq",w[w.RegexOp=9]="RegexOp",w[w.RegexStr=10]="RegexStr",w[w.True=11]="True",w[w.False=12]="False",w[w.In=13]="In",w[w.Not=14]="Not",w[w.And=15]="And",w[w.Or=16]="Or",w[w.Str=17]="Str",w[w.QuotedStr=18]="QuotedStr",w[w.Error=19]="Error",w[w.EOF=20]="EOF"})(d||(e.TokenType=d={}));function M(...w){switch(w.length){case 1:return(0,T.localize)(0,null,w[0]);case 2:return(0,T.localize)(1,null,w[0],w[1]);case 3:return(0,T.localize)(2,null,w[0],w[1],w[2]);default:return}}const A=(0,T.localize)(3,null),b=(0,T.localize)(4,null);class E{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(R){switch(R.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return R.isTripleEq?"===":"==";case 4:return R.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return R.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return R.lexeme;case 18:return R.lexeme;case 19:return R.lexeme;case 20:return"EOF";default:throw(0,C.$7)(`unhandled token type: ${JSON.stringify(R)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(R=>R.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(R){return this.c=R,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const I=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:I})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const I=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:I})}else this.h(126)?this.k(9):this.l(M("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(M("&&"));break;case 124:this.h(124)?this.k(16):this.l(M("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(R){return this.r()||this.c.charCodeAt(this.e)!==R?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(R){this.f.push({type:R,offset:this.d})}l(R){const I=this.d,p=this.c.substring(this.d,this.e),y={type:19,offset:this.d,lexeme:p};this.g.push({offset:I,lexeme:p,additionalInfo:R}),this.f.push(y)}n(){this.m.lastIndex=this.d;const R=this.m.exec(this.c);if(R){this.e=this.d+R[0].length;const I=this.c.substring(this.d,this.e),p=E.b.get(I);p?this.k(p):this.f.push({type:17,lexeme:I,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let R=this.e,I=!1,p=!1;for(;;){if(R>=this.c.length){this.e=R,this.l(b);return}const D=this.c.charCodeAt(R);if(I)I=!1;else if(D===47&&!p){R++;break}else D===91?p=!0:D===92?I=!0:D===93&&(p=!1);R++}for(;R<this.c.length&&E.a.has(this.c.charCodeAt(R));)R++;this.e=R;const y=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:y,offset:this.d})}r(){return this.e>=this.c.length}}e.$Ii=E}),define(De[228],Ce([1,0,24,38,193,371]),function(me,e,C,T,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function E(s){return s=s.trim(),s==="*"||A.test(s)}e.$Ho=E;function w(s){if(!E(s))return null;if(s=s.trim(),s==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const r=s.match(A);return r?{hasCaret:r[1]==="^",hasGreaterEquals:r[1]===">=",majorBase:r[2]==="x"?0:parseInt(r[2],10),majorMustEqual:r[2]!=="x",minorBase:r[4]==="x"?0:parseInt(r[4],10),minorMustEqual:r[4]!=="x",patchBase:r[6]==="x"?0:parseInt(r[6],10),patchMustEqual:r[6]!=="x",preRelease:r[8]||null}:null}e.$Io=w;function R(s){if(!s)return null;const r=s.majorBase,c=s.majorMustEqual,m=s.minorBase;let h=s.minorMustEqual;const t=s.patchBase;let n=s.patchMustEqual;s.hasCaret&&(r===0||(h=!1),n=!1);let o=0;if(s.preRelease){const i=b.exec(s.preRelease);if(i){const[,a,u,k]=i;o=Date.UTC(Number(a),Number(u)-1,Number(k))}}return{majorBase:r,majorMustEqual:c,minorBase:m,minorMustEqual:h,patchBase:t,patchMustEqual:n,isMinimum:s.hasGreaterEquals,notBefore:o}}e.$Jo=R;function I(s,r,c){let m;typeof s=="string"?m=R(w(s)):m=s;let h;r instanceof Date?h=r.getTime():typeof r=="string"&&(h=new Date(r).getTime());let t;if(typeof c=="string"?t=R(w(c)):t=c,!m||!t)return!1;const n=m.majorBase,o=m.minorBase,i=m.patchBase;let a=t.majorBase,u=t.minorBase,k=t.patchBase;const S=t.notBefore;let $=t.majorMustEqual,g=t.minorMustEqual,f=t.patchMustEqual;return t.isMinimum?n>a?!0:n<a?!1:o>u?!0:o<u||h&&h<S?!1:i>=k:(n===1&&a===0&&(!$||!g||!f)&&(a=1,u=0,k=0,$=!0,g=!1,f=!1),n<a?!1:n>a?!$:o<u?!1:o>u?!g:i<k?!1:i>k?!f:!(h&&h<S))}e.$Ko=I;function p(s,r,c,m,h){const t=[];if(typeof m.publisher<"u"&&typeof m.publisher!="string")return t.push([T.default.Error,d.localize(0,null)]),t;if(typeof m.name!="string")return t.push([T.default.Error,d.localize(1,null,"name")]),t;if(typeof m.version!="string")return t.push([T.default.Error,d.localize(2,null,"version")]),t;if(!m.engines)return t.push([T.default.Error,d.localize(3,null,"engines")]),t;if(typeof m.engines.vscode!="string")return t.push([T.default.Error,d.localize(4,null,"engines.vscode")]),t;if(typeof m.extensionDependencies<"u"&&!l(m.extensionDependencies))return t.push([T.default.Error,d.localize(5,null,"extensionDependencies")]),t;if(typeof m.activationEvents<"u"){if(!l(m.activationEvents))return t.push([T.default.Error,d.localize(6,null,"activationEvents")]),t;if(typeof m.main>"u"&&typeof m.browser>"u")return t.push([T.default.Error,d.localize(7,null,"activationEvents","main","browser")]),t}if(typeof m.extensionKind<"u"&&typeof m.main>"u"&&t.push([T.default.Warning,d.localize(8,null,"extensionKind")]),typeof m.main<"u"){if(typeof m.main!="string")return t.push([T.default.Error,d.localize(9,null,"main")]),t;{const i=(0,C.$ug)(c,m.main);(0,C.$og)(i,c)||t.push([T.default.Warning,d.localize(10,null,i.path,c.path)])}}if(typeof m.browser<"u"){if(typeof m.browser!="string")return t.push([T.default.Error,d.localize(11,null,"browser")]),t;{const i=(0,C.$ug)(c,m.browser);(0,C.$og)(i,c)||t.push([T.default.Warning,d.localize(12,null,i.path,c.path)])}}if(!M.valid(m.version))return t.push([T.default.Error,d.localize(13,null)]),t;const n=[];if(!y(s,r,m,h,n))for(const i of n)t.push([T.default.Error,i]);return t}e.$Lo=p;function y(s,r,c,m,h){return m||typeof c.main>"u"&&typeof c.browser>"u"?!0:v(s,r,c.engines.vscode,h)}e.$Mo=y;function D(s,r,c){return s==="*"||v(r,c,s)}e.$No=D;function v(s,r,c,m=[]){const h=R(w(c));if(!h)return m.push(d.localize(14,null,c)),!1;if(h.majorBase===0){if(!h.majorMustEqual||!h.minorMustEqual)return m.push(d.localize(15,null,c)),!1}else if(!h.majorMustEqual)return m.push(d.localize(16,null,c)),!1;return I(s,r,h)?!0:(m.push(d.localize(17,null,s,c)),!1)}function l(s){if(!Array.isArray(s))return!1;for(let r=0,c=s.length;r<c;r++)if(typeof s[r]!="string")return!1;return!0}}),define(De[102],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kh=void 0;class C{constructor(d,M=[],A=!1){this.ctor=d,this.staticArguments=M,this.supportsDelayedInstantiation=A}}e.$Kh=C}),define(De[103],Ce([1,0,102]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tr=e.$sr=e.InstantiationType=void 0;const T=[];var d;(function(b){b[b.Eager=0]="Eager",b[b.Delayed=1]="Delayed"})(d||(e.InstantiationType=d={}));function M(b,E,w){E instanceof C.$Kh||(E=new C.$Kh(E,[],!!w)),T.push([b,E])}e.$sr=M;function A(){return T}e.$tr=A}),define(De[229],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$p=e.$0p=void 0;class C{constructor(M,A){this.key=M,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$0p=C;class T{constructor(M){this.b=M,this.a=new Map}roots(){const M=[];for(const A of this.a.values())A.outgoing.size===0&&M.push(A);return M}insertEdge(M,A){const b=this.lookupOrInsertNode(M),E=this.lookupOrInsertNode(A);b.outgoing.set(E.key,E),E.incoming.set(b.key,b)}removeNode(M){const A=this.b(M);this.a.delete(A);for(const b of this.a.values())b.outgoing.delete(A),b.incoming.delete(A)}lookupOrInsertNode(M){const A=this.b(M);let b=this.a.get(A);return b||(b=new C(A,M),this.a.set(A,b)),b}lookup(M){return this.a.get(this.b(M))}isEmpty(){return this.a.size===0}toString(){const M=[];for(const[A,b]of this.a)M.push(`${A}
	(-> incoming)[${[...b.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...b.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,A]of this.a){const b=new Set([M]),E=this.c(A,b);if(E)return E}}c(M,A){for(const[b,E]of M.outgoing){if(A.has(b))return[...A,b].join(" -> ");A.add(b);const w=this.c(E,A);if(w)return w;A.delete(b)}}}e.$$p=T}),define(De[5],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oh=e.$Nh=e.$Mh=e._util=void 0;var C;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function b(E){return E[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=b})(C||(e._util=C={})),e.$Mh=d("instantiationService");function T(A,b,E){b[C.DI_TARGET]===b?b[C.DI_DEPENDENCIES].push({id:A,index:E}):(b[C.DI_DEPENDENCIES]=[{id:A,index:E}],b[C.DI_TARGET]=b)}function d(A){if(C.serviceIds.has(A))return C.serviceIds.get(A);const b=function(E,w,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T(b,E,R)};return b.toString=()=>A,C.serviceIds.set(A,b),b}e.$Nh=d;function M(A){return A}e.$Oh=M}),define(De[49],Ce([1,0,18,2,5]),function(me,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.ConfigurationTarget=e.$ji=e.$ii=e.$hi=void 0,e.$hi=(0,d.$Nh)("configurationService");function M(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof T.URI)}e.$ii=M;function A(s){return s&&typeof s=="object"&&(!s.overrideIdentifiers||Array.isArray(s.overrideIdentifiers))&&!s.overrideIdentifier&&(!s.resource||s.resource instanceof T.URI)}e.$ji=A;var b;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.USER=2]="USER",s[s.USER_LOCAL=3]="USER_LOCAL",s[s.USER_REMOTE=4]="USER_REMOTE",s[s.WORKSPACE=5]="WORKSPACE",s[s.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",s[s.DEFAULT=7]="DEFAULT",s[s.MEMORY=8]="MEMORY"})(b||(e.ConfigurationTarget=b={}));function E(s){switch(s){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$ki=E;function w(s){return s.applicationValue!==void 0||s.userValue!==void 0||s.userLocalValue!==void 0||s.userRemoteValue!==void 0||s.workspaceValue!==void 0||s.workspaceFolderValue!==void 0}e.$li=w;function R(s,r){const c=Object.create(null);for(const m in s)I(c,m,s[m],r);return c}e.$mi=R;function I(s,r,c,m){const h=r.split("."),t=h.pop();let n=s;for(let o=0;o<h.length;o++){const i=h[o];let a=n[i];switch(typeof a){case"undefined":a=n[i]=Object.create(null);break;case"object":break;default:m(`Ignoring ${r} as ${h.slice(0,o+1).join(".")} is ${JSON.stringify(a)}`);return}n=a}if(typeof n=="object"&&n!==null)try{n[t]=c}catch{m(`Ignoring ${r} as ${h.join(".")} is ${JSON.stringify(n)}`)}else m(`Ignoring ${r} as ${h.join(".")} is ${JSON.stringify(n)}`)}e.$ni=I;function p(s,r){const c=r.split(".");y(s,c)}e.$oi=p;function y(s,r){const c=r.shift();if(r.length===0){delete s[c];return}if(Object.keys(s).indexOf(c)!==-1){const m=s[c];typeof m=="object"&&!Array.isArray(m)&&(y(m,r),Object.keys(m).length===0&&delete s[c])}}function D(s,r,c){function m(n,o){let i=n;for(const a of o){if(typeof i!="object"||i===null)return;i=i[a]}return i}const h=r.split("."),t=m(s,h);return typeof t>"u"?c:t}e.$pi=D;function v(s,r,c){Object.keys(r).forEach(m=>{m!=="__proto__"&&(m in s?C.$zf(s[m])&&C.$zf(r[m])?v(s[m],r[m],c):c&&(s[m]=r[m]):s[m]=r[m])})}e.$qi=v;function l(s){return s.replace(/[\[\]]/g,"")}e.$ri=l}),define(De[41],Ce([1,0,12,15,227,5,189,8]),function(me,e,C,T,d,M,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.ContextKeyExprType=e.$Ji=void 0;const E=new Map;E.set("false",!1),E.set("true",!0),E.set("isMac",C.$k),E.set("isLinux",C.$l),E.set("isWindows",C.$j),E.set("isWeb",C.$p),E.set("isMacNative",C.$k&&!C.$p),E.set("isEdge",C.$H),E.set("isFirefox",C.$F),E.set("isChrome",C.$E),E.set("isSafari",C.$G);function w(J,U){if(E.get(J)!==void 0)throw(0,b.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");E.set(J,U)}e.$Ji=w;const R=Object.prototype.hasOwnProperty;var I;(function(J){J[J.False=0]="False",J[J.True=1]="True",J[J.Defined=2]="Defined",J[J.Not=3]="Not",J[J.Equals=4]="Equals",J[J.NotEquals=5]="NotEquals",J[J.And=6]="And",J[J.Regex=7]="Regex",J[J.NotRegex=8]="NotRegex",J[J.Or=9]="Or",J[J.In=10]="In",J[J.NotIn=11]="NotIn",J[J.Greater=12]="Greater",J[J.GreaterEquals=13]="GreaterEquals",J[J.Smaller=14]="Smaller",J[J.SmallerEquals=15]="SmallerEquals"})(I||(e.ContextKeyExprType=I={}));const p={regexParsingWithErrorRecovery:!0},y=(0,A.localize)(0,null),D=(0,A.localize)(1,null),v=(0,A.localize)(2,null),l=(0,A.localize)(3,null),s=(0,A.localize)(4,null),r=(0,A.localize)(5,null),c=(0,A.localize)(6,null),m=(0,A.localize)(7,null);class h{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(U=p){this.k=U,this.d=new d.$Ii,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(U){if(U===""){this.h.push({message:y,offset:0,lexeme:"",additionalInfo:D});return}this.f=this.d.reset(U).scan(),this.g=0,this.h=[];try{const V=this.l();if(!this.E()){const ge=this.D(),_=ge.type===17?r:void 0;throw this.h.push({message:s,offset:ge.offset,lexeme:d.$Ii.getLexeme(ge),additionalInfo:_}),h.c}return V}catch(V){if(V!==h.c)throw V;return}}l(){return this.m()}m(){const U=[this.o()];for(;this.y(16);){const V=this.o();U.push(V)}return U.length===1?U[0]:t.or(...U)}o(){const U=[this.s()];for(;this.y(15);){const V=this.s();U.push(V)}return U.length===1?U[0]:t.and(...U)}s(){if(this.y(2)){const U=this.D();switch(U.type){case 11:return this.z(),a.INSTANCE;case 12:return this.z(),u.INSTANCE;case 0:{this.z();const V=this.l();return this.A(1,l),V?.negate()}case 17:return this.z(),P.create(U.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",U)}}return this.t()}t(){const U=this.D();switch(U.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const V=this.l();return this.A(1,l),V}case 17:{const V=U.lexeme;if(this.z(),this.y(9)){const _=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),_.type!==10)throw this.B("REGEX",_);const ie=_.lexeme,re=ie.lastIndexOf("/"),Ee=re===ie.length-1?void 0:this.w(ie.substring(re+1));let oe;try{oe=new RegExp(ie.substring(1,re),Ee)}catch{throw this.B("REGEX",_)}return F.create(V,oe)}switch(_.type){case 10:case 19:{const ie=[_.lexeme];this.z();let re=this.D(),Ee=0;for(let $e=0;$e<_.lexeme.length;$e++)_.lexeme.charCodeAt($e)===40?Ee++:_.lexeme.charCodeAt($e)===41&&Ee--;for(;!this.E()&&re.type!==15&&re.type!==16;){switch(re.type){case 0:Ee++;break;case 1:Ee--;break;case 10:case 18:for(let $e=0;$e<re.lexeme.length;$e++)re.lexeme.charCodeAt($e)===40?Ee++:_.lexeme.charCodeAt($e)===41&&Ee--}if(Ee<0)break;ie.push(d.$Ii.getLexeme(re)),this.z(),re=this.D()}const oe=ie.join(""),he=oe.lastIndexOf("/"),ee=he===oe.length-1?void 0:this.w(oe.substring(he+1));let le;try{le=new RegExp(oe.substring(1,he),ee)}catch{throw this.B("REGEX",_)}return t.regex(V,le)}case 18:{const ie=_.lexeme;this.z();let re=null;if(!(0,T.$Ae)(ie)){const Ee=ie.indexOf("/"),oe=ie.lastIndexOf("/");if(Ee!==oe&&Ee>=0){const he=ie.slice(Ee+1,oe),ee=ie[oe+1]==="i"?"i":"";try{re=new RegExp(he,ee)}catch{throw this.B("REGEX",_)}}}if(re===null)throw this.B("REGEX",_);return F.create(V,re)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,v);const _=this.u();return t.notIn(V,_)}switch(this.D().type){case 3:{this.z();const _=this.u();if(this.x().type===18)return t.equals(V,_);switch(_){case"true":return t.has(V);case"false":return t.not(V);default:return t.equals(V,_)}}case 4:{this.z();const _=this.u();if(this.x().type===18)return t.notEquals(V,_);switch(_){case"true":return t.not(V);case"false":return t.has(V);default:return t.notEquals(V,_)}}case 5:return this.z(),j.create(V,this.u());case 6:return this.z(),z.create(V,this.u());case 7:return this.z(),O.create(V,this.u());case 8:return this.z(),L.create(V,this.u());case 13:return this.z(),t.in(V,this.u());default:return t.has(V)}}case 20:throw this.h.push({message:c,offset:U.offset,lexeme:"",additionalInfo:m}),h.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const U=this.D();switch(U.type){case 17:case 18:return this.z(),U.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(U){return U.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(U){return this.C(U)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(U,V){if(this.C(U))return this.z();throw this.B(V,this.D())}B(U,V,ge){const _=(0,A.localize)(8,null,U,d.$Ii.getLexeme(V)),ie=V.offset,re=d.$Ii.getLexeme(V);return this.h.push({message:_,offset:ie,lexeme:re,additionalInfo:ge}),h.c}C(U){return this.D().type===U}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Ki=h;class t{static false(){return a.INSTANCE}static true(){return u.INSTANCE}static has(U){return k.create(U)}static equals(U,V){return S.create(U,V)}static notEquals(U,V){return f.create(U,V)}static regex(U,V){return F.create(U,V)}static in(U,V){return $.create(U,V)}static notIn(U,V){return g.create(U,V)}static not(U){return P.create(U)}static and(...U){return fe.create(U,null,!0)}static or(...U){return x.create(U,null,!0)}static greater(U,V){return O.create(U,V)}static greaterEquals(U,V){return L.create(U,V)}static smaller(U,V){return j.create(U,V)}static smallerEquals(U,V){return z.create(U,V)}static{this.c=new h({regexParsingWithErrorRecovery:!1})}static deserialize(U){return U==null?void 0:this.c.parse(U)}}e.$Li=t;function n(J){const U=new h({regexParsingWithErrorRecovery:!1});return J.map(V=>(U.parse(V),U.lexingErrors.length>0?U.lexingErrors.map(ge=>({errorMessage:ge.additionalInfo?(0,A.localize)(9,null,ge.additionalInfo):(0,A.localize)(10,null),offset:ge.offset,length:ge.lexeme.length})):U.parsingErrors.length>0?U.parsingErrors.map(ge=>({errorMessage:ge.additionalInfo?`${ge.message}. ${ge.additionalInfo}`:ge.message,offset:ge.offset,length:ge.lexeme.length})):[]))}e.$Mi=n;function o(J,U){const V=J?J.substituteConstants():void 0,ge=U?U.substituteConstants():void 0;return!V&&!ge?!0:!V||!ge?!1:V.equals(ge)}e.$Ni=o;function i(J,U){return J.cmp(U)}class a{static{this.INSTANCE=new a}constructor(){this.type=0}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!1}serialize(){return"false"}keys(){return[]}map(U){return this}negate(){return u.INSTANCE}}e.$Oi=a;class u{static{this.INSTANCE=new u}constructor(){this.type=1}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!0}serialize(){return"true"}keys(){return[]}map(U){return this}negate(){return a.INSTANCE}}e.$Pi=u;class k{static create(U,V=null){const ge=E.get(U);return typeof ge=="boolean"?ge?u.INSTANCE:a.INSTANCE:new k(U,V)}constructor(U,V){this.key=U,this.c=V,this.type=2}cmp(U){return U.type!==this.type?this.type-U.type:q(this.key,U.key)}equals(U){return U.type===this.type?this.key===U.key:!1}substituteConstants(){const U=E.get(this.key);return typeof U=="boolean"?U?u.INSTANCE:a.INSTANCE:this}evaluate(U){return!!U.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(U){return U.mapDefined(this.key)}negate(){return this.c||(this.c=P.create(this.key,this)),this.c}}e.$Qi=k;class S{static create(U,V,ge=null){if(typeof V=="boolean")return V?k.create(U,ge):P.create(U,ge);const _=E.get(U);return typeof _=="boolean"?V===(_?"true":"false")?u.INSTANCE:a.INSTANCE:new S(U,V,ge)}constructor(U,V,ge){this.c=U,this.d=V,this.f=ge,this.type=4}cmp(U){return U.type!==this.type?this.type-U.type:Y(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=E.get(this.c);if(typeof U=="boolean"){const V=U?"true":"false";return this.d===V?u.INSTANCE:a.INSTANCE}return this}evaluate(U){return U.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(U){return U.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=f.create(this.c,this.d,this)),this.f}}e.$Ri=S;class ${static create(U,V){return new $(U,V)}constructor(U,V){this.d=U,this.f=V,this.type=10,this.c=null}cmp(U){return U.type!==this.type?this.type-U.type:Y(this.d,this.f,U.d,U.f)}equals(U){return U.type===this.type?this.d===U.d&&this.f===U.f:!1}substituteConstants(){return this}evaluate(U){const V=U.getValue(this.f),ge=U.getValue(this.d);return Array.isArray(V)?V.includes(ge):typeof ge=="string"&&typeof V=="object"&&V!==null?R.call(V,ge):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(U){return U.mapIn(this.d,this.f)}negate(){return this.c||(this.c=g.create(this.d,this.f)),this.c}}e.$Si=$;class g{static create(U,V){return new g(U,V)}constructor(U,V){this.d=U,this.f=V,this.type=11,this.c=$.create(U,V)}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(U){return U.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Ti=g;class f{static create(U,V,ge=null){if(typeof V=="boolean")return V?P.create(U,ge):k.create(U,ge);const _=E.get(U);return typeof _=="boolean"?V===(_?"true":"false")?a.INSTANCE:u.INSTANCE:new f(U,V,ge)}constructor(U,V,ge){this.c=U,this.d=V,this.f=ge,this.type=5}cmp(U){return U.type!==this.type?this.type-U.type:Y(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=E.get(this.c);if(typeof U=="boolean"){const V=U?"true":"false";return this.d===V?a.INSTANCE:u.INSTANCE}return this}evaluate(U){return U.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(U){return U.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=S.create(this.c,this.d,this)),this.f}}e.$Ui=f;class P{static create(U,V=null){const ge=E.get(U);return typeof ge=="boolean"?ge?a.INSTANCE:u.INSTANCE:new P(U,V)}constructor(U,V){this.c=U,this.d=V,this.type=3}cmp(U){return U.type!==this.type?this.type-U.type:q(this.c,U.c)}equals(U){return U.type===this.type?this.c===U.c:!1}substituteConstants(){const U=E.get(this.c);return typeof U=="boolean"?U?a.INSTANCE:u.INSTANCE:this}evaluate(U){return!U.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(U){return U.mapNot(this.c)}negate(){return this.d||(this.d=k.create(this.c,this)),this.d}}e.$Vi=P;function N(J,U){if(typeof J=="string"){const V=parseFloat(J);isNaN(V)||(J=V)}return typeof J=="string"||typeof J=="number"?U(J):a.INSTANCE}class O{static create(U,V,ge=null){return N(V,_=>new O(U,_,ge))}constructor(U,V,ge){this.c=U,this.d=V,this.f=ge,this.type=12}cmp(U){return U.type!==this.type?this.type-U.type:Y(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$Wi=O;class L{static create(U,V,ge=null){return N(V,_=>new L(U,_,ge))}constructor(U,V,ge){this.c=U,this.d=V,this.f=ge,this.type=13}cmp(U){return U.type!==this.type?this.type-U.type:Y(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$Xi=L;class j{static create(U,V,ge=null){return N(V,_=>new j(U,_,ge))}constructor(U,V,ge){this.c=U,this.d=V,this.f=ge,this.type=14}cmp(U){return U.type!==this.type?this.type-U.type:Y(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=L.create(this.c,this.d,this)),this.f}}e.$Yi=j;class z{static create(U,V,ge=null){return N(V,_=>new z(U,_,ge))}constructor(U,V,ge){this.c=U,this.d=V,this.f=ge,this.type=15}cmp(U){return U.type!==this.type?this.type-U.type:Y(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$Zi=z;class F{static create(U,V){return new F(U,V)}constructor(U,V){this.d=U,this.f=V,this.type=7,this.c=null}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.d<U.d)return-1;if(this.d>U.d)return 1;const V=this.f?this.f.source:"",ge=U.f?U.f.source:"";return V<ge?-1:V>ge?1:0}equals(U){if(U.type===this.type){const V=this.f?this.f.source:"",ge=U.f?U.f.source:"";return this.d===U.d&&V===ge}return!1}substituteConstants(){return this}evaluate(U){const V=U.getValue(this.d);return this.f?this.f.test(V):!1}serialize(){const U=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${U}`}keys(){return[this.d]}map(U){return U.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=H.create(this)),this.c}}e.$1i=F;class H{static create(U){return new H(U)}constructor(U){this.c=U,this.type=8}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(U){return new H(this.c.map(U))}negate(){return this.c}}e.$2i=H;function K(J){let U=null;for(let V=0,ge=J.length;V<ge;V++){const _=J[V].substituteConstants();if(J[V]!==_&&U===null){U=[];for(let ie=0;ie<V;ie++)U[ie]=J[ie]}U!==null&&(U[V]=_)}return U===null?J:U}class fe{static create(U,V,ge){return fe.d(U,V,ge)}constructor(U,V){this.expr=U,this.c=V,this.type=6}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let V=0,ge=this.expr.length;V<ge;V++){const _=i(this.expr[V],U.expr[V]);if(_!==0)return _}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let V=0,ge=this.expr.length;V<ge;V++)if(!this.expr[V].equals(U.expr[V]))return!1;return!0}return!1}substituteConstants(){const U=K(this.expr);return U===this.expr?this:fe.create(U,this.c,!1)}evaluate(U){for(let V=0,ge=this.expr.length;V<ge;V++)if(!this.expr[V].evaluate(U))return!1;return!0}static d(U,V,ge){const _=[];let ie=!1;for(const re of U)if(re){if(re.type===1){ie=!0;continue}if(re.type===0)return a.INSTANCE;if(re.type===6){_.push(...re.expr);continue}_.push(re)}if(_.length===0&&ie)return u.INSTANCE;if(_.length!==0){if(_.length===1)return _[0];_.sort(i);for(let re=1;re<_.length;re++)_[re-1].equals(_[re])&&(_.splice(re,1),re--);if(_.length===1)return _[0];for(;_.length>1;){const re=_[_.length-1];if(re.type!==9)break;_.pop();const Ee=_.pop(),oe=_.length===0,he=x.create(re.expr.map(ee=>fe.create([ee,Ee],null,ge)),null,oe);he&&(_.push(he),_.sort(i))}if(_.length===1)return _[0];if(ge){for(let re=0;re<_.length;re++)for(let Ee=re+1;Ee<_.length;Ee++)if(_[re].negate().equals(_[Ee]))return a.INSTANCE;if(_.length===1)return _[0]}return new fe(_,V)}}serialize(){return this.expr.map(U=>U.serialize()).join(" && ")}keys(){const U=[];for(const V of this.expr)U.push(...V.keys());return U}map(U){return new fe(this.expr.map(V=>V.map(U)),null)}negate(){if(!this.c){const U=[];for(const V of this.expr)U.push(V.negate());this.c=x.create(U,this,!0)}return this.c}}e.$3i=fe;class x{static create(U,V,ge){return x.d(U,V,ge)}constructor(U,V){this.expr=U,this.c=V,this.type=9}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let V=0,ge=this.expr.length;V<ge;V++){const _=i(this.expr[V],U.expr[V]);if(_!==0)return _}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let V=0,ge=this.expr.length;V<ge;V++)if(!this.expr[V].equals(U.expr[V]))return!1;return!0}return!1}substituteConstants(){const U=K(this.expr);return U===this.expr?this:x.create(U,this.c,!1)}evaluate(U){for(let V=0,ge=this.expr.length;V<ge;V++)if(this.expr[V].evaluate(U))return!0;return!1}static d(U,V,ge){let _=[],ie=!1;if(U){for(let re=0,Ee=U.length;re<Ee;re++){const oe=U[re];if(oe){if(oe.type===0){ie=!0;continue}if(oe.type===1)return u.INSTANCE;if(oe.type===9){_=_.concat(oe.expr);continue}_.push(oe)}}if(_.length===0&&ie)return a.INSTANCE;_.sort(i)}if(_.length!==0){if(_.length===1)return _[0];for(let re=1;re<_.length;re++)_[re-1].equals(_[re])&&(_.splice(re,1),re--);if(_.length===1)return _[0];if(ge){for(let re=0;re<_.length;re++)for(let Ee=re+1;Ee<_.length;Ee++)if(_[re].negate().equals(_[Ee]))return u.INSTANCE;if(_.length===1)return _[0]}return new x(_,V)}}serialize(){return this.expr.map(U=>U.serialize()).join(" || ")}keys(){const U=[];for(const V of this.expr)U.push(...V.keys());return U}map(U){return new x(this.expr.map(V=>V.map(U)),null)}negate(){if(!this.c){const U=[];for(const V of this.expr)U.push(V.negate());for(;U.length>1;){const V=U.shift(),ge=U.shift(),_=[];for(const ie of ve(V))for(const re of ve(ge))_.push(fe.create([ie,re],null,!1));U.unshift(x.create(_,null,!1))}this.c=x.create(U,this,!0)}return this.c}}e.$4i=x;class Z extends k{static{this.d=[]}static all(){return Z.d.values()}constructor(U,V,ge){super(U,null),this.f=V,typeof ge=="object"?Z.d.push({...ge,key:U}):ge!==!0&&Z.d.push({key:U,description:ge,type:V!=null?typeof V:void 0})}bindTo(U){return U.createKey(this.key,this.f)}getValue(U){return U.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(U){return S.create(this.key,U)}notEqualsTo(U){return f.create(this.key,U)}}e.$5i=Z,e.$6i=(0,M.$Nh)("contextKeyService");function q(J,U){return J<U?-1:J>U?1:0}function Y(J,U,V,ge){return J<V?-1:J>V?1:U<ge?-1:U>ge?1:0}function be(J,U){if(J.type===0||U.type===1)return!0;if(J.type===9)return U.type===9?ue(J.expr,U.expr):!1;if(U.type===9){for(const V of U.expr)if(be(J,V))return!0;return!1}if(J.type===6){if(U.type===6)return ue(U.expr,J.expr);for(const V of J.expr)if(be(V,U))return!0;return!1}return J.equals(U)}e.$7i=be;function ue(J,U){let V=0,ge=0;for(;V<J.length&&ge<U.length;){const _=J[V].cmp(U[ge]);if(_<0)return!1;_===0&&V++,ge++}return V===J.length}function ve(J){return J.type===9?J.expr:[J]}}),define(De[230],Ce([1,0,24,38,191,5,99,12,23]),function(me,e,C,T,d,M,A,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zv=e.$yv=e.ConfirmResult=e.$xv=e.$wv=e.$vv=void 0,e.$vv=(0,M.$Nh)("dialogService");var w;(function(v){v[v.Confirmation=1]="Confirmation",v[v.Prompt=2]="Prompt",v[v.Input=3]="Input"})(w||(w={}));class R{a(l){return this.d(l,w.Confirmation)}b(l){return this.d(l,w.Prompt)}c(l){return this.d(l,w.Input)}d(l,s){const r=[];switch(s){case w.Confirmation:{const c=l;c.primaryButton?r.push(c.primaryButton):r.push((0,d.localize)(0,null)),c.cancelButton?r.push(c.cancelButton):r.push((0,d.localize)(1,null));break}case w.Prompt:{const c=l;Array.isArray(c.buttons)&&c.buttons.length>0&&r.push(...c.buttons.map(m=>m.label)),c.cancelButton&&(c.cancelButton===!0?r.push((0,d.localize)(2,null)):typeof c.cancelButton=="string"?r.push(c.cancelButton):c.cancelButton.label?r.push(c.cancelButton.label):r.push((0,d.localize)(3,null))),r.length===0&&r.push((0,d.localize)(4,null));break}case w.Input:{const c=l;c.primaryButton?r.push(c.primaryButton):r.push((0,d.localize)(5,null)),c.cancelButton?r.push(c.cancelButton):r.push((0,d.localize)(6,null));break}}return r}e(l){if(typeof l=="string")return l;if(typeof l=="number")return l===T.default.Info?"info":l===T.default.Error?"error":l===T.default.Warning?"warning":"none"}f(l,s,r){const c=[...l.buttons??[]];l.cancelButton&&typeof l.cancelButton!="string"&&typeof l.cancelButton!="boolean"&&c.push(l.cancelButton);let m=c[s]?.run({checkboxChecked:r});return m instanceof Promise||(m=Promise.resolve(m)),{result:m,checkboxChecked:r}}}e.$wv=R,e.$xv=(0,M.$Nh)("fileDialogService");var I;(function(v){v[v.SAVE=0]="SAVE",v[v.DONT_SAVE=1]="DONT_SAVE",v[v.CANCEL=2]="CANCEL"})(I||(e.ConfirmResult=I={}));const p=10;function y(v){const l=[];return l.push(...v.slice(0,p).map(s=>typeof s=="string"?s:(0,C.$rg)(s))),v.length>p&&(v.length-p===1?l.push((0,d.localize)(7,null)):l.push((0,d.localize)(8,null,v.length-p))),l.push(""),l.join(`
`)}e.$yv=y;function D(v,l){const s=(0,E.$2m)(v);let r=(s.buttons??[]).map(t=>(0,A.$sv)(t)),c=(v.buttons||[]).map((t,n)=>n),m=0,h=s.cancelId??r.length-1;if(r.length>1){const t=typeof h=="number"?r[h]:void 0;if(b.$l||b.$k){if(typeof t=="string"&&r.length>1&&h!==1){r.splice(h,1),r.splice(1,0,t);const n=c[h];c.splice(h,1),c.splice(1,0,n),h=1}b.$l&&r.length>1&&(r=r.reverse(),c=c.reverse(),m=r.length-1,typeof t=="string"&&(h=m-1))}else if(b.$j&&typeof t=="string"&&r.length>1&&h!==r.length-1){r.splice(h,1),r.push(t);const n=c[h];c.splice(h,1),c.push(n),h=r.length-1}}return s.buttons=r,s.defaultId=m,s.cancelId=h,s.noLink=!0,s.title=s.title||l.nameLong,{options:s,buttonIndeces:c}}e.$zv=D}),define(De[131],Ce([1,0,5]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vh=e.$Uh=void 0,e.$Uh=(0,C.$Nh)("environmentService"),e.$Vh=(0,C.$Oh)(e.$Uh)}),define(De[132],Ce([1,0,192,5]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$6n=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=void 0,e.$Sn="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Tn=new RegExp(e.$Sn),e.$Un="__web_extension",e.$Vn="skipWalkthrough",e.$Wn="extensionsSync",e.$Xn="dependecyOrPackExtensionInstall";function d(r){switch(r){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Yn=d;function M(r){switch(r){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Zn=M;function A(r,c){switch(r){case 3:return c==="x64"?"win32-x64":c==="ia32"?"win32-ia32":c==="arm64"?"win32-arm64":"unknown";case 2:return c==="x64"?"linux-x64":c==="arm64"?"linux-arm64":c==="arm"?"linux-armhf":"unknown";case"alpine":return c==="x64"?"alpine-x64":c==="arm64"?"alpine-arm64":"unknown";case 1:return c==="x64"?"darwin-x64":c==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$1n=A;function b(r,c){return c==="web"&&!r.includes("web")}e.$2n=b;function E(r,c,m){return b(c,m)?!1:r==="undefined"||r==="universal"?!0:r==="unknown"?!1:r===m?!0:w(m).includes(r)}e.$3n=E;function w(r){switch(r){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$4n=w;function R(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(!r.uuid||typeof r.uuid=="string")}e.$5n=R;var I;(function(r){r[r.NoneOrRelevance=0]="NoneOrRelevance",r[r.LastUpdatedDate=1]="LastUpdatedDate",r[r.Title=2]="Title",r[r.PublisherName=3]="PublisherName",r[r.InstallCount=4]="InstallCount",r[r.PublishedDate=10]="PublishedDate",r[r.AverageRating=6]="AverageRating",r[r.WeightedRating=12]="WeightedRating"})(I||(e.SortBy=I={}));var p;(function(r){r[r.Default=0]="Default",r[r.Ascending=1]="Ascending",r[r.Descending=2]="Descending"})(p||(e.SortOrder=p={}));var y;(function(r){r.Install="install",r.Uninstall="uninstall"})(y||(e.StatisticType=y={}));var D;(function(r){r[r.None=1]="None",r[r.Install=2]="Install",r[r.Update=3]="Update",r[r.Migrate=4]="Migrate"})(D||(e.InstallOperation=D={})),e.$6n=(0,T.$Nh)("extensionGalleryService");var v;(function(r){r.Unsupported="Unsupported",r.Deprecated="Deprecated",r.Malicious="Malicious",r.Incompatible="Incompatible",r.IncompatibleTargetPlatform="IncompatibleTargetPlatform",r.ReleaseVersionNotFound="ReleaseVersionNotFound",r.Invalid="Invalid",r.Download="Download",r.Extract="Extract",r.Delete="Delete",r.Rename="Rename",r.CorruptZip="CorruptZip",r.IncompleteZip="IncompleteZip",r.Signature="Signature",r.Internal="Internal"})(v||(e.ExtensionManagementErrorCode=v={}));var l;(function(r){r.UnknownError="UnknownError",r.PackageIsInvalidZip="PackageIsInvalidZip",r.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(l||(e.ExtensionSignaturetErrorCode=l={}));class s extends Error{constructor(c,m){super(c),this.code=m,this.name=m}}e.$7n=s,e.$8n=(0,T.$Nh)("extensionManagementService"),e.$9n="extensionsIdentifiers/disabled",e.$0n="extensionsIdentifiers/enabled",e.$$n=(0,T.$Nh)("IGlobalExtensionEnablementService"),e.$_n=(0,T.$Nh)("IExtensionTipsService"),e.$ao=(0,C.localize)(0,null),e.$bo={value:e.$ao,original:"Extensions"},e.$co={value:(0,C.localize)(1,null),original:"Preferences"}}),define(De[231],Ce([1,0,5]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YXb=e.$XXb=void 0,e.$XXb=(0,C.$Nh)("externalTerminal"),e.$YXb="Terminal.app"}),define(De[232],Ce([1,0,48,17,16,12,98,29,101,194,231]),function(me,e,C,T,d,M,A,b,E,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K6b=e.$J6b=e.$I6b=void 0;const I=w.localize(0,null);class p{async getDefaultTerminalForPlatforms(){return{windows:y.getDefaultTerminalWindows(),linux:await v.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class y extends p{static{this.b="cmd.exe"}openTerminal(m,h){return this.spawnTerminal(C,m,E.$xl(),h)}spawnTerminal(m,h,t,n){const o=h.windowsExec||y.getDefaultTerminalWindows();n&&n[1]===":"&&(n=n[0].toUpperCase()+n.substr(1));const i=d.$mc(o,".exe").toLowerCase();if(i==="cmder")return m.spawn(o,n?[n]:void 0),Promise.resolve(void 0);const a=["/c","start","/wait"];return o.indexOf(" ")>=0&&a.push('""'),a.push(o),i==="wt"&&a.push("-d ."),new Promise((u,k)=>{const S=l(process),$=m.spawn(t,a,{cwd:n,env:S});$.on("error",k),$.on("exit",()=>u())})}runInTerminal(m,h,t,n,o){const i="windowsExec"in o&&o.windowsExec?o.windowsExec:y.getDefaultTerminalWindows();return new Promise((a,u)=>{const k=`"${h} - ${I}"`,S=`""${t.join('" "')}" & pause"`,$=Object.assign({},l(process),n);Object.keys($).filter(O=>$[O]===null).forEach(O=>delete $[O]);const g={cwd:h,env:$,windowsVerbatimArguments:!0};let f,P;d.$mc(i,".exe")==="wt"?(f=i,P=["-d",".",y.b,"/c",S]):(f=y.b,P=["/c","start",k,"/wait",i,"/c",S]),C.spawn(f,P,g).on("error",O=>{u(s(O))}),a(void 0)})}static getDefaultTerminalWindows(){if(!y.d){const m=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");y.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${m?"Sysnative":"System32"}\\cmd.exe`}return y.d}}e.$I6b=y;class D extends p{static{this.b="/usr/bin/osascript"}openTerminal(m,h){return this.spawnTerminal(C,m,h)}runInTerminal(m,h,t,n,o){const i=o.osxExec||R.$YXb;return new Promise((a,u)=>{if(i===R.$YXb||i==="iTerm.app"){const k=i===R.$YXb?"TerminalHelper":"iTermHelper",$=[T.$bg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${k}.scpt`).fsPath,"-t",m||I,"-w",h];for(const P of t)$.push("-a"),$.push(P);if(n){const P=Object.assign({},l(process),n);for(const N in P){const O=P[N];O===null?($.push("-u"),$.push(N)):($.push("-e"),$.push(`${N}=${O}`))}}let g="";const f=C.spawn(D.b,$);f.on("error",P=>{u(s(P))}),f.stderr.on("data",P=>{g+=P.toString()}),f.on("exit",P=>{if(P===0)a(void 0);else if(g){const N=g.split(`
`,1);u(new Error(N[0]))}else u(new Error(w.localize(1,null,k,P)))})}else u(new Error(w.localize(2,null,i)))})}spawnTerminal(m,h,t){const n=h.osxExec||R.$YXb;return new Promise((o,i)=>{const a=["-a",n];t&&a.push(t);const u=l(process),k=m.spawn("/usr/bin/open",a,{cwd:t,env:u});k.on("error",i),k.on("exit",()=>o())})}}e.$J6b=D;class v extends p{static{this.b=w.localize(3,null)}openTerminal(m,h){return this.spawnTerminal(C,m,h)}runInTerminal(m,h,t,n,o){const i=o.linuxExec?Promise.resolve(o.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((a,u)=>{const k=[];i.then(S=>{S.indexOf("gnome-terminal")>=0?k.push("-x"):k.push("-e"),k.push("bash"),k.push("-c");const $=`${r(t)}; echo; read -p "${v.b}" -n1;`;k.push(`''${$}''`);const g=Object.assign({},l(process),n);Object.keys(g).filter(O=>g[O]===null).forEach(O=>delete g[O]);const f={cwd:h,env:g};let P="";const N=C.spawn(S,k,f);N.on("error",O=>{u(s(O))}),N.stderr.on("data",O=>{P+=O.toString()}),N.on("exit",O=>{if(O===0)a(void 0);else if(P){const L=P.split(`
`,1);u(new Error(L[0]))}else u(new Error(w.localize(4,null,S,O)))})})})}static async getDefaultTerminalLinuxReady(){if(!v.d)if(!M.$l)v.d=Promise.resolve("xterm");else{const m=await b.Promises.exists("/etc/debian_version");v.d=new Promise(h=>{m?h("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?h("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?h("konsole"):process.env.COLORTERM?h(process.env.COLORTERM):process.env.TERM?h(process.env.TERM):h("xterm")})}return v.d}spawnTerminal(m,h,t){const n=h.linuxExec?Promise.resolve(h.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((o,i)=>{n.then(a=>{const u=l(process),k=m.spawn(a,[],{cwd:t,env:u});k.on("error",i),k.on("exit",()=>o())})})}}e.$K6b=v;function l(c){const m={...c.env};return(0,A.$vl)(m),m}function s(c){return"errno"in c&&c.errno==="ENOENT"&&"path"in c&&typeof c.path=="string"?new Error(w.localize(5,null,c.path)):c}function r(c){let m="";for(const h of c)h.indexOf(" ")>=0?m+='"'+h+'"':m+=h,m+=" ";return m}}),define(De[30],Ce([1,0,77,16,15,18,2,195,5,12,17]),function(me,e,C,T,d,M,A,b,E,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ek=e.$Dk=e.$Ck=e.$Bk=e.$Ak=e.FileKind=e.$zk=e.$yk=e.$xk=e.$wk=e.$vk=e.$uk=e.$tk=e.FileOperationResult=e.$sk=e.$rk=e.$qk=e.$pk=e.$ok=e.FileChangeType=e.$nk=e.FileOperation=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.FileSystemProviderErrorCode=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$0j=e.$9j=void 0,e.$9j=(0,E.$Nh)("fileService");function I(q){return q.create===!0}e.$0j=I;var p;(function(q){q[q.Unknown=0]="Unknown",q[q.File=1]="File",q[q.Directory=2]="Directory",q[q.SymbolicLink=64]="SymbolicLink"})(p||(e.FileType=p={}));var y;(function(q){q[q.Readonly=1]="Readonly",q[q.Locked=2]="Locked"})(y||(e.FilePermission=y={}));var D;(function(q){q[q.None=0]="None",q[q.FileReadWrite=2]="FileReadWrite",q[q.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",q[q.FileReadStream=16]="FileReadStream",q[q.FileFolderCopy=8]="FileFolderCopy",q[q.PathCaseSensitive=1024]="PathCaseSensitive",q[q.Readonly=2048]="Readonly",q[q.Trash=4096]="Trash",q[q.FileWriteUnlock=8192]="FileWriteUnlock",q[q.FileAtomicRead=16384]="FileAtomicRead",q[q.FileAtomicWrite=32768]="FileAtomicWrite",q[q.FileAtomicDelete=65536]="FileAtomicDelete",q[q.FileClone=131072]="FileClone"})(D||(e.FileSystemProviderCapabilities=D={}));function v(q){return!!(q.capabilities&2)}e.$$j=v;function l(q){return!!(q.capabilities&8)}e.$_j=l;function s(q){return!!(q.capabilities&131072)}e.$ak=s;function r(q){return!!(q.capabilities&4)}e.$bk=r;function c(q){return!!(q.capabilities&16)}e.$ck=c;function m(q){return v(q)?!!(q.capabilities&16384):!1}e.$dk=m;function h(q){return v(q)?!!(q.capabilities&32768):!1}e.$ek=h;function t(q){return!!(q.capabilities&65536)}e.$fk=t;function n(q){return!!(q.capabilities&2048)}e.$gk=n;var o;(function(q){q.FileExists="EntryExists",q.FileNotFound="EntryNotFound",q.FileNotADirectory="EntryNotADirectory",q.FileIsADirectory="EntryIsADirectory",q.FileExceedsStorageQuota="EntryExceedsStorageQuota",q.FileTooLarge="EntryTooLarge",q.FileWriteLocked="EntryWriteLocked",q.NoPermissions="NoPermissions",q.Unavailable="Unavailable",q.Unknown="Unknown"})(o||(e.FileSystemProviderErrorCode=o={}));class i extends Error{static create(Y,be){const ue=new i(Y.toString(),be);return k(ue,be),ue}constructor(Y,be){super(Y),this.code=be}}e.$hk=i;function a(q,Y){return i.create(q,Y)}e.$ik=a;function u(q){return q||a((0,b.localize)(0,null),o.Unknown)}e.$jk=u;function k(q,Y){return q.name=Y?`${Y} (FileSystemError)`:"FileSystemError",q}e.$kk=k;function S(q){if(!q)return o.Unknown;if(q instanceof i)return q.code;const Y=/^(.+) \(FileSystemError\)$/.exec(q.name);if(!Y)return o.Unknown;switch(Y[1]){case o.FileExists:return o.FileExists;case o.FileIsADirectory:return o.FileIsADirectory;case o.FileNotADirectory:return o.FileNotADirectory;case o.FileNotFound:return o.FileNotFound;case o.FileTooLarge:return o.FileTooLarge;case o.FileWriteLocked:return o.FileWriteLocked;case o.NoPermissions:return o.NoPermissions;case o.Unavailable:return o.Unavailable}return o.Unknown}e.$lk=S;function $(q){if(q instanceof L)return q.fileOperationResult;switch(S(q)){case o.FileNotFound:return 1;case o.FileIsADirectory:return 0;case o.FileNotADirectory:return 9;case o.FileWriteLocked:return 5;case o.NoPermissions:return 6;case o.FileExists:return 4;case o.FileTooLarge:return 7;default:return 10}}e.$mk=$;var g;(function(q){q[q.CREATE=0]="CREATE",q[q.DELETE=1]="DELETE",q[q.MOVE=2]="MOVE",q[q.COPY=3]="COPY",q[q.WRITE=4]="WRITE"})(g||(e.FileOperation=g={}));class f{constructor(Y,be,ue){this.resource=Y,this.operation=be,this.target=ue}isOperation(Y){return this.operation===Y}}e.$nk=f;var P;(function(q){q[q.UPDATED=0]="UPDATED",q[q.ADDED=1]="ADDED",q[q.DELETED=2]="DELETED"})(P||(e.FileChangeType=P={}));class N{constructor(Y,be){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ue=new Map;for(const ve of Y){const J=ue.get(ve.type);switch(J?J.push([ve.resource,ve]):ue.set(ve.type,[[ve.resource,ve]]),ve.type){case 1:this.rawAdded.push(ve.resource);break;case 0:this.rawUpdated.push(ve.resource);break;case 2:this.rawDeleted.push(ve.resource);break}}for(const[ve,J]of ue)switch(ve){case 1:this.a=C.$Th.forUris(()=>be),this.a.fill(J);break;case 0:this.b=C.$Th.forUris(()=>be),this.b.fill(J);break;case 2:this.c=C.$Th.forUris(()=>be),this.c.fill(J);break}}contains(Y,...be){return this.d(Y,{includeChildren:!1},...be)}affects(Y,...be){return this.d(Y,{includeChildren:!0},...be)}d(Y,be,...ue){if(!Y)return!1;const ve=ue.length>0;return!!((!ve||ue.includes(1))&&(this.a?.get(Y)||be.includeChildren&&this.a?.findSuperstr(Y))||(!ve||ue.includes(0))&&(this.b?.get(Y)||be.includeChildren&&this.b?.findSuperstr(Y))||(!ve||ue.includes(2))&&(this.c?.findSubstr(Y)||be.includeChildren&&this.c?.findSuperstr(Y)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.$ok=N;function O(q,Y,be){return!q||!Y||q===Y||Y.length>q.length?!1:(Y.charAt(Y.length-1)!==T.sep&&(Y+=T.sep),be?(0,d.$2e)(q,Y):q.indexOf(Y)===0)}e.$pk=O;class L extends Error{constructor(Y,be,ue){super(Y),this.fileOperationResult=be,this.options=ue}}e.$qk=L;class j extends L{constructor(Y,be,ue,ve){super(Y,be,ve),this.fileOperationResult=be,this.size=ue}}e.$rk=j;class z extends L{constructor(Y,be,ue){super(Y,2,ue),this.stat=be}}e.$sk=z;var F;(function(q){q[q.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",q[q.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",q[q.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",q[q.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",q[q.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",q[q.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",q[q.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",q[q.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",q[q.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",q[q.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",q[q.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(F||(e.FileOperationResult=F={})),e.$tk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$uk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$vk="files.associations",e.$wk="files.exclude",e.$xk="files.readonlyInclude",e.$yk="files.readonlyExclude",e.$zk="files.readonlyFromPermissions";var H;(function(q){q[q.FILE=0]="FILE",q[q.FOLDER=1]="FOLDER",q[q.ROOT_FOLDER=2]="ROOT_FOLDER"})(H||(e.FileKind=H={})),e.$Ak="";function K(q){if(!(typeof q.size!="number"||typeof q.mtime!="number"))return q.mtime.toString(29)+q.size.toString(31)}e.$Bk=K;async function fe(q,Y){if(!Y.hasProvider(A.URI.from({scheme:q.scheme})))return new Promise(be=>{const ue=Y.onDidChangeFileSystemProviderRegistrations(ve=>{ve.scheme===q.scheme&&ve.added&&(ue.dispose(),be())})})}e.$Ck=fe;class x{static{this.KB=1024}static{this.MB=x.KB*x.KB}static{this.GB=x.MB*x.KB}static{this.TB=x.GB*x.KB}static formatSize(Y){return(0,M.$Bf)(Y)||(Y=0),Y<x.KB?(0,b.localize)(1,null,Y.toFixed(0)):Y<x.MB?(0,b.localize)(2,null,(Y/x.KB).toFixed(2)):Y<x.GB?(0,b.localize)(3,null,(Y/x.MB).toFixed(2)):Y<x.TB?(0,b.localize)(4,null,(Y/x.GB).toFixed(2)):(0,b.localize)(5,null,(Y/x.TB).toFixed(2))}}e.$Dk=x;function Z(q){const Y=typeof q=="string"||q?.scheme===R.Schemas.vscodeRemote;return typeof q!="string"&&q?.scheme===R.Schemas.file?1024*x.MB:Y?10*x.MB:w.$p?50*x.MB:1024*x.MB}e.$Ek=Z}),define(De[233],Ce([1,0,22,8,196,30]),function(me,e,C,T,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ip=void 0;async function A(R,I,p,y,D,v){let l;try{await b(R,I,p,y,D,v)}catch(s){l=s}finally{l&&D.errorTransformer&&(l=D.errorTransformer(l)),typeof l<"u"&&p.error(l),p.end()}}e.$Ip=A;async function b(R,I,p,y,D,v){E(v);const l=await R.open(I,{create:!1});try{E(v);let s=0,r=0,c=D&&typeof D.length=="number"?D.length:void 0,m=C.$ae.alloc(Math.min(D.bufferSize,typeof c=="number"?c:D.bufferSize)),h=D&&typeof D.position=="number"?D.position:0,t=0;do r=await R.read(l,h,m.buffer,t,m.byteLength-t),h+=r,t+=r,s+=r,typeof c=="number"&&(c-=r),t===m.byteLength&&(await p.write(y(m)),m=C.$ae.alloc(Math.min(D.bufferSize,typeof c=="number"?c:D.bufferSize)),t=0);while(r>0&&(typeof c!="number"||c>0)&&E(v)&&w(s,D));if(t>0){let n=t;typeof c=="number"&&(n=Math.min(t,c)),p.write(y(m.slice(0,n)))}}catch(s){throw(0,M.$jk)(s)}finally{await R.close(l)}}function E(R){if(R.isCancellationRequested)throw(0,T.$5)();return!0}function w(R,I){if(typeof I?.limits?.size=="number"&&R>I.limits.size)throw(0,M.$ik)((0,d.localize)(0,null),M.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(De[83],Ce([1,0,35,3,16,12,2,30]),function(me,e,C,T,d,M,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=e.$Qp=e.$Pp=e.$Op=e.$Np=e.$Mp=e.$Lp=e.$Kp=void 0;function E(s){return s.recursive===!0}e.$Kp=E;class w extends T.$Rc{static{this.a=5}constructor(r,c,m,h){super(),this.h=r,this.j=c,this.m=m,this.n=h,this.c=this.B(new T.$Sc),this.f=void 0,this.g=0}s(){const r=new T.$Qc;this.c.value=r,this.b=this.r(r),this.b.setVerboseLogging(this.m),r.add(this.b.onDidChangeFile(c=>this.h(c))),r.add(this.b.onDidLogMessage(c=>this.j(c))),r.add(this.b.onDidError(c=>this.t(c)))}t(r){this.n.restartOnError?this.g<w.a&&this.f?(this.w(`restarting watcher after error: ${r}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${r}`):this.w(r)}u(r){this.g++,this.s(),this.watch(r)}async watch(r){this.f=r,await this.b?.watch(r)}async setVerboseLogging(r){this.m=r,await this.b?.setVerboseLogging(r)}w(r){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${r}`})}y(r){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${r}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Lp=w;class R extends w{constructor(r,c,m){super(r,c,m,{type:"node.js",restartOnError:!1})}}e.$Mp=R;class I extends w{constructor(r,c,m){super(r,c,m,{type:"universal",restartOnError:!0})}}e.$Np=I;function p(s){return s.map(r=>({type:r.type,resource:A.URI.revive(r.resource)}))}e.$Op=p;function y(s){const r=new l;for(const c of s)r.processEvent(c);return r.coalesce()}e.$Pp=y;function D(s,r){return typeof r=="string"&&!r.startsWith(C.$qj)&&!(0,d.$hc)(r)?{base:s,pattern:r}:r}e.$Qp=D;function v(s,r){const c=[];for(const m of r)c.push((0,C.$uj)(D(s,m)));return c}e.$Rp=v;class l{constructor(){this.a=new Set,this.b=new Map}c(r){return M.$l?r.resource.fsPath:r.resource.fsPath.toLowerCase()}processEvent(r){const c=this.b.get(this.c(r));let m=!1;if(c){const h=c.type,t=r.type;c.resource.fsPath!==r.resource.fsPath&&(r.type===2||r.type===1)?m=!0:h===1&&t===2?(this.b.delete(this.c(r)),this.a.delete(c)):h===2&&t===1?c.type=0:h===1&&t===0||(c.type=t)}else m=!0;m&&(this.a.add(r),this.b.set(this.c(r),r))}coalesce(){const r=[],c=[];return Array.from(this.a).filter(m=>m.type!==2?(r.push(m),!1):!0).sort((m,h)=>m.resource.fsPath.length-h.resource.fsPath.length).filter(m=>c.some(h=>(0,b.$pk)(m.resource.fsPath,h,!M.$l))?!1:(c.push(m.resource.fsPath),!0)).concat(r)}}}),define(De[234],Ce([1,0,53,9,21,32,3,76,16,12,2,100,29,83]),function(me,e,C,T,d,M,A,b,E,w,R,I,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6p=e.$5p=void 0;class D extends A.$Rc{static{this.a=100}static{this.b=75}constructor(s,r,c,m){super(),this.m=s,this.n=r,this.r=c,this.s=m,this.c=this.B(new T.$8g({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},h=>this.n(h))),this.f=this.B(new T.$7g(h=>this.z(h),D.b)),this.g=(0,y.$Rp)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,y.$Rp)(this.m.path,this.m.includes):void 0,this.j=new d.$Wd,this.ready=this.t()}async t(){try{const s=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const r=await p.Promises.stat(s);this.B(await this.w(s,r.isDirectory()))}catch(s){s.code!=="ENOENT"?this.D(s):this.G(s)}}async u(s){let r=s.path;try{r=await p.Promises.realpath(s.path),s.path===r&&(r=await(0,I.$2p)(s.path)??s.path),s.path!==r&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${s.path}, real: ${r})`)}catch{}return r}async w(s,r){if(w.$k&&(0,M.$Wf)(s,"/Volumes/",!0))return this.D(`Refusing to watch ${s} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),A.$Rc.None;const c=new d.$Wd(this.j.token),m=new A.$Qc;try{const h=(0,E.$mc)(s),t=(0,C.watch)(s);m.add((0,A.$Pc)(()=>{t.removeAllListeners(),t.close()})),this.G(`Started watching: '${s}'`);const n=new Set;if(r)try{for(const i of await p.Promises.readdir(s))n.add(i)}catch(i){this.D(i)}const o=new Map;m.add((0,A.$Pc)(()=>{for(const[,i]of o)i.dispose();o.clear()})),t.on("error",(i,a)=>{this.D(`Failed to watch ${s} for changes using fs.watch() (${i}, ${a})`),this.dispose()}),t.on("change",(i,a)=>{if(c.token.isCancellationRequested)return;this.G(`[raw] ["${i}"] ${a}`);let u="";if(a&&(u=a.toString(),w.$k&&(u=(0,b.$kl)(u))),!(!u||i!=="change"&&i!=="rename"))if(r)if(i==="rename"){o.get(u)?.dispose();const k=setTimeout(async()=>{if(o.delete(u),u===h&&!await p.Promises.exists(s)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const S=await this.C((0,E.$ic)(s,u));if(c.token.isCancellationRequested)return;let $;S?n.has(u)?$=0:($=1,n.add(u)):(n.delete(u),$=2),this.y({resource:R.URI.file((0,E.$ic)(this.m.path,u)),type:$})},D.a);o.set(u,(0,A.$Pc)(()=>clearTimeout(k)))}else{let k;n.has(u)?k=0:(k=1,n.add(u)),this.y({resource:R.URI.file((0,E.$ic)(this.m.path,u)),type:k})}else if(i==="rename"||u!==h){const k=setTimeout(async()=>{const S=await p.Promises.exists(s);c.token.isCancellationRequested||(S?(this.y({resource:R.URI.file(this.m.path),type:0},!0),m.add(await this.w(s,!1))):(this.y({resource:R.URI.file(this.m.path),type:2},!0),this.f.flush(),this.dispose()))},D.a);m.clear(),m.add((0,A.$Pc)(()=>clearTimeout(k)))}else this.y({resource:R.URI.file(this.m.path),type:0},!0)})}catch(h){await p.Promises.exists(s)&&!c.token.isCancellationRequested&&this.D(`Failed to watch ${s} for changes using fs.watch() (${h.toString()})`)}return(0,A.$Pc)(()=>{c.dispose(!0),m.dispose()})}y(s,r=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${s.type===1?"[ADDED]":s.type===2?"[DELETED]":"[CHANGED]"} ${s.resource.fsPath}`),!r&&this.g.some(c=>c(s.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${s.resource.fsPath}`):!r&&this.h&&this.h.length>0&&!this.h.some(c=>c(s.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${s.resource.fsPath}`):this.f.work(s))}z(s){const r=(0,y.$Pp)(s);if(r.length>0){if(this.s)for(const m of r)this.G(`>> normalized ${m.type===1?"[ADDED]":m.type===2?"[DELETED]":"[CHANGED]"} ${m.resource.fsPath}`);this.c.work(r)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${r[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${r.length}, most recent change: ${r[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(s){if(w.$l)return p.Promises.exists(s);try{const r=(0,E.$mc)(s);return(await p.Promises.readdir((0,E.$lc)(s))).some(m=>m===r)}catch(r){return this.G(r),!1}}setVerboseLogging(s){this.s=s}D(s){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${s}`})}F(s){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${s}`})}G(s){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${s}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$5p=D;async function v(l,s,r,c,m=512){const h=await p.Promises.open(l,"r"),t=Buffer.allocUnsafe(m),n=new d.$Wd(c);let o,i=!1;const a={path:l,excludes:[],recursive:!1},u=new D(a,k=>{(async()=>{for(const{type:S}of k)if(S===0){if(i)return;i=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:$}=await p.Promises.read(h,t,0,m,null);if(!$||n.token.isCancellationRequested)break;s(t.slice(0,$))}}catch($){o=new Error($),n.dispose(!0)}finally{i=!1}}})()});return await u.ready,r(),new Promise((k,S)=>{n.token.onCancellationRequested(async()=>{u.dispose();try{await p.Promises.close(h)}catch($){o=new Error($)}o?S(o):k()})})}e.$6p=v}),define(De[235],Ce([1,0,4,35,3,12,234]),function(me,e,C,T,d,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=void 0;class b extends d.$Rc{constructor(){super(...arguments),this.a=this.B(new C.$Md),this.onDidChangeFile=this.a.event,this.b=this.B(new C.$Md),this.onDidLogMessage=this.b.event,this.onDidError=C.Event.None,this.c=new Map,this.f=!1}async watch(w){const R=this.j(w),I=R.filter(y=>{const D=this.c.get(y.path);return D?!(0,T.$yj)(D.request.excludes,y.excludes)||!(0,T.$yj)(D.request.includes,y.includes):!0}),p=Array.from(this.c.values()).filter(({request:y})=>!R.find(D=>D.path===y.path&&(0,T.$yj)(D.excludes,y.excludes)&&(0,T.$yj)(D.includes,y.includes))).map(({request:y})=>y.path);I.length&&this.m(`Request to start watching: ${I.map(y=>`${y.path} (excludes: ${y.excludes.length>0?y.excludes:"<none>"}, includes: ${y.includes&&y.includes.length>0?JSON.stringify(y.includes):"<all>"})`).join(",")}`),p.length&&this.m(`Request to stop watching: ${p.join(",")}`);for(const y of p)this.h(y);for(const y of I)this.g(y)}g(w){const R=new A.$5p(w,p=>this.a.fire(p),p=>this.b.fire(p),this.f),I={request:w,instance:R};this.c.set(w.path,I)}async stop(){for(const[w]of this.c)this.h(w);this.c.clear()}h(w){const R=this.c.get(w);R&&(this.c.delete(w),R.instance.dispose())}j(w){const R=new Map;for(const I of w){const p=M.$l?I.path:I.path.toLowerCase();R.set(p,I)}return Array.from(R.values())}async setVerboseLogging(w){this.f=w;for(const[,R]of this.c)R.instance.setVerboseLogging(w)}m(w){this.f&&this.b.fire({type:"trace",message:this.n(w)})}n(w,R){return R?`[File Watcher (node.js)] ${w} (path: ${R.request.path})`:`[File Watcher (node.js)] ${w}`}}e.$7p=b}),define(De[236],Ce([1,0,83,235]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=void 0;class d extends C.$Mp{constructor(A,b,E){super(A,b,E),this.s()}r(A){return A.add(new T.$7p)}}e.$8p=d}),define(De[237],Ce([1,0,17,80,183,83]),function(me,e,C,T,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=void 0;class A extends M.$Np{constructor(E,w,R){super(E,w,R),this.s()}r(E){const w=E.add(new d.$Yp(C.$bg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return E.add(w.onDidProcessExit(({code:R,signal:I})=>this.t(`terminated by itself with code ${R}, signal: ${I}`))),T.ProxyChannel.toService((0,T.$uh)(w.getChannel("watcher")))}}e.$Zp=A}),define(De[104],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lh=void 0;class C{constructor(...d){this.a=new Map;for(const[M,A]of d)this.set(M,A)}set(d,M){const A=this.a.get(d);return this.a.set(d,M),A}has(d){return this.a.has(d)}get(d){return this.a.get(d)}}e.$Lh=C}),define(De[238],Ce([1,0,9,8,3,102,229,5,104,75]),function(me,e,C,T,d,M,A,b,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aq=e.$_p=void 0;const R=!1;class I extends Error{constructor(l){super("cyclic dependency between services"),this.message=l.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${l.toString()}`}}class p{constructor(l=new E.$Lh,s=!1,r,c=R){this.f=l,this.g=s,this.h=r,this.i=c,this.o=new Set,this.f.set(b.$Mh,this),this._globalGraph=c?r?._globalGraph??new A.$$p(m=>m):void 0}createChild(l){return new p(l,this.g,this,this.i)}invokeFunction(l,...s){const r=D.traceInvocation(this.i,l);let c=!1;try{return l({get:h=>{if(c)throw(0,T.$7)("service accessor is only valid during the invocation of its target method");const t=this.m(h,r);if(!t)throw new Error(`[invokeFunction] unknown service '${h}'`);return t}},...s)}finally{c=!0,r.stop()}}createInstance(l,...s){let r,c;return l instanceof M.$Kh?(r=D.traceCreation(this.i,l.ctor),c=this.j(l.ctor,l.staticArguments.concat(s),r)):(r=D.traceCreation(this.i,l),c=this.j(l,s,r)),r.stop(),c}j(l,s=[],r){const c=b._util.getServiceDependencies(l).sort((t,n)=>t.index-n.index),m=[];for(const t of c){const n=this.m(t.id,r);n||this.u(`[createInstance] ${l.name} depends on UNKNOWN service ${t.id}.`,!1),m.push(n)}const h=c.length>0?c[0].index:s.length;if(s.length!==h){console.trace(`[createInstance] First service dependency of ${l.name} at position ${h+1} conflicts with ${s.length} static arguments`);const t=h-s.length;t>0?s=s.concat(new Array(t)):s=s.slice(0,h)}return Reflect.construct(l,s.concat(m))}k(l,s){if(this.f.get(l)instanceof M.$Kh)this.f.set(l,s);else if(this.h)this.h.k(l,s);else throw new Error("illegalState - setting UNKNOWN service instance")}l(l){const s=this.f.get(l);return!s&&this.h?this.h.l(l):s}m(l,s){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(l));const r=this.l(l);return r instanceof M.$Kh?this.q(l,r,s.branch(l,!0)):(s.branch(l,!1),r)}q(l,s,r){if(this.o.has(l))throw new Error(`illegal state - RECURSIVELY instantiating service '${l}'`);this.o.add(l);try{return this.r(l,s,r)}finally{this.o.delete(l)}}r(l,s,r){const c=new A.$$p(t=>t.id.toString());let m=0;const h=[{id:l,desc:s,_trace:r}];for(;h.length;){const t=h.pop();if(c.lookupOrInsertNode(t),m++>1e3)throw new I(c);for(const n of b._util.getServiceDependencies(t.desc.ctor)){const o=this.l(n.id);if(o||this.u(`[createInstance] ${l} depends on ${n.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(n.id)),o instanceof M.$Kh){const i={id:n.id,desc:o,_trace:t._trace.branch(n.id,!0)};c.insertEdge(t,i),h.push(i)}}}for(;;){const t=c.roots();if(t.length===0){if(!c.isEmpty())throw new I(c);break}for(const{data:n}of t){if(this.l(n.id)instanceof M.$Kh){const i=this.s(n.id,n.desc.ctor,n.desc.staticArguments,n.desc.supportsDelayedInstantiation,n._trace);this.k(n.id,i)}c.removeNode(n)}}return this.l(l)}s(l,s,r=[],c,m){if(this.f.get(l)instanceof M.$Kh)return this.t(l,s,r,c,m);if(this.h)return this.h.s(l,s,r,c,m);throw new Error(`illegalState - creating UNKNOWN service instance ${s.name}`)}t(l,s,r=[],c,m){if(c){const h=new p(void 0,this.g,this,this.i);h.c=String(l);const t=new Map,n=new C.$0g(()=>{const o=h.j(s,r,m);for(const[i,a]of t){const u=o[i];if(typeof u=="function")for(const k of a)u.apply(o,k)}return t.clear(),o});return new Proxy(Object.create(null),{get(o,i){if(!n.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let k=t.get(i);return k||(k=new w.$1c,t.set(i,k)),($,g,f)=>{const P=k.push([$,g,f]);return(0,d.$Pc)(P)}}if(i in o)return o[i];const a=n.value;let u=a[i];return typeof u!="function"||(u=u.bind(a),o[i]=u),u},set(o,i,a){return n.value[i]=a,!0},getPrototypeOf(o){return s.prototype}})}else return this.j(s,r,m)}u(l,s){if(s&&console.warn(l),this.g)throw new Error(l)}}e.$_p=p;var y;(function(v){v[v.None=0]="None",v[v.Creation=1]="Creation",v[v.Invocation=2]="Invocation",v[v.Branch=3]="Branch"})(y||(y={}));class D{static{this.all=new Set}static{this.c=new class extends D{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(l,s){return l?new D(2,s.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):D.c}static traceCreation(l,s){return l?new D(1,s.name):D.c}static{this.f=0}constructor(l,s){this.type=l,this.name=s,this.g=Date.now(),this.h=[]}branch(l,s){const r=new D(3,l.toString());return this.h.push([l,s,r]),r}stop(){const l=Date.now()-this.g;D.f+=l;let s=!1;function r(m,h){const t=[],n=new Array(m+1).join("	");for(const[o,i,a]of h.h)if(i&&a){s=!0,t.push(`${n}CREATES -> ${o}`);const u=r(m+1,a);u&&t.push(u)}else t.push(`${n}uses -> ${o}`);return t.join(`
`)}const c=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${r(1,this)}`,`DONE, took ${l.toFixed(2)}ms (grand total ${D.f.toFixed(2)}ms)`];(l>2||s)&&D.all.add(c.join(`
`))}}e.$aq=D}),define(De[13],Ce([1,0,46,4,52,3,28,12,24,18,2,41,5]),function(me,e,C,T,d,M,A,b,E,w,R,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.log=e.$$i=e.LogLevel=e.$0i=e.$9i=e.$8i=void 0,e.$8i=(0,p.$Nh)("logService"),e.$9i=(0,p.$Nh)("loggerService");function y(){return new Date().toISOString()}function D($){return(0,w.$Bf)($)}e.$0i=D;var v;(function($){$[$.Off=0]="Off",$[$.Trace=1]="Trace",$[$.Debug=2]="Debug",$[$.Info=3]="Info",$[$.Warning=4]="Warning",$[$.Error=5]="Error"})(v||(e.LogLevel=v={})),e.$$i=v.Info;function l($,g,f){switch(g){case v.Trace:$.trace(f);break;case v.Debug:$.debug(f);break;case v.Info:$.info(f);break;case v.Warning:$.warn(f);break;case v.Error:$.error(f);break;case v.Off:break;default:throw new Error(`Invalid log level ${g}`)}}e.log=l;function s($,g=!1){let f="";for(let P=0;P<$.length;P++){let N=$[P];if(N instanceof Error&&(N=(0,C.$yi)(N,g)),typeof N=="object")try{N=JSON.stringify(N)}catch{}f+=(P>0?" ":"")+N}return f}class r extends M.$Rc{constructor(){super(...arguments),this.b=e.$$i,this.c=this.B(new T.$Md),this.onDidChangeLogLevel=this.c.event}setLevel(g){this.b!==g&&(this.b=g,this.c.fire(this.b))}getLevel(){return this.b}f(g){return this.b!==v.Off&&this.b<=g}}e.$aj=r;class c extends r{constructor(g){super(),this.h=g}f(g){return this.h||super.f(g)}trace(g,...f){this.f(v.Trace)&&this.g(v.Trace,s([g,...f],!0))}debug(g,...f){this.f(v.Debug)&&this.g(v.Debug,s([g,...f]))}info(g,...f){this.f(v.Info)&&this.g(v.Info,s([g,...f]))}warn(g,...f){this.f(v.Warning)&&this.g(v.Warning,s([g,...f]))}error(g,...f){if(this.f(v.Error))if(g instanceof Error){const P=Array.prototype.slice.call(arguments);P[0]=g.stack,this.g(v.Error,s(P))}else this.g(v.Error,s([g,...f]))}flush(){}}e.$bj=c;class m extends r{constructor(g=e.$$i){super(),this.setLevel(g),this.g=!b.$j}trace(g,...f){this.f(v.Trace)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,g,...f):console.log(`[main ${y()}]`,g,...f))}debug(g,...f){this.f(v.Debug)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,g,...f):console.log(`[main ${y()}]`,g,...f))}info(g,...f){this.f(v.Info)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,g,...f):console.log(`[main ${y()}]`,g,...f))}warn(g,...f){this.f(v.Warning)&&(this.g?console.warn(`\x1B[93m[main ${y()}]\x1B[0m`,g,...f):console.warn(`[main ${y()}]`,g,...f))}error(g,...f){this.f(v.Error)&&(this.g?console.error(`\x1B[91m[main ${y()}]\x1B[0m`,g,...f):console.error(`[main ${y()}]`,g,...f))}dispose(){}flush(){}}e.$cj=m;class h extends r{constructor(g=e.$$i,f=!0){super(),this.g=f,this.setLevel(g)}trace(g,...f){this.f(v.Trace)&&(this.g?console.log("%cTRACE","color: #888",g,...f):console.log(g,...f))}debug(g,...f){this.f(v.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",g,...f):console.log(g,...f))}info(g,...f){this.f(v.Info)&&(this.g?console.log("%c INFO","color: #33f",g,...f):console.log(g,...f))}warn(g,...f){this.f(v.Warning)&&(this.g?console.log("%c WARN","color: #993",g,...f):console.log(g,...f))}error(g,...f){this.f(v.Error)&&(this.g?console.log("%c  ERR","color: #f33",g,...f):console.error(g,...f))}dispose(){}flush(){}}e.$dj=h;class t extends r{constructor(g,f=e.$$i){super(),this.g=g,this.setLevel(f)}trace(g,...f){this.f(v.Trace)&&this.g.log(v.Trace,[this.h(g),...f])}debug(g,...f){this.f(v.Debug)&&this.g.log(v.Debug,[this.h(g),...f])}info(g,...f){this.f(v.Info)&&this.g.log(v.Info,[this.h(g),...f])}warn(g,...f){this.f(v.Warning)&&this.g.log(v.Warning,[this.h(g),...f])}error(g,...f){this.f(v.Error)&&this.g.log(v.Error,[this.h(g),...f])}h(g){return typeof g=="string"?g:(0,C.$yi)(g,this.f(v.Trace))}dispose(){}flush(){}}e.$ej=t;class n extends r{constructor(g){super(),this.g=g,g.length&&this.setLevel(g[0].getLevel())}setLevel(g){for(const f of this.g)f.setLevel(g);super.setLevel(g)}trace(g,...f){for(const P of this.g)P.trace(g,...f)}debug(g,...f){for(const P of this.g)P.debug(g,...f)}info(g,...f){for(const P of this.g)P.info(g,...f)}warn(g,...f){for(const P of this.g)P.warn(g,...f)}error(g,...f){for(const P of this.g)P.error(g,...f)}flush(){for(const g of this.g)g.flush()}dispose(){for(const g of this.g)g.dispose()}}e.$fj=n;class o extends M.$Rc{constructor(g,f,P){if(super(),this.h=g,this.j=f,this.b=new A.$zc,this.c=this.B(new T.$Md),this.onDidChangeLoggers=this.c.event,this.f=this.B(new T.$Md),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new T.$Md),this.onDidChangeVisibility=this.g.event,P)for(const N of P)this.b.set(N.resource,{logger:void 0,info:N})}m(g){return(0,w.$xf)(g)?[...this.b.values()].find(f=>f.info.id===g):this.b.get(g)}getLogger(g){return this.m(g)?.logger}createLogger(g,f){const P=this.n(g),N=(0,w.$xf)(g)?g:f?.id??(0,d.$Bi)(P.toString()).toString(16);let O=this.b.get(P)?.logger;const L=f?.logLevel==="always"?v.Trace:f?.logLevel;O||(O=this.s(P,L??this.getLogLevel(P)??this.h,{...f,id:N}));const j={logger:O,info:{resource:P,id:N,logLevel:L,name:f?.name,hidden:f?.hidden,extensionId:f?.extensionId,when:f?.when}};return this.registerLogger(j.info),this.b.set(P,j),O}n(g){return(0,w.$xf)(g)?(0,E.$ug)(this.j,`${g}.log`):g}setLogLevel(g,f){if(R.URI.isUri(g)){const P=g,N=f,O=this.b.get(P);O&&N!==O.info.logLevel&&(O.info.logLevel=N===this.h?void 0:N,O.logger?.setLevel(N),this.b.set(O.info.resource,O),this.f.fire([P,N]))}else{this.h=g;for(const[P,N]of this.b.entries())this.b.get(P)?.info.logLevel===void 0&&N.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(g,f){const P=this.m(g);P&&f!==!P.info.hidden&&(P.info.hidden=!f,this.b.set(P.info.resource,P),this.g.fire([P.info.resource,f]))}getLogLevel(g){let f;return g&&(f=this.b.get(g)?.info.logLevel),f??this.h}registerLogger(g){const f=this.b.get(g.resource);f?f.info.hidden!==g.hidden&&this.setVisibility(g.resource,!g.hidden):(this.b.set(g.resource,{info:g,logger:void 0}),this.c.fire({added:[g],removed:[]}))}deregisterLogger(g){const f=this.b.get(g);f&&(f.logger&&f.logger.dispose(),this.b.delete(g),this.c.fire({added:[],removed:[f.info]}))}*getRegisteredLoggers(){for(const g of this.b.values())yield g.info}getRegisteredLogger(g){return this.b.get(g)?.info}dispose(){this.b.forEach(g=>g.logger?.dispose()),this.b.clear(),super.dispose()}}e.$gj=o;class i{constructor(){this.onDidChangeLogLevel=new T.$Md().event}setLevel(g){}getLevel(){return v.Info}trace(g,...f){}debug(g,...f){}info(g,...f){}warn(g,...f){}error(g,...f){}critical(g,...f){}dispose(){}flush(){}}e.$hj=i;class a extends i{}e.$ij=a;function u($){if($.verbose)return v.Trace;if(typeof $.logLevel=="string"){const g=S($.logLevel.toLowerCase());if(g!==void 0)return g}return e.$$i}e.$jj=u;function k($){switch($){case v.Trace:return"trace";case v.Debug:return"debug";case v.Info:return"info";case v.Warning:return"warn";case v.Error:return"error";case v.Off:return"off"}}e.$kj=k;function S($){switch($){case"trace":return v.Trace;case"debug":return v.Debug;case"info":return v.Info;case"warn":return v.Warning;case"error":return v.Error;case"critical":return v.Error;case"off":return v.Off}}e.$lj=S,e.$mj=new I.$5i("logLevel",k(v.Info))}),define(De[239],Ce([1,0,19,9,8,4,3,16,83,13]),function(me,e,C,T,d,M,A,b,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=void 0;class R extends A.$Rc{constructor(p,y){super(),this.a=p,this.b=y,this.c=this.B(new M.$Md),this.onDidChangeFile=this.c.event,this.g=this.B(new M.$Md),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new T.$Qg(0)),this.w=[],this.y=this.B(new T.$Qg(0))}watch(p,y){return y.recursive||this.b?.watcher?.forceUniversal?this.n(p,y):this.z(p,y)}n(p,y){const D={path:this.H(p),excludes:y.excludes,includes:y.includes,recursive:y.recursive},v=(0,C.$Tb)(this.j,D);return this.r(),(0,A.$Pc)(()=>{v(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(p=>(0,d.$Z)(p))}s(){this.h||(this.h=this.B(this.t(y=>this.c.fire((0,E.$Op)(y)),y=>this.G(y),this.a.getLevel()===w.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===w.LogLevel.Trace)})));const p=this.b?.watcher?.recursive?.usePolling;if(p===!0)for(const y of this.j)(0,E.$Kp)(y)&&(y.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(p))for(const y of this.j)(0,E.$Kp)(y)&&p.includes(y.path)&&(y.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(p,y){const D={path:this.H(p),excludes:y.excludes,includes:y.includes,recursive:!1},v=(0,C.$Tb)(this.w,D);return this.C(),(0,A.$Pc)(()=>{v(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(p=>(0,d.$Z)(p))}D(){return this.u||(this.u=this.B(this.F(p=>this.c.fire((0,E.$Op)(p)),p=>this.G(p),this.a.getLevel()===w.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===w.LogLevel.Trace)}))),this.u.watch(this.w)}G(p){p.type==="error"&&this.g.fire(p.message),this.a[p.type](p.message)}H(p){return(0,b.$gc)(p.fsPath)}}e.$Sp=R}),define(De[240],Ce([1,0,53,372,9,28,22,4,32,3,16,12,24,96,29,197,30,233,239,46,237,236]),function(me,e,C,T,d,M,A,b,E,w,R,I,p,y,D,v,l,s,r,c,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=void 0,(()=>{try{(0,T.gracefulify)(C)}catch(n){console.error(`Error enabling graceful-fs: ${(0,c.$yi)(n)}`)}})();class t extends r.$Sp{static{this.I=!1}constructor(o,i){super(o,i),this.onDidChangeCapabilities=b.Event.None,this.N=new M.$zc(a=>p.$lg.getComparisonKey(a)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,I.$l&&(this.J|=1024)),this.J}async stat(o){try{const{stat:i,symbolicLink:a}=await D.SymlinkSupport.stat(this.H(o));return{type:this.M(i,a),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:l.FilePermission.Locked}}catch(i){throw this.fb(i)}}async L(o){try{return await this.stat(o)}catch{return}}async readdir(o){try{const i=await D.Promises.readdir(this.H(o),{withFileTypes:!0}),a=[];return await Promise.all(i.map(async u=>{try{let k;u.isSymbolicLink()?k=(await this.stat((0,p.$ug)(o,u.name))).type:k=this.M(u),a.push([u.name,k])}catch(k){this.a.trace(k)}})),a}catch(i){throw this.fb(i)}}M(o,i){let a;return i?.dangling?a=l.FileType.Unknown:o.isFile()?a=l.FileType.File:o.isDirectory()?a=l.FileType.Directory:a=l.FileType.Unknown,i&&(a|=l.FileType.SymbolicLink),a}async O(o){const i=this.H(o);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let a;for(;a=this.N.get(o);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await a.wait();const u=new d.$Rg;return this.N.set(o,u),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,w.$Pc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.N.get(o)===u&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.N.delete(o)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),u.open()})}async readFile(o,i){let a;try{i?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(o)})`),a=await this.O(o));const u=this.H(o);return await D.Promises.readFile(u)}catch(u){throw this.fb(u)}finally{a?.dispose()}}P(o){t.I&&this.a.trace(o)}readFileStream(o,i,a){const u=(0,y.$1d)(k=>A.$ae.concat(k.map(S=>A.$ae.wrap(S))).buffer);return(0,s.$Ip)(this,o,u,k=>k.buffer,{...i,bufferSize:256*1024},a),u}async writeFile(o,i,a){return a?.atomic!==!1&&a?.atomic?.postfix&&await this.Q(o)?this.R(o,(0,p.$ug)((0,p.$tg)(o),`${(0,p.$rg)(o)}${a.atomic.postfix}`),i,a):this.S(o,i,a)}async Q(o){try{const i=this.H(o),{symbolicLink:a}=await D.SymlinkSupport.stat(i);if(a)return!1}catch{}return!0}async R(o,i,a,u){const k=new w.$Qc;try{k.add(await this.O(o)),k.add(await this.O(i)),await this.S(i,a,u,!0);try{await this.rename(i,o,{overwrite:!0})}catch(S){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw S}}finally{k.dispose()}}async S(o,i,a,u){let k;try{const S=this.H(o);if(!a.create||!a.overwrite){if(await D.Promises.exists(S)){if(!a.overwrite)throw(0,l.$ik)((0,v.localize)(0,null),l.FileSystemProviderErrorCode.FileExists)}else if(!a.create)throw(0,l.$ik)((0,v.localize)(1,null),l.FileSystemProviderErrorCode.FileNotFound)}k=await this.open(o,{create:!0,unlock:a.unlock},u),await this.write(k,0,i,0,i.byteLength)}catch(S){throw await this.gb(o,S)}finally{typeof k=="number"&&await this.close(k)}}static{this.Y=!0}static configureFlushOnWrite(o){t.Y=o}async open(o,i,a){const u=this.H(o);let k;(0,l.$0j)(i)&&!a&&(k=await this.O(o));let S;try{if((0,l.$0j)(i)&&i.unlock)try{const{stat:g}=await D.SymlinkSupport.stat(u);g.mode&128||await D.Promises.chmod(u,g.mode|128)}catch(g){g.code!=="ENOENT"&&this.a.trace(g)}let $;if((0,l.$0j)(i)){if(I.$j)try{await D.Promises.truncate(u,0),$="r+"}catch(g){g.code!=="ENOENT"&&this.a.trace(g)}$||($="w")}else $="r";S=await D.Promises.open(u,$)}catch($){throw k?.dispose(),(0,l.$0j)(i)?await this.gb(o,$):this.fb($)}if(this.U.set(S,0),(0,l.$0j)(i)&&this.X.set(S,o),k){const $=this.W.get(S);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${S} (${u})`),this.W.set(S,k),$&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${S} (${u})`),$.dispose())}return S}async close(o){const i=this.W.get(o);try{if(this.U.delete(o),this.X.delete(o)&&t.Y)try{await D.Promises.fdatasync(o)}catch(a){t.configureFlushOnWrite(!1),this.a.error(a)}return await D.Promises.close(o)}catch(a){throw this.fb(a)}finally{i&&(this.W.get(o)===i&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${o}`),this.W.delete(o)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${o}`),i.dispose())}}async read(o,i,a,u,k){const S=this.Z(o,i);let $=null;try{$=(await D.Promises.read(o,a,u,k,S)).bytesRead}catch(g){throw this.fb(g)}finally{this.$(o,S,$)}return $}Z(o,i){return i===this.U.get(o)?null:i}$(o,i,a){const u=this.U.get(o);typeof u=="number"&&(typeof i=="number"||(typeof a=="number"?this.U.set(o,u+a):this.U.delete(o)))}async write(o,i,a,u,k){return(0,d.$$g)(()=>this.ab(o,i,a,u,k),100,3)}async ab(o,i,a,u,k){const S=this.Z(o,i);let $=null;try{$=(await D.Promises.write(o,a,u,k,S)).bytesWritten}catch(g){throw await this.gb(this.X.get(o),g)}finally{this.$(o,S,$)}return $}async mkdir(o){try{await D.Promises.mkdir(this.H(o))}catch(i){throw this.fb(i)}}async delete(o,i){try{const a=this.H(o);if(i.recursive){let u;i?.atomic!==!1&&i.atomic.postfix&&(u=(0,R.$ic)((0,R.$lc)(a),`${(0,R.$mc)(a)}${i.atomic.postfix}`)),await D.Promises.rm(a,D.RimRafMode.MOVE,u)}else try{await D.Promises.unlink(a)}catch(u){if(u.code==="EPERM"||u.code==="EISDIR"){let k=!1;try{const{stat:S,symbolicLink:$}=await D.SymlinkSupport.stat(a);k=S.isDirectory()&&!$}catch{}if(k)await D.Promises.rmdir(a);else throw u}else throw u}}catch(a){throw this.fb(a)}}async rename(o,i,a){const u=this.H(o),k=this.H(i);if(u!==k)try{await this.bb(o,i,"move",a.overwrite),await D.Promises.rename(u,k)}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,v.localize)(2,null,(0,R.$mc)(u),(0,R.$mc)((0,R.$lc)(k)),S.toString()))),this.fb(S)}}async copy(o,i,a){const u=this.H(o),k=this.H(i);if(u!==k)try{await this.bb(o,i,"copy",a.overwrite),await D.Promises.copy(u,k,{preserveSymlinks:!0})}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,v.localize)(3,null,(0,R.$mc)(u),(0,R.$mc)((0,R.$lc)(k)),S.toString()))),this.fb(S)}}async bb(o,i,a,u){const k=this.H(o),S=this.H(i);let $=!1;if(!!(this.capabilities&1024)||($=(0,E.$Vf)(k,S,!0)),$){if(a==="copy")throw(0,l.$ik)((0,v.localize)(4,null),l.FileSystemProviderErrorCode.FileExists);if(a==="move")return}const f=await this.L(o);if(!f)throw(0,l.$ik)((0,v.localize)(5,null),l.FileSystemProviderErrorCode.FileNotFound);const P=await this.L(i);if(P){if(!u)throw(0,l.$ik)((0,v.localize)(6,null),l.FileSystemProviderErrorCode.FileExists);f.type&l.FileType.File&&P.type&l.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(o,i){return this.cb(o,i,!1)}async cb(o,i,a){const u=this.H(o),k=this.H(i),S=!!(this.capabilities&1024);if((0,E.$Vf)(u,k,!S))return;const $=new w.$Qc;try{$.add(await this.O(o)),$.add(await this.O(i)),a&&await D.Promises.mkdir((0,R.$lc)(k),{recursive:!0}),await D.Promises.copyFile(u,k)}catch(g){if(g.code==="ENOENT"&&!a)return this.cb(o,i,!0);throw this.fb(g)}finally{$.dispose()}}t(o,i,a){return new m.$Zp(u=>o(u),u=>i(u),a)}F(o,i,a){return new h.$8p(u=>o(u),u=>i(u),a)}fb(o){if(o instanceof l.$hk)return o;let i=o,a;switch(o.code){case"ENOENT":a=l.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=l.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=l.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=l.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=l.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${o.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,a=l.FileSystemProviderErrorCode.Unknown;break;default:a=l.FileSystemProviderErrorCode.Unknown}return(0,l.$ik)(i,a)}async gb(o,i){let a=this.fb(i);if(o&&a.code===l.FileSystemProviderErrorCode.NoPermissions)try{const{stat:u}=await D.SymlinkSupport.stat(this.H(o));u.mode&128||(a=(0,l.$ik)(i,l.FileSystemProviderErrorCode.FileWriteLocked))}catch(u){this.a.trace(u)}return a}}e.$9p=t}),define(De[241],Ce([1,0,3,13]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xN=void 0;class d extends C.$Rc{constructor(A,b=[]){super(),this.a=new T.$fj([A,...b]),this.B(A.onDidChangeLogLevel(E=>this.setLevel(E)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...b){this.a.trace(A,...b)}debug(A,...b){this.a.debug(A,...b)}info(A,...b){this.a.info(A,...b)}warn(A,...b){this.a.warn(A,...b)}error(A,...b){this.a.error(A,...b)}flush(){this.a.flush()}}e.$xN=d}),define(De[242],Ce([1,0,30,13]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mN=void 0;var d;(function(w){w[w.Trace=0]="Trace",w[w.Debug=1]="Debug",w[w.Info=2]="Info",w[w.Warning=3]="Warning",w[w.Error=4]="Error",w[w.Critical=5]="Critical",w[w.Off=6]="Off"})(d||(d={}));async function M(w,R,I,p,y){try{const D=await new Promise((l,s)=>{me(["@vscode/spdlog"],l,s)});D.setFlushOn(d.Trace);const v=await D.createAsyncRotatingLogger(w,R,I,p);return y?v.clearFormatters():v.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),v}catch(D){console.error(D)}return null}function A(w,R,I){switch(R){case T.LogLevel.Trace:w.trace(I);break;case T.LogLevel.Debug:w.debug(I);break;case T.LogLevel.Info:w.info(I);break;case T.LogLevel.Warning:w.warn(I);break;case T.LogLevel.Error:w.error(I);break;case T.LogLevel.Off:break;default:throw new Error(`Invalid log level ${R}`)}}function b(w,R){switch(R){case T.LogLevel.Trace:w.setLevel(d.Trace);break;case T.LogLevel.Debug:w.setLevel(d.Debug);break;case T.LogLevel.Info:w.setLevel(d.Info);break;case T.LogLevel.Warning:w.setLevel(d.Warning);break;case T.LogLevel.Error:w.setLevel(d.Error);break;case T.LogLevel.Off:w.setLevel(d.Off);break;default:throw new Error(`Invalid log level ${R}`)}}class E extends T.$bj{constructor(R,I,p,y,D){super(),this.m=[],this.setLevel(D),this.n=this.s(R,I,p,y),this.B(this.onDidChangeLogLevel(v=>{this.r&&b(this.r,v)}))}async s(R,I,p,y){const D=p?6:1,v=30/D*C.$Dk.MB,l=await M(R,I,v,D,y);if(l){this.r=l,b(this.r,this.getLevel());for(const{level:s,message:r}of this.m)A(this.r,s,r);this.m=[]}}g(R,I){this.r?A(this.r,R,I):this.getLevel()<=R&&this.m.push({level:R,message:I})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u())}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$mN=E}),define(De[133],Ce([1,0,38,198,5]),function(me,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7s=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var M;(function(E){E[E.Unnecessary=1]="Unnecessary",E[E.Deprecated=2]="Deprecated"})(M||(e.MarkerTag=M={}));var A;(function(E){E[E.Hint=1]="Hint",E[E.Info=2]="Info",E[E.Warning=4]="Warning",E[E.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function(E){function w(D,v){return v-D}E.compare=w;const R=Object.create(null);R[E.Error]=(0,T.localize)(0,null),R[E.Warning]=(0,T.localize)(1,null),R[E.Info]=(0,T.localize)(2,null);function I(D){return R[D]||""}E.toString=I;function p(D){switch(D){case C.default.Error:return E.Error;case C.default.Warning:return E.Warning;case C.default.Info:return E.Info;case C.default.Ignore:return E.Hint}}E.fromSeverity=p;function y(D){switch(D){case E.Error:return C.default.Error;case E.Warning:return C.default.Warning;case E.Info:return C.default.Info;case E.Hint:return C.default.Ignore}}E.toSeverity=y}(A||(e.MarkerSeverity=A={}));var b;(function(E){const w="";function R(p){return I(p,!0)}E.makeKey=R;function I(p,y){const D=[w];return p.source?D.push(p.source.replace("\xA6","\\\xA6")):D.push(w),p.code?typeof p.code=="string"?D.push(p.code.replace("\xA6","\\\xA6")):D.push(p.code.value.replace("\xA6","\\\xA6")):D.push(w),p.severity!==void 0&&p.severity!==null?D.push(A.toString(p.severity)):D.push(w),p.message&&y?D.push(p.message.replace("\xA6","\\\xA6")):D.push(w),p.startLineNumber!==void 0&&p.startLineNumber!==null?D.push(p.startLineNumber.toString()):D.push(w),p.startColumn!==void 0&&p.startColumn!==null?D.push(p.startColumn.toString()):D.push(w),p.endLineNumber!==void 0&&p.endLineNumber!==null?D.push(p.endLineNumber.toString()):D.push(w),p.endColumn!==void 0&&p.endColumn!==null?D.push(p.endColumn.toString()):D.push(w),D.push(w),D.join("\xA6")}E.makeKeyOptionalMessage=I})(b||(e.IMarkerData=b={})),e.$7s=(0,d.$Nh)("markerService")}),define(De[243],Ce([1,0,4,38,5]),function(me,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wu=e.$Vu=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Uu=e.Severity=void 0,e.Severity=T.default,e.$Uu=(0,d.$Nh)("notificationService");var M;(function(R){R[R.DEFAULT=0]="DEFAULT",R[R.SILENT=1]="SILENT",R[R.URGENT=2]="URGENT"})(M||(e.NotificationPriority=M={}));var A;(function(R){R[R.WORKSPACE=0]="WORKSPACE",R[R.PROFILE=1]="PROFILE",R[R.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));var b;(function(R){R[R.OFF=0]="OFF",R[R.SILENT=1]="SILENT",R[R.ERROR=2]="ERROR"})(b||(e.NotificationsFilter=b={}));class E{constructor(){this.progress=new w,this.onDidClose=C.Event.None,this.onDidChangeVisibility=C.Event.None}updateSeverity(I){}updateMessage(I){}updateActions(I){}close(){}}e.$Vu=E;class w{infinite(){}done(){}total(I){}worked(I){}}e.$Wu=w}),define(De[134],Ce([1,0,15,2,5]),function(me,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_T=e.$$T=e.$0T=e.$9T=e.$8T=void 0,e.$8T=(0,d.$Nh)("openerService");function M(w,R){return T.URI.isUri(w)?(0,C.$1e)(w.scheme,R):(0,C.$2e)(w,R+":")}e.$9T=M;function A(w,...R){return R.some(I=>M(w,I))}e.$0T=A;function b(w,R){return w.with({fragment:`${R.startLineNumber},${R.startColumn}${R.endLineNumber?`-${R.endLineNumber}${R.endColumn?`,${R.endColumn}`:""}`:""}`})}e.$$T=b;function E(w){let R;const I=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(w.fragment);return I&&(R={startLineNumber:parseInt(I[1]),startColumn:I[2]?parseInt(I[2]):1,endLineNumber:I[4]?parseInt(I[4]):void 0,endColumn:I[4]?I[5]?parseInt(I[5]):1:void 0},w=w.with({fragment:""})),{selection:R,uri:w}}e.$_T=E}),define(De[244],Ce([1,0,12,47]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let d;if(typeof C.$h.vscode<"u"&&typeof C.$h.vscode.context<"u"){const M=C.$h.vscode.context.configuration();if(M)d=M.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(d=globalThis._VSCODE_PRODUCT_JSON,T.env.VSCODE_DEV&&Object.assign(d,{nameShort:`${d.nameShort} Dev`,nameLong:`${d.nameLong} Dev`,dataFolderName:`${d.dataFolderName}-dev`,serverDataFolderName:d.serverDataFolderName?`${d.serverDataFolderName}-dev`:void 0}),!d.version){const M=globalThis._VSCODE_PACKAGE_JSON;Object.assign(d,{version:M.version})}}else d={},Object.keys(d).length===0&&Object.assign(d,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=d}),define(De[135],Ce([1,0,5]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oj=e.$nj=void 0,e.$nj=(0,C.$Nh)("productService"),e.$oj="vscode://schemas/vscode-product"});var Be=this&&this.__param||function(me,e){return function(C,T){e(C,T,me)}};define(De[84],Ce([1,0,9,21,3,5]),function(me,e,C,T,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3u=e.$2u=e.$1u=e.$Zu=e.$Yu=e.ProgressLocation=e.$Xu=void 0,e.$Xu=(0,M.$Nh)("progressService");var A;(function(R){R[R.Explorer=1]="Explorer",R[R.Scm=3]="Scm",R[R.Extensions=5]="Extensions",R[R.Window=10]="Window",R[R.Notification=15]="Notification",R[R.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.$Yu=Object.freeze({total(){},worked(){},done(){}});class b{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(I,p){this.e=I,this.report=p?.async?this.g.bind(this):this.f.bind(this)}f(I){this.a=I,this.e(this.a)}g(I){this.b?this.b.push(I):this.b=[I],this.h()}async h(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const I=this.b.shift();this.a=I,await this.e(this.a)}}finally{this.c=!1;const I=this.d;this.d=void 0,I?.()}}drain(){return this.c?new Promise(I=>{const p=this.d;this.d=()=>{p?.(),I()}}):Promise.resolve()}}e.$Zu=b;let E=class extends d.$Rc{constructor(I,p){super(),this.a=new C.$bh,p.withProgress(I,y=>(this.b=y,this.c&&y.report(this.c),this.a.p)),this.B((0,d.$Pc)(()=>this.a.complete()))}report(I){this.b?this.b.report(I):this.c=I}};e.$1u=E,e.$1u=E=He([Be(1,e.$Xu)],E);class w extends d.$Rc{constructor(I){super(),this.g=I,this.a=0,this.b=this.B(new d.$Qc)}start(I){this.stop();const p=++this.a,y=new T.$Wd;return this.f=setTimeout(()=>{p===this.a&&(this.c=this.g.show(!0))},I),this.b.add((0,d.$Pc)(()=>clearTimeout(this.f))),this.b.add((0,d.$Pc)(()=>y.cancel())),this.b.add((0,d.$Pc)(()=>this.c?this.c.done():void 0)),{id:p,token:y.token,stop:()=>this.h(p),isCurrent:()=>this.a===p}}stop(){this.h(this.a)}h(I){this.a===I&&this.b.clear()}}e.$2u=w,e.$3u=(0,M.$Nh)("editorProgressService")}),define(De[42],Ce([1,0,58,18]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bn=void 0;class d{constructor(){this.a=new Map}add(A,b){C.ok(T.$xf(A)),C.ok(T.$zf(b)),C.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,b)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$bn=new d}),define(De[105],Ce([1,0,4,42]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cn=void 0,e.$cn={JSONContribution:"base.contributions.json"};function d(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class M{constructor(){this.b=new C.$Md,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(E,w){this.a[d(E)]=w,this.b.fire(E)}notifySchemaChanged(E){this.b.fire(E)}getSchemaContributions(){return{schemas:this.a}}}const A=new M;T.$bn.add(e.$cn.JSONContribution,A)}),define(De[136],Ce([1,0,19,4,18,188,49,105,42]),function(me,e,C,T,d,M,A,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.ConfigurationScope=e.$gn=e.EditPresentationTypes=void 0;var w;(function(h){h.Multiline="multilineText",h.Singleline="singlelineText"})(w||(e.EditPresentationTypes=w={})),e.$gn={Configuration:"base.contributions.configuration"};var R;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.MACHINE=2]="MACHINE",h[h.WINDOW=3]="WINDOW",h[h.RESOURCE=4]="RESOURCE",h[h.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",h[h.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R||(e.ConfigurationScope=R={})),e.$hn={properties:{},patternProperties:{}},e.$in={properties:{},patternProperties:{}},e.$jn={properties:{},patternProperties:{}},e.$kn={properties:{},patternProperties:{}},e.$ln={properties:{},patternProperties:{}},e.$mn={properties:{},patternProperties:{}},e.$nn="vscode://schemas/settings/resourceLanguage",e.$on="vscode://schemas/settings/configurationDefaults";const I=E.$bn.as(b.$cn.JSONContribution);class p{constructor(){this.h=new Set,this.i=new T.$Md,this.onDidSchemaChange=this.i.event,this.j=new T.$Md,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},I.registerSchema(e.$nn,this.g),this.v()}registerConfiguration(t,n=!0){this.registerConfigurations([t],n)}registerConfigurations(t,n=!0){const o=new Set;this.n(t,n,o),I.registerSchema(e.$nn,this.g),this.i.fire(),this.j.fire({properties:o})}deregisterConfigurations(t){const n=new Set;this.o(t,n),I.registerSchema(e.$nn,this.g),this.i.fire(),this.j.fire({properties:n})}updateConfigurations({add:t,remove:n}){const o=new Set;this.o(n,o),this.n(t,!1,o),I.registerSchema(e.$nn,this.g),this.i.fire(),this.j.fire({properties:o})}registerDefaultConfigurations(t){const n=new Set;this.k(t,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:!0})}k(t,n){const o=[];for(const{overrides:i,source:a}of t)for(const u in i)if(n.add(u),e.$qn.test(u)){const k=this.a.get(u),S=k?.valuesSources??new Map;if(a)for(const P of Object.keys(i[u]))S.set(P,a);const $={...k?.value||{},...i[u]};this.a.set(u,{source:a,value:$,valuesSources:S});const g=(0,A.$ri)(u),f={type:"object",default:$,description:M.localize(1,null,g),$ref:e.$nn,defaultDefaultValue:$,source:d.$xf(a)?void 0:a,defaultValueSource:a};o.push(...v(u)),this.d[u]=f,this.b.properties[u]=f}else{this.a.set(u,{value:i[u],source:a});const k=this.d[u];k&&(this.w(u,k),this.r(u,k))}this.m(o)}deregisterDefaultConfigurations(t){const n=new Set;this.l(t,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:!0})}l(t,n){for(const{overrides:o,source:i}of t)for(const a in o){const u=this.a.get(a),k=d.$xf(i)?i:i?.id,S=d.$xf(u?.source)?u?.source:u?.source?.id;if(k===S)if(n.add(a),this.a.delete(a),e.$qn.test(a))delete this.d[a],delete this.b.properties[a];else{const $=this.d[a];$&&(this.w(a,$),this.r(a,$))}}this.u()}deltaConfiguration(t){let n=!1;const o=new Set;t.removedDefaults&&(this.l(t.removedDefaults,o),n=!0),t.addedDefaults&&(this.k(t.addedDefaults,o),n=!0),t.removedConfigurations&&this.o(t.removedConfigurations,o),t.addedConfigurations&&this.n(t.addedConfigurations,!1,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:n})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const n of t)this.h.add(n);this.u()}n(t,n,o){t.forEach(i=>{this.p(i,n,i.extensionInfo,i.restrictedProperties,void 0,o),this.c.push(i),this.q(i)})}o(t,n){const o=i=>{if(i.properties)for(const a in i.properties){n.add(a);const u=this.d[a];u?.policy?.name&&this.e.delete(u.policy.name),delete this.d[a],this.s(a,i.properties[a])}i.allOf?.forEach(a=>o(a))};for(const i of t){o(i);const a=this.c.indexOf(i);a!==-1&&this.c.splice(a,1)}}p(t,n=!0,o,i,a=3,u){a=d.$Gf(t.scope)?a:t.scope;const k=t.properties;if(k)for(const $ in k){const g=k[$];if(n&&c($,g)){delete k[$];continue}if(g.source=o,g.defaultDefaultValue=k[$].default,this.w($,g),e.$qn.test($)?g.scope=void 0:(g.scope=d.$Gf(g.scope)?a:g.scope,g.restricted=d.$Gf(g.restricted)?!!i?.includes($):g.restricted),k[$].hasOwnProperty("included")&&!k[$].included){this.f[$]=k[$],delete k[$];continue}else this.d[$]=k[$],k[$].policy?.name&&this.e.set(k[$].policy.name,$);!k[$].deprecationMessage&&k[$].markdownDeprecationMessage&&(k[$].deprecationMessage=k[$].markdownDeprecationMessage),u.add($)}const S=t.allOf;if(S)for(const $ of S)this.p($,n,o,i,a,u)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const n=o=>{const i=o.properties;if(i)for(const u in i)this.r(u,i[u]);o.allOf?.forEach(n)};n(t)}r(t,n){switch(e.$hn.properties[t]=n,n.scope){case 1:e.$in.properties[t]=n;break;case 2:e.$jn.properties[t]=n;break;case 6:e.$kn.properties[t]=n;break;case 3:e.$ln.properties[t]=n;break;case 4:e.$mn.properties[t]=n;break;case 5:e.$mn.properties[t]=n,this.g.properties[t]=n;break}}s(t,n){switch(delete e.$hn.properties[t],n.scope){case 1:delete e.$in.properties[t];break;case 2:delete e.$jn.properties[t];break;case 6:delete e.$kn.properties[t];break;case 3:delete e.$ln.properties[t];break;case 4:case 5:delete e.$mn.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const n=`[${t}]`,o={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.$nn};this.w(n,o),e.$hn.properties[n]=o,e.$in.properties[n]=o,e.$jn.properties[n]=o,e.$kn.properties[n]=o,e.$ln.properties[n]=o,e.$mn.properties[n]=o}}v(){const t={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.$nn};e.$hn.patternProperties[e.$pn]=t,e.$in.patternProperties[e.$pn]=t,e.$jn.patternProperties[e.$pn]=t,e.$kn.patternProperties[e.$pn]=t,e.$ln.patternProperties[e.$pn]=t,e.$mn.patternProperties[e.$pn]=t,this.i.fire()}w(t,n){const o=this.a.get(t);let i=o?.value,a=o?.source;d.$Ef(i)&&(i=n.defaultDefaultValue,a=void 0),d.$Ef(i)&&(i=s(n.type)),n.default=i,n.defaultValueSource=a}}const y="\\[([^\\]]+)\\]",D=new RegExp(y,"g");e.$pn=`^(${y})+$`,e.$qn=new RegExp(e.$pn);function v(h){const t=[];if(e.$qn.test(h)){let n=D.exec(h);for(;n?.length;){const o=n[1].trim();o&&t.push(o),n=D.exec(h)}}return(0,C.$Lb)(t)}e.$rn=v;function l(h){return h.reduce((t,n)=>`${t}[${n}]`,"")}e.$sn=l;function s(h){switch(Array.isArray(h)?h[0]:h){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$tn=s;const r=new p;E.$bn.add(e.$gn.Configuration,r);function c(h,t){return h.trim()?e.$qn.test(h)?M.localize(7,null,h):r.getConfigurationProperties()[h]!==void 0?M.localize(8,null,h):t.policy?.name&&r.getPolicyConfigurations().get(t.policy?.name)!==void 0?M.localize(9,null,h,t.policy?.name,r.getPolicyConfigurations().get(t.policy?.name)):null:M.localize(6,null)}e.$un=c;function m(){const h=[],t=r.getConfigurationProperties();for(const n of Object.keys(t))h.push([n,t[n].scope]);return h.push(["launch",4]),h.push(["task",4]),h}e.$vn=m}),define(De[245],Ce([1,0,19,4,157,3,28,23,18,2,49,136,42]),function(me,e,C,T,d,M,A,b,E,w,R,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.$wn=void 0;function y(n){return Object.isFrozen(n)?n:b.$3m(n)}class D{constructor(o={},i=[],a=[],u){this.b=o,this.c=i,this.d=a,this.raw=u,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const o=this.raw.map(i=>{if(i instanceof D)return i;const a=new v("");return a.parseRaw(i),a.configurationModel});this.f=o.reduce((i,a)=>a===i?a:i.merge(a),o[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(o){return o?(0,R.$pi)(this.contents,o):this.contents}inspect(o,i){const a=this.rawConfiguration.getValue(o),u=i?this.rawConfiguration.getOverrideValue(o,i):void 0,k=i?this.rawConfiguration.override(i).getValue(o):a;return{value:a,override:u,merged:k}}getOverrideValue(o,i){const a=this.i(i);return a?o?(0,R.$pi)(a,o):a:void 0}getKeysForOverrideIdentifier(o){const i=[];for(const a of this.overrides)a.identifiers.includes(o)&&i.push(...a.keys);return C.$Lb(i)}getAllOverrideIdentifiers(){const o=[];for(const i of this.overrides)o.push(...i.identifiers);return C.$Lb(o)}override(o){let i=this.a.get(o);return i||(i=this.g(o),this.a.set(o,i)),i}merge(...o){const i=b.$2m(this.contents),a=b.$2m(this.overrides),u=[...this.keys],k=this.raw?.length?[...this.raw]:[this];for(const S of o)if(k.push(...S.raw?.length?S.raw:[S]),!S.isEmpty()){this.h(i,S.contents);for(const $ of S.overrides){const[g]=a.filter(f=>C.$tb(f.identifiers,$.identifiers));g?(this.h(g.contents,$.contents),g.keys.push(...$.keys),g.keys=C.$Lb(g.keys)):a.push(b.$2m($))}for(const $ of S.keys)u.indexOf($)===-1&&u.push($)}return new D(i,u,a,k.every(S=>S instanceof D)?void 0:k)}g(o){const i=this.i(o);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const a={};for(const u of C.$Lb([...Object.keys(this.contents),...Object.keys(i)])){let k=this.contents[u];const S=i[u];S&&(typeof k=="object"&&typeof S=="object"?(k=b.$2m(k),this.h(k,S)):k=S),a[u]=k}return new D(a,this.keys,this.overrides)}h(o,i){for(const a of Object.keys(i)){if(a in o&&E.$zf(o[a])&&E.$zf(i[a])){this.h(o[a],i[a]);continue}o[a]=b.$2m(i[a])}}i(o){let i=null,a=null;const u=k=>{k&&(a?this.h(a,k):a=b.$2m(k))};for(const k of this.overrides)k.identifiers.length===1&&k.identifiers[0]===o?i=k.contents:k.identifiers.includes(o)&&u(k.contents);return u(i),a}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(o,i){this.j(o,i,!0)}setValue(o,i){this.j(o,i,!1)}removeValue(o){const i=this.keys.indexOf(o);i!==-1&&(this.keys.splice(i,1),(0,R.$oi)(this.contents,o),I.$qn.test(o)&&this.overrides.splice(this.overrides.findIndex(a=>C.$tb(a.identifiers,(0,I.$rn)(o))),1))}j(o,i,a){(0,R.$ni)(this.contents,o,i,u=>console.error(u)),a=a||this.keys.indexOf(o)===-1,a&&this.keys.push(o),I.$qn.test(o)&&this.overrides.push({identifiers:(0,I.$rn)(o),keys:Object.keys(this.contents[o]),contents:(0,R.$mi)(this.contents[o],u=>console.error(u))})}}e.$wn=D;class v{constructor(o){this.f=o,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new D}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(o,i){if(!E.$Gf(o)){const a=this.g(o);this.parseRaw(a,i)}}reparse(o){this.a&&this.parseRaw(this.a,o)}parseRaw(o,i){this.a=o;const{contents:a,keys:u,overrides:k,restricted:S,hasExcludedProperties:$}=this.h(o,i);this.b=new D(a,u,k,$?[o]:void 0),this.c=S||[]}g(o){let i={},a=null,u=[];const k=[],S=[];function $(f){Array.isArray(u)?u.push(f):a!==null&&(u[a]=f)}const g={onObjectBegin:()=>{const f={};$(f),k.push(u),u=f,a=null},onObjectProperty:f=>{a=f},onObjectEnd:()=>{u=k.pop()},onArrayBegin:()=>{const f=[];$(f),k.push(u),u=f,a=null},onArrayEnd:()=>{u=k.pop()},onLiteralValue:$,onError:(f,P,N)=>{S.push({error:f,offset:P,length:N})}};if(o)try{d.$Ym(o,g),i=u[0]||{}}catch(f){console.error(`Error while parsing settings file ${this.f}: ${f}`),this.d=[f]}return i}h(o,i){const a=p.$bn.as(I.$gn.Configuration).getConfigurationProperties(),u=this.i(o,a,!0,i);o=u.raw;const k=(0,R.$mi)(o,g=>console.error(`Conflict in settings file ${this.f}: ${g}`)),S=Object.keys(o),$=this.j(o,g=>console.error(`Conflict in settings file ${this.f}: ${g}`));return{contents:k,keys:S,overrides:$,restricted:u.restricted,hasExcludedProperties:u.hasExcludedProperties}}i(o,i,a,u){let k=!1;if(!u?.scopes&&!u?.skipRestricted&&!u?.exclude?.length)return{raw:o,restricted:[],hasExcludedProperties:k};const S={},$=[];for(const g in o)if(I.$qn.test(g)&&a){const f=this.i(o[g],i,!1,u);S[g]=f.raw,k=k||f.hasExcludedProperties,$.push(...f.restricted)}else{const f=i[g],P=f?typeof f.scope<"u"?f.scope:3:void 0;f?.restricted&&$.push(g),!u.exclude?.includes(g)&&(u.include?.includes(g)||(P===void 0||u.scopes===void 0||u.scopes.includes(P))&&!(u.skipRestricted&&f?.restricted))?S[g]=o[g]:k=!0}return{raw:S,restricted:$,hasExcludedProperties:k}}j(o,i){const a=[];for(const u of Object.keys(o))if(I.$qn.test(u)){const k={};for(const S in o[u])k[S]=o[u][S];a.push({identifiers:(0,I.$rn)(u),keys:Object.keys(k),contents:(0,R.$mi)(k,i)})}return a}}e.$xn=v;class l extends M.$Rc{constructor(o,i,a,u){super(),this.c=o,this.f=i,this.g=u,this.b=this.B(new T.$Md),this.onDidChange=this.b.event,this.a=new v(this.c.toString()),this.B(this.g.watch(a.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(T.Event.any(T.Event.filter(this.g.onDidFilesChange,k=>k.contains(this.c)),T.Event.filter(this.g.onDidRunOperation,k=>(k.isOperation(0)||k.isOperation(3)||k.isOperation(1)||k.isOperation(4))&&a.isEqual(k.resource,o)))(()=>this.b.fire()))}async loadConfiguration(){try{const o=await this.g.readFile(this.c);return this.a.parse(o.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new D}}reparse(o){return o&&(this.f=o),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$yn=l;class s{constructor(o,i,a,u,k,S,$,g,f,P,N,O,L){this.a=o,this.b=i,this.c=a,this.overrideIdentifiers=u,this.d=k,this.f=S,this.g=$,this.h=g,this.i=f,this.j=P,this.k=N,this.l=O,this.m=L}get value(){return y(this.c)}n(o,i,a){const u=o.inspect(i,a);return{get value(){return y(u.value)},get override(){return y(u.override)},get merged(){return y(u.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class r{constructor(o,i,a,u,k=new D,S=new D,$=new A.$zc,g=new D,f=new A.$zc){this.c=o,this.d=i,this.f=a,this.g=u,this.h=k,this.i=S,this.j=$,this.l=g,this.m=f,this.a=null,this.b=new A.$zc,this.n=null}getValue(o,i,a){return this.q(o,i,a).getValue(o)}updateValue(o,i,a={}){let u;a.resource?(u=this.m.get(a.resource),u||(u=new D,this.m.set(a.resource,u))):u=this.l,i===void 0?u.removeValue(o):u.setValue(o,i),a.resource||(this.a=null)}inspect(o,i,a){const u=this.q(o,i,a),k=this.u(i.resource,a),S=i.resource?this.m.get(i.resource)||this.l:this.l,$=new Set;for(const g of u.overrides)for(const f of g.identifiers)u.getOverrideValue(o,f)!==void 0&&$.add(f);return new s(o,i,u.getValue(o),$.size?[...$]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,a?this.i:void 0,k||void 0,S)}keys(o){const i=this.u(void 0,o);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(o){this.c=o,this.a=null,this.b.clear()}updatePolicyConfiguration(o){this.d=o}updateApplicationConfiguration(o){this.f=o,this.a=null,this.b.clear()}updateLocalUserConfiguration(o){this.g=o,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(o){this.h=o,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(o){this.i=o,this.a=null,this.b.clear()}updateFolderConfiguration(o,i){this.j.set(o,i),this.b.delete(o)}deleteFolderConfiguration(o){this.p.delete(o),this.b.delete(o)}compareAndUpdateDefaultConfiguration(o,i){const a=[];if(!i){const{added:u,updated:k,removed:S}=h(this.c,o);i=[...u,...k,...S]}for(const u of i)for(const k of(0,I.$rn)(u)){const S=this.c.getKeysForOverrideIdentifier(k),$=o.getKeysForOverrideIdentifier(k),g=[...$.filter(f=>S.indexOf(f)===-1),...S.filter(f=>$.indexOf(f)===-1),...S.filter(f=>!b.$6m(this.c.override(k).getValue(f),o.override(k).getValue(f)))];a.push([k,g])}return this.updateDefaultConfiguration(o),{keys:i,overrides:a}}compareAndUpdatePolicyConfiguration(o){const{added:i,updated:a,removed:u}=h(this.d,o),k=[...i,...a,...u];return k.length&&this.updatePolicyConfiguration(o),{keys:k,overrides:[]}}compareAndUpdateApplicationConfiguration(o){const{added:i,updated:a,removed:u,overrides:k}=h(this.applicationConfiguration,o),S=[...i,...a,...u];return S.length&&this.updateApplicationConfiguration(o),{keys:S,overrides:k}}compareAndUpdateLocalUserConfiguration(o){const{added:i,updated:a,removed:u,overrides:k}=h(this.localUserConfiguration,o),S=[...i,...a,...u];return S.length&&this.updateLocalUserConfiguration(o),{keys:S,overrides:k}}compareAndUpdateRemoteUserConfiguration(o){const{added:i,updated:a,removed:u,overrides:k}=h(this.remoteUserConfiguration,o),S=[...i,...a,...u];return S.length&&this.updateRemoteUserConfiguration(o),{keys:S,overrides:k}}compareAndUpdateWorkspaceConfiguration(o){const{added:i,updated:a,removed:u,overrides:k}=h(this.workspaceConfiguration,o),S=[...i,...a,...u];return S.length&&this.updateWorkspaceConfiguration(o),{keys:S,overrides:k}}compareAndUpdateFolderConfiguration(o,i){const a=this.p.get(o),{added:u,updated:k,removed:S,overrides:$}=h(a,i),g=[...u,...k,...S];return(g.length||!a)&&this.updateFolderConfiguration(o,i),{keys:g,overrides:$}}compareAndDeleteFolderConfiguration(o){const i=this.p.get(o);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(o);const{added:a,updated:u,removed:k,overrides:S}=h(i,void 0);return{keys:[...a,...u,...k],overrides:S}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(o,i,a){let u=this.r(i,a);return i.overrideIdentifier&&(u=u.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(o)!==void 0&&(u=u.merge(this.d)),u}r({resource:o},i){let a=this.s();if(i&&o){const u=i.getFolder(o);u&&(a=this.t(u.uri)||a);const k=this.m.get(o);k&&(a=a.merge(k))}return a}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(o){let i=this.b.get(o);if(!i){const a=this.s(),u=this.j.get(o);u?(i=a.merge(u),this.b.set(o,i)):i=a}return i}u(o,i){if(i&&o){const a=i.getFolder(o);if(a)return this.j.get(a.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((o,i)=>{const{contents:a,overrides:u,keys:k}=this.j.get(i);return o.push([i,{contents:a,overrides:u,keys:k}]),o},[])}}allKeys(){const o=new Set;return this.c.keys.forEach(i=>o.add(i)),this.userConfiguration.keys.forEach(i=>o.add(i)),this.i.keys.forEach(i=>o.add(i)),this.j.forEach(i=>i.keys.forEach(a=>o.add(a))),[...o.values()]}v(){const o=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>o.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>o.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>o.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(a=>o.add(a))),[...o.values()]}w(o){const i=new Set;return this.c.getKeysForOverrideIdentifier(o).forEach(a=>i.add(a)),this.userConfiguration.getKeysForOverrideIdentifier(o).forEach(a=>i.add(a)),this.i.getKeysForOverrideIdentifier(o).forEach(a=>i.add(a)),this.j.forEach(a=>a.getKeysForOverrideIdentifier(o).forEach(u=>i.add(u))),[...i.values()]}static parse(o){const i=this.x(o.defaults),a=this.x(o.policy),u=this.x(o.application),k=this.x(o.user),S=this.x(o.workspace),$=o.folders.reduce((g,f)=>(g.set(w.URI.revive(f[0]),this.x(f[1])),g),new A.$zc);return new r(i,a,u,k,new D,S,$,new D,new A.$zc)}static x(o){return new D(o.contents,o.keys,o.overrides)}}e.$zn=r;function c(...n){if(n.length===0)return{keys:[],overrides:[]};if(n.length===1)return n[0];const o=new Set,i=new Map;for(const u of n)u.keys.forEach(k=>o.add(k)),u.overrides.forEach(([k,S])=>{const $=(0,A.$wc)(i,k,new Set);S.forEach(g=>$.add(g))});const a=[];return i.forEach((u,k)=>a.push([k,[...u.values()]])),{keys:[...o.values()],overrides:a}}e.$An=c;class m{constructor(o,i,a,u){this.change=o,this.f=i,this.g=a,this.h=u,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const k of o.keys)this.affectedKeys.add(k);for(const[,k]of o.overrides)for(const S of k)this.affectedKeys.add(S);this.d=this.a;for(const k of this.affectedKeys)this.d+=k+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=r.parse(this.f.data)),this.i}affectsConfiguration(o,i){const a=this.a+o,u=this.d.indexOf(a);if(u<0)return!1;const k=u+a.length;if(k>=this.d.length)return!1;const S=this.d.charCodeAt(k);if(S!==this.b&&S!==this.c)return!1;if(i){const $=this.previousConfiguration?this.previousConfiguration.getValue(o,i,this.f?.workspace):void 0,g=this.g.getValue(o,i,this.h);return!b.$6m($,g)}return!0}}e.$Bn=m;function h(n,o){const{added:i,removed:a,updated:u}=t(o?.rawConfiguration,n?.rawConfiguration),k=[],S=n?.getAllOverrideIdentifiers()||[],$=o?.getAllOverrideIdentifiers()||[];if(o){const g=$.filter(f=>!S.includes(f));for(const f of g)k.push([f,o.getKeysForOverrideIdentifier(f)])}if(n){const g=S.filter(f=>!$.includes(f));for(const f of g)k.push([f,n.getKeysForOverrideIdentifier(f)])}if(o&&n){for(const g of S)if($.includes(g)){const f=t({contents:n.getOverrideValue(void 0,g)||{},keys:n.getKeysForOverrideIdentifier(g)},{contents:o.getOverrideValue(void 0,g)||{},keys:o.getKeysForOverrideIdentifier(g)});k.push([g,[...f.added,...f.removed,...f.updated]])}}return{added:i,removed:a,updated:u,overrides:k}}function t(n,o){const i=n?o?n.keys.filter(k=>o.keys.indexOf(k)===-1):[...n.keys]:[],a=o?n?o.keys.filter(k=>n.keys.indexOf(k)===-1):[...o.keys]:[],u=[];if(n&&o){for(const k of o.keys)if(n.keys.indexOf(k)!==-1){const S=(0,R.$pi)(o.contents,k),$=(0,R.$pi)(n.contents,k);b.$6m(S,$)||u.push(k)}}return{added:i,removed:a,updated:u}}}),define(De[246],Ce([1,0,22,4,3,81]),function(me,e,C,T,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vkb=e.$ukb=e.$tkb=e.$skb=void 0;const A=(w,R,I)=>{const p=new Uint8Array(16);for(let v=0;v<16;v++)p[v]=Math.round(Math.random()*256);const y=(0,C.$ue)(C.$ae.wrap(p));return[`GET ws://localhost${w}?${R}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${y}`].join(`\r
`)+`\r
\r
`};e.$skb=A,e.$tkb=C.$ae.fromString(`\r
\r
`);async function b(w,R,I,p,y){w.write(C.$ae.fromString((0,e.$skb)(R,I,p)));const D=new d.$Qc;try{return await new Promise((v,l)=>{let s;D.add(w.onData(r=>{s?s=C.$ae.concat([s,r],s.byteLength+r.byteLength):s=r;const c=s.indexOf(e.$tkb);if(c===-1)return;v(w),w.pauseData();const m=s.slice(c+e.$tkb.byteLength);m.byteLength&&y.onData.fire(m)})),D.add(w.onClose(r=>l(r??new Error("socket closed")))),D.add(w.onEnd(()=>l(new Error("socket ended"))))})}catch(v){throw w.dispose(),v}finally{D.dispose()}}e.$ukb=b;class E extends d.$Rc{constructor(R,I){super(),this.g=R,this.a=this.B(new T.$Pd),this.onData=(...p)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...p)),this.b=this.B(new T.$Md),this.onDidDispose=this.b.event,this.f=!1,this.B(I.onData),this.B(I.onData.event(p=>this.a.fire(p))),this.onClose=this.B(I.onClose).event,this.onEnd=this.B(I.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(R,I){M.SocketDiagnostics.traceSocketEvent(this,this.g,R,I)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$vkb=E}),define(De[64],Ce([1,0,8,5]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qk=e.$Pk=e.RemoteAuthorityResolverErrorCode=e.$Ok=e.$Nk=e.RemoteConnectionType=e.$Mk=void 0,e.$Mk=(0,T.$Nh)("remoteAuthorityResolverService");var d;(function(R){R[R.WebSocket=0]="WebSocket",R[R.Managed=1]="Managed"})(d||(e.RemoteConnectionType=d={}));class M{constructor(I){this.id=I,this.type=1}toString(){return`Managed(${this.id})`}}e.$Nk=M;class A{constructor(I,p){this.host=I,this.port=p,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Ok=A;var b;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound",R.InvalidAuthority="InvalidAuthority"})(b||(e.RemoteAuthorityResolverErrorCode=b={}));class E extends C.$ab{static isNotAvailable(I){return I instanceof E&&I._code===b.NotAvailable}static isTemporarilyNotAvailable(I){return I instanceof E&&I._code===b.TemporarilyNotAvailable}static isNoResolverFound(I){return I instanceof E&&I._code===b.NoResolverFound}static isInvalidAuthority(I){return I instanceof E&&I._code===b.InvalidAuthority}static isHandled(I){return I instanceof E&&I.isHandled}constructor(I,p=b.Unknown,y){super(I),this._message=I,this._code=p,this._detail=y,this.isHandled=p===b.NotAvailable&&y===!0,Object.setPrototypeOf(this,E.prototype)}}e.$Pk=E;function w(R){const I=R.indexOf("+");return I===-1?R:R.substring(0,I)}e.$Qk=w}),define(De[65],Ce([1,0,17]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vk=e.$Uk=e.$Tk=e.$Sk=e.$Rk=void 0;function T(w){return w.scheme===C.Schemas.vscodeRemote?w.authority:void 0}e.$Rk=T;function d(w){if(!w)return;const R=w.indexOf("+");return R<0?w:w.substr(0,R)}e.$Sk=d;function M(w){return`/${w.quality??"oss"}-${w.commit??"dev"}`}e.$Tk=M;function A(w){const{host:R,port:I}=E(w);if(typeof I>"u")throw new Error("Remote authority doesn't contain a port!");return{host:R,port:I}}e.$Uk=A;function b(w,R){let{host:I,port:p}=E(w);return typeof p>"u"&&(p=R),{host:I,port:p}}e.$Vk=b;function E(w){const R=w.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(R)return{host:R[1],port:parseInt(R[2],10)};const I=w.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const p=w.match(/(.*):(\d+)$/);return p?{host:p[1],port:parseInt(p[2],10)}:{host:w,port:void 0}}}),define(De[25],Ce([1,0,15,5,65]),function(me,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=e.TargetPlatform=e.ExtensionType=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.$Vl=void 0,e.$Vl="extensions.user.cache",e.$Wl="extensions.builtin.cache",e.$Xl="undefined_publisher",e.$Yl=["ui","workspace","web"];function M(v){if(typeof v=="object"&&v!==null&&v.supported!==!0)return v.description}e.$Zl=M,e.$1l=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(v){v[v.System=0]="System",v[v.User=1]="User"})(A||(e.ExtensionType=A={}));var b;(function(v){v.WIN32_X64="win32-x64",v.WIN32_IA32="win32-ia32",v.WIN32_ARM64="win32-arm64",v.LINUX_X64="linux-x64",v.LINUX_ARM64="linux-arm64",v.LINUX_ARMHF="linux-armhf",v.ALPINE_X64="alpine-x64",v.ALPINE_ARM64="alpine-arm64",v.DARWIN_X64="darwin-x64",v.DARWIN_ARM64="darwin-arm64",v.WEB="web",v.UNIVERSAL="universal",v.UNKNOWN="unknown",v.UNDEFINED="undefined"})(b||(e.TargetPlatform=b={}));class E{constructor(l){this.value=l,this._lower=l.toLowerCase()}static equals(l,s){if(typeof l>"u"||l===null)return typeof s>"u"||s===null;if(typeof s>"u"||s===null)return!1;if(typeof l=="string"||typeof s=="string"){const r=typeof l=="string"?l:l.value,c=typeof s=="string"?s:s.value;return C.$1e(r,c)}return l._lower===s._lower}static toKey(l){return typeof l=="string"?l.toLowerCase():l._lower}}e.$2l=E;class w{get size(){return this.c.size}constructor(l){if(this.c=new Set,l)for(const s of l)this.add(s)}add(l){this.c.add(E.toKey(l))}delete(l){return this.c.delete(E.toKey(l))}has(l){return this.c.has(E.toKey(l))}}e.$3l=w;class R{constructor(){this.c=new Map}clear(){this.c.clear()}delete(l){this.c.delete(E.toKey(l))}get(l){return this.c.get(E.toKey(l))}has(l){return this.c.has(E.toKey(l))}set(l,s){this.c.set(E.toKey(l),s)}values(){return this.c.values()}forEach(l){this.c.forEach(l)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$4l=R;function I(v){return p(v)}e.$5l=I;function p(v){return v.contributes&&v.contributes.localizations?v.contributes.localizations.length>0:!1}e.$6l=p;function y(v){return v.contributes&&v.contributes.authentication?v.contributes.authentication.length>0:!1}e.$7l=y;function D(v,l){if(l){const s=`onResolveRemoteAuthority:${(0,d.$Sk)(l)}`;return!!v.activationEvents?.includes(s)}return!1}e.$8l=D,e.$9l=(0,T.$Nh)("IBuiltinExtensionsScannerService")}),define(De[137],Ce([1,0,8,25]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QE=e.$PE=void 0;class d{constructor(){this.a=new Map,this.b=new WeakMap}register(A,b){this.a.set(A,b)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const b=Object.create(null);for(const E of A){const w=this.readActivationEvents(E);w.length>0&&(b[T.$2l.toKey(E.identifier)]=w)}return b}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const b=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];if(!A.contributes)return b;for(const E in A.contributes){const w=this.a.get(E);if(!w)continue;const R=A.contributes[E],I=Array.isArray(R)?R:[R];try{w(I,b)}catch(p){(0,C.$Z)(p)}}return b}}e.$PE=d,e.$QE=new d}),define(De[247],Ce([1,0,9,22,21,8,4,3,54,37,31,81,64,65]),function(me,e,C,T,d,M,A,b,E,w,R,I,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$k=e.$0k=e.$9k=e.$8k=e.$7k=e.$6k=e.$5k=e.$4k=e.PersistentConnectionEventType=e.$3k=e.$2k=e.$1k=e.ConnectionType=void 0;const D=30*1e3;var v;(function(J){J[J.Management=1]="Management",J[J.ExtensionHost=2]="ExtensionHost",J[J.Tunnel=3]="Tunnel"})(v||(e.ConnectionType=v={}));function l(J){switch(J){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function s(J){const U=new d.$Wd;return setTimeout(()=>U.cancel(),J),U.token}function r(J,U){if(J.isCancellationRequested||U.isCancellationRequested)return d.CancellationToken.Cancelled;const V=new d.$Wd;return J.onCancellationRequested(()=>V.cancel()),U.onCancellationRequested(()=>V.cancel()),V.token}class c{get didTimeout(){return this.c==="timedout"}constructor(U){this.c="pending",this.d=new b.$Qc,this.promise=new Promise((V,ge)=>{this.f=V,this.g=ge}),U.isCancellationRequested?this.h():this.d.add(U.onCancellationRequested(()=>this.h()))}registerDisposable(U){this.c==="pending"?this.d.add(U):U.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const U=new Error("Time limit reached");return U.code="ETIMEDOUT",U.syscall="connect",U}resolve(U){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(U))}reject(U){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(U))}}function m(J,U){const V=new c(U);return V.registerDisposable(J.onControlMessage(ge=>{const _=JSON.parse(ge.toString()),ie=Z(_);ie?V.reject(ie):V.resolve(_)})),V.promise}function h(J,U,V,ge,_,ie,re,Ee){const oe=new c(Ee),he=w.$Id.create(!1);return J.info(`Creating a socket (${re})...`),E.mark(`code/willCreateSocket/${ie}`),U.connect(V,ge,_,re).then(ee=>{oe.didTimeout?(E.mark(`code/didCreateSocketError/${ie}`),J.info(`Creating a socket (${re}) finished after ${he.elapsed()} ms, but this is too late and has timed out already.`),ee?.dispose()):(E.mark(`code/didCreateSocketOK/${ie}`),J.info(`Creating a socket (${re}) was successful after ${he.elapsed()} ms.`),oe.resolve(ee))},ee=>{E.mark(`code/didCreateSocketError/${ie}`),J.info(`Creating a socket (${re}) returned an error after ${he.elapsed()} ms.`),J.error(ee),oe.reject(ee)}),oe.promise}function t(J,U){const V=new c(U);return J.then(ge=>{V.didTimeout||V.resolve(ge)},ge=>{V.didTimeout||V.reject(ge)}),V.promise}async function n(J,U,V,ge){const _=ue(J,U);J.logService.trace(`${_} 1/6. invoking socketFactory.connect().`);let ie;try{ie=await h(J.logService,J.remoteSocketFactoryService,J.connectTo,(0,y.$Tk)(J),`reconnectionToken=${J.reconnectionToken}&reconnection=${J.reconnectionProtocol?"true":"false"}`,l(U),`renderer-${l(U)}-${J.reconnectionToken}`,ge)}catch(ee){throw J.logService.error(`${_} socketFactory.connect() failed or timed out. Error:`),J.logService.error(ee),ee}J.logService.trace(`${_} 2/6. socketFactory.connect() was successful.`);let re,Ee;J.reconnectionProtocol?(J.reconnectionProtocol.beginAcceptReconnection(ie,null),re=J.reconnectionProtocol,Ee=!1):(re=new I.$Bh({socket:ie}),Ee=!0),J.logService.trace(`${_} 3/6. sending AuthRequest control message.`);const oe=await t(J.signService.createNewMessage((0,R.$dg)()),ge),he={type:"auth",auth:J.connectionToken||"00000000000000000000",data:oe.data};re.sendControl(T.$ae.fromString(JSON.stringify(he)));try{const ee=await m(re,r(ge,s(1e4)));if(ee.type!=="sign"||typeof ee.data!="string"){const B=new Error("Unexpected handshake message");throw B.code="VSCODE_CONNECTION_ERROR",B}if(J.logService.trace(`${_} 4/6. received SignRequest control message.`),!await t(J.signService.validate(oe,ee.signedData),ge)){const B=new Error("Refused to connect to unsupported server");throw B.code="VSCODE_CONNECTION_ERROR",B}const $e=await t(J.signService.sign(ee.data),ge),Pe={type:"connectionType",commit:J.commit,signedData:$e,desiredConnectionType:U};return V&&(Pe.args=V),J.logService.trace(`${_} 5/6. sending ConnectionTypeRequest control message.`),re.sendControl(T.$ae.fromString(JSON.stringify(Pe))),{protocol:re,ownsProtocol:Ee}}catch(ee){throw ee&&ee.code==="ETIMEDOUT"&&(J.logService.error(`${_} the handshake timed out. Error:`),J.logService.error(ee)),ee&&ee.code==="VSCODE_CONNECTION_ERROR"&&(J.logService.error(`${_} received error control message when negotiating connection. Error:`),J.logService.error(ee)),Ee&&x(re),ee}}async function o(J,U,V,ge){const _=Date.now(),ie=ue(J,U),{protocol:re,ownsProtocol:Ee}=await n(J,U,V,ge),oe=new c(ge);return oe.registerDisposable(re.onControlMessage(he=>{const ee=JSON.parse(he.toString()),le=Z(ee);le?(J.logService.error(`${ie} received error control message when negotiating connection. Error:`),J.logService.error(le),Ee&&x(re),oe.reject(le)):(J.reconnectionProtocol?.endAcceptReconnection(),J.logService.trace(`${ie} 6/6. handshake finished, connection is up and running after ${ve(_)}!`),oe.resolve({protocol:re,firstMessage:ee}))})),oe.promise}async function i(J,U){const{protocol:V}=await o(J,1,void 0,U);return{protocol:V}}async function a(J,U,V){const{protocol:ge,firstMessage:_}=await o(J,2,U,V),ie=_&&_.debugPort;return{protocol:ge,debugPort:ie}}async function u(J,U,V){const ge=Date.now(),_=ue(J,3),{protocol:ie}=await n(J,3,U,V);return J.logService.trace(`${_} 6/6. handshake finished, connection is up and running after ${ve(ge)}!`),ie}async function k(J,U,V){const{connectTo:ge,connectionToken:_}=await J.addressProvider.getAddress();return{commit:J.commit,quality:J.quality,connectTo:ge,connectionToken:_,reconnectionToken:U,reconnectionProtocol:V,remoteSocketFactoryService:J.remoteSocketFactoryService,signService:J.signService,logService:J.logService}}async function S(J,U,V){return g(J,async ge=>{const{protocol:_}=await i(ge,d.CancellationToken.None);return new K(J,U,V,ge.reconnectionToken,_)})}e.$1k=S;async function $(J,U){return g(J,async V=>{const{protocol:ge,debugPort:_}=await a(V,U,d.CancellationToken.None);return new fe(J,U,V.reconnectionToken,ge,_)})}e.$2k=$;async function g(J,U){for(let ge=1;;ge++)try{const _=(0,R.$dg)(),ie=await k(J,_,null);return await U(ie)}catch(_){if(ge<5)J.logService.error(`[remote-connection][attempt ${ge}] An error occurred in initial connection! Will retry... Error:`),J.logService.error(_);else throw J.logService.error(`[remote-connection][attempt ${ge}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),J.logService.error(_),H.triggerPermanentFailure(0,0,p.$Pk.isHandled(_)),_}}async function f(J,U,V){const ge=await k(J,(0,R.$dg)(),null);return await u(ge,{host:U,port:V},d.CancellationToken.None)}e.$3k=f;function P(J){return(0,C.$Gg)(U=>new Promise((V,ge)=>{const _=setTimeout(V,J*1e3);U.onCancellationRequested(()=>{clearTimeout(_),V()})}))}var N;(function(J){J[J.ConnectionLost=0]="ConnectionLost",J[J.ReconnectionWait=1]="ReconnectionWait",J[J.ReconnectionRunning=2]="ReconnectionRunning",J[J.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",J[J.ConnectionGain=4]="ConnectionGain"})(N||(e.PersistentConnectionEventType=N={}));class O{constructor(U,V){this.reconnectionToken=U,this.millisSinceLastIncomingData=V,this.type=0}}e.$4k=O;class L{constructor(U,V,ge,_){this.reconnectionToken=U,this.millisSinceLastIncomingData=V,this.durationSeconds=ge,this.c=_,this.type=1}skipWait(){this.c.cancel()}}e.$5k=L;class j{constructor(U,V,ge){this.reconnectionToken=U,this.millisSinceLastIncomingData=V,this.attempt=ge,this.type=2}}e.$6k=j;class z{constructor(U,V,ge){this.reconnectionToken=U,this.millisSinceLastIncomingData=V,this.attempt=ge,this.type=4}}e.$7k=z;class F{constructor(U,V,ge,_){this.reconnectionToken=U,this.millisSinceLastIncomingData=V,this.attempt=ge,this.handled=_,this.type=3}}e.$8k=F;class H extends b.$Rc{static triggerPermanentFailure(U,V,ge){this._permanentFailure=!0,this.f=U,this.g=V,this.h=ge,this.j.forEach(_=>_.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(U=>U.y())}static debugPauseSocketWriting(){this.j.forEach(U=>U.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||H._permanentFailure}constructor(U,V,ge,_,ie){super(),this.t=U,this.u=V,this.reconnectionToken=ge,this.protocol=_,this.w=ie,this.m=this.B(new A.$Md),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new z(this.reconnectionToken,0,0)),this.B(_.onSocketClose(re=>{const Ee=be(this.t,this.reconnectionToken,!0);re?re.type===0?(this.u.logService.info(`${Ee} received socket close event (hadError: ${re.hadError}).`),re.error&&this.u.logService.error(re.error)):(this.u.logService.info(`${Ee} received socket close event (wasClean: ${re.wasClean}, code: ${re.code}, reason: ${re.reason}).`),re.event&&this.u.logService.error(re.event)):this.u.logService.info(`${Ee} received socket close event.`),this.y()})),this.B(_.onSocketTimeout(re=>{const Ee=be(this.t,this.reconnectionToken,!0);this.u.logService.info(`${Ee} received socket timeout event (unacknowledgedMsgCount: ${re.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${re.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${re.timeSinceLastReceivedSomeData}).`),this.y()})),H.j.push(this),this.B((0,b.$Pc)(()=>{const re=H.j.indexOf(this);re>=0&&H.j.splice(re,1)})),this.n&&this.D(H.f,H.g,H.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const U=be(this.t,this.reconnectionToken,!0);this.u.logService.info(`${U} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const V=[0,5,5,10,10,10,10,10,30];let ge=-1;do{ge++;const _=ge<V.length?V[ge]:V[V.length-1];try{if(_>0){const re=P(_);this.m.fire(new L(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),_,re)),this.u.logService.info(`${U} waiting for ${_} seconds before reconnecting...`);try{await re}catch{}}if(this.n){this.u.logService.error(`${U} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ge+1)),this.u.logService.info(`${U} resolving connection...`);const ie=await k(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${U} connecting to ${ie.connectTo}...`),await this.G(ie,s(D)),this.u.logService.info(`${U} reconnected!`),this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ge+1));break}catch(ie){if(ie.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${U} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(ie),this.C(this.protocol.getMillisSinceLastIncomingData(),ge+1,!1);break}if(ge>360){this.u.logService.error(`${U} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(ie),this.C(this.protocol.getMillisSinceLastIncomingData(),ge+1,!1);break}if(p.$Pk.isTemporarilyNotAvailable(ie)){this.u.logService.info(`${U} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ie);continue}if((ie.code==="ETIMEDOUT"||ie.code==="ENETUNREACH"||ie.code==="ECONNREFUSED"||ie.code==="ECONNRESET")&&ie.syscall==="connect"){this.u.logService.info(`${U} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ie);continue}if((0,M.$3)(ie)){this.u.logService.info(`${U} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ie);continue}if(ie instanceof p.$Pk){this.u.logService.error(`${U} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(ie),this.C(this.protocol.getMillisSinceLastIncomingData(),ge+1,p.$Pk.isHandled(ie));break}this.u.logService.error(`${U} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(ie),this.C(this.protocol.getMillisSinceLastIncomingData(),ge+1,!1);break}}while(!this.n&&!this.s)}C(U,V,ge){this.w?H.triggerPermanentFailure(U,V,ge):this.D(U,V,ge)}D(U,V,ge){this.m.fire(new F(this.reconnectionToken,U,V,ge)),x(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$9k=H;class K extends H{constructor(U,V,ge,_,ie){super(1,U,_,ie,!0),this.client=this.B(new I.$zh(ie,{remoteAuthority:V,clientId:ge},U.ipcLogger))}async G(U,V){await i(U,V)}}e.$0k=K;class fe extends H{constructor(U,V,ge,_,ie){super(2,U,ge,_,!1),this.H=V,this.debugPort=ie}async G(U,V){await a(U,this.H,V)}}e.$$k=fe;function x(J){try{J.acceptDisconnect();const U=J.getSocket();J.dispose(),U.dispose()}catch(U){(0,M.$Z)(U)}}function Z(J){if(J&&J.type==="error"){const U=new Error(`Connection error: ${J.reason}`);return U.code="VSCODE_CONNECTION_ERROR",U}return null}function q(J,U){for(;J.length<U;)J+=" ";return J}function Y(J,U){return`[remote-connection][${q(l(J),13)}][${U.substr(0,5)}\u2026]`}function be(J,U,V){return`${Y(J,U)}[${V?"reconnect":"initial"}]`}function ue(J,U){return`${be(U,J.reconnectionToken,!!J.reconnectionProtocol)}[${J.connectTo}]`}function ve(J){return`${Date.now()-J} ms`}}),define(De[248],Ce([1,0,3,5]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xk=e.$Wk=void 0,e.$Wk=(0,T.$Nh)("remoteSocketFactoryService");class d{constructor(){this.a={}}register(A,b){return this.a[A]??=[],this.a[A].push(b),(0,C.$Pc)(()=>{const E=this.a[A]?.indexOf(b);typeof E=="number"&&E>=0&&this.a[A]?.splice(E,1)})}b(A){return(this.a[A.type]||[]).find(E=>E.supports(A))}connect(A,b,E,w){const R=this.b(A);if(!R)throw new Error(`No socket factory found for ${A}`);return R.connect(A,b,E,w)}}e.$Xk=d}),define(De[249],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$2b=void 0;class C{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(d){try{const M=await this.c();if(M){const A=String(C.a++);return this.b.set(A,M),{id:A,data:M.createNewMessage(d)}}}catch{}return{id:"",data:d}}async validate(d,M){if(!d.id)return!0;const A=this.b.get(d.id);if(!A)return!1;this.b.delete(d.id);try{return A.validate(M)==="ok"}catch{return!1}finally{A.dispose?.()}}async sign(d){try{return await this.d(d)}catch{}return d}}e.$$2b=C}),define(De[106],Ce([1,0,5]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zk=e.$Yk=void 0,e.$Yk="signService",e.$Zk=(0,C.$Nh)(e.$Yk)}),define(De[138],Ce([1,0,249]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y7b=void 0;class T extends C.$$2b{c(){return this.h().then(M=>new M.validator)}d(M){return this.h().then(A=>new A.signer().sign(M))}h(){return new Promise((M,A)=>me(["vsda"],M,A))}}e.$Y7b=T}),define(De[250],Ce([1,0,12,47,31]),function(me,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eo=e.$do=void 0;function M(E){if(C.$u===2&&/^penguin(\.|$)/i.test(E))return"chromebook"}function A(E,w,R,I,p,y,D,v){const l=Object.create(null);l["common.machineId"]=y,l.sessionID=(0,d.$dg)()+Date.now(),l.commitHash=I,l.version=p,l["common.platformVersion"]=(E||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),l["common.platform"]=(0,C.$i)(C.$u),l["common.nodePlatform"]=T.$cc,l["common.nodeArch"]=R,l["common.product"]=v||"desktop",D&&(l["common.msftInternal"]=D);let s=0;const r=Date.now();Object.defineProperties(l,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-r,enumerable:!0},"common.sequence":{get:()=>s++,enumerable:!0}}),C.$m&&(l["common.snap"]="true");const c=M(w);return c&&(l["common.platformDetail"]=c),l}e.$do=A;function b(E){const w=T.env.USERDNSDOMAIN;if(!w)return!1;const R=w.toLowerCase();return E.some(I=>R===I)}e.$eo=b}),define(De[251],Ce([1,0,5]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$il=e.$hl=e.$gl=e.$fl=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.$_k=void 0,e.$_k=(0,C.$Nh)("telemetryService"),e.$al=(0,C.$Nh)("customEndpointTelemetryService"),e.$bl="telemetry.currentSessionDate",e.$cl="telemetry.firstSessionDate",e.$dl="telemetry.lastSessionDate",e.$el="telemetry.machineId",e.$fl="telemetry",e.$gl="telemetry.telemetryLevel",e.$hl="telemetry.enableCrashReporter",e.$il="telemetry.enableTelemetry";var T;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(T||(e.TelemetryLevel=T={}));var d;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(d||(e.TelemetryConfiguration=d={}))}),define(De[85],Ce([1,0,23,18,4,49,65,250,251]),function(me,e,C,T,d,M,A,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=void 0;class w{constructor(a){this.value=a,this.isTrustedTelemetryValue=!0}}e.$fo=w;class R{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$go=R,e.$ho=new R;class I{async publicLog(a,u,k){}async publicLogError(a,u,k){}}e.$io=I,e.$jo="telemetry",e.$ko="extensionTelemetryLog",e.$lo={log:()=>null,flush:()=>Promise.resolve(null)};function p(i,a){return d.Event.debounce(a.onDidChangeConfiguration,(k,S)=>{const $=k?new Set([...k.affectedKeys,...S.affectedKeys]):S.affectedKeys;return{...S,affectedKeys:$}},1e3,!0)(k=>{k.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,M.$ki)(k.source),configurationKeys:Array.from(k.affectedKeys)})})}e.$mo=p;function y(i,a){return!a.isBuilt&&!a.disableTelemetry?!0:!(a.disableTelemetry||!i.enableTelemetry)}e.$no=y;function D(i,a){return a.extensionTestsLocationURI?!0:!(a.isBuilt||a.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.$oo=D;function v(i){const a=i.getValue(E.$gl),u=i.getValue(E.$hl);if(i.getValue(E.$il)===!1||u===!1)return 0;switch(a??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$po=v;function l(i){const a={},u={},k={};c(i,k);for(let S in k){S=S.length>150?S.substr(S.length-149):S;const $=k[S];typeof $=="number"?u[S]=$:typeof $=="boolean"?u[S]=$?1:0:typeof $=="string"?($.length>8192&&console.warn(`Telemetry property: ${S} has been trimmed to 8192, the original length is ${$.length}`),a[S]=$.substring(0,8191)):typeof $<"u"&&$!==null&&(a[S]=$)}return{properties:a,measurements:u}}e.$qo=l;const s=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function r(i){if(!i)return"none";const a=(0,A.$Sk)(i);return s.has(a)?a:"other"}e.$ro=r;function c(i,a,u=0,k){if(i)for(const S of Object.getOwnPropertyNames(i)){const $=i[S],g=k?k+S:S;Array.isArray($)?a[g]=(0,C.$7m)($):$ instanceof Date?a[g]=$.toISOString():(0,T.$zf)($)?u<2?c($,a,u+1,g+"."):a[g]=(0,C.$7m)($):a[g]=$}}function m(i,a){const u=i.msftInternalDomains||[],k=a.getValue("telemetry.internalTesting");return(0,b.$eo)(u)||k}e.$so=m;function h(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.$to=h;function t(i,a){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let u=i;const k=[];for(const f of a)for(;;){const P=f.exec(i);if(!P)break;k.push([P.index,f.lastIndex])}const S=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,$=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let g=0;for(u="";;){const f=$.exec(i);if(!f)break;const P=k.some(([N,O])=>f.index<O&&N<$.lastIndex);!S.test(f[0])&&!P&&(u+=i.substring(g,f.index)+"<REDACTED: user-file-path>",g=$.lastIndex)}return g<i.length&&(u+=i.substr(g)),u}function n(i){if(!i)return i;const a=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const u of a)if(u.regex.test(i))return`<REDACTED: ${u.label}>`;return i}function o(i,a){return(0,C.$4m)(i,u=>{if(u instanceof w||Object.hasOwnProperty.call(u,"isTrustedTelemetryValue"))return u.value;if(typeof u=="string"){let k=u.replaceAll("%20"," ");k=t(k,a);for(const S of a)k=k.replace(S,"");return k=n(k),k}})}e.$uo=o}),define(De[252],Ce([1,0,15,132,25,12,2,8,47,85]),function(me,e,C,T,d,M,A,b,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=void 0;function R(o,i){return o.uuid&&i.uuid?o.uuid===i.uuid:o.id===i.id?!0:(0,C.$Ve)(o.id,i.id)===0}e.$vo=R;const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class p{static create(i){const a=i.manifest?i.manifest.version:i.version,u=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new p(i.identifier,a,u)}static parse(i){const a=I.exec(i);return a&&a[1]&&a[2]?new p({id:a[1]},a[2],a[4]||void 0):null}constructor(i,a,u="undefined"){this.version=a,this.targetPlatform=u,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof p?R(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$wo=p;const y=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function D(o){const i=y.exec(o);return i&&i[1]?[l(i[1]),i[2]]:[l(o),void 0]}e.$xo=D;function v(o,i){return`${o}.${i}`}e.$yo=v;function l(o){return o.toLowerCase()}e.$zo=l;function s(o,i){return l(v(o??d.$Xl,i))}e.$Ao=s;function r(o,i){const a=[],u=k=>{for(const S of a)if(S.some($=>R(i($),i(k))))return S;return null};for(const k of o){const S=u(k);S?S.push(k):a.push([k])}return a}e.$Bo=r;function c(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}e.$Co=c;function m(o){return{id:new w.$fo(o.identifier.id),name:new w.$fo(o.name),galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,isPreReleaseVersion:o.properties.isPreReleaseVersion,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),isSigned:o.isSigned,...o.telemetryData}}e.$Do=m,e.$Eo=new d.$2l("pprice.better-merge");function h(o,i){const a=[],u=i.manifest.extensionDependencies?.slice(0)??[];for(;u.length;){const k=u.shift();if(k&&a.every(S=>!R(S.identifier,{id:k}))){const S=o.filter($=>R($.identifier,{id:k}));S.length===1&&(a.push(S[0]),u.push(...S[0].manifest.extensionDependencies?.slice(0)??[]))}}return a}e.$Fo=h;async function t(o,i){if(!M.$l)return!1;let a;try{a=(await o.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{a=(await o.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(k){i.debug("Error while getting the os-release file.",(0,b.$9)(k))}}return!!a&&(a.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function n(o,i){const a=await t(o,i),u=(0,T.$1n)(a?"alpine":M.$u,E.$dc);return i.debug("ComputeTargetPlatform:",u),u}e.$Go=n}),define(De[253],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lr=e.$kr=e.$jr=e.$ir=e.$hr=e.$gr=void 0;function C(E){return[...E.entries()]}e.$gr=C;function T(E){return E?[...E.entries()]:[]}e.$hr=T;function d(E){return new Map(E)}e.$ir=d;function M(E){return new Map(E??[])}e.$jr=M;function A(E){return Array.from(E.entries()).map(w=>[w[0],C(w[1].map),T(w[1].descriptionMap)])}e.$kr=A;function b(E){return new Map(E.map(w=>[w[0],{map:d(w[1]),descriptionMap:M(w[2])}]))}e.$lr=b}),define(De[254],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lkb=void 0;class C{constructor(d){this.b=d,this.a=new Map}dispose(){for(const d of this.a.values())d.dispose()}startBuffering(d,M,A=5){const b=M(E=>{const w=typeof E=="string"?E:E.data;let R=this.a.get(d);if(R){R.data.push(w);return}const I=setTimeout(()=>this.flushBuffer(d),A);R={data:[w],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(d),b.dispose()}},this.a.set(d,R)});return b}stopBuffering(d){this.a.get(d)?.dispose()}flushBuffer(d){const M=this.a.get(d);M&&(this.a.delete(d),this.b(d,M.data.join("")))}}e.$Lkb=C}),define(De[255],Ce([1,0,9,78,59,4,18,2,199,105,42]),function(me,e,C,T,d,M,A,b,E,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7v=e.$6v=e.$5v=e.$4v=e.$3v=e.$2v=e.$1v=e.$Zv=e.IconFontDefinition=e.IconContribution=e.$Yv=void 0,e.$Yv={IconContribution:"base.contributions.icons"};var I;(function(m){function h(t,n){let o=t.defaults;for(;d.ThemeIcon.isThemeIcon(o);){const i=D.getIcon(o.id);if(!i)return;o=i.defaults}return o}m.getDefinition=h})(I||(e.IconContribution=I={}));var p;(function(m){function h(n){return{weight:n.weight,style:n.style,src:n.src.map(o=>({format:o.format,location:o.location.toString()}))}}m.toJSONObject=h;function t(n){const o=i=>(0,A.$xf)(i)?i:void 0;if(n&&Array.isArray(n.src)&&n.src.every(i=>(0,A.$xf)(i.format)&&(0,A.$xf)(i.location)))return{weight:o(n.weight),style:o(n.style),src:n.src.map(i=>({format:i.format,location:b.URI.parse(i.location)}))}}m.fromJSONObject=t})(p||(e.IconFontDefinition=p={}));class y{constructor(){this.a=new M.$Md,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,E.localize)(0,null)},fontCharacter:{type:"string",description:(0,E.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${d.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(h,t,n,o){const i=this.b[h];if(i){if(n&&!i.description){i.description=n,this.d.properties[h].markdownDescription=`${n} $(${h})`;const k=this.e.enum.indexOf(h);k!==-1&&(this.e.enumDescriptions[k]=n),this.a.fire()}return i}const a={id:h,description:n,defaults:t,deprecationMessage:o};this.b[h]=a;const u={$ref:"#/definitions/icons"};return o&&(u.deprecationMessage=o),n&&(u.markdownDescription=`${n}: $(${h})`),this.d.properties[h]=u,this.e.enum.push(h),this.e.enumDescriptions.push(n||""),this.a.fire(),{id:h}}deregisterIcon(h){delete this.b[h],delete this.d.properties[h];const t=this.e.enum.indexOf(h);t!==-1&&(this.e.enum.splice(t,1),this.e.enumDescriptions.splice(t,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(h=>this.b[h])}getIcon(h){return this.b[h]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(h,t){const n=this.f[h];return n||(this.f[h]=t,this.a.fire(),t)}deregisterIconFont(h){delete this.f[h]}getIconFont(h){return this.f[h]}toString(){const h=(i,a)=>i.id.localeCompare(a.id),t=i=>{for(;d.ThemeIcon.isThemeIcon(i.defaults);)i=this.b[i.defaults.id];return`codicon codicon-${i?i.id:""}`},n=[];n.push("| preview     | identifier                        | default codicon ID                | description"),n.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const o=Object.keys(this.b).map(i=>this.b[i]);for(const i of o.filter(a=>!!a.description).sort(h))n.push(`|<i class="${t(i)}"></i>|${i.id}|${d.ThemeIcon.isThemeIcon(i.defaults)?i.defaults.id:i.id}|${i.description||""}|`);n.push("| preview     | identifier                        "),n.push("| ----------- | --------------------------------- |");for(const i of o.filter(a=>!d.ThemeIcon.isThemeIcon(a.defaults)).sort(h))n.push(`|<i class="${t(i)}"></i>|${i.id}|`);return n.join(`
`)}}const D=new y;R.$bn.add(e.$Yv.IconContribution,D);function v(m,h,t,n){return D.registerIcon(m,h,t,n)}e.$Zv=v;function l(){return D}e.$1v=l;function s(){const m=(0,T.$Qj)();for(const h in m){const t="\\"+m[h].toString(16);D.registerIcon(h,{fontCharacter:t})}}s(),e.$2v="vscode://schemas/icons";const r=R.$bn.as(w.$cn.JSONContribution);r.registerSchema(e.$2v,D.getIconSchema());const c=new C.$5g(()=>r.notifySchemaChanged(e.$2v),200);D.onDidChange(()=>{c.isScheduled()||c.schedule()}),e.$3v=v("widget-close",T.$Sj.close,(0,E.localize)(2,null)),e.$4v=v("goto-previous-location",T.$Sj.arrowUp,(0,E.localize)(3,null)),e.$5v=v("goto-next-location",T.$Sj.arrowDown,(0,E.localize)(4,null)),e.$6v=d.ThemeIcon.modify(T.$Sj.sync,"spin"),e.$7v=d.ThemeIcon.modify(T.$Sj.loading,"spin")}),define(De[86],Ce([1,0,4,49,5,13]),function(me,e,C,T,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bv=e.$av=e.$_u=e.$$u=e.$0u=e.$9u=e.$8u=e.$7u=e.ProvidedOnAutoForward=e.$6u=e.TunnelPrivacyId=e.TunnelProtocol=e.$5u=e.$4u=void 0,e.$4u=(0,d.$Nh)("tunnelService"),e.$5u=(0,d.$Nh)("sharedTunnelsService");var A;(function(l){l.Http="http",l.Https="https"})(A||(e.TunnelProtocol=A={}));var b;(function(l){l.ConstantPrivate="constantPrivate",l.Private="private",l.Public="public"})(b||(e.TunnelPrivacyId=b={}));function E(l){return!!l.forwardPort}e.$6u=E;var w;(function(l){l[l.Notify=1]="Notify",l[l.OpenBrowser=2]="OpenBrowser",l[l.OpenPreview=3]="OpenPreview",l[l.Silent=4]="Silent",l[l.Ignore=5]="Ignore",l[l.OpenBrowserOnce=6]="OpenBrowserOnce"})(w||(e.ProvidedOnAutoForward=w={}));function R(l){if(l.scheme!=="http"&&l.scheme!=="https")return;const s=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(l.authority);if(s)return{address:s[1],port:+s[2]}}e.$7u=R,e.$8u=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function I(l){return e.$8u.indexOf(l)>=0}e.$9u=I,e.$0u=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function p(l){return e.$0u.indexOf(l)>=0}e.$$u=p;function y(l,s,r,c){if(r===1)return!1;if(r===2&&p(s)){const m=/(\d+)\.(\d+)\.(\d+)/g.exec(c);if(m?.length===4&&parseInt(m[1])>=18)return!1}return l<1024}e.$_u=y;class D{constructor(s,r,c){this.remoteAddress=s,this.localAddress=r,this.b=c,this.a=new C.$Md,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$av=D;let v=class{constructor(s,r){this.j=s,this.k=r,this.a=new C.$Md,this.onTunnelOpened=this.a.event,this.b=new C.$Md,this.onTunnelClosed=this.b.event,this.c=new C.$Md,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const s=this.k.getValue("remote.localPortHost");return!s||s==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(s){return this.f=s,s?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(s){this.g=s.elevation,this.h=s.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const s=[],r=Array.from(this.e.values());for(const c of r){const m=Array.from(c.values());for(const h of m){const t=await h.value;t&&typeof t!="string"&&s.push(t)}}return s}async dispose(){for(const s of this.e.values()){for(const{value:r}of s.values())await r.then(c=>typeof c!="string"?c?.dispose():void 0);s.clear()}this.e.clear()}setEnvironmentTunnel(s,r,c,m,h){this.p(s,r,Promise.resolve({tunnelRemoteHost:s,tunnelRemotePort:r,localAddress:c,privacy:m,protocol:h,dispose:()=>Promise.resolve()}))}async getExistingTunnel(s,r){(p(s)||I(s))&&(s=e.$8u[0]);const c=this.r(s,r);if(c)return++c.refcount,c.value}openTunnel(s,r,c,m,h,t=!1,n,o){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${r}:${c} on local port ${h}.`);const i=this.f??s;if(!i)return;if(r||(r="localhost"),m||(m=this.l),this.f&&this.i.has(c)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const a=this.s(i,r,c,m,h,t,n,o);return a?a.then(u=>{if(u){if(typeof u=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(r,c),u}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(r,c);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const k=this.n(u);return(u.tunnelRemoteHost!==r||u.tunnelRemotePort!==c)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),n&&u.privacy!==n&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(k),k}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),a)}n(s){return{tunnelRemotePort:s.tunnelRemotePort,tunnelRemoteHost:s.tunnelRemoteHost,tunnelLocalPort:s.tunnelLocalPort,localAddress:s.localAddress,privacy:s.privacy,protocol:s.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${s.tunnelRemoteHost}:${s.tunnelRemotePort} `);const r=this.e.get(s.tunnelRemoteHost);if(r){const c=r.get(s.tunnelRemotePort);c&&(c.refcount--,await this.o(s.tunnelRemoteHost,s.tunnelRemotePort,c))}}}}async o(s,r,c){if(c.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${s}:${r}.`);const m=c.value.then(async h=>{h&&typeof h!="string"&&(await h.dispose(!0),this.b.fire({host:h.tunnelRemoteHost,port:h.tunnelRemotePort}))});return this.e.has(s)&&this.e.get(s).delete(r),m}}async closeTunnel(s,r){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${s}:${r} `);const c=this.e.get(s);if(c&&c.has(r)){const m=c.get(r);m.refcount=0,await this.o(s,r,m)}}p(s,r,c){this.e.has(s)||this.e.set(s,new Map),this.e.get(s).set(r,{refcount:1,value:c})}async q(s,r){const c=this.e.get(s);if(c){const m=c.get(r),h=m?await m.value:void 0;(!h||typeof h=="string")&&c.delete(r),c.size===0&&this.e.delete(s)}}r(s,r){const c=[s];I(s)?(c.push(...e.$8u),c.push(...e.$0u)):p(s)&&c.push(...e.$0u);const m=c.map(h=>this.e.get(h));for(const h of m){const t=h?.get(r);if(t)return t}}canTunnel(s){return!!R(s)}t(s,r,c,m,h,t,n){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${r}:${c} on local port ${m}.`);const o=c;this.i.add(o);const i=m===void 0?c:m,a={elevationRequired:h?this.isPortPrivileged(i):!1},u={remoteAddress:{host:r,port:c},localAddressPort:m,privacy:t,public:t?t!==b.Private:void 0,protocol:n},k=s.forwardPort(u,a);return k?(this.p(r,c,k),k.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(o)})):this.i.delete(o),k}};e.$bv=v,e.$bv=v=He([Be(0,M.$8i),Be(1,T.$hi)],v)}),define(De[256],Ce([1,0,5]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fk=void 0,e.$Fk=(0,C.$Nh)("IUriIdentityService")}),define(De[257],Ce([1,0,5]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$cv=void 0,e.$cv=(0,C.$Nh)("editSessionIdentityService");var T;(function(d){d[d.Complete=100]="Complete",d[d.Partial=50]="Partial",d[d.None=0]="None"})(T||(e.EditSessionIdentityMatch=T={}))}),define(De[258],Ce([1,0,17]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MJ=e.$LJ=e.$KJ=e.$JJ=e.$IJ=void 0;function T(E){return E.scheme!==C.Schemas.file&&E.scheme!==C.Schemas.vscodeRemote}e.$IJ=T;function d(E){if(E.folders.length)return E.folders.every(w=>T(w.uri))?E.folders[0].uri:void 0;if(E.configuration&&T(E.configuration))return E.configuration}e.$JJ=d;function M(E){return d(E)?.scheme}e.$KJ=M;function A(E){return d(E)?.authority}e.$LJ=A;function b(E){return d(E)!==void 0}e.$MJ=b}),define(De[43],Ce([1,0,201,16,77,24,2,5,17]),function(me,e,C,T,d,M,A,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=e.$6h=e.$5h=e.WorkbenchState=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=void 0,e.$Wh=(0,b.$Nh)("contextService");function w(i){const a=i;return typeof a?.id=="string"&&A.URI.isUri(a.uri)}e.$Xh=w;function R(i){return typeof i?.id=="string"&&!w(i)&&!p(i)}e.$Yh=R,e.$Zh={id:"ext-dev"},e.$1h={id:"empty-window"};function I(i,a){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,T.$mc)(i)}:a?e.$Zh:e.$1h;const u=i;return u.configuration?{id:u.id,configPath:u.configuration}:u.folders.length===1?{id:u.id,uri:u.folders[0].uri}:{id:u.id}}e.$2h=I;function p(i){const a=i;return typeof a?.id=="string"&&A.URI.isUri(a.configPath)}e.$3h=p;function y(i){const a=i;if(a?.uri)return{id:a.id,uri:A.URI.revive(a.uri)};const u=i;if(u?.configPath)return{id:u.id,configPath:A.URI.revive(u.configPath)};if(i?.id)return{id:i.id}}e.$4h=y;var D;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(D||(e.WorkbenchState=D={}));function v(i){const a=i;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&Array.isArray(a.folders))}e.$5h=v;function l(i){const a=i;return!!(a&&typeof a=="object"&&A.URI.isUri(a.uri)&&typeof a.name=="string"&&typeof a.toResource=="function")}e.$6h=l;class s{constructor(a,u,k,S,$){this.h=a,this.j=k,this.k=S,this.l=$,this.c=d.$Th.forUris(this.l,()=>!0),this.folders=u}update(a){this.h=a.id,this.k=a.configuration,this.j=a.transient,this.l=a.l,this.folders=a.folders}get folders(){return this.g}set folders(a){this.g=a,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(a){this.k=a}getFolder(a){return a&&this.c.findSubstr(a)||null}n(){this.c=d.$Th.forUris(this.l,()=>!0);for(const a of this.folders)this.c.set(a.uri,a)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$7h=s;class r{constructor(a,u){this.raw=u,this.uri=a.uri,this.index=a.index,this.name=a.name}toResource(a){return(0,M.$ug)(this.uri,a)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$8h=r;function c(i){return new r({uri:i,index:0,name:(0,M.$qg)(i)},{uri:i.toString()})}e.$9h=c,e.$0h="code-workspace",e.$$h=`.${e.$0h}`,e.$_h=[{name:(0,C.localize)(0,null),extensions:[e.$0h]}],e.$ai="workspace.json";function m(i,a){return M.$lg.isEqualOrParent(i,a.untitledWorkspacesHome)}e.$bi=m;function h(i){let a;return A.URI.isUri(i)?a=i:a=i.configuration,a?.scheme===E.Schemas.tmp}e.$ci=h,e.$di="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.$di}e.$ei=t;function n(i,a){return!m(i,a)&&!h(i)}e.$fi=n;function o(i){return(typeof i=="string"?(0,T.$nc)(i):(0,M.$sg)(i))===e.$$h}e.$gi=o}),define(De[259],Ce([1,0,52,4,3,24,2,200,131,30,5,13,43,28,256,9,31,15,18]),function(me,e,C,T,d,M,A,b,E,w,R,I,p,y,D,v,l,s,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lk=e.$Kk=e.$Jk=e.$Ik=e.$Hk=e.$Gk=e.ProfileResourceType=void 0;var c;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(c||(e.ProfileResourceType=c={}));function m(i){const a=i;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&typeof a.isDefault=="boolean"&&typeof a.name=="string"&&A.URI.isUri(a.location)&&A.URI.isUri(a.globalStorageHome)&&A.URI.isUri(a.settingsResource)&&A.URI.isUri(a.keybindingsResource)&&A.URI.isUri(a.tasksResource)&&A.URI.isUri(a.snippetsHome)&&A.URI.isUri(a.extensionsResource))}e.$Gk=m,e.$Hk=(0,R.$Nh)("IUserDataProfilesService");function h(i,a){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:A.URI.revive(i.location).with({scheme:a}),globalStorageHome:A.URI.revive(i.globalStorageHome).with({scheme:a}),settingsResource:A.URI.revive(i.settingsResource).with({scheme:a}),keybindingsResource:A.URI.revive(i.keybindingsResource).with({scheme:a}),tasksResource:A.URI.revive(i.tasksResource).with({scheme:a}),snippetsHome:A.URI.revive(i.snippetsHome).with({scheme:a}),extensionsResource:A.URI.revive(i.extensionsResource).with({scheme:a}),cacheHome:A.URI.revive(i.cacheHome).with({scheme:a}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.$Ik=h;function t(i,a,u,k,S,$){return{id:i,name:a,location:u,isDefault:!1,shortName:S?.shortName,icon:S?.icon,globalStorageHome:$&&S?.useDefaultFlags?.globalState?$.globalStorageHome:(0,M.$ug)(u,"globalStorage"),settingsResource:$&&S?.useDefaultFlags?.settings?$.settingsResource:(0,M.$ug)(u,"settings.json"),keybindingsResource:$&&S?.useDefaultFlags?.keybindings?$.keybindingsResource:(0,M.$ug)(u,"keybindings.json"),tasksResource:$&&S?.useDefaultFlags?.tasks?$.tasksResource:(0,M.$ug)(u,"tasks.json"),snippetsHome:$&&S?.useDefaultFlags?.snippets?$.snippetsHome:(0,M.$ug)(u,"snippets"),extensionsResource:$&&S?.useDefaultFlags?.extensions?$.extensionsResource:(0,M.$ug)(u,"extensions.json"),cacheHome:(0,M.$ug)(k,i),useDefaultFlags:S?.useDefaultFlags,isTransient:S?.transient}}e.$Jk=t;let n=class extends d.$Rc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(a,u,k,S){super(),this.t=a,this.u=u,this.w=k,this.y=S,this.f=!0,this.h=this.B(new T.$Md),this.onDidChangeProfiles=this.h.event,this.j=this.B(new T.$Md),this.onWillCreateProfile=this.j.event,this.m=this.B(new T.$Md),this.onWillRemoveProfile=this.m.event,this.n=this.B(new T.$Md),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new y.$zc,emptyWindows:new Map},this.profilesHome=(0,M.$ug)(this.t.userRoamingDataHome,"profiles"),this.g=(0,M.$ug)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(a){this.f!==a&&(this.z=void 0,this.f=a)}isEnabled(){return this.f}get C(){if(!this.z){const a=this.D(),u=[a];if(this.f)try{for(const $ of this.O()){if(!$.name||!(0,r.$xf)($.name)||!$.location){this.y.warn("Skipping the invalid stored profile",$.location||$.name);continue}u.push(t((0,M.$rg)($.location),$.name,$.location,this.g,{shortName:$.shortName,icon:$.icon,useDefaultFlags:$.useDefaultFlags},a))}}catch($){this.y.error($)}const k=new y.$zc,S=new Map;if(u.length)try{const $=this.Q();if($.workspaces)for(const[g,f]of Object.entries($.workspaces)){const P=A.URI.parse(g),N=u.find(O=>O.id===f);N&&k.set(P,N)}if($.emptyWindows)for(const[g,f]of Object.entries($.emptyWindows)){const P=u.find(N=>N.id===f);P&&S.set(g,P)}}catch($){this.y.error($)}this.z={profiles:u,workspaces:k,emptyWindows:S}}return this.z}D(){const a=t("__default__profile__",(0,b.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...a,extensionsResource:this.S()??a.extensionsResource,isDefault:!0}}async createTransientProfile(a){const u="Temp",k=new RegExp(`${(0,s.$Ee)(u)}\\s(\\d+)`);let S=0;for(const g of this.profiles){const f=k.exec(g.name),P=f?parseInt(f[1]):0;S=P>S?P:S}const $=`${u} ${S+1}`;return this.createProfile((0,C.$Bi)((0,l.$dg)()).toString(16),$,{transient:!0},a)}async createNamedProfile(a,u,k){return this.createProfile((0,C.$Bi)((0,l.$dg)()).toString(16),a,u,k)}async createProfile(a,u,k,S){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const $=await this.F(a,u,k);return S&&await this.setProfileForWorkspace(S,$),$}async F(a,u,k){if(!(0,r.$xf)(u)||!u)throw new Error("Name of the profile is mandatory and must be of type `string`");let S=this.r.get(u);return S||(S=(async()=>{try{const $=this.profiles.find(P=>P.name===u||P.id===a);if($)return $;const g=t(a,u,(0,M.$ug)(this.profilesHome,a),this.g,k,this.defaultProfile);await this.u.createFolder(g.location);const f=[];return this.j.fire({profile:g,join(P){f.push(P)}}),await v.Promises.settled(f),this.I([g],[],[]),g}finally{this.r.delete(u)}})(),this.r.set(u,S)),S}async updateProfile(a,u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let k=this.profiles.find(S=>S.id===a.id);if(!k)throw new Error(`Profile '${a.name}' does not exist`);return k=t(k.id,u.name??k.name,k.location,this.g,{shortName:u.shortName??k.shortName,icon:u.icon===null?void 0:u.icon??k.icon,transient:u.transient??k.isTransient,useDefaultFlags:u.useDefaultFlags??k.useDefaultFlags},this.defaultProfile),this.I([],[],[k]),k}async removeProfile(a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(a.isDefault)throw new Error("Cannot remove default profile");const u=this.profiles.find(S=>S.id===a.id);if(!u)throw new Error(`Profile '${a.name}' does not exist`);const k=[];this.m.fire({profile:u,join(S){k.push(S)}});try{await Promise.allSettled(k)}catch(S){this.y.error(S)}for(const S of[...this.C.emptyWindows.keys()])u.id===this.C.emptyWindows.get(S)?.id&&this.C.emptyWindows.delete(S);for(const S of[...this.C.workspaces.keys()])u.id===this.C.workspaces.get(S)?.id&&this.C.workspaces.delete(S);this.M(),this.I([],[u],[]);try{await this.u.del(u.cacheHome,{recursive:!0})}catch(S){(0,w.$mk)(S)!==1&&this.y.error(S)}}async setProfileForWorkspace(a,u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const k=this.profiles.find(S=>S.id===u.id);if(!k)throw new Error(`Profile '${u.name}' does not exist`);this.L(a,k)}unsetWorkspace(a,u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(a,void 0,u)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const a=await this.u.resolve(this.profilesHome);await Promise.all((a.children||[]).filter(u=>u.isDirectory&&this.profiles.every(k=>!this.w.extUri.isEqual(k.location,u.resource))).map(u=>this.u.del(u.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const a=this.s.profiles.filter(u=>!this.H(u));await Promise.allSettled(a.map(u=>this.removeProfile(u)))}getProfileForWorkspace(a){const u=this.G(a);return A.URI.isUri(u)?this.s.workspaces.get(u)??this.C.workspaces.get(u):this.s.emptyWindows.get(u)??this.C.emptyWindows.get(u)}G(a){return(0,p.$Xh)(a)?a.uri:(0,p.$3h)(a)?a.configPath:a.id}H(a){return!!([...this.s.emptyWindows.values()].some(u=>this.w.extUri.isEqual(u.location,a.location))||[...this.s.workspaces.values()].some(u=>this.w.extUri.isEqual(u.location,a.location))||[...this.C.emptyWindows.values()].some(u=>this.w.extUri.isEqual(u.location,a.location))||[...this.C.workspaces.values()].some(u=>this.w.extUri.isEqual(u.location,a.location)))}I(a,u,k){const S=[...this.profiles,...a],$=[];this.s.profiles=[];for(let g of S)g.isDefault||u.some(f=>g.id===f.id)||(g=k.find(f=>g.id===f.id)??g,g.isTransient?this.s.profiles.push(g):$.push({location:g.location,name:g.name,shortName:g.shortName,icon:g.icon,useDefaultFlags:g.useDefaultFlags}));this.P($),this.z=void 0,this.J(a,u,k)}J(a,u,k){this.h.fire({added:a,removed:u,updated:k,all:this.profiles})}L(a,u,k){k=u?.isTransient?!0:k,k||this.L(a,void 0,!0);const S=this.G(a),$=k?this.s:this.C;A.URI.isUri(S)?($.workspaces.delete(S),u&&$.workspaces.set(S,u)):($.emptyWindows.delete(S),u&&$.emptyWindows.set(S,u)),k||this.M()}M(){const a={};for(const[k,S]of this.C.workspaces.entries())a[k.toString()]=S.id;const u={};for(const[k,S]of this.C.emptyWindows.entries())u[k.toString()]=S.id;this.R({workspaces:a,emptyWindows:u}),this.z=void 0}N(a){const u={},k=this.D();if(a.workspaces)for(const[$,g]of Object.entries(a.workspaces)){const f=A.URI.parse(g);u[$]=this.w.extUri.isEqual(f,k.location)?k.id:this.w.extUri.basename(f)}const S={};if(a.emptyWindows)for(const[$,g]of Object.entries(a.emptyWindows)){const f=A.URI.parse(g);S[$]=this.w.extUri.isEqual(f,k.location)?k.id:this.w.extUri.basename(f)}return{workspaces:u,emptyWindows:S}}O(){return[]}P(a){throw new Error("not implemented")}Q(){return{}}R(a){throw new Error("not implemented")}S(){}};e.$Kk=n,e.$Kk=n=He([Be(0,E.$Uh),Be(1,w.$9j),Be(2,D.$Fk),Be(3,I.$8i)],n);class o extends n{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(a){this.a=a}Q(){return this.X}R(a){this.X=a}}e.$Lk=o}),define(De[260],Ce([1,0,9,4,3,54,18,184,5,259]),function(me,e,C,T,d,M,A,b,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$2o=e.$1o=e.$Zo=void 0,e.$Zo="__$__isNewStorageMarker",e.$1o="__$__targetStorageMarker",e.$2o=(0,E.$Nh)("storageService");var R;(function(r){r[r.NONE=0]="NONE",r[r.SHUTDOWN=1]="SHUTDOWN"})(R||(e.WillSaveStateReason=R={}));var I;(function(r){r[r.APPLICATION=-1]="APPLICATION",r[r.PROFILE=0]="PROFILE",r[r.WORKSPACE=1]="WORKSPACE"})(I||(e.StorageScope=I={}));var p;(function(r){r[r.USER=0]="USER",r[r.MACHINE=1]="MACHINE"})(p||(e.StorageTarget=p={}));function y(r){const c=r.get(e.$1o);if(c)try{return JSON.parse(c)}catch{}return Object.create(null)}e.$3o=y;class D extends d.$Rc{static{this.a=60*1e3}constructor(c={flushInterval:D.a}){super(),this.m=c,this.b=this.B(new T.$Pd),this.c=this.B(new T.$Pd),this.onDidChangeTarget=this.c.event,this.f=this.B(new T.$Md),this.onWillSaveState=this.f.event,this.h=this.B(new C.$5g(()=>this.n(),this.m.flushInterval)),this.j=this.B(new d.$Sc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(c,m,h){return T.Event.filter(this.b.event,t=>t.scope===c&&(m===void 0||t.key===m),h)}n(){this.j.value=(0,C.$9g)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,d.$Mc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,M.mark)("code/willInitStorage");try{await this.O()}finally{(0,M.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(c,m){const{key:h,external:t}=m;if(h===e.$1o){switch(c){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:c})}else this.b.fire({scope:c,key:h,target:this.J(c)[h],external:t})}w(c){this.f.fire({reason:c})}get(c,m,h){return this.P(m)?.get(c,h)}getBoolean(c,m,h){return this.P(m)?.getBoolean(c,h)}getNumber(c,m,h){return this.P(m)?.getNumber(c,h)}getObject(c,m,h){return this.P(m)?.getObject(c,h)}storeAll(c,m){this.y(()=>{for(const h of c)this.store(h.key,h.value,h.scope,h.target,m)})}store(c,m,h,t,n=!1){if((0,A.$Gf)(m)){this.remove(c,h,n);return}this.y(()=>{this.z(c,h,t),this.P(h)?.set(c,m,n)})}remove(c,m,h=!1){this.y(()=>{this.z(c,m,void 0),this.P(m)?.delete(c,h)})}y(c){this.b.pause(),this.c.pause();try{c()}finally{this.b.resume(),this.c.resume()}}keys(c,m){const h=[],t=this.J(c);for(const n of Object.keys(t))t[n]===m&&h.push(n);return h}z(c,m,h,t=!1){const n=this.J(m);typeof h=="number"?n[c]!==h&&(n[c]=h,this.P(m)?.set(e.$1o,JSON.stringify(n),t)):typeof n[c]=="number"&&(delete n[c],this.P(m)?.set(e.$1o,JSON.stringify(n),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(c){switch(c){case-1:return this.I;case 0:return this.G;default:return this.D}}L(c){const m=this.P(c);return m?y(m):Object.create(null)}isNew(c){return this.getBoolean(e.$Zo,c)===!0}async flush(c=R.NONE){this.f.fire({reason:c});const m=this.P(-1),h=this.P(0),t=this.P(1);switch(c){case R.NONE:await C.Promises.settled([m?.whenFlushed()??Promise.resolve(),h?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case R.SHUTDOWN:await C.Promises.settled([m?.flush(0)??Promise.resolve(),h?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const c=this.P(-1)?.items??new Map,m=this.P(0)?.items??new Map,h=this.P(1)?.items??new Map;return s(c,m,h,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(c){return await this.flush(),this.P(c)?.optimize()}async switch(c,m){return this.w(R.NONE),(0,w.$Gk)(c)?this.R(c,m):this.S(c,m)}M(c,m){return!(c.id===m.id||v(m)&&v(c))}N(c,m,h){this.y(()=>{const t=new Set;for(const[n,o]of c)t.add(n),m.get(n)!==o&&this.u(h,{key:n,external:!0});for(const[n]of m.items)t.has(n)||this.u(h,{key:n,external:!0})})}}e.$4o=D;function v(r){return r.isDefault||!!r.useDefaultFlags?.globalState}e.$5o=v;class l extends D{constructor(){super(),this.U=this.B(new b.$Xo(new b.$Yo,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new b.$Xo(new b.$Yo,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new b.$Xo(new b.$Yo,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(c=>this.u(1,c))),this.B(this.W.onDidChangeStorage(c=>this.u(0,c))),this.B(this.U.onDidChangeStorage(c=>this.u(-1,c)))}P(c){switch(c){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(c){switch(c){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(c){return!1}}e.$6o=l;async function s(r,c,m,h,t,n){const o=P=>{try{return JSON.parse(P)}catch{return P}},i=new Map,a=new Map;r.forEach((P,N)=>{i.set(N,P),a.set(N,o(P))});const u=new Map,k=new Map;c.forEach((P,N)=>{u.set(N,P),k.set(N,o(P))});const S=new Map,$=new Map;m.forEach((P,N)=>{S.set(N,P),$.set(N,o(P))}),console.group(h!==t?`Storage: Application (path: ${h})`:`Storage: Application & Profile (path: ${h}, default profile)`);const g=[];if(i.forEach((P,N)=>{g.push({key:N,value:P})}),console.table(g),console.groupEnd(),console.log(a),h!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const P=[];u.forEach((N,O)=>{P.push({key:O,value:N})}),console.table(P),console.groupEnd(),console.log(k)}console.group(`Storage: Workspace (path: ${n})`);const f=[];S.forEach((P,N)=>{f.push({key:N,value:P})}),console.table(f),console.groupEnd(),console.log($)}e.$7o=s}),define(De[107],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jbc=void 0;class C{static{this.a=!1}constructor(d){this.d=d,this.b=new Map,this.c=1}add(d){const M=this.c++;return this.b.set(M,d),this.e(),M}get(d,M){return this.b.has(d)?this.b.get(d)[M]:void 0}delete(d){this.b.delete(d),this.e()}e(){C.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Jbc=C}),define(De[55],Ce([1,0,17,24,5]),function(me,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mbc=e.$Lbc=void 0;class M{constructor(){this.a=new Set(Object.keys(C.Schemas)),this.b=new Map,this.extUri=new T.$jg(b=>{const E=this.b.get(b.scheme);return!(E===void 0||E&1024)})}$acceptProviderInfos(b,E){E===null?this.b.delete(b.scheme):this.b.set(b.scheme,E)}isFreeScheme(b){return!this.b.has(b)&&!this.a.has(b)}getCapabilities(b){return this.b.get(b)}}e.$Lbc=M,e.$Mbc=(0,d.$Nh)("IExtHostFileSystemInfo")}),define(De[27],Ce([1,0,5]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qM=void 0,e.$qM=(0,C.$Nh)("IExtHostInitDataService")}),define(De[261],Ce([1,0,206,13,241,27]),function(me,e,C,T,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sdc=void 0;let A=class extends d.$xN{constructor(E,w,R){const I=R.remote.isRemote?"remoteexthost":E?"workerexthost":"exthost",p=R.remote.isRemote?(0,C.localize)(0,null):E?(0,C.localize)(1,null):(0,C.localize)(2,null);super(w.createLogger(I,{name:p}))}};e.$Sdc=A,e.$Sdc=A=He([Be(1,T.$9i),Be(2,M.$qM)],A)}),define(De[262],Ce([1,0,9]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dcc=e.$ccc=void 0;class T{constructor(A,b,E){this.h=new Map,this.a=A,this.b=b,this.c=E,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(w=>(this.f=w,this)),this.g=this.c.onDidChangeStorage(w=>{w.shared===this.b&&w.key===this.a&&(this.f=w.value)}),this.i=new C.$5g(()=>{const w=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const R of w.values())R.complete()}catch(R){for(const I of w.values())I.error(R)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this.d}get(A,b){let E=this.f[A];return typeof E>"u"&&(E=b),E}update(A,b){this.f[A]=b;const E=this.h.get(A);if(E!==void 0)return E.p;const w=new C.$bh;return this.h.set(A,w),this.i.isScheduled()||this.i.schedule(),w.p}dispose(){this.g.dispose()}}e.$ccc=T;class d extends T{setKeysForSync(A){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},A)}constructor(A,b){super(A.identifier.value,!0,b),this.j=A}}e.$dcc=d}),define(De[263],Ce([1,0,4,2]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bdc=void 0;class d{constructor(A){this.c=A,this.a=new C.$Md,this.onDidSaveNotebookDocument=this.a.event,this.b=new C.$Md,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(A,b,E,w){const I=this.c.getNotebookDocument(T.URI.revive(A)).acceptModelChanged(b.value,E,w);this.b.fire(I)}$acceptDirtyStateChanged(A,b){this.c.getNotebookDocument(T.URI.revive(A)).acceptDirty(b)}$acceptModelSaved(A){const b=this.c.getNotebookDocument(T.URI.revive(A));this.a.fire(b.apiNotebook)}}e.$Bdc=d}),define(De[20],Ce([1,0,5]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bM=e.$aM=void 0,e.$aM=(0,C.$Nh)("IExtHostRpcService");class T{constructor(M){this.getProxy=M.getProxy.bind(M),this.set=M.set.bind(M),this.dispose=M.dispose.bind(M),this.assertRegistered=M.assertRegistered.bind(M),this.drain=M.drain.bind(M)}}e.$bM=T}),define(De[264],Ce([1,0,25,4]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$occ=void 0;class d{#e;constructor(A,b){this.b=new T.$Md,this.onDidChange=this.b.event,this.a=C.$2l.toKey(A.identifier),this.#e=b,this.#e.onDidChangePassword(E=>{E.extensionId===this.a&&this.b.fire({key:E.key})})}get(A){return this.#e.get(this.a,A)}store(A,b){return this.#e.store(this.a,A,b)}delete(A){return this.#e.delete(this.a,A)}}e.$occ=d}),define(De[66],Ce([1,0,5]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xbc=e.$Wbc=void 0,e.$Wbc=(0,C.$Nh)("IURITransformerService");class T{constructor(M){M?(this.transformIncoming=M.transformIncoming.bind(M),this.transformOutgoing=M.transformOutgoing.bind(M),this.transformOutgoingURI=M.transformOutgoingURI.bind(M),this.transformOutgoingScheme=M.transformOutgoingScheme.bind(M)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.$Xbc=T}),define(De[265],Ce([1,0,22]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$scb=e.$rcb=void 0;class T{constructor(){this.buffers=[]}add(E){let w=this.buffers.indexOf(E);return w<0&&(w=this.buffers.length,this.buffers.push(E)),w}}function d(b,E){if(E.serializeBuffersForPostMessage){const w=new T,I=JSON.stringify(b,(y,D)=>{if(D instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:w.add(D)};if(ArrayBuffer.isView(D)){const v=M(D);if(v)return{$$vscode_array_buffer_reference$$:!0,index:w.add(D.buffer),view:{type:v,byteLength:D.byteLength,byteOffset:D.byteOffset}}}return D}),p=w.buffers.map(y=>{const D=new Uint8Array(y);return C.$ae.wrap(D)});return{message:I,buffers:p}}else return{message:JSON.stringify(b),buffers:[]}}e.$rcb=d;function M(b){switch(b.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(b,E){const w=E.map(p=>{const y=new ArrayBuffer(p.byteLength);return new Uint8Array(y).set(p.buffer),y}),R=E.length?(p,y)=>{if(y&&typeof y=="object"&&y.$$vscode_array_buffer_reference$$){const D=y,{index:v}=D,l=w[v];if(D.view)switch(D.view.type){case 1:return new Int8Array(l,D.view.byteOffset,D.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(l,D.view.byteOffset,D.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(l,D.view.byteOffset,D.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(l,D.view.byteOffset,D.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(l,D.view.byteOffset,D.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(l,D.view.byteOffset,D.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(l,D.view.byteOffset,D.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(l,D.view.byteOffset,D.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(l,D.view.byteOffset,D.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(l,D.view.byteOffset,D.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(l,D.view.byteOffset,D.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return l}return y}:void 0;return{message:JSON.parse(b,R),arrayBuffers:w}}e.$scb=A}),define(De[266],Ce([1,0,267,373,374,60,2,13,375]),function(me,e,C,T,d,M,A,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oec=void 0;const w=!1;function R(c,m,h,t,n,o){const i=o.environment.useHostProxy,a=typeof i=="boolean"?i:!o.remote.isRemote,u={resolveProxy:$=>c.resolveProxy($),lookupProxyAuthorization:l.bind(void 0,t,n,m,{},o.remote.isRemote),getProxyURL:()=>m.getConfiguration("http").get("proxy"),getProxySupport:()=>m.getConfiguration("http").get("proxySupport")||"off",getSystemCertificatesV1:()=>p(m),getSystemCertificatesV2:()=>y(m),log:($,g,...f)=>{switch($){case E.LogLevel.Trace:t.trace(g,...f);break;case E.LogLevel.Debug:t.debug(g,...f);break;case E.LogLevel.Info:t.info(g,...f);break;case E.LogLevel.Warning:t.warn(g,...f);break;case E.LogLevel.Error:t.error(g,...f);break;case E.LogLevel.Critical:t.error(g,...f);break;case E.LogLevel.Off:break;default:P($,g,f);break}function P(N,O,...L){t.error("Unknown log level",N),t.error(O,...L)}},getLogLevel:()=>{const $=t.getLevel();switch($){case b.LogLevel.Trace:return E.LogLevel.Trace;case b.LogLevel.Debug:return E.LogLevel.Debug;case b.LogLevel.Info:return E.LogLevel.Info;case b.LogLevel.Warning:return E.LogLevel.Warning;case b.LogLevel.Error:return E.LogLevel.Error;case b.LogLevel.Off:return E.LogLevel.Off;default:return g($)}function g(f){return t.error("Unknown log level",f),E.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:a,addCertificates:[],env:process.env},k=(0,E.createProxyResolver)(u),S=I(u,k);return v(h,S)}e.$oec=R;function I(c,m){return{http:Object.assign(C,(0,E.createHttpPatch)(c,C,m)),https:Object.assign(T,(0,E.createHttpPatch)(c,T,m)),net:Object.assign(M,(0,E.createNetPatch)(c,M)),tls:Object.assign(d,(0,E.createTlsPatch)(c,d))}}function p(c){const m=c.getConfiguration("http");return!m.get("experimental.systemCertificatesV2",w)&&!!m.get("systemCertificates")}function y(c){const m=c.getConfiguration("http");return!!m.get("experimental.systemCertificatesV2",w)&&!!m.get("systemCertificates")}const D=new Map;function v(c,m){return c.getExtensionPathIndex().then(h=>{const t=globalThis._VSCODE_NODE_MODULES.module,n=t._load;t._load=function(i,a,u){if(i==="net")return m.net;if(i==="tls")return m.tls;if(i!=="http"&&i!=="https")return n.apply(this,arguments);const k=h.findSubstr(A.URI.file(a.filename));let S=D.get(k);if(S||D.set(k,S={}),!S[i]){const $=m[i];S[i]={...$}}return S[i]}})}async function l(c,m,h,t,n,o,i,a){const u=t[o];i&&(t[o]=i),c.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${o}`,`proxyAuthenticate:${i}`,`proxyAuthenticateCache:${u}`);const k=i||u,S=Array.isArray(k)?k:typeof k=="string"?[k]:[];if(r(m,S,n),S.some($=>/^(Negotiate|Kerberos)( |$)/i.test($))&&!a.kerberosRequested)try{a.kerberosRequested=!0;const $=await new Promise((O,L)=>{me(["kerberos"],O,L)}),g=new URL(o),f=h.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${g.hostname}`:`HTTP@${g.hostname}`);return c.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${o}`,`spn:${f}`),"Negotiate "+await(await $.initializeClient(f)).step("")}catch($){c.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",$)}}let s=!1;function r(c,m,h){s||!m.length||(s=!0,c.$publicLog2("proxyAuthenticationRequest",{authenticationType:m.map(t=>t.split(" ")[0]).join(","),extensionHostType:h?"remote":"local"}))}}),define(De[268],Ce([1,0,128]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wr=void 0;function T(M){return{transformIncoming:A=>A.scheme==="vscode-remote"?{scheme:"file",path:A.path,query:A.query,fragment:A.fragment}:A.scheme==="file"?{scheme:"vscode-local",path:A.path,query:A.query,fragment:A.fragment}:A,transformOutgoing:A=>A.scheme==="file"?{scheme:"vscode-remote",authority:M,path:A.path,query:A.query,fragment:A.fragment}:A.scheme==="vscode-local"?{scheme:"file",path:A.path,query:A.query,fragment:A.fragment}:A,transformOutgoingScheme:A=>A==="file"?"vscode-remote":A==="vscode-local"?"file":A}}function d(M){return new C.$Hm(T(M))}e.$wr=d}),define(De[139],Ce([1,0,216,18,2,3,5,42,30,17,46,176,38]),function(me,e,C,T,d,M,A,b,E,w,R,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aE=e.$_D=e.$$D=e.EditorsOrder=e.$0D=e.CloseDirection=e.$9D=e.$8D=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$7D=e.$6D=e.$5D=e.$4D=e.$3D=e.$2D=e.$1D=e.$ZD=e.EditorInputCapabilities=e.$YD=e.SaveReason=e.Verbosity=e.$XD=e.$WD=e.$VD=e.$UD=e.$TD=e.$SD=e.$RD=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$QD=e.$PD=e.$OD=e.$ND=e.$MD=void 0,e.$MD={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$ND={id:"default",displayName:(0,C.localize)(0,null),providerDisplayName:(0,C.localize)(1,null)},e.$OD="workbench.editor.sidebysideEditor",e.$PD="workbench.editors.textDiffEditor",e.$QD="workbench.editors.binaryResourceDiffEditor";var y;(function(ue){ue[ue.PROGRAMMATIC=1]="PROGRAMMATIC",ue[ue.USER=2]="USER",ue[ue.EDIT=3]="EDIT",ue[ue.NAVIGATION=4]="NAVIGATION",ue[ue.JUMP=5]="JUMP"})(y||(e.EditorPaneSelectionChangeReason=y={}));var D;(function(ue){ue[ue.IDENTICAL=1]="IDENTICAL",ue[ue.SIMILAR=2]="SIMILAR",ue[ue.DIFFERENT=3]="DIFFERENT"})(D||(e.EditorPaneSelectionCompareResult=D={}));function v(ue){const ve=ue;return!!ve&&typeof ve.getSelection=="function"&&!!ve.onDidChangeSelection}e.$RD=v;function l(ue,ve,J){for(const U of J.visibleEditorPanes)if(U.group.id===ve&&ue.matches(U.input))return U.getViewState()}e.$SD=l;function s(ue){if(u(ue))return!1;const ve=ue;return d.URI.isUri(ve?.resource)}e.$TD=s;function r(ue){if(u(ue))return!1;const ve=ue;return ve?.original!==void 0&&ve.modified!==void 0}e.$UD=r;function c(ue){if(u(ue)||r(ue))return!1;const ve=ue;return ve?.primary!==void 0&&ve.secondary!==void 0}e.$VD=c;function m(ue){if(u(ue))return!1;const ve=ue;return ve?ve.resource===void 0||ve.resource.scheme===w.Schemas.untitled||ve.forceUntitled===!0:!1}e.$WD=m;function h(ue){if(u(ue))return!1;const ve=ue;return d.URI.isUri(ve?.base?.resource)&&d.URI.isUri(ve?.input1?.resource)&&d.URI.isUri(ve?.input2?.resource)&&d.URI.isUri(ve?.result?.resource)}e.$XD=h;var t;(function(ue){ue[ue.SHORT=0]="SHORT",ue[ue.MEDIUM=1]="MEDIUM",ue[ue.LONG=2]="LONG"})(t||(e.Verbosity=t={}));var n;(function(ue){ue[ue.EXPLICIT=1]="EXPLICIT",ue[ue.AUTO=2]="AUTO",ue[ue.FOCUS_CHANGE=3]="FOCUS_CHANGE",ue[ue.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(n||(e.SaveReason=n={}));class o{constructor(){this.a=new Map}registerSource(ve,J){let U=this.a.get(ve);return U||(U={source:ve,label:J},this.a.set(ve,U)),U.source}getSourceLabel(ve){return this.a.get(ve)?.label??ve}}e.$YD=new o;var i;(function(ue){ue[ue.None=0]="None",ue[ue.Readonly=2]="Readonly",ue[ue.Untitled=4]="Untitled",ue[ue.Singleton=8]="Singleton",ue[ue.RequiresTrust=16]="RequiresTrust",ue[ue.CanSplitInGroup=32]="CanSplitInGroup",ue[ue.ForceDescription=64]="ForceDescription",ue[ue.CanDropIntoEditor=128]="CanDropIntoEditor",ue[ue.MultipleEditors=256]="MultipleEditors",ue[ue.Scratchpad=512]="Scratchpad"})(i||(e.EditorInputCapabilities=i={}));class a extends M.$Rc{}e.$ZD=a;function u(ue){return ue instanceof a}e.$1D=u;function k(ue){const ve=ue;return d.URI.isUri(ve?.preferredResource)}function S(ue){const ve=ue;return u(ve?.primary)&&u(ve?.secondary)}e.$2D=S;function $(ue){const ve=ue;return u(ve?.modified)&&u(ve?.original)}e.$3D=$;function g(ue,ve,J,U,V){return be(U,[(0,I.$xi)({id:"workbench.action.openLargeFile",label:(0,C.localize)(2,null),run:()=>{const ge={...J,limits:{size:Number.MAX_VALUE}};ue.openEditor(ve,ge)}}),(0,I.$xi)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,C.localize)(3,null),run:()=>V.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:p.default.Warning})}e.$4D=g;function f(ue){return u(ue?.editor)}e.$5D=f;function P(ue){const ve=ue;return f(ue)&&ve?.group!==void 0}e.$6D=P;function N(ue){const ve=ue;return typeof ve?.groupId=="number"&&u(ve.editor)}e.$7D=N;var O;(function(ue){ue[ue.UNKNOWN=0]="UNKNOWN",ue[ue.REPLACE=1]="REPLACE",ue[ue.MOVE=2]="MOVE",ue[ue.UNPIN=3]="UNPIN"})(O||(e.EditorCloseContext=O={}));var L;(function(ue){ue[ue.GROUP_ACTIVE=0]="GROUP_ACTIVE",ue[ue.GROUP_INDEX=1]="GROUP_INDEX",ue[ue.GROUP_LOCKED=2]="GROUP_LOCKED",ue[ue.EDITOR_OPEN=3]="EDITOR_OPEN",ue[ue.EDITOR_CLOSE=4]="EDITOR_CLOSE",ue[ue.EDITOR_MOVE=5]="EDITOR_MOVE",ue[ue.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",ue[ue.EDITOR_LABEL=7]="EDITOR_LABEL",ue[ue.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",ue[ue.EDITOR_PIN=9]="EDITOR_PIN",ue[ue.EDITOR_STICKY=10]="EDITOR_STICKY",ue[ue.EDITOR_DIRTY=11]="EDITOR_DIRTY",ue[ue.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(L||(e.GroupModelChangeKind=L={}));var j;(function(ue){ue[ue.PRIMARY=1]="PRIMARY",ue[ue.SECONDARY=2]="SECONDARY",ue[ue.BOTH=3]="BOTH",ue[ue.ANY=4]="ANY"})(j||(e.SideBySideEditor=j={}));class z{getOriginalUri(ve,J){if(!ve)return;if(h(ve))return e.$9D.getOriginalUri(ve.result,J);if(J?.supportSideBySide){const{primary:V,secondary:ge}=this.a(ve);if(V&&ge){if(J?.supportSideBySide===j.BOTH)return{primary:this.getOriginalUri(V,{filterByScheme:J.filterByScheme}),secondary:this.getOriginalUri(ge,{filterByScheme:J.filterByScheme})};if(J?.supportSideBySide===j.ANY)return this.getOriginalUri(V,{filterByScheme:J.filterByScheme})??this.getOriginalUri(ge,{filterByScheme:J.filterByScheme});ve=J.supportSideBySide===j.PRIMARY?V:ge}}if(r(ve)||c(ve)||h(ve))return;const U=k(ve)?ve.preferredResource:ve.resource;return!U||!J||!J.filterByScheme?U:this.b(U,J.filterByScheme)}a(ve){return S(ve)||c(ve)?{primary:ve.primary,secondary:ve.secondary}:$(ve)||r(ve)?{primary:ve.modified,secondary:ve.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(ve,J){if(!ve)return;if(h(ve))return e.$9D.getCanonicalUri(ve.result,J);if(J?.supportSideBySide){const{primary:V,secondary:ge}=this.a(ve);if(V&&ge){if(J?.supportSideBySide===j.BOTH)return{primary:this.getCanonicalUri(V,{filterByScheme:J.filterByScheme}),secondary:this.getCanonicalUri(ge,{filterByScheme:J.filterByScheme})};if(J?.supportSideBySide===j.ANY)return this.getCanonicalUri(V,{filterByScheme:J.filterByScheme})??this.getCanonicalUri(ge,{filterByScheme:J.filterByScheme});ve=J.supportSideBySide===j.PRIMARY?V:ge}}if(r(ve)||c(ve)||h(ve))return;const U=ve.resource;return!U||!J||!J.filterByScheme?U:this.b(U,J.filterByScheme)}b(ve,J){if(Array.isArray(J)){if(J.some(U=>ve.scheme===U))return ve}else if(J===ve.scheme)return ve}}var F;(function(ue){ue[ue.UNKNOWN=0]="UNKNOWN",ue[ue.KEYBOARD=1]="KEYBOARD",ue[ue.MOUSE=2]="MOUSE"})(F||(e.EditorCloseMethod=F={}));function H(ue,ve,J,U){if(!ue.isSticky(ve))return!1;switch(U.preventPinnedEditorClose){case"keyboardAndMouse":return J===F.MOUSE||J===F.KEYBOARD;case"mouse":return J===F.MOUSE;case"keyboard":return J===F.KEYBOARD}return!1}e.$8D=H,e.$9D=new z;var K;(function(ue){ue[ue.LEFT=0]="LEFT",ue[ue.RIGHT=1]="RIGHT"})(K||(e.CloseDirection=K={}));class fe{constructor(){this.c=new Map,this.d=new Map}start(ve){const J=this.a=ve.get(A.$Mh);for(const[U,V]of this.c)this.e(U,V,J);this.c.clear()}e(ve,J,U){const V=U.createInstance(J);this.d.set(ve,V)}registerFileEditorFactory(ve){if(this.b)throw new Error("Can only register one file editor factory.");this.b=ve}getFileEditorFactory(){return(0,T.$If)(this.b)}registerEditorSerializer(ve,J){if(this.c.has(ve)||this.d.has(ve))throw new Error(`A editor serializer with type ID '${ve}' was already registered.`);return this.a?this.e(ve,J,this.a):this.c.set(ve,J),(0,M.$Pc)(()=>{this.c.delete(ve),this.d.delete(ve)})}getEditorSerializer(ve){return this.d.get(typeof ve=="string"?ve:ve.typeId)}}b.$bn.add(e.$MD.EditorFactory,new fe);async function x(ue,ve,J){return!ue||!ue.length?[]:await Promise.all(ue.map(async U=>{const V=d.URI.revive(U.fileUri);if(!V){J.info("Cannot resolve the path because it is not valid.",U);return}if(!await ve.canHandleResource(V)){J.info("Cannot resolve the path because it cannot be handled",U);return}let _=U.exists,ie=U.type;if(typeof _!="boolean"||typeof ie!="number")try{ie=(await ve.stat(V)).isDirectory?E.FileType.Directory:E.FileType.Unknown,_=!0}catch(Ee){J.error(Ee),_=!1}if(!_&&U.openOnlyIfExists){J.info("Cannot resolve the path because it does not exist",U);return}if(ie===E.FileType.Directory){J.info("Cannot resolve the path because it is a directory",U);return}const re={...U.options,pinned:!0};return _?{resource:V,options:re}:{resource:V,options:re,forceUntitled:!0}}))}e.$0D=x;var Z;(function(ue){ue[ue.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ue[ue.SEQUENTIAL=1]="SEQUENTIAL"})(Z||(e.EditorsOrder=Z={}));function q(ue){const ve=ue;if(!ve)return!1;const J=ve;if(J.modified)return q(J.modified);const U=ve;return!!(U.contributionsState&&U.viewState&&Array.isArray(U.cursorState))}e.$$D=q;function Y(ue){return(0,R.$zi)(ue)}e.$_D=Y;function be(ue,ve,J){const U=(0,R.$Ai)(ue,ve);return U.forceMessage=J?.forceMessage,U.forceSeverity=J?.forceSeverity,U.allowDialog=J?.allowDialog,U}e.$aE=be}),define(De[269],Ce([1,0,4,217,5,3,28,42,19,23,78,255]),function(me,e,C,T,d,M,A,b,E,w,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lE=e.$kE=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$jE=e.$iE=e.ViewContentGroups=e.$hE=e.$gE=e.ViewContainerLocation=e.Extensions=e.$fE=e.$eE=e.$dE=void 0,e.$dE="views",e.$eE=(0,T.localize)(0,null),e.$fE=(0,I.$Zv)("default-view-icon",R.$Sj.window,(0,T.localize)(1,null));var p;(function(n){n.ViewContainersRegistry="workbench.registry.view.containers",n.ViewsRegistry="workbench.registry.view"})(p||(e.Extensions=p={}));var y;(function(n){n[n.Sidebar=0]="Sidebar",n[n.Panel=1]="Panel",n[n.AuxiliaryBar=2]="AuxiliaryBar"})(y||(e.ViewContainerLocation=y={})),e.$gE=[0,1,2];function D(n){switch(n){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$hE=D;class v extends M.$Rc{constructor(){super(...arguments),this.c=this.B(new C.$Md),this.onDidRegister=this.c.event,this.f=this.B(new C.$Md),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,E.$Qb)([...this.g.values()])}registerViewContainer(o,i,a){const u=this.get(o.id);if(u)return u;const k=o;return k.openCommandActionDescriptor=a?.doNotRegisterOpenCommand?void 0:k.openCommandActionDescriptor??{id:k.id},(0,A.$wc)(this.g,i,[]).push(k),a?.isDefault&&this.h.push(k),this.c.fire({viewContainer:k,viewContainerLocation:i}),k}deregisterViewContainer(o){for(const i of this.g.keys()){const a=this.g.get(i),u=a?.indexOf(o);if(u!==-1){a?.splice(u,1),a.length===0&&this.g.delete(i),this.f.fire({viewContainer:o,viewContainerLocation:i});return}}}get(o){return this.all.filter(i=>i.id===o)[0]}getViewContainers(o){return[...this.g.get(o)||[]]}getViewContainerLocation(o){return[...this.g.keys()].filter(i=>this.getViewContainers(i).filter(a=>a?.id===o.id).length>0)[0]}getDefaultViewContainer(o){return this.h.find(i=>this.getViewContainerLocation(i)===o)}}b.$bn.add(p.ViewContainersRegistry,new v);var l;(function(n){n.Open="2_open",n.Debug="4_debug",n.SCM="5_scm",n.More="9_more"})(l||(e.ViewContentGroups=l={}));function s(n,o){const i=n.group??l.More,a=o.group??l.More;return i!==a?i.localeCompare(a):(n.order??5)-(o.order??5)}class r extends M.$Rc{constructor(){super(...arguments),this.c=this.B(new C.$Md),this.onViewsRegistered=this.c.event,this.f=this.B(new C.$Md),this.onViewsDeregistered=this.f.event,this.g=this.B(new C.$Md),this.onDidChangeContainer=this.g.event,this.h=this.B(new C.$Md),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new A.$Fc}registerViews(o,i){this.registerViews2([{views:o,viewContainer:i}])}registerViews2(o){o.forEach(({views:i,viewContainer:a})=>this.r(i,a)),this.c.fire(o)}deregisterViews(o,i){const a=this.s(o,i);a.length&&this.f.fire({views:a,viewContainer:i})}moveViews(o,i){for(const a of this.m.keys())if(a!==i){const u=this.s(o,a);u.length&&(this.r(u,i),this.g.fire({views:u,from:a,to:i}))}}getViews(o){return this.m.get(o)||[]}getView(o){for(const i of this.j){const a=(this.m.get(i)||[]).filter(u=>u.id===o)[0];if(a)return a}return null}getViewContainer(o){for(const i of this.j)if((this.m.get(i)||[]).filter(u=>u.id===o)[0])return i;return null}registerViewWelcomeContent(o,i){return this.n.add(o,i),this.h.fire(o),(0,M.$Pc)(()=>{this.n.delete(o,i),this.h.fire(o)})}registerViewWelcomeContent2(o,i){const a=new Map;for(const[u,k]of i)this.n.add(o,k),a.set(u,(0,M.$Pc)(()=>{this.n.delete(o,k),this.h.fire(o)}));return this.h.fire(o),a}getViewWelcomeContent(o){const i=[];return this.n.forEach(o,a=>i.push(a)),i.sort(s)}r(o,i){let a=this.m.get(i);a||(a=[],this.m.set(i,a),this.j.push(i));for(const u of o){if(this.getView(u.id)!==null)throw new Error((0,T.localize)(2,null,u.id));a.push(u)}}s(o,i){const a=this.m.get(i);if(!a)return[];const u=[],k=[];for(const S of a)o.includes(S)?u.push(S):k.push(S);return u.length&&(k.length?this.m.set(i,k):(this.m.delete(i),this.j.splice(this.j.indexOf(i),1))),u}}b.$bn.add(p.ViewsRegistry,new r),e.$iE=(0,d.$Nh)("viewsService"),e.$jE=(0,d.$Nh)("viewDescriptorService");var c;(function(n){n[n.Default=0]="Default",n[n.Expand=1]="Expand"})(c||(e.ViewVisibilityState=c={}));var m;(function(n){n[n.None=0]="None",n[n.Collapsed=1]="Collapsed",n[n.Expanded=2]="Expanded"})(m||(e.TreeItemCollapsibleState=m={}));class h{constructor(o,i){this.c=!1,this.d=!1,(0,w.$5m)(this,o),this.d=!!i,this.resolve=async a=>{if(i&&!this.c){const u=await i(a);u&&(this.tooltip=this.tooltip??u.tooltip,this.command=this.command??u.command)}a.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$kE=h;class t extends Error{constructor(o){super((0,T.localize)(3,null,o)),this.name="NoTreeViewError"}static is(o){return o.name==="NoTreeViewError"}}e.$lE=t}),define(De[140],Ce([1,0,4,9,218]),function(me,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xcb=void 0;class M{constructor(){this.f=new Map,this.k=[],this.m=new C.$Md,this.n=new C.$Md,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(b){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=b}onEvent(b){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=b}onRequest(b){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=b}sendResponse(b){b.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${b.command}`)):this.s("response",b)}sendRequest(b,E,w,R){const I={command:b};if(E&&Object.keys(E).length>0&&(I.arguments=E),this.s("request",I),typeof R=="number"){const p=setTimeout(()=>{clearTimeout(p);const y=this.f.get(I.seq);if(y){this.f.delete(I.seq);const D={type:"response",seq:0,request_seq:I.seq,success:!1,command:b,message:(0,d.localize)(0,null,R,b)};y(D)}},R)}return w&&this.f.set(I.seq,w),I.seq}acceptMessage(b){this.j?this.j(b):(this.k.push(b),this.k.length===1&&this.q())}o(b,E){return b.type!=="event"||E.type!=="event"}async q(){let b;for(;this.k.length;){if((!b||this.o(this.k[0],b))&&await(0,T.$Tg)(0),b=this.k.shift(),!b)return;switch(b.type){case"event":this.i?.(b);break;case"request":this.g?.(b);break;case"response":{const E=b,w=this.f.get(E.request_seq);w&&(this.f.delete(E.request_seq),w(E));break}}}}s(b,E){E.type=b,E.seq=this.d++,this.sendMessage(E)}async u(){if(this.f.size===0)return Promise.resolve();const b=new Map;this.f.forEach((E,w)=>b.set(w,E)),await(0,T.$Tg)(500),b.forEach((E,w)=>{E({type:"response",seq:0,request_seq:w,success:!1,command:"canceled",message:"canceled"}),this.f.delete(w)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$Xcb=M}),define(De[270],Ce([1,0,219,41,5]),function(me,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$2G=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$1G=e.MemoryRangeType=e.$ZG=e.State=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=e.$$F=e.$0F=e.$9F=e.$8F=e.$7F=e.$6F=e.$5F=e.$4F=e.$3F=e.$2F=e.$1F=e.$ZF=e.$YF=e.$XF=void 0,e.$XF="workbench.view.debug",e.$YF="workbench.debug.variablesView",e.$ZF="workbench.debug.watchExpressionsView",e.$1F="workbench.debug.callStackView",e.$2F="workbench.debug.loadedScriptsView",e.$3F="workbench.debug.breakPointsView",e.$4F="workbench.debug.disassemblyView",e.$5F="workbench.panel.repl",e.$6F="workbench.panel.repl.view",e.$7F=new T.$5i("debugType",void 0,{type:"string",description:C.localize(0,null)}),e.$8F=new T.$5i("debugConfigurationType",void 0,{type:"string",description:C.localize(1,null)}),e.$9F=new T.$5i("debugState","inactive",{type:"string",description:C.localize(2,null)}),e.$0F="debugUx",e.$$F=new T.$5i(e.$0F,"default",{type:"string",description:C.localize(3,null)}),e.$_F=new T.$5i("hasDebugged",!1,{type:"boolean",description:C.localize(4,null)}),e.$aG=new T.$5i("inDebugMode",!1,{type:"boolean",description:C.localize(5,null)}),e.$bG=new T.$5i("inDebugRepl",!1,{type:"boolean",description:C.localize(6,null)}),e.$cG=new T.$5i("breakpointWidgetVisible",!1,{type:"boolean",description:C.localize(7,null)}),e.$dG=new T.$5i("inBreakpointWidget",!1,{type:"boolean",description:C.localize(8,null)}),e.$eG=new T.$5i("breakpointsFocused",!0,{type:"boolean",description:C.localize(9,null)}),e.$fG=new T.$5i("watchExpressionsFocused",!0,{type:"boolean",description:C.localize(10,null)}),e.$gG=new T.$5i("watchExpressionsExist",!1,{type:"boolean",description:C.localize(11,null)}),e.$hG=new T.$5i("variablesFocused",!0,{type:"boolean",description:C.localize(12,null)}),e.$iG=new T.$5i("expressionSelected",!1,{type:"boolean",description:C.localize(13,null)}),e.$jG=new T.$5i("breakpointInputFocused",!1,{type:"boolean",description:C.localize(14,null)}),e.$kG=new T.$5i("callStackItemType",void 0,{type:"string",description:C.localize(15,null)}),e.$lG=new T.$5i("callStackSessionIsAttach",!1,{type:"boolean",description:C.localize(16,null)}),e.$mG=new T.$5i("callStackItemStopped",!1,{type:"boolean",description:C.localize(17,null)}),e.$nG=new T.$5i("callStackSessionHasOneThread",!1,{type:"boolean",description:C.localize(18,null)}),e.$oG=new T.$5i("watchItemType",void 0,{type:"string",description:C.localize(19,null)}),e.$pG=new T.$5i("canViewMemory",void 0,{type:"boolean",description:C.localize(20,null)}),e.$qG=new T.$5i("breakpointItemType",void 0,{type:"string",description:C.localize(21,null)}),e.$rG=new T.$5i("breakpointSupportsCondition",!1,{type:"boolean",description:C.localize(22,null)}),e.$sG=new T.$5i("loadedScriptsSupported",!1,{type:"boolean",description:C.localize(23,null)}),e.$tG=new T.$5i("loadedScriptsItemType",void 0,{type:"string",description:C.localize(24,null)}),e.$uG=new T.$5i("focusedSessionIsAttach",!1,{type:"boolean",description:C.localize(25,null)}),e.$vG=new T.$5i("stepBackSupported",!1,{type:"boolean",description:C.localize(26,null)}),e.$wG=new T.$5i("restartFrameSupported",!1,{type:"boolean",description:C.localize(27,null)}),e.$xG=new T.$5i("stackFrameSupportsRestart",!1,{type:"boolean",description:C.localize(28,null)}),e.$yG=new T.$5i("jumpToCursorSupported",!1,{type:"boolean",description:C.localize(29,null)}),e.$zG=new T.$5i("stepIntoTargetsSupported",!1,{type:"boolean",description:C.localize(30,null)}),e.$AG=new T.$5i("breakpointsExist",!1,{type:"boolean",description:C.localize(31,null)}),e.$BG=new T.$5i("debuggersAvailable",!1,{type:"boolean",description:C.localize(32,null)}),e.$CG=new T.$5i("debugExtensionAvailable",!0,{type:"boolean",description:C.localize(33,null)}),e.$DG=new T.$5i("debugProtocolVariableMenuContext",void 0,{type:"string",description:C.localize(34,null)}),e.$EG=new T.$5i("debugSetVariableSupported",!1,{type:"boolean",description:C.localize(35,null)}),e.$FG=new T.$5i("debugSetExpressionSupported",!1,{type:"boolean",description:C.localize(36,null)}),e.$GG=new T.$5i("breakWhenValueChangesSupported",!1,{type:"boolean",description:C.localize(37,null)}),e.$HG=new T.$5i("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:C.localize(38,null)}),e.$IG=new T.$5i("breakWhenValueIsReadSupported",!1,{type:"boolean",description:C.localize(39,null)}),e.$JG=new T.$5i("terminateDebuggeeSupported",!1,{type:"boolean",description:C.localize(40,null)}),e.$KG=new T.$5i("suspendDebuggeeSupported",!1,{type:"boolean",description:C.localize(41,null)}),e.$LG=new T.$5i("variableEvaluateNamePresent",!1,{type:"boolean",description:C.localize(42,null)}),e.$MG=new T.$5i("variableIsReadonly",!1,{type:"boolean",description:C.localize(43,null)}),e.$NG=new T.$5i("exceptionWidgetVisible",!1,{type:"boolean",description:C.localize(44,null)}),e.$OG=new T.$5i("multiSessionRepl",!1,{type:"boolean",description:C.localize(45,null)}),e.$PG=new T.$5i("multiSessionDebug",!1,{type:"boolean",description:C.localize(46,null)}),e.$QG=new T.$5i("disassembleRequestSupported",!1,{type:"boolean",description:C.localize(47,null)}),e.$RG=new T.$5i("disassemblyViewFocus",!1,{type:"boolean",description:C.localize(48,null)}),e.$SG=new T.$5i("languageSupportsDisassembleRequest",!1,{type:"boolean",description:C.localize(49,null)}),e.$TG=new T.$5i("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:C.localize(50,null)});const M=p=>C.localize(51,null,p);e.$UG=M,e.$VG="editor.contrib.debug",e.$WG="editor.contrib.breakpoint",e.$XG="debug",e.$YG={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:C.localize(52,null)};var A;(function(p){p[p.Inactive=0]="Inactive",p[p.Initializing=1]="Initializing",p[p.Stopped=2]="Stopped",p[p.Running=3]="Running"})(A||(e.State=A={}));function b(p){switch(p){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$ZG=b;var E;(function(p){p[p.Valid=0]="Valid",p[p.Unreadable=1]="Unreadable",p[p.Error=2]="Error"})(E||(e.MemoryRangeType=E={})),e.$1G="vscode-debug-memory";var w;(function(p){p[p.Initial=1]="Initial",p[p.Dynamic=2]="Dynamic"})(w||(e.DebugConfigurationProviderTriggerKind=w={}));var R;(function(p){p.UnverifiedBreakpoints="unverifiedBreakpoints"})(R||(e.DebuggerString=R={})),e.$2G=(0,d.$Nh)("debugService");var I;(function(p){p[p.CONDITION=0]="CONDITION",p[p.HIT_COUNT=1]="HIT_COUNT",p[p.LOG_MESSAGE=2]="LOG_MESSAGE"})(I||(e.BreakpointWidgetContext=I={}))}),define(De[271],Ce([1,0,15,2,16,23,17,34,21,19]),function(me,e,C,T,d,M,A,b,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yF=e.$xF=e.$wF=e.$vF=e.$uF=e.$tF=e.$sF=e.$rF=e.$qF=e.$pF=e.$oF=e.$nF=e.$mF=void 0;const R=/{([^}]+)}/g;function I(S,$,g){return S.replace(R,function(f,P){return $&&P.length>0&&P[0]!=="_"?f:g&&g.hasOwnProperty(P)?g[P]:f})}e.$mF=I;function p(S){const $={};for(const g of Object.keys(S))g.startsWith("!")||($[g]=S[g]);return $}e.$nF=p;function y(S){return S.configuration.request==="attach"&&!D(S)&&(!S.parentSession||y(S.parentSession))}e.$oF=y;function D(S){let $=S.configuration.type;if($)return $==="vslsShare"&&($=S.configuration.adapterProxy.configuration.type),(0,C.$1e)($,"extensionhost")||(0,C.$1e)($,"pwa-extensionhost")?S:S.parentSession?D(S.parentSession):void 0}e.$pF=D;function v(S){return S.type&&(S.label||S.program||S.runtime)}e.$qF=v;function l(S,$,g){let f,P=0;const N=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let O=null;for(;O=N.exec(S);){const L=O.index+1,j=L+O[0].length;if(L<=$&&j>=g){f=O[0],P=L;break}}if(f){const L=/\w+/g;let j=null;for(;(j=L.exec(f))&&!(j.index+1+P+j[0].length>=g););j&&(f=f.substring(0,L.lastIndex))}return f?{start:P,end:P+f.length-1}:{start:0,end:0}}e.$rF=l;async function s(S,$,g,f){if(S.evaluatableExpressionProvider.has($)){const P=S.evaluatableExpressionProvider.ordered($),N=(0,w.$Gb)(await Promise.all(P.map(async O=>{try{return await O.provideEvaluatableExpression($,g,f??E.CancellationToken.None)}catch{return}})));if(N.length>0){let O=N[0].expression;const L=N[0].range;return O||(O=$.getLineContent(g.lineNumber).substring(L.startColumn-1,L.endColumn-1)),{range:L,matchingExpression:O}}}else{const P=$.getLineContent(g.lineNumber),{start:N,end:O}=l(P,g.column,g.column),L=P.substring(N-1,O);return{matchingExpression:L,range:new b.$os(g.lineNumber,N,g.lineNumber,N+L.length)}}return null}e.$sF=s;const r=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function c(S){return!!(S&&S.match(r))}e.$tF=c;function m(S){if(typeof S.path=="string"&&!(typeof S.sourceReference=="number"&&S.sourceReference>0)){if(c(S.path))return T.URI.parse(S.path);if((0,d.$hc)(S.path))return T.URI.file(S.path)}return S.path}function h(S){if(typeof S.path=="object"){const $=T.URI.revive(S.path);if($)return $.scheme===A.Schemas.file?$.fsPath:$.toString()}return S.path}function t(S,$){const g=$?m:h,f=(0,M.$2m)(S);return o(f,(P,N)=>{P&&N&&(N.path=g(N))}),f}e.$uF=t;function n(S,$){const g=$?m:h,f=(0,M.$2m)(S);return o(f,(P,N)=>{!P&&N&&(N.path=g(N))}),f}e.$vF=n;function o(S,$){switch(S.type){case"event":{const g=S;switch(g.event){case"output":$(!1,g.body.source);break;case"loadedSource":$(!1,g.body.source);break;case"breakpoint":$(!1,g.body.breakpoint.source);break;default:break}break}case"request":{const g=S;switch(g.command){case"setBreakpoints":$(!0,g.arguments.source);break;case"breakpointLocations":$(!0,g.arguments.source);break;case"source":$(!0,g.arguments.source);break;case"gotoTargets":$(!0,g.arguments.source);break;case"launchVSCode":g.arguments.args.forEach(f=>$(!1,f));break;default:break}break}case"response":{const g=S;if(g.success&&g.body)switch(g.command){case"stackTrace":g.body.stackFrames.forEach(f=>$(!1,f.source));break;case"loadedSources":g.body.sources.forEach(f=>$(!1,f));break;case"scopes":g.body.scopes.forEach(f=>$(!1,f.source));break;case"setFunctionBreakpoints":g.body.breakpoints.forEach(f=>$(!1,f.source));break;case"setBreakpoints":g.body.breakpoints.forEach(f=>$(!1,f.source));break;case"disassemble":g.body?.instructions.forEach(P=>$(!1,P.location));break;default:break}break}}}function i(S){return S.filter($=>!$.presentation?.hidden).sort(($,g)=>$.presentation?g.presentation?$.presentation.group?g.presentation.group?$.presentation.group!==g.presentation.group?$.presentation.group.localeCompare(g.presentation.group):a($.presentation.order,g.presentation.order):-1:g.presentation.group?1:a($.presentation.order,g.presentation.order):-1:g.presentation?1:0)}e.$wF=i;function a(S,$){return typeof S!="number"?typeof $!="number"?0:1:typeof $!="number"?-1:S-$}async function u(S,$){const g=S.getValue("debug.saveBeforeStart",{overrideIdentifier:$.activeTextEditorLanguageId});if(g!=="none"&&(await $.saveAll(),g==="allEditorsInActiveGroup")){const f=$.activeEditorPane;f&&f.input.resource?.scheme===A.Schemas.untitled&&await $.save({editor:f.input,groupId:f.group.id})}await S.reloadConfiguration()}e.$xF=u;const k=(S,$)=>!S||!$?S===$:S.name===$.name&&S.path===$.path&&S.sourceReference===$.sourceReference;e.$yF=k}),define(De[272],Ce([1,0,48,60,23,16,12,15,29,220,140]),function(me,e,C,T,d,M,A,b,E,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3dc=e.$2dc=e.$1dc=e.$Zdc=e.$Ydc=void 0;class I extends R.$Xcb{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.l=/: */}constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(s,r){this.p=r,this.r=Buffer.allocUnsafe(0),this.t=-1,s.on("data",c=>this.w(c))}sendMessage(s){if(this.p){const r=JSON.stringify(s);this.p.write(`Content-Length: ${Buffer.byteLength(r,"utf8")}${I.a}${r}`,"utf8")}}w(s){for(this.r=Buffer.concat([this.r,s]);;){if(this.t>=0){if(this.r.length>=this.t){const r=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,r.length>0)try{this.acceptMessage(JSON.parse(r))}catch(c){this.m.fire(new Error((c.message||c)+`
`+r))}continue}}else{const r=this.r.indexOf(I.a);if(r!==-1){const m=this.r.toString("utf8",0,r).split(I.b);for(const h of m){const t=h.split(I.l);t[0]==="Content-Length"&&(this.t=Number(t[1]))}this.r=this.r.slice(r+I.a.length);continue}}break}}}e.$Ydc=I;class p extends I{startSession(){return new Promise((s,r)=>{let c=!1;this.x=this.y(()=>{this.v(this.x,this.x),s(),c=!0}),this.x.on("close",()=>{c?this.m.fire(new Error("connection closed")):r(new Error("connection closed"))}),this.x.on("error",m=>{c?this.m.fire(m):r(m)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.$Zdc=p;class y extends p{constructor(s){super(),this.z=s}y(s){return T.createConnection(this.z.port,this.z.host||"127.0.0.1",s)}}e.$1dc=y;class D extends p{constructor(s){super(),this.z=s}y(s){return T.createConnection(this.z.path,s)}}e.$2dc=D;class v extends I{constructor(s,r){super(),this.y=s,this.z=r}async startSession(){const s=this.y.command,r=this.y.args,c=this.y.options||{};try{if(s)if(M.$hc(s)){if(!await E.Promises.exists(s))throw new Error(w.localize(0,null,s))}else s.indexOf("/")<0&&s.indexOf("\\")<0;else throw new Error(w.localize(1,null,this.z));let m=process.env;if(c.env&&Object.keys(c.env).length>0&&(m=d.$5m(d.$2m(process.env),c.env)),s==="node")if(Array.isArray(r)&&r.length>0){const h=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:m,execArgv:h?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};c.cwd&&(t.cwd=c.cwd);const n=C.fork(r[0],r.slice(1),t);if(!n.pid)throw new Error(w.localize(2,null,r[0]));this.x=n}else throw new Error(w.localize(3,null));else{const h={env:m};c.cwd&&(h.cwd=c.cwd),this.x=C.spawn(s,r,h)}this.x.on("error",h=>{this.m.fire(h)}),this.x.on("exit",(h,t)=>{this.n.fire(h)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",h=>{this.m.fire(h)}),this.x.stdin.on("error",h=>{this.m.fire(h)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch(m){this.m.fire(m)}}async stopSession(){return this.x?(await this.u(),A.$j?new Promise((s,r)=>{const c=C.exec(`taskkill /F /T /PID ${this.x.pid}`,function(m,h,t){if(m)return r(m)});c.on("exit",s),c.on("error",r)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(s,r){if(!s)return;const c=Object.create(null);s.runtime&&(s.runtime.indexOf("./")===0?c.runtime=M.$ic(r,s.runtime):c.runtime=s.runtime),s.runtimeArgs&&(c.runtimeArgs=s.runtimeArgs),s.program&&(M.$hc(s.program)?c.program=s.program:c.program=M.$ic(r,s.program)),s.args&&(c.args=s.args);const m=s;return m.win&&(c.win=v.A(m.win,r)),m.winx86&&(c.winx86=v.A(m.winx86,r)),m.windows&&(c.windows=v.A(m.windows,r)),m.osx&&(c.osx=v.A(m.osx,r)),m.linux&&(c.linux=v.A(m.linux,r)),c}static platformAdapterExecutable(s,r){let c=Object.create(null);r=r.toLowerCase();for(const i of s)if(i.contributes){const a=i.contributes.debuggers;a&&a.length>0&&a.filter(u=>typeof u.type=="string"&&b.$1e(u.type,r)).forEach(u=>{const k=v.A(u,i.extensionLocation.fsPath);c=d.$5m(c,k,i.isBuiltin)})}let m;A.$j&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?m=c.winx86||c.win||c.windows:A.$j?m=c.win||c.windows:A.$k?m=c.osx:A.$l&&(m=c.linux),m=m||c;const h=m.program||c.program,t=m.args||c.args,n=m.runtime||c.runtime,o=m.runtimeArgs||c.runtimeArgs;if(n)return{type:"executable",command:n,args:(o||[]).concat(typeof h=="string"?[h]:[]).concat(t||[])};if(h)return{type:"executable",command:h,args:t||[]}}}e.$3dc=v}),define(De[273],Ce([1,0,48,32,12]),function(me,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5dc=e.$4dc=void 0;function M(w,R){return new Promise((I,p)=>{let y="";const D=C.spawn(w,R);D.pid&&D.stdout.on("data",v=>{y+=v.toString()}),D.on("error",v=>{p(v)}),D.on("close",v=>{I(y)})})}async function A(w){if(w)if(d.$j){const R=await new Promise((I,p)=>{me(["@vscode/windows-process-tree"],I,p)});return new Promise(I=>{R.getProcessTree(w,p=>{I(!!p&&p.children.length>0)})})}else return M("/usr/bin/pgrep",["-lP",String(w)]).then(R=>{const I=R.trim();return!(I.length===0||I.indexOf(" tmux")>=0)},R=>!0);return Promise.resolve(!0)}e.$4dc=A;var b;(function(w){w[w.cmd=0]="cmd",w[w.powershell=1]="powershell",w[w.bash=2]="bash"})(b||(b={}));function E(w,R,I,p,y){w=w.trim().toLowerCase();let D;w.indexOf("powershell")>=0||w.indexOf("pwsh")>=0?D=1:w.indexOf("cmd.exe")>=0?D=0:w.indexOf("bash")>=0?D=2:d.$j?D=0:D=2;let v,l=" ";switch(D){case 1:if(v=s=>(s=s.replace(/\'/g,"''"),s.length>0&&s.charAt(s.length-1)==="\\"?`'${s}\\'`:`'${s}'`),p){const s=(0,T.$2f)(p);s&&(l+=`${s}:; `),l+=`cd ${v(p)}; `}if(y)for(const s in y){const r=y[s];r===null?l+=`Remove-Item env:${s}; `:l+=`\${env:${s}}='${r}'; `}if(R.length>0){const s=R.shift(),r=I?s:v(s);l+=r[0]==="'"?`& ${r} `:`${r} `;for(const c of R)l+=c==="<"||c===">"||I?c:v(c),l+=" "}break;case 0:if(v=s=>(s=s.replace(/\"/g,'""'),s=s.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(r=>s.includes(r))||s.length===0?`"${s}"`:s),p){const s=(0,T.$2f)(p);s&&(l+=`${s}: && `),l+=`cd ${v(p)} && `}if(y){l+='cmd /C "';for(const s in y){let r=y[s];r===null?l+=`set "${s}=" && `:(r=r.replace(/[&^|<>]/g,c=>`^${c}`),l+=`set "${s}=${r}" && `)}}for(const s of R)l+=s==="<"||s===">"||I?s:v(s),l+=" ";y&&(l+='"');break;case 2:{v=r=>(r=r.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),r.length===0?'""':r);const s=r=>/[^\w@%\/+=,.:^-]/.test(r)?`'${r.replace(/'/g,"'\\''")}'`:r;if(p&&(l+=`cd ${v(p)} ; `),y){l+="/usr/bin/env";for(const r in y){const c=y[r];c===null?l+=` -u ${s(r)}`:l+=` ${s(`${r}=${c}`)}`}l+=" "}for(const r of R)l+=r==="<"||r===">"||I?r:v(r),l+=" ";break}}return l}e.$5dc=E}),define(De[108],Ce([1,0,22,35,50,97,17,16,12,41]),function(me,e,C,T,d,M,A,b,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nI=e.$mI=e.$lI=e.$kI=e.CellStatusbarAlignment=e.$jI=e.$iI=e.$hI=e.NotebookEditorPriority=e.$gI=e.$fI=e.$eI=e.$dI=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$cI=e.$bI=e.$aI=e.$_H=e.CellKind=e.$$H=e.$0H=e.$9H=void 0,e.$9H="workbench.editor.notebook",e.$0H="workbench.editor.notebookTextDiffEditor",e.$$H="workbench.editor.interactive";var R;(function(F){F[F.Markup=1]="Markup",F[F.Code=2]="Code"})(R||(e.CellKind=R={})),e.$_H=["application/json","application/javascript","text/html","image/svg+xml",M.$Lr.latex,M.$Lr.markdown,"image/png","image/jpeg",M.$Lr.text],e.$aI=[M.$Lr.latex,M.$Lr.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",M.$Lr.text],e.$bI=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$cI="_notAvailable";var I;(function(F){F[F.Running=1]="Running",F[F.Idle=2]="Idle"})(I||(e.NotebookRunState=I={}));var p;(function(F){F[F.Unconfirmed=1]="Unconfirmed",F[F.Pending=2]="Pending",F[F.Executing=3]="Executing"})(p||(e.NotebookCellExecutionState=p={}));var y;(function(F){F[F.Unconfirmed=1]="Unconfirmed",F[F.Pending=2]="Pending",F[F.Executing=3]="Executing"})(y||(e.NotebookExecutionState=y={}));var D;(function(F){F[F.WithHardKernelDependency=0]="WithHardKernelDependency",F[F.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",F[F.Pure=2]="Pure",F[F.Never=3]="Never"})(D||(e.NotebookRendererMatch=D={}));var v;(function(F){F.Always="always",F.Never="never",F.Optional="optional"})(v||(e.RendererMessagingSpec=v={}));var l;(function(F){F[F.ModelChange=1]="ModelChange",F[F.Move=2]="Move",F[F.ChangeCellLanguage=5]="ChangeCellLanguage",F[F.Initialize=6]="Initialize",F[F.ChangeCellMetadata=7]="ChangeCellMetadata",F[F.Output=8]="Output",F[F.OutputItem=9]="OutputItem",F[F.ChangeCellContent=10]="ChangeCellContent",F[F.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",F[F.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",F[F.ChangeCellMime=13]="ChangeCellMime",F[F.Unknown=100]="Unknown"})(l||(e.NotebookCellsChangeType=l={}));var s;(function(F){F[F.Handle=0]="Handle",F[F.Index=1]="Index"})(s||(e.SelectionStateType=s={}));var r;(function(F){F[F.Replace=1]="Replace",F[F.Output=2]="Output",F[F.Metadata=3]="Metadata",F[F.CellLanguage=4]="CellLanguage",F[F.DocumentMetadata=5]="DocumentMetadata",F[F.Move=6]="Move",F[F.OutputItems=7]="OutputItems",F[F.PartialMetadata=8]="PartialMetadata",F[F.PartialInternalMetadata=9]="PartialInternalMetadata"})(r||(e.CellEditType=r={}));var c;(function(F){F.scheme=A.Schemas.vscodeNotebookCell;const H=["W","X","Y","Z","a","b","c","d","e","f"],K=new RegExp(`^[${H.join("")}]+`),fe=7;function x(ve,J){const U=J.toString(fe),ge=`${U.length<H.length?H[U.length-1]:"z"}${U}s${(0,C.$ue)(C.$ae.fromString(ve.scheme),!0,!0)}`;return ve.with({scheme:F.scheme,fragment:ge})}F.generate=x;function Z(ve){if(ve.scheme!==F.scheme)return;const J=ve.fragment.indexOf("s");if(J<0)return;const U=parseInt(ve.fragment.substring(0,J).replace(K,""),fe),V=(0,C.$te)(ve.fragment.substring(J+1)).toString();if(!isNaN(U))return{handle:U,notebook:ve.with({scheme:V,fragment:null})}}F.parse=Z;function q(ve,J){return ve.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${J??""},${ve.scheme!==A.Schemas.file?ve.scheme:""}`})}F.generateCellOutputUri=q;function Y(ve){if(ve.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const J=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ve.fragment);if(!J)return;const U=J[1]&&J[1]!==""?J[1]:void 0,V=J[2];return{outputId:U,notebook:ve.with({scheme:V||A.Schemas.file,fragment:null})}}F.parseCellOutputUri=Y;function be(ve,J,U){return F.generate(ve,J).with({scheme:U})}F.generateCellPropertyUri=be;function ue(ve,J){if(ve.scheme===J)return F.parse(ve.with({scheme:F.scheme}))}F.parseCellPropertyUri=ue})(c||(e.CellUri=c={}));const m=F=>E.$j?F.replace(/\//g,"\\"):F;class h{constructor(H=[],K=e.$_H){this.e=K,this.d=[...new Set(H)].map(fe=>({pattern:fe,matches:T.$uj(m(fe))}))}sort(H){const K=new Map(d.Iterable.map(H,x=>[x,m(x)]));let fe=[];for(const{matches:x}of this.d)for(const[Z,q]of K)if(x(q)){fe.push(Z),K.delete(Z);break}return K.size&&(fe=fe.concat([...K.keys()].sort((x,Z)=>this.e.indexOf(x)-this.e.indexOf(Z)))),fe}prioritize(H,K){const fe=this.f(H);if(fe===-1){this.d.unshift({pattern:H,matches:T.$uj(m(H))});return}const x=new Set(K.map(q=>this.f(q,fe)));x.delete(-1);const Z=Array.from(x).sort();this.d.splice(fe+1,0,...Z.map(q=>this.d[q]));for(let q=Z.length-1;q>=0;q--)this.d.splice(Z[q],1)}toArray(){return this.d.map(H=>H.pattern)}f(H,K=this.d.length){const fe=m(H);for(let x=0;x<K;x++)if(this.d[x].matches(fe))return x;return-1}}e.$dI=h;function t(F,H,K,fe=(x,Z)=>x===Z){const x=[];function Z(be,ue,ve){if(ue===0&&ve.length===0)return;const J=x[x.length-1];J&&J.start+J.deleteCount===be?(J.deleteCount+=ue,J.toInsert.push(...ve)):x.push({start:be,deleteCount:ue,toInsert:ve})}let q=0,Y=0;for(;;){if(q===F.length){Z(q,0,H.slice(Y));break}if(Y===H.length){Z(q,F.length-q,[]);break}const be=F[q],ue=H[Y];if(fe(be,ue)){q+=1,Y+=1;continue}K(ue)?(Z(q,1,[]),q+=1):(Z(q,0,[ue]),Y+=1)}return x}e.$eI=t,e.$fI=new w.$5i("notebookEditorCursorAtBoundary","none"),e.$gI=new w.$5i("notebookEditorCursorAtLineBoundary","none");var n;(function(F){F.default="default",F.option="option"})(n||(e.NotebookEditorPriority=n={}));function o(F){const H=F;return!!((typeof H.include=="string"||T.$vj(H.include))&&(typeof H.exclude=="string"||T.$vj(H.exclude)))}e.$hI=o;function i(F,H,K){if(Array.isArray(F.viewType)&&F.viewType.indexOf(H)>=0||F.viewType===H)return!0;if(F.filenamePattern){const fe=o(F.filenamePattern)?F.filenamePattern.include:F.filenamePattern,x=o(F.filenamePattern)?F.filenamePattern.exclude:void 0;if(T.$tj(fe,(0,b.$mc)(K.fsPath).toLowerCase()))return!(x&&T.$tj(x,(0,b.$mc)(K.fsPath).toLowerCase()))}return!1}e.$iI=i,e.$jI={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell"};var a;(function(F){F[F.Left=1]="Left",F[F.Right=2]="Right"})(a||(e.CellStatusbarAlignment=a={}));class u{static{this.d="notebook/"}static create(H){return`${u.d}${H}`}static parse(H){if(H.startsWith(u.d))return H.substring(u.d.length)}}e.$kI=u;function k(F){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(F)}e.$lI=k;const S=new TextDecoder;function $(F){const H=[];let K=!1;for(const q of F)(H.length===0||K)&&(H.push(q),K=!0);let fe=P(H);const x=C.$ae.concat(H.map(q=>C.$ae.wrap(q))),Z=z(x);return fe=fe||Z.byteLength!==x.byteLength,{data:Z,didCompression:fe}}e.$mI=$,e.$nI=`${String.fromCharCode(27)}[A`;const g=e.$nI.split("").map(F=>F.charCodeAt(0)),f=10;function P(F){let H=!1;return F.forEach((K,fe)=>{if(fe===0||K.length<e.$nI.length)return;const x=F[fe-1],Z=K.subarray(0,e.$nI.length);if(Z[0]===g[0]&&Z[1]===g[1]&&Z[2]===g[2]){const q=x.lastIndexOf(f);if(q===-1)return;H=!0,F[fe-1]=x.subarray(0,q),F[fe]=K.subarray(e.$nI.length)}}),H}function N(F){let H=F;do F=H,H=F.replace(/[^\n]\x08/gm,"");while(H.length<F.length);return F}function O(F){for(F=F.replace(/\r+\n/gm,`
`);F.search(/\r[^$]/g)>-1;){const H=F.match(/^(.*)\r+/m)[1];let K=F.match(/\r+(.*)$/m)[1];K=K+H.slice(K.length,H.length),F=F.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,K)}return F}const L="\b".charCodeAt(0),j="\r".charCodeAt(0);function z(F){return!F.buffer.includes(L)&&!F.buffer.includes(j)?F:C.$ae.fromString(O(N(S.decode(F.buffer))))}}),define(De[7],Ce([1,0,19,8,79,28,97,15,18,2,31,25,30,64,108]),function(me,e,C,T,d,M,A,b,E,w,R,I,p,y,D){"use strict";var v,l,s,r,c,m,h,t,n,o,i,a,u,k,S,$,g,f;Object.defineProperty(e,"__esModule",{value:!0}),e.RelatedInformationType=e.$2L=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$1L=e.$ZL=e.$YL=e.$XL=e.$WL=e.$VL=e.$UL=e.$TL=e.$SL=e.$RL=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$QL=e.$PL=e.$OL=e.$NL=e.$ML=e.$LL=e.$KL=e.$JL=e.TestRunProfileKind=e.TestResultState=e.$IL=e.$HL=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$GL=e.$FL=e.$EL=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$DL=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$CL=e.$BL=e.$AL=e.$zL=e.$yL=e.ColorThemeKind=e.$xL=e.$wL=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$vL=e.DebugConsoleMode=e.$uL=e.$tL=e.$sL=e.$rL=e.$qL=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$pL=e.$oL=e.FileChangeType=e.$nL=e.$mL=e.$lL=e.$kL=e.InlineCompletionTriggerKind=e.$jL=e.$iL=e.$hL=e.$gL=e.$fL=e.$eL=e.$dL=e.$cL=e.$bL=e.$aL=e.$_K=e.$$K=e.$0K=e.ConfigurationTarget=e.$9K=e.$8K=e.$7K=e.$6K=e.$5K=e.$4K=e.$3K=e.$2K=e.$1K=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$ZK=e.ViewBadge=e.ProgressLocation=e.$YK=e.$XK=e.TaskScope=e.ShellQuoting=e.$WK=e.$VK=e.$UK=e.TaskPanelKind=e.TaskRevealKind=e.$TK=e.TerminalLocation=e.$SK=e.$RK=e.$QK=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$PK=e.$OK=e.$NK=e.$MK=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$LK=e.StatusBarAlignment=e.ViewColumn=e.$KK=e.$JK=e.$IK=e.$HK=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$GK=e.$FK=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$EK=e.$DK=e.$CK=e.$BK=e.$AK=e.LanguageStatusSeverity=e.$zK=e.$yK=e.$xK=e.$wK=e.$vK=e.$uK=e.CodeActionTriggerKind=e.$tK=e.$sK=e.SymbolTag=e.SymbolKind=e.$rK=e.DocumentHighlightKind=e.$qK=e.$pK=e.$oK=e.$nK=e.DiagnosticSeverity=e.DiagnosticTag=e.$mK=e.$lK=e.FileEditType=e.$kK=e.$jK=e.$iK=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$hK=e.$gK=e.$fK=e.$eK=e.$dK=e.$cK=e.$bK=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function P(G){return Object.assign(G,{apply:function(...pe){if(pe.length===0)return Reflect.construct(G,[]);{const Re=pe.length===1?[]:pe[1];return Reflect.construct(G,Re,pe[0].constructor)}},call:function(...pe){if(pe.length===0)return Reflect.construct(G,[]);{const[Re,...Qe]=pe;return Reflect.construct(G,Qe,Re.constructor)}}})}var N;(function(G){G[G.Top=0]="Top",G[G.Bottom=1]="Bottom"})(N||(e.TerminalOutputAnchor=N={}));var O;(function(G){G[G.TerminalCommand=0]="TerminalCommand",G[G.Opener=1]="Opener",G[G.Command=3]="Command"})(O||(e.TerminalQuickFixType=O={}));let L=v=class{static from(...W){let pe=W;return new v(function(){if(pe){for(const Re of pe)Re&&typeof Re.dispose=="function"&&Re.dispose();pe=void 0}})}#e;constructor(W){this.#e=W}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$bK=L,e.$bK=L=v=He([P],L);let j=l=class{static Min(...W){if(W.length===0)throw new TypeError;let pe=W[0];for(let Re=1;Re<W.length;Re++){const Qe=W[Re];Qe.isBefore(pe)&&(pe=Qe)}return pe}static Max(...W){if(W.length===0)throw new TypeError;let pe=W[0];for(let Re=1;Re<W.length;Re++){const Qe=W[Re];Qe.isAfter(pe)&&(pe=Qe)}return pe}static isPosition(W){if(!W)return!1;if(W instanceof l)return!0;const{line:pe,character:Re}=W;return typeof pe=="number"&&typeof Re=="number"}static of(W){if(W instanceof l)return W;if(this.isPosition(W))return new l(W.line,W.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(W,pe){if(W<0)throw(0,T.$6)("line must be non-negative");if(pe<0)throw(0,T.$6)("character must be non-negative");this.c=W,this.e=pe}isBefore(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<W.e}isBeforeOrEqual(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<=W.e}isAfter(W){return!this.isBeforeOrEqual(W)}isAfterOrEqual(W){return!this.isBefore(W)}isEqual(W){return this.c===W.c&&this.e===W.e}compareTo(W){return this.c<W.c?-1:this.c>W.line?1:this.e<W.e?-1:this.e>W.e?1:0}translate(W,pe=0){if(W===null||pe===null)throw(0,T.$6)();let Re;return typeof W>"u"?Re=0:typeof W=="number"?Re=W:(Re=typeof W.lineDelta=="number"?W.lineDelta:0,pe=typeof W.characterDelta=="number"?W.characterDelta:0),Re===0&&pe===0?this:new l(this.line+Re,this.character+pe)}with(W,pe=this.character){if(W===null||pe===null)throw(0,T.$6)();let Re;return typeof W>"u"?Re=this.line:typeof W=="number"?Re=W:(Re=typeof W.line=="number"?W.line:this.line,pe=typeof W.character=="number"?W.character:this.character),Re===this.line&&pe===this.character?this:new l(Re,pe)}toJSON(){return{line:this.line,character:this.character}}};e.$cK=j,e.$cK=j=l=He([P],j);let z=s=class{static isRange(W){return W instanceof s?!0:W?j.isPosition(W.start)&&j.isPosition(W.end):!1}static of(W){if(W instanceof s)return W;if(this.isRange(W))return new s(W.start,W.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(W,pe,Re,Qe){let tt,at;if(typeof W=="number"&&typeof pe=="number"&&typeof Re=="number"&&typeof Qe=="number"?(tt=new j(W,pe),at=new j(Re,Qe)):j.isPosition(W)&&j.isPosition(pe)&&(tt=j.of(W),at=j.of(pe)),!tt||!at)throw new Error("Invalid arguments");tt.isBefore(at)?(this.c=tt,this.e=at):(this.c=at,this.e=tt)}contains(W){return s.isRange(W)?this.contains(W.start)&&this.contains(W.end):j.isPosition(W)?!(j.of(W).isBefore(this.c)||this.e.isBefore(W)):!1}isEqual(W){return this.c.isEqual(W.c)&&this.e.isEqual(W.e)}intersection(W){const pe=j.Max(W.start,this.c),Re=j.Min(W.end,this.e);if(!pe.isAfter(Re))return new s(pe,Re)}union(W){if(this.contains(W))return this;if(W.contains(this))return W;const pe=j.Min(W.start,this.c),Re=j.Max(W.end,this.end);return new s(pe,Re)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(W,pe=this.end){if(W===null||pe===null)throw(0,T.$6)();let Re;return W?j.isPosition(W)?Re=W:(Re=W.start||this.start,pe=W.end||this.end):Re=this.start,Re.isEqual(this.c)&&pe.isEqual(this.end)?this:new s(Re,pe)}toJSON(){return[this.start,this.end]}};e.$dK=z,e.$dK=z=s=He([P],z);let F=r=class extends z{static isSelection(W){return W instanceof r?!0:W?z.isRange(W)&&j.isPosition(W.anchor)&&j.isPosition(W.active)&&typeof W.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(W,pe,Re,Qe){let tt,at;if(typeof W=="number"&&typeof pe=="number"&&typeof Re=="number"&&typeof Qe=="number"?(tt=new j(W,pe),at=new j(Re,Qe)):j.isPosition(W)&&j.isPosition(pe)&&(tt=j.of(W),at=j.of(pe)),!tt||!at)throw new Error("Invalid arguments");super(tt,at),this.f=tt,this.g=at}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$eK=F,e.$eK=F=r=He([P],F);const H=G=>{if(typeof G!="string"||G.length===0||!/^[0-9A-Za-z_\-]+$/.test(G))throw(0,T.$6)("connectionToken")};class K{static isResolvedAuthority(W){return W&&typeof W=="object"&&typeof W.host=="string"&&typeof W.port=="number"&&(W.connectionToken===void 0||typeof W.connectionToken=="string")}constructor(W,pe,Re){if(typeof W!="string"||W.length===0)throw(0,T.$6)("host");if(typeof pe!="number"||pe===0||Math.round(pe)!==pe)throw(0,T.$6)("port");typeof Re<"u"&&H(Re),this.host=W,this.port=Math.round(pe),this.connectionToken=Re}}e.$fK=K;class fe{static isManagedResolvedAuthority(W){return W&&typeof W=="object"&&typeof W.makeConnection=="function"&&(W.connectionToken===void 0||typeof W.connectionToken=="string")}constructor(W,pe){this.makeConnection=W,this.connectionToken=pe,typeof pe<"u"&&H(pe)}}e.$gK=fe;class x extends Error{static NotAvailable(W,pe){return new x(W,y.RemoteAuthorityResolverErrorCode.NotAvailable,pe)}static TemporarilyNotAvailable(W){return new x(W,y.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(W,pe=y.RemoteAuthorityResolverErrorCode.Unknown,Re){super(W),this._message=W,this._code=pe,this._detail=Re,Object.setPrototypeOf(this,x.prototype)}}e.$hK=x;var Z;(function(G){G[G.LF=1]="LF",G[G.CRLF=2]="CRLF"})(Z||(e.EndOfLine=Z={}));var q;(function(G){G[G.Replace=1]="Replace",G[G.Append=2]="Append",G[G.Prepend=3]="Prepend"})(q||(e.EnvironmentVariableMutatorType=q={}));let Y=c=class{static isTextEdit(W){return W instanceof c?!0:W?z.isRange(W)&&typeof W.newText=="string":!1}static replace(W,pe){return new c(W,pe)}static insert(W,pe){return c.replace(new z(W,W),pe)}static delete(W){return c.replace(W,"")}static setEndOfLine(W){const pe=new c(new z(new j(0,0),new j(0,0)),"");return pe.newEol=W,pe}get range(){return this.c}set range(W){if(W&&!z.isRange(W))throw(0,T.$6)("range");this.c=W}get newText(){return this.e||""}set newText(W){if(W&&typeof W!="string")throw(0,T.$6)("newText");this.e=W}get newEol(){return this.f}set newEol(W){if(W&&typeof W!="number")throw(0,T.$6)("newEol");this.f=W}constructor(W,pe){this.c=W,this.e=pe}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$iK=Y,e.$iK=Y=c=He([P],Y);let be=m=class{static isNotebookCellEdit(W){return W instanceof m?!0:W?xt.isNotebookRange(W)&&Array.isArray(W.newCells):!1}static replaceCells(W,pe){return new m(W,pe)}static insertCells(W,pe){return new m(new xt(W,W),pe)}static deleteCells(W){return new m(W,[])}static updateCellMetadata(W,pe){const Re=new m(new xt(W,W),[]);return Re.newCellMetadata=pe,Re}static updateNotebookMetadata(W){const pe=new m(new xt(0,0),[]);return pe.newNotebookMetadata=W,pe}constructor(W,pe){this.range=W,this.newCells=pe}};e.$jK=be,e.$jK=be=m=He([P],be);class ue{static isSnippetTextEdit(W){return W instanceof ue?!0:W?z.isRange(W.range)&&U.isSnippetString(W.snippet):!1}static replace(W,pe){return new ue(W,pe)}static insert(W,pe){return ue.replace(new z(W,W),pe)}constructor(W,pe){this.range=W,this.snippet=pe}}e.$kK=ue;var ve;(function(G){G[G.File=1]="File",G[G.Text=2]="Text",G[G.Cell=3]="Cell",G[G.CellReplace=5]="CellReplace",G[G.Snippet=6]="Snippet"})(ve||(e.FileEditType=ve={}));let J=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(W,pe,Re,Qe){this.c.push({_type:1,from:W,to:pe,options:Re,metadata:Qe})}createFile(W,pe,Re){this.c.push({_type:1,from:void 0,to:W,options:pe,metadata:Re})}deleteFile(W,pe,Re){this.c.push({_type:1,from:W,to:void 0,options:pe,metadata:Re})}e(W,pe,Re){this.c.push({_type:3,metadata:Re,uri:W,edit:{editType:5,metadata:pe},notebookMetadata:pe})}f(W,pe,Re,Qe){const tt=pe.start,at=pe.end;(tt!==at||Re.length>0)&&this.c.push({_type:5,uri:W,index:tt,count:at-tt,cells:Re,metadata:Qe})}g(W,pe,Re,Qe){this.c.push({_type:3,metadata:Qe,uri:W,edit:{editType:3,index:pe,metadata:Re}})}replace(W,pe,Re,Qe){this.c.push({_type:2,uri:W,edit:new Y(pe,Re),metadata:Qe})}insert(W,pe,Re,Qe){this.replace(W,new z(pe,pe),Re,Qe)}delete(W,pe,Re){this.replace(W,pe,"",Re)}has(W){return this.c.some(pe=>pe._type===2&&pe.uri.toString()===W.toString())}set(W,pe){if(pe)for(const Re of pe){if(!Re)continue;let Qe,tt;Array.isArray(Re)?(Qe=Re[0],tt=Re[1]):Qe=Re,be.isNotebookCellEdit(Qe)?Qe.newCellMetadata?this.g(W,Qe.range.start,Qe.newCellMetadata,tt):Qe.newNotebookMetadata?this.e(W,Qe.newNotebookMetadata,tt):this.f(W,Qe.range,Qe.newCells,tt):ue.isSnippetTextEdit(Qe)?this.c.push({_type:6,uri:W,range:Qe.range,edit:Qe.snippet,metadata:tt}):this.c.push({_type:2,uri:W,edit:Qe,metadata:tt})}else{for(let Re=0;Re<this.c.length;Re++){const Qe=this.c[Re];switch(Qe._type){case 2:case 6:case 3:case 5:Qe.uri.toString()===W.toString()&&(this.c[Re]=void 0);break}}(0,C.$Hb)(this.c)}}get(W){const pe=[];for(const Re of this.c)Re._type===2&&Re.uri.toString()===W.toString()&&pe.push(Re.edit);return pe}entries(){const W=new M.$zc;for(const pe of this.c)if(pe._type===2){let Re=W.get(pe.uri);Re||(Re=[pe.uri,[]],W.set(pe.uri,Re)),Re[1].push(pe.edit)}return[...W.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$lK=J,e.$lK=J=He([P],J);let U=h=class{static isSnippetString(W){return W instanceof h?!0:W?typeof W.value=="string":!1}static c(W){return W.replace(/\$|}|\\/g,"\\$&")}constructor(W){this.e=1,this.value=W||""}appendText(W){return this.value+=h.c(W),this}appendTabstop(W=this.e++){return this.value+="$",this.value+=W,this}appendPlaceholder(W,pe=this.e++){if(typeof W=="function"){const Re=new h;Re.e=this.e,W(Re),this.e=Re.e,W=Re.value}else W=h.c(W);return this.value+="${",this.value+=pe,this.value+=":",this.value+=W,this.value+="}",this}appendChoice(W,pe=this.e++){const Re=W.map(Qe=>Qe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=pe,this.value+="|",this.value+=Re,this.value+="|}",this}appendVariable(W,pe){if(typeof pe=="function"){const Re=new h;Re.e=this.e,pe(Re),this.e=Re.e,pe=Re.value}else typeof pe=="string"&&(pe=pe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=W,pe&&(this.value+=":",this.value+=pe),this.value+="}",this}};e.$mK=U,e.$mK=U=h=He([P],U);var V;(function(G){G[G.Unnecessary=1]="Unnecessary",G[G.Deprecated=2]="Deprecated"})(V||(e.DiagnosticTag=V={}));var ge;(function(G){G[G.Hint=3]="Hint",G[G.Information=2]="Information",G[G.Warning=1]="Warning",G[G.Error=0]="Error"})(ge||(e.DiagnosticSeverity=ge={}));let _=t=class{static isLocation(W){return W instanceof t?!0:W?z.isRange(W.range)&&w.URI.isUri(W.uri):!1}constructor(W,pe){if(this.uri=W,pe)if(z.isRange(pe))this.range=z.of(pe);else if(j.isPosition(pe))this.range=new z(pe,pe);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$nK=_,e.$nK=_=t=He([P],_);let ie=class{static is(W){return W?typeof W.message=="string"&&W.location&&z.isRange(W.location.range)&&w.URI.isUri(W.location.uri):!1}constructor(W,pe){this.location=W,this.message=pe}static isEqual(W,pe){return W===pe?!0:!W||!pe?!1:W.message===pe.message&&W.location.range.isEqual(pe.location.range)&&W.location.uri.toString()===pe.location.uri.toString()}};e.$oK=ie,e.$oK=ie=He([P],ie);let re=class{constructor(W,pe,Re=ge.Error){if(!z.isRange(W))throw new TypeError("range must be set");if(!pe)throw new TypeError("message must be set");this.range=W,this.message=pe,this.severity=Re}toJSON(){return{severity:ge[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(W,pe){return W===pe?!0:!W||!pe?!1:W.message===pe.message&&W.severity===pe.severity&&W.code===pe.code&&W.severity===pe.severity&&W.source===pe.source&&W.range.isEqual(pe.range)&&(0,C.$tb)(W.tags,pe.tags)&&(0,C.$tb)(W.relatedInformation,pe.relatedInformation,ie.isEqual)}};e.$pK=re,e.$pK=re=He([P],re);let Ee=class{constructor(W,pe){if(!W)throw new Error("Illegal argument, contents must be defined");Array.isArray(W)?this.contents=W:this.contents=[W],this.range=pe}};e.$qK=Ee,e.$qK=Ee=He([P],Ee);var oe;(function(G){G[G.Text=0]="Text",G[G.Read=1]="Read",G[G.Write=2]="Write"})(oe||(e.DocumentHighlightKind=oe={}));let he=class{constructor(W,pe=oe.Text){this.range=W,this.kind=pe}toJSON(){return{range:this.range,kind:oe[this.kind]}}};e.$rK=he,e.$rK=he=He([P],he);var ee;(function(G){G[G.File=0]="File",G[G.Module=1]="Module",G[G.Namespace=2]="Namespace",G[G.Package=3]="Package",G[G.Class=4]="Class",G[G.Method=5]="Method",G[G.Property=6]="Property",G[G.Field=7]="Field",G[G.Constructor=8]="Constructor",G[G.Enum=9]="Enum",G[G.Interface=10]="Interface",G[G.Function=11]="Function",G[G.Variable=12]="Variable",G[G.Constant=13]="Constant",G[G.String=14]="String",G[G.Number=15]="Number",G[G.Boolean=16]="Boolean",G[G.Array=17]="Array",G[G.Object=18]="Object",G[G.Key=19]="Key",G[G.Null=20]="Null",G[G.EnumMember=21]="EnumMember",G[G.Struct=22]="Struct",G[G.Event=23]="Event",G[G.Operator=24]="Operator",G[G.TypeParameter=25]="TypeParameter"})(ee||(e.SymbolKind=ee={}));var le;(function(G){G[G.Deprecated=1]="Deprecated"})(le||(e.SymbolTag=le={}));let $e=n=class{static validate(W){if(!W.name)throw new Error("name must not be falsy")}constructor(W,pe,Re,Qe,tt){this.name=W,this.kind=pe,this.containerName=tt,typeof Re=="string"&&(this.containerName=Re),Qe instanceof _?this.location=Qe:Re instanceof z&&(this.location=new _(Qe,Re)),n.validate(this)}toJSON(){return{name:this.name,kind:ee[this.kind],location:this.location,containerName:this.containerName}}};e.$sK=$e,e.$sK=$e=n=He([P],$e);let Pe=o=class{static validate(W){if(!W.name)throw new Error("name must not be falsy");if(!W.range.contains(W.selectionRange))throw new Error("selectionRange must be contained in fullRange");W.children?.forEach(o.validate)}constructor(W,pe,Re,Qe,tt){this.name=W,this.detail=pe,this.kind=Re,this.range=Qe,this.selectionRange=tt,this.children=[],o.validate(this)}};e.$tK=Pe,e.$tK=Pe=o=He([P],Pe);var B;(function(G){G[G.Invoke=1]="Invoke",G[G.Automatic=2]="Automatic"})(B||(e.CodeActionTriggerKind=B={}));let Q=class{constructor(W,pe){this.title=W,this.kind=pe}};e.$uK=Q,e.$uK=Q=He([P],Q);let te=class{static{i=this}static{this.c="."}constructor(W){this.value=W}append(W){return new i(this.value?this.value+i.c+W:W)}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+i.c)}};e.$vK=te,e.$vK=te=i=He([P],te),te.Empty=new te(""),te.QuickFix=te.Empty.append("quickfix"),te.Refactor=te.Empty.append("refactor"),te.RefactorExtract=te.Refactor.append("extract"),te.RefactorInline=te.Refactor.append("inline"),te.RefactorMove=te.Refactor.append("move"),te.RefactorRewrite=te.Refactor.append("rewrite"),te.Source=te.Empty.append("source"),te.SourceOrganizeImports=te.Source.append("organizeImports"),te.SourceFixAll=te.Source.append("fixAll"),te.Notebook=te.Empty.append("notebook");let se=class{constructor(W,pe){if(this.range=W,this.parent=pe,pe&&!pe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$wK=se,e.$wK=se=He([P],se);class X{constructor(W,pe,Re,Qe,tt,at){this.kind=W,this.name=pe,this.detail=Re,this.uri=Qe,this.range=tt,this.selectionRange=at}}e.$xK=X;class de{constructor(W,pe){this.fromRanges=pe,this.from=W}}e.$yK=de;class ye{constructor(W,pe){this.fromRanges=pe,this.to=W}}e.$zK=ye;var je;(function(G){G[G.Information=0]="Information",G[G.Warning=1]="Warning",G[G.Error=2]="Error"})(je||(e.LanguageStatusSeverity=je={}));let We=class{constructor(W,pe){this.range=W,this.command=pe}get isResolved(){return!!this.command}};e.$AK=We,e.$AK=We=He([P],We);let _e=a=class{#e;static isMarkdownString(W){return W instanceof a?!0:W&&W.appendCodeblock&&W.appendMarkdown&&W.appendText&&W.value!==void 0}constructor(W,pe=!1){this.#e=new d.$1j(W,{supportThemeIcons:pe})}get value(){return this.#e.value}set value(W){this.#e.value=W}get isTrusted(){return this.#e.isTrusted}set isTrusted(W){this.#e.isTrusted=W}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(W){this.#e.supportThemeIcons=W}get supportHtml(){return this.#e.supportHtml}set supportHtml(W){this.#e.supportHtml=W}get baseUri(){return this.#e.baseUri}set baseUri(W){this.#e.baseUri=W}appendText(W){return this.#e.appendText(W),this}appendMarkdown(W){return this.#e.appendMarkdown(W),this}appendCodeblock(W,pe){return this.#e.appendCodeblock(pe??"",W),this}};e.$BK=_e,e.$BK=_e=a=He([P],_e);let Ye=class{constructor(W,pe){this.label=W,this.documentation=pe}};e.$CK=Ye,e.$CK=Ye=He([P],Ye);let it=class{constructor(W,pe){this.label=W,this.documentation=pe,this.parameters=[]}};e.$DK=it,e.$DK=it=He([P],it);let et=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$EK=et,e.$EK=et=He([P],et);var Ae;(function(G){G[G.Invoke=1]="Invoke",G[G.TriggerCharacter=2]="TriggerCharacter",G[G.ContentChange=3]="ContentChange"})(Ae||(e.SignatureHelpTriggerKind=Ae={}));var Ne;(function(G){G[G.Type=1]="Type",G[G.Parameter=2]="Parameter"})(Ne||(e.InlayHintKind=Ne={}));let qe=class{constructor(W){this.value=W}};e.$FK=qe,e.$FK=qe=He([P],qe);let Me=class{constructor(W,pe,Re){this.position=W,this.label=pe,this.kind=Re}};e.$GK=Me,e.$GK=Me=He([P],Me);var Ze;(function(G){G[G.Invoke=0]="Invoke",G[G.TriggerCharacter=1]="TriggerCharacter",G[G.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ze||(e.CompletionTriggerKind=Ze={}));var ce;(function(G){G[G.Text=0]="Text",G[G.Method=1]="Method",G[G.Function=2]="Function",G[G.Constructor=3]="Constructor",G[G.Field=4]="Field",G[G.Variable=5]="Variable",G[G.Class=6]="Class",G[G.Interface=7]="Interface",G[G.Module=8]="Module",G[G.Property=9]="Property",G[G.Unit=10]="Unit",G[G.Value=11]="Value",G[G.Enum=12]="Enum",G[G.Keyword=13]="Keyword",G[G.Snippet=14]="Snippet",G[G.Color=15]="Color",G[G.File=16]="File",G[G.Reference=17]="Reference",G[G.Folder=18]="Folder",G[G.EnumMember=19]="EnumMember",G[G.Constant=20]="Constant",G[G.Struct=21]="Struct",G[G.Event=22]="Event",G[G.Operator=23]="Operator",G[G.TypeParameter=24]="TypeParameter",G[G.User=25]="User",G[G.Issue=26]="Issue"})(ce||(e.CompletionItemKind=ce={}));var ae;(function(G){G[G.Deprecated=1]="Deprecated"})(ae||(e.CompletionItemTag=ae={}));let Ie=class{constructor(W,pe){this.label=W,this.kind=pe}toJSON(){return{label:this.label,kind:this.kind&&ce[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$HK=Ie,e.$HK=Ie=He([P],Ie);let Ve=class{constructor(W=[],pe=!1){this.items=W,this.isIncomplete=pe}};e.$IK=Ve,e.$IK=Ve=He([P],Ve);let ze=class{constructor(W,pe,Re){this.insertText=W,this.range=pe,this.command=Re}};e.$JK=ze,e.$JK=ze=He([P],ze);let Xe=class{constructor(W){this.commands=void 0,this.suppressSuggestions=void 0,this.items=W}};e.$KK=Xe,e.$KK=Xe=He([P],Xe);var rt;(function(G){G[G.Active=-1]="Active",G[G.Beside=-2]="Beside",G[G.One=1]="One",G[G.Two=2]="Two",G[G.Three=3]="Three",G[G.Four=4]="Four",G[G.Five=5]="Five",G[G.Six=6]="Six",G[G.Seven=7]="Seven",G[G.Eight=8]="Eight",G[G.Nine=9]="Nine"})(rt||(e.ViewColumn=rt={}));var ot;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(ot||(e.StatusBarAlignment=ot={}));function wt(G,W){return`${I.$2l.toKey(G)}.${W}`}e.$LK=wt;var Et;(function(G){G[G.Off=0]="Off",G[G.On=1]="On",G[G.Relative=2]="Relative"})(Et||(e.TextEditorLineNumbersStyle=Et={}));var Yt;(function(G){G[G.Manual=1]="Manual",G[G.AfterDelay=2]="AfterDelay",G[G.FocusOut=3]="FocusOut"})(Yt||(e.TextDocumentSaveReason=Yt={}));var Kt;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(Kt||(e.TextEditorRevealType=Kt={}));var pt;(function(G){G[G.Keyboard=1]="Keyboard",G[G.Mouse=2]="Mouse",G[G.Command=3]="Command"})(pt||(e.TextEditorSelectionChangeKind=pt={}));var Ut;(function(G){G[G.Undo=1]="Undo",G[G.Redo=2]="Redo"})(Ut||(e.TextDocumentChangeReason=Ut={}));var Ft;(function(G){G[G.OpenOpen=0]="OpenOpen",G[G.ClosedClosed=1]="ClosedClosed",G[G.OpenClosed=2]="OpenClosed",G[G.ClosedOpen=3]="ClosedOpen"})(Ft||(e.DecorationRangeBehavior=Ft={})),function(G){function W(pe){switch(pe){case"keyboard":return G.Keyboard;case"mouse":return G.Mouse;case"api":return G.Command}}G.fromValue=W}(pt||(e.TextEditorSelectionChangeKind=pt={}));var Bt;(function(G){G[G.Other=0]="Other",G[G.Comment=1]="Comment",G[G.String=2]="String",G[G.RegEx=3]="RegEx"})(Bt||(e.SyntaxTokenType=Bt={})),function(G){function W(pe){switch(pe){case G.Other:return"other";case G.Comment:return"comment";case G.String:return"string";case G.RegEx:return"regex"}return"other"}G.toString=W}(Bt||(e.SyntaxTokenType=Bt={}));let Pt=class{constructor(W,pe){if(pe&&!w.URI.isUri(pe))throw(0,T.$6)("target");if(!z.isRange(W)||W.isEmpty)throw(0,T.$6)("range");this.range=W,this.target=pe}};e.$MK=Pt,e.$MK=Pt=He([P],Pt);let At=class{constructor(W,pe,Re,Qe){this.red=W,this.green=pe,this.blue=Re,this.alpha=Qe}};e.$NK=At,e.$NK=At=He([P],At);let Nt=class{constructor(W,pe){if(pe&&!(pe instanceof At))throw(0,T.$6)("color");if(!z.isRange(W)||W.isEmpty)throw(0,T.$6)("range");this.range=W,this.color=pe}};e.$OK=Nt,e.$OK=Nt=He([P],Nt);let Wt=class{constructor(W){if(!W||typeof W!="string")throw(0,T.$6)("label");this.label=W}};e.$PK=Wt,e.$PK=Wt=He([P],Wt);var Ht;(function(G){G[G.RGB=0]="RGB",G[G.HEX=1]="HEX",G[G.HSL=2]="HSL"})(Ht||(e.ColorFormat=Ht={}));var qt;(function(G){G[G.Error=0]="Error",G[G.Warning=1]="Warning",G[G.Information=2]="Information"})(qt||(e.SourceControlInputBoxValidationType=qt={}));var ct;(function(G){G[G.Unknown=0]="Unknown",G[G.Shutdown=1]="Shutdown",G[G.Process=2]="Process",G[G.User=3]="User",G[G.Extension=4]="Extension"})(ct||(e.TerminalExitReason=ct={}));class lt{constructor(W,pe,Re){if(this.startIndex=W,this.length=pe,this.tooltip=Re,typeof W!="number"||W<0)throw(0,T.$6)("startIndex");if(typeof pe!="number"||pe<1)throw(0,T.$6)("length");if(Re!==void 0&&typeof Re!="string")throw(0,T.$6)("tooltip")}}e.$QK=lt;class Jt{constructor(W){this.uri=W}}e.$RK=Jt;class It{constructor(W){this.terminalCommand=W}}e.$SK=It;var kt;(function(G){G[G.Panel=1]="Panel",G[G.Editor=2]="Editor"})(kt||(e.TerminalLocation=kt={}));class ft{constructor(W){if(this.options=W,typeof W!="object")throw(0,T.$6)("options")}}e.$TK=ft;var Dt;(function(G){G[G.Always=1]="Always",G[G.Silent=2]="Silent",G[G.Never=3]="Never"})(Dt||(e.TaskRevealKind=Dt={}));var Tt;(function(G){G[G.Shared=1]="Shared",G[G.Dedicated=2]="Dedicated",G[G.New=3]="New"})(Tt||(e.TaskPanelKind=Tt={}));let yt=class{static{u=this}static{this.Clean=new u("clean","Clean")}static{this.Build=new u("build","Build")}static{this.Rebuild=new u("rebuild","Rebuild")}static{this.Test=new u("test","Test")}static from(W){switch(W){case"clean":return u.Clean;case"build":return u.Build;case"rebuild":return u.Rebuild;case"test":return u.Test;default:return}}constructor(W,pe){if(this.label=pe,typeof W!="string"||typeof pe!="string")throw(0,T.$6)("name");this.c=W}get id(){return this.c}};e.$UK=yt,e.$UK=yt=u=He([P],yt);function Ge(G){let W="";for(let pe=0;pe<G.length;pe++)W+=G[pe].replace(/,/g,",,")+",";return W}let Ot=class{constructor(W,pe,Re){if(typeof W!="string")throw(0,T.$6)("process");this.e=[],this.c=W,pe!==void 0&&(Array.isArray(pe)?(this.e=pe,this.f=Re):this.f=pe)}get process(){return this.c}set process(W){if(typeof W!="string")throw(0,T.$6)("process");this.c=W}get args(){return this.e}set args(W){Array.isArray(W)||(W=[]),this.e=W}get options(){return this.f}set options(W){this.f=W}computeId(){const W=[];if(W.push("process"),this.c!==void 0&&W.push(this.c),this.e&&this.e.length>0)for(const pe of this.e)W.push(pe);return Ge(W)}};e.$VK=Ot,e.$VK=Ot=He([P],Ot);let jt=class{constructor(W,pe,Re){if(this.f=[],Array.isArray(pe)){if(!W)throw(0,T.$6)("command can't be undefined or null");if(typeof W!="string"&&typeof W.value!="string")throw(0,T.$6)("command");this.e=W,this.f=pe,this.g=Re}else{if(typeof W!="string")throw(0,T.$6)("commandLine");this.c=W,this.g=pe}}get commandLine(){return this.c}set commandLine(W){if(typeof W!="string")throw(0,T.$6)("commandLine");this.c=W}get command(){return this.e?this.e:""}set command(W){if(typeof W!="string"&&typeof W.value!="string")throw(0,T.$6)("command");this.e=W}get args(){return this.f}set args(W){this.f=W||[]}get options(){return this.g}set options(W){this.g=W}computeId(){const W=[];if(W.push("shell"),this.c!==void 0&&W.push(this.c),this.e!==void 0&&W.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const pe of this.f)W.push(typeof pe=="string"?pe:pe.value);return Ge(W)}};e.$WK=jt,e.$WK=jt=He([P],jt);var Le;(function(G){G[G.Escape=1]="Escape",G[G.Strong=2]="Strong",G[G.Weak=3]="Weak"})(Le||(e.ShellQuoting=Le={}));var Te;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace"})(Te||(e.TaskScope=Te={}));class Se{constructor(W){this.c=W}computeId(){return"customExecution"+(0,R.$dg)()}set callback(W){this.c=W}get callback(){return this.c}}e.$XK=Se;let ne=class{static{k=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(W,pe,Re,Qe,tt,at){this.j=!1,this.k=this.definition=W;let ht;typeof pe=="string"?(this.m=this.name=pe,this.t=this.source=Re,this.execution=Qe,ht=tt,this.j=!0):pe===Te.Global||pe===Te.Workspace?(this.target=pe,this.m=this.name=Re,this.t=this.source=Qe,this.execution=tt,ht=at):(this.target=pe,this.m=this.name=Re,this.t=this.source=Qe,this.execution=tt,ht=at),typeof ht=="string"?(this.o=[ht],this.q=!0):Array.isArray(ht)?(this.o=ht,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.w=Object.create(null),this.x=Object.create(null)}get _id(){return this.h}set _id(W){this.h=W}get _deprecated(){return this.j}z(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.A())}A(){this.n instanceof Ot?this.k={type:k.e,id:this.n.computeId()}:this.n instanceof jt?this.k={type:k.f,id:this.n.computeId()}:this.n instanceof Se?this.k={type:k.c,id:this.n.computeId()}:this.k={type:k.g,id:(0,R.$dg)()}}get definition(){return this.k}set definition(W){if(W==null)throw(0,T.$6)("Kind can't be undefined or null");this.z(),this.k=W}get scope(){return this.l}set target(W){this.z(),this.l=W}get name(){return this.m}set name(W){if(typeof W!="string")throw(0,T.$6)("name");this.z(),this.m=W}get execution(){return this.n}set execution(W){W===null&&(W=void 0),this.z(),this.n=W;const pe=this.k.type;(k.g===pe||k.e===pe||k.f===pe||k.c===pe)&&this.A()}get problemMatchers(){return this.o}set problemMatchers(W){if(Array.isArray(W))this.z(),this.o=W,this.q=!0;else{this.z(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(W){W!==!0&&W!==!1&&(W=!1),this.z(),this.r=W}get source(){return this.t}set source(W){if(typeof W!="string"||W.length===0)throw(0,T.$6)("source must be a string of length > 0");this.z(),this.t=W}get group(){return this.u}set group(W){W===null&&(W=void 0),this.z(),this.u=W}get detail(){return this.y}set detail(W){W===null&&(W=void 0),this.y=W}get presentationOptions(){return this.w}set presentationOptions(W){W==null&&(W=Object.create(null)),this.z(),this.w=W}get runOptions(){return this.x}set runOptions(W){W==null&&(W=Object.create(null)),this.z(),this.x=W}};e.$YK=ne,e.$YK=ne=k=He([P],ne);var Fe;(function(G){G[G.SourceControl=1]="SourceControl",G[G.Window=10]="Window",G[G.Notification=15]="Notification"})(Fe||(e.ProgressLocation=Fe={}));var Ke;(function(G){function W(pe){const Re=pe;return(0,E.$Bf)(Re.value)?Re.tooltip&&!(0,E.$xf)(Re.tooltip)?(console.log("INVALID view badge, invalid tooltip",Re.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Re.value),!1)}G.isViewBadge=W})(Ke||(e.ViewBadge=Ke={}));let xe=S=class{static isTreeItem(W,pe){const Re=W;if(Re.checkboxState!==void 0){const Qe=(0,E.$Bf)(Re.checkboxState)?Re.checkboxState:(0,E.$zf)(Re.checkboxState)&&(0,E.$Bf)(Re.checkboxState.state)?Re.checkboxState.state:void 0,tt=!(0,E.$Bf)(Re.checkboxState)&&(0,E.$zf)(Re.checkboxState)?Re.checkboxState.tooltip:void 0;if(Qe===void 0||Qe!==nt.Checked&&Qe!==nt.Unchecked||tt!==void 0&&!(0,E.$xf)(tt))return console.log("INVALID tree item, invalid checkboxState",Re.checkboxState),!1}if(W instanceof S)return!0;if(Re.label!==void 0&&!(0,E.$xf)(Re.label)&&!Re.label?.label)return console.log("INVALID tree item, invalid label",Re.label),!1;if(Re.id!==void 0&&!(0,E.$xf)(Re.id))return console.log("INVALID tree item, invalid id",Re.id),!1;if(Re.iconPath!==void 0&&!(0,E.$xf)(Re.iconPath)&&!w.URI.isUri(Re.iconPath)&&(!Re.iconPath||!(0,E.$xf)(Re.iconPath.id))){const Qe=Re.iconPath;if(!Qe||!(0,E.$xf)(Qe.light)&&!w.URI.isUri(Qe.light)&&!(0,E.$xf)(Qe.dark)&&!w.URI.isUri(Qe.dark))return console.log("INVALID tree item, invalid iconPath",Re.iconPath),!1}return Re.description!==void 0&&!(0,E.$xf)(Re.description)&&typeof Re.description!="boolean"?(console.log("INVALID tree item, invalid description",Re.description),!1):Re.resourceUri!==void 0&&!w.URI.isUri(Re.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Re.resourceUri),!1):Re.tooltip!==void 0&&!(0,E.$xf)(Re.tooltip)&&!(Re.tooltip instanceof _e)?(console.log("INVALID tree item, invalid tooltip",Re.tooltip),!1):Re.command!==void 0&&!Re.command.command?(console.log("INVALID tree item, invalid command",Re.command),!1):Re.collapsibleState!==void 0&&Re.collapsibleState<Je.None&&Re.collapsibleState>Je.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Re.collapsibleState),!1):Re.contextValue!==void 0&&!(0,E.$xf)(Re.contextValue)?(console.log("INVALID tree item, invalid contextValue",Re.contextValue),!1):Re.accessibilityInformation!==void 0&&!Re.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Re.accessibilityInformation),!1):!0}constructor(W,pe=Je.None){this.collapsibleState=pe,w.URI.isUri(W)?this.resourceUri=W:this.label=W}};e.$ZK=xe,e.$ZK=xe=S=He([P],xe);var Je;(function(G){G[G.None=0]="None",G[G.Collapsed=1]="Collapsed",G[G.Expanded=2]="Expanded"})(Je||(e.TreeItemCollapsibleState=Je={}));var nt;(function(G){G[G.Unchecked=0]="Unchecked",G[G.Checked=1]="Checked"})(nt||(e.TreeItemCheckboxState=nt={}));let mt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(W){this.value=W}};e.$1K=mt,e.$1K=mt=He([P],mt);class gt extends mt{}e.$2K=gt;class bt extends gt{#e;constructor(W){super(""),this.#e=W}asFile(){return this.#e}}e.$3K=bt;class dt{constructor(W,pe,Re,Qe){this.name=W,this.uri=pe,this._itemId=Re,this.c=Qe}data(){return this.c()}}e.$4K=dt;let Rt=class{#e=new Map;constructor(W){for(const[pe,Re]of W??[]){const Qe=this.#e.get(this.#t(pe));Qe?Qe.push(Re):this.#e.set(this.#t(pe),[Re])}}get(W){return this.#e.get(this.#t(W))?.[0]}set(W,pe){this.#e.set(this.#t(W),[pe])}forEach(W,pe){for(const[Re,Qe]of this.#e)for(const tt of Qe)W.call(pe,tt,Re,this)}*[Symbol.iterator](){for(const[W,pe]of this.#e)for(const Re of pe)yield[W,Re]}#t(W){return W.toLowerCase()}};e.$5K=Rt,e.$5K=Rt=He([P],Rt);let Gt=class{constructor(W){this.insertText=W}};e.$6K=Gt,e.$6K=Gt=He([P],Gt);let Ei=class{constructor(W,pe){this.label=pe,this.insertText=W}};e.$7K=Ei,e.$7K=Ei=He([P],Ei);let Vt=class{constructor(W,pe){this.id=W,this.color=pe}static isThemeIcon(W){return typeof W.id!="string"?(console.log("INVALID ThemeIcon, invalid id",W.id),!1):!0}};e.$8K=Vt,e.$8K=Vt=He([P],Vt),Vt.File=new Vt("file"),Vt.Folder=new Vt("folder");let mi=class{constructor(W){this.id=W}};e.$9K=mi,e.$9K=mi=He([P],mi);var Ct;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace",G[G.WorkspaceFolder=3]="WorkspaceFolder"})(Ct||(e.ConfigurationTarget=Ct={}));let ki=class{get base(){return this.c}set base(W){this.c=W,this.e=w.URI.file(W)}get baseUri(){return this.e}set baseUri(W){this.e=W,this.c=W.fsPath}constructor(W,pe){if(typeof W!="string"&&(!W||!w.URI.isUri(W)&&!w.URI.isUri(W.uri)))throw(0,T.$6)("base");if(typeof pe!="string")throw(0,T.$6)("pattern");typeof W=="string"?this.baseUri=w.URI.file(W):w.URI.isUri(W)?this.baseUri=W:this.baseUri=W.uri,this.pattern=pe}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$0K=ki,e.$0K=ki=He([P],ki);const qi=new WeakMap;function St(G,W){qi.set(G,W)}e.$$K=St;let ii=class{constructor(W,pe,Re,Qe){this.enabled=typeof W=="boolean"?W:!0,typeof pe=="string"&&(this.condition=pe),typeof Re=="string"&&(this.hitCondition=Re),typeof Qe=="string"&&(this.logMessage=Qe)}get id(){return this.c||(this.c=qi.get(this)??(0,R.$dg)()),this.c}};e.$_K=ii,e.$_K=ii=He([P],ii);let $i=class extends ii{constructor(W,pe,Re,Qe,tt){if(super(pe,Re,Qe,tt),W===null)throw(0,T.$6)("location");this.location=W}};e.$aL=$i,e.$aL=$i=He([P],$i);let oi=class extends ii{constructor(W,pe,Re,Qe,tt){super(pe,Re,Qe,tt),this.functionName=W}};e.$bL=oi,e.$bL=oi=He([P],oi);let Si=class extends ii{constructor(W,pe,Re,Qe,tt,at,ht){if(super(Qe,tt,at,ht),!pe)throw(0,T.$6)("dataId");this.label=W,this.dataId=pe,this.canPersist=Re}};e.$cL=Si,e.$cL=Si=He([P],Si);let Di=class{constructor(W,pe,Re){this.command=W,this.args=pe||[],this.options=Re}};e.$dL=Di,e.$dL=Di=He([P],Di);let Mt=class{constructor(W,pe){this.port=W,this.host=pe}};e.$eL=Mt,e.$eL=Mt=He([P],Mt);let bi=class{constructor(W){this.path=W}};e.$fL=bi,e.$fL=bi=He([P],bi);let Ci=class{constructor(W){this.implementation=W}};e.$gL=Ci,e.$gL=Ci=He([P],Ci);let ai=class{constructor(W,pe,Re){this.session=W,this.threadId=pe,this.frameId=Re}};e.$hL=ai,e.$hL=ai=He([P],ai);let ci=class{constructor(W,pe){this.session=W,this.threadId=pe}};e.$iL=ci,e.$iL=ci=He([P],ci);let ut=class{constructor(W,pe){this.range=W,this.expression=pe}};e.$jL=ut,e.$jL=ut=He([P],ut);var Vi;(function(G){G[G.Invoke=0]="Invoke",G[G.Automatic=1]="Automatic"})(Vi||(e.InlineCompletionTriggerKind=Vi={}));let Xt=class{constructor(W,pe){this.range=W,this.text=pe}};e.$kL=Xt,e.$kL=Xt=He([P],Xt);let ni=class{constructor(W,pe,Re=!0){this.range=W,this.variableName=pe,this.caseSensitiveLookup=Re}};e.$lL=ni,e.$lL=ni=He([P],ni);let wi=class{constructor(W,pe){this.range=W,this.expression=pe}};e.$mL=wi,e.$mL=wi=He([P],wi);let Ii=class{constructor(W,pe){this.frameId=W,this.stoppedLocation=pe}};e.$nL=Ii,e.$nL=Ii=He([P],Ii);var Ki;(function(G){G[G.Changed=1]="Changed",G[G.Created=2]="Created",G[G.Deleted=3]="Deleted"})(Ki||(e.FileChangeType=Ki={}));let Pi=$=class extends Error{static FileExists(W){return new $(W,p.FileSystemProviderErrorCode.FileExists,$.FileExists)}static FileNotFound(W){return new $(W,p.FileSystemProviderErrorCode.FileNotFound,$.FileNotFound)}static FileNotADirectory(W){return new $(W,p.FileSystemProviderErrorCode.FileNotADirectory,$.FileNotADirectory)}static FileIsADirectory(W){return new $(W,p.FileSystemProviderErrorCode.FileIsADirectory,$.FileIsADirectory)}static NoPermissions(W){return new $(W,p.FileSystemProviderErrorCode.NoPermissions,$.NoPermissions)}static Unavailable(W){return new $(W,p.FileSystemProviderErrorCode.Unavailable,$.Unavailable)}constructor(W,pe=p.FileSystemProviderErrorCode.Unknown,Re){super(w.URI.isUri(W)?W.toString(!0):W),this.code=Re?.name??"Unknown",(0,p.$kk)(this,pe),Object.setPrototypeOf(this,$.prototype),typeof Error.captureStackTrace=="function"&&typeof Re=="function"&&Error.captureStackTrace(this,Re)}};e.$oL=Pi,e.$oL=Pi=$=He([P],Pi);let pi=class{constructor(W,pe,Re){this.start=W,this.end=pe,this.kind=Re}};e.$pL=pi,e.$pL=pi=He([P],pi);var Hi;(function(G){G[G.Comment=1]="Comment",G[G.Imports=2]="Imports",G[G.Region=3]="Region"})(Hi||(e.FoldingRangeKind=Hi={}));var Ai;(function(G){G[G.Collapsed=0]="Collapsed",G[G.Expanded=1]="Expanded"})(Ai||(e.CommentThreadCollapsibleState=Ai={}));var ui;(function(G){G[G.Editing=0]="Editing",G[G.Preview=1]="Preview"})(ui||(e.CommentMode=ui={}));var Gi;(function(G){G[G.Published=0]="Published",G[G.Draft=1]="Draft"})(Gi||(e.CommentState=Gi={}));var vi;(function(G){G[G.Unresolved=0]="Unresolved",G[G.Resolved=1]="Resolved"})(vi||(e.CommentThreadState=vi={}));class Ri{constructor(W,pe=[]){this.tokenTypes=W,this.tokenModifiers=pe}}e.$qL=Ri;function cn(G){return typeof G>"u"||(0,E.$yf)(G)}class Mi{constructor(W){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,W){this.l=!0;for(let pe=0,Re=W.tokenTypes.length;pe<Re;pe++)this.j.set(W.tokenTypes[pe],pe);for(let pe=0,Re=W.tokenModifiers.length;pe<Re;pe++)this.k.set(W.tokenModifiers[pe],pe)}}push(W,pe,Re,Qe,tt){if(typeof W=="number"&&typeof pe=="number"&&typeof Re=="number"&&typeof Qe=="number"&&(typeof tt=="number"||typeof tt>"u"))return typeof tt>"u"&&(tt=0),this.n(W,pe,Re,Qe,tt);if(z.isRange(W)&&typeof pe=="string"&&cn(Re))return this.m(W,pe,Re);throw(0,T.$6)()}m(W,pe,Re){if(!this.l)throw new Error("Legend must be provided in constructor");if(W.start.line!==W.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(pe))throw new Error("`tokenType` is not in the provided legend");const Qe=W.start.line,tt=W.start.character,at=W.end.character-W.start.character,ht=this.j.get(pe);let zt=0;if(Re)for(const Zt of Re){if(!this.k.has(Zt))throw new Error("`tokenModifier` is not in the provided legend");const ei=this.k.get(Zt);zt|=1<<ei>>>0}this.n(Qe,tt,at,ht,zt)}n(W,pe,Re,Qe,tt){if(this.f&&(W<this.c||W===this.c&&pe<this.e)){this.f=!1;const zt=this.g.length/5|0;let Zt=0,ei=0;for(let ti=0;ti<zt;ti++){let si=this.g[5*ti],Bi=this.g[5*ti+1];si===0?(si=Zt,Bi+=ei):si+=Zt,this.g[5*ti]=si,this.g[5*ti+1]=Bi,Zt=si,ei=Bi}}let at=W,ht=pe;this.f&&this.h>0&&(at-=this.c,at===0&&(ht-=this.e)),this.g[this.h++]=at,this.g[this.h++]=ht,this.g[this.h++]=Re,this.g[this.h++]=Qe,this.g[this.h++]=tt,this.c=W,this.e=pe}static o(W){const pe=[],Re=W.length/5|0;for(let ht=0;ht<Re;ht++)pe[ht]=ht;pe.sort((ht,zt)=>{const Zt=W[5*ht],ei=W[5*zt];if(Zt===ei){const ti=W[5*ht+1],si=W[5*zt+1];return ti-si}return Zt-ei});const Qe=new Uint32Array(W.length);let tt=0,at=0;for(let ht=0;ht<Re;ht++){const zt=5*pe[ht],Zt=W[zt+0],ei=W[zt+1],ti=W[zt+2],si=W[zt+3],Bi=W[zt+4],vn=Zt-tt,Mn=vn===0?ei-at:ei,Wi=5*ht;Qe[Wi+0]=vn,Qe[Wi+1]=Mn,Qe[Wi+2]=ti,Qe[Wi+3]=si,Qe[Wi+4]=Bi,tt=Zt,at=ei}return Qe}build(W){return this.f?new ri(new Uint32Array(this.g),W):new ri(Mi.o(this.g),W)}}e.$rL=Mi;class ri{constructor(W,pe){this.resultId=pe,this.data=W}}e.$sL=ri;class un{constructor(W,pe,Re){this.start=W,this.deleteCount=pe,this.data=Re}}e.$tL=un;class ln{constructor(W,pe){this.resultId=pe,this.edits=W}}e.$uL=ln;var Ji;(function(G){G[G.Separate=0]="Separate",G[G.MergeWithParent=1]="MergeWithParent"})(Ji||(e.DebugConsoleMode=Ji={}));let fi=class{static{this.Back={iconPath:new Vt("arrow-left")}}constructor(){}};e.$vL=fi,e.$vL=fi=He([P],fi);var Qi;(function(G){G[G.Separator=-1]="Separator",G[G.Default=0]="Default"})(Qi||(e.QuickPickItemKind=Qi={}));var Zi;(function(G){G[G.Info=1]="Info",G[G.Warning=2]="Warning",G[G.Error=3]="Error"})(Zi||(e.InputBoxValidationSeverity=Zi={}));var gi;(function(G){G[G.UI=1]="UI",G[G.Workspace=2]="Workspace"})(gi||(e.ExtensionKind=gi={}));class Yi{static validate(W){if(typeof W.badge=="string"){let pe=(0,b.$$e)(W.badge,0);if(pe<W.badge.length&&(pe+=(0,b.$$e)(W.badge,pe)),W.badge.length>pe)throw new Error("The 'badge'-property must be undefined or a short character")}else if(W.badge&&!Vt.isThemeIcon(W.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!W.color&&!W.badge&&!W.tooltip)throw new Error("The decoration is empty");return!0}constructor(W,pe,Re){this.badge=W,this.tooltip=pe,this.color=Re}}e.$wL=Yi;let Li=class{constructor(W){this.kind=W}};e.$xL=Li,e.$xL=Li=He([P],Li);var Xi;(function(G){G[G.Light=1]="Light",G[G.Dark=2]="Dark",G[G.HighContrast=3]="HighContrast",G[G.HighContrastLight=4]="HighContrastLight"})(Xi||(e.ColorThemeKind=Xi={}));class xt{static isNotebookRange(W){return W instanceof xt?!0:W?typeof W.start=="number"&&typeof W.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(W,pe){if(W<0)throw(0,T.$6)("start must be positive");if(pe<0)throw(0,T.$6)("end must be positive");W<=pe?(this.c=W,this.e=pe):(this.c=pe,this.e=W)}with(W){let pe=this.c,Re=this.e;return W.start!==void 0&&(pe=W.start),W.end!==void 0&&(Re=W.end),pe===this.c&&Re===this.e?this:new xt(pe,Re)}}e.$yL=xt;class yi{static validate(W){if(typeof W.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof W.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof W.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(W){return Array.isArray(W)&&W.every(pe=>yi.isNotebookCellData(pe))}static isNotebookCellData(W){return!0}constructor(W,pe,Re,Qe,tt,at,ht){this.kind=W,this.value=pe,this.languageId=Re,this.mime=Qe,this.outputs=tt??[],this.metadata=at,this.executionSummary=ht,yi.validate(this)}}e.$zL=yi;class hn{constructor(W){this.cells=W}}e.$AL=hn;class Qt{static isNotebookCellOutputItem(W){return W instanceof Qt?!0:W?typeof W.mime=="string"&&W.data instanceof Uint8Array:!1}static error(W){const pe={name:W.name,message:W.message,stack:W.stack};return Qt.json(pe,"application/vnd.code.notebook.error")}static stdout(W){return Qt.text(W,"application/vnd.code.notebook.stdout")}static stderr(W){return Qt.text(W,"application/vnd.code.notebook.stderr")}static bytes(W,pe="application/octet-stream"){return new Qt(W,pe)}static#e=new TextEncoder;static text(W,pe=A.$Lr.text){const Re=Qt.#e.encode(String(W));return new Qt(Re,pe)}static json(W,pe="text/x-json"){const Re=JSON.stringify(W,void 0,"	");return Qt.text(Re,pe)}constructor(W,pe){this.data=W,this.mime=pe;const Re=(0,A.$Pr)(pe,!0);if(!Re)throw new Error(`INVALID mime type: ${pe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Re}}e.$BL=Qt;class li{static isNotebookCellOutput(W){return W instanceof li?!0:!W||typeof W!="object"?!1:typeof W.id=="string"&&Array.isArray(W.items)}static ensureUniqueMimeTypes(W,pe=!1){const Re=new Set,Qe=new Set;for(let tt=0;tt<W.length;tt++){const at=W[tt],ht=(0,A.$Pr)(at.mime);if(!Re.has(ht)||(0,D.$lI)(ht)){Re.add(ht);continue}Qe.add(tt),pe&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return Qe.size===0?W:W.filter((tt,at)=>!Qe.has(at))}constructor(W,pe,Re){this.items=li.ensureUniqueMimeTypes(W,!0),typeof pe=="string"?(this.id=pe,this.metadata=Re):(this.id=(0,R.$dg)(),this.metadata=pe??Re)}}e.$CL=li;var Ti;(function(G){G[G.Markup=1]="Markup",G[G.Code=2]="Code"})(Ti||(e.NotebookCellKind=Ti={}));var Ue;(function(G){G[G.Idle=1]="Idle",G[G.Pending=2]="Pending",G[G.Executing=3]="Executing"})(Ue||(e.NotebookCellExecutionState=Ue={}));var _t;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(_t||(e.NotebookCellStatusBarAlignment=_t={}));var Fi;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(Fi||(e.NotebookEditorRevealType=Fi={}));class $t{constructor(W,pe){this.text=W,this.alignment=pe}}e.$DL=$t;var xi;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred"})(xi||(e.NotebookControllerAffinity=xi={}));var _i;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred",G[G.Hidden=-1]="Hidden"})(_i||(e.NotebookControllerAffinity2=_i={}));class en{constructor(W,pe=[]){this.uri=W,this.provides=(0,C.$2b)(pe)}}e.$EL=en;class dn{constructor(W){this.label=W}}e.$FL=dn;let hi=class{constructor(W,pe){this.label=W,this.timestamp=pe}};e.$GL=hi,e.$GL=hi=He([P],hi);var tn;(function(G){G[G.Production=1]="Production",G[G.Development=2]="Development",G[G.Test=3]="Test"})(tn||(e.ExtensionMode=tn={}));var nn;(function(G){G[G.Node=1]="Node",G[G.Webworker=2]="Webworker"})(nn||(e.ExtensionRuntime=nn={}));var rn;(function(G){G[G.Other=0]="Other",G[G.Comment=1]="Comment",G[G.String=2]="String",G[G.RegEx=3]="RegEx"})(rn||(e.StandardTokenType=rn={}));class sn{constructor(W,pe){this.ranges=W,this.wordPattern=pe}}e.$HL=sn;class fn{constructor(W){this.c=W}get autoForwardAction(){return this.c}}e.$IL=fn;var on;(function(G){G[G.Queued=1]="Queued",G[G.Running=2]="Running",G[G.Passed=3]="Passed",G[G.Failed=4]="Failed",G[G.Skipped=5]="Skipped",G[G.Errored=6]="Errored"})(on||(e.TestResultState=on={}));var an;(function(G){G[G.Run=1]="Run",G[G.Debug=2]="Debug",G[G.Coverage=3]="Coverage"})(an||(e.TestRunProfileKind=an={}));let Ni=class{constructor(W=void 0,pe=void 0,Re=void 0,Qe=!1){this.include=W,this.exclude=pe,this.profile=Re,this.continuous=Qe}};e.$JL=Ni,e.$JL=Ni=He([P],Ni);let Oi=g=class{static diff(W,pe,Re){const Qe=new g(W);return Qe.expectedOutput=pe,Qe.actualOutput=Re,Qe}constructor(W){this.message=W}};e.$KL=Oi,e.$KL=Oi=g=He([P],Oi);let ji=class{constructor(W){this.id=W}};e.$LL=ji,e.$LL=ji=He([P],ji);let di=class{constructor(W,pe){this.covered=W,this.total=pe}};e.$ML=di,e.$ML=di=He([P],di);let zi=f=class{static fromDetails(W,pe){const Re=new di(0,0),Qe=new di(0,0),tt=new di(0,0);for(const ht of pe)if("branches"in ht){Re.total+=1,Re.covered+=ht.executionCount>0?1:0;for(const zt of ht.branches)Qe.total+=1,Qe.covered+=zt.executionCount>0?1:0}else tt.total+=1,tt.covered+=ht.executionCount>0?1:0;const at=new f(W,Re,Qe.total>0?Qe:void 0,tt.total>0?tt:void 0);return at.detailedCoverage=pe,at}constructor(W,pe,Re,Qe){this.uri=W,this.statementCoverage=pe,this.branchCoverage=Re,this.functionCoverage=Qe}};e.$NL=zi,e.$NL=zi=f=He([P],zi);let Ui=class{constructor(W,pe,Re=[]){this.executionCount=W,this.location=pe,this.branches=Re}};e.$OL=Ui,e.$OL=Ui=He([P],Ui);let we=class{constructor(W,pe){this.executionCount=W,this.location=pe}};e.$PL=we,e.$PL=we=He([P],we);let ke=class{constructor(W,pe){this.executionCount=W,this.location=pe}};e.$QL=ke,e.$QL=ke=He([P],ke);var Oe;(function(G){G[G.None=0]="None",G[G.Option=1]="Option",G[G.Default=2]="Default",G[G.Preferred=3]="Preferred"})(Oe||(e.ExternalUriOpenerPriority=Oe={}));var st;(function(G){G[G.Untrusted=0]="Untrusted",G[G.Trusted=1]="Trusted",G[G.Unspecified=2]="Unspecified"})(st||(e.WorkspaceTrustState=st={}));var vt;(function(G){G[G.Notify=1]="Notify",G[G.OpenBrowser=2]="OpenBrowser",G[G.OpenPreview=3]="OpenPreview",G[G.Silent=4]="Silent",G[G.Ignore=5]="Ignore",G[G.OpenBrowserOnce=6]="OpenBrowserOnce"})(vt||(e.PortAutoForwardAction=vt={}));class Lt{constructor(W,pe,Re,Qe,tt,at){this.kind=W,this.name=pe,this.detail=Re,this.uri=Qe,this.range=tt,this.selectionRange=at}}e.$RL=Lt;class yn{constructor(W){this.uri=W}}e.$SL=yn;class En{constructor(W,pe){this.original=W,this.modified=pe}}e.$TL=En;class kn{constructor(W,pe,Re,Qe){this.base=W,this.input1=pe,this.input2=Re,this.result=Qe}}e.$UL=kn;class Sn{constructor(W,pe){this.uri=W,this.viewType=pe}}e.$VL=Sn;class Dn{constructor(W){this.viewType=W}}e.$WL=Dn;class Cn{constructor(W,pe){this.uri=W,this.notebookType=pe}}e.$XL=Cn;class In{constructor(W,pe,Re){this.original=W,this.modified=pe,this.notebookType=Re}}e.$YL=In;class Pn{constructor(){}}e.$ZL=Pn;class An{constructor(W,pe){this.uri=W,this.inputBoxUri=pe}}e.$1L=An;var gn;(function(G){G[G.Up=1]="Up",G[G.Down=2]="Down"})(gn||(e.InteractiveSessionVoteDirection=gn={}));var mn;(function(G){G[G.Action=1]="Action",G[G.Toolbar=2]="Toolbar"})(mn||(e.InteractiveSessionCopyKind=mn={}));var $n;(function(G){G[G.Unhelpful=0]="Unhelpful",G[G.Helpful=1]="Helpful",G[G.Undone=2]="Undone",G[G.Accepted=3]="Accepted"})($n||(e.InteractiveEditorResponseFeedbackKind=$n={}));var bn;(function(G){G[G.System=0]="System",G[G.User=1]="User",G[G.Assistant=2]="Assistant",G[G.Function=3]="Function"})(bn||(e.ChatMessageRole=bn={}));var wn;(function(G){G[G.Short=1]="Short",G[G.Medium=2]="Medium",G[G.Full=3]="Full"})(wn||(e.ChatVariableLevel=wn={}));class Rn{constructor(W,pe){this.role=W,this.content=pe}}e.$2L=Rn;var pn;(function(G){G[G.SymbolInformation=1]="SymbolInformation",G[G.CommandInformation=2]="CommandInformation",G[G.SearchInformation=3]="SearchInformation",G[G.SettingInformation=4]="SettingInformation"})(pn||(e.RelatedInformationType=pn={}))}),define(De[141],Ce([1,0,58,17,15,171,124,7,19]),function(me,e,C,T,d,M,A,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eM=e.$dM=e.$cM=void 0;const w=new Map;function R(D,v){v?w.set(D,v):w.delete(D)}e.$cM=R;function I(D){return w.get(D)}class p extends M.$Qu{constructor(v,l,s,r,c,m,h,t){super(l,s,r,c),this.c=v,this.m=m,this.q=h,this.notebook=t,this.b=!1}dispose(){(0,C.ok)(!this.b),this.b=!0,this.q=!1}equalLines(v){return(0,E.$tb)(this.f,v)}get document(){if(!this.a){const v=this;this.a={get uri(){return v.d},get fileName(){return v.d.fsPath},get isUntitled(){return v.d.scheme===T.Schemas.untitled},get languageId(){return v.m},get version(){return v.h},get isClosed(){return v.b},get isDirty(){return v.q},save(){return v.r()},getText(l){return l?v.s(l):v.getText()},get eol(){return v.g===`
`?b.EndOfLine.LF:b.EndOfLine.CRLF},get lineCount(){return v.f.length},lineAt(l){return v.t(l)},offsetAt(l){return v.u(l)},positionAt(l){return v.v(l)},validateRange(l){return v.w(l)},validatePosition(l){return v.x(l)},getWordRangeAtPosition(l,s){return v.y(l,s)}}}return Object.freeze(this.a)}_acceptLanguageId(v){(0,C.ok)(!this.b),this.m=v}_acceptIsDirty(v){(0,C.ok)(!this.b),this.q=v}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(v){const l=this.w(v);if(l.isEmpty)return"";if(l.isSingleLine)return this.f[l.start.line].substring(l.start.character,l.end.character);const s=this.g,r=l.start.line,c=l.end.line,m=[];m.push(this.f[r].substring(l.start.character));for(let h=r+1;h<c;h++)m.push(this.f[h]);return m.push(this.f[c].substring(0,l.end.character)),m.join(s)}t(v){let l;if(v instanceof b.$cK?l=v.line:typeof v=="number"&&(l=v),typeof l!="number"||l<0||l>=this.f.length||Math.floor(l)!==l)throw new Error("Illegal value for `line`");return new y(l,this.f[l],l===this.f.length-1)}u(v){return v=this.x(v),this.l(),this.j.getPrefixSum(v.line-1)+v.character}v(v){v=Math.floor(v),v=Math.max(0,v),this.l();const l=this.j.getIndexOf(v),s=this.f[l.index].length;return new b.$cK(l.index,Math.min(l.remainder,s))}w(v){if(!(v instanceof b.$dK))throw new Error("Invalid argument");const l=this.x(v.start),s=this.x(v.end);return l===v.start&&s===v.end?v:new b.$dK(l.line,l.character,s.line,s.character)}x(v){if(!(v instanceof b.$cK))throw new Error("Invalid argument");if(this.f.length===0)return v.with(0,0);let{line:l,character:s}=v,r=!1;if(l<0)l=0,s=0,r=!0;else if(l>=this.f.length)l=this.f.length-1,s=this.f[l].length,r=!0;else{const c=this.f[l].length;s<0?(s=0,r=!0):s>c&&(s=c,r=!0)}return r?new b.$cK(l,s):v}y(v,l){const s=this.x(v);if(!l)l=I(this.m);else if((0,d.$Ne)(l))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${l.source}' because it matches the empty string.`);const r=(0,A.$4r)(s.character+1,(0,A.$2r)(l),this.f[s.line],0);if(r)return new b.$dK(s.line,r.startColumn-1,s.line,r.endColumn-1)}}e.$dM=p;class y{constructor(v,l,s){this.a=v,this.b=l,this.c=s}get lineNumber(){return this.a}get text(){return this.b}get range(){return new b.$dK(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new b.$dK(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$eM=y}),define(De[274],Ce([1,0,7,20,4]),function(me,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kdc=void 0;let M=class{constructor(b){this.a=new C.$xL(C.ColorThemeKind.Dark),this.b=new d.$Md}get activeColorTheme(){return this.a}$onColorThemeChange(b){let E;switch(b){case"light":E=C.ColorThemeKind.Light;break;case"hcDark":E=C.ColorThemeKind.HighContrast;break;case"hcLight":E=C.ColorThemeKind.HighContrastLight;break;default:E=C.ColorThemeKind.Dark}this.a=new C.$xL(E),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$kdc=M,e.$kdc=M=He([Be(0,T.$aM)],M)}),define(De[275],Ce([1,0,5]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pI=e.CellExecutionUpdateType=void 0;var T;(function(d){d[d.Output=1]="Output",d[d.OutputItems=2]="OutputItems",d[d.ExecutionState=3]="ExecutionState"})(T||(e.CellExecutionUpdateType=T={})),e.$pI=(0,C.$Nh)("INotebookExecutionService")}),define(De[67],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5I=e.TestPosition=e.TestIdPathParts=void 0;var C;(function(M){M.Delimiter="\0"})(C||(e.TestIdPathParts=C={}));var T;(function(M){M[M.IsSame=0]="IsSame",M[M.Disconnected=1]="Disconnected",M[M.IsChild=2]="IsChild",M[M.IsParent=3]="IsParent"})(T||(e.TestPosition=T={}));class d{static fromExtHostTestItem(A,b,E=A.parent){if(A._isRoot)return new d([b]);const w=[A.id];for(let R=E;R&&R.id!==b;R=R.parent)w.push(R.id);return w.push(b),new d(w.reverse())}static isRoot(A){return!A.includes("\0")}static root(A){const b=A.indexOf("\0");return b===-1?A:A.slice(0,b)}static fromString(A){return new d(A.split("\0"))}static join(A,b){return new d([...A.path,b])}static joinToString(A,b){return A.toString()+"\0"+b}static parentId(A){const b=A.lastIndexOf("\0");return b===-1?void 0:A.slice(0,b)}static localId(A){const b=A.lastIndexOf("\0");return b===-1?A:A.slice(b+1)}static isChild(A,b){return b.startsWith(A)&&b[A.length]==="\0"}static compare(A,b){return A===b?0:d.isChild(A,b)?2:d.isChild(b,A)?3:1}constructor(A,b=A.length){if(this.path=A,this.d=b,A.length===0||b<1)throw new Error("cannot create test with empty path")}get rootId(){return new d(this.path,1)}get parentId(){return this.d>1?new d(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new d(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new d(this.path,A)}compare(A){if(typeof A=="string")return d.compare(this.toString(),A);for(let b=0;b<A.d&&b<this.d;b++)if(A.path[b]!==this.path[b])return 1;return A.d>this.d?2:A.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+="\0",this.c+=this.path[A]}return this.c}}e.$5I=d}),define(De[87],Ce([1,0,2,34,67]),function(me,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_I=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.$$I=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$0I=e.$9I=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$8I=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$7I=e.$6I=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var M;(function(S){S[S.Unset=0]="Unset",S[S.Queued=1]="Queued",S[S.Running=2]="Running",S[S.Passed=3]="Passed",S[S.Failed=4]="Failed",S[S.Skipped=5]="Skipped",S[S.Errored=6]="Errored"})(M||(e.TestResultState=M={}));var A;(function(S){S[S.Run=1]="Run",S[S.Debug=2]="Debug",S[S.Coverage=3]="Coverage"})(A||(e.ExtTestRunProfileKind=A={}));var b;(function(S){S[S.Run=2]="Run",S[S.Debug=4]="Debug",S[S.Coverage=8]="Coverage",S[S.HasNonDefaultProfile=16]="HasNonDefaultProfile",S[S.HasConfigurable=32]="HasConfigurable",S[S.SupportsContinuousRun=64]="SupportsContinuousRun"})(b||(e.TestRunProfileBitset=b={})),e.$6I=[2,4,8,16,32,64];const E=S=>"runId"in S;e.$7I=E;var w;(function(S){S.serialize=$=>({range:$.range.toJSON(),uri:$.uri.toJSON()}),S.deserialize=$=>({range:T.$os.lift($.range),uri:C.URI.revive($.uri)})})(w||(e.IRichLocation=w={}));var R;(function(S){S[S.Error=0]="Error",S[S.Output=1]="Output"})(R||(e.TestMessageType=R={}));var I;(function(S){S.serialize=$=>({message:$.message,type:0,expected:$.expected,actual:$.actual,contextValue:$.contextValue,location:$.location&&w.serialize($.location)}),S.deserialize=$=>({message:$.message,type:0,expected:$.expected,actual:$.actual,contextValue:$.contextValue,location:$.location&&w.deserialize($.location)})})(I||(e.ITestErrorMessage=I={}));const p=(S,$)=>`${$?"s":"e"}${S}`;e.$8I=p;var y;(function(S){S.serialize=$=>({message:$.message,type:1,offset:$.offset,length:$.length,location:$.location&&w.serialize($.location)}),S.deserialize=$=>({message:$.message,type:1,offset:$.offset,length:$.length,location:$.location&&w.deserialize($.location)})})(y||(e.ITestOutputMessage=y={}));var D;(function(S){S.serialize=$=>$.type===0?I.serialize($):y.serialize($),S.deserialize=$=>$.type===0?I.deserialize($):y.deserialize($)})(D||(e.ITestMessage=D={}));var v;(function(S){S.serializeWithoutMessages=$=>({state:$.state,duration:$.duration,messages:[]}),S.serialize=$=>({state:$.state,duration:$.duration,messages:$.messages.map(D.serialize)}),S.deserialize=$=>({state:$.state,duration:$.duration,messages:$.messages.map(D.deserialize)})})(v||(e.ITestTaskState=v={}));const l="\0",s=(S,$)=>S+l+$;e.$9I=s;const r=S=>{const $=S.indexOf(l);return{ctrlId:S.slice(0,$),tagId:S.slice($+1)}};e.$0I=r;var c;(function(S){S.serialize=$=>({extId:$.extId,label:$.label,tags:$.tags,busy:$.busy,children:void 0,uri:$.uri?.toJSON(),range:$.range?.toJSON()||null,description:$.description,error:$.error,sortText:$.sortText}),S.deserialize=$=>({extId:$.extId,label:$.label,tags:$.tags,busy:$.busy,children:void 0,uri:$.uri?C.URI.revive($.uri):void 0,range:$.range?T.$os.lift($.range):null,description:$.description,error:$.error,sortText:$.sortText})})(c||(e.ITestItem=c={}));var m;(function(S){S[S.NotExpandable=0]="NotExpandable",S[S.Expandable=1]="Expandable",S[S.BusyExpanding=2]="BusyExpanding",S[S.Expanded=3]="Expanded"})(m||(e.TestItemExpandState=m={}));var h;(function(S){S.serialize=$=>({expand:$.expand,item:c.serialize($.item)}),S.deserialize=$=>({controllerId:d.$5I.root($.item.extId),expand:$.expand,item:c.deserialize($.item)})})(h||(e.InternalTestItem=h={}));var t;(function(S){S.serialize=$=>{let g;return $.item&&(g={},$.item.label!==void 0&&(g.label=$.item.label),$.item.tags!==void 0&&(g.tags=$.item.tags),$.item.busy!==void 0&&(g.busy=$.item.busy),$.item.uri!==void 0&&(g.uri=$.item.uri?.toJSON()),$.item.range!==void 0&&(g.range=$.item.range?.toJSON()),$.item.description!==void 0&&(g.description=$.item.description),$.item.error!==void 0&&(g.error=$.item.error),$.item.sortText!==void 0&&(g.sortText=$.item.sortText)),{extId:$.extId,expand:$.expand,item:g}},S.deserialize=$=>{let g;return $.item&&(g={},$.item.label!==void 0&&(g.label=$.item.label),$.item.tags!==void 0&&(g.tags=$.item.tags),$.item.busy!==void 0&&(g.busy=$.item.busy),$.item.range!==void 0&&(g.range=$.item.range?T.$os.lift($.item.range):null),$.item.description!==void 0&&(g.description=$.item.description),$.item.error!==void 0&&(g.error=$.item.error),$.item.sortText!==void 0&&(g.sortText=$.item.sortText)),{extId:$.extId,expand:$.expand,item:g}}})(t||(e.ITestItemUpdate=t={}));const n=(S,$)=>{$.expand!==void 0&&(S.expand=$.expand),$.item!==void 0&&(S.item=S.item?Object.assign(S.item,$.item):$.item)};e.$$I=n;var o;(function(S){S.serializeWithoutMessages=$=>({...h.serialize($),ownComputedState:$.ownComputedState,computedState:$.computedState,tasks:$.tasks.map(v.serializeWithoutMessages)}),S.serialize=$=>({...h.serialize($),ownComputedState:$.ownComputedState,computedState:$.computedState,tasks:$.tasks.map(v.serialize)}),S.deserialize=$=>({...h.deserialize($),ownComputedState:$.ownComputedState,computedState:$.computedState,tasks:$.tasks.map(v.deserialize),retired:!0})})(o||(e.TestResultItem=o={}));var i;(function(S){S[S.Function=0]="Function",S[S.Statement=1]="Statement"})(i||(e.DetailType=i={}));var a;(function(S){S[S.Add=0]="Add",S[S.Update=1]="Update",S[S.DocumentSynced=2]="DocumentSynced",S[S.Remove=3]="Remove",S[S.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",S[S.Retire=5]="Retire",S[S.AddTag=6]="AddTag",S[S.RemoveTag=7]="RemoveTag"})(a||(e.TestDiffOpType=a={}));var u;(function(S){S.deserialize=$=>$.op===0?{op:$.op,item:h.deserialize($.item)}:$.op===1?{op:$.op,item:t.deserialize($.item)}:$.op===2?{op:$.op,uri:C.URI.revive($.uri),docv:$.docv}:$,S.serialize=$=>$.op===0?{op:$.op,item:h.serialize($.item)}:$.op===1?{op:$.op,item:t.serialize($.item)}:$})(u||(e.TestsDiffOp=u={}));class k{constructor(){this.d=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.d}apply($){const g=this.p();for(const f of $)switch(f.op){case 0:this.k(h.deserialize(f.item),g);break;case 1:this.l(t.deserialize(f.item),g);break;case 3:this.m(f.itemId,g);break;case 5:this.o(f.itemId);break;case 4:this.updatePendingRoots(f.amount);break;case 6:this.d.set(f.tag.id,f.tag);break;case 7:this.d.delete(f.id);break}g.complete?.()}k($,g){const f=d.$5I.parentId($.item.extId)?.toString();let P;if(!f)P=this.q($),this.g.add(P),this.f.set($.item.extId,P);else if(this.f.has(f)){const N=this.f.get(f);N.children.add($.item.extId),P=this.q($,N),this.f.set($.item.extId,P)}else{console.error(`Test with unknown parent ID: ${JSON.stringify($)}`);return}return g.add?.(P),$.expand===2&&this.h++,P}l($,g){const f=this.f.get($.extId);if(f)return $.expand!==void 0&&(f.expand===2&&this.h--,$.expand===2&&this.h++),(0,e.$$I)(f,$),g.update?.(f),f}m($,g){const f=this.f.get($);if(!f)return;const P=d.$5I.parentId(f.item.extId)?.toString();P?this.f.get(P).children.delete(f.item.extId):this.g.delete(f);const N=[[$]];for(;N.length;)for(const O of N.pop()){const L=this.f.get(O);L&&(N.push(L.children),this.f.delete(O),g.remove?.(L,L!==f),L.expand===2&&this.h--)}}o($){}updatePendingRoots($){this.j+=$}p(){return{}}}e.$_I=k}),define(De[109],Ce([1,0,9,4,3,58,87,67]),function(me,e,C,T,d,M,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7L=e.$6L=e.$5L=e.$4L=e.$3L=e.TestItemEventOp=void 0;var E;(function(r){r[r.Upsert=0]="Upsert",r[r.SetTags=1]="SetTags",r[r.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",r[r.RemoveChild=3]="RemoveChild",r[r.SetProp=4]="SetProp",r[r.Bulk=5]="Bulk",r[r.DocumentSynced=6]="DocumentSynced"})(E||(e.TestItemEventOp=E={}));const w=(r,c)=>r===c,I=Object.entries({range:(r,c)=>r===c?!0:!r||!c?!1:r.equalsRange(c),busy:w,label:w,description:w,error:w,sortText:w,tags:(r,c)=>!(r.length!==c.length||r.some(m=>!c.includes(m)))}),p=(r,c)=>{let m;for(const[h,t]of I)t(r[h],c[h])||(m?m[h]=c[h]:m={[h]:c[h]});return m};class y extends d.$Rc{get root(){return this.s.root}constructor(c){super(),this.s=c,this.f=this.B(new C.$5g(()=>this.flushDiff(),200)),this.g=this.B(new T.$Md),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.y(this.root,void 0)}set resolveHandler(c){this.h=c;for(const m of this.tree.values())this.I(m)}get resolveHandler(){return this.h}collectDiff(){const c=this.m;return this.m=[],c}pushDiff(c){switch(c.op){case 2:{for(const m of this.m)if(m.op===2&&m.uri===c.uri){m.docv=c.docv;return}break}case 1:{const m=this.m[this.m.length-1];if(m){if(m.op===1&&m.item.extId===c.item.extId){(0,A.$$I)(m.item,c.item);return}if(m.op===0&&m.item.item.extId===c.item.extId){(0,A.$$I)(m.item,c.item);return}}break}}this.m.push(c),this.f.isScheduled()||this.f.schedule()}expand(c,m){const h=this.tree.get(c);if(h){if((h.expandLevels===void 0||m>h.expandLevels)&&(h.expandLevels=m),h.expand===1){const t=this.L(h);return t.isOpen()?this.J(h,m-1):t.wait().then(()=>this.J(h,m-1))}else if(h.expand===3)return h.resolveBarrier?.isOpen()===!1?h.resolveBarrier.wait().then(()=>this.J(h,m-1)):this.J(h,m-1)}}dispose(){for(const c of this.tree.values())this.s.getApiFor(c.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}u(c,m){switch(m.op){case 3:this.N(b.$5I.joinToString(c.fullId,m.id));break;case 0:this.y(m.item,c);break;case 5:for(const h of m.ops)this.u(c,h);break;case 1:this.z(m.new,m.old,c.fullId.toString());break;case 2:this.I(c);break;case 4:this.pushDiff({op:1,item:{extId:c.fullId.toString(),item:m.update}});break;case 6:this.w(c.actual.uri);break;default:(0,M.$3c)(m)}}w(c){c&&this.pushDiff({op:2,uri:c,docv:this.s.getDocumentVersion(c)})}y(c,m){const h=b.$5I.fromExtHostTestItem(c,this.root.id,m?.actual),t=this.s.getApiFor(c);t.parent&&t.parent!==m?.actual&&this.s.getChildren(t.parent).delete(c.id);let n=this.tree.get(h.toString());if(!n){n={fullId:h,actual:c,expandLevels:m?.expandLevels?m.expandLevels-1:void 0,expand:0},c.tags.forEach(this.C,this),this.tree.set(n.fullId.toString(),n),this.F(c,m),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:n.expand,item:this.s.toITestItem(c)}}),this.H(c,n,m);return}if(n.actual===c){this.G(c,n,m);return}if(n.actual.uri?.toString()!==c.uri?.toString())return this.N(h.toString()),this.y(c,m);const o=this.s.getChildren(n.actual),i=n.actual,a=p(this.s.toITestItem(i),this.s.toITestItem(c));this.s.getApiFor(i).listener=void 0,n.actual=c,n.expand=0,a&&(a.hasOwnProperty("tags")&&(this.z(c.tags,i.tags,h.toString()),delete a.tags),this.u(n,{op:4,update:a})),this.H(c,n,m);for(const[u,k]of o)this.s.getChildren(c).get(k.id)||this.N(b.$5I.joinToString(h,k.id));this.w(n.actual.uri)}z(c,m,h){const t=new Set(m.map(n=>n.id));for(const n of c)t.delete(n.id)||this.C(n);this.pushDiff({op:1,item:{extId:h,item:{tags:c.map(n=>(0,A.$9I)(this.s.controllerId,n.id))}}}),t.forEach(this.D,this)}C(c){const m=this.j.get(c.id);m?m.refCount++:(this.j.set(c.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,A.$9I)(this.s.controllerId,c.id)}}))}D(c){const m=this.j.get(c);m&&!--m.refCount&&(this.j.delete(c),this.pushDiff({op:7,id:(0,A.$9I)(this.s.controllerId,c)}))}F(c,m){this.s.getApiFor(c).parent=m&&m.actual!==this.root?m.actual:void 0}G(c,m,h){this.F(c,h);const t=this.s.getApiFor(c);t.parent=h?.actual,t.listener=n=>this.u(m,n),this.I(m)}H(c,m,h){this.G(c,m,h);for(const[t,n]of this.s.getChildren(c))this.y(n,m)}I(c){let m;this.h?c.resolveBarrier?m=c.resolveBarrier.isOpen()?3:2:m=c.actual.canResolveChildren?1:0:m=0,m!==c.expand&&(c.expand=m,this.pushDiff({op:1,item:{extId:c.fullId.toString(),expand:m}}),m===1&&c.expandLevels!==void 0&&this.L(c))}J(c,m){if(m<0)return;const h=[];for(const[t,n]of this.s.getChildren(c.actual)){const o=this.expand(b.$5I.joinToString(c.fullId,n.id),m);(0,C.$Fg)(o)&&h.push(o)}if(h.length)return Promise.all(h).then(()=>{})}L(c){if(c.resolveBarrier)return c.resolveBarrier;if(!this.h){const n=new C.$Rg;return n.open(),n}c.expand=2,this.M(c);const m=c.resolveBarrier=new C.$Rg,h=n=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,n)};let t;try{t=this.h(c.actual===this.root?void 0:c.actual)}catch(n){h(n)}return(0,C.$Fg)(t)?t.catch(h).then(()=>{m.open(),this.I(c)}):(m.open(),this.I(c)),c.resolveBarrier}M(c){this.pushDiff({op:1,item:{extId:c.fullId.toString(),expand:c.expand}})}N(c){const m=this.tree.get(c);if(!m)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:c});const h=[m];for(;h.length;){const t=h.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const n of t.actual.tags)this.D(n.id);this.tree.delete(t.fullId.toString());for(const[n,o]of this.s.getChildren(t.actual))h.push(this.tree.get(b.$5I.joinToString(t.fullId,o.id)))}}}flushDiff(){const c=this.collectDiff();c.length&&this.g.fire(c)}}e.$3L=y;class D extends Error{constructor(c){super(`Attempted to insert a duplicate test item ID ${c}`)}}e.$4L=D;class v extends Error{constructor(c){super(`TestItem with ID "${c}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$5L=v;class l extends Error{constructor(c,m,h){super(`TestItem with ID "${c}" is from controller "${m}" and cannot be added as a child of an item from controller "${h}".`)}}e.$6L=l;const s=(r,c,m)=>{let h=new Map;return{get size(){return h.size},forEach(t,n){for(const o of h.values())t.call(n,o,this)},[Symbol.iterator](){return h.entries()},replace(t){const n=new Map,o=new Set(h.keys()),i={op:5,ops:[]};for(const a of t){if(!(a instanceof m))throw new v(a.id);const u=c(a).controllerId;if(u!==r.controllerId)throw new l(a.id,u,r.controllerId);if(n.has(a.id))throw new D(a.id);n.set(a.id,a),o.delete(a.id),i.ops.push({op:0,item:a})}for(const a of o.keys())i.ops.push({op:3,id:a});r.listener?.(i),h=n},add(t){if(!(t instanceof m))throw new v(t.id);h.set(t.id,t),r.listener?.({op:0,item:t})},delete(t){h.delete(t)&&r.listener?.({op:3,id:t})},get(t){return h.get(t)},toJSON(){return Array.from(h.values())}}};e.$7L=s}),define(De[142],Ce([1,0,109]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9L=e.$8L=void 0;const T=new WeakMap,d=(A,b)=>{const E={controllerId:b};return T.set(A,E),E};e.$8L=d;const M=A=>{const b=T.get(A);if(!b)throw new C.$5L(A?.id||"<unknown>");return b};e.$9L=M}),define(De[110],Ce([1,0,17,2]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2ob=e.$1ob=e.$Zob=e.$Yob=e.$Xob=void 0,e.$Xob="vscode-cdn.net",e.$Yob=`vscode-resource.${e.$Xob}`,e.$Zob=`'self' https://*.${e.$Xob}`;function d(b,E){return b.scheme===C.Schemas.http||b.scheme===C.Schemas.https?b:(E&&E.authority&&E.isRemote&&b.scheme===C.Schemas.file&&(b=T.URI.from({scheme:C.Schemas.vscodeRemote,authority:E.authority,path:b.path})),T.URI.from({scheme:C.Schemas.https,authority:`${b.scheme}+${M(b.authority)}.${e.$Yob}`,path:b.path,fragment:b.fragment,query:b.query}))}e.$1ob=d;function M(b){return b.replace(/./g,E=>{const w=E.charCodeAt(0);return w>=97&&w<=122||w>=65&&w<=90||w>=48&&w<=57?E:"-"+w.toString(16).padStart(4,"0")})}function A(b){return b.replace(/-([0-9a-f]{4})/g,(E,w)=>String.fromCharCode(parseInt(w,16)))}e.$2ob=A}),define(De[276],Ce([1,0,4,3,110]),function(me,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ucc=void 0;class M{constructor(b,E,w){this.d=b,this.e=E,this.f=w,this.a=0,this.b=new T.$Qc,this.c=new Map,this.b.add(E.onDidChangeVisibleTextEditors(()=>{const R=E.getVisibleTextEditors();for(const I of this.c.values())R.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this.c.forEach(b=>b.inset.dispose()),this.b.dispose()}createWebviewEditorInset(b,E,w,R,I){let p;for(const c of this.e.getVisibleTextEditors(!0))if(c.value===b){p=c;break}if(!p)throw new Error("not a visible editor");const y=this,D=this.a++,v=new C.$Md,l=new C.$Md,s=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(c){return(0,d.$1ob)(c,y.f)}get cspSource(){return d.$Zob}set options(c){this.b=c,y.d.$setOptions(D,c)}get options(){return this.b}set html(c){this.a=c,y.d.$setHtml(D,c)}get html(){return this.a}get onDidReceiveMessage(){return v.event}postMessage(c){return y.d.$postMessage(D,c)}},r=new class{constructor(){this.editor=b,this.line=E,this.height=w,this.webview=s,this.onDidDispose=l.event}dispose(){y.c.has(D)&&(y.c.delete(D),y.d.$disposeEditorInset(D),l.fire(),l.dispose(),v.dispose())}};return this.d.$createEditorInset(D,p.id,p.value.document.uri,E+1,w,R||{},I.identifier,I.extensionLocation),this.c.set(D,{editor:b,inset:r,onDidReceiveMessage:v}),r}$onDidDispose(b){const E=this.c.get(b);E&&E.inset.dispose()}$onDidReceiveMessage(b,E){this.c.get(b)?.onDidReceiveMessage.fire(E)}}e.$Ucc=M}),define(De[277],Ce([1,0,5]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZM=e.VariableKind=e.$YM=void 0,e.$YM=(0,C.$Nh)("configurationResolverService");var T;(function(M){M.Unknown="unknown",M.Env="env",M.Config="config",M.Command="command",M.Input="input",M.ExtensionInstallFolder="extensionInstallFolder",M.WorkspaceFolder="workspaceFolder",M.Cwd="cwd",M.WorkspaceFolderBasename="workspaceFolderBasename",M.UserHome="userHome",M.LineNumber="lineNumber",M.SelectedText="selectedText",M.File="file",M.FileWorkspaceFolder="fileWorkspaceFolder",M.RelativeFile="relativeFile",M.RelativeFileDirname="relativeFileDirname",M.FileDirname="fileDirname",M.FileExtname="fileExtname",M.FileBasename="fileBasename",M.FileBasenameNoExtension="fileBasenameNoExtension",M.FileDirnameBasename="fileDirnameBasename",M.ExecPath="execPath",M.ExecInstallFolder="execInstallFolder",M.PathSeparator="pathSeparator"})(T||(e.VariableKind=T={}));class d extends Error{constructor(A,b){super(b),this.variable=A}}e.$ZM=d}),define(De[278],Ce([1,0,16,47,18,23,12,99,223,277,15]),function(me,e,C,T,d,M,A,b,E,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bN=void 0;class I{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(y,D,v,l){this.h=new Map,this.a=y,this.b=D,this.g=v,l&&(this.c=l.then(s=>this.i(s)))}i(y){if(A.$j){const D=Object.create(null);return Object.keys(y).forEach(v=>{D[v.toLowerCase()]=y[v]}),D}return y}resolveWithEnvironment(y,D,v){return this.l({env:this.i(y),userHome:void 0},D?D.uri:void 0,v)}async resolveAsync(y,D){const v={env:await this.c,userHome:await this.g};return this.l(v,y?y.uri:void 0,D)}async j(y,D,v,l){const s=M.$2m(D);A.$j&&s.windows?Object.keys(s.windows).forEach(c=>s[c]=s.windows[c]):A.$k&&s.osx?Object.keys(s.osx).forEach(c=>s[c]=s.osx[c]):A.$l&&s.linux&&Object.keys(s.linux).forEach(c=>s[c]=s.linux[c]),delete s.windows,delete s.osx,delete s.linux;const r={env:await this.c,userHome:await this.g};return this.l(r,y?y.uri:void 0,s,v,l)}async resolveAnyAsync(y,D,v){return this.j(y,D,v)}async resolveAnyMap(y,D,v){const l=new Map;return{newConfig:await this.j(y,D,v,l),resolvedVariables:l}}resolveWithInteractionReplace(y,D,v,l){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(y,D,v,l){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(y,D){if(this.h.has(y))throw new Error("Variable "+y+" is contributed twice.");this.h.set(y,D)}async l(y,D,v,l,s){if(d.$xf(v))return this.m(y,D,v,l,s);if(Array.isArray(v))return Promise.all(v.map(r=>this.l(y,D,r,l,s)));if(d.$zf(v)){const r=Object.create(null),c=await Promise.all(Object.keys(v).map(async m=>[await this.m(y,D,m,l,s),await this.l(y,D,v[m],l,s)]));for(const[m,h]of c)r[m]=h;return r}return v}m(y,D,v,l,s){return(0,R.$Se)(v,I.VARIABLE_REGEXP,async(r,c)=>{if(c.includes(I.VARIABLE_LHS))return r;let m=await this.o(y,r,c,D,l);return s?.set(c,m),m!==r&&d.$xf(m)&&m.match(I.VARIABLE_REGEXP)&&(m=await this.m(y,D,m,l,s)),m})}n(y){return this.b?this.b.getUriLabel(y,{noPrefix:!0}):y.fsPath}async o(y,D,v,l,s){let r;const c=v.split(":");c.length>1&&(v=c[0],r=c[1]);const m=n=>{const o=this.a.getFilePath();if(o)return(0,b.$mv)(o);throw new w.$ZM(n,(0,E.localize)(0,null,D))},h=n=>{const o=m(n);if(this.a.getWorkspaceFolderPathForFile){const i=this.a.getWorkspaceFolderPathForFile();if(i)return(0,b.$mv)(i)}throw new w.$ZM(n,(0,E.localize)(1,null,D,C.$mc(o)))},t=n=>{if(r){const o=this.a.getFolderUri(r);if(o)return o;throw new w.$ZM(n,(0,E.localize)(2,null,D,r))}if(l)return l;throw this.a.getWorkspaceFolderCount()>1?new w.$ZM(n,(0,E.localize)(3,null,D)):new w.$ZM(n,(0,E.localize)(4,null,D))};switch(v){case"env":if(r){if(y.env){const n=y.env[A.$j?r.toLowerCase():r];if(d.$xf(n))return n}return""}throw new w.$ZM(w.VariableKind.Env,(0,E.localize)(5,null,D));case"config":if(r){const n=this.a.getConfigurationValue(l,r);if(d.$Gf(n))throw new w.$ZM(w.VariableKind.Config,(0,E.localize)(6,null,D,r));if(d.$zf(n))throw new w.$ZM(w.VariableKind.Config,(0,E.localize)(7,null,D,r));return n}throw new w.$ZM(w.VariableKind.Config,(0,E.localize)(8,null,D));case"command":return this.p(w.VariableKind.Command,D,r,s,"command");case"input":return this.p(w.VariableKind.Input,D,r,s,"input");case"extensionInstallFolder":if(r){const n=await this.a.getExtension(r);if(!n)throw new w.$ZM(w.VariableKind.ExtensionInstallFolder,(0,E.localize)(9,null,D,r));return this.n(n.extensionLocation)}throw new w.$ZM(w.VariableKind.ExtensionInstallFolder,(0,E.localize)(10,null,D));default:switch(v){case"workspaceRoot":case"workspaceFolder":return(0,b.$mv)(this.n(t(w.VariableKind.WorkspaceFolder)));case"cwd":return l||r?(0,b.$mv)(this.n(t(w.VariableKind.Cwd))):T.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,b.$mv)(C.$mc(this.n(t(w.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(y.userHome)return y.userHome;throw new w.$ZM(w.VariableKind.UserHome,(0,E.localize)(11,null,D))}case"lineNumber":{const n=this.a.getLineNumber();if(n)return n;throw new w.$ZM(w.VariableKind.LineNumber,(0,E.localize)(12,null,D))}case"selectedText":{const n=this.a.getSelectedText();if(n)return n;throw new w.$ZM(w.VariableKind.SelectedText,(0,E.localize)(13,null,D))}case"file":return m(w.VariableKind.File);case"fileWorkspaceFolder":return h(w.VariableKind.FileWorkspaceFolder);case"relativeFile":return l||r?C.$kc(this.n(t(w.VariableKind.RelativeFile)),m(w.VariableKind.RelativeFile)):m(w.VariableKind.RelativeFile);case"relativeFileDirname":{const n=C.$lc(m(w.VariableKind.RelativeFileDirname));if(l||r){const o=C.$kc(this.n(t(w.VariableKind.RelativeFileDirname)),n);return o.length===0?".":o}return n}case"fileDirname":return C.$lc(m(w.VariableKind.FileDirname));case"fileExtname":return C.$nc(m(w.VariableKind.FileExtname));case"fileBasename":return C.$mc(m(w.VariableKind.FileBasename));case"fileBasenameNoExtension":{const n=C.$mc(m(w.VariableKind.FileBasenameNoExtension));return n.slice(0,n.length-C.$nc(n).length)}case"fileDirnameBasename":return C.$mc(C.$lc(m(w.VariableKind.FileDirnameBasename)));case"execPath":{const n=this.a.getExecPath();return n||D}case"execInstallFolder":{const n=this.a.getAppRoot();return n||D}case"pathSeparator":return C.sep;default:try{const n=r?`${v}:${r}`:v;return this.p(w.VariableKind.Unknown,D,n,s,void 0)}catch{return D}}}}p(y,D,v,l,s){if(v&&l){const r=s===void 0?l[v]:l[s+":"+v];if(typeof r=="string")return r;throw new w.$ZM(y,(0,E.localize)(14,null,D))}return D}}e.$bN=I}),define(De[143],Ce([1,0,5,139]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bC=e.$aC=e.OpenEditorContext=e.GroupsOrder=e.$_B=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$$B=void 0,e.$$B=(0,C.$Nh)("editorGroupsService");var d;(function(D){D[D.UP=0]="UP",D[D.DOWN=1]="DOWN",D[D.LEFT=2]="LEFT",D[D.RIGHT=3]="RIGHT"})(d||(e.GroupDirection=d={}));var M;(function(D){D[D.HORIZONTAL=0]="HORIZONTAL",D[D.VERTICAL=1]="VERTICAL"})(M||(e.GroupOrientation=M={}));var A;(function(D){D[D.FIRST=0]="FIRST",D[D.LAST=1]="LAST",D[D.NEXT=2]="NEXT",D[D.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var b;(function(D){D[D.MAXIMIZE=0]="MAXIMIZE",D[D.EVEN=1]="EVEN",D[D.TOGGLE=2]="TOGGLE"})(b||(e.GroupsArrangement=b={}));var E;(function(D){D[D.COPY_EDITORS=0]="COPY_EDITORS",D[D.MOVE_EDITORS=1]="MOVE_EDITORS"})(E||(e.MergeGroupMode=E={}));function w(D){const v=D;return(0,T.$1D)(v?.editor)&&(0,T.$1D)(v?.replacement)}e.$_B=w;var R;(function(D){D[D.CREATION_TIME=0]="CREATION_TIME",D[D.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",D[D.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R||(e.GroupsOrder=R={}));var I;(function(D){D[D.NEW_EDITOR=1]="NEW_EDITOR",D[D.MOVE_EDITOR=2]="MOVE_EDITOR",D[D.COPY_EDITOR=3]="COPY_EDITOR"})(I||(e.OpenEditorContext=I={}));function p(D){const v=D;return!!v&&typeof v.id=="number"&&Array.isArray(v.editors)}e.$aC=p;function y(D){return D.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$bC=y}),define(De[279],Ce([1,0,5,143]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fC=e.$eC=e.$dC=e.$cC=void 0,e.$cC=(0,C.$Nh)("editorService"),e.$dC=-1,e.$eC=-2;function d(M){const A=M;return typeof M=="number"||(0,T.$aC)(A)}e.$fC=d}),define(De[14],Ce([1,0,19,22,162,74,79,28,158,62,97,23,18,2,34,82,133,142,139,108,67,87,279,7]),function(me,e,C,T,d,M,A,b,E,w,R,I,p,y,D,v,l,s,r,c,m,h,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$_L=e.$$L=e.MarkdownString=e.$0L=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var o;(function(Le){function Te(ne){const{selectionStartLineNumber:Fe,selectionStartColumn:Ke,positionLineNumber:xe,positionColumn:Je}=ne,nt=new n.$cK(Fe-1,Ke-1),mt=new n.$cK(xe-1,Je-1);return new n.$eK(nt,mt)}Le.to=Te;function Se(ne){const{anchor:Fe,active:Ke}=ne;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:Ke.line+1,positionColumn:Ke.character+1}}Le.from=Se})(o||(e.Selection=o={}));var i;(function(Le){function Te(ne){if(!ne)return;const{start:Fe,end:Ke}=ne;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:Ke.line+1,endColumn:Ke.character+1}}Le.from=Te;function Se(ne){if(!ne)return;const{startLineNumber:Fe,startColumn:Ke,endLineNumber:xe,endColumn:Je}=ne;return new n.$dK(Fe-1,Ke-1,xe-1,Je-1)}Le.to=Se})(i||(e.Range=i={}));var a;(function(Le){function Te(Se){switch(Se){case 1:return n.StandardTokenType.Comment;case 0:return n.StandardTokenType.Other;case 3:return n.StandardTokenType.RegEx;case 2:return n.StandardTokenType.String}}Le.to=Te})(a||(e.TokenType=a={}));var u;(function(Le){function Te(ne){return new n.$cK(ne.lineNumber-1,ne.column-1)}Le.to=Te;function Se(ne){return{lineNumber:ne.line+1,column:ne.character+1}}Le.from=Se})(u||(e.Position=u={}));var k;(function(Le){function Te(Fe,Ke,xe){return(0,C.$Gb)((0,C.$2b)(Fe).map(Je=>Se(Je,Ke,xe)))}Le.from=Te;function Se(Fe,Ke,xe){if(typeof Fe=="string")return{$serialized:!0,language:Fe,isBuiltin:xe?.isBuiltin};if(Fe)return{$serialized:!0,language:Fe.language,scheme:ne(Fe.scheme,Ke),pattern:Ze.from(Fe.pattern)??void 0,exclusive:Fe.exclusive,notebookType:Fe.notebookType,isBuiltin:xe?.isBuiltin}}function ne(Fe,Ke){return Ke&&typeof Fe=="string"?Ke.transformOutgoingScheme(Fe):Fe}})(k||(e.DocumentSelector=k={}));var S;(function(Le){function Te(ne){switch(ne){case n.DiagnosticTag.Unnecessary:return 1;case n.DiagnosticTag.Deprecated:return 2}}Le.from=Te;function Se(ne){switch(ne){case 1:return n.DiagnosticTag.Unnecessary;case 2:return n.DiagnosticTag.Deprecated;default:return}}Le.to=Se})(S||(e.DiagnosticTag=S={}));var $;(function(Le){function Te(ne){let Fe;return ne.code&&((0,p.$xf)(ne.code)||(0,p.$Bf)(ne.code)?Fe=String(ne.code):Fe={value:String(ne.code.value),target:ne.code.target}),{...i.from(ne.range),message:ne.message,source:ne.source,code:Fe,severity:f.from(ne.severity),relatedInformation:ne.relatedInformation&&ne.relatedInformation.map(g.from),tags:Array.isArray(ne.tags)?(0,C.$Gb)(ne.tags.map(S.from)):void 0}}Le.from=Te;function Se(ne){const Fe=new n.$pK(i.to(ne),ne.message,f.to(ne.severity));return Fe.source=ne.source,Fe.code=(0,p.$xf)(ne.code)?ne.code:ne.code?.value,Fe.relatedInformation=ne.relatedInformation&&ne.relatedInformation.map(g.to),Fe.tags=ne.tags&&(0,C.$Gb)(ne.tags.map(S.to)),Fe}Le.to=Se})($||(e.Diagnostic=$={}));var g;(function(Le){function Te(ne){return{...i.from(ne.location.range),message:ne.message,resource:ne.location.uri}}Le.from=Te;function Se(ne){return new n.$oK(new n.$nK(ne.resource,i.to(ne)),ne.message)}Le.to=Se})(g||(e.DiagnosticRelatedInformation=g={}));var f;(function(Le){function Te(ne){switch(ne){case n.DiagnosticSeverity.Error:return l.MarkerSeverity.Error;case n.DiagnosticSeverity.Warning:return l.MarkerSeverity.Warning;case n.DiagnosticSeverity.Information:return l.MarkerSeverity.Info;case n.DiagnosticSeverity.Hint:return l.MarkerSeverity.Hint}return l.MarkerSeverity.Error}Le.from=Te;function Se(ne){switch(ne){case l.MarkerSeverity.Info:return n.DiagnosticSeverity.Information;case l.MarkerSeverity.Warning:return n.DiagnosticSeverity.Warning;case l.MarkerSeverity.Error:return n.DiagnosticSeverity.Error;case l.MarkerSeverity.Hint:return n.DiagnosticSeverity.Hint;default:return n.DiagnosticSeverity.Error}}Le.to=Se})(f||(e.DiagnosticSeverity=f={}));var P;(function(Le){function Te(ne){return typeof ne=="number"&&ne>=n.ViewColumn.One?ne-1:ne===n.ViewColumn.Beside?t.$eC:t.$dC}Le.from=Te;function Se(ne){if(typeof ne=="number"&&ne>=0)return ne+1;throw new Error("invalid 'EditorGroupColumn'")}Le.to=Se})(P||(e.ViewColumn=P={}));function N(Le){return typeof Le.range<"u"}function O(Le){return Le.length===0?!0:!!N(Le[0])}e.$0L=O;var L;(function(Le){function Te(Je){return Je.map(Le.from)}Le.fromMany=Te;function Se(Je){return Je&&typeof Je=="object"&&typeof Je.language=="string"&&typeof Je.value=="string"}function ne(Je){let nt;if(Se(Je)){const{language:dt,value:Rt}=Je;nt={value:"```"+dt+`
`+Rt+"\n```\n"}}else n.$BK.isMarkdownString(Je)?nt={value:Je.value,isTrusted:Je.isTrusted,supportThemeIcons:Je.supportThemeIcons,supportHtml:Je.supportHtml,baseUri:Je.baseUri}:typeof Je=="string"?nt={value:Je}:nt={value:""};const mt=Object.create(null);nt.uris=mt;const gt=dt=>{try{let Rt=y.URI.parse(dt,!0);Rt=Rt.with({query:Fe(Rt.query,mt)}),mt[dt]=Rt}catch{}return""},bt=new E.marked.Renderer;return bt.link=gt,bt.image=dt=>typeof dt=="string"?gt(A.$8j(dt).href):"",(0,E.marked)(nt.value,{renderer:bt}),nt}Le.from=ne;function Fe(Je,nt){if(!Je)return Je;let mt;try{mt=(0,w.$jh)(Je)}catch{}if(!mt)return Je;let gt=!1;return mt=(0,I.$4m)(mt,bt=>{if(y.URI.isUri(bt)){const dt=`__uri_${Math.random().toString(16).slice(2,8)}`;return nt[dt]=bt,gt=!0,dt}else return}),gt?JSON.stringify(mt):Je}function Ke(Je){const nt=new n.$BK(Je.value,Je.supportThemeIcons);return nt.isTrusted=Je.isTrusted,nt.supportHtml=Je.supportHtml,nt.baseUri=Je.baseUri?y.URI.from(Je.baseUri):void 0,nt}Le.to=Ke;function xe(Je){if(Je)return typeof Je=="string"?Je:Le.from(Je)}Le.fromStrict=xe})(L||(e.MarkdownString=L={}));function j(Le){return O(Le)?Le.map(Te=>({range:i.from(Te.range),hoverMessage:Array.isArray(Te.hoverMessage)?L.fromMany(Te.hoverMessage):Te.hoverMessage?L.from(Te.hoverMessage):void 0,renderOptions:Te.renderOptions})):Le.map(Te=>({range:i.from(Te)}))}e.$$L=j;function z(Le){return typeof Le>"u"?Le:typeof Le=="string"?y.URI.file(Le):Le}e.$_L=z;var F;(function(Le){function Te(Se){return typeof Se>"u"?Se:{contentText:Se.contentText,contentIconPath:Se.contentIconPath?z(Se.contentIconPath):void 0,border:Se.border,borderColor:Se.borderColor,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,color:Se.color,backgroundColor:Se.backgroundColor,margin:Se.margin,width:Se.width,height:Se.height}}Le.from=Te})(F||(e.ThemableDecorationAttachmentRenderOptions=F={}));var H;(function(Le){function Te(Se){return typeof Se>"u"?Se:{backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?z(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?F.from(Se.before):void 0,after:Se.after?F.from(Se.after):void 0}}Le.from=Te})(H||(e.ThemableDecorationRenderOptions=H={}));var K;(function(Le){function Te(Se){if(typeof Se>"u")return Se;switch(Se){case n.DecorationRangeBehavior.OpenOpen:return 0;case n.DecorationRangeBehavior.ClosedClosed:return 1;case n.DecorationRangeBehavior.OpenClosed:return 2;case n.DecorationRangeBehavior.ClosedOpen:return 3}}Le.from=Te})(K||(e.DecorationRangeBehavior=K={}));var fe;(function(Le){function Te(Se){return{isWholeLine:Se.isWholeLine,rangeBehavior:Se.rangeBehavior?K.from(Se.rangeBehavior):void 0,overviewRulerLane:Se.overviewRulerLane,light:Se.light?H.from(Se.light):void 0,dark:Se.dark?H.from(Se.dark):void 0,backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?z(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?F.from(Se.before):void 0,after:Se.after?F.from(Se.after):void 0}}Le.from=Te})(fe||(e.DecorationRenderOptions=fe={}));var x;(function(Le){function Te(ne){return{text:ne.newText,eol:ne.newEol&&et.from(ne.newEol),range:i.from(ne.range)}}Le.from=Te;function Se(ne){const Fe=new n.$iK(i.to(ne.range),ne.text);return Fe.newEol=typeof ne.eol>"u"?void 0:et.to(ne.eol),Fe}Le.to=Se})(x||(e.TextEdit=x={}));var Z;(function(Le){function Te(ne,Fe){const Ke={edits:[]};if(ne instanceof n.$lK){const xe=new b.$Ac;for(const Je of ne._allEntries())Je._type===1&&y.URI.isUri(Je.to)&&Je.from===void 0&&xe.add(Je.to);for(const Je of ne._allEntries())if(Je._type===1){let nt;Je.options?.contents&&(ArrayBuffer.isView(Je.options.contents)?nt={type:"base64",value:(0,T.$ue)(T.$ae.wrap(Je.options.contents))}:nt={type:"dataTransferItem",id:Je.options.contents._itemId}),Ke.edits.push({oldResource:Je.from,newResource:Je.to,options:{...Je.options,contents:nt},metadata:Je.metadata})}else Je._type===2?Ke.edits.push({resource:Je.uri,textEdit:x.from(Je.edit),versionId:xe.has(Je.uri)?void 0:Fe?.getTextDocumentVersion(Je.uri),metadata:Je.metadata}):Je._type===6?Ke.edits.push({resource:Je.uri,textEdit:{range:i.from(Je.range),text:Je.edit.value,insertAsSnippet:!0},versionId:xe.has(Je.uri)?void 0:Fe?.getTextDocumentVersion(Je.uri),metadata:Je.metadata}):Je._type===3?Ke.edits.push({metadata:Je.metadata,resource:Je.uri,cellEdit:Je.edit,notebookMetadata:Je.notebookMetadata,notebookVersionId:Fe?.getNotebookDocumentVersion(Je.uri)}):Je._type===5&&Ke.edits.push({metadata:Je.metadata,resource:Je.uri,notebookVersionId:Fe?.getNotebookDocumentVersion(Je.uri),cellEdit:{editType:1,index:Je.index,count:Je.count,cells:Je.cells.map(ot.from)}})}return Ke}Le.from=Te;function Se(ne){const Fe=new n.$lK,Ke=new b.$zc;for(const xe of ne.edits)if(xe.textEdit){const Je=xe,nt=y.URI.revive(Je.resource),mt=i.to(Je.textEdit.range),gt=Je.textEdit.text,bt=Je.textEdit.insertAsSnippet;let dt;bt?dt=n.$kK.replace(mt,new n.$mK(gt)):dt=n.$iK.replace(mt,gt);const Rt=Ke.get(nt);Rt?Rt.push(dt):Ke.set(nt,[dt])}else Fe.renameFile(y.URI.revive(xe.oldResource),y.URI.revive(xe.newResource),xe.options);for(const[xe,Je]of Ke)Fe.set(xe,Je);return Fe}Le.to=Se})(Z||(e.WorkspaceEdit=Z={}));var q;(function(Le){const Te=Object.create(null);Te[n.SymbolKind.File]=0,Te[n.SymbolKind.Module]=1,Te[n.SymbolKind.Namespace]=2,Te[n.SymbolKind.Package]=3,Te[n.SymbolKind.Class]=4,Te[n.SymbolKind.Method]=5,Te[n.SymbolKind.Property]=6,Te[n.SymbolKind.Field]=7,Te[n.SymbolKind.Constructor]=8,Te[n.SymbolKind.Enum]=9,Te[n.SymbolKind.Interface]=10,Te[n.SymbolKind.Function]=11,Te[n.SymbolKind.Variable]=12,Te[n.SymbolKind.Constant]=13,Te[n.SymbolKind.String]=14,Te[n.SymbolKind.Number]=15,Te[n.SymbolKind.Boolean]=16,Te[n.SymbolKind.Array]=17,Te[n.SymbolKind.Object]=18,Te[n.SymbolKind.Key]=19,Te[n.SymbolKind.Null]=20,Te[n.SymbolKind.EnumMember]=21,Te[n.SymbolKind.Struct]=22,Te[n.SymbolKind.Event]=23,Te[n.SymbolKind.Operator]=24,Te[n.SymbolKind.TypeParameter]=25;function Se(Fe){return typeof Te[Fe]=="number"?Te[Fe]:6}Le.from=Se;function ne(Fe){for(const Ke in Te)if(Te[Ke]===Fe)return Number(Ke);return n.SymbolKind.Property}Le.to=ne})(q||(e.SymbolKind=q={}));var Y;(function(Le){function Te(ne){switch(ne){case n.SymbolTag.Deprecated:return 1}}Le.from=Te;function Se(ne){switch(ne){case 1:return n.SymbolTag.Deprecated}}Le.to=Se})(Y||(e.SymbolTag=Y={}));var be;(function(Le){function Te(ne){return{name:ne.name,kind:q.from(ne.kind),tags:ne.tags&&ne.tags.map(Y.from),containerName:ne.containerName,location:V.from(ne.location)}}Le.from=Te;function Se(ne){const Fe=new n.$sK(ne.name,q.to(ne.kind),ne.containerName,V.to(ne.location));return Fe.tags=ne.tags&&ne.tags.map(Y.to),Fe}Le.to=Se})(be||(e.WorkspaceSymbol=be={}));var ue;(function(Le){function Te(ne){const Fe={name:ne.name||"!!MISSING: name!!",detail:ne.detail,range:i.from(ne.range),selectionRange:i.from(ne.selectionRange),kind:q.from(ne.kind),tags:ne.tags?.map(Y.from)??[]};return ne.children&&(Fe.children=ne.children.map(Te)),Fe}Le.from=Te;function Se(ne){const Fe=new n.$tK(ne.name,ne.detail,q.to(ne.kind),i.to(ne.range),i.to(ne.selectionRange));return(0,C.$Kb)(ne.tags)&&(Fe.tags=ne.tags.map(Y.to)),ne.children&&(Fe.children=ne.children.map(Se)),Fe}Le.to=Se})(ue||(e.DocumentSymbol=ue={}));var ve;(function(Le){function Te(ne){const Fe=new n.$xK(q.to(ne.kind),ne.name,ne.detail||"",y.URI.revive(ne.uri),i.to(ne.range),i.to(ne.selectionRange));return Fe._sessionId=ne._sessionId,Fe._itemId=ne._itemId,Fe}Le.to=Te;function Se(ne,Fe,Ke){if(Fe=Fe??ne._sessionId,Ke=Ke??ne._itemId,Fe===void 0||Ke===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:Ke,name:ne.name,detail:ne.detail,kind:q.from(ne.kind),uri:ne.uri,range:i.from(ne.range),selectionRange:i.from(ne.selectionRange),tags:ne.tags?.map(Y.from)}}Le.from=Se})(ve||(e.CallHierarchyItem=ve={}));var J;(function(Le){function Te(Se){return new n.$yK(ve.to(Se.from),Se.fromRanges.map(ne=>i.to(ne)))}Le.to=Te})(J||(e.CallHierarchyIncomingCall=J={}));var U;(function(Le){function Te(Se){return new n.$zK(ve.to(Se.to),Se.fromRanges.map(ne=>i.to(ne)))}Le.to=Te})(U||(e.CallHierarchyOutgoingCall=U={}));var V;(function(Le){function Te(ne){return{range:ne.range&&i.from(ne.range),uri:ne.uri}}Le.from=Te;function Se(ne){return new n.$nK(y.URI.revive(ne.uri),i.to(ne.range))}Le.to=Se})(V||(e.location=V={}));var ge;(function(Le){function Te(ne){const Fe=ne,Ke=ne;return{originSelectionRange:Fe.originSelectionRange?i.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:Ke.uri,range:i.from(Fe.targetRange?Fe.targetRange:Ke.range),targetSelectionRange:Fe.targetSelectionRange?i.from(Fe.targetSelectionRange):void 0}}Le.from=Te;function Se(ne){return{targetUri:y.URI.revive(ne.uri),targetRange:i.to(ne.range),targetSelectionRange:ne.targetSelectionRange?i.to(ne.targetSelectionRange):void 0,originSelectionRange:ne.originSelectionRange?i.to(ne.originSelectionRange):void 0}}Le.to=Se})(ge||(e.DefinitionLink=ge={}));var _;(function(Le){function Te(ne){return{range:i.from(ne.range),contents:L.fromMany(ne.contents)}}Le.from=Te;function Se(ne){return new n.$qK(ne.contents.map(L.to),i.to(ne.range))}Le.to=Se})(_||(e.Hover=_={}));var ie;(function(Le){function Te(ne){return{range:i.from(ne.range),expression:ne.expression}}Le.from=Te;function Se(ne){return new n.$jL(i.to(ne.range),ne.expression)}Le.to=Se})(ie||(e.EvaluatableExpression=ie={}));var re;(function(Le){function Te(ne){if(ne instanceof n.$kL)return{type:"text",range:i.from(ne.range),text:ne.text};if(ne instanceof n.$lL)return{type:"variable",range:i.from(ne.range),variableName:ne.variableName,caseSensitiveLookup:ne.caseSensitiveLookup};if(ne instanceof n.$mL)return{type:"expression",range:i.from(ne.range),expression:ne.expression};throw new Error("Unknown 'InlineValue' type")}Le.from=Te;function Se(ne){switch(ne.type){case"text":return{range:i.to(ne.range),text:ne.text};case"variable":return{range:i.to(ne.range),variableName:ne.variableName,caseSensitiveLookup:ne.caseSensitiveLookup};case"expression":return{range:i.to(ne.range),expression:ne.expression}}}Le.to=Se})(re||(e.InlineValue=re={}));var Ee;(function(Le){function Te(ne){return{frameId:ne.frameId,stoppedLocation:i.from(ne.stoppedLocation)}}Le.from=Te;function Se(ne){return new n.$nL(ne.frameId,i.to(ne.stoppedLocation))}Le.to=Se})(Ee||(e.InlineValueContext=Ee={}));var oe;(function(Le){function Te(ne){return{range:i.from(ne.range),kind:ne.kind}}Le.from=Te;function Se(ne){return new n.$rK(i.to(ne.range),ne.kind)}Le.to=Se})(oe||(e.DocumentHighlight=oe={}));var he;(function(Le){function Te(Se){switch(Se){case 1:return n.CompletionTriggerKind.TriggerCharacter;case 2:return n.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return n.CompletionTriggerKind.Invoke}}Le.to=Te})(he||(e.CompletionTriggerKind=he={}));var ee;(function(Le){function Te(Se){return{triggerKind:he.to(Se.triggerKind),triggerCharacter:Se.triggerCharacter}}Le.to=Te})(ee||(e.CompletionContext=ee={}));var le;(function(Le){function Te(ne){switch(ne){case n.CompletionItemTag.Deprecated:return 1}}Le.from=Te;function Se(ne){switch(ne){case 1:return n.CompletionItemTag.Deprecated}}Le.to=Se})(le||(e.CompletionItemTag=le={}));var $e;(function(Le){const Te=new Map([[n.CompletionItemKind.Method,0],[n.CompletionItemKind.Function,1],[n.CompletionItemKind.Constructor,2],[n.CompletionItemKind.Field,3],[n.CompletionItemKind.Variable,4],[n.CompletionItemKind.Class,5],[n.CompletionItemKind.Interface,7],[n.CompletionItemKind.Struct,6],[n.CompletionItemKind.Module,8],[n.CompletionItemKind.Property,9],[n.CompletionItemKind.Unit,12],[n.CompletionItemKind.Value,13],[n.CompletionItemKind.Constant,14],[n.CompletionItemKind.Enum,15],[n.CompletionItemKind.EnumMember,16],[n.CompletionItemKind.Keyword,17],[n.CompletionItemKind.Snippet,27],[n.CompletionItemKind.Text,18],[n.CompletionItemKind.Color,19],[n.CompletionItemKind.File,20],[n.CompletionItemKind.Reference,21],[n.CompletionItemKind.Folder,23],[n.CompletionItemKind.Event,10],[n.CompletionItemKind.Operator,11],[n.CompletionItemKind.TypeParameter,24],[n.CompletionItemKind.Issue,26],[n.CompletionItemKind.User,25]]);function Se(Ke){return Te.get(Ke)??9}Le.from=Se;const ne=new Map([[0,n.CompletionItemKind.Method],[1,n.CompletionItemKind.Function],[2,n.CompletionItemKind.Constructor],[3,n.CompletionItemKind.Field],[4,n.CompletionItemKind.Variable],[5,n.CompletionItemKind.Class],[7,n.CompletionItemKind.Interface],[6,n.CompletionItemKind.Struct],[8,n.CompletionItemKind.Module],[9,n.CompletionItemKind.Property],[12,n.CompletionItemKind.Unit],[13,n.CompletionItemKind.Value],[14,n.CompletionItemKind.Constant],[15,n.CompletionItemKind.Enum],[16,n.CompletionItemKind.EnumMember],[17,n.CompletionItemKind.Keyword],[27,n.CompletionItemKind.Snippet],[18,n.CompletionItemKind.Text],[19,n.CompletionItemKind.Color],[20,n.CompletionItemKind.File],[21,n.CompletionItemKind.Reference],[23,n.CompletionItemKind.Folder],[10,n.CompletionItemKind.Event],[11,n.CompletionItemKind.Operator],[24,n.CompletionItemKind.TypeParameter],[25,n.CompletionItemKind.User],[26,n.CompletionItemKind.Issue]]);function Fe(Ke){return ne.get(Ke)??n.CompletionItemKind.Property}Le.to=Fe})($e||(e.CompletionItemKind=$e={}));var Pe;(function(Le){function Te(Se,ne){const Fe=new n.$HK(Se.label);return Fe.insertText=Se.insertText,Fe.kind=$e.to(Se.kind),Fe.tags=Se.tags?.map(le.to),Fe.detail=Se.detail,Fe.documentation=A.$3j(Se.documentation)?L.to(Se.documentation):Se.documentation,Fe.sortText=Se.sortText,Fe.filterText=Se.filterText,Fe.preselect=Se.preselect,Fe.commitCharacters=Se.commitCharacters,D.$os.isIRange(Se.range)?Fe.range=i.to(Se.range):typeof Se.range=="object"&&(Fe.range={inserting:i.to(Se.range.insert),replacing:i.to(Se.range.replace)}),Fe.keepWhitespace=typeof Se.insertTextRules>"u"?!1:!!(Se.insertTextRules&1),typeof Se.insertTextRules<"u"&&Se.insertTextRules&4?Fe.insertText=new n.$mK(Se.insertText):(Fe.insertText=Se.insertText,Fe.textEdit=Fe.range instanceof n.$dK?new n.$iK(Fe.range,Fe.insertText):void 0),Se.additionalTextEdits&&Se.additionalTextEdits.length>0&&(Fe.additionalTextEdits=Se.additionalTextEdits.map(Ke=>x.to(Ke))),Fe.command=ne&&Se.command?ne.fromInternal(Se.command):void 0,Fe}Le.to=Te})(Pe||(e.CompletionItem=Pe={}));var B;(function(Le){function Te(ne){if(typeof ne.label!="string"&&!Array.isArray(ne.label))throw new TypeError("Invalid label");return{label:ne.label,documentation:L.fromStrict(ne.documentation)}}Le.from=Te;function Se(ne){return{label:ne.label,documentation:A.$3j(ne.documentation)?L.to(ne.documentation):ne.documentation}}Le.to=Se})(B||(e.ParameterInformation=B={}));var Q;(function(Le){function Te(ne){return{label:ne.label,documentation:L.fromStrict(ne.documentation),parameters:Array.isArray(ne.parameters)?ne.parameters.map(B.from):[],activeParameter:ne.activeParameter}}Le.from=Te;function Se(ne){return{label:ne.label,documentation:A.$3j(ne.documentation)?L.to(ne.documentation):ne.documentation,parameters:Array.isArray(ne.parameters)?ne.parameters.map(B.to):[],activeParameter:ne.activeParameter}}Le.to=Se})(Q||(e.SignatureInformation=Q={}));var te;(function(Le){function Te(ne){return{activeSignature:ne.activeSignature,activeParameter:ne.activeParameter,signatures:Array.isArray(ne.signatures)?ne.signatures.map(Q.from):[]}}Le.from=Te;function Se(ne){return{activeSignature:ne.activeSignature,activeParameter:ne.activeParameter,signatures:Array.isArray(ne.signatures)?ne.signatures.map(Q.to):[]}}Le.to=Se})(te||(e.SignatureHelp=te={}));var se;(function(Le){function Te(Se,ne){const Fe=new n.$GK(u.to(ne.position),typeof ne.label=="string"?ne.label:ne.label.map(X.to.bind(void 0,Se)),ne.kind&&de.to(ne.kind));return Fe.textEdits=ne.textEdits&&ne.textEdits.map(x.to),Fe.tooltip=A.$3j(ne.tooltip)?L.to(ne.tooltip):ne.tooltip,Fe.paddingLeft=ne.paddingLeft,Fe.paddingRight=ne.paddingRight,Fe}Le.to=Te})(se||(e.InlayHint=se={}));var X;(function(Le){function Te(Se,ne){const Fe=new n.$FK(ne.label);return Fe.tooltip=A.$3j(ne.tooltip)?L.to(ne.tooltip):ne.tooltip,v.Command.is(ne.command)&&(Fe.command=Se.fromInternal(ne.command)),ne.location&&(Fe.location=V.to(ne.location)),Fe}Le.to=Te})(X||(e.InlayHintLabelPart=X={}));var de;(function(Le){function Te(ne){return ne}Le.from=Te;function Se(ne){return ne}Le.to=Se})(de||(e.InlayHintKind=de={}));var ye;(function(Le){function Te(ne){return{range:i.from(ne.range),url:ne.target,tooltip:ne.tooltip}}Le.from=Te;function Se(ne){let Fe;if(ne.url)try{Fe=typeof ne.url=="string"?y.URI.parse(ne.url,!0):y.URI.revive(ne.url)}catch{}return new n.$MK(i.to(ne.range),Fe)}Le.to=Se})(ye||(e.DocumentLink=ye={}));var je;(function(Le){function Te(ne){const Fe=new n.$PK(ne.label);return ne.textEdit&&(Fe.textEdit=x.to(ne.textEdit)),ne.additionalTextEdits&&(Fe.additionalTextEdits=ne.additionalTextEdits.map(Ke=>x.to(Ke))),Fe}Le.to=Te;function Se(ne){return{label:ne.label,textEdit:ne.textEdit?x.from(ne.textEdit):void 0,additionalTextEdits:ne.additionalTextEdits?ne.additionalTextEdits.map(Fe=>x.from(Fe)):void 0}}Le.from=Se})(je||(e.ColorPresentation=je={}));var We;(function(Le){function Te(ne){return new n.$NK(ne[0],ne[1],ne[2],ne[3])}Le.to=Te;function Se(ne){return[ne.red,ne.green,ne.blue,ne.alpha]}Le.from=Se})(We||(e.Color=We={}));var _e;(function(Le){function Te(ne){return{range:i.from(ne.range)}}Le.from=Te;function Se(ne){return new n.$wK(i.to(ne.range))}Le.to=Se})(_e||(e.SelectionRange=_e={}));var Ye;(function(Le){function Te(Se){switch(Se){case 2:return n.TextDocumentSaveReason.AfterDelay;case 1:return n.TextDocumentSaveReason.Manual;case 3:case 4:return n.TextDocumentSaveReason.FocusOut}}Le.to=Te})(Ye||(e.TextDocumentSaveReason=Ye={}));var it;(function(Le){function Te(ne){switch(ne){case n.TextEditorLineNumbersStyle.Off:return 0;case n.TextEditorLineNumbersStyle.Relative:return 2;case n.TextEditorLineNumbersStyle.On:default:return 1}}Le.from=Te;function Se(ne){switch(ne){case 0:return n.TextEditorLineNumbersStyle.Off;case 2:return n.TextEditorLineNumbersStyle.Relative;case 1:default:return n.TextEditorLineNumbersStyle.On}}Le.to=Se})(it||(e.TextEditorLineNumbersStyle=it={}));var et;(function(Le){function Te(ne){if(ne===n.EndOfLine.CRLF)return 1;if(ne===n.EndOfLine.LF)return 0}Le.from=Te;function Se(ne){if(ne===1)return n.EndOfLine.CRLF;if(ne===0)return n.EndOfLine.LF}Le.to=Se})(et||(e.EndOfLine=et={}));var Ae;(function(Le){function Te(Se){if(typeof Se=="object")return Se.viewId;switch(Se){case n.ProgressLocation.SourceControl:return 3;case n.ProgressLocation.Window:return 10;case n.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Le.from=Te})(Ae||(e.ProgressLocation=Ae={}));var Ne;(function(Le){function Te(ne){const Fe={start:ne.start+1,end:ne.end+1};return ne.kind&&(Fe.kind=qe.from(ne.kind)),Fe}Le.from=Te;function Se(ne){const Fe={start:ne.start-1,end:ne.end-1};return ne.kind&&(Fe.kind=qe.to(ne.kind)),Fe}Le.to=Se})(Ne||(e.FoldingRange=Ne={}));var qe;(function(Le){function Te(ne){if(ne)switch(ne){case n.FoldingRangeKind.Comment:return v.$dt.Comment;case n.FoldingRangeKind.Imports:return v.$dt.Imports;case n.FoldingRangeKind.Region:return v.$dt.Region}}Le.from=Te;function Se(ne){if(ne)switch(ne.value){case v.$dt.Comment.value:return n.FoldingRangeKind.Comment;case v.$dt.Imports.value:return n.FoldingRangeKind.Imports;case v.$dt.Region.value:return n.FoldingRangeKind.Region}}Le.to=Se})(qe||(e.FoldingRangeKind=qe={}));var Me;(function(Le){function Te(Se){if(Se)return{pinned:typeof Se.preview=="boolean"?!Se.preview:void 0,inactive:Se.background,preserveFocus:Se.preserveFocus,selection:typeof Se.selection=="object"?i.from(Se.selection):void 0,override:typeof Se.override=="boolean"?r.$ND.id:void 0}}Le.from=Te})(Me||(e.TextEditorOpenOptions=Me={}));var Ze;(function(Le){function Te(Ke){return Ke instanceof n.$0K?Ke.toJSON():typeof Ke=="string"?Ke:Se(Ke)||ne(Ke)?new n.$0K(Ke.baseUri??Ke.base,Ke.pattern).toJSON():Ke}Le.from=Te;function Se(Ke){const xe=Ke;return xe?y.URI.isUri(xe.baseUri)&&typeof xe.pattern=="string":!1}function ne(Ke){const xe=Ke;return xe?typeof xe.base=="string"&&typeof xe.pattern=="string":!1}function Fe(Ke){return typeof Ke=="string"?Ke:new n.$0K(y.URI.revive(Ke.baseUri),Ke.pattern)}Le.to=Fe})(Ze||(e.GlobPattern=Ze={}));var ce;(function(Le){function Te(Se){if(Se){if(Array.isArray(Se))return Se.map(Te);if(typeof Se=="string")return Se;{const ne=Se;return{language:ne.language,scheme:ne.scheme,pattern:Ze.from(ne.pattern),exclusive:ne.exclusive,notebookType:ne.notebookType}}}else return}Le.from=Te})(ce||(e.LanguageSelector=ce={}));var ae;(function(Le){function Te(ne){return!!ne&&typeof ne=="object"&&"documents"in ne&&Array.isArray(ne.documents)&&ne.documents.every(Fe=>Array.isArray(Fe)&&Fe.every(Ke=>Ke&&typeof Ke=="object"&&"uri"in Ke&&y.URI.isUri(Ke.uri)&&"version"in Ke&&typeof Ke.version=="number"&&"ranges"in Ke&&Array.isArray(Ke.ranges)&&Ke.ranges.every(xe=>xe instanceof n.$dK)))}Le.is=Te;function Se(ne){return{documents:ne.documents.map(Fe=>Fe.map(Ke=>({uri:y.URI.from(Ke.uri),version:Ke.version,ranges:Ke.ranges.map(xe=>i.from(xe))})))}}Le.from=Se})(ae||(e.MappedEditsContext=ae={}));var Ie;(function(Le){function Te(ne){return{start:ne.start,end:ne.end}}Le.from=Te;function Se(ne){return new n.$yL(ne.start,ne.end)}Le.to=Se})(Ie||(e.NotebookRange=Ie={}));var Ve;(function(Le){function Te(ne){return{timing:typeof ne.runStartTime=="number"&&typeof ne.runEndTime=="number"?{startTime:ne.runStartTime,endTime:ne.runEndTime}:void 0,executionOrder:ne.executionOrder,success:ne.lastRunSuccess}}Le.to=Te;function Se(ne){return{lastRunSuccess:ne.success,runStartTime:ne.timing?.startTime,runEndTime:ne.timing?.endTime,executionOrder:ne.executionOrder}}Le.from=Se})(Ve||(e.NotebookCellExecutionSummary=Ve={}));var ze;(function(Le){function Te(Se){if(Se===c.NotebookCellExecutionState.Unconfirmed)return n.NotebookCellExecutionState.Pending;if(Se===c.NotebookCellExecutionState.Pending)return;if(Se===c.NotebookCellExecutionState.Executing)return n.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Se}`)}Le.to=Te})(ze||(e.NotebookCellExecutionState=ze={}));var Xe;(function(Le){function Te(ne){switch(ne){case n.NotebookCellKind.Markup:return c.CellKind.Markup;case n.NotebookCellKind.Code:default:return c.CellKind.Code}}Le.from=Te;function Se(ne){switch(ne){case c.CellKind.Markup:return n.NotebookCellKind.Markup;case c.CellKind.Code:default:return n.NotebookCellKind.Code}}Le.to=Se})(Xe||(e.NotebookCellKind=Xe={}));var rt;(function(Le){function Te(ne){const Fe={metadata:ne.metadata??Object.create(null),cells:[]};for(const Ke of ne.cells)n.$zL.validate(Ke),Fe.cells.push(ot.from(Ke));return Fe}Le.from=Te;function Se(ne){const Fe=new n.$AL(ne.cells.map(ot.to));return(0,p.$Kf)(ne.metadata)||(Fe.metadata=ne.metadata),Fe}Le.to=Se})(rt||(e.NotebookData=rt={}));var ot;(function(Le){function Te(ne){return{cellKind:Xe.from(ne.kind),language:ne.languageId,mime:ne.mime,source:ne.value,metadata:ne.metadata,internalMetadata:Ve.from(ne.executionSummary??{}),outputs:ne.outputs?ne.outputs.map(Et.from):[]}}Le.from=Te;function Se(ne){return new n.$zL(Xe.to(ne.cellKind),ne.source,ne.language,ne.mime,ne.outputs?ne.outputs.map(Et.to):void 0,ne.metadata,ne.internalMetadata?Ve.to(ne.internalMetadata):void 0)}Le.to=Se})(ot||(e.NotebookCellData=ot={}));var wt;(function(Le){function Te(ne){return{mime:ne.mime,valueBytes:T.$ae.wrap(ne.data)}}Le.from=Te;function Se(ne){return new n.$BL(ne.valueBytes.buffer,ne.mime)}Le.to=Se})(wt||(e.NotebookCellOutputItem=wt={}));var Et;(function(Le){function Te(ne){return{outputId:ne.id,items:ne.items.map(wt.from),metadata:ne.metadata}}Le.from=Te;function Se(ne){const Fe=ne.items.map(wt.to);return new n.$CL(Fe,ne.outputId,ne.metadata)}Le.to=Se})(Et||(e.NotebookCellOutput=Et={}));var Yt;(function(Le){function Te(Fe){return ne(Fe)?{include:Ze.from(Fe.include)??void 0,exclude:Ze.from(Fe.exclude)??void 0}:Ze.from(Fe)??void 0}Le.from=Te;function Se(Fe){return ne(Fe)?{include:Ze.to(Fe.include),exclude:Ze.to(Fe.exclude)}:Ze.to(Fe)}Le.to=Se;function ne(Fe){const Ke=Fe;return Ke?!(0,p.$Gf)(Ke.include)&&!(0,p.$Gf)(Ke.exclude):!1}})(Yt||(e.NotebookExclusiveDocumentPattern=Yt={}));var Kt;(function(Le){function Te(Se,ne,Fe){const Ke=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{alignment:Se.alignment===n.NotebookCellStatusBarAlignment.Left?1:2,command:ne.toInternal(Ke,Fe),text:Se.text,tooltip:Se.tooltip,accessibilityInformation:Se.accessibilityInformation,priority:Se.priority}}Le.from=Te})(Kt||(e.NotebookStatusBarItem=Kt={}));var pt;(function(Le){function Te(Se,ne,Fe){const Ke=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{command:ne.toInternal(Ke,Fe),label:Se.label,description:Se.description,detail:Se.detail,documentation:Se.documentation}}Le.from=Te})(pt||(e.NotebookKernelSourceAction=pt={}));var Ut;(function(Le){function Te(Se){return{transientOutputs:Se?.transientOutputs??!1,transientCellMetadata:Se?.transientCellMetadata??{},transientDocumentMetadata:Se?.transientDocumentMetadata??{},cellContentMetadata:Se?.cellContentMetadata??{}}}Le.from=Te})(Ut||(e.NotebookDocumentContentOptions=Ut={}));var Ft;(function(Le){function Te(ne){return{uri:ne.uri,provides:ne.provides}}Le.from=Te;function Se(ne){return new n.$EL(y.URI.revive(ne.uri),ne.provides)}Le.to=Se})(Ft||(e.NotebookRendererScript=Ft={}));var Bt;(function(Le){function Te(ne){return{message:L.fromStrict(ne.message)||"",type:0,expected:ne.expectedOutput,actual:ne.actualOutput,contextValue:ne.contextValue,location:ne.location&&{range:i.from(ne.location.range),uri:ne.location.uri}}}Le.from=Te;function Se(ne){const Fe=new n.$KL(typeof ne.message=="string"?ne.message:L.to(ne.message));return Fe.actualOutput=ne.actual,Fe.expectedOutput=ne.expected,Fe.contextValue=ne.contextValue,Fe.location=ne.location?V.to(ne.location):void 0,Fe}Le.to=Se})(Bt||(e.TestMessage=Bt={}));var Pt;(function(Le){Le.namespace=h.$9I,Le.denamespace=h.$0I})(Pt||(e.TestTag=Pt={}));var At;(function(Le){function Te(ne){const Fe=(0,s.$9L)(ne).controllerId;return{extId:m.$5I.fromExtHostTestItem(ne,Fe).toString(),label:ne.label,uri:y.URI.revive(ne.uri),busy:ne.busy,tags:ne.tags.map(Ke=>Pt.namespace(Fe,Ke.id)),range:D.$os.lift(i.from(ne.range)),description:ne.description||null,sortText:ne.sortText||null,error:ne.error&&L.fromStrict(ne.error)||null}}Le.from=Te;function Se(ne){return{parent:void 0,error:void 0,id:m.$5I.fromString(ne.extId).localId,label:ne.label,uri:y.URI.revive(ne.uri),tags:(ne.tags||[]).map(Fe=>{const{tagId:Ke}=Pt.denamespace(Fe);return new n.$LL(Ke)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:i.to(ne.range||void 0),canResolveChildren:!1,busy:ne.busy,description:ne.description||void 0,sortText:ne.sortText||void 0}}Le.toPlain=Se})(At||(e.TestItem=At={})),function(Le){function Te(ne){return{id:ne.id}}Le.from=Te;function Se(ne){return new n.$LL(ne.id)}Le.to=Se}(Pt||(e.TestTag=Pt={}));var Nt;(function(Le){const Te=(ne,Fe)=>{const Ke=[];for(const[Je,nt]of Fe)m.$5I.compare(nt.item.extId,Je)===2&&(Fe.delete(Je),Ke.push(nt));const xe={...At.toPlain(ne.item),parent:void 0,taskStates:ne.tasks.map(Je=>({state:Je.state,duration:Je.duration,messages:Je.messages.filter(nt=>nt.type===0).map(Bt.to)})),children:Ke.map(Je=>Te(Je,Fe))};for(const Je of xe.children)Je.parent=xe;return xe};function Se(ne){const Fe=[],Ke=new Map;for(const xe of ne.items){Ke.set(xe.item.extId,xe);const Je=m.$5I.root(xe.item.extId);ne.request.targets.some(nt=>nt.controllerId===Je&&nt.testIds.includes(xe.item.extId))&&Fe.push(xe)}return{completedAt:ne.completedAt,results:Fe.map(xe=>Te(xe,Ke))}}Le.to=Se})(Nt||(e.TestResults=Nt={}));var Wt;(function(Le){function Te(Ke){return{covered:Ke.covered,total:Ke.covered}}function Se(Ke){return"line"in Ke?u.from(Ke):i.from(Ke)}function ne(Ke){return"branches"in Ke?{count:Ke.executionCount,location:Se(Ke.location),type:1,branches:Ke.branches.length?Ke.branches.map(xe=>({count:xe.executionCount,location:xe.location&&Se(xe.location)})):void 0}:{type:0,count:Ke.executionCount,location:Se(Ke.location)}}Le.fromDetailed=ne;function Fe(Ke){return{uri:Ke.uri,statement:Te(Ke.statementCoverage),branch:Ke.branchCoverage&&Te(Ke.branchCoverage),function:Ke.functionCoverage&&Te(Ke.functionCoverage),details:Ke.detailedCoverage?.map(ne)}}Le.fromFile=Fe})(Wt||(e.TestCoverage=Wt={}));var Ht;(function(Le){function Te(Se){switch(Se){case 1:return n.CodeActionTriggerKind.Invoke;case 2:return n.CodeActionTriggerKind.Automatic}}Le.to=Te})(Ht||(e.CodeActionTriggerKind=Ht={}));var qt;(function(Le){function Te(ne){const Fe=new n.$RL(q.to(ne.kind),ne.name,ne.detail||"",y.URI.revive(ne.uri),i.to(ne.range),i.to(ne.selectionRange));return Fe._sessionId=ne._sessionId,Fe._itemId=ne._itemId,Fe}Le.to=Te;function Se(ne,Fe,Ke){if(Fe=Fe??ne._sessionId,Ke=Ke??ne._itemId,Fe===void 0||Ke===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:Ke,kind:q.from(ne.kind),name:ne.name,detail:ne.detail??"",uri:ne.uri,range:i.from(ne.range),selectionRange:i.from(ne.selectionRange),tags:ne.tags?.map(Y.from)}}Le.from=Se})(qt||(e.TypeHierarchyItem=qt={}));var ct;(function(Le){function Te(Se){if(Se)return{value:Se.value,tooltip:Se.tooltip}}Le.from=Te})(ct||(e.ViewBadge=ct={}));var lt;(function(Le){function Te(Ke,xe,Je){const nt=xe.fileData;return nt?new n.$3K(new n.$4K(nt.name,y.URI.revive(nt.uri),nt.id,(0,M.$cb)(()=>Je(nt.id)))):Ke===R.$Lr.uriList&&xe.uriListData?new n.$2K(Fe(xe.uriListData)):new n.$2K(xe.asString)}Le.to=Te;async function Se(Ke,xe){const Je=await xe.asString();if(Ke===R.$Lr.uriList)return{asString:Je,fileData:void 0,uriListData:ne(Je)};const nt=xe.asFile();return{asString:Je,fileData:nt?{name:nt.name,uri:nt.uri,id:nt._itemId??nt.id}:void 0}}Le.from=Se;function ne(Ke){return d.$Xs.split(Ke).map(xe=>{if(xe.startsWith("#"))return xe;try{return y.URI.parse(xe)}catch{}return xe})}function Fe(Ke){return d.$Xs.create(Ke.map(xe=>typeof xe=="string"?xe:y.URI.revive(xe)))}})(lt||(e.DataTransferItem=lt={}));var Jt;(function(Le){function Te(ne,Fe){const Ke=ne.items.map(([xe,Je])=>[xe,lt.to(xe,Je,Fe)]);return new n.$5K(Ke)}Le.toDataTransfer=Te;async function Se(ne){const Fe={items:[]},Ke=[];for(const[xe,Je]of ne)Ke.push((async()=>{Fe.items.push([xe,await lt.from(xe,Je)])})());return await Promise.all(Ke),Fe}Le.from=Se})(Jt||(e.DataTransfer=Jt={}));var It;(function(Le){function Te(ne){return{message:ne.message,metadata:ne.metadata,title:ne.title,tooltip:ne.tooltip}}Le.to=Te;function Se(ne){return{kind:"reply",message:ne.message,metadata:ne.metadata,title:ne.title,tooltip:ne.tooltip}}Le.from=Se})(It||(e.ChatReplyFollowup=It={}));var kt;(function(Le){function Te(Se){return typeof Se=="string"?{title:Se,message:Se,kind:"reply"}:"commandId"in Se?{kind:"command",title:Se.title??"",commandId:Se.commandId??"",when:Se.when??"",args:Se.args}:It.from(Se)}Le.from=Te})(kt||(e.ChatFollowup=kt={}));var ft;(function(Le){function Te(ne){const Fe=new n.$2L(Dt.to(ne.role),ne.content);return Fe.name=ne.name,Fe}Le.to=Te;function Se(ne){return{role:Dt.from(ne.role),content:ne.content,name:ne.name}}Le.from=Se})(ft||(e.ChatMessage=ft={}));var Dt;(function(Le){function Te(ne){switch(ne){case 0:return n.ChatMessageRole.System;case 1:return n.ChatMessageRole.User;case 2:return n.ChatMessageRole.Assistant;case 3:return n.ChatMessageRole.Function}}Le.to=Te;function Se(ne){switch(ne){case n.ChatMessageRole.System:return 0;case n.ChatMessageRole.Assistant:return 2;case n.ChatMessageRole.Function:return 3;case n.ChatMessageRole.User:default:return 1}}Le.from=Se})(Dt||(e.ChatMessageRole=Dt={}));var Tt;(function(Le){function Te(ne){return{level:yt.to(ne.level),value:ne.value,description:ne.description}}Le.to=Te;function Se(ne){return{level:yt.from(ne.level),value:ne.value,description:ne.description}}Le.from=Se})(Tt||(e.ChatVariable=Tt={}));var yt;(function(Le){function Te(ne){switch(ne){case"short":return n.ChatVariableLevel.Short;case"medium":return n.ChatVariableLevel.Medium;case"full":default:return n.ChatVariableLevel.Full}}Le.to=Te;function Se(ne){switch(ne){case n.ChatVariableLevel.Short:return"short";case n.ChatVariableLevel.Medium:return"medium";case n.ChatVariableLevel.Full:default:return"full"}}Le.from=Se})(yt||(e.ChatVariableLevel=yt={}));var Ge;(function(Le){function Te(Se){switch(Se){case 1:return n.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return n.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return n.InteractiveEditorResponseFeedbackKind.Undone;case 3:return n.InteractiveEditorResponseFeedbackKind.Accepted}}Le.to=Te})(Ge||(e.InteractiveEditorResponseFeedbackKind=Ge={}));var Ot;(function(Le){function Te(Se){return"placeholder"in Se&&"resolvedContent"in Se?{placeholder:Se.placeholder}:"responseId"in Se?{requestId:Se.responseId}:"content"in Se?{content:typeof Se.content=="string"?Se.content:L.from(Se.content)}:"documents"in Se?{documents:Se.documents.map(ne=>({uri:ne.uri,version:ne.version,ranges:ne.ranges.map(Fe=>i.from(Fe))}))}:"reference"in Se?{reference:"uri"in Se.reference?{uri:Se.reference.uri,range:i.from(Se.reference.range)}:Se.reference}:Se}Le.from=Te})(Ot||(e.ChatResponseProgress=Ot={}));var jt;(function(Le){function Te(Se,ne,Fe){return"terminalCommand"in Se?{terminalCommand:Se.terminalCommand}:"uri"in Se?{uri:Se.uri}:ne.toInternal(Se,Fe)}Le.from=Te})(jt||(e.TerminalQuickFix=jt={}))}),define(De[280],Ce([1,0,2,8,7,14,75]),function(me,e,C,T,d,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6bc=void 0;class b{constructor(w,R,I,p={timeout:1500,errors:3}){this.c=w,this.d=R,this.f=I,this.g=p,this.a=new A.$1c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(w){return(R,I,p)=>{const D={dispose:this.a.push([R,I,w])};return Array.isArray(p)&&p.push(D),D}}async $participateInSave(w,R){const I=C.URI.revive(w);let p=!1;const y=setTimeout(()=>p=!0,this.g.timeout),D=[];try{for(const v of[...this.a]){if(p)break;const l=this.d.getDocument(I),s=await this.h(v,{document:l,reason:M.TextDocumentSaveReason.to(R)});D.push(s)}}finally{clearTimeout(y)}return D}h([w,R,I],p){const y=this.b.get(w);return typeof y=="number"&&y>this.g.errors?Promise.resolve(!1):this.i(I,w,R,p).then(()=>!0,D=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this.c.error(D),!(D instanceof Error)||D.message!=="concurrent_edits"){const v=this.b.get(w);this.b.set(w,v?v+1:1),typeof v=="number"&&v>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(w,R,I,p){const y=[],D=Date.now(),{document:v,reason:l}=p,{version:s}=v,r=Object.freeze({document:v,reason:l,waitUntil(c){if(Object.isFrozen(y))throw(0,T.$7)("waitUntil can not be called async");y.push(Promise.resolve(c))}});try{R.apply(I,[r])}catch(c){return Promise.reject(c)}return Object.freeze(y),new Promise((c,m)=>{const h=setTimeout(()=>m(new Error("timeout")),this.g.timeout);return Promise.all(y).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${w.identifier.value}' finished after ${Date.now()-D}ms`),clearTimeout(h),c(t)}).catch(t=>{clearTimeout(h),m(t)})}).then(c=>{const m={edits:[]};for(const h of c)if(Array.isArray(h)&&h.every(t=>t instanceof d.$iK))for(const{newText:t,newEol:n,range:o}of h)m.edits.push({resource:v.uri,versionId:void 0,textEdit:{range:o&&M.Range.from(o),text:t,eol:n&&M.EndOfLine.from(n)}});if(m.edits.length!==0)return s===v.version?this.f.$tryApplyWorkspaceEdit(m):Promise.reject(new Error("concurrent_edits"))})}}e.$6bc=b}),define(De[281],Ce([1,0,17,2,14,7,108]),function(me,e,C,T,d,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hdc=e.$gdc=void 0;class b{constructor(I,p,y,D){this.start=I,this.deletedCount=p,this.deletedItems=y,this.items=D}asApiEvent(){return{range:new M.$yL(this.start,this.start+this.deletedCount),addedCells:this.items.map(I=>I.apiCell),removedCells:this.deletedItems}}}class E{static asModelAddData(I,p){return{EOL:p.eol,lines:p.source,languageId:p.language,uri:p.uri,isDirty:!1,versionId:1,notebook:I}}constructor(I,p,y){this.notebook=I,this.h=p,this.j=y,this.handle=y.handle,this.uri=T.URI.revive(y.uri),this.cellKind=y.cellKind,this.a=y.outputs.map(d.NotebookCellOutput.to),this.e=y.internalMetadata??{},this.b=Object.freeze(y.metadata??{}),this.d=Object.freeze(d.NotebookCellExecutionSummary.to(y.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const I=this,p=this.h.getDocument(this.uri);if(!p)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const y={get index(){return I.notebook.getCellIndex(I)},notebook:I.notebook.apiNotebook,kind:d.NotebookCellKind.to(this.j.cellKind),document:p.document,get mime(){return I.g},set mime(D){I.g=D},get outputs(){return I.a.slice(0)},get metadata(){return I.b},get executionSummary(){return I.d}};this.f=Object.freeze(y)}return this.f}setOutputs(I){this.a=I.map(d.NotebookCellOutput.to)}setOutputItems(I,p,y){const D=y.map(d.NotebookCellOutputItem.to),v=this.a.find(l=>l.id===I);if(v&&(p||(v.items.length=0),v.items.push(...D),v.items.length>1&&v.items.every(l=>A.$lI(l.mime)))){const l=new Map,s=[];v.items.forEach(r=>{let c;l.has(r.mime)?c=l.get(r.mime):(c=[],l.set(r.mime,c),s.push(r.mime)),c.push(r.data)}),v.items.length=0,s.forEach(r=>{const c=A.$mI(l.get(r));v.items.push({mime:r,data:c.data.buffer})})}}setMetadata(I){this.b=Object.freeze(I)}setInternalMetadata(I){this.e=I,this.d=Object.freeze(d.NotebookCellExecutionSummary.to(I))}setMime(I){}}e.$gdc=E;class w{static{this.a=0}constructor(I,p,y,D,v){this.k=I,this.l=p,this.m=y,this.uri=D,this.handle=w.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=v.viewType,this.f=Object.freeze(v.metadata??Object.create(null)),this.r([[0,0,v.cells]],!0,void 0),this.g=v.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const I=this,p={get uri(){return I.uri},get version(){return I.g},get notebookType(){return I.d},get isDirty(){return I.h},get isUntitled(){return I.uri.scheme===C.Schemas.untitled},get isClosed(){return I.j},get metadata(){return I.f},get cellCount(){return I.b.length},cellAt(y){return y=I.n(y),I.b[y].apiCell},getCells(y){return(y?I.p(y):I.b).map(v=>v.apiCell)},save(){return I.q()}};this.e=Object.freeze(p)}return this.e}acceptDocumentPropertiesChanged(I){I.metadata&&(this.f=Object.freeze({...this.f,...I.metadata}))}acceptDirty(I){this.h=I}acceptModelChanged(I,p,y){this.g=I.versionId,this.h=p,this.acceptDocumentPropertiesChanged({metadata:y});const D={notebook:this.apiNotebook,metadata:y,cellChanges:[],contentChanges:[]},v=[];for(const s of I.rawEvents)s.kind===A.NotebookCellsChangeType.ModelChange?this.r(s.changes,!1,D.contentChanges):s.kind===A.NotebookCellsChangeType.Move?this.s(s.index,s.length,s.newIdx,D.contentChanges):s.kind===A.NotebookCellsChangeType.Output?(this.t(s.index,s.outputs),v.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===A.NotebookCellsChangeType.OutputItem?(this.u(s.index,s.outputId,s.append,s.outputItems),v.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this.v(s.index,s.language),v.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document})):s.kind===A.NotebookCellsChangeType.ChangeCellContent?v.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document}):s.kind===A.NotebookCellsChangeType.ChangeCellMime?this.w(s.index,s.mime):s.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this.x(s.index,s.metadata),v.push({cell:this.b[s.index].apiCell,metadata:this.b[s.index].apiCell.metadata})):s.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(s.index,s.internalMetadata),v.push({cell:this.b[s.index].apiCell,executionSummary:this.b[s.index].apiCell.executionSummary}));const l=new Map;for(let s=0;s<v.length;s++){const r=v[s],c=l.get(r.cell);if(c===void 0){const m=D.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...r});l.set(r.cell,m-1)}else D.cellChanges[c]={...D.cellChanges[c],...r}}return Object.freeze(D),Object.freeze(D.cellChanges),Object.freeze(D.contentChanges),D}n(I){return I=I|0,I<0?0:I>=this.b.length?this.b.length-1:I}o(I){let p=I.start|0,y=I.end|0;return p<0&&(p=0),y>this.b.length&&(y=this.b.length),I.with({start:p,end:y})}p(I){I=this.o(I);const p=[];for(let y=I.start;y<I.end;y++)p.push(this.b[y]);return p}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(I,p,y){if(this.j)return;const D=[],v=[],l=[];if(I.reverse().forEach(s=>{const c=s[2].map(t=>{const n=new E(this,this.l,t);return p||v.push(E.asModelAddData(this.apiNotebook,t)),n}),m=new b(s[0],s[1],[],c),h=this.b.splice(s[0],s[1],...c);for(const t of h)l.push(t.uri),m.deletedItems.push(t.apiCell);D.push(m)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:v,removedDocuments:l}),y)for(const s of D)y.push(s.asApiEvent())}s(I,p,y,D){const v=this.b.splice(I,p);this.b.splice(y,0,...v);const l=[new b(I,p,v.map(s=>s.apiCell),[]),new b(y,0,[],v)];for(const s of l)D.push(s.asApiEvent())}t(I,p){this.b[I].setOutputs(p)}u(I,p,y,D){this.b[I].setOutputItems(p,y,D)}v(I,p){const y=this.b[I];y.apiCell.document.languageId!==p&&this.m.$acceptModelLanguageChanged(y.uri,p)}w(I,p){const y=this.b[I];y.apiCell.mime=p}x(I,p){this.b[I].setMetadata(p)}y(I,p){this.b[I].setInternalMetadata(p)}getCellFromApiCell(I){return this.b.find(p=>p.apiCell===I)}getCellFromIndex(I){return this.b[I]}getCell(I){return this.b.find(p=>p.handle===I)}getCellIndex(I){return this.b.indexOf(I)}}e.$hdc=w}),define(De[282],Ce([1,0,4,2,14,7]),function(me,e,C,T,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hdc=void 0;class A{constructor(E,w,R,I={timeout:1500,errors:3}){this.b=E,this.c=w,this.d=R,this.f=I,this.a=new C.$Od}dispose(){}getOnWillSaveNotebookDocumentEvent(E){return(w,R,I)=>{const p=function(D){w.call(R,D)};return p.extension=E,this.a.event(p,void 0,I)}}async $participateInSave(E,w,R){const I=T.URI.revive(E),p=this.c.getNotebookDocument(I);if(!p)throw new Error("Unable to resolve notebook document");const y=[];if(await this.a.fireAsync({notebook:p.apiNotebook,reason:d.TextDocumentSaveReason.to(w)},R,async(v,l)=>{const s=Date.now(),r=await await Promise.resolve(v);Date.now()-s>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",l.extension.identifier),!R.isCancellationRequested&&r&&(r instanceof M.$lK?y.push(r):this.b.warn("onWillSaveNotebookDocument-listener from extension",l.extension.identifier,"ignored due to invalid data"))}),R.isCancellationRequested)return!1;if(y.length===0)return!0;const D={edits:[]};for(const v of y){const{edits:l}=d.WorkspaceEdit.from(v);D.edits=D.edits.concat(l)}return this.d.$tryApplyWorkspaceEdit(D)}}e.$Hdc=A}),define(De[144],Ce([1,0,8,14,7]),function(me,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$idc=void 0;class M{static{this.apiEditorsToExtHost=new WeakMap}constructor(b,E,w,R,I,p){this.id=b,this.f=E,this.notebookData=w,this.a=[],this.b=[],this.d=!1,this.a=I,this.b=R,this.c=p}get apiEditor(){if(!this.e){const b=this;this.e={get notebook(){return b.notebookData.apiNotebook},get selection(){return b.a[0]},set selection(E){this.selections=[E]},get selections(){return b.a},set selections(E){if(!Array.isArray(E)||!E.every(d.$yL.isNotebookRange))throw(0,C.$6)("selections");b.a=E,b.g(E)},get visibleRanges(){return b.b},revealRange(E,w){b.f.$tryRevealRange(b.id,T.NotebookRange.from(E),w??d.NotebookEditorRevealType.Default)},get viewColumn(){return b.c}},M.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(b){this.d=b}_acceptVisibleRanges(b){this.b=b}_acceptSelections(b){this.a=b}g(b){this.f.$trySetSelections(this.id,b.map(T.NotebookRange.from))}_acceptViewColumn(b){this.c=b}}e.$idc=M}),define(De[283],Ce([1,0,8,4,13,14]),function(me,e,C,T,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Adc=void 0;let A=class{constructor(E,w){this.c=E,this.d=w,this.a=new T.$Md({onListenerError:C.$1}),this.b=new T.$Md({onListenerError:C.$1}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(E,w){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",E,w);const R=this.d.getEditorById(E);w.visibleRanges&&R._acceptVisibleRanges(w.visibleRanges.ranges.map(M.NotebookRange.to)),w.selections&&R._acceptSelections(w.selections.selections.map(M.NotebookRange.to)),w.visibleRanges&&this.b.fire({notebookEditor:R.apiEditor,visibleRanges:R.apiEditor.visibleRanges}),w.selections&&this.a.fire(Object.freeze({notebookEditor:R.apiEditor,selections:R.apiEditor.selections}))}$acceptEditorViewColumns(E){for(const w in E)this.d.getEditorById(w)._acceptViewColumn(M.ViewColumn.to(E[w]))}};e.$Adc=A,e.$Adc=A=He([Be(0,d.$8i)],A)}),define(De[284],Ce([1,0,14,84,208,21,57,8]),function(me,e,C,T,d,M,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ecc=void 0;class E{constructor(p){this.b=0,this.c=new Map,this.a=p}async withProgress(p,y,D){const v=this.b++,{title:l,location:s,cancellable:r}=y,c={label:(0,d.localize)(0,null,p.displayName||p.name),id:p.identifier.value};return this.a.$startProgress(v,{location:C.ProgressLocation.from(s),title:l,source:c,cancellable:r},p.isUnderDevelopment?void 0:p.identifier.value).catch(b.$1),this.d(v,D,!!r)}d(p,y,D){let v;D&&(v=new M.$Wd,this.c.set(p,v));const l=r=>{this.a.$progressEnd(r),this.c.delete(r),v?.dispose()};let s;try{s=y(new R(this.a,p),D&&v?v.token:M.CancellationToken.None)}catch(r){throw l(p),r}return s.then(r=>l(p),r=>l(p)),s}$acceptProgressCanceled(p){const y=this.c.get(p);y&&(y.cancel(),this.c.delete(p))}}e.$Ecc=E;function w(I,p){return I.message=p.message,typeof p.increment=="number"&&(typeof I.increment=="number"?I.increment+=p.increment:I.increment=p.increment),I}class R extends T.$Zu{constructor(p,y){super(D=>this.throttledReport(D)),this.i=p,this.j=y}throttledReport(p){this.i.$progressReport(this.j,p)}}He([(0,A.$hh)(100,(I,p)=>w(I,p),()=>Object.create(null))],R.prototype,"throttledReport",null)}),define(De[145],Ce([1,0,34,142,67,109,87,14,2]),function(me,e,C,T,d,M,A,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pM=e.$oM=e.$nM=e.$mM=void 0;const w=(c,m,h,t)=>{let n=m;return{enumerable:!0,configurable:!1,get(){return n},set(o){if(!h(n,o)){const i=n;n=o,c.listener?.(t(o,i))}}}},R=(c,m)=>c===m,I={range:(c,m)=>c===m?!0:!c||!m?!1:c.isEqual(m),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(c,m)=>!(c.length!==m.length||c.some(h=>!m.find(t=>h.id===t.id)))},p=c=>m=>({op:4,update:c(m)}),y=(c,m)=>({range:(()=>{let h;const t=p(n=>({range:C.$os.lift(b.Range.from(n))}));return{enumerable:!0,configurable:!1,get(){return h},set(n){c.listener?.({op:6}),I.range(h,n)||(h=n,c.listener?.(t(n)))}}})(),label:w(c,m,I.label,p(h=>({label:h}))),description:w(c,void 0,I.description,p(h=>({description:h}))),sortText:w(c,void 0,I.sortText,p(h=>({sortText:h}))),canResolveChildren:w(c,!1,I.canResolveChildren,h=>({op:2,state:h})),busy:w(c,!1,I.busy,p(h=>({busy:h}))),error:w(c,void 0,I.error,p(h=>({error:b.MarkdownString.fromStrict(h)||null}))),tags:w(c,[],I.tags,(h,t)=>({op:1,new:h.map(b.TestTag.from),old:t.map(b.TestTag.from)}))}),D=c=>{const m=d.$5I.fromString(c.extId),h=new l(m.controllerId,m.localId,c.label,E.URI.revive(c.uri)||void 0);return h.range=b.Range.to(c.range||void 0),h.description=c.description||void 0,h.sortText=c.sortText||void 0,h.tags=c.tags.map(t=>b.TestTag.to({id:(0,A.$0I)(t).tagId})),h},v=c=>{let m;for(const h of c.tests){const t=D(h.item);(0,T.$9L)(t).parent=m,m=t}return m};e.$mM=v;class l{constructor(m,h,t,n){if(h.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(h)} symbol`);const o=(0,T.$8L)(this,m);Object.defineProperties(this,{id:{value:h,enumerable:!0,writable:!1},uri:{value:n,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return o.parent instanceof s?void 0:o.parent}},children:{value:(0,M.$7L)(o,T.$9L,l),enumerable:!0,writable:!1},...y(o,t)})}}e.$nM=l;class s extends l{constructor(m,h){super(m,m,h,void 0),this._isRoot=!0}}e.$oM=s;class r extends M.$3L{constructor(m,h,t){super({controllerId:m,getDocumentVersion:n=>n&&t.getDocument(n)?.version,getApiFor:T.$9L,getChildren:n=>n.children,root:new s(m,h),toITestItem:b.TestItem.from})}}e.$pM=r}),define(De[146],Ce([1,0,58,8,119,14,7]),function(me,e,C,T,d,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jM=e.$iM=e.$hM=void 0;class b{static{this.c=new d.$fM("TextEditorDecorationType")}constructor(p,y,D){const v=b.c.nextId();p.$registerTextEditorDecorationType(y.identifier,v,M.DecorationRenderOptions.from(D)),this.value=Object.freeze({key:v,dispose(){p.$removeTextEditorDecorationType(v)}})}}e.$hM=b;class E{constructor(p,y){this.g=[],this.h=void 0,this.j=!1,this.c=p,this.d=p.version,this.e=y.undoStopBefore,this.f=y.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(p,y){this.k();let D=null;if(p instanceof A.$cK)D=new A.$dK(p,p);else if(p instanceof A.$dK)D=p;else throw new Error("Unrecognized location");this.l(D,y,!1)}insert(p,y){this.k(),this.l(new A.$dK(p,p),y,!0)}delete(p){this.k();let y=null;if(p instanceof A.$dK)y=p;else throw new Error("Unrecognized location");this.l(y,null,!0)}l(p,y,D){const v=this.c.validateRange(p);this.g.push({range:v,text:y,forceMoveMarkers:D})}setEndOfLine(p){if(this.k(),p!==A.EndOfLine.LF&&p!==A.EndOfLine.CRLF)throw(0,T.$6)("endOfLine");this.h=p}}class w{constructor(p,y,D,v){this.c=p,this.d=y,this._accept(D),this.e=v;const l=this;this.value={get tabSize(){return l.f},set tabSize(s){l.m(s)},get indentSize(){return l.g},set indentSize(s){l.o(s)},get insertSpaces(){return l.h},set insertSpaces(s){l.q(s)},get cursorStyle(){return l.j},set cursorStyle(s){l.s(s)},get lineNumbers(){return l.k},set lineNumbers(s){l.t(s)}}}_accept(p){this.f=p.tabSize,this.g=p.indentSize,this.h=p.insertSpaces,this.j=p.cursorStyle,this.k=M.TextEditorLineNumbersStyle.to(p.lineNumbers)}l(p){if(p==="auto")return"auto";if(typeof p=="number"){const y=Math.floor(p);return y>0?y:null}if(typeof p=="string"){const y=parseInt(p,10);return isNaN(y)?null:y>0?y:null}return null}m(p){const y=this.l(p);if(y!==null){if(typeof y=="number"){if(this.f===y)return;this.f=y}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:y}))}}n(p){if(p==="tabSize")return"tabSize";if(typeof p=="number"){const y=Math.floor(p);return y>0?y:null}if(typeof p=="string"){const y=parseInt(p,10);return isNaN(y)?null:y>0?y:null}return null}o(p){const y=this.n(p);if(y!==null){if(typeof y=="number"){if(this.g===y)return;this.g=y}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:y}))}}p(p){return p==="auto"?"auto":p==="false"?!1:!!p}q(p){const y=this.p(p);if(typeof y=="boolean"){if(this.h===y)return;this.h=y}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:y}))}s(p){this.j!==p&&(this.j=p,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:p})))}t(p){this.k!==p&&(this.k=p,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:M.TextEditorLineNumbersStyle.from(p)})))}assign(p){const y={};let D=!1;if(typeof p.tabSize<"u"){const v=this.l(p.tabSize);v==="auto"?(D=!0,y.tabSize=v):typeof v=="number"&&this.f!==v&&(this.f=v,D=!0,y.tabSize=v)}if(typeof p.indentSize<"u"){const v=this.n(p.indentSize);v==="tabSize"?(D=!0,y.indentSize=v):typeof v=="number"&&this.g!==v&&(this.g=v,D=!0,y.indentSize=v)}if(typeof p.insertSpaces<"u"){const v=this.p(p.insertSpaces);v==="auto"?(D=!0,y.insertSpaces=v):this.h!==v&&(this.h=v,D=!0,y.insertSpaces=v)}typeof p.cursorStyle<"u"&&this.j!==p.cursorStyle&&(this.j=p.cursorStyle,D=!0,y.cursorStyle=p.cursorStyle),typeof p.lineNumbers<"u"&&this.k!==p.lineNumbers&&(this.k=p.lineNumbers,D=!0,y.lineNumbers=M.TextEditorLineNumbersStyle.from(p.lineNumbers)),D&&this.u("setOptions",this.c.$trySetOptions(this.d,y))}u(p,y){y.catch(D=>{this.e.warn(`ExtHostTextEditorOptions '${p}' failed:'`),this.e.warn(D)})}}e.$iM=w;class R{constructor(p,y,D,v,l,s,r,c){this.id=p,this.j=y,this.k=D,this.g=!1,this.h=new Set,this.c=l,this.d=new w(this.j,this.id,s,D),this.e=r,this.f=c;const m=this;this.value=Object.freeze({get document(){return v.value},set document(h){throw new T.$8("document")},get selection(){return m.c&&m.c[0]},set selection(h){if(!(h instanceof A.$eK))throw(0,T.$6)("selection");m.c=[h],m.l()},get selections(){return m.c},set selections(h){if(!Array.isArray(h)||h.some(t=>!(t instanceof A.$eK)))throw(0,T.$6)("selections");m.c=h,m.l()},get visibleRanges(){return m.e},set visibleRanges(h){throw new T.$8("visibleRanges")},get options(){return m.d.value},set options(h){m.g||m.d.assign(h)},get viewColumn(){return m.f},set viewColumn(h){throw new T.$8("viewColumn")},edit(h,t={undoStopBefore:!0,undoStopAfter:!0}){if(m.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const n=new E(v.value,t);return h(n),m.m(n)},insertSnippet(h,t,n={undoStopBefore:!0,undoStopAfter:!0}){if(m.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let o;if(!t||Array.isArray(t)&&t.length===0)o=m.c.map(i=>M.Range.from(i));else if(t instanceof A.$cK){const{lineNumber:i,column:a}=M.Position.from(t);o=[{startLineNumber:i,startColumn:a,endLineNumber:i,endColumn:a}]}else if(t instanceof A.$dK)o=[M.Range.from(t)];else{o=[];for(const i of t)if(i instanceof A.$dK)o.push(M.Range.from(i));else{const{lineNumber:a,column:u}=M.Position.from(i);o.push({startLineNumber:a,startColumn:u,endLineNumber:a,endColumn:u})}}return y.$tryInsertSnippet(p,v.value.version,h.value,o,n)},setDecorations(h,t){const n=t.length===0;n&&!m.h.has(h.key)||(n?m.h.delete(h.key):m.h.add(h.key),m.n(()=>{if(M.$0L(t))return y.$trySetDecorations(p,h.key,M.$$L(t));{const o=new Array(4*t.length);for(let i=0,a=t.length;i<a;i++){const u=t[i];o[4*i]=u.start.line+1,o[4*i+1]=u.start.character+1,o[4*i+2]=u.end.line+1,o[4*i+3]=u.end.character+1}return y.$trySetDecorationsFast(p,h.key,o)}}))},revealRange(h,t){m.n(()=>y.$tryRevealRange(p,M.Range.from(h),t||A.TextEditorRevealType.Default))},show(h){y.$tryShowEditor(p,M.ViewColumn.from(h))},hide(){y.$tryHideEditor(p)}})}dispose(){(0,C.ok)(!this.g),this.g=!0}_acceptOptions(p){(0,C.ok)(!this.g),this.d._accept(p)}_acceptVisibleRanges(p){(0,C.ok)(!this.g),this.e=p}_acceptViewColumn(p){(0,C.ok)(!this.g),this.f=p}_acceptSelections(p){(0,C.ok)(!this.g),this.c=p}async l(){const p=this.c.map(M.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,p)),this.value}m(p){const y=p.finalize();if(y.edits.length===0&&!y.setEndOfLine)return Promise.resolve(!0);const D=y.edits.map(l=>l.range);D.sort((l,s)=>l.end.line===s.end.line?l.end.character===s.end.character?l.start.line===s.start.line?l.start.character-s.start.character:l.start.line-s.start.line:l.end.character-s.end.character:l.end.line-s.end.line);for(let l=0,s=D.length-1;l<s;l++){const r=D[l].end;if(D[l+1].start.isBefore(r))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const v=y.edits.map(l=>({range:M.Range.from(l.range),text:l.text,forceMoveMarkers:l.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,y.documentVersionId,v,{setEndOfLine:typeof y.setEndOfLine=="number"?M.EndOfLine.from(y.setEndOfLine):void 0,undoStopBefore:y.undoStopBefore,undoStopAfter:y.undoStopAfter})}n(p){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):p().then(()=>this,y=>(y instanceof Error&&y.name==="DISPOSED"||this.k.warn(y),null))}}e.$jM=R}),define(De[147],Ce([1,0,5,131]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wJ=void 0,e.$wJ=(0,C.$Oh)(T.$Uh)}),define(De[148],Ce([1,0,25,4,16,3]),function(me,e,C,T,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d4b=e.$c4b=e.$b4b=e.$a4b=e.$_3b=e.$$3b=void 0;class A{constructor(s,r){this.versionId=s,this.removedDueToLooping=r}}e.$$3b=A;class b{static isHostExtension(s,r,c){if(r.getExtensionDescription(s))return!1;const m=c.getExtensionDescription(s);return m?!!((m.main||m.browser)&&m.api==="none"):!1}constructor(s,r){this.j=s,this.c=new T.$Md,this.onDidChange=this.c.event,this.d=0,this.e=r,this.k()}k(){this.e.sort(D),this.f=new C.$4l,this.g=[],this.h=new Map;for(const s of this.e){if(this.f.has(s.identifier)){console.error("Extension `"+s.identifier.value+"` is already registered");continue}this.f.set(s.identifier,s),this.g.push(s);const r=this.j.readActivationEvents(s);if(Array.isArray(r))for(let c of r)c==="onUri"&&(c=`onUri:${C.$2l.toKey(s.identifier)}`),this.h.has(c)||this.h.set(c,[]),this.h.get(c).push(s)}}set(s){return this.e=s,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(s,r){this.e=v(this.e,r),this.e=this.e.concat(s);const c=b.l(this.e);return this.e=v(this.e,c.map(m=>m.identifier)),this.k(),this.d++,this.c.fire(void 0),new A(this.d,c)}static l(s){const r=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(n){this.d.has(n)||(this.d.add(n),this.e.push(n))}addArc(n,o){this.addNode(n),this.addNode(o),this.c.has(n)?this.c.get(n).push(o):this.c.set(n,[o])}getArcs(n){return this.c.has(n)?this.c.get(n):[]}hasOnlyGoodArcs(n,o){const i=r.getArcs(n);for(let a=0;a<i.length;a++)if(!o.has(i[a]))return!1;return!0}getNodes(){return this.e}},c=new C.$4l;for(const n of s)if(c.set(n.identifier,n),n.extensionDependencies)for(const o of n.extensionDependencies)r.addArc(C.$2l.toKey(n.identifier),C.$2l.toKey(o));const m=new Set;r.getNodes().filter(n=>r.getArcs(n).length===0).forEach(n=>m.add(n));const h=r.getNodes().filter(n=>!m.has(n));let t;do{t=!1;for(let n=0;n<h.length;n++){const o=h[n];r.hasOnlyGoodArcs(o,m)&&(h.splice(n,1),n--,m.add(o),t=!0)}}while(t);return h.map(n=>c.get(n))}containsActivationEvent(s){return this.h.has(s)}containsExtension(s){return this.f.has(s)}getExtensionDescriptionsForActivationEvent(s){const r=this.h.get(s);return r?r.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new E(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(s){const r=this.f.get(s);return r||void 0}getExtensionDescriptionByUUID(s){for(const r of this.g)if(r.uuid===s)return r}getExtensionDescriptionByIdOrUUID(s,r){return this.getExtensionDescription(s)??(r?this.getExtensionDescriptionByUUID(r):void 0)}}e.$_3b=b;class E{constructor(s,r){this.versionId=s,this.extensions=r}}e.$a4b=E,e.$b4b={readActivationEvents:l=>l.activationEvents};class w{constructor(s){this.d=new p,this.c=new b(s,[])}async acquireLock(s){const r=await this.d.acquire(s);return new R(this,r)}deltaExtensions(s,r,c){if(!s.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(r,c)}containsActivationEvent(s){return this.c.containsActivationEvent(s)}containsExtension(s){return this.c.containsExtension(s)}getExtensionDescriptionsForActivationEvent(s){return this.c.getExtensionDescriptionsForActivationEvent(s)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(s){return this.c.getExtensionDescription(s)}getExtensionDescriptionByUUID(s){return this.c.getExtensionDescriptionByUUID(s)}getExtensionDescriptionByIdOrUUID(s,r){return this.c.getExtensionDescriptionByIdOrUUID(s,r)}}e.$c4b=w;class R extends M.$Rc{constructor(s,r){super(),this.f=s,this.c=!1,this.B(r)}isAcquiredFor(s){return!this.c&&this.f===s}}e.$d4b=R;class I{constructor(s){this.name=s,this.promise=new Promise((r,c)=>{this.c=r})}resolve(s){this.c(s)}}class p{constructor(){this.c=[],this.d=!1}async acquire(s){const r=new I(s);return this.c.push(r),this.e(),r.promise}e(){if(this.d||this.c.length===0)return;const s=this.c.shift();this.d=!0;let r=!0;const c=setTimeout(()=>{r&&console.warn(`The customer named ${s.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),m=()=>{r&&(clearTimeout(c),r=!1,this.d=!1,this.e())};s.resolve((0,M.$Pc)(m))}}var y;(function(l){l[l.Builtin=0]="Builtin",l[l.User=1]="User",l[l.Dev=2]="Dev"})(y||(y={}));function D(l,s){const r=l.isBuiltin?0:l.isUnderDevelopment?2:1,c=s.isBuiltin?0:s.isUnderDevelopment?2:1;if(r!==c)return r-c;const m=d.$fc.basename(l.extensionLocation.path),h=d.$fc.basename(s.extensionLocation.path);return m<h?-1:m>h?1:0}function v(l,s){const r=new C.$3l(s);return l.filter(c=>!r.has(c.identifier))}}),define(De[285],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xm=e.$wm=e.$vm=e.$um=e.$tm=e.ExtHostConnectionType=void 0;var C;(function(R){R[R.IPC=1]="IPC",R[R.Socket=2]="Socket",R[R.MessagePort=3]="MessagePort"})(C||(e.ExtHostConnectionType=C={}));class T{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(I){this.pipeName=I,this.type=1}serialize(I){I[T.ENV_KEY]=this.pipeName}}e.$tm=T;class d{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(I){I[d.ENV_KEY]="1"}}e.$um=d;class M{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(I){I[M.ENV_KEY]="1"}}e.$vm=M;function A(R){delete R[T.ENV_KEY],delete R[d.ENV_KEY],delete R[M.ENV_KEY]}function b(R,I){A(I),R.serialize(I)}e.$wm=b;function E(R){if(R[T.ENV_KEY])return w(R,new T(R[T.ENV_KEY]));if(R[d.ENV_KEY])return w(R,new d);if(R[M.ENV_KEY])return w(R,new M);throw new Error("No connection information defined in environment!")}e.$xm=E;function w(R,I){return A(R),I}}),define(De[111],Ce([1,0,22]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$$l=e.$0l=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var T;(function(w){w[w.Desktop=1]="Desktop",w[w.Web=2]="Web"})(T||(e.UIKind=T={}));var d;(function(w){w[w.VersionMismatch=55]="VersionMismatch",w[w.UnexpectedError=81]="UnexpectedError"})(d||(e.ExtensionHostExitCode=d={}));var M;(function(w){w[w.Initialized=0]="Initialized",w[w.Ready=1]="Ready",w[w.Terminate=2]="Terminate"})(M||(e.MessageType=M={}));function A(w){const R=C.$ae.alloc(1);switch(w){case 0:R.writeUInt8(1,0);break;case 1:R.writeUInt8(2,0);break;case 2:R.writeUInt8(3,0);break}return R}e.$0l=A;function b(w,R){if(w.byteLength!==1)return!1;switch(w.readUInt8(0)){case 1:return R===0;case 2:return R===1;case 3:return R===2;default:return!1}}e.$$l=b;var E;(function(w){w.Start="START_NATIVE_LOG",w.End="END_NATIVE_LOG"})(E||(e.NativeLogMarkers=E={}))}),define(De[88],Ce([1,0,5,4,13,27,111,65,85,23,2,3,210]),function(me,e,C,T,d,M,A,b,E,w,R,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uM=e.$tM=e.$sM=e.$rM=void 0;let y=class extends I.$Rc{constructor(s,r){super(),this.s=s,this.t=r,this.a=this.B(new T.$Md),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new T.$Md),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=R.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=r.createLogger(this.m,{id:E.$ko,name:(0,p.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(r.onDidChangeLogLevel(c=>{(0,d.$0i)(c)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===d.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(s,r,c){const m=this.getTelemetryDetails(),h=new D(r,c,s,this.n,this.j,this.getBuiltInCommonProperties(s),{isUsageEnabled:m.isUsageEnabled,isErrorsEnabled:m.isErrorsEnabled}),t=this.r.get(s.identifier.value)??[];return this.r.set(s.identifier.value,[...t,h]),h.apiTelemetryLogger}$initializeTelemetryLevel(s,r,c){this.f=s,this.g=r,this.c=c??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(s){const r=Object.create(null);switch(r["common.extname"]=`${s.publisher}.${s.name}`,r["common.extversion"]=s.version,r["common.vscodemachineid"]=this.s.telemetryInfo.machineId,r["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,r["common.vscodeversion"]=this.s.version,r["common.isnewappinstall"]=v(this.s.telemetryInfo.firstSessionDate),r["common.product"]=this.s.environment.appHost,this.s.uiKind){case A.UIKind.Web:r["common.uikind"]="web";break;case A.UIKind.Desktop:r["common.uikind"]="desktop";break;default:r["common.uikind"]="unknown"}return r["common.remotename"]=(0,b.$Sk)((0,E.$ro)(this.s.remote.authority)),r}$onDidChangeTelemetryLevel(s){this.h=this.getTelemetryConfiguration(),this.f=s;const r=this.getTelemetryDetails();this.r.forEach((c,m)=>{const h=c.filter(t=>!t.isDisposed);h.length===0?this.r.delete(m):this.r.set(m,h)}),this.r.forEach(c=>{for(const m of c)m.updateTelemetryEnablements(r.isUsageEnabled,r.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(s,r){const m=this.r.get(s.value)?.filter(t=>!t.isDisposed);if(!m)return this.r.delete(s.value),!1;let h=!1;for(const t of m)t.ignoreUnhandledExtHostErrors||(t.logError(r),h=!0);return h}};e.$rM=y,e.$rM=y=He([Be(0,M.$qM),Be(1,d.$9i)],y);class D{static validateSender(s){if(typeof s!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof s.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof s.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof s.flush<"u"&&typeof s.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(s,r,c,m,h,t,n){this.g=c,this.h=m,this.i=h,this.j=t,this.a=new T.$Md,this.ignoreUnhandledExtHostErrors=r?.ignoreUnhandledErrors??!1,this.b=r?.ignoreBuiltInCommonProperties??!1,this.c=r?.additionalCommonProperties,this.f=s,this.d={isUsageEnabled:n.isUsageEnabled,isErrorsEnabled:n.isErrorsEnabled}}updateTelemetryEnablements(s,r){this.e&&(this.d={isUsageEnabled:s,isErrorsEnabled:r},this.a.fire(this.e))}mixInCommonPropsAndCleanData(s){let r="properties"in s?s.properties??{}:s;return r=(0,E.$uo)(r,[]),this.c&&(r=(0,w.$5m)(r,this.c)),this.b||(r=(0,w.$5m)(r,this.j)),"properties"in s?s.properties=r:s=r,s}k(s,r){this.f&&(this.g.publisher==="vscode"?s=this.g.name+"/"+s:s=this.g.identifier.value+"/"+s,r=this.mixInCommonPropsAndCleanData(r||{}),this.i||this.f?.sendEventData(s,r),this.h.trace(s,r))}logUsage(s,r){this.d.isUsageEnabled&&this.k(s,r)}logError(s,r){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof s=="string")this.k(s,r);else{const c={name:s.name,message:s.message,stack:s.stack,cause:s.cause},m=(0,E.$uo)(c,[]),h=new Error(m.message,{cause:m.cause});h.stack=m.stack,h.name=m.name,r=this.mixInCommonPropsAndCleanData(r||{}),this.i||this.f.sendErrorData(h,r),this.h.trace("exception",r)}}get apiTelemetryLogger(){if(!this.e){const s=this,r={logUsage:s.logUsage.bind(s),get isUsageEnabled(){return s.d.isUsageEnabled},get isErrorsEnabled(){return s.d.isErrorsEnabled},logError:s.logError.bind(s),dispose:s.dispose.bind(s),onDidChangeEnableStates:s.a.event.bind(s)};this.e=Object.freeze(r)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let s=this.f;this.f=void 0,Promise.resolve(s.flush()).then(s=void 0),this.e=void 0}else this.f=void 0}}e.$sM=D;function v(l){const s=Date.now()-new Date(l).getTime();return isNaN(s)?!1:s<1e3*60*60*24}e.$tM=v,e.$uM=(0,C.$Nh)("IExtHostTelemetry")}),define(De[26],Ce([1,0,4,2,252,137,25,5]),function(me,e,C,T,d,M,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eF=e.$dF=e.$cF=e.ActivationKind=e.$bF=e.$aF=e.$_E=e.$$E=e.$0E=e.ExtensionHostStartup=e.$9E=e.$8E=e.$7E=e.$6E=void 0,e.$6E=Object.freeze({identifier:new A.$2l("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:T.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$7E="extensions.webWorker",e.$8E=(0,b.$Nh)("extensionService");class E{constructor(h){this.dependency=h}}e.$9E=E;var w;(function(m){m[m.EagerAutoStart=1]="EagerAutoStart",m[m.EagerManualStart=2]="EagerManualStart",m[m.Lazy=3]="Lazy"})(w||(e.ExtensionHostStartup=w={}));class R{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(h,t,n){this.c=h,this.d=t.slice(0),this.e=n.slice(0)}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:M.$QE.createActivationEventsMap(this.d)}}set(h,t,n){if(this.c>h)throw new Error(`ExtensionHostExtensions: invalid versionId ${h} (current: ${this.c})`);const o=[],i=[],a=[],u=[],k=I(this.d),S=I(t),$=(O,L)=>O.extensionLocation.toString()===L.extensionLocation.toString()||O.isBuiltin===L.isBuiltin||O.isUserBuiltin===L.isUserBuiltin||O.isUnderDevelopment===L.isUnderDevelopment;for(const O of this.d){const L=S.get(O.identifier);if(!L){o.push(O.identifier),k.delete(O.identifier);continue}if(!$(O,L)){o.push(O.identifier),k.delete(O.identifier);continue}}for(const O of t){const L=k.get(O.identifier);if(!L){i.push(O);continue}if(!$(L,O)){o.push(L.identifier),k.delete(L.identifier);continue}}const g=new A.$3l(this.e),f=new A.$3l(n);for(const O of this.e)f.has(O)||a.push(O);for(const O of n)g.has(O)||u.push(O);const P=M.$QE.createActivationEventsMap(i),N={versionId:h,toRemove:o,toAdd:i,addActivationEvents:P,myToRemove:a,myToAdd:u};return this.delta(N),N}delta(h){if(this.c>=h.versionId)return null;const{toRemove:t,toAdd:n,myToRemove:o,myToAdd:i}=h,a=new A.$3l(t),u=new A.$3l(o);for(let k=0;k<this.d.length;k++)a.has(this.d[k].identifier)&&(this.d.splice(k,1),k--);for(let k=0;k<this.e.length;k++)u.has(this.e[k])&&(this.e.splice(k,1),k--);for(const k of n)this.d.push(k);for(const k of i)this.e.push(k);return h}containsExtension(h){for(const t of this.e)if(A.$2l.equals(t,h))return!0;return!1}}e.$0E=R;function I(m){const h=new A.$4l;for(const t of m)h.set(t.identifier,t);return h}function p(m,h){return m.enabledApiProposals?m.enabledApiProposals.includes(h):!1}e.$$E=p;function y(m,h){if(!p(m,h))throw new Error(`Extension '${m.identifier.value}' CANNOT use API proposal: ${h}.
Its package.json#enabledApiProposals-property declares: ${m.enabledApiProposals?.join(", ")??"[]"} but NOT ${h}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${m.identifier.value}`)}e.$_E=y;class D{constructor(h,t,n,o){this.codeLoadingTime=h,this.activateCallTime=t,this.activateResolvedTime=n,this.activationReason=o}}e.$aF=D;class v{constructor(h,t){this.description=h,this.value=t}}e.$bF=v;var l;(function(m){m[m.Normal=0]="Normal",m[m.Immediate=1]="Immediate"})(l||(e.ActivationKind=l={}));function s(m){return{type:m.isBuiltin?0:1,isBuiltin:m.isBuiltin||m.isUserBuiltin,identifier:{id:(0,d.$Ao)(m.publisher,m.name),uuid:m.uuid},manifest:m,location:m.extensionLocation,targetPlatform:m.targetPlatform,validations:[],isValid:!0}}e.$cF=s;function r(m,h){return{identifier:new A.$2l((0,d.$yo)(m.manifest.publisher,m.manifest.name)),isBuiltin:m.type===0,isUserBuiltin:m.type===1&&m.isBuiltin,isUnderDevelopment:!!h,extensionLocation:m.location,...m.manifest,uuid:m.identifier.uuid,targetPlatform:m.targetPlatform}}e.$dF=r;class c{constructor(){this.onDidRegisterExtensions=C.Event.None,this.onDidChangeExtensionsStatus=C.Event.None,this.onDidChangeExtensions=C.Event.None,this.onWillActivateByEvent=C.Event.None,this.onDidChangeResponsiveChange=C.Event.None,this.onWillStop=C.Event.None,this.extensions=[]}activateByEvent(h){return Promise.resolve(void 0)}activationEventIsDone(h){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(h){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(h,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(h){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$eF=c}),define(De[286],Ce([1,0,8,148,25,26,13,9]),function(me,e,C,T,d,M,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_bc=e.$$bc=e.$0bc=e.$9bc=e.$8bc=e.$7bc=void 0;class E{static{this.NONE=new E(!1,-1,-1,-1)}constructor(s,r,c,m){this.startup=s,this.codeLoadingTime=r,this.activateCallTime=c,this.activateResolvedTime=m}}e.$7bc=E;class w{constructor(s){this.a=s,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(s,r){return s===-1||r===-1?-1:r-s}build(){return new E(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$8bc=w;class R{constructor(s,r,c,m,h,t){this.activationFailed=s,this.activationFailedError=r,this.activationTimes=c,this.module=m,this.exports=h,this.subscriptions=t}}e.$9bc=R;class I extends R{constructor(s){super(!1,null,s,{activate:void 0,deactivate:void 0},void 0,[])}}e.$0bc=I;class p extends R{constructor(){super(!1,null,E.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$$bc=p;class y extends R{constructor(s){super(!0,s,E.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let D=class{constructor(s,r,c,m){this.g=m,this.a=s,this.b=r,this.c=c,this.d=new d.$4l,this.f=Object.create(null)}dispose(){for(const[s,r]of this.d)r.dispose()}async waitForActivatingExtensions(){const s=[];for(const[r,c]of this.d)s.push(c.wait());await Promise.all(s)}isActivated(s){const r=this.d.get(s);return!!(r&&r.value)}getActivatedExtension(s){const r=this.d.get(s);if(!r||!r.value)throw new Error(`Extension '${s.value}' is not known or not activated`);return r.value}async activateByEvent(s,r){if(this.f[s])return;const c=this.a.getExtensionDescriptionsForActivationEvent(s);await this.h(c.map(m=>({id:m.identifier,reason:{startup:r,extensionId:m.identifier,activationEvent:s}}))),this.f[s]=!0}activateById(s,r){const c=this.a.getExtensionDescription(s);if(!c)throw new Error(`Extension '${s}' is not known`);return this.h([{id:c.identifier,reason:r}])}async h(s){const r=s.filter(c=>!this.isActivated(c.id)).map(c=>this.j(c));await Promise.all(r.map(c=>c.wait()))}j(s){if(this.d.has(s.id))return this.d.get(s.id);if(this.l(s.id))return this.k(s,null,[],null);const r=this.a.getExtensionDescription(s.id);if(!r){const h=new Error(`Cannot activate unknown extension '${s.id.value}'`),t=this.k(s,null,[],new y(h));return this.c.onExtensionActivationError(s.id,h,new M.$9E(s.id.value)),t}const c=[],m=typeof r.extensionDependencies>"u"?[]:r.extensionDependencies;for(const h of m){if(this.m(h))continue;const t=this.d.get(h);if(t){c.push(t);continue}if(this.l(h)){c.push(this.j({id:this.b.getExtensionDescription(h).identifier,reason:s.reason}));continue}const n=this.a.getExtensionDescription(h);if(n){if(!n.main&&!n.browser)continue;c.push(this.j({id:n.identifier,reason:s.reason}));continue}const o=r.displayName||r.identifier.value,i=new Error(`Cannot activate the '${o}' extension because it depends on unknown extension '${h}'`),a=this.k(s,r.displayName,[],new y(i));return this.c.onExtensionActivationError(r.identifier,i,new M.$9E(h)),a}return this.k(s,r.displayName,c,null)}k(s,r,c,m){const h=new v(s.id,r,s.reason,c,m,this.c,this.g);return this.d.set(s.id,h),h}l(s){return T.$_3b.isHostExtension(s,this.a,this.b)}m(s){const r=this.b.getExtensionDescription(s);return r?!r.main&&!r.browser:!1}};e.$_bc=D,e.$_bc=D=He([Be(3,A.$8i)],D);let v=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(s,r,c,m,h,t,n){this.c=s,this.d=r,this.f=c,this.g=m,this.h=h,this.j=t,this.k=n,this.a=new b.$Rg,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let s=0;s<this.g.length;s++){const r=this.g[s];if(r.value&&!r.value.activationFailed){this.g.splice(s,1),s--;continue}if(r.value&&r.value.activationFailed){const c=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${r.friendlyName}' failed to activate`);c.detail=r.value.activationFailedError,this.h=new y(c),this.j.onExtensionActivationError(this.c,c,null);return}}this.g.length>0&&await Promise.race(this.g.map(s=>s.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(s){const r=new Error;if(s&&s.name&&(r.name=s.name),s&&s.message?r.message=`Activating extension '${this.c.value}' failed: ${s.message}.`:r.message=`Activating extension '${this.c.value}' failed: ${s}.`,s&&s.stack&&(r.stack=s.stack),this.h=new y(r),this.b&&C.$3(s))return;this.j.onExtensionActivationError(this.c,r,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(s)}}};v=He([Be(6,A.$8i)],v)}),define(De[287],Ce([1,0,212,24,2,4,3,269,9,7,18,19,14,79,21,173,26]),function(me,e,C,T,d,M,A,b,E,w,R,I,p,y,D,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lcc=void 0;function s(m,h){if((0,R.$xf)(m))return{label:m};if(m&&typeof m=="object"&&typeof m.label=="string"){let t;return Array.isArray(m.highlights)&&(t=m.highlights.filter(n=>n.length===2&&typeof n[0]=="number"&&typeof n[1]=="number"),t=t.length?t:void 0),{label:m.label,highlights:t}}}class r extends A.$Rc{constructor(h,t,n){super(),this.f=h,this.g=t,this.h=n,this.a=new Map,this.b=new v.$F7;function o(i){return i&&i.$treeViewId&&(i.$treeItemHandle||i.$selectedTreeItems||i.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:i=>o(i)?this.r(i):Array.isArray(i)&&i.length>0?i.map(a=>o(a)?this.r(a):a):i})}registerTreeDataProvider(h,t,n){const o=this.createTreeView(h,{treeDataProvider:t},n);return{dispose:()=>o.dispose()}}createTreeView(h,t,n){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const o=t.dragAndDropController?.dropMimeTypes??[],i=t.dragAndDropController?.dragMimeTypes??[],a=!!t.dragAndDropController?.handleDrag,u=!!t.dragAndDropController?.handleDrop,k=this.m(h,t,n),S={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:o,dragMimeTypes:i,hasHandleDrag:a,hasHandleDrop:u,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},$=this.f.$registerTreeViewDataProvider(h,S),g={get onDidCollapseElement(){return k.onDidCollapseElement},get onDidExpandElement(){return k.onDidExpandElement},get selection(){return k.selectedElements},get onDidChangeSelection(){return k.onDidChangeSelection},get activeItem(){return(0,l.$_E)(n,"treeViewActiveItem"),k.focusedElement},get onDidChangeActiveItem(){return(0,l.$_E)(n,"treeViewActiveItem"),k.onDidChangeActiveItem},get visible(){return k.visible},get onDidChangeVisibility(){return k.onDidChangeVisibility},get onDidChangeCheckboxState(){return k.onDidChangeCheckboxState},get message(){return k.message},set message(f){(0,y.$3j)(f)&&(0,l.$_E)(n,"treeViewMarkdownMessage"),k.message=f},get title(){return k.title},set title(f){k.title=f},get description(){return k.description},set description(f){k.description=f},get badge(){return k.badge},set badge(f){f!==void 0&&w.ViewBadge.isViewBadge(f)?k.badge={value:Math.floor(Math.abs(f.value)),tooltip:f.tooltip}:f===void 0&&(k.badge=void 0)},reveal:(f,P)=>k.reveal(f,P),dispose:async()=>{await $,this.a.delete(h),k.dispose()}};return this.B(g),g}$getChildren(h,t){const n=this.a.get(h);return n?n.getChildren(t):Promise.reject(new b.$lE(h))}async $handleDrop(h,t,n,o,i,a,u,k){const S=this.a.get(h);if(!S)return Promise.reject(new b.$lE(h));const $=p.DataTransfer.toDataTransfer(n,async g=>(await this.f.$resolveDropFileData(h,t,g)).buffer);return u===h&&k&&await this.j($,S,k,i,a),S.onDrop($,o,i)}async j(h,t,n,o,i){const a=this.b.removeDragOperationTransfer(i);if(a)(await a)?.forEach((u,k)=>{u&&h.set(k,u)});else if(i&&t.handleDrag){const u=t.handleDrag(n,h,o);this.b.addDragOperationTransfer(i,u),await u}return h}async $handleDrag(h,t,n,o){const i=this.a.get(h);if(!i)return Promise.reject(new b.$lE(h));const a=await this.j(new w.$5K,i,t,o,n);if(!(!a||o.isCancellationRequested))return p.DataTransfer.from(a)}async $hasResolve(h){const t=this.a.get(h);if(!t)throw new b.$lE(h);return t.hasResolve}$resolve(h,t,n){const o=this.a.get(h);if(!o)throw new b.$lE(h);return o.resolveTreeItem(t,n)}$setExpanded(h,t,n){const o=this.a.get(h);if(!o)throw new b.$lE(h);o.setExpanded(t,n)}$setSelectionAndFocus(h,t,n){const o=this.a.get(h);if(!o)throw new b.$lE(h);o.setSelectionAndFocus(t,n)}$setVisible(h,t){const n=this.a.get(h);if(!n){if(!t)return;throw new b.$lE(h)}n.setVisible(t)}$changeCheckboxState(h,t){const n=this.a.get(h);if(!n)throw new b.$lE(h);n.setCheckboxState(t)}m(h,t,n){const o=this.B(new c(h,t,this.f,this.g.converter,this.h,n));return this.a.set(h,o),o}r(h){const t=this.a.get(h.$treeViewId);return t&&"$treeItemHandle"in h?t.getExtensionElement(h.$treeItemHandle):t&&"$focusedTreeItem"in h&&h.$focusedTreeItem?t.focusedElement:null}}e.$Lcc=r;class c extends A.$Rc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(h=>this.getExtensionElement(h)).filter(h=>!(0,R.$Gf)(h))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(h,t,n,o,i,a){if(super(),this.I=h,this.J=n,this.L=o,this.M=i,this.N=a,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new M.$Md),this.onDidExpandElement=this.u.event,this.w=this.B(new M.$Md),this.onDidCollapseElement=this.w.event,this.y=this.B(new M.$Md),this.onDidChangeSelection=this.y.event,this.z=this.B(new M.$Md),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new M.$Md),this.onDidChangeVisibility=this.C.event,this.D=this.B(new M.$Md),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new M.$Md),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new D.$Wd,a.contributes&&a.contributes.views)for(const $ in a.contributes.views)for(const g of a.contributes.views[$])g.id===h&&(this.P=g.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData($=>this.F.fire({message:!1,element:$})));let u,k;const S=M.Event.debounce(this.F.event,($,g)=>($||($={message:!1,elements:[]}),g.element!==!1&&(u||(u=new Promise(f=>k=f),this.G=this.G.then(()=>u)),Array.isArray(g.element)?$.elements.push(...g.element):$.elements.push(g.element)),g.message&&($.message=!0),$),200,!0);this.B(S(({message:$,elements:g})=>{g.length&&(this.H=this.H.then(()=>{const f=k;return u=null,this.$(g).then(()=>f())})),$&&this.J.$setMessage(this.I,p.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(h){const t=h?this.getExtensionElement(h):void 0;if(h&&!t)return this.M.error(`No tree item with id '${h}' found.`),Promise.resolve([]);let n=this.X(h);return n||(n=await this.Y(t)),n?n.map(o=>o.item):void 0}getExtensionElement(h){return this.j.get(h)}reveal(h,t){t=t||{select:!0,focus:!1};const n=(0,R.$Gf)(t.select)?!0:t.select,o=(0,R.$Gf)(t.focus)?!1:t.focus,i=(0,R.$Gf)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):h?this.G.then(()=>this.S(h)).then(a=>this.W(h,a[a.length-1]).then(u=>this.J.$reveal(this.I,{item:u.item,parentChain:a.map(k=>k.item)},{select:n,focus:o,expand:i})),a=>this.M.error(a)):this.J.$reveal(this.I,void 0,{select:n,focus:o,expand:i})}get message(){return this.O}set message(h){this.O=h,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(h){this.P=h,this.J.$setTitle(this.I,h,this.Q)}get description(){return this.Q}set description(h){this.Q=h,this.J.$setTitle(this.I,this.P,h)}get badge(){return this.R}set badge(h){this.R?.value===h?.value&&this.R?.tooltip===h?.tooltip||(this.R=p.ViewBadge.from(h),this.J.$setBadge(this.I,h))}setExpanded(h,t){const n=this.getExtensionElement(h);n&&(t?this.u.fire(Object.freeze({element:n})):this.w.fire(Object.freeze({element:n})))}setSelectionAndFocus(h,t){const n=!(0,I.$tb)(this.s,h);this.s=h;const o=this.t!==t;this.t=t,n&&this.y.fire(Object.freeze({selection:this.selectedElements})),o&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(h){h!==this.r&&(this.r=h,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(h){const t=(await Promise.all(h.map(async n=>{const o=this.getExtensionElement(n.treeItemHandle);return o?{extensionItem:o,treeItem:await this.f.getTreeItem(o),newState:n.newState?w.TreeItemCheckboxState.Checked:w.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(n=>n!==void 0);t.forEach(n=>{n.treeItem.checkboxState=n.newState?w.TreeItemCheckboxState.Checked:w.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(n=>[n.extensionItem,n.newState])})}async handleDrag(h,t,n){const o=[];for(const i of h){const a=this.getExtensionElement(i);a&&o.push(a)}if(!(!this.g?.handleDrag||o.length===0))return await this.g.handleDrag(o,t,n),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(h,t,n){const o=t?this.getExtensionElement(t):void 0;if(!(!o&&t||!this.g?.handleDrop))return(0,E.$Lg)(()=>this.g?.handleDrop?this.g.handleDrop(o,h,n):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(h,t){if(!this.f.resolveTreeItem)return;const n=this.j.get(h);if(n){const o=this.m.get(n);if(o){const i=await this.f.resolveTreeItem(o.extensionItem,n,t)??o.extensionItem;return this.hb(i),o.item.tooltip=this.eb(i.tooltip),o.item.command=this.fb(o.disposableStore,i.command),o.item}}}S(h){return this.U(h).then(t=>t?this.S(t).then(n=>this.W(t,n[n.length-1]).then(o=>(n.push(o),n))):Promise.resolve([]))}U(h){const t=this.m.get(h);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,E.$Lg)(()=>this.f.getParent(h))}W(h,t){const n=this.m.get(h);return n?Promise.resolve(n):(0,E.$Lg)(()=>this.f.getTreeItem(h)).then(o=>this.kb(h,o,t,!0)).then(o=>this.getChildren(t?t.item.handle:void 0).then(()=>{const i=this.getExtensionElement(o);if(i){const a=this.m.get(i);if(a)return Promise.resolve(a)}throw new Error(`Cannot resolve tree item for element ${o} from extension ${this.N.identifier.value}`)}))}X(h){if(h){let t;if(typeof h=="string"){const n=this.getExtensionElement(h);t=n?this.m.get(n):void 0}else t=h;return t&&t.children||void 0}return this.h}async Y(h){this.rb(h);const t=new D.$Wd(this.Z.token);try{const n=h?this.m.get(h):void 0,o=await this.f.getChildren(h);if(t.token.isCancellationRequested)return;const i=await Promise.all((0,I.$Gb)(o||[]).map(async a=>{const u=await this.f.getTreeItem(a);return u&&!t.token.isCancellationRequested?this.db(a,u,n):null}));return t.token.isCancellationRequested?void 0:(0,I.$Gb)(i)}finally{t.dispose()}}$(h){if(h.some(n=>!n))return this.Z.dispose(!0),this.Z=new D.$Wd,this.tb(),this.J.$refresh(this.I);{const n=this.ab(h);if(n.length)return this.bb(n)}return Promise.resolve(void 0)}ab(h){const t=new Set,n=h.map(i=>this.m.get(i));for(const i of n)if(i&&!t.has(i.item.handle)){let a=i;for(;a&&a.parent&&n.findIndex(u=>a&&a.parent&&u&&u.item.handle===a.parent.item.handle)===-1;){const u=this.j.get(a.parent.item.handle);a=u?this.m.get(u):void 0}a&&!a.parent&&t.add(i.item.handle)}const o=[];return t.forEach(i=>{const a=this.j.get(i);if(a){const u=this.m.get(a);u&&(!u.parent||!t.has(u.parent.item.handle))&&o.push(i)}}),o}bb(h){const t={};return Promise.all(h.map(n=>this.cb(n).then(o=>{o&&(t[n]=o.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(h){const t=this.getExtensionElement(h);if(t){const n=this.m.get(t);if(n)return this.rb(t),(0,E.$Lg)(()=>this.f.getTreeItem(t)).then(o=>{if(o){const i=this.ib(t,o,n.parent);return this.pb(t,i,n,n.parent),n.dispose(),i}return null})}return Promise.resolve(null)}db(h,t,n){const o=this.ib(h,t,n);if(t.id&&this.j.has(o.item.handle))throw new Error((0,C.localize)(0,null,t.id));return this.ob(h,o),this.qb(o,n),o}eb(h){return w.$BK.isMarkdownString(h)?p.MarkdownString.from(h):h}fb(h,t){return t?{...this.L.toInternal(t,h),originalId:t.command}:void 0}gb(h){if(h.checkboxState===void 0)return;let t,n,o;return typeof h.checkboxState=="number"?t=h.checkboxState:(t=h.checkboxState.state,n=h.checkboxState.tooltip,o=h.checkboxState.accessibilityInformation),{isChecked:t===w.TreeItemCheckboxState.Checked,tooltip:n,accessibilityInformation:o}}hb(h){if(!w.$ZK.isTreeItem(h,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(h,t,n){this.hb(t);const o=this.B(new A.$Qc),i=this.kb(h,t,n),a=this.lb(t);return{item:{handle:i,parentHandle:n?n.item.handle:void 0,label:s(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(o,t.command),contextValue:t.contextValue,icon:a,iconDark:this.mb(t)||a,themeIcon:this.jb(t),collapsibleState:(0,R.$Gf)(t.collapsibleState)?w.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:n,children:void 0,disposableStore:o,dispose(){o.dispose()}}}jb(h){return h.iconPath instanceof w.$8K?h.iconPath:void 0}kb(h,{id:t,label:n,resourceUri:o},i,a){if(t)return`${c.b}/${t}`;const u=s(n,this.N),k=i?i.item.handle:c.a;let S=u?u.label:o?(0,T.$rg)(o):"";S=S.indexOf("/")!==-1?S.replace("/","//"):S;const $=this.m.has(h)?this.m.get(h).item.handle:void 0,g=this.X(i)||[];let f,P=0;do{if(f=`${k}/${P}:${S}`,a||!this.j.has(f)||$===f)break;P++}while(P<=g.length);return f}lb(h){if(h.iconPath&&!(h.iconPath instanceof w.$8K))return typeof h.iconPath=="string"||d.URI.isUri(h.iconPath)?this.nb(h.iconPath):this.nb(h.iconPath.light)}mb(h){if(h.iconPath&&!(h.iconPath instanceof w.$8K)&&h.iconPath.dark)return this.nb(h.iconPath.dark)}nb(h){return d.URI.isUri(h)?h:d.URI.file(h)}ob(h,t){this.j.set(t.item.handle,h),this.m.set(h,t)}pb(h,t,n,o){this.j.delete(t.item.handle),this.m.delete(h),t.item.handle!==n.item.handle&&this.j.delete(n.item.handle),this.ob(h,t);const i=this.X(o)||[],a=i.filter(u=>u.item.handle===n.item.handle)[0];a&&i.splice(i.indexOf(a),1,t)}qb(h,t){t?(t.children||(t.children=[]),t.children.push(h)):(this.h||(this.h=[]),this.h.push(h))}rb(h){if(h){const t=this.m.get(h);if(t){if(t.children)for(const n of t.children){const o=this.j.get(n.item.handle);o&&this.sb(o)}t.children=void 0}}else this.tb()}sb(h){const t=this.m.get(h);if(t){if(t.children)for(const n of t.children){const o=this.j.get(n.item.handle);o&&this.sb(o)}this.m.delete(h),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(h=>h.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(De[288],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testMessageContextValue:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testMessageContextValue.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(De[289],Ce([1,0,224,8,38,132,105,42,25,288,135,137]),function(me,e,C,T,d,M,A,b,E,w,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5E=e.$4E=e.$3E=e.$2E=e.$1E=e.$ZE=void 0;const p=b.$bn.as(A.$cn.JSONContribution);class y{constructor(h,t,n){this.a=h,this.b=t,this.c=n}d(h,t){this.a({type:h,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(h){this.d(d.default.Error,h)}warn(h){this.d(d.default.Warning,h)}info(h){this.d(d.default.Info,h)}}e.$ZE=y;class D{static a(h){const t=new E.$3l;for(let n=0,o=h.length;n<o;n++)t.add(h[n].description.identifier);return t}static compute(h,t){if(!h||!h.length)return new D(t,[]);if(!t||!t.length)return new D([],h);const n=this.a(h),o=this.a(t),i=t.filter(u=>!n.has(u.description.identifier)),a=h.filter(u=>!o.has(u.description.identifier));return new D(i,a)}constructor(h,t){this.added=h,this.removed=t}}e.$1E=D;class v{constructor(h,t){this.name=h,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(h){if(this.a!==null)throw new Error("Handler already set!");this.a=h,this.d()}acceptUsers(h){this.c=D.compute(this.b,h),this.b=h,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(h){(0,T.$Z)(h)}}}e.$2E=v;const l={type:"string",enum:["ui","workspace"],enumDescriptions:[C.localize(0,null),C.localize(1,null)]},s="vscode://schemas/vscode-extensions";e.$3E={properties:{engines:{type:"object",description:C.localize(2,null),properties:{vscode:{type:"string",description:C.localize(3,null),default:"^1.22.0"}}},publisher:{description:C.localize(4,null),type:"string"},displayName:{description:C.localize(5,null),type:"string"},categories:{description:C.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:E.$1l},{type:"string",const:"Languages",deprecationMessage:C.localize(7,null)}]}},galleryBanner:{type:"object",description:C.localize(8,null),properties:{color:{description:C.localize(9,null),type:"string"},theme:{description:C.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:C.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:C.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:C.localize(13,null)},enabledApiProposals:{markdownDescription:C.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(w.allApiProposals),markdownEnumDescriptions:Object.values(w.allApiProposals)}},api:{markdownDescription:C.localize(15,null),type:"string",enum:["none"],enumDescriptions:[C.localize(16,null)]},activationEvents:{description:C.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:C.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:C.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:C.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:C.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:C.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:C.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:C.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:C.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:C.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:C.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:C.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:C.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:C.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:C.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:C.localize(32,null)},{label:"onUri",body:"onUri",description:C.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:C.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:C.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:C.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:C.localize(37,null)},{label:"onRenderer",description:C.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:C.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:C.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:C.localize(41,null)},{label:"*",description:C.localize(42,null),body:"*"}]}},badges:{type:"array",description:C.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:C.localize(44,null)},href:{type:"string",description:C.localize(45,null)},description:{type:"string",description:C.localize(46,null)}}}},markdown:{type:"string",description:C.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:C.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:C.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.$Sn}},extensionPack:{description:C.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.$Sn}},extensionKind:{description:C.localize(51,null),type:"array",items:l,default:["workspace"],defaultSnippets:[{body:["ui"],description:C.localize(52,null)},{body:["workspace"],description:C.localize(53,null)},{body:["ui","workspace"],description:C.localize(54,null)},{body:["workspace","ui"],description:C.localize(55,null)},{body:[],description:C.localize(56,null)}]},capabilities:{description:C.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:C.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:C.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[C.localize(60,null),C.localize(61,null),C.localize(62,null)]},description:{type:"string",markdownDescription:C.localize(63,null)}}},untrustedWorkspaces:{description:C.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:C.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[C.localize(66,null),C.localize(67,null),C.localize(68,null)]},restrictedConfigurations:{description:C.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:C.localize(70,null)}}}}},sponsor:{description:C.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:C.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:C.localize(73,null),type:"string"},"vscode:uninstall":{description:C.localize(74,null),type:"string"}}},icon:{type:"string",description:C.localize(75,null)},l10n:{type:"string",description:C.localize(76,null)},pricing:{type:"string",markdownDescription:C.localize(77,null),enum:["Free","Trial"],default:"Free"}}};class r{constructor(){this.a=new Map}registerExtensionPoint(h){if(this.a.has(h.extensionPoint))throw new Error("Duplicate extension point: "+h.extensionPoint);const t=new v(h.extensionPoint,h.defaultExtensionKind);return this.a.set(h.extensionPoint,t),h.activationEventsGenerator&&I.$QE.register(h.extensionPoint,h.activationEventsGenerator),e.$3E.properties.contributes.properties[h.extensionPoint]=h.jsonSchema,p.registerSchema(s,e.$3E),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$4E=r;const c={ExtensionsRegistry:"ExtensionsRegistry"};b.$bn.add(c.ExtensionsRegistry,new r),e.$5E=b.$bn.as(c.ExtensionsRegistry),p.registerSchema(s,e.$3E),p.registerSchema(R.$oj,{properties:{extensionEnabledApiProposals:{description:C.localize(78,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(w.allApiProposals),markdownEnumDescriptions:Object.values(w.allApiProposals)}}]}}}})}),define(De[290],Ce([1,0,221,18,23,289,41,4]),function(me,e,C,T,d,M,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MF=void 0;const E={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:C.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:C.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:C.localize(2,null),default:""}}};var w;(function(p){function y(D,v,l){if(!D)return;const s=T.$xf(D.type)?D.type:void 0;if(!s||s.length===0){l.error(C.localize(3,null));return}const r=[];if(Array.isArray(D.required))for(const c of D.required)T.$xf(c)&&r.push(c);return{extensionId:v.value,taskType:s,required:r,properties:D.properties?d.$2m(D.properties):{},when:D.when?A.$Li.deserialize(D.when):void 0}}p.from=y})(w||(w={}));const R=M.$5E.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(p,y)=>{for(const D of p)D.type&&y.push(`onTaskType:${D.type}`)},jsonSchema:{description:C.localize(4,null),type:"array",items:E}});class I{constructor(){this.d=new b.$Md,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((y,D)=>{R.setHandler((v,l)=>{this.c=void 0;try{for(const s of l.removed){const r=s.value;for(const c of r)this.a&&c.type&&this.a[c.type]&&delete this.a[c.type]}for(const s of l.added){const r=s.value;for(const c of r){const m=w.from(c,s.description.identifier,s.collector);m&&(this.a[m.taskType]=m)}}(l.removed.length>0||l.added.length>0)&&this.d.fire()}catch{}y(void 0)})})}onReady(){return this.b}get(y){return this.a[y]}all(){return Object.keys(this.a).map(y=>this.a[y])}getJsonSchema(){if(this.c===void 0){const y=[];for(const D of this.all()){const v={type:"object",additionalProperties:!1};D.required.length>0&&(v.required=D.required.slice(0)),D.properties!==void 0?v.properties=d.$2m(D.properties):v.properties=Object.create(null),v.properties.type={type:"string",enum:[D.taskType]},y.push(v)}this.c={oneOf:y}}return this.c}}e.$MF=new I}),define(De[291],Ce([1,0,222,18,24,23,41,290]),function(me,e,C,T,d,M,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$WF=e.JsonSchemaVersion=e.ExecutionEngine=e.$VF=e.$UF=e.$TF=e.$SF=e.$RF=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$QF=e.ShellQuoting=e.$PF=e.$OF=e.$NF=void 0,e.$NF="settings",e.$OF=new A.$5i("taskRunning",!1,C.localize(0,null)),e.$PF={value:C.localize(1,null),original:"Tasks"};var E;(function(z){z[z.Escape=1]="Escape",z[z.Strong=2]="Strong",z[z.Weak=3]="Weak"})(E||(e.ShellQuoting=E={})),e.$QF="$customized",function(z){function F(H){if(!H)return z.Strong;switch(H.toLowerCase()){case"escape":return z.Escape;case"strong":return z.Strong;case"weak":return z.Weak;default:return z.Strong}}z.from=F}(E||(e.ShellQuoting=E={}));var w;(function(z){z.defaults={cwd:"${workspaceFolder}"}})(w||(e.CommandOptions=w={}));var R;(function(z){z[z.Always=1]="Always",z[z.Silent=2]="Silent",z[z.Never=3]="Never"})(R||(e.RevealKind=R={})),function(z){function F(H){switch(H.toLowerCase()){case"always":return z.Always;case"silent":return z.Silent;case"never":return z.Never;default:return z.Always}}z.fromString=F}(R||(e.RevealKind=R={}));var I;(function(z){z[z.Never=1]="Never",z[z.OnProblem=2]="OnProblem",z[z.Always=3]="Always"})(I||(e.RevealProblemKind=I={})),function(z){function F(H){switch(H.toLowerCase()){case"always":return z.Always;case"never":return z.Never;case"onproblem":return z.OnProblem;default:return z.OnProblem}}z.fromString=F}(I||(e.RevealProblemKind=I={}));var p;(function(z){z[z.Shared=1]="Shared",z[z.Dedicated=2]="Dedicated",z[z.New=3]="New"})(p||(e.PanelKind=p={})),function(z){function F(H){switch(H.toLowerCase()){case"shared":return z.Shared;case"dedicated":return z.Dedicated;case"new":return z.New;default:return z.Shared}}z.fromString=F}(p||(e.PanelKind=p={}));var y;(function(z){z.defaults={echo:!0,reveal:R.Always,revealProblems:I.Never,focus:!1,panel:p.Shared,showReuseMessage:!0,clear:!1}})(y||(e.PresentationOptions=y={}));var D;(function(z){z[z.Shell=1]="Shell",z[z.Process=2]="Process",z[z.CustomExecution=3]="CustomExecution"})(D||(e.RuntimeType=D={})),function(z){function F(K){switch(K.toLowerCase()){case"shell":return z.Shell;case"process":return z.Process;case"customExecution":return z.CustomExecution;default:return z.Process}}z.fromString=F;function H(K){switch(K){case z.Shell:return"shell";case z.Process:return"process";case z.CustomExecution:return"customExecution";default:return"process"}}z.toString=H}(D||(e.RuntimeType=D={}));var v;(function(z){function F(H){return T.$xf(H)?H:H.value}z.value=F})(v||(e.CommandString=v={}));var l;(function(z){z.Clean={_id:"clean",isDefault:!1},z.Build={_id:"build",isDefault:!1},z.Rebuild={_id:"rebuild",isDefault:!1},z.Test={_id:"test",isDefault:!1};function F(K){return K===z.Clean._id||K===z.Build._id||K===z.Rebuild._id||K===z.Test._id}z.is=F;function H(K){if(K!==void 0)return T.$xf(K)?F(K)?{_id:K,isDefault:!1}:void 0:K}z.from=H})(l||(e.TaskGroup=l={}));var s;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace",z[z.Folder=3]="Folder"})(s||(e.TaskScope=s={}));var r;(function(z){z.Workspace="workspace",z.Extension="extension",z.InMemory="inMemory",z.WorkspaceFile="workspaceFile",z.User="user";function F(H){switch(H){case z.User:return 2;case z.WorkspaceFile:return 5;default:return 6}}z.toConfigurationTarget=F})(r||(e.TaskSourceKind=r={}));var c;(function(z){z.parallel="parallel",z.sequence="sequence"})(c||(e.DependsOrder=c={}));var m;(function(z){z[z.default=1]="default",z[z.folderOpen=2]="folderOpen"})(m||(e.RunOnOptions=m={}));var h;(function(z){z.defaults={reevaluateOnRerun:!0,runOn:m.default,instanceLimit:1}})(h||(e.RunOptions=h={}));class t{constructor(F,H,K,fe,x,Z){this._label="",this._id=F,H&&(this._label=H),K&&(this.type=K),this.runOptions=fe,this.configurationProperties=x,this._source=Z}getDefinition(F){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const F={folder:this.d(),id:this._id};return JSON.stringify(F)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(F,H=!1){if(F===void 0)return!1;if(T.$xf(F))return F===this._label||F===this.configurationProperties.identifier||H&&F===this._id;const K=this.getDefinition(!0);return K!==void 0&&K._key===F._key}getQualifiedLabel(){const F=this.getWorkspaceFolder();return F?`${this._label} (${F.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(F){this.c===void 0&&(this.c=[]),F&&(this.c=this.c.concat(F))}get taskLoadMessages(){return this.c}}e.$RF=t;class n extends t{constructor(F,H,K,fe,x,Z,q,Y){super(F,K,void 0,q,Y,H),this.command={},this._source=H,this.hasDefinedMatchers=Z,x&&(this.command=x)}clone(){return new n(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(F=!1){if(F&&this._source.customizes!==void 0)return this._source.customizes;{let H;switch(this.command?this.command.runtime:void 0){case D.Shell:H="shell";break;case D.Process:H="process";break;case D.CustomExecution:H="customExecution";break;case void 0:H="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:H,_key:this._id,id:this._id}}}static is(F){return F instanceof n}getMapKey(){const F=this._source.config.workspaceFolder;return F?`${F.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===r.User?e.$NF:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const F=this.d();if(!F)return;let H=this.configurationProperties.identifier;this._source.kind!==r.Workspace&&(H+=this._source.kind);const K={type:e.$QF,folder:F,id:H};return JSON.stringify(K)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?d.$rg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(F){return new n(F._id,F._source,F._label,F.type,F.command,F.hasDefinedMatchers,F.runOptions,F.configurationProperties)}}e.$SF=n;class o extends t{constructor(F,H,K,fe,x,Z,q){super(F,K,fe,Z,q,H),this._source=H,this.configures=x}static is(F){return F instanceof o}f(F){return F}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?d.$rg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===r.User?e.$NF:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const F=this.d();if(!F)return;let H=this.configurationProperties.identifier;this._source.kind!==r.Workspace&&(H+=this._source.kind);const K={type:e.$QF,folder:F,id:H};return JSON.stringify(K)}}e.$TF=o;class i extends t{constructor(F,H,K,fe,x,Z,q,Y,be){super(F,K,fe,Y,be,H),this.defines=x,this.hasDefinedMatchers=q,this.command=Z,this.icon=be.icon,this.hide=be.hide}clone(){return new i(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(F){return F instanceof i}getMapKey(){const F=this._source.workspaceFolder;return F?`${this._source.scope.toString()}|${F.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const F={type:"contributed",scope:this._source.scope,id:this._id};return F.folder=this.d(),JSON.stringify(F)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(F){return new i(F._id,F._source,F._label,F.type,F.defines,F.command,F.hasDefinedMatchers,F.runOptions,F.configurationProperties)}}e.$UF=i;class a extends t{constructor(F,H,K,fe,x,Z){super(F,K,fe,x,Z,H),this._source=H}clone(){return new a(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(F){return F instanceof a}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(F){return new a(F._id,F._source,F._label,F.type,F.runOptions,F.configurationProperties)}}e.$VF=a;var u;(function(z){z[z.Process=1]="Process",z[z.Terminal=2]="Terminal"})(u||(e.ExecutionEngine=u={})),function(z){z._default=z.Terminal}(u||(e.ExecutionEngine=u={}));var k;(function(z){z[z.V0_1_0=1]="V0_1_0",z[z.V2_0_0=2]="V2_0_0"})(k||(e.JsonSchemaVersion=k={}));class S{constructor(F){this.c=new Map;for(let H=0;H<F.length;H++)this.c.set(F[H].uri.toString(),H)}compare(F,H){const K=F.getWorkspaceFolder(),fe=H.getWorkspaceFolder();if(K&&fe){let x=this.c.get(K.uri.toString());x=x===void 0?0:x+1;let Z=this.c.get(fe.uri.toString());return Z=Z===void 0?0:Z+1,x===Z?F._label.localeCompare(H._label):x-Z}else return!K&&fe?-1:K&&!fe?1:0}}e.$WF=S;var $;(function(z){z.DependsOnStarted="dependsOnStarted",z.AcquiredInput="acquiredInput",z.Start="start",z.ProcessStarted="processStarted",z.Active="active",z.Inactive="inactive",z.Changed="changed",z.Terminated="terminated",z.ProcessEnded="processEnded",z.End="end"})($||(e.TaskEventKind=$={}));var g;(function(z){z.SingleRun="singleRun",z.Background="background"})(g||(e.TaskRunType=g={}));var f;(function(z){z[z.System=0]="System",z[z.User=1]="User",z[z.FolderOpen=2]="FolderOpen",z[z.ConfigurationChange=3]="ConfigurationChange",z[z.Reconnect=4]="Reconnect"})(f||(e.TaskRunSource=f={}));var P;(function(z){function F(Y){return{taskId:Y._id,taskName:Y.configurationProperties.name,runType:Y.configurationProperties.isBackground?"background":"singleRun",group:Y.configurationProperties.group,__task:Y}}function H(Y,be,ue){return{...F(Y),kind:"start",terminalId:be,resolvedVariables:ue}}z.start=H;function K(Y,be,ue){return{...F(Y),kind:"processStarted",terminalId:be,processId:ue}}z.processStarted=K;function fe(Y,be,ue){return{...F(Y),kind:"processEnded",terminalId:be,exitCode:ue}}z.processEnded=fe;function x(Y,be,ue){return{...F(Y),kind:"terminated",exitReason:ue,terminalId:be}}z.terminated=x;function Z(Y,be,ue){return{...F(be),kind:Y,terminalId:ue}}z.general=Z;function q(){return{kind:"changed"}}z.changed=q})(P||(e.TaskEvent=P={}));var N;(function(z){function F(K){const fe=Object.keys(K).sort();let x="";for(const Z of fe){let q=K[Z];q instanceof Object?q=F(q):typeof q=="string"&&(q=q.replace(/,/g,",,")),x+=Z+","+q+","}return x}function H(K){const x={_key:F(K),type:K.taskType};return Object.assign(x,K),x}z.create=H})(N||(e.KeyedTaskIdentifier=N={}));var O;(function(z){z.AutoDetect="task.autoDetect",z.SaveBeforeRun="task.saveBeforeRun",z.ShowDecorations="task.showDecorations",z.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",z.SlowProviderWarning="task.slowProviderWarning",z.QuickOpenHistory="task.quickOpen.history",z.QuickOpenDetail="task.quickOpen.detail",z.QuickOpenSkip="task.quickOpen.skip",z.QuickOpenShowAll="task.quickOpen.showAll",z.AllowAutomaticTasks="task.allowAutomaticTasks",z.Reconnection="task.reconnection"})(O||(e.TaskSettingId=O={}));var L;(function(z){z.Tasks="tasks",z.SuppressTaskName="tasks.suppressTaskName",z.Windows="tasks.windows",z.Osx="tasks.osx",z.Linux="tasks.linux",z.ShowOutput="tasks.showOutput",z.IsShellCommand="tasks.isShellCommand",z.ServiceTestSetting="tasks.service.testSetting"})(L||(e.TasksSchemaProperties=L={}));var j;(function(z){function F(H,K){const fe=b.$MF.get(H.type);if(fe===void 0){const Y=M.$2m(H);return delete Y._key,N.create(Y)}const x=Object.create(null);x.type=fe.taskType;const Z=new Set;fe.required.forEach(Y=>Z.add(Y));const q=fe.properties;for(const Y of Object.keys(q)){const be=H[Y];if(be!=null)x[Y]=be;else if(Z.has(Y)){const ue=q[Y];if(ue.default!==void 0)x[Y]=M.$2m(ue.default);else switch(ue.type){case"boolean":x[Y]=!1;break;case"number":case"integer":x[Y]=0;break;case"string":x[Y]="";break;default:K.error(C.localize(2,null,JSON.stringify(H,void 0,0),Y));return}}}return N.create(x)}z.createTaskIdentifier=F})(j||(e.TaskDefinition=j={}))}),define(De[292],Ce([1,0,8]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f4b=e.$e4b=void 0;class T{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((A,b)=>{this.b=A,this.d=b,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(A){this.f||this.h||(this.f=!0,this.g=A,this.a&&this.b(A))}resolveErr(A){this.f||this.h||(this.h=!0,this.i=A,this.a?this.d(A):(0,C.$Z)(A))}then(A,b){return this.j().then(A,b)}catch(A){return this.j().then(void 0,A)}finally(A){return this.j().finally(A)}}e.$e4b=T;class d extends T{constructor(){super(),this.h=!0,this.i=new C.$4}}e.$f4b=d}),define(De[68],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kv=e.$jv=e.$iv=e.$hv=void 0;class C{static{this.count=0}constructor(E){this._proxyIdentifierBrand=void 0,this.sid=E,this.nid=++C.count}}e.$hv=C;const T=[];function d(b){const E=new C(b);return T[E.nid]=E,E}e.$iv=d;function M(b){return T[b].sid}e.$jv=M;class A{constructor(E){this.value=E}}e.$kv=A}),define(De[6],Ce([1,0,68]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aK=e.$_J=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$$J=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var T;(function(v){v[v.Default=0]="Default",v[v.InCenter=1]="InCenter",v[v.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",v[v.AtTop=3]="AtTop"})(T||(e.TextEditorRevealType=T={}));var d;(function(v){v[v.UnknownInput=0]="UnknownInput",v[v.TextInput=1]="TextInput",v[v.TextDiffInput=2]="TextDiffInput",v[v.TextMergeInput=3]="TextMergeInput",v[v.NotebookInput=4]="NotebookInput",v[v.NotebookDiffInput=5]="NotebookDiffInput",v[v.CustomEditorInput=6]="CustomEditorInput",v[v.WebviewEditorInput=7]="WebviewEditorInput",v[v.TerminalEditorInput=8]="TerminalEditorInput",v[v.InteractiveEditorInput=9]="InteractiveEditorInput"})(d||(e.TabInputKind=d={}));var M;(function(v){v[v.TAB_OPEN=0]="TAB_OPEN",v[v.TAB_CLOSE=1]="TAB_CLOSE",v[v.TAB_UPDATE=2]="TAB_UPDATE",v[v.TAB_MOVE=3]="TAB_MOVE"})(M||(e.TabModelOperationKind=M={}));var A;(function(v){v[v.Editable=0]="Editable",v[v.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var b;(function(v){v[v.Int8Array=1]="Int8Array",v[v.Uint8Array=2]="Uint8Array",v[v.Uint8ClampedArray=3]="Uint8ClampedArray",v[v.Int16Array=4]="Int16Array",v[v.Uint16Array=5]="Uint16Array",v[v.Int32Array=6]="Int32Array",v[v.Uint32Array=7]="Uint32Array",v[v.Float32Array=8]="Float32Array",v[v.Float64Array=9]="Float64Array",v[v.BigInt64Array=10]="BigInt64Array",v[v.BigUint64Array=11]="BigUint64Array"})(b||(e.WebviewMessageArrayBufferViewType=b={}));var E;(function(v){v[v.Text=1]="Text",v[v.Error=2]="Error",v[v.Rich=3]="Rich"})(E||(e.CellOutputKind=E={}));var w;(function(v){v[v.Default=0]="Default",v[v.InCenter=1]="InCenter",v[v.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",v[v.AtTop=3]="AtTop"})(w||(e.NotebookEditorRevealType=w={}));var R;(function(v){v[v.None=0]="None",v[v.Process=1]="Process",v[v.Output=2]="Output"})(R||(e.CandidatePortSource=R={}));class I{static{this.a=0}static mixin(l){return l._id=I.a++,l}}e.$$J=I;var p;(function(v){v.label="a",v.kind="b",v.detail="c",v.documentation="d",v.sortText="e",v.filterText="f",v.preselect="g",v.insertText="h",v.insertTextRules="i",v.range="j",v.commitCharacters="k",v.additionalTextEdits="l",v.kindModifier="m",v.commandIdent="n",v.commandId="o",v.commandArguments="p"})(p||(e.ISuggestDataDtoField=p={}));var y;(function(v){v.defaultRanges="a",v.completions="b",v.isIncomplete="c",v.duration="d"})(y||(e.ISuggestResultDtoField=y={}));var D;(function(v){v[v.Workspace=0]="Workspace",v[v.TextDocument=1]="TextDocument"})(D||(e.ExtHostTestingResource=D={})),e.$_J={MainThreadAuthentication:(0,C.$iv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,C.$iv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,C.$iv)("MainThreadChatProvider"),MainThreadChatAgents:(0,C.$iv)("MainThreadChatAgents"),MainThreadChatVariables:(0,C.$iv)("MainThreadChatVariables"),MainThreadClipboard:(0,C.$iv)("MainThreadClipboard"),MainThreadCommands:(0,C.$iv)("MainThreadCommands"),MainThreadComments:(0,C.$iv)("MainThreadComments"),MainThreadConfiguration:(0,C.$iv)("MainThreadConfiguration"),MainThreadConsole:(0,C.$iv)("MainThreadConsole"),MainThreadDebugService:(0,C.$iv)("MainThreadDebugService"),MainThreadDecorations:(0,C.$iv)("MainThreadDecorations"),MainThreadDiagnostics:(0,C.$iv)("MainThreadDiagnostics"),MainThreadDialogs:(0,C.$iv)("MainThreadDiaglogs"),MainThreadDocuments:(0,C.$iv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,C.$iv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,C.$iv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,C.$iv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,C.$iv)("MainThreadEditorTabs"),MainThreadErrors:(0,C.$iv)("MainThreadErrors"),MainThreadTreeViews:(0,C.$iv)("MainThreadTreeViews"),MainThreadDownloadService:(0,C.$iv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,C.$iv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,C.$iv)("MainThreadLanguages"),MainThreadLogger:(0,C.$iv)("MainThreadLogger"),MainThreadMessageService:(0,C.$iv)("MainThreadMessageService"),MainThreadOutputService:(0,C.$iv)("MainThreadOutputService"),MainThreadProgress:(0,C.$iv)("MainThreadProgress"),MainThreadQuickDiff:(0,C.$iv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,C.$iv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,C.$iv)("MainThreadStatusBar"),MainThreadSecretState:(0,C.$iv)("MainThreadSecretState"),MainThreadStorage:(0,C.$iv)("MainThreadStorage"),MainThreadTelemetry:(0,C.$iv)("MainThreadTelemetry"),MainThreadTerminalService:(0,C.$iv)("MainThreadTerminalService"),MainThreadWebviews:(0,C.$iv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,C.$iv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,C.$iv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,C.$iv)("MainThreadCustomEditors"),MainThreadUrls:(0,C.$iv)("MainThreadUrls"),MainThreadUriOpeners:(0,C.$iv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,C.$iv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,C.$iv)("MainThreadWorkspace"),MainThreadFileSystem:(0,C.$iv)("MainThreadFileSystem"),MainThreadExtensionService:(0,C.$iv)("MainThreadExtensionService"),MainThreadSCM:(0,C.$iv)("MainThreadSCM"),MainThreadSearch:(0,C.$iv)("MainThreadSearch"),MainThreadShare:(0,C.$iv)("MainThreadShare"),MainThreadTask:(0,C.$iv)("MainThreadTask"),MainThreadWindow:(0,C.$iv)("MainThreadWindow"),MainThreadLabelService:(0,C.$iv)("MainThreadLabelService"),MainThreadNotebook:(0,C.$iv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,C.$iv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,C.$iv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,C.$iv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,C.$iv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,C.$iv)("MainThreadInteractive"),MainThreadChat:(0,C.$iv)("MainThreadChat"),MainThreadInlineChat:(0,C.$iv)("MainThreadInlineChatShape"),MainThreadTheming:(0,C.$iv)("MainThreadTheming"),MainThreadTunnelService:(0,C.$iv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,C.$iv)("MainThreadManagedSockets"),MainThreadTimeline:(0,C.$iv)("MainThreadTimeline"),MainThreadTesting:(0,C.$iv)("MainThreadTesting"),MainThreadLocalization:(0,C.$iv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,C.$iv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,C.$iv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,C.$iv)("MainThreadIssueReporter")},e.$aK={ExtHostCommands:(0,C.$iv)("ExtHostCommands"),ExtHostConfiguration:(0,C.$iv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,C.$iv)("ExtHostDiagnostics"),ExtHostDebugService:(0,C.$iv)("ExtHostDebugService"),ExtHostDecorations:(0,C.$iv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,C.$iv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,C.$iv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,C.$iv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,C.$iv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,C.$iv)("ExtHostEditors"),ExtHostTreeViews:(0,C.$iv)("ExtHostTreeViews"),ExtHostFileSystem:(0,C.$iv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,C.$iv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,C.$iv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,C.$iv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,C.$iv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,C.$iv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,C.$iv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,C.$iv)("ExtHostStatusBar"),ExtHostShare:(0,C.$iv)("ExtHostShare"),ExtHostExtensionService:(0,C.$iv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,C.$iv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,C.$iv)("ExtHostTerminalService"),ExtHostSCM:(0,C.$iv)("ExtHostSCM"),ExtHostSearch:(0,C.$iv)("ExtHostSearch"),ExtHostTask:(0,C.$iv)("ExtHostTask"),ExtHostWorkspace:(0,C.$iv)("ExtHostWorkspace"),ExtHostWindow:(0,C.$iv)("ExtHostWindow"),ExtHostWebviews:(0,C.$iv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,C.$iv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,C.$iv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,C.$iv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,C.$iv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,C.$iv)("ExtHostEditorTabs"),ExtHostProgress:(0,C.$iv)("ExtHostProgress"),ExtHostComments:(0,C.$iv)("ExtHostComments"),ExtHostSecretState:(0,C.$iv)("ExtHostSecretState"),ExtHostStorage:(0,C.$iv)("ExtHostStorage"),ExtHostUrls:(0,C.$iv)("ExtHostUrls"),ExtHostUriOpeners:(0,C.$iv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,C.$iv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,C.$iv)("ExtHostOutputService"),ExtHosLabelService:(0,C.$iv)("ExtHostLabelService"),ExtHostNotebook:(0,C.$iv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,C.$iv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,C.$iv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,C.$iv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,C.$iv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,C.$iv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,C.$iv)("ExtHostInteractive"),ExtHostInlineChat:(0,C.$iv)("ExtHostInlineChatShape"),ExtHostChat:(0,C.$iv)("ExtHostChat"),ExtHostChatAgents:(0,C.$iv)("ExtHostChatAgents"),ExtHostChatVariables:(0,C.$iv)("ExtHostChatVariables"),ExtHostChatProvider:(0,C.$iv)("ExtHostChatProvider"),ExtHostAiRelatedInformation:(0,C.$iv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,C.$iv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,C.$iv)("ExtHostTheming"),ExtHostTunnelService:(0,C.$iv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,C.$iv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,C.$iv)("ExtHostAuthentication"),ExtHostTimeline:(0,C.$iv)("ExtHostTimeline"),ExtHostTesting:(0,C.$iv)("ExtHostTesting"),ExtHostTelemetry:(0,C.$iv)("ExtHostTelemetry"),ExtHostLocalization:(0,C.$iv)("ExtHostLocalization"),ExtHostIssueReporter:(0,C.$iv)("ExtHostIssueReporter")}}),define(De[293],Ce([1,0,6,7]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mdc=void 0;class d{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(C.$_J.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,b,E){if(this.a.size===0)throw new Error("No related information providers registered");const w=this.a.get(A);if(!w)throw new Error("related information provider not found");return await w.provideRelatedInformation(b,E)??[]}getRelatedInformation(A,b,E){return this.c.$getAiRelatedInformation(b,E)}registerRelatedInformationProvider(A,b,E){const w=this.b;return this.b++,this.a.set(w,E),this.c.$registerAiRelatedInformationProvider(w,b),new T.$bK(()=>{this.c.$unregisterAiRelatedInformationProvider(w),this.a.delete(w)})}}e.$Mdc=d}),define(De[89],Ce([1,0,5,13,6,20]),function(me,e,C,T,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rbc=e.$Qbc=e.$Pbc=void 0,e.$Pbc=(0,C.$Nh)("IExtHostApiDeprecationService");let A=class{constructor(E,w){this.c=w,this.a=new Set,this.b=E.getProxy(d.$_J.MainThreadTelemetry)}report(E,w,R){const I=this.d(E,w);this.a.has(I)||(this.a.add(I),w.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${E}' is deprecated. ${R}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:w.identifier.value,apiId:E}))}d(E,w){return`${E}-${w.identifier.value}`}};e.$Qbc=A,e.$Qbc=A=He([Be(0,M.$aM),Be(1,T.$8i)],A),e.$Rbc=Object.freeze(new class{report(b,E,w){}})}),define(De[294],Ce([1,0,4,6,7,25]),function(me,e,C,T,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ldc=void 0;class A{constructor(w){this.b=new Map,this.c=[],this.d=new C.$Md,this.onDidChangeSessions=this.d.event,this.f=new b,this.g=new b,this.a=w.getProxy(T.$_J.MainThreadAuthentication)}$setProviders(w){return this.c=w,Promise.resolve()}async getSession(w,R,I,p={}){const y=M.$2l.toKey(w.identifier),D=[...I].sort().join(" ");return await this.f.getOrCreate(`${y} ${R} ${D}`,async()=>{await this.a.$ensureProvider(R);const v=w.displayName||w.name;return this.a.$getSession(R,I,y,v,p)})}async getSessions(w,R,I){const p=M.$2l.toKey(w.identifier),y=[...I].sort().join(" ");return await this.g.getOrCreate(`${p} ${y}`,async()=>{await this.a.$ensureProvider(R);const D=w.displayName||w.name;return this.a.$getSessions(R,I,p,D)})}async removeSession(w,R){const I=this.b.get(w);return I?I.provider.removeSession(R):this.a.$removeSession(w,R)}registerAuthenticationProvider(w,R,I,p){if(this.b.get(w))throw new Error(`An authentication provider with id '${w}' is already registered.`);this.b.set(w,{label:R,provider:I,options:p??{supportsMultipleAccounts:!1}}),this.c.find(D=>D.id===w)||this.c.push({id:w,label:R});const y=I.onDidChangeSessions(D=>{this.a.$sendDidChangeSessions(w,{added:D.added??[],changed:D.changed??[],removed:D.removed??[]})});return this.a.$registerAuthenticationProvider(w,R,p?.supportsMultipleAccounts??!1),new d.$bK(()=>{y.dispose(),this.b.delete(w);const D=this.c.findIndex(v=>v.id===w);D>-1&&this.c.splice(D),this.a.$unregisterAuthenticationProvider(w)})}$createSession(w,R,I){const p=this.b.get(w);if(p)return Promise.resolve(p.provider.createSession(R,I));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$removeSession(w,R){const I=this.b.get(w);if(I)return Promise.resolve(I.provider.removeSession(R));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$getSessions(w,R){const I=this.b.get(w);if(I)return Promise.resolve(I.provider.getSessions(R));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$onDidChangeAuthenticationSessions(w,R){return this.d.fire({provider:{id:w,label:R}}),Promise.resolve()}}e.$ldc=A;class b{constructor(){this.a=new Map}getOrCreate(w,R){const I=this.a.get(w);if(I)return I;const p=R().finally(()=>this.a.delete(w));return this.a.set(w,p),p}}}),define(De[295],Ce([1,0,6,20,14]),function(me,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rdc=void 0;let M=class{constructor(b,E){this.a=b.getProxy(C.$_J.MainThreadBulkEdits),this.b={getTextDocumentVersion:w=>E.getDocument(w)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(b,E,w){const R=d.WorkspaceEdit.from(b,this.b);return this.a.$tryApplyWorkspaceEdit(R,void 0,w?.isRefactoring??!1)}};e.$rdc=M,e.$rdc=M=He([Be(0,T.$aM)],M)}),define(De[296],Ce([1,0,9,4,50,3,37,202,6,14]),function(me,e,C,T,d,M,A,b,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fdc=void 0;class R{static{this.a=0}constructor(y,D){this.extension=y,this.provider=D,this.handle=R.a++}}class I{static{this.a=0}constructor(y,D){this.h=D,this.b=new Map,this.d=new Map,this.e=new T.$Md,this.onDidPerformUserAction=this.e.event,this.g=y.getProxy(E.$_J.MainThreadChat)}registerChatProvider(y,D,v){const l=new R(y,v);return this.b.set(l.handle,l),this.g.$registerChatProvider(l.handle,D),(0,M.$Pc)(()=>{this.g.$unregisterChatProvider(l.handle),this.b.delete(l.handle)})}transferChatSession(y,D){const v=d.Iterable.find(this.d.keys(),l=>this.d.get(l)===y)??0;typeof v=="number"&&this.g.$transferChatSession(v,D)}sendInteractiveRequestToProvider(y,D){this.g.$sendRequestToProvider(y,D)}async $prepareChat(y,D,v){const l=this.b.get(y);if(!l)return;const s=await l.provider.prepareSession(D,v);if(!s)return;const r=I.a++;return this.d.set(r,s),{id:r,requesterUsername:s.requester?.name,requesterAvatarIconUri:s.requester?.icon,responderUsername:s.responder?.name,responderAvatarIconUri:s.responder?.icon,inputPlaceholder:s.inputPlaceholder}}async $provideWelcomeMessage(y,D){const v=this.b.get(y);if(!v||!v.provider.provideWelcomeMessage)return;const l=await v.provider.provideWelcomeMessage(D);if(l)return l.map(s=>typeof s=="string"?s:s.map(r=>w.ChatReplyFollowup.from(r)))}async $provideFollowups(y,D,v){const l=this.b.get(y);if(!l)return;const s=this.d.get(D);return!s||!l.provider.provideFollowups?void 0:(await l.provider.provideFollowups(s,v))?.map(c=>w.ChatFollowup.from(c))}$removeRequest(y,D,v){const l=this.b.get(y);if(!l)return;const s=this.d.get(D);s&&l.provider.removeRequest&&l.provider.removeRequest(s,v)}async $provideReply(y,D,v,l){const s=this.b.get(y);if(!s)return;const r=this.d.get(D);if(!r)return;const c={session:r,message:typeof v.message=="string"?v.message:w.ChatReplyFollowup.to(v.message),variables:{}};if(v.variables)for(const i of Object.keys(v.variables))c.variables[i]=v.variables[i].map(w.ChatVariable.to);const m=A.$Id.create(!1);let h;const t={report:i=>{if(l.isCancellationRequested)return;typeof h>"u"&&(h=m.elapsed());const a=w.ChatResponseProgress.from(i);if("placeholder"in i&&"resolvedContent"in i){const u=Promise.all([this.g.$acceptResponseProgress(y,D,a),i.resolvedContent]);(0,C.$Hg)(u,l).then(k=>{if(!k)return;const[S,$]=k;this.g.$acceptResponseProgress(y,D,$,S??void 0)})}else this.g.$acceptResponseProgress(y,D,a)}};let n;try{n=await s.provider.provideResponseWithProgress(c,t,l),n||(n={errorDetails:{message:(0,b.localize)(0,null)}})}catch(i){n={errorDetails:{message:(0,b.localize)(1,null,i.message),responseIsIncomplete:!0}},this.h.error(i)}try{if(r.saveState&&this.d.has(D)){const i=r.saveState();this.g.$acceptChatState(D,i)}}catch(i){this.h.warn(i)}const o={firstProgress:h??0,totalElapsed:m.elapsed()};return{errorDetails:n.errorDetails,timings:o}}async $provideSlashCommands(y,D,v){const l=this.b.get(y);if(!l)return;const s=this.d.get(D);return!s||!l.provider.provideSlashCommands?void 0:(await l.provider.provideSlashCommands(s,v))?.map(c=>({...c,kind:w.CompletionItemKind.from(c.kind)}))}$releaseSession(y){this.d.delete(y)}async $onDidPerformUserAction(y){this.e.fire(y)}}e.$Fdc=I}),define(De[297],Ce([1,0,9,3,84,6,14,7]),function(me,e,C,T,d,M,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Odc=void 0;class E{static{this.a=0}constructor(I,p,y){this.d=p,this.e=y,this.b=new Map,this.c=I.getProxy(M.$_J.MainThreadChatAgents)}registerAgent(I,p,y,D){const v=E.a++;return this.b.set(v,{extension:I,agent:y}),this.c.$registerAgent(v,p,D),(0,T.$Pc)(()=>{this.c.$unregisterAgent(v),this.b.delete(v)})}async $invokeAgent(I,p,y,D,v){const l=this.b.get(I);if(!l){this.e.warn(`[CHAT](${I}) CANNOT invoke agent because the agent is not registered`);return}let s=!1;function r(){if(s)throw new Error("Only valid while executing the command")}const c=new C.$bh;v.onCancellationRequested(()=>c.complete()),setTimeout(()=>c.complete(),10*1e3),this.d.allowListExtensionWhile(l.extension,c.p);const m=l.agent({role:b.ChatMessageRole.User,content:y},{history:D.history.map(A.ChatMessage.to)},new d.$Zu(h=>{r(),this.c.$handleProgressChunk(p,{content:w(h.message)?h.message:h.message.value})}),v);try{return await(0,C.$Hg)(Promise.resolve(m).then(h=>{if(h&&"followUp"in h)return{followUp:h?.followUp?.map(n=>A.ChatFollowup.from(n))}}),v)}finally{s=!0,c.complete()}}}e.$Odc=E;function w(R){return!!R&&typeof R=="object"&&"treeData"in R}}),define(De[298],Ce([1,0,3,6,14,84,25]),function(me,e,C,T,d,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kdc=void 0;class b{static{this.a=1}constructor(w,R){this.d=R,this.c=new Map,this.e=new Map,this.f=new A.$4l,this.b=w.getProxy(T.$_J.MainThreadChatProvider)}registerProvider(w,R,I,p){const y=b.a++;return this.c.set(y,{extension:w,provider:I}),this.b.$registerProvider(y,R,{extension:w,displayName:p.name??w.value}),(0,C.$Pc)(()=>{this.b.$unregisterProvider(y),this.c.delete(y)})}async $provideChatResponse(w,R,I,p,y){const D=this.c.get(w);if(!D)return;const v=new M.$Zu(async l=>{if(y.isCancellationRequested){this.d.warn(`[CHAT](${D.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}await this.b.$handleProgressChunk(R,{index:l.index,part:l.part})},{async:!0});return D.provider.provideChatResponse(I.map(d.ChatMessage.to),p,v,y)}allowListExtensionWhile(w,R){this.f.set(w,R),R.finally(()=>this.f.delete(w))}async requestChatResponseProvider(w,R){if(!this.f.has(w))throw new Error("Extension is NOT allowed to make chat requests");const I=this;return{get isRevoked(){return!I.f.has(w)},async makeRequest(p,y,D,v){if(!I.f.has(w))throw new Error("Access to chat has been revoked");const l=Math.random()*1e6|0;I.e.set(l,D);try{await I.b.$fetchResponse(w,R,l,p.map(d.ChatMessage.from),y,v)}finally{I.e.delete(l)}}}}async $handleResponseFragment(w,R){this.e.get(w)?.report(R)}}e.$Kdc=b}),define(De[299],Ce([1,0,3,6,8,14]),function(me,e,C,T,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ldc=void 0;class A{static{this.a=0}constructor(E){this.b=new Map,this.c=E.getProxy(T.$_J.MainThreadChatVariables)}async $resolveVariable(E,w,R){const I=this.b.get(E);if(I)try{const p=await I.resolver.resolve(I.data.name,{message:w},R);if(p)return p.map(M.ChatVariable.from)}catch(p){(0,d.$1)(p)}}registerVariableResolver(E,w,R,I){const p=A.a++;return this.b.set(p,{extension:E.identifier,data:{name:w,description:R},resolver:I}),this.c.$registerVariable(p,{name:w,description:R}),(0,C.$Pc)(()=>{this.b.delete(p),this.c.$unregisterVariable(p)})}}e.$Ldc=A}),define(De[300],Ce([1,0,6]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ubc=void 0;class T{constructor(M){const A=M.getProxy(C.$_J.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(b){return A.$writeText(b)}})}}e.$Ubc=T}),define(De[33],Ce([1,0,18,7,14,23,6,19,13,62,34,61,2,3,5,20,145,22,68,46,37,85,88]),function(me,e,C,T,d,M,A,b,E,w,R,I,p,y,D,v,l,s,r,c,m,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AM=e.$zM=e.$yM=e.$xM=e.$wM=e.$vM=void 0;let n=class{#e;#t;#i;constructor(S,$,g){this.b=new Map,this.c=new Map,this.#e=S.getProxy(A.$_J.MainThreadCommands),this.d=$,this.#i=g,this.#t=S.getProxy(A.$_J.MainThreadTelemetry),this.converter=new o(this,f=>{const P=this.c.get(f);return P?.result===a.Void?P:void 0},$),this.f=[{processArgument(f){return(0,w.$kh)(f)}},{processArgument(f){return(0,M.$4m)(f,function(P){if(R.$os.isIRange(P))return d.Range.to(P);if(I.$ns.isIPosition(P))return d.Position.to(P);if(R.$os.isIRange(P.range)&&p.URI.isUri(P.uri))return d.location.to(P);if(P instanceof s.$ae)return P.buffer.buffer;if(!Array.isArray(P))return P})}}]}registerArgumentProcessor(S){this.f.push(S)}registerApiCommand(S){const $=this.registerCommand(!1,S.id,async(...g)=>{const f=S.args.map((N,O)=>{if(!N.validate(g[O]))throw new Error(`Invalid argument '${N.name}' when running '${S.id}', received: ${typeof g[O]=="object"?JSON.stringify(g[O],null,"	"):g[O]} `);return N.convert(g[O])}),P=await this.executeCommand(S.internalId,...f);return S.result.convert(P,g,this.converter)},void 0,{description:S.description,args:S.args,returns:S.result.description});return this.c.set(S.id,S),new T.$bK(()=>{$.dispose(),this.c.delete(S.id)})}registerCommand(S,$,g,f,P,N){if(this.d.trace("ExtHostCommands#registerCommand",$),!$.trim().length)throw new Error("invalid id");if(this.b.has($))throw new Error(`command '${$}' already exists`);return this.b.set($,{callback:g,thisArg:f,metadata:P,extension:N}),S&&this.#e.$registerCommand($),new T.$bK(()=>{this.b.delete($)&&S&&this.#e.$unregisterCommand($)})}executeCommand(S,...$){return this.d.trace("ExtHostCommands#executeCommand",S),this.g(S,$,!0)}async g(S,$,g){if(this.b.has(S))return this.#e.$fireCommandActivationEvent(S),this.h(S,$,!1);{let f=!1;const P=(0,M.$4m)($,function(N){if(N instanceof T.$cK)return d.Position.from(N);if(N instanceof T.$dK)return d.Range.from(N);if(N instanceof T.$nK)return d.location.from(N);if(T.$yL.isNotebookRange(N))return d.NotebookRange.from(N);if(N instanceof ArrayBuffer)return f=!0,s.$ae.wrap(new Uint8Array(N));if(N instanceof Uint8Array)return f=!0,s.$ae.wrap(N);if(N instanceof s.$ae)return f=!0,N;if(!Array.isArray(N))return N});try{const N=await this.#e.$executeCommand(S,f?new r.$kv(P):P,g);return(0,w.$kh)(N)}catch(N){if(N instanceof Error&&N.message==="$executeCommand:retry")return this.g(S,$,!1);throw N}}}async h(S,$,g){const f=this.b.get(S);if(!f)throw new Error("Unknown command");const{callback:P,thisArg:N,metadata:O}=f;if(O?.args)for(let j=0;j<O.args.length;j++)try{(0,C.$Of)($[j],O.args[j].constraint)}catch{throw new Error(`Running the contributed command: '${S}' failed. Illegal argument '${O.args[j].name}' - ${O.args[j].description}`)}const L=m.$Id.create();try{return await P.apply(N,$)}catch(j){if(S===this.converter.delegatingCommandId){const z=this.converter.getActualCommand(...$);z&&(S=z.command)}if(this.d.error(j,S,f.extension?.identifier),!g)throw j;if(f.extension?.identifier){const z=this.#i.onExtensionError(f.extension.identifier,j);this.d.trace("forwarded error to extension?",z,f.extension?.identifier)}throw new class extends Error{constructor(){super((0,c.$yi)(j)),this.id=S,this.source=f.extension?.displayName??f.extension?.name}}}finally{this.j(f,S,L.elapsed())}}j(S,$,g){S.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:S.extension.identifier.value,id:new h.$fo($),duration:g})}$executeContributedCommand(S,...$){this.d.trace("ExtHostCommands#$executeContributedCommand",S);const g=this.b.get(S);return g?($=$.map(f=>this.f.reduce((P,N)=>N.processArgument(P,g.extension?.identifier),f)),this.h(S,$,!0)):Promise.reject(new Error(`Contributed command '${S}' does not exist.`))}getCommands(S=!1){return this.d.trace("ExtHostCommands#getCommands",S),this.#e.$getCommands().then($=>(S&&($=$.filter(g=>g[0]!=="_")),$))}$getContributedCommandMetadata(){const S=Object.create(null);for(const[$,g]of this.b){const{metadata:f}=g;f&&(S[$]=f)}return Promise.resolve(S)}};e.$vM=n,e.$vM=n=He([Be(0,v.$aM),Be(1,E.$8i),Be(2,t.$uM)],n),e.$wM=(0,D.$Nh)("IExtHostCommands");class o{constructor(S,$,g){this.d=S,this.f=$,this.g=g,this.delegatingCommandId=`__vsc${Date.now().toString(36)} `,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(S,$){if(!S)return;const g={$ident:void 0,id:S.command,title:S.title,tooltip:S.tooltip};if(!S.command)return g;const f=this.f(S.command);if(f)g.id=f.internalId,g.arguments=f.args.map((P,N)=>P.convert(S.arguments&&S.arguments[N]));else if((0,b.$Kb)(S.arguments)){const P=`${S.command} /${++this.c}`;this.b.set(P,S),$.add((0,y.$Pc)(()=>{this.b.delete(P),this.g.trace("CommandsConverter#DISPOSE",P)})),g.$ident=P,g.id=this.delegatingCommandId,g.arguments=[P],this.g.trace("CommandsConverter#CREATE",S.command,P)}return g}fromInternal(S){return typeof S.$ident=="string"?this.b.get(S.$ident):{command:S.id,title:S.title,arguments:S.arguments}}getActualCommand(...S){return this.b.get(S[0])}h(...S){const $=this.getActualCommand(...S);return this.g.trace("CommandsConverter#EXECUTE",S[0],$?$.command:"MISSING"),$?this.d.executeCommand($.command,...$.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${S[0]}`)}}e.$xM=o;class i{static{this.Uri=new i("uri","Uri of a text document",S=>p.URI.isUri(S),S=>S)}static{this.Position=new i("position","A position in a text document",S=>T.$cK.isPosition(S),d.Position.from)}static{this.Range=new i("range","A range in a text document",S=>T.$dK.isRange(S),d.Range.from)}static{this.Selection=new i("selection","A selection in a text document",S=>T.$eK.isSelection(S),d.Selection.from)}static{this.Number=new i("number","",S=>typeof S=="number",S=>S)}static{this.String=new i("string","",S=>typeof S=="string",S=>S)}static{this.StringArray=i.Arr(i.String)}static Arr(S){return new i(`${S.name}_array`,`Array of ${S.name}, ${S.description}`,$=>Array.isArray($)&&$.every(g=>S.validate(g)),$=>$.map(g=>S.convert(g)))}static{this.CallHierarchyItem=new i("item","A call hierarchy item",S=>S instanceof T.$xK,d.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new i("item","A type hierarchy item",S=>S instanceof T.$RL,d.TypeHierarchyItem.from)}static{this.TestItem=new i("testItem","A VS Code TestItem",S=>S instanceof l.$nM,d.TestItem.from)}constructor(S,$,g,f){this.name=S,this.description=$,this.validate=g,this.convert=f}optional(){return new i(this.name,`(optional) ${this.description}`,S=>S==null||this.validate(S),S=>S===void 0?void 0:S===null?null:this.convert(S))}with(S,$){return new i(S??this.name,$??this.description,this.validate,this.convert)}}e.$yM=i;class a{static{this.Void=new a("no result",S=>S)}constructor(S,$){this.description=S,this.convert=$}}e.$zM=a;class u{constructor(S,$,g,f,P){this.id=S,this.internalId=$,this.description=g,this.args=f,this.result=P}}e.$AM=u}),define(De[301],Ce([1,0,19,17,2,82,129,41,134,33,14,7]),function(me,e,C,T,d,M,A,b,E,w,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tbc=void 0;const p=[new w.$AM("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[w.$yM.Uri,w.$yM.Position],new w.$zM("A promise that resolves to an array of DocumentHighlight-instances.",D(R.DocumentHighlight.to))),new w.$AM("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[w.$yM.Uri],new w.$zM("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(l,s)=>{if((0,C.$Jb)(l))return;class r extends I.$sK{static to(m){const h=new r(m.name,R.SymbolKind.to(m.kind),m.containerName||"",new I.$nK(s[0],R.Range.to(m.range)));return h.detail=m.detail,h.range=h.location.range,h.selectionRange=R.Range.to(m.selectionRange),h.children=m.children?m.children.map(r.to):[],h}}return l.map(r.to)})),new w.$AM("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[w.$yM.Uri,new w.$yM("options","Formatting options",l=>!0,l=>l)],new w.$zM("A promise that resolves to an array of TextEdits.",D(R.TextEdit.to))),new w.$AM("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[w.$yM.Uri,w.$yM.Range,new w.$yM("options","Formatting options",l=>!0,l=>l)],new w.$zM("A promise that resolves to an array of TextEdits.",D(R.TextEdit.to))),new w.$AM("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[w.$yM.Uri,w.$yM.Position,new w.$yM("ch","Trigger character",l=>typeof l=="string",l=>l),new w.$yM("options","Formatting options",l=>!0,l=>l)],new w.$zM("A promise that resolves to an array of TextEdits.",D(R.TextEdit.to))),new w.$AM("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[w.$yM.Uri,w.$yM.Position],new w.$zM("A promise that resolves to an array of Location or LocationLink instances.",v)),new w.$AM("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[w.$yM.Uri,w.$yM.Position],new w.$zM("A promise that resolves to an array of Location or LocationLink instances.",v)),new w.$AM("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[w.$yM.Uri,w.$yM.Position],new w.$zM("A promise that resolves to an array of Location or LocationLink instances.",v)),new w.$AM("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[w.$yM.Uri,w.$yM.Position],new w.$zM("A promise that resolves to an array of Location or LocationLink instances.",v)),new w.$AM("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[w.$yM.Uri,w.$yM.Position],new w.$zM("A promise that resolves to an array of Location-instances.",D(R.location.to))),new w.$AM("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[w.$yM.Uri,w.$yM.Position],new w.$zM("A promise that resolves to an array of Hover-instances.",D(R.Hover.to))),new w.$AM("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[w.$yM.Uri,new w.$yM("position","A position in a text document",l=>Array.isArray(l)&&l.every(s=>I.$cK.isPosition(s)),l=>l.map(R.Position.from))],new w.$zM("A promise that resolves to an array of ranges.",l=>l.map(s=>{let r;for(const c of s.reverse())r=new I.$wK(R.Range.to(c),r);return r}))),new w.$AM("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[w.$yM.String.with("query","Search string")],new w.$zM("A promise that resolves to an array of SymbolInformation-instances.",l=>l.map(R.WorkspaceSymbol.to))),new w.$AM("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[w.$yM.Uri,w.$yM.Position],new w.$zM("A promise that resolves to an array of CallHierarchyItem-instances",l=>l.map(R.CallHierarchyItem.to))),new w.$AM("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[w.$yM.CallHierarchyItem],new w.$zM("A promise that resolves to an array of CallHierarchyIncomingCall-instances",l=>l.map(R.CallHierarchyIncomingCall.to))),new w.$AM("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[w.$yM.CallHierarchyItem],new w.$zM("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",l=>l.map(R.CallHierarchyOutgoingCall.to))),new w.$AM("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[w.$yM.Uri,w.$yM.Position],new w.$zM("A promise that resolves to a range and placeholder text.",l=>{if(l)return{range:R.Range.to(l.range),placeholder:l.text}})),new w.$AM("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[w.$yM.Uri,w.$yM.Position,w.$yM.String.with("newName","The new symbol name")],new w.$zM("A promise that resolves to a WorkspaceEdit.",l=>{if(l){if(l.rejectReason)throw new Error(l.rejectReason);return R.WorkspaceEdit.to(l)}})),new w.$AM("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[w.$yM.Uri,w.$yM.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new w.$zM("A promise that resolves to an array of DocumentLink-instances.",l=>l.map(R.DocumentLink.to))),new w.$AM("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[w.$yM.Uri],new w.$zM("A promise that resolves to SemanticTokensLegend.",l=>{if(l)return new I.$qL(l.tokenTypes,l.tokenModifiers)})),new w.$AM("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[w.$yM.Uri],new w.$zM("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const s=(0,A.$Q0)(l);if(s.type==="full")return new I.$sL(s.data,void 0)})),new w.$AM("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[w.$yM.Uri,w.$yM.Range.optional()],new w.$zM("A promise that resolves to SemanticTokensLegend.",l=>{if(l)return new I.$qL(l.tokenTypes,l.tokenModifiers)})),new w.$AM("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[w.$yM.Uri,w.$yM.Range],new w.$zM("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const s=(0,A.$Q0)(l);if(s.type==="full")return new I.$sL(s.data,void 0)})),new w.$AM("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[w.$yM.Uri,w.$yM.Position,w.$yM.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),w.$yM.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new w.$zM("A promise that resolves to a CompletionList-instance.",(l,s,r)=>{if(!l)return new I.$IK([]);const c=l.suggestions.map(m=>R.CompletionItem.to(m,r));return new I.$IK(c,l.incomplete)})),new w.$AM("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[w.$yM.Uri,w.$yM.Position,w.$yM.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new w.$zM("A promise that resolves to SignatureHelp.",l=>{if(l)return R.SignatureHelp.to(l)})),new w.$AM("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[w.$yM.Uri,w.$yM.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new w.$zM("A promise that resolves to an array of CodeLens-instances.",(l,s,r)=>D(c=>new I.$AK(R.Range.to(c.range),c.command&&r.fromInternal(c.command)))(l))),new w.$AM("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[w.$yM.Uri,new w.$yM("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",l=>I.$dK.isRange(l),l=>I.$eK.isSelection(l)?R.Selection.from(l):R.Range.from(l)),w.$yM.String.with("kind","Code action kind to return code actions for").optional(),w.$yM.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new w.$zM("A promise that resolves to an array of Command-instances.",(l,s,r)=>D(c=>{if(c._isSynthetic){if(!c.command)throw new Error("Synthetic code actions must have a command");return r.fromInternal(c.command)}else{const m=new I.$uK(c.title,c.kind?new I.$vK(c.kind):void 0);return c.edit&&(m.edit=R.WorkspaceEdit.to(c.edit)),c.command&&(m.command=r.fromInternal(c.command)),m.isPreferred=c.isPreferred,m}})(l))),new w.$AM("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[w.$yM.Uri],new w.$zM("A promise that resolves to an array of ColorInformation objects.",l=>l?l.map(s=>new I.$OK(R.Range.to(s.range),R.Color.to(s.color))):[])),new w.$AM("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new w.$yM("color","The color to show and insert",l=>l instanceof I.$NK,R.Color.from),new w.$yM("context","Context object with uri and range",l=>!0,l=>({uri:l.uri,range:R.Range.from(l.range)}))],new w.$zM("A promise that resolves to an array of ColorPresentation objects.",l=>l?l.map(R.ColorPresentation.to):[])),new w.$AM("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[w.$yM.Uri,w.$yM.Range],new w.$zM("A promise that resolves to an array of Inlay objects",(l,s,r)=>l.map(R.InlayHint.to.bind(void 0,r)))),new w.$AM("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[w.$yM.Uri],new w.$zM("A promise that resolves to an array of FoldingRange objects",(l,s)=>{if(l)return l.map(R.FoldingRange.to)})),new w.$AM("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new w.$zM("A promise that resolves to an array of NotebookContentProvider static info objects.",D(l=>({viewType:l.viewType,displayName:l.displayName,options:{transientOutputs:l.options.transientOutputs,transientCellMetadata:l.options.transientCellMetadata,transientDocumentMetadata:l.options.transientDocumentMetadata},filenamePattern:l.filenamePattern.map(s=>R.NotebookExclusiveDocumentPattern.to(s))})))),new w.$AM("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[w.$yM.Uri,w.$yM.Range,new w.$yM("context","An InlineValueContext",l=>l&&typeof l.frameId=="number"&&l.stoppedLocation instanceof I.$dK,l=>R.InlineValueContext.from(l))],new w.$zM("A promise that resolves to an array of InlineValue objects",l=>l.map(R.InlineValue.to))),new w.$AM("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new w.$yM("uriOrString","Uri-instance or string (only http/https)",l=>d.URI.isUri(l)||typeof l=="string"&&(0,E.$0T)(l,T.Schemas.http,T.Schemas.https),l=>l),new w.$yM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[R.ViewColumn.from(l),void 0]:[R.ViewColumn.from(l.viewColumn),R.TextEditorOpenOptions.from(l)])).optional(),w.$yM.String.with("label","").optional()],w.$zM.Void),new w.$AM("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[w.$yM.Uri.with("resource","Resource to open"),w.$yM.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new w.$yM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[R.ViewColumn.from(l),void 0]:[R.ViewColumn.from(l.viewColumn),R.TextEditorOpenOptions.from(l)])).optional()],w.$zM.Void),new w.$AM("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[w.$yM.Uri.with("left","Left-hand side resource of the diff editor"),w.$yM.Uri.with("right","Right-hand side resource of the diff editor"),w.$yM.String.with("title","Human readable title for the diff editor").optional(),new w.$yM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="object",l=>l&&[R.ViewColumn.from(l.viewColumn),R.TextEditorOpenOptions.from(l)]).optional()],w.$zM.Void),new w.$AM("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[w.$yM.Uri,w.$yM.Position],new w.$zM("A promise that resolves to an array of TypeHierarchyItem-instances",l=>l.map(R.TypeHierarchyItem.to))),new w.$AM("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[w.$yM.TypeHierarchyItem],new w.$zM("A promise that resolves to an array of TypeHierarchyItem-instances",l=>l.map(R.TypeHierarchyItem.to))),new w.$AM("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[w.$yM.TypeHierarchyItem],new w.$zM("A promise that resolves to an array of TypeHierarchyItem-instances",l=>l.map(R.TypeHierarchyItem.to))),new w.$AM("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[w.$yM.TestItem],w.$zM.Void),new w.$AM("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[w.$yM.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],w.$zM.Void),new w.$AM("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[w.$yM.String.with("name","The context key name"),new w.$yM("value","The context key value",()=>!0,l=>l)],w.$zM.Void),new w.$AM("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[w.$yM.Uri,w.$yM.StringArray,new w.$yM("MappedEditsContext","Mapped Edits Context",l=>R.MappedEditsContext.is(l),l=>R.MappedEditsContext.from(l))],new w.$zM("A promise that resolves to a workspace edit or null",l=>l?R.WorkspaceEdit.to(l):null))];class y{static register(s){p.forEach(s.registerApiCommand,s),this.a(s)}static a(s){s.registerCommand(!1,"_validateWhenClauses",b.$Mi)}}e.$Tbc=y;function D(l){return s=>{if(Array.isArray(s))return s.map(l)}}function v(l){if(!Array.isArray(l))return;const s=[];for(const r of l)M.$_s(r)?s.push(R.DefinitionLink.to(r)):s.push(R.location.to(r));return s}}),define(De[302],Ce([1,0,9,57,4,3,2,82,25,14,7,6,26]),function(me,e,C,T,d,M,A,b,E,w,R,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vbc=void 0;function y(D,v,l){const s=D.getProxy(I.$_J.MainThreadComments);class r{static{this.a=0}constructor(){this.b=new Map,this.c=new E.$4l,v.registerArgumentProcessor({processArgument:u=>{if(u&&u.$mid===6){const k=this.b.get(u.handle);return k?k.value:u}else if(u&&u.$mid===7){const k=this.b.get(u.commentControlHandle);if(!k)return u;const S=k.getCommentThread(u.commentThreadHandle);return S?S.value:u}else if(u&&(u.$mid===9||u.$mid===8)){const k=this.b.get(u.thread.commentControlHandle);if(!k)return u;const S=k.getCommentThread(u.thread.commentThreadHandle);return S?u.$mid===8?S.value:{thread:S.value,text:u.text}:u}else if(u&&u.$mid===10){const k=this.b.get(u.thread.commentControlHandle);if(!k)return u;const S=k.getCommentThread(u.thread.commentThreadHandle);if(!S)return u;const $=u.commentUniqueId,g=S.getCommentByUniqueId($);return g||u}else if(u&&u.$mid===11){const k=this.b.get(u.thread.commentControlHandle);if(!k)return u;const S=k.getCommentThread(u.thread.commentThreadHandle);if(!S)return u;const $=u.text,g=u.commentUniqueId,f=S.getCommentByUniqueId(g);return f?(typeof f.body=="string"?f.body=$:f.body=new R.$BK($),f):u}return u}})}createCommentController(u,k,S){const $=r.a++,g=new m(u,$,k,S);this.b.set(g.handle,g);const f=this.c.get(u.identifier)||[];return f.push(g),this.c.set(u.identifier,f),g.value}$createCommentThreadTemplate(u,k,S){const $=this.b.get(u);$&&$.$createCommentThreadTemplate(k,S)}async $updateCommentThreadTemplate(u,k,S){const $=this.b.get(u);$&&$.$updateCommentThreadTemplate(k,S)}$deleteCommentThread(u,k){this.b.get(u)?.$deleteCommentThread(k)}$provideCommentingRanges(u,k,S){const $=this.b.get(u);if(!$||!$.commentingRangeProvider)return Promise.resolve(void 0);const g=l.getDocument(A.URI.revive(k));return(0,C.$Lg)(async()=>{const f=await $.commentingRangeProvider.provideCommentingRanges(g,S);let P;return Array.isArray(f)?P={ranges:f,fileComments:!1}:f?P={ranges:f.ranges||[],fileComments:f.fileComments||!1}:P=f??void 0,P}).then(f=>{let P;return f&&(P={ranges:f.ranges.map(N=>w.Range.from(N)),fileComments:f.fileComments}),P})}$toggleReaction(u,k,S,$,g){const f=this.b.get(u);return!f||!f.reactionHandler?Promise.resolve(void 0):(0,C.$Lg)(()=>{const P=f.getCommentThread(k);if(P){const N=P.getCommentByUniqueId($.uniqueIdInThread);if(f!==void 0&&N&&f.reactionHandler)return f.reactionHandler(N,n(g))}return Promise.resolve(void 0)})}}class c{static{this.a=0}set threadId(u){this.n=u}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(u){(u===void 0!=(this.p===void 0)||!u||!this.p||!u.isEqual(this.p))&&(this.p=u,this.b.range=u,this.c.fire())}get range(){return this.p}set canReply(u){this.d!==u&&(this.d=u,this.b.canReply=u,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(u){this.e=u,this.b.label=u,this.c.fire()}get contextValue(){return this.f}set contextValue(u){this.f=u,this.b.contextValue=u,this.c.fire()}get comments(){return this.q}set comments(u){this.q=u,this.b.comments=u,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(u){this.g=u,this.b.collapsibleState=u,this.c.fire()}get state(){return this.h}set state(u){this.h=u,this.b.state=u,this.c.fire()}get isDisposed(){return this.j}constructor(u,k,S,$,g,f,P,N){this.m=k,this.n=S,this.o=$,this.p=g,this.q=f,this.extensionDescription=P,this.r=N,this.handle=c.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new d.$Md,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new M.$Sc,this.l.value=new M.$Qc,this.n===void 0&&(this.n=`${u}.${this.handle}`),s.$createCommentThread(k,this.handle,this.n,this.o,w.Range.from(this.p),P.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=f,this.i.push({dispose:()=>{s.$deleteCommentThread(k,this.handle)}});const O=this;this.value={get uri(){return O.uri},get range(){return O.range},set range(L){O.range=L},get comments(){return O.comments},set comments(L){O.comments=L},get collapsibleState(){return O.collapsibleState},set collapsibleState(L){O.collapsibleState=L},get canReply(){return O.canReply},set canReply(L){O.canReply=L},get contextValue(){return O.contextValue},set contextValue(L){O.contextValue=L},get label(){return O.label},set label(L){O.label=L},get state(){return O.state},set state(L){O.state=L},dispose:()=>{O.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new M.$Qc);const u=S=>Object.prototype.hasOwnProperty.call(this.b,S),k={};u("range")&&(k.range=w.Range.from(this.p)),u("label")&&(k.label=this.label),u("contextValue")&&(k.contextValue=this.contextValue??null),u("comments")&&(k.comments=this.q.map(S=>h(this,S,this.k,this.extensionDescription))),u("collapsibleState")&&(k.collapseState=o(this.g)),u("canReply")&&(k.canReply=this.canReply),u("state")&&(k.state=i(this.h)),u("isTemplate")&&(k.isTemplate=this.r),this.b={},s.$updateCommentThread(this.m,this.handle,this.n,this.o,k)}getCommentByUniqueId(u){for(const k of this.k){const S=k[0],$=k[1];if(u===$)return S}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(u=>u.dispose())}}He([(0,T.$gh)(100)],c.prototype,"eventuallyUpdateCommentThread",null);class m{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(u){this.b=u,s.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(u){this.c=u,s.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!u})}get options(){return this.d}set options(u){this.d=u,s.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(u,k,S,$){this.f=u,this.g=k,this.h=S,this.i=$,this.a=new Map,s.$registerCommentController(this.handle,S,$,this.f.identifier.value);const g=this;this.value=Object.freeze({id:g.id,label:g.label,get options(){return g.options},set options(f){g.options=f},get commentingRangeProvider(){return g.commentingRangeProvider},set commentingRangeProvider(f){g.commentingRangeProvider=f},get reactionHandler(){return g.reactionHandler},set reactionHandler(f){g.reactionHandler=f},createCommentThread(f,P,N){return g.createCommentThread(f,P,N).value},dispose:()=>{g.dispose()}}),this.e=[],this.e.push({dispose:()=>{s.$unregisterCommentController(this.handle)}})}createCommentThread(u,k,S){k===void 0&&(0,p.$_E)(this.f,"fileComments");const $=new c(this.id,this.handle,void 0,u,k,S,this.f,!1);return this.a.set($.handle,$),$}$createCommentThreadTemplate(u,k){const S=new c(this.id,this.handle,void 0,A.URI.revive(u),w.Range.to(k),[],this.f,!0);return S.collapsibleState=b.CommentThreadCollapsibleState.Expanded,this.a.set(S.handle,S),S}$updateCommentThreadTemplate(u,k){const S=this.a.get(u);S&&(S.range=w.Range.to(k))}$deleteCommentThread(u){this.a.get(u)?.dispose(),this.a.delete(u)}getCommentThread(u){return this.a.get(u)}dispose(){this.a.forEach(u=>{u.dispose()}),this.e.forEach(u=>u.dispose())}}function h(a,u,k,S){let $=k.get(u);return $||($=++a.commentHandle,k.set(u,$)),u.state!==void 0&&(0,p.$_E)(S,"commentsDraftState"),{mode:u.mode,contextValue:u.contextValue,uniqueIdInThread:$,body:typeof u.body=="string"?u.body:w.MarkdownString.from(u.body),userName:u.author.name,userIconPath:u.author.iconPath,label:u.label,commentReactions:u.reactions?u.reactions.map(g=>t(g)):void 0,state:u.state,timestamp:u.timestamp?.toJSON()}}function t(a){return{label:a.label,iconPath:a.iconPath?w.$_L(a.iconPath):void 0,count:a.count,hasReacted:a.authorHasReacted}}function n(a){return{label:a.label||"",count:a.count||0,iconPath:a.iconPath?A.URI.revive(a.iconPath):"",authorHasReacted:a.hasReacted||!1}}function o(a){if(a!==void 0)switch(a){case R.CommentThreadCollapsibleState.Expanded:return b.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return b.CommentThreadCollapsibleState.Collapsed}return b.CommentThreadCollapsibleState.Collapsed}function i(a){if(a!==void 0)switch(a){case R.CommentThreadState.Unresolved:return b.CommentThreadState.Unresolved;case R.CommentThreadState.Resolved:return b.CommentThreadState.Resolved}return b.CommentThreadState.Unresolved}return new r}e.$Vbc=y}),define(De[303],Ce([1,0,23,6,27,20]),function(me,e,C,T,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rdc=void 0;let A=class{constructor(R,I){this.a=R.getProxy(T.$_J.MainThreadConsole),this.b=I.consoleForward.includeStack,this.c=I.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(R,I){const p=this,y=console[R];Object.defineProperty(console,R,{set:()=>{},get:()=>function(){p.e(R,I,y,arguments)}})}e(R,I,p,y){this.a.$logExtensionHostMessage({type:"__$console",severity:I,arguments:E(y,this.b)}),this.c&&this.f(R,p,y)}};e.$Rdc=A,e.$Rdc=A=He([Be(0,M.$aM),Be(1,d.$qM)],A);const b=1e5;function E(w,R){const I=[];if(w.length)for(let p=0;p<w.length;p++){let y=w[p];if(typeof y>"u")y="undefined";else if(y instanceof Error){const D=y;D.stack?y=D.stack:y=D.toString()}I.push(y)}if(R){const p=new Error().stack;p&&I.push({__$stack:p.split(`
`).slice(3).join(`
`)})}try{const p=(0,C.$7m)(I);return p.length>b?"Output omitted for a large object that exceeds the limits":p}catch(p){return`Output omitted for an object that cannot be inspected ('${p.toString()}')`}}}),define(De[149],Ce([1,0,2,6,7,5,20,13,19,15,16,26]),function(me,e,C,T,d,M,A,b,E,w,R,I){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$Xcc=e.$Wcc=void 0;let y=class{static{p=this}static{this.c=0}static{this.d=250}constructor(v,l){this.h=l,this.f=new Map,this.g=v.getProxy(T.$_J.MainThreadDecorations)}registerFileDecorationProvider(v,l){const s=p.c++;this.f.set(s,{provider:v,extensionDescription:l}),this.g.$registerDecorationProvider(s,l.identifier.value);const r=v.onDidChangeFileDecorations&&v.onDidChangeFileDecorations(c=>{if(!c){this.g.$onDidChange(s,null);return}const m=(0,E.$2b)(c);if(m.length<=p.d){this.g.$onDidChange(s,m);return}this.h.warn("[Decorations] CAPPING events from decorations provider",l.identifier.value,m.length);const h=m.map(o=>({uri:o,rank:(0,w.$Fe)(o.path,"/")})),t=(0,E.$yb)(h,(o,i)=>o.rank-i.rank||(0,w.$Te)(o.uri.path,i.uri.path)),n=[];e:for(const o of t){let i;for(const a of o){const u=(0,R.$lc)(a.uri.path);if(i!==u&&(i=u,n.push(a.uri)>=p.d))break e}}this.g.$onDidChange(s,n)});return new d.$bK(()=>{r?.dispose(),this.g.$unregisterDecorationProvider(s),this.f.delete(s)})}async $provideDecorations(v,l,s){if(!this.f.has(v))return Object.create(null);const r=Object.create(null),{provider:c,extensionDescription:m}=this.f.get(v);return await Promise.all(l.map(async h=>{try{const{uri:t,id:n}=h,o=await Promise.resolve(c.provideFileDecoration(C.URI.revive(t),s));if(!o)return;try{d.$wL.validate(o),o.badge&&typeof o.badge!="string"&&(0,I.$_E)(m,"codiconDecoration"),r[n]=[o.propagate,o.tooltip,o.badge,o.color]}catch(i){this.h.warn(`INVALID decoration from extension '${m.identifier.value}': ${i}`)}}catch(t){this.h.error(t)}})),r}};e.$Wcc=y,e.$Wcc=y=p=He([Be(0,A.$aM),Be(1,b.$8i)],y),e.$Xcc=(0,M.$Nh)("IExtHostDecorations")}),define(De[304],Ce([1,0,203,133,2,6,7,14,4,13,28,55]),function(me,e,C,T,d,M,A,b,E,w,R,I){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$Obc=e.$Nbc=void 0;class y{#e;#t;#i;constructor(l,s,r,c,m,h,t,n){this.d=l,this.e=s,this.f=r,this.g=c,this.h=m,this.c=!1,this.f=Math.max(c,r),this.#i=new R.$zc(o=>h.getComparisonKey(o)),this.#e=t,this.#t=n}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(l,s){if(!l){this.clear();return}this.j();let r=[];if(d.URI.isUri(l)){if(!s){this.delete(l);return}this.#i.set(l,s.slice()),r=[l]}else if(Array.isArray(l)){r=[];let h;l=[...l].sort(y.k);for(const t of l){const[n,o]=t;if((!h||n.toString()!==h.toString())&&(h&&this.#i.get(h).length===0&&this.#i.delete(h),h=n,r.push(n),this.#i.set(n,[])),o)this.#i.get(n)?.push(...o);else{const i=this.#i.get(n);i&&(i.length=0)}}}if(this.#t.fire(r),!this.#e)return;const c=[];let m=0;for(const h of r){let t=[];const n=this.#i.get(h);if(n)if(n.length>this.g){t=[];const o=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let i=0;i<4;i++)for(const a of n)if(a.severity===o[i]&&t.push({...b.Diagnostic.from(a),modelVersionId:this.h(h)})===this.g)break e;t.push({severity:T.MarkerSeverity.Info,message:(0,C.localize)(0,null,n.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=n.map(o=>({...b.Diagnostic.from(o),modelVersionId:this.h(h)}));if(c.push([h,t]),m+=t.length,m>this.f)break}this.#e.$changeMany(this.e,c)}delete(l){this.j(),this.#t.fire([l]),this.#i.delete(l),this.#e?.$changeMany(this.e,[[l,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(l,s){this.j();for(const[r,c]of this)l.call(s,r,c,this)}*[Symbol.iterator](){this.j();for(const l of this.#i.keys())yield[l,this.get(l)]}get(l){this.j();const s=this.#i.get(l);return Array.isArray(s)?Object.freeze(s.slice(0)):[]}has(l){return this.j(),Array.isArray(this.#i.get(l))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(l,s){return l[0].toString()<s[0].toString()?-1:l[0].toString()>s[0].toString()?1:0}}e.$Nbc=y;let D=class{static{p=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*p.d}static _mapper(l){const s=new R.$zc;for(const r of l)s.set(r,r);return{uris:Object.freeze(Array.from(s.values()))}}constructor(l,s,r,c){this.j=s,this.k=r,this.l=c,this.g=new Map,this.h=new E.$Qd({merge:m=>m.flat(),delay:50}),this.onDidChangeDiagnostics=E.Event.map(this.h.event,p._mapper),this.f=l.getProxy(M.$_J.MainThreadDiagnostics)}createDiagnosticCollection(l,s){const{g:r,f:c,h:m,j:h,k:t,l:n}=this,o=new class{$changeMany(u,k){c.$changeMany(u,k),h.trace("[DiagnosticCollection] change many (extension, owner, uris)",l.value,u,k.length===0?"CLEARING":k)}$clear(u){c.$clear(u),h.trace("[DiagnosticCollection] remove all (extension, owner)",l.value,u)}dispose(){c.dispose()}};let i;if(!s)s="_generated_diagnostic_collection_name_#"+p.c++,i=s;else if(!r.has(s))i=s;else{this.j.warn(`DiagnosticCollection with name '${s}' does already exist.`);do i=s+p.c++;while(r.has(i))}return new class extends y{constructor(){super(s,i,p.e,p.d,u=>n.getDocument(u)?.version,t.extUri,o,m),r.set(i,this)}dispose(){super.dispose(),r.delete(i)}}}getDiagnostics(l){if(l)return this.m(l);{const s=new Map,r=[];for(const c of this.g.values())c.forEach((m,h)=>{let t=s.get(m.toString());typeof t>"u"&&(t=r.length,s.set(m.toString(),t),r.push([m,[]])),r[t][1]=r[t][1].concat(...h)});return r}}m(l){let s=[];for(const r of this.g.values())r.has(l)&&(s=s.concat(r.get(l)));return s}$acceptMarkersChange(l){if(!this.n){const s="_generated_mirror",r=new y(s,s,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,c=>{},this.k.extUri,void 0,this.h);this.g.set(s,r),this.n=r}for(const[s,r]of l)this.n.set(d.URI.revive(s),r.map(b.Diagnostic.to))}};e.$Obc=D,e.$Obc=D=p=He([Be(1,w.$8i),Be(2,I.$Mbc)],D)}),define(De[305],Ce([1,0,2,6,26]),function(me,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4bc=void 0;class M{constructor(b){this.a=b.getProxy(T.$_J.MainThreadDialogs)}showOpenDialog(b,E){return E?.allowUIResources&&(0,d.$_E)(b,"showLocal"),this.a.$showOpenDialog(E).then(w=>w?w.map(R=>C.URI.revive(R)):void 0)}showSaveDialog(b){return this.a.$showSaveDialog(b).then(E=>E?C.URI.revive(E):void 0)}}e.$4bc=M}),define(De[306],Ce([1,0,8,2,7,6,17,21,15]),function(me,e,C,T,d,M,A,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5bc=void 0;class w{static{this.a=0}constructor(I,p,y){this.d=p,this.e=y,this.b=new Map,this.c=I.getProxy(M.$_J.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,p){if(Object.keys(A.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const y=w.a++;this.b.set(y,p),this.c.$registerTextContentProvider(y,I);let D;return typeof p.onDidChange=="function"&&(D=p.onDidChange(v=>{if(v.scheme!==I){this.e.warn(`Provider for scheme '${I}' is firing event for schema '${v.scheme}' which will be IGNORED`);return}this.d.getDocument(v)&&this.$provideTextDocumentContent(y,v).then(l=>{if(!l&&typeof l!="string")return;const s=this.d.getDocument(v);if(!s)return;const r=(0,E.$Oe)(l);if(!s.equalLines(r))return this.c.$onVirtualDocumentChange(v,l)},C.$Z)})),new d.$bK(()=>{this.b.delete(y)&&this.c.$unregisterTextContentProvider(y),D&&(D.dispose(),D=void 0)})}$provideTextDocumentContent(I,p){const y=this.b.get(I);return y?Promise.resolve(y.provideTextDocumentContent(T.URI.revive(p),b.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${p.scheme}`))}}e.$5bc=w}),define(De[307],Ce([1,0,4,3,2,6,141,14,18,23,7,8]),function(me,e,C,T,d,M,A,b,E,w,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kbc=void 0;class p{constructor(D,v){this.a=new C.$Md({onListenerError:I.$1}),this.b=new C.$Md({onListenerError:I.$1}),this.c=new C.$Md({onListenerError:I.$1}),this.d=new C.$Md({onListenerError:I.$1}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new T.$Qc,this.h=new Map,this.f=D.getProxy(M.$_J.MainThreadDocuments),this.g=v,this.g.onDidRemoveDocuments(l=>{for(const s of l)this.b.fire(s.document)},void 0,this.e),this.g.onDidAddDocuments(l=>{for(const s of l)this.a.fire(s.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(D){if(!D)return;const v=this.g.getDocument(D);if(v)return v}getDocument(D){const v=this.getDocumentData(D);if(!v?.document)throw new Error(`Unable to retrieve document from URI '${D}'`);return v.document}ensureDocumentData(D){const v=this.g.getDocument(D);if(v)return Promise.resolve(v);let l=this.h.get(D.toString());return l||(l=this.f.$tryOpenDocument(D).then(s=>{this.h.delete(D.toString());const r=d.URI.revive(s);return(0,E.$If)(this.g.getDocument(r))},s=>(this.h.delete(D.toString()),Promise.reject(s))),this.h.set(D.toString(),l)),l}createDocumentData(D){return this.f.$tryCreateDocument(D).then(v=>d.URI.revive(v))}$acceptModelLanguageChanged(D,v){const l=d.URI.revive(D),s=this.g.getDocument(l);if(!s)throw new Error("unknown document");this.b.fire(s.document),s._acceptLanguageId(v),this.a.fire(s.document)}$acceptModelSaved(D){const v=d.URI.revive(D),l=this.g.getDocument(v);if(!l)throw new Error("unknown document");this.$acceptDirtyStateChanged(D,!1),this.d.fire(l.document)}$acceptDirtyStateChanged(D,v){const l=d.URI.revive(D),s=this.g.getDocument(l);if(!s)throw new Error("unknown document");s._acceptIsDirty(v),this.c.fire({document:s.document,contentChanges:[],reason:void 0})}$acceptModelChanged(D,v,l){const s=d.URI.revive(D),r=this.g.getDocument(s);if(!r)throw new Error("unknown document");r._acceptIsDirty(l),r.onEvents(v);let c;v.isUndoing?c=R.TextDocumentChangeReason.Undo:v.isRedoing&&(c=R.TextDocumentChangeReason.Redo),this.c.fire((0,w.$3m)({document:r.document,contentChanges:v.changes.map(m=>({range:b.Range.to(m.range),rangeOffset:m.rangeOffset,rangeLength:m.rangeLength,text:m.text})),reason:c}))}setWordDefinitionFor(D,v){(0,A.$cM)(D,v)}}e.$Kbc=p}),define(De[69],Ce([1,0,58,4,3,2,5,6,141,20,146,14,13,28,17,50,51]),function(me,e,C,T,d,M,A,b,E,w,R,I,p,y,D,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lM=e.$kM=void 0;class s{constructor(m){this.value=m,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let r=class{constructor(m,h){this.h=m,this.i=h,this.a=null,this.b=new Map,this.c=new y.$zc,this.d=new T.$Md,this.e=new T.$Md,this.f=new T.$Md,this.g=new T.$Md,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(m){this.acceptDocumentsAndEditorsDelta(m)}acceptDocumentsAndEditorsDelta(m){const h=[],t=[],n=[];if(m.removedDocuments)for(const o of m.removedDocuments){const i=M.URI.revive(o),a=this.c.get(i);a?.unref()&&(this.c.delete(i),h.push(a.value))}if(m.addedDocuments)for(const o of m.addedDocuments){const i=M.URI.revive(o.uri);let a=this.c.get(i);if(a&&i.scheme!==D.Schemas.vscodeNotebookCell&&i.scheme!==D.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);a||(a=new s(new E.$dM(this.h.getProxy(b.$_J.MainThreadDocuments),i,o.lines,o.EOL,o.versionId,o.languageId,o.isDirty,o.notebook)),this.c.set(i,a),t.push(a.value)),a.ref()}if(m.removedEditors)for(const o of m.removedEditors){const i=this.b.get(o);this.b.delete(o),i&&n.push(i)}if(m.addedEditors)for(const o of m.addedEditors){const i=M.URI.revive(o.documentUri);C.ok(this.c.has(i),`document '${i}' does not exist`),C.ok(!this.b.has(o.id),`editor '${o.id}' already exists!`);const a=this.c.get(i).value,u=new R.$jM(o.id,this.h.getProxy(b.$_J.MainThreadTextEditors),this.i,new l.$U(()=>a.document),o.selections.map(I.Selection.to),o.options,o.visibleRanges.map(k=>I.Range.to(k)),typeof o.editorPosition=="number"?I.ViewColumn.to(o.editorPosition):void 0);this.b.set(o.id,u)}m.newActiveEditor!==void 0&&(C.ok(m.newActiveEditor===null||this.b.has(m.newActiveEditor),`active editor '${m.newActiveEditor}' does not exist`),this.a=m.newActiveEditor),(0,d.$Mc)(h),(0,d.$Mc)(n),m.removedDocuments&&this.e.fire(h),m.addedDocuments&&this.d.fire(t),(m.removedEditors||m.addedEditors)&&this.f.fire(this.allEditors().map(o=>o.value)),m.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(m){return this.c.get(m)?.value}allDocuments(){return v.Iterable.map(this.c.values(),m=>m.value)}getEditor(m){return this.b.get(m)}activeEditor(m){if(!this.a)return;const h=this.b.get(this.a);return m?h:h?.value}allEditors(){return[...this.b.values()]}};e.$kM=r,e.$kM=r=He([Be(0,w.$aM),Be(1,p.$8i)],r),e.$lM=(0,A.$Nh)("IExtHostDocumentsAndEditors")}),define(De[70],Ce([1,0,14,6,2,4,5,7,20,18,73]),function(me,e,C,T,d,M,A,b,E,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3cc=e.$2cc=void 0,e.$2cc=(0,A.$Nh)("IExtHostEditorTabs");class I{constructor(l,s,r){this.e=r,this.d=s,this.acceptDtoUpdate(l)}get apiObject(){if(!this.a){const l=this,s={get isActive(){return l.b.id===l.e()},get label(){return l.b.label},get input(){return l.c},get isDirty(){return l.b.isDirty},get isPinned(){return l.b.isPinned},get isPreview(){return l.b.isPreview},get group(){return l.d.apiObject}};this.a=Object.freeze(s)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(l){this.b=l,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new b.$SL(d.URI.revive(this.b.input.uri));case 2:return new b.$TL(d.URI.revive(this.b.input.original),d.URI.revive(this.b.input.modified));case 3:return new b.$UL(d.URI.revive(this.b.input.base),d.URI.revive(this.b.input.input1),d.URI.revive(this.b.input.input2),d.URI.revive(this.b.input.result));case 6:return new b.$VL(d.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new b.$WL(this.b.input.viewType);case 4:return new b.$XL(d.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new b.$YL(d.URI.revive(this.b.input.original),d.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new b.$ZL;case 9:return new b.$1L(d.URI.revive(this.b.input.uri),d.URI.revive(this.b.input.inputBoxUri));default:return}}}class p{constructor(l,s){this.c=[],this.d="",this.b=l,this.e=s;for(const r of l.tabs)r.isActive&&(this.d=r.id),this.c.push(new I(r,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const l=this,s={get isActive(){return l.b.groupId===l.e()},get viewColumn(){return C.ViewColumn.to(l.b.viewColumn)},get activeTab(){return l.c.find(r=>r.tabId===l.d)?.apiObject},get tabs(){return Object.freeze(l.c.map(r=>r.apiObject))}};this.a=Object.freeze(s)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(l){this.b=l}acceptTabOperation(l){if(l.kind===0){const r=new I(l.tabDto,this,()=>this.activeTabId());return this.c.splice(l.index,0,r),l.tabDto.isActive&&(this.d=r.tabId),r}else if(l.kind===1){const r=this.c.splice(l.index,1)[0];if(!r)throw new Error(`Tab close updated received for index ${l.index} which does not exist`);return r.tabId===this.d&&(this.d=""),r}else if(l.kind===3){if(l.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const r=this.c.splice(l.oldIndex,1)[0];if(!r)throw new Error(`Tab move updated received for index ${l.oldIndex} which does not exist`);return this.c.splice(l.index,0,r),r}const s=this.c.find(r=>r.tabId===l.tabDto.id);if(!s)throw new Error("INVALID tab");return l.tabDto.isActive?this.d=l.tabDto.id:this.d===l.tabDto.id&&!l.tabDto.isActive&&(this.d=""),s.acceptDtoUpdate(l.tabDto),s}activeTabId(){return this.d}}let y=class{constructor(l){this.b=new M.$Md,this.c=new M.$Md,this.e=[],this.a=l.getProxy(T.$_J.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const l=this,s={onDidChangeTabGroups:l.c.event,onDidChangeTabs:l.b.event,get all(){return Object.freeze(l.e.map(r=>r.apiObject))},get activeTabGroup(){const r=l.d;return(0,w.$If)(l.e.find(m=>m.groupId===r)?.apiObject)},close:async(r,c)=>{const m=Array.isArray(r)?r:[r];return m.length?D(m[0])?this.j(m,c):this.i(m,c):!0}};this.f=Object.freeze(s)}return this.f}$acceptEditorTabModel(l){const s=new Set(this.e.map(o=>o.groupId)),r=new Set(l.map(o=>o.groupId)),c=(0,R.$K)(s,r),m=this.e.filter(o=>c.removed.includes(o.groupId)).map(o=>o.apiObject),h=[],t=[];this.e=l.map(o=>{const i=new p(o,()=>this.d);return c.added.includes(i.groupId)?h.push(i.apiObject):t.push(i.apiObject),i});const n=(0,w.$If)(l.find(o=>o.isActive===!0)?.groupId);n!==void 0&&this.d!==n&&(this.d=n),this.c.fire(Object.freeze({opened:h,closed:m,changed:t}))}$acceptTabGroupUpdate(l){const s=this.e.find(r=>r.groupId===l.groupId);if(!s)throw new Error("Update Group IPC call received before group creation.");s.acceptGroupDtoUpdate(l),l.isActive&&(this.d=l.groupId),this.c.fire(Object.freeze({changed:[s.apiObject],opened:[],closed:[]}))}$acceptTabOperation(l){const s=this.e.find(c=>c.groupId===l.groupId);if(!s)throw new Error("Update Tabs IPC call received before group creation.");const r=s.acceptTabOperation(l);switch(l.kind){case 0:this.b.fire(Object.freeze({opened:[r.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[r.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[r.apiObject]}));return}}g(l){for(const s of this.e)for(const r of s.tabs)if(r.apiObject===l)return r}h(l){return this.e.find(s=>s.apiObject===l)}async i(l,s){const r=[];for(const c of l){const m=this.g(c);if(!m)throw new Error("Tab close: Invalid tab not found!");r.push(m.tabId)}return this.a.$closeTab(r,s)}async j(l,s){const r=[];for(const c of l){const m=this.h(c);if(!m)throw new Error("Group close: Invalid group not found!");r.push(m.groupId)}return this.a.$closeGroup(r,s)}};e.$3cc=y,e.$3cc=y=He([Be(0,E.$aM)],y);function D(v){return v.tabs!==void 0}}),define(De[308],Ce([1,0,6,7]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ndc=void 0;class d{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(C.$_J.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,b,E){if(this.a.size===0)throw new Error("No embedding vector providers registered");const w=this.a.get(A);if(!w)throw new Error("Embedding vector provider not found");const R=await w.provideEmbeddingVector(b,E);if(!R)throw new Error("Embedding vector provider returned undefined");return R}registerEmbeddingVectorProvider(A,b,E){const w=this.b;return this.b++,this.a.set(w,E),this.c.$registerAiEmbeddingVectorProvider(b,w),new T.$bK(()=>{this.c.$unregisterAiEmbeddingVectorProvider(w),this.a.delete(w)})}}e.$Ndc=d}),define(De[309],Ce([1,0,2,6,3,7,14,169,15,22,26,79]),function(me,e,C,T,d,M,A,b,E,w,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ycc=void 0;class p{constructor(){this.a=[]}add(v){this.b=void 0,this.a.push(v)}delete(v){const l=this.a.indexOf(v);l>=0&&(this.a.splice(l,1),this.b=void 0)}c(){if(!this.b){const v=this.a.sort(),l=[];let s,r,c=14,m=14;for(const h of v){let t=s?(0,E.$3e)(s,h):0;for(t===0?r=1:r=m;t<h.length;t++)t+1===h.length?(c=m,m=9):m+=1,l.push([r,h.toUpperCase().charCodeAt(t),m]),l.push([r,h.toLowerCase().charCodeAt(t),m]),r=m;s=h,m=c}l.push([9,58,10]),l.push([10,47,12]),this.b=new b.$SY(l)}}provideDocumentLinks(v){this.c();const l=[],s=b.$TY.computeLinks({getLineContent(r){return v.lineAt(r-1).text},getLineCount(){return v.lineCount}},this.b);for(const r of s){const c=A.DocumentLink.to(r);c.target&&l.push(c)}return l}}class y{constructor(v,l){this.i=l,this.b=new p,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=v.getProxy(T.$_J.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(v,l,s,r={}){if(y.j(s),this.d.has(l))throw new Error(`a provider for the scheme '${l}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(v,"*",this.b));const c=this.h++;this.b.add(l),this.d.add(l),this.c.set(c,s);let m=2;r.isCaseSensitive&&(m+=1024),r.isReadonly&&(m+=2048),typeof s.copy=="function"&&(m+=8),typeof s.open=="function"&&typeof s.close=="function"&&typeof s.read=="function"&&typeof s.write=="function"&&((0,R.$_E)(v,"fsChunks"),m+=4);let h;r.isReadonly&&(0,I.$3j)(r.isReadonly)&&((0,R.$_E)(v,"readonlyMessage"),h={value:r.isReadonly.value,isTrusted:r.isReadonly.isTrusted,supportThemeIcons:r.isReadonly.supportThemeIcons,supportHtml:r.isReadonly.supportHtml,baseUri:r.isReadonly.baseUri,uris:r.isReadonly.uris}),this.a.$registerFileSystemProvider(c,l,m,h).catch(n=>{console.error(`FAILED to register filesystem provider of ${v.identifier.value}-extension for the scheme ${l}`),console.error(n)});const t=s.onDidChangeFile(n=>{const o=[];for(const i of n){const{uri:a,type:u}=i;if(a.scheme!==l)continue;let k;switch(u){case M.FileChangeType.Changed:k=0;break;case M.FileChangeType.Created:k=1;break;case M.FileChangeType.Deleted:k=2;break;default:throw new Error("Unknown FileChangeType")}o.push({resource:a,type:k})}this.a.$onFileSystemChange(c,o)});return(0,d.$Pc)(()=>{t.dispose(),this.b.delete(l),this.d.delete(l),this.c.delete(c),this.a.$unregisterProvider(c)})}static j(v){if(!v)throw new Error("MISSING provider");if(typeof v.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof v.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof v.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof v.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof v.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof v.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof v.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof v.rename!="function")throw new Error("Provider does NOT implement rename")}static k(v){const{type:l,ctime:s,mtime:r,size:c,permissions:m}=v;return{type:l,ctime:s,mtime:r,size:c,permissions:m}}$stat(v,l){return Promise.resolve(this.l(v).stat(C.URI.revive(l))).then(s=>y.k(s))}$readdir(v,l){return Promise.resolve(this.l(v).readDirectory(C.URI.revive(l)))}$readFile(v,l){return Promise.resolve(this.l(v).readFile(C.URI.revive(l))).then(s=>w.$ae.wrap(s))}$writeFile(v,l,s,r){return Promise.resolve(this.l(v).writeFile(C.URI.revive(l),s.buffer,r))}$delete(v,l,s){return Promise.resolve(this.l(v).delete(C.URI.revive(l),s))}$rename(v,l,s,r){return Promise.resolve(this.l(v).rename(C.URI.revive(l),C.URI.revive(s),r))}$copy(v,l,s,r){const c=this.l(v);if(!c.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(c.copy(C.URI.revive(l),C.URI.revive(s),r))}$mkdir(v,l){return Promise.resolve(this.l(v).createDirectory(C.URI.revive(l)))}$watch(v,l,s,r){const c=this.l(v).watch(C.URI.revive(s),r);this.f.set(l,c)}$unwatch(v,l){const s=this.f.get(l);s&&(s.dispose(),this.f.delete(l))}$open(v,l,s){const r=this.l(v);if(!r.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(r.open(C.URI.revive(l),s))}$close(v,l){const s=this.l(v);if(!s.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(s.close(l))}$read(v,l,s,r){const c=this.l(v);if(!c.read)throw new Error('FileSystemProvider does not implement "read"');const m=w.$ae.alloc(r);return Promise.resolve(c.read(l,s,m.buffer,0,r)).then(h=>m.slice(0,h))}$write(v,l,s,r){const c=this.l(v);if(!c.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(c.write(l,s,r.buffer,0,r.byteLength))}l(v){const l=this.c.get(v);if(!l){const s=new Error;throw s.name="ENOPRO",s.message="no provider",s}return l}}e.$ycc=y}),define(De[71],Ce([1,0,6,30,7,22,5,20,55,3,9,24,17]),function(me,e,C,T,d,M,A,b,E,w,R,I,p){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$fcc=e.$ecc=void 0;let D=y=class{constructor(l,s){this.b=new Map,this.c=new R.$2g,this.a=l.getProxy(C.$_J.MainThreadFileSystem);const r=this;this.value=Object.freeze({async stat(c){try{let m;const h=r.b.get(c.scheme);return h?(await r.a.$ensureActivation(c.scheme),m=await h.impl.stat(c)):m=await r.a.$stat(c),{type:m.type,ctime:m.ctime,mtime:m.mtime,size:m.size,permissions:m.permissions===T.FilePermission.Readonly?1:void 0}}catch(m){y.e(m)}},async readDirectory(c){try{const m=r.b.get(c.scheme);return m?(await r.a.$ensureActivation(c.scheme),(await m.impl.readDirectory(c)).slice()):await r.a.$readdir(c)}catch(m){return y.e(m)}},async createDirectory(c){try{const m=r.b.get(c.scheme);return m&&!m.isReadonly?(await r.a.$ensureActivation(c.scheme),await r.d(m.impl,m.extUri,c)):await r.a.$mkdir(c)}catch(m){return y.e(m)}},async readFile(c){try{const m=r.b.get(c.scheme);return m?(await r.a.$ensureActivation(c.scheme),(await m.impl.readFile(c)).slice()):(await r.a.$readFile(c)).buffer}catch(m){return y.e(m)}},async writeFile(c,m){try{const h=r.b.get(c.scheme);return h&&!h.isReadonly?(await r.a.$ensureActivation(c.scheme),await r.d(h.impl,h.extUri,h.extUri.dirname(c)),await r.c.queueFor(c).queue(()=>Promise.resolve(h.impl.writeFile(c,m,{create:!0,overwrite:!0})))):await r.a.$writeFile(c,M.$ae.wrap(m))}catch(h){return y.e(h)}},async delete(c,m){try{const h=r.b.get(c.scheme);return h&&!h.isReadonly?(await r.a.$ensureActivation(c.scheme),await h.impl.delete(c,{recursive:!1,...m})):await r.a.$delete(c,{recursive:!1,useTrash:!1,atomic:!1,...m})}catch(h){return y.e(h)}},async rename(c,m,h){try{return await r.a.$rename(c,m,{overwrite:!1,...h})}catch(t){return y.e(t)}},async copy(c,m,h){try{return await r.a.$copy(c,m,{overwrite:!1,...h})}catch(t){return y.e(t)}},isWritableFileSystem(c){const m=s.getCapabilities(c);if(typeof m=="number")return!(m&2048)}})}async d(l,s,r){const c=[];for(;!s.isEqual(r,s.dirname(r));)try{if(!((await l.stat(r)).type&T.FileType.Directory))throw d.$oL.FileExists(`Unable to create folder '${r.scheme===p.Schemas.file?r.fsPath:r.toString(!0)}' that already exists but is not a directory`);break}catch(m){if(T.$lk(m)!==T.FileSystemProviderErrorCode.FileNotFound)throw m;c.push(s.basename(r)),r=s.dirname(r)}for(let m=c.length-1;m>=0;m--){r=s.joinPath(r,c[m]);try{await l.createDirectory(r)}catch(h){if(T.$lk(h)!==T.FileSystemProviderErrorCode.FileExists)throw h}}}static e(l){if(l instanceof d.$oL)throw l;if(l instanceof T.$hk)switch(l.code){case T.FileSystemProviderErrorCode.FileExists:throw d.$oL.FileExists(l.message);case T.FileSystemProviderErrorCode.FileNotFound:throw d.$oL.FileNotFound(l.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw d.$oL.FileNotADirectory(l.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw d.$oL.FileIsADirectory(l.message);case T.FileSystemProviderErrorCode.NoPermissions:throw d.$oL.NoPermissions(l.message);case T.FileSystemProviderErrorCode.Unavailable:throw d.$oL.Unavailable(l.message);default:throw new d.$oL(l.message,l.name)}if(!(l instanceof Error))throw new d.$oL(String(l));if(l.name==="ENOPRO"||l.message.includes("ENOPRO"))throw d.$oL.Unavailable(l.message);switch(l.name){case T.FileSystemProviderErrorCode.FileExists:throw d.$oL.FileExists(l.message);case T.FileSystemProviderErrorCode.FileNotFound:throw d.$oL.FileNotFound(l.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw d.$oL.FileNotADirectory(l.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw d.$oL.FileIsADirectory(l.message);case T.FileSystemProviderErrorCode.NoPermissions:throw d.$oL.NoPermissions(l.message);case T.FileSystemProviderErrorCode.Unavailable:throw d.$oL.Unavailable(l.message);default:throw new d.$oL(l.message,l.name)}}addFileSystemProvider(l,s,r){return this.b.set(l,{impl:s,extUri:r?.isCaseSensitive?I.$kg:I.$mg,isReadonly:!!r?.isReadonly}),(0,w.$Pc)(()=>this.b.delete(l))}getFileSystemProviderExtUri(l){return this.b.get(l)?.extUri??I.$kg}};e.$ecc=D,e.$ecc=D=y=He([Be(0,b.$aM),Be(1,E.$Mbc)],D),e.$fcc=(0,A.$Nh)("IExtHostConsumerFileSystem")}),define(De[310],Ce([1,0,4,35,2,6,14,7,51]),function(me,e,C,T,d,M,A,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zcc=void 0;class w{get ignoreCreateEvents(){return!!(this.g&1)}get ignoreChangeEvents(){return!!(this.g&2)}get ignoreDeleteEvents(){return!!(this.g&4)}constructor(y,D,v,l,s,r,c,m){this.a=new C.$Md,this.b=new C.$Md,this.c=new C.$Md;const h=this.h(y,v,s);this.g=0,r&&(this.g+=1),c&&(this.g+=2),m&&(this.g+=4);const t=(0,T.$uj)(s),n=typeof s=="string",o=l(i=>{if(!r)for(const a of i.created){const u=d.URI.revive(a);t(u.fsPath)&&(!n||D.getWorkspaceFolder(u))&&this.a.fire(u)}if(!c)for(const a of i.changed){const u=d.URI.revive(a);t(u.fsPath)&&(!n||D.getWorkspaceFolder(u))&&this.b.fire(u)}if(!m)for(const a of i.deleted){const u=d.URI.revive(a);t(u.fsPath)&&(!n||D.getWorkspaceFolder(u))&&this.c.fire(u)}});this.d=b.$bK.from(h,this.a,this.b,this.c,o)}h(y,D,v){const l=b.$bK.from();if(typeof v=="string")return l;const s=y.getProxy(M.$_J.MainThreadFileSystem);let r=!1;(v.pattern.includes(T.$qj)||v.pattern.includes(T.$rj))&&(r=!0);const c=Math.random();return s.$watch(D.identifier.value,c,v.baseUri,{recursive:r,excludes:[]}),b.$bK.from({dispose:()=>s.$unwatch(c)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class R{constructor(y){this.a=y,this.b=new E.$U(()=>this.a.created.map(d.URI.revive)),this.c=new E.$U(()=>this.a.changed.map(d.URI.revive)),this.d=new E.$U(()=>this.a.deleted.map(d.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class I{constructor(y,D,v){this.j=y,this.k=D,this.l=v,this.a=new C.$Md,this.b=new C.$Md,this.c=new C.$Md,this.d=new C.$Md,this.g=new C.$Od,this.h=new C.$Od,this.i=new C.$Od,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(y,D,v,l,s,r){return new w(this.j,y,D,this.a.event,A.GlobPattern.from(v),l,s,r)}$onFileEvent(y){this.a.fire(new R(y))}$onDidRunFileOperation(y,D){switch(y){case 2:this.b.fire(Object.freeze({files:D.map(v=>({oldUri:d.URI.revive(v.source),newUri:d.URI.revive(v.target)}))}));break;case 1:this.d.fire(Object.freeze({files:D.map(v=>d.URI.revive(v.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:D.map(v=>d.URI.revive(v.target))}));break;default:}}getOnWillRenameFileEvent(y){return this.m(y,this.g)}getOnWillCreateFileEvent(y){return this.m(y,this.h)}getOnWillDeleteFileEvent(y){return this.m(y,this.i)}m(y,D){return(v,l,s)=>{const r=function(m){v.call(l,m)};return r.extension=y,D.event(r,void 0,s)}}async $onWillRunFileOperation(y,D,v,l){switch(y){case 2:return await this.n(this.g,{files:D.map(s=>({oldUri:d.URI.revive(s.source),newUri:d.URI.revive(s.target)}))},v,l);case 1:return await this.n(this.i,{files:D.map(s=>d.URI.revive(s.target))},v,l);case 0:case 3:return await this.n(this.h,{files:D.map(s=>d.URI.revive(s.target))},v,l)}}async n(y,D,v,l){const s=new Set,r=[];if(await y.fireAsync(D,l,async(m,h)=>{const t=Date.now(),n=await Promise.resolve(m);n instanceof b.$lK&&(r.push([h.extension,n]),s.add(h.extension.displayName??h.extension.identifier.value)),Date.now()-t>v&&this.k.warn("SLOW file-participant",h.extension.identifier)}),l.isCancellationRequested||r.length===0)return;const c={edits:[]};for(const[,m]of r){const{edits:h}=A.WorkspaceEdit.from(m,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});c.edits=c.edits.concat(h)}return{edit:c,extensionNames:Array.from(s)}}}e.$zcc=I}),define(De[311],Ce([1,0,3,2,6,14,7,33,9]),function(me,e,C,T,d,M,A,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gdc=void 0;class w{static{this.a=0}constructor(y,D){this.extension=y,this.provider=D,this.handle=w.a++}}class R{constructor(y){this.session=y,this.responses=[]}}class I{static{this.a=0}constructor(y,D,v,l){this.f=v,this.g=l,this.b=new Map,this.d=new Map,this.e=y.getProxy(d.$_J.MainThreadInlineChat),D.registerApiCommand(new b.$AM("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new b.$yM("Run arguments","",s=>!0,s=>{if(s)return{initialRange:s.initialRange?M.Range.from(s.initialRange):void 0,initialSelection:s.initialSelection?M.Selection.from(s.initialSelection):void 0,message:s.message,autoSend:s.autoSend,position:s.position?M.Position.from(s.position):void 0}})],b.$zM.Void))}registerProvider(y,D,v){const l=new w(y,D);return this.b.set(l.handle,l),this.e.$registerInteractiveEditorProvider(l.handle,v.label,y.identifier.value,typeof D.handleInteractiveEditorResponseFeedback=="function"),(0,C.$Pc)(()=>{this.e.$unregisterInteractiveEditorProvider(l.handle),this.b.delete(l.handle)})}async $prepareSession(y,D,v,l){const s=this.b.get(y);if(!s){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const r=this.f.getDocument(T.URI.revive(D)),c=M.Selection.to(v),m=await s.provider.prepareInteractiveEditorSession({document:r,selection:c},l);if(!m)return;if(m.wholeRange&&!m.wholeRange.contains(c))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const h=I.a++;return this.d.set(h,new R(m)),{id:h,placeholder:m.placeholder,slashCommands:m.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:M.Range.from(m.wholeRange),message:m.message}}async $provideResponse(y,D,v,l){const s=this.b.get(y);if(!s)return;const r=this.d.get(D.id);if(!r)return;const c={prompt:v.prompt,selection:M.Selection.to(v.selection),wholeRange:M.Range.to(v.wholeRange),attempt:v.attempt,live:v.live};let m=!1;const h={report:async u=>{if(!v.live)throw new Error("Progress reporting is only supported for live sessions");m||l.isCancellationRequested||await this.e.$handleProgressChunk(v.requestId,{message:u.message,edits:u.edits?.map(M.TextEdit.from),slashCommand:u.slashCommand?.command})}},t=Promise.resolve(s.provider.provideInteractiveEditorResponse(r.session,c,h,l));let n;try{n=await(0,E.$Hg)(t,l)}finally{m=!0}if(!n)return;const o=r.responses.push(n)-1,i={wholeRange:M.Range.from(n.wholeRange),placeholder:n.placeholder};if(I.h(n))return{...i,id:o,type:"message",message:M.MarkdownString.from(n.contents)};const{edits:a}=n;return a instanceof A.$lK?{...i,id:o,type:"bulkEdit",edits:M.WorkspaceEdit.from(a)}:{...i,id:o,type:"editorEdit",edits:a.map(M.TextEdit.from)}}$handleFeedback(y,D,v,l){const s=this.b.get(y),r=this.d.get(D),c=r?.responses[v];if(s&&c){const m=M.InteractiveEditorResponseFeedbackKind.to(l);s.provider.handleInteractiveEditorResponseFeedback?.(r.session,c,m)}}$releaseSession(y,D){}static h(y){return typeof y=="object"&&typeof y.contents=="object"}}e.$Gdc=I}),define(De[312],Ce([1,0,2,33]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cdc=void 0;class d{constructor(A,b,E,w,R){this.a=b,this.b=E,this.c=w;const I=new T.$AM("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new T.$yM("showOptions","Show Options",p=>!0,p=>p),new T.$yM("resource","Interactive resource Uri",p=>!0,p=>p),new T.$yM("controllerId","Notebook controller Id",p=>!0,p=>p),new T.$yM("title","Interactive editor title",p=>!0,p=>p)],new T.$zM("Notebook and input URI",p=>{if(R.debug("[ExtHostInteractive] open iw with notebook editor id",p.notebookEditorId),p.notebookEditorId!==void 0){const y=this.a.getEditorById(p.notebookEditorId);return R.debug("[ExtHostInteractive] notebook editor found",y.id),{notebookUri:C.URI.revive(p.notebookUri),inputUri:C.URI.revive(p.inputUri),notebookEditor:y.apiEditor}}return R.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",p.notebookUri,p.inputUri),{notebookUri:C.URI.revive(p.notebookUri),inputUri:C.URI.revive(p.inputUri)}}));this.c.registerApiCommand(I)}$willAddInteractiveDocument(A,b,E,w){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:b,lines:[""],languageId:E,uri:A,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(C.URI.revive(w))?.apiNotebook}]})}$willRemoveInteractiveDocument(A,b){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.$Cdc=d}),define(De[313],Ce([1,0,6,7]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Idc=void 0;class d{constructor(A){this.a=new Map,this.b=A.getProxy(C.$_J.MainThreadIssueReporter)}async $getIssueReporterUri(A,b){if(this.a.size===0)throw new Error("No issue request handlers registered");const E=this.a.get(A);if(!E)throw new Error("Issue request handler not found");const w=await E.handleIssueUrlRequest();if(!w)throw new Error("Issue request handler returned no result");return w}registerIssueUriRequestHandler(A,b){const E=A.identifier.value;return this.a.set(E,b),this.b.$registerIssueUriRequestHandler(E),new T.$bK(()=>{this.b.$unregisterIssueUriRequestHandler(E),this.a.delete(E)})}}e.$Idc=d}),define(De[314],Ce([1,0,3,6]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vcc=void 0;class d{constructor(A){this.b=0,this.a=A.getProxy(T.$_J.MainThreadLabelService)}$registerResourceLabelFormatter(A){const b=this.b++;return this.a.$registerResourceLabelFormatter(b,A),(0,C.$Pc)(()=>{this.a.$unregisterResourceLabelFormatter(b)})}}e.$Vcc=d}),define(De[315],Ce([1,0,2,23,14,7,82,6,15,34,19,18,165,21,25,3,129,119,107,37,8,9,26,205]),function(me,e,C,T,d,M,A,b,E,w,R,I,p,y,D,v,l,s,r,c,m,h,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sbc=void 0;class o{constructor(B,Q){this.d=B,this.e=Q}async provideDocumentSymbols(B,Q){const te=this.d.getDocument(B),se=await this.e.provideDocumentSymbols(te,Q);if(!(0,R.$Jb)(se))return se[0]instanceof M.$tK?se.map(d.DocumentSymbol.from):o.f(se)}static f(B){B=B.slice(0).sort((se,X)=>{let de=se.location.range.start.compareTo(X.location.range.start);return de===0&&(de=X.location.range.end.compareTo(se.location.range.end)),de});const Q=[],te=[];for(const se of B){const X={name:se.name||"!!MISSING: name!!",kind:d.SymbolKind.from(se.kind),tags:se.tags?.map(d.SymbolTag.from)||[],detail:"",containerName:se.containerName,range:d.Range.from(se.location.range),selectionRange:d.Range.from(se.location.range),children:[]};for(;;){if(te.length===0){te.push(X),Q.push(X);break}const de=te[te.length-1];if(w.$os.containsRange(de.range,X.range)&&!w.$os.equalsRange(de.range,X.range)){de.children?.push(X),te.push(X);break}te.pop()}}return Q}}class i{static{this.d={command:"missing",title:"!!MISSING: command!!"}}constructor(B,Q,te){this.g=B,this.h=Q,this.j=te,this.e=new r.$Jbc("CodeLens"),this.f=new Map}async provideCodeLenses(B,Q){const te=this.g.getDocument(B),se=await this.j.provideCodeLenses(te,Q);if(!se||Q.isCancellationRequested)return;const X=this.e.add(se),de=new v.$Qc;this.f.set(X,de);const ye={cacheId:X,lenses:[]};for(let je=0;je<se.length;je++)ye.lenses.push({cacheId:[X,je],range:d.Range.from(se[je].range),command:this.h.toInternal(se[je].command,de)});return ye}async resolveCodeLens(B,Q){const te=B.cacheId&&this.e.get(...B.cacheId);if(!te)return;let se;if(typeof this.j.resolveCodeLens!="function"||te.isResolved?se=te:se=await this.j.resolveCodeLens(te,Q),se||(se=te),Q.isCancellationRequested)return;const X=B.cacheId&&this.f.get(B.cacheId[0]);if(X)return B.command=this.h.toInternal(se.command??i.d,X),B}releaseCodeLenses(B){this.f.get(B)?.dispose(),this.f.delete(B),this.e.delete(B)}}function a(Pe){return Array.isArray(Pe)?Pe.map(d.DefinitionLink.from):Pe?[d.DefinitionLink.from(Pe)]:[]}class u{constructor(B,Q){this.d=B,this.e=Q}async provideDefinition(B,Q,te){const se=this.d.getDocument(B),X=d.Position.to(Q),de=await this.e.provideDefinition(se,X,te);return a(de)}}class k{constructor(B,Q){this.d=B,this.e=Q}async provideDeclaration(B,Q,te){const se=this.d.getDocument(B),X=d.Position.to(Q),de=await this.e.provideDeclaration(se,X,te);return a(de)}}class S{constructor(B,Q){this.d=B,this.e=Q}async provideImplementation(B,Q,te){const se=this.d.getDocument(B),X=d.Position.to(Q),de=await this.e.provideImplementation(se,X,te);return a(de)}}class ${constructor(B,Q){this.d=B,this.e=Q}async provideTypeDefinition(B,Q,te){const se=this.d.getDocument(B),X=d.Position.to(Q),de=await this.e.provideTypeDefinition(se,X,te);return a(de)}}class g{constructor(B,Q){this.d=B,this.e=Q}async provideHover(B,Q,te){const se=this.d.getDocument(B),X=d.Position.to(Q),de=await this.e.provideHover(se,X,te);if(!(!de||(0,R.$Jb)(de.contents)))return de.range||(de.range=se.getWordRangeAtPosition(X)),de.range||(de.range=new M.$dK(X,X)),d.Hover.from(de)}}class f{constructor(B,Q){this.d=B,this.e=Q}async provideEvaluatableExpression(B,Q,te){const se=this.d.getDocument(B),X=d.Position.to(Q),de=await this.e.provideEvaluatableExpression(se,X,te);if(de)return d.EvaluatableExpression.from(de)}}class P{constructor(B,Q){this.d=B,this.e=Q}async provideInlineValues(B,Q,te,se){const X=this.d.getDocument(B),de=await this.e.provideInlineValues(X,d.Range.to(Q),d.InlineValueContext.to(te),se);if(Array.isArray(de))return de.map(ye=>d.InlineValue.from(ye))}}class N{constructor(B,Q){this.d=B,this.e=Q}async provideDocumentHighlights(B,Q,te){const se=this.d.getDocument(B),X=d.Position.to(Q),de=await this.e.provideDocumentHighlights(se,X,te);if(Array.isArray(de))return de.map(d.DocumentHighlight.from)}}class O{constructor(B,Q){this.d=B,this.e=Q}async provideLinkedEditingRanges(B,Q,te){const se=this.d.getDocument(B),X=d.Position.to(Q),de=await this.e.provideLinkedEditingRanges(se,X,te);if(de&&Array.isArray(de.ranges))return{ranges:(0,R.$Gb)(de.ranges.map(d.Range.from)),wordPattern:de.wordPattern}}}class L{constructor(B,Q){this.d=B,this.e=Q}async provideReferences(B,Q,te,se){const X=this.d.getDocument(B),de=d.Position.to(Q),ye=await this.e.provideReferences(X,de,te,se);if(Array.isArray(ye))return ye.map(d.location.from)}}class j{static{this.d=1e3}constructor(B,Q,te,se,X,de,ye){this.g=B,this.h=Q,this.j=te,this.k=se,this.l=X,this.m=de,this.n=ye,this.e=new r.$Jbc("CodeAction"),this.f=new Map}async provideCodeActions(B,Q,te,se){const X=this.g.getDocument(B),de=p.$qs.isISelection(Q)?d.Selection.to(Q):d.Range.to(Q),ye=[];for(const et of this.j.getDiagnostics(B))if(de.intersection(et.range)&&ye.push(et)>j.d)break;const je={diagnostics:ye,only:te.only?new M.$vK(te.only):void 0,triggerKind:d.CodeActionTriggerKind.to(te.trigger)},We=await this.k.provideCodeActions(X,de,je,se);if(!(0,R.$Kb)(We)||se.isCancellationRequested)return;const _e=this.e.add(We),Ye=new v.$Qc;this.f.set(_e,Ye);const it=[];for(let et=0;et<We.length;et++){const Ae=We[et];Ae&&(j.o(Ae)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),it.push({_isSynthetic:!0,title:Ae.title,command:this.h.toInternal(Ae,Ye)})):(je.only&&(Ae.kind?je.only.contains(Ae.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${je.only.value} 'requested but returned code action is of kind '${Ae.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${je.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),it.push({cacheId:[_e,et],title:Ae.title,command:Ae.command&&this.h.toInternal(Ae.command,Ye),diagnostics:Ae.diagnostics&&Ae.diagnostics.map(d.Diagnostic.from),edit:Ae.edit&&d.WorkspaceEdit.from(Ae.edit,void 0),kind:Ae.kind&&Ae.kind.value,isPreferred:Ae.isPreferred,isAI:(0,t.$$E)(this.m,"codeActionAI")?Ae.isAI:!1,disabled:Ae.disabled?.reason})))}return{cacheId:_e,actions:it}}async resolveCodeAction(B,Q){const[te,se]=B,X=this.e.get(te,se);if(!X||j.o(X))return{};if(!this.k.resolveCodeAction)return{};const de=await this.k.resolveCodeAction(X,Q)??X;let ye;de.edit&&(ye=d.WorkspaceEdit.from(de.edit,void 0));let je;if(de.command){const We=this.f.get(te);We&&(je=this.h.toInternal(de.command,We))}return{edit:ye,command:je}}releaseCodeActions(B){this.f.get(B)?.dispose(),this.f.delete(B),this.e.delete(B)}static o(B){return typeof B.command=="string"&&typeof B.title=="string"}}class z{static toInternalProviderId(B,Q){return B+"."+Q}constructor(B,Q,te,se,X){this.d=B,this.e=Q,this.f=te,this.g=se,this.h=X}async prepareDocumentPaste(B,Q,te,se){if(!this.f.prepareDocumentPaste)return;const X=this.e.getDocument(B),de=Q.map(We=>d.Range.to(We)),ye=d.DataTransfer.toDataTransfer(te,()=>{throw new m.$0});if(await this.f.prepareDocumentPaste(X,de,ye,se),se.isCancellationRequested)return;const je=Array.from(ye).filter(([,We])=>!(We instanceof M.$2K));return d.DataTransfer.from(je)}async providePasteEdits(B,Q,te,se,X){if(!this.f.provideDocumentPasteEdits)return;const de=this.e.getDocument(Q),ye=te.map(_e=>d.Range.to(_e)),je=d.DataTransfer.toDataTransfer(se,async _e=>(await this.d.$resolvePasteFileData(this.g,B,_e)).buffer),We=await this.f.provideDocumentPasteEdits(de,ye,je,X);if(We)return{label:We.label??(0,n.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:We.yieldTo?.map(_e=>"mimeType"in _e?_e:{providerId:z.toInternalProviderId(_e.extensionId,_e.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?d.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class F{constructor(B,Q){this.d=B,this.e=Q}async provideDocumentFormattingEdits(B,Q,te){const se=this.d.getDocument(B),X=await this.e.provideDocumentFormattingEdits(se,Q,te);if(Array.isArray(X))return X.map(d.TextEdit.from)}}class H{constructor(B,Q){this.d=B,this.e=Q}async provideDocumentRangeFormattingEdits(B,Q,te,se){const X=this.d.getDocument(B),de=d.Range.to(Q),ye=await this.e.provideDocumentRangeFormattingEdits(X,de,te,se);if(Array.isArray(ye))return ye.map(d.TextEdit.from)}async provideDocumentRangesFormattingEdits(B,Q,te,se){(0,I.$Hf)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const X=this.d.getDocument(B),de=Q.map(d.Range.to),ye=await this.e.provideDocumentRangesFormattingEdits(X,de,te,se);if(Array.isArray(ye))return ye.map(d.TextEdit.from)}}class K{constructor(B,Q){this.d=B,this.e=Q,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(B,Q,te,se,X){const de=this.d.getDocument(B),ye=d.Position.to(Q),je=await this.e.provideOnTypeFormattingEdits(de,ye,te,se,X);if(Array.isArray(je))return je.map(d.TextEdit.from)}}class fe{constructor(B,Q){this.e=B,this.f=Q,this.d=new r.$Jbc("WorkspaceSymbols")}async provideWorkspaceSymbols(B,Q){const te=await this.e.provideWorkspaceSymbols(B,Q);if(!(0,R.$Kb)(te))return{symbols:[]};const se=this.d.add(te),X={cacheId:se,symbols:[]};for(let de=0;de<te.length;de++){const ye=te[de];if(!ye||!ye.name){this.f.warn("INVALID SymbolInformation",ye);continue}X.symbols.push({...d.WorkspaceSymbol.from(ye),cacheId:[se,de]})}return X}async resolveWorkspaceSymbol(B,Q){if(typeof this.e.resolveWorkspaceSymbol!="function"||!B.cacheId)return B;const te=this.d.get(...B.cacheId);if(te){const se=await this.e.resolveWorkspaceSymbol(te,Q);return se&&(0,T.$5m)(B,d.WorkspaceSymbol.from(se),!0)}}releaseWorkspaceSymbols(B){this.d.delete(B)}}class x{static supportsResolving(B){return typeof B.prepareRename=="function"}constructor(B,Q,te){this.d=B,this.e=Q,this.f=te}async provideRenameEdits(B,Q,te,se){const X=this.d.getDocument(B),de=d.Position.to(Q);try{const ye=await this.e.provideRenameEdits(X,de,te,se);return ye?d.WorkspaceEdit.from(ye):void 0}catch(ye){const je=x.g(ye);return je?{rejectReason:je,edits:void 0}:Promise.reject(ye)}}async resolveRenameLocation(B,Q,te){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const se=this.d.getDocument(B),X=d.Position.to(Q);try{const de=await this.e.prepareRename(se,X,te);let ye,je;if(M.$dK.isRange(de)?(ye=de,je=se.getText(de)):(0,I.$zf)(de)&&(ye=de.range,je=de.placeholder),!ye||!je)return;if(ye.start.line>X.line||ye.end.line<X.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:d.Range.from(ye),text:je}}catch(de){const ye=x.g(de);return ye?{rejectReason:ye,range:void 0,text:void 0}:Promise.reject(de)}}static g(B){return typeof B=="string"?B:B instanceof Error&&typeof B.message=="string"?B.message:void 0}}class Z{constructor(B,Q){this.resultId=B,this.tokens=Q}}class q{constructor(B,Q){this.f=B,this.g=Q,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(B,Q,te){const se=this.f.getDocument(B),X=Q!==0?this.d.get(Q):null;let de=typeof X?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(se,X.resultId,te):await this.g.provideDocumentSemanticTokens(se,te);return X&&this.d.delete(Q),de?(de=q.h(de),this.o(q.n(X,de),de)):null}async releaseDocumentSemanticColoring(B){this.d.delete(B)}static h(B){return q.j(B)?q.k(B)?B:new M.$sL(new Uint32Array(B.data),B.resultId):q.l(B)?q.m(B)?B:new M.$uL(B.edits.map(Q=>new M.$tL(Q.start,Q.deleteCount,Q.data?new Uint32Array(Q.data):Q.data)),B.resultId):B}static j(B){return B&&!!B.data}static k(B){return B.data instanceof Uint32Array}static l(B){return B&&Array.isArray(B.edits)}static m(B){for(const Q of B.edits)if(!(Q.data instanceof Uint32Array))return!1;return!0}static n(B,Q){if(!q.j(Q)||!B||!B.tokens)return Q;const te=B.tokens,se=te.length,X=Q.data,de=X.length;let ye=0;const je=Math.min(se,de);for(;ye<je&&te[ye]===X[ye];)ye++;if(ye===se&&ye===de)return new M.$uL([],Q.resultId);let We=0;const _e=je-ye;for(;We<_e&&te[se-We-1]===X[de-We-1];)We++;return new M.$uL([{start:ye,deleteCount:se-ye-We,data:X.subarray(ye,de-We)}],Q.resultId)}o(B,Q){if(q.j(B)){const te=this.e++;return this.d.set(te,new Z(B.resultId,B.data)),(0,l.$P0)({id:te,type:"full",data:B.data})}if(q.l(B)){const te=this.e++;return q.j(Q)?this.d.set(te,new Z(Q.resultId,Q.data)):this.d.set(te,new Z(B.resultId)),(0,l.$P0)({id:te,type:"delta",deltas:(B.edits||[]).map(se=>({start:se.start,deleteCount:se.deleteCount,data:se.data}))})}return null}}class Y{constructor(B,Q){this.d=B,this.e=Q}async provideDocumentRangeSemanticTokens(B,Q,te){const se=this.d.getDocument(B),X=await this.e.provideDocumentRangeSemanticTokens(se,d.Range.to(Q),te);return X?this.f(X):null}f(B){return(0,l.$P0)({id:0,type:"full",data:B.data})}}class be{static supportsResolving(B){return typeof B.resolveCompletionItem=="function"}constructor(B,Q,te,se,X){this.f=B,this.g=Q,this.h=te,this.j=se,this.k=X,this.d=new r.$Jbc("CompletionItem"),this.e=new Map}async provideCompletionItems(B,Q,te,se){const X=this.f.getDocument(B),de=d.Position.to(Q),ye=X.getWordRangeAtPosition(de)||new M.$dK(de,de),je=ye.with({end:de}),We=new c.$Id,_e=await this.h.provideCompletionItems(X,de,se,d.CompletionContext.to(te));if(!_e||se.isCancellationRequested)return;const Ye=Array.isArray(_e)?new M.$IK(_e):_e,it=be.supportsResolving(this.h)?this.d.add(Ye.items):this.d.add([]),et=new v.$Qc;this.e.set(it,et);const Ae=[],Ne={x:it,b:Ae,a:{replace:d.Range.from(ye),insert:d.Range.from(je)},c:Ye.isIncomplete||void 0,d:We.elapsed()};for(let qe=0;qe<Ye.items.length;qe++){const Me=Ye.items[qe],Ze=this.l(Me,[it,qe],je,ye);Ae.push(Ze)}return Ne}async resolveCompletionItem(B,Q){if(typeof this.h.resolveCompletionItem!="function")return;const te=this.d.get(...B);if(!te)return;const se=this.l(te,B),X=await this.h.resolveCompletionItem(te,Q);if(!X)return;const de=this.l(X,B);return(se.h!==de.h||se.i!==de.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(se.n!==de.n||se.o!==de.o||!(0,T.$6m)(se.p,de.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...se,d:de.d,c:de.c,l:de.l,h:de.h,i:de.i,n:de.n,o:de.o,p:de.p}}releaseCompletionItems(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,Q,te,se){const X=this.e.get(Q[0]);if(!X)throw Error("DisposableStore is missing...");const de=this.g.toInternal(B.command,X),ye={x:Q,a:B.label,b:B.kind!==void 0?d.CompletionItemKind.from(B.kind):void 0,m:B.tags&&B.tags.map(d.CompletionItemTag.from),c:B.detail,d:typeof B.documentation>"u"?void 0:d.MarkdownString.fromStrict(B.documentation),e:B.sortText!==B.label?B.sortText:void 0,f:B.filterText!==B.label?B.filterText:void 0,g:B.preselect||void 0,i:B.keepWhitespace?1:0,k:B.commitCharacters?.join(""),l:B.additionalTextEdits&&B.additionalTextEdits.map(d.TextEdit.from),n:de?.$ident,o:de?.id,p:de?.$ident?void 0:de?.arguments};B.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ye.h=B.textEdit.newText):typeof B.insertText=="string"?ye.h=B.insertText:B.insertText instanceof M.$mK&&(ye.h=B.insertText.value,ye.i|=4);let je;return B.textEdit?je=B.textEdit.range:B.range&&(je=B.range),M.$dK.isRange(je)?ye.j=d.Range.from(je):je&&(!te?.isEqual(je.inserting)||!se?.isEqual(je.replacing))&&(ye.j={insert:d.Range.from(je.inserting),replace:d.Range.from(je.replacing)}),ye}}class ue{async provideInlineCompletions(B,Q,te,se){}disposeCompletions(B){}handleDidShowCompletionItem(B,Q,te){}handlePartialAccept(B,Q,te){}}class ve extends ue{constructor(B,Q,te,se){super(),this.f=B,this.g=Q,this.h=te,this.j=se,this.d=new J,this.e=(0,t.$$E)(this.f,"inlineCompletionsAdditions"),this.k={[A.InlineCompletionTriggerKind.Automatic]:M.InlineCompletionTriggerKind.Automatic,[A.InlineCompletionTriggerKind.Explicit]:M.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$$E)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(B,Q,te,se){const X=this.g.getDocument(B),de=d.Position.to(Q),ye=await this.h.provideInlineCompletionItems(X,de,{selectedCompletionInfo:te.selectedSuggestionInfo?{range:d.Range.to(te.selectedSuggestionInfo.range),text:te.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[te.triggerKind]},se);if(!ye||se.isCancellationRequested)return;const je=Array.isArray(ye)?ye:ye.items,We=this.e?Array.isArray(ye)?[]:ye.commands||[]:[],_e=this.e&&!Array.isArray(ye)?ye.enableForwardStability:void 0;let Ye;return{pid:this.d.createReferenceId({dispose(){Ye?.dispose()},items:je}),items:je.map((et,Ae)=>{let Ne;et.command&&(Ye||(Ye=new v.$Qc),Ne=this.j.toInternal(et.command,Ye));const qe=et.insertText;return{insertText:typeof qe=="string"?qe:{snippet:qe.value},filterText:et.filterText,range:et.range?d.Range.from(et.range):void 0,command:Ne,idx:Ae,completeBracketPairs:this.e?et.completeBracketPairs:!1}}),commands:We.map(et=>(Ye||(Ye=new v.$Qc),this.j.toInternal(et,Ye))),suppressSuggestions:!1,enableForwardStability:_e}}disposeCompletions(B){this.d.disposeReferenceId(B)?.dispose()}handleDidShowCompletionItem(B,Q,te){const se=this.d.get(B)?.items[Q];se&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(se,te)}handlePartialAccept(B,Q,te){const se=this.d.get(B)?.items[Q];se&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(se,te)}}class J{constructor(){this.d=new Map,this.e=1}createReferenceId(B){const Q=this.e++;return this.d.set(Q,B),Q}disposeReferenceId(B){const Q=this.d.get(B);return this.d.delete(B),Q}get(B){return this.d.get(B)}}class U{constructor(B,Q){this.e=B,this.f=Q,this.d=new r.$Jbc("SignatureHelp")}async provideSignatureHelp(B,Q,te,se){const X=this.e.getDocument(B),de=d.Position.to(Q),ye=this.g(te),je=await this.f.provideSignatureHelp(X,de,se,ye);if(je){const We=this.d.add([je]);return{...d.SignatureHelp.from(je),id:We}}}g(B){let Q;if(B.activeSignatureHelp){const te=d.SignatureHelp.to(B.activeSignatureHelp),se=this.d.get(B.activeSignatureHelp.id,0);se?(Q=se,Q.activeSignature=te.activeSignature,Q.activeParameter=te.activeParameter):Q=te}return{...B,activeSignatureHelp:Q}}releaseSignatureHelp(B){this.d.delete(B)}}class V{constructor(B,Q,te,se,X){this.f=B,this.g=Q,this.h=te,this.j=se,this.k=X,this.d=new r.$Jbc("InlayHints"),this.e=new Map}async provideInlayHints(B,Q,te){const se=this.f.getDocument(B),X=d.Range.to(Q),de=await this.h.provideInlayHints(se,X,te);if(!Array.isArray(de)||de.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${Q}`);return}if(te.isCancellationRequested)return;const ye=this.d.add(de);this.e.set(ye,new v.$Qc);const je={hints:[],cacheId:ye};for(let We=0;We<de.length;We++)this.l(de[We],X)&&je.hints.push(this.m(de[We],[ye,We]));return this.j.trace(`[InlayHints] ${je.hints.length} inlay hints from '${this.k.identifier.value}' for ${Q}`),je}async resolveInlayHint(B,Q){if(typeof this.h.resolveInlayHint!="function")return;const te=this.d.get(...B);if(!te)return;const se=await this.h.resolveInlayHint(te,Q);if(se&&this.l(se))return this.m(se,B)}releaseHints(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,Q){return B.label.length===0||Array.isArray(B.label)&&B.label.every(te=>te.value.length===0)?(console.log("INVALID inlay hint, empty label",B),!1):!(Q&&!Q.contains(B.position))}m(B,Q){const te=this.e.get(Q[0]);if(!te)throw Error("DisposableStore is missing...");const se={label:"",cacheId:Q,tooltip:d.MarkdownString.fromStrict(B.tooltip),position:d.Position.from(B.position),textEdits:B.textEdits&&B.textEdits.map(d.TextEdit.from),kind:B.kind&&d.InlayHintKind.from(B.kind),paddingLeft:B.paddingLeft,paddingRight:B.paddingRight};return typeof B.label=="string"?se.label=B.label:se.label=B.label.map(X=>{const de={label:X.value};return de.tooltip=d.MarkdownString.fromStrict(X.tooltip),M.$nK.isLocation(X.location)&&(de.location=d.location.from(X.location)),X.command&&(de.command=this.g.toInternal(X.command,te)),de}),se}}class ge{constructor(B,Q){this.e=B,this.f=Q,this.d=new r.$Jbc("DocumentLink")}async provideLinks(B,Q){const te=this.e.getDocument(B),se=await this.f.provideDocumentLinks(te,Q);if(!(!Array.isArray(se)||se.length===0)&&!Q.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:se.filter(ge.g).map(d.DocumentLink.from)};{const X=this.d.add(se),de={links:[],cacheId:X};for(let ye=0;ye<se.length;ye++){if(!ge.g(se[ye]))continue;const je=d.DocumentLink.from(se[ye]);je.cacheId=[X,ye],de.links.push(je)}return de}}}static g(B){return B.target&&B.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(B,Q){if(typeof this.f.resolveDocumentLink!="function")return;const te=this.d.get(...B);if(!te)return;const se=await this.f.resolveDocumentLink(te,Q);if(!(!se||!ge.g(se)))return d.DocumentLink.from(se)}releaseLinks(B){this.d.delete(B)}}class _{constructor(B,Q){this.d=B,this.e=Q}async provideColors(B,Q){const te=this.d.getDocument(B),se=await this.e.provideDocumentColors(te,Q);return Array.isArray(se)?se.map(de=>({color:d.Color.from(de.color),range:d.Range.from(de.range)})):[]}async provideColorPresentations(B,Q,te){const se=this.d.getDocument(B),X=d.Range.to(Q.range),de=d.Color.to(Q.color),ye=await this.e.provideColorPresentations(de,{document:se,range:X},te);if(Array.isArray(ye))return ye.map(d.ColorPresentation.from)}}class ie{constructor(B,Q){this.d=B,this.e=Q}async provideFoldingRanges(B,Q,te){const se=this.d.getDocument(B),X=await this.e.provideFoldingRanges(se,Q,te);if(Array.isArray(X))return X.map(d.FoldingRange.from)}}class re{constructor(B,Q,te){this.d=B,this.e=Q,this.f=te}async provideSelectionRanges(B,Q,te){const se=this.d.getDocument(B),X=Q.map(d.Position.to),de=await this.e.provideSelectionRanges(se,X,te);if(!(0,R.$Kb)(de))return[];if(de.length!==X.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ye=[];for(let je=0;je<X.length;je++){const We=[];ye.push(We);let _e=X[je],Ye=de[je];for(;;){if(!Ye.range.contains(_e))throw new Error("INVALID selection range, must contain the previous range");if(We.push(d.SelectionRange.from(Ye)),!Ye.parent)break;_e=Ye.range,Ye=Ye.parent}}return ye}}class Ee{constructor(B,Q){this.f=B,this.g=Q,this.d=new s.$fM(""),this.e=new Map}async prepareSession(B,Q,te){const se=this.f.getDocument(B),X=d.Position.to(Q),de=await this.g.prepareCallHierarchy(se,X,te);if(!de)return;const ye=this.d.nextId();return this.e.set(ye,new Map),Array.isArray(de)?de.map(je=>this.h(ye,je)):[this.h(ye,de)]}async provideCallsTo(B,Q,te){const se=this.j(B,Q);if(!se)throw new Error("missing call hierarchy item");const X=await this.g.provideCallHierarchyIncomingCalls(se,te);if(X)return X.map(de=>({from:this.h(B,de.from),fromRanges:de.fromRanges.map(ye=>d.Range.from(ye))}))}async provideCallsFrom(B,Q,te){const se=this.j(B,Q);if(!se)throw new Error("missing call hierarchy item");const X=await this.g.provideCallHierarchyOutgoingCalls(se,te);if(X)return X.map(de=>({to:this.h(B,de.to),fromRanges:de.fromRanges.map(ye=>d.Range.from(ye))}))}releaseSession(B){this.e.delete(B)}h(B,Q){const te=this.e.get(B),se=d.CallHierarchyItem.from(Q,B,te.size.toString(36));return te.set(se._itemId,Q),se}j(B,Q){return this.e.get(B)?.get(Q)}}class oe{constructor(B,Q){this.f=B,this.g=Q,this.d=new s.$fM(""),this.e=new Map}async prepareSession(B,Q,te){const se=this.f.getDocument(B),X=d.Position.to(Q),de=await this.g.prepareTypeHierarchy(se,X,te);if(!de)return;const ye=this.d.nextId();return this.e.set(ye,new Map),Array.isArray(de)?de.map(je=>this.h(ye,je)):[this.h(ye,de)]}async provideSupertypes(B,Q,te){const se=this.j(B,Q);if(!se)throw new Error("missing type hierarchy item");const X=await this.g.provideTypeHierarchySupertypes(se,te);if(X)return X.map(de=>this.h(B,de))}async provideSubtypes(B,Q,te){const se=this.j(B,Q);if(!se)throw new Error("missing type hierarchy item");const X=await this.g.provideTypeHierarchySubtypes(se,te);if(X)return X.map(de=>this.h(B,de))}releaseSession(B){this.e.delete(B)}h(B,Q){const te=this.e.get(B),se=d.TypeHierarchyItem.from(Q,B,te.size.toString(36));return te.set(se._itemId,Q),se}j(B,Q){return this.e.get(B)?.get(Q)}}class he{static toInternalProviderId(B,Q){return B+"."+Q}constructor(B,Q,te,se,X){this.d=B,this.e=Q,this.f=te,this.g=se,this.h=X}async provideDocumentOnDropEdits(B,Q,te,se,X){const de=this.e.getDocument(Q),ye=d.Position.to(te),je=d.DataTransfer.toDataTransfer(se,async _e=>(await this.d.$resolveDocumentOnDropFileData(this.g,B,_e)).buffer),We=await this.f.provideDocumentDropEdits(de,ye,je,X);if(We)return{label:We.label??(0,n.localize)(1,null,this.h.displayName||this.h.name),yieldTo:We.yieldTo?.map(_e=>"mimeType"in _e?_e:{providerId:he.toInternalProviderId(_e.extensionId,_e.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?d.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class ee{constructor(B,Q){this.d=B,this.e=Q}async provideMappedEdits(B,Q,te,se){const X=C.URI.revive(B),de=this.d.getDocument(X),ye=te.documents.map(_e=>_e.map(Ye=>({uri:C.URI.revive(Ye.uri),version:Ye.version,ranges:Ye.ranges.map(it=>d.Range.to(it))}))),je={documents:ye,selections:ye[0]?.[0]?.ranges??[]},We=await this.e.provideMappedEdits(de,Q,je,se);return We?d.WorkspaceEdit.from(We):null}}class le{constructor(B,Q){this.adapter=B,this.extension=Q}}class $e{static{this.d=0}constructor(B,Q,te,se,X,de,ye,je){this.g=Q,this.h=te,this.j=se,this.k=X,this.l=de,this.m=ye,this.n=je,this.f=new Map,this.e=B.getProxy(b.$_J.MainThreadLanguageFeatures)}o(B,Q){return d.DocumentSelector.from(B,this.g,Q)}p(B){return new M.$bK(()=>{this.f.delete(B),this.e.$unregister(B)})}q(){return $e.d++}async s(B,Q,te,se,X,de=!1){const ye=this.f.get(B);if(!ye||!(ye.adapter instanceof Q))return se;const je=Date.now();de||this.l.trace(`[${ye.extension.identifier.value}] INVOKE provider '${te.toString().replace(/[\r\n]/g,"")}'`);const We=te(ye.adapter,ye.extension);return Promise.resolve(We).catch(_e=>{(0,m.$3)(_e)||(this.l.error(`[${ye.extension.identifier.value}] provider FAILED`),this.l.error(_e),this.n.onExtensionError(ye.extension.identifier,_e))}).finally(()=>{de||this.l.trace(`[${ye.extension.identifier.value}] provider DONE after ${Date.now()-je}ms`)}),y.CancellationToken.isCancellationToken(X)?(0,h.$Ig)(We,X):We}t(B,Q){const te=this.q();return this.f.set(te,new le(B,Q)),te}static u(B){return B.displayName||B.name}registerDocumentSymbolProvider(B,Q,te,se){const X=this.t(new o(this.h,te),B),de=se&&se.label||$e.u(B);return this.e.$registerDocumentSymbolProvider(X,this.o(Q,B),de),this.p(X)}$provideDocumentSymbols(B,Q,te){return this.s(B,o,se=>se.provideDocumentSymbols(C.URI.revive(Q),te),void 0,te)}registerCodeLensProvider(B,Q,te){const se=this.q(),X=typeof te.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(se,new le(new i(this.h,this.j.converter,te),B)),this.e.$registerCodeLensSupport(se,this.o(Q,B),X);let de=this.p(se);if(X!==void 0){const ye=te.onDidChangeCodeLenses(je=>this.e.$emitCodeLensEvent(X));de=M.$bK.from(de,ye)}return de}$provideCodeLenses(B,Q,te){return this.s(B,i,se=>se.provideCodeLenses(C.URI.revive(Q),te),void 0,te)}$resolveCodeLens(B,Q,te){return this.s(B,i,se=>se.resolveCodeLens(Q,te),void 0,void 0)}$releaseCodeLenses(B,Q){this.s(B,i,te=>Promise.resolve(te.releaseCodeLenses(Q)),void 0,void 0)}registerDefinitionProvider(B,Q,te){const se=this.t(new u(this.h,te),B);return this.e.$registerDefinitionSupport(se,this.o(Q,B)),this.p(se)}$provideDefinition(B,Q,te,se){return this.s(B,u,X=>X.provideDefinition(C.URI.revive(Q),te,se),[],se)}registerDeclarationProvider(B,Q,te){const se=this.t(new k(this.h,te),B);return this.e.$registerDeclarationSupport(se,this.o(Q,B)),this.p(se)}$provideDeclaration(B,Q,te,se){return this.s(B,k,X=>X.provideDeclaration(C.URI.revive(Q),te,se),[],se)}registerImplementationProvider(B,Q,te){const se=this.t(new S(this.h,te),B);return this.e.$registerImplementationSupport(se,this.o(Q,B)),this.p(se)}$provideImplementation(B,Q,te,se){return this.s(B,S,X=>X.provideImplementation(C.URI.revive(Q),te,se),[],se)}registerTypeDefinitionProvider(B,Q,te){const se=this.t(new $(this.h,te),B);return this.e.$registerTypeDefinitionSupport(se,this.o(Q,B)),this.p(se)}$provideTypeDefinition(B,Q,te,se){return this.s(B,$,X=>X.provideTypeDefinition(C.URI.revive(Q),te,se),[],se)}registerHoverProvider(B,Q,te,se){const X=this.t(new g(this.h,te),B);return this.e.$registerHoverProvider(X,this.o(Q,B)),this.p(X)}$provideHover(B,Q,te,se){return this.s(B,g,X=>X.provideHover(C.URI.revive(Q),te,se),void 0,se)}registerEvaluatableExpressionProvider(B,Q,te,se){const X=this.t(new f(this.h,te),B);return this.e.$registerEvaluatableExpressionProvider(X,this.o(Q,B)),this.p(X)}$provideEvaluatableExpression(B,Q,te,se){return this.s(B,f,X=>X.provideEvaluatableExpression(C.URI.revive(Q),te,se),void 0,se)}registerInlineValuesProvider(B,Q,te,se){const X=typeof te.onDidChangeInlineValues=="function"?this.q():void 0,de=this.t(new P(this.h,te),B);this.e.$registerInlineValuesProvider(de,this.o(Q,B),X);let ye=this.p(de);if(X!==void 0){const je=te.onDidChangeInlineValues(We=>this.e.$emitInlineValuesEvent(X));ye=M.$bK.from(ye,je)}return ye}$provideInlineValues(B,Q,te,se,X){return this.s(B,P,de=>de.provideInlineValues(C.URI.revive(Q),te,se,X),void 0,X)}registerDocumentHighlightProvider(B,Q,te){const se=this.t(new N(this.h,te),B);return this.e.$registerDocumentHighlightProvider(se,this.o(Q,B)),this.p(se)}$provideDocumentHighlights(B,Q,te,se){return this.s(B,N,X=>X.provideDocumentHighlights(C.URI.revive(Q),te,se),void 0,se)}registerLinkedEditingRangeProvider(B,Q,te){const se=this.t(new O(this.h,te),B);return this.e.$registerLinkedEditingRangeProvider(se,this.o(Q,B)),this.p(se)}$provideLinkedEditingRanges(B,Q,te,se){return this.s(B,O,async X=>{const de=await X.provideLinkedEditingRanges(C.URI.revive(Q),te,se);if(de)return{ranges:de.ranges,wordPattern:de.wordPattern?$e.w(de.wordPattern):void 0}},void 0,se)}registerReferenceProvider(B,Q,te){const se=this.t(new L(this.h,te),B);return this.e.$registerReferenceSupport(se,this.o(Q,B)),this.p(se)}$provideReferences(B,Q,te,se,X){return this.s(B,L,de=>de.provideReferences(C.URI.revive(Q),te,se,X),void 0,X)}registerCodeActionProvider(B,Q,te,se){const X=new v.$Qc,de=this.t(new j(this.h,this.j.converter,this.k,te,this.l,B,this.m),B);return this.e.$registerQuickFixSupport(de,this.o(Q,B),{providedKinds:se?.providedCodeActionKinds?.map(ye=>ye.value),documentation:se?.documentation?.map(ye=>({kind:ye.kind.value,command:this.j.converter.toInternal(ye.command,X)}))},$e.u(B),!!te.resolveCodeAction),X.add(this.p(de)),X}$provideCodeActions(B,Q,te,se,X){return this.s(B,j,de=>de.provideCodeActions(C.URI.revive(Q),te,se,X),void 0,X)}$resolveCodeAction(B,Q,te){return this.s(B,j,se=>se.resolveCodeAction(Q,te),{},void 0)}$releaseCodeActions(B,Q){this.s(B,j,te=>Promise.resolve(te.releaseCodeActions(Q)),void 0,void 0)}registerDocumentFormattingEditProvider(B,Q,te){const se=this.t(new F(this.h,te),B);return this.e.$registerDocumentFormattingSupport(se,this.o(Q,B),B.identifier,B.displayName||B.name),this.p(se)}$provideDocumentFormattingEdits(B,Q,te,se){return this.s(B,F,X=>X.provideDocumentFormattingEdits(C.URI.revive(Q),te,se),void 0,se)}registerDocumentRangeFormattingEditProvider(B,Q,te){const se=typeof te.provideDocumentRangesFormattingEdits=="function",X=this.t(new H(this.h,te),B);return this.e.$registerRangeFormattingSupport(X,this.o(Q,B),B.identifier,B.displayName||B.name,se),this.p(X)}$provideDocumentRangeFormattingEdits(B,Q,te,se,X){return this.s(B,H,de=>de.provideDocumentRangeFormattingEdits(C.URI.revive(Q),te,se,X),void 0,X)}$provideDocumentRangesFormattingEdits(B,Q,te,se,X){return this.s(B,H,de=>de.provideDocumentRangesFormattingEdits(C.URI.revive(Q),te,se,X),void 0,X)}registerOnTypeFormattingEditProvider(B,Q,te,se){const X=this.t(new K(this.h,te),B);return this.e.$registerOnTypeFormattingSupport(X,this.o(Q,B),se,B.identifier),this.p(X)}$provideOnTypeFormattingEdits(B,Q,te,se,X,de){return this.s(B,K,ye=>ye.provideOnTypeFormattingEdits(C.URI.revive(Q),te,se,X,de),void 0,de)}registerWorkspaceSymbolProvider(B,Q){const te=this.t(new fe(Q,this.l),B);return this.e.$registerNavigateTypeSupport(te,typeof Q.resolveWorkspaceSymbol=="function"),this.p(te)}$provideWorkspaceSymbols(B,Q,te){return this.s(B,fe,se=>se.provideWorkspaceSymbols(Q,te),{symbols:[]},te)}$resolveWorkspaceSymbol(B,Q,te){return this.s(B,fe,se=>se.resolveWorkspaceSymbol(Q,te),void 0,void 0)}$releaseWorkspaceSymbols(B,Q){this.s(B,fe,te=>te.releaseWorkspaceSymbols(Q),void 0,void 0)}registerRenameProvider(B,Q,te){const se=this.t(new x(this.h,te,this.l),B);return this.e.$registerRenameSupport(se,this.o(Q,B),x.supportsResolving(te)),this.p(se)}$provideRenameEdits(B,Q,te,se,X){return this.s(B,x,de=>de.provideRenameEdits(C.URI.revive(Q),te,se,X),void 0,X)}$resolveRenameLocation(B,Q,te,se){return this.s(B,x,X=>X.resolveRenameLocation(C.URI.revive(Q),te,se),void 0,se)}registerDocumentSemanticTokensProvider(B,Q,te,se){const X=this.t(new q(this.h,te),B),de=typeof te.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(X,this.o(Q,B),se,de);let ye=this.p(X);if(de){const je=te.onDidChangeSemanticTokens(We=>this.e.$emitDocumentSemanticTokensEvent(de));ye=M.$bK.from(ye,je)}return ye}$provideDocumentSemanticTokens(B,Q,te,se){return this.s(B,q,X=>X.provideDocumentSemanticTokens(C.URI.revive(Q),te,se),null,se)}$releaseDocumentSemanticTokens(B,Q){this.s(B,q,te=>te.releaseDocumentSemanticColoring(Q),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(B,Q,te,se){const X=this.t(new Y(this.h,te),B);return this.e.$registerDocumentRangeSemanticTokensProvider(X,this.o(Q,B),se),this.p(X)}$provideDocumentRangeSemanticTokens(B,Q,te,se){return this.s(B,Y,X=>X.provideDocumentRangeSemanticTokens(C.URI.revive(Q),te,se),null,se)}registerCompletionItemProvider(B,Q,te,se){const X=this.t(new be(this.h,this.j.converter,te,this.m,B),B);return this.e.$registerCompletionsProvider(X,this.o(Q,B),se,be.supportsResolving(te),B.identifier),this.p(X)}$provideCompletionItems(B,Q,te,se,X){return this.s(B,be,de=>de.provideCompletionItems(C.URI.revive(Q),te,se,X),void 0,X)}$resolveCompletionItem(B,Q,te){return this.s(B,be,se=>se.resolveCompletionItem(Q,te),void 0,te)}$releaseCompletionItems(B,Q){this.s(B,be,te=>te.releaseCompletionItems(Q),void 0,void 0)}registerInlineCompletionsProvider(B,Q,te,se){const X=new ve(B,this.h,te,this.j.converter),de=this.t(X,B);return this.e.$registerInlineCompletionsSupport(de,this.o(Q,B),X.supportsHandleEvents,D.$2l.toKey(B.identifier.value),se?.yieldTo?.map(ye=>D.$2l.toKey(ye))||[]),this.p(de)}$provideInlineCompletions(B,Q,te,se,X){return this.s(B,ue,de=>de.provideInlineCompletions(C.URI.revive(Q),te,se,X),void 0,X)}$handleInlineCompletionDidShow(B,Q,te,se){this.s(B,ue,async X=>{X.handleDidShowCompletionItem(Q,te,se)},void 0,void 0)}$handleInlineCompletionPartialAccept(B,Q,te,se){this.s(B,ue,async X=>{X.handlePartialAccept(Q,te,se)},void 0,void 0)}$freeInlineCompletionsList(B,Q){this.s(B,ue,async te=>{te.disposeCompletions(Q)},void 0,void 0)}registerSignatureHelpProvider(B,Q,te,se){const X=Array.isArray(se)?{triggerCharacters:se,retriggerCharacters:[]}:se,de=this.t(new U(this.h,te),B);return this.e.$registerSignatureHelpProvider(de,this.o(Q,B),X),this.p(de)}$provideSignatureHelp(B,Q,te,se,X){return this.s(B,U,de=>de.provideSignatureHelp(C.URI.revive(Q),te,se,X),void 0,X)}$releaseSignatureHelp(B,Q){this.s(B,U,te=>te.releaseSignatureHelp(Q),void 0,void 0)}registerInlayHintsProvider(B,Q,te){const se=typeof te.onDidChangeInlayHints=="function"?this.q():void 0,X=this.t(new V(this.h,this.j.converter,te,this.l,B),B);this.e.$registerInlayHintsProvider(X,this.o(Q,B),typeof te.resolveInlayHint=="function",se,$e.u(B));let de=this.p(X);if(se!==void 0){const ye=te.onDidChangeInlayHints(je=>this.e.$emitInlayHintsEvent(se));de=M.$bK.from(de,ye)}return de}$provideInlayHints(B,Q,te,se){return this.s(B,V,X=>X.provideInlayHints(C.URI.revive(Q),te,se),void 0,se)}$resolveInlayHint(B,Q,te){return this.s(B,V,se=>se.resolveInlayHint(Q,te),void 0,te)}$releaseInlayHints(B,Q){this.s(B,V,te=>te.releaseHints(Q),void 0,void 0)}registerDocumentLinkProvider(B,Q,te){const se=this.t(new ge(this.h,te),B);return this.e.$registerDocumentLinkProvider(se,this.o(Q,B),typeof te.resolveDocumentLink=="function"),this.p(se)}$provideDocumentLinks(B,Q,te){return this.s(B,ge,se=>se.provideLinks(C.URI.revive(Q),te),void 0,te,Q.scheme==="output")}$resolveDocumentLink(B,Q,te){return this.s(B,ge,se=>se.resolveLink(Q,te),void 0,void 0,!0)}$releaseDocumentLinks(B,Q){this.s(B,ge,te=>te.releaseLinks(Q),void 0,void 0,!0)}registerColorProvider(B,Q,te){const se=this.t(new _(this.h,te),B);return this.e.$registerDocumentColorProvider(se,this.o(Q,B)),this.p(se)}$provideDocumentColors(B,Q,te){return this.s(B,_,se=>se.provideColors(C.URI.revive(Q),te),[],te)}$provideColorPresentations(B,Q,te,se){return this.s(B,_,X=>X.provideColorPresentations(C.URI.revive(Q),te,se),void 0,se)}registerFoldingRangeProvider(B,Q,te){const se=this.q(),X=typeof te.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(se,new le(new ie(this.h,te),B)),this.e.$registerFoldingRangeProvider(se,this.o(Q,B),B.identifier,X);let de=this.p(se);if(X!==void 0){const ye=te.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(X));de=M.$bK.from(de,ye)}return de}$provideFoldingRanges(B,Q,te,se){return this.s(B,ie,X=>X.provideFoldingRanges(C.URI.revive(Q),te,se),void 0,se)}registerSelectionRangeProvider(B,Q,te){const se=this.t(new re(this.h,te,this.l),B);return this.e.$registerSelectionRangeProvider(se,this.o(Q,B)),this.p(se)}$provideSelectionRanges(B,Q,te,se){return this.s(B,re,X=>X.provideSelectionRanges(C.URI.revive(Q),te,se),[],se)}registerCallHierarchyProvider(B,Q,te){const se=this.t(new Ee(this.h,te),B);return this.e.$registerCallHierarchyProvider(se,this.o(Q,B)),this.p(se)}$prepareCallHierarchy(B,Q,te,se){return this.s(B,Ee,X=>Promise.resolve(X.prepareSession(C.URI.revive(Q),te,se)),void 0,se)}$provideCallHierarchyIncomingCalls(B,Q,te,se){return this.s(B,Ee,X=>X.provideCallsTo(Q,te,se),void 0,se)}$provideCallHierarchyOutgoingCalls(B,Q,te,se){return this.s(B,Ee,X=>X.provideCallsFrom(Q,te,se),void 0,se)}$releaseCallHierarchy(B,Q){this.s(B,Ee,te=>Promise.resolve(te.releaseSession(Q)),void 0,void 0)}registerTypeHierarchyProvider(B,Q,te){const se=this.t(new oe(this.h,te),B);return this.e.$registerTypeHierarchyProvider(se,this.o(Q,B)),this.p(se)}$prepareTypeHierarchy(B,Q,te,se){return this.s(B,oe,X=>Promise.resolve(X.prepareSession(C.URI.revive(Q),te,se)),void 0,se)}$provideTypeHierarchySupertypes(B,Q,te,se){return this.s(B,oe,X=>X.provideSupertypes(Q,te,se),void 0,se)}$provideTypeHierarchySubtypes(B,Q,te,se){return this.s(B,oe,X=>X.provideSubtypes(Q,te,se),void 0,se)}$releaseTypeHierarchy(B,Q){this.s(B,oe,te=>Promise.resolve(te.releaseSession(Q)),void 0,void 0)}registerDocumentOnDropEditProvider(B,Q,te,se){const X=this.q();this.f.set(X,new le(new he(this.e,this.h,te,X,B),B));const de=(0,t.$$E)(B,"dropMetadata")&&se?he.toInternalProviderId(B.identifier.value,se.id):void 0;return this.e.$registerDocumentOnDropEditProvider(X,this.o(Q,B),de,(0,t.$$E)(B,"dropMetadata")?se:void 0),this.p(X)}$provideDocumentOnDropEdits(B,Q,te,se,X,de){return this.s(B,he,ye=>Promise.resolve(ye.provideDocumentOnDropEdits(Q,C.URI.revive(te),se,X,de)),void 0,void 0)}registerMappedEditsProvider(B,Q,te){const se=this.t(new ee(this.h,te),B);return this.e.$registerMappedEditsProvider(se,this.o(Q,B)),this.p(se)}$provideMappedEdits(B,Q,te,se,X){return this.s(B,ee,de=>Promise.resolve(de.provideMappedEdits(Q,te,se,X)),null,X)}registerDocumentPasteEditProvider(B,Q,te,se){const X=this.q();this.f.set(X,new le(new z(this.e,this.h,te,X,B),B));const de=z.toInternalProviderId(B.identifier.value,se.id);return this.e.$registerPasteEditProvider(X,this.o(Q,B),de,{supportsCopy:!!te.prepareDocumentPaste,supportsPaste:!!te.provideDocumentPasteEdits,copyMimeTypes:se.copyMimeTypes,pasteMimeTypes:se.pasteMimeTypes}),this.p(X)}$prepareDocumentPaste(B,Q,te,se,X){return this.s(B,z,de=>de.prepareDocumentPaste(C.URI.revive(Q),te,se,X),void 0,X)}$providePasteEdits(B,Q,te,se,X,de){return this.s(B,z,ye=>ye.providePasteEdits(Q,C.URI.revive(te),se,X,de),void 0,de)}static w(B){return{pattern:B.source,flags:B.flags}}static y(B){return{decreaseIndentPattern:$e.w(B.decreaseIndentPattern),increaseIndentPattern:$e.w(B.increaseIndentPattern),indentNextLinePattern:B.indentNextLinePattern?$e.w(B.indentNextLinePattern):void 0,unIndentedLinePattern:B.unIndentedLinePattern?$e.w(B.unIndentedLinePattern):void 0}}static z(B){return{beforeText:$e.w(B.beforeText),afterText:B.afterText?$e.w(B.afterText):void 0,previousLineText:B.previousLineText?$e.w(B.previousLineText):void 0,action:B.action}}static B(B){return B.map($e.z)}static C(B){return{open:B.open,close:B.close,notIn:B.notIn?B.notIn.map(Q=>M.SyntaxTokenType.toString(Q)):void 0}}static D(B){return B.map($e.C)}setLanguageConfiguration(B,Q,te){const{wordPattern:se}=te;if(se&&(0,E.$Ne)(se))throw new Error(`Invalid language configuration: wordPattern '${se}' is not allowed to match the empty string.`);se?this.h.setWordDefinitionFor(Q,se):this.h.setWordDefinitionFor(Q,void 0),te.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",B,"Do not use."),te.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",B,"Do not use.");const X=this.q(),de={comments:te.comments,brackets:te.brackets,wordPattern:te.wordPattern?$e.w(te.wordPattern):void 0,indentationRules:te.indentationRules?$e.y(te.indentationRules):void 0,onEnterRules:te.onEnterRules?$e.B(te.onEnterRules):void 0,__electricCharacterSupport:te.__electricCharacterSupport,__characterPairSupport:te.__characterPairSupport,autoClosingPairs:te.autoClosingPairs?$e.D(te.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(X,Q,de),this.p(X)}$setWordDefinitions(B){for(const Q of B)this.h.setWordDefinitionFor(Q.languageId,new RegExp(Q.regexSource,Q.regexFlags))}}e.$Sbc=$e}),define(De[316],Ce([1,0,6,14,7,38,9,3,26]),function(me,e,C,T,d,M,A,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Acc=void 0;class w{constructor(I,p,y,D){this.c=p,this.d=y,this.e=D,this.b=[],this.f=0,this.g=new Set,this.a=I.getProxy(C.$_J.MainThreadLanguages)}$acceptLanguageIds(I){this.b=I}async getLanguages(){return this.b.slice(0)}async changeLanguage(I,p){await this.a.$changeLanguage(I,p);const y=this.c.getDocumentData(I);if(!y)throw new Error(`document '${I.toString()}' NOT found`);return y.document}async tokenAtPosition(I,p){const y=I.version,D=T.Position.from(p),v=await this.a.$tokensAtPosition(I.uri,D),l={type:d.StandardTokenType.Other,range:I.getWordRangeAtPosition(p)??new d.$dK(p.line,p.character,p.line,p.character)};if(!v)return l;const s={range:T.Range.to(v.range),type:T.TokenType.to(v.type)};return!s.range.contains(p)||y!==I.version?l:s}createLanguageStatusItem(I,p,y){const D=this.f++,v=this.a,l=this.g,s=`${I.identifier.value}/${p}`;if(l.has(s))throw new Error(`LanguageStatusItem with id '${p}' ALREADY exists`);l.add(s);const r={selector:y,id:p,name:I.displayName??I.name,severity:d.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let c;const m=new b.$Qc,h=()=>{if(c?.dispose(),!l.has(s)){console.warn(`LanguageStatusItem (${p}) from ${I.identifier.value} has been disposed and CANNOT be updated anymore`);return}c=(0,A.$Ug)(()=>{m.clear(),this.a.$setLanguageStatus(D,{id:s,name:r.name??I.displayName??I.name,source:I.displayName??I.name,selector:T.DocumentSelector.from(r.selector,this.e),label:r.text,detail:r.detail??"",severity:r.severity===d.LanguageStatusSeverity.Error?M.default.Error:r.severity===d.LanguageStatusSeverity.Warning?M.default.Warning:M.default.Info,command:r.command&&this.d.toInternal(r.command,m),accessibilityInfo:r.accessibilityInformation,busy:r.busy})},0)},t={dispose(){m.dispose(),c?.dispose(),v.$removeLanguageStatus(D),l.delete(s)},get id(){return r.id},get name(){return r.name},set name(n){r.name=n,h()},get selector(){return r.selector},set selector(n){r.selector=n,h()},get text(){return r.text},set text(n){r.text=n,h()},set text2(n){(0,E.$_E)(I,"languageStatusText"),r.text=n,h()},get text2(){return(0,E.$_E)(I,"languageStatusText"),r.text},get detail(){return r.detail},set detail(n){r.detail=n,h()},get severity(){return r.severity},set severity(n){r.severity=n,h()},get accessibilityInformation(){return r.accessibilityInformation},set accessibilityInformation(n){r.accessibilityInformation=n,h()},get command(){return r.command},set command(n){r.command=n,h()},get busy(){return r.busy},set busy(n){r.busy=n,h()}};return h(),t}}e.$Acc=w}),define(De[112],Ce([1,0,12,15,2,5,13,6,27,20]),function(me,e,C,T,d,M,A,b,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qcc=e.$pcc=void 0;let R=class{constructor(p,y,D){this.f=D,this.d=new Map,this.a=y.getProxy(b.$_J.MainThreadLocalization),this.b=p.environment.appLanguage,this.c=this.b===C.$g}getMessage(p,y){const{message:D,args:v,comment:l}=y;if(this.c)return(0,T.$Ce)(D,v??{});let s=D;l&&l.length>0&&(s+=`/${Array.isArray(l)?l.join(""):l}`);const r=this.d.get(p)?.contents[s];return r||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${s}`),(0,T.$Ce)(r??D,v??{})}getBundle(p){return this.d.get(p)?.contents}getBundleUri(p){return this.d.get(p)?.uri}async initializeLocalizedMessages(p){if(this.c||!p.l10n&&!p.isBuiltin||this.d.has(p.identifier.value))return;let y;const D=await this.g(p);if(!D){this.f.error(`No bundle location found for extension ${p.identifier.value}`);return}try{const v=await this.a.$fetchBundleContents(D),l=JSON.parse(v);y=p.isBuiltin?l.contents?.bundle:l}catch(v){this.f.error(`Failed to load translations for ${p.identifier.value} from ${D}: ${v.message}`);return}y&&this.d.set(p.identifier.value,{contents:y,uri:D})}async g(p){if(p.isBuiltin){const y=await this.a.$fetchBuiltInBundleUri(p.identifier.value,this.b);return d.URI.revive(y)}return p.l10n?d.URI.joinPath(p.extensionLocation,p.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$pcc=R,e.$pcc=R=He([Be(0,E.$qM),Be(1,w.$aM),Be(2,A.$8i)],R),e.$qcc=(0,M.$Nh)("IExtHostLocalizationService")}),define(De[150],Ce([1,0,13,6,27,20,2,62]),function(me,e,C,T,d,M,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qdc=void 0;let E=class extends C.$gj{constructor(I,p){super(p.logLevel,p.logsLocation,p.loggers.map(y=>(0,b.$kh)(y))),this.r=I.getProxy(T.$_J.MainThreadLogger)}$setLogLevel(I,p){p?this.setLogLevel(A.URI.revive(p),I):this.setLogLevel(I)}setVisibility(I,p){super.setVisibility(I,p),this.r.$setVisibility(I,p)}s(I,p,y){return new w(this.r,I,p,y)}};e.$Qdc=E,e.$Qdc=E=He([Be(0,M.$aM),Be(1,d.$qM)],E);class w extends C.$bj{constructor(I,p,y,D){super(D?.logLevel==="always"),this.r=I,this.s=p,this.m=!1,this.n=[],this.setLevel(y),this.r.$createLogger(p,D).then(()=>{this.u(this.n),this.m=!0})}g(I,p){const y=[[I,p]];this.m?this.u(y):this.n.push(...y)}u(I){this.r.$log(this.s,I)}flush(){this.r.$flush(this.s)}}}),define(De[113],Ce([1,0,6,5,3,20,22]),function(me,e,C,T,d,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$scc=e.$rcc=void 0,e.$rcc=(0,T.$Nh)("IExtHostManagedSockets");let b=class{constructor(I){this.b=0,this.c=null,this.d=new Map,this.a=I.getProxy(C.$_J.MainThreadManagedSockets)}setFactory(I,p){for(const y of this.d.values())y.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new E(I,p),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(I){if(!this.c||this.c.socketFactoryId!==I)throw new Error(`No socket factory with id ${I}`);const p=++this.b,y=await this.c.makeConnection(),D=new d.$Qc;return this.d.set(p,new w(p,y,D)),D.add((0,d.$Pc)(()=>this.d.delete(p))),D.add(y.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(p),D.dispose()})),D.add(y.onDidClose(v=>{this.a.$onDidManagedSocketClose(p,v?.stack??v?.message),D.dispose()})),D.add(y.onDidReceiveMessage(v=>this.a.$onDidManagedSocketHaveData(p,A.$ae.wrap(v)))),p}$remoteSocketWrite(I,p){this.d.get(I)?.actual.send(p.buffer)}$remoteSocketEnd(I){const p=this.d.get(I);p&&(p.actual.end(),p.dispose())}async $remoteSocketDrain(I){await this.d.get(I)?.actual.drain?.()}};e.$scc=b,e.$scc=b=He([Be(0,M.$aM)],b);class E{constructor(I,p){this.socketFactoryId=I,this.makeConnection=p}}class w extends d.$Rc{constructor(I,p,y){super(),this.socketId=I,this.actual=p,this.B(y)}}}),define(De[317],Ce([1,0,6,13,26]),function(me,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bcc=void 0;function M(b){return b&&b.title}let A=class{constructor(E,w){this.b=w,this.a=E.getProxy(C.$_J.MainThreadMessageService)}showMessage(E,w,R,I,p){const y={source:{identifier:E.identifier,label:E.displayName||E.name}};let D;typeof I=="string"||M(I)?D=[I,...p]:(y.modal=I?.modal,y.useCustom=I?.useCustom,y.detail=I?.detail,D=p),y.useCustom&&(0,d.$_E)(E,"resolvers");const v=[];for(let l=0;l<D.length;l++){const s=D[l];if(typeof s=="string")v.push({title:s,handle:l,isCloseAffordance:!1});else if(typeof s=="object"){const{title:r,isCloseAffordance:c}=s;v.push({title:r,isCloseAffordance:!!c,handle:l})}else this.b.warn("Invalid message item:",s)}return this.a.$showMessage(w,R,y,v).then(l=>{if(typeof l=="number")return D[l]})}};e.$Bcc=A,e.$Bcc=A=He([Be(1,T.$8i)],A)}),define(De[318],Ce([1,0,207,22,4,3,28,15,18,2,30,107,6,33,14,7,68,281,144,8,23,17]),function(me,e,C,T,d,M,A,b,E,w,R,I,p,y,D,v,l,s,r,c,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jdc=void 0;class t{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(o=>o.apiEditor)}constructor(o,i,a,u,k){this.q=a,this.r=u,this.s=k,this.f=new Map,this.g=new A.$zc,this.h=new Map,this.j=new d.$Md({onListenerError:c.$1}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new d.$Md({onListenerError:c.$1}),this.onDidOpenNotebookDocument=this.m.event,this.n=new d.$Md({onListenerError:c.$1}),this.onDidCloseNotebookDocument=this.n.event,this.o=new d.$Md({onListenerError:c.$1}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new I.$Jbc("NotebookCellStatusBarCache"),this.u=0,this.w=new Map,this.b=o.getProxy(p.$_J.MainThreadNotebook),this.c=o.getProxy(p.$_J.MainThreadNotebookDocuments),this.d=o.getProxy(p.$_J.MainThreadNotebookEditors),this.i=i.converter,i.registerArgumentProcessor({processArgument:S=>{if(S&&S.$mid===13){const $=S.notebookEditor?.notebookUri,g=S.cell.handle,P=this.g.get($)?.getCell(g);if(P)return P.apiCell}if(S&&S.$mid===14){const $=S.uri,g=this.g.get($);if(g)return g.apiNotebook}return S}}),t.A(i)}getEditorById(o){const i=this.h.get(o);if(!i)throw new Error(`unknown text editor: ${o}. known editors: ${[...this.h.keys()]} `);return i}getIdByEditor(o){for(const[i,a]of this.h)if(a.apiEditor===o)return i}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(o,i){const a=this.g.get(o);if(!a&&!i)throw new Error(`NO notebook document for '${o}'`);return a}static t(o,i){if(!i)return;const a=i.filenamePattern.map(u=>D.NotebookExclusiveDocumentPattern.from(u)).filter(u=>u!==void 0);if(i.filenamePattern&&!a){console.warn(`Notebook content provider view options file name pattern is invalid ${i.filenamePattern}`);return}return{extension:o.identifier,providerDisplayName:o.displayName||o.name,displayName:i.displayName,filenamePattern:a,exclusive:i.exclusive||!1}}registerNotebookCellStatusBarItemProvider(o,i,a){const u=t.a++,k=typeof a.onDidChangeCellStatusBarItems=="function"?t.a++:void 0;this.f.set(u,a),this.b.$registerNotebookCellStatusBarItemProvider(u,k,i);let S;return k!==void 0&&(S=a.onDidChangeCellStatusBarItems($=>this.b.$emitCellStatusBarEvent(k))),new v.$bK(()=>{this.f.delete(u),this.b.$unregisterNotebookCellStatusBarItemProvider(u,k),S?.dispose()})}async createNotebookDocument(o){const i=await this.c.$tryCreateNotebook({viewType:o.viewType,content:o.content&&D.NotebookData.from(o.content)});return w.URI.revive(i)}async openNotebookDocument(o){const i=this.g.get(o);if(i)return i.apiNotebook;const a=await this.c.$tryOpenNotebook(o),u=this.g.get(w.URI.revive(a));return(0,E.$If)(u?.apiNotebook)}async showNotebookDocument(o,i){w.URI.isUri(o)&&(o=await this.openNotebookDocument(o));let a;typeof i=="object"?a={position:D.ViewColumn.from(i.viewColumn),preserveFocus:i.preserveFocus,selections:i.selections&&i.selections.map(D.NotebookRange.from),pinned:typeof i.preview=="boolean"?!i.preview:void 0}:a={preserveFocus:!1};const u=await this.d.$tryShowNotebookDocument(o.uri,o.notebookType,a),k=u&&this.h.get(u)?.apiEditor;if(k)return k;throw u?new Error(`Could NOT open editor for "${o.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${o.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(o,i,a,u){const k=this.f.get(o),S=w.URI.revive(i),$=this.g.get(S);if(!$||!k)return;const g=$.getCellFromIndex(a);if(!g)return;const f=await k.provideCellStatusBarItems(g.apiCell,u);if(!f)return;const P=new M.$Qc,N=this.p.add([P]),L=(Array.isArray(f)?f:[f]).map(j=>D.NotebookStatusBarItem.from(j,this.i,P));return{cacheId:N,items:L}}$releaseNotebookCellStatusBarItems(o){this.p.delete(o)}registerNotebookSerializer(o,i,a,u,k){if((0,b.$Ae)(i))throw new Error("viewType cannot be empty or just whitespace");const S=this.u++;return this.w.set(S,{viewType:i,serializer:a,options:u}),this.b.$registerNotebookSerializer(S,{id:o.identifier,location:o.extensionLocation},i,D.NotebookDocumentContentOptions.from(u),t.t(o,k)),(0,M.$Pc)(()=>{this.b.$unregisterNotebookSerializer(S)})}async $dataToNotebook(o,i,a){const u=this.w.get(o);if(!u)throw new Error("NO serializer found");const k=await u.serializer.deserializeNotebook(i.buffer,a);return new l.$kv(D.NotebookData.from(k))}async $notebookToData(o,i,a){const u=this.w.get(o);if(!u)throw new Error("NO serializer found");const k=await u.serializer.serializeNotebook(D.NotebookData.to(i.value),a);return T.$ae.wrap(k)}async $saveNotebook(o,i,a,u,k){const S=w.URI.revive(i),$=this.w.get(o);if(!$)throw new Error("NO serializer found");const g=this.g.get(S);if(!g)throw new Error("Document NOT found");if(g.versionId!==a)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(S.scheme))throw new R.$qk((0,C.localize)(0,null,this.y(S)),6);await this.x(S,u);const f={metadata:(0,m.$0m)(g.apiNotebook.metadata,j=>!($.options?.transientDocumentMetadata??{})[j]),cells:[]};for(const j of g.apiNotebook.getCells()){const z=new v.$zL(j.kind,j.document.getText(),j.document.languageId,j.mime,$.options?.transientOutputs?[]:[...j.outputs],j.metadata,j.executionSummary);z.metadata=(0,m.$0m)(j.metadata,F=>!($.options?.transientCellMetadata??{})[F]),f.cells.push(z)}const P=await $.serializer.serializeNotebook(f,k);await this.s.value.writeFile(S,P);const N=this.s.getFileSystemProviderExtUri(S.scheme),O=await this.s.value.stat(S);return{name:N.basename(S),isFile:(O.type&R.FileType.File)!==0,isDirectory:(O.type&R.FileType.Directory)!==0,isSymbolicLink:(O.type&R.FileType.SymbolicLink)!==0,mtime:O.mtime,ctime:O.ctime,size:O.size,readonly:!!((O.permissions??0)&R.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(S.scheme),locked:!!((O.permissions??0)&R.FilePermission.Locked),etag:R.$Bk({mtime:O.mtime,size:O.size}),children:void 0}}async x(o,i){const a=await this.s.value.stat(o);if(typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==R.$Ak&&typeof a.mtime=="number"&&typeof a.size=="number"&&i.mtime<a.mtime&&i.etag!==R.$Bk({mtime:i.mtime,size:a.size}))throw new R.$qk((0,C.localize)(1,null),3,i)}y(o){return o.scheme===h.Schemas.file?o.fsPath:o.toString()}z(o,i,a){if(this.h.has(i))throw new Error(`editor with id ALREADY EXSIST: ${i}`);const u=new r.$idc(i,this.d,o,a.visibleRanges.map(D.NotebookRange.to),a.selections.map(D.NotebookRange.to),typeof a.viewColumn=="number"?D.ViewColumn.to(a.viewColumn):void 0);this.h.set(i,u)}$acceptDocumentAndEditorsDelta(o){if(o.value.removedDocuments)for(const a of o.value.removedDocuments){const u=w.URI.revive(a),k=this.g.get(u);k&&(k.dispose(),this.g.delete(u),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:k.apiNotebook.getCells().map(S=>S.document.uri)}),this.n.fire(k.apiNotebook));for(const S of this.h.values())S.notebookData.uri.toString()===u.toString()&&this.h.delete(S.id)}if(o.value.addedDocuments){const a=[];for(const u of o.value.addedDocuments){const k=w.URI.revive(u.uri);if(this.g.has(k))throw new Error(`adding EXISTING notebook ${k} `);const S=new s.$hdc(this.c,this.q,this.r,k,u);a.push(...u.cells.map($=>s.$gdc.asModelAddData(S.apiNotebook,$))),this.g.get(k)?.dispose(),this.g.set(k,S),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:a}),this.m.fire(S.apiNotebook)}}if(o.value.addedEditors)for(const a of o.value.addedEditors){if(this.h.has(a.id))return;const u=w.URI.revive(a.documentUri),k=this.g.get(u);k&&this.z(k,a.id,a)}const i=[];if(o.value.removedEditors)for(const a of o.value.removedEditors){const u=this.h.get(a);u&&(this.h.delete(a),this.k?.id===u.id&&(this.k=void 0),i.push(u))}if(o.value.visibleEditors){this.l=o.value.visibleEditors.map(u=>this.h.get(u)).filter(u=>!!u);const a=new Set;this.l.forEach(u=>a.add(u.id));for(const u of this.h.values()){const k=a.has(u.id);u._acceptVisibility(k)}this.l=[...this.h.values()].map(u=>u).filter(u=>u.visible),this.o.fire(this.visibleNotebookEditors)}o.value.newActiveEditor===null?this.k=void 0:o.value.newActiveEditor&&(this.h.get(o.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${o.value.newActiveEditor}`),this.k=this.h.get(o.value.newActiveEditor)),o.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static A(o){const i=y.$yM.String.with("notebookType","A notebook type"),a=new y.$AM("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[i,new y.$yM("data","Bytes to convert to data",k=>k instanceof Uint8Array,k=>T.$ae.wrap(k))],new y.$zM("Notebook Data",k=>D.NotebookData.to(k.value))),u=new y.$AM("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[i,new y.$yM("NotebookData","Notebook data to convert to bytes",k=>!0,k=>new l.$kv(D.NotebookData.from(k)))],new y.$zM("Bytes",k=>k.buffer));o.registerApiCommand(a),o.registerApiCommand(u)}}e.$jdc=t}),define(De[319],Ce([1,0,19,9,21,4,3,28,2,25,13,6,33,14,7,110,275,26,68]),function(me,e,C,T,d,M,A,b,E,w,R,I,p,y,D,v,l,s,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ydc=e.$xdc=void 0;let c=class{constructor(u,k,S,$,g){this.l=k,this.m=S,this.n=$,this.o=g,this.b=new b.$zc,this.c=new b.$zc,this.e=new Map,this.f=0,this.g=new Map,this.h=0,this.i=new Map,this.j=0,this.k=new M.$Md,this.onDidChangeNotebookCellExecutionState=this.k.event,this.a=u.getProxy(I.$_J.MainThreadNotebookKernels);const f=new p.$AM("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new p.$yM("options","Select kernel options",P=>!0,P=>{if(P&&"notebookEditor"in P&&"id"in P){const N=this.m.getIdByEditor(P.notebookEditor);return{id:P.id,extension:P.extension,notebookEditorId:N}}else if(P&&"notebookEditor"in P){const N=this.m.getIdByEditor(P.notebookEditor);if(N===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${P.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:N}}return P})],p.$zM.Void);this.n.registerApiCommand(f)}createNotebookController(u,k,S,$,g,f){for(const Y of this.i.values())if(Y.controller.id===k&&w.$2l.equals(u.identifier,Y.extensionId))throw new Error(`notebook controller with id '${k}' ALREADY exist`);const P=this.j++,N=this;this.o.trace(`NotebookController[${P}], CREATED by ${u.identifier.value}, ${k}`);const O=()=>console.warn(`NO execute handler from notebook controller '${F.id}' of extension: '${u.identifier}'`);let L=!1;const j=new M.$Md,z=new M.$Md,F={id:i(u.identifier,k),notebookType:S,extensionId:u.identifier,extensionLocation:u.extensionLocation,label:$||u.identifier.value,preloads:f?f.map(y.NotebookRendererScript.from):[]};let H=g??O,K;this.a.$addKernel(P,F).catch(Y=>{console.log(Y),L=!0});let fe=0;const x=()=>{if(L)return;const Y=++fe;Promise.resolve().then(()=>{Y===fe&&this.a.$updateKernel(P,F)})},Z=new b.$zc,q={get id(){return k},get notebookType(){return F.notebookType},onDidChangeSelectedNotebooks:j.event,get label(){return F.label},set label(Y){F.label=Y??u.displayName??u.name,x()},get detail(){return F.detail??""},set detail(Y){F.detail=Y,x()},get description(){return F.description??""},set description(Y){F.description=Y,x()},get supportedLanguages(){return F.supportedLanguages},set supportedLanguages(Y){F.supportedLanguages=Y,x()},get supportsExecutionOrder(){return F.supportsExecutionOrder??!1},set supportsExecutionOrder(Y){F.supportsExecutionOrder=Y,x()},get rendererScripts(){return F.preloads?F.preloads.map(y.NotebookRendererScript.to):[]},get executeHandler(){return H},set executeHandler(Y){H=Y??O},get interruptHandler(){return K},set interruptHandler(Y){K=Y,F.supportsInterrupt=!!Y,x()},createNotebookCellExecution(Y){if(L)throw new Error("notebook controller is DISPOSED");if(!Z.has(Y.notebook.uri))throw N.o.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Z.keys()).map(be=>be.toString())),new Error(`notebook controller is NOT associated to notebook: ${Y.notebook.uri.toString()}`);return N._createNotebookCellExecution(Y,i(u.identifier,this.id))},createNotebookExecution(Y){if((0,s.$_E)(u,"notebookExecution"),L)throw new Error("notebook controller is DISPOSED");if(!Z.has(Y.uri))throw N.o.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Z.keys()).map(be=>be.toString())),new Error(`notebook controller is NOT associated to notebook: ${Y.uri.toString()}`);return N._createNotebookExecution(Y,i(u.identifier,this.id))},dispose:()=>{L||(this.o.trace(`NotebookController[${P}], DISPOSED`),L=!0,this.i.delete(P),j.dispose(),z.dispose(),this.a.$removeKernel(P))},updateNotebookAffinity(Y,be){be===D.NotebookControllerAffinity2.Hidden&&(0,s.$_E)(u,"notebookControllerAffinityHidden"),N.a.$updateNotebookPriority(P,Y.uri,be)},onDidReceiveMessage:z.event,postMessage(Y,be){return(0,s.$_E)(u,"notebookMessaging"),N.a.$postMessage(P,be&&N.m.getIdByEditor(be),Y)},asWebviewUri(Y){return(0,s.$_E)(u,"notebookMessaging"),(0,v.$1ob)(Y,N.l.remote)}};return this.i.set(P,{extensionId:u.identifier,controller:q,onDidReceiveMessage:z,onDidChangeSelection:j,associatedNotebooks:Z}),q}getIdByController(u){for(const[k,S]of this.i)if(S.controller===u)return i(S.extensionId,u.id);return null}createNotebookControllerDetectionTask(u,k){const S=this.f++,$=this;this.o.trace(`NotebookControllerDetectionTask[${S}], CREATED by ${u.identifier.value}`),this.a.$addKernelDetectionTask(S,k);const g={dispose:()=>{this.e.delete(S),$.a.$removeKernelDetectionTask(S)}};return this.e.set(S,g),g}registerKernelSourceActionProvider(u,k,S){const $=this.h++,g=typeof S.onDidChangeNotebookKernelSourceActions=="function"?$:void 0,f=this;this.g.set($,S),this.o.trace(`NotebookKernelSourceActionProvider[${$}], CREATED by ${u.identifier.value}`),this.a.$addKernelSourceActionProvider($,$,k);let P;return g!==void 0&&(P=S.onDidChangeNotebookKernelSourceActions(N=>this.a.$emitNotebookKernelSourceActionsChangeEvent(g))),{dispose:()=>{this.g.delete($),f.a.$removeKernelSourceActionProvider($,$),P?.dispose()}}}async $provideKernelSourceActions(u,k){const S=this.g.get(u);if(S){const $=new A.$Qc;return(await S.provideNotebookKernelSourceActions(k)??[]).map(f=>y.NotebookKernelSourceAction.from(f,this.n.converter,$))}return[]}$acceptNotebookAssociation(u,k,S){const $=this.i.get(u);if($){const g=this.m.getNotebookDocument(E.URI.revive(k));S?$.associatedNotebooks.set(g.uri,!0):$.associatedNotebooks.delete(g.uri),this.o.trace(`NotebookController[${u}] ASSOCIATE notebook`,g.uri.toString(),S),$.onDidChangeSelection.fire({selected:S,notebook:g.apiNotebook})}}async $executeCells(u,k,S){const $=this.i.get(u);if(!$)return;const g=this.m.getNotebookDocument(E.URI.revive(k)),f=[];for(const P of S){const N=g.getCell(P);N&&f.push(N.apiCell)}try{this.o.trace(`NotebookController[${u}] EXECUTE cells`,g.uri.toString(),f.length),await $.controller.executeHandler.call($.controller,f,g.apiNotebook,$.controller)}catch(P){this.o.error(`NotebookController[${u}] execute cells FAILED`,P),console.error(P)}}async $cancelCells(u,k,S){const $=this.i.get(u);if(!$)return;const g=this.m.getNotebookDocument(E.URI.revive(k));if($.controller.interruptHandler)await $.controller.interruptHandler.call($.controller,g.apiNotebook);else for(const f of S){const P=g.getCell(f);P&&this.b.get(P.uri)?.cancel()}if($.controller.interruptHandler){const f=this.c.get(g.uri);S.length&&Array.isArray(f)&&f.length&&f.forEach(P=>P.dispose())}}$acceptKernelMessageFromRenderer(u,k,S){const $=this.i.get(u);if(!$)return;const g=this.m.getEditorById(k);$.onDidReceiveMessage.fire(Object.freeze({editor:g.apiEditor,message:S}))}$cellExecutionChanged(u,k,S){const g=this.m.getNotebookDocument(E.URI.revive(u)).getCell(k);if(g){const f=S?y.NotebookCellExecutionState.to(S):D.NotebookCellExecutionState.Idle;f!==void 0&&this.k.fire({cell:g.apiCell,state:f})}}_createNotebookCellExecution(u,k){if(u.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const $=this.m.getNotebookDocument(u.notebook.uri).getCellFromApiCell(u);if(!$)throw new Error("invalid cell");if(this.b.has($.uri))throw new Error(`duplicate execution for ${$.uri}`);const g=new h(k,$,this.a);this.b.set($.uri,g);const f=g.onDidChangeState(()=>{g.state===m.Resolved&&(g.dispose(),f.dispose(),this.b.delete($.uri))});return g.asApiObject()}_createNotebookExecution(u,k){const S=this.m.getNotebookDocument(u.uri),$=u.getCells().find(P=>{const N=S.getCellFromApiCell(P);return N&&this.b.has(N.uri)});if($)throw new Error(`duplicate cell execution for ${$.document.uri}`);if(this.c.has(S.uri))throw new Error(`duplicate notebook execution for ${S.uri}`);const g=new n(k,S,this.a),f=g.onDidChangeState(()=>{g.state===t.Resolved&&(g.dispose(),f.dispose(),this.c.delete(S.uri))});return this.c.set(S.uri,[g,f]),g.asApiObject()}};e.$xdc=c,e.$xdc=c=He([Be(4,R.$8i)],c);var m;(function(a){a[a.Init=0]="Init",a[a.Started=1]="Started",a[a.Resolved=2]="Resolved"})(m||(m={}));class h extends A.$Rc{static{this.a=0}get state(){return this.f}constructor(u,k,S){super(),this.m=k,this.n=S,this.b=h.a++,this.c=new M.$Md,this.onDidChangeState=this.c.event,this.f=m.Init,this.g=this.B(new d.$Wd),this.h=new o(10,$=>this.s($)),this.j=k.internalMetadata.executionOrder,this.n.$createExecution(this.b,u,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(u){await this.h.addItem(u)}async s(u){const k=Array.isArray(u)?u:[u];return this.n.$updateExecution(this.b,new r.$kv(k))}t(){if(this.f===m.Init)throw new Error("Must call start before modifying cell output");if(this.f===m.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(u){let k=this.m;if(u&&(k=this.m.notebook.getCellFromApiCell(u)),!k)throw new Error("INVALID cell");return k.handle}y(u){return u.map(k=>{const S=D.$CL.ensureUniqueMimeTypes(k.items,!0);return S===k.items?y.NotebookCellOutput.from(k):y.NotebookCellOutput.from({items:S,id:k.id,metadata:k.metadata})})}async z(u,k,S){const $=this.w(k),g=this.y((0,C.$2b)(u));return this.r({editType:l.CellExecutionUpdateType.Output,cellHandle:$,append:S,outputs:g})}async C(u,k,S){return u=D.$CL.ensureUniqueMimeTypes((0,C.$2b)(u),!0),this.r({editType:l.CellExecutionUpdateType.OutputItems,items:u.map(y.NotebookCellOutputItem.from),outputId:k.id,append:S})}asApiObject(){const u=this;return Object.freeze({get token(){return u.g.token},get cell(){return u.m.apiCell},get executionOrder(){return u.j},set executionOrder(S){u.j=S,u.s([{editType:l.CellExecutionUpdateType.ExecutionState,executionOrder:u.j}])},start(S){if(u.f===m.Resolved||u.f===m.Started)throw new Error("Cannot call start again");u.f=m.Started,u.c.fire(),u.s({editType:l.CellExecutionUpdateType.ExecutionState,runStartTime:S})},end(S,$){if(u.f===m.Resolved)throw new Error("Cannot call resolve twice");u.f=m.Resolved,u.c.fire(),u.h.flush(),u.n.$completeExecution(u.b,new r.$kv({runEndTime:$,lastRunSuccess:S}))},clearOutput(S){return u.t(),u.z([],S,!1)},appendOutput(S,$){return u.t(),u.z(S,$,!0)},replaceOutput(S,$){return u.t(),u.z(S,$,!1)},appendOutputItems(S,$){return u.t(),u.C(S,$,!0)},replaceOutputItems(S,$){return u.t(),u.C(S,$,!1)}})}}var t;(function(a){a[a.Init=0]="Init",a[a.Started=1]="Started",a[a.Resolved=2]="Resolved"})(t||(t={}));class n extends A.$Rc{static{this.a=0}get state(){return this.f}constructor(u,k,S){super(),this.h=k,this.j=S,this.b=n.a++,this.c=new M.$Md,this.onDidChangeState=this.c.event,this.f=t.Init,this.g=this.B(new d.$Wd),this.j.$createNotebookExecution(this.b,u,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===t.Resolved||this.f===t.Started)throw new Error("Cannot call start again");this.f=t.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===t.Resolved)throw new Error("Cannot call resolve twice");this.f=t.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class o{constructor(u,k){this.e=u,this.f=k,this.a=[],this.b=Date.now()}addItem(u){return this.a.push(u),this.c||(this.c=new T.$bh,this.b=Date.now(),(0,T.$Tg)(this.e).then(()=>this.flush())),Date.now()-this.b>this.e?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const u=this.c;this.c=void 0;const k=this.a;return this.a=[],this.f(k).finally(()=>u.complete())}}function i(a,u){return`${a.value}/${u}`}e.$ydc=i}),define(De[320],Ce([1,0,4,6,144]),function(me,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zdc=void 0;class M{constructor(b,E){this.c=E,this.a=new Map,this.b=b.getProxy(T.$_J.MainThreadNotebookRenderers)}$postRendererMessage(b,E,w){const R=this.c.getEditorById(b);this.a.get(E)?.fire({editor:R.apiEditor,message:w})}createRendererMessaging(b,E){if(!b.contributes?.notebookRenderer?.some(R=>R.id===E))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${E})`);return{onDidReceiveMessage:(R,I,p)=>this.d(E).event(R,I,p),postMessage:(R,I)=>{d.$idc.apiEditorsToExtHost.has(R)&&([R,I]=[I,R]);const p=I&&d.$idc.apiEditorsToExtHost.get(I);return this.b.$postMessage(p?.id,E,R)}}}d(b){let E=this.a.get(b);return E||(E=new C.$Md({onDidRemoveLastListener:()=>{E?.dispose(),this.a.delete(b)}}),this.a.set(b,E),E)}}e.$zdc=M}),define(De[321],Ce([1,0,3,18,2,26,6]),function(me,e,C,T,d,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ddc=void 0;class b{constructor(w){this.b=new Map,this.a=w.getProxy(A.$_J.MainThreadProfileContentHandlers)}registrProfileContentHandler(w,R,I){if((0,M.$_E)(w,"profileContentHandlers"),this.b.has(R))throw new Error(`Handler with id '${R}' already registered`);return this.b.set(R,I),this.a.$registerProfileContentHandler(R,I.name,I.description,w.identifier.value),(0,C.$Pc)(()=>{this.b.delete(R),this.a.$unregisterProfileContentHandler(R)})}async $saveProfile(w,R,I,p){const y=this.b.get(w);if(!y)throw new Error(`Unknown handler with id: ${w}`);return y.saveProfile(R,I,p)}async $readProfile(w,R,I){const p=this.b.get(w);if(!p)throw new Error(`Unknown handler with id: ${w}`);return p.readProfile((0,T.$xf)(R)?R:d.URI.revive(R),I)}}e.$Ddc=b}),define(De[322],Ce([1,0,2,6,9,14]),function(me,e,C,T,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Edc=void 0;class A{static{this.a=0}constructor(E,w){this.d=w,this.c=new Map,this.b=E.getProxy(T.$_J.MainThreadQuickDiff)}$provideOriginalResource(E,w,R){const I=C.URI.revive(w),p=this.c.get(E);return p?(0,d.$Lg)(()=>p.provideOriginalResource(I,R)).then(y=>y||null):Promise.resolve(null)}registerQuickDiffProvider(E,w,R,I){const p=A.a++;return this.c.set(p,w),this.b.$registerQuickDiffProvider(p,M.DocumentSelector.from(E,this.d),R,I),{dispose:()=>{this.b.$unregisterQuickDiffProvider(p),this.c.delete(p)}}}}e.$Edc=A}),define(De[323],Ce([1,0,21,4,3,6,2,7,8,19,38,59,26,14]),function(me,e,C,T,d,M,A,b,E,w,R,I,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fcc=void 0;function D(v,l,s){const r=v.getProxy(M.$_J.MainThreadQuickOpen);class c{constructor(k,S){this.e=new Map,this.f=0,this.a=k,this.b=S}showQuickPick(k,S,$,g=C.CancellationToken.None){this.c=void 0;const f=Promise.resolve(S),P=++this.f,N=r.$show(P,{title:$?.title,placeHolder:$?.placeHolder,matchOnDescription:$?.matchOnDescription,matchOnDetail:$?.matchOnDetail,ignoreFocusLost:$?.ignoreFocusOut,canPickMany:$?.canPickMany},g),O={},L=N.then(()=>O);return Promise.race([L,f]).then(j=>{if(j===O)return;const z=(0,p.$$E)(k,"quickPickItemTooltip");return f.then(F=>{const H=[];for(let K=0;K<F.length;K++){const fe=F[K];if(typeof fe=="string")H.push({label:fe,handle:K});else if(fe.kind===b.QuickPickItemKind.Separator)H.push({type:"separator",label:fe.label});else{fe.tooltip&&!z&&console.warn(`Extension '${k.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${k.identifier.value}`);const x=fe.iconPath?o(fe.iconPath):void 0;H.push({label:fe.label,iconPath:x?.iconPath,iconClass:x?.iconClass,description:fe.description,detail:fe.detail,picked:fe.picked,alwaysShow:fe.alwaysShow,tooltip:z?y.MarkdownString.fromStrict(fe.tooltip):void 0,handle:K})}}return $&&typeof $.onDidSelectItem=="function"&&(this.c=K=>{$.onDidSelectItem(F[K])}),r.$setItems(P,H),N.then(K=>{if(typeof K=="number")return F[K];if(Array.isArray(K))return K.map(fe=>F[fe])})})}).then(void 0,j=>{if(!(0,E.$3)(j))return r.$setError(P,j),Promise.reject(j)})}$onItemSelected(k){this.c?.(k)}showInput(k,S=C.CancellationToken.None){return this.d=k?.validateInput,r.$input(k,typeof this.d=="function",S).then(void 0,$=>{if(!(0,E.$3)($))return Promise.reject($)})}async $validateInput(k){if(!this.d)return;const S=await this.d(k);if(!S||typeof S=="string")return S;let $;switch(S.severity){case b.InputBoxValidationSeverity.Info:$=R.default.Info;break;case b.InputBoxValidationSeverity.Warning:$=R.default.Warning;break;case b.InputBoxValidationSeverity.Error:$=R.default.Error;break;default:$=S.message?R.default.Error:R.default.Ignore;break}return{content:S.message,severity:$}}async showWorkspaceFolderPick(k,S=C.CancellationToken.None){const $=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[k]);if(!$)return;const g=await this.a.getWorkspaceFolders2();if(g)return g.find(f=>f.uri.toString()===$.uri.toString())}createQuickPick(k){const S=new i(k,()=>this.e.delete(S._id));return this.e.set(S._id,S),S}createInputBox(k){const S=new a(k,()=>this.e.delete(S._id));return this.e.set(S._id,S),S}$onDidChangeValue(k,S){this.e.get(k)?._fireDidChangeValue(S)}$onDidAccept(k){this.e.get(k)?._fireDidAccept()}$onDidChangeActive(k,S){const $=this.e.get(k);$ instanceof i&&$._fireDidChangeActive(S)}$onDidChangeSelection(k,S){const $=this.e.get(k);$ instanceof i&&$._fireDidChangeSelection(S)}$onDidTriggerButton(k,S){this.e.get(k)?._fireDidTriggerButton(S)}$onDidTriggerItemButton(k,S,$){const g=this.e.get(k);g instanceof i&&g._fireDidTriggerItemButton(S,$)}$onDidHide(k){this.e.get(k)?._fireDidHide()}}class m{static{this.a=1}constructor(k,S){this.x=k,this.y=S,this._id=i.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new T.$Md,this.q=new T.$Md,this.r=new T.$Md,this.s=new T.$Md,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(k){this.b=k,this.z({title:k})}get step(){return this.c}set step(k){this.c=k,this.z({step:k})}get totalSteps(){return this.d}set totalSteps(k){this.d=k,this.z({totalSteps:k})}get enabled(){return this.g}set enabled(k){this.g=k,this.z({enabled:k})}get busy(){return this.j}set busy(k){this.j=k,this.z({busy:k})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(k){this.k=k,this.z({ignoreFocusOut:k})}get value(){return this.l}set value(k){this.l=k,this.z({value:k})}get placeholder(){return this.m}set placeholder(k){this.m=k,this.z({placeholder:k})}get buttons(){return this.n}set buttons(k){this.n=k.slice(),this.o.clear(),k.forEach((S,$)=>{const g=S===b.$vL.Back?-1:$;this.o.set(g,S)}),this.z({buttons:k.map((S,$)=>({...o(S.iconPath),tooltip:S.tooltip,handle:S===b.$vL.Back?-1:$}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(k){this.l=k,this.q.fire(k)}_fireDidTriggerButton(k){const S=this.o.get(k);S&&this.r.fire(S)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,d.$Mc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),r.$dispose(this._id))}z(k){if(!this.v){for(const S of Object.keys(k)){const $=k[S];this.u[S]=$===void 0?null:$}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){r.$createOrUpdate(this.u),this.u={id:this._id}}}function h(u){if(u instanceof b.$8K)return{id:u.id};const k=n(u),S=t(u);return{dark:typeof k=="string"?A.URI.file(k):k,light:typeof S=="string"?A.URI.file(S):S}}function t(u){return typeof u=="object"&&"light"in u?u.light:u}function n(u){return typeof u=="object"&&"dark"in u?u.dark:u}function o(u){const k=h(u);let S,$;return"id"in k?$=I.ThemeIcon.asClassName(k):S=k,{iconPath:S,iconClass:$}}class i extends m{constructor(k,S){super(k.identifier,S),this.O=k,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new T.$Md,this.L=[],this.M=new T.$Md,this.N=new T.$Md,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(k){this.B=k.slice(),this.C.clear(),this.D.clear(),k.forEach((g,f)=>{this.C.set(f,g),this.D.set(g,f)});const S=(0,p.$$E)(this.O,"quickPickItemTooltip"),$=[];for(let g=0;g<k.length;g++){const f=k[g];if(f.kind===b.QuickPickItemKind.Separator)$.push({type:"separator",label:f.label});else{f.tooltip&&!S&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const P=f.iconPath?o(f.iconPath):void 0;$.push({handle:g,label:f.label,iconPath:P?.iconPath,iconClass:P?.iconClass,description:f.description,detail:f.detail,picked:f.picked,alwaysShow:f.alwaysShow,tooltip:S?y.MarkdownString.fromStrict(f.tooltip):void 0,buttons:f.buttons?.map((N,O)=>({...o(N.iconPath),tooltip:N.tooltip,handle:O}))})}}this.z({items:$})}get canSelectMany(){return this.E}set canSelectMany(k){this.E=k,this.z({canSelectMany:k})}get matchOnDescription(){return this.F}set matchOnDescription(k){this.F=k,this.z({matchOnDescription:k})}get matchOnDetail(){return this.G}set matchOnDetail(k){this.G=k,this.z({matchOnDetail:k})}get sortByLabel(){return this.H}set sortByLabel(k){this.H=k,this.z({sortByLabel:k})}get keepScrollPosition(){return this.I}set keepScrollPosition(k){this.I=k,this.z({keepScrollPosition:k})}get activeItems(){return this.J}set activeItems(k){this.J=k.filter(S=>this.D.has(S)),this.z({activeItems:this.J.map(S=>this.D.get(S))})}get selectedItems(){return this.L}set selectedItems(k){this.L=k.filter(S=>this.D.has(S)),this.z({selectedItems:this.L.map(S=>this.D.get(S))})}_fireDidChangeActive(k){const S=(0,w.$Gb)(k.map($=>this.C.get($)));this.J=S,this.K.fire(S)}_fireDidChangeSelection(k){const S=(0,w.$Gb)(k.map($=>this.C.get($)));this.L=S,this.M.fire(S)}_fireDidTriggerItemButton(k,S){const $=this.C.get(k);if(!$||!$.buttons||!$.buttons.length)return;const g=$.buttons[S];g&&this.N.fire({button:g,item:$})}}class a extends m{constructor(k,S){super(k.identifier,S),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(k){this.B=k,this.z({password:k})}get prompt(){return this.C}set prompt(k){this.C=k,this.z({prompt:k})}get valueSelection(){return this.D}set valueSelection(k){this.D=k,this.z({valueSelection:k})}get validationMessage(){return this.E}set validationMessage(k){this.E=k,k?typeof k=="string"?this.z({validationMessage:k,severity:R.default.Error}):this.z({validationMessage:k.message,severity:k.severity??R.default.Error}):this.z({validationMessage:void 0,severity:R.default.Ignore})}}return new c(l,s)}e.$Fcc=D}),define(De[324],Ce([1,0,2,4,57,3,9,6,19,126,13,25,59,14,26,17]),function(me,e,C,T,d,M,A,b,E,w,R,I,p,y,D,v){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hcc=e.$Gcc=void 0;function s(g){if(g)return typeof g.iconPath=="string"?C.URI.file(g.iconPath):C.URI.isUri(g.iconPath)||p.ThemeIcon.isThemeIcon(g.iconPath)?g.iconPath:void 0}function r(g){if(g.icon){if(C.URI.isUri(g.icon))return g.icon;if(p.ThemeIcon.isThemeIcon(g.icon))return g.icon;{const f=g.icon;return{light:f.light,dark:f.dark}}}else return}function c(g,f){if(!g.iconPath&&!f.iconPath)return 0;if(g.iconPath){if(!f.iconPath)return 1}else return-1;const P=typeof g.iconPath=="string"?g.iconPath:C.URI.isUri(g.iconPath)?g.iconPath.fsPath:g.iconPath.id,N=typeof f.iconPath=="string"?f.iconPath:C.URI.isUri(f.iconPath)?f.iconPath.fsPath:f.iconPath.id;return(0,w.$nq)(P,N)}function m(g,f){let P=0;if(g.strikeThrough!==f.strikeThrough)return g.strikeThrough?1:-1;if(g.faded!==f.faded)return g.faded?1:-1;if(g.tooltip!==f.tooltip)return(g.tooltip||"").localeCompare(f.tooltip||"");if(P=c(g,f),P!==0)return P;if(g.light&&f.light)P=c(g.light,f.light);else{if(g.light)return 1;if(f.light)return-1}if(P!==0)return P;if(g.dark&&f.dark)P=c(g.dark,f.dark);else{if(g.dark)return 1;if(f.dark)return-1}return P}function h(g,f){if(g.command!==f.command)return g.command<f.command?-1:1;if(g.title!==f.title)return g.title<f.title?-1:1;if(g.tooltip!==f.tooltip){if(g.tooltip!==void 0&&f.tooltip!==void 0)return g.tooltip<f.tooltip?-1:1;if(g.tooltip!==void 0)return 1;if(f.tooltip!==void 0)return-1}if(g.arguments===f.arguments)return 0;if(g.arguments)if(f.arguments){if(g.arguments.length!==f.arguments.length)return g.arguments.length-f.arguments.length}else return 1;else return-1;for(let P=0;P<g.arguments.length;P++){const N=g.arguments[P],O=f.arguments[P];if(N!==O)return N<O?-1:1}return 0}function t(g,f){let P=(0,w.$nq)(g.resourceUri.fsPath,f.resourceUri.fsPath,!0);if(P!==0)return P;if(g.command&&f.command)P=h(g.command,f.command);else{if(g.command)return 1;if(f.command)return-1}if(P!==0)return P;if(g.decorations&&f.decorations)P=m(g.decorations,f.decorations);else{if(g.decorations)return 1;if(f.decorations)return-1}return P}function n(g,f){for(let P=0;P<g.length;P++)if(g[P]!==f[P])return!1;return!0}function o(g,f){return g.command===f.command&&g.title===f.title&&g.tooltip===f.tooltip&&(g.arguments&&f.arguments?n(g.arguments,f.arguments):g.arguments===f.arguments)}function i(g,f){return(0,E.$tb)(g,f,o)}function a(g,f){return g===f?!0:!g||!f?!1:g.id===f.id&&g.label===f.label&&g.upstream?.id===f.upstream?.id&&g.upstream?.label===f.upstream?.label}class u{#e;#t;get value(){return this.d}set value(f){f=f??"",this.#e.$setInputBoxValue(this.l,f),this.n(f)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(f){this.#e.$setInputBoxPlaceholder(this.l,f),this.f=f}get validateInput(){return(0,D.$_E)(this.k,"scmValidation"),this.g}set validateInput(f){if((0,D.$_E)(this.k,"scmValidation"),f&&typeof f!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=f,this.#e.$setValidationProviderIsEnabled(this.l,!!f)}get enabled(){return this.h}set enabled(f){f=!!f,this.h!==f&&(this.h=f,this.#e.$setInputBoxEnablement(this.l,f))}get visible(){return this.j}set visible(f){f=!!f,this.j!==f&&(this.j=f,this.#e.$setInputBoxVisibility(this.l,f))}get document(){return(0,D.$_E)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(f,P,N,O,L){this.k=f,this.l=O,this.m=L,this.d="",this.e=new T.$Md,this.f="",this.h=!0,this.j=!0,this.#t=P,this.#e=N}showValidationMessage(f,P){(0,D.$_E)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,f,P)}$onInputBoxValueChange(f){this.n(f)}n(f){this.d=f,this.e.fire(f)}}e.$Gcc=u;class k{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(f){this.v=f,this.q.$updateGroupLabel(this.t,this.handle,f)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(f){this.p=f,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(f){this.f=[...f],this.k.fire()}constructor(f,P,N,O,L){this.q=f,this.s=P,this.t=N,this.u=O,this.v=L,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new T.$Md,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new T.$Md,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=k.d++}getResourceState(f){return this.g.get(f)}$executeResourceCommand(f,P){const N=this.h.get(f);return N?(0,A.$Lg)(()=>this.s.executeCommand(N.command,...N.arguments||[],P)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const f=[...this.f].sort(t),N=(0,E.$Cb)(this.o,f,t).map(j=>{const z=j.toInsert.map(F=>{const H=this.e++;this.g.set(H,F);const K=F.resourceUri;let fe;if(F.command)if(F.command.command==="vscode.open"||F.command.command==="vscode.diff"){const V=new M.$Qc;fe=this.s.converter.toInternal(F.command,V),this.j.set(H,V)}else this.h.set(H,F.command);const x=s(F.decorations),Z=F.decorations&&s(F.decorations.light)||x,q=F.decorations&&s(F.decorations.dark)||x,Y=[Z,q],be=F.decorations&&F.decorations.tooltip||"",ue=F.decorations&&!!F.decorations.strikeThrough,ve=F.decorations&&!!F.decorations.faded,J=F.contextValue||"";return{rawResource:[H,K,Y,be,ue,ve,J,fe],handle:H}});return{start:j.start,deleteCount:j.deleteCount,toInsert:z}}),O=N.map(({start:j,deleteCount:z,toInsert:F})=>[j,z,F.map(H=>H.rawResource)]),L=N.reverse();for(const{start:j,deleteCount:z,toInsert:F}of L){const H=F.map(fe=>fe.handle),K=this.n.splice(j,z,...H);for(const fe of K)this.g.delete(fe),this.h.delete(fe),this.j.get(fe)?.dispose(),this.j.delete(fe)}return this.o=f,O}dispose(){this.l=!0,this.m.fire()}}class S{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(f){this.g!==f&&(this.g=f,this.#e.$updateSourceControl(this.x,{count:f}))}get quickDiffProvider(){return this.h}set quickDiffProvider(f){this.h=f;let P;(0,D.$$E)(this.y,"quickDiffProvider")&&(P=f?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!f,quickDiffLabel:P})}get historyProvider(){return(0,D.$_E)(this.y,"scmHistoryProvider"),this.j}set historyProvider(f){(0,D.$_E)(this.y,"scmHistoryProvider"),this.j=f,this.k.value=new M.$Qc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!f}),f&&(this.k.value.add(f.onDidChangeCurrentHistoryItemGroup(()=>{a(this.l,f?.currentHistoryItemGroup)||(this.l=f?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.l))})),this.k.value.add(f.onDidChangeActionButton(()=>{(0,D.$_E)(this.y,"scmActionButton"),this.m.value=new M.$Qc;const P=f.actionButton!==void 0?{command:this.z.converter.toInternal(f.actionButton.command,this.m.value),description:f.actionButton.description,enabled:f.actionButton.enabled}:void 0;this.#e.$onDidChangeHistoryProviderActionButton(this.x,P??null)})))}get commitTemplate(){return this.n}set commitTemplate(f){f!==this.n&&(this.n=f,this.#e.$updateSourceControl(this.x,{commitTemplate:f}))}get acceptInputCommand(){return this.p}set acceptInputCommand(f){this.o.value=new M.$Qc,this.p=f;const P=this.z.converter.toInternal(f,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:P})}get actionButton(){return(0,D.$_E)(this.y,"scmActionButton"),this.s}set actionButton(f){(0,D.$_E)(this.y,"scmActionButton"),this.q.value=new M.$Qc,this.s=f;const P=f!==void 0?{command:this.z.converter.toInternal(f.command,this.q.value),secondaryCommands:f.secondaryCommands?.map(N=>N.map(O=>this.z.converter.toInternal(O,this.q.value))),description:f.description,enabled:f.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:P??null})}get statusBarCommands(){return this.u}set statusBarCommands(f){if(this.u&&f&&i(this.u,f))return;this.t.value=new M.$Qc,this.u=f;const P=(f||[]).map(N=>this.z.converter.toInternal(N,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:P})}get selected(){return this.v}constructor(f,P,N,O,L,j,z){this.y=f,this.z=O,this.A=L,this.B=j,this.C=z,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new M.$Sc,this.m=new M.$Sc,this.n=void 0,this.o=new M.$Sc,this.p=void 0,this.q=new M.$Sc,this.t=new M.$Sc,this.u=void 0,this.v=!1,this.w=new T.$Md,this.onDidChangeSelection=this.w.event,this.x=S.d++,this.D=new Map,this.E=new Set,this.#e=N;const F=C.URI.from({scheme:v.Schemas.vscodeSourceControl,path:`${L}/scm${this.x}/input`,query:z?`rootUri=${encodeURIComponent(z.toString())}`:void 0});this.f=new u(f,P,this.#e,this.x,F),this.#e.$registerSourceControl(this.x,L,j,z,F)}createResourceGroup(f,P){const N=new k(this.#e,this.z,this.x,f,P),O=T.Event.once(N.onDidDispose)(()=>this.D.delete(N));return this.D.set(N,O),this.eventuallyAddResourceGroups(),N}eventuallyAddResourceGroups(){const f=[],P=[];for(const[N,O]of this.D){O.dispose();const L=N.onDidUpdateResourceStates(()=>{this.E.add(N),this.eventuallyUpdateResourceStates()});T.Event.once(N.onDidDispose)(()=>{this.E.delete(N),L.dispose(),this.e.delete(N.handle),this.#e.$unregisterGroup(this.x,N.handle)}),f.push([N.handle,N.id,N.label,N.features]);const j=N._takeResourceStateSnapshot();j.length>0&&P.push([N.handle,j]),this.e.set(N.handle,N)}this.#e.$registerGroups(this.x,f,P),this.D.clear()}eventuallyUpdateResourceStates(){const f=[];this.E.forEach(P=>{const N=P._takeResourceStateSnapshot();N.length!==0&&f.push([P.handle,N])}),f.length>0&&this.#e.$spliceResourceStates(this.x,f),this.E.clear()}getResourceGroup(f){return this.e.get(f)}setSelectionState(f){this.v=f,this.w.fire(f)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(f=>f.dispose()),this.#e.$unregisterSourceControl(this.x)}}He([(0,d.$gh)(100)],S.prototype,"eventuallyAddResourceGroups",null),He([(0,d.$gh)(100)],S.prototype,"eventuallyUpdateResourceStates",null);let $=class{static{l=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(f,P,N,O){this.l=P,this.m=N,this.n=O,this.g=new Map,this.h=new I.$4l,this.j=new T.$Md,this.e=f.getProxy(b.$_J.MainThreadSCM),this.f=f.getProxy(b.$_J.MainThreadTelemetry),P.registerArgumentProcessor({processArgument:L=>{if(L&&L.$mid===3){const j=this.g.get(L.sourceControlHandle);if(!j)return L;const z=j.getResourceGroup(L.groupHandle);return z?z.getResourceState(L.handle):L}else if(L&&L.$mid===4){const j=this.g.get(L.sourceControlHandle);return j?j.getResourceGroup(L.groupHandle):L}else if(L&&L.$mid===5){const j=this.g.get(L.handle);return j||L}return L}})}createSourceControl(f,P,N,O){this.n.trace("ExtHostSCM#createSourceControl",f.identifier.value,P,N,O),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:f.identifier.value});const L=l.d++,j=new S(f,this.m,this.e,this.l,P,N,O);this.g.set(L,j);const z=this.h.get(f.identifier)||[];return z.push(j),this.h.set(f.identifier,z),j}getLastInputBox(f){this.n.trace("ExtHostSCM#getLastInputBox",f.identifier.value);const P=this.h.get(f.identifier),N=P&&P[P.length-1];return N&&N.inputBox}$provideOriginalResource(f,P,N){const O=C.URI.revive(P);this.n.trace("ExtHostSCM#$provideOriginalResource",f,O.toString());const L=this.g.get(f);return!L||!L.quickDiffProvider||!L.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.$Lg)(()=>L.quickDiffProvider.provideOriginalResource(O,N)).then(j=>j||null)}$onInputBoxValueChange(f,P){this.n.trace("ExtHostSCM#$onInputBoxValueChange",f);const N=this.g.get(f);return N&&N.inputBox.$onInputBoxValueChange(P),Promise.resolve(void 0)}$executeResourceCommand(f,P,N,O){this.n.trace("ExtHostSCM#$executeResourceCommand",f,P,N);const L=this.g.get(f);if(!L)return Promise.resolve(void 0);const j=L.getResourceGroup(P);return j?j.$executeResourceCommand(N,O):Promise.resolve(void 0)}$validateInput(f,P,N){this.n.trace("ExtHostSCM#$validateInput",f);const O=this.g.get(f);return!O||!O.inputBox.validateInput?Promise.resolve(void 0):(0,A.$Lg)(()=>O.inputBox.validateInput(P,N)).then(L=>{if(!L)return Promise.resolve(void 0);const j=y.MarkdownString.fromStrict(L.message);return j?Promise.resolve([j,L.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(f){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",f),f!==void 0&&this.g.get(f)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=f,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(f,P,N){return await this.g.get(f)?.historyProvider?.resolveHistoryItemGroupBase(P,N)??void 0}async $resolveHistoryItemGroupCommonAncestor(f,P,N,O){return await this.g.get(f)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(P,N,O)??void 0}async $provideHistoryItems(f,P,N,O){return(await this.g.get(f)?.historyProvider?.provideHistoryItems(P,N,O))?.map(z=>({id:z.id,parentIds:z.parentIds,label:z.label,description:z.description,icon:r(z),timestamp:z.timestamp}))??void 0}async $provideHistoryItemChanges(f,P,N){return await this.g.get(f)?.historyProvider?.provideHistoryItemChanges(P,N)??void 0}};e.$Hcc=$,e.$Hcc=$=l=He([Be(3,R.$8i)],$)}),define(De[114],Ce([1,0,6,4,5]),function(me,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ncc=e.$mcc=void 0;class M{constructor(b){this.b=new T.$Md,this.onDidChangePassword=this.b.event,this.a=b.getProxy(C.$_J.MainThreadSecretState)}async $onDidChangePassword(b){this.b.fire(b)}get(b,E){return this.a.$getPassword(b,E)}store(b,E,w){return this.a.$setPassword(b,E,w)}delete(b,E){return this.a.$deletePassword(b,E)}}e.$mcc=M,e.$ncc=(0,d.$Nh)("IExtHostSecretState")}),define(De[325],Ce([1,0,6,14,2]),function(me,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jdc=void 0;class M{static{this.a=0}constructor(b,E){this.d=E,this.c=new Map,this.b=b.getProxy(C.$_J.MainThreadShare)}async $provideShare(b,E,w){return await this.c.get(b)?.provideShare({selection:T.Range.to(E.selection),resourceUri:d.URI.revive(E.resourceUri)},w)??void 0}registerShareProvider(b,E){const w=M.a++;return this.c.set(w,E),this.b.$registerShareProvider(w,T.DocumentSelector.from(b,this.d),E.id,E.label,E.priority),{dispose:()=>{this.b.$unregisterShareProvider(w),this.c.delete(w)}}}}e.$Jdc=M}),define(De[326],Ce([1,0,7,6,209,3,14,18]),function(me,e,C,T,d,M,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jcc=e.$Icc=void 0;class E{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new C.$9K("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new C.$9K("statusBarItem.warningForeground")]])}#e;#t;constructor(p,y,D,v,l,s=C.StatusBarAlignment.Left,r){if(this.i=!1,this.k="",this.q=new M.$Qc,this.#e=p,this.#t=y,l&&v){this.c=(0,C.$LK)(v.identifier,l);const c=D.get(this.c);c&&(s=c.alignLeft?C.StatusBarAlignment.Left:C.StatusBarAlignment.Right,r=c.priority,this.j=!0,this.name=c.name,this.text=c.text,this.tooltip=c.tooltip,this.command=c.command,this.accessibilityInformation=c.accessibilityInformation)}else this.c=String(E.a++);this.e=v,this.f=l,this.g=s,this.h=this.u(r)}u(p){if((0,b.$Bf)(p))return p===Number.POSITIVE_INFINITY?Number.MAX_VALUE:p===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:p}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(p){this.k=p,this.v()}set name(p){this.m=p,this.v()}set tooltip(p){this.l=p,this.v()}set color(p){this.n=p,this.v()}set backgroundColor(p){p&&!E.b.has(p.id)&&(p=void 0),this.o=p,this.v()}set command(p){this.r?.fromApi!==p&&(this.p&&this.q.add(this.p),this.p=new M.$Qc,typeof p=="string"?this.r={fromApi:p,internal:this.#t.toInternal({title:"",command:p},this.p)}:p?this.r={fromApi:p,internal:this.#t.toInternal(p,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(p){this.t=p,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let p;this.e?this.f?p=`${this.e.identifier.value}.${this.f}`:p=this.e.identifier.value:p=this.f;let y;this.m?y=this.m:y=(0,d.localize)(0,null,this.e.displayName||this.e.name);let D=this.n;this.o&&(D=E.b.get(this.o.id));const v=A.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,p,this.e?.identifier.value,y,this.k,v,this.r?.internal,D,this.o,this.g===C.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Icc=E;class w{constructor(p){this.b=[],this.a=p.createStatusBarEntry(void 0,"status.extensionMessage",C.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,d.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(p){const y={message:p};return this.b.unshift(y),this.c(),new C.$bK(()=>{const D=this.b.indexOf(y);D>=0&&(this.b.splice(D,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class R{constructor(p,y){this.e=new Map,this.a=p.getProxy(T.$_J.MainThreadStatusBar),this.b=y,this.c=new w(this)}$acceptStaticEntries(p){for(const y of p)this.e.set(y.entryId,y)}createStatusBarEntry(p,y,D,v){return new E(this.a,this.b,this.e,p,y,D,v)}setStatusBarMessage(p,y){const D=this.c.setMessage(p);let v;return typeof y=="number"?v=setTimeout(()=>D.dispose(),y):typeof y<"u"&&y.then(()=>D.dispose(),()=>D.dispose()),new C.$bK(()=>{D.dispose(),clearTimeout(v)})}}e.$Jcc=R}),define(De[115],Ce([1,0,6,4,5]),function(me,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bcc=e.$acc=void 0;class M{constructor(b,E){this.c=E,this.b=new T.$Md,this.onDidChangeStorage=this.b.event,this.a=b.getProxy(C.$_J.MainThreadStorage)}registerExtensionStorageKeysToSync(b,E){this.a.$registerExtensionStorageKeysToSync(b,E)}async initializeExtensionStorage(b,E,w){const R=await this.a.$initializeExtensionStorage(b,E);let I;return R&&(I=this.d(b,E,R)),I||w}setValue(b,E,w){return this.a.$setValue(b,E,w)}$acceptValue(b,E,w){const R=this.d(b,E,w);R&&this.b.fire({shared:b,key:E,value:R})}d(b,E,w){try{return JSON.parse(w)}catch(R){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${E}, global: ${b}): ${R}`)}}}e.$acc=M,e.$bcc=(0,d.$Nh)("IExtHostStorage")}),define(De[90],Ce([1,0,5,27,13,71,2]),function(me,e,C,T,d,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hcc=e.$gcc=void 0,e.$gcc=(0,C.$Nh)("IExtensionStoragePaths");let b=class{constructor(w,R,I){this.d=R,this.f=I,this.a=w.workspace??void 0,this.b=w.environment,this.whenReady=this.h().then(p=>this.c=p)}async g(w){return A.URI.joinPath(this.b.workspaceStorageHome,w)}async h(){if(!this.a)return Promise.resolve(void 0);const w=this.a.id,R=await this.g(w);try{return await this.f.value.stat(R),this.d.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",R),await this.f.value.createDirectory(R),await this.f.value.writeFile(A.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:A.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),R}catch(I){this.d.error("[ExtHostStorage]",I);return}}workspaceValue(w){if(this.c)return A.URI.joinPath(this.c,w.identifier.value)}globalValue(w){return A.URI.joinPath(this.b.globalStorageHome,w.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$hcc=b,e.$hcc=b=He([Be(0,T.$qM),Be(1,d.$8i),Be(2,M.$fcc)],b)}),define(De[44],Ce([1,0,4,6,5,2,20,3,7,211,8,253,21,31,254,59,9,14,33]),function(me,e,C,T,d,M,A,b,E,w,R,I,p,y,D,v,l,s,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lcc=e.$kcc=e.$jcc=e.$icc=void 0,e.$icc=(0,d.$Nh)("IExtHostTerminalService");class c{constructor($,g,f,P){this.l=$,this._id=g,this.m=f,this.n=P,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(O=>this.f=O);const N=this;this.value={get name(){return N.n||""},get processId(){return N.b},get creationOptions(){return N.m},get exitStatus(){return N.h},get state(){return N.j},get selection(){return N.k},sendText(O,L=!0){N.q(),N.l.$sendText(N._id,O,L)},show(O){N.q(),N.l.$show(N._id,O)},hide(){N.q(),N.l.$hide(N._id)},dispose(){N.a||(N.a=!0,N.l.$dispose(N._id))},get dimensions(){if(!(N.d===void 0||N.g===void 0))return{columns:N.d,rows:N.g}}}}async create($,g){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:$.name,shellPath:$.shellPath??void 0,shellArgs:$.shellArgs??void 0,cwd:$.cwd??void 0,env:$.env??void 0,icon:a($.iconPath)??void 0,color:v.ThemeColor.isThemeColor($.color)?$.color.id:void 0,initialText:$.message??void 0,strictEnv:$.strictEnv??void 0,hideFromUser:$.hideFromUser??void 0,isFeatureTerminal:g?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:g?.useShellEnvironment??void 0,location:g?.location||this.o($.location,g?.resolvedExtHostIdentifier),isTransient:$.isTransient??void 0})}async createExtensionTerminal($,g,f,P){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:f,color:v.ThemeColor.isThemeColor(P)?P.id:void 0,location:this.o($,g),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o($,g){return typeof $=="object"?"parentTerminal"in $&&$.parentTerminal&&g?{parentTerminal:g}:"viewColumn"in $?{viewColumn:s.ViewColumn.from($.viewColumn),preserveFocus:$.preserveFocus}:void 0:$}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name($){this.n=$}setExitStatus($,g){this.h=Object.freeze({code:$,reason:g})}setDimensions($,g){return $===this.d&&g===this.g||$===0||g===0?!1:(this.d=$,this.g=g,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection($){this.k=$}_setProcessId($){this.f?(this.f($),this.f=void 0):this.b.then(g=>{g!==$&&(this.b=Promise.resolve($))})}}e.$jcc=c;class m{get onProcessReady(){return this.b.event}constructor($){this.g=$,this.id=0,this.shouldPersist=!1,this.a=new C.$Md,this.onProcessData=this.a.event,this.b=new C.$Md,this.d=new C.$Md,this.onDidChangeProperty=this.d.event,this.f=new C.$Md,this.onProcessExit=this.f.event}refreshProperty($){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${$}`)}updateProperty($,g){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${$}, value: ${g}`)}async start(){}shutdown(){this.g.close()}input($){this.g.handleInput?.($)}resize($,g){this.g.setDimensions?.({columns:$,rows:g})}clearBuffer(){}async processBinary($){}acknowledgeDataEvent($){}async setUnicodeVersion($){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents($){this.g.onDidWrite(g=>this.a.fire(g)),this.g.onDidClose?.((g=void 0)=>{this.f.fire(g===void 0?void 0:g)}),this.g.onDidOverrideDimensions?.(g=>{g&&this.d.fire({type:"overrideDimensions",value:{cols:g.columns,rows:g.rows}})}),this.g.onDidChangeName?.(g=>{this.d.fire({type:"title",value:g})}),this.g.open($||void 0),$&&this.g.setDimensions?.($),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let h=1,t=class extends b.$Rc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map($=>$.value)}constructor($,g,f){super(),this.Q=g,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new b.$Sc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new C.$Md,this.onDidCloseTerminal=this.H.event,this.I=new C.$Md,this.onDidOpenTerminal=this.I.event,this.J=new C.$Md,this.onDidChangeActiveTerminal=this.J.event,this.L=new C.$Md,this.onDidChangeTerminalDimensions=this.L.event,this.M=new C.$Md,this.onDidChangeTerminalState=this.M.event,this.N=new C.$Md,this.onDidChangeShell=this.N.event,this.O=new C.$Md({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new C.$Md({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=f.getProxy(T.$_J.MainThreadTerminalService),this.y=new D.$Lkb(this.a.$sendProcessData),this.a.$registerProcessSupport($),this.Q.registerArgumentProcessor({processArgument:P=>{const N=O=>{const L=O;return this.W(L.instanceId)?.value};switch(P?.$mid){case 15:return N(P);default:{if(Array.isArray(P))for(let O=0;O<P.length&&P[O].$mid===15;O++)P[O]=N(P[O]);return P}}}}),this.B({dispose:()=>{for(const[P,N]of this.g)N.shutdown(!0)}})}getDefaultShell($){return($?this.u:this.s)?.path||""}getDefaultShellArgs($){return($?this.u:this.s)?.args||[]}createExtensionTerminal($,g){const f=new c(this.a,(0,y.$dg)(),$,$.name),P=new m($.pty);return f.createExtensionTerminal($.location,this.R($,g).resolvedExtHostIdentifier,a($.iconPath),u($.color)).then(N=>{const O=this.S(N,P);this.h[N]=O}),this.f.push(f),f.value}R($,g){if(g=g||{},$.location&&typeof $.location=="object"&&"parentTerminal"in $.location){const f=$.location.parentTerminal;if(f){const P=this.f.find(N=>N.value===f);P&&(g.resolvedExtHostIdentifier=P._id)}}else $.location&&typeof $.location!="object"?g.location=$.location:g.location&&typeof g.location=="object"&&"splitActiveTerminal"in g.location&&(g.location={splitActiveTerminal:!0});return g}attachPtyToTerminal($,g){if(!this.W($))throw new Error(`Cannot resolve terminal with id ${$} for virtual process`);const P=new m(g),N=this.S($,P);this.h[$]=N}async $acceptActiveTerminalChanged($){const g=this.b;if($===null){this.b=void 0,g!==this.b&&this.J.fire(this.b);return}const f=this.W($);f&&(this.b=f,g!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData($,g){const f=this.W($);f&&this.O.fire({terminal:f.value,data:g})}async $acceptTerminalDimensions($,g,f){const P=this.W($);P&&P.setDimensions(g,f)&&this.L.fire({terminal:P.value,dimensions:P.value.dimensions})}async $acceptDidExecuteCommand($,g){const f=this.W($);f&&this.P.fire({terminal:f.value,...g})}async $acceptTerminalMaximumDimensions($,g,f){this.g.get($)?.resize(g,f)}async $acceptTerminalTitleChange($,g){const f=this.W($);f&&(f.name=g)}async $acceptTerminalClosed($,g,f){const P=this.Y(this.f,$);if(P!==null){const N=this.f.splice(P,1)[0];N.setExitStatus(g,f),this.H.fire(N.value)}}$acceptTerminalOpened($,g,f,P){if(g){const L=this.Y(this.f,g);if(L!==null){this.f[L]._id=$,this.I.fire(this.terminals[L]),this.f[L].isOpen=!0;return}}const N={name:P.name,shellPath:P.executable,shellArgs:P.args,cwd:typeof P.cwd=="string"?P.cwd:M.URI.revive(P.cwd),env:P.env,hideFromUser:P.hideFromUser},O=new c(this.a,$,N,f);this.f.push(O),this.I.fire(O.value),O.isOpen=!0}async $acceptTerminalProcessId($,g){this.W($)?._setProcessId(g)}async $startExtensionTerminal($,g){const f=this.W($);if(!f)return{message:(0,w.localize)(0,null,$)};f.isOpen||await new Promise(N=>{const O=this.onDidOpenTerminal(async L=>{L===f.value&&(O.dispose(),N())})});const P=this.g.get($);P?P.startSendingEvents(g):this.j[$]={initialDimensions:g}}S($,g){const f=new b.$Qc;f.add(g.onProcessReady(N=>this.a.$sendProcessReady($,N.pid,N.cwd,N.windowsPty))),f.add(g.onDidChangeProperty(N=>this.a.$sendProcessProperty($,N))),this.y.startBuffering($,g.onProcessData),f.add(g.onProcessExit(N=>this.U($,N))),this.g.set($,g);const P=this.j[$];return P&&g instanceof m&&(g.startSendingEvents(P.initialDimensions),delete this.j[$]),f}$acceptProcessAckDataEvent($,g){this.g.get($)?.acknowledgeDataEvent(g)}$acceptProcessInput($,g){this.g.get($)?.input(g)}$acceptTerminalInteraction($){const g=this.W($);g?.setInteractedWith()&&this.M.fire(g.value)}$acceptTerminalSelection($,g){this.W($)?.setSelection(g)}$acceptProcessResize($,g,f){try{this.g.get($)?.resize(g,f)}catch(P){if(P.code!=="EPIPE"&&P.code!=="ERR_IPC_CHANNEL_CLOSED")throw P}}$acceptProcessShutdown($,g){this.g.get($)?.shutdown(g)}$acceptProcessRequestInitialCwd($){this.g.get($)?.getInitialCwd().then(g=>this.a.$sendProcessProperty($,{type:"initialCwd",value:g}))}$acceptProcessRequestCwd($){this.g.get($)?.getCwd().then(g=>this.a.$sendProcessProperty($,{type:"cwd",value:g}))}$acceptProcessRequestLatency($){return Promise.resolve($)}registerLinkProvider($){return this.z.add($),this.z.size===1&&this.a.$startLinkProvider(),new E.$bK(()=>{this.z.delete($),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider($,g,f){if(this.C.has(g))throw new Error(`Terminal profile provider "${g}" already registered`);return this.C.set(g,f),this.a.$registerProfileProvider(g,$.identifier.value),new E.$bK(()=>{this.C.delete(g),this.a.$unregisterProfileProvider(g)})}registerTerminalQuickFixProvider($,g,f){if(this.D.has($))throw new Error(`Terminal quick fix provider "${$}" is already registered`);return this.D.set($,f),this.a.$registerQuickFixProvider($,g),new E.$bK(()=>{this.D.delete($),this.a.$unregisterQuickFixProvider($)})}async $provideTerminalQuickFixes($,g){const f=new p.$Wd().token;if(f.isCancellationRequested)return;const P=this.D.get($);if(!P)return;const N=await P.provideTerminalQuickFixes(g,f);if(N===null||Array.isArray(N)&&N.length===0)return;const O=new b.$Qc;if(this.w.value=O,!Array.isArray(N))return N?s.TerminalQuickFix.from(N,this.Q.converter,O):void 0;const L=[];for(const j of N){const z=s.TerminalQuickFix.from(j,this.Q.converter,O);z&&L.push(z)}return L}async $createContributedProfileTerminal($,g){const f=new p.$Wd().token;let P=await this.C.get($)?.provideTerminalProfile(f);if(!f.isCancellationRequested){if(P&&!("options"in P)&&(P={options:P}),!P||!("options"in P))throw new Error(`No terminal profile options provided for id "${$}"`);if("pty"in P.options){this.createExtensionTerminal(P.options,g);return}this.createTerminalFromOptions(P.options,g)}}async $provideLinks($,g){const f=this.W($);if(!f)return[];this.F.delete($),this.G.get($)?.dispose(!0);const N=new p.$Wd;this.G.set($,N);const O=[],L={terminal:f.value,line:g},j=[];for(const H of this.z)j.push(l.Promises.withAsyncBody(async K=>{N.token.onCancellationRequested(()=>K({provider:H,links:[]}));const fe=await H.provideTerminalLinks(L,N.token)||[];N.token.isCancellationRequested||K({provider:H,links:fe})}));const z=await Promise.all(j);if(N.token.isCancellationRequested)return[];const F=new Map;for(const H of z)H&&H.links.length>0&&O.push(...H.links.map(K=>{const fe={id:h++,startIndex:K.startIndex,length:K.length,label:K.tooltip};return F.set(fe.id,{provider:H.provider,link:K}),fe}));return this.F.set($,F),O}$activateLink($,g){const f=this.F.get($)?.get(g);f&&f.provider.handleTerminalLink(f.link)}U($,g){this.y.stopBuffering($),this.g.delete($),delete this.j[$];const f=this.h[$];f&&(f.dispose(),delete this.h[$]),this.a.$sendProcessExit($,g)}W($){return this.X(this.f,$)}X($,g){const f=this.Y($,g);return f!==null?$[f]:null}Y($,g){const f=$.findIndex(P=>P._id===g);return f===-1?null:f}getEnvironmentVariableCollection($){let g=this.n.get($.identifier.value);return g||(g=new n,this.$($.identifier.value,g)),g.getScopedEnvironmentVariableCollection(void 0)}Z($,g){const f=(0,I.$gr)(g.map),P=(0,I.$hr)(g.descriptionMap);this.a.$setEnvironmentVariableCollection($,g.persistent,f.length===0?void 0:f,P)}$initEnvironmentVariableCollections($){$.forEach(g=>{const f=g[0],P=new n(g[1]);this.$(f,P)})}$acceptDefaultProfile($,g){const f=this.s;this.s=$,this.u=g,f?.path!==$.path&&this.N.fire($.path)}$($,g){this.n.set($,g),g.onDidChangeCollection(()=>{this.Z($,g)})}};e.$kcc=t,e.$kcc=t=He([Be(1,r.$wM),Be(2,A.$aM)],t);class n{get persistent(){return this.b}set persistent($){this.b=$,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor($){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new C.$Md,this.map=new Map($)}getScopedEnvironmentVariableCollection($){const g=this.h($);let f=this.a.get(g);return f||(f=new o(this,$),this.a.set(g,f),f.onDidChangeCollection(()=>this.d.fire())),f}replace($,g,f,P){this.f($,{value:g,type:E.EnvironmentVariableMutatorType.Replace,options:f??{applyAtProcessCreation:!0},scope:P})}append($,g,f,P){this.f($,{value:g,type:E.EnvironmentVariableMutatorType.Append,options:f??{applyAtProcessCreation:!0},scope:P})}prepend($,g,f,P){this.f($,{value:g,type:E.EnvironmentVariableMutatorType.Prepend,options:f??{applyAtProcessCreation:!0},scope:P})}f($,g){if(g.options&&g.options.applyAtProcessCreation===!1&&!g.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const f=this.g($,g.scope),P=this.map.get(f),N=g.options?{applyAtProcessCreation:g.options.applyAtProcessCreation??!1,applyAtShellIntegration:g.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!P||P.value!==g.value||P.type!==g.type||P.options?.applyAtProcessCreation!==N.applyAtProcessCreation||P.options?.applyAtShellIntegration!==N.applyAtShellIntegration||P.scope?.workspaceFolder?.index!==g.scope?.workspaceFolder?.index){const O=this.g($,g.scope),L={variable:$,...g,options:N};this.map.set(O,L),this.d.fire()}}get($,g){const f=this.g($,g),P=this.map.get(f);return P?k(P):void 0}g($,g){const f=this.h(g);return f.length?`${$}:::${f}`:$}h($){return this.j($?.workspaceFolder)??""}j($){return $?$.uri.toString():void 0}getVariableMap($){const g=new Map;for(const[f,P]of this.map)this.h(P.scope)===this.h($)&&g.set(P.variable,k(P));return g}delete($,g){const f=this.g($,g);this.map.delete(f),this.d.fire()}clear($){if($?.workspaceFolder){for(const[g,f]of this.map)f.scope?.workspaceFolder?.index===$.workspaceFolder.index&&this.map.delete(g);this.k($)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription($,g){const f=this.h(g),P=this.descriptionMap.get(f);if(!P||P.description!==$){let N;typeof $=="string"?N=$:N=$?.value.split(`

`)[0];const O={description:N,scope:g};this.descriptionMap.set(f,O),this.d.fire()}}getDescription($){const g=this.h($);return this.descriptionMap.get(g)?.description}k($){const g=this.h($);this.descriptionMap.delete(g)}}class o{get persistent(){return this.b.persistent}set persistent($){this.b.persistent=$}get onDidChangeCollection(){return this.a&&this.a.event}constructor($,g){this.b=$,this.d=g,this.a=new C.$Md}getScoped($){return this.b.getScopedEnvironmentVariableCollection($)}replace($,g,f){this.b.replace($,g,f,this.d)}append($,g,f){this.b.append($,g,f,this.d)}prepend($,g,f){this.b.prepend($,g,f,this.d)}get($){return this.b.get($,this.d)}forEach($,g){this.b.getVariableMap(this.d).forEach((f,P)=>$.call(g,P,f,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete($){this.b.delete($,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description($){this.b.setDescription($,this.d)}get description(){return this.b.getDescription(this.d)}}let i=class extends t{constructor($,g){super(!1,$,g)}createTerminal($,g,f){throw new R.$$}createTerminalFromOptions($,g){throw new R.$$}};e.$lcc=i,e.$lcc=i=He([Be(0,r.$wM),Be(1,A.$aM)],i);function a(S){if(!(!S||typeof S=="string"))return"id"in S?{id:S.id,color:S.color}:S}function u(S){return v.ThemeColor.isThemeColor(S)?S:void 0}function k(S){const $={...S};return delete $.scope,$.options=$.options??void 0,delete $.variable,$}}),define(De[327],Ce([1,0,118,9,22,21,4,74,52,3,23,18,31,6,20,145,14,7,67,109,87,26]),function(me,e,C,T,d,M,A,b,E,w,R,I,p,y,D,v,l,s,r,c,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vdc=e.$udc=e.$tdc=e.$sdc=void 0;let t=class{constructor(L,j,z){this.k=z,this.d=new A.$Md,this.f=new Map,this.onResultsChanged=this.d.event,this.results=[],this.g=L.getProxy(y.$_J.MainThreadTesting),this.j=new f(this.g),this.h=new a(this.g),j.registerArgumentProcessor({processArgument:F=>{switch(F?.$mid){case 16:{const H=F,K=H.tests[H.tests.length-1].item.extId;return this.f.get(r.$5I.root(K))?.collection.tree.get(K)?.actual??(0,v.$mM)(F)}case 18:{const{extId:H,message:K}=F;return{test:this.f.get(r.$5I.root(H))?.collection.tree.get(H)?.actual,message:l.TestMessage.to(K)}}default:return F}}}),j.registerCommand(!1,"testing.getExplorerSelection",async()=>{const F=await j.executeCommand("_testing.getExplorerSelection"),H=K=>{const fe=this.f.get(r.$5I.root(K));if(fe)return r.$5I.isRoot(K)?fe.controller:fe.collection.tree.get(K)?.actual};return{include:F?.include.map(H).filter(I.$Ff)||[],exclude:F?.exclude.map(H).filter(I.$Ff)||[]}})}createTestController(L,j,z,F){if(this.f.has(j))throw new Error(`Attempt to insert a duplicate controller with ID "${j}"`);const H=new w.$Qc,K=H.add(new v.$pM(j,z,this.k));K.root.label=z;const fe=new Map,x=this.g,Z={items:K.root.children,get label(){return z},set label(Y){z=Y,K.root.label=Y,x.$updateController(j,{label:z})},get refreshHandler(){return F},set refreshHandler(Y){F=Y,x.$updateController(j,{canRefresh:!!Y})},get id(){return j},createRunProfile:(Y,be,ue,ve,J,U)=>{let V=(0,E.$Bi)(Y);for(;fe.has(V);)V++;return new P(this.g,fe,j,V,Y,be,ue,ve,J,U)},createTestItem(Y,be,ue){return new v.$nM(j,Y,be,ue)},createTestRun:(Y,be,ue=!0)=>this.h.createTestRun(L,j,K,Y,be,ue),invalidateTestResults:Y=>{if(Y===void 0)this.g.$markTestRetired(void 0);else{const be=Y instanceof Array?Y:[Y];this.g.$markTestRetired(be.map(ue=>r.$5I.fromExtHostTestItem(ue,j).toString()))}},set resolveHandler(Y){K.resolveHandler=Y},get resolveHandler(){return K.resolveHandler},dispose:()=>{H.dispose()}};x.$registerTestController(j,z,!!F),H.add((0,w.$Pc)(()=>x.$unregisterTestController(j)));const q={controller:Z,collection:K,profiles:fe,extension:L};return this.f.set(j,q),H.add((0,w.$Pc)(()=>this.f.delete(j))),H.add(K.onDidGenerateDiff(Y=>x.$publishDiff(j,Y.map(m.TestsDiffOp.serialize)))),Z}createTestObserver(){return this.j.checkout()}async runTests(L,j=M.CancellationToken.None){const z=u(L);if(!z)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const F=this.f.get(z.controllerId);if(!F)throw new Error("Controller not found");await this.g.$runTests({isUiTriggered:!1,targets:[{testIds:L.include?.map(H=>r.$5I.fromExtHostTestItem(H,F.collection.root.id).toString())??[F.collection.root.id],profileGroup:N[z.kind],profileId:z.profileId,controllerId:z.controllerId}],exclude:L.exclude?.map(H=>H.id)},j)}$syncTests(){for(const{collection:L}of this.f.values())L.flushDiff();return Promise.resolve()}$provideFileCoverage(L,j,z){return(0,C.$qb)(this.h.trackers,H=>H.id===L?H.getCoverage(j):void 0)?.provideFileCoverage(z)??Promise.resolve([])}$resolveFileCoverage(L,j,z,F){return(0,C.$qb)(this.h.trackers,K=>K.id===L?K.getCoverage(j):void 0)?.resolveFileCoverage(z,F)??Promise.resolve([])}$configureRunProfile(L,j){this.f.get(L)?.profiles.get(j)?.configureHandler?.()}async $refreshTests(L,j){await this.f.get(L)?.controller.refreshHandler?.(j)}$publishTestResults(L){this.results=Object.freeze(L.map(j=>(0,R.$3m)(l.TestResults.to(j))).concat(this.results).sort((j,z)=>z.completedAt-j.completedAt).slice(0,32)),this.d.fire()}async $expandTest(L,j){const z=this.f.get(r.$5I.fromString(L).controllerId)?.collection;z&&(await z.expand(L,j<0?1/0:j),z.flushDiff())}$acceptDiff(L){this.j.applyDiff(L.map(m.TestsDiffOp.deserialize))}async $runControllerTests(L,j){return Promise.all(L.map(z=>this.l(z,!1,j)))}async $startContinuousRun(L,j){const z=new M.$Wd(j),F=await Promise.all(L.map(H=>this.l(H,!0,z.token)));return!j.isCancellationRequested&&!F.some(H=>H.error)&&await new Promise(H=>j.onCancellationRequested(H)),z.dispose(!0),F}async l(L,j,z){const F=this.f.get(L.controllerId);if(!F)return{};const{collection:H,profiles:K,extension:fe}=F,x=K.get(L.profileId);if(!x)return{};const Z=L.testIds.map(ue=>H.tree.get(ue)).filter(I.$Ff),q=L.excludeExtIds.map(ue=>F.collection.tree.get(ue)).filter(I.$Ff).filter(ue=>Z.some(ve=>ve.fullId.compare(ue.fullId)===2));if(!Z.length)return{};const Y=new s.$JL(Z.some(ue=>ue.actual instanceof v.$oM)?void 0:Z.map(ue=>ue.actual),q.map(ue=>ue.actual),x,j),be=(0,m.$7I)(L)&&this.h.prepareForMainThreadTestRun(Y,k.fromInternal(L,F.collection),fe,z);try{return await x.runHandler(Y,z),{}}catch(ue){return{error:String(ue)}}finally{be&&(be.hasRunningTasks&&!z.isCancellationRequested&&await A.Event.toPromise(be.onEnd),be.dispose())}}$cancelExtensionTestRun(L){L===void 0?this.h.cancelAllRuns():this.h.cancelRunById(L)}};e.$sdc=t,e.$sdc=t=He([Be(0,D.$aM)],t);const n=1e4;var o;(function(O){O[O.Running=0]="Running",O[O.Cancelling=1]="Cancelling",O[O.Ended=2]="Ended"})(o||(o={}));class i extends w.$Rc{get hasRunningTasks(){return this.g.size>0}get id(){return this.s.id}constructor(L,j,z,F){super(),this.s=L,this.u=j,this.w=z,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new A.$Md),this.onEnd=this.m.event,this.j=this.B(new M.$Wd(F));const H=this.B(new T.$5g(()=>this.y(),n));this.B(this.j.token.onCancellationRequested(()=>H.schedule()))}cancel(){this.f===0?(this.j.cancel(),this.f=1):this.f===1&&this.y()}getCoverage(L){return this.g.get(L)?.coverage}createRun(L){const j=this.s.id,z=this.s.controllerId,F=(0,p.$dg)(),H=new S(this.u,j,F),K=q=>(Y,...be)=>{if(x){console.warn(`Setting the state of test "${Y.id}" is a no-op after the run ends.`);return}this.s.isIncluded(Y)&&(this.C(Y),q(Y,...be))},fe=(q,Y)=>{const be=Y instanceof Array?Y.map(l.TestMessage.from):[l.TestMessage.from(Y)];if(be.some(ue=>ue.contextValue!==void 0)&&(0,h.$_E)(this.w,"testMessageContextValue"),q.uri&&q.range){const ue={range:l.Range.from(q.range),uri:q.uri};for(const ve of be)ve.location=ve.location||ue}this.u.$appendTestMessagesInRun(j,F,r.$5I.fromExtHostTestItem(q,z).toString(),be)};let x=!1;const Z={isPersisted:this.s.isPersisted,token:this.j.token,name:L,get coverageProvider(){return H.coverageProvider},set coverageProvider(q){H.coverageProvider=q},enqueued:K(q=>{this.u.$updateTestStateInRun(j,F,r.$5I.fromExtHostTestItem(q,z).toString(),1)}),skipped:K(q=>{this.u.$updateTestStateInRun(j,F,r.$5I.fromExtHostTestItem(q,z).toString(),5)}),started:K(q=>{this.u.$updateTestStateInRun(j,F,r.$5I.fromExtHostTestItem(q,z).toString(),2)}),errored:K((q,Y,be)=>{fe(q,Y),this.u.$updateTestStateInRun(j,F,r.$5I.fromExtHostTestItem(q,z).toString(),6,be)}),failed:K((q,Y,be)=>{fe(q,Y),this.u.$updateTestStateInRun(j,F,r.$5I.fromExtHostTestItem(q,z).toString(),4,be)}),passed:K((q,Y)=>{this.u.$updateTestStateInRun(j,F,r.$5I.fromExtHostTestItem(q,this.s.controllerId).toString(),3,Y)}),appendOutput:(q,Y,be)=>{x||(be&&(this.s.isIncluded(be)?this.C(be):be=void 0),this.u.$appendOutputToRun(j,F,d.$ae.fromString(q),Y&&l.location.from(Y),be&&r.$5I.fromExtHostTestItem(be,z).toString()))},end:()=>{x||(x=!0,this.u.$finishedTestRunTask(j,F),this.g.delete(F),this.g.size||this.z())}};return this.g.set(F,{run:Z,coverage:H}),this.u.$startedTestRunTask(j,{id:F,name:L,running:!0}),Z}y(){for(const{run:L}of this.g.values())L.end()}z(){this.f!==2&&(this.f=2,this.m.fire())}C(L){if(!(L instanceof v.$nM))throw new c.$5L(L.id);if(this.h.has(r.$5I.fromExtHostTestItem(L,this.s.controllerId).toString()))return;const j=[],z=this.s.colllection.root;for(;;){const F=l.TestItem.from(L);if(j.unshift(F),this.h.has(F.extId)||(this.h.add(F.extId),L===z))break;L=L.parent||z}this.u.$addTestsToRun(this.s.controllerId,this.s.id,j)}dispose(){this.z(),super.dispose()}}class a{get trackers(){return this.d.values()}constructor(L){this.f=L,this.d=new Map}prepareForMainThreadTestRun(L,j,z,F){return this.g(L,j,z,F)}cancelRunById(L){for(const j of this.d.values())if(j.id===L){j.cancel();return}}cancelAllRuns(){for(const L of this.d.values())L.cancel()}createTestRun(L,j,z,F,H,K){const fe=this.d.get(F);if(fe)return fe.createRun(H);const x=k.fromPublic(j,z,F,K),Z=u(F);this.f.$startedExtensionTestRun({controllerId:j,continuous:!!F.continuous,profile:Z&&{group:N[Z.kind],id:Z.profileId},exclude:F.exclude?.map(Y=>r.$5I.fromExtHostTestItem(Y,z.root.id).toString())??[],id:x.id,include:F.include?.map(Y=>r.$5I.fromExtHostTestItem(Y,z.root.id).toString())??[z.root.id],persist:K});const q=this.g(F,x,L);return A.Event.once(q.onEnd)(()=>{this.f.$finishedExtensionTestRun(x.id),q.dispose()}),q.createRun(H)}g(L,j,z,F){const H=new i(j,this.f,z,F);return this.d.set(L,H),A.Event.once(H.onEnd)(()=>this.d.delete(L)),H}}e.$tdc=a;const u=O=>{if(O.profile){if(!(O.profile instanceof P))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return O.profile}};class k{static fromPublic(L,j,z,F){return new k(L,(0,p.$dg)(),z.include?.map(H=>r.$5I.fromExtHostTestItem(H,L).toString())??[L],z.exclude?.map(H=>r.$5I.fromExtHostTestItem(H,L).toString())??[],F,j)}static fromInternal(L,j){return new k(L.controllerId,L.runId,L.testIds,L.excludeExtIds,!0,j)}constructor(L,j,z,F,H,K){this.controllerId=L,this.id=j,this.isPersisted=H,this.colllection=K,this.d=z.map(fe=>fe+"\0"),this.f=F.map(fe=>fe+"\0")}isIncluded(L){const j=r.$5I.fromExtHostTestItem(L,this.controllerId).toString()+"\0";for(const z of this.f)if(j===z||j.startsWith(z))return!1;for(const z of this.d)if(j===z||j.startsWith(z))return!0;return!1}}e.$udc=k;class S{set coverageProvider(L){if(this.d)throw new Error("The TestCoverageProvider cannot be replaced after being provided");L&&(this.d=L,this.g.$signalCoverageAvailable(this.h,this.j))}get coverageProvider(){return this.d}constructor(L,j,z){this.g=L,this.h=j,this.j=z}async provideFileCoverage(L){if(!this.d)return[];this.f||(this.f=(async()=>this.d.provideFileCoverage(L))());try{return(await this.f)?.map(l.TestCoverage.fromFile)??[]}catch(j){throw this.f=void 0,j}}async resolveFileCoverage(L,j){const z=await this.f;let F=z?.[L];return!this.d||!z||!F?[]:(F.detailedCoverage||(F=z[L]=await this.d.resolveFileCoverage?.(F,j)??F),F.detailedCoverage?.map(l.TestCoverage.fromDetailed)??[])}}class ${get isEmpty(){return this.d.size===0&&this.g.size===0&&this.f.size===0}constructor(L){this.j=L,this.d=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(L){this.d.add(L)}update(L){Object.assign(L.revived,l.TestItem.toPlain(L.item)),this.d.has(L)||this.f.add(L)}remove(L){if(this.d.has(L)){this.d.delete(L);return}this.f.delete(L);const j=r.$5I.parentId(L.item.extId);if(j&&this.h.has(j.toString())){this.h.add(L.item.extId);return}this.g.add(L)}getChangeEvent(){const{d:L,f:j,g:z}=this;return{get added(){return[...L].map(F=>F.revived)},get updated(){return[...j].map(F=>F.revived)},get removed(){return[...z].map(F=>F.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class g extends m.$_I{constructor(){super(...arguments),this.s=new A.$Md,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(L){return this.f.get(L)}getMirroredTestDataByReference(L){return this.f.get(L.id)}q(L,j){return{...L,revived:l.TestItem.toPlain(L.item),depth:j?j.depth+1:0,children:new Set}}p(){return new $(this.s)}}class f{constructor(L){this.f=L}checkout(){this.d||(this.d=this.g());const L=this.d;return L.observers++,{onDidChangeTest:L.tests.onDidChangeTests,get tests(){return[...L.tests.rootTests].map(j=>j.revived)},dispose:(0,b.$cb)(()=>{--L.observers===0&&(this.f.$unsubscribeFromDiffs(),this.d=void 0)})}}getMirroredTestDataByReference(L){return this.d?.tests.getMirroredTestDataByReference(L)}applyDiff(L){this.d?.tests.apply(L)}g(){const L=new g;return this.f.$subscribeToDiffs(),{observers:0,tests:L}}}class P{#e;#t;get label(){return this.f}set label(L){L!==this.f&&(this.f=L,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:L}))}get supportsContinuousRun(){return this.h}set supportsContinuousRun(L){L!==this.h&&(this.h=L,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:L}))}get isDefault(){return this.g}set isDefault(L){L!==this.g&&(this.g=L,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:L}))}get tag(){return this._tag}set tag(L){L?.id!==this._tag?.id&&(this._tag=L,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:L?l.TestTag.namespace(this.controllerId,L.id):null}))}get configureHandler(){return this.d}set configureHandler(L){L!==this.d&&(this.d=L,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!L}))}constructor(L,j,z,F,H,K,fe,x=!1,Z=void 0,q=!1){this.controllerId=z,this.profileId=F,this.f=H,this.kind=K,this.runHandler=fe,this.g=x,this._tag=Z,this.h=q,this.#e=L,this.#t=j,j.set(F,this);const Y=N[K];if(typeof Y!="number")throw new Error(`Unknown TestRunProfile.group ${K}`);this.#e.$publishTestRunProfile({profileId:F,controllerId:z,tag:Z?l.TestTag.namespace(this.controllerId,Z.id):null,label:H,group:Y,isDefault:x,hasConfigurationHandler:!1,supportsContinuousRun:q})}dispose(){this.#t?.delete(this.profileId)&&(this.#t=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.$vdc=P;const N={[s.TestRunProfileKind.Coverage]:8,[s.TestRunProfileKind.Debug]:4,[s.TestRunProfileKind.Run]:2}}),define(De[328],Ce([1,0,19,8,4,6,146,14,7]),function(me,e,C,T,d,M,A,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kcc=void 0;class w{constructor(I,p){this.i=p,this.a=new d.$Md({onListenerError:T.$1}),this.b=new d.$Md({onListenerError:T.$1}),this.c=new d.$Md({onListenerError:T.$1}),this.d=new d.$Md({onListenerError:T.$1}),this.f=new d.$Md({onListenerError:T.$1}),this.g=new d.$Md({onListenerError:T.$1}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=I.getProxy(M.$_J.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(y=>this.g.fire(y)),this.i.onDidChangeActiveTextEditor(y=>this.f.fire(y))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(I){const p=this.i.allEditors();return I?p:p.map(y=>y.value)}async showTextDocument(I,p,y){let D;typeof p=="number"?D={position:b.ViewColumn.from(p),preserveFocus:y}:typeof p=="object"?D={position:b.ViewColumn.from(p.viewColumn),preserveFocus:p.preserveFocus,selection:typeof p.selection=="object"?b.Range.from(p.selection):void 0,pinned:typeof p.preview=="boolean"?!p.preview:void 0}:D={preserveFocus:!1};const v=await this.h.$tryShowTextDocument(I.uri,D),l=v&&this.i.getEditor(v);if(l)return l.value;throw v?new Error(`Could NOT open editor for "${I.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${I.uri.toString()}".`)}createTextEditorDecorationType(I,p){return new A.$hM(this.h,I,p).value}$acceptEditorPropertiesChanged(I,p){const y=this.i.getEditor(I);if(!y)throw new Error("unknown text editor");if(p.options&&y._acceptOptions(p.options),p.selections){const D=p.selections.selections.map(b.Selection.to);y._acceptSelections(D)}if(p.visibleRanges){const D=C.$Gb(p.visibleRanges.map(b.Range.to));y._acceptVisibleRanges(D)}if(p.options&&this.b.fire({textEditor:y.value,options:{...p.options,lineNumbers:b.TextEditorLineNumbersStyle.to(p.options.lineNumbers)}}),p.selections){const D=E.TextEditorSelectionChangeKind.fromValue(p.selections.source),v=p.selections.selections.map(b.Selection.to);this.a.fire({textEditor:y.value,selections:v,kind:D})}if(p.visibleRanges){const D=C.$Gb(p.visibleRanges.map(b.Range.to));this.c.fire({textEditor:y.value,visibleRanges:D})}}$acceptEditorPositionData(I){for(const p in I){const y=this.i.getEditor(p);if(!y)throw new Error("Unknown text editor");const D=b.ViewColumn.to(I[p]);y.value.viewColumn!==D&&(y._acceptViewColumn(D),this.d.fire({textEditor:y.value,viewColumn:D}))}}getDiffInformation(I){return Promise.resolve(this.h.$getDiffInformation(I))}}e.$Kcc=w}),define(De[329],Ce([1,0,2,5,6,3,7,14,25,18]),function(me,e,C,T,d,M,A,b,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ndc=e.$mdc=void 0,e.$mdc=(0,T.$Nh)("IExtHostTimeline");class R{constructor(y,D){this.b=new Map,this.c=new Map,this.a=y.getProxy(d.$_J.MainThreadTimeline),D.registerArgumentProcessor({processArgument:(v,l)=>{if(v&&v.$mid===12)if(this.b.get(v.source)&&E.$2l.equals(l,this.b.get(v.source)?.extension)){const s=v.uri===void 0?void 0:C.URI.revive(v.uri);return this.c.get(v.source)?.get(I(s))?.get(v.handle)}else return;return v}})}async $getTimeline(y,D,v,l){return this.b.get(y)?.provider.provideTimeline(C.URI.revive(D),v,l)}registerTimelineProvider(y,D,v,l){const s=new M.$Qc,r=this.d(D.id,l,s).bind(this);let c;D.onDidChange&&(c=D.onDidChange(h=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...h,id:D.id}),this));const m=this.c;return this.f({...D,scheme:y,onDidChange:void 0,async provideTimeline(h,t,n){t?.resetCache&&(s.clear(),m.get(D.id)?.clear());const o=await D.provideTimeline(h,t,n);if(o==null)return;const i=r(h,t);return{...o,source:D.id,items:o.items.map(i)}},dispose(){for(const h of m.values())h.get(D.id)?.clear();c?.dispose(),s.dispose()}},v)}d(y,D,v){return(l,s)=>{let r;if(s?.cacheResults){let c=this.c.get(y);c===void 0&&(c=new Map,this.c.set(y,c));const m=I(l);r=c.get(m),r===void 0&&(r=new Map,c.set(m,r))}return c=>{const{iconPath:m,...h}=c,t=`${y}|${c.id??c.timestamp}`;r?.set(t,c);let n,o,i;c.iconPath&&(m instanceof A.$8K?i={id:m.id,color:m.color}:C.URI.isUri(m)?(n=m,o=m):{light:n,dark:o}=m);let a;return A.$BK.isMarkdownString(h.tooltip)?a=b.MarkdownString.from(h.tooltip):(0,w.$xf)(h.tooltip)?a=h.tooltip:A.$BK.isMarkdownString(h.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),a=b.MarkdownString.from(h.detail)):(0,w.$xf)(h.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),a=h.detail),{...h,id:h.id??void 0,handle:t,source:y,command:c.command?D.toInternal(c.command,v):void 0,icon:n,iconDark:o,themeIcon:i,tooltip:a,accessibilityInformation:c.accessibilityInformation}}}}f(y,D){if(this.b.get(y.id))throw new Error(`Timeline Provider ${y.id} already exists.`);return this.a.$registerTimelineProvider({id:y.id,label:y.label,scheme:y.scheme}),this.b.set(y.id,{provider:y,extension:D}),(0,M.$Pc)(()=>{for(const l of this.c.values())l.get(y.id)?.clear();this.b.delete(y.id),this.a.$unregisterTimelineProvider(y.id),y.dispose()})}}e.$ndc=R;function I(p){return p?.toString()}}),define(De[72],Ce([1,0,21,4,3,213,5,13,86,6,27,20,7]),function(me,e,C,T,d,M,A,b,E,w,R,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xvb=e.$Wvb=e.TunnelDtoConverter=void 0;class y extends E.$av{}var D;(function(l){function s(c){return{remoteAddress:c.remoteAddress,localAddress:c.localAddress,public:!!c.public,privacy:c.privacy??(c.public?E.TunnelPrivacyId.Public:E.TunnelPrivacyId.Private),protocol:c.protocol}}l.fromApiTunnel=s;function r(c){return{remoteAddress:{host:c.tunnelRemoteHost,port:c.tunnelRemotePort},localAddress:c.localAddress,public:c.privacy!==E.TunnelPrivacyId.ConstantPrivate&&c.privacy!==E.TunnelPrivacyId.ConstantPrivate,privacy:c.privacy,protocol:c.protocol}}l.fromServiceTunnel=r})(D||(e.TunnelDtoConverter=D={})),e.$Wvb=(0,A.$Nh)("IExtHostTunnelService");let v=class extends d.$Rc{constructor(s,r,c){super(),this.s=c,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new T.$Md,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=s.getProxy(w.$_J.MainThreadTunnelService)}async openTunnel(s,r){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${s.identifier.value} called openTunnel API for ${r.remoteAddress.host}:${r.remoteAddress.port}.`);const c=await this.a.$openTunnel(r,s.displayName);if(c){const m=new y(c.remoteAddress,c.localAddress,()=>this.a.$closeTunnel(c.remoteAddress));return this.B(m),m}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(s,r){const c=this.u();return this.r.set(c,{selector:s,provider:r}),this.a.$registerPortsAttributesProvider(s,c),new p.$bK(()=>{this.r.delete(c),this.a.$unregisterPortsAttributesProvider(c)})}async $providePortAttributes(s,r,c,m,h){const t=[];for(const o of s){const i=this.r.get(o);if(!i)return[];t.push(...await Promise.all(r.map(async a=>{let u;try{u=await i.provider.providePortAttributes({port:a,pid:c,commandLine:m},h)}catch{u=await i.provider.providePortAttributes(a,c,m,h)}return{providedAttributes:u,port:a}})))}const n=t.filter(o=>!!o.providedAttributes);return n.length>0?n.map(o=>({autoForwardAction:o.providedAttributes.autoForwardAction,port:o.port})):[]}async $registerCandidateFinder(s){}registerTunnelProvider(s,r){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(m,h)=>await s.provideTunnel(m,h,new C.$Wd().token)??void 0;const c=r.tunnelFeatures?{elevation:!!r.tunnelFeatures?.elevation,privacyOptions:r.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(c),Promise.resolve((0,d.$Pc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(s,r){if(s){s.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(s.candidatePortSource),s.showCandidatePort&&(this.f=s.showCandidatePort,this.a.$setCandidateFilter());const c=s.tunnelFactory??(r?this.w(r):void 0);if(c){this.b=c;let m=s.tunnelFeatures?.privacyOptions??[];s.tunnelFeatures?.public&&m.length===0&&(m=[{id:"private",label:M.localize(0,null),themeIcon:"lock"},{id:"public",label:M.localize(1,null),themeIcon:"eye"}]);const h=s.tunnelFeatures?{elevation:!!s.tunnelFeatures?.elevation,public:!!s.tunnelFeatures?.public,privacyOptions:m}:void 0;this.a.$setTunnelProvider(h)}}else this.b=void 0;return(0,d.$Pc)(()=>{this.b=void 0})}w(s){}async $closeTunnel(s,r){if(this.g.has(s.host)){const c=this.g.get(s.host);c.has(s.port)&&(r&&c.get(s.port).disposeListener.dispose(),await c.get(s.port).tunnel.dispose(),c.delete(s.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(s,r){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const c=this.b(s,r);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),c!==void 0){const m=await c;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),m===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(s.remoteAddress.host)||this.g.set(s.remoteAddress.host,new Map);const h=this.B(m.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(m.remoteAddress))));return this.g.get(s.remoteAddress.host).set(s.remoteAddress.port,{tunnel:m,disposeListener:h}),D.fromApiTunnel(m)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(c){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),c instanceof Error)return c.message}}async $applyCandidateFilter(s){const r=await Promise.all(s.map(m=>this.f(m.host,m.port,m.detail??""))),c=s.filter((m,h)=>r[h]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${s.map(m=>m.port).join(", ")} to ${c.map(m=>m.port).join(", ")}`),c}};e.$Xvb=v,e.$Xvb=v=He([Be(0,I.$aM),Be(1,R.$qM),Be(2,b.$8i)],v)}),define(De[330],Ce([1,0,3,17,2,6]),function(me,e,C,T,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wdc=void 0;class A{static{this.a=new Set([T.Schemas.http,T.Schemas.https])}constructor(E){this.c=new Map,this.b=E.getProxy(M.$_J.MainThreadUriOpeners)}registerExternalUriOpener(E,w,R,I){if(this.c.has(w))throw new Error(`Opener with id '${w}' already registered`);const p=I.schemes.find(y=>!A.a.has(y));if(p)throw new Error(`Scheme '${p}' is not supported. Only http and https are currently supported.`);return this.c.set(w,R),this.b.$registerUriOpener(w,I.schemes,E,I.label),(0,C.$Pc)(()=>{this.c.delete(w),this.b.$unregisterUriOpener(w)})}async $canOpenUri(E,w,R){const I=this.c.get(E);if(!I)throw new Error(`Unknown opener with id: ${E}`);const p=d.URI.revive(w);return I.canOpenExternalUri(p,R)}async $openUri(E,w,R){const I=this.c.get(E);if(!I)throw new Error(`Unknown opener id: '${E}'`);return I.openExternalUri(d.URI.revive(w.resolvedUri),{sourceUri:d.URI.revive(w.sourceUri)},R)}}e.$wdc=A}),define(De[331],Ce([1,0,6,2,3,8,25]),function(me,e,C,T,d,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mcc=void 0;class b{static{this.a=0}constructor(w){this.c=new A.$3l,this.d=new Map,this.b=w.getProxy(C.$_J.MainThreadUrls)}registerUriHandler(w,R){const I=w.identifier;if(this.c.has(I))throw new Error(`Protocol handler already registered for extension ${I}`);const p=b.a++;return this.c.add(I),this.d.set(p,R),this.b.$registerUriHandler(p,I,w.displayName||w.name),(0,d.$Pc)(()=>{this.c.delete(I),this.d.delete(p),this.b.$unregisterUriHandler(p)})}$handleExternalUri(w,R){const I=this.d.get(w);if(!I)return Promise.resolve(void 0);try{I.handleUri(T.URI.revive(R))}catch(p){(0,M.$Z)(p)}return Promise.resolve(void 0)}async createAppUri(w){return T.URI.revive(await this.b.$createAppUri(w))}}e.$Mcc=b}),define(De[91],Ce([1,0,4,3,17,23,2,228,265,110,6]),function(me,e,C,T,d,M,A,b,E,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rcc=e.$Qcc=e.$Pcc=e.$Occ=e.$Ncc=void 0;class I{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;constructor(m,h,t,n,o,i,a){this.#s="",this.#o=!1,this.#a=!1,this._onMessageEmitter=new C.$Md,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new C.$Md,this._onDidDispose=this.#h.event,this.#e=m,this.#t=h,this.#r=t,this.#l=n,this.#u=o,this.#n=i,this.#c=p(i),this.#d=y(i),this.#i=a}#h;dispose(){this.#o=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(m){return this.#a=!0,(0,w.$1ob)(m,this.#l)}get cspSource(){const m=this.#n.extensionLocation;if(m.scheme===d.Schemas.https||m.scheme===d.Schemas.http){let h=m.toString();return h.endsWith("/")||(h+="/"),h+" "+w.$Zob}return w.$Zob}get html(){return this.a(),this.#s}set html(m){this.a(),this.#s!==m&&(this.#s=m,this.#d&&!this.#a&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(m)&&(this.#a=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(m)))}get options(){return this.a(),this.#r}set options(m){this.a(),M.$6m(this.#r,m)||this.#t.$setOptions(this.#e,l(this.#n,this.#u,m)),this.#r=m}async postMessage(m){if(this.#o)return!1;const h=(0,E.$rcb)(m,{serializeBuffersForPostMessage:this.#c});return this.#t.$postMessage(this.#e,h.message,...h.buffers)}a(){if(this.#o)throw new Error("Webview is disposed")}b(m){if(!this.#d)return m;const h=this.#n.extensionLocation?.scheme===d.Schemas.vscodeRemote,t=this.#n.extensionLocation.scheme===d.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return m.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(n,o,i,a,u,k)=>{const S=A.URI.from({scheme:a||"file",path:decodeURIComponent(u)}),$=(0,w.$1ob)(S,{isRemote:h,authority:t}).toString();return`${o}${$}${k}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(n,o,i,a,u,k)=>{const S=A.URI.from({scheme:a||"file",path:decodeURIComponent(u)}),$=(0,w.$1ob)(S,{isRemote:h,authority:t}).toString();return`${o}${$}${k}`})}}e.$Ncc=I;function p(c){try{const m=(0,b.$Jo)((0,b.$Io)(c.engines.vscode));return!!m&&m.majorBase>=1&&m.minorBase>=57}catch{return!1}}e.$Occ=p;function y(c){try{const m=(0,b.$Jo)((0,b.$Io)(c.engines.vscode));return m?m.majorBase<1||m.majorBase===1&&m.minorBase<60:!1}catch{return!1}}class D extends T.$Rc{constructor(m,h,t,n,o){super(),this.c=h,this.f=t,this.g=n,this.h=o,this.b=new Map,this.a=m.getProxy(R.$_J.MainThreadWebviews)}dispose(){super.dispose();for(const m of this.b.values())m.dispose();this.b.clear()}$onMessage(m,h,t){const n=this.j(m);if(n){const{message:o}=(0,E.$scb)(h,t.value);n._onMessageEmitter.fire(o)}}$onMissingCsp(m,h){this.g.warn(`${h} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(m,h,t){const n=new I(m,this.a,s(h),this.c,this.f,t,this.h);this.b.set(m,n);const o=n._onDidDispose(()=>{o.dispose(),this.deleteWebview(m)});return n}deleteWebview(m){this.b.delete(m)}j(m){return this.b.get(m)}}e.$Pcc=D;function v(c){return{id:c.identifier,location:c.extensionLocation}}e.$Qcc=v;function l(c,m,h){return{enableCommandUris:h.enableCommandUris,enableScripts:h.enableScripts,enableForms:h.enableForms,portMapping:h.portMapping,localResourceRoots:h.localResourceRoots||r(c,m)}}e.$Rcc=l;function s(c){return{enableCommandUris:c.enableCommandUris,enableScripts:c.enableScripts,enableForms:c.enableForms,portMapping:c.portMapping,localResourceRoots:c.localResourceRoots?.map(m=>A.URI.from(m))}}function r(c,m){return[...(m?.getWorkspaceFolders()||[]).map(h=>h.uri),c.extensionLocation]}}),define(De[332],Ce([1,0,21,52,3,17,24,2,14,91,107,6,7]),function(me,e,C,T,d,M,A,b,E,w,R,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qdc=void 0;class y{constructor(n,o){this.document=n,this.b=o,this.a=1,this.c=new R.$Jbc("custom documents")}addEdit(n){return this.c.add([n])}async undo(n,o){await this.f(n).undo(),o||this.disposeBackup()}async redo(n,o){await this.f(n).redo(),o||this.disposeBackup()}disposeEdits(n){for(const o of n)this.c.delete(o)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const n=h(this.document.uri)+this.a++;return(0,A.$ug)(this.b,n)}updateBackup(n){this.d?.delete(),this.d=n}disposeBackup(){this.d?.delete(),this.d=void 0}f(n){const o=this.c.get(n,0);if(!o)throw new Error("No edit found");return o}}class D{constructor(){this.a=new Map}get(n,o){return this.a.get(this.b(n,o))}add(n,o,i){const a=this.b(n,o.uri);if(this.a.has(a))throw new Error(`Document already exists for viewType:${n} resource:${o.uri}`);const u=new y(o,i);return this.a.set(a,u),u}delete(n,o){const i=this.b(n,o.uri);this.a.delete(i)}b(n,o){return`${n}@@@${o}`}}var v;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(v||(v={}));class l{constructor(){this.a=new Map}addTextProvider(n,o,i){return this.b(0,n,o,i)}addCustomProvider(n,o,i){return this.b(1,n,o,i)}get(n){return this.a.get(n)}b(n,o,i,a){if(this.a.has(o))throw new Error(`Provider for viewType:${o} already registered`);return this.a.set(o,{type:n,extension:i,provider:a}),new p.$bK(()=>this.a.delete(o))}}class s{constructor(n,o,i,a,u){this.d=o,this.f=i,this.g=a,this.h=u,this.b=new l,this.c=new D,this.a=n.getProxy(I.$_J.MainThreadCustomEditors)}registerCustomEditorProvider(n,o,i,a){const u=new d.$Qc;return c(i)?(u.add(this.b.addTextProvider(o,n,i)),this.a.$registerTextEditorProvider((0,w.$Qcc)(n),o,a.webviewOptions||{},{supportsMove:!!i.moveCustomTextEditor},(0,w.$Occ)(n))):(u.add(this.b.addCustomProvider(o,n,i)),r(i)&&u.add(i.onDidChangeCustomDocument(k=>{const S=this.i(o,k.document.uri);if(m(k)){const $=S.addEdit(k);this.a.$onDidEdit(k.document.uri,o,$,k.label)}else this.a.$onContentChange(k.document.uri,o)})),this.a.$registerCustomEditorProvider((0,w.$Qcc)(n),o,a.webviewOptions||{},!!a.supportsMultipleEditorsPerDocument,(0,w.$Occ)(n))),p.$bK.from(u,new p.$bK(()=>{this.a.$unregisterEditorProvider(o)}))}async $createCustomDocument(n,o,i,a,u){const k=this.b.get(o);if(!k)throw new Error(`No provider found for '${o}'`);if(k.type!==1)throw new Error(`Invalid provide type for '${o}'`);const S=b.URI.revive(n),$=await k.provider.openCustomDocument(S,{backupId:i,untitledDocumentData:a?.buffer},u);let g;return r(k.provider)&&this.f&&(g=this.f.workspaceValue(k.extension)??this.f.globalValue(k.extension)),this.c.add(o,$,g),{editable:r(k.provider)}}async $disposeCustomDocument(n,o){const i=this.b.get(o);if(!i)throw new Error(`No provider found for '${o}'`);if(i.type!==1)throw new Error(`Invalid provider type for '${o}'`);const a=b.URI.revive(n),{document:u}=this.i(o,a);this.c.delete(o,u),u.dispose()}async $resolveCustomEditor(n,o,i,a,u,k){const S=this.b.get(i);if(!S)throw new Error(`No provider found for '${i}'`);const $=E.ViewColumn.to(u),g=this.g.createNewWebview(o,a.contentOptions,S.extension),f=this.h.createNewWebviewPanel(o,i,a.title,$,a.options,g,a.active),P=b.URI.revive(n);switch(S.type){case 1:{const{document:N}=this.i(i,P);return S.provider.resolveCustomEditor(N,f,k)}case 0:{const N=this.d.getDocument(P);return S.provider.resolveCustomTextEditor(N,f,k)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(n,o,i){this.i(o,n).disposeEdits(i)}async $onMoveCustomEditor(n,o,i){const a=this.b.get(i);if(!a)throw new Error(`No provider found for '${i}'`);if(!a.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${i}'`);const u=this.h.getWebviewPanel(n);if(!u)throw new Error("No webview found");const k=b.URI.revive(o),S=this.d.getDocument(k);await a.provider.moveCustomTextEditor(S,u,C.CancellationToken.None)}async $undo(n,o,i,a){return this.i(o,n).undo(i,a)}async $redo(n,o,i,a){return this.i(o,n).redo(i,a)}async $revert(n,o,i){const a=this.i(o,n);await this.j(o).revertCustomDocument(a.document,i),a.disposeBackup()}async $onSave(n,o,i){const a=this.i(o,n);await this.j(o).saveCustomDocument(a.document,i),a.disposeBackup()}async $onSaveAs(n,o,i,a){const u=this.i(o,n);return this.j(o).saveCustomDocumentAs(u.document,b.URI.revive(i),a)}async $backup(n,o,i){const a=this.i(o,n),k=await this.j(o).backupCustomDocument(a.document,{destination:a.getNewBackupUri()},i);return a.updateBackup(k),k.id}i(n,o){const i=this.c.get(n,b.URI.revive(o));if(!i)throw new Error("No custom document found");return i}j(n){const i=this.b.get(n)?.provider;if(!i||!r(i))throw new Error("Custom document is not editable");return i}}e.$qdc=s;function r(t){return!!t.onDidChangeCustomDocument}function c(t){return typeof t.resolveCustomTextEditor=="function"}function m(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function h(t){const n=t.scheme===M.Schemas.file||t.scheme===M.Schemas.untitled?t.fsPath:t.toString();return(0,T.$Bi)(n)+""}}),define(De[333],Ce([1,0,4,3,2,31,14,91,6,7]),function(me,e,C,T,d,M,A,b,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pdc=void 0;class R extends T.$Rc{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;#h;constructor(D,v,l,s){super(),this.#r=void 0,this.#o=!0,this.#c=!1,this.#d=this.B(new C.$Md),this.onDidDispose=this.#d.event,this.#h=this.B(new C.$Md),this.onDidChangeViewState=this.#h.event,this.#e=D,this.#t=v,this.#l=l,this.#i=s.viewType,this.#u=s.panelOptions,this.#r=s.viewColumn,this.#n=s.title,this.#a=s.active}dispose(){this.#c||(this.#c=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#l.dispose(),super.dispose())}get webview(){return this.c(),this.#l}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#n}set title(D){this.c(),this.#n!==D&&(this.#n=D,this.#t.$setTitle(this.#e,D))}get iconPath(){return this.c(),this.#s}set iconPath(D){this.c(),this.#s!==D&&(this.#s=D,this.#t.$setIconPath(this.#e,d.URI.isUri(D)?{light:D,dark:D}:D))}get options(){return this.#u}get viewColumn(){if(this.c(),!(typeof this.#r=="number"&&this.#r<0))return this.#r}get active(){return this.c(),this.#a}get visible(){return this.c(),this.#o}_updateViewState(D){this.#c||(this.active!==D.active||this.visible!==D.visible||this.viewColumn!==D.viewColumn)&&(this.#a=D.active,this.#o=D.visible,this.#r=D.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(D,v){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof D>"u"?void 0:A.ViewColumn.from(D),preserveFocus:!!v})}c(){if(this.#c)throw new Error("Webview is disposed")}}class I extends T.$Rc{static c(){return(0,M.$dg)()}constructor(D,v,l){super(),this.j=v,this.m=l,this.g=new Map,this.h=new Map,this.f=D.getProxy(E.$_J.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(D=>D.dispose()),this.g.clear()}createWebviewPanel(D,v,l,s,r={}){const c=typeof s=="object"?s.viewColumn:s,m={viewColumn:A.ViewColumn.from(c),preserveFocus:typeof s=="object"&&!!s.preserveFocus},h=(0,b.$Occ)(D),t=I.c();this.f.$createWebviewPanel((0,b.$Qcc)(D),t,v,{title:l,panelOptions:p(r),webviewOptions:(0,b.$Rcc)(D,this.m,r),serializeBuffersForPostMessage:h},m);const n=this.j.createNewWebview(t,r,D);return this.createNewWebviewPanel(t,v,l,c,r,n,!0)}$onDidChangeWebviewPanelViewStates(D){const v=Object.keys(D);v.sort((l,s)=>{const r=D[l],c=D[s];return r.active?1:c.active?-1:+r.visible-+c.visible});for(const l of v){const s=this.getWebviewPanel(l);if(!s)continue;const r=D[l];s._updateViewState({active:r.active,visible:r.visible,viewColumn:A.ViewColumn.to(r.position)})}}async $onDidDisposeWebviewPanel(D){this.getWebviewPanel(D)?.dispose(),this.g.delete(D),this.j.deleteWebview(D)}registerWebviewPanelSerializer(D,v,l){if(this.h.has(v))throw new Error(`Serializer for '${v}' already registered`);return this.h.set(v,{serializer:l,extension:D}),this.f.$registerSerializer(v,{serializeBuffersForPostMessage:(0,b.$Occ)(D)}),new w.$bK(()=>{this.h.delete(v),this.f.$unregisterSerializer(v)})}async $deserializeWebviewPanel(D,v,l,s){const r=this.h.get(v);if(!r)throw new Error(`No serializer found for '${v}'`);const{serializer:c,extension:m}=r,h=this.j.createNewWebview(D,l.webviewOptions,m),t=this.createNewWebviewPanel(D,v,l.title,s,l.panelOptions,h,l.active);await c.deserializeWebviewPanel(t,l.state)}createNewWebviewPanel(D,v,l,s,r,c,m){const h=new R(D,this.f,c,{viewType:v,title:l,viewColumn:s,panelOptions:r,active:m});return this.g.set(D,h),h}getWebviewPanel(D){return this.g.get(D)}}e.$pdc=I;function p(y){return{enableFindWidget:y.enableFindWidget,retainContextWhenHidden:y.retainContextWhenHidden}}}),define(De[334],Ce([1,0,4,3,91,14,6,7]),function(me,e,C,T,d,M,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$odc=void 0;class E extends T.$Rc{#e;#t;#i;#l;#u;#n;#s;#r;#o;constructor(I,p,y,D,v,l){super(),this.#u=!1,this.#a=this.B(new C.$Md),this.onDidChangeVisibility=this.#a.event,this.#c=this.B(new C.$Md),this.onDidDispose=this.#c.event,this.#i=y,this.#s=D,this.#e=I,this.#t=p,this.#l=v,this.#n=l}dispose(){this.#u||(this.#u=!0,this.#c.fire(),this.#l.dispose(),super.dispose())}#a;#c;get title(){return this.a(),this.#s}set title(I){this.a(),this.#s!==I&&(this.#s=I,this.#t.$setWebviewViewTitle(this.#e,I))}get description(){return this.a(),this.#r}set description(I){this.a(),this.#r!==I&&(this.#r=I,this.#t.$setWebviewViewDescription(this.#e,I))}get visible(){return this.#n}get webview(){return this.#l}get viewType(){return this.#i}_setVisible(I){I===this.#n||this.#u||(this.#n=I,this.#a.fire())}get badge(){return this.a(),this.#o}set badge(I){this.a(),!(I?.value===this.#o?.value&&I?.tooltip===this.#o?.tooltip)&&(this.#o=M.ViewBadge.from(I),this.#t.$setWebviewViewBadge(this.#e,I))}show(I){this.a(),this.#t.$show(this.#e,!!I)}a(){if(this.#u)throw new Error("Webview is disposed")}}class w{constructor(I,p){this.d=p,this.b=new Map,this.c=new Map,this.a=I.getProxy(A.$_J.MainThreadWebviewViews)}registerWebviewViewProvider(I,p,y,D){if(this.b.has(p))throw new Error(`View provider for '${p}' already registered`);return this.b.set(p,{provider:y,extension:I}),this.a.$registerWebviewViewProvider((0,d.$Qcc)(I),p,{retainContextWhenHidden:D?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,d.$Occ)(I)}),new b.$bK(()=>{this.b.delete(p),this.a.$unregisterWebviewViewProvider(p)})}async $resolveWebviewView(I,p,y,D,v){const l=this.b.get(p);if(!l)throw new Error(`No view provider found for '${p}'`);const{provider:s,extension:r}=l,c=this.d.createNewWebview(I,{},r),m=new E(I,this.a,p,y,c,!0);this.c.set(I,m),await s.resolveWebviewView(m,{state:D},v)}async $onDidChangeWebviewViewVisibility(I,p){this.e(I)._setVisible(p)}async $disposeWebviewView(I){const p=this.e(I);this.c.delete(I),p.dispose(),this.d.deleteWebview(I)}e(I){const p=this.c.get(I);if(!p)throw new Error("No webview found");return p}}e.$odc=w}),define(De[151],Ce([1,0,4,6,2,17,15,5,20,26]),function(me,e,C,T,d,M,A,b,E,w){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.$Tcc=e.$Scc=void 0;let I=class{static{R=this}static{this.a={focused:!0,active:!0}}getState(y){const D=this.d;return{get focused(){return D.focused},get active(){return(0,w.$_E)(y,"windowActivity"),D.active}}}constructor(y){this.c=new C.$Md,this.onDidChangeWindowState=this.c.event,this.d=R.a,this.b=y.getProxy(T.$_J.MainThreadWindow),this.b.$getInitialState().then(({isFocused:D,isActive:v})=>{this.onDidChangeWindowProperty("focused",D),this.onDidChangeWindowProperty("active",v)})}$onDidChangeWindowFocus(y){this.onDidChangeWindowProperty("focused",y)}$onDidChangeWindowActive(y){this.onDidChangeWindowProperty("active",y)}onDidChangeWindowProperty(y,D){D!==this.d[y]&&(this.d={...this.d,[y]:D},this.c.fire(this.d))}openUri(y,D){let v;if(typeof y=="string"){v=y;try{y=d.URI.parse(y)}catch{return Promise.reject(`Invalid uri - '${y}'`)}}return(0,A.$Ae)(y.scheme)?Promise.reject("Invalid scheme - cannot be empty"):y.scheme===M.Schemas.command?Promise.reject(`Invalid scheme '${y.scheme}'`):this.b.$openUri(y,v,D)}async asExternalUri(y,D){if((0,A.$Ae)(y.scheme))return Promise.reject("Invalid scheme - cannot be empty");const v=await this.b.$asExternalUri(y,D);return d.URI.from(v)}};e.$Scc=I,e.$Scc=I=R=He([Be(0,E.$aM)],I),e.$Tcc=(0,b.$Nh)("IExtHostWindow")}),define(De[335],Ce([1,0,303,27,20]),function(me,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qec=void 0;const M=1024*1024;let A=class extends C.$Rdc{constructor(E,w){super(E,w),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(E,w,R){const I=E==="error"||E==="warn"?process.stderr:process.stdout;this.g=!0,I.write(`
START_NATIVE_LOG
`),w.apply(console,R),I.write(`
END_NATIVE_LOG
`),this.g=!1}j(E,w){const R=process[E],I=R.write;let p="";Object.defineProperty(R,"write",{set:()=>{},get:()=>(y,D,v)=>{if(!this.g){p+=y.toString(D);const l=p.length>M?p.length:p.lastIndexOf(`
`);l!==-1&&(console[w](p.slice(0,l)),p=p.slice(l+1))}I.call(R,y,D,v)}})}};e.$qec=A,e.$qec=A=He([Be(0,d.$aM),Be(1,T.$qM)],A)}),define(De[336],Ce([1,0,71,17,13,240,30,12]),function(me,e,C,T,d,M,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rec=void 0;let E=class{constructor(I,p){I.addFileSystemProvider(T.Schemas.file,new w(p),{isCaseSensitive:b.$l})}};e.$rec=E,e.$rec=E=He([Be(0,C.$fcc),Be(1,d.$8i)],E);class w{constructor(I){this.b=I,this.a=new M.$9p(this.b)}async stat(I){const p=await this.a.stat(I);return{type:p.type,ctime:p.ctime,mtime:p.mtime,size:p.size,permissions:p.permissions===A.FilePermission.Readonly?1:void 0}}readDirectory(I){return this.a.readdir(I)}createDirectory(I){return this.a.mkdir(I)}readFile(I){return this.a.readFile(I)}writeFile(I,p,y){return this.a.writeFile(I,p,{...y,unlock:!1,atomic:!1})}delete(I,p){return this.a.delete(I,{...p,useTrash:!1,atomic:!1})}rename(I,p,y){return this.a.rename(I,p,y)}copy(I,p,y){return this.a.copy(I,p,y)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(I,p){throw new Error("Method not implemented.")}}}),define(De[337],Ce([1,0,16,63,31,33,3,6,2,20]),function(me,e,C,T,d,M,A,b,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pec=void 0;let R=class extends A.$Rc{constructor(p,y){super();const D=p.getProxy(b.$_J.MainThreadDownloadService);y.registerCommand(!1,"_workbench.downloadResource",async v=>{const l=E.URI.file((0,C.$ic)((0,T.tmpdir)(),(0,d.$dg)()));return await D.$download(v,l),l})}};e.$pec=R,e.$pec=R=He([Be(0,w.$aM),Be(1,M.$wM)],R)}),define(De[338],Ce([1,0,150,17,242,31]),function(me,e,C,T,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cec=void 0;class A extends C.$Qdc{s(E,w,R){return E.scheme===T.Schemas.file?new d.$mN(R?.name||(0,M.$dg)(),E.fsPath,!R?.donotRotate,!!R?.donotUseFormatters,w):super.s(E,w,R)}registerLogger(E){super.registerLogger(E),this.r.$registerLogger(E)}deregisterLogger(E){super.deregisterLogger(E),this.r.$deregisterLogger(E)}}e.$Cec=A}),define(De[339],Ce([1,0,53,16,2,90,3,17,9,29]),function(me,e,C,T,d,M,A,b,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bec=void 0;class R extends M.$hcc{constructor(){super(...arguments),this.i=null}async g(t){const n=await super.g(t);if(n.scheme!==b.Schemas.file)return n;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${n.fsPath}.`),n;const o=n.fsPath;let i=0;do{let a;i===0?a=o:a=/[/\\]$/.test(o)?`${o.substr(0,o.length-1)}-${i}`:`${o}-${i}`,await I(a);const u=T.$ic(a,"vscode.lock"),k=await v(this.d,u,!1);if(k)return this.i=k,process.on("exit",()=>{k.dispose()}),d.URI.file(a);i++}while(i<10);return n}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$Bec=R;async function I(h){try{await w.Promises.stat(h);return}catch{}try{await w.Promises.mkdir(h,{recursive:!0})}catch{}}const p=1e3,y=10*60*1e3;class D extends A.$Rc{constructor(t,n){super(),this.b=t,this.c=n,this.a=this.B(new E.$4g),this.a.cancelAndSet(async()=>{const o=await l(t,n);(!o||o.pid!==process.pid)&&(t.info(`Lock '${n}': The lock was lost unexpectedly.`),this.a.cancel());try{await w.Promises.utimes(n,new Date,new Date)}catch(i){t.error(i),t.info(`Lock '${n}': Could not update mtime.`)}},p)}dispose(){super.dispose();try{C.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const n={pid:process.pid,willReleaseAt:Date.now()+t};await w.Promises.writeFile(this.c,JSON.stringify(n),{flag:"w"})}catch(n){this.b.error(n)}}}async function v(h,t,n){try{const i={pid:process.pid,willReleaseAt:0};await w.Promises.writeFile(t,JSON.stringify(i),{flag:"wx"})}catch(i){h.error(i)}const o=await l(h,t);return!o||o.pid!==process.pid?n?(h.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(h.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),c(h,t)):(h.info(`Lock '${t}': Lock acquired.`),new D(h,t))}async function l(h,t){let n;try{n=await w.Promises.readFile(t)}catch(o){return h.error(o),null}try{return JSON.parse(String(n))}catch(o){return h.error(o),null}}async function s(h,t){let n;try{n=await w.Promises.stat(t)}catch(o){return h.error(o),0}return n.mtime.getTime()}function r(h){try{return process.kill(h,0),!0}catch{return!1}}async function c(h,t){const n=await l(h,t);if(!n)return h.info(`Lock '${t}': Could not read pid of lock holder.`),m(h,t);if(n.willReleaseAt){let k=n.willReleaseAt-Date.now();if(k<5e3){for(k>0?h.info(`Lock '${t}': The lockfile is scheduled to be released in ${k} ms.`):h.info(`Lock '${t}': The lockfile is scheduled to have been released.`);k>0;){if(await(0,E.$Tg)(Math.min(100,k)),await s(h,t)===0)return m(h,t);k=n.willReleaseAt-Date.now()}return m(h,t)}}if(!r(n.pid))return h.info(`Lock '${t}': The pid ${n.pid} appears to be gone.`),m(h,t);const o=await s(h,t),i=Date.now()-o;if(i<=y)return h.info(`Lock '${t}': The lock does not look stale, elapsed: ${i} ms, giving up.`),null;h.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,E.$Tg)(2e3);const a=await s(h,t),u=Date.now()-a;return u<=y?(h.info(`Lock '${t}': The lock does not look stale, elapsed: ${u} ms, giving up.`),null):(h.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),m(h,t))}async function m(h,t){h.info(`Lock '${t}': Deleting a stale lock.`);try{await w.Promises.unlink(t)}catch{}return v(h,t,!0)}}),define(De[340],Ce([1,0,31,20,44,33]),function(me,e,C,T,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wdc=void 0;let A=class extends d.$kcc{constructor(E,w){super(!0,E,w)}createTerminal(E,w,R){return this.createTerminalFromOptions({name:E,shellPath:w,shellArgs:R})}createTerminalFromOptions(E,w){const R=new d.$jcc(this.a,(0,C.$dg)(),E,E.name);return this.f.push(R),R.create(E,this.R(E,w)),R.value}};e.$Wdc=A,e.$Wdc=A=He([Be(0,M.$wM),Be(1,T.$aM)],A)}),define(De[341],Ce([1,0,9,22,21,8,4,3,128,292,68]),function(me,e,C,T,d,M,A,b,E,w,R){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$i4b=e.ResponsiveState=e.RequestInitiator=e.$h4b=e.$g4b=void 0;function p(f,P){try{return JSON.stringify(f,P)}catch{return"null"}}const y="$$ref$$",D={[y]:-1};class v{constructor(P,N){this.jsonString=P,this.referencedBuffers=N}}function l(f,P=null,N=!1){const O=[];return{jsonString:(N?p:JSON.stringify)(f,(j,z)=>{if(typeof z>"u")return D;if(typeof z=="object"){if(z instanceof T.$ae){const F=O.push(z)-1;return{[y]:F}}if(P)return P(j,z)}return z}),referencedBuffers:O}}e.$g4b=l;function s(f,P,N){return JSON.parse(f,(O,L)=>{if(L){const j=L[y];if(typeof j=="number")return P[j];if(N&&L.$mid===1)return N.transformIncoming(L)}return L})}e.$h4b=s;function r(f,P){return JSON.stringify(f,P)}function c(f){return f?(P,N)=>N&&N.$mid===1?f.transformOutgoing(N):N:null}var m;(function(f){f[f.LocalSide=0]="LocalSide",f[f.OtherSide=1]="OtherSide"})(m||(e.RequestInitiator=m={}));var h;(function(f){f[f.Responsive=0]="Responsive",f[f.Unresponsive=1]="Unresponsive"})(h||(e.ResponsiveState=h={}));const t=()=>{},n=Symbol.for("rpcProtocol"),o=Symbol.for("rpcProxy");class i extends b.$Rc{static{I=n}static{this.a=3*1e3}constructor(P,N=null,O=null){super(),this[I]=!0,this.b=this.B(new A.$Md),this.onDidChangeResponsiveState=this.b.event,this.c=P,this.f=N,this.g=O,this.h=c(this.g),this.j=!1,this.m=[],this.s=[];for(let L=0,j=R.$hv.count;L<j;L++)this.m[L]=null,this.s[L]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new C.$5g(()=>this.H(),1e3)),this.c.onMessage(L=>this.L(L))}dispose(){this.j=!0,Object.keys(this.w).forEach(P=>{const N=this.w[P];delete this.w[P],N.resolveErr(M.$5())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(P){this.z===0&&(this.C=Date.now()+i.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(P){this.C=Date.now()+i.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(P){this.y!==P&&(this.y=P,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(P){return this.g?(0,E.$Km)(P,this.g):P}getProxy(P){const{nid:N,sid:O}=P;return this.s[N]||(this.s[N]=this.J(N,O)),this.s[N]}J(P,N){const O={get:(L,j)=>(typeof j=="string"&&!L[j]&&j.charCodeAt(0)===36&&(L[j]=(...z)=>this.U(P,j,z)),j===o?N:L[j])};return new Proxy(Object.create(null),O)}set(P,N){return this.m[P.nid]=N,N}assertRegistered(P){for(let N=0,O=P.length;N<O;N++){const L=P[N];if(!this.m[L.nid])throw new Error(`Missing proxy instance ${L.sid}`)}}L(P){if(this.j)return;const N=P.byteLength,O=u.read(P,0),L=O.readUInt8(),j=O.readUInt32();switch(L){case 1:case 2:{let{rpcId:z,method:F,args:H}=S.deserializeRequestJSONArgs(O);this.g&&(H=(0,E.$Km)(H,this.g)),this.M(N,j,z,F,H,L===2);break}case 3:case 4:{let{rpcId:z,method:F,args:H}=S.deserializeRequestMixedArgs(O);this.g&&(H=(0,E.$Km)(H,this.g)),this.M(N,j,z,F,H,L===4);break}case 5:{this.f?.logIncoming(N,j,0,"ack"),this.G(j);break}case 6:{this.N(N,j);break}case 7:{this.O(N,j,void 0);break}case 9:{let z=S.deserializeReplyOKJSON(O);this.g&&(z=(0,E.$Km)(z,this.g)),this.O(N,j,z);break}case 10:{const z=S.deserializeReplyOKJSONWithBuffers(O,this.g);this.O(N,j,z);break}case 8:{const z=S.deserializeReplyOKVSBuffer(O);this.O(N,j,z);break}case 11:{let z=S.deserializeReplyErrError(O);this.g&&(z=(0,E.$Km)(z,this.g)),this.P(N,j,z);break}case 12:{this.P(N,j,void 0);break}default:console.error("received unexpected message"),console.error(P)}}M(P,N,O,L,j,z){this.f?.logIncoming(P,N,1,`receiveRequest ${(0,R.$jv)(O)}.${L}(`,j);const F=String(N);let H,K;if(z){const x=new d.$Wd;j.push(x.token),H=this.Q(O,L,j),K=()=>x.cancel()}else H=this.Q(O,L,j),K=t;this.u[F]=K;const fe=S.serializeAcknowledged(N);this.f?.logOutgoing(fe.byteLength,N,1,"ack"),this.c.send(fe),H.then(x=>{delete this.u[F];const Z=S.serializeReplyOK(N,x,this.h);this.f?.logOutgoing(Z.byteLength,N,1,"reply:",x),this.c.send(Z)},x=>{delete this.u[F];const Z=S.serializeReplyErr(N,x);this.f?.logOutgoing(Z.byteLength,N,1,"replyErr:",x),this.c.send(Z)})}N(P,N){this.f?.logIncoming(P,N,1,"receiveCancel");const O=String(N);this.u[O]?.()}O(P,N,O){this.f?.logIncoming(P,N,0,"receiveReply:",O);const L=String(N);if(!this.w.hasOwnProperty(L))return;const j=this.w[L];delete this.w[L],j.resolveOk(O)}P(P,N,O){this.f?.logIncoming(P,N,0,"receiveReplyErr:",O);const L=String(N);if(!this.w.hasOwnProperty(L))return;const j=this.w[L];delete this.w[L];let z;O&&(O.$isError?(z=new Error,z.name=O.name,z.message=O.message,z.stack=O.stack):z=O),j.resolveErr(z)}Q(P,N,O){try{return Promise.resolve(this.S(P,N,O))}catch(L){return Promise.reject(L)}}S(P,N,O){const L=this.m[P];if(!L)throw new Error("Unknown actor "+(0,R.$jv)(P));const j=L[N];if(typeof j!="function")throw new Error("Unknown method "+N+" on actor "+(0,R.$jv)(P));return j.apply(L,O)}U(P,N,O){if(this.j)return new w.$f4b;let L=null;if(O.length>0&&d.CancellationToken.isCancellationToken(O[O.length-1])&&(L=O.pop()),L&&L.isCancellationRequested)return Promise.reject(M.$5());const j=S.serializeRequestArguments(O,this.h),z=++this.t,F=String(z),H=new w.$e4b,K=new b.$Qc;L&&K.add(L.onCancellationRequested(()=>{const x=S.serializeCancel(z);this.f?.logOutgoing(x.byteLength,z,0,"cancel"),this.c.send(S.serializeCancel(z))})),this.w[F]=new a(H,K),this.F(z);const fe=S.serializeRequest(z,P,N,j,!!L);return this.f?.logOutgoing(fe.byteLength,z,0,`request: ${(0,R.$jv)(P)}.${N}(`,O),this.c.send(fe),H}}e.$i4b=i;class a{constructor(P,N){this.a=P,this.b=N}resolveOk(P){this.a.resolveOk(P),this.b.dispose()}resolveErr(P){this.a.resolveErr(P),this.b.dispose()}}class u{static alloc(P,N,O){const L=new u(T.$ae.alloc(O+1+4),0);return L.writeUInt8(P),L.writeUInt32(N),L}static read(P,N){return new u(P,N)}get buffer(){return this.a}constructor(P,N){this.a=P,this.b=N}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(P){this.a.writeUInt8(P,this.b),this.b+=1}readUInt8(){const P=this.a.readUInt8(this.b);return this.b+=1,P}writeUInt32(P){this.a.writeUInt32BE(P,this.b),this.b+=4}readUInt32(){const P=this.a.readUInt32BE(this.b);return this.b+=4,P}static sizeShortString(P){return 1+P.byteLength}writeShortString(P){this.a.writeUInt8(P.byteLength,this.b),this.b+=1,this.a.set(P,this.b),this.b+=P.byteLength}readShortString(){const P=this.a.readUInt8(this.b);this.b+=1;const O=this.a.slice(this.b,this.b+P).toString();return this.b+=P,O}static sizeLongString(P){return 4+P.byteLength}writeLongString(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readLongString(){const P=this.a.readUInt32BE(this.b);this.b+=4;const O=this.a.slice(this.b,this.b+P).toString();return this.b+=P,O}writeBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}static sizeVSBuffer(P){return 4+P.byteLength}writeVSBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readVSBuffer(){const P=this.a.readUInt32BE(this.b);this.b+=4;const N=this.a.slice(this.b,this.b+P);return this.b+=P,N}static sizeMixedArray(P){let N=0;N+=1;for(let O=0,L=P.length;O<L;O++){const j=P[O];switch(N+=1,j.type){case 1:N+=this.sizeLongString(j.value);break;case 2:N+=this.sizeVSBuffer(j.value);break;case 3:N+=this.sizeUInt32,N+=this.sizeLongString(j.value);for(let z=0;z<j.buffers.length;++z)N+=this.sizeVSBuffer(j.buffers[z]);break;case 4:break}}return N}writeMixedArray(P){this.a.writeUInt8(P.length,this.b),this.b+=1;for(let N=0,O=P.length;N<O;N++){const L=P[N];switch(L.type){case 1:this.writeUInt8(1),this.writeLongString(L.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(L.value);break;case 3:this.writeUInt8(3),this.writeUInt32(L.buffers.length),this.writeLongString(L.value);for(let j=0;j<L.buffers.length;++j)this.writeBuffer(L.buffers[j]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const P=this.a.readUInt8(this.b);this.b+=1;const N=new Array(P);for(let O=0;O<P;O++)switch(this.readUInt8()){case 1:N[O]=this.readLongString();break;case 2:N[O]=this.readVSBuffer();break;case 3:{const j=this.readUInt32(),z=this.readLongString(),F=[];for(let H=0;H<j;++H)F.push(this.readVSBuffer());N[O]=new R.$kv(s(z,F,null));break}case 4:N[O]=void 0;break}return N}}var k;(function(f){f[f.Simple=0]="Simple",f[f.Mixed=1]="Mixed"})(k||(k={}));class S{static a(P){for(let N=0,O=P.length;N<O;N++)if(P[N]instanceof T.$ae||P[N]instanceof R.$kv||typeof P[N]>"u")return!0;return!1}static serializeRequestArguments(P,N){if(this.a(P)){const O=[];for(let L=0,j=P.length;L<j;L++){const z=P[L];if(z instanceof T.$ae)O[L]={type:2,value:z};else if(typeof z>"u")O[L]={type:4};else if(z instanceof R.$kv){const{jsonString:F,referencedBuffers:H}=l(z.value,N);O[L]={type:3,value:T.$ae.fromString(F),buffers:H}}else O[L]={type:1,value:T.$ae.fromString(r(z,N))}}return{type:1,args:O}}return{type:0,args:r(P,N)}}static serializeRequest(P,N,O,L,j){switch(L.type){case 0:return this.b(P,N,O,L.args,j);case 1:return this.c(P,N,O,L.args,j)}}static b(P,N,O,L,j){const z=T.$ae.fromString(O),F=T.$ae.fromString(L);let H=0;H+=u.sizeUInt8(),H+=u.sizeShortString(z),H+=u.sizeLongString(F);const K=u.alloc(j?2:1,P,H);return K.writeUInt8(N),K.writeShortString(z),K.writeLongString(F),K.buffer}static deserializeRequestJSONArgs(P){const N=P.readUInt8(),O=P.readShortString(),L=P.readLongString();return{rpcId:N,method:O,args:JSON.parse(L)}}static c(P,N,O,L,j){const z=T.$ae.fromString(O);let F=0;F+=u.sizeUInt8(),F+=u.sizeShortString(z),F+=u.sizeMixedArray(L);const H=u.alloc(j?4:3,P,F);return H.writeUInt8(N),H.writeShortString(z),H.writeMixedArray(L),H.buffer}static deserializeRequestMixedArgs(P){const N=P.readUInt8(),O=P.readShortString(),L=P.readMixedArray(),j=new Array(L.length);for(let z=0,F=L.length;z<F;z++){const H=L[z];typeof H=="string"?j[z]=JSON.parse(H):j[z]=H}return{rpcId:N,method:O,args:j}}static serializeAcknowledged(P){return u.alloc(5,P,0).buffer}static serializeCancel(P){return u.alloc(6,P,0).buffer}static serializeReplyOK(P,N,O){if(typeof N>"u")return this.d(P);if(N instanceof T.$ae)return this.e(P,N);if(N instanceof R.$kv){const{jsonString:L,referencedBuffers:j}=l(N.value,O,!0);return this.g(P,L,j)}else return this.f(P,p(N,O))}static d(P){return u.alloc(7,P,0).buffer}static e(P,N){let O=0;O+=u.sizeVSBuffer(N);const L=u.alloc(8,P,O);return L.writeVSBuffer(N),L.buffer}static deserializeReplyOKVSBuffer(P){return P.readVSBuffer()}static f(P,N){const O=T.$ae.fromString(N);let L=0;L+=u.sizeLongString(O);const j=u.alloc(9,P,L);return j.writeLongString(O),j.buffer}static g(P,N,O){const L=T.$ae.fromString(N);let j=0;j+=u.sizeUInt32,j+=u.sizeLongString(L);for(const F of O)j+=u.sizeVSBuffer(F);const z=u.alloc(10,P,j);z.writeUInt32(O.length),z.writeLongString(L);for(const F of O)z.writeBuffer(F);return z.buffer}static deserializeReplyOKJSON(P){const N=P.readLongString();return JSON.parse(N)}static deserializeReplyOKJSONWithBuffers(P,N){const O=P.readUInt32(),L=P.readLongString(),j=[];for(let z=0;z<O;++z)j.push(P.readVSBuffer());return new R.$kv(s(L,j,N))}static serializeReplyErr(P,N){const O=N?p(M.$2(N),null):void 0;if(typeof O!="string")return this.h(P);const L=T.$ae.fromString(O);let j=0;j+=u.sizeLongString(L);const z=u.alloc(11,P,j);return z.writeLongString(L),z.buffer}static deserializeReplyErrError(P){const N=P.readLongString();return JSON.parse(N)}static h(P){return u.alloc(12,P,0).buffer}}var $;(function(f){f[f.RequestJSONArgs=1]="RequestJSONArgs",f[f.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",f[f.RequestMixedArgs=3]="RequestMixedArgs",f[f.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",f[f.Acknowledged=5]="Acknowledged",f[f.Cancel=6]="Cancel",f[f.ReplyOKEmpty=7]="ReplyOKEmpty",f[f.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",f[f.ReplyOKJSON=9]="ReplyOKJSON",f[f.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",f[f.ReplyErrError=11]="ReplyErrError",f[f.ReplyErrEmpty=12]="ReplyErrEmpty"})($||($={}));var g;(function(f){f[f.String=1]="String",f[f.VSBuffer=2]="VSBuffer",f[f.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",f[f.Undefined=4]="Undefined"})(g||(g={}))}),define(De[342],Ce([1,0,4,42,41,5]),function(me,e,C,T,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vJ=e.$uJ=e.OutputChannelUpdateMode=e.$tJ=e.$sJ=e.$rJ=e.$qJ=e.$pJ=e.$oJ=e.$nJ=e.$mJ=e.$lJ=e.$kJ=void 0,e.$kJ="text/x-code-output",e.$lJ="output",e.$mJ="Log",e.$nJ="text/x-code-log-output",e.$oJ="log",e.$pJ="workbench.panel.output",e.$qJ=new d.$5i("inOutput",!1),e.$rJ=new d.$5i("activeLogOutput",!1),e.$sJ=new d.$5i("outputView.scrollLock",!1),e.$tJ=(0,M.$Nh)("outputService");var A;(function(E){E[E.Append=1]="Append",E[E.Replace=2]="Replace",E[E.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.$uJ={OutputChannels:"workbench.contributions.outputChannels"};class b{constructor(){this.a=new Map,this.b=new C.$Md,this.onDidRegisterChannel=this.b.event,this.c=new C.$Md,this.onDidRemoveChannel=this.c.event}registerChannel(w){this.a.has(w.id)||(this.a.set(w.id,w),this.b.fire(w.id))}getChannels(){const w=[];return this.a.forEach(R=>w.push(R)),w}getChannel(w){return this.a.get(w)}removeChannel(w){this.a.delete(w),this.c.fire(w)}}T.$bn.add(e.$uJ.OutputChannels,new b),e.$vJ=new d.$5i("activeOutputChannel","")}),define(De[152],Ce([1,0,6,5,20,25,13,342,71,27,55,178,22,18,30,4,3]),function(me,e,C,T,d,M,A,b,E,w,R,I,p,y,D,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dcc=e.$Ccc=void 0;class s extends A.$bj{get disposed(){return this.n}constructor(h,t,n,o,i){super(),this.id=h,this.name=t,this.r=n,this.s=o,this.extension=i,this.m=0,this.n=!1,this.visible=!1,this.setLevel(n.getLevel()),this.B(n.onDidChangeLogLevel(a=>this.setLevel(a)))}get logLevel(){return this.getLevel()}appendLine(h){this.append(h+`
`)}append(h){this.info(h)}clear(){const h=this.m;this.r.flush(),this.s.$update(this.id,b.OutputChannelUpdateMode.Clear,h)}replace(h){const t=this.m;this.info(h),this.s.$update(this.id,b.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(h,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof h=="boolean"?h:t))}hide(){this.s.$close(this.id)}g(h,t){this.m+=p.$ae.fromString(t).byteLength,(0,A.log)(this.r,h,t),this.visible&&(this.r.flush(),this.s.$update(this.id,b.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class r extends s{appendLine(h){this.append(h)}}let c=class{constructor(h,t,n,o,i,a){this.i=t,this.j=n,this.k=o,this.l=i,this.m=a,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=h.getProxy(C.$_J.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,I.$am)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(h){this.h=h;for(const[t,n]of this.g)n.visible=t===this.h}createOutputChannel(h,t,n){if(h=h.trim(),!h)throw new Error("illegal argument `name`. must not be falsy");const o=typeof t=="object"&&t.log,i=(0,y.$xf)(t)?t:void 0;if((0,y.$xf)(i)&&!i.trim())throw new Error("illegal argument `languageId`. must not be empty");let a;const u=this.i.environment.extensionLogLevel?.find(([S])=>M.$2l.equals(n.identifier,S))?.[1];u&&(a=(0,A.$lj)(u));const k=o?this.o(h,a,n):this.n(h,i,n);return k.then(S=>{this.g.set(S.id,S),S.visible=S.id===this.h}),o?this.r(h,a??this.m.getLevel(),k):this.q(h,k)}async n(h,t,n){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const o=await this.c,i=this.k.extUri.joinPath(o,`${this.f++}-${h.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),a=this.l.createLogger(i,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),u=await this.a.$register(h,i,t,n.identifier.value);return new s(u,h,a,this.a,n)}async o(h,t,n){const o=await this.p(n),i=h.replace(/[\\/:\*\?"<>\|]/g,""),a=this.k.extUri.joinPath(o,`${i}.log`),u=`${n.identifier.value}.${i}`,k=this.l.createLogger(a,{id:u,name:h,logLevel:t,extensionId:n.identifier.value});return new r(u,h,k,this.a,n)}p(h){let t=this.d.get(h.identifier.value);if(!t){const n=this.k.extUri.joinPath(this.i.logsLocation,h.identifier.value);this.d.set(h.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(n)}catch(o){if((0,D.$lk)(o)!==D.FileSystemProviderErrorCode.FileExists)throw o}return n})())}return t}q(h,t){let n=!1;const o=()=>{if(n)throw new Error("Channel has been closed")};return{get name(){return h},append(i){o(),t.then(a=>a.append(i))},appendLine(i){o(),t.then(a=>a.appendLine(i))},clear(){o(),t.then(i=>i.clear())},replace(i){o(),t.then(a=>a.replace(i))},show(i,a){o(),t.then(u=>u.show(i,a))},hide(){o(),t.then(i=>i.hide())},dispose(){n=!0,t.then(i=>i.dispose())}}}r(h,t,n){const o=new l.$Qc,i=()=>{if(o.isDisposed)throw new Error("Channel has been closed")},a=o.add(new v.$Md);function u(k){t=k,a.fire(k)}return n.then(k=>{o.add(k),k.logLevel!==t&&u(k.logLevel),o.add(k.onDidChangeLogLevel(S=>u(S)))}),{...this.q(h,n),get logLevel(){return t},onDidChangeLogLevel:a.event,trace(k,...S){i(),n.then($=>$.trace(k,...S))},debug(k,...S){i(),n.then($=>$.debug(k,...S))},info(k,...S){i(),n.then($=>$.info(k,...S))},warn(k,...S){i(),n.then($=>$.warn(k,...S))},error(k,...S){i(),n.then($=>$.error(k,...S))},dispose(){o.dispose()}}}};e.$Ccc=c,e.$Ccc=c=He([Be(0,d.$aM),Be(1,w.$qM),Be(2,E.$fcc),Be(3,R.$Mbc),Be(4,A.$9i),Be(5,A.$8i)],c),e.$Dcc=(0,T.$Nh)("IExtHostOutputService")}),define(De[343],Ce([1,0,5,9]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qm=e.$pm=void 0,e.$pm=(0,C.$Nh)("remoteAgentService"),e.$qm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(d){let M=1/0;for(let b=0;b<this.maxSampleCount;b++){const E=await d.getRoundTripTime();if(E===void 0)return;M=Math.min(M,E/2),await(0,T.$Tg)(this.sampleDelay)}this.average.push(M),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(M):A=this.initial.reduce((b,E)=>b+E,0)/this.initial.length,this.lastMeasurement={initial:A,current:M,average:this.average.reduce((b,E)=>b+E,0)/this.average.length,high:(()=>typeof A>"u"?!1:M>this.highLatencyMaxThreshold||M>this.highLatencyMinThreshold&&M>A*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(De[344],Ce([1,0,32,17,16,12,24,2,5,258,43,147,343]),function(me,e,C,T,d,M,A,b,E,w,R,I,p){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$OJ=e.$NJ=void 0,e.$NJ=(0,E.$Nh)("pathService");let D=y=class{constructor(l,s,r,c){this.d=l,this.e=s,this.f=r,this.g=c,this.a=(async()=>(await this.e.getEnvironment())?.os||M.OS)(),this.b=(async()=>{const m=await this.e.getEnvironment();return this.c=m?.userHome??l})()}hasValidBasename(l,s,r){return typeof s=="string"||typeof s>"u"?this.a.then(c=>this.h(l,c,s)):this.h(l,s,r)}h(l,s,r){return l.scheme===T.Schemas.file||l.scheme===T.Schemas.vscodeRemote?(0,C.$Uf)(r??(0,A.$rg)(l),s===1):!0}get defaultUriScheme(){return y.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(l,s){if(l.remoteAuthority)return T.Schemas.vscodeRemote;const r=(0,w.$KJ)(s.getWorkspace());if(r)return r;const c=s.getWorkspace().folders[0];if(c)return c.uri.scheme;const m=s.getWorkspace().configuration;return m?m.scheme:T.Schemas.file}userHome(l){return l?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(l=>l===1?d.$ec:d.$fc)}async fileURI(l){let s="";if(await this.a===1&&(l=l.replace(/\\/g,"/")),l[0]==="/"&&l[1]==="/"){const c=l.indexOf("/",2);c===-1?(s=l.substring(2),l="/"):(s=l.substring(2,c),l=l.substring(c)||"/")}return b.URI.from({scheme:T.Schemas.file,authority:s,path:l,query:"",fragment:""})}};e.$OJ=D,e.$OJ=D=y=He([Be(1,p.$pm),Be(2,I.$wJ),Be(3,R.$Wh)],D)}),define(De[345],Ce([1,0,225,19,57,4,52,3,2,49,230,13,64,260,86,43,147,26,21,18,23,41]),function(me,e,C,T,d,M,A,b,E,w,R,I,p,y,D,v,l,s,r,c,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HJ=e.$GJ=e.$FJ=e.OnPortForward=e.$EJ=e.$DJ=e.$CJ=e.$BJ=e.$AJ=e.TunnelSource=e.TunnelCloseReason=e.$zJ=e.$yJ=e.$xJ=void 0;const t=10*1e3,n="remote.tunnels.toRestore";e.$xJ="onTunnel",e.$yJ=new h.$5i("forwardedPortsViewEnabled",!1,C.localize(0,null));function o(N){const O=N.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(O)return{host:O[1]?.substring(0,O[1].length-1)||"localhost",port:Number(O[2])}}e.$zJ=o;var i;(function(N){N.Other="Other",N.User="User",N.AutoForwardEnd="AutoForwardEnd"})(i||(e.TunnelCloseReason=i={}));var a;(function(N){N[N.User=0]="User",N[N.Auto=1]="Auto",N[N.Extension=2]="Extension"})(a||(e.TunnelSource=a={})),e.$AJ={source:a.User,description:C.localize(1,null)},e.$BJ={source:a.Auto,description:C.localize(2,null)};function u(N,O,L){const j=N.get(S(O,L));if(j)return j;if((0,D.$9u)(O))for(const z of D.$8u){const F=S(z,L);if(N.has(F))return N.get(F)}else if((0,D.$$u)(O))for(const z of D.$0u){const F=S(z,L);if(N.has(F))return N.get(F)}}e.$CJ=u;function k(N,O,L){const j=u(N,O,L);if(j)return j;const z=(0,D.$$u)(O)?"localhost":(0,D.$9u)(O)?"0.0.0.0":void 0;if(z)return u(N,z,L)}e.$DJ=k;function S(N,O){return N+":"+O}e.$EJ=S;var $;(function(N){N.Notify="notify",N.OpenBrowser="openBrowser",N.OpenBrowserOnce="openBrowserOnce",N.OpenPreview="openPreview",N.Silent="silent",N.Ignore="ignore"})($||(e.OnPortForward=$={}));function g(N){return N&&"host"in N&&typeof N.host=="string"&&"port"in N&&typeof N.port=="number"&&(!("detail"in N)||typeof N.detail=="string")&&(!("pid"in N)||typeof N.pid=="string")}e.$FJ=g;class f extends b.$Rc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(O){super(),this.r=O,this.j=[],this.n=new M.$Md,this.onDidChangeAttributes=this.n.event,this.B(O.onDidChangeConfiguration(L=>{(L.affectsConfiguration(f.c)||L.affectsConfiguration(f.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(O,L,j){let z=this.w(O,L,j,this.j,0);const F={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;z>=0;){const H=this.j[z];H.key===O?(F.onAutoForward=H.onAutoForward??F.onAutoForward,F.elevateIfNeeded=H.elevateIfNeeded!==void 0?H.elevateIfNeeded:F.elevateIfNeeded,F.label=H.label??F.label,F.requireLocalPort=H.requireLocalPort,F.protocol=H.protocol):(F.onAutoForward=F.onAutoForward??H.onAutoForward,F.elevateIfNeeded=F.elevateIfNeeded!==void 0?F.elevateIfNeeded:H.elevateIfNeeded,F.label=F.label??H.label,F.requireLocalPort=F.requireLocalPort!==void 0?F.requireLocalPort:void 0,F.protocol=F.protocol??H.protocol),z=this.w(O,L,j,this.j,z+1)}return F.onAutoForward!==void 0||F.elevateIfNeeded!==void 0||F.label!==void 0||F.requireLocalPort!==void 0||F.protocol!==void 0?F:this.C()}t(O){return O.start!==void 0&&O.end!==void 0}u(O){return O.host!==void 0&&O.port!==void 0&&(0,c.$xf)(O.host)&&(0,c.$Bf)(O.port)}w(O,L,j,z,F){if(F>=z.length)return-1;const H=!(0,D.$9u)(L)&&!(0,D.$$u)(L),fe=z.slice(F).findIndex(x=>(0,c.$Bf)(x.key)?H?!1:x.key===O:this.t(x.key)?H?!1:O>=x.key.start&&O<=x.key.end:this.u(x.key)?O===x.key.port&&L===x.key.host:j?x.key.test(j):!1);return fe>=0?fe+F:-1}y(){const O=this.r.getValue(f.c);if(!O||!(0,c.$zf)(O))return[];const L=[];for(const z in O){if(z===void 0)continue;const F=O[z];let H;if(Number(z))H=Number(z);else if((0,c.$xf)(z))if(f.g.test(z)){const K=z.match(f.g);H={start:Number(K[1]),end:Number(K[2])}}else if(f.h.test(z)){const K=z.match(f.h);H={host:K[1],port:Number(K[2])}}else{let K;try{K=RegExp(z)}catch{}K&&(H=K)}H&&L.push({key:H,elevateIfNeeded:F.elevateIfNeeded,onAutoForward:F.onAutoForward,label:F.label,requireLocalPort:F.requireLocalPort,protocol:F.protocol})}const j=this.r.getValue(f.f);return j&&(this.m={elevateIfNeeded:j.elevateIfNeeded,label:j.label,onAutoForward:j.onAutoForward,requireLocalPort:j.requireLocalPort,protocol:j.protocol}),this.z(L)}z(O){function L(j,z){return(0,c.$Bf)(j.key)?j.key:z.t(j.key)?j.key.start:z.u(j.key)?j.key.port:Number.MAX_VALUE}return O.sort((j,z)=>L(j,this)-L(z,this))}C(){return this.m}static providedActionToAction(O){switch(O){case D.ProvidedOnAutoForward.Notify:return $.Notify;case D.ProvidedOnAutoForward.OpenBrowser:return $.OpenBrowser;case D.ProvidedOnAutoForward.OpenBrowserOnce:return $.OpenBrowserOnce;case D.ProvidedOnAutoForward.OpenPreview:return $.OpenPreview;case D.ProvidedOnAutoForward.Silent:return $.Silent;case D.ProvidedOnAutoForward.Ignore:return $.Ignore;default:return}}async addAttributes(O,L,j){const F=this.r.inspect(f.c).userRemoteValue;let H;!F||!(0,c.$zf)(F)?H={}:H=(0,m.$2m)(F),H[`${O}`]||(H[`${O}`]={});for(const K in L)H[`${O}`][K]=L[K];return this.r.updateValue(f.c,H,j)}}e.$GJ=f;let P=class extends b.$Rc{constructor(O,L,j,z,F,H,K,fe,x,Z){super(),this.H=O,this.I=L,this.J=j,this.L=z,this.M=F,this.N=H,this.O=K,this.P=fe,this.Q=x,this.R=Z,this.c=new Map,this.g=new M.$Md,this.onForwardPort=this.g.event,this.h=new M.$Md,this.onClosePort=this.h.event,this.j=new M.$Md,this.onPortName=this.j.event,this.n=new M.$Md,this.onCandidatesChanged=this.n.event,this.t=new M.$Md,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new M.$Md,this.D=new Map,this.F=new Map,this.G=[],this.ab=new Date,this.configPortsAttributes=new f(j),this.s=this.Z(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.gb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async q=>{const Y=await this.getAttributes(q.map(be=>({port:be.tunnelRemotePort,host:be.tunnelRemoteHost})));for(const be of q)if(be.localAddress){const ue=S(be.tunnelRemoteHost,be.tunnelRemotePort),ve=k(this.m??new Map,be.tunnelRemoteHost,be.tunnelRemotePort);this.forwarded.set(ue,{remotePort:be.tunnelRemotePort,remoteHost:be.tunnelRemoteHost,localAddress:be.localAddress,protocol:Y?.get(be.tunnelRemotePort)?.protocol??D.TunnelProtocol.Http,localUri:await this.X(be.localAddress,Y?.get(be.tunnelRemotePort)),localPort:be.tunnelLocalPort,runningProcess:ve?.detail,hasRunningProcess:!!ve,pid:ve?.pid,privacy:be.privacy,source:e.$AJ}),this.f.set(ue,be)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async q=>{const Y=S(q.tunnelRemoteHost,q.tunnelRemotePort);if(!k(this.forwarded,q.tunnelRemoteHost,q.tunnelRemotePort)&&!k(this.detected,q.tunnelRemoteHost,q.tunnelRemotePort)&&!k(this.c,q.tunnelRemoteHost,q.tunnelRemotePort)&&q.localAddress){const be=k(this.m??new Map,q.tunnelRemoteHost,q.tunnelRemotePort),ue=(await this.getAttributes([{port:q.tunnelRemotePort,host:q.tunnelRemoteHost}]))?.get(q.tunnelRemotePort);this.forwarded.set(Y,{remoteHost:q.tunnelRemoteHost,remotePort:q.tunnelRemotePort,localAddress:q.localAddress,protocol:ue?.protocol??D.TunnelProtocol.Http,localUri:await this.X(q.localAddress,ue),localPort:q.tunnelLocalPort,closeable:!0,runningProcess:be?.detail,hasRunningProcess:!!be,pid:be?.pid,privacy:q.privacy,source:e.$AJ})}await this.$(),this.f.set(Y,q),this.g.fire(this.forwarded.get(Y))})),this.B(this.H.onTunnelClosed(q=>this.W(q,i.Other))),this.U()}S(){return this.Q.extensions.find(O=>O.activationEvents?.includes(e.$xJ))?(this.R.createKey(e.$yJ.key,!0),!0):!1}U(){if(this.S())return;const O=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&O.dispose()}))}async W(O,L){const j=S(O.host,O.port);this.forwarded.has(j)&&(this.forwarded.delete(j),await this.$(),this.h.fire(O))}X(O,L){if(O.startsWith("http"))return E.URI.parse(O);const j=L?.protocol??"http";return E.URI.parse(`${j}://${O}`)}async Y(){const O=this.N.getWorkspace(),L=O.configuration?(0,A.$Bi)(O.configuration.path):O.folders.length>0?(0,A.$Bi)(O.folders[0].uri.path):void 0;if(L===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${n}.${this.L.remoteAuthority}.${L}`}async Z(){const O=this.I.get(n,1);if(O)return this.I.remove(n,1),await this.$(),O;const L=await this.Y();if(L)return this.I.get(L,0)}async restoreForwarded(){if(this.J.getValue("remote.restoreForwardedPorts")){const O=await this.s;if(O&&O!==this.y){const L=JSON.parse(O)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${L.map(j=>j.remotePort).join(", ")}`);for(const j of L){const z=k(this.detected,j.remoteHost,j.remotePort);j.source.source!==a.Extension&&!z||j.source.source===a.Extension&&z?await this.cb({remote:{host:j.remoteHost,port:j.remotePort},local:j.localPort,name:j.name,privacy:j.privacy,elevateIfNeeded:!0,source:j.source}):j.source.source===a.Extension&&!z&&this.D.set(S(j.remoteHost,j.remotePort),j)}}}if(this.z=!0,this.C.fire(),!this.w){const O=await this.Y();this.w=this.B(new b.$Qc),this.w.add(this.I.onDidChangeValue(0,void 0,this.w)(async L=>{L.key===O&&(this.s=Promise.resolve(this.I.get(O,0)),await this.restoreForwarded())}))}}async $(){if(this.J.getValue("remote.restoreForwardedPorts")){const O=JSON.stringify(Array.from(this.forwarded.values()));if(O!==this.y){this.y=O;const L=await this.Y();L&&this.I.store(L,this.y,0,0)}}}async bb(O,L,j){if(!O.tunnelLocalPort||!j?.requireLocalPort||O.tunnelLocalPort===L)return;const z=new Date;if(this.ab.getTime()+t>z.getTime())return;this.ab=z;const F=C.localize(3,null,L,O.tunnelRemotePort,O.tunnelLocalPort);return this.P.info(F)}async forward(O,L){return!this.z&&this.L.remoteAuthority&&await M.Event.toPromise(this.C.event),this.cb(O,L)}async cb(O,L){await this.Q.activateByEvent(e.$xJ);const j=k(this.forwarded,O.remote.host,O.remote.port);L=L??(L!==null?(await this.getAttributes([O.remote]))?.get(O.remote.port):void 0);const z=O.local!==void 0?O.local:O.remote.port;let F;if(j)return this.eb(j,O,L);{const H=this.L.remoteAuthority,K=H?{getAddress:async()=>(await this.M.resolveAuthority(H)).authority}:void 0,fe=S(O.remote.host,O.remote.port);this.c.set(fe,!0),O=this.db(fe,O);const x=await this.H.openTunnel(K,O.remote.host,O.remote.port,void 0,z,O.elevateIfNeeded?O.elevateIfNeeded:L?.elevateIfNeeded,O.privacy,L?.protocol);if(typeof x=="string")F=x;else if(x&&x.localAddress){const Z=k(this.m??new Map,O.remote.host,O.remote.port),q=x.protocol?x.protocol===D.TunnelProtocol.Https?D.TunnelProtocol.Https:D.TunnelProtocol.Http:L?.protocol??D.TunnelProtocol.Http,Y={remoteHost:x.tunnelRemoteHost,remotePort:x.tunnelRemotePort,localPort:x.tunnelLocalPort,name:L?.label??O.name,closeable:!0,localAddress:x.localAddress,protocol:q,localUri:await this.X(x.localAddress,L),runningProcess:Z?.detail,hasRunningProcess:!!Z,pid:Z?.pid,source:O.source??e.$AJ,privacy:x.privacy};return this.forwarded.set(fe,Y),this.f.set(fe,x),this.c.delete(fe),await this.$(),await this.bb(x,z,L),this.g.fire(Y),x}this.c.delete(fe)}return F}db(O,L){const j=this.D.has(O)?this.D:this.F.has(O)?this.F:void 0;if(j){const z=j.get(O);j.delete(O),z&&(L.name=z.name??L.name,L.local=("local"in z?z.local:"localPort"in z?z.localPort:void 0)??L.local,L.privacy=z.privacy??L.privacy)}return L}async eb(O,L,j){const z=j?.label??L.name;let F;(function(K){K[K.None=0]="None",K[K.Fire=1]="Fire",K[K.Reopen=2]="Reopen"})(F||(F={}));let H=F.None;switch(z!==O.name&&(O.name=z,H=F.Fire),(j?.protocol||O.protocol!==D.TunnelProtocol.Http)&&j?.protocol!==O.protocol&&(L.source=O.source,H=F.Reopen),L.privacy&&O.privacy!==L.privacy&&(H=F.Reopen),H){case F.Fire:{this.g.fire();break}case F.Reopen:await this.close(O.remoteHost,O.remotePort,i.User),await this.cb(L,j)}return k(this.f,L.remote.host,L.remote.port)}async name(O,L,j){const z=k(this.forwarded,O,L),F=S(O,L);if(z){z.name=j,await this.$(),this.j.fire({host:O,port:L});return}else this.detected.has(F)&&(this.detected.get(F).name=j,this.j.fire({host:O,port:L}))}async close(O,L,j){const z=S(O,L),F=this.forwarded.get(z);return j===i.AutoForwardEnd&&F&&F.source.source===a.Auto&&this.F.set(z,{local:F.localPort,name:F.name,privacy:F.privacy}),await this.H.closeTunnel(O,L),this.W({host:O,port:L},j)}address(O,L){const j=S(O,L);return(this.forwarded.get(j)||this.detected.get(j))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(O){if(O)for(const L of O){const j=k(this.m??new Map,L.remoteAddress.host,L.remoteAddress.port),z=typeof L.localAddress=="string"?L.localAddress:S(L.localAddress.host,L.localAddress.port);this.detected.set(S(L.remoteAddress.host,L.remoteAddress.port),{remoteHost:L.remoteAddress.host,remotePort:L.remoteAddress.port,localAddress:z,protocol:D.TunnelProtocol.Http,localUri:this.X(z),closeable:!1,runningProcess:j?.detail,hasRunningProcess:!!j,pid:j?.pid,privacy:D.TunnelPrivacyId.ConstantPrivate,source:{source:a.Extension,description:C.localize(4,null)}}),this.H.setEnvironmentTunnel(L.remoteAddress.host,L.remoteAddress.port,z,D.TunnelPrivacyId.ConstantPrivate,D.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(O){this.r=O}async setCandidates(O){let L=O;this.r&&(L=await this.r(O));const j=this.fb(L);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(j.values()).map(z=>z.port).join(", ")}`),this.n.fire(j)}fb(O){const L=this.m??new Map,j=new Map;return this.m=j,O.forEach(z=>{const F=S(z.host,z.port);j.set(F,{host:z.host,port:z.port,detail:z.detail,pid:z.pid}),L.has(F)&&L.delete(F);const H=k(this.forwarded,z.host,z.port);H&&(H.runningProcess=z.detail,H.hasRunningProcess=!0,H.pid=z.pid)}),L.forEach((z,F)=>{const H=o(F);if(!H)return;const K=k(this.forwarded,H.host,H.port);K&&(K.runningProcess=void 0,K.hasRunningProcess=!1,K.pid=void 0);const fe=k(this.detected,H.host,H.port);fe&&(fe.runningProcess=void 0,fe.hasRunningProcess=!1,fe.pid=void 0)}),L}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async gb(){const O=Array.from(this.forwarded.values()),L=await this.getAttributes(O.map(j=>({port:j.remotePort,host:j.remoteHost})),!1);if(L)for(const j of O){const z=L.get(j.remotePort);(z?.protocol||j.protocol!==D.TunnelProtocol.Http)&&z?.protocol!==j.protocol&&await this.cb({remote:{host:j.remoteHost,port:j.remotePort},local:j.localPort,name:j.name,source:j.source},z),z&&z.label&&z.label!==j.name&&await this.name(j.remoteHost,j.remotePort,z.label)}}async getAttributes(O,L=!0){const j=new Map,z=new Map;O.forEach(x=>{const Z=k(this.m??new Map,D.$8u[0],x.port)??x;if(Z){j.set(x.port,Z);const q=g(Z)?Z.pid:void 0;z.has(q)||z.set(q,[]),z.get(q)?.push(x.port)}});const F=new Map;if(O.forEach(x=>{const Z=this.configPortsAttributes.getAttributes(x.port,x.host,j.get(x.port)?.detail);Z&&F.set(x.port,Z)}),this.G.length===0||!L)return F.size>0?F:void 0;const H=await Promise.all((0,T.$Qb)(this.G.map(x=>Array.from(z.entries()).map(Z=>{const q=Z[1],Y=j.get(q[0]);return x.providePortAttributes(q,Y?.pid,Y?.detail,new r.$Wd().token)})))),K=new Map;if(H.forEach(x=>x.forEach(Z=>{Z&&K.set(Z.port,Z)})),!F&&!K)return;const fe=new Map;return O.forEach(x=>{const Z=F.get(x.port),q=K.get(x.port);fe.set(x.port,{elevateIfNeeded:Z?.elevateIfNeeded,label:Z?.label,onAutoForward:Z?.onAutoForward??f.providedActionToAction(q?.autoForwardAction),requireLocalPort:Z?.requireLocalPort,protocol:Z?.protocol})}),fe}addAttributesProvider(O){this.G.push(O)}};e.$HJ=P,He([(0,d.$gh)(1e3)],P.prototype,"$",null),e.$HJ=P=He([Be(0,D.$4u),Be(1,y.$2o),Be(2,w.$hi),Be(3,l.$wJ),Be(4,p.$Mk),Be(5,v.$Wh),Be(6,I.$8i),Be(7,R.$vv),Be(8,s.$8E),Be(9,h.$6i)],P)}),define(De[92],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$xI=e.$wI=void 0;class C{constructor(A,b){this.line=A,this.character=b}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,b){return new C(0,0)}with(A){return new C(0,0)}}e.$wI=C;class T{constructor(A,b,E,w){this.isEmpty=!1,this.isSingleLine=!1,this.start=new C(A,b),this.end=new C(E,w)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new T(0,0,0,0)}with(A){return new T(0,0,0,0)}}e.$xI=T;var d;(function(M){M[M.Information=1]="Information",M[M.Warning=2]="Warning"})(d||(e.TextSearchCompleteMessageType=d={}))}),define(De[36],Ce([1,0,19,35,23,32,15,5,16,8,92,9]),function(me,e,C,T,d,M,A,b,E,w,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YI=e.$XI=e.$WI=e.$VI=e.$UI=e.$TI=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.SearchErrorCode=e.$MI=e.$LI=e.SearchSortOrder=e.ViewMode=e.$KI=e.$JI=e.$II=e.$HI=e.SearchCompletionExitCode=e.$GI=e.$FI=e.$EI=e.QueryType=e.SearchProviderType=e.$DI=e.$CI=e.$BI=e.$AI=e.$zI=e.$yI=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.$yI="workbench.view.search",e.$zI="workbench.panel.search",e.$AI="workbench.view.search",e.$BI="search-result",e.$CI="search.exclude";const p="\u27EA ",y=" characters skipped \u27EB",D=(p.length+y.length+5)*2;e.$DI=(0,b.$Nh)("searchService");var v;(function(q){q[q.file=0]="file",q[q.text=1]="text"})(v||(e.SearchProviderType=v={}));var l;(function(q){q[q.File=1]="File",q[q.Text=2]="Text"})(l||(e.QueryType=l={}));function s(q){return!!q.preview}e.$EI=s;function r(q){return!!q.resource}e.$FI=r;function c(q){return!!q.message}e.$GI=c;var m;(function(q){q[q.Normal=0]="Normal",q[q.NewSearchStarted=1]="NewSearchStarted"})(m||(e.SearchCompletionExitCode=m={}));class h{constructor(Y){this.resource=Y,this.results=[]}}e.$HI=h;class t{constructor(Y,be,ue,ve){this.ranges=be,this.webviewIndex=ve;const J=Array.isArray(be)?be:[be];if(ue&&ue.matchLines===1&&n(J)){Y=(0,A.$qf)(Y,ue.matchLines);let U="",V=0,ge=0;const _=Math.floor(ue.charsPerLine/5),ie=[];for(const re of J){const Ee=Math.max(re.startColumn-_,0),oe=re.startColumn+ue.charsPerLine;if(Ee>ge+_+D){const he=p+(Ee-ge)+y;U+=he+Y.slice(Ee,oe),V+=Ee-(ge+he.length)}else U+=Y.slice(ge,oe);ie.push(new i(0,re.startColumn-V,re.endColumn-V)),ge=oe}this.preview={text:U,matches:Array.isArray(this.ranges)?ie:ie[0]}}else{const U=Array.isArray(be)?be[0].startLineNumber:be.startLineNumber;this.preview={text:Y,matches:(0,C.$1b)(be,V=>new o(V.startLineNumber-U,V.startColumn,V.endLineNumber-U,V.endColumn))}}}}e.$II=t;function n(q){const Y=q[0].startLineNumber;for(const be of q)if(be.startLineNumber!==Y||be.endLineNumber!==Y)return!1;return!0}class o{constructor(Y,be,ue,ve){this.startLineNumber=Y,this.startColumn=be,this.endLineNumber=ue,this.endColumn=ve}}e.$JI=o;class i extends o{constructor(Y,be,ue){super(Y,be,Y,ue)}}e.$KI=i;var a;(function(q){q.List="list",q.Tree="tree"})(a||(e.ViewMode=a={}));var u;(function(q){q.Default="default",q.FileNames="fileNames",q.Type="type",q.Modified="modified",q.CountDescending="countDescending",q.CountAscending="countAscending"})(u||(e.SearchSortOrder=u={}));function k(q,Y=!0){const be=q&&q.files&&q.files.exclude,ue=Y&&q&&q.search&&q.search.exclude;if(!be&&!ue)return;if(!be||!ue)return be||ue;let ve=Object.create(null);return ve=d.$5m(ve,d.$2m(be)),ve=d.$5m(ve,d.$2m(ue),!0),ve}e.$LI=k;function S(q,Y){return q.excludePattern&&T.$tj(q.excludePattern,Y)?!1:q.includePattern||q.usingSearchPaths?q.includePattern&&T.$tj(q.includePattern,Y)?!0:q.usingSearchPaths?!!q.folderQueries&&q.folderQueries.some(be=>{const ue=be.folder.fsPath;if(M.$Wf(Y,ue)){const ve=E.$kc(ue,Y);return!be.includePattern||!!T.$tj(be.includePattern,ve)}else return!1}):!1:!0}e.$MI=S;var $;(function(q){q[q.unknownEncoding=1]="unknownEncoding",q[q.regexParseError=2]="regexParseError",q[q.globParseError=3]="globParseError",q[q.invalidLiteral=4]="invalidLiteral",q[q.rgProcessError=5]="rgProcessError",q[q.other=6]="other",q[q.canceled=7]="canceled"})($||(e.SearchErrorCode=$={}));class g extends Error{constructor(Y,be){super(Y),this.code=be}}e.$NI=g;function f(q){const Y=q.message;if((0,w.$3)(q))return new g(Y,$.canceled);try{const be=JSON.parse(Y);return new g(be.message,be.code)}catch{return new g(Y,$.other)}}e.$OI=f;function P(q){const Y={message:q.message,code:q.code};return new Error(JSON.stringify(Y))}e.$PI=P;function N(q){return q.type==="error"?!0:q.type==="success"}e.$QI=N;function O(q){return q.type==="success"}e.$RI=O;function L(q){return!!q.path}e.$SI=L;function j(q,Y){const be=q.searchPath?q.searchPath:q.relativePath;return(0,A.$nf)(be,Y)}e.$TI=j;class z{constructor(Y){this.path=Y,this.results=[]}addMatch(Y){this.results.push(Y)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$UI=z;function F(q,Y){const be={...q||{},...Y||{}};return Object.keys(be).filter(ue=>{const ve=be[ue];return typeof ve=="boolean"&&ve})}e.$VI=F;class H{constructor(Y,be){this.c=null,this.a={...Y.excludePattern||{},...be.excludePattern||{}},this.b=T.$uj(this.a);let ue=Y.includePattern;be.includePattern&&(ue?ue={...ue,...be.includePattern}:ue=be.includePattern),ue&&(this.c=T.$uj(ue))}matchesExcludesSync(Y,be,ue){return!!(this.b&&this.b(Y,be,ue))}includedInQuerySync(Y,be,ue){return!(this.b&&this.b(Y,be,ue)||this.c&&!this.c(Y,be,ue))}includedInQuery(Y,be,ue){const ve=this.b(Y,be,ue),J=()=>this.c?!!this.c(Y,be,ue):!0;return(0,I.$Fg)(ve)?ve.then(U=>U?!1:J()):J()}hasSiblingExcludeClauses(){return K(this.a)}}e.$WI=H;function K(q){for(const Y in q)if(typeof q[Y]!="boolean")return!0;return!1}function fe(q){if(!q)return;let Y;return be=>(Y||(Y=(q()||Promise.resolve([])).then(ue=>ue?Z(ue):{})),Y.then(ue=>!!ue[be]))}e.$XI=fe;function x(q){if(!q)return;let Y;return be=>{if(!Y){const ue=q();Y=ue?Z(ue):{}}return!!Y[be]}}e.$YI=x;function Z(q){const Y={};for(const be of q)Y[be]=!0;return Y}}),define(De[39],Ce([1,0,19,9,21,4,3,77,17,120,24,15,2,214,5,13,243,43,55,27,20,14,7,66,36,6]),function(me,e,C,T,d,M,A,b,E,w,R,I,p,y,D,v,l,s,r,c,m,h,t,n,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zbc=e.$Ybc=void 0;function a(N,O,L){return new R.$jg(j=>$(j,L)).isEqual(N,O)}function u(N,O,L){return a(N.uri,O.uri,L)?0:(0,I.$Te)(N.uri.toString(),O.uri.toString())}function k(N,O,L){return N.index!==O.index?N.index<O.index?-1:1:a(N.uri,O.uri,L)?(0,I.$Te)(N.name,O.name):(0,I.$Te)(N.uri.toString(),O.uri.toString())}function S(N,O,L,j){const z=N.slice(0).sort((H,K)=>L(H,K,j)),F=O.slice(0).sort((H,K)=>L(H,K,j));return(0,C.$Db)(z,F,(H,K)=>L(H,K,j))}function $(N,O){const L=O.getCapabilities(N.scheme);return!(L&&L&1024)}class g extends s.$7h{static toExtHostWorkspace(O,L,j,z){if(!O)return{workspace:null,added:[],removed:[]};const{id:F,name:H,folders:K,configuration:fe,transient:x,isUntitled:Z}=O,q=[],Y=L;L?K.forEach((J,U)=>{const V=p.URI.revive(J.uri),ge=g.o(j||L,V,z);ge?(ge.name=J.name,ge.index=J.index,q.push(ge)):q.push({uri:V,name:J.name,index:U})}):q.push(...K.map(({uri:J,name:U,index:V})=>({uri:p.URI.revive(J),name:U,index:V}))),q.sort((J,U)=>J.index<U.index?-1:1);const be=new g(F,H,q,!!x,fe?p.URI.revive(fe):null,!!Z,J=>$(J,z)),{added:ue,removed:ve}=S(Y?Y.workspaceFolders:[],be.workspaceFolders,u,z);return{workspace:be,added:ue,removed:ve}}static o(O,L,j){for(let z=0;z<O.folders.length;z++){const F=O.workspaceFolders[z];if(a(F.uri,L,j))return F}}constructor(O,L,j,z,F,H,K){super(O,j.map(fe=>new s.$8h(fe)),z,F,K),this.t=L,this.u=H,this.q=[],this.s=b.$Th.forUris(K),j.forEach(fe=>{this.q.push(fe),this.s.set(fe.uri,fe)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(O,L){return L&&this.s.get(O)&&(O=(0,R.$tg)(O)),this.s.findSubstr(O)}resolveWorkspaceFolder(O){return this.s.get(O)}}let f=class{constructor(O,L,j,z,F){this.c=new M.$Md,this.onDidChangeWorkspace=this.c.event,this.g=new M.$Md,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new M.$Od,this.B=new Map,this.h=z,this.s=j,this.t=F,this.j=new w.$Ml,this.k=new T.$Rg,this.o=O.getProxy(i.$_J.MainThreadWorkspace),this.q=O.getProxy(i.$_J.MainThreadMessageService);const H=L.workspace;this.l=H?new g(H.id,H.name,[],!!H.transient,H.configuration?p.URI.revive(H.configuration):null,!!H.isUntitled,K=>$(K,j)):void 0}$initializeWorkspace(O,L){this.v=L,this.$acceptWorkspaceData(O),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?p.URI.from({scheme:E.Schemas.untitled,path:(0,R.$rg)((0,R.$tg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(O,L,j,...z){const F=[];if(Array.isArray(z)&&z.forEach(Z=>{p.URI.isUri(Z.uri)&&!F.some(q=>a(q.uri,Z.uri,this.s))&&F.push({uri:Z.uri,name:Z.name||(0,R.$qg)(Z.uri)})}),this.n||[L,j].some(Z=>typeof Z!="number"||Z<0)||j===0&&F.length===0)return!1;const H=this.x?this.x.workspaceFolders:[];if(L+j>H.length)return!1;const K=H.slice(0);K.splice(L,j,...F.map(Z=>({uri:Z.uri,name:Z.name||(0,R.$qg)(Z.uri),index:void 0})));for(let Z=0;Z<K.length;Z++){const q=K[Z];if(K.some((Y,be)=>be!==Z&&a(q.uri,Y.uri,this.s)))return!1}K.forEach((Z,q)=>Z.index=q);const{added:fe,removed:x}=S(H,K,k,this.s);if(fe.length===0&&x.length===0)return!1;if(this.o){const Z=O.displayName||O.name;this.o.$updateWorkspaceFolders(Z,L,j,F).then(void 0,q=>{this.n=void 0;const Y={source:{identifier:O.identifier,label:O.displayName||O.name}};this.q.$showMessage(l.Severity.Error,(0,y.localize)(0,null,Z,q.toString()),Y,[])})}return this.y(K),!0}getWorkspaceFolder(O,L){if(this.x)return this.x.getWorkspaceFolder(O,L)}async getWorkspaceFolder2(O,L){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(O,L)}async resolveWorkspaceFolder(O){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(O)}getPath(){if(!this.x)return;const{folders:O}=this.x;if(O.length!==0)return O[0].uri.fsPath}getRelativePath(O,L){let j,z="";if(typeof O=="string"?(j=p.URI.file(O),z=O):typeof O<"u"&&(j=O,z=O.fsPath),!j)return z;const F=this.getWorkspaceFolder(j,!0);if(!F)return z;typeof L>"u"&&this.x&&(L=this.x.folders.length>1);let H=(0,R.$wg)(F.uri,j);return L&&F.name&&(H=`${F.name}/${H}`),H}y(O){this.x&&(this.n=g.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:O,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(O){const{workspace:L,added:j,removed:z}=g.toExtHostWorkspace(O,this.l,this.n,this.s);this.l=L||void 0,this.n=void 0,this.c.fire(Object.freeze({added:j,removed:z}))}findFiles(O,L,j,z,F=d.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${z.value}, entryPoint: findFiles`);let H;if(L===null?H=!1:L&&(typeof L=="string"?H=L:H=L.pattern),F&&F.isCancellationRequested)return Promise.resolve([]);const{includePattern:K,folder:fe}=P(h.GlobPattern.from(O));return this.o.$startFileSearch(K??null,fe??null,H??null,j??null,F).then(x=>Array.isArray(x)?x.map(Z=>p.URI.revive(Z)):[])}async findTextInFiles(O,L,j,z,F=d.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${z.value}, entryPoint: findTextInFiles`);const H=this.j.getNext(),K=typeof L.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:L.previewOptions,{includePattern:fe,folder:x}=P(h.GlobPattern.from(L.include)),Z=typeof L.exclude=="string"?L.exclude:L.exclude?L.exclude.pattern:void 0,q={ignoreSymlinks:typeof L.followSymlinks=="boolean"?!L.followSymlinks:void 0,disregardIgnoreFiles:typeof L.useIgnoreFiles=="boolean"?!L.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof L.useGlobalIgnoreFiles=="boolean"?!L.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof L.useParentIgnoreFiles=="boolean"?!L.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof L.useDefaultExcludes=="boolean"?!L.useDefaultExcludes:!0,fileEncoding:L.encoding,maxResults:L.maxResults,previewOptions:K,afterContext:L.afterContext,beforeContext:L.beforeContext,includePattern:fe,excludePattern:Z},Y=!1;if(this.u[H]=be=>{if(Y)return;const ue=p.URI.revive(be.resource);be.results.forEach(ve=>{(0,o.$EI)(ve)?j({uri:ue,preview:{text:ve.preview.text,matches:(0,C.$1b)(ve.preview.matches,J=>new t.$dK(J.startLineNumber,J.startColumn,J.endLineNumber,J.endColumn))},ranges:(0,C.$1b)(ve.ranges,J=>new t.$dK(J.startLineNumber,J.startColumn,J.endLineNumber,J.endColumn))}):j({uri:ue,text:ve.text,lineNumber:ve.lineNumber})})},F.isCancellationRequested)return{};try{const be=await this.o.$startTextSearch(O,x??null,q,H,F);return delete this.u[H],be||{}}catch(be){throw delete this.u[H],be}}$handleTextSearchResult(O,L){this.u[L]?.(O)}async save(O){const L=await this.o.$save(O,{saveAs:!1});return p.URI.revive(L)}async saveAs(O){const L=await this.o.$save(O,{saveAs:!0});return p.URI.revive(L)}saveAll(O){return this.o.$saveAll(O)}resolveProxy(O){return this.o.$resolveProxy(O)}get trusted(){return this.v}requestWorkspaceTrust(O){return this.o.$requestWorkspaceTrust(O)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(O,L){if(this.w.has(O))throw new Error(`A provider has already been registered for scheme ${O}`);this.w.set(O,L);const j=this.t.transformOutgoingScheme(O),z=this.z++;return this.o.$registerEditSessionIdentityProvider(z,j),(0,A.$Pc)(()=>{this.w.delete(O),this.o.$unregisterEditSessionIdentityProvider(z)})}async $getEditSessionIdentifier(O,L){this.h.info("Getting edit session identifier for workspaceFolder",O);const j=await this.resolveWorkspaceFolder(p.URI.revive(O));if(!j){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",j);const z=this.w.get(j.uri.scheme);if(this.h.info(`Provider for scheme ${j.uri.scheme} is defined: `,!!z),!z)return;const F=await z.provideEditSessionIdentity(j,L);if(this.h.info("Provider returned edit session identifier: ",F),!!F)return F}async $provideEditSessionIdentityMatch(O,L,j,z){this.h.info("Getting edit session identifier for workspaceFolder",O);const F=await this.resolveWorkspaceFolder(p.URI.revive(O));if(!F){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",F);const H=this.w.get(F.uri.scheme);if(this.h.info(`Provider for scheme ${F.uri.scheme} is defined: `,!!H),!H)return;const K=await H.provideEditSessionIdentityMatch?.(L,j,z);if(this.h.info("Provider returned edit session identifier match result: ",K),!!K)return K}getOnWillCreateEditSessionIdentityEvent(O){return(L,j,z)=>{const F=function(K){L.call(j,K)};return F.extension=O,this.A.event(F,void 0,z)}}async $onWillCreateEditSessionIdentity(O,L,j){const z=await this.resolveWorkspaceFolder(p.URI.revive(O));if(z===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:z},L,async(F,H)=>{const K=Date.now();await Promise.resolve(F),Date.now()-K>j&&this.h.warn("SLOW edit session create-participant",H.extension.identifier)}),L.isCancellationRequested}registerCanonicalUriProvider(O,L){if(this.B.has(O))throw new Error(`A provider has already been registered for scheme ${O}`);this.B.set(O,L);const j=this.t.transformOutgoingScheme(O),z=this.z++;return this.o.$registerCanonicalUriProvider(z,j),(0,A.$Pc)(()=>{this.B.delete(O),this.o.$unregisterCanonicalUriProvider(z)})}async provideCanonicalUri(O,L,j){const z=this.B.get(O.scheme);if(!z)return;const F=await z.provideCanonicalUri?.(p.URI.revive(O),L,j);if(F)return F}async $provideCanonicalUri(O,L,j){return this.provideCanonicalUri(p.URI.revive(O),{targetScheme:L},j)}};e.$Ybc=f,e.$Ybc=f=He([Be(0,m.$aM),Be(1,c.$qM),Be(2,r.$Mbc),Be(3,v.$8i),Be(4,n.$Wbc)],f),e.$Zbc=(0,D.$Nh)("IExtHostWorkspace");function P(N){let O,L;return N&&(typeof N=="string"?O=N:(O=N.pattern,L=p.URI.revive(N.baseUri))),{includePattern:O,folder:L}}}),define(De[40],Ce([1,0,23,4,39,6,7,245,136,18,9,5,20,13,2]),function(me,e,C,T,d,M,A,b,E,w,R,I,p,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3bc=e.$2bc=e.$1bc=void 0;function v(n,o){if(o){const i=o.split(".");let a=n;for(let u=0;a&&u<i.length;u++)a=a[i[u]];return a}}function l(n){return n instanceof D.URI}function s(n){return n&&n.uri instanceof D.URI&&n.languageId&&typeof n.languageId=="string"}function r(n){return n&&!n.uri&&n.languageId&&typeof n.languageId=="string"}function c(n){return n&&n.uri instanceof D.URI&&(!n.name||typeof n.name=="string")&&(!n.index||typeof n.index=="number")}function m(n){if(l(n))return{resource:n};if(s(n))return{resource:n.uri,overrideIdentifier:n.languageId};if(r(n))return{overrideIdentifier:n.languageId};if(c(n))return{resource:n.uri};if(n===null)return{resource:null}}let h=class{constructor(o,i,a){this.a=o.getProxy(M.$_J.MainThreadConfiguration),this.c=i,this.b=a,this.d=new R.$Rg,this.e=null}getConfigProvider(){return this.d.wait().then(o=>this.e)}$initializeConfiguration(o){this.e=new t(this.a,this.c,o,this.b),this.d.open()}$acceptConfigurationChanged(o,i){this.getConfigProvider().then(a=>a.$acceptConfigurationChanged(o,i))}};e.$1bc=h,e.$1bc=h=He([Be(0,p.$aM),Be(1,d.$Zbc),Be(2,y.$8i)],h);class t{constructor(o,i,a,u){this.a=new T.$Md,this.b=o,this.f=u,this.c=i,this.e=b.$zn.parse(a),this.d=this.k(a.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(o,i){const a={data:this.e.toData(),workspace:this.c.workspace};this.e=b.$zn.parse(o),this.d=this.k(o.configurationScopes),this.a.fire(this.j(i,a))}getConfiguration(o,i,a){const u=m(i)||{},k=this.g(o?v(this.e.getValue(void 0,u,this.c.workspace),o):this.e.getValue(void 0,u,this.c.workspace));o&&this.h(o,u,a?.identifier);function S(g){if(g==null)return null;if(typeof g=="boolean")return g?2:5;switch(g){case A.ConfigurationTarget.Global:return 2;case A.ConfigurationTarget.Workspace:return 5;case A.ConfigurationTarget.WorkspaceFolder:return 6}}const $={has(g){return typeof v(k,g)<"u"},get:(g,f)=>{this.h(o?`${o}.${g}`:g,u,a?.identifier);let P=v(k,g);if(typeof P>"u")P=f;else{let N;const O=(L,j)=>{if((0,w.$zf)(L)){let z;const F=()=>{N=N||(0,C.$2m)(k),z=z||v(N,j)};return new Proxy(L,{get:(H,K)=>{if(typeof K=="string"&&K.toLowerCase()==="tojson")return F(),()=>z;if(N)return z=z||v(N,j),z[K];const fe=H[K];return typeof K=="string"?O(fe,`${j}.${K}`):fe},set:(H,K,fe)=>(F(),z&&(z[K]=fe),!0),deleteProperty:(H,K)=>(F(),z&&delete z[K],!0),defineProperty:(H,K,fe)=>(F(),z&&Object.defineProperty(z,K,fe),!0)})}return Array.isArray(L)?(0,C.$2m)(L):L};P=O(P,g)}return P},update:(g,f,P,N)=>{g=o?`${o}.${g}`:g;const O=S(P);return f!==void 0?this.b.$updateConfigurationOption(O,g,f,u,N):this.b.$removeConfigurationOption(O,g,u,N)},inspect:g=>{g=o?`${o}.${g}`:g;const f=this.e.inspect(g,u,this.c.workspace);if(f)return{key:g,defaultValue:(0,C.$2m)(f.policy?.value??f.default?.value),globalValue:(0,C.$2m)(f.user?.value??f.application?.value),workspaceValue:(0,C.$2m)(f.workspace?.value),workspaceFolderValue:(0,C.$2m)(f.workspaceFolder?.value),defaultLanguageValue:(0,C.$2m)(f.default?.override),globalLanguageValue:(0,C.$2m)(f.user?.override??f.application?.override),workspaceLanguageValue:(0,C.$2m)(f.workspace?.override),workspaceFolderLanguageValue:(0,C.$2m)(f.workspaceFolder?.override),languageIds:(0,C.$2m)(f.overrideIdentifiers)}}};return typeof k=="object"&&(0,C.$5m)($,k,!1),Object.freeze($)}g(o){const i=a=>(0,w.$zf)(a)?new Proxy(a,{get:(u,k)=>i(u[k]),set:(u,k,S)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(k)}' of object`)},deleteProperty:(u,k)=>{throw new Error(`TypeError: Cannot delete read only property '${String(k)}' of object`)},defineProperty:(u,k)=>{throw new Error(`TypeError: Cannot define property '${String(k)}' for a readonly object`)},setPrototypeOf:u=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):a;return i(o)}h(o,i,a){const u=E.$qn.test(o)?4:this.d.get(o),k=a?`[${a.value}] `:"";if(u===4){typeof i?.resource>"u"&&this.f.warn(`${k}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${o}', provide the URI of a resource or 'null' for any resource.`);return}if(u===3){i?.resource&&this.f.warn(`${k}Accessing a window scoped configuration for a resource is not expected. To associate '${o}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(o,i){const a=new b.$Bn(o,i,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(u,k)=>a.affectsConfiguration(u,m(k))})}k(o){return o.reduce((i,a)=>(i.set(a[0],a[1]),i),new Map)}}e.$2bc=t,e.$3bc=(0,I.$Nh)("IExtHostConfiguration")}),define(De[93],Ce([1,0,2,9,4,6,7,39,69,40,21,44,20,27,5,17,12,13,89,291,8]),function(me,e,C,T,d,M,A,b,E,w,R,I,p,y,D,v,l,s,r,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1cc=e.$Zcc=e.$Ycc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var h;(function(O){function L(z){if(z!=null)return z}O.from=L;function j(z){if(z!=null)return z}O.to=j})(h||(h={}));var t;(function(O){function L(z){if(z!=null)return z}O.from=L;function j(z){if(z!=null)return z}O.to=j})(t||(t={}));var n;(function(O){function L(z){if(z!=null)return z}O.from=L;function j(z){if(z!=null)return z}O.to=j})(n||(n={}));var o;(function(O){function L(F){if(F){const H=F;return H&&!!H.process}else return!1}O.is=L;function j(F){if(F==null)return;const H={process:F.process,args:F.args};return F.options&&(H.options=n.from(F.options)),H}O.from=j;function z(F){if(F!=null)return new A.$VK(F.process,F.args,F.options)}O.to=z})(o||(o={}));var i;(function(O){function L(z){if(z!=null)return z}O.from=L;function j(z){if(z!=null)return z}O.to=j})(i||(i={}));var a;(function(O){function L(F){if(F){const H=F;return H&&(!!H.commandLine||!!H.command)}else return!1}O.is=L;function j(F){if(F==null)return;const H={};return F.commandLine!==void 0?H.commandLine=F.commandLine:(H.command=F.command,H.args=F.args),F.options&&(H.options=i.from(F.options)),H}O.from=j;function z(F){if(!(F==null||F.command===void 0&&F.commandLine===void 0))return F.commandLine?new A.$WK(F.commandLine,F.options):new A.$WK(F.command,F.args?F.args:[],F.options)}O.to=z})(a||(a={}));var u;(function(O){function L(F){if(F){const H=F;return H&&H.customExecution==="customExecution"}else return!1}O.is=L;function j(F){return{customExecution:"customExecution"}}O.from=j;function z(F,H){return H.get(F)}O.to=z})(u||(e.CustomExecutionDTO=u={}));var k;(function(O){function L(j,z){let F;return j.scope!==void 0&&typeof j.scope!="number"?F=j.scope.uri:j.scope!==void 0&&typeof j.scope=="number"&&(j.scope===A.TaskScope.Workspace&&z&&z.workspaceFile?F=z.workspaceFile:F=c.$NF),{id:j._id,workspaceFolder:F}}O.from=L})(k||(e.TaskHandleDTO=k={}));var S;(function(O){function L(j){if(j!=null)return{_id:j.id,isDefault:j.isDefault}}O.from=L})(S||(S={}));var $;(function(O){function L(F,H){if(F==null)return[];const K=[];for(const fe of F){const x=j(fe,H);x&&K.push(x)}return K}O.fromMany=L;function j(F,H){if(F==null)return;let K;F.execution instanceof A.$VK?K=o.from(F.execution):F.execution instanceof A.$WK?K=a.from(F.execution):F.execution&&F.execution instanceof A.$XK&&(K=u.from(F.execution));const fe=h.from(F.definition);let x;return F.scope?typeof F.scope=="number"?x=F.scope:x=F.scope.uri:x=A.TaskScope.Workspace,!fe||!x?void 0:{_id:F._id,definition:fe,name:F.name,source:{extensionId:H.identifier.value,label:F.source,scope:x},execution:K,isBackground:F.isBackground,group:S.from(F.group),presentationOptions:t.from(F.presentationOptions),problemMatchers:F.problemMatchers,hasDefinedMatchers:F.hasDefinedMatchers,runOptions:F.runOptions?F.runOptions:{reevaluateOnRerun:!0},detail:F.detail}}O.from=j;async function z(F,H,K){if(F==null)return;let fe;o.is(F.execution)?fe=o.to(F.execution):a.is(F.execution)?fe=a.to(F.execution):u.is(F.execution)&&(fe=u.to(F._id,K));const x=h.to(F.definition);let Z;if(F.source&&(F.source.scope!==void 0?typeof F.source.scope=="number"?Z=F.source.scope:Z=await H.resolveWorkspaceFolder(C.URI.revive(F.source.scope)):Z=A.TaskScope.Workspace),!x||!Z)return;const q=new A.$YK(x,Z,F.name,F.source.label,fe,F.problemMatchers);return F.isBackground!==void 0&&(q.isBackground=F.isBackground),F.group!==void 0&&(q.group=A.$UK.from(F.group._id),q.group&&F.group.isDefault&&(q.group=new A.$UK(q.group.id,q.group.label),F.group.isDefault===!0&&(q.group.isDefault=F.group.isDefault))),F.presentationOptions&&(q.presentationOptions=t.to(F.presentationOptions)),F._id&&(q._id=F._id),F.detail&&(q.detail=F.detail),q}O.to=z})($||(e.TaskDTO=$={}));var g;(function(O){function L(z){return z}O.from=L;function j(z){if(z)return Object.assign(Object.create(null),z)}O.to=j})(g||(g={}));class f{#e;constructor(L,j,z){this._id=j,this.a=z,this.#e=L}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(L){}fireDidEndProcess(L){}}let P=class{constructor(L,j,z,F,H,K,fe,x){this.q=new d.$Md,this.r=new d.$Md,this.s=new d.$Md,this.t=new d.$Md,this.a=L.getProxy(M.$_J.MainThreadTask),this.b=z,this.c=F,this.d=H,this.e=K,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=fe,this.g=x,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(L,j,z){if(!z)return new A.$bK(()=>{});const F=this.w();return this.j.set(F,{type:j,provider:z,extension:L}),this.a.$registerTaskProvider(F,j),new A.$bK(()=>{this.j.delete(F),this.a.$unregisterTaskProvider(F)})}registerTaskSystem(L,j){this.a.$registerTaskSystem(L,j)}fetchTasks(L){return this.a.$fetchTasks(g.from(L)).then(async j=>{const z=[];for(const F of j){const H=await $.to(F,this.b,this.m);H&&z.push(H)}return z})}get taskExecutions(){const L=[];return this.k.forEach(j=>L.push(j)),L}terminateTask(L){if(!(L instanceof f))throw new Error("No valid task execution provided");return this.a.$terminateTask(L._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(L,j,z){const F=this.m.get(L.id);F&&(this.o.set(L.id,F),this.e.attachPtyToTerminal(j,await F.callback(z))),this.p=L.id,this.q.fire({execution:await this.y(L)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(L){const j=await this.y(L);this.l.delete(L.id),this.k.delete(L.id),this.A(L),this.r.fire({execution:j})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(L){const j=await this.y(L.id);this.s.fire({execution:j,processId:L.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(L){const j=await this.y(L.id);this.t.fire({execution:j,exitCode:L.exitCode})}$provideTasks(L,j){const z=this.j.get(L);if(!z)return Promise.reject(new Error("no handler found"));const F=[],H=(0,T.$Lg)(()=>z.provider.provideTasks(R.CancellationToken.None)).then(K=>this.u(j,F,z,K));return new Promise(K=>{H.then(fe=>{Promise.all(F).then(()=>{K(fe)})})})}async $resolveTask(L,j){const z=this.j.get(L);if(!z)return Promise.reject(new Error("no handler found"));if(j.definition.type!==z.type)throw new Error(`Unexpected: Task of type [${j.definition.type}] cannot be resolved by provider of type [${z.type}].`);const F=await $.to(j,this.b,this.m);if(!F)throw new Error("Unexpected: Task cannot be resolved.");const H=await z.provider.resolveTask(F,R.CancellationToken.None);if(!H)return;this.z(H,z);const K=$.from(H,z.extension);if(!K)throw new Error("Unexpected: Task cannot be resolved.");if(H.definition!==F.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return u.is(K.execution)&&await this.x(K,H,!0),await this.v(K)}w(){return this.h++}async x(L,j,z){const F=await this.a.$createTaskId(L);!z&&!this.m.has(F)&&(this.n.add(F),this.o.set(F,j.execution)),this.m.set(F,j.execution)}async y(L,j){if(typeof L=="string"){const H=this.l.get(L);if(!H)throw new m.$ab("Unexpected: The specified task is missing an execution");return H}const z=this.l.get(L.id);if(z)return z;const F=new Promise((H,K)=>{function fe(x,Z,q){q?H(new f(x,Z.id,q)):K("Unexpected: Task does not exist.")}j?fe(this,L,j):$.to(L.task,this.b,this.m).then(x=>fe(this,L,x))});return this.l.set(L.id,F),F.then(H=>(this.k.set(L.id,H),H),H=>Promise.reject(H))}z(L,j){L._deprecated&&this.g.report("Task.constructor",j.extension,"Use the Task constructor that takes a `scope` instead.")}A(L){this.o.get(L.id)&&this.o.delete(L.id),this.n.has(L.id)&&this.p!==L.id&&(this.m.delete(L.id),this.n.delete(L.id));const z=this.n.values();let F=z.next();for(;!F.done;)!this.o.has(F.value)&&this.p!==F.value&&(this.m.delete(F.value),this.n.delete(F.value)),F=z.next()}};e.$Ycc=P,e.$Ycc=P=He([Be(0,p.$aM),Be(1,y.$qM),Be(2,b.$Zbc),Be(3,E.$lM),Be(4,w.$3bc),Be(5,I.$icc),Be(6,s.$8i),Be(7,r.$Pbc)],P);let N=class extends P{constructor(L,j,z,F,H,K,fe,x){super(L,j,z,F,H,K,fe,x),this.registerTaskSystem(v.Schemas.vscodeRemote,{scheme:v.Schemas.vscodeRemote,authority:"",platform:l.$i(0)})}async executeTask(L,j){if(!j.execution)throw new Error("Tasks to execute must include an execution");const z=$.from(j,L);if(z===void 0)throw new Error("Task is not valid");if(u.is(z.execution))await this.x(z,j,!1);else throw new m.$$;const F=await this.y(await this.a.$getTaskExecution(z),j);return this.a.$executeTask(z).catch(H=>{throw new Error(H)}),F}u(L,j,z,F){const H=[];if(F)for(const K of F){this.z(K,z),(!K.definition||!L[K.definition.type])&&this.f.warn(`The task [${K.source}, ${K.name}] uses an undefined task type. The task will be ignored in the future.`);const fe=$.from(K,z.extension);fe&&u.is(fe.execution)?(H.push(fe),j.push(this.x(fe,K,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:H,extension:z.extension}}async v(L){if(u.is(L.execution))return L;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(L,j){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(L,j,z){}};e.$Zcc=N,e.$Zcc=N=He([Be(0,p.$aM),Be(1,y.$qM),Be(2,b.$Zbc),Be(3,E.$lM),Be(4,w.$3bc),Be(5,I.$icc),Be(6,s.$8i),Be(7,r.$Pbc)],N),e.$1cc=(0,D.$Nh)("IExtHostTask")}),define(De[346],Ce([1,0,16,21,46,35,24,37,36]),function(me,e,C,T,d,M,A,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$cc=void 0;class w{constructor(p,y,D){this.k=p,this.l=y,this.o=D,this.e=!1,this.f=0,this.g=!1,this.a=p.filePattern,this.b=p.includePattern&&M.$uj(p.includePattern),this.c=p.maxResults||void 0,this.d=p.exists,this.h=new Set,this.j=p.excludePattern&&M.$uj(p.excludePattern)}cancel(){this.g=!0,this.h.forEach(p=>p.cancel()),this.h=new Set}search(p){const y=this.k.folderQueries||[];return new Promise((D,v)=>{const l=s=>{this.f++,p(s)};if(this.g)return D({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(s=>{const r=s.toString(),c=C.$mc(r);this.j&&this.j(r,c)||this.v(l,{base:s,basename:c})}),Promise.all(y.map(s=>this.p(s,l))).then(s=>{D({limitHit:this.e,stats:s[0]||void 0})},s=>{v(new Error((0,d.$yi)(s)))})})}async p(p,y){const D=new T.$Wd,v=this.q(p),l=this.r(),s=new E.$WI(this.k,p),r=!s.hasSiblingExcludeClauses();let c;try{this.h.add(D),c=b.$Id.create();const m=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},v,D.token),h=c.elapsed(),t=b.$Id.create();return this.g&&!this.e||(m&&m.forEach(n=>{const o=C.$fc.relative(p.folder.path,n.path);if(r){const i=C.$mc(n.path);this.v(y,{base:p.folder,relativePath:o,basename:i});return}this.s(l,p.folder,o,y)}),this.g&&!this.e)?null:(this.u(l,s,y),{providerTime:h,postProcessTime:t.elapsed()})}finally{D.dispose(),this.h.delete(D)}}q(p){const y=(0,E.$VI)(this.k.includePattern,p.includePattern),D=(0,E.$VI)(this.k.excludePattern,p.excludePattern);return{folder:p.folder,excludes:D,includes:y,useIgnoreFiles:!p.disregardIgnoreFiles,useGlobalIgnoreFiles:!p.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!p.disregardParentIgnoreFiles,followSymlinks:!p.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const p={rootEntries:[],pathToEntries:Object.create(null)};return p.pathToEntries["."]=p.rootEntries,p}s({pathToEntries:p},y,D,v){if(D===this.a){const s=C.$mc(this.a);this.v(v,{base:y,relativePath:this.a,basename:s})}function l(s){const r=C.$mc(s),c=C.$lc(s);let m=p[c];m||(m=p[c]=[],l(c)),m.push({base:y,relativePath:s,basename:r})}l(D)}u({rootEntries:p,pathToEntries:y},D,v){const l=this,s=this.a;function r(c){const m=(0,E.$YI)(()=>c.map(h=>h.basename));for(let h=0,t=c.length;h<t;h++){const n=c[h],{relativePath:o,basename:i}=n;if(D.matchesExcludesSync(o,i,s!==i?m:void 0))continue;const a=y[o];if(a)r(a);else{if(o===s)continue;l.v(v,n)}if(l.e)break}}r(p)}v(p,y){(!this.b||y.relativePath&&this.b(y.relativePath,y.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||p(y))}}class R{constructor(){this.b=new Map}static{this.a=512}fileSearch(p,y,D,v){const l=this.c(p.cacheKey),s=new w(p,y,l&&l.token);let r=0;const c=m=>{r+=m.length,D(m.map(h=>this.d(h)))};return this.e(s,R.a,c,v).then(m=>({limitHit:m.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:r,detailStats:m.stats}}))}clearCache(p){this.c(p)?.cancel()}c(p){if(p)return this.b.has(p)||this.b.set(p,new T.$Wd),this.b.get(p)}d(p){return p.relativePath?{resource:A.$ug(p.base,p.relativePath)}:{resource:p.base}}e(p,y,D,v){const l=v.onCancellationRequested(()=>{p.cancel()}),s=c=>{c&&(r.push(c),y>0&&r.length>=y&&(D(r),r=[]))};let r=[];return p.search(s).then(c=>(r.length&&D(r),l.dispose(),c),c=>(r.length&&D(r),l.dispose(),Promise.reject(c)))}}e.$$cc=R}),define(De[347],Ce([1,0,19,73,35,99,28,17,16,24,15,18,2,172,226,49,13,43,143,344,36]),function(me,e,C,T,d,M,A,b,E,w,R,I,p,y,D,v,l,s,r,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QJ=e.$PJ=void 0;let h=class{constructor(g,f,P,N,O){this.a=g,this.b=f,this.c=P,this.d=N,this.e=O}text(g,f,P={}){g=this.f(g,P);const N=this.a.getValue(),O=f&&f.some(j=>!this.a.getValue({resource:j}).search.useRipgrep);return{...this.h(f?.map(s.$9h),P),type:2,contentPattern:g,previewOptions:P.previewOptions,maxFileSize:P.maxFileSize,usePCRE2:N.search.usePCRE2||O||!1,beforeContext:P.beforeContext,afterContext:P.afterContext,userDisabledExcludesAndIgnoreFiles:P.disregardExcludeSettings&&P.disregardIgnoreFiles}}f(g,f){const P=this.a.getValue();g.isRegExp&&(g.pattern=g.pattern.replace(/\r?\n/g,"\\n"));const N={...g,wordSeparators:P.editor.wordSeparators};return this.j(g,f)&&(N.isCaseSensitive=!0),this.k(g)&&(N.isMultiline=!0),f.notebookSearchConfig?.includeMarkupInput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookMarkdownInput=f.notebookSearchConfig.includeMarkupInput),f.notebookSearchConfig?.includeMarkupPreview&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookMarkdownPreview=f.notebookSearchConfig.includeMarkupPreview),f.notebookSearchConfig?.includeCodeInput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookCellInput=f.notebookSearchConfig.includeCodeInput),f.notebookSearchConfig?.includeOutput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookCellOutput=f.notebookSearchConfig.includeOutput),N}file(g,f={}){return{...this.h(g,f),type:1,filePattern:f.filePattern?f.filePattern.trim():f.filePattern,exists:f.exists,sortByScore:f.sortByScore,cacheKey:f.cacheKey}}g(g,f){return g?(g=Array.isArray(g)?g.map(a):a(g),f?this.parseSearchPaths(g):{pattern:n(...Array.isArray(g)?g:[g])}):{}}h(g=[],f={}){const P=this.g(f.includePattern,f.expandPatterns),N=this.g(f.excludePattern,f.expandPatterns),O=g.length>1,L=(P.searchPaths&&P.searchPaths.length?P.searchPaths.map(F=>this.q(F,f,N)):g.map(F=>this.r(F,f,N,O))).filter(F=>!!F),j={_reason:f._reason,folderQueries:L,usingSearchPaths:!!(P.searchPaths&&P.searchPaths.length),extraFileResources:f.extraFileResources,excludePattern:N.pattern,includePattern:P.pattern,onlyOpenEditors:f.onlyOpenEditors,maxResults:f.maxResults};if(f.onlyOpenEditors){const F=C.$Gb(C.$Qb(this.c.groups.map(fe=>fe.editors.map(x=>x.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(F));const H=F.filter(fe=>(0,m.$MI)(j,fe.fsPath)),K=this.i(H);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(K)),{...j,...K}}const z=f.extraFileResources&&f.extraFileResources.filter(F=>(0,m.$MI)(j,F.fsPath));return j.extraFileResources=z&&z.length?z:void 0,j}i(g){const f=[],P=new A.$zc,N={};let O=!1;return g.forEach(L=>{if(L.scheme===b.Schemas.walkThrough)return;if((0,w.$yg)(L)){const z=this.b.getWorkspaceFolder(L)?.uri??L.with({path:E.$lc(L.fsPath)});let F=P.get(z);F||(O=!0,F={folder:z,includePattern:{}},f.push(F),P.set(z,F));const H=E.$kc(z.fsPath,L.fsPath);(0,I.$If)(F.includePattern)[H.replace(/\\/g,"/")]=!0}else L.fsPath&&(O=!0,N[L.fsPath]=!0)}),{folderQueries:f,includePattern:N,usingSearchPaths:!0,excludePattern:O?void 0:{"**/*":!0}}}j(g,f){if(f.isSmartCase){if(g.isRegExp){if(R.$of(g.pattern,!0))return!0}else if(R.$of(g.pattern))return!0}return!!g.isCaseSensitive}k(g){return g.isMultiline||g.isRegExp&&(0,y.$oB)(g.pattern)||g.pattern.indexOf(`
`)>=0?!0:!!g.isMultiline}parseSearchPaths(g){const f=K=>E.$hc(K)||/^\.\.?([\/\\]|$)/.test(K),N=(Array.isArray(g)?g:o(g)).map(K=>{const fe=this.e.resolvedUserHome;return fe?(0,M.$ov)(K,fe.scheme===b.Schemas.file?fe.fsPath:fe.path):K}),O=T.$J(N,K=>f(K)?"searchPaths":"exprSegments"),L=(O.exprSegments||[]).map(K=>R.$Je(K,"/")).map(K=>R.$Je(K,"\\")).map(K=>(K[0]==="."&&(K="*"+K),i(K))),j={},z=this.m(O.searchPaths||[]);z&&z.length&&(j.searchPaths=z);const F=C.$Qb(L),H=n(...F);return H&&(j.pattern=H),j}l(g,f){return f.disregardExcludeSettings?void 0:(0,m.$LI)(g,!f.disregardSearchExcludeSettings)}m(g){if(!g||!g.length)return[];const f=g.flatMap(N=>{let{pathPortion:O,globPortion:L}=t(N);return L&&(L=u(L)),this.n(O).flatMap(z=>this.o(z,L))}),P=new Map;return f.forEach(N=>{const O=N.searchPath.toString(),L=P.get(O);L?N.pattern&&(L.pattern=L.pattern||{},L.pattern[N.pattern]=!0):P.set(O,{searchPath:N.searchPath,pattern:N.pattern?n(N.pattern):void 0})}),Array.from(P.values())}n(g){if(E.$hc(g)){const f=this.b.getWorkspace().folders;return f[0]&&f[0].uri.scheme!==b.Schemas.file?[{searchPath:f[0].uri.with({path:g})}]:[{searchPath:p.URI.file(E.$gc(g))}]}if(this.b.getWorkbenchState()===2){const f=this.b.getWorkspace().folders[0].uri;if(g=a(g),g.startsWith("../")||g===".."){const N=E.$fc.resolve(f.path,g);return[{searchPath:f.with({path:N})}]}const P=u(g);return[{searchPath:f,pattern:P}]}else{if(g==="./"||g===".\\")return[];{const f=g.replace(/^\.[\/\\]/,""),N=this.b.getWorkspace().folders.map(O=>{const L=f.match(new RegExp(`^${R.$Ee(O.name)}(?:/(.*)|$)`));return L?{match:L,folder:O}:null}).filter(I.$Ff);if(N.length)return N.map(O=>{const L=O.match[1];return{searchPath:O.folder.uri,pattern:L&&u(L)}});{const O=g.match(/\.[\/\\](.+)[\/\\]?/),L=O?O[1]:g,j=D.localize(0,null,L);throw new Error(j)}}}}o(g,f){const P=g.pattern&&f?`${g.pattern}/${f}`:g.pattern||f,N=[{searchPath:g.searchPath,pattern:P}];return P&&!P.endsWith("**")&&N.push({searchPath:g.searchPath,pattern:P+"/**"}),N}q(g,f,P){const N=this.r((0,s.$9h)(g.searchPath),f,P,!1);return N?{...N,includePattern:g.pattern}:null}r(g,f,P,N){let O;const L=p.URI.isUri(g)?g:g.uri;if(P.searchPaths){const K=P.searchPaths.filter(fe=>(0,w.$ng)(fe.searchPath,L))[0];if(K&&!K.pattern)return null;K&&(O=K.pattern)}const j=this.a.getValue({resource:L}),F={...this.l(j,f)||{},...O||{}},H=p.URI.isUri(g)?(0,w.$rg)(g):g.name;return{folder:L,folderName:N?H:void 0,excludePattern:Object.keys(F).length>0?F:void 0,fileEncoding:j.files&&j.files.encoding,disregardIgnoreFiles:typeof f.disregardIgnoreFiles=="boolean"?f.disregardIgnoreFiles:!j.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof f.disregardGlobalIgnoreFiles=="boolean"?f.disregardGlobalIgnoreFiles:!j.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof f.disregardParentIgnoreFiles=="boolean"?f.disregardParentIgnoreFiles:!j.search.useParentIgnoreFiles,ignoreSymlinks:typeof f.ignoreSymlinks=="boolean"?f.ignoreSymlinks:!j.search.followSymlinks}}};e.$PJ=h,e.$PJ=h=He([Be(0,v.$hi),Be(1,s.$Wh),Be(2,r.$$B),Be(3,l.$8i),Be(4,c.$NJ)],h);function t($){const g=$.match(/[\*\{\}\(\)\[\]\?]/);if(g){const f=g.index,P=$.substr(0,f).match(/[/|\\][^/\\]*$/);if(P){let N=$.substr(0,P.index);return N.match(/[/\\]/)||(N+="/"),{pathPortion:N,globPortion:$.substr((P.index||0)+1)}}}return{pathPortion:$}}function n(...$){return $.length?$.reduce((g,f)=>(g[f]=!0,g),Object.create(null)):void 0}function o($){return d.$sj($,",").map(g=>g.trim()).filter(g=>!!g.length)}function i($){return[`**/${$}/**`,`**/${$}`].map(f=>f.replace(/\*\*\/\*\*/g,"**"))}function a($){return $.replace(/\\/g,"/")}function u($){return a($).replace(/^\.\//,"").replace(/\/+$/g,"")}function k($){return $.replace(/([?*[\]])/g,"[$1]")}function S($,g){$=C.$Lb($,N=>N.toString());const f=[],P=g.getWorkspace();return $&&$.forEach(N=>{let O;if(g.getWorkbenchState()===2)O=(0,w.$wg)(P.folders[0].uri,N),O&&O!=="."&&(O="./"+O);else{const L=g.getWorkspaceFolder(N);if(L){const j=L.name;if(P.folders.filter(F=>F.name===j).length===1){const F=(0,w.$wg)(L.uri,N);F===""?O=`./${L.name}`:O=`./${L.name}/${F}`}else O=N.fsPath}}O&&f.push(k(O))}),f}e.$QJ=S}),define(De[348],Ce([1,0,24,2,21,8,5,347,36,43]),function(me,e,C,T,d,M,A,b,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$slb=e.$rlb=void 0;const R=7e3;function I(v,l){const s=l.activationEvents;if(!s)return Promise.resolve(void 0);const r=[],c=[];for(const i of s)if(/^workspaceContains:/.test(i)){const a=i.substr(18);a.indexOf("*")>=0||a.indexOf("?")>=0||v.forceUsingSearch?c.push(a):r.push(a)}if(r.length===0&&c.length===0)return Promise.resolve(void 0);let m;const h=new Promise((i,a)=>{m=i}),t=i=>m({activationEvent:i}),n=Promise.all(r.map(i=>p(v,i,t))).then(()=>{}),o=y(v,l.identifier,c,t);return Promise.all([n,o]).then(()=>{m(void 0)}),h}e.$rlb=I;async function p(v,l,s){for(const r of v.folders)if(await v.exists(C.$ug(T.URI.revive(r),l))){s(`workspaceContains:${l}`);return}}async function y(v,l,s,r){if(s.length===0)return Promise.resolve(void 0);const c=new d.$Wd,m=v.checkExists(v.folders,s,c.token),h=setTimeout(async()=>{c.cancel(),v.logService.info(`Not activating extension '${l.value}': Timed out while searching for 'workspaceContains' pattern ${s.join(",")}`)},R);let t=!1;try{t=await m}catch(n){M.$3(n)||M.$Z(n)}c.dispose(),clearTimeout(h),t&&r(`workspaceContains:${s.join(",")}`)}function D(v,l,s,r){const c=v.get(A.$Mh),m=v.get(E.$DI),t=c.createInstance(b.$PJ).file(l.map(n=>(0,w.$9h)(T.URI.revive(n))),{_reason:"checkExists",includePattern:s,exists:!0});return m.fileSearch(t,r).then(n=>!!n.limitHit,n=>M.$3(n)?!1:Promise.reject(n))}e.$slb=D}),define(De[45],Ce([1,0,204,16,54,24,9,3,77,2,13,6,40,286,115,39,26,148,8,25,22,262,7,64,5,27,90,20,104,72,44,4,348,114,264,17,112,37,12,113]),function(me,e,C,T,d,M,A,b,E,w,R,I,p,y,D,v,l,s,r,c,m,h,t,n,o,i,a,u,k,S,$,g,f,P,N,O,L,j,z,F){"use strict";var H;Object.defineProperty(e,"__esModule",{value:!0}),e.$xcc=e.$wcc=e.$vcc=e.$ucc=e.$tcc=void 0,e.$tcc=(0,o.$Nh)("IHostUtils");let K=H=class extends b.$Rc{constructor(J,U,V,ge,_,ie,re,Ee,oe,he,ee,le){super(),this.X=le,this.a=this.B(new g.$Md),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=U,this.g=V,this.f=re,this.j=ge,this.m=_,this.s=ie,this.t=oe,this.u=he,this.w=ee,this.y=this.g.getProxy(I.$_J.MainThreadWorkspace),this.z=this.g.getProxy(I.$_J.MainThreadTelemetry),this.C=this.g.getProxy(I.$_J.MainThreadExtensionService),this.D=new A.$Rg,this.F=new A.$Rg,this.G=new A.$Rg,this.H=new A.$Rg,this.I=new ue(this.f.extensions.activationEvents),this.L=new s.$_3b(this.I,this.f.extensions.allExtensions);const $e=new c.$3l(this.f.extensions.myExtensions);this.J=new s.$_3b(this.I,Y(this.L,$e)),z.$t&&(this.s.info(`Creating extension host with the following global extensions: ${Z(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${Z(this.J)}`)),this.M=new D.$acc(this.g,this.s),this.N=new P.$mcc(this.g),this.O=Ee,this.h=J.createChild(new k.$Lh([D.$bcc,this.M],[P.$ncc,this.N])),this.P=this.B(new y.$_bc(this.J,this.L,{onExtensionActivationError:(Pe,B,Q)=>{this.C.$onExtensionActivationError(Pe,r.$2(B),Q)},actualActivateExtension:async(Pe,B)=>{if(s.$_3b.isHostExtension(Pe,this.J,this.L))return await this.C.$activateExtension(Pe,B),new y.$$bc;const Q=this.J.getExtensionDescription(Pe);return this.db(Q,B)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),d.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(J){r.$Z(J)}}async Y(){this.O.onWillDeactivateAll();let J=[];try{J=this.J.getAllExtensionDescriptions().map(_=>_.identifier).filter(_=>this.isActivated(_)).map(_=>this.cb(_))}catch{}await Promise.all(J)}terminate(J,U=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${J}`),this.s.flush(),this.u.dispose(),this.P.dispose(),r.setUnexpectedErrorHandler(ge=>{this.s.error(ge)}),this.g.dispose();const V=this.Y();Promise.race([(0,A.$Tg)(5e3),V]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${U}`):this.s.info(`Extension host exiting with code ${U}`),this.s.flush(),this.s.dispose(),this.c.exit(U)})}isActivated(J){return this.G.isOpen()?this.P.isActivated(J):!1}async getExtension(J){const U=await this.C.$getExtension(J);return U&&{...U,identifier:new c.$2l(U.identifier.value),extensionLocation:w.URI.revive(U.extensionLocation)}}Z(J,U){return this.P.activateByEvent(J,U)}$(J,U){return this.P.activateById(J,U)}activateByIdWithErrors(J,U){return this.$(J,U).then(()=>{const V=this.P.getActivatedExtension(J);if(V.activationFailed)return Promise.reject(V.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(J=>this.J)}getExtensionExports(J){if(this.G.isOpen())return this.P.getActivatedExtension(J).exports;try{return this.P.getActivatedExtension(J).exports}catch{return null}}async ab(J){if(J.scheme===O.Schemas.file&&this.c.fsRealpath){const U=await this.c.fsRealpath(J.fsPath);return w.URI.file(U)}return J}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(J=>new be(J))),this.Q}async bb(J){const U=E.$Th.forUris(V=>M.$lg.ignorePathCasing(V));return await Promise.all(J.map(async V=>{if(this.ub(V)){const ge=await this.ab(V.extensionLocation);U.set(ge,V)}})),U}cb(J){let U=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(J))return U;const V=this.P.getActivatedExtension(J);if(!V)return U;try{typeof V.module.deactivate=="function"&&(U=Promise.resolve(V.module.deactivate()).then(void 0,ge=>(this.s.error(ge),Promise.resolve(void 0))))}catch(ge){this.s.error(`An error occurred when deactivating the extension '${J.value}':`),this.s.error(ge)}try{(0,b.$Mc)(V.subscriptions)}catch(ge){this.s.error(`An error occurred when deactivating the subscriptions for extension '${J.value}':`),this.s.error(ge)}return U}async db(J,U){return this.f.remote.isRemote?this.C.$onWillActivateExtension(J.identifier):await this.C.$onWillActivateExtension(J.identifier),this.fb(J,U).then(V=>{const ge=V.activationTimes;return this.C.$onDidActivateExtension(J.identifier,ge.codeLoadingTime,ge.activateCallTime,ge.activateResolvedTime,U),this.eb(J,U,"success",ge),V},V=>{throw this.eb(J,U,"failure"),V})}eb(J,U,V,ge){const _=x(J,U);this.z.$publicLog2("extensionActivationTimes",{..._,...ge||{},outcome:V})}fb(J,U){const V=x(J,U);this.z.$publicLog2("activatePlugin",V);const ge=this.ub(J);if(!ge)return Promise.resolve(new y.$0bc(y.$7bc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${J.identifier.value}, startup: ${U.startup}, activationEvent: '${U.activationEvent}'${J.identifier.value!==U.extensionId.value?`, root cause: ${U.extensionId.value}`:""}`),this.s.flush();const _=new y.$8bc(U.startup);return Promise.all([this.vb(J,(0,M.$ug)(J.extensionLocation,ge),_),this.gb(J)]).then(ie=>(d.mark(`code/extHost/willActivateExtension/${J.identifier.value}`),H.hb(this.s,J.identifier,ie[0],ie[1],_))).then(ie=>(d.mark(`code/extHost/didActivateExtension/${J.identifier.value}`),ie))}gb(J){const U=new h.$dcc(J,this.M),V=new h.$ccc(J.identifier.value,!1,this.M),ge=new N.$occ(J,this.N),_=J.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,ie=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${J.identifier.value}`),Promise.all([U.whenReady,V.whenReady,this.O.whenReady]).then(()=>{const re=this;let Ee,oe;const he=(0,l.$$E)(J,"ipc")?this.f.messagePorts?.get(c.$2l.toKey(J.identifier)):void 0;return Object.freeze({globalState:U,workspaceState:V,secrets:ge,subscriptions:[],get extensionUri(){return J.extensionLocation},get extensionPath(){return J.extensionLocation.fsPath},asAbsolutePath(ee){return T.$ic(J.extensionLocation.fsPath,ee)},get storagePath(){return re.O.workspaceValue(J)?.fsPath},get globalStoragePath(){return re.O.globalValue(J).fsPath},get logPath(){return T.$ic(re.f.logsLocation.fsPath,J.identifier.value)},get logUri(){return w.URI.joinPath(re.f.logsLocation,J.identifier.value)},get storageUri(){return re.O.workspaceValue(J)},get globalStorageUri(){return re.O.globalValue(J)},get extensionMode(){return _},get extension(){return Ee===void 0&&(Ee=new q(re,J.identifier,J,ie,!1)),Ee},get extensionRuntime(){return(0,l.$_E)(J,"extensionRuntime"),re.extensionRuntime},get environmentVariableCollection(){return re.u.getEnvironmentVariableCollection(J)},get messagePassingProtocol(){if(!oe){if(!he)return;const ee=g.Event.buffer(g.Event.fromDOMEventEmitter(he,"message",le=>le.data));he.start(),oe={onDidReceiveMessage:ee,postMessage:he.postMessage.bind(he)}}return oe}})})}static hb(J,U,V,ge,_){return V=V||{activate:void 0,deactivate:void 0},this.ib(J,U,V,ge,_).then(ie=>new y.$9bc(!1,null,_.build(),V,ie,ge.subscriptions))}static ib(J,U,V,ge,_){if(typeof V.activate=="function")try{_.activateCallStart(),J.trace(`ExtensionService#_callActivateOptional ${U.value}`);const ie=typeof global=="object"?global:self,re=V.activate.apply(ie,[ge]);return _.activateCallStop(),_.activateResolveStart(),Promise.resolve(re).then(Ee=>(_.activateResolveStop(),Ee))}catch(ie){return Promise.reject(ie)}else return Promise.resolve(V)}jb(J,U){this.$(J.identifier,{startup:!1,extensionId:J.identifier,activationEvent:U}).then(void 0,V=>{this.s.error(V)})}kb(J,U=0){const ge=Date.now();(0,z.$B)(()=>{for(let _=U;_<J.length;_+=1){const ie=J[_];for(const re of ie.activationEvents??[])if(re==="onStartupFinished")if(Date.now()-ge>50){this.kb(J,_);break}else this.jb(ie,re)}})}lb(){this.C.$setPerformanceMarks(d.getMarks()),this.m.getConfigProvider().then(J=>{const U=J.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),V=this.J.getAllExtensionDescriptions();if(U)this.kb(V);else for(const ge of V)if(ge.activationEvents)for(const _ of ge.activationEvents)_==="onStartupFinished"&&this.jb(ge,_)})}mb(){const J=this.Z("*",!0).then(void 0,ie=>{this.s.error(ie)});this.B(this.j.onDidChangeWorkspace(ie=>this.nb(ie.added)));const U=this.j.workspace?this.j.workspace.folders:[],V=this.nb(U),ge=this.pb(),_=Promise.all([ge,J,V]).then(()=>{});return Promise.race([_,(0,A.$Tg)(1e4)]).then(()=>{this.lb()}),_}nb(J){return J.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(U=>this.ob(J,U))).then(()=>{})}async ob(J,U){if(this.isActivated(U.identifier))return;const V=!this.f.remote.isRemote&&!!this.f.remote.authority,ge={logService:this.s,folders:J.map(ie=>ie.uri),forceUsingSearch:V||!this.c.fsExists,exists:ie=>this.c.fsExists(ie.fsPath),checkExists:(ie,re,Ee)=>this.y.$checkExists(ie,re,Ee)},_=await(0,f.$rlb)(ge,U);if(_)return this.$(U.identifier,{startup:!0,extensionId:U.identifier,activationEvent:_.activationEvent}).then(void 0,ie=>this.s.error(ie))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(J){throw console.error(J),J}}async qb(){const{extensionDevelopmentLocationURI:J,extensionTestsLocationURI:U}=this.f.environment;if(!J||!U)throw new Error(C.localize(0,null));const V=await this.vb(null,U,new y.$8bc(!1));if(!V||typeof V.run!="function")throw new Error(C.localize(1,null,U.toString()));return new Promise((ge,_)=>{const ie=(oe,he)=>{oe?(z.$t&&this.s.error("Test runner called back with error",oe),_(oe)):(z.$t&&(he?this.s.info(`Test runner called back with ${he} failures.`):this.s.info("Test runner called back with successful outcome.")),ge(typeof he=="number"&&he>0?1:0))},re=(0,M.$ig)(U),Ee=V.run(re,ie);Ee&&Ee.then&&Ee.then(()=>{z.$t&&this.s.info("Test runner finished successfully."),ge(0)}).catch(oe=>{z.$t&&this.s.error("Test runner finished with error",oe),_(oe instanceof Error&&oe.stack?oe.stack:String(oe))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,A.$Tg)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(J,U){return this.R[J]=U,(0,b.$Pc)(()=>{delete this.R[J]})}async getRemoteExecServer(J){const{resolver:U}=await this.sb(J);return U?.resolveExecServer?.(J,{resolveAttempt:0})}async sb(J){const U=J.indexOf("+");if(U===-1)throw new t.$hK("Not an authority that can be resolved!",n.RemoteAuthorityResolverErrorCode.InvalidAuthority);const V=J.substr(0,U);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${V}`,!1),{authorityPrefix:V,resolver:this.R[V]}}async $resolveAuthority(J,U){const V=j.$Id.create(!1),ge=()=>`[resolveAuthority(${(0,n.$Qk)(J)},${U})][${V.elapsed()}ms] `,_=se=>this.s.info(`${ge()}${se}`),ie=se=>this.s.warn(`${ge()}${se}`),re=(se,X=void 0)=>this.s.error(`${ge()}${se}`,X),Ee=se=>{if(se instanceof t.$hK)return{type:"error",error:{code:se._code,message:se._message,detail:se._detail}};throw se},oe=async se=>{_(`activating resolver for ${se}...`);const{resolver:X,authorityPrefix:de}=await this.sb(se);if(!X)throw re(`no resolver for ${de}`),new t.$hK(`No remote extension installed to resolve ${de}.`,n.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:X,authorityPrefix:de,remoteAuthority:se}},he=J.split(/@|%40/g).reverse();_(`activating remote resolvers ${he.join(" -> ")}`);let ee;try{ee=await Promise.all(he.map(oe)).catch(async se=>{if(!(se instanceof t.$hK)||se._code!==n.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw se;return ie(`resolving nested authorities failed: ${se.message}`),[await oe(J)]})}catch(se){return Ee(se)}const le=new A.$4g;le.cancelAndSet(()=>_("waiting..."),1e3);let $e,Pe;for(const[se,{authorityPrefix:X,resolver:de,remoteAuthority:ye}]of ee.entries())try{if(se===ee.length-1)_("invoking final resolve()..."),d.mark(`code/extHost/willResolveAuthority/${X}`),$e=await de.resolve(ye,{resolveAttempt:U,execServer:Pe}),d.mark(`code/extHost/didResolveAuthorityOK/${X}`),_("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(de,t.$gK.isManagedResolvedAuthority($e)?$e:void 0));else{if(_(`invoking resolveExecServer() for ${ye}`),d.mark(`code/extHost/willResolveExecServer/${X}`),Pe=await de.resolveExecServer?.(ye,{resolveAttempt:U,execServer:Pe}),!Pe)throw new t.$hK(`Exec server was not available for ${ye}`,n.RemoteAuthorityResolverErrorCode.NoResolverFound);d.mark(`code/extHost/didResolveExecServerOK/${X}`)}}catch(je){return d.mark(`code/extHost/didResolveAuthorityError/${X}`),re("returned an error",je),le.dispose(),Ee(je)}le.dispose();const B={environmentTunnels:$e.environmentTunnels,features:$e.tunnelFeatures},Q={extensionHostEnv:$e.extensionHostEnv,isTrusted:$e.isTrusted,authenticationSession:$e.authenticationSessionForInitializingExtensions?{id:$e.authenticationSessionForInitializingExtensions.id,providerId:$e.authenticationSessionForInitializingExtensions.providerId}:void 0};_(`returned ${t.$gK.isManagedResolvedAuthority($e)?"managed authority":`${$e.host}:${$e.port}`}`);let te;if(t.$gK.isManagedResolvedAuthority($e)){const se=U;this.X.setFactory(se,$e.makeConnection),te={authority:J,connectTo:new n.$Nk(se),connectionToken:$e.connectionToken}}else te={authority:J,connectTo:new n.$Ok($e.host,$e.port),connectionToken:$e.connectionToken};return{type:"ok",value:{authority:te,options:Q,tunnelInformation:B}}}async $getCanonicalURI(J,U){this.s.info(`$getCanonicalURI invoked for authority (${(0,n.$Qk)(J)})`);const{resolver:V}=await this.sb(J);if(!V)return null;const ge=w.URI.revive(U);if(typeof V.getCanonicalURI>"u")return ge;const _=await(0,A.$Lg)(()=>V.getCanonicalURI(ge));return _||ge}$startExtensionHost(J){J.toAdd.forEach(ge=>ge.extensionLocation=w.URI.revive(ge.extensionLocation));const{globalRegistry:U,myExtensions:V}=fe(this.I,this.L,this.J,J);return this.L.set(U.getAllExtensionDescriptions()),this.J.set(V),z.$t&&(this.s.info(`$startExtensionHost: global extensions: ${Z(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${Z(this.J)}`)),this.rb()}$activateByEvent(J,U){return U===1?this.D.wait().then(V=>this.Z(J,!1)):this.G.wait().then(V=>this.Z(J,!1))}async $activate(J,U){return await this.G.wait(),this.J.getExtensionDescription(J)?(await this.$(J,U),!0):!1}async $deltaExtensions(J){J.toAdd.forEach(ie=>ie.extensionLocation=w.URI.revive(ie.extensionLocation));const{globalRegistry:U,myExtensions:V}=fe(this.I,this.L,this.J,J),ge=await this.bb(V);return(await this.getExtensionPathIndex()).setSearchTree(ge),this.L.set(U.getAllExtensionDescriptions()),this.J.set(V),z.$t&&(this.s.info(`$deltaExtensions: global extensions: ${Z(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${Z(this.J)}`)),Promise.resolve(void 0)}async $test_latency(J){return J}async $test_up(J){return J.byteLength}async $test_down(J){const U=m.$ae.alloc(J),V=Math.random()%256;for(let ge=0;ge<J;ge++)U.writeUInt8(V,ge);return U}async $updateRemoteConnectionData(J){this.W=J,this.a.fire()}};e.$ucc=K,e.$ucc=K=H=He([Be(0,o.$Mh),Be(1,e.$tcc),Be(2,u.$aM),Be(3,v.$Zbc),Be(4,p.$3bc),Be(5,R.$8i),Be(6,i.$qM),Be(7,a.$gcc),Be(8,S.$Wvb),Be(9,$.$icc),Be(10,L.$qcc),Be(11,F.$rcc)],K);function fe(ve,J,U,V){ve.addActivationEvents(V.addActivationEvents);const ge=new s.$_3b(ve,J.getAllExtensionDescriptions());ge.deltaExtensions(V.toAdd,V.toRemove);const _=new c.$3l(U.getAllExtensionDescriptions().map(re=>re.identifier));for(const re of V.myToRemove)_.delete(re);for(const re of V.myToAdd)_.add(re);const ie=Y(ge,_);return{globalRegistry:ge,myExtensions:ie}}function x(ve,J){return{id:ve.identifier.value,name:ve.name,extensionVersion:ve.version,publisherDisplayName:ve.publisher,activationEvents:ve.activationEvents?ve.activationEvents.join(","):null,isBuiltin:ve.isBuiltin,reason:J.activationEvent,reasonId:J.extensionId.value}}function Z(ve){return ve.getAllExtensionDescriptions().map(J=>J.identifier.value).join(",")}e.$vcc=(0,o.$Nh)("IExtHostExtensionService");class q{#e;#t;#i;constructor(J,U,V,ge,_){this.#e=J,this.#t=U,this.#i=V.identifier,this.id=V.identifier.value,this.extensionUri=V.extensionLocation,this.extensionPath=T.$gc((0,M.$ig)(V.extensionLocation)),this.packageJSON=V,this.extensionKind=ge,this.isFromDifferentExtensionHost=_}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$wcc=q;function Y(ve,J){return ve.getAllExtensionDescriptions().filter(U=>J.has(U.identifier))}class be{constructor(J){this.a=J}setSearchTree(J){this.a=J}findSubstr(J){return this.a.findSubstr(J)}forEach(J){return this.a.forEach(J)}}e.$xcc=be;class ue{constructor(J){this.a=new c.$4l,this.addActivationEvents(J)}readActivationEvents(J){return this.a.get(J.identifier)}addActivationEvents(J){for(const U of Object.keys(J))this.a.set(U,J[U])}}}),define(De[349],Ce([1,0,54,2,6,40,26,25,20,27,5,45,13,15]),function(me,e,C,T,d,M,A,b,E,w,R,I,p,y){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$Tdc=void 0;let v=class{constructor(m,h,t,n,o,i,a){this.c=m,this.d=h,this.e=t,this.f=n,this.g=o,this.h=i,this.i=a,this.a=new Map,this.b=[]}async install(){this.j(),C.mark("code/extHost/willWaitForConfig");const m=await this.f.getConfigProvider();C.mark("code/extHost/didWaitForConfig");const h=await this.g.getExtensionPathIndex();this.register(new s(this.c,h,this.d,m,this.i)),this.register(this.e.createInstance(l)),this.h.remote.isRemote&&this.register(this.e.createInstance(r,h,this.h.environment.appUriScheme))}register(m){if("nodeModuleName"in m)if(Array.isArray(m.nodeModuleName))for(const h of m.nodeModuleName)this.a.set(h,m);else this.a.set(m.nodeModuleName,m);typeof m.alternativeModuleName=="function"&&this.b.push(h=>m.alternativeModuleName(h))}};e.$Tdc=v,e.$Tdc=v=He([Be(2,R.$Mh),Be(3,M.$3bc),Be(4,I.$vcc),Be(5,w.$qM),Be(6,p.$8i)],v);let l=class{static{D=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(m){if(m.environment.appRoot&&D.a.size){const h=(0,y.$Ee)(this.c(m.environment.appRoot.fsPath)),t="[a-z0-9_.-]",n=`@${t}+\\/${t}+|${t}+`,o="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${h}/${o}\\/)(${n})(.*)$`,"i")}}alternativeModuleName(m){if(!this.b)return;const h=this.b.exec(this.c(m));if(!h)return;const[,t,n,o]=h,i=D.a.get(n);if(i!==void 0)return console.warn(`${n} as been renamed to ${i}, please update your imports`),t+i+o}c(m){return m.replace(/\\/g,"/")}};l=D=He([Be(0,w.$qM)],l);class s{constructor(m,h,t,n,o){this.c=m,this.d=h,this.e=t,this.f=n,this.g=o,this.nodeModuleName="vscode",this.a=new b.$4l}load(m,h){const t=this.d.findSubstr(h);if(t){let n=this.a.get(t.identifier);return n||(n=this.c(t,this.e,this.f),this.a.set(t.identifier,n)),n}if(!this.b){let n="";this.d.forEach((o,i)=>n+=`	${i} -> ${o.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${h}. These are the extension path mappings: 
${n}`),this.b=this.c(A.$6E,this.e,this.f)}return this.b}}let r=class{constructor(m,h,t){this.e=m,this.f=h,this.nodeModuleName=["open","opn"],this.d=t.getProxy(d.$_J.MainThreadTelemetry);const n=t.getProxy(d.$_J.MainThreadWindow);this.c=(o,i)=>{const a=T.URI.parse(o);return i?this.g(o,i):a.scheme==="http"||a.scheme==="https"?n.$openUri(a,o,{allowTunneling:!0}):a.scheme==="mailto"||a.scheme===this.f?n.$openUri(a,o,{}):this.g(o,i)}}load(m,h,t){const n=this.e.findSubstr(h);return n&&(this.a=n.identifier.value,this.h()),this.b=t(m),this.c}g(m,h){return this.i(),this.b(m,h)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};r=He([Be(2,E.$aM)],r)}),define(De[56],Ce([1,0,51,3,16,47,5,69,70,45,7,39,278,40]),function(me,e,C,T,d,M,A,b,E,w,R,I,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5cc=e.$4cc=void 0,e.$4cc=(0,A.$Nh)("IExtHostVariableResolverProvider");class D extends p.$bN{constructor(s,r,c,m,h,t,n){function o(){if(c){const i=c.activeEditor();if(i)return i.document.uri;const a=m.tabGroups.all.find(u=>u.isActive)?.activeTab;if(a!==void 0){if(a.input instanceof R.$TL||a.input instanceof R.$YL)return a.input.modified;if(a.input instanceof R.$SL||a.input instanceof R.$XL||a.input instanceof R.$VL)return a.input.uri}}}super({getFolderUri:i=>{const a=t.folders.filter(u=>u.name===i);if(a&&a.length>0)return a[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(i,a)=>h.getConfiguration(void 0,i).get(a),getAppRoot:()=>M.cwd(),getExecPath:()=>M.env.VSCODE_EXEC_PATH,getFilePath:()=>{const i=o();if(i)return d.$gc(i.fsPath)},getWorkspaceFolderPathForFile:()=>{if(r){const i=o();if(i){const a=r.getWorkspaceFolder(i);if(a)return d.$gc(a.uri.fsPath)}}},getSelectedText:()=>{if(c){const i=c.activeEditor();if(i&&!i.selection.isEmpty)return i.document.getText(i.selection)}},getLineNumber:()=>{if(c){const i=c.activeEditor();if(i)return String(i.selection.end.line+1)}},getExtension:i=>s.getExtension(i)},void 0,n?Promise.resolve(n):void 0,Promise.resolve(M.env))}}let v=class extends T.$Rc{constructor(s,r,c,m,h){super(),this.b=s,this.c=r,this.g=c,this.h=m,this.j=h,this.a=new C.$U(async()=>{const t=await this.h.getConfigProvider(),o={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async i=>{o.folders=await this.c.getWorkspaceFolders2()||[]})),new D(this.b,this.c,this.g,this.j,t,o,this.m())})}getResolver(){return this.a.value}m(){}};e.$5cc=v,e.$5cc=v=He([Be(0,w.$vcc),Be(1,I.$Zbc),Be(2,b.$lM),Be(3,y.$3bc),Be(4,E.$2cc)],v)}),define(De[94],Ce([1,0,9,4,2,5,6,70,45,20,7,39,140,271,40,56]),function(me,e,C,T,d,M,A,b,E,w,R,I,p,y,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0cc=e.$9cc=e.$8cc=e.$7cc=e.$6cc=void 0,e.$6cc=(0,M.$Nh)("IExtHostDebugService");let l=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(n,o,i,a,u,k){this.E=o,this.F=i,this.G=a,this.H=u,this.I=k,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new T.$Md,this.n=new T.$Md,this.o=new T.$Md,this.u=new T.$Md,this.k=n.getProxy(A.$_J.MainThreadDebugService),this.y=new T.$Md,this.A=new T.$Md,this.v=new r(this.k),this.w=new Map,this.F.getExtensionRegistry().then(S=>{S.onDidChange($=>{this.J(S)}),this.J(S)})}asDebugSourceUri(n,o){const i=n;if(typeof i.sourceReference=="number"&&i.sourceReference>0){let a=`debug:${encodeURIComponent(i.path||"")}`,u="?";return o&&(a+=`${u}session=${encodeURIComponent(o.id)}`,u="&"),a+=`${u}ref=${i.sourceReference}`,d.URI.parse(a)}else{if(i.path)return d.URI.file(i.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(n){const o=[];for(const i of n.getAllExtensionDescriptions())if(i.contributes){const a=i.contributes.debuggers;if(a&&a.length>0)for(const u of a)(0,y.$qF)(u)&&o.push(u.type)}this.k.$registerDebugTypes(o)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const n=[];return this.w.forEach(o=>n.push(o)),n}addBreakpoints(n){const o=n.filter(u=>{const k=u.id;return this.w.has(k)?!1:(this.w.set(k,u),!0)});this.U(o,[],[]);const i=[],a=new Map;for(const u of o)if(u instanceof R.$aL){let k=a.get(u.location.uri.toString());k||(k={type:"sourceMulti",uri:u.location.uri,lines:[]},a.set(u.location.uri.toString(),k),i.push(k)),k.lines.push({id:u.id,enabled:u.enabled,condition:u.condition,hitCondition:u.hitCondition,logMessage:u.logMessage,line:u.location.range.start.line,character:u.location.range.start.character})}else u instanceof R.$bL&&i.push({type:"function",id:u.id,enabled:u.enabled,hitCondition:u.hitCondition,logMessage:u.logMessage,condition:u.condition,functionName:u.functionName});return this.k.$registerBreakpoints(i)}removeBreakpoints(n){const o=n.filter(k=>this.w.delete(k.id));this.U([],o,[]);const i=o.filter(k=>k instanceof R.$aL).map(k=>k.id),a=o.filter(k=>k instanceof R.$bL).map(k=>k.id),u=o.filter(k=>k instanceof R.$cL).map(k=>k.id);return this.k.$unregisterBreakpoints(i,a,u)}startDebugging(n,o,i){return this.k.$startDebugging(n?n.uri:void 0,o,{parentSessionID:i.parentSession?i.parentSession.id:void 0,lifecycleManagedByParent:i.lifecycleManagedByParent,repl:i.consoleMode===R.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:i.noDebug,compact:i.compact,suppressSaveBeforeStart:i.suppressSaveBeforeStart,suppressDebugStatusbar:i.suppressDebugStatusbar??i.debugUI?.simple,suppressDebugToolbar:i.suppressDebugToolbar??i.debugUI?.simple,suppressDebugView:i.suppressDebugView??i.debugUI?.simple})}stopDebugging(n){return this.k.$stopDebugging(n?n.id:void 0)}registerDebugConfigurationProvider(n,o,i){if(!o)return new R.$bK(()=>{});const a=this.d++;return this.f.push({type:n,handle:a,provider:o}),this.k.$registerDebugConfigurationProvider(n,i,!!o.provideDebugConfigurations,!!o.resolveDebugConfiguration,!!o.resolveDebugConfigurationWithSubstitutedVariables,a),new R.$bK(()=>{this.f=this.f.filter(u=>u.provider!==o),this.k.$unregisterDebugConfigurationProvider(a)})}registerDebugAdapterDescriptorFactory(n,o,i){if(!i)return new R.$bK(()=>{});if(!this.Q(n,o))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${o}' debugger.`);if(this.N(o))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const a=this.g++;return this.h.push({type:o,handle:a,factory:i}),this.k.$registerDebugAdapterDescriptorFactory(o,a),new R.$bK(()=>{this.h=this.h.filter(u=>u.factory!==i),this.k.$unregisterDebugAdapterDescriptorFactory(a)})}registerDebugAdapterTrackerFactory(n,o){if(!o)return new R.$bK(()=>{});const i=this.i++;return this.j.push({type:n,handle:i,factory:o}),new R.$bK(()=>{this.j=this.j.filter(a=>a.factory!==o)})}async $runInTerminal(n,o){return Promise.resolve(void 0)}async $substituteVariables(n,o){let i;const a=await this.W(n);return a&&(i={uri:a.uri,name:a.name,index:a.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(i,o)}K(n,o){if(n.type==="implementation")return new m(n.implementation)}L(){}async $startDASession(n,o){const i=this,a=await this.V(o);return this.S(this.N(a.type),a).then(u=>{if(!u)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}' (extension might have failed to activate)`);const k=this.M(u),S=this.K(k,a);if(!S)throw new Error(`Couldn't create a debug adapter for type '${a.type}'.`);const $=S;return this.B.set(n,$),this.R(a).then(g=>(g&&this.C.set(n,g),$.onMessage(async f=>{if(f.type==="request"&&f.command==="handshake"){const P=f,N={type:"response",seq:0,command:P.command,request_seq:P.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const O=await this.D.sign(P.arguments.value);N.body={signature:O},$.sendResponse(N)}else throw new Error("no signer")}catch(O){N.success=!1,N.message=O.message,$.sendResponse(N)}}else g&&g.onDidSendMessage&&g.onDidSendMessage(f),f=(0,y.$vF)(f,!0),i.k.$acceptDAMessage(n,f)}),$.onError(f=>{g&&g.onError&&g.onError(f),this.k.$acceptDAError(n,f.name,f.message,f.stack)}),$.onExit(f=>{g&&g.onExit&&g.onExit(f??void 0,void 0),this.k.$acceptDAExit(n,f??void 0,void 0)}),g&&g.onWillStartSession&&g.onWillStartSession(),$.startSession()))})}$sendDAMessage(n,o){o=(0,y.$uF)(o,!1);const i=this.C.get(n);i&&i.onWillReceiveMessage&&i.onWillReceiveMessage(o),this.B.get(n)?.sendMessage(o)}$stopDASession(n){const o=this.C.get(n);this.C.delete(n),o&&o.onWillStopSession&&o.onWillStopSession();const i=this.B.get(n);return this.B.delete(n),i?i.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(n){const o=[],i=[],a=[];if(n.added)for(const u of n.added){const k=u.id;if(k&&!this.w.has(k)){let S;if(u.type==="function")S=new R.$bL(u.functionName,u.enabled,u.condition,u.hitCondition,u.logMessage);else if(u.type==="data")S=new R.$cL(u.label,u.dataId,u.canPersist,u.enabled,u.hitCondition,u.condition,u.logMessage);else{const $=d.URI.revive(u.uri);S=new R.$aL(new R.$nK($,new R.$cK(u.line,u.character)),u.enabled,u.condition,u.hitCondition,u.logMessage)}(0,R.$$K)(S,k),this.w.set(k,S),o.push(S)}}if(n.removed)for(const u of n.removed){const k=this.w.get(u);k&&(this.w.delete(u),i.push(k))}if(n.changed){for(const u of n.changed)if(u.id){const k=this.w.get(u.id);if(k){if(k instanceof R.$bL&&u.type==="function"){const S=k;S.enabled=u.enabled,S.condition=u.condition,S.hitCondition=u.hitCondition,S.logMessage=u.logMessage,S.functionName=u.functionName}else if(k instanceof R.$aL&&u.type==="source"){const S=k;S.enabled=u.enabled,S.condition=u.condition,S.hitCondition=u.hitCondition,S.logMessage=u.logMessage,S.location=new R.$nK(d.URI.revive(u.uri),new R.$cK(u.line,u.character))}a.push(k)}}}this.U(o,i,a)}async $acceptStackFrameFocus(n){let o;const i=n.sessionId?await this.V(n.sessionId):void 0;if(!i)throw new Error("no DebugSession found for debug focus context");n.kind==="thread"?o=new R.$iL(i,n.threadId):o=new R.$hL(i,n.threadId,n.frameId),this.z=o,this.A.fire(this.z)}$provideDebugConfigurations(n,o,i){return(0,C.$Lg)(async()=>{const a=this.P(n);if(!a)throw new Error("no DebugConfigurationProvider found");if(!a.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const u=await this.W(o);return a.provideDebugConfigurations(u,i)}).then(a=>{if(!a)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return a})}$resolveDebugConfiguration(n,o,i,a){return(0,C.$Lg)(async()=>{const u=this.P(n);if(!u)throw new Error("no DebugConfigurationProvider found");if(!u.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const k=await this.W(o);return u.resolveDebugConfiguration(k,i,a)})}$resolveDebugConfigurationWithSubstitutedVariables(n,o,i,a){return(0,C.$Lg)(async()=>{const u=this.P(n);if(!u)throw new Error("no DebugConfigurationProvider found");if(!u.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const k=await this.W(o);return u.resolveDebugConfigurationWithSubstitutedVariables(k,i,a)})}async $provideDebugAdapter(n,o){const i=this.O(n);if(!i)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const a=await this.V(o);return this.S(i,a).then(u=>{if(!u)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}'`);return this.M(u)})}async $acceptDebugSessionStarted(n){const o=await this.V(n);this.m.fire(o)}async $acceptDebugSessionTerminated(n){const o=await this.V(n);o&&(this.n.fire(o),this.l.delete(o.id))}async $acceptDebugSessionActiveChanged(n){this.q=n?await this.V(n):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(n,o){(await this.V(n))?._acceptNameChanged(o)}async $acceptDebugSessionCustomEvent(n,o){const a={session:await this.V(n),event:o.event,body:o.body};this.u.fire(a)}M(n){if(n instanceof R.$dL)return{type:"executable",command:n.command,args:n.args,options:n.options};if(n instanceof R.$eL)return{type:"server",port:n.port,host:n.host};if(n instanceof R.$fL)return{type:"pipeServer",path:n.path};if(n instanceof R.$gL)return{type:"implementation",implementation:n.implementation};throw new Error("convertToDto unexpected type")}N(n){const o=this.h.filter(i=>i.type===n);if(o.length>0)return o[0].factory}O(n){const o=this.h.filter(i=>i.handle===n);if(o.length>0)return o[0].factory}P(n){const o=this.f.filter(i=>i.handle===n);if(o.length>0)return o[0].provider}Q(n,o){if(n.contributes){const i=n.contributes.debuggers;if(i&&i.length>0){for(const a of i)if(a.label&&a.type&&a.type===o)return!0}}return!1}R(n){const i=n.configuration.type,a=this.j.filter(u=>u.type===i||u.type==="*").map(u=>(0,C.$Lg)(()=>u.factory.createDebugAdapterTracker(n)).then(k=>k,k=>null));return Promise.race([Promise.all(a).then(u=>{const k=u.filter(S=>!!S);if(k.length>0)return new c(k)}),new Promise(u=>setTimeout(()=>u(void 0),1e3))]).catch(u=>{})}async S(n,o){const i=o.configuration.debugServer;if(typeof i=="number")return Promise.resolve(new R.$eL(i));if(n){const u=await this.F.getExtensionRegistry();return(0,C.$Lg)(()=>n.createDebugAdapterDescriptor(o,this.T(o,u))).then(k=>{if(k)return k})}const a=await this.F.getExtensionRegistry();return Promise.resolve(this.T(o,a))}T(n,o){}U(n,o,i){(n.length>0||o.length>0||i.length>0)&&this.y.fire(Object.freeze({added:n,removed:o,changed:i}))}async V(n){if(n)if(typeof n=="string"){const o=this.l.get(n);if(o)return o}else{let o=this.l.get(n.id);if(!o){const i=await this.W(n.folderUri),a=n.parent?this.l.get(n.parent):void 0;o=new s(this.k,n.id,n.type,n.name,i,n.configuration,a),this.l.set(o.id,o),this.k.$sessionCached(o.id)}return o}throw new Error("cannot find session")}W(n){if(n){const o=d.URI.revive(n);return this.E.resolveWorkspaceFolder(o)}return Promise.resolve(void 0)}};e.$7cc=l,e.$7cc=l=He([Be(0,w.$aM),Be(1,I.$Zbc),Be(2,E.$vcc),Be(3,D.$3bc),Be(4,b.$2cc),Be(5,v.$4cc)],l);class s{constructor(n,o,i,a,u,k,S){this.d=n,this.f=o,this.g=i,this.h=a,this.i=u,this.j=k,this.k=S}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(n){this.h=n,this.d.$setDebugSessionName(this.f,n)}get parentSession(){return this.k}_acceptNameChanged(n){this.h=n}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(n,o){return this.d.$customDebugAdapterRequest(this.f,n,o)}getDebugProtocolBreakpoint(n){return this.d.$getDebugProtocolBreakpoint(this.f,n.id)}}e.$8cc=s;class r{constructor(n){this.value=Object.freeze({append(o){n.$appendDebugConsole(o)},appendLine(o){this.append(o+`
`)}})}}e.$9cc=r;class c{constructor(n){this.d=n}onWillStartSession(){this.d.forEach(n=>n.onWillStartSession?n.onWillStartSession():void 0)}onWillReceiveMessage(n){this.d.forEach(o=>o.onWillReceiveMessage?o.onWillReceiveMessage(n):void 0)}onDidSendMessage(n){this.d.forEach(o=>o.onDidSendMessage?o.onDidSendMessage(n):void 0)}onWillStopSession(){this.d.forEach(n=>n.onWillStopSession?n.onWillStopSession():void 0)}onError(n){this.d.forEach(o=>o.onError?o.onError(n):void 0)}onExit(n,o){this.d.forEach(i=>i.onExit?i.onExit(n,o):void 0)}}class m extends p.$Xcb{constructor(n){super(),this.h=n,n.onDidSendMessage(o=>{this.acceptMessage(o)})}startSession(){return Promise.resolve(void 0)}sendMessage(n){this.h.handleMessage(n)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let h=class extends l{constructor(n,o,i,a,u,k){super(n,o,i,a,u,k)}};e.$0cc=h,e.$0cc=h=He([Be(0,w.$aM),Be(1,I.$Zbc),Be(2,E.$vcc),Be(3,D.$3bc),Be(4,b.$2cc),Be(5,v.$4cc)],h)}),define(De[350],Ce([1,0,8,54,2,6,341,13,103,104,27,238,20,66,45,88]),function(me,e,C,T,d,M,A,b,E,w,R,I,p,y,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vdc=e.$Udc=void 0;class l{static async installEarlyHandler(c){Error.stackTraceLimit=100;const m=c.get(b.$8i),t=c.get(p.$aM).getProxy(M.$_J.MainThreadErrors);C.setUnexpectedErrorHandler(n=>{m.error(n);const o=C.$2(n);t.$onUnexpectedError(o)})}static async installFullHandler(c){const m=c.get(b.$8i),h=c.get(p.$aM),t=c.get(D.$vcc),n=c.get(v.$uM),o=h.getProxy(M.$_J.MainThreadExtensionService),i=h.getProxy(M.$_J.MainThreadErrors),a=await t.getExtensionPathIndex(),u=new WeakMap;function k(g,f){if(u.has(g))return u.get(g).stack;let P="",N,O;for(const j of f)P+=`
	at ${j.toString()}`,O=j.getFileName(),!N&&O&&(N=a.findSubstr(d.URI.file(O)));const L=`${g.name||"Error"}: ${g.message||""}${P}`;return u.set(g,{extensionIdentifier:N?.identifier,stack:L}),L}const S=Symbol("prepareStackTrace wrapped");let $=k;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return $},set(g){if(g===k||!g||g[S]){$=g||k;return}$=function(f,P){return k(f,P),g.call(Error,f,P)},Object.assign($,{[S]:!0})}}),C.setUnexpectedErrorHandler(g=>{m.error(g);const f=C.$2(g),P=u.get(g);if(!P?.extensionIdentifier){i.$onUnexpectedError(f);return}o.$onExtensionRuntimeError(P.extensionIdentifier,f);const N=n.onExtensionError(P.extensionIdentifier,g);m.trace("forwarded error to extension?",N,P)})}}e.$Udc=l;class s{constructor(c,m,h,t,n){this.a=h,this.b=new A.$i4b(c,null,t),m=s.e(m,this.b);const o=new w.$Lh(...(0,E.$tr)());o.set(R.$qM,{_serviceBrand:void 0,...m,messagePorts:n}),o.set(p.$aM,new p.$bM(this.b)),o.set(y.$Wbc,new y.$Xbc(t)),o.set(D.$tcc,h);const i=new I.$_p(o,!0);i.invokeFunction(l.installEarlyHandler),this.d=i.invokeFunction(a=>a.get(b.$8i)),T.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",m),this.c=i.invokeFunction(a=>a.get(D.$vcc)),this.c.initialize(),i.invokeFunction(l.installFullHandler)}async asBrowserUri(c){const m=this.b.getProxy(M.$_J.MainThreadExtensionService);return d.URI.revive(await m.$asBrowserUri(c))}terminate(c){this.c.terminate(c)}static e(c,m){c.extensions.allExtensions.forEach(t=>{t.extensionLocation=d.URI.revive(m.transformIncomingURIs(t.extensionLocation))}),c.environment.appRoot=d.URI.revive(m.transformIncomingURIs(c.environment.appRoot));const h=c.environment.extensionDevelopmentLocationURI;return h&&(c.environment.extensionDevelopmentLocationURI=h.map(t=>d.URI.revive(m.transformIncomingURIs(t)))),c.environment.extensionTestsLocationURI=d.URI.revive(m.transformIncomingURIs(c.environment.extensionTestsLocationURI)),c.environment.globalStorageHome=d.URI.revive(m.transformIncomingURIs(c.environment.globalStorageHome)),c.environment.workspaceStorageHome=d.URI.revive(m.transformIncomingURIs(c.environment.workspaceStorageHome)),c.environment.extensionTelemetryLogResource=d.URI.revive(m.transformIncomingURIs(c.environment.extensionTelemetryLogResource)),c.nlsBaseUrl=d.URI.revive(m.transformIncomingURIs(c.nlsBaseUrl)),c.logsLocation=d.URI.revive(m.transformIncomingURIs(c.logsLocation)),c.workspace=m.transformIncomingURIs(c.workspace),c}}e.$Vdc=s}),define(De[351],Ce([1,0,9,12,215,232,138,94,70,45,20,44,7,56,39,272,273,40]),function(me,e,C,T,d,M,A,b,E,w,R,I,p,y,D,v,l,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6dc=void 0;let r=class extends b.$7cc{constructor(n,o,i,a,u,k,S){super(n,o,i,a,k,S),this.Z=u,this.X=new h}K(n,o){switch(n.type){case"server":return new v.$1dc(n);case"pipeServer":return new v.$2dc(n);case"executable":return new v.$3dc(n,o.type)}return super.K(n,o)}T(n,o){const i=v.$3dc.platformAdapterExecutable(o.getAllExtensionDescriptions(),n.type);if(i)return new p.$dL(i.command,i.args,i.options)}L(){return new A.$Y7b}async $runInTerminal(n,o){if(n.kind==="integrated"){this.Y||(this.Y=this.Z.onDidCloseTerminal(L=>{this.X.onTerminalClosed(L)}));const i=await this.G.getConfigProvider(),a=this.Z.getDefaultShell(!0),u=this.Z.getDefaultShellArgs(!0),k=n.title||d.localize(0,null),S=JSON.stringify({shell:a,shellArgs:u});let $=await this.X.checkout(S,k),g,f=!1;if($)g=n.cwd;else{const L={shellPath:a,shellArgs:u,cwd:n.cwd,name:k,iconPath:new p.$8K("debug")};f=!0,$=this.Z.createTerminalFromOptions(L,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.X.insert($,S)}$.show(!0);const P=await $.processId;f?await new Promise(L=>setTimeout(L,1e3)):i.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(a.indexOf("powershell")>=0||a.indexOf("pwsh")>=0||a.indexOf("cmd.exe")>=0?$.sendText("cls"):a.indexOf("bash")>=0?$.sendText("clear"):T.$j?$.sendText("cls"):$.sendText("clear"));const N=(0,l.$5dc)(a,n.args,!!n.argsCanBeInterpretedByShell,g,n.env);$.sendText(N);const O=this.onDidTerminateDebugSession(L=>{L.id===o&&(this.X.free($),O.dispose())});return P}else if(n.kind==="external")return m(n,await this.G.getConfigProvider());return super.$runInTerminal(n,o)}};e.$6dc=r,e.$6dc=r=He([Be(0,R.$aM),Be(1,D.$Zbc),Be(2,w.$vcc),Be(3,s.$3bc),Be(4,I.$icc),Be(5,E.$2cc),Be(6,y.$4cc)],r);let c;function m(t,n){if(!c)if(T.$j)c=new M.$I6b;else if(T.$k)c=new M.$J6b;else if(T.$l)c=new M.$K6b;else throw new Error("external terminals not supported on this platform");const o=n.getConfiguration("terminal");return c.runInTerminal(t.title,t.cwd,t.args,t.env||{},o.external||{})}class h{constructor(){this.b=new Map}static{this.a=1e3}async checkout(n,o){const a=[...this.b.entries()].map(([u,k])=>(0,C.$Gg)(async S=>{if(u.name!==o||k.lastUsedAt!==-1&&await(0,l.$4dc)(await u.processId))return null;const $=Date.now();return k.lastUsedAt+h.a>$||S.isCancellationRequested||k.config!==n?null:(k.lastUsedAt=$,u)}));return await(0,C.$Xg)(a,u=>!!u)}insert(n,o){this.b.set(n,{lastUsedAt:Date.now(),config:o})}free(n){const o=this.b.get(n);o&&(o.lastUsedAt=-1)}onTerminalClosed(n){this.b.delete(n)}}}),define(De[352],Ce([1,0,16,2,101,39,69,40,43,44,20,27,93,17,13,89,24,63,56]),function(me,e,C,T,d,M,A,b,E,w,R,I,p,y,D,v,l,s,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xdc=void 0;let c=class extends p.$Ycc{constructor(h,t,n,o,i,a,u,k,S){super(h,t,n,o,i,a,u,k),this.B=n,this.C=S,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(y.Schemas.vscodeRemote,{scheme:y.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(y.Schemas.file,{scheme:y.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(h,t){const n=t;if(!t.execution&&n._id===void 0)throw new Error("Tasks to execute must include an execution");if(n._id!==void 0){const o=p.TaskHandleDTO.from(n,this.B),i=await this.a.$getTaskExecution(o);if(i.task===void 0)throw new Error("Task from execution DTO is undefined");const a=await this.y(i,t);return this.a.$executeTask(o).catch(()=>{}),a}else{const o=p.TaskDTO.from(t,h);if(o===void 0)return Promise.reject(new Error("Task is not valid"));p.CustomExecutionDTO.is(o.execution)&&await this.x(o,t,!1);const i=await this.y(await this.a.$getTaskExecution(o),t);return this.a.$executeTask(o).catch(()=>{}),i}}u(h,t,n,o){const i=[];if(o)for(const a of o){this.z(a,n),(!a.definition||!h[a.definition.type])&&this.f.warn(`The task [${a.source}, ${a.name}] uses an undefined task type. The task will be ignored in the future.`);const u=p.TaskDTO.from(a,n.extension);u&&(i.push(u),p.CustomExecutionDTO.is(u.execution)&&t.push(this.x(u,a,!0)))}return{tasks:i,extension:n.extension}}async v(h){return h}async F(h){let t=h&&h.length>0?h[0]:void 0;if(!t){const n=T.URI.file((0,s.homedir)());t=new E.$8h({uri:n,name:l.$rg(n),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(h,t){const n=T.URI.revive(h),o={process:void 0,variables:Object.create(null)},i=await this.b.resolveWorkspaceFolder(n),a=await this.b.getWorkspaceFolders2()??[],u=await this.C.getResolver(),k=i?{uri:i.uri,name:i.name,index:i.index,toResource:()=>{throw new Error("Not implemented")}}:await this.F(a);for(const S of t.variables)o.variables[S]=await u.resolveAsync(k,S);if(t.process!==void 0){let S;if(t.process.path!==void 0){S=t.process.path.split(C.$sc);for(let $=0;$<S.length;$++)S[$]=await u.resolveAsync(k,S[$])}o.process=await d.win32.findExecutable(await u.resolveAsync(k,t.process.name),t.process.cwd!==void 0?await u.resolveAsync(k,t.process.cwd):void 0,S)}return o}async $jsonTasksSupported(){return!0}async $findExecutable(h,t,n){return d.win32.findExecutable(h,t,n)}};e.$Xdc=c,e.$Xdc=c=He([Be(0,R.$aM),Be(1,I.$qM),Be(2,M.$Zbc),Be(3,A.$lM),Be(4,b.$3bc),Be(5,w.$icc),Be(6,D.$8i),Be(7,v.$Pbc),Be(8,r.$4cc)],c)}),define(De[353],Ce([1,0,63,56]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dec=void 0;class d extends T.$5cc{m(){return(0,C.homedir)()}}e.$Dec=d}),define(De[153],Ce([1,0,19,9,21,46,17,16,24,2,36]),function(me,e,C,T,d,M,A,b,E,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cdc=e.$bdc=e.$adc=e.$_cc=void 0;class I{constructor(r,c,m,h){this.d=r,this.e=c,this.f=m,this.g=h,this.a=null,this.b=!1,this.c=0}search(r,c){const m=this.d.folderQueries||[],h=new d.$Wd(c);return new Promise((t,n)=>{this.a=new y(r);let o=!1;const i=(a,u)=>{if(!o&&!this.b){const k=this.h(a);v(a)&&typeof this.d.maxResults=="number"&&this.c+k>this.d.maxResults&&(this.b=!0,o=!0,h.cancel(),a=this.j(a,this.d.maxResults-this.c));const S=this.h(a);this.c+=S,(S>0||!v(a))&&this.a.add(a,u)}};Promise.all(m.map((a,u)=>this.k(a,k=>i(k,u),h.token))).then(a=>{h.dispose(),this.a.flush();const u=a.some(k=>!!k&&!!k.limitHit);t({limitHit:this.b||u,messages:(0,C.$Qb)(a.map(k=>k?.message?Array.isArray(k.message)?k.message:[k.message]:[])),stats:{type:this.g}})},a=>{h.dispose();const u=(0,M.$yi)(a);n(new Error(u))})})}h(r){return v(r)?Array.isArray(r.ranges)?r.ranges.length:1:0}j(r,c){const m=Array.isArray(r.ranges)?r.ranges:[r.ranges],h=Array.isArray(r.preview.matches)?r.preview.matches:[r.preview.matches];return{ranges:m.slice(0,c),preview:{matches:h.slice(0,c),text:r.preview.text},uri:r.uri}}async k(r,c,m){const h=new R.$WI(this.d,r),t=[],n={report:a=>{if(!this.l(a))return;const u=r.folder.scheme===A.Schemas.file?(0,R.$XI)(()=>this.f.readdir(E.$tg(a.uri))):void 0,k=E.$wg(r.folder,a.uri);if(k){const S=h.includedInQuery(k,b.$mc(k),u);(0,T.$Fg)(S)?t.push(S.then($=>{$&&c(a)})):S&&c(a)}}},o=this.n(r),i=await this.e.provideTextSearchResults(p(this.d.contentPattern),o,n,m);return t.length&&await Promise.all(t),i}l(r){if(v(r)){if(Array.isArray(r.ranges)){if(!Array.isArray(r.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(r.preview.matches.length!==r.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(r.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(r){const c=(0,R.$VI)(this.d.includePattern,r.includePattern),m=(0,R.$VI)(this.d.excludePattern,r.excludePattern),h={folder:w.URI.from(r.folder),excludes:m,includes:c,useIgnoreFiles:!r.disregardIgnoreFiles,useGlobalIgnoreFiles:!r.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!r.disregardParentIgnoreFiles,followSymlinks:!r.ignoreSymlinks,encoding:r.fileEncoding&&this.f.toCanonicalName(r.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return h.usePCRE2=this.d.usePCRE2,h}}e.$_cc=I;function p(s){return{isCaseSensitive:s.isCaseSensitive||!1,isRegExp:s.isRegExp||!1,isWordMatch:s.isWordMatch||!1,isMultiline:s.isMultiline||!1,pattern:s.pattern}}class y{constructor(r){this.e=r,this.b=-1,this.d=null,this.a=new l(512,c=>this.g(c))}add(r,c){this.d&&(this.b!==c||!E.$ng(this.c,r.uri))&&(this.f(),this.d=null),this.d||(this.b=c,this.d={resource:r.uri,results:[]}),this.d.results.push(D(r))}f(){const r=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,r)}flush(){this.f(),this.a.flush()}g(r){this.e(r)}}e.$adc=y;function D(s){return v(s)?{preview:{matches:(0,C.$1b)(s.preview.matches,r=>({startLineNumber:r.start.line,startColumn:r.start.character,endLineNumber:r.end.line,endColumn:r.end.character})),text:s.preview.text},ranges:(0,C.$1b)(s.ranges,r=>({startLineNumber:r.start.line,startColumn:r.start.character,endLineNumber:r.end.line,endColumn:r.end.character}))}:{text:s.text,lineNumber:s.lineNumber}}function v(s){return!!s.preview}e.$bdc=v;class l{static{this.a=4e3}static{this.b=50}constructor(r,c){this.g=r,this.h=c,this.c=0,this.d=[],this.e=0}addItem(r,c){r&&this.j(r,c)}addItems(r,c){r&&this.k(r,c)}j(r,c){this.d.push(r),this.e+=c,this.l()}k(r,c){this.d=this.d.concat(r),this.e+=c,this.l()}l(){this.c<l.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},l.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$cdc=l}),define(De[95],Ce([1,0,3,6,5,346,20,66,13,2,153]),function(me,e,C,T,d,M,A,b,E,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fdc=e.$edc=e.$ddc=void 0,e.$ddc=(0,d.$Nh)("IExtHostSearch");let I=class{constructor(v,l,s){this.k=v,this.l=l,this.n=s,this.c=this.k.getProxy(T.$_J.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new M.$$cc}o(v){return this.l.transformOutgoingScheme(v)}registerTextSearchProvider(v,l){if(this.g.has(v))throw new Error(`a text search provider for the scheme '${v}' is already registered`);this.g.add(v);const s=this.d++;return this.e.set(s,l),this.c.$registerTextSearchProvider(s,this.o(v)),(0,C.$Pc)(()=>{this.g.delete(v),this.e.delete(s),this.c.$unregisterProvider(s)})}registerFileSearchProvider(v,l){if(this.i.has(v))throw new Error(`a file search provider for the scheme '${v}' is already registered`);this.i.add(v);const s=this.d++;return this.h.set(s,l),this.c.$registerFileSearchProvider(s,this.o(v)),(0,C.$Pc)(()=>{this.i.delete(v),this.h.delete(s),this.c.$unregisterProvider(s)})}$provideFileSearchResults(v,l,s,r){const c=p(s),m=this.h.get(v);if(m)return this.j.fileSearch(c,m,h=>{this.c.$handleFileMatch(v,l,h.map(t=>t.resource))},r);throw new Error("unknown provider: "+v)}$clearCache(v){return this.j.clearCache(v),Promise.resolve(void 0)}$provideTextSearchResults(v,l,s,r){const c=this.e.get(v);if(!c||!c.provideTextSearchResults)throw new Error(`Unknown provider ${v}`);const m=p(s);return this.q(m,c).search(t=>this.c.$handleTextMatch(v,l,t),r)}$enableExtensionHostSearch(){}q(v,l){return new R.$_cc(v,l,{readdir:s=>Promise.resolve([]),toCanonicalName:s=>s},"textSearchProvider")}};e.$edc=I,e.$edc=I=He([Be(0,A.$aM),Be(1,b.$Wbc),Be(2,E.$8i)],I);function p(D){return{...D,folderQueries:D.folderQueries&&D.folderQueries.map(y),extraFileResources:D.extraFileResources&&D.extraFileResources.map(v=>w.URI.revive(v))}}e.$fdc=p;function y(D){return{...D,folder:w.URI.revive(D.folder)}}}),define(De[354],Ce([1,0,21,8,4,38,2,130,125,168,185,30,6,111,301,300,33,302,40,304,305,306,280,307,69,45,309,310,315,316,317,152,284,323,324,326,115,44,328,287,14,7,85,331,91,151,39,25,276,314,65,149,93,94,95,13,66,20,27,318,274,72,89,294,329,90,71,334,332,333,295,55,327,330,114,70,88,319,92,320,17,134,283,263,312,3,26,270,112,257,321,322,296,311,282,313,113,325,298,299,293,308,297]),function(me,e,C,T,d,M,A,b,E,w,R,I,p,y,D,v,l,s,r,c,m,h,t,n,o,i,a,u,k,S,$,g,f,P,N,O,L,j,z,F,H,K,fe,x,Z,q,Y,be,ue,ve,J,U,V,ge,_,ie,re,Ee,oe,he,ee,le,$e,Pe,B,Q,te,se,X,de,ye,je,We,_e,Ye,it,et,Ae,Ne,qe,Me,Ze,ce,ae,Ie,Ve,ze,Xe,rt,ot,wt,Et,Yt,Kt,pt,Ut,Ft,Bt,Pt,At,Nt,Wt,Ht){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pdc=void 0;function qt(ct){const lt=ct.get(oe.$qM),Jt=ct.get(je.$Mbc),It=ct.get(te.$fcc),kt=ct.get(i.$vcc),ft=ct.get(Y.$Zbc),Dt=ct.get(et.$uM),Tt=ct.get(r.$3bc),yt=ct.get(re.$Wbc),Ge=ct.get(Ee.$aM),Ot=ct.get(L.$bcc),jt=ct.get(Q.$gcc),Le=ct.get(ie.$9i),Te=ct.get(ie.$8i),Se=ct.get(le.$Wvb),ne=ct.get($e.$Pbc),Fe=ct.get(q.$Tcc),Ke=ct.get(Ye.$ncc),xe=ct.get(it.$2cc),Je=ct.get(Ft.$rcc);Ge.set(p.$aK.ExtHostFileSystemInfo,Jt),Ge.set(p.$aK.ExtHostLogLevelServiceShape,Le),Ge.set(p.$aK.ExtHostWorkspace,ft),Ge.set(p.$aK.ExtHostConfiguration,Tt),Ge.set(p.$aK.ExtHostExtensionService,kt),Ge.set(p.$aK.ExtHostStorage,Ot),Ge.set(p.$aK.ExtHostTunnelService,Se),Ge.set(p.$aK.ExtHostWindow,Fe),Ge.set(p.$aK.ExtHostSecretState,Ke),Ge.set(p.$aK.ExtHostTelemetry,Dt),Ge.set(p.$aK.ExtHostEditorTabs,xe),Ge.set(p.$aK.ExtHostManagedSockets,Je);const nt=Ge.set(p.$aK.ExtHostDecorations,ct.get(U.$Xcc)),mt=Ge.set(p.$aK.ExtHostDocumentsAndEditors,ct.get(o.$lM)),gt=Ge.set(p.$aK.ExtHostCommands,ct.get(l.$wM)),bt=Ge.set(p.$aK.ExtHostTerminalService,ct.get(j.$icc)),dt=Ge.set(p.$aK.ExtHostDebugService,ct.get(ge.$6cc)),Rt=Ge.set(p.$aK.ExtHostSearch,ct.get(_.$ddc)),Gt=Ge.set(p.$aK.ExtHostTask,ct.get(V.$1cc)),Ei=Ge.set(p.$aK.ExtHostOutputService,ct.get(g.$Dcc)),Vt=Ge.set(p.$aK.ExtHostLocalization,ct.get(rt.$qcc)),mi=Ge.set(p.$aK.ExtHostUrls,new x.$Mcc(Ge)),Ct=Ge.set(p.$aK.ExtHostDocuments,new n.$Kbc(Ge,mt)),ki=Ge.set(p.$aK.ExtHostDocumentContentProviders,new h.$5bc(Ge,mt,Te)),qi=Ge.set(p.$aK.ExtHostDocumentSaveParticipant,new t.$6bc(Te,Ct,Ge.getProxy(p.$_J.MainThreadBulkEdits))),St=Ge.set(p.$aK.ExtHostNotebook,new he.$jdc(Ge,gt,mt,Ct,It)),ii=Ge.set(p.$aK.ExtHostNotebookDocuments,new ae.$Bdc(St)),$i=Ge.set(p.$aK.ExtHostNotebookEditors,new ce.$Adc(Te,St)),oi=Ge.set(p.$aK.ExtHostNotebookKernels,new Ae.$xdc(Ge,lt,St,gt,Te)),Si=Ge.set(p.$aK.ExtHostNotebookRenderers,new qe.$zdc(Ge,St)),Di=Ge.set(p.$aK.ExtHostNotebookDocumentSaveParticipant,new pt.$Hdc(Te,St,Ge.getProxy(p.$_J.MainThreadBulkEdits))),Mt=Ge.set(p.$aK.ExtHostEditors,new z.$Kcc(Ge,mt)),bi=Ge.set(p.$aK.ExtHostTreeViews,new F.$Lcc(Ge.getProxy(p.$_J.MainThreadTreeViews),gt,Te)),Ci=Ge.set(p.$aK.ExtHostEditorInsets,new ue.$Ucc(Ge.getProxy(p.$_J.MainThreadEditorInsets),Mt,lt.remote)),ai=Ge.set(p.$aK.ExtHostDiagnostics,new c.$Obc(Ge,Te,Jt,mt)),ci=Ge.set(p.$aK.ExtHostLanguages,new S.$Acc(Ge,Ct,gt.converter,yt)),ut=Ge.set(p.$aK.ExtHostLanguageFeatures,new k.$Sbc(Ge,yt,Ct,gt,ai,Te,ne,Dt)),Vi=Ge.set(p.$aK.ExtHostFileSystem,new a.$ycc(Ge,ut)),Xt=Ge.set(p.$aK.ExtHostFileSystemEventService,new u.$zcc(Ge,Te,mt)),ni=Ge.set(p.$aK.ExtHostQuickOpen,(0,P.$Fcc)(Ge,ft,gt)),wi=Ge.set(p.$aK.ExtHostSCM,new N.$Hcc(Ge,gt,Ct,Te)),Ii=Ge.set(p.$aK.ExtHostQuickDiff,new Et.$Edc(Ge,yt)),Ki=Ge.set(p.$aK.ExtHostShare,new Bt.$Jdc(Ge,yt)),Pi=Ge.set(p.$aK.ExtHostComments,(0,s.$Vbc)(Ge,gt,Ct)),pi=Ge.set(p.$aK.ExtHostProgress,new f.$Ecc(Ge.getProxy(p.$_J.MainThreadProgress))),Hi=Ge.set(p.$aK.ExtHosLabelService,new ve.$Vcc(Ge)),Ai=Ge.set(p.$aK.ExtHostTheming,new ee.$kdc(Ge)),ui=Ge.set(p.$aK.ExtHostAuthentication,new Pe.$ldc(Ge)),Gi=Ge.set(p.$aK.ExtHostTimeline,new B.$ndc(Ge,gt)),vi=Ge.set(p.$aK.ExtHostWebviews,new Z.$Pcc(Ge,lt.remote,ft,Te,ne)),Ri=Ge.set(p.$aK.ExtHostWebviewPanels,new de.$pdc(Ge,vi,ft)),cn=Ge.set(p.$aK.ExtHostCustomEditors,new X.$qdc(Ge,Ct,jt,vi,Ri)),Mi=Ge.set(p.$aK.ExtHostWebviewViews,new se.$odc(Ge,vi)),ri=Ge.set(p.$aK.ExtHostTesting,new We.$sdc(Ge,gt,mt)),un=Ge.set(p.$aK.ExtHostUriOpeners,new _e.$wdc(Ge)),ln=Ge.set(p.$aK.ExtHostProfileContentHandlers,new wt.$Ddc(Ge));Ge.set(p.$aK.ExtHostInteractive,new Ie.$Cdc(Ge,St,mt,gt,Te));const Ji=Ge.set(p.$aK.ExtHostInlineChat,new Kt.$Gdc(Ge,gt,Ct,Te)),fi=Ge.set(p.$aK.ExtHostChatProvider,new Pt.$Kdc(Ge,Te)),Qi=Ge.set(p.$aK.ExtHostChatAgents,new Ht.$Odc(Ge,fi,Te)),Zi=Ge.set(p.$aK.ExtHostChatVariables,new At.$Ldc(Ge)),gi=Ge.set(p.$aK.ExtHostChat,new Yt.$Fdc(Ge,Te)),Yi=Ge.set(p.$aK.ExtHostAiRelatedInformation,new Nt.$Mdc(Ge)),Li=Ge.set(p.$aK.ExtHostAiEmbeddingVector,new Wt.$Ndc(Ge)),Xi=Ge.set(p.$aK.ExtHostIssueReporter,new Ut.$Idc(Ge)),xt=Ge.set(p.$aK.ExtHostStatusBar,new O.$Jcc(Ge,gt.converter)),yi=Object.values(p.$aK);Ge.assertRegistered(yi);const hn=new ye.$rdc(Ge,mt),Qt=new v.$Ubc(Ge),li=new $.$Bcc(Ge,Te),Ti=new m.$4bc(Ge);return D.$Tbc.register(gt),function(Ue,_t,Fi){const $t=function(){let we=!Ue.isUnderDevelopment;function ke(){we||(Te.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),we=!0)}return function Oe(st){if(Array.isArray(st))st.forEach(Oe);else if(typeof st=="string")ke();else{const vt=st;typeof vt.scheme>"u"&&ke(),typeof vt.exclusive=="boolean"&&(0,ze.$_E)(Ue,"documentFiltersExclusive")}return st}}(),xi={getSession(we,ke,Oe){return ui.getSession(Ue,we,ke,Oe)},getSessions(we,ke){return(0,ze.$_E)(Ue,"authGetSessions"),ui.getSessions(Ue,we,ke)},async hasSession(we,ke){return(0,ze.$_E)(Ue,"authSession"),!!await ui.getSession(Ue,we,ke,{silent:!0})},get onDidChangeSessions(){return ui.onDidChangeSessions},registerAuthenticationProvider(we,ke,Oe,st){return ui.registerAuthenticationProvider(we,ke,Oe,st)}},_i={registerCommand(we,ke,Oe){return gt.registerCommand(!0,we,ke,Oe,void 0,Ue)},registerTextEditorCommand(we,ke,Oe){return gt.registerCommand(!0,we,(...st)=>{const vt=Mt.getActiveTextEditor();if(!vt){Te.warn("Cannot execute "+we+" because there is no active text editor.");return}return vt.edit(Lt=>{ke.apply(Oe,[vt,Lt,...st])}).then(Lt=>{Lt||Te.warn("Edits from command "+we+" were not applied.")},Lt=>{Te.warn("An error occurred while running command "+we,Lt)})},void 0,void 0,Ue)},registerDiffInformationCommand:(we,ke,Oe)=>((0,ze.$_E)(Ue,"diffCommand"),gt.registerCommand(!0,we,async(...st)=>{const vt=mt.activeEditor(!0);if(!vt){Te.warn("Cannot execute "+we+" because there is no active text editor.");return}const Lt=await Mt.getDiffInformation(vt.id);ke.apply(Oe,[Lt,...st])},void 0,void 0,Ue)),executeCommand(we,...ke){return gt.executeCommand(we,...ke)},getCommands(we=!1){return gt.getCommands(we)}},en={get machineId(){return lt.telemetryInfo.machineId},get sessionId(){return lt.telemetryInfo.sessionId},get language(){return lt.environment.appLanguage},get appName(){return lt.environment.appName},get appRoot(){return lt.environment.appRoot?.fsPath??""},get appHost(){return lt.environment.appHost},get uriScheme(){return lt.environment.appUriScheme},get clipboard(){return Qt.value},get shell(){return bt.getDefaultShell(!1)},get onDidChangeShell(){return bt.onDidChangeShell},get isTelemetryEnabled(){return Dt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Dt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,ze.$_E)(Ue,"telemetry"),Dt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,ze.$_E)(Ue,"telemetry"),Dt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,et.$tM)(lt.telemetryInfo.firstSessionDate)},createTelemetryLogger(we,ke){return et.$sM.validateSender(we),Dt.instantiateLogger(Ue,we,ke)},openExternal(we,ke){return Fe.openUri(we,{allowTunneling:!!lt.remote.authority,allowContributedOpeners:ke?.allowContributedOpeners})},async asExternalUri(we){if(we.scheme===lt.environment.appUriScheme)return mi.createAppUri(we);try{return await Fe.asExternalUri(we,{allowTunneling:!!lt.remote.authority})}catch(ke){if((0,Ze.$9T)(we,Me.Schemas.http)||(0,Ze.$9T)(we,Me.Schemas.https))return we;throw ke}},get remoteName(){return(0,J.$Sk)(lt.remote.authority)},get remoteAuthority(){return(0,ze.$_E)(Ue,"resolvers"),lt.remote.authority},get uiKind(){return lt.uiKind},get logLevel(){return Te.getLevel()},get onDidChangeLogLevel(){return Te.onDidChangeLogLevel},registerIssueUriRequestHandler(we){return(0,ze.$_E)(Ue,"handleIssueUri"),Xi.registerIssueUriRequestHandler(Ue,we)},get appQuality(){return(0,ze.$_E)(Ue,"resolvers"),lt.quality},get appCommit(){return(0,ze.$_E)(Ue,"resolvers"),lt.commit}};lt.environment.extensionTestsLocationURI||Object.freeze(en);const dn={createTestController(we,ke,Oe){return ri.createTestController(Ue,we,ke,Oe)},createTestObserver(){return(0,ze.$_E)(Ue,"testObserver"),ri.createTestObserver()},runTests(we){return(0,ze.$_E)(Ue,"testObserver"),ri.runTests(we)},get onDidChangeTestResults(){return(0,ze.$_E)(Ue,"testObserver"),ri.onResultsChanged},get testResults(){return(0,ze.$_E)(Ue,"testObserver"),ri.results}},hi=lt.remote.isRemote?K.ExtensionKind.Workspace:K.ExtensionKind.UI,tn={getExtension(we,ke){(0,ze.$$E)(Ue,"extensionsAny")||(ke=!1);const Oe=_t.mine.getExtensionDescription(we);if(Oe)return new i.$wcc(kt,Ue.identifier,Oe,hi,!1);if(ke){const st=_t.all.getExtensionDescription(we);if(st)return new i.$wcc(kt,Ue.identifier,st,hi,!0)}},get all(){const we=[];for(const ke of _t.mine.getAllExtensionDescriptions())we.push(new i.$wcc(kt,Ue.identifier,ke,hi,!1));return we},get allAcrossExtensionHosts(){(0,ze.$_E)(Ue,"extensionsAny");const we=new be.$3l(_t.mine.getAllExtensionDescriptions().map(Oe=>Oe.identifier)),ke=[];for(const Oe of _t.all.getAllExtensionDescriptions()){const st=!we.has(Oe.identifier);ke.push(new i.$wcc(kt,Ue.identifier,Oe,hi,st))}return ke},get onDidChange(){return(0,ze.$$E)(Ue,"extensionsAny")?d.Event.any(_t.mine.onDidChange,_t.all.onDidChange):_t.mine.onDidChange}},nn={createDiagnosticCollection(we){return ai.createDiagnosticCollection(Ue.identifier,we)},get onDidChangeDiagnostics(){return ai.onDidChangeDiagnostics},getDiagnostics:we=>ai.getDiagnostics(we),getLanguages(){return ci.getLanguages()},setTextDocumentLanguage(we,ke){return ci.changeLanguage(we.uri,ke)},match(we,ke){const Oe=Ct.getDocumentData(ke.uri)?.notebook;return(0,R.$mE)(H.LanguageSelector.from(we),ke.uri,ke.languageId,!0,Oe?.uri,Oe?.notebookType)},registerCodeActionsProvider(we,ke,Oe){return ut.registerCodeActionProvider(Ue,$t(we),ke,Oe)},registerDocumentPasteEditProvider(we,ke,Oe){return(0,ze.$_E)(Ue,"documentPaste"),ut.registerDocumentPasteEditProvider(Ue,$t(we),ke,Oe)},registerCodeLensProvider(we,ke){return ut.registerCodeLensProvider(Ue,$t(we),ke)},registerDefinitionProvider(we,ke){return ut.registerDefinitionProvider(Ue,$t(we),ke)},registerDeclarationProvider(we,ke){return ut.registerDeclarationProvider(Ue,$t(we),ke)},registerImplementationProvider(we,ke){return ut.registerImplementationProvider(Ue,$t(we),ke)},registerTypeDefinitionProvider(we,ke){return ut.registerTypeDefinitionProvider(Ue,$t(we),ke)},registerHoverProvider(we,ke){return ut.registerHoverProvider(Ue,$t(we),ke,Ue.identifier)},registerEvaluatableExpressionProvider(we,ke){return ut.registerEvaluatableExpressionProvider(Ue,$t(we),ke,Ue.identifier)},registerInlineValuesProvider(we,ke){return ut.registerInlineValuesProvider(Ue,$t(we),ke,Ue.identifier)},registerDocumentHighlightProvider(we,ke){return ut.registerDocumentHighlightProvider(Ue,$t(we),ke)},registerLinkedEditingRangeProvider(we,ke){return ut.registerLinkedEditingRangeProvider(Ue,$t(we),ke)},registerReferenceProvider(we,ke){return ut.registerReferenceProvider(Ue,$t(we),ke)},registerRenameProvider(we,ke){return ut.registerRenameProvider(Ue,$t(we),ke)},registerDocumentSymbolProvider(we,ke,Oe){return ut.registerDocumentSymbolProvider(Ue,$t(we),ke,Oe)},registerWorkspaceSymbolProvider(we){return ut.registerWorkspaceSymbolProvider(Ue,we)},registerDocumentFormattingEditProvider(we,ke){return ut.registerDocumentFormattingEditProvider(Ue,$t(we),ke)},registerDocumentRangeFormattingEditProvider(we,ke){return ut.registerDocumentRangeFormattingEditProvider(Ue,$t(we),ke)},registerOnTypeFormattingEditProvider(we,ke,Oe,...st){return ut.registerOnTypeFormattingEditProvider(Ue,$t(we),ke,[Oe].concat(st))},registerDocumentSemanticTokensProvider(we,ke,Oe){return ut.registerDocumentSemanticTokensProvider(Ue,$t(we),ke,Oe)},registerDocumentRangeSemanticTokensProvider(we,ke,Oe){return ut.registerDocumentRangeSemanticTokensProvider(Ue,$t(we),ke,Oe)},registerSignatureHelpProvider(we,ke,Oe,...st){return typeof Oe=="object"?ut.registerSignatureHelpProvider(Ue,$t(we),ke,Oe):ut.registerSignatureHelpProvider(Ue,$t(we),ke,typeof Oe>"u"?[]:[Oe,...st])},registerCompletionItemProvider(we,ke,...Oe){return ut.registerCompletionItemProvider(Ue,$t(we),ke,Oe)},registerInlineCompletionItemProvider(we,ke,Oe){return ke.handleDidShowCompletionItem&&(0,ze.$_E)(Ue,"inlineCompletionsAdditions"),ke.handleDidPartiallyAcceptCompletionItem&&(0,ze.$_E)(Ue,"inlineCompletionsAdditions"),Oe&&(0,ze.$_E)(Ue,"inlineCompletionsAdditions"),ut.registerInlineCompletionsProvider(Ue,$t(we),ke,Oe)},registerDocumentLinkProvider(we,ke){return ut.registerDocumentLinkProvider(Ue,$t(we),ke)},registerColorProvider(we,ke){return ut.registerColorProvider(Ue,$t(we),ke)},registerFoldingRangeProvider(we,ke){return ut.registerFoldingRangeProvider(Ue,$t(we),ke)},registerSelectionRangeProvider(we,ke){return ut.registerSelectionRangeProvider(Ue,we,ke)},registerCallHierarchyProvider(we,ke){return ut.registerCallHierarchyProvider(Ue,we,ke)},registerTypeHierarchyProvider(we,ke){return ut.registerTypeHierarchyProvider(Ue,we,ke)},setLanguageConfiguration:(we,ke)=>ut.setLanguageConfiguration(Ue,we,ke),getTokenInformationAtPosition(we,ke){return(0,ze.$_E)(Ue,"tokenInformation"),ci.tokenAtPosition(we,ke)},registerInlayHintsProvider(we,ke){return ut.registerInlayHintsProvider(Ue,we,ke)},createLanguageStatusItem(we,ke){return ci.createLanguageStatusItem(Ue,we,ke)},registerDocumentDropEditProvider(we,ke,Oe){return ut.registerDocumentOnDropEditProvider(Ue,we,ke,(0,ze.$$E)(Ue,"dropMetadata")?Oe:void 0)}},rn={get activeTextEditor(){return Mt.getActiveTextEditor()},get visibleTextEditors(){return Mt.getVisibleTextEditors()},get activeTerminal(){return bt.activeTerminal},get terminals(){return bt.terminals},async showTextDocument(we,ke,Oe){const st=await(A.URI.isUri(we)?Promise.resolve(sn.openTextDocument(we)):Promise.resolve(we));return Mt.showTextDocument(st,ke,Oe)},createTextEditorDecorationType(we){return Mt.createTextEditorDecorationType(Ue,we)},onDidChangeActiveTextEditor(we,ke,Oe){return Mt.onDidChangeActiveTextEditor(we,ke,Oe)},onDidChangeVisibleTextEditors(we,ke,Oe){return Mt.onDidChangeVisibleTextEditors(we,ke,Oe)},onDidChangeTextEditorSelection(we,ke,Oe){return Mt.onDidChangeTextEditorSelection(we,ke,Oe)},onDidChangeTextEditorOptions(we,ke,Oe){return Mt.onDidChangeTextEditorOptions(we,ke,Oe)},onDidChangeTextEditorVisibleRanges(we,ke,Oe){return Mt.onDidChangeTextEditorVisibleRanges(we,ke,Oe)},onDidChangeTextEditorViewColumn(we,ke,Oe){return Mt.onDidChangeTextEditorViewColumn(we,ke,Oe)},onDidCloseTerminal(we,ke,Oe){return bt.onDidCloseTerminal(we,ke,Oe)},onDidOpenTerminal(we,ke,Oe){return bt.onDidOpenTerminal(we,ke,Oe)},onDidChangeActiveTerminal(we,ke,Oe){return bt.onDidChangeActiveTerminal(we,ke,Oe)},onDidChangeTerminalDimensions(we,ke,Oe){return(0,ze.$_E)(Ue,"terminalDimensions"),bt.onDidChangeTerminalDimensions(we,ke,Oe)},onDidChangeTerminalState(we,ke,Oe){return bt.onDidChangeTerminalState(we,ke,Oe)},onDidWriteTerminalData(we,ke,Oe){return(0,ze.$_E)(Ue,"terminalDataWriteEvent"),bt.onDidWriteTerminalData(we,ke,Oe)},onDidExecuteTerminalCommand(we,ke,Oe){return(0,ze.$_E)(Ue,"terminalExecuteCommandEvent"),bt.onDidExecuteTerminalCommand(we,ke,Oe)},get state(){return Fe.getState(Ue)},onDidChangeWindowState(we,ke,Oe){return Fe.onDidChangeWindowState(we,ke,Oe)},showInformationMessage(we,...ke){return li.showMessage(Ue,M.default.Info,we,ke[0],ke.slice(1))},showWarningMessage(we,...ke){return li.showMessage(Ue,M.default.Warning,we,ke[0],ke.slice(1))},showErrorMessage(we,...ke){return li.showMessage(Ue,M.default.Error,we,ke[0],ke.slice(1))},showQuickPick(we,ke,Oe){return ni.showQuickPick(Ue,we,ke,Oe)},showWorkspaceFolderPick(we){return ni.showWorkspaceFolderPick(we)},showInputBox(we,ke){return ni.showInput(we,ke)},showOpenDialog(we){return Ti.showOpenDialog(Ue,we)},showSaveDialog(we){return Ti.showSaveDialog(we)},createStatusBarItem(we,ke,Oe){let st,vt,Lt;return typeof we=="string"?(st=we,vt=ke,Lt=Oe):(vt=we,Lt=ke),xt.createStatusBarEntry(Ue,st,vt,Lt)},setStatusBarMessage(we,ke){return xt.setStatusBarMessage(we,ke)},withScmProgress(we){return ne.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),pi.withProgress(Ue,{location:K.ProgressLocation.SourceControl},(ke,Oe)=>we({report(st){}}))},withProgress(we,ke){return pi.withProgress(Ue,we,ke)},createOutputChannel(we,ke){return Ei.createOutputChannel(we,ke,Ue)},createWebviewPanel(we,ke,Oe,st){return Ri.createWebviewPanel(Ue,we,ke,Oe,st)},createWebviewTextEditorInset(we,ke,Oe,st){return(0,ze.$_E)(Ue,"editorInsets"),Ci.createWebviewEditorInset(we,ke,Oe,st,Ue)},createTerminal(we,ke,Oe){return typeof we=="object"?"pty"in we?bt.createExtensionTerminal(we):bt.createTerminalFromOptions(we):bt.createTerminal(we,ke,Oe)},registerTerminalLinkProvider(we){return bt.registerLinkProvider(we)},registerTerminalProfileProvider(we,ke){return bt.registerProfileProvider(Ue,we,ke)},registerTerminalQuickFixProvider(we,ke){return(0,ze.$_E)(Ue,"terminalQuickFixProvider"),bt.registerTerminalQuickFixProvider(we,Ue.identifier.value,ke)},registerTreeDataProvider(we,ke){return bi.registerTreeDataProvider(we,ke,Ue)},createTreeView(we,ke){return bi.createTreeView(we,ke,Ue)},registerWebviewPanelSerializer:(we,ke)=>Ri.registerWebviewPanelSerializer(Ue,we,ke),registerCustomEditorProvider:(we,ke,Oe={})=>cn.registerCustomEditorProvider(Ue,we,ke,Oe),registerFileDecorationProvider(we){return nt.registerFileDecorationProvider(we,Ue)},registerUriHandler(we){return mi.registerUriHandler(Ue,we)},createQuickPick(){return ni.createQuickPick(Ue)},createInputBox(){return ni.createInputBox(Ue)},get activeColorTheme(){return Ai.activeColorTheme},onDidChangeActiveColorTheme(we,ke,Oe){return Ai.onDidChangeActiveColorTheme(we,ke,Oe)},registerWebviewViewProvider(we,ke,Oe){return Mi.registerWebviewViewProvider(Ue,we,ke,Oe?.webviewOptions)},get activeNotebookEditor(){return St.activeNotebookEditor},onDidChangeActiveNotebookEditor(we,ke,Oe){return St.onDidChangeActiveNotebookEditor(we,ke,Oe)},get visibleNotebookEditors(){return St.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return St.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(we,ke,Oe){return $i.onDidChangeNotebookEditorSelection(we,ke,Oe)},onDidChangeNotebookEditorVisibleRanges(we,ke,Oe){return $i.onDidChangeNotebookEditorVisibleRanges(we,ke,Oe)},showNotebookDocument(we,ke){return St.showNotebookDocument(we,ke)},registerExternalUriOpener(we,ke,Oe){return(0,ze.$_E)(Ue,"externalUriOpener"),un.registerExternalUriOpener(Ue.identifier,we,ke,Oe)},registerProfileContentHandler(we,ke){return(0,ze.$_E)(Ue,"profileContentHandlers"),ln.registrProfileContentHandler(Ue,we,ke)},registerQuickDiffProvider(we,ke,Oe,st){return(0,ze.$_E)(Ue,"quickDiffProvider"),Ii.registerQuickDiffProvider($t(we),ke,Oe,st)},get tabGroups(){return xe.tabGroups},registerShareProvider(we,ke){return(0,ze.$_E)(Ue,"shareProvider"),Ki.registerShareProvider($t(we),ke)}},sn={get rootPath(){return ne.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(we){throw new T.$8("rootPath")},getWorkspaceFolder(we){return ft.getWorkspaceFolder(we)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(we){throw new T.$8("name")},get workspaceFile(){return ft.workspaceFile},set workspaceFile(we){throw new T.$8("workspaceFile")},updateWorkspaceFolders:(we,ke,...Oe)=>ft.updateWorkspaceFolders(Ue,we,ke||0,...Oe),onDidChangeWorkspaceFolders:function(we,ke,Oe){return ft.onDidChangeWorkspace(we,ke,Oe)},asRelativePath:(we,ke)=>ft.getRelativePath(we,ke),findFiles:(we,ke,Oe,st)=>ft.findFiles(we,ke,Oe,Ue.identifier,st),findTextInFiles:(we,ke,Oe,st)=>{(0,ze.$_E)(Ue,"findTextInFiles");let vt,Lt;return typeof ke=="object"?(vt=ke,Lt=Oe):(vt={},Lt=ke,st=Oe),ft.findTextInFiles(we,vt||{},Lt,Ue.identifier,st)},save:we=>((0,ze.$_E)(Ue,"saveEditor"),ft.save(we)),saveAs:we=>((0,ze.$_E)(Ue,"saveEditor"),ft.saveAs(we)),saveAll:we=>ft.saveAll(we),applyEdit(we,ke){return hn.applyWorkspaceEdit(we,Ue,ke)},createFileSystemWatcher:(we,ke,Oe,st)=>Xt.createFileSystemWatcher(ft,Ue,we,ke,Oe,st),get textDocuments(){return Ct.getAllDocumentData().map(we=>we.document)},set textDocuments(we){throw new T.$8("textDocuments")},openTextDocument(we){let ke;const Oe=we;if(typeof we=="string")ke=Promise.resolve(A.URI.file(we));else if(A.URI.isUri(we))ke=Promise.resolve(we);else if(!Oe||typeof Oe=="object")ke=Ct.createDocumentData(Oe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ke.then(st=>Ct.ensureDocumentData(st).then(vt=>vt.document))},onDidOpenTextDocument:(we,ke,Oe)=>Ct.onDidAddDocument(we,ke,Oe),onDidCloseTextDocument:(we,ke,Oe)=>Ct.onDidRemoveDocument(we,ke,Oe),onDidChangeTextDocument:(we,ke,Oe)=>Ct.onDidChangeDocument(we,ke,Oe),onDidSaveTextDocument:(we,ke,Oe)=>Ct.onDidSaveDocument(we,ke,Oe),onWillSaveTextDocument:(we,ke,Oe)=>qi.getOnWillSaveTextDocumentEvent(Ue)(we,ke,Oe),get notebookDocuments(){return St.notebookDocuments.map(we=>we.apiNotebook)},async openNotebookDocument(we,ke){let Oe;if(A.URI.isUri(we))Oe=we,await St.openNotebookDocument(we);else if(typeof we=="string")Oe=A.URI.revive(await St.createNotebookDocument({viewType:we,content:ke}));else throw new Error("Invalid arguments");return St.getNotebookDocument(Oe).apiNotebook},onDidSaveNotebookDocument(we,ke,Oe){return ii.onDidSaveNotebookDocument(we,ke,Oe)},onDidChangeNotebookDocument(we,ke,Oe){return ii.onDidChangeNotebookDocument(we,ke,Oe)},onWillSaveNotebookDocument(we,ke,Oe){return Di.getOnWillSaveNotebookDocumentEvent(Ue)(we,ke,Oe)},get onDidOpenNotebookDocument(){return St.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return St.onDidCloseNotebookDocument},registerNotebookSerializer(we,ke,Oe,st){return St.registerNotebookSerializer(Ue,we,ke,Oe,(0,ze.$$E)(Ue,"notebookLiveShare")?st:void 0)},onDidChangeConfiguration:(we,ke,Oe)=>Fi.onDidChangeConfiguration(we,ke,Oe),getConfiguration(we,ke){return ke=arguments.length===1?void 0:ke,Fi.getConfiguration(we,ke,Ue)},registerTextDocumentContentProvider(we,ke){return ki.registerTextDocumentContentProvider(we,ke)},registerTaskProvider:(we,ke)=>(ne.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),Gt.registerTaskProvider(Ue,we,ke)),registerFileSystemProvider(we,ke,Oe){return(0,Ve.$Oc)(Vi.registerFileSystemProvider(Ue,we,ke,Oe),It.addFileSystemProvider(we,ke,Oe))},get fs(){return It.value},registerFileSearchProvider:(we,ke)=>((0,ze.$_E)(Ue,"fileSearchProvider"),Rt.registerFileSearchProvider(we,ke)),registerTextSearchProvider:(we,ke)=>((0,ze.$_E)(Ue,"textSearchProvider"),Rt.registerTextSearchProvider(we,ke)),registerRemoteAuthorityResolver:(we,ke)=>((0,ze.$_E)(Ue,"resolvers"),kt.registerRemoteAuthorityResolver(we,ke)),registerResourceLabelFormatter:we=>((0,ze.$_E)(Ue,"resolvers"),Hi.$registerResourceLabelFormatter(we)),getRemoteExecServer:we=>((0,ze.$_E)(Ue,"resolvers"),kt.getRemoteExecServer(we)),onDidCreateFiles:(we,ke,Oe)=>Xt.onDidCreateFile(we,ke,Oe),onDidDeleteFiles:(we,ke,Oe)=>Xt.onDidDeleteFile(we,ke,Oe),onDidRenameFiles:(we,ke,Oe)=>Xt.onDidRenameFile(we,ke,Oe),onWillCreateFiles:(we,ke,Oe)=>Xt.getOnWillCreateFileEvent(Ue)(we,ke,Oe),onWillDeleteFiles:(we,ke,Oe)=>Xt.getOnWillDeleteFileEvent(Ue)(we,ke,Oe),onWillRenameFiles:(we,ke,Oe)=>Xt.getOnWillRenameFileEvent(Ue)(we,ke,Oe),openTunnel:we=>((0,ze.$_E)(Ue,"tunnels"),Se.openTunnel(Ue,we).then(ke=>{if(!ke)throw new Error("cannot open tunnel");return ke})),get tunnels(){return(0,ze.$_E)(Ue,"tunnels"),Se.getTunnels()},onDidChangeTunnels:(we,ke,Oe)=>((0,ze.$_E)(Ue,"tunnels"),Se.onDidChangeTunnels(we,ke,Oe)),registerPortAttributesProvider:(we,ke)=>((0,ze.$_E)(Ue,"portsAttributes"),Se.registerPortsAttributesProvider(we,ke)),registerTunnelProvider:(we,ke)=>((0,ze.$_E)(Ue,"tunnelFactory"),Se.registerTunnelProvider(we,ke)),registerTimelineProvider:(we,ke)=>((0,ze.$_E)(Ue,"timeline"),Gi.registerTimelineProvider(we,ke,Ue.identifier,gt.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:we=>((0,ze.$_E)(Ue,"workspaceTrust"),ft.requestWorkspaceTrust(we)),onDidGrantWorkspaceTrust:(we,ke,Oe)=>ft.onDidGrantWorkspaceTrust(we,ke,Oe),registerEditSessionIdentityProvider:(we,ke)=>((0,ze.$_E)(Ue,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(we,ke)),onWillCreateEditSessionIdentity:(we,ke,Oe)=>((0,ze.$_E)(Ue,"editSessionIdentityProvider"),ft.getOnWillCreateEditSessionIdentityEvent(Ue)(we,ke,Oe)),registerCanonicalUriProvider:(we,ke)=>((0,ze.$_E)(Ue,"canonicalUriProvider"),ft.registerCanonicalUriProvider(we,ke)),getCanonicalUri:(we,ke,Oe)=>((0,ze.$_E)(Ue,"canonicalUriProvider"),ft.provideCanonicalUri(we,ke,Oe))},fn={get inputBox(){return ne.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),wi.getLastInputBox(Ue)},createSourceControl(we,ke,Oe){return wi.createSourceControl(Ue,we,ke,Oe)}},on={createCommentController(we,ke){return Pi.createCommentController(Ue,we,ke)}},an={get activeDebugSession(){return dt.activeDebugSession},get activeDebugConsole(){return dt.activeDebugConsole},get breakpoints(){return dt.breakpoints},get stackFrameFocus(){return dt.stackFrameFocus},onDidStartDebugSession(we,ke,Oe){return dt.onDidStartDebugSession(we,ke,Oe)},onDidTerminateDebugSession(we,ke,Oe){return dt.onDidTerminateDebugSession(we,ke,Oe)},onDidChangeActiveDebugSession(we,ke,Oe){return dt.onDidChangeActiveDebugSession(we,ke,Oe)},onDidReceiveDebugSessionCustomEvent(we,ke,Oe){return dt.onDidReceiveDebugSessionCustomEvent(we,ke,Oe)},onDidChangeBreakpoints(we,ke,Oe){return dt.onDidChangeBreakpoints(we,ke,Oe)},onDidChangeStackFrameFocus(we,ke,Oe){return(0,ze.$_E)(Ue,"debugFocus"),dt.onDidChangeStackFrameFocus(we,ke,Oe)},registerDebugConfigurationProvider(we,ke,Oe){return dt.registerDebugConfigurationProvider(we,ke,Oe||Xe.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(we,ke){return dt.registerDebugAdapterDescriptorFactory(Ue,we,ke)},registerDebugAdapterTrackerFactory(we,ke){return dt.registerDebugAdapterTrackerFactory(we,ke)},startDebugging(we,ke,Oe){return!Oe||typeof Oe=="object"&&"configuration"in Oe?dt.startDebugging(we,ke,{parentSession:Oe}):dt.startDebugging(we,ke,Oe||{})},stopDebugging(we){return dt.stopDebugging(we)},addBreakpoints(we){return dt.addBreakpoints(we)},removeBreakpoints(we){return dt.removeBreakpoints(we)},asDebugSourceUri(we,ke){return dt.asDebugSourceUri(we,ke)}},Ni={registerTaskProvider:(we,ke)=>Gt.registerTaskProvider(Ue,we,ke),fetchTasks:we=>Gt.fetchTasks(we),executeTask:we=>Gt.executeTask(Ue,we),get taskExecutions(){return Gt.taskExecutions},onDidStartTask:(we,ke,Oe)=>Gt.onDidStartTask(we,ke,Oe),onDidEndTask:(we,ke,Oe)=>Gt.onDidEndTask(we,ke,Oe),onDidStartTaskProcess:(we,ke,Oe)=>Gt.onDidStartTaskProcess(we,ke,Oe),onDidEndTaskProcess:(we,ke,Oe)=>Gt.onDidEndTaskProcess(we,ke,Oe)},Oi={createNotebookController(we,ke,Oe,st,vt){return oi.createNotebookController(Ue,we,ke,Oe,st,(0,ze.$$E)(Ue,"notebookMessaging")?vt:void 0)},registerNotebookCellStatusBarItemProvider:(we,ke)=>St.registerNotebookCellStatusBarItemProvider(Ue,we,ke),createRendererMessaging(we){return Si.createRendererMessaging(Ue,we)},createNotebookControllerDetectionTask(we){return(0,ze.$_E)(Ue,"notebookKernelSource"),oi.createNotebookControllerDetectionTask(Ue,we)},registerKernelSourceActionProvider(we,ke){return(0,ze.$_E)(Ue,"notebookKernelSource"),oi.registerKernelSourceActionProvider(Ue,we,ke)},onDidChangeNotebookCellExecutionState(we,ke,Oe){return(0,ze.$_E)(Ue,"notebookCellExecutionState"),oi.onDidChangeNotebookCellExecutionState(we,ke,Oe)}},ji={t(...we){if(typeof we[0]=="string"){const ke=we.shift(),Oe=!we||typeof we[0]!="object"?we:we[0];return Vt.getMessage(Ue.identifier.value,{message:ke,args:Oe})}return Vt.getMessage(Ue.identifier.value,we[0])},get bundle(){return Vt.getBundle(Ue.identifier.value)},get uri(){return Vt.getBundleUri(Ue.identifier.value)}},di={_version:1,registerInteractiveEditorSessionProvider(we,ke){return(0,ze.$_E)(Ue,"interactive"),Ji.registerProvider(Ue,we,ke={label:ke?.label??Ue.displayName??Ue.name})},registerInteractiveSessionProvider(we,ke){return(0,ze.$_E)(Ue,"interactive"),gi.registerChatProvider(Ue,we,ke)},sendInteractiveRequestToProvider(we,ke){return(0,ze.$_E)(Ue,"interactive"),gi.sendInteractiveRequestToProvider(we,ke)},get onDidPerformUserAction(){return(0,ze.$_E)(Ue,"interactiveUserActions"),gi.onDidPerformUserAction},transferChatSession(we,ke){return(0,ze.$_E)(Ue,"interactive"),gi.transferChatSession(we,ke)}},zi={getRelatedInformation(we,ke){return(0,ze.$_E)(Ue,"aiRelatedInformation"),Yi.getRelatedInformation(Ue,we,ke)},registerRelatedInformationProvider(we,ke){return(0,ze.$_E)(Ue,"aiRelatedInformation"),Yi.registerRelatedInformationProvider(Ue,we,ke)},registerEmbeddingVectorProvider(we,ke){return(0,ze.$_E)(Ue,"aiRelatedInformation"),Li.registerEmbeddingVectorProvider(Ue,we,ke)}},Ui={registerChatResponseProvider(we,ke,Oe){return(0,ze.$_E)(Ue,"chatProvider"),fi.registerProvider(Ue.identifier,we,ke,Oe)},requestChatAccess(we){return(0,ze.$_E)(Ue,"chatRequestAccess"),fi.requestChatResponseProvider(Ue.identifier,we)},registerVariable(we,ke,Oe){return(0,ze.$_E)(Ue,"chatVariables"),Zi.registerVariableResolver(Ue,we,ke,Oe)},registerMappedEditsProvider(we,ke){return(0,ze.$_E)(Ue,"mappedEditsProvider"),ut.registerMappedEditsProvider(Ue,we,ke)},registerAgent(we,ke,Oe){return(0,ze.$_E)(Ue,"chatAgents"),Qi.registerAgent(Ue.identifier,we,ke,Oe)}};return{version:lt.version,ai:zi,authentication:xi,commands:_i,comments:on,chat:Ui,debug:an,env:en,extensions:tn,interactive:di,l10n:ji,languages:nn,notebooks:Oi,scm:fn,tasks:Ni,tests:dn,window:rn,workspace:sn,Breakpoint:K.$_K,TerminalOutputAnchor:K.TerminalOutputAnchor,ChatMessage:K.$2L,ChatMessageRole:K.ChatMessageRole,ChatVariableLevel:K.ChatVariableLevel,CallHierarchyIncomingCall:K.$yK,CallHierarchyItem:K.$xK,CallHierarchyOutgoingCall:K.$zK,CancellationError:T.$4,CancellationTokenSource:C.$Wd,CandidatePortSource:p.CandidatePortSource,CodeAction:K.$uK,CodeActionKind:K.$vK,CodeActionTriggerKind:K.CodeActionTriggerKind,CodeLens:K.$AK,Color:K.$NK,ColorInformation:K.$OK,ColorPresentation:K.$PK,ColorThemeKind:K.ColorThemeKind,CommentMode:K.CommentMode,CommentState:K.CommentState,CommentThreadCollapsibleState:K.CommentThreadCollapsibleState,CommentThreadState:K.CommentThreadState,CompletionItem:K.$HK,CompletionItemKind:K.CompletionItemKind,CompletionItemTag:K.CompletionItemTag,CompletionList:K.$IK,CompletionTriggerKind:K.CompletionTriggerKind,ConfigurationTarget:K.ConfigurationTarget,CustomExecution:K.$XK,DebugAdapterExecutable:K.$dL,DebugAdapterInlineImplementation:K.$gL,DebugAdapterNamedPipeServer:K.$fL,DebugAdapterServer:K.$eL,DebugConfigurationProviderTriggerKind:Xe.DebugConfigurationProviderTriggerKind,DebugConsoleMode:K.DebugConsoleMode,DecorationRangeBehavior:K.DecorationRangeBehavior,Diagnostic:K.$pK,DiagnosticRelatedInformation:K.$oK,DiagnosticSeverity:K.DiagnosticSeverity,DiagnosticTag:K.DiagnosticTag,Disposable:K.$bK,DocumentHighlight:K.$rK,DocumentHighlightKind:K.DocumentHighlightKind,DocumentLink:K.$MK,DocumentSymbol:K.$tK,EndOfLine:K.EndOfLine,EnvironmentVariableMutatorType:K.EnvironmentVariableMutatorType,EvaluatableExpression:K.$jL,InlineValueText:K.$kL,InlineValueVariableLookup:K.$lL,InlineValueEvaluatableExpression:K.$mL,InlineCompletionTriggerKind:K.InlineCompletionTriggerKind,EventEmitter:d.$Md,ExtensionKind:K.ExtensionKind,ExtensionMode:K.ExtensionMode,ExternalUriOpenerPriority:K.ExternalUriOpenerPriority,FileChangeType:K.FileChangeType,FileDecoration:K.$wL,FileDecoration2:K.$wL,FileSystemError:K.$oL,FileType:I.FileType,FilePermission:I.FilePermission,FoldingRange:K.$pL,FoldingRangeKind:K.FoldingRangeKind,FunctionBreakpoint:K.$bL,InlineCompletionItem:K.$JK,InlineCompletionList:K.$KK,Hover:K.$qK,IndentAction:w.IndentAction,Location:K.$nK,MarkdownString:K.$BK,OverviewRulerLane:E.OverviewRulerLane,ParameterInformation:K.$CK,PortAutoForwardAction:K.PortAutoForwardAction,Position:K.$cK,ProcessExecution:K.$VK,ProgressLocation:K.ProgressLocation,QuickInputButtons:K.$vL,Range:K.$dK,RelativePattern:K.$0K,Selection:K.$eK,SelectionRange:K.$wK,SemanticTokens:K.$sL,SemanticTokensBuilder:K.$rL,SemanticTokensEdit:K.$tL,SemanticTokensEdits:K.$uL,SemanticTokensLegend:K.$qL,ShellExecution:K.$WK,ShellQuoting:K.ShellQuoting,SignatureHelp:K.$EK,SignatureHelpTriggerKind:K.SignatureHelpTriggerKind,SignatureInformation:K.$DK,SnippetString:K.$mK,SourceBreakpoint:K.$aL,StandardTokenType:K.StandardTokenType,StatusBarAlignment:K.StatusBarAlignment,SymbolInformation:K.$sK,SymbolKind:K.SymbolKind,SymbolTag:K.SymbolTag,Task:K.$YK,TaskGroup:K.$UK,TaskPanelKind:K.TaskPanelKind,TaskRevealKind:K.TaskRevealKind,TaskScope:K.TaskScope,TerminalLink:K.$QK,TerminalQuickFixExecuteTerminalCommand:K.$SK,TerminalQuickFixOpener:K.$RK,TerminalLocation:K.TerminalLocation,TerminalProfile:K.$TK,TerminalExitReason:K.TerminalExitReason,TextDocumentSaveReason:K.TextDocumentSaveReason,TextEdit:K.$iK,SnippetTextEdit:K.$kK,TextEditorCursorStyle:b.TextEditorCursorStyle,TextEditorLineNumbersStyle:K.TextEditorLineNumbersStyle,TextEditorRevealType:K.TextEditorRevealType,TextEditorSelectionChangeKind:K.TextEditorSelectionChangeKind,SyntaxTokenType:K.SyntaxTokenType,TextDocumentChangeReason:K.TextDocumentChangeReason,ThemeColor:K.$9K,ThemeIcon:K.$8K,TreeItem:K.$ZK,TreeItemCheckboxState:K.TreeItemCheckboxState,TreeItemCollapsibleState:K.TreeItemCollapsibleState,TypeHierarchyItem:K.$RL,UIKind:y.UIKind,Uri:A.URI,ViewColumn:K.ViewColumn,WorkspaceEdit:K.$lK,DocumentDropEdit:K.$6K,DocumentPasteEdit:K.$7K,InlayHint:K.$GK,InlayHintLabelPart:K.$FK,InlayHintKind:K.InlayHintKind,RemoteAuthorityResolverError:K.$hK,ResolvedAuthority:K.$fK,ManagedResolvedAuthority:K.$gK,SourceControlInputBoxValidationType:K.SourceControlInputBoxValidationType,ExtensionRuntime:K.ExtensionRuntime,TimelineItem:K.$GL,NotebookRange:K.$yL,NotebookCellKind:K.NotebookCellKind,NotebookCellExecutionState:K.NotebookCellExecutionState,NotebookCellData:K.$zL,NotebookData:K.$AL,NotebookRendererScript:K.$EL,NotebookCellStatusBarAlignment:K.NotebookCellStatusBarAlignment,NotebookEditorRevealType:K.NotebookEditorRevealType,NotebookCellOutput:K.$CL,NotebookCellOutputItem:K.$BL,NotebookCellStatusBarItem:K.$DL,NotebookControllerAffinity:K.NotebookControllerAffinity,NotebookControllerAffinity2:K.NotebookControllerAffinity2,NotebookEdit:K.$jK,NotebookKernelSourceAction:K.$FL,PortAttributes:K.$IL,LinkedEditingRanges:K.$HL,TestResultState:K.TestResultState,TestRunRequest:K.$JL,TestMessage:K.$KL,TestMessage2:K.$KL,TestTag:K.$LL,TestRunProfileKind:K.TestRunProfileKind,TextSearchCompleteMessageType:Ne.TextSearchCompleteMessageType,DataTransfer:K.$5K,DataTransferItem:K.$1K,CoveredCount:K.$ML,FileCoverage:K.$NL,StatementCoverage:K.$OL,BranchCoverage:K.$PL,FunctionCoverage:K.$QL,WorkspaceTrustState:K.WorkspaceTrustState,LanguageStatusSeverity:K.LanguageStatusSeverity,QuickPickItemKind:K.QuickPickItemKind,InputBoxValidationSeverity:K.InputBoxValidationSeverity,TabInputText:K.$SL,TabInputTextDiff:K.$TL,TabInputTextMerge:K.$UL,TabInputCustom:K.$VL,TabInputNotebook:K.$XL,TabInputNotebookDiff:K.$YL,TabInputWebview:K.$WL,TabInputTerminal:K.$ZL,TabInputInteractiveWindow:K.$1L,TelemetryTrustedValue:fe.$fo,LogLevel:ie.LogLevel,EditSessionIdentityMatch:ot.EditSessionIdentityMatch,InteractiveSessionVoteDirection:K.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:K.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:K.InteractiveEditorResponseFeedbackKind,StackFrameFocus:K.$hL,ThreadFocus:K.$iL,RelatedInformationType:K.RelatedInformationType}}}e.$Pdc=qt}),define(De[355],Ce([1,0,103,152,39,149,40,33,69,44,93,94,95,115,72,89,151,71,55,114,88,70,150,13,56,112,113]),function(me,e,C,T,d,M,A,b,E,w,R,I,p,y,D,v,l,s,r,c,m,h,t,n,o,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,C.$sr)(i.$qcc,i.$pcc,1),(0,C.$sr)(n.$9i,t.$Qdc,1),(0,C.$sr)(v.$Pbc,v.$Qbc,1),(0,C.$sr)(b.$wM,b.$vM,0),(0,C.$sr)(A.$3bc,A.$1bc,0),(0,C.$sr)(s.$fcc,s.$ecc,0),(0,C.$sr)(I.$6cc,I.$0cc,0),(0,C.$sr)(M.$Xcc,M.$Wcc,0),(0,C.$sr)(E.$lM,E.$kM,0),(0,C.$sr)(a.$rcc,a.$scc,0),(0,C.$sr)(r.$Mbc,r.$Lbc,0),(0,C.$sr)(T.$Dcc,T.$Ccc,1),(0,C.$sr)(p.$ddc,p.$edc,0),(0,C.$sr)(y.$bcc,y.$acc,0),(0,C.$sr)(R.$1cc,R.$Zcc,0),(0,C.$sr)(w.$icc,w.$lcc,0),(0,C.$sr)(D.$Wvb,D.$Xvb,0),(0,C.$sr)(l.$Tcc,l.$Scc,0),(0,C.$sr)(d.$Zbc,d.$Ybc,0),(0,C.$sr)(c.$ncc,c.$mcc,0),(0,C.$sr)(m.$uM,m.$rM,0),(0,C.$sr)(h.$2cc,h.$3cc,0),(0,C.$sr)(o.$4cc,o.$5cc,0)}),define(De[116],Ce([1,0,19,13,36,92]),function(me,e,C,T,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9dc=e.$8dc=e.$7dc=void 0;function A(I){return I.startsWith("**")||I.startsWith("/")?I:`/${I}`}e.$7dc=A;function b(I,p,y,D){const v=(0,C.$1b)(y,E),l=new d.$II(p,v,D),s=l.preview.matches;return{ranges:(0,C.$1b)(v,w),uri:I,preview:{text:l.preview.text,matches:(0,C.$1b)(s,w)}}}e.$8dc=b;function E(I){return new d.$JI(I.start.line,I.start.character,I.end.line,I.end.character)}function w(I){return new M.$xI(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn)}let R=class{constructor(p,y){this.a=p,this.b=y}appendLine(p){this.b.debug(`${this.a}#search`,p)}};e.$9dc=R,e.$9dc=R=He([Be(1,T.$8i)],R)}),define(De[356],Ce([1,0,48,16,76,32,12,15,116,357]),function(me,e,C,T,d,M,A,b,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_dc=e.$$dc=e.$0dc=void 0;const R=w.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function I(c,m,h,t){const n=p(c,m,h,t),o=m.folder.fsPath;return{cmd:C.spawn(R,n.args,{cwd:o}),rgDiskPath:R,siblingClauses:n.siblingClauses,rgArgs:n,cwd:o}}e.$0dc=I;function p(c,m,h,t){const n=["--files","--hidden","--case-sensitive","--no-require-git"];D([m],h,!1).forEach(i=>{const a=(0,E.$7dc)(i);if(n.push("-g",a),A.$k){const u=(0,d.$ll)(a);u!==a&&n.push("-g",u)}});const o=y([m],t,void 0,!1);return o.globArgs.forEach(i=>{const a=`!${(0,E.$7dc)(i)}`;if(n.push("-g",a),A.$k){const u=(0,d.$ll)(a);u!==a&&n.push("-g",u)}}),m.disregardIgnoreFiles!==!1?n.push("--no-ignore"):m.disregardParentIgnoreFiles!==!1&&n.push("--no-ignore-parent"),m.ignoreSymlinks||n.push("--follow"),c.exists&&n.push("--quiet"),n.push("--no-config"),m.disregardGlobalIgnoreFiles&&n.push("--no-ignore-global"),{args:n,siblingClauses:o.siblingClauses}}function y(c,m,h,t=!0){const n=[];let o={};return c.forEach(i=>{const a=Object.assign({},i.excludePattern||{},m||{}),u=v(a,t?i.folder.fsPath:void 0,h);n.push(...u.globArgs),u.siblingClauses&&(o=Object.assign(o,u.siblingClauses))}),{globArgs:n,siblingClauses:o}}function D(c,m,h=!0){const t=[];return c.forEach(n=>{const o=Object.assign({},m||{},n.includePattern||{}),i=v(o,h?n.folder.fsPath:void 0);t.push(...i.globArgs)}),t}function v(c,m,h){const t=[],n={};return Object.keys(c).forEach(o=>{if(h&&h.has(o)||!o)return;const i=c[o];o=s(m?l(m,o):o),o.startsWith("\\\\")?o="\\\\"+o.substr(2).replace(/\\/g,"/"):o=o.replace(/\\/g,"/"),typeof i=="boolean"&&i?(o.startsWith("\\\\")&&(o+="**"),t.push(r(o))):i&&i.when&&(n[o]=i)}),{globArgs:t,siblingClauses:n}}function l(c,m){return T.$hc(m)?m:T.$ic(c,m)}e.$$dc=l;function s(c){return c=b.$Je(c,"\\"),b.$Je(c,"/")}function r(c){return M.$Sf(c).toLowerCase()==="c:/"?c.replace(/^c:[/\\]/i,"/"):c}e.$_dc=r}),define(De[358],Ce([1,0,48,53,16,359,19,46,35,76,32,12,37,15,18,29,36,356,127]),function(me,e,C,T,d,M,A,b,E,w,R,I,p,y,D,v,l,s,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bec=e.$aec=void 0;const c=new Set;process.on("exit",()=>{c.forEach(o=>o())});class m{constructor(i){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=i,this.b=i.filePattern||"",this.d=i.includePattern&&E.$uj(i.includePattern),this.f=i.maxResults||null,this.g=!!i.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=(0,r.$uq)(this.b).normalizedLowercase),this.u=i.excludePattern&&E.$uj(i.excludePattern),this.t=new Map,i.folderQueries.forEach(a=>{const u=Object.assign({},a.excludePattern||{},this.a.excludePattern||{}),k=a.folder.fsPath;i.folderQueries.map(S=>S.folder.fsPath).filter(S=>S!==k).forEach(S=>{(0,R.$Wf)(S,k)&&(u[d.$kc(k,S)]=!0)}),this.t.set(k,new t(u,k))})}cancel(){this.l=!0,c.forEach(i=>i())}walk(i,a,u,k,S){if(this.m=p.$Id.create(!1),this.l)return S(null,this.j);a.forEach($=>{const g=d.$mc($.fsPath);this.u&&this.u($.fsPath,g)||this.J(u,{relativePath:$.fsPath,searchPath:void 0})}),this.r=p.$Id.create(!1),this.w(i,($,g)=>{this.x(this.y,this,$,u,k,f=>{if(f){const P=(0,b.$yi)(f);console.error(P),this.q.push(P),g(f,void 0)}else g(null,void 0)})},($,g)=>{this.m.stop();const f=$?A.$Gb($)[0]:null;S(f,this.j)})}w(i,a,u){const k=new Array(i.length),S=new Array(i.length);let $=!1,g=0;if(i.length===0)return u(null,[]);i.forEach((f,P)=>{a(f,(N,O)=>{if(N?($=!0,k[P]=null,S[P]=N):(k[P]=O,S[P]=null),++g===i.length)return u($?S:null,k)})})}x(i,a,...u){try{i.apply(a,u)}catch(k){u[u.length-1](k)}}y(i,a,u,k){const S=i.folder.fsPath,$=I.$k,g=()=>L&&L.kill();c.add(g);let f=H=>{c.delete(g),f=()=>{},k(H)},P="";const N=this.D(),O=(0,s.$0dc)(this.a,i,this.a.includePattern,this.t.get(i.folder.fsPath).expression),L=O.cmd,j=!Object.keys(O.siblingClauses).length,z=O.rgArgs.args.map(H=>H.match(/^-/)?H:`'${H}'`).join(" ");let F=`${O.rgDiskPath} ${z}
 - cwd: ${O.cwd}`;O.rgArgs.siblingClauses&&(F+=`
 - Sibling clauses: ${JSON.stringify(O.rgArgs.siblingClauses)}`),u({message:F}),this.s=0,this.z(L,"utf8",u,(H,K,fe)=>{if(H){f(H);return}if(this.j){f();return}const Z=(P+($?w.$kl(K||""):K)).split(`
`);if(fe){const q=Z.length;Z[q-1]=Z[q-1].trim(),Z[q-1]||Z.pop()}else P=Z.pop()||"";if(Z.length&&Z[0].indexOf(`
`)!==-1){f(new Error("Splitting up files failed"));return}if(this.s+=Z.length,j){for(const q of Z)if(this.J(a,{base:S,relativePath:q,searchPath:this.N(i,q)}),this.j){g();break}(fe||this.j)&&f();return}this.G(i,N,S,Z,a),fe&&(this.H(N,S,a),f())})}spawnFindCmd(i){const a=this.t.get(i.folder.fsPath),u=a.getBasenameTerms(),k=a.getPathTerms(),S=["-L","."];if(u.length||k.length){S.push("-not","(","(");for(const $ of u)S.push("-name",$),S.push("-o");for(const $ of k)S.push("-path",$),S.push("-o");S.pop(),S.push(")","-prune",")")}return S.push("-type","f"),C.spawn("find",S,{cwd:i.folder.fsPath})}readStdout(i,a,u){let k="";this.z(i,a,()=>{},(S,$,g)=>{if(S){u(S);return}k+=$,g&&u(null,k)})}z(i,a,u,k){let S=(f,P,N)=>{(f||N)&&(S=()=>{},this.r?.stop()),k(f,P,N)},$=!1;i.stdout?(this.A(i.stdout,a,S),i.stdout.once("data",()=>$=!0)):u({message:"stdout is null"});let g;i.stderr?g=this.B(i.stderr):u({message:"stderr is null"}),i.on("error",f=>{S(f)}),i.on("close",f=>{let P;!$&&(P=this.C(g,a))&&n(P)?S(new Error(`command failed with error code ${f}: ${this.C(g,a)}`)):(this.g&&f===0&&(this.j=!0),S(null,"",!0))})}A(i,a,u){const k=new M.StringDecoder(a);return i.on("data",S=>{u(null,k.write(S))}),k}B(i){const a=[];return i.on("data",u=>{a.push(u)}),a}C(i,a){const u=new M.StringDecoder(a);return i.map(k=>u.write(k)).join("")}D(){const i={rootEntries:[],pathToEntries:Object.create(null)};return i.pathToEntries["."]=i.rootEntries,i}G(i,{pathToEntries:a},u,k,S){k.indexOf(this.b)!==-1&&this.J(S,{base:u,relativePath:this.b,searchPath:this.N(i,this.b)});const $=g=>{const f=d.$mc(g),P=d.$lc(g);let N=a[P];N||(N=a[P]=[],$(P)),N.push({base:u,relativePath:g,basename:f,searchPath:this.N(i,g)})};k.forEach($)}H({rootEntries:i,pathToEntries:a},u,k){const S=this,$=this.t.get(u),g=this.b;function f(P){S.o++;const N=(0,l.$YI)(()=>P.map(O=>O.basename));for(let O=0,L=P.length;O<L;O++){const j=P[O],{relativePath:z,basename:F}=j;if($.test(z,F,g!==F?N:void 0))continue;const H=a[z];if(H)f(H);else{if(S.p++,z===g)continue;S.J(k,j)}if(S.j)break}}f(i)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(i,a,u,k,S){const $=i.folder,g=(0,l.$YI)(()=>u);this.w(u,(f,P)=>{if(this.l||this.j)return P(null);const N=a?[a,f].join(d.sep):f;if(this.t.get(i.folder.fsPath).test(N,f,this.a.filePattern!==f?g:void 0))return P(null);const O=[$.fsPath,N].join(d.sep);T.lstat(O,(L,j)=>{if(L||this.l||this.j)return P(null);this.L(O,j,(z,F)=>z||this.l||this.j?P(null):F.isDirectory()?(this.o++,this.M(O,j,(H,K)=>H||this.l||this.j||(K=K||"",this.v[K])?P(null):(this.v[K]=!0,v.Promises.readdir(O).then(fe=>{if(this.l||this.j)return P(null);this.I(i,N,fe,k,x=>P(x||null))},fe=>{P(null)})))):(this.p++,N===this.b||this.h&&D.$Bf(F.size)&&F.size>this.h||this.J(k,{base:$.fsPath,relativePath:N,searchPath:this.N(i,N)}),P(null,void 0)))})},f=>{const P=f&&A.$Gb(f);return S(P&&P.length>0?P[0]:void 0)})}J(i,a){this.K(a)&&(!this.d||this.d(a.relativePath,d.$mc(a.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||i(a))}K(i){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,l.$TI)(i,this.c)}return!0}L(i,a,u){return a.isSymbolicLink()?T.stat(i,u):u(null,a)}M(i,a,u){return a.isSymbolicLink()?T.realpath(i,(k,S)=>k?u(k):u(null,S)):u(null,i)}N(i,a){return i.folderName?d.$ic(i.folderName,a):a}}e.$aec=m;class h{constructor(i){this.a=i.folderQueries,this.b=i.extraFileResources||[],this.c=new m(i)}search(i,a,u){this.c.walk(this.a,this.b,i,a,(k,S)=>{u(k,{limitHit:S,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$bec=h;class t{constructor(i,a){this.expression=i,this.c=a,this.d(i)}d(i){let a,u;Object.keys(i).filter(k=>i[k]).forEach(k=>{d.$hc(k)?(a=a||E.$pj(),a[k]=i[k]):(u=u||E.$pj(),u[k]=i[k])}),this.a=a&&E.$uj(a,{trimForExclusions:!0}),this.b=u&&E.$uj(u,{trimForExclusions:!0})}test(i,a,u){return this.b&&this.b(i,a,u)||this.a&&this.a(d.$ic(this.c,i),a,u)}getBasenameTerms(){const i=[];return this.a&&i.push(...E.$wj(this.a)),this.b&&i.push(...E.$wj(this.b)),i}getPathTerms(){const i=[];return this.a&&i.push(...E.$xj(this.a)),this.b&&i.push(...E.$xj(this.b)),i}}function n(o){const i=o.trim().split(`
`),a=i[0].trim();if(a.startsWith("Error parsing regex"))return a;if(a.startsWith("regex parse error"))return y.$pf(i[i.length-1].trim());if(a.startsWith("error parsing glob")||a.startsWith("unsupported encoding"))return a.charAt(0).toUpperCase()+a.substr(1);if(a==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(a.startsWith("Literal "))return a}}),define(De[360],Ce([1,0,96,22,182,21]),function(me,e,C,T,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xC=e.$wC=e.$vC=e.$uC=e.$tC=e.$sC=e.$rC=e.$qC=e.$pC=e.DecodeStreamErrorKind=e.$oC=e.$nC=e.$mC=e.$lC=e.$kC=e.$jC=e.$iC=e.$hC=void 0,e.$hC="utf8",e.$iC="utf8bom",e.$jC="utf16be",e.$kC="utf16le";function A(a){return[e.$hC,e.$iC,e.$jC,e.$kC].some(u=>u===a)}e.$lC=A,e.$mC=[254,255],e.$nC=[255,254],e.$oC=[239,187,191];const b=512,E=512,w=512*8,R=512*128;var I;(function(a){a[a.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(I||(e.DecodeStreamErrorKind=I={}));class p extends Error{constructor(u,k){super(u),this.decodeStreamErrorKind=k}}e.$pC=p;class y{static async create(u){let k;if(u!==e.$hC)k=(await(0,d.$gC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(s(u));else{const S=new TextDecoder;k={write($){return S.decode($,{stream:!0})},end(){return S.decode()}}}return new y(k)}constructor(u){this.a=u}write(u){return this.a.write(u)}end(){return this.a.end()}}function D(a,u){const k=u.minBytesRequiredForDetection??u.guessEncoding?w:E;return new Promise((S,$)=>{const g=(0,C.$1d)(j=>j.join("")),f=[];let P=0,N;const O=new M.$Wd,L=async()=>{try{const j=await i({buffer:T.$ae.concat(f),bytesRead:P},u.guessEncoding);if(j.seemsBinary&&u.acceptTextOnly)throw new p("Stream is binary but only text is accepted for decoding",1);j.encoding=await u.overwriteEncoding(j.encoding),N=await y.create(j.encoding);const z=N.write(T.$ae.concat(f).buffer);g.write(z),f.length=0,P=0,S({stream:g,detected:j})}catch(j){O.cancel(),g.destroy(),$(j)}};(0,C.$5d)(a,{onData:async j=>{N?g.write(N.write(j.buffer)):(f.push(j),P+=j.byteLength,P>=k&&(a.pause(),await L(),setTimeout(()=>a.resume())))},onError:j=>g.error(j),onEnd:async()=>{N||await L(),g.end(N?.end())}},O.token)})}e.$qC=D;async function v(a,u,k){const $=(await(0,d.$gC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(s(u),k);let g=!1,f=!1;return{read(){if(f)return null;const P=a.read();if(typeof P!="string"){if(f=!0,!g&&k?.addBOM)switch(u){case e.$hC:case e.$iC:return T.$ae.wrap(Uint8Array.from(e.$oC));case e.$jC:return T.$ae.wrap(Uint8Array.from(e.$mC));case e.$kC:return T.$ae.wrap(Uint8Array.from(e.$nC))}const N=$.end();return N&&N.length>0?(g=!0,T.$ae.wrap(N)):null}return g=!0,T.$ae.wrap($.write(P))}}}e.$rC=v;async function l(a){return(await(0,d.$gC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(s(a))}e.$sC=l;function s(a){return a===e.$iC||a===null?e.$hC:a}e.$tC=s;function r(a,u){if(!a||u<e.$mC.length)return null;const k=a.readUInt8(0),S=a.readUInt8(1);if(k===e.$mC[0]&&S===e.$mC[1])return e.$jC;if(k===e.$nC[0]&&S===e.$nC[1])return e.$kC;if(u<e.$oC.length)return null;const $=a.readUInt8(2);return k===e.$oC[0]&&S===e.$oC[1]&&$===e.$oC[2]?e.$iC:null}e.$uC=r;const c=["ascii","utf-16","utf-32"];async function m(a){const u=await(0,d.$gC)("jschardet","dist/jschardet.min.js"),k=a.slice(0,R),S=n(k.buffer),$=u.detect(S);if(!$||!$.encoding)return null;const g=$.encoding.toLowerCase();return 0<=c.indexOf(g)?null:t($.encoding)}const h={ibm866:"cp866",big5:"cp950"};function t(a){const u=a.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return h[u]||u}function n(a){let u="";for(let k=0;k<a.length;k++)u+=String.fromCharCode(a[k]);return u}function o(a){switch(a){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const u=a.match(/windows(\d+)/);return u?"windows-"+u[1]:a}}}e.$vC=o;function i({buffer:a,bytesRead:u},k){let S=r(a,u),$=!1;if(S!==e.$jC&&S!==e.$kC&&a){let g=!0,f=!0,P=!1;for(let N=0;N<u&&N<b;N++){const O=N%2===1,L=a.readUInt8(N)===0;if(L&&(P=!0),g&&(O&&!L||!O&&L)&&(g=!1),f&&(O&&L||!O&&!L)&&(f=!1),L&&!g&&!f)break}P&&(g?S=e.$kC:f?S=e.$jC:$=!0)}return k&&!$&&!S&&a?m(a.slice(0,u)).then(g=>({seemsBinary:!1,encoding:g})):{seemsBinary:$,encoding:S}}e.$wC=i,e.$xC={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(De[154],Ce([1,0,360,29,153]),function(me,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jec=void 0;class M extends d.$_cc{constructor(b,E,w=T,R="searchProcess"){super(b,E,{readdir:I=>w.Promises.readdir(I.fsPath),toCanonicalName:I=>(0,C.$vC)(I)},R)}}e.$jec=M}),define(De[155],Ce([1,0,48,376,359,19,73,35,16,15,2,36,92,377,357,116]),function(me,e,C,T,d,M,A,b,E,w,R,I,p,y,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iec=e.$hec=e.$gec=e.$fec=e.$eec=e.$dec=e.$cec=void 0;const l=D.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class s{constructor(f){this.a=f}provideTextSearchResults(f,P,N,O){return this.a.appendLine(`provideTextSearchResults ${f.pattern}, ${JSON.stringify({...P,folder:P.folder.toString()})}`),new Promise((L,j)=>{O.onCancellationRequested(()=>q());const z=n(f,P),F=P.folder.fsPath,H=z.map(J=>J.match(/^-/)?J:`'${J}'`).join(" ");this.a.appendLine(`${l} ${H}
 - cwd: ${F}`);let K=C.spawn(l,z,{cwd:F});K.on("error",J=>{console.error(J),this.a.appendLine("Error: "+(J&&J.message)),j((0,I.$PI)(new I.$NI(J&&J.message,I.SearchErrorCode.rgProcessError)))});let fe=!1;const x=new m(P.maxResults,F,P.previewOptions);x.on("result",J=>{fe=!0,be="",N.report(J)});let Z=!1;const q=()=>{Z=!0,K?.kill(),x?.cancel()};let Y=!1;x.on("hitLimit",()=>{Y=!0,q()});let be="";K.stdout.on("data",J=>{x.handleData(J),fe||(be+=J)});let ue=!1;K.stdout.once("data",()=>ue=!0);let ve="";K.stderr.on("data",J=>{const U=J.toString();this.a.appendLine(U),ve.length+U.length<1e6&&(ve+=U)}),K.on("close",()=>{if(this.a.appendLine(ue?"Got data from stdout":"No data from stdout"),this.a.appendLine(fe?"Got result from parser":"No result from parser"),be&&this.a.appendLine(`Got data without result: ${be}`),this.a.appendLine(""),Z)L({limitHit:Y});else{x.flush(),K=null;let J;ve&&!ue&&(J=r(ve))?j((0,I.$PI)(new I.$NI(J.message,J.code))):L({limitHit:Y})}})})}}e.$cec=s;function r(g){const f=g.split(`
`),P=f[0].trim();if(f.some(O=>O.startsWith("regex parse error")))return new I.$NI(c(f),I.SearchErrorCode.regexParseError);const N=P.match(/grep config error: unknown encoding: (.*)/);if(N)return new I.$NI(`Unknown encoding: ${N[1]}`,I.SearchErrorCode.unknownEncoding);if(P.startsWith("error parsing glob"))return new I.$NI(P.charAt(0).toUpperCase()+P.substr(1),I.SearchErrorCode.globParseError);if(P.startsWith("the literal"))return new I.$NI(P.charAt(0).toUpperCase()+P.substr(1),I.SearchErrorCode.invalidLiteral);if(P.startsWith("PCRE2: error compiling pattern"))return new I.$NI(P,I.SearchErrorCode.regexParseError)}function c(g){const f=["Regex parse error"],P=g.filter(N=>N.startsWith("PCRE2:"));if(P.length>=1){const N=P[0].replace("PCRE2:","");if(N.indexOf(":")!==-1&&N.split(":").length>=2){const O=N.split(":")[1];f.push(":"+O)}}return f.join("")}class m extends T.EventEmitter{constructor(f,P,N){super(),this.g=f,this.h=P,this.j=N,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new d.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(f,P){return super.on(f,P),this}handleData(f){if(this.b)return;const P=typeof f=="string"?f:this.d.write(f);this.k(P)}k(f){let P=f.indexOf(`
`);const N=this.a+f;if(P>=0)P+=this.a.length;else{this.a=N;return}let O=0;for(;P>=0;)this.m(N.substring(O,P).trim()),O=P+1,P=N.indexOf(`
`,O);this.a=N.substring(O)}m(f){if(this.b||!f)return;let P;try{P=JSON.parse(f)}catch{throw new Error(`malformed line from rg: ${f}`)}if(P.type==="match"){const N=h(P.data.path),O=R.URI.file(E.$ic(this.h,N)),L=this.n(P.data,O);this.p(L),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(P.type==="context"){const N=h(P.data.path),O=R.URI.file(E.$ic(this.h,N));this.o(P.data,O).forEach(j=>this.p(j))}}n(f,P){const N=f.line_number-1,O=h(f.lines),L=Buffer.from(O);let j=0,z=0,F=N;f.submatches.length===0&&f.submatches.push(O.length?{start:0,end:1,match:{text:O[0]}}:{start:0,end:0,match:{text:""}});const H=(0,M.$Gb)(f.submatches.map((K,fe)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const x=h(K.match),Z=L.slice(j,K.start).toString(),q=t(Z),Y=q.numLines>0?q.lastLineLength:q.lastLineLength+z,be=t(x),ue=q.numLines+F,ve=be.numLines+ue,J=be.numLines>0?be.lastLineLength:be.lastLineLength+Y;return j=K.end,z=J,F=ve,new p.$xI(ue,Y,ve,J)}));return(0,v.$8dc)(P,O,H,this.j)}o(f,P){const N=h(f.lines),O=f.line_number;return N.replace(/\r?\n$/,"").split(`
`).map((L,j)=>({text:L,uri:P,lineNumber:O+j}))}p(f){this.emit("result",f)}}e.$dec=m;function h(g){return g.bytes?Buffer.from(g.bytes,"base64").toString():g.text}function t(g){const f=/\n/g;let P=0,N=-1,O;for(;O=f.exec(g);)P++,N=O.index;const L=N>=0?g.length-N-1:g.length;return{numLines:P,lastLineLength:L}}function n(g,f){const P=["--hidden","--no-require-git"];P.push(g.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:N,otherIncludes:O}=(0,A.$J)(f.includes,j=>j.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(O&&O.length){const j=new Set;O.forEach(z=>{j.add(z)}),P.push("-g","!*"),j.forEach(z=>{o(z).map(v.$7dc).forEach(F=>{P.push("-g",F)})})}N&&N.length&&N.forEach(j=>{P.push("-g",j)}),f.excludes.map(v.$7dc).forEach(j=>P.push("-g",`!${j}`)),f.maxFileSize&&P.push("--max-filesize",f.maxFileSize+""),f.useIgnoreFiles?f.useParentIgnoreFiles||P.push("--no-ignore-parent"):P.push("--no-ignore"),f.followSymlinks&&P.push("--follow"),f.encoding&&f.encoding!=="utf8"&&P.push("--encoding",f.encoding),g.pattern==="--"&&(g.isRegExp=!0,g.pattern="\\-\\-"),g.isMultiline&&!g.isRegExp&&(g.pattern=(0,w.$Ee)(g.pattern),g.isRegExp=!0),f.usePCRE2&&P.push("--pcre2"),P.push("--crlf"),g.isRegExp&&(g.pattern=i(g.pattern),P.push("--engine","auto"));let L;if(g.isWordMatch){const z=(0,w.$Me)(g.pattern,!!g.isRegExp,{wholeWord:g.isWordMatch}).source.replace(/\\\//g,"/");P.push("--regexp",z)}else if(g.isRegExp){let j=u(g.pattern);j=k(j),P.push("--regexp",j)}else L=g.pattern,P.push("--fixed-strings");return P.push("--no-config"),f.useGlobalIgnoreFiles||P.push("--no-ignore-global"),P.push("--json"),g.isMultiline&&P.push("--multiline"),f.beforeContext&&P.push("--before-context",f.beforeContext+""),f.afterContext&&P.push("--after-context",f.afterContext+""),P.push("--"),L&&P.push(L),P.push("."),P}e.$eec=n;function o(g){return $(g).flatMap(P=>{const N=(0,b.$sj)(P,"/");return N.map((O,L)=>N.slice(0,L+1).join("/"))})}function i(g){const f=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;g.match(f);)g=g.replace(f,"$1\\x{$2}");const P=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;g.match(P);)g=g.replace(P,"$1\\x{$2}");return g}e.$fec=i;const a=g=>g.type==="Assertion"&&g.kind==="lookbehind";function u(g){let f;try{f=new y.RegExpParser().parsePattern(g)}catch{return g}let P="",N=0;const O=(z,F,H)=>{P+=g.slice(N,z)+H,N=F},L=[];return new y.RegExpVisitor({onCharacterEnter(z){if(z.raw!=="\\n")return;const F=L[0];if(!F)O(z.start,z.end,"\\r?\\n");else if(!L.some(a))if(F.type==="CharacterClass")if(F.negate){const H=g.slice(F.start+2,z.start)+g.slice(z.end,F.end-1);F.parent?.type==="Quantifier"?O(F.start,F.end,H?`[^${H}]`:"."):O(F.start,F.end,"(?!\\r?\\n"+(H?`|[${H}]`:"")+")")}else{const H=g.slice(F.start+1,z.start)+g.slice(z.end,F.end-1);O(F.start,F.end,H===""?"\\r?\\n":`(?:[${H}]|\\r?\\n)`)}else F.type==="Quantifier"&&O(z.start,z.end,"(?:\\r?\\n)")},onQuantifierEnter(z){L.unshift(z)},onQuantifierLeave(){L.shift()},onCharacterClassRangeEnter(z){L.unshift(z)},onCharacterClassRangeLeave(){L.shift()},onCharacterClassEnter(z){L.unshift(z)},onCharacterClassLeave(){L.shift()},onAssertionEnter(z){a(z)&&L.push(z)},onAssertionLeave(z){L[0]===z&&L.shift()}}).visit(f),P+=g.slice(N),P}e.$gec=u;function k(g){return g.replace(/\n/g,"\\r?\\n")}e.$hec=k;function S(g){let f=!1,P=!1,N="",O="";for(let L=0;L<g.length;L++){const j=g[L];switch(j){case"\\":P?(f?O+="\\"+j:N+="\\"+j,P=!1):P=!0;break;case"{":if(P)f?O+=j:N+=j,P=!1;else{if(f)return{strInBraces:N+"{"+O+"{"+g.substring(L+1)};f=!0}break;case"}":if(P)f?O+=j:N+=j,P=!1;else{if(f)return{fixedStart:N,strInBraces:O,fixedEnd:g.substring(L+1)};N+=j}break;default:f?O+=(P?"\\":"")+j:N+=(P?"\\":"")+j,P=!1;break}}return{strInBraces:N+(f?"{"+O:"")}}function $(g){const{fixedStart:f,strInBraces:P,fixedEnd:N}=S(g);if(f===void 0||N===void 0)return[P];let O=(0,b.$sj)(P,",");O.length||(O=[""]);const L=$(N);return O.flatMap(j=>{const z=f+j;return L.map(F=>z+F)})}e.$iec=$}),define(De[361],Ce([1,0,21,155,84,17]),function(me,e,C,T,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mec=void 0;class A{constructor(w){this.b=w,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(w,R,I,p){const y=new T.$cec(this.b);if(R.folder.scheme===M.Schemas.vscodeUserData){const D={...R,folder:R.folder.with({scheme:M.Schemas.file})},v=new d.$Zu(l=>I.report({...l,uri:l.uri.with({scheme:R.folder.scheme})}));return this.c(p,l=>y.provideTextSearchResults(w,D,v,l))}else return this.c(p,D=>y.provideTextSearchResults(w,R,I,D))}async c(w,R){const I=b(w);this.a.add(I);const p=await R(I.token);return this.a.delete(I),p}d(){this.a.forEach(w=>w.cancel())}}e.$mec=A;function b(E){const w=new C.$Wd;return E.onCancellationRequested(()=>w.cancel()),w}}),define(De[362],Ce([1,0,29,155,154]),function(me,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kec=void 0;class M{constructor(E){this.a=E}search(E,w,R){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const I={appendLine(y){R({message:y})}},p=new d.$jec(this.a,new T.$cec(I),C);return new Promise((y,D)=>p.search(v=>{w(v.map(A))},E).then(v=>y({limitHit:v.limitHit,type:"success",stats:v.stats}),D))}}e.$kec=M;function A(b){return{path:b.resource&&b.resource.fsPath,results:b.results,numMatches:(b.results||[]).reduce((E,w)=>{if(w.ranges){const R=w;return E+(Array.isArray(R.ranges)?R.ranges.length:1)}else return E+1},0)}}}),define(De[363],Ce([1,0,19,9,8,4,127,16,37,2,30,36,358,362]),function(me,e,C,T,d,M,A,b,E,w,R,I,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lec=void 0;class D{static{this.a=512}constructor(m="searchProcess"){this.d=m,this.b=Object.create(null)}fileSearch(m){let h;const t=s(m),n=new M.$Md({onDidAddFirstListener:()=>{h=(0,T.$Gg)(o=>this.doFileSearchWithEngine(p.$bec,t,i=>n.fire(i),o)),h.then(o=>n.fire(o),o=>n.fire({type:"error",error:{message:o.message,stack:o.stack}}))},onDidRemoveLastListener:()=>{h.cancel()}});return n.event}textSearch(m){let h;const t=s(m),n=new M.$Md({onDidAddFirstListener:()=>{h=(0,T.$Gg)(o=>this.f(t,i=>n.fire(i),o)),h.then(o=>n.fire(o),o=>n.fire({type:"error",error:{message:o.message,stack:o.stack}}))},onDidRemoveLastListener:()=>{h.cancel()}});return n.event}f(m,h,t){return m.maxFileSize=this.g().maxFileSize,new y.$kec(m).search(t,h,h)}g(){return{maxFileSize:process.arch==="ia32"?300*R.$Dk.MB:16*R.$Dk.GB}}doFileSearch(m,h,t){return this.doFileSearchWithEngine(p.$bec,m,h,t)}doFileSearchWithEngine(m,h,t,n,o=D.a){let i=0;const a=k=>{Array.isArray(k)?(i+=k.length,t(k.map(S=>this.h(S)))):k.relativePath?(i++,t(this.h(k))):t(k)};if(h.sortByScore){let k=this.l(h,a,n);if(!k){const S=h.maxResults?Object.assign({},h,{maxResults:null}):h,$=new m(S);k=this.j($,h,t,a,n)}return new Promise((S,$)=>{k.then(([g,f])=>{const P=f.map(N=>this.h(N));this.o(P,t,o),S(g)},$)})}const u=new m(h);return this.r(u,a,o,n).then(k=>({limitHit:k.limitHit,type:"success",stats:{detailStats:k.stats,type:this.d,fromCache:!1,resultCount:i,sortingTime:void 0}}))}h(m){return{path:m.base?(0,b.$ic)(m.base,m.relativePath):m.relativePath}}j(m,h,t,n,o){const i=new M.$Md;let a=(0,T.$Gg)(k=>{let S=[];const $=g=>{Array.isArray(g)?S=g:(n(g),i.fire(g))};return this.r(m,$,-1,k).then(g=>[g,S])}),u;if(h.cacheKey){u=this.k(h.cacheKey);const k={promise:a,event:i.event,resolved:!1};u.resultsToSearchCache[h.filePattern||""]=k,a.then(()=>{k.resolved=!0},S=>{delete u.resultsToSearchCache[h.filePattern||""]}),a=this.s(a)}return a.then(([k,S])=>{const $=u?u.scorerCache:Object.create(null),g=(typeof h.maxResults!="number"||h.maxResults>0)&&E.$Id.create(!1);return this.n(h,S,$,o).then(f=>{const P=g?g.elapsed():-1;return[{type:"success",stats:{detailStats:k.stats,sortingTime:P,fromCache:!1,type:this.d,workspaceFolderCount:h.folderQueries.length,resultCount:f.length},messages:k.messages,limitHit:k.limitHit||typeof h.maxResults=="number"&&S.length>h.maxResults},f]})})}k(m){const h=this.b[m];return h||(this.b[m]=new v)}l(m,h,t){const n=m.cacheKey&&this.b[m.cacheKey];if(!n)return;const o=this.q(n,m.filePattern||"",h,t);if(o)return o.then(([i,a,u])=>{const k=E.$Id.create(!1);return this.n(m,a,n.scorerCache,t).then(S=>{const $=k.elapsed(),g={fromCache:!0,detailStats:u,type:this.d,resultCount:a.length,sortingTime:$};return[{type:"success",limitHit:i.limitHit||typeof m.maxResults=="number"&&a.length>m.maxResults,stats:g},S]})})}n(m,h,t,n){const o=(0,A.$uq)(m.filePattern||""),i=(u,k)=>(0,A.$tq)(u,k,o,!0,l,t),a=typeof m.maxResults=="number"?m.maxResults:Number.MAX_VALUE;return C.$Fb(h,i,a,1e4,n)}o(m,h,t){if(t&&t>0)for(let n=0;n<m.length;n+=t)h(m.slice(n,n+t));else h(m)}q(m,h,t,n){const o=E.$Id.create(!1),i=h.indexOf(b.sep)>=0;let a;for(const $ in m.resultsToSearchCache)if(h.startsWith($)){if(i&&$.indexOf(b.sep)<0&&$!=="")continue;const g=m.resultsToSearchCache[$];a={promise:this.s(g.promise),event:g.event,resolved:g.resolved};break}if(!a)return null;const u=o.elapsed(),k=E.$Id.create(!1),S=a.event(t);return n&&n.onCancellationRequested(()=>{S.dispose()}),a.promise.then(([$,g])=>{if(n&&n.isCancellationRequested)throw(0,d.$5)();const f=[],P=(0,A.$uq)(h).normalizedLowercase;for(const N of g)(0,I.$TI)(N,P)&&f.push(N);return[$,f,{cacheWasResolved:a.resolved,cacheLookupTime:u,cacheFilterTime:k.elapsed(),cacheEntryCount:g.length}]})}r(m,h,t,n){return new Promise((o,i)=>{let a=[];n?.onCancellationRequested(()=>m.cancel()),m.search(u=>{u&&(t?(a.push(u),t>0&&a.length>=t&&(h(a),a=[])):h(u))},u=>{h(u)},(u,k)=>{a.length&&h(a),u?i(u):o(k)})})}clearCache(m){return delete this.b[m],Promise.resolve(void 0)}s(m){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(h,t){return m.then(h,t)}catch(h){return this.then(void 0,h)}finally(h){return m.finally(h)}}}}e.$lec=D;class v{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const l=new class{getItemLabel(c){return(0,b.$mc)(c.relativePath)}getItemDescription(c){return(0,b.$lc)(c.relativePath)}getItemPath(c){return c.relativePath}};function s(c){return{...c,folderQueries:c.folderQueries&&c.folderQueries.map(r),extraFileResources:c.extraFileResources&&c.extraFileResources.map(m=>w.URI.revive(m))}}function r(c){return{...c,folder:w.URI.revive(c.folder)}}}),define(De[364],Ce([1,0,3,17,2,29,13,27,20,95,66,36,363,361,116,154]),function(me,e,C,T,d,M,A,b,E,w,R,I,p,y,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nec=void 0;let l=class extends w.$edc{constructor(r,c,m,h){super(r,m,h),this.s=M,this.t=-1,this.v=null,this.w=!1,this.x=new C.$Qc;const t=new D.$9dc("RipgrepSearchUD",this.n);this.x.add(this.registerTextSearchProvider(T.Schemas.vscodeUserData,new y.$mec(t))),c.remote.isRemote&&c.remote.authority&&this.y()}dispose(){this.x.dispose()}$enableExtensionHostSearch(){this.y()}y(){if(this.w)return;this.w=!0;const r=new D.$9dc("RipgrepSearchEH",this.n);this.x.add(this.registerTextSearchProvider(T.Schemas.file,new y.$mec(r))),this.x.add(this.z(T.Schemas.file,new p.$lec("fileSearchProvider")))}z(r,c){const m=this.d++;return this.v=c,this.t=m,this.c.$registerFileSearchProvider(m,this.o(r)),(0,C.$Pc)(()=>{this.v=null,this.c.$unregisterProvider(m)})}$provideFileSearchResults(r,c,m,h){const t=(0,w.$fdc)(m);return r===this.t?this.A(r,c,t,h):super.$provideFileSearchResults(r,c,m,h)}A(r,c,m,h){const t=n=>{if((0,I.$SI)(n)&&(n=[n]),Array.isArray(n)){this.c.$handleFileMatch(r,c,n.map(o=>d.URI.file(o.path)));return}n.message&&this.n.debug("ExtHostSearch",n.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(m,t,h)}$clearCache(r){return this.v?.clearCache(r),super.$clearCache(r)}q(r,c){return new v.$jec(r,c,void 0,"textSearchProvider")}};e.$nec=l,e.$nec=l=He([Be(0,E.$aM),Be(1,b.$qM),Be(2,R.$Wbc),Be(3,A.$8i)],l)}),define(De[117],Ce([1,0,378,60,63,379,22,8,4,3,16,12,31,80,81]),function(me,e,C,T,d,M,A,b,E,w,R,I,p,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=void 0;class v{traceSocketEvent(g,f){D.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,g,f)}constructor(g,f=""){this.f=!0,this.debugLabel=f,this.socket=g,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=P=>{if(this.traceSocketEvent("error",{code:P?.code,message:P?.message}),P){if(P.code==="EPIPE")return;(0,b.$Z)(P)}},this.socket.on("error",this.a),this.b=P=>{this.traceSocketEvent("close",{hadError:P}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(g){const f=P=>{this.traceSocketEvent("read",P),g(A.$ae.wrap(P))};return this.socket.on("data",f),{dispose:()=>this.socket.off("data",f)}}onClose(g){const f=P=>{g({type:0,hadError:P,error:void 0})};return this.socket.on("close",f),{dispose:()=>this.socket.off("close",f)}}onEnd(g){const f=()=>{g()};return this.socket.on("end",f),{dispose:()=>this.socket.off("end",f)}}write(g){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",g),this.socket.write(g.buffer,f=>{if(f){if(f.code==="EPIPE")return;(0,b.$Z)(f)}})}catch(f){if(f.code==="EPIPE")return;(0,b.$Z)(f)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((g,f)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),g();return}const P=()=>{this.socket.off("close",P),this.socket.off("end",P),this.socket.off("error",P),this.socket.off("timeout",P),this.socket.off("drain",P),this.traceSocketEvent("nodeDrainEnd"),g()};this.socket.on("close",P),this.socket.on("end",P),this.socket.on("error",P),this.socket.on("timeout",P),this.socket.on("drain",P)})}}e.$Ch=v;var l;(function($){$[$.MinHeaderByteSize=2]="MinHeaderByteSize",$[$.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(l||(l={}));var s;(function($){$[$.PeekHeader=1]="PeekHeader",$[$.ReadHeader=2]="ReadHeader",$[$.ReadBody=3]="ReadBody",$[$.Fin=4]="Fin"})(s||(s={}));class r extends w.$Rc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(g,f){this.socket.traceSocketEvent(g,f)}constructor(g,f,P,N){super(),this.f=this.B(new E.$Md),this.g=this.B(new E.$Md),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=g,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:f,inflateBytesLength:P?.byteLength||0,recordInflateBytes:N}),this.a=this.B(new c(this,f,P,N,this.f,(O,L)=>this.m(O,L))),this.B(this.a.onError(O=>{console.error(O),(0,b.$Z)(O),this.g.fire({type:0,hadError:!0,error:O})})),this.b=new D.$xh,this.B(this.socket.onData(O=>this.n(O))),this.B(this.socket.onClose(async O=>{this.a.isProcessingReadQueue()&&await E.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(O)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(g){return this.f.event(g)}onClose(g){return this.g.event(g)}onEnd(g){return this.socket.onEnd(g)}write(g){let f=0;for(;f<g.byteLength;)this.a.writeMessage(g.slice(f,Math.min(f+262144,g.byteLength)),{compressed:!0,opcode:2}),f+=262144}m(g,{compressed:f,opcode:P}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",g);let N=2;g.byteLength<126?N+=0:g.byteLength<2**16?N+=2:N+=8;const O=A.$ae.alloc(N),L=f?64:0,j=P&15;if(O.writeUInt8(128|L|j,0),g.byteLength<126)O.writeUInt8(g.byteLength,1);else if(g.byteLength<2**16){O.writeUInt8(126,1);let z=1;O.writeUInt8(g.byteLength>>>8&255,++z),O.writeUInt8(g.byteLength>>>0&255,++z)}else{O.writeUInt8(127,1);let z=1;O.writeUInt8(0,++z),O.writeUInt8(0,++z),O.writeUInt8(0,++z),O.writeUInt8(0,++z),O.writeUInt8(g.byteLength>>>24&255,++z),O.writeUInt8(g.byteLength>>>16&255,++z),O.writeUInt8(g.byteLength>>>8&255,++z),O.writeUInt8(g.byteLength>>>0&255,++z)}this.socket.write(A.$ae.concat([O,g]))}end(){this.h=!0,this.socket.end()}n(g){if(g.byteLength!==0){for(this.b.acceptChunk(g);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const f=this.b.peek(this.j.readLen),P=f.readUInt8(0),N=(P&128)>>>7,O=(P&64)>>>6,L=P&15,j=f.readUInt8(1),z=(j&128)>>>7,F=j&127;this.j.state=2,this.j.readLen=2+(z?4:0)+(F===126?2:0)+(F===127?8:0),this.j.fin=N,this.j.firstFrameOfMessage&&(this.j.compressed=!!O),this.j.firstFrameOfMessage=!!N,this.j.mask=0,this.j.opcode=L,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const f=this.b.read(this.j.readLen),P=f.readUInt8(1),N=(P&128)>>>7;let O=P&127,L=1;O===126?O=f.readUInt8(++L)*2**8+f.readUInt8(++L):O===127&&(O=f.readUInt8(++L)*0+f.readUInt8(++L)*0+f.readUInt8(++L)*0+f.readUInt8(++L)*0+f.readUInt8(++L)*2**24+f.readUInt8(++L)*2**16+f.readUInt8(++L)*2**8+f.readUInt8(++L));let j=0;N&&(j=f.readUInt8(++L)*2**24+f.readUInt8(++L)*2**16+f.readUInt8(++L)*2**8+f.readUInt8(++L)),this.j.state=3,this.j.readLen=O,this.j.mask=j,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const f=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",f),t(f,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",f),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(f,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(f,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await E.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Dh=r;class c extends w.$Rc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:A.$ae.alloc(0)}constructor(g,f,P,N,O,L){super(),this.n=g,this.r=O,this.s=L,this.a=this.B(new E.$Md),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new E.$Md),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new E.$Md),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,f?(this.b=this.B(new m(this.n,N,P,{windowBits:15})),this.f=this.B(new h(this.n,{windowBits:15})),this.B(this.b.onError(j=>this.a.fire(j))),this.B(this.f.onError(j=>this.a.fire(j)))):(this.b=null,this.f=null)}writeMessage(g,f){this.g.push({data:g,options:f}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:g,options:f}=this.g.shift();if(this.f&&f.compressed){const P=await this.w(this.f,g);this.s(P,f)}else this.s(g,{...f,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(g,f){return new Promise((P,N)=>{g.write(f),g.flush(O=>P(O))})}acceptFrame(g,f,P){this.h.push({data:g,isCompressed:f,isLastFrameOfMessage:P}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const g=this.h.shift();if(this.b&&g.isCompressed){const f=await this.C(this.b,g.data,g.isLastFrameOfMessage);this.r.fire(f)}else this.r.fire(g.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(g,f,P){return new Promise((N,O)=>{g.write(f),P&&g.write(A.$ae.fromByteArray([0,0,255,255])),g.flush(L=>N(L))})}}class m extends w.$Rc{get recordedInflateBytes(){return this.j?A.$ae.concat(this.f):A.$ae.alloc(0)}constructor(g,f,P,N){super(),this.h=g,this.j=f,this.a=this.B(new E.$Md),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,M.createInflateRaw)(N),this.b.on("error",O=>{this.h.traceSocketEvent("zlibInflateError",{message:O?.message,code:O?.code}),this.a.fire(O)}),this.b.on("data",O=>{this.h.traceSocketEvent("zlibInflateData",O),this.g.push(A.$ae.wrap(O))}),P&&(this.h.traceSocketEvent("zlibInflateInitialWrite",P.buffer),this.b.write(P.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(g){this.j&&this.f.push(g.clone()),this.h.traceSocketEvent("zlibInflateWrite",g),this.b.write(g.buffer)}flush(g){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const f=A.$ae.concat(this.g);this.g.length=0,g(f)})}}class h extends w.$Rc{constructor(g,f){super(),this.g=g,this.a=this.B(new E.$Md),this.onError=this.a.event,this.f=[],this.b=(0,M.createDeflateRaw)({windowBits:15}),this.b.on("error",P=>{this.g.traceSocketEvent("zlibDeflateError",{message:P?.message,code:P?.code}),this.a.fire(P)}),this.b.on("data",P=>{this.g.traceSocketEvent("zlibDeflateData",P),this.f.push(A.$ae.wrap(P))})}write(g){this.g.traceSocketEvent("zlibDeflateWrite",g.buffer),this.b.write(g.buffer)}flush(g){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let f=A.$ae.concat(this.f);this.f.length=0,f=f.slice(0,f.byteLength-4),g(f)})}}function t($,g){if(g===0)return;const f=$.byteLength>>>2;for(let z=0;z<f;z++){const F=$.readUInt32BE(z*4);$.writeUInt32BE(F^g,z*4)}const P=f*4,N=$.byteLength-P,O=g>>>24&255,L=g>>>16&255,j=g>>>8&255;N>=1&&$.writeUInt8($.readUInt8(P)^O,P),N>=2&&$.writeUInt8($.readUInt8(P+1)^L,P+1),N>=3&&$.writeUInt8($.readUInt8(P+2)^j,P+2)}e.$Eh=process.env.XDG_RUNTIME_DIR;const n={[2]:107,[1]:103};function o(){const $=(0,p.$dg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${$}-sock`;const g=process.platform!=="darwin"&&e.$Eh?e.$Eh:(0,d.tmpdir)(),f=(0,R.$ic)(g,`vscode-ipc-${$}.sock`);return a(f),f}e.$Fh=o;function i($,g,f){const P=(0,C.createHash)("md5").update($).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${P}-${f}-${g}-sock`;const N=f.substr(0,4),O=g.substr(0,6),L=P.substr(0,8);let j;return process.platform!=="darwin"&&e.$Eh&&!process.env.VSCODE_PORTABLE?j=(0,R.$ic)(e.$Eh,`vscode-${L}-${N}-${O}.sock`):j=(0,R.$ic)($,`${N}-${O}.sock`),a(j),j}e.$Gh=i;function a($){const g=n[I.$u];typeof g=="number"&&$.length>=g&&console.warn(`WARNING: IPC handle "${$}" is longer than ${g} chars, try a shorter --user-data-dir`)}class u extends y.$rh{static b(g){const f=E.Event.fromNodeEventEmitter(g,"connection");return E.Event.map(f,P=>({protocol:new D.$yh(new v(P,"ipc-server-connection")),onDidClientDisconnect:E.Event.once(E.Event.fromNodeEventEmitter(P,"close"))}))}constructor(g){super(u.b(g)),this.d=g}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Hh=u;function k($){return new Promise((g,f)=>{const P=(0,T.createServer)();P.on("error",f),P.listen($,()=>{P.removeListener("error",f),g(new u(P))})})}e.$Ih=k;function S($,g){return new Promise((f,P)=>{const N=(0,T.createConnection)($,()=>{N.removeListener("error",P),f(D.$zh.fromSocket(new v(N,`ipc-client${g}`),g))});N.once("error",P)})}e.$Jh=S}),define(De[365],Ce([1,0,60,63,163,117,9,3,12,49,13,135,247,248,106,86,22]),function(me,e,C,T,d,M,A,b,E,w,R,I,p,y,D,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W7b=e.$V7b=e.$U7b=e.$T7b=void 0;async function s(t,n,o,i,a){let u;for(let k=3;k&&(u?.dispose(),u=await new r(t,n,o,i,a).waitForReady(),!(a&&d.$gg[a]||!d.$gg[u.tunnelLocalPort]));k--);return u}class r extends b.$Rc{constructor(n,o,i,a,u){super(),this.m=o,this.n=u,this.privacy=v.TunnelPrivacyId.Private,this.j=new Map,this.a=n,this.b=C.createServer(),this.c=new A.$Rg,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=k=>this.r(k),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=a,this.tunnelRemoteHost=i}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(o=>{o()})}async waitForReady(){const n=this.n??this.tunnelRemotePort,o=(0,v.$$u)(this.m)?"0.0.0.0":"127.0.0.1";let i=await(0,d.$hg)(n,2,1e3,o),a=null;return this.b.listen(i,this.m),await this.c.wait(),a=this.b.address(),a||(i=0,this.b.listen(i,this.m),await this.c.wait(),a=this.b.address()),this.tunnelLocalPort=a.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${a.port}`,this}async r(n){n.pause();const o=(0,v.$9u)(this.tunnelRemoteHost)||(0,v.$$u)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,i=await(0,p.$3k)(this.a,o,this.tunnelRemotePort),a=i.getSocket(),u=i.readEntireBuffer();i.dispose(),u.byteLength>0&&n.write(u.buffer),n.on("end",()=>{n.localAddress&&this.j.delete(n.localAddress),a.end()}),n.on("close",()=>a.end()),n.on("error",()=>{n.localAddress&&this.j.delete(n.localAddress),a instanceof M.$Ch?a.socket.destroy():a.end()}),a instanceof M.$Ch?this.t(n,a):this.s(n,a),n.localAddress&&this.j.set(n.localAddress,()=>{n.end(),a.end()})}s(n,o){o.onClose(()=>n.destroy()),o.onEnd(()=>n.end()),o.onData(i=>n.write(i.buffer)),n.on("data",i=>o.write(l.$ae.wrap(i))),n.resume()}t(n,o){const i=o.socket;i.on("end",()=>n.end()),i.on("close",()=>n.end()),i.on("error",()=>{n.destroy()}),i.pipe(n),n.pipe(i)}}e.$T7b=r;let c=class extends v.$bv{constructor(n,o,i,a,u){super(o,u),this.u=n,this.v=i,this.w=a}isPortPrivileged(n){return(0,v.$_u)(n,this.l,E.OS,T.release())}s(n,o,i,a,u,k,S,$){const g=this.r(o,i);if(g)return++g.refcount,g.value;if((0,v.$6u)(n))return this.t(n,o,i,u,k,S,$);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${o}:${i} on local port ${u}.`);const f={commit:this.w.commit,quality:this.w.quality,addressProvider:n,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},P=s(f,a,o,i,u);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(o,i,P),P}}};e.$U7b=c,e.$U7b=c=He([Be(0,y.$Wk),Be(1,R.$8i),Be(2,D.$Zk),Be(3,I.$nj),Be(4,w.$hi)],c);let m=class extends c{constructor(n,o,i,a,u){super(n,o,i,a,u)}};e.$V7b=m,e.$V7b=m=He([Be(0,y.$Wk),Be(1,R.$8i),Be(2,D.$Zk),Be(3,I.$nj),Be(4,w.$hi)],m);let h=class extends b.$Rc{constructor(n,o,i,a,u){super(),this.b=n,this.c=o,this.f=i,this.g=a,this.h=u,this.a=new Map}async openTunnel(n,o,i,a,u,k,S,$,g){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${i}:${a} on local port ${k}.`),!this.a.has(n)){const f=new m(this.b,this.c,this.g,this.f,this.h);this.B(f),this.a.set(n,f),f.onTunnelClosed(async()=>{(await f.tunnels).length===0&&(f.dispose(),this.a.delete(n))})}return this.a.get(n).openTunnel(o,i,a,u,k,S,$,g)}};e.$W7b=h,e.$W7b=h=He([Be(0,y.$Wk),Be(1,R.$8i),Be(2,I.$nj),Be(3,D.$Zk),Be(4,w.$hi)],h)}),define(De[366],Ce([1,0,117,267,53,33,2,13,43]),function(me,e,C,T,d,M,A,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CM=e.$BM=void 0;class w{constructor(p,y,D){this.b=p,this.c=y,this.f=D,this.a=T.createServer((v,l)=>this.h(v,l)),this.g().catch(v=>(y.error(v),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",p=>this.c.error(p))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(p,y){const D=(l,s)=>{y.writeHead(l,{"content-type":"application/json"}),y.end(JSON.stringify(s||null),r=>r&&this.c.error(r))},v=[];p.setEncoding("utf8"),p.on("data",l=>v.push(l)),p.on("end",async()=>{try{const l=JSON.parse(v.join(""));let s;switch(l.type){case"open":s=await this.i(l);break;case"openExternal":s=await this.j(l);break;case"status":s=await this.l(l);break;case"extensionManagement":s=await this.k(l);break;default:D(404,`Unknown message type: ${l.type}`);break}D(200,s)}catch(l){const s=l instanceof Error?l.message:JSON.stringify(l);D(500,s),this.c.error("Error while processing pipe request",l)}})}async i(p){const{fileURIs:y,folderURIs:D,forceNewWindow:v,diffMode:l,mergeMode:s,addMode:r,forceReuseWindow:c,gotoLineMode:m,waitMarkerFilePath:h,remoteAuthority:t}=p,n=[];if(Array.isArray(D))for(const u of D)try{n.push({folderUri:A.URI.parse(u)})}catch{}if(Array.isArray(y))for(const u of y)try{(0,E.$gi)(u)?n.push({workspaceUri:A.URI.parse(u)}):n.push({fileUri:A.URI.parse(u)})}catch{}const o=h?A.URI.file(h):void 0,a={forceNewWindow:v,diffMode:l,mergeMode:s,addMode:r,gotoLineMode:m,forceReuseWindow:c,preferNewWindow:!c&&!o&&!r,waitMarkerFileURI:o,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",n,a)}async j(p){for(const y of p.uris){const D=A.URI.parse(y),v=D.scheme==="file"?D:y;await this.b.executeCommand("_remoteCLI.openExternal",v)}}async k(p){const y=v=>v?.map(l=>/\.vsix$/i.test(l)?A.URI.parse(l):l),D={list:p.list,install:y(p.install),uninstall:y(p.uninstall),force:p.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",D)}async l(p){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&d.existsSync(this.f)&&d.unlinkSync(this.f)}}e.$BM=w;let R=class extends w{constructor(p,y){super(p,y,(0,C.$Fh)())}};e.$CM=R,e.$CM=R=He([Be(0,M.$wM),Be(1,b.$8i)],R)}),define(De[367],Ce([1,0,54,354,349,266,45,337,2,17,7,366,100,335,336]),function(me,e,C,T,d,M,A,b,E,w,R,I,p,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sec=void 0;class v extends d.$Tdc{j(){const r=this,c=globalThis._VSCODE_NODE_MODULES.module,m=c._load;c._load=function(o,i,a){return o=t(o),r.a.has(o)?r.a.get(o).load(o,E.URI.file((0,p.$4p)(i.filename)),u=>m.apply(this,[u,i,a])):m.apply(this,arguments)};const h=c._resolveLookupPaths;c._resolveLookupPaths=(n,o)=>h.call(this,t(n),o);const t=n=>{for(const o of r.b){const i=o(n);if(i){n=i;break}}return n}}}class l extends A.$ucc{constructor(){super(...arguments),this.extensionRuntime=R.ExtensionRuntime.Node}async tb(){this.h.createInstance(y.$qec);const r=this.h.invokeFunction(T.$Pdc);if(this.h.createInstance(b.$pec),this.f.remote.isRemote&&this.f.remote.authority){const h=this.h.createInstance(I.$CM);process.env.VSCODE_IPC_HOOK_CLI=h.ipcHandlePath}this.h.createInstance(D.$rec),await this.h.createInstance(v,r,{mine:this.J,all:this.L}).install(),C.mark("code/extHost/didInitAPI");const m=await this.m.getConfigProvider();await(0,M.$oec)(this.j,m,this,this.s,this.z,this.f),C.mark("code/extHost/didInitProxyResolver")}ub(r){return r.main}async vb(r,c,m){if(c.scheme!==w.Schemas.file)throw new Error(`Cannot load URI: '${c}', must be of file-scheme`);let h=null;m.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${c.toString(!0)}`),this.s.flush();const t=r?.identifier.value;r&&await this.w.initializeLocalizedMessages(r);try{t&&C.mark(`code/extHost/willLoadExtensionCode/${t}`),h=me.__$__nodeRequire(c.fsPath)}finally{t&&C.mark(`code/extHost/didLoadExtensionCode/${t}`),m.codeLoadingStop()}return h}async $setRemoteEnvironment(r){if(this.f.remote.isRemote)for(const c in r){const m=r[c];m===null?delete process.env[c]:process.env[c]=m}}}e.$sec=l}),define(De[368],Ce([1,0,48,22,4,3,120,12,24,2,29,13,246,64,106,86,365,27,20,72,345]),function(me,e,C,T,d,M,A,b,E,w,R,I,p,y,D,v,l,s,r,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aec=e.$zec=e.$yec=e.$xec=e.$wec=e.$vec=e.$uec=e.$tec=void 0;function h(g){const f=g.trim().split(`
`),P=[];return f.forEach(O=>{const L=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(O);L&&L.length>=3&&P.push({pid:parseInt(L[1],10),socket:parseInt(L[2],10)})}),P.reduce((O,L)=>(O[L.socket]=L,O),{})}e.$tec=h;function t(...g){const f=[].concat(...g.map(o));return[...new Map(f.filter(P=>P.st==="0A").map(P=>{const N=P.local_address.split(":");return{socket:parseInt(P.inode,10),ip:n(N[0]),port:parseInt(N[1],16)}}).map(P=>[P.ip+":"+P.port,P])).values()]}e.$uec=t;function n(g){let f="";if(g.length===8)for(let P=g.length-2;P>=0;P-=2)f+=parseInt(g.substr(P,2),16),P!==0&&(f+=".");else for(let P=0;P<g.length;P+=8){const N=g.substring(P,P+8);let O="";for(let L=8;L>=2;L-=2)O+=N.substring(L-2,L),(L===6||L===2)&&(O=parseInt(O,16).toString(16),f+=`${O}`,O="",P+L!==g.length-6&&(f+=":"))}return f}e.$vec=n;function o(g){const f=g.trim().split(`
`),P=f.shift().trim().split(/\s+/).filter(O=>O!=="rx_queue"&&O!=="tm->when");return f.map(O=>O.trim().split(/\s+/).reduce((L,j,z)=>(L[P[z]||z]=j,L),{}))}e.$wec=o;function i(g){return!!g.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||g.indexOf("out/server-main.js")!==-1||g.indexOf("_productName=VSCode")!==-1}function a(g){const f=g.trim().split(`
`),P=[];return f.forEach(N=>{const O=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(N);O&&O.length>=4&&P.push({pid:parseInt(O[1],10),ppid:parseInt(O[2]),cmd:O[3]})}),P}e.$xec=a;async function u(g,f,P){const N=P.reduce((L,j)=>(L[j.pid]=j,L),{}),O=[];return g.forEach(({socket:L,ip:j,port:z})=>{const F=f[L]?f[L].pid:void 0,H=F?N[F]?.cmd:void 0;F&&H&&!i(H)&&O.push({host:j,port:z,detail:H,pid:F})}),O}e.$yec=u;function k(g,f,P){const N=new Map,O=a(f);for(const L of g){const j=P.get(L.port);if(j){N.set(L.port,j);continue}const z=O.find(F=>F.cmd.includes(`${L.port}`));if(z){let F=z,H;do H=O.find(K=>K.ppid===F.pid),H&&(F=H);while(H);N.set(L.port,{host:L.ip,port:L.port,pid:F.pid,detail:F.cmd,ppid:F.ppid})}else N.set(L.port,{host:L.ip,port:L.port,ppid:Number.MAX_VALUE})}return N}e.$zec=k;let S=class extends c.$Xvb{constructor(f,P,N,O){super(f,P,N),this.D=P,this.F=O,this.y=void 0,this.z=new Map,this.C=!1,b.$l&&P.remote.isRemote&&P.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(f){if(f&&this.C)return;this.C=f;let P;this.y&&(P=this.y,await this.a.$onFoundNewCandidates(this.y));const N=new A.$Nl;let O=0;for(;this.C;){const L=new Date().getTime(),j=(await this.I()).filter(H=>(0,v.$9u)(H.host)||(0,v.$$u)(H.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${j.map(H=>H.port).join(", ")}`);const z=new Date().getTime()-L;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${z} ms.`),O++>3&&N.update(z),(!P||JSON.stringify(P)!==JSON.stringify(j))&&(P=j,await this.a.$onFoundNewCandidates(P));const F=this.G(N.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${F} ms.`),await new Promise(H=>setTimeout(()=>H(),F))}}G(f){return Math.max(f*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(f=>f.port).join(", ")}`)}async I(){let f="",P="";try{f=await R.Promises.readFile("/proc/net/tcp","utf8"),P=await R.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const N=t(f,P),O=await new Promise(x=>{(0,C.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(Z,q,Y)=>{x(q)})}),L=h(O),j=await R.Promises.readdir("/proc"),z=[];for(const x of j)try{const Z=Number(x),q=E.$ug(w.URI.file("/proc"),x);if((await R.Promises.stat(q.fsPath)).isDirectory()&&!isNaN(Z)){const be=await R.Promises.readlink(E.$ug(q,"cwd").fsPath),ue=await R.Promises.readFile(E.$ug(q,"cmdline").fsPath,"utf8");z.push({pid:Z,cwd:be,cmd:ue})}}catch{}const F=[],H=N.filter(x=>{const Z=L[x.socket];return Z||F.push(x),Z}),K=u(H,L,z);let fe;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${F.length}`),F.length>0){const x=await new Promise(Z=>{(0,C.exec)("ps -F -A -l | grep root",(q,Y,be)=>{Z(Y)})});this.z=k(F,x,this.z),fe=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${fe.map(Z=>Z.port).join(", ")}`)}return K.then(x=>fe?x.concat(fe):x)}w(f){return async P=>{const N=new l.$T7b({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(L,j,z,F){const H=await f.makeConnection();return $.connect(H,j,z,F)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new y.$Nk(0),connectionToken:f.connectionToken})}},signService:this.F},"localhost",P.remoteAddress.host||"localhost",P.remoteAddress.port,P.localAddressPort);await N.waitForReady();const O=new d.$Md;return{localAddress:(0,m.$zJ)(N.localAddress)??N.localAddress,remoteAddress:{port:N.tunnelRemotePort,host:N.tunnelRemoteHost},onDidDispose:O.event,dispose:()=>{N.dispose(),O.fire(),O.dispose()}}}}};e.$Aec=S,e.$Aec=S=He([Be(0,r.$aM),Be(1,s.$qM),Be(2,I.$8i),Be(3,D.$Zk)],S);class $ extends p.$vkb{static connect(f,P,N,O){const L=new M.$Qc,j={onClose:L.add(new d.$Md),onData:L.add(new d.$Md),onEnd:L.add(new d.$Md)};L.add(f.onDidReceiveMessage(F=>j.onData.fire(T.$ae.wrap(F)))),L.add(f.onDidEnd(()=>j.onEnd.fire())),L.add(f.onDidClose(F=>j.onClose.fire({type:0,error:F,hadError:!!F})));const z=new $(f,O,j);return z.B(L),(0,p.$ukb)(z,P,N,O,j)}constructor(f,P,N){super(P,N),this.n=f}write(f){this.n.send(f.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(De[369],Ce([1,0,103,340,352,351,364,367,368,94,45,95,93,44,72,90,339,338,13,353,56,261,102,106,138]),function(me,e,C,T,d,M,A,b,E,w,R,I,p,y,D,v,l,s,r,c,m,h,t,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,C.$sr)(R.$vcc,b.$sec,0),(0,C.$sr)(r.$9i,s.$Cec,1),(0,C.$sr)(r.$8i,new t.$Kh(h.$Sdc,[!1],!0)),(0,C.$sr)(n.$Zk,o.$Y7b,1),(0,C.$sr)(v.$gcc,l.$Bec,0),(0,C.$sr)(w.$6cc,M.$6dc,0),(0,C.$sr)(I.$ddc,A.$nec,0),(0,C.$sr)(p.$1cc,d.$Xdc,0),(0,C.$sr)(y.$icc,T.$Wdc,0),(0,C.$sr)(D.$Wvb,E.$Aec,0),(0,C.$sr)(m.$4cc,c.$Dec,0)}),define(De[380],Ce([1,0,60,381,54,8,81,117,244,111,350,22,29,100,9,130,268,285,355,369]),function(me,e,C,T,d,M,A,b,E,w,R,I,p,y,D,v,l,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let u=0;u<process.execArgv.length;u++)process.execArgv[u]==="--inspect-port=0"&&(process.execArgv.splice(u,1),u--)}();const r=T(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const a=globalThis._VSCODE_NODE_MODULES.module,u=a._load;a._load=function(k){if(k==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return u.apply(this,arguments)}})();const c=process.exit.bind(process);function m(a){process.exit=function(u){if(a)c(u);else{const k=new Error("An extension called process.exit() and this was prevented.");console.warn(k.stack)}},process.crash=function(){const u=new Error("An extension called process.crash() and this was prevented.");console.warn(u.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let h=function(a){c()};function t(){const a=(0,s.$xm)(process.env);if(a.type===3)return new Promise((u,k)=>{const S=$=>{const g=$[0],f=new A.$Ah;g.on("message",P=>f.fire(I.$ae.wrap(P.data))),g.on("close",()=>{h("renderer closed the MessagePort")}),g.start(),u({onMessage:f.event,send:P=>g.postMessage(P.buffer)})};process.parentPort.on("message",$=>S($.ports))});if(a.type===2)return new Promise((u,k)=>{let S=null;const $=setTimeout(()=>{h("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),g=108e5,f=3e5,P=new D.$6g(()=>h("renderer disconnected for too long (1)"),g),N=new D.$6g(()=>h("renderer disconnected for too long (2)"),f);process.on("message",(L,j)=>{if(L&&L.type==="VSCODE_EXTHOST_IPC_SOCKET"){j.setNoDelay(!0);const z=I.$ae.wrap(Buffer.from(L.initialDataChunk,"base64"));let F;if(L.skipWebSocketFrames)F=new b.$Ch(j,"extHost-socket");else{const H=I.$ae.wrap(Buffer.from(L.inflateBytes,"base64"));F=new b.$Dh(new b.$Ch(j,"extHost-socket"),L.permessageDeflate,H,!1)}S?(P.cancel(),N.cancel(),S.beginAcceptReconnection(F,z),S.endAcceptReconnection(),S.sendResume()):(clearTimeout($),S=new A.$Bh({socket:F,initialChunk:z}),S.sendResume(),S.onDidDispose(()=>h("renderer disconnected")),u(S),S.onSocketClose(()=>{P.schedule()}))}if(L&&L.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(N.isScheduled())return;P.isScheduled()&&N.schedule()}});const O={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(O)});{const u=a.pipeName;return new Promise((k,S)=>{const $=C.createConnection(u,()=>{$.removeListener("error",S);const g=new A.$Bh({socket:new b.$Ch($,"extHost-renderer")});g.sendResume(),k(g)});$.once("error",S),$.on("close",()=>{h("renderer closed the socket")})})}}async function n(){const a=await t();return new class{constructor(){this.a=new A.$Ah,this.onMessage=this.a.event,this.b=!1,a.onMessage(u=>{(0,w.$$l)(u,2)?(this.b=!0,h("received terminate message from renderer")):this.a.fire(u)})}send(u){this.b||a.send(u)}async drain(){if(a.drain)return a.drain()}}}function o(a){return new Promise(u=>{const k=a.onMessage(S=>{k.dispose();const $=JSON.parse(S.toString()),g=$.commit,f=E.default.commit;if(g&&f&&g!==f&&c(55),$.parentPid){let P=0;setInterval(function(){try{process.kill($.parentPid,0),P=0}catch(O){O&&O.code==="EPERM"?(P++,P>=3&&h(`parent process ${$.parentPid} does not exist anymore (3 x EPERM): ${O.message} (code: ${O.code}) (errno: ${O.errno})`)):h(`parent process ${$.parentPid} does not exist anymore: ${O.message} (code: ${O.code}) (errno: ${O.errno})`)}},1e3);let N;try{N=globalThis._VSCODE_NODE_MODULES["native-watchdog"],N.start($.parentPid)}catch(O){(0,M.$Z)(O)}}a.send((0,w.$0l)(0)),u({protocol:a,initData:$})});a.send((0,w.$0l)(1))})}async function i(){const a=[];process.on("unhandledRejection",(P,N)=>{a.push(N),setTimeout(()=>{const O=a.indexOf(N);O>=0&&N.catch(L=>{a.splice(O,1),(0,M.$3)(L)||(console.warn(`rejected promise not handled within 1 second: ${L}`),L&&L.stack&&console.warn(`stack trace: ${L.stack}`),P&&(0,M.$Z)(P))})},1e3)}),process.on("rejectionHandled",P=>{const N=a.indexOf(P);N>=0&&a.splice(N,1)}),process.on("uncaughtException",function(P){(0,M.$Y)(P)||(0,M.$Z)(P)}),d.mark("code/extHost/willConnectToRenderer");const u=await n();d.mark("code/extHost/didConnectToRenderer");const k=await o(u);d.mark("code/extHost/didWaitForInitData");const{initData:S}=k;m(!!S.environment.extensionTestsLocationURI),S.environment.useHostProxy=r.useHostProxy!==void 0?r.useHostProxy!=="false":void 0,S.environment.skipWorkspaceStorageLock=(0,v.boolean)(r.skipWorkspaceStorageLock,!1);const $=new class{constructor(){this.pid=process.pid}exit(N){c(N)}fsExists(N){return p.Promises.exists(N)}fsRealpath(N){return(0,y.$3p)(N)}};let g=null;S.remote.authority&&r.transformURIs&&(g=(0,l.$wr)(S.remote.authority));const f=new R.$Vdc(k.protocol,S,$,g);h=P=>f.terminate(P)}i().catch(a=>console.log(a))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/eb4f3c149f34d82b9763a08230907cf79e7fc103/core/vs/workbench/api/node/extensionHostProcess.js.map
