/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Re=["exports","require","vs/base/common/uri","vs/workbench/api/common/extHost.protocol","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/errors","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/async","vs/base/common/network","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/platform/extensions/common/extensions","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/resources","vs/base/common/objects","vs/workbench/services/extensions/common/extensions","vs/base/common/buffer","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/base/common/severity","vs/platform/registry/common/platform","vs/workbench/api/common/extHostCommands","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/base/common/themables","vs/base/common/errorMessage","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/editor/common/core/range","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/lazy","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/base/common/stopwatch","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/mime","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/editor/common/languages","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChat","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/base/common/arraysFind","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Me=function(be){for(var e=[],w=0,M=be.length;w<M;w++)e[w]=Re[be[w]];return e};define(Re[64],Me([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hh=e.$gh=e.$fh=void 0;function w(A){return(l,k,f)=>{let R=null,D=null;if(typeof f.value=="function"?(R="value",D=f.value):typeof f.get=="function"&&(R="get",D=f.get),!D)throw new Error("not supported");f[R]=A(D,k)}}function M(A,l,k){let f=null,R=null;if(typeof k.value=="function"?(f="value",R=k.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof k.get=="function"&&(f="get",R=k.get),!R)throw new Error("not supported");const D=`$memoize$${l}`;k[f]=function(...c){return this.hasOwnProperty(D)||Object.defineProperty(this,D,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,c)}),this[D]}}e.$fh=M;function C(A,l,k){return w((f,R)=>{const D=`$debounce$${R}`,c=`$debounce$result$${R}`;return function(...p){this[c]||(this[c]=k?k():void 0),clearTimeout(this[D]),l&&(this[c]=l(this[c],...p),p=[this[c]]),this[D]=setTimeout(()=>{f.apply(this,p),this[c]=k?k():void 0},A)}})}e.$gh=C;function F(A,l,k){return w((f,R)=>{const D=`$throttle$timer$${R}`,c=`$throttle$result$${R}`,p=`$throttle$lastRun$${R}`,$=`$throttle$pending$${R}`;return function(...g){if(this[c]||(this[c]=k?k():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),l&&(this[c]=l(this[c],...g)),this[$])return;const t=this[p]+A;t<=Date.now()?(this[p]=Date.now(),f.apply(this,[this[c]]),this[c]=k?k():void 0):(this[$]=!0,this[D]=setTimeout(()=>{this[$]=!1,this[p]=Date.now(),f.apply(this,[this[c]]),this[c]=k?k():void 0},t-Date.now()))}})}e.$hh=F}),define(Re[88],Me([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gM=e.$fM=void 0;class w{constructor(C){this.a=C,this.b=0}nextId(){return this.a+ ++this.b}}e.$fM=w,e.$gM=new w("id#")}),define(Re[115],Me([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.$Vm=e.$Um=e.$Tm=e.$Sm=e.$Rm=e.$Qm=e.$Pm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var w;(function(r){r[r.None=0]="None",r[r.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=2]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",r[r.InvalidUnicode=4]="InvalidUnicode",r[r.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",r[r.InvalidCharacter=6]="InvalidCharacter"})(w||(e.ScanError=w={}));var M;(function(r){r[r.OpenBraceToken=1]="OpenBraceToken",r[r.CloseBraceToken=2]="CloseBraceToken",r[r.OpenBracketToken=3]="OpenBracketToken",r[r.CloseBracketToken=4]="CloseBracketToken",r[r.CommaToken=5]="CommaToken",r[r.ColonToken=6]="ColonToken",r[r.NullKeyword=7]="NullKeyword",r[r.TrueKeyword=8]="TrueKeyword",r[r.FalseKeyword=9]="FalseKeyword",r[r.StringLiteral=10]="StringLiteral",r[r.NumericLiteral=11]="NumericLiteral",r[r.LineCommentTrivia=12]="LineCommentTrivia",r[r.BlockCommentTrivia=13]="BlockCommentTrivia",r[r.LineBreakTrivia=14]="LineBreakTrivia",r[r.Trivia=15]="Trivia",r[r.Unknown=16]="Unknown",r[r.EOF=17]="EOF"})(M||(e.SyntaxKind=M={}));var C;(function(r){r[r.InvalidSymbol=1]="InvalidSymbol",r[r.InvalidNumberFormat=2]="InvalidNumberFormat",r[r.PropertyNameExpected=3]="PropertyNameExpected",r[r.ValueExpected=4]="ValueExpected",r[r.ColonExpected=5]="ColonExpected",r[r.CommaExpected=6]="CommaExpected",r[r.CloseBraceExpected=7]="CloseBraceExpected",r[r.CloseBracketExpected=8]="CloseBracketExpected",r[r.EndOfFileExpected=9]="EndOfFileExpected",r[r.InvalidCommentToken=10]="InvalidCommentToken",r[r.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=12]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",r[r.InvalidUnicode=14]="InvalidUnicode",r[r.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",r[r.InvalidCharacter=16]="InvalidCharacter"})(C||(e.ParseErrorCode=C={}));var F;(function(r){r.DEFAULT={allowTrailingComma:!0}})(F||(e.ParseOptions=F={}));function A(r,s=!1){let i=0;const o=r.length;let y="",d=0,I=16,S=0;function u(B){let O=0,N=0;for(;O<B;){const te=r.charCodeAt(i);if(te>=48&&te<=57)N=N*16+te-48;else if(te>=65&&te<=70)N=N*16+te-65+10;else if(te>=97&&te<=102)N=N*16+te-97+10;else break;i++,O++}return O<B&&(N=-1),N}function m(B){i=B,y="",d=0,I=16,S=0}function h(){const B=i;if(r.charCodeAt(i)===48)i++;else for(i++;i<r.length&&f(r.charCodeAt(i));)i++;if(i<r.length&&r.charCodeAt(i)===46)if(i++,i<r.length&&f(r.charCodeAt(i)))for(i++;i<r.length&&f(r.charCodeAt(i));)i++;else return S=3,r.substring(B,i);let O=i;if(i<r.length&&(r.charCodeAt(i)===69||r.charCodeAt(i)===101))if(i++,(i<r.length&&r.charCodeAt(i)===43||r.charCodeAt(i)===45)&&i++,i<r.length&&f(r.charCodeAt(i))){for(i++;i<r.length&&f(r.charCodeAt(i));)i++;O=i}else S=3;return r.substring(B,O)}function P(){let B="",O=i;for(;;){if(i>=o){B+=r.substring(O,i),S=2;break}const N=r.charCodeAt(i);if(N===34){B+=r.substring(O,i),i++;break}if(N===92){if(B+=r.substring(O,i),i++,i>=o){S=2;break}switch(r.charCodeAt(i++)){case 34:B+='"';break;case 92:B+="\\";break;case 47:B+="/";break;case 98:B+="\b";break;case 102:B+="\f";break;case 110:B+=`
`;break;case 114:B+="\r";break;case 116:B+="	";break;case 117:{const Y=u(4);Y>=0?B+=String.fromCharCode(Y):S=4;break}default:S=5}O=i;continue}if(N>=0&&N<=31)if(k(N)){B+=r.substring(O,i),S=2;break}else S=6;i++}return B}function W(){if(y="",S=0,d=i,i>=o)return d=o,I=17;let B=r.charCodeAt(i);if(l(B)){do i++,y+=String.fromCharCode(B),B=r.charCodeAt(i);while(l(B));return I=15}if(k(B))return i++,y+=String.fromCharCode(B),B===13&&r.charCodeAt(i)===10&&(i++,y+=`
`),I=14;switch(B){case 123:return i++,I=1;case 125:return i++,I=2;case 91:return i++,I=3;case 93:return i++,I=4;case 58:return i++,I=6;case 44:return i++,I=5;case 34:return i++,y=P(),I=10;case 47:{const O=i-1;if(r.charCodeAt(i+1)===47){for(i+=2;i<o&&!k(r.charCodeAt(i));)i++;return y=r.substring(O,i),I=12}if(r.charCodeAt(i+1)===42){i+=2;const N=o-1;let te=!1;for(;i<N;){if(r.charCodeAt(i)===42&&r.charCodeAt(i+1)===47){i+=2,te=!0;break}i++}return te||(i++,S=1),y=r.substring(O,i),I=13}return y+=String.fromCharCode(B),i++,I=16}case 45:if(y+=String.fromCharCode(B),i++,i===o||!f(r.charCodeAt(i)))return I=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return y+=h(),I=11;default:for(;i<o&&K(B);)i++,B=r.charCodeAt(i);if(d!==i){switch(y=r.substring(d,i),y){case"true":return I=8;case"false":return I=9;case"null":return I=7}return I=16}return y+=String.fromCharCode(B),i++,I=16}}function K(B){if(l(B)||k(B))return!1;switch(B){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function U(){let B;do B=W();while(B>=12&&B<=15);return B}return{setPosition:m,getPosition:()=>i,scan:s?U:W,getToken:()=>I,getTokenValue:()=>y,getTokenOffset:()=>d,getTokenLength:()=>i-d,getTokenError:()=>S}}e.$Pm=A;function l(r){return r===32||r===9||r===11||r===12||r===160||r===5760||r>=8192&&r<=8203||r===8239||r===8287||r===12288||r===65279}function k(r){return r===10||r===13||r===8232||r===8233}function f(r){return r>=48&&r<=57}var R;(function(r){r[r.nullCharacter=0]="nullCharacter",r[r.maxAsciiCharacter=127]="maxAsciiCharacter",r[r.lineFeed=10]="lineFeed",r[r.carriageReturn=13]="carriageReturn",r[r.lineSeparator=8232]="lineSeparator",r[r.paragraphSeparator=8233]="paragraphSeparator",r[r.nextLine=133]="nextLine",r[r.space=32]="space",r[r.nonBreakingSpace=160]="nonBreakingSpace",r[r.enQuad=8192]="enQuad",r[r.emQuad=8193]="emQuad",r[r.enSpace=8194]="enSpace",r[r.emSpace=8195]="emSpace",r[r.threePerEmSpace=8196]="threePerEmSpace",r[r.fourPerEmSpace=8197]="fourPerEmSpace",r[r.sixPerEmSpace=8198]="sixPerEmSpace",r[r.figureSpace=8199]="figureSpace",r[r.punctuationSpace=8200]="punctuationSpace",r[r.thinSpace=8201]="thinSpace",r[r.hairSpace=8202]="hairSpace",r[r.zeroWidthSpace=8203]="zeroWidthSpace",r[r.narrowNoBreakSpace=8239]="narrowNoBreakSpace",r[r.ideographicSpace=12288]="ideographicSpace",r[r.mathematicalSpace=8287]="mathematicalSpace",r[r.ogham=5760]="ogham",r[r._=95]="_",r[r.$=36]="$",r[r._0=48]="_0",r[r._1=49]="_1",r[r._2=50]="_2",r[r._3=51]="_3",r[r._4=52]="_4",r[r._5=53]="_5",r[r._6=54]="_6",r[r._7=55]="_7",r[r._8=56]="_8",r[r._9=57]="_9",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.ampersand=38]="ampersand",r[r.asterisk=42]="asterisk",r[r.at=64]="at",r[r.backslash=92]="backslash",r[r.bar=124]="bar",r[r.caret=94]="caret",r[r.closeBrace=125]="closeBrace",r[r.closeBracket=93]="closeBracket",r[r.closeParen=41]="closeParen",r[r.colon=58]="colon",r[r.comma=44]="comma",r[r.dot=46]="dot",r[r.doubleQuote=34]="doubleQuote",r[r.equals=61]="equals",r[r.exclamation=33]="exclamation",r[r.greaterThan=62]="greaterThan",r[r.lessThan=60]="lessThan",r[r.minus=45]="minus",r[r.openBrace=123]="openBrace",r[r.openBracket=91]="openBracket",r[r.openParen=40]="openParen",r[r.percent=37]="percent",r[r.plus=43]="plus",r[r.question=63]="question",r[r.semicolon=59]="semicolon",r[r.singleQuote=39]="singleQuote",r[r.slash=47]="slash",r[r.tilde=126]="tilde",r[r.backspace=8]="backspace",r[r.formFeed=12]="formFeed",r[r.byteOrderMark=65279]="byteOrderMark",r[r.tab=9]="tab",r[r.verticalTab=11]="verticalTab"})(R||(R={}));function D(r,s){const i=[],o=new Object;let y;const d={value:{},offset:0,length:0,type:"object",parent:void 0};let I=!1;function S(u,m,h,P){d.value=u,d.offset=m,d.length=h,d.type=P,d.colonOffset=void 0,y=d}try{b(r,{onObjectBegin:(u,m)=>{if(s<=u)throw o;y=void 0,I=s>u,i.push("")},onObjectProperty:(u,m,h)=>{if(s<m||(S(u,m,h,"property"),i[i.length-1]=u,s<=m+h))throw o},onObjectEnd:(u,m)=>{if(s<=u)throw o;y=void 0,i.pop()},onArrayBegin:(u,m)=>{if(s<=u)throw o;y=void 0,i.push(0)},onArrayEnd:(u,m)=>{if(s<=u)throw o;y=void 0,i.pop()},onLiteralValue:(u,m,h)=>{if(s<m||(S(u,m,h,v(u)),s<=m+h))throw o},onSeparator:(u,m,h)=>{if(s<=m)throw o;if(u===":"&&y&&y.type==="property")y.colonOffset=m,I=!1,y=void 0;else if(u===","){const P=i[i.length-1];typeof P=="number"?i[i.length-1]=P+1:(I=!0,i[i.length-1]=""),y=void 0}}})}catch(u){if(u!==o)throw u}return{path:i,previousNode:y,isAtPropertyKey:I,matches:u=>{let m=0;for(let h=0;m<u.length&&h<i.length;h++)if(u[m]===i[h]||u[m]==="*")m++;else if(u[m]!=="**")return!1;return m===u.length}}}e.$Qm=D;function c(r,s=[],i=F.DEFAULT){let o=null,y=[];const d=[];function I(u){Array.isArray(y)?y.push(u):o!==null&&(y[o]=u)}return b(r,{onObjectBegin:()=>{const u={};I(u),d.push(y),y=u,o=null},onObjectProperty:u=>{o=u},onObjectEnd:()=>{y=d.pop()},onArrayBegin:()=>{const u=[];I(u),d.push(y),y=u,o=null},onArrayEnd:()=>{y=d.pop()},onLiteralValue:I,onError:(u,m,h)=>{s.push({error:u,offset:m,length:h})}},i),y[0]}e.$Rm=c;function p(r,s=[],i=F.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function y(u){o.type==="property"&&(o.length=u-o.offset,o=o.parent)}function d(u){return o.children.push(u),u}b(r,{onObjectBegin:u=>{o=d({type:"object",offset:u,length:-1,parent:o,children:[]})},onObjectProperty:(u,m,h)=>{o=d({type:"property",offset:m,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:u,offset:m,length:h,parent:o})},onObjectEnd:(u,m)=>{o.length=u+m-o.offset,o=o.parent,y(u+m)},onArrayBegin:(u,m)=>{o=d({type:"array",offset:u,length:-1,parent:o,children:[]})},onArrayEnd:(u,m)=>{o.length=u+m-o.offset,o=o.parent,y(u+m)},onLiteralValue:(u,m,h)=>{d({type:v(u),offset:m,length:h,parent:o,value:u}),y(m+h)},onSeparator:(u,m,h)=>{o.type==="property"&&(u===":"?o.colonOffset=m:u===","&&y(m))},onError:(u,m,h)=>{s.push({error:u,offset:m,length:h})}},i);const S=o.children[0];return S&&delete S.parent,S}e.$Sm=p;function $(r,s){if(!r)return;let i=r;for(const o of s)if(typeof o=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let y=!1;for(const d of i.children)if(Array.isArray(d.children)&&d.children[0].value===o){i=d.children[1],y=!0;break}if(!y)return}else{const y=o;if(i.type!=="array"||y<0||!Array.isArray(i.children)||y>=i.children.length)return;i=i.children[y]}return i}e.$Tm=$;function g(r){if(!r.parent||!r.parent.children)return[];const s=g(r.parent);if(r.parent.type==="property"){const i=r.parent.children[0].value;s.push(i)}else if(r.parent.type==="array"){const i=r.parent.children.indexOf(r);i!==-1&&s.push(i)}return s}e.$Um=g;function t(r){switch(r.type){case"array":return r.children.map(t);case"object":{const s=Object.create(null);for(const i of r.children){const o=i.children[1];o&&(s[i.children[0].value]=t(o))}return s}case"null":case"string":case"number":case"boolean":return r.value;default:return}}e.$Vm=t;function n(r,s,i=!1){return s>=r.offset&&s<r.offset+r.length||i&&s===r.offset+r.length}e.$Wm=n;function a(r,s,i=!1){if(n(r,s,i)){const o=r.children;if(Array.isArray(o))for(let y=0;y<o.length&&o[y].offset<=s;y++){const d=a(o[y],s,i);if(d)return d}return r}}e.$Xm=a;function b(r,s,i=F.DEFAULT){const o=A(r,!1);function y(Se){return Se?()=>Se(o.getTokenOffset(),o.getTokenLength()):()=>!0}function d(Se){return Se?ue=>Se(ue,o.getTokenOffset(),o.getTokenLength()):()=>!0}const I=y(s.onObjectBegin),S=d(s.onObjectProperty),u=y(s.onObjectEnd),m=y(s.onArrayBegin),h=y(s.onArrayEnd),P=d(s.onLiteralValue),W=d(s.onSeparator),K=y(s.onComment),U=d(s.onError),B=i&&i.disallowComments,O=i&&i.allowTrailingComma;function N(){for(;;){const Se=o.scan();switch(o.getTokenError()){case 4:te(14);break;case 5:te(15);break;case 3:te(13);break;case 1:B||te(11);break;case 2:te(12);break;case 6:te(16);break}switch(Se){case 12:case 13:B?te(10):K();break;case 16:te(1);break;case 15:case 14:break;default:return Se}}}function te(Se,ue=[],$e=[]){if(U(Se),ue.length+$e.length>0){let ie=o.getToken();for(;ie!==17;){if(ue.indexOf(ie)!==-1){N();break}else if($e.indexOf(ie)!==-1)break;ie=N()}}}function Y(Se){const ue=o.getTokenValue();return Se?P(ue):S(ue),N(),!0}function ye(){switch(o.getToken()){case 11:{let Se=0;try{Se=JSON.parse(o.getTokenValue()),typeof Se!="number"&&(te(2),Se=0)}catch{te(2)}P(Se);break}case 7:P(null);break;case 8:P(!0);break;case 9:P(!1);break;default:return!1}return N(),!0}function Ee(){return o.getToken()!==10?(te(3,[],[2,5]),!1):(Y(!1),o.getToken()===6?(W(":"),N(),ae()||te(4,[],[2,5])):te(5,[],[2,5]),!0)}function Pe(){I(),N();let Se=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(Se||te(4,[],[]),W(","),N(),o.getToken()===2&&O)break}else Se&&te(6,[],[]);Ee()||te(4,[],[2,5]),Se=!0}return u(),o.getToken()!==2?te(7,[2],[]):N(),!0}function X(){m(),N();let Se=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(Se||te(4,[],[]),W(","),N(),o.getToken()===4&&O)break}else Se&&te(6,[],[]);ae()||te(4,[],[4,5]),Se=!0}return h(),o.getToken()!==4?te(8,[4],[]):N(),!0}function ae(){switch(o.getToken()){case 3:return X();case 1:return Pe();case 10:return Y(!0);default:return ye()}}return N(),o.getToken()===17?i.allowEmptyContent?!0:(te(4,[],[]),!1):ae()?(o.getToken()!==17&&te(9,[],[]),!0):(te(4,[],[]),!1)}e.$Ym=b;function E(r,s){const i=A(r),o=[];let y,d=0,I;do switch(I=i.getPosition(),y=i.scan(),y){case 12:case 13:case 17:d!==I&&o.push(r.substring(d,I)),s!==void 0&&o.push(i.getTokenValue().replace(/[^\r\n]/g,s)),d=i.getPosition();break}while(y!==17);return o.join("")}e.$Zm=E;function v(r){switch(typeof r){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(r){if(Array.isArray(r))return"array"}else return"null";return"object"}default:return"null"}}e.$1m=v}),function(be,e){typeof define=="function"&&define.amd?define(Re[116],Me([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(be=typeof globalThis<"u"?globalThis:be||self,e(be.marked={}))}(this,function(be){"use strict";function e(ve,me){for(var De=0;De<me.length;De++){var re=me[De];re.enumerable=re.enumerable||!1,re.configurable=!0,"value"in re&&(re.writable=!0),Object.defineProperty(ve,re.key,re)}}function w(ve,me,De){return me&&e(ve.prototype,me),De&&e(ve,De),Object.defineProperty(ve,"prototype",{writable:!1}),ve}function M(ve,me){if(ve){if(typeof ve=="string")return C(ve,me);var De=Object.prototype.toString.call(ve).slice(8,-1);if(De==="Object"&&ve.constructor&&(De=ve.constructor.name),De==="Map"||De==="Set")return Array.from(ve);if(De==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(De))return C(ve,me)}}function C(ve,me){(me==null||me>ve.length)&&(me=ve.length);for(var De=0,re=new Array(me);De<me;De++)re[De]=ve[De];return re}function F(ve,me){var De=typeof Symbol<"u"&&ve[Symbol.iterator]||ve["@@iterator"];if(De)return(De=De.call(ve)).next.bind(De);if(Array.isArray(ve)||(De=M(ve))||me&&ve&&typeof ve.length=="number"){De&&(ve=De);var re=0;return function(){return re>=ve.length?{done:!0}:{done:!1,value:ve[re++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}be.defaults=A();function l(ve){be.defaults=ve}var k=/[&<>"']/,f=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,D=/[<>"']|&(?!#?\w+;)/g,c={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},p=function(me){return c[me]};function $(ve,me){if(me){if(k.test(ve))return ve.replace(f,p)}else if(R.test(ve))return ve.replace(D,p);return ve}var g=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function t(ve){return ve.replace(g,function(me,De){return De=De.toLowerCase(),De==="colon"?":":De.charAt(0)==="#"?De.charAt(1)==="x"?String.fromCharCode(parseInt(De.substring(2),16)):String.fromCharCode(+De.substring(1)):""})}var n=/(^|[^\[])\^/g;function a(ve,me){ve=typeof ve=="string"?ve:ve.source,me=me||"";var De={replace:function(he,se){return se=se.source||se,se=se.replace(n,"$1"),ve=ve.replace(he,se),De},getRegex:function(){return new RegExp(ve,me)}};return De}var b=/[^\w:]/g,E=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function v(ve,me,De){if(ve){var re;try{re=decodeURIComponent(t(De)).replace(b,"").toLowerCase()}catch{return null}if(re.indexOf("javascript:")===0||re.indexOf("vbscript:")===0||re.indexOf("data:")===0)return null}me&&!E.test(De)&&(De=y(me,De));try{De=encodeURI(De).replace(/%25/g,"%")}catch{return null}return De}var r={},s=/^[^:]+:\/*[^/]*$/,i=/^([^:]+:)[\s\S]*$/,o=/^([^:]+:\/*[^/]*)[\s\S]*$/;function y(ve,me){r[" "+ve]||(s.test(ve)?r[" "+ve]=ve+"/":r[" "+ve]=u(ve,"/",!0)),ve=r[" "+ve];var De=ve.indexOf(":")===-1;return me.substring(0,2)==="//"?De?me:ve.replace(i,"$1")+me:me.charAt(0)==="/"?De?me:ve.replace(o,"$1")+me:ve+me}var d={exec:function(){}};function I(ve){for(var me=1,De,re;me<arguments.length;me++){De=arguments[me];for(re in De)Object.prototype.hasOwnProperty.call(De,re)&&(ve[re]=De[re])}return ve}function S(ve,me){var De=ve.replace(/\|/g,function(se,oe,de){for(var Ie=!1,T=oe;--T>=0&&de[T]==="\\";)Ie=!Ie;return Ie?"|":" |"}),re=De.split(/ \|/),he=0;if(re[0].trim()||re.shift(),re.length>0&&!re[re.length-1].trim()&&re.pop(),re.length>me)re.splice(me);else for(;re.length<me;)re.push("");for(;he<re.length;he++)re[he]=re[he].trim().replace(/\\\|/g,"|");return re}function u(ve,me,De){var re=ve.length;if(re===0)return"";for(var he=0;he<re;){var se=ve.charAt(re-he-1);if(se===me&&!De)he++;else if(se!==me&&De)he++;else break}return ve.slice(0,re-he)}function m(ve,me){if(ve.indexOf(me[1])===-1)return-1;for(var De=ve.length,re=0,he=0;he<De;he++)if(ve[he]==="\\")he++;else if(ve[he]===me[0])re++;else if(ve[he]===me[1]&&(re--,re<0))return he;return-1}function h(ve){ve&&ve.sanitize&&!ve.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function P(ve,me){if(me<1)return"";for(var De="";me>1;)me&1&&(De+=ve),me>>=1,ve+=ve;return De+ve}function W(ve,me,De,re){var he=me.href,se=me.title?$(me.title):null,oe=ve[1].replace(/\\([\[\]])/g,"$1");if(ve[0].charAt(0)!=="!"){re.state.inLink=!0;var de={type:"link",raw:De,href:he,title:se,text:oe,tokens:re.inlineTokens(oe)};return re.state.inLink=!1,de}return{type:"image",raw:De,href:he,title:se,text:$(oe)}}function K(ve,me){var De=ve.match(/^(\s+)(?:```)/);if(De===null)return me;var re=De[1];return me.split(`
`).map(function(he){var se=he.match(/^\s+/);if(se===null)return he;var oe=se[0];return oe.length>=re.length?he.slice(re.length):he}).join(`
`)}var U=function(){function ve(De){this.options=De||be.defaults}var me=ve.prototype;return me.space=function(re){var he=this.rules.block.newline.exec(re);if(he&&he[0].length>0)return{type:"space",raw:he[0]}},me.code=function(re){var he=this.rules.block.code.exec(re);if(he){var se=he[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:he[0],codeBlockStyle:"indented",text:this.options.pedantic?se:u(se,`
`)}}},me.fences=function(re){var he=this.rules.block.fences.exec(re);if(he){var se=he[0],oe=K(se,he[3]||"");return{type:"code",raw:se,lang:he[2]?he[2].trim():he[2],text:oe}}},me.heading=function(re){var he=this.rules.block.heading.exec(re);if(he){var se=he[2].trim();if(/#$/.test(se)){var oe=u(se,"#");(this.options.pedantic||!oe||/ $/.test(oe))&&(se=oe.trim())}return{type:"heading",raw:he[0],depth:he[1].length,text:se,tokens:this.lexer.inline(se)}}},me.hr=function(re){var he=this.rules.block.hr.exec(re);if(he)return{type:"hr",raw:he[0]}},me.blockquote=function(re){var he=this.rules.block.blockquote.exec(re);if(he){var se=he[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:he[0],tokens:this.lexer.blockTokens(se,[]),text:se}}},me.list=function(re){var he=this.rules.block.list.exec(re);if(he){var se,oe,de,Ie,T,q,J,Q,H,x,ce,Fe,Ue=he[1].trim(),Qe=Ue.length>1,Ge={type:"list",raw:"",ordered:Qe,start:Qe?+Ue.slice(0,-1):"",loose:!1,items:[]};Ue=Qe?"\\d{1,9}\\"+Ue.slice(-1):"\\"+Ue,this.options.pedantic&&(Ue=Qe?Ue:"[*+-]");for(var _e=new RegExp("^( {0,3}"+Ue+")((?:[	 ][^\\n]*)?(?:\\n|$))");re&&(Fe=!1,!(!(he=_e.exec(re))||this.rules.block.hr.test(re)));){if(se=he[0],re=re.substring(se.length),Q=he[2].split(`
`,1)[0],H=re.split(`
`,1)[0],this.options.pedantic?(Ie=2,ce=Q.trimLeft()):(Ie=he[2].search(/[^ ]/),Ie=Ie>4?1:Ie,ce=Q.slice(Ie),Ie+=he[1].length),q=!1,!Q&&/^ *$/.test(H)&&(se+=H+`
`,re=re.substring(H.length+1),Fe=!0),!Fe)for(var Xe=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),xe=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),it=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}(?:```|~~~)"),tt=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}#");re&&(x=re.split(`
`,1)[0],Q=x,this.options.pedantic&&(Q=Q.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(it.test(Q)||tt.test(Q)||Xe.test(Q)||xe.test(re)));){if(Q.search(/[^ ]/)>=Ie||!Q.trim())ce+=`
`+Q.slice(Ie);else if(!q)ce+=`
`+Q;else break;!q&&!Q.trim()&&(q=!0),se+=x+`
`,re=re.substring(x.length+1)}Ge.loose||(J?Ge.loose=!0:/\n *\n *$/.test(se)&&(J=!0)),this.options.gfm&&(oe=/^\[[ xX]\] /.exec(ce),oe&&(de=oe[0]!=="[ ] ",ce=ce.replace(/^\[[ xX]\] +/,""))),Ge.items.push({type:"list_item",raw:se,task:!!oe,checked:de,loose:!1,text:ce}),Ge.raw+=se}Ge.items[Ge.items.length-1].raw=se.trimRight(),Ge.items[Ge.items.length-1].text=ce.trimRight(),Ge.raw=Ge.raw.trimRight();var ze=Ge.items.length;for(T=0;T<ze;T++){this.lexer.state.top=!1,Ge.items[T].tokens=this.lexer.blockTokens(Ge.items[T].text,[]);var st=Ge.items[T].tokens.filter(function(Z){return Z.type==="space"}),_=st.every(function(Z){for(var pe=Z.raw.split(""),je=0,Oe=F(pe),Ze;!(Ze=Oe()).done;){var rt=Ze.value;if(rt===`
`&&(je+=1),je>1)return!0}return!1});!Ge.loose&&st.length&&_&&(Ge.loose=!0,Ge.items[T].loose=!0)}return Ge}},me.html=function(re){var he=this.rules.block.html.exec(re);if(he){var se={type:"html",raw:he[0],pre:!this.options.sanitizer&&(he[1]==="pre"||he[1]==="script"||he[1]==="style"),text:he[0]};if(this.options.sanitize){var oe=this.options.sanitizer?this.options.sanitizer(he[0]):$(he[0]);se.type="paragraph",se.text=oe,se.tokens=this.lexer.inline(oe)}return se}},me.def=function(re){var he=this.rules.block.def.exec(re);if(he){he[3]&&(he[3]=he[3].substring(1,he[3].length-1));var se=he[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:se,raw:he[0],href:he[2],title:he[3]}}},me.table=function(re){var he=this.rules.block.table.exec(re);if(he){var se={type:"table",header:S(he[1]).map(function(J){return{text:J}}),align:he[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:he[3]&&he[3].trim()?he[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(se.header.length===se.align.length){se.raw=he[0];var oe=se.align.length,de,Ie,T,q;for(de=0;de<oe;de++)/^ *-+: *$/.test(se.align[de])?se.align[de]="right":/^ *:-+: *$/.test(se.align[de])?se.align[de]="center":/^ *:-+ *$/.test(se.align[de])?se.align[de]="left":se.align[de]=null;for(oe=se.rows.length,de=0;de<oe;de++)se.rows[de]=S(se.rows[de],se.header.length).map(function(J){return{text:J}});for(oe=se.header.length,Ie=0;Ie<oe;Ie++)se.header[Ie].tokens=this.lexer.inline(se.header[Ie].text);for(oe=se.rows.length,Ie=0;Ie<oe;Ie++)for(q=se.rows[Ie],T=0;T<q.length;T++)q[T].tokens=this.lexer.inline(q[T].text);return se}}},me.lheading=function(re){var he=this.rules.block.lheading.exec(re);if(he)return{type:"heading",raw:he[0],depth:he[2].charAt(0)==="="?1:2,text:he[1],tokens:this.lexer.inline(he[1])}},me.paragraph=function(re){var he=this.rules.block.paragraph.exec(re);if(he){var se=he[1].charAt(he[1].length-1)===`
`?he[1].slice(0,-1):he[1];return{type:"paragraph",raw:he[0],text:se,tokens:this.lexer.inline(se)}}},me.text=function(re){var he=this.rules.block.text.exec(re);if(he)return{type:"text",raw:he[0],text:he[0],tokens:this.lexer.inline(he[0])}},me.escape=function(re){var he=this.rules.inline.escape.exec(re);if(he)return{type:"escape",raw:he[0],text:$(he[1])}},me.tag=function(re){var he=this.rules.inline.tag.exec(re);if(he)return!this.lexer.state.inLink&&/^<a /i.test(he[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(he[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(he[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(he[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:he[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(he[0]):$(he[0]):he[0]}},me.link=function(re){var he=this.rules.inline.link.exec(re);if(he){var se=he[2].trim();if(!this.options.pedantic&&/^</.test(se)){if(!/>$/.test(se))return;var oe=u(se.slice(0,-1),"\\");if((se.length-oe.length)%2===0)return}else{var de=m(he[2],"()");if(de>-1){var Ie=he[0].indexOf("!")===0?5:4,T=Ie+he[1].length+de;he[2]=he[2].substring(0,de),he[0]=he[0].substring(0,T).trim(),he[3]=""}}var q=he[2],J="";if(this.options.pedantic){var Q=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(q);Q&&(q=Q[1],J=Q[3])}else J=he[3]?he[3].slice(1,-1):"";return q=q.trim(),/^</.test(q)&&(this.options.pedantic&&!/>$/.test(se)?q=q.slice(1):q=q.slice(1,-1)),W(he,{href:q&&q.replace(this.rules.inline._escapes,"$1"),title:J&&J.replace(this.rules.inline._escapes,"$1")},he[0],this.lexer)}},me.reflink=function(re,he){var se;if((se=this.rules.inline.reflink.exec(re))||(se=this.rules.inline.nolink.exec(re))){var oe=(se[2]||se[1]).replace(/\s+/g," ");if(oe=he[oe.toLowerCase()],!oe||!oe.href){var de=se[0].charAt(0);return{type:"text",raw:de,text:de}}return W(se,oe,se[0],this.lexer)}},me.emStrong=function(re,he,se){se===void 0&&(se="");var oe=this.rules.inline.emStrong.lDelim.exec(re);if(oe&&!(oe[3]&&se.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var de=oe[1]||oe[2]||"";if(!de||de&&(se===""||this.rules.inline.punctuation.exec(se))){var Ie=oe[0].length-1,T,q,J=Ie,Q=0,H=oe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(H.lastIndex=0,he=he.slice(-1*re.length+Ie);(oe=H.exec(he))!=null;)if(T=oe[1]||oe[2]||oe[3]||oe[4]||oe[5]||oe[6],!!T){if(q=T.length,oe[3]||oe[4]){J+=q;continue}else if((oe[5]||oe[6])&&Ie%3&&!((Ie+q)%3)){Q+=q;continue}if(J-=q,!(J>0)){if(q=Math.min(q,q+J+Q),Math.min(Ie,q)%2){var x=re.slice(1,Ie+oe.index+q);return{type:"em",raw:re.slice(0,Ie+oe.index+q+1),text:x,tokens:this.lexer.inlineTokens(x)}}var ce=re.slice(2,Ie+oe.index+q-1);return{type:"strong",raw:re.slice(0,Ie+oe.index+q+1),text:ce,tokens:this.lexer.inlineTokens(ce)}}}}}},me.codespan=function(re){var he=this.rules.inline.code.exec(re);if(he){var se=he[2].replace(/\n/g," "),oe=/[^ ]/.test(se),de=/^ /.test(se)&&/ $/.test(se);return oe&&de&&(se=se.substring(1,se.length-1)),se=$(se,!0),{type:"codespan",raw:he[0],text:se}}},me.br=function(re){var he=this.rules.inline.br.exec(re);if(he)return{type:"br",raw:he[0]}},me.del=function(re){var he=this.rules.inline.del.exec(re);if(he)return{type:"del",raw:he[0],text:he[2],tokens:this.lexer.inlineTokens(he[2])}},me.autolink=function(re,he){var se=this.rules.inline.autolink.exec(re);if(se){var oe,de;return se[2]==="@"?(oe=$(this.options.mangle?he(se[1]):se[1]),de="mailto:"+oe):(oe=$(se[1]),de=oe),{type:"link",raw:se[0],text:oe,href:de,tokens:[{type:"text",raw:oe,text:oe}]}}},me.url=function(re,he){var se;if(se=this.rules.inline.url.exec(re)){var oe,de;if(se[2]==="@")oe=$(this.options.mangle?he(se[0]):se[0]),de="mailto:"+oe;else{var Ie;do Ie=se[0],se[0]=this.rules.inline._backpedal.exec(se[0])[0];while(Ie!==se[0]);oe=$(se[0]),se[1]==="www."?de="http://"+oe:de=oe}return{type:"link",raw:se[0],text:oe,href:de,tokens:[{type:"text",raw:oe,text:oe}]}}},me.inlineText=function(re,he){var se=this.rules.inline.text.exec(re);if(se){var oe;return this.lexer.state.inRawBlock?oe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(se[0]):$(se[0]):se[0]:oe=$(this.options.smartypants?he(se[0]):se[0]),{type:"text",raw:se[0],text:oe}}},ve}(),B={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:d,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};B._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,B._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,B.def=a(B.def).replace("label",B._label).replace("title",B._title).getRegex(),B.bullet=/(?:[*+-]|\d{1,9}[.)])/,B.listItemStart=a(/^( *)(bull) */).replace("bull",B.bullet).getRegex(),B.list=a(B.list).replace(/bull/g,B.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+B.def.source+")").getRegex(),B._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",B._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,B.html=a(B.html,"i").replace("comment",B._comment).replace("tag",B._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),B.paragraph=a(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.blockquote=a(B.blockquote).replace("paragraph",B.paragraph).getRegex(),B.normal=I({},B),B.gfm=I({},B.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),B.gfm.table=a(B.gfm.table).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.gfm.paragraph=a(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",B.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.pedantic=I({},B.normal,{html:a(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",B._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:d,paragraph:a(B.normal._paragraph).replace("hr",B.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",B.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var O={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:d,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:d,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};O._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",O.punctuation=a(O.punctuation).replace(/punctuation/g,O._punctuation).getRegex(),O.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,O.escapedEmSt=/\\\*|\\_/g,O._comment=a(B._comment).replace("(?:-->|$)","-->").getRegex(),O.emStrong.lDelim=a(O.emStrong.lDelim).replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimAst=a(O.emStrong.rDelimAst,"g").replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimUnd=a(O.emStrong.rDelimUnd,"g").replace(/punct/g,O._punctuation).getRegex(),O._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,O._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,O._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,O.autolink=a(O.autolink).replace("scheme",O._scheme).replace("email",O._email).getRegex(),O._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,O.tag=a(O.tag).replace("comment",O._comment).replace("attribute",O._attribute).getRegex(),O._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,O._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,O._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,O.link=a(O.link).replace("label",O._label).replace("href",O._href).replace("title",O._title).getRegex(),O.reflink=a(O.reflink).replace("label",O._label).replace("ref",B._label).getRegex(),O.nolink=a(O.nolink).replace("ref",B._label).getRegex(),O.reflinkSearch=a(O.reflinkSearch,"g").replace("reflink",O.reflink).replace("nolink",O.nolink).getRegex(),O.normal=I({},O),O.pedantic=I({},O.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:a(/^!?\[(label)\]\((.*?)\)/).replace("label",O._label).getRegex(),reflink:a(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",O._label).getRegex()}),O.gfm=I({},O.normal,{escape:a(O.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),O.gfm.url=a(O.gfm.url,"i").replace("email",O.gfm._extended_email).getRegex(),O.breaks=I({},O.gfm,{br:a(O.br).replace("{2,}","*").getRegex(),text:a(O.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function N(ve){return ve.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function te(ve){var me="",De,re,he=ve.length;for(De=0;De<he;De++)re=ve.charCodeAt(De),Math.random()>.5&&(re="x"+re.toString(16)),me+="&#"+re+";";return me}var Y=function(){function ve(De){this.tokens=[],this.tokens.links=Object.create(null),this.options=De||be.defaults,this.options.tokenizer=this.options.tokenizer||new U,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var re={block:B.normal,inline:O.normal};this.options.pedantic?(re.block=B.pedantic,re.inline=O.pedantic):this.options.gfm&&(re.block=B.gfm,this.options.breaks?re.inline=O.breaks:re.inline=O.gfm),this.tokenizer.rules=re}ve.lex=function(re,he){var se=new ve(he);return se.lex(re)},ve.lexInline=function(re,he){var se=new ve(he);return se.inlineTokens(re)};var me=ve.prototype;return me.lex=function(re){re=re.replace(/\r\n|\r/g,`
`),this.blockTokens(re,this.tokens);for(var he;he=this.inlineQueue.shift();)this.inlineTokens(he.src,he.tokens);return this.tokens},me.blockTokens=function(re,he){var se=this;he===void 0&&(he=[]),this.options.pedantic?re=re.replace(/\t/g,"    ").replace(/^ +$/gm,""):re=re.replace(/^( *)(\t+)/gm,function(J,Q,H){return Q+"    ".repeat(H.length)});for(var oe,de,Ie,T;re;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(J){return(oe=J.call({lexer:se},re,he))?(re=re.substring(oe.raw.length),he.push(oe),!0):!1}))){if(oe=this.tokenizer.space(re)){re=re.substring(oe.raw.length),oe.raw.length===1&&he.length>0?he[he.length-1].raw+=`
`:he.push(oe);continue}if(oe=this.tokenizer.code(re)){re=re.substring(oe.raw.length),de=he[he.length-1],de&&(de.type==="paragraph"||de.type==="text")?(de.raw+=`
`+oe.raw,de.text+=`
`+oe.text,this.inlineQueue[this.inlineQueue.length-1].src=de.text):he.push(oe);continue}if(oe=this.tokenizer.fences(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.heading(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.hr(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.blockquote(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.list(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.html(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.def(re)){re=re.substring(oe.raw.length),de=he[he.length-1],de&&(de.type==="paragraph"||de.type==="text")?(de.raw+=`
`+oe.raw,de.text+=`
`+oe.raw,this.inlineQueue[this.inlineQueue.length-1].src=de.text):this.tokens.links[oe.tag]||(this.tokens.links[oe.tag]={href:oe.href,title:oe.title});continue}if(oe=this.tokenizer.table(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.lheading(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(Ie=re,this.options.extensions&&this.options.extensions.startBlock&&function(){var J=1/0,Q=re.slice(1),H=void 0;se.options.extensions.startBlock.forEach(function(x){H=x.call({lexer:this},Q),typeof H=="number"&&H>=0&&(J=Math.min(J,H))}),J<1/0&&J>=0&&(Ie=re.substring(0,J+1))}(),this.state.top&&(oe=this.tokenizer.paragraph(Ie))){de=he[he.length-1],T&&de.type==="paragraph"?(de.raw+=`
`+oe.raw,de.text+=`
`+oe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=de.text):he.push(oe),T=Ie.length!==re.length,re=re.substring(oe.raw.length);continue}if(oe=this.tokenizer.text(re)){re=re.substring(oe.raw.length),de=he[he.length-1],de&&de.type==="text"?(de.raw+=`
`+oe.raw,de.text+=`
`+oe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=de.text):he.push(oe);continue}if(re){var q="Infinite loop on byte: "+re.charCodeAt(0);if(this.options.silent){console.error(q);break}else throw new Error(q)}}return this.state.top=!0,he},me.inline=function(re,he){return he===void 0&&(he=[]),this.inlineQueue.push({src:re,tokens:he}),he},me.inlineTokens=function(re,he){var se=this;he===void 0&&(he=[]);var oe,de,Ie,T=re,q,J,Q;if(this.tokens.links){var H=Object.keys(this.tokens.links);if(H.length>0)for(;(q=this.tokenizer.rules.inline.reflinkSearch.exec(T))!=null;)H.includes(q[0].slice(q[0].lastIndexOf("[")+1,-1))&&(T=T.slice(0,q.index)+"["+P("a",q[0].length-2)+"]"+T.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(q=this.tokenizer.rules.inline.blockSkip.exec(T))!=null;)T=T.slice(0,q.index)+"["+P("a",q[0].length-2)+"]"+T.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(q=this.tokenizer.rules.inline.escapedEmSt.exec(T))!=null;)T=T.slice(0,q.index)+"++"+T.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;re;)if(J||(Q=""),J=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ce){return(oe=ce.call({lexer:se},re,he))?(re=re.substring(oe.raw.length),he.push(oe),!0):!1}))){if(oe=this.tokenizer.escape(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.tag(re)){re=re.substring(oe.raw.length),de=he[he.length-1],de&&oe.type==="text"&&de.type==="text"?(de.raw+=oe.raw,de.text+=oe.text):he.push(oe);continue}if(oe=this.tokenizer.link(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.reflink(re,this.tokens.links)){re=re.substring(oe.raw.length),de=he[he.length-1],de&&oe.type==="text"&&de.type==="text"?(de.raw+=oe.raw,de.text+=oe.text):he.push(oe);continue}if(oe=this.tokenizer.emStrong(re,T,Q)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.codespan(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.br(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.del(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.autolink(re,te)){re=re.substring(oe.raw.length),he.push(oe);continue}if(!this.state.inLink&&(oe=this.tokenizer.url(re,te))){re=re.substring(oe.raw.length),he.push(oe);continue}if(Ie=re,this.options.extensions&&this.options.extensions.startInline&&function(){var ce=1/0,Fe=re.slice(1),Ue=void 0;se.options.extensions.startInline.forEach(function(Qe){Ue=Qe.call({lexer:this},Fe),typeof Ue=="number"&&Ue>=0&&(ce=Math.min(ce,Ue))}),ce<1/0&&ce>=0&&(Ie=re.substring(0,ce+1))}(),oe=this.tokenizer.inlineText(Ie,N)){re=re.substring(oe.raw.length),oe.raw.slice(-1)!=="_"&&(Q=oe.raw.slice(-1)),J=!0,de=he[he.length-1],de&&de.type==="text"?(de.raw+=oe.raw,de.text+=oe.text):he.push(oe);continue}if(re){var x="Infinite loop on byte: "+re.charCodeAt(0);if(this.options.silent){console.error(x);break}else throw new Error(x)}}return he},w(ve,null,[{key:"rules",get:function(){return{block:B,inline:O}}}]),ve}(),ye=function(){function ve(De){this.options=De||be.defaults}var me=ve.prototype;return me.code=function(re,he,se){var oe=(he||"").match(/\S*/)[0];if(this.options.highlight){var de=this.options.highlight(re,oe);de!=null&&de!==re&&(se=!0,re=de)}return re=re.replace(/\n$/,"")+`
`,oe?'<pre><code class="'+this.options.langPrefix+$(oe,!0)+'">'+(se?re:$(re,!0))+`</code></pre>
`:"<pre><code>"+(se?re:$(re,!0))+`</code></pre>
`},me.blockquote=function(re){return`<blockquote>
`+re+`</blockquote>
`},me.html=function(re){return re},me.heading=function(re,he,se,oe){if(this.options.headerIds){var de=this.options.headerPrefix+oe.slug(se);return"<h"+he+' id="'+de+'">'+re+"</h"+he+`>
`}return"<h"+he+">"+re+"</h"+he+`>
`},me.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},me.list=function(re,he,se){var oe=he?"ol":"ul",de=he&&se!==1?' start="'+se+'"':"";return"<"+oe+de+`>
`+re+"</"+oe+`>
`},me.listitem=function(re){return"<li>"+re+`</li>
`},me.checkbox=function(re){return"<input "+(re?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},me.paragraph=function(re){return"<p>"+re+`</p>
`},me.table=function(re,he){return he&&(he="<tbody>"+he+"</tbody>"),`<table>
<thead>
`+re+`</thead>
`+he+`</table>
`},me.tablerow=function(re){return`<tr>
`+re+`</tr>
`},me.tablecell=function(re,he){var se=he.header?"th":"td",oe=he.align?"<"+se+' align="'+he.align+'">':"<"+se+">";return oe+re+("</"+se+`>
`)},me.strong=function(re){return"<strong>"+re+"</strong>"},me.em=function(re){return"<em>"+re+"</em>"},me.codespan=function(re){return"<code>"+re+"</code>"},me.br=function(){return this.options.xhtml?"<br/>":"<br>"},me.del=function(re){return"<del>"+re+"</del>"},me.link=function(re,he,se){if(re=v(this.options.sanitize,this.options.baseUrl,re),re===null)return se;var oe='<a href="'+$(re)+'"';return he&&(oe+=' title="'+he+'"'),oe+=">"+se+"</a>",oe},me.image=function(re,he,se){if(re=v(this.options.sanitize,this.options.baseUrl,re),re===null)return se;var oe='<img src="'+re+'" alt="'+se+'"';return he&&(oe+=' title="'+he+'"'),oe+=this.options.xhtml?"/>":">",oe},me.text=function(re){return re},ve}(),Ee=function(){function ve(){}var me=ve.prototype;return me.strong=function(re){return re},me.em=function(re){return re},me.codespan=function(re){return re},me.del=function(re){return re},me.html=function(re){return re},me.text=function(re){return re},me.link=function(re,he,se){return""+se},me.image=function(re,he,se){return""+se},me.br=function(){return""},ve}(),Pe=function(){function ve(){this.seen={}}var me=ve.prototype;return me.serialize=function(re){return re.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},me.getNextSafeSlug=function(re,he){var se=re,oe=0;if(this.seen.hasOwnProperty(se)){oe=this.seen[re];do oe++,se=re+"-"+oe;while(this.seen.hasOwnProperty(se))}return he||(this.seen[re]=oe,this.seen[se]=0),se},me.slug=function(re,he){he===void 0&&(he={});var se=this.serialize(re);return this.getNextSafeSlug(se,he.dryrun)},ve}(),X=function(){function ve(De){this.options=De||be.defaults,this.options.renderer=this.options.renderer||new ye,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Ee,this.slugger=new Pe}ve.parse=function(re,he){var se=new ve(he);return se.parse(re)},ve.parseInline=function(re,he){var se=new ve(he);return se.parseInline(re)};var me=ve.prototype;return me.parse=function(re,he){he===void 0&&(he=!0);var se="",oe,de,Ie,T,q,J,Q,H,x,ce,Fe,Ue,Qe,Ge,_e,Xe,xe,it,tt,ze=re.length;for(oe=0;oe<ze;oe++){if(ce=re[oe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ce.type]&&(tt=this.options.extensions.renderers[ce.type].call({parser:this},ce),tt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ce.type))){se+=tt||"";continue}switch(ce.type){case"space":continue;case"hr":{se+=this.renderer.hr();continue}case"heading":{se+=this.renderer.heading(this.parseInline(ce.tokens),ce.depth,t(this.parseInline(ce.tokens,this.textRenderer)),this.slugger);continue}case"code":{se+=this.renderer.code(ce.text,ce.lang,ce.escaped);continue}case"table":{for(H="",Q="",T=ce.header.length,de=0;de<T;de++)Q+=this.renderer.tablecell(this.parseInline(ce.header[de].tokens),{header:!0,align:ce.align[de]});for(H+=this.renderer.tablerow(Q),x="",T=ce.rows.length,de=0;de<T;de++){for(J=ce.rows[de],Q="",q=J.length,Ie=0;Ie<q;Ie++)Q+=this.renderer.tablecell(this.parseInline(J[Ie].tokens),{header:!1,align:ce.align[Ie]});x+=this.renderer.tablerow(Q)}se+=this.renderer.table(H,x);continue}case"blockquote":{x=this.parse(ce.tokens),se+=this.renderer.blockquote(x);continue}case"list":{for(Fe=ce.ordered,Ue=ce.start,Qe=ce.loose,T=ce.items.length,x="",de=0;de<T;de++)_e=ce.items[de],Xe=_e.checked,xe=_e.task,Ge="",_e.task&&(it=this.renderer.checkbox(Xe),Qe?_e.tokens.length>0&&_e.tokens[0].type==="paragraph"?(_e.tokens[0].text=it+" "+_e.tokens[0].text,_e.tokens[0].tokens&&_e.tokens[0].tokens.length>0&&_e.tokens[0].tokens[0].type==="text"&&(_e.tokens[0].tokens[0].text=it+" "+_e.tokens[0].tokens[0].text)):_e.tokens.unshift({type:"text",text:it}):Ge+=it),Ge+=this.parse(_e.tokens,Qe),x+=this.renderer.listitem(Ge,xe,Xe);se+=this.renderer.list(x,Fe,Ue);continue}case"html":{se+=this.renderer.html(ce.text);continue}case"paragraph":{se+=this.renderer.paragraph(this.parseInline(ce.tokens));continue}case"text":{for(x=ce.tokens?this.parseInline(ce.tokens):ce.text;oe+1<ze&&re[oe+1].type==="text";)ce=re[++oe],x+=`
`+(ce.tokens?this.parseInline(ce.tokens):ce.text);se+=he?this.renderer.paragraph(x):x;continue}default:{var st='Token with "'+ce.type+'" type was not found.';if(this.options.silent){console.error(st);return}else throw new Error(st)}}}return se},me.parseInline=function(re,he){he=he||this.renderer;var se="",oe,de,Ie,T=re.length;for(oe=0;oe<T;oe++){if(de=re[oe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[de.type]&&(Ie=this.options.extensions.renderers[de.type].call({parser:this},de),Ie!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(de.type))){se+=Ie||"";continue}switch(de.type){case"escape":{se+=he.text(de.text);break}case"html":{se+=he.html(de.text);break}case"link":{se+=he.link(de.href,de.title,this.parseInline(de.tokens,he));break}case"image":{se+=he.image(de.href,de.title,de.text);break}case"strong":{se+=he.strong(this.parseInline(de.tokens,he));break}case"em":{se+=he.em(this.parseInline(de.tokens,he));break}case"codespan":{se+=he.codespan(de.text);break}case"br":{se+=he.br();break}case"del":{se+=he.del(this.parseInline(de.tokens,he));break}case"text":{se+=he.text(de.text);break}default:{var q='Token with "'+de.type+'" type was not found.';if(this.options.silent){console.error(q);return}else throw new Error(q)}}}return se},ve}();function ae(ve,me,De){if(typeof ve>"u"||ve===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ve!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ve)+", string expected");if(typeof me=="function"&&(De=me,me=null),me=I({},ae.defaults,me||{}),h(me),De){var re=me.highlight,he;try{he=Y.lex(ve,me)}catch(T){return De(T)}var se=function(q){var J;if(!q)try{me.walkTokens&&ae.walkTokens(he,me.walkTokens),J=X.parse(he,me)}catch(Q){q=Q}return me.highlight=re,q?De(q):De(null,J)};if(!re||re.length<3||(delete me.highlight,!he.length))return se();var oe=0;ae.walkTokens(he,function(T){T.type==="code"&&(oe++,setTimeout(function(){re(T.text,T.lang,function(q,J){if(q)return se(q);J!=null&&J!==T.text&&(T.text=J,T.escaped=!0),oe--,oe===0&&se()})},0))}),oe===0&&se();return}function de(T){if(T.message+=`
Please report this to https://github.com/markedjs/marked.`,me.silent)return"<p>An error occurred:</p><pre>"+$(T.message+"",!0)+"</pre>";throw T}try{var Ie=Y.lex(ve,me);if(me.walkTokens){if(me.async)return Promise.all(ae.walkTokens(Ie,me.walkTokens)).then(function(){return X.parse(Ie,me)}).catch(de);ae.walkTokens(Ie,me.walkTokens)}return X.parse(Ie,me)}catch(T){de(T)}}ae.options=ae.setOptions=function(ve){return I(ae.defaults,ve),l(ae.defaults),ae},ae.getDefaults=A,ae.defaults=be.defaults,ae.use=function(){for(var ve=arguments.length,me=new Array(ve),De=0;De<ve;De++)me[De]=arguments[De];var re=I.apply(void 0,[{}].concat(me)),he=ae.defaults.extensions||{renderers:{},childTokens:{}},se;me.forEach(function(oe){if(oe.extensions&&(se=!0,oe.extensions.forEach(function(Ie){if(!Ie.name)throw new Error("extension name required");if(Ie.renderer){var T=he.renderers?he.renderers[Ie.name]:null;T?he.renderers[Ie.name]=function(){for(var q=arguments.length,J=new Array(q),Q=0;Q<q;Q++)J[Q]=arguments[Q];var H=Ie.renderer.apply(this,J);return H===!1&&(H=T.apply(this,J)),H}:he.renderers[Ie.name]=Ie.renderer}if(Ie.tokenizer){if(!Ie.level||Ie.level!=="block"&&Ie.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");he[Ie.level]?he[Ie.level].unshift(Ie.tokenizer):he[Ie.level]=[Ie.tokenizer],Ie.start&&(Ie.level==="block"?he.startBlock?he.startBlock.push(Ie.start):he.startBlock=[Ie.start]:Ie.level==="inline"&&(he.startInline?he.startInline.push(Ie.start):he.startInline=[Ie.start]))}Ie.childTokens&&(he.childTokens[Ie.name]=Ie.childTokens)})),oe.renderer&&function(){var Ie=ae.defaults.renderer||new ye,T=function(Q){var H=Ie[Q];Ie[Q]=function(){for(var x=arguments.length,ce=new Array(x),Fe=0;Fe<x;Fe++)ce[Fe]=arguments[Fe];var Ue=oe.renderer[Q].apply(Ie,ce);return Ue===!1&&(Ue=H.apply(Ie,ce)),Ue}};for(var q in oe.renderer)T(q);re.renderer=Ie}(),oe.tokenizer&&function(){var Ie=ae.defaults.tokenizer||new U,T=function(Q){var H=Ie[Q];Ie[Q]=function(){for(var x=arguments.length,ce=new Array(x),Fe=0;Fe<x;Fe++)ce[Fe]=arguments[Fe];var Ue=oe.tokenizer[Q].apply(Ie,ce);return Ue===!1&&(Ue=H.apply(Ie,ce)),Ue}};for(var q in oe.tokenizer)T(q);re.tokenizer=Ie}(),oe.walkTokens){var de=ae.defaults.walkTokens;re.walkTokens=function(Ie){var T=[];return T.push(oe.walkTokens.call(this,Ie)),de&&(T=T.concat(de.call(this,Ie))),T}}se&&(re.extensions=he),ae.setOptions(re)})},ae.walkTokens=function(ve,me){for(var De=[],re=function(){var de=se.value;switch(De=De.concat(me.call(ae,de)),de.type){case"table":{for(var Ie=F(de.header),T;!(T=Ie()).done;){var q=T.value;De=De.concat(ae.walkTokens(q.tokens,me))}for(var J=F(de.rows),Q;!(Q=J()).done;)for(var H=Q.value,x=F(H),ce;!(ce=x()).done;){var Fe=ce.value;De=De.concat(ae.walkTokens(Fe.tokens,me))}break}case"list":{De=De.concat(ae.walkTokens(de.items,me));break}default:ae.defaults.extensions&&ae.defaults.extensions.childTokens&&ae.defaults.extensions.childTokens[de.type]?ae.defaults.extensions.childTokens[de.type].forEach(function(Ue){De=De.concat(ae.walkTokens(de[Ue],me))}):de.tokens&&(De=De.concat(ae.walkTokens(de.tokens,me)))}},he=F(ve),se;!(se=he()).done;)re();return De},ae.parseInline=function(ve,me){if(typeof ve>"u"||ve===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ve!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ve)+", string expected");me=I({},ae.defaults,me||{}),h(me);try{var De=Y.lexInline(ve,me);return me.walkTokens&&ae.walkTokens(De,me.walkTokens),X.parseInline(De,me)}catch(re){if(re.message+=`
Please report this to https://github.com/markedjs/marked.`,me.silent)return"<p>An error occurred:</p><pre>"+$(re.message+"",!0)+"</pre>";throw re}},ae.Parser=X,ae.parser=X.parse,ae.Renderer=ye,ae.TextRenderer=Ee,ae.Lexer=Y,ae.lexer=Y.lex,ae.Tokenizer=U,ae.Slugger=Pe,ae.parse=ae;var Se=ae.options,ue=ae.setOptions,$e=ae.use,ie=ae.walkTokens,z=ae.parseInline,V=ae,le=X.parse,we=Y.lex;be.Lexer=Y,be.Parser=X,be.Renderer=ye,be.Slugger=Pe,be.TextRenderer=Ee,be.Tokenizer=U,be.getDefaults=A,be.lexer=we,be.marked=ae,be.options=Se,be.parse=V,be.parseInline=z,be.parser=le,be.setOptions=ue,be.use=$e,be.walkTokens=ie,Object.defineProperty(be,"__esModule",{value:!0})}),define(Re[117],Me([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ol=e.$Nl=e.$Ml=e.rot=e.$Kl=void 0;function w(l,k,f){return Math.min(Math.max(l,k),f)}e.$Kl=w;function M(l,k){return(k+l%k)%k}e.rot=M;class C{constructor(){this.a=0}getNext(){return this.a++}}e.$Ml=C;class F{constructor(){this.a=1,this.b=0}update(k){return this.b=this.b+(k-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Nl=F;class A{constructor(k){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(k),this.c.fill(0,0,k)}update(k){const f=this.c[this.d];return this.c[this.d]=k,this.d=(this.d+1)%this.c.length,this.e-=f,this.e+=k,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Ol=A}),function(){function be(C){const F=[];typeof C=="number"&&F.push("code/timeOrigin",C);function A(k){F.push(k,Date.now())}function l(){const k=[];for(let f=0;f<F.length;f+=2)k.push({name:F[f],startTime:F[f+1]});return k}return{mark:A,getMarks:l}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?be():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const F=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const A of performance.getEntriesByType("mark"))F.push({name:A.name,startTime:Math.round(C+A.startTime)});return F}};if(typeof process=="object"){const C=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return be(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),be()}function w(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var M;typeof global=="object"?M=global:typeof self=="object"?M=self:M={},typeof define=="function"?define("vs/base/common/performance",[],function(){return w(M)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=w(M):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),M.perf=w(M))}(),function(be,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var w=e();for(var M in w)(typeof exports=="object"?exports:be)[M]=w[M]}}(typeof self<"u"?self:this,function(){return function(be){var e={};function w(M){if(e[M])return e[M].exports;var C=e[M]={i:M,l:!1,exports:{}};return be[M].call(C.exports,C,C.exports,w),C.l=!0,C.exports}return w.m=be,w.c=e,w.d=function(M,C,F){w.o(M,C)||Object.defineProperty(M,C,{enumerable:!0,get:F})},w.r=function(M){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(M,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(M,"__esModule",{value:!0})},w.t=function(M,C){if(1&C&&(M=w(M)),8&C||4&C&&typeof M=="object"&&M&&M.__esModule)return M;var F=Object.create(null);if(w.r(F),Object.defineProperty(F,"default",{enumerable:!0,value:M}),2&C&&typeof M!="string")for(var A in M)w.d(F,A,function(l){return M[l]}.bind(null,A));return F},w.n=function(M){var C=M&&M.__esModule?function(){return M.default}:function(){return M};return w.d(C,"a",C),C},w.o=function(M,C){return Object.prototype.hasOwnProperty.call(M,C)},w.p="",w(w.s=0)}([function(be,e,w){(function(M){var C;e=be.exports=$e,C=typeof M=="object"&&M.env&&M.env.NODE_DEBUG&&/\bsemver\b/i.test(M.env.NODE_DEBUG)?function(){var H=Array.prototype.slice.call(arguments,0);H.unshift("SEMVER"),console.log.apply(console,H)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var F=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,l=e.re=[],k=e.src=[],f=0,R=f++;k[R]="0|[1-9]\\d*";var D=f++;k[D]="[0-9]+";var c=f++;k[c]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var p=f++;k[p]="("+k[R]+")\\.("+k[R]+")\\.("+k[R]+")";var $=f++;k[$]="("+k[D]+")\\.("+k[D]+")\\.("+k[D]+")";var g=f++;k[g]="(?:"+k[R]+"|"+k[c]+")";var t=f++;k[t]="(?:"+k[D]+"|"+k[c]+")";var n=f++;k[n]="(?:-("+k[g]+"(?:\\."+k[g]+")*))";var a=f++;k[a]="(?:-?("+k[t]+"(?:\\."+k[t]+")*))";var b=f++;k[b]="[0-9A-Za-z-]+";var E=f++;k[E]="(?:\\+("+k[b]+"(?:\\."+k[b]+")*))";var v=f++,r="v?"+k[p]+k[n]+"?"+k[E]+"?";k[v]="^"+r+"$";var s="[v=\\s]*"+k[$]+k[a]+"?"+k[E]+"?",i=f++;k[i]="^"+s+"$";var o=f++;k[o]="((?:<|>)?=?)";var y=f++;k[y]=k[D]+"|x|X|\\*";var d=f++;k[d]=k[R]+"|x|X|\\*";var I=f++;k[I]="[v=\\s]*("+k[d]+")(?:\\.("+k[d]+")(?:\\.("+k[d]+")(?:"+k[n]+")?"+k[E]+"?)?)?";var S=f++;k[S]="[v=\\s]*("+k[y]+")(?:\\.("+k[y]+")(?:\\.("+k[y]+")(?:"+k[a]+")?"+k[E]+"?)?)?";var u=f++;k[u]="^"+k[o]+"\\s*"+k[I]+"$";var m=f++;k[m]="^"+k[o]+"\\s*"+k[S]+"$";var h=f++;k[h]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var P=f++;k[P]="(?:~>?)";var W=f++;k[W]="(\\s*)"+k[P]+"\\s+",l[W]=new RegExp(k[W],"g");var K=f++;k[K]="^"+k[P]+k[I]+"$";var U=f++;k[U]="^"+k[P]+k[S]+"$";var B=f++;k[B]="(?:\\^)";var O=f++;k[O]="(\\s*)"+k[B]+"\\s+",l[O]=new RegExp(k[O],"g");var N=f++;k[N]="^"+k[B]+k[I]+"$";var te=f++;k[te]="^"+k[B]+k[S]+"$";var Y=f++;k[Y]="^"+k[o]+"\\s*("+s+")$|^$";var ye=f++;k[ye]="^"+k[o]+"\\s*("+r+")$|^$";var Ee=f++;k[Ee]="(\\s*)"+k[o]+"\\s*("+s+"|"+k[I]+")",l[Ee]=new RegExp(k[Ee],"g");var Pe=f++;k[Pe]="^\\s*("+k[I]+")\\s+-\\s+("+k[I]+")\\s*$";var X=f++;k[X]="^\\s*("+k[S]+")\\s+-\\s+("+k[S]+")\\s*$";var ae=f++;k[ae]="(<|>)?=?\\s*\\*";for(var Se=0;Se<35;Se++)C(Se,k[Se]),l[Se]||(l[Se]=new RegExp(k[Se]));function ue(H,x){if(H instanceof $e)return H;if(typeof H!="string"||H.length>F||!(x?l[i]:l[v]).test(H))return null;try{return new $e(H,x)}catch{return null}}function $e(H,x){if(H instanceof $e){if(H.loose===x)return H;H=H.version}else if(typeof H!="string")throw new TypeError("Invalid Version: "+H);if(H.length>F)throw new TypeError("version is longer than "+F+" characters");if(!(this instanceof $e))return new $e(H,x);C("SemVer",H,x),this.loose=x;var ce=H.trim().match(x?l[i]:l[v]);if(!ce)throw new TypeError("Invalid Version: "+H);if(this.raw=H,this.major=+ce[1],this.minor=+ce[2],this.patch=+ce[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");ce[4]?this.prerelease=ce[4].split(".").map(function(Fe){if(/^[0-9]+$/.test(Fe)){var Ue=+Fe;if(Ue>=0&&Ue<A)return Ue}return Fe}):this.prerelease=[],this.build=ce[5]?ce[5].split("."):[],this.format()}e.parse=ue,e.valid=function(H,x){var ce=ue(H,x);return ce?ce.version:null},e.clean=function(H,x){var ce=ue(H.trim().replace(/^[=v]+/,""),x);return ce?ce.version:null},e.SemVer=$e,$e.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},$e.prototype.toString=function(){return this.version},$e.prototype.compare=function(H){return C("SemVer.compare",this.version,this.loose,H),H instanceof $e||(H=new $e(H,this.loose)),this.compareMain(H)||this.comparePre(H)},$e.prototype.compareMain=function(H){return H instanceof $e||(H=new $e(H,this.loose)),z(this.major,H.major)||z(this.minor,H.minor)||z(this.patch,H.patch)},$e.prototype.comparePre=function(H){if(H instanceof $e||(H=new $e(H,this.loose)),this.prerelease.length&&!H.prerelease.length)return-1;if(!this.prerelease.length&&H.prerelease.length)return 1;if(!this.prerelease.length&&!H.prerelease.length)return 0;var x=0;do{var ce=this.prerelease[x],Fe=H.prerelease[x];if(C("prerelease compare",x,ce,Fe),ce===void 0&&Fe===void 0)return 0;if(Fe===void 0)return 1;if(ce===void 0)return-1;if(ce!==Fe)return z(ce,Fe)}while(++x)},$e.prototype.inc=function(H,x){switch(H){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",x);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",x);break;case"prepatch":this.prerelease.length=0,this.inc("patch",x),this.inc("pre",x);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",x),this.inc("pre",x);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ce=this.prerelease.length;--ce>=0;)typeof this.prerelease[ce]=="number"&&(this.prerelease[ce]++,ce=-2);ce===-1&&this.prerelease.push(0)}x&&(this.prerelease[0]===x?isNaN(this.prerelease[1])&&(this.prerelease=[x,0]):this.prerelease=[x,0]);break;default:throw new Error("invalid increment argument: "+H)}return this.format(),this.raw=this.version,this},e.inc=function(H,x,ce,Fe){typeof ce=="string"&&(Fe=ce,ce=void 0);try{return new $e(H,ce).inc(x,Fe).version}catch{return null}},e.diff=function(H,x){if(ve(H,x))return null;var ce=ue(H),Fe=ue(x);if(ce.prerelease.length||Fe.prerelease.length){for(var Ue in ce)if((Ue==="major"||Ue==="minor"||Ue==="patch")&&ce[Ue]!==Fe[Ue])return"pre"+Ue;return"prerelease"}for(var Ue in ce)if((Ue==="major"||Ue==="minor"||Ue==="patch")&&ce[Ue]!==Fe[Ue])return Ue},e.compareIdentifiers=z;var ie=/^[0-9]+$/;function z(H,x){var ce=ie.test(H),Fe=ie.test(x);return ce&&Fe&&(H=+H,x=+x),ce&&!Fe?-1:Fe&&!ce?1:H<x?-1:H>x?1:0}function V(H,x,ce){return new $e(H,ce).compare(new $e(x,ce))}function le(H,x,ce){return V(H,x,ce)>0}function we(H,x,ce){return V(H,x,ce)<0}function ve(H,x,ce){return V(H,x,ce)===0}function me(H,x,ce){return V(H,x,ce)!==0}function De(H,x,ce){return V(H,x,ce)>=0}function re(H,x,ce){return V(H,x,ce)<=0}function he(H,x,ce,Fe){var Ue;switch(x){case"===":typeof H=="object"&&(H=H.version),typeof ce=="object"&&(ce=ce.version),Ue=H===ce;break;case"!==":typeof H=="object"&&(H=H.version),typeof ce=="object"&&(ce=ce.version),Ue=H!==ce;break;case"":case"=":case"==":Ue=ve(H,ce,Fe);break;case"!=":Ue=me(H,ce,Fe);break;case">":Ue=le(H,ce,Fe);break;case">=":Ue=De(H,ce,Fe);break;case"<":Ue=we(H,ce,Fe);break;case"<=":Ue=re(H,ce,Fe);break;default:throw new TypeError("Invalid operator: "+x)}return Ue}function se(H,x){if(H instanceof se){if(H.loose===x)return H;H=H.value}if(!(this instanceof se))return new se(H,x);C("comparator",H,x),this.loose=x,this.parse(H),this.semver===oe?this.value="":this.value=this.operator+this.semver.version,C("comp",this)}e.rcompareIdentifiers=function(H,x){return z(x,H)},e.major=function(H,x){return new $e(H,x).major},e.minor=function(H,x){return new $e(H,x).minor},e.patch=function(H,x){return new $e(H,x).patch},e.compare=V,e.compareLoose=function(H,x){return V(H,x,!0)},e.rcompare=function(H,x,ce){return V(x,H,ce)},e.sort=function(H,x){return H.sort(function(ce,Fe){return e.compare(ce,Fe,x)})},e.rsort=function(H,x){return H.sort(function(ce,Fe){return e.rcompare(ce,Fe,x)})},e.gt=le,e.lt=we,e.eq=ve,e.neq=me,e.gte=De,e.lte=re,e.cmp=he,e.Comparator=se;var oe={};function de(H,x){if(H instanceof de)return H.loose===x?H:new de(H.raw,x);if(H instanceof se)return new de(H.value,x);if(!(this instanceof de))return new de(H,x);if(this.loose=x,this.raw=H,this.set=H.split(/\s*\|\|\s*/).map(function(ce){return this.parseRange(ce.trim())},this).filter(function(ce){return ce.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+H);this.format()}function Ie(H){return!H||H.toLowerCase()==="x"||H==="*"}function T(H,x,ce,Fe,Ue,Qe,Ge,_e,Xe,xe,it,tt,ze){return((x=Ie(ce)?"":Ie(Fe)?">="+ce+".0.0":Ie(Ue)?">="+ce+"."+Fe+".0":">="+x)+" "+(_e=Ie(Xe)?"":Ie(xe)?"<"+(+Xe+1)+".0.0":Ie(it)?"<"+Xe+"."+(+xe+1)+".0":tt?"<="+Xe+"."+xe+"."+it+"-"+tt:"<="+_e)).trim()}function q(H,x){for(var ce=0;ce<H.length;ce++)if(!H[ce].test(x))return!1;if(x.prerelease.length){for(ce=0;ce<H.length;ce++)if(C(H[ce].semver),H[ce].semver!==oe&&H[ce].semver.prerelease.length>0){var Fe=H[ce].semver;if(Fe.major===x.major&&Fe.minor===x.minor&&Fe.patch===x.patch)return!0}return!1}return!0}function J(H,x,ce){try{x=new de(x,ce)}catch{return!1}return x.test(H)}function Q(H,x,ce,Fe){var Ue,Qe,Ge,_e,Xe;switch(H=new $e(H,Fe),x=new de(x,Fe),ce){case">":Ue=le,Qe=re,Ge=we,_e=">",Xe=">=";break;case"<":Ue=we,Qe=De,Ge=le,_e="<",Xe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(J(H,x,Fe))return!1;for(var xe=0;xe<x.set.length;++xe){var it=x.set[xe],tt=null,ze=null;if(it.forEach(function(st){st.semver===oe&&(st=new se(">=0.0.0")),tt=tt||st,ze=ze||st,Ue(st.semver,tt.semver,Fe)?tt=st:Ge(st.semver,ze.semver,Fe)&&(ze=st)}),tt.operator===_e||tt.operator===Xe||(!ze.operator||ze.operator===_e)&&Qe(H,ze.semver)||ze.operator===Xe&&Ge(H,ze.semver))return!1}return!0}se.prototype.parse=function(H){var x=this.loose?l[Y]:l[ye],ce=H.match(x);if(!ce)throw new TypeError("Invalid comparator: "+H);this.operator=ce[1],this.operator==="="&&(this.operator=""),ce[2]?this.semver=new $e(ce[2],this.loose):this.semver=oe},se.prototype.toString=function(){return this.value},se.prototype.test=function(H){return C("Comparator.test",H,this.loose),this.semver===oe||(typeof H=="string"&&(H=new $e(H,this.loose)),he(H,this.operator,this.semver,this.loose))},se.prototype.intersects=function(H,x){if(!(H instanceof se))throw new TypeError("a Comparator is required");var ce;if(this.operator==="")return ce=new de(H.value,x),J(this.value,ce,x);if(H.operator==="")return ce=new de(this.value,x),J(H.semver,ce,x);var Fe=!(this.operator!==">="&&this.operator!==">"||H.operator!==">="&&H.operator!==">"),Ue=!(this.operator!=="<="&&this.operator!=="<"||H.operator!=="<="&&H.operator!=="<"),Qe=this.semver.version===H.semver.version,Ge=!(this.operator!==">="&&this.operator!=="<="||H.operator!==">="&&H.operator!=="<="),_e=he(this.semver,"<",H.semver,x)&&(this.operator===">="||this.operator===">")&&(H.operator==="<="||H.operator==="<"),Xe=he(this.semver,">",H.semver,x)&&(this.operator==="<="||this.operator==="<")&&(H.operator===">="||H.operator===">");return Fe||Ue||Qe&&Ge||_e||Xe},e.Range=de,de.prototype.format=function(){return this.range=this.set.map(function(H){return H.join(" ").trim()}).join("||").trim(),this.range},de.prototype.toString=function(){return this.range},de.prototype.parseRange=function(H){var x=this.loose;H=H.trim(),C("range",H,x);var ce=x?l[X]:l[Pe];H=H.replace(ce,T),C("hyphen replace",H),H=H.replace(l[Ee],"$1$2$3"),C("comparator trim",H,l[Ee]),H=(H=(H=H.replace(l[W],"$1~")).replace(l[O],"$1^")).split(/\s+/).join(" ");var Fe=x?l[Y]:l[ye],Ue=H.split(" ").map(function(Qe){return function(Ge,_e){return C("comp",Ge),Ge=function(Xe,xe){return Xe.trim().split(/\s+/).map(function(it){return function(tt,ze){C("caret",tt,ze);var st=ze?l[te]:l[N];return tt.replace(st,function(_,Z,pe,je,Oe){var Ze;return C("caret",tt,_,Z,pe,je,Oe),Ie(Z)?Ze="":Ie(pe)?Ze=">="+Z+".0.0 <"+(+Z+1)+".0.0":Ie(je)?Ze=Z==="0"?">="+Z+"."+pe+".0 <"+Z+"."+(+pe+1)+".0":">="+Z+"."+pe+".0 <"+(+Z+1)+".0.0":Oe?(C("replaceCaret pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Ze=Z==="0"?pe==="0"?">="+Z+"."+pe+"."+je+Oe+" <"+Z+"."+pe+"."+(+je+1):">="+Z+"."+pe+"."+je+Oe+" <"+Z+"."+(+pe+1)+".0":">="+Z+"."+pe+"."+je+Oe+" <"+(+Z+1)+".0.0"):(C("no pr"),Ze=Z==="0"?pe==="0"?">="+Z+"."+pe+"."+je+" <"+Z+"."+pe+"."+(+je+1):">="+Z+"."+pe+"."+je+" <"+Z+"."+(+pe+1)+".0":">="+Z+"."+pe+"."+je+" <"+(+Z+1)+".0.0"),C("caret return",Ze),Ze})}(it,xe)}).join(" ")}(Ge,_e),C("caret",Ge),Ge=function(Xe,xe){return Xe.trim().split(/\s+/).map(function(it){return function(tt,ze){var st=ze?l[U]:l[K];return tt.replace(st,function(_,Z,pe,je,Oe){var Ze;return C("tilde",tt,_,Z,pe,je,Oe),Ie(Z)?Ze="":Ie(pe)?Ze=">="+Z+".0.0 <"+(+Z+1)+".0.0":Ie(je)?Ze=">="+Z+"."+pe+".0 <"+Z+"."+(+pe+1)+".0":Oe?(C("replaceTilde pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Ze=">="+Z+"."+pe+"."+je+Oe+" <"+Z+"."+(+pe+1)+".0"):Ze=">="+Z+"."+pe+"."+je+" <"+Z+"."+(+pe+1)+".0",C("tilde return",Ze),Ze})}(it,xe)}).join(" ")}(Ge,_e),C("tildes",Ge),Ge=function(Xe,xe){return C("replaceXRanges",Xe,xe),Xe.split(/\s+/).map(function(it){return function(tt,ze){tt=tt.trim();var st=ze?l[m]:l[u];return tt.replace(st,function(_,Z,pe,je,Oe,Ze){C("xRange",tt,_,Z,pe,je,Oe,Ze);var rt=Ie(pe),mt=rt||Ie(je),wt=mt||Ie(Oe);return Z==="="&&wt&&(Z=""),rt?_=Z===">"||Z==="<"?"<0.0.0":"*":Z&&wt?(mt&&(je=0),wt&&(Oe=0),Z===">"?(Z=">=",mt?(pe=+pe+1,je=0,Oe=0):wt&&(je=+je+1,Oe=0)):Z==="<="&&(Z="<",mt?pe=+pe+1:je=+je+1),_=Z+pe+"."+je+"."+Oe):mt?_=">="+pe+".0.0 <"+(+pe+1)+".0.0":wt&&(_=">="+pe+"."+je+".0 <"+pe+"."+(+je+1)+".0"),C("xRange return",_),_})}(it,xe)}).join(" ")}(Ge,_e),C("xrange",Ge),Ge=function(Xe,xe){return C("replaceStars",Xe,xe),Xe.trim().replace(l[ae],"")}(Ge,_e),C("stars",Ge),Ge}(Qe,x)}).join(" ").split(/\s+/);return this.loose&&(Ue=Ue.filter(function(Qe){return!!Qe.match(Fe)})),Ue=Ue.map(function(Qe){return new se(Qe,x)})},de.prototype.intersects=function(H,x){if(!(H instanceof de))throw new TypeError("a Range is required");return this.set.some(function(ce){return ce.every(function(Fe){return H.set.some(function(Ue){return Ue.every(function(Qe){return Fe.intersects(Qe,x)})})})})},e.toComparators=function(H,x){return new de(H,x).set.map(function(ce){return ce.map(function(Fe){return Fe.value}).join(" ").trim().split(" ")})},de.prototype.test=function(H){if(!H)return!1;typeof H=="string"&&(H=new $e(H,this.loose));for(var x=0;x<this.set.length;x++)if(q(this.set[x],H))return!0;return!1},e.satisfies=J,e.maxSatisfying=function(H,x,ce){var Fe=null,Ue=null;try{var Qe=new de(x,ce)}catch{return null}return H.forEach(function(Ge){Qe.test(Ge)&&(Fe&&Ue.compare(Ge)!==-1||(Ue=new $e(Fe=Ge,ce)))}),Fe},e.minSatisfying=function(H,x,ce){var Fe=null,Ue=null;try{var Qe=new de(x,ce)}catch{return null}return H.forEach(function(Ge){Qe.test(Ge)&&(Fe&&Ue.compare(Ge)!==1||(Ue=new $e(Fe=Ge,ce)))}),Fe},e.validRange=function(H,x){try{return new de(H,x).range||"*"}catch{return null}},e.ltr=function(H,x,ce){return Q(H,x,"<",ce)},e.gtr=function(H,x,ce){return Q(H,x,">",ce)},e.outside=Q,e.prerelease=function(H,x){var ce=ue(H,x);return ce&&ce.prerelease.length?ce.prerelease:null},e.intersects=function(H,x,ce){return H=new de(H,ce),x=new de(x,ce),H.intersects(x)},e.coerce=function(H){if(H instanceof $e)return H;if(typeof H!="string")return null;var x=H.match(l[h]);return x==null?null:ue((x[1]||"0")+"."+(x[2]||"0")+"."+(x[3]||"0"))}}).call(this,w(1))},function(be,e){var w,M,C=be.exports={};function F(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function l(t){if(w===setTimeout)return setTimeout(t,0);if((w===F||!w)&&setTimeout)return w=setTimeout,setTimeout(t,0);try{return w(t,0)}catch{try{return w.call(null,t,0)}catch{return w.call(this,t,0)}}}(function(){try{w=typeof setTimeout=="function"?setTimeout:F}catch{w=F}try{M=typeof clearTimeout=="function"?clearTimeout:A}catch{M=A}})();var k,f=[],R=!1,D=-1;function c(){R&&k&&(R=!1,k.length?f=k.concat(f):D=-1,f.length&&p())}function p(){if(!R){var t=l(c);R=!0;for(var n=f.length;n;){for(k=f,f=[];++D<n;)k&&k[D].run();D=-1,n=f.length}k=null,R=!1,function(a){if(M===clearTimeout)return clearTimeout(a);if((M===A||!M)&&clearTimeout)return M=clearTimeout,clearTimeout(a);try{M(a)}catch{try{return M.call(null,a)}catch{return M.call(this,a)}}}(t)}}function $(t,n){this.fun=t,this.array=n}function g(){}C.nextTick=function(t){var n=new Array(arguments.length-1);if(arguments.length>1)for(var a=1;a<arguments.length;a++)n[a-1]=arguments[a];f.push(new $(t,n)),f.length!==1||R||l(p)},$.prototype.run=function(){this.fun.apply(null,this.array)},C.title="browser",C.browser=!0,C.env={},C.argv=[],C.version="",C.versions={},C.on=g,C.addListener=g,C.once=g,C.off=g,C.removeListener=g,C.removeAllListeners=g,C.emit=g,C.prependListener=g,C.prependOnceListener=g,C.listeners=function(t){return[]},C.binding=function(t){throw new Error("process.binding is not supported")},C.cwd=function(){return"/"},C.chdir=function(t){throw new Error("process.chdir is not supported")},C.umask=function(){return 0}}])}),define(Re[118],Me([1,0,9,6]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=void 0;function C(E){const v=E;return v?typeof v.read=="function":!1}e.$Xd=C;function F(E){const v=E;return v?[v.on,v.pause,v.resume,v.destroy].every(r=>typeof r=="function"):!1}e.$Yd=F;function A(E){const v=E;return v?F(v.stream)&&Array.isArray(v.buffer)&&typeof v.ended=="boolean":!1}e.$Zd=A;function l(E,v){return new k(E,v)}e.$1d=l;class k{constructor(v,r){this.e=v,this.f=r,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(v){if(!this.a.destroyed){if(this.a.flowing)this.g(v);else if(this.b.data.push(v),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(r=>this.d.push(r))}}error(v){this.a.destroyed||(this.a.flowing?this.h(v):this.b.error.push(v))}end(v){this.a.destroyed||(typeof v<"u"&&this.write(v),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(v){this.c.data.slice(0).forEach(r=>r(v))}h(v){this.c.error.length===0?(0,w.$Z)(v):this.c.error.slice(0).forEach(r=>r(v))}i(){this.c.end.slice(0).forEach(v=>v())}on(v,r){if(!this.a.destroyed)switch(v){case"data":this.c.data.push(r),this.resume();break;case"end":this.c.end.push(r),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(r),this.a.flowing&&this.k();break}}removeListener(v,r){if(this.a.destroyed)return;let s;switch(v){case"data":s=this.c.data;break;case"end":s=this.c.end;break;case"error":s=this.c.error;break}if(s){const i=s.indexOf(r);i>=0&&s.splice(i,1)}}j(){if(this.b.data.length>0){const v=this.e(this.b.data);this.g(v),this.b.data.length=0;const r=[...this.d];this.d.length=0,r.forEach(s=>s())}}k(){if(this.c.error.length>0){for(const v of this.b.error)this.h(v);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function f(E,v){const r=[];let s;for(;(s=E.read())!==null;)r.push(s);return v(r)}e.$2d=f;function R(E,v,r){const s=[];let i;for(;(i=E.read())!==null&&s.length<r;)s.push(i);return i===null&&s.length>0?v(s):{read:()=>{if(s.length>0)return s.shift();if(typeof i<"u"){const o=i;return i=void 0,o}return E.read()}}}e.$3d=R;function D(E,v){return new Promise((r,s)=>{const i=[];c(E,{onData:o=>{v&&i.push(o)},onError:o=>{v?s(o):r(void 0)},onEnd:()=>{r(v?v(i):void 0)}})})}e.$4d=D;function c(E,v,r){E.on("error",s=>{r?.isCancellationRequested||v.onError(s)}),E.on("end",()=>{r?.isCancellationRequested||v.onEnd()}),E.on("data",s=>{r?.isCancellationRequested||v.onData(s)})}e.$5d=c;function p(E,v){return new Promise((r,s)=>{const i=new M.$Qc,o=[],y=S=>{if(o.push(S),o.length>v)return i.dispose(),E.pause(),r({stream:E,buffer:o,ended:!1})},d=S=>(i.dispose(),s(S)),I=()=>(i.dispose(),r({stream:E,buffer:o,ended:!0}));i.add((0,M.$Pc)(()=>E.removeListener("error",d))),E.on("error",d),i.add((0,M.$Pc)(()=>E.removeListener("end",I))),E.on("end",I),i.add((0,M.$Pc)(()=>E.removeListener("data",y))),E.on("data",y)})}e.$6d=p;function $(E,v){const r=l(v);return r.end(E),r}e.$7d=$;function g(){const E=l(()=>{throw new Error("not supported")});return E.end(),E}e.$8d=g;function t(E){let v=!1;return{read:()=>v?null:(v=!0,E)}}e.$9d=t;function n(E,v,r){const s=l(r);return c(E,{onData:i=>s.write(v.data(i)),onError:i=>s.error(v.error?v.error(i):i),onEnd:()=>s.end()}),s}e.$0d=n;function a(E,v,r){let s=!1;return{read:()=>{const i=v.read();return s?i:(s=!0,i!==null?r([E,i]):E)}}}e.$$d=a;function b(E,v,r){let s=!1;const i=l(r);return c(v,{onData:o=>s?i.write(o):(s=!0,i.write(r([E,o]))),onError:o=>i.error(o),onEnd:()=>{s||(s=!0,i.write(E)),i.end()}}),i}e.$_d=b}),define(Re[26],Me([1,0,48,118]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=void 0;const C=typeof Buffer<"u",F=new w.$U(()=>new Uint8Array(256));let A,l;class k{static alloc(h){return C?new k(Buffer.allocUnsafe(h)):new k(new Uint8Array(h))}static wrap(h){return C&&!Buffer.isBuffer(h)&&(h=Buffer.from(h.buffer,h.byteOffset,h.byteLength)),new k(h)}static fromString(h,P){return!(P?.dontUseNodeBuffer||!1)&&C?new k(Buffer.from(h)):(A||(A=new TextEncoder),new k(A.encode(h)))}static fromByteArray(h){const P=k.alloc(h.length);for(let W=0,K=h.length;W<K;W++)P.buffer[W]=h[W];return P}static concat(h,P){if(typeof P>"u"){P=0;for(let U=0,B=h.length;U<B;U++)P+=h[U].byteLength}const W=k.alloc(P);let K=0;for(let U=0,B=h.length;U<B;U++){const O=h[U];W.set(O,K),K+=O.byteLength}return W}constructor(h){this.buffer=h,this.byteLength=this.buffer.byteLength}clone(){const h=k.alloc(this.byteLength);return h.set(this),h}toString(){return C?this.buffer.toString():(l||(l=new TextDecoder),l.decode(this.buffer))}slice(h,P){return new k(this.buffer.subarray(h,P))}set(h,P){if(h instanceof k)this.buffer.set(h.buffer,P);else if(h instanceof Uint8Array)this.buffer.set(h,P);else if(h instanceof ArrayBuffer)this.buffer.set(new Uint8Array(h),P);else if(ArrayBuffer.isView(h))this.buffer.set(new Uint8Array(h.buffer,h.byteOffset,h.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(h){return c(this.buffer,h)}writeUInt32BE(h,P){p(this.buffer,h,P)}readUInt32LE(h){return $(this.buffer,h)}writeUInt32LE(h,P){g(this.buffer,h,P)}readUInt8(h){return t(this.buffer,h)}writeUInt8(h,P){n(this.buffer,h,P)}indexOf(h,P=0){return f(this.buffer,h instanceof k?h.buffer:h,P)}}e.$ae=k;function f(m,h,P=0){const W=h.byteLength,K=m.byteLength;if(W===0)return 0;if(W===1)return m.indexOf(h[0]);if(W>K-P)return-1;const U=F.value;U.fill(h.length);for(let te=0;te<h.length;te++)U[h[te]]=h.length-te-1;let B=P+h.length-1,O=B,N=-1;for(;B<K;)if(m[B]===h[O]){if(O===0){N=B;break}B--,O--}else B+=Math.max(h.length-O,U[m[B]]),O=h.length-1;return N}e.$be=f;function R(m,h){return m[h+0]<<0>>>0|m[h+1]<<8>>>0}e.$ce=R;function D(m,h,P){m[P+0]=h&255,h=h>>>8,m[P+1]=h&255}e.$de=D;function c(m,h){return m[h]*2**24+m[h+1]*2**16+m[h+2]*2**8+m[h+3]}e.$ee=c;function p(m,h,P){m[P+3]=h,h=h>>>8,m[P+2]=h,h=h>>>8,m[P+1]=h,h=h>>>8,m[P]=h}e.$fe=p;function $(m,h){return m[h+0]<<0>>>0|m[h+1]<<8>>>0|m[h+2]<<16>>>0|m[h+3]<<24>>>0}e.$ge=$;function g(m,h,P){m[P+0]=h&255,h=h>>>8,m[P+1]=h&255,h=h>>>8,m[P+2]=h&255,h=h>>>8,m[P+3]=h&255}e.$he=g;function t(m,h){return m[h]}e.$ie=t;function n(m,h,P){m[P]=h}e.$je=n;function a(m){return M.$2d(m,h=>k.concat(h))}e.$ke=a;function b(m){return M.$9d(m)}e.$le=b;function E(m){return M.$4d(m,h=>k.concat(h))}e.$me=E;async function v(m){return m.ended?k.concat(m.buffer):k.concat([...m.buffer,await E(m.stream)])}e.$ne=v;function r(m){return M.$7d(m,h=>k.concat(h))}e.$oe=r;function s(m){return M.$0d(m,{data:h=>typeof h=="string"?k.fromString(h):k.wrap(h)},h=>k.concat(h))}e.$pe=s;function i(m){return M.$1d(h=>k.concat(h),m)}e.$qe=i;function o(m,h){return M.$$d(m,h,P=>k.concat(P))}e.$re=o;function y(m,h){return M.$_d(m,h,P=>k.concat(P))}e.$se=y;function d(m){let h=0,P=0,W=0;const K=new Uint8Array(Math.floor(m.length/4*3)),U=O=>{switch(P){case 3:K[W++]=h|O,P=0;break;case 2:K[W++]=h|O>>>2,h=O<<6,P=3;break;case 1:K[W++]=h|O>>>4,h=O<<4,P=2;break;default:h=O<<2,P=1}};for(let O=0;O<m.length;O++){const N=m.charCodeAt(O);if(N>=65&&N<=90)U(N-65);else if(N>=97&&N<=122)U(N-97+26);else if(N>=48&&N<=57)U(N-48+52);else if(N===43||N===45)U(62);else if(N===47||N===95)U(63);else{if(N===61)break;throw new SyntaxError(`Unexpected base64 character ${m[O]}`)}}const B=W;for(;P>0;)U(0);return k.wrap(K).slice(0,B)}e.$te=d;const I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function u({buffer:m},h=!0,P=!1){const W=P?S:I;let K="";const U=m.byteLength%3;let B=0;for(;B<m.byteLength-U;B+=3){const O=m[B+0],N=m[B+1],te=m[B+2];K+=W[O>>>2],K+=W[(O<<4|N>>>4)&63],K+=W[(N<<2|te>>>6)&63],K+=W[te&63]}if(U===1){const O=m[B+0];K+=W[O>>>2],K+=W[O<<4&63],h&&(K+="==")}else if(U===2){const O=m[B+0],N=m[B+1];K+=W[O>>>2],K+=W[(O<<4|N>>>4)&63],K+=W[N<<2&63],h&&(K+="=")}return K}e.$ue=u}),define(Re[119],Me([1,0,28,15]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.FuzzyScore=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.or=void 0;function C(...se){return function(oe,de){for(let Ie=0,T=se.length;Ie<T;Ie++){const q=se[Ie](oe,de);if(q)return q}return null}}e.or=C,e.$Aj=F.bind(void 0,!1),e.$Bj=F.bind(void 0,!0);function F(se,oe,de){if(!de||de.length<oe.length)return null;let Ie;return se?Ie=M.$2e(de,oe):Ie=de.indexOf(oe)===0,Ie?oe.length>0?[{start:0,end:oe.length}]:[]:null}function A(se,oe){const de=oe.toLowerCase().indexOf(se.toLowerCase());return de===-1?null:[{start:de,end:de+se.length}]}e.$Cj=A;function l(se,oe){return k(se.toLowerCase(),oe.toLowerCase(),0,0)}e.$Dj=l;function k(se,oe,de,Ie){if(de===se.length)return[];if(Ie===oe.length)return null;if(se[de]===oe[Ie]){let T=null;return(T=k(se,oe,de+1,Ie+1))?n({start:Ie,end:Ie+1},T):null}return k(se,oe,de,Ie+1)}function f(se){return 97<=se&&se<=122}function R(se){return 65<=se&&se<=90}e.$Ej=R;function D(se){return 48<=se&&se<=57}function c(se){return se===32||se===9||se===10||se===13}const p=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(se=>p.add(se.charCodeAt(0)));function $(se){return c(se)||p.has(se)}function g(se,oe){return se===oe||$(se)&&$(oe)}function t(se){return f(se)||R(se)||D(se)}function n(se,oe){return oe.length===0?oe=[se]:se.end===oe[0].start?oe[0].start=se.start:oe.unshift(se),oe}function a(se,oe){for(let de=oe;de<se.length;de++){const Ie=se.charCodeAt(de);if(R(Ie)||D(Ie)||de>0&&!t(se.charCodeAt(de-1)))return de}return se.length}function b(se,oe,de,Ie){if(de===se.length)return[];if(Ie===oe.length)return null;if(se[de]!==oe[Ie].toLowerCase())return null;{let T=null,q=Ie+1;for(T=b(se,oe,de+1,Ie+1);!T&&(q=a(oe,q))<oe.length;)T=b(se,oe,de+1,q),q++;return T===null?null:n({start:Ie,end:Ie+1},T)}}function E(se){let oe=0,de=0,Ie=0,T=0,q=0;for(let ce=0;ce<se.length;ce++)q=se.charCodeAt(ce),R(q)&&oe++,f(q)&&de++,t(q)&&Ie++,D(q)&&T++;const J=oe/se.length,Q=de/se.length,H=Ie/se.length,x=T/se.length;return{upperPercent:J,lowerPercent:Q,alphaPercent:H,numericPercent:x}}function v(se){const{upperPercent:oe,lowerPercent:de}=se;return de===0&&oe>.6}function r(se){const{upperPercent:oe,lowerPercent:de,alphaPercent:Ie,numericPercent:T}=se;return de>.2&&oe<.8&&Ie>.6&&T<.2}function s(se){let oe=0,de=0,Ie=0,T=0;for(let q=0;q<se.length;q++)Ie=se.charCodeAt(q),R(Ie)&&oe++,f(Ie)&&de++,c(Ie)&&T++;return(oe===0||de===0)&&T===0?se.length<=30:oe<=5}function i(se,oe){if(!oe||(oe=oe.trim(),oe.length===0)||!s(se)||oe.length>60)return null;const de=E(oe);if(!r(de)){if(!v(de))return null;oe=oe.toLowerCase()}let Ie=null,T=0;for(se=se.toLowerCase();T<oe.length&&(Ie=b(se,oe,0,T))===null;)T=a(oe,T+1);return Ie}e.$Fj=i;function o(se,oe,de=!1){if(!oe||oe.length===0)return null;let Ie=null,T=0;for(se=se.toLowerCase(),oe=oe.toLowerCase();T<oe.length&&(Ie=y(se,oe,0,T,de))===null;)T=d(oe,T+1);return Ie}e.$Gj=o;function y(se,oe,de,Ie,T){if(de===se.length)return[];if(Ie===oe.length)return null;if(g(se.charCodeAt(de),oe.charCodeAt(Ie))){let q=null,J=Ie+1;if(q=y(se,oe,de+1,Ie+1,T),!T)for(;!q&&(J=d(oe,J))<oe.length;)q=y(se,oe,de+1,J,T),J++;return q?se.charCodeAt(de)!==oe.charCodeAt(Ie)?q:n({start:Ie,end:Ie+1},q):null}else return null}function d(se,oe){for(let de=oe;de<se.length;de++)if($(se.charCodeAt(de))||de>0&&$(se.charCodeAt(de-1)))return de;return se.length}const I=C(e.$Bj,i,A),S=C(e.$Bj,i,l),u=new w.$Cc(1e4);function m(se,oe,de=!1){if(typeof se!="string"||typeof oe!="string")return null;let Ie=u.get(se);Ie||(Ie=new RegExp(M.$Ke(se),"i"),u.set(se,Ie));const T=Ie.exec(oe);return T?[{start:T.index,end:T.index+T[0].length}]:de?S(se,oe):I(se,oe)}e.$Hj=m;function h(se,oe){const de=le(se,se.toLowerCase(),0,oe,oe.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return de?W(de):null}e.$Ij=h;function P(se,oe,de,Ie,T,q){const J=Math.min(13,se.length);for(;de<J;de++){const Q=le(se,oe,de,Ie,T,q,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Q)return Q}return[0,q]}e.$Jj=P;function W(se){if(typeof se>"u")return[];const oe=[],de=se[1];for(let Ie=se.length-1;Ie>1;Ie--){const T=se[Ie]+de,q=oe[oe.length-1];q&&q.end===T?q.end=T+1:oe.push({start:T,end:T+1})}return oe}e.$Kj=W;const K=128;function U(){const se=[],oe=[];for(let de=0;de<=K;de++)oe[de]=0;for(let de=0;de<=K;de++)se.push(oe.slice(0));return se}function B(se){const oe=[];for(let de=0;de<=se;de++)oe[de]=0;return oe}const O=B(2*K),N=B(2*K),te=U(),Y=U(),ye=U(),Ee=!1;function Pe(se,oe,de,Ie,T){function q(Q,H,x=" "){for(;Q.length<H;)Q=x+Q;return Q}let J=` |   |${Ie.split("").map(Q=>q(Q,3)).join("|")}
`;for(let Q=0;Q<=de;Q++)Q===0?J+=" |":J+=`${oe[Q-1]}|`,J+=se[Q].slice(0,T+1).map(H=>q(H.toString(),3)).join("|")+`
`;return J}function X(se,oe,de,Ie){se=se.substr(oe),de=de.substr(Ie),console.log(Pe(Y,se,se.length,de,de.length)),console.log(Pe(ye,se,se.length,de,de.length)),console.log(Pe(te,se,se.length,de,de.length))}function ae(se,oe){if(oe<0||oe>=se.length)return!1;const de=se.codePointAt(oe);switch(de){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!M.$hf(de)}}function Se(se,oe){if(oe<0||oe>=se.length)return!1;switch(se.charCodeAt(oe)){case 32:case 9:return!0;default:return!1}}function ue(se,oe,de){return oe[se]!==de[se]}function $e(se,oe,de,Ie,T,q,J=!1){for(;oe<de&&T<q;)se[oe]===Ie[T]&&(J&&(O[oe]=T),oe+=1),T+=1;return oe===de}e.$Lj=$e;var ie;(function(se){se[se.Diag=1]="Diag",se[se.Left=2]="Left",se[se.LeftLeft=3]="LeftLeft"})(ie||(ie={}));var z;(function(se){se.Default=[-100,0];function oe(de){return!de||de.length===2&&de[0]===-100&&de[1]===0}se.isDefault=oe})(z||(e.FuzzyScore=z={}));class V{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(oe,de){this.firstMatchCanBeWeak=oe,this.boostFullMatch=de}}e.$Mj=V;function le(se,oe,de,Ie,T,q,J=V.default){const Q=se.length>K?K:se.length,H=Ie.length>K?K:Ie.length;if(de>=Q||q>=H||Q-de>H-q||!$e(oe,de,Q,T,q,H,!0))return;we(Q,H,de,q,oe,T);let x=1,ce=1,Fe=de,Ue=q;const Qe=[!1];for(x=1,Fe=de;Fe<Q;x++,Fe++){const it=O[Fe],tt=N[Fe],ze=Fe+1<Q?N[Fe+1]:H;for(ce=it-q+1,Ue=it;Ue<ze;ce++,Ue++){let st=Number.MIN_SAFE_INTEGER,_=!1;Ue<=tt&&(st=ve(se,oe,Fe,de,Ie,T,Ue,H,q,te[x-1][ce-1]===0,Qe));let Z=0;st!==Number.MAX_SAFE_INTEGER&&(_=!0,Z=st+Y[x-1][ce-1]);const pe=Ue>it,je=pe?Y[x][ce-1]+(te[x][ce-1]>0?-5:0):0,Oe=Ue>it+1&&te[x][ce-1]>0,Ze=Oe?Y[x][ce-2]+(te[x][ce-2]>0?-5:0):0;if(Oe&&(!pe||Ze>=je)&&(!_||Ze>=Z))Y[x][ce]=Ze,ye[x][ce]=3,te[x][ce]=0;else if(pe&&(!_||je>=Z))Y[x][ce]=je,ye[x][ce]=2,te[x][ce]=0;else if(_)Y[x][ce]=Z,ye[x][ce]=1,te[x][ce]=te[x-1][ce-1]+1;else throw new Error("not possible")}}if(Ee&&X(se,de,Ie,q),!Qe[0]&&!J.firstMatchCanBeWeak)return;x--,ce--;const Ge=[Y[x][ce],q];let _e=0,Xe=0;for(;x>=1;){let it=ce;do{const tt=ye[x][it];if(tt===3)it=it-2;else if(tt===2)it=it-1;else break}while(it>=1);_e>1&&oe[de+x-1]===T[q+ce-1]&&!ue(it+q-1,Ie,T)&&_e+1>te[x][it]&&(it=ce),it===ce?_e++:_e=1,Xe||(Xe=it),x--,ce=it-1,Ge.push(ce)}H===Q&&J.boostFullMatch&&(Ge[0]+=2);const xe=Xe-Q;return Ge[0]-=xe,Ge}e.$Nj=le;function we(se,oe,de,Ie,T,q){let J=se-1,Q=oe-1;for(;J>=de&&Q>=Ie;)T[J]===q[Q]&&(N[J]=Q,J--),Q--}function ve(se,oe,de,Ie,T,q,J,Q,H,x,ce){if(oe[de]!==q[J])return Number.MIN_SAFE_INTEGER;let Fe=1,Ue=!1;return J===de-Ie?Fe=se[de]===T[J]?7:5:ue(J,T,q)&&(J===0||!ue(J-1,T,q))?(Fe=se[de]===T[J]?7:5,Ue=!0):ae(q,J)&&(J===0||!ae(q,J-1))?Fe=5:(ae(q,J-1)||Se(q,J-1))&&(Fe=5,Ue=!0),Fe>1&&de===Ie&&(ce[0]=!0),Ue||(Ue=ue(J,T,q)||ae(q,J-1)||Se(q,J-1)),de===Ie?J>H&&(Fe-=Ue?3:5):x?Fe+=Ue?2:0:Fe+=Ue?0:1,J+1===Q&&(Fe-=Ue?3:5),Fe}function me(se,oe,de,Ie,T,q,J){return re(se,oe,de,Ie,T,q,!0,J)}e.$Oj=me;function De(se,oe,de,Ie,T,q,J){return re(se,oe,de,Ie,T,q,!1,J)}e.$Pj=De;function re(se,oe,de,Ie,T,q,J,Q){let H=le(se,oe,de,Ie,T,q,Q);if(H&&!J)return H;if(se.length>=3){const x=Math.min(7,se.length-1);for(let ce=de+1;ce<x;ce++){const Fe=he(se,ce);if(Fe){const Ue=le(Fe,Fe.toLowerCase(),de,Ie,T,q,Q);Ue&&(Ue[0]-=3,(!H||Ue[0]>H[0])&&(H=Ue))}}}return H}function he(se,oe){if(oe+1>=se.length)return;const de=se[oe],Ie=se[oe+1];if(de!==Ie)return se.slice(0,oe)+Ie+de+se.slice(oe+2)}}),define(Re[29],Me([1,0,15]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var M;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(M||(M={})),function(C){const F="error",A="warning",l="warn",k="info",f="ignore";function R(c){return c?w.$1e(F,c)?C.Error:w.$1e(A,c)||w.$1e(l,c)?C.Warning:w.$1e(k,c)?C.Info:C.Ignore:C.Ignore}C.fromValue=R;function D(c){switch(c){case C.Error:return F;case C.Warning:return A;case C.Info:return k;default:return f}}C.toString=D}(M||(M={})),e.default=M}),define(Re[120],Me([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jd=void 0,e.$Jd=Symbol("MicrotaskDelay")}),define(Re[49],Me([1,0,18,15]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=void 0;class C{constructor(){this.b="",this.c=0}reset(p){return this.b=p,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(p){const $=p.charCodeAt(0),g=this.b.charCodeAt(this.c);return $-g}value(){return this.b[this.c]}}e.$Ph=C;class F{constructor(p=!0){this.e=p}reset(p){return this.b=p,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let p=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(p)this.c++;else break;else p=!1;return this}cmp(p){return this.e?(0,M.$Ue)(p,this.b,0,p.length,this.c,this.d):(0,M.$We)(p,this.b,0,p.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Qh=F;class A{constructor(p=!0,$=!0){this.f=p,this.g=$}reset(p){this.d=0,this.e=0,this.b=p,this.c=p.length;for(let $=p.length-1;$>=0;$--,this.c--){const g=this.b.charCodeAt($);if(!(g===47||this.f&&g===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let p=!0;for(;this.e<this.c;this.e++){const $=this.b.charCodeAt(this.e);if($===47||this.f&&$===92)if(p)this.d++;else break;else p=!1}return this}cmp(p){return this.g?(0,M.$Ue)(p,this.b,0,p.length,this.d,this.e):(0,M.$We)(p,this.b,0,p.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Rh=A;var l;(function(c){c[c.Scheme=1]="Scheme",c[c.Authority=2]="Authority",c[c.Path=3]="Path",c[c.Query=4]="Query",c[c.Fragment=5]="Fragment"})(l||(l={}));class k{constructor(p,$){this.f=p,this.g=$,this.d=[],this.e=0}reset(p){return this.c=p,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(p)),this.b.reset(p.path),this.b.value()&&this.d.push(3)),this.g(p)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(p){if(this.d[this.e]===1)return(0,M.$Ve)(p,this.c.scheme);if(this.d[this.e]===2)return(0,M.$Ve)(p,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(p);if(this.d[this.e]===4)return(0,M.$Te)(p,this.c.query);if(this.d[this.e]===5)return(0,M.$Te)(p,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Sh=k;class f{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const p=this.right;return this.right=p.left,p.left=this,this.updateHeight(),p.updateHeight(),p}rotateRight(){const p=this.left;return this.left=p.right,p.right=this,this.updateHeight(),p.updateHeight(),p}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var R;(function(c){c[c.Left=-1]="Left",c[c.Mid=0]="Mid",c[c.Right=1]="Right"})(R||(R={}));class D{static forUris(p=()=>!1,$=()=>!1){return new D(new k(p,$))}static forPaths(p=!1){return new D(new A(void 0,!p))}static forStrings(){return new D(new C)}static forConfigKeys(){return new D(new F)}constructor(p){this.b=p}clear(){this.c=void 0}fill(p,$){if($){const g=$.slice(0);(0,w.$Wb)(g);for(const t of g)this.set(t,p)}else{const g=p.slice(0);(0,w.$Wb)(g);for(const t of g)this.set(t[0],t[1])}}set(p,$){const g=this.b.reset(p);let t;this.c||(this.c=new f,this.c.segment=g.value());const n=[];for(t=this.c;;){const b=g.cmp(t.segment);if(b>0)t.left||(t.left=new f,t.left.segment=g.value()),n.push([-1,t]),t=t.left;else if(b<0)t.right||(t.right=new f,t.right.segment=g.value()),n.push([1,t]),t=t.right;else if(g.hasNext())g.next(),t.mid||(t.mid=new f,t.mid.segment=g.value()),n.push([0,t]),t=t.mid;else break}const a=t.value;t.value=$,t.key=p;for(let b=n.length-1;b>=0;b--){const E=n[b][1];E.updateHeight();const v=E.balanceFactor();if(v<-1||v>1){const r=n[b][0],s=n[b+1][0];if(r===1&&s===1)n[b][1]=E.rotateLeft();else if(r===-1&&s===-1)n[b][1]=E.rotateRight();else if(r===1&&s===-1)E.right=n[b+1][1]=n[b+1][1].rotateRight(),n[b][1]=E.rotateLeft();else if(r===-1&&s===1)E.left=n[b+1][1]=n[b+1][1].rotateLeft(),n[b][1]=E.rotateRight();else throw new Error;if(b>0)switch(n[b-1][0]){case-1:n[b-1][1].left=n[b][1];break;case 1:n[b-1][1].right=n[b][1];break;case 0:n[b-1][1].mid=n[b][1];break}else this.c=n[0][1]}}return a}get(p){return this.d(p)?.value}d(p){const $=this.b.reset(p);let g=this.c;for(;g;){const t=$.cmp(g.segment);if(t>0)g=g.left;else if(t<0)g=g.right;else if($.hasNext())$.next(),g=g.mid;else break}return g}has(p){const $=this.d(p);return!($?.value===void 0&&$?.mid===void 0)}delete(p){return this.e(p,!1)}deleteSuperstr(p){return this.e(p,!0)}e(p,$){const g=this.b.reset(p),t=[];let n=this.c;for(;n;){const a=g.cmp(n.segment);if(a>0)t.push([-1,n]),n=n.left;else if(a<0)t.push([1,n]),n=n.right;else if(g.hasNext())g.next(),t.push([0,n]),n=n.mid;else break}if(n){if($?(n.left=void 0,n.mid=void 0,n.right=void 0,n.height=1):(n.key=void 0,n.value=void 0),!n.mid&&!n.value)if(n.left&&n.right){const a=this.f(n.right);if(a.key){const{key:b,value:E,segment:v}=a;this.e(a.key,!1),n.key=b,n.value=E,n.segment=v}}else{const a=n.left??n.right;if(t.length>0){const[b,E]=t[t.length-1];switch(b){case-1:E.left=a;break;case 0:E.mid=a;break;case 1:E.right=a;break}}else this.c=a}for(let a=t.length-1;a>=0;a--){const b=t[a][1];b.updateHeight();const E=b.balanceFactor();if(E>1?(b.right.balanceFactor()>=0||(b.right=b.right.rotateRight()),t[a][1]=b.rotateLeft()):E<-1&&(b.left.balanceFactor()<=0||(b.left=b.left.rotateLeft()),t[a][1]=b.rotateRight()),a>0)switch(t[a-1][0]){case-1:t[a-1][1].left=t[a][1];break;case 1:t[a-1][1].right=t[a][1];break;case 0:t[a-1][1].mid=t[a][1];break}else this.c=t[0][1]}}}f(p){for(;p.left;)p=p.left;return p}findSubstr(p){const $=this.b.reset(p);let g=this.c,t;for(;g;){const n=$.cmp(g.segment);if(n>0)g=g.left;else if(n<0)g=g.right;else if($.hasNext())$.next(),t=g.value||t,g=g.mid;else break}return g&&g.value||t}findSuperstr(p){return this.g(p,!1)}g(p,$){const g=this.b.reset(p);let t=this.c;for(;t;){const n=g.cmp(t.segment);if(n>0)t=t.left;else if(n<0)t=t.right;else if(g.hasNext())g.next(),t=t.mid;else return t.mid?this.h(t.mid):$?t.value:void 0}}hasElementOrSubtree(p){return this.g(p,!0)!==void 0}forEach(p){for(const[$,g]of this)p(g,$)}*[Symbol.iterator](){yield*this.h(this.c)}h(p){const $=[];return this.j(p,$),$[Symbol.iterator]()}j(p,$){p&&(p.left&&this.j(p.left,$),p.value&&$.push([p.key,p.value]),p.mid&&this.j(p.mid,$),p.right&&this.j(p.right,$))}_isBalanced(){const p=$=>{if(!$)return!0;const g=$.balanceFactor();return g<-1||g>1?!1:p($.left)&&p($.right)};return p(this.c)}}e.$Th=D}),define(Re[40],Me([1,0,89]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Tj=e.ThemeColor=void 0;var M;(function(A){function l(k){return k&&typeof k=="object"&&typeof k.id=="string"}A.isThemeColor=l})(M||(e.ThemeColor=M={}));function C(A){return{id:A}}e.$Tj=C;var F;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const l=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function k(a){const b=l.exec(a.id);if(!b)return k(w.$Sj.error);const[,E,v]=b,r=["codicon","codicon-"+E];return v&&r.push("codicon-modifier-"+v.substring(1)),r}A.asClassNameArray=k;function f(a){return k(a).join(" ")}A.asClassName=f;function R(a){return"."+k(a).join(".")}A.asCSSSelector=R;function D(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(typeof a.color>"u"||M.isThemeColor(a.color))}A.isThemeIcon=D;const c=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function p(a){const b=c.exec(a);if(!b)return;const[,E]=b;return{id:E}}A.fromString=p;function $(a){return{id:a}}A.fromId=$;function g(a,b){let E=a.id;const v=E.lastIndexOf("~");return v!==-1&&(E=E.substring(0,v)),b&&(E=`${E}~${b}`),{id:E}}A.modify=g;function t(a){const b=a.id.lastIndexOf("~");if(b!==-1)return a.id.substring(b+1)}A.getModifier=t;function n(a,b){return a.id===b.id&&a.color?.id===b.color?.id}A.isEqual=n})(F||(e.ThemeIcon=F={}))}),define(Re[121],Me([1,0,119,15,40]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=void 0;const F="$(",A=new RegExp(`\\$\\(${C.ThemeIcon.iconNameExpression}(?:${C.ThemeIcon.iconModifierExpression})?\\)`,"g"),l=new RegExp(`(\\\\)?${A.source}`,"g");function k(n){return n.replace(l,(a,b)=>b?a:`\\${a}`)}e.$Uj=k;const f=new RegExp(`\\\\${A.source}`,"g");function R(n){return n.replace(f,a=>`\\${a}`)}e.$Vj=R;const D=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function c(n){return n.indexOf(F)===-1?n:n.replace(D,(a,b,E,v)=>E?a:b||v||"")}e.$Wj=c;function p(n){return n?n.replace(/\$\((.*?)\)/g,(a,b)=>` ${b} `).trim():""}e.$Xj=p;const $=new RegExp(`\\$\\(${C.ThemeIcon.iconNameCharacter}+\\)`,"g");function g(n){$.lastIndex=0;let a="";const b=[];let E=0;for(;;){const v=$.lastIndex,r=$.exec(n),s=n.substring(v,r?.index);if(s.length>0){a+=s;for(let i=0;i<s.length;i++)b.push(E)}if(!r)break;E+=r[0].length}return{text:a,iconOffsets:b}}e.$Yj=g;function t(n,a,b=!1){const{text:E,iconOffsets:v}=a;if(!v||v.length===0)return(0,w.$Hj)(n,E,b);const r=(0,M.$Ie)(E," "),s=E.length-r.length,i=(0,w.$Hj)(n,r,b);if(i)for(const o of i){const y=v[o.start+s]+s;o.start+=y,o.end+=y}return i}e.$Zj=t}),define(Re[36],Me([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dg=e.$cg=void 0;const w=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function M(C){return w.test(C)}e.$cg=M,e.$dg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(l){for(let k=0;k<l.length;k++)l[k]=Math.floor(Math.random()*256);return l};const F=new Uint8Array(16),A=[];for(let l=0;l<256;l++)A.push(l.toString(16).padStart(2,"0"));return function(){C(F),F[6]=F[6]&15|64,F[8]=F[8]&63|128;let k=0,f="";return f+=A[F[k++]],f+=A[F[k++]],f+=A[F[k++]],f+=A[F[k++]],f+="-",f+=A[F[k++]],f+=A[F[k++]],f+="-",f+=A[F[k++]],f+=A[F[k++]],f+="-",f+=A[F[k++]],f+=A[F[k++]],f+="-",f+=A[F[k++]],f+=A[F[k++]],f+=A[F[k++]],f+=A[F[k++]],f+=A[F[k++]],f+=A[F[k++]],f}}()}),define(Re[122],Me([1,0,18,65,36]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xs=e.$Ws=e.$Vs=e.$Us=e.$Ts=void 0;function F(D){return{asString:async()=>D,asFile:()=>{},value:typeof D=="string"?D:void 0}}e.$Ts=F;function A(D,c,p){const $={id:(0,C.$dg)(),name:D,uri:c,data:p};return{asString:async()=>"",asFile:()=>$,value:void 0}}e.$Us=A;class l{constructor(){this.a=new Map}get size(){let c=0;for(const p of this.a)c++;return c}has(c){return this.a.has(this.b(c))}matches(c){const p=[...this.a.keys()];return M.Iterable.some(this,([$,g])=>g.asFile())&&p.push("files"),R(k(c),p)}get(c){return this.a.get(this.b(c))?.[0]}append(c,p){const $=this.a.get(c);$?$.push(p):this.a.set(this.b(c),[p])}replace(c,p){this.a.set(this.b(c),[p])}delete(c){this.a.delete(this.b(c))}*[Symbol.iterator](){for(const[c,p]of this.a)for(const $ of p)yield[c,$]}b(c){return k(c)}}e.$Vs=l;function k(D){return D.toLowerCase()}function f(D,c){return R(k(D),c.map(k))}e.$Ws=f;function R(D,c){if(D==="*/*")return c.length>0;if(c.includes(D))return!0;const p=D.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!p)return!1;const[$,g,t]=p;return t==="*"?c.some(n=>n.startsWith(g+"/")):!1}e.$Xs=Object.freeze({create:D=>(0,w.$Lb)(D.map(c=>c.toString())).join(`\r
`),split:D=>D.split(`\r
`),parse:D=>e.$Xs.split(D).filter(c=>!c.startsWith("#"))})}),define(Re[123],Me([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yr=void 0,e.$Yr={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Re[124],Me([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lt=e.$kt=e.IndentAction=void 0;var w;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(w||(e.IndentAction=w={}));class M{constructor(l){if(this.e=null,this.f=!1,this.open=l.open,this.close=l.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(l.notIn))for(let k=0,f=l.notIn.length;k<f;k++)switch(l.notIn[k]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(l){switch(l){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(l,k){if(l.getTokenCount()===0)return!0;const f=l.findTokenIndexAtOffset(k-2),R=l.getStandardTokenType(f);return this.isOK(R)}g(l,k){for(let f=l;f<=k;f++){const R=String.fromCharCode(f);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$kt=M;class C{constructor(l){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const k of l)F(this.autoClosingPairsOpenByStart,k.open.charAt(0),k),F(this.autoClosingPairsOpenByEnd,k.open.charAt(k.open.length-1),k),F(this.autoClosingPairsCloseByStart,k.close.charAt(0),k),F(this.autoClosingPairsCloseByEnd,k.close.charAt(k.close.length-1),k),k.close.length===1&&k.open.length===1&&F(this.autoClosingPairsCloseSingleChar,k.close,k)}}e.$lt=C;function F(A,l,k){A.has(l)?A.get(l).push(k):A.set(l,[k])}}),define(Re[125],Me([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G7=e.$F7=void 0;class w{constructor(){this.a=new Map}removeDragOperationTransfer(F){if(F&&this.a.has(F)){const A=this.a.get(F);return this.a.delete(F),A}}addDragOperationTransfer(F,A){this.a.set(F,A)}}e.$F7=w;class M{constructor(F){this.identifier=F}}e.$G7=M}),define(Re[126],Me([10,11]),function(be,e){return be.create("vs/base/common/actions",e)}),define(Re[127],Me([1,0,5,6,126]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=void 0;class F extends M.$Rc{constructor(c,p="",$="",g=!0,t){super(),this.h=this.B(new w.$Md),this.onDidChange=this.h.event,this.w=!0,this.j=c,this.m=p,this.u=$,this.w=g,this.C=t}get id(){return this.j}get label(){return this.m}set label(c){this.D(c)}D(c){this.m!==c&&(this.m=c,this.h.fire({label:c}))}get tooltip(){return this.n||""}set tooltip(c){this.F(c)}F(c){this.n!==c&&(this.n=c,this.h.fire({tooltip:c}))}get class(){return this.u}set class(c){this.G(c)}G(c){this.u!==c&&(this.u=c,this.h.fire({class:c}))}get enabled(){return this.w}set enabled(c){this.H(c)}H(c){this.w!==c&&(this.w=c,this.h.fire({enabled:c}))}get checked(){return this.z}set checked(c){this.I(c)}I(c){this.z!==c&&(this.z=c,this.h.fire({checked:c}))}async run(c,p){this.C&&await this.C(c)}}e.$si=F;class A extends M.$Rc{constructor(){super(...arguments),this.f=this.B(new w.$Md),this.onWillRun=this.f.event,this.m=this.B(new w.$Md),this.onDidRun=this.m.event}async run(c,p){if(!c.enabled)return;this.f.fire({action:c});let $;try{await this.u(c,p)}catch(g){$=g}this.m.fire({action:c,error:$})}async u(c,p){await c.run(p)}}e.$ti=A;class l{constructor(){this.id=l.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...c){let p=[];for(const $ of c)$.length&&(p.length?p=[...p,new l,...$]:p=$);return p}static{this.ID="vs.actions.separator"}async run(){}}e.$ui=l;class k{get actions(){return this.a}constructor(c,p,$,g){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=c,this.label=p,this.class=g,this.a=$}async run(){}}e.$vi=k;class f extends F{static{this.ID="vs.actions.empty"}constructor(){super(f.ID,C.localize(0,null),void 0,!1)}}e.$wi=f;function R(D){return{id:D.id,label:D.label,class:void 0,enabled:D.enabled??!0,checked:D.checked??!1,run:async(...c)=>D.run(...c),tooltip:D.label}}e.$xi=R}),define(Re[128],Me([10,11]),function(be,e){return be.create("vs/base/common/date",e)}),define(Re[129],Me([1,0,128]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$am=e.$_l=void 0;const M=60,C=M*60,F=C*24,A=F*7,l=F*30,k=F*365;function f(D,c,p,$){typeof D!="number"&&(D=D.getTime());const g=Math.round((new Date().getTime()-D)/1e3);if(g<-30)return(0,w.localize)(0,null,f(new Date().getTime()+g*1e3,!1));if(!$&&g<30)return(0,w.localize)(1,null);let t;return g<M?(t=g,c?t===1?p?(0,w.localize)(2,null,t):(0,w.localize)(3,null,t):p?(0,w.localize)(4,null,t):(0,w.localize)(5,null,t):t===1?p?(0,w.localize)(6,null,t):(0,w.localize)(7,null,t):p?(0,w.localize)(8,null,t):(0,w.localize)(9,null,t)):g<C?(t=Math.floor(g/M),c?t===1?p?(0,w.localize)(10,null,t):(0,w.localize)(11,null,t):p?(0,w.localize)(12,null,t):(0,w.localize)(13,null,t):t===1?p?(0,w.localize)(14,null,t):(0,w.localize)(15,null,t):p?(0,w.localize)(16,null,t):(0,w.localize)(17,null,t)):g<F?(t=Math.floor(g/C),c?t===1?p?(0,w.localize)(18,null,t):(0,w.localize)(19,null,t):p?(0,w.localize)(20,null,t):(0,w.localize)(21,null,t):t===1?p?(0,w.localize)(22,null,t):(0,w.localize)(23,null,t):p?(0,w.localize)(24,null,t):(0,w.localize)(25,null,t)):g<A?(t=Math.floor(g/F),c?t===1?(0,w.localize)(26,null,t):(0,w.localize)(27,null,t):t===1?(0,w.localize)(28,null,t):(0,w.localize)(29,null,t)):g<l?(t=Math.floor(g/A),c?t===1?p?(0,w.localize)(30,null,t):(0,w.localize)(31,null,t):p?(0,w.localize)(32,null,t):(0,w.localize)(33,null,t):t===1?p?(0,w.localize)(34,null,t):(0,w.localize)(35,null,t):p?(0,w.localize)(36,null,t):(0,w.localize)(37,null,t)):g<k?(t=Math.floor(g/l),c?t===1?p?(0,w.localize)(38,null,t):(0,w.localize)(39,null,t):p?(0,w.localize)(40,null,t):(0,w.localize)(41,null,t):t===1?p?(0,w.localize)(42,null,t):(0,w.localize)(43,null,t):p?(0,w.localize)(44,null,t):(0,w.localize)(45,null,t)):(t=Math.floor(g/k),c?t===1?p?(0,w.localize)(46,null,t):(0,w.localize)(47,null,t):p?(0,w.localize)(48,null,t):(0,w.localize)(49,null,t):t===1?p?(0,w.localize)(50,null,t):(0,w.localize)(51,null,t):p?(0,w.localize)(52,null,t):(0,w.localize)(53,null,t))}e.$_l=f;function R(D){return D.getFullYear()+"-"+String(D.getMonth()+1).padStart(2,"0")+"-"+String(D.getDate()).padStart(2,"0")+"T"+String(D.getHours()).padStart(2,"0")+":"+String(D.getMinutes()).padStart(2,"0")+":"+String(D.getSeconds()).padStart(2,"0")+"."+(D.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$am=R}),define(Re[130],Me([10,11]),function(be,e){return be.create("vs/base/common/errorMessage",e)}),define(Re[41],Me([1,0,18,16,130]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ai=e.$zi=e.$yi=void 0;function F(D,c){return c&&(D.stack||D.stacktrace)?C.localize(0,null,l(D),A(D.stack)||A(D.stacktrace)):l(D)}function A(D){return Array.isArray(D)?D.join(`
`):D}function l(D){return D.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${D.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof D.code=="string"&&typeof D.errno=="number"&&typeof D.syscall=="string"?C.localize(1,null,D.message):D.message||C.localize(2,null)}function k(D=null,c=!1){if(!D)return C.localize(3,null);if(Array.isArray(D)){const p=w.$Gb(D),$=k(p[0],c);return p.length>1?C.localize(4,null,$,p.length):$}if(M.$xf(D))return D;if(D.detail){const p=D.detail;if(p.error)return F(p.error,c);if(p.exception)return F(p.exception,c)}return D.stack?F(D,c):D.message?D.message:C.localize(5,null)}e.$yi=k;function f(D){const c=D;return c instanceof Error&&Array.isArray(c.actions)}e.$zi=f;function R(D,c){let p;return typeof D=="string"?p=new Error(D):p=D,p.actions=c,p}e.$Ai=R}),define(Re[131],Me([1,0,48,19]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pq=e.$oq=e.$nq=e.$mq=e.$lq=e.$kq=e.$jq=e.$iq=e.$hq=e.$gq=e.$fq=e.$eq=e.$dq=void 0;const C=new w.$U(()=>{const S=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:S,collatorIsNumeric:S.resolvedOptions().numeric}}),F=new w.$U(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new w.$U(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function l(S,u,m=!1){const h=S||"",P=u||"",W=C.value.collator.compare(h,P);return C.value.collatorIsNumeric&&W===0&&h!==P?h<P?-1:1:W}e.$dq=l;function k(S,u){const m=F.value.collator;return S=S||"",u=u||"",E(m,S,u)}e.$eq=k;function f(S,u){const m=F.value.collator;return S=S||"",u=u||"",i(S,u)||E(m,S,u)}e.$fq=f;function R(S,u){const m=F.value.collator;return S=S||"",u=u||"",s(S,u)||E(m,S,u)}e.$gq=R;function D(S,u){return S=S||"",u=u||"",S===u?0:S<u?-1:1}e.$hq=D;function c(S,u){const[m,h]=a(S),[P,W]=a(u);let K=C.value.collator.compare(h,W);if(K===0){if(C.value.collatorIsNumeric&&h!==W)return h<W?-1:1;if(K=C.value.collator.compare(m,P),C.value.collatorIsNumeric&&K===0&&m!==P)return m<P?-1:1}return K}e.$iq=c;function p(S,u){S=S||"",u=u||"";const m=b(S),h=b(u),P=F.value.collator,W=A.value.collator;return E(W,m,h)||E(P,S,u)}e.$jq=p;function $(S,u){S=S||"",u=u||"";const m=b(S),h=b(u),P=F.value.collator,W=A.value.collator;return E(W,m,h)||i(S,u)||E(P,S,u)}e.$kq=$;function g(S,u){S=S||"",u=u||"";const m=b(S),h=b(u),P=F.value.collator,W=A.value.collator;return E(W,m,h)||s(S,u)||E(P,S,u)}e.$lq=g;function t(S,u){S=S||"",u=u||"";const m=b(S).toLowerCase(),h=b(u).toLowerCase();return m!==h?m<h?-1:1:S!==u?S<u?-1:1:0}e.$mq=t;const n=/^(.*?)(\.([^.]*))?$/;function a(S,u=!1){const m=S?n.exec(S):[];let h=[m&&m[1]||"",m&&m[3]||""];return u&&(!h[0]&&h[1]||h[0]&&h[0].charAt(0)===".")&&(h=[h[0]+"."+h[1],""]),h}function b(S){const u=S?n.exec(S):[];return u&&u[1]&&u[1].charAt(0)!=="."&&u[3]||""}function E(S,u,m){const h=S.compare(u,m);return h!==0?h:u.length!==m.length?u.length<m.length?-1:1:0}function v(S){const u=S.charAt(0);return u.toLocaleUpperCase()!==u}function r(S){const u=S.charAt(0);return u.toLocaleLowerCase()!==u}function s(S,u){return v(S)&&r(u)?-1:r(S)&&v(u)?1:0}function i(S,u){return r(S)&&v(u)?-1:v(S)&&r(u)?1:0}function o(S,u,m=!1){return m||(S=S&&S.toLowerCase(),u=u&&u.toLowerCase()),S===u?0:S<u?-1:1}function y(S,u,m=!1){const h=S.split(M.sep),P=u.split(M.sep),W=h.length-1,K=P.length-1;let U,B;for(let O=0;;O++){if(U=W===O,B=K===O,U&&B)return l(h[O],P[O],m);if(U)return-1;if(B)return 1;const N=o(h[O],P[O],m);if(N!==0)return N}}e.$nq=y;function d(S,u,m){const h=S.toLowerCase(),P=u.toLowerCase(),W=I(S,u,m);if(W)return W;const K=h.endsWith(m),U=P.endsWith(m);if(K!==U)return K?-1:1;const B=l(h,P);return B!==0?B:h.localeCompare(P)}e.$oq=d;function I(S,u,m){const h=S.toLowerCase(),P=u.toLowerCase(),W=h.startsWith(m),K=P.startsWith(m);if(W!==K)return W?-1:1;if(W&&K){if(h.length<P.length)return-1;if(h.length>P.length)return 1}return 0}e.$pq=I}),define(Re[42],Me([1,0,19,22,15,16]),function(be,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=void 0;function A(d){return d===47||d===92}e.$Pf=A;function l(d){return d.replace(/[\\/]/g,w.$fc.sep)}e.$Qf=l;function k(d){return d.indexOf("/")===-1&&(d=l(d)),/^[a-zA-Z]:(\/|$)/.test(d)&&(d="/"+d),d}e.$Rf=k;function f(d,I=w.$fc.sep){if(!d)return"";const S=d.length,u=d.charCodeAt(0);if(A(u)){if(A(d.charCodeAt(1))&&!A(d.charCodeAt(2))){let h=3;const P=h;for(;h<S&&!A(d.charCodeAt(h));h++);if(P!==h&&!A(d.charCodeAt(h+1))){for(h+=1;h<S;h++)if(A(d.charCodeAt(h)))return d.slice(0,h+1).replace(/[\\/]/g,I)}}return I}else if(n(u)&&d.charCodeAt(1)===58)return A(d.charCodeAt(2))?d.slice(0,2)+I:d.slice(0,2);let m=d.indexOf("://");if(m!==-1){for(m+=3;m<S;m++)if(A(d.charCodeAt(m)))return d.slice(0,m+1)}return""}e.$Sf=f;function R(d){if(!M.$j||!d||d.length<5)return!1;let I=d.charCodeAt(0);if(I!==92||(I=d.charCodeAt(1),I!==92))return!1;let S=2;const u=S;for(;S<d.length&&(I=d.charCodeAt(S),I!==92);S++);return!(u===S||(I=d.charCodeAt(S+1),isNaN(I)||I===92))}e.$Tf=R;const D=/[\\/:\*\?"<>\|]/g,c=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function $(d,I=M.$j){const S=I?D:c;return!(!d||d.length===0||/^\s+$/.test(d)||(S.lastIndex=0,S.test(d))||I&&p.test(d)||d==="."||d===".."||I&&d[d.length-1]==="."||I&&d.length!==d.trim().length||d.length>255)}e.$Uf=$;function g(d,I,S){const u=d===I;return!S||u?u:!d||!I?!1:(0,C.$1e)(d,I)}e.$Vf=g;function t(d,I,S,u=w.sep){if(d===I)return!0;if(!d||!I||I.length>d.length)return!1;if(S){if(!(0,C.$2e)(d,I))return!1;if(I.length===d.length)return!0;let h=I.length;return I.charAt(I.length-1)===u&&h--,d.charAt(h)===u}return I.charAt(I.length-1)!==u&&(I+=u),d.indexOf(I)===0}e.$Wf=t;function n(d){return d>=65&&d<=90||d>=97&&d<=122}e.$Xf=n;function a(d,I){return M.$j&&d.endsWith(":")&&(d+=w.sep),(0,w.$hc)(d)||(d=(0,w.$ic)(I,d)),d=(0,w.$gc)(d),M.$j?(d=(0,C.$Je)(d,w.sep),d.endsWith(":")&&(d+=w.sep)):(d=(0,C.$Je)(d,w.sep),d||(d=w.sep)),d}e.$Yf=a;function b(d){const I=(0,w.$gc)(d);return M.$j?d.length>3?!1:E(I)&&(d.length===2||I.charCodeAt(2)===92):I===w.$fc.sep}e.$Zf=b;function E(d,I=M.$j){return I?n(d.charCodeAt(0))&&d.charCodeAt(1)===58:!1}e.$1f=E;function v(d,I=M.$j){return E(d,I)?d[0]:void 0}e.$2f=v;function r(d,I,S){return I.length>d.length?-1:d===I?0:(S&&(d=d.toLowerCase(),I=I.toLowerCase()),d.indexOf(I))}e.$3f=r;function s(d){const I=d.split(":");let S,u,m;for(const h of I){const P=Number(h);(0,F.$Bf)(P)?u===void 0?u=P:m===void 0&&(m=P):S=S?[S,h].join(":"):h}if(!S)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:S,line:u!==void 0?u:void 0,column:m!==void 0?m:u!==void 0?1:void 0}}e.$4f=s;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",o="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function y(d,I,S=8){let u="";for(let h=0;h<S;h++){let P;h===0&&M.$j&&!I&&(S===3||S===4)?P=o:P=i,u+=P.charAt(Math.floor(Math.random()*P.length))}let m;return I?m=`${I}-${u}`:m=u,d?(0,w.$ic)(d,m):m}e.$5f=y}),define(Re[66],Me([1,0,19]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pr=e.$Or=e.$Nr=e.$Mr=e.$Lr=void 0,e.$Lr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const M={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},C={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function F(R){const D=(0,w.$nc)(R),c=M[D.toLowerCase()];return c!==void 0?c:A(R)}e.$Mr=F;function A(R){const D=(0,w.$nc)(R);return C[D.toLowerCase()]}e.$Nr=A;function l(R){for(const D in C)if(C[D]===R)return D}e.$Or=l;const k=/^(.+)\/(.+?)(;.+)?$/;function f(R,D){const c=k.exec(R);return c?`${c[1].toLowerCase()}/${c[2].toLowerCase()}${c[3]??""}`:D?void 0:R}e.$Pr=f}),define(Re[67],Me([1,0,26,2]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kh=e.$jh=e.$ih=void 0;function C(k){return JSON.stringify(k,A)}e.$ih=C;function F(k){let f=JSON.parse(k);return f=l(f),f}e.$jh=F;function A(k,f){return f instanceof RegExp?{$mid:2,source:f.source,flags:f.flags}:f}function l(k,f=0){if(!k||f>200)return k;if(typeof k=="object"){switch(k.$mid){case 1:return M.URI.revive(k);case 2:return new RegExp(k.source,k.flags);case 17:return new Date(k.source)}if(k instanceof w.$ae||k instanceof Uint8Array)return k;if(Array.isArray(k))for(let R=0;R<k.length;++R)k[R]=l(k[R],f+1);else for(const R in k)Object.hasOwnProperty.call(k,R)&&(k[R]=l(k[R],f+1))}return k}e.$kh=l}),define(Re[13],Me([1,0,9,22,2]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.Schemas=void 0;var F;(function(f){f.inMemory="inmemory",f.vscode="vscode",f.internal="private",f.walkThrough="walkThrough",f.walkThroughSnippet="walkThroughSnippet",f.http="http",f.https="https",f.file="file",f.mailto="mailto",f.untitled="untitled",f.data="data",f.command="command",f.vscodeRemote="vscode-remote",f.vscodeRemoteResource="vscode-remote-resource",f.vscodeManagedRemoteResource="vscode-managed-remote-resource",f.vscodeUserData="vscode-userdata",f.vscodeCustomEditor="vscode-custom-editor",f.vscodeNotebookCell="vscode-notebook-cell",f.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",f.vscodeNotebookCellOutput="vscode-notebook-cell-output",f.vscodeInteractiveInput="vscode-interactive-input",f.vscodeSettings="vscode-settings",f.vscodeWorkspaceTrust="vscode-workspace-trust",f.vscodeTerminal="vscode-terminal",f.vscodeChatSesssion="vscode-chat-editor",f.webviewPanel="webview-panel",f.vscodeWebview="vscode-webview",f.extension="extension",f.vscodeFileResource="vscode-file",f.tmp="tmp",f.vsls="vsls",f.vscodeSourceControl="vscode-scm"})(F||(e.Schemas=F={})),e.$6f="vscode-tkn",e.$7f="tkn";class A{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${F.vscodeRemoteResource}`}setPreferredWebSchema(R){this.d=R}setDelegate(R){this.e=R}setServerRootPath(R){this.f=`${R}/${F.vscodeRemoteResource}`}set(R,D,c){this.a[R]=D,this.b[R]=c}setConnectionToken(R,D){this.c[R]=D}getPreferredWebSchema(){return this.d}rewrite(R){if(this.e)try{return this.e(R)}catch(t){return w.$Z(t),R}const D=R.authority;let c=this.a[D];c&&c.indexOf(":")!==-1&&c.indexOf("[")===-1&&(c=`[${c}]`);const p=this.b[D],$=this.c[D];let g=`path=${encodeURIComponent(R.path)}`;return typeof $=="string"&&(g+=`&${e.$7f}=${encodeURIComponent($)}`),C.URI.from({scheme:M.$p?this.d:F.vscodeRemoteResource,authority:`${c}:${p}`,path:this.f,query:g})}}e.$8f=new A,e.$9f="vs/../../extensions",e.$0f="vs/../../node_modules",e.$$f="vs/../../node_modules.asar",e.$_f="vs/../../node_modules.asar.unpacked",e.$ag="vscode-app";class l{static{this.a=e.$ag}asBrowserUri(R){const D=this.b(R,be);return this.uriToBrowserUri(D)}uriToBrowserUri(R){return R.scheme===F.vscodeRemote?e.$8f.rewrite(R):R.scheme===F.file&&(M.$n||M.$q&&M.$h.origin===`${F.vscodeFileResource}://${l.a}`)?R.with({scheme:F.vscodeFileResource,authority:R.authority||l.a,query:null,fragment:null}):R}asFileUri(R){const D=this.b(R,be);return this.uriToFileUri(D)}uriToFileUri(R){return R.scheme===F.vscodeFileResource?R.with({scheme:F.file,authority:R.authority!==l.a?R.authority:null,query:null,fragment:null}):R}b(R,D){return C.URI.isUri(R)?R:C.URI.parse(D.toUrl(R))}}e.$bg=new l;var k;(function(f){const R=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);f.CoopAndCoep=Object.freeze(R.get("3"));const D="vscode-coi";function c($){let g;typeof $=="string"?g=new URL($).searchParams:$ instanceof URL?g=$.searchParams:C.URI.isUri($)&&(g=new URL($.toString(!0)).searchParams);const t=g?.get(D);if(t)return R.get(t)}f.getHeadersFromQuery=c;function p($,g,t){if(!globalThis.crossOriginIsolated)return;const n=g&&t?"3":t?"2":"1";$ instanceof URLSearchParams?$.set(D,n):$[D]=n}f.addSearchParam=p})(k||(e.COI=k={}))}),define(Re[23],Me([1,0,42,13,19,22,15,2]),function(be,e,w,M,C,F,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eg=e.DataUri=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=void 0;function k(p){return(0,l.$vc)(p,!0)}e.$ig=k;class f{constructor($){this.a=$}compare($,g,t=!1){return $===g?0:(0,A.$Te)(this.getComparisonKey($,t),this.getComparisonKey(g,t))}isEqual($,g,t=!1){return $===g?!0:!$||!g?!1:this.getComparisonKey($,t)===this.getComparisonKey(g,t)}getComparisonKey($,g=!1){return $.with({path:this.a($)?$.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing($){return this.a($)}isEqualOrParent($,g,t=!1){if($.scheme===g.scheme){if($.scheme===M.Schemas.file)return w.$Wf(k($),k(g),this.a($))&&$.query===g.query&&(t||$.fragment===g.fragment);if((0,e.$zg)($.authority,g.authority))return w.$Wf($.path,g.path,this.a($),"/")&&$.query===g.query&&(t||$.fragment===g.fragment)}return!1}joinPath($,...g){return l.URI.joinPath($,...g)}basenameOrAuthority($){return(0,e.$rg)($)||$.authority}basename($){return C.$fc.basename($.path)}extname($){return C.$fc.extname($.path)}dirname($){if($.path.length===0)return $;let g;return $.scheme===M.Schemas.file?g=l.URI.file(C.$lc(k($))).path:(g=C.$fc.dirname($.path),$.authority&&g.length&&g.charCodeAt(0)!==47&&(console.error(`dirname("${$.toString})) resulted in a relative path`),g="/")),$.with({path:g})}normalizePath($){if(!$.path.length)return $;let g;return $.scheme===M.Schemas.file?g=l.URI.file(C.$gc(k($))).path:g=C.$fc.normalize($.path),$.with({path:g})}relativePath($,g){if($.scheme!==g.scheme||!(0,e.$zg)($.authority,g.authority))return;if($.scheme===M.Schemas.file){const a=C.$kc(k($),k(g));return F.$j?w.$Qf(a):a}let t=$.path||"/";const n=g.path||"/";if(this.a($)){let a=0;for(const b=Math.min(t.length,n.length);a<b&&!(t.charCodeAt(a)!==n.charCodeAt(a)&&t.charAt(a).toLowerCase()!==n.charAt(a).toLowerCase());a++);t=n.substr(0,a)+t.substr(a)}return C.$fc.relative(t,n)}resolvePath($,g){if($.scheme===M.Schemas.file){const t=l.URI.file(C.$jc(k($),g));return $.with({authority:t.authority,path:t.path})}return g=w.$Rf(g),$.with({path:C.$fc.resolve($.path,g)})}isAbsolutePath($){return!!$.path&&$.path[0]==="/"}isEqualAuthority($,g){return $===g||$!==void 0&&g!==void 0&&(0,A.$1e)($,g)}hasTrailingPathSeparator($,g=C.sep){if($.scheme===M.Schemas.file){const t=k($);return t.length>w.$Sf(t).length&&t[t.length-1]===g}else{const t=$.path;return t.length>1&&t.charCodeAt(t.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test($.fsPath)}}removeTrailingPathSeparator($,g=C.sep){return(0,e.$Ag)($,g)?$.with({path:$.path.substr(0,$.path.length-1)}):$}addTrailingPathSeparator($,g=C.sep){let t=!1;if($.scheme===M.Schemas.file){const n=k($);t=n!==void 0&&n.length===w.$Sf(n).length&&n[n.length-1]===g}else{g="/";const n=$.path;t=n.length===1&&n.charCodeAt(n.length-1)===47}return!t&&!(0,e.$Ag)($,g)?$.with({path:$.path+"/"}):$}}e.$jg=f,e.$kg=new f(()=>!1),e.$lg=new f(p=>p.scheme===M.Schemas.file?!F.$l:!0),e.$mg=new f(p=>!0),e.$ng=e.$kg.isEqual.bind(e.$kg),e.$og=e.$kg.isEqualOrParent.bind(e.$kg),e.$pg=e.$kg.getComparisonKey.bind(e.$kg),e.$qg=e.$kg.basenameOrAuthority.bind(e.$kg),e.$rg=e.$kg.basename.bind(e.$kg),e.$sg=e.$kg.extname.bind(e.$kg),e.$tg=e.$kg.dirname.bind(e.$kg),e.$ug=e.$kg.joinPath.bind(e.$kg),e.$vg=e.$kg.normalizePath.bind(e.$kg),e.$wg=e.$kg.relativePath.bind(e.$kg),e.$xg=e.$kg.resolvePath.bind(e.$kg),e.$yg=e.$kg.isAbsolutePath.bind(e.$kg),e.$zg=e.$kg.isEqualAuthority.bind(e.$kg),e.$Ag=e.$kg.hasTrailingPathSeparator.bind(e.$kg),e.$Bg=e.$kg.removeTrailingPathSeparator.bind(e.$kg),e.$Cg=e.$kg.addTrailingPathSeparator.bind(e.$kg);function R(p,$){const g=[];for(let t=0;t<p.length;t++){const n=$(p[t]);p.some((a,b)=>b===t?!1:(0,e.$og)(n,$(a)))||g.push(p[t])}return g}e.$Dg=R;var D;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function $(g){const t=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach(b=>{const[E,v]=b.split(":");E&&v&&t.set(E,v)});const a=g.path.substring(0,g.path.indexOf(";"));return a&&t.set(p.META_DATA_MIME,a),t}p.parseMetaData=$})(D||(e.DataUri=D={}));function c(p,$,g){if($){let t=p.path;return t&&t[0]!==C.$fc.sep&&(t=C.$fc.sep+t),p.with({scheme:g,authority:$,path:t})}return p.with({scheme:g})}e.$Eg=c}),define(Re[12],Me([1,0,21,9,5,6,23,22,120]),function(be,e,w,M,C,F,A,l,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eh=e.$dh=e.$ch=e.Promises=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=void 0;function f(z){return!!z&&typeof z.then=="function"}e.$Fg=f;function R(z){const V=new w.$Wd,le=z(V.token),we=new Promise((ve,me)=>{const De=V.token.onCancellationRequested(()=>{De.dispose(),V.dispose(),me(new M.$4)});Promise.resolve(le).then(re=>{De.dispose(),V.dispose(),ve(re)},re=>{De.dispose(),V.dispose(),me(re)})});return new class{cancel(){V.cancel()}then(ve,me){return we.then(ve,me)}catch(ve){return this.then(void 0,ve)}finally(ve){return we.finally(ve)}}}e.$Gg=R;function D(z,V,le){return new Promise((we,ve)=>{const me=V.onCancellationRequested(()=>{me.dispose(),we(le)});z.then(we,ve).finally(()=>me.dispose())})}e.$Hg=D;function c(z,V){return new Promise((le,we)=>{const ve=V.onCancellationRequested(()=>{ve.dispose(),we(new M.$4)});z.then(le,we).finally(()=>ve.dispose())})}e.$Ig=c;async function p(z){let V=-1;const le=z.map((we,ve)=>we.then(me=>(V=ve,me)));try{return await Promise.race(le)}finally{z.forEach((we,ve)=>{ve!==V&&we.cancel()})}}e.$Jg=p;function $(z,V,le){let we;const ve=setTimeout(()=>{we?.(void 0),le?.()},V);return Promise.race([z.finally(()=>clearTimeout(ve)),new Promise(me=>we=me)])}e.$Kg=$;function g(z){return new Promise((V,le)=>{const we=z();f(we)?we.then(V,le):V(we)})}e.$Lg=g;class t{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(V){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=V,!this.b){const le=()=>{if(this.b=null,this.f)return;const we=this.queue(this.d);return this.d=null,we};this.b=new Promise(we=>{this.a.then(le,le).then(we)})}return new Promise((le,we)=>{this.b.then(le,we)})}return this.a=V(),new Promise((le,we)=>{this.a.then(ve=>{this.a=null,le(ve)},ve=>{this.a=null,we(ve)})})}dispose(){this.f=!0}}e.$Mg=t;class n{constructor(){this.a=Promise.resolve(null)}queue(V){return this.a=this.a.then(()=>V(),()=>V())}}e.$Ng=n;class a{constructor(){this.a=new Map}queue(V,le){const ve=(this.a.get(V)??Promise.resolve()).catch(()=>{}).then(le).finally(()=>{this.a.get(V)===ve&&this.a.delete(V)});return this.a.set(V,ve),ve}}e.$Og=a;const b=(z,V)=>{let le=!0;const we=setTimeout(()=>{le=!1,V()},z);return{isTriggered:()=>le,dispose:()=>{clearTimeout(we),le=!1}}},E=z=>{let V=!0;return queueMicrotask(()=>{V&&(V=!1,z())}),{isTriggered:()=>V,dispose:()=>{V=!1}}};class v{constructor(V){this.defaultDelay=V,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(V,le=this.defaultDelay){this.g=V,this.h(),this.b||(this.b=new Promise((ve,me)=>{this.d=ve,this.f=me}).then(()=>{if(this.b=null,this.d=null,this.g){const ve=this.g;return this.g=null,ve()}}));const we=()=>{this.a=null,this.d?.(null)};return this.a=le===k.$Jd?E(we):b(le,we),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new M.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Pg=v;class r{constructor(V){this.a=new v(V),this.b=new t}trigger(V,le){return this.a.trigger(()=>this.b.queue(V),le)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Qg=r;class s{constructor(){this.a=!1,this.b=new Promise((V,le)=>{this.d=V})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Rg=s;class i extends s{constructor(V){super(),this.f=setTimeout(()=>this.open(),V)}open(){clearTimeout(this.f),super.open()}}e.$Sg=i;function o(z,V){return V?new Promise((le,we)=>{const ve=setTimeout(()=>{me.dispose(),le()},z),me=V.onCancellationRequested(()=>{clearTimeout(ve),me.dispose(),we(new M.$4)})}):R(le=>o(z,le))}e.$Tg=o;function y(z,V=0,le){const we=setTimeout(()=>{z(),le&&ve.dispose()},V),ve=(0,F.$Pc)(()=>{clearTimeout(we),le?.deleteAndLeak(ve)});return le?.add(ve),ve}e.$Ug=y;function d(z){const V=[];let le=0;const we=z.length;function ve(){return le<we?z[le++]():null}function me(De){De!=null&&V.push(De);const re=ve();return re?re.then(me):Promise.resolve(V)}return Promise.resolve(null).then(me)}e.$Vg=d;function I(z,V=we=>!!we,le=null){let we=0;const ve=z.length,me=()=>{if(we>=ve)return Promise.resolve(le);const De=z[we++];return Promise.resolve(De()).then(he=>V(he)?Promise.resolve(he):me())};return me()}e.$Wg=I;function S(z,V=we=>!!we,le=null){if(z.length===0)return Promise.resolve(le);let we=z.length;const ve=()=>{we=-1;for(const me of z)me.cancel?.()};return new Promise((me,De)=>{for(const re of z)re.then(he=>{--we>=0&&V(he)?(ve(),me(he)):we===0&&me(le)}).catch(he=>{--we>=0&&(ve(),De(he))})})}e.$Xg=S;class u{constructor(V){this.a=0,this.d=V,this.f=[],this.b=0,this.g=new C.$Md}get onDrained(){return this.g.event}get size(){return this.a}queue(V){return this.a++,new Promise((le,we)=>{this.f.push({factory:V,c:le,e:we}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const V=this.f.shift();this.b++;const le=V.factory();le.then(V.c,V.e),le.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Yg=u;class m extends u{constructor(){super(1)}}e.$Zg=m;class h{constructor(){this.a=new ye,this.b=0}queue(V){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,V())):this.a.run(this.b++,V())}}e.$1g=h;class P{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const V=new X;return this.b.add(V),V.p}g(){for(const[,V]of this.a)if(V.size>0)return!1;return!0}queueFor(V,le=A.$kg){const we=le.getComparisonKey(V);let ve=this.a.get(we);if(!ve){ve=new m;const me=this.f++,De=C.Event.once(ve.onDrained)(()=>{ve?.dispose(),this.a.delete(we),this.h(),this.d?.deleteAndDispose(me),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new F.$Zc),this.d.set(me,De),this.a.set(we,ve)}return ve}h(){this.g()&&this.j()}j(){for(const V of this.b)V.complete();this.b.clear()}dispose(){for(const[,V]of this.a)V.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$2g=P;class W{constructor(V,le){this.a=-1,typeof V=="function"&&typeof le=="number"&&this.setIfNotSet(V,le)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(V,le){this.cancel(),this.a=setTimeout(()=>{this.a=-1,V()},le)}setIfNotSet(V,le){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,V()},le))}}e.$3g=W;class K{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(V,le){this.cancel(),this.a=setInterval(()=>{V()},le)}}e.$4g=K;class U{constructor(V,le){this.b=-1,this.a=V,this.d=le,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(V=this.d){this.cancel(),this.b=setTimeout(this.f,V)}get delay(){return this.d}set delay(V){this.d=V}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$5g=U;class B{constructor(V,le){le%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${le}ms is not a multiple of 1000ms.`),this.a=V,this.b=le,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(V=this.b){V%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${V}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(V/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$6g=B;class O extends U{constructor(V,le){super(V,le),this.j=[]}work(V){this.j.push(V),this.isScheduled()||this.schedule()}h(){const V=this.j;this.j=[],this.a?.(V)}dispose(){this.j=[],super.dispose()}}e.$7g=O;class N extends F.$Rc{constructor(V,le){super(),this.g=V,this.h=le,this.a=[],this.b=this.B(new F.$Sc),this.f=!1}get pending(){return this.a.length}work(V){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+V.length>this.g.maxBufferedWork)return!1}else if(this.pending+V.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const le of V)this.a.push(le);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new U(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$8g=N,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$9g=z=>{(0,l.$B)(()=>{if(V)return;const le=Date.now()+15;z(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,le-Date.now())}}))});let V=!1;return{dispose(){V||(V=!0)}}}:e.$9g=(z,V)=>{const le=requestIdleCallback(z,typeof V=="number"?{timeout:V}:void 0);let we=!1;return{dispose(){we||(we=!0,cancelIdleCallback(le))}}}}();class te{constructor(V){this.d=!1,this.a=()=>{try{this.f=V()}catch(le){this.g=le}finally{this.d=!0}},this.b=(0,e.$9g)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$0g=te;async function Y(z,V,le){let we;for(let ve=0;ve<le;ve++)try{return await z()}catch(me){we=me,await o(V)}throw we}e.$$g=Y;class ye{isRunning(V){return typeof V=="number"?this.a?.taskId===V:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(V,le,we){return this.a={taskId:V,cancel:()=>we?.(),promise:le},le.then(()=>this.d(V),()=>this.d(V)),le}d(V){this.a&&V===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const V=this.b;this.b=void 0,V.run().then(V.promiseResolve,V.promiseReject)}}queue(V){if(this.b)this.b.run=V;else{let le,we;const ve=new Promise((me,De)=>{le=me,we=De});this.b={run:V,promise:ve,promiseResolve:le,promiseReject:we}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$_g=ye;class Ee{constructor(V,le=()=>Date.now()){this.d=V,this.f=le,this.a=0,this.b=0}increment(){const V=this.f();return V-this.a>this.d&&(this.a=V,this.b=0),this.b++,this.b}}e.$ah=Ee;var Pe;(function(z){z[z.Resolved=0]="Resolved",z[z.Rejected=1]="Rejected"})(Pe||(Pe={}));class X{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((V,le)=>{this.a=V,this.b=le})}complete(V){return new Promise(le=>{this.a(V),this.d={outcome:0,value:V},le()})}error(V){return new Promise(le=>{this.b(V),this.d={outcome:1,value:V},le()})}cancel(){return this.error(new M.$4)}}e.$bh=X;var ae;(function(z){async function V(we){let ve;const me=await Promise.all(we.map(De=>De.then(re=>re,re=>{ve||(ve=re)})));if(typeof ve<"u")throw ve;return me}z.settled=V;function le(we){return new Promise(async(ve,me)=>{try{await we(ve,me)}catch(De){me(De)}})}z.withAsyncBody=le})(ae||(e.Promises=ae={}));var Se;(function(z){z[z.Initial=0]="Initial",z[z.DoneOK=1]="DoneOK",z[z.DoneError=2]="DoneError"})(Se||(Se={}));class ue{static fromArray(V){return new ue(le=>{le.emitMany(V)})}static fromPromise(V){return new ue(async le=>{le.emitMany(await V)})}static fromPromises(V){return new ue(async le=>{await Promise.all(V.map(async we=>le.emitOne(await we)))})}static merge(V){return new ue(async le=>{await Promise.all(V.map(async we=>{for await(const ve of we)le.emitOne(ve)}))})}static{this.EMPTY=ue.fromArray([])}constructor(V){this.a=0,this.b=[],this.d=null,this.f=new C.$Md,queueMicrotask(async()=>{const le={emitOne:we=>this.g(we),emitMany:we=>this.h(we),reject:we=>this.k(we)};try{await Promise.resolve(V(le)),this.j()}catch(we){this.k(we)}finally{le.emitOne=void 0,le.emitMany=void 0,le.reject=void 0}})}[Symbol.asyncIterator](){let V=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(V<this.b.length)return{done:!1,value:this.b[V++]};if(this.a===1)return{done:!0,value:void 0};await C.Event.toPromise(this.f.event)}while(!0)}}}static map(V,le){return new ue(async we=>{for await(const ve of V)we.emitOne(le(ve))})}map(V){return ue.map(this,V)}static filter(V,le){return new ue(async we=>{for await(const ve of V)le(ve)&&we.emitOne(ve)})}filter(V){return ue.filter(this,V)}static coalesce(V){return ue.filter(V,le=>!!le)}coalesce(){return ue.coalesce(this)}static async toPromise(V){const le=[];for await(const we of V)le.push(we);return le}toPromise(){return ue.toPromise(this)}g(V){this.a===0&&(this.b.push(V),this.f.fire())}h(V){this.a===0&&(this.b=this.b.concat(V),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(V){this.a===0&&(this.a=2,this.d=V,this.f.fire())}}e.$ch=ue;class $e extends ue{constructor(V,le){super(le),this.l=V}cancel(){this.l.cancel()}}e.$dh=$e;function ie(z){const V=new w.$Wd,le=z(V.token);return new $e(V,async we=>{const ve=V.token.onCancellationRequested(()=>{ve.dispose(),V.dispose(),we.reject(new M.$4)});try{for await(const me of le){if(V.token.isCancellationRequested)return;we.emitOne(me)}ve.dispose(),V.dispose()}catch(me){ve.dispose(),V.dispose(),we.reject(me)}})}e.$eh=ie}),define(Re[37],Me([1,0,18,12,42,28,19,22,15]),function(be,e,w,M,C,F,A,l,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=void 0;function f(){return Object.create(null)}e.$pj=f,e.$qj="**",e.$rj="/";const R="[/\\\\]",D="[^/\\\\]",c=/\//g;function p(ye,Ee){switch(ye){case 0:return"";case 1:return`${D}*?`;default:return`(?:${R}|${D}+${R}${Ee?`|${R}${D}+`:""})*?`}}function $(ye,Ee){if(!ye)return[];const Pe=[];let X=!1,ae=!1,Se="";for(const ue of ye){switch(ue){case Ee:if(!X&&!ae){Pe.push(Se),Se="";continue}break;case"{":X=!0;break;case"}":X=!1;break;case"[":ae=!0;break;case"]":ae=!1;break}Se+=ue}return Se&&Pe.push(Se),Pe}e.$sj=$;function g(ye){if(!ye)return"";let Ee="";const Pe=$(ye,e.$rj);if(Pe.every(X=>X===e.$qj))Ee=".*";else{let X=!1;Pe.forEach((ae,Se)=>{if(ae===e.$qj){if(X)return;Ee+=p(2,Se===Pe.length-1)}else{let ue=!1,$e="",ie=!1,z="";for(const V of ae){if(V!=="}"&&ue){$e+=V;continue}if(ie&&(V!=="]"||!z)){let le;V==="-"?le=V:(V==="^"||V==="!")&&!z?le="^":V===e.$rj?le="":le=(0,k.$Ee)(V),z+=le;continue}switch(V){case"{":ue=!0;continue;case"[":ie=!0;continue;case"}":{const we=`(?:${$($e,",").map(ve=>g(ve)).join("|")})`;Ee+=we,ue=!1,$e="";break}case"]":{Ee+="["+z+"]",ie=!1,z="";break}case"?":Ee+=D;continue;case"*":Ee+=p(1);continue;default:Ee+=(0,k.$Ee)(V)}}Se<Pe.length-1&&(Pe[Se+1]!==e.$qj||Se+2<Pe.length)&&(Ee+=R)}X=ae===e.$qj})}return Ee}const t=/^\*\*\/\*\.[\w\.-]+$/,n=/^\*\*\/([\w\.-]+)\/?$/,a=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,b=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,E=/^\*\*((\/[\w\.-]+)+)\/?$/,v=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,r=new F.$Cc(1e4),s=function(){return!1},i=function(){return null};function o(ye,Ee){if(!ye)return i;let Pe;typeof ye!="string"?Pe=ye.pattern:Pe=ye,Pe=Pe.trim();const X=`${Pe}_${!!Ee.trimForExclusions}`;let ae=r.get(X);if(ae)return y(ae,ye);let Se;return t.test(Pe)?ae=I(Pe.substr(4),Pe):(Se=n.exec(d(Pe,Ee)))?ae=S(Se[1],Pe):(Ee.trimForExclusions?b:a).test(Pe)?ae=u(Pe,Ee):(Se=E.exec(d(Pe,Ee)))?ae=m(Se[1].substr(1),Pe,!0):(Se=v.exec(d(Pe,Ee)))?ae=m(Se[1],Pe,!1):ae=h(Pe),r.set(X,ae),y(ae,ye)}function y(ye,Ee){if(typeof Ee=="string")return ye;const Pe=function(X,ae){return(0,C.$Wf)(X,Ee.base,!l.$l)?ye((0,k.$Ie)(X.substr(Ee.base.length),A.sep),ae):null};return Pe.allBasenames=ye.allBasenames,Pe.allPaths=ye.allPaths,Pe.basenames=ye.basenames,Pe.patterns=ye.patterns,Pe}function d(ye,Ee){return Ee.trimForExclusions&&ye.endsWith("/**")?ye.substr(0,ye.length-2):ye}function I(ye,Ee){return function(Pe,X){return typeof Pe=="string"&&Pe.endsWith(ye)?Ee:null}}function S(ye,Ee){const Pe=`/${ye}`,X=`\\${ye}`,ae=function(ue,$e){return typeof ue!="string"?null:$e?$e===ye?Ee:null:ue===ye||ue.endsWith(Pe)||ue.endsWith(X)?Ee:null},Se=[ye];return ae.basenames=Se,ae.patterns=[Ee],ae.allBasenames=Se,ae}function u(ye,Ee){const Pe=te(ye.slice(1,-1).split(",").map($e=>o($e,Ee)).filter($e=>$e!==i),ye),X=Pe.length;if(!X)return i;if(X===1)return Pe[0];const ae=function($e,ie){for(let z=0,V=Pe.length;z<V;z++)if(Pe[z]($e,ie))return ye;return null},Se=Pe.find($e=>!!$e.allBasenames);Se&&(ae.allBasenames=Se.allBasenames);const ue=Pe.reduce(($e,ie)=>ie.allPaths?$e.concat(ie.allPaths):$e,[]);return ue.length&&(ae.allPaths=ue),ae}function m(ye,Ee,Pe){const X=A.sep===A.$fc.sep,ae=X?ye:ye.replace(c,A.sep),Se=A.sep+ae,ue=A.$fc.sep+ye;let $e;return Pe?$e=function(ie,z){return typeof ie=="string"&&(ie===ae||ie.endsWith(Se)||!X&&(ie===ye||ie.endsWith(ue)))?Ee:null}:$e=function(ie,z){return typeof ie=="string"&&(ie===ae||!X&&ie===ye)?Ee:null},$e.allPaths=[(Pe?"*/":"./")+ye],$e}function h(ye){try{const Ee=new RegExp(`^${g(ye)}$`);return function(Pe){return Ee.lastIndex=0,typeof Pe=="string"&&Ee.test(Pe)?ye:null}}catch{return i}}function P(ye,Ee,Pe){return!ye||typeof Ee!="string"?!1:W(ye)(Ee,void 0,Pe)}e.$tj=P;function W(ye,Ee={}){if(!ye)return s;if(typeof ye=="string"||K(ye)){const Pe=o(ye,Ee);if(Pe===i)return s;const X=function(ae,Se){return!!Pe(ae,Se)};return Pe.allBasenames&&(X.allBasenames=Pe.allBasenames),Pe.allPaths&&(X.allPaths=Pe.allPaths),X}return O(ye,Ee)}e.$uj=W;function K(ye){const Ee=ye;return Ee?typeof Ee.base=="string"&&typeof Ee.pattern=="string":!1}e.$vj=K;function U(ye){return ye.allBasenames||[]}e.$wj=U;function B(ye){return ye.allPaths||[]}e.$xj=B;function O(ye,Ee){const Pe=te(Object.getOwnPropertyNames(ye).map($e=>N($e,ye[$e],Ee)).filter($e=>$e!==i)),X=Pe.length;if(!X)return i;if(!Pe.some($e=>!!$e.requiresSiblings)){if(X===1)return Pe[0];const $e=function(V,le){let we;for(let ve=0,me=Pe.length;ve<me;ve++){const De=Pe[ve](V,le);if(typeof De=="string")return De;(0,M.$Fg)(De)&&(we||(we=[]),we.push(De))}return we?(async()=>{for(const ve of we){const me=await ve;if(typeof me=="string")return me}return null})():null},ie=Pe.find(V=>!!V.allBasenames);ie&&($e.allBasenames=ie.allBasenames);const z=Pe.reduce((V,le)=>le.allPaths?V.concat(le.allPaths):V,[]);return z.length&&($e.allPaths=z),$e}const ae=function($e,ie,z){let V,le;for(let we=0,ve=Pe.length;we<ve;we++){const me=Pe[we];me.requiresSiblings&&z&&(ie||(ie=(0,A.$mc)($e)),V||(V=ie.substr(0,ie.length-(0,A.$nc)($e).length)));const De=me($e,ie,V,z);if(typeof De=="string")return De;(0,M.$Fg)(De)&&(le||(le=[]),le.push(De))}return le?(async()=>{for(const we of le){const ve=await we;if(typeof ve=="string")return ve}return null})():null},Se=Pe.find($e=>!!$e.allBasenames);Se&&(ae.allBasenames=Se.allBasenames);const ue=Pe.reduce(($e,ie)=>ie.allPaths?$e.concat(ie.allPaths):$e,[]);return ue.length&&(ae.allPaths=ue),ae}function N(ye,Ee,Pe){if(Ee===!1)return i;const X=o(ye,Pe);if(X===i)return i;if(typeof Ee=="boolean")return X;if(Ee){const ae=Ee.when;if(typeof ae=="string"){const Se=(ue,$e,ie,z)=>{if(!z||!X(ue,$e))return null;const V=ae.replace("$(basename)",()=>ie),le=z(V);return(0,M.$Fg)(le)?le.then(we=>we?ye:null):le?ye:null};return Se.requiresSiblings=!0,Se}}return X}function te(ye,Ee){const Pe=ye.filter($e=>!!$e.basenames);if(Pe.length<2)return ye;const X=Pe.reduce(($e,ie)=>{const z=ie.basenames;return z?$e.concat(z):$e},[]);let ae;if(Ee){ae=[];for(let $e=0,ie=X.length;$e<ie;$e++)ae.push(Ee)}else ae=Pe.reduce(($e,ie)=>{const z=ie.patterns;return z?$e.concat(z):$e},[]);const Se=function($e,ie){if(typeof $e!="string")return null;if(!ie){let V;for(V=$e.length;V>0;V--){const le=$e.charCodeAt(V-1);if(le===47||le===92)break}ie=$e.substr(V)}const z=X.indexOf(ie);return z!==-1?ae[z]:null};Se.basenames=X,Se.patterns=ae,Se.allBasenames=X;const ue=ye.filter($e=>!$e.basenames);return ue.push(Se),ue}function Y(ye,Ee){return(0,w.$tb)(ye,Ee,(Pe,X)=>typeof Pe=="string"&&typeof X=="string"?Pe===X:typeof Pe!="string"&&typeof X!="string"?Pe.base===X.base&&Pe.pattern===X.pattern:!1)}e.$yj=Y}),define(Re[50],Me([1,0,9,121,23,15,2]),function(be,e,w,M,C,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8j=e.$7j=e.$6j=e.$5j=e.$4j=e.$3j=e.$2j=e.$1j=e.MarkdownStringTextNewlineStyle=void 0;var l;(function(t){t[t.Paragraph=0]="Paragraph",t[t.Break=1]="Break"})(l||(e.MarkdownStringTextNewlineStyle=l={}));class k{constructor(n="",a=!1){if(this.value=n,typeof this.value!="string")throw(0,w.$6)("value");typeof a=="boolean"?(this.isTrusted=a,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=a.isTrusted??void 0,this.supportThemeIcons=a.supportThemeIcons??!1,this.supportHtml=a.supportHtml??!1)}appendText(n,a=0){return this.value+=c(this.supportThemeIcons?(0,M.$Uj)(n):n).replace(/([ \t]+)/g,(b,E)=>"&nbsp;".repeat(E.length)).replace(/\>/gm,"\\>").replace(/\n/g,a===1?`\\
`:`

`),this}appendMarkdown(n){return this.value+=n,this}appendCodeblock(n,a){return this.value+="\n```",this.value+=n,this.value+=`
`,this.value+=a,this.value+="\n```\n",this}appendLink(n,a,b){return this.value+="[",this.value+=this.c(a,"]"),this.value+="](",this.value+=this.c(String(n),")"),b&&(this.value+=` "${this.c(this.c(b,'"'),")")}"`),this.value+=")",this}c(n,a){const b=new RegExp((0,F.$Ee)(a),"g");return n.replace(b,(E,v)=>n.charAt(v-1)!=="\\"?`\\${E}`:E)}}e.$1j=k;function f(t){return R(t)?!t.value:Array.isArray(t)?t.every(f):!0}e.$2j=f;function R(t){return t instanceof k?!0:t&&typeof t=="object"?typeof t.value=="string"&&(typeof t.isTrusted=="boolean"||typeof t.isTrusted=="object"||t.isTrusted===void 0)&&(typeof t.supportThemeIcons=="boolean"||t.supportThemeIcons===void 0):!1}e.$3j=R;function D(t,n){return t===n?!0:!t||!n?!1:t.value===n.value&&t.isTrusted===n.isTrusted&&t.supportThemeIcons===n.supportThemeIcons&&t.supportHtml===n.supportHtml&&(t.baseUri===n.baseUri||!!t.baseUri&&!!n.baseUri&&(0,C.$ng)(A.URI.from(t.baseUri),A.URI.from(n.baseUri)))}e.$4j=D;function c(t){return t.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$5j=c;function p(t){return t.replace(/"/g,"&quot;")}e.$6j=p;function $(t){return t&&t.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$7j=$;function g(t){const n=[],a=t.split("|").map(E=>E.trim());t=a[0];const b=a[1];if(b){const E=/height=(\d+)/.exec(b),v=/width=(\d+)/.exec(b),r=E?E[1]:"",s=v?v[1]:"",i=isFinite(parseInt(s)),o=isFinite(parseInt(r));i&&n.push(`width="${s}"`),o&&n.push(`height="${r}"`)}return{href:t,dimensions:n}}e.$8j=g}),define(Re[90],Me([1,0,18,42,19,22,23,15]),function(be,e,w,M,C,F,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uv=e.$tv=e.$sv=e.$rv=e.$qv=e.$pv=e.$ov=e.$nv=e.$mv=e.$lv=void 0;function k(o,y){const{os:d,tildify:I,relative:S}=y;if(S){const h=f(o,S,d);if(typeof h=="string")return h}let u=o.fsPath;if(d===1&&!F.$j?u=u.replace(/\//g,"\\"):d!==1&&F.$j&&(u=u.replace(/\\/g,"/")),d!==1&&I?.userHome){const h=I.userHome.fsPath;let P;o.scheme!==I.userHome.scheme&&o.path.startsWith(C.$fc.sep)?P=I.userHome.with({path:o.path}).fsPath:P=o.fsPath,u=c(P,h,d)}return(d===1?C.$ec:C.$fc).normalize(R(u,d===1))}e.$lv=k;function f(o,y,d){const I=d===1?C.$ec:C.$fc,S=d===3?A.$kg:A.$mg,u=y.getWorkspace(),m=(0,w.$Nb)(u.folders);if(!m)return;o.scheme!==m.uri.scheme&&o.path.startsWith(C.$fc.sep)&&(o=m.uri.with({path:o.path}));const h=y.getWorkspaceFolder(o);if(!h)return;let P;if(S.isEqual(h.uri,o)?P="":P=S.relativePath(h.uri,o)??"",P&&(P=I.normalize(P)),u.folders.length>1&&!y.noPrefix){const W=h.name?h.name:S.basenameOrAuthority(h.uri);P=P?`${W} \u2022 ${P}`:W}return P}function R(o,y=F.$j){return(0,M.$1f)(o,y)?o.charAt(0).toUpperCase()+o.slice(1):o}e.$mv=R;let D=Object.create(null);function c(o,y,d=F.OS){if(d===1||!o||!y)return o;let I=D.original===y?D.normalized:void 0;I||(I=y,F.$j&&(I=(0,M.$Qf)(I)),I=`${(0,l.$Je)(I,C.$fc.sep)}${C.$fc.sep}`,D={original:y,normalized:I});let S=o;return F.$j&&(S=(0,M.$Qf)(S)),(d===3?S.startsWith(I):(0,l.$2e)(S,I))?`~/${S.substr(I.length)}`:o}e.$nv=c;function p(o,y){return o.replace(/^~($|\/|\\)/,`${y}$1`)}e.$ov=p;const $="\u2026",g="\\\\",t="~";function n(o,y=C.sep){const d=new Array(o.length);let I=!1;for(let S=0;S<o.length;S++){const u=o[S];if(u===""){d[S]=`.${y}`;continue}if(!u){d[S]=u;continue}I=!0;let m="",h=u;h.indexOf(g)===0?(m=h.substr(0,h.indexOf(g)+g.length),h=h.substr(h.indexOf(g)+g.length)):h.indexOf(y)===0?(m=h.substr(0,h.indexOf(y)+y.length),h=h.substr(h.indexOf(y)+y.length)):h.indexOf(t)===0&&(m=h.substr(0,h.indexOf(t)+t.length),h=h.substr(h.indexOf(t)+t.length));const P=h.split(y);for(let W=1;I&&W<=P.length;W++)for(let K=P.length-W;I&&K>=0;K--){I=!1;let U=P.slice(K,K+W).join(y);for(let B=0;!I&&B<o.length;B++)if(B!==S&&o[B]&&o[B].indexOf(U)>-1){const O=K+W===P.length,N=K>0&&o[B].indexOf(y)>-1?y+U:U,te=o[B].endsWith(N);I=!O||te}if(!I){let B="";(P[0].endsWith(":")||m!=="")&&(K===1&&(K=0,W++,U=P[0]+y+U),K>0&&(B=P[0]+y),B=m+B),K>0&&(B=B+$+y),B=B+U,K+W<P.length&&(B=B+y+$),d[S]=B}}I&&(d[S]=u)}return d}e.$pv=n;var a;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(a||(a={}));function b(o,y=Object.create(null)){const d=[];let I=!1,S="";for(const u of o)if(u==="$"||I&&u==="{")S&&d.push({value:S,type:a.TEXT}),S="",I=!0;else if(u==="}"&&I){const m=y[S];if(typeof m=="string")m.length&&d.push({value:m,type:a.VARIABLE});else if(m){const h=d[d.length-1];(!h||h.type!==a.SEPARATOR)&&d.push({value:m.label,type:a.SEPARATOR})}S="",I=!1}else S+=u;return S&&!I&&d.push({value:S,type:a.TEXT}),d.filter((u,m)=>{if(u.type===a.SEPARATOR){const h=d[m-1],P=d[m+1];return[h,P].every(W=>W&&(W.type===a.VARIABLE||W.type===a.TEXT)&&W.value.length>0)}return!0}).map(u=>u.value).join("")}e.$qv=b;function E(o,y){return F.$k||y?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,F.$k?"&":"&&"):o.replace(/&&|&/g,d=>d==="&"?"&&":"&")}e.$rv=E;function v(o,y){return F.$k||y?o.replace(/\(&&\w\)|&&/g,""):F.$j?o.replace(/&&|&/g,d=>d==="&"?"&&":"&"):o.replace(/&&/g,"_")}e.$sv=v;function r(o){return o.replace(/&/g,"&&")}e.$tv=r;function s(o){if(o.endsWith("]")){const y=o.lastIndexOf(" [",o.length-2);if(y!==-1){const d=i(o.substring(0,y));return{name:d.name,parentPath:d.parentPath+o.substring(y)}}}return i(o)}e.$uv=s;function i(o){const y=o.indexOf("/")!==-1?C.$fc:C.$ec,d=y.basename(o),I=y.dirname(o);return d.length?{name:d,parentPath:I}:{name:I,parentPath:""}}}),define(Re[132],Me([1,0,26,2]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lm=e.$Km=e.$Jm=e.$Im=e.$Hm=void 0;function C(D){return D.toJSON()}class F{constructor(c){this.a=c}transformIncoming(c){const p=this.a.transformIncoming(c);return p===c?c:C(M.URI.from(p))}transformOutgoing(c){const p=this.a.transformOutgoing(c);return p===c?c:C(M.URI.from(p))}transformOutgoingURI(c){const p=this.a.transformOutgoing(c);return p===c?c:M.URI.from(p)}transformOutgoingScheme(c){return this.a.transformOutgoingScheme(c)}}e.$Hm=F,e.$Im=new class{transformIncoming(D){return D}transformOutgoing(D){return D}transformOutgoingURI(D){return D}transformOutgoingScheme(D){return D}};function A(D,c,p){if(!D||p>200)return null;if(typeof D=="object"){if(D instanceof M.URI)return c.transformOutgoing(D);for(const $ in D)if(Object.hasOwnProperty.call(D,$)){const g=A(D[$],c,p+1);g!==null&&(D[$]=g)}}return null}function l(D,c){const p=A(D,c,0);return p===null?D:p}e.$Jm=l;function k(D,c,p,$){if(!D||$>200)return null;if(typeof D=="object"){if(D.$mid===1)return p?M.URI.revive(c.transformIncoming(D)):c.transformIncoming(D);if(D instanceof w.$ae)return null;for(const g in D)if(Object.hasOwnProperty.call(D,g)){const t=k(D[g],c,p,$+1);t!==null&&(D[g]=t)}}return null}function f(D,c){const p=k(D,c,!1,0);return p===null?D:p}e.$Km=f;function R(D,c){const p=k(D,c,!0,0);return p===null?D:p}e.$Lm=R}),define(Re[133],Me([1,0,37,19]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mE=void 0;function C(F,A,l,k,f,R){if(Array.isArray(F)){let D=0;for(const c of F){const p=C(c,A,l,k,f,R);if(p===10)return p;p>D&&(D=p)}return D}else{if(typeof F=="string")return k?F==="*"?5:F===l?10:0:0;if(F){const{language:D,pattern:c,scheme:p,hasAccessToAllModels:$,notebookType:g}=F;if(!k&&!$)return 0;g&&f&&(A=f);let t=0;if(p)if(p===A.scheme)t=10;else if(p==="*")t=5;else return 0;if(D)if(D===l)t=10;else if(D==="*")t=Math.max(t,5);else return 0;if(g)if(g===R)t=10;else if(g==="*"&&R!==void 0)t=Math.max(t,5);else return 0;if(c){let n;if(typeof c=="string"?n=c:n={...c,base:(0,M.$gc)(c.base)},n===A.fsPath||(0,w.$tj)(n,A.fsPath))t=10;else return 0}return t}else return 0}}e.$mE=C}),define(Re[91],Me([1,0,26,22]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q0=e.$P0=void 0;var C;(function(D){D[D.Full=1]="Full",D[D.Delta=2]="Delta"})(C||(C={}));function F(D){for(let c=0,p=D.length;c<p;c+=4){const $=D[c+0],g=D[c+1],t=D[c+2],n=D[c+3];D[c+0]=n,D[c+1]=t,D[c+2]=g,D[c+3]=$}}function A(D){const c=new Uint8Array(D.buffer,D.byteOffset,D.length*4);return M.$D()||F(c),w.$ae.wrap(c)}function l(D){const c=D.buffer;if(M.$D()||F(c),c.byteOffset%4===0)return new Uint32Array(c.buffer,c.byteOffset,c.length/4);{const p=new Uint8Array(c.byteLength);return p.set(c),new Uint32Array(p.buffer,p.byteOffset,p.length/4)}}function k(D){const c=new Uint32Array(f(D));let p=0;if(c[p++]=D.id,D.type==="full")c[p++]=1,c[p++]=D.data.length,c.set(D.data,p),p+=D.data.length;else{c[p++]=2,c[p++]=D.deltas.length;for(const $ of D.deltas)c[p++]=$.start,c[p++]=$.deleteCount,$.data?(c[p++]=$.data.length,c.set($.data,p),p+=$.data.length):c[p++]=0}return A(c)}e.$P0=k;function f(D){let c=0;if(c+=1+1,D.type==="full")c+=1+D.data.length;else{c+=1,c+=(1+1+1)*D.deltas.length;for(const p of D.deltas)p.data&&(c+=p.data.length)}return c}function R(D){const c=l(D);let p=0;const $=c[p++];if(c[p++]===1){const a=c[p++],b=c.subarray(p,p+a);return p+=a,{id:$,type:"full",data:b}}const t=c[p++],n=[];for(let a=0;a<t;a++){const b=c[p++],E=c[p++],v=c[p++];let r;v>0&&(r=c.subarray(p,p+v),p+=v),n[a]={start:b,deleteCount:E,data:r}}return{id:$,type:"delta",deltas:n}}e.$Q0=R}),define(Re[134],Me([10,11]),function(be,e){return be.create("vs/editor/common/config/editorOptions",e)}),define(Re[135],Me([1,0,18,24,22,123,136,134]),function(be,e,w,M,C,F,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var k;(function(_){_[_.None=0]="None",_[_.Keep=1]="Keep",_[_.Brackets=2]="Brackets",_[_.Advanced=3]="Advanced",_[_.Full=4]="Full"})(k||(e.EditorAutoIndentStrategy=k={})),e.MINIMAP_GUTTER_WIDTH=8;class f{constructor(Z){this.c=Z}hasChanged(Z){return this.c[Z]}}e.ConfigurationChangedEvent=f;class R{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=R;class D{constructor(Z,pe,je,Oe){this.id=Z,this.name=pe,this.defaultValue=je,this.schema=Oe}applyUpdate(Z,pe){return p(Z,pe)}compute(Z,pe,je){return je}}class c{constructor(Z,pe){this.newValue=Z,this.didChange=pe}}e.ApplyUpdateResult=c;function p(_,Z){if(typeof _!="object"||typeof Z!="object"||!_||!Z)return new c(Z,_!==Z);if(Array.isArray(_)||Array.isArray(Z)){const je=Array.isArray(_)&&Array.isArray(Z)&&w.$tb(_,Z);return new c(Z,!je)}let pe=!1;for(const je in Z)if(Z.hasOwnProperty(je)){const Oe=p(_[je],Z[je]);Oe.didChange&&(_[je]=Oe.newValue,pe=!0)}return new c(_,pe)}class ${constructor(Z){this.schema=void 0,this.id=Z,this.name="_never_",this.defaultValue=void 0}applyUpdate(Z,pe){return p(Z,pe)}validate(Z){return this.defaultValue}}class g{constructor(Z,pe,je,Oe){this.id=Z,this.name=pe,this.defaultValue=je,this.schema=Oe}applyUpdate(Z,pe){return p(Z,pe)}validate(Z){return typeof Z>"u"?this.defaultValue:Z}compute(Z,pe,je){return je}}function t(_,Z){return typeof _>"u"?Z:_==="false"?!1:!!_}e.boolean=t;class n extends g{constructor(Z,pe,je,Oe=void 0){typeof Oe<"u"&&(Oe.type="boolean",Oe.default=je),super(Z,pe,je,Oe)}validate(Z){return t(Z,this.defaultValue)}}function a(_,Z,pe,je){if(typeof _>"u")return Z;let Oe=parseInt(_,10);return isNaN(Oe)?Z:(Oe=Math.max(pe,Oe),Oe=Math.min(je,Oe),Oe|0)}e.clampedInt=a;class b extends g{static clampedInt(Z,pe,je,Oe){return a(Z,pe,je,Oe)}constructor(Z,pe,je,Oe,Ze,rt=void 0){typeof rt<"u"&&(rt.type="integer",rt.default=je,rt.minimum=Oe,rt.maximum=Ze),super(Z,pe,je,rt),this.minimum=Oe,this.maximum=Ze}validate(Z){return b.clampedInt(Z,this.defaultValue,this.minimum,this.maximum)}}function E(_,Z,pe,je){if(typeof _>"u")return Z;const Oe=v.float(_,Z);return v.clamp(Oe,pe,je)}e.clampedFloat=E;class v extends g{static clamp(Z,pe,je){return Z<pe?pe:Z>je?je:Z}static float(Z,pe){if(typeof Z=="number")return Z;if(typeof Z>"u")return pe;const je=parseFloat(Z);return isNaN(je)?pe:je}constructor(Z,pe,je,Oe,Ze){typeof Ze<"u"&&(Ze.type="number",Ze.default=je),super(Z,pe,je,Ze),this.validationFn=Oe}validate(Z){return this.validationFn(v.float(Z,this.defaultValue))}}class r extends g{static string(Z,pe){return typeof Z!="string"?pe:Z}constructor(Z,pe,je,Oe=void 0){typeof Oe<"u"&&(Oe.type="string",Oe.default=je),super(Z,pe,je,Oe)}validate(Z){return r.string(Z,this.defaultValue)}}function s(_,Z,pe,je){return typeof _!="string"?Z:je&&_ in je?je[_]:pe.indexOf(_)===-1?Z:_}e.stringSet=s;class i extends g{constructor(Z,pe,je,Oe,Ze=void 0){typeof Ze<"u"&&(Ze.type="string",Ze.enum=Oe,Ze.default=je),super(Z,pe,je,Ze),this.c=Oe}validate(Z){return s(Z,this.defaultValue,this.c)}}class o extends D{constructor(Z,pe,je,Oe,Ze,rt,mt=void 0){typeof mt<"u"&&(mt.type="string",mt.enum=Ze,mt.default=Oe),super(Z,pe,je,mt),this.c=Ze,this.d=rt}validate(Z){return typeof Z!="string"?this.defaultValue:this.c.indexOf(Z)===-1?this.defaultValue:this.d(Z)}}function y(_){switch(_){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class d extends D{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[l.localize(0,null),l.localize(1,null),l.localize(2,null)],default:"auto",tags:["accessibility"],description:l.localize(3,null)})}validate(Z){switch(Z){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Z,pe,je){return je===0?Z.accessibilitySupport:je}}class I extends D{constructor(){const Z={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",Z,{"editor.comments.insertSpace":{type:"boolean",default:Z.insertSpace,description:l.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Z.ignoreEmptyLines,description:l.localize(5,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{insertSpace:t(pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:t(pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var S;(function(_){_[_.Hidden=0]="Hidden",_[_.Blink=1]="Blink",_[_.Smooth=2]="Smooth",_[_.Phase=3]="Phase",_[_.Expand=4]="Expand",_[_.Solid=5]="Solid"})(S||(e.TextEditorCursorBlinkingStyle=S={}));function u(_){switch(_){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var m;(function(_){_[_.Line=1]="Line",_[_.Block=2]="Block",_[_.Underline=3]="Underline",_[_.LineThin=4]="LineThin",_[_.BlockOutline=5]="BlockOutline",_[_.UnderlineThin=6]="UnderlineThin"})(m||(e.TextEditorCursorStyle=m={}));function h(_){switch(_){case m.Line:return"line";case m.Block:return"block";case m.Underline:return"underline";case m.LineThin:return"line-thin";case m.BlockOutline:return"block-outline";case m.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=h;function P(_){switch(_){case"line":return m.Line;case"block":return m.Block;case"underline":return m.Underline;case"line-thin":return m.LineThin;case"block-outline":return m.BlockOutline;case"underline-thin":return m.UnderlineThin}}class W extends ${constructor(){super(140)}compute(Z,pe,je){const Oe=["monaco-editor"];return pe.get(39)&&Oe.push(pe.get(39)),Z.extraEditorClassName&&Oe.push(Z.extraEditorClassName),pe.get(73)==="default"?Oe.push("mouse-default"):pe.get(73)==="copy"&&Oe.push("mouse-copy"),pe.get(110)&&Oe.push("showUnused"),pe.get(138)&&Oe.push("showDeprecated"),Oe.join(" ")}}class K extends n{constructor(){super(37,"emptySelectionClipboard",!0,{description:l.localize(6,null)})}compute(Z,pe,je){return je&&Z.emptySelectionClipboard}}class U extends D{constructor(){const Z={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",Z,{"editor.find.cursorMoveOnType":{type:"boolean",default:Z.cursorMoveOnType,description:l.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Z.seedSearchStringFromSelection,enumDescriptions:[l.localize(8,null),l.localize(9,null),l.localize(10,null)],description:l.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Z.autoFindInSelection,enumDescriptions:[l.localize(12,null),l.localize(13,null),l.localize(14,null)],description:l.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Z.globalFindClipboard,description:l.localize(16,null),included:C.$k},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Z.addExtraSpaceOnTop,description:l.localize(17,null)},"editor.find.loop":{type:"boolean",default:Z.loop,description:l.localize(18,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{cursorMoveOnType:t(pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Z.seedSearchStringFromSelection=="boolean"?Z.seedSearchStringFromSelection?"always":"never":s(pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Z.autoFindInSelection=="boolean"?Z.autoFindInSelection?"always":"never":s(pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:t(pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:t(pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:t(pe.loop,this.defaultValue.loop)}}}class B extends D{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",B.OFF,{anyOf:[{type:"boolean",description:l.localize(19,null)},{type:"string",description:l.localize(20,null)}],description:l.localize(21,null),default:!1})}validate(Z){return typeof Z>"u"?this.defaultValue:typeof Z=="string"?Z==="false"?B.OFF:Z==="true"?B.ON:Z:Z?B.ON:B.OFF}}e.EditorFontLigatures=B;class O extends D{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",O.OFF,{anyOf:[{type:"boolean",description:l.localize(22,null)},{type:"string",description:l.localize(23,null)}],description:l.localize(24,null),default:!1})}validate(Z){return typeof Z>"u"?this.defaultValue:typeof Z=="string"?Z==="false"?O.OFF:Z==="true"?O.TRANSLATE:Z:Z?O.TRANSLATE:O.OFF}compute(Z,pe,je){return Z.fontInfo.fontVariationSettings}}e.EditorFontVariations=O;class N extends ${constructor(){super(50)}compute(Z,pe,je){return Z.fontInfo}}class te extends g{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:l.localize(25,null)})}validate(Z){const pe=v.float(Z,this.defaultValue);return pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:v.clamp(pe,6,100)}compute(Z,pe,je){return Z.fontInfo.fontSize}}class Y extends D{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:Y.d,maximum:Y.e,errorMessage:l.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:Y.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:l.localize(27,null)})}validate(Z){return Z==="normal"||Z==="bold"?Z:String(b.clampedInt(Z,e.EDITOR_FONT_DEFAULTS.fontWeight,Y.d,Y.e))}}class ye extends D{constructor(){const Z={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:Z.multiple,enumDescriptions:[l.localize(28,null),l.localize(29,null),l.localize(30,null)]},je=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",Z,{"editor.gotoLocation.multiple":{deprecationMessage:l.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:l.localize(32,null),...pe},"editor.gotoLocation.multipleTypeDefinitions":{description:l.localize(33,null),...pe},"editor.gotoLocation.multipleDeclarations":{description:l.localize(34,null),...pe},"editor.gotoLocation.multipleImplementations":{description:l.localize(35,null),...pe},"editor.gotoLocation.multipleReferences":{description:l.localize(36,null),...pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Z.alternativeDefinitionCommand,enum:je,description:l.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Z.alternativeTypeDefinitionCommand,enum:je,description:l.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Z.alternativeDeclarationCommand,enum:je,description:l.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Z.alternativeImplementationCommand,enum:je,description:l.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Z.alternativeReferenceCommand,enum:je,description:l.localize(41,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{multiple:s(pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:pe.multipleDefinitions??s(pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:pe.multipleTypeDefinitions??s(pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:pe.multipleDeclarations??s(pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:pe.multipleImplementations??s(pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:pe.multipleReferences??s(pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:r.string(pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:r.string(pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:r.string(pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:r.string(pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:r.string(pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class Ee extends D{constructor(){const Z={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",Z,{"editor.hover.enabled":{type:"boolean",default:Z.enabled,description:l.localize(42,null)},"editor.hover.delay":{type:"number",default:Z.delay,minimum:0,maximum:1e4,description:l.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Z.sticky,description:l.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:Z.hidingDelay,description:l.localize(45,null)},"editor.hover.above":{type:"boolean",default:Z.above,description:l.localize(46,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:t(pe.enabled,this.defaultValue.enabled),delay:b.clampedInt(pe.delay,this.defaultValue.delay,0,1e4),sticky:t(pe.sticky,this.defaultValue.sticky),hidingDelay:b.clampedInt(pe.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:t(pe.above,this.defaultValue.above)}}}var Pe;(function(_){_[_.None=0]="None",_[_.Text=1]="Text",_[_.Blocks=2]="Blocks"})(Pe||(e.RenderMinimap=Pe={}));class X extends ${constructor(){super(143)}compute(Z,pe,je){return X.computeLayout(pe,{memory:Z.memory,outerWidth:Z.outerWidth,outerHeight:Z.outerHeight,isDominatedByLongLines:Z.isDominatedByLongLines,lineHeight:Z.fontInfo.lineHeight,viewLineCount:Z.viewLineCount,lineNumbersDigitCount:Z.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Z.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Z.fontInfo.maxDigitWidth,pixelRatio:Z.pixelRatio,glyphMarginDecorationLaneCount:Z.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(Z){const pe=Z.height/Z.lineHeight,je=Math.floor(Z.paddingTop/Z.lineHeight);let Oe=Math.floor(Z.paddingBottom/Z.lineHeight);Z.scrollBeyondLastLine&&(Oe=Math.max(Oe,pe-1));const Ze=(je+Z.viewLineCount+Oe)/(Z.pixelRatio*Z.height),rt=Math.floor(Z.viewLineCount/Ze);return{typicalViewportLineCount:pe,extraLinesBeforeFirstLine:je,extraLinesBeyondLastLine:Oe,desiredRatio:Ze,minimapLineCount:rt}}static c(Z,pe){const je=Z.outerWidth,Oe=Z.outerHeight,Ze=Z.pixelRatio;if(!Z.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ze*Oe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Oe};const rt=pe.stableMinimapLayoutInput,mt=rt&&Z.outerHeight===rt.outerHeight&&Z.lineHeight===rt.lineHeight&&Z.typicalHalfwidthCharacterWidth===rt.typicalHalfwidthCharacterWidth&&Z.pixelRatio===rt.pixelRatio&&Z.scrollBeyondLastLine===rt.scrollBeyondLastLine&&Z.paddingTop===rt.paddingTop&&Z.paddingBottom===rt.paddingBottom&&Z.minimap.enabled===rt.minimap.enabled&&Z.minimap.side===rt.minimap.side&&Z.minimap.size===rt.minimap.size&&Z.minimap.showSlider===rt.minimap.showSlider&&Z.minimap.renderCharacters===rt.minimap.renderCharacters&&Z.minimap.maxColumn===rt.minimap.maxColumn&&Z.minimap.scale===rt.minimap.scale&&Z.verticalScrollbarWidth===rt.verticalScrollbarWidth&&Z.isViewportWrapping===rt.isViewportWrapping,wt=Z.lineHeight,Ct=Z.typicalHalfwidthCharacterWidth,Yt=Z.scrollBeyondLastLine,qt=Z.minimap.renderCharacters;let vt=Ze>=2?Math.round(Z.minimap.scale*2):Z.minimap.scale;const jt=Z.minimap.maxColumn,Ft=Z.minimap.size,Bt=Z.minimap.side,Pt=Z.verticalScrollbarWidth,At=Z.viewLineCount,Nt=Z.remainingWidth,Wt=Z.isViewportWrapping,Ht=qt?2:3;let Kt=Math.floor(Ze*Oe);const at=Kt/Ze;let ut=!1,Jt=!1,It=Ht*vt,Et=vt/Ze,dt=1;if(Ft==="fill"||Ft==="fit"){const{typicalViewportLineCount:Ce,extraLinesBeforeFirstLine:Ae,extraLinesBeyondLastLine:ge,desiredRatio:G,minimapLineCount:Te}=X.computeContainedMinimapLineCount({viewLineCount:At,scrollBeyondLastLine:Yt,paddingTop:Z.paddingTop,paddingBottom:Z.paddingBottom,height:Oe,lineHeight:wt,pixelRatio:Ze});if(At/Te>1)ut=!0,Jt=!0,vt=1,It=1,Et=vt/Ze;else{let Je=!1,Ve=vt+1;if(Ft==="fit"){const et=Math.ceil((Ae+At+ge)*It);Wt&&mt&&Nt<=pe.stableFitRemainingWidth?(Je=!0,Ve=pe.stableFitMaxMinimapScale):Je=et>Kt}if(Ft==="fill"||Je){ut=!0;const et=vt;It=Math.min(wt*Ze,Math.max(1,Math.floor(1/G))),Wt&&mt&&Nt<=pe.stableFitRemainingWidth&&(Ve=pe.stableFitMaxMinimapScale),vt=Math.min(Ve,Math.max(1,Math.floor(It/Ht))),vt>et&&(dt=Math.min(2,vt/et)),Et=vt/Ze/dt,Kt=Math.ceil(Math.max(Ce,Ae+At+ge)*It),Wt?(pe.stableMinimapLayoutInput=Z,pe.stableFitRemainingWidth=Nt,pe.stableFitMaxMinimapScale=vt):(pe.stableMinimapLayoutInput=null,pe.stableFitRemainingWidth=0)}}}const kt=Math.floor(jt*Et),Lt=Math.min(kt,Math.max(0,Math.floor((Nt-Pt-2)*Et/(Ct+Et)))+e.MINIMAP_GUTTER_WIDTH);let yt=Math.floor(Ze*Lt);const Ke=yt/Ze;yt=Math.floor(yt*dt);const Ot=qt?1:2,zt=Bt==="left"?0:je-Lt-Pt;return{renderMinimap:Ot,minimapLeft:zt,minimapWidth:Lt,minimapHeightIsEditorHeight:ut,minimapIsSampling:Jt,minimapScale:vt,minimapLineHeight:It,minimapCanvasInnerWidth:yt,minimapCanvasInnerHeight:Kt,minimapCanvasOuterWidth:Ke,minimapCanvasOuterHeight:at}}static computeLayout(Z,pe){const je=pe.outerWidth|0,Oe=pe.outerHeight|0,Ze=pe.lineHeight|0,rt=pe.lineNumbersDigitCount|0,mt=pe.typicalHalfwidthCharacterWidth,wt=pe.maxDigitWidth,Ct=pe.pixelRatio,Yt=pe.viewLineCount,qt=Z.get(135),vt=qt==="inherit"?Z.get(134):qt,jt=vt==="inherit"?Z.get(130):vt,Ft=Z.get(133),Bt=pe.isDominatedByLongLines,Pt=Z.get(57),At=Z.get(67).renderType!==0,Nt=Z.get(68),Wt=Z.get(104),Ht=Z.get(83),Kt=Z.get(72),at=Z.get(102),ut=at.verticalScrollbarSize,Jt=at.verticalHasArrows,It=at.arrowSize,Et=at.horizontalScrollbarSize,dt=Z.get(43),kt=Z.get(109)!=="never";let Lt=Z.get(65);dt&&kt&&(Lt+=16);let yt=0;if(At){const ft=Math.max(rt,Nt);yt=Math.round(ft*wt)}let Ke=0;Pt&&(Ke=Ze*pe.glyphMarginDecorationLaneCount);let Ot=0,zt=Ot+Ke,Ce=zt+yt,Ae=Ce+Lt;const ge=je-Ke-yt-Lt;let G=!1,Te=!1,Be=-1;vt==="inherit"&&Bt?(G=!0,Te=!0):jt==="on"||jt==="bounded"?Te=!0:jt==="wordWrapColumn"&&(Be=Ft);const Je=X.c({outerWidth:je,outerHeight:Oe,lineHeight:Ze,typicalHalfwidthCharacterWidth:mt,pixelRatio:Ct,scrollBeyondLastLine:Wt,paddingTop:Ht.top,paddingBottom:Ht.bottom,minimap:Kt,verticalScrollbarWidth:ut,viewLineCount:Yt,remainingWidth:ge,isViewportWrapping:Te},pe.memory||new R);Je.renderMinimap!==0&&Je.minimapLeft===0&&(Ot+=Je.minimapWidth,zt+=Je.minimapWidth,Ce+=Je.minimapWidth,Ae+=Je.minimapWidth);const Ve=ge-Je.minimapWidth,et=Math.max(1,Math.floor((Ve-ut-2)/mt)),gt=Jt?It:0;return Te&&(Be=Math.max(1,et),jt==="bounded"&&(Be=Math.min(Be,Ft))),{width:je,height:Oe,glyphMarginLeft:Ot,glyphMarginWidth:Ke,glyphMarginDecorationLaneCount:pe.glyphMarginDecorationLaneCount,lineNumbersLeft:zt,lineNumbersWidth:yt,decorationsLeft:Ce,decorationsWidth:Lt,contentLeft:Ae,contentWidth:Ve,minimap:Je,viewportColumn:et,isWordWrapMinified:G,isViewportWrapping:Te,wrappingColumn:Be,verticalScrollbarWidth:ut,horizontalScrollbarHeight:Et,overviewRuler:{top:gt,width:ut,height:Oe-2*gt,right:0}}}}e.EditorLayoutInfoComputer=X;class ae extends D{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[l.localize(47,null),l.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:l.localize(49,null)}})}validate(Z){return s(Z,"simple",["simple","advanced"])}compute(Z,pe,je){return pe.get(2)===2?"advanced":je}}class Se extends D{constructor(){const Z={enabled:!0};super(64,"lightbulb",Z,{"editor.lightbulb.enabled":{type:"boolean",default:Z.enabled,description:l.localize(50,null)}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{enabled:t(Z.enabled,this.defaultValue.enabled)}}}class ue extends D{constructor(){const Z={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",Z,{"editor.stickyScroll.enabled":{type:"boolean",default:Z.enabled,description:l.localize(51,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:Z.maxLineCount,minimum:1,maximum:10,description:l.localize(52,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:Z.defaultModel,description:l.localize(53,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:Z.scrollWithEditor,description:l.localize(54,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:t(pe.enabled,this.defaultValue.enabled),maxLineCount:b.clampedInt(pe.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:s(pe.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:t(pe.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class $e extends D{constructor(){const Z={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",Z,{"editor.inlayHints.enabled":{type:"string",default:Z.enabled,description:l.localize(55,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[l.localize(56,null),l.localize(57,null,C.$k?"Ctrl+Option":"Ctrl+Alt"),l.localize(58,null,C.$k?"Ctrl+Option":"Ctrl+Alt"),l.localize(59,null)]},"editor.inlayHints.fontSize":{type:"number",default:Z.fontSize,markdownDescription:l.localize(60,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Z.fontFamily,markdownDescription:l.localize(61,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Z.padding,description:l.localize(62,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return typeof pe.enabled=="boolean"&&(pe.enabled=pe.enabled?"on":"off"),{enabled:s(pe.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:b.clampedInt(pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:r.string(pe.fontFamily,this.defaultValue.fontFamily),padding:t(pe.padding,this.defaultValue.padding)}}}class ie extends D{constructor(){super(65,"lineDecorationsWidth",10)}validate(Z){return typeof Z=="string"&&/^\d+(\.\d+)?ch$/.test(Z)?-parseFloat(Z.substring(0,Z.length-2)):b.clampedInt(Z,this.defaultValue,0,1e3)}compute(Z,pe,je){return je<0?b.clampedInt(-je*Z.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):je}}class z extends v{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Z=>v.clamp(Z,0,150),{markdownDescription:l.localize(63,null)})}compute(Z,pe,je){return Z.fontInfo.lineHeight}}class V extends D{constructor(){const Z={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",Z,{"editor.minimap.enabled":{type:"boolean",default:Z.enabled,description:l.localize(64,null)},"editor.minimap.autohide":{type:"boolean",default:Z.autohide,description:l.localize(65,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[l.localize(66,null),l.localize(67,null),l.localize(68,null)],default:Z.size,description:l.localize(69,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Z.side,description:l.localize(70,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Z.showSlider,description:l.localize(71,null)},"editor.minimap.scale":{type:"number",default:Z.scale,minimum:1,maximum:3,enum:[1,2,3],description:l.localize(72,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Z.renderCharacters,description:l.localize(73,null)},"editor.minimap.maxColumn":{type:"number",default:Z.maxColumn,description:l.localize(74,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:t(pe.enabled,this.defaultValue.enabled),autohide:t(pe.autohide,this.defaultValue.autohide),size:s(pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:s(pe.side,this.defaultValue.side,["right","left"]),showSlider:s(pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:t(pe.renderCharacters,this.defaultValue.renderCharacters),scale:b.clampedInt(pe.scale,1,1,3),maxColumn:b.clampedInt(pe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function le(_){return _==="ctrlCmd"?C.$k?"metaKey":"ctrlKey":"altKey"}class we extends D{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:l.localize(75,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:l.localize(76,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{top:b.clampedInt(pe.top,0,0,1e3),bottom:b.clampedInt(pe.bottom,0,0,1e3)}}}class ve extends D{constructor(){const Z={enabled:!0,cycle:!0};super(85,"parameterHints",Z,{"editor.parameterHints.enabled":{type:"boolean",default:Z.enabled,description:l.localize(77,null)},"editor.parameterHints.cycle":{type:"boolean",default:Z.cycle,description:l.localize(78,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:t(pe.enabled,this.defaultValue.enabled),cycle:t(pe.cycle,this.defaultValue.cycle)}}}class me extends ${constructor(){super(141)}compute(Z,pe,je){return Z.pixelRatio}}class De extends D{constructor(){const Z={other:"on",comments:"off",strings:"off"},pe=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[l.localize(79,null),l.localize(80,null),l.localize(81,null)]}];super(88,"quickSuggestions",Z,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:pe,default:Z.strings,description:l.localize(82,null)},comments:{anyOf:pe,default:Z.comments,description:l.localize(83,null)},other:{anyOf:pe,default:Z.other,description:l.localize(84,null)}},default:Z,markdownDescription:l.localize(85,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Z}validate(Z){if(typeof Z=="boolean"){const Ct=Z?"on":"off";return{comments:Ct,strings:Ct,other:Ct}}if(!Z||typeof Z!="object")return this.defaultValue;const{other:pe,comments:je,strings:Oe}=Z,Ze=["on","inline","off"];let rt,mt,wt;return typeof pe=="boolean"?rt=pe?"on":"off":rt=s(pe,this.defaultValue.other,Ze),typeof je=="boolean"?mt=je?"on":"off":mt=s(je,this.defaultValue.comments,Ze),typeof Oe=="boolean"?wt=Oe?"on":"off":wt=s(Oe,this.defaultValue.strings,Ze),{other:rt,comments:mt,strings:wt}}}var re;(function(_){_[_.Off=0]="Off",_[_.On=1]="On",_[_.Relative=2]="Relative",_[_.Interval=3]="Interval",_[_.Custom=4]="Custom"})(re||(e.RenderLineNumbersType=re={}));class he extends D{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[l.localize(86,null),l.localize(87,null),l.localize(88,null),l.localize(89,null)],default:"on",description:l.localize(90,null)})}validate(Z){let pe=this.defaultValue.renderType,je=this.defaultValue.renderFn;return typeof Z<"u"&&(typeof Z=="function"?(pe=4,je=Z):Z==="interval"?pe=3:Z==="relative"?pe=2:Z==="on"?pe=1:pe=0),{renderType:pe,renderFn:je}}}function se(_){const Z=_.get(97);return Z==="editable"?_.get(90):Z!=="on"}e.filterValidationDecorations=se;class oe extends D{constructor(){const Z=[],pe={type:"number",description:l.localize(91,null)};super(101,"rulers",Z,{type:"array",items:{anyOf:[pe,{type:["object"],properties:{column:pe,color:{type:"string",description:l.localize(92,null),format:"color-hex"}}}]},default:Z,description:l.localize(93,null)})}validate(Z){if(Array.isArray(Z)){const pe=[];for(const je of Z)if(typeof je=="number")pe.push({column:b.clampedInt(je,0,0,1e4),color:null});else if(je&&typeof je=="object"){const Oe=je;pe.push({column:b.clampedInt(Oe.column,0,0,1e4),color:Oe.color})}return pe.sort((je,Oe)=>je.column-Oe.column),pe}return this.defaultValue}}class de extends D{constructor(){super(91,"readOnlyMessage",void 0)}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:Z}}function Ie(_,Z){if(typeof _!="string")return Z;switch(_){case"hidden":return 2;case"visible":return 3;default:return 1}}class T extends D{constructor(){const Z={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(102,"scrollbar",Z,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[l.localize(94,null),l.localize(95,null),l.localize(96,null)],default:"auto",description:l.localize(97,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[l.localize(98,null),l.localize(99,null),l.localize(100,null)],default:"auto",description:l.localize(101,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Z.verticalScrollbarSize,description:l.localize(102,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Z.horizontalScrollbarSize,description:l.localize(103,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Z.scrollByPage,description:l.localize(104,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z,je=b.clampedInt(pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Oe=b.clampedInt(pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:b.clampedInt(pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ie(pe.vertical,this.defaultValue.vertical),horizontal:Ie(pe.horizontal,this.defaultValue.horizontal),useShadows:t(pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:t(pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:t(pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:t(pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:t(pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:je,horizontalSliderSize:b.clampedInt(pe.horizontalSliderSize,je,0,1e3),verticalScrollbarSize:Oe,verticalSliderSize:b.clampedInt(pe.verticalSliderSize,Oe,0,1e3),scrollByPage:t(pe.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class q extends D{constructor(){const Z={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",Z,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.nonBasicASCII,description:l.localize(105,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Z.invisibleCharacters,description:l.localize(106,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Z.ambiguousCharacters,description:l.localize(107,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.includeComments,description:l.localize(108,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.includeStrings,description:l.localize(109,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Z.allowedCharacters,description:l.localize(110,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Z.allowedLocales,description:l.localize(111,null)}})}applyUpdate(Z,pe){let je=!1;pe.allowedCharacters&&Z&&(M.$6m(Z.allowedCharacters,pe.allowedCharacters)||(Z={...Z,allowedCharacters:pe.allowedCharacters},je=!0)),pe.allowedLocales&&Z&&(M.$6m(Z.allowedLocales,pe.allowedLocales)||(Z={...Z,allowedLocales:pe.allowedLocales},je=!0));const Oe=super.applyUpdate(Z,pe);return je?new c(Oe.newValue,!0):Oe}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{nonBasicASCII:x(pe.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:t(pe.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:t(pe.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:x(pe.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:x(pe.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Z.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Z.allowedLocales,this.defaultValue.allowedLocales)}}c(Z,pe){if(typeof Z!="object"||!Z)return pe;const je={};for(const[Oe,Ze]of Object.entries(Z))Ze===!0&&(je[Oe]=!0);return je}}class J extends D{constructor(){const Z={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",Z,{"editor.inlineSuggest.enabled":{type:"boolean",default:Z.enabled,description:l.localize(112,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Z.showToolbar,enum:["always","onHover"],enumDescriptions:[l.localize(113,null),l.localize(114,null)],description:l.localize(115,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:Z.suppressSuggestions,description:l.localize(116,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:t(pe.enabled,this.defaultValue.enabled),mode:s(pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:s(pe.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:t(pe.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:t(pe.keepOnBlur,this.defaultValue.keepOnBlur)}}}class Q extends D{constructor(){const Z={enabled:F.$Yr.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:F.$Yr.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",Z,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Z.enabled,markdownDescription:l.localize(117,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Z.independentColorPoolPerBracketType,description:l.localize(118,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:t(pe.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:t(pe.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class H extends D{constructor(){const Z={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",Z,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[l.localize(119,null),l.localize(120,null),l.localize(121,null)],default:Z.bracketPairs,description:l.localize(122,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[l.localize(123,null),l.localize(124,null),l.localize(125,null)],default:Z.bracketPairsHorizontal,description:l.localize(126,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Z.highlightActiveBracketPair,description:l.localize(127,null)},"editor.guides.indentation":{type:"boolean",default:Z.indentation,description:l.localize(128,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[l.localize(129,null),l.localize(130,null),l.localize(131,null)],default:Z.highlightActiveIndentation,description:l.localize(132,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{bracketPairs:x(pe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:x(pe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:t(pe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:t(pe.indentation,this.defaultValue.indentation),highlightActiveIndentation:x(pe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function x(_,Z,pe){const je=pe.indexOf(_);return je===-1?Z:pe[je]}class ce extends D{constructor(){const Z={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",Z,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[l.localize(133,null),l.localize(134,null)],default:Z.insertMode,description:l.localize(135,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Z.filterGraceful,description:l.localize(136,null)},"editor.suggest.localityBonus":{type:"boolean",default:Z.localityBonus,description:l.localize(137,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Z.shareSuggestSelections,markdownDescription:l.localize(138,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[l.localize(139,null),l.localize(140,null),l.localize(141,null),l.localize(142,null)],default:Z.selectionMode,markdownDescription:l.localize(143,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Z.snippetsPreventQuickSuggestions,description:l.localize(144,null)},"editor.suggest.showIcons":{type:"boolean",default:Z.showIcons,description:l.localize(145,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Z.showStatusBar,description:l.localize(146,null)},"editor.suggest.preview":{type:"boolean",default:Z.preview,description:l.localize(147,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Z.showInlineDetails,description:l.localize(148,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:l.localize(149,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:l.localize(150,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:l.localize(151,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:l.localize(152,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:l.localize(153,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:l.localize(154,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:l.localize(155,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:l.localize(156,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:l.localize(157,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:l.localize(158,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:l.localize(159,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:l.localize(160,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:l.localize(161,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:l.localize(162,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:l.localize(163,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:l.localize(164,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:l.localize(165,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:l.localize(166,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:l.localize(167,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:l.localize(168,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:l.localize(169,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:l.localize(170,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:l.localize(171,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:l.localize(172,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:l.localize(173,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:l.localize(174,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:l.localize(175,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:l.localize(176,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:l.localize(177,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:l.localize(178,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:l.localize(179,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:l.localize(180,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{insertMode:s(pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:t(pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:t(pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:t(pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:t(pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:s(pe.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:t(pe.showIcons,this.defaultValue.showIcons),showStatusBar:t(pe.showStatusBar,this.defaultValue.showStatusBar),preview:t(pe.preview,this.defaultValue.preview),previewMode:s(pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:t(pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:t(pe.showMethods,this.defaultValue.showMethods),showFunctions:t(pe.showFunctions,this.defaultValue.showFunctions),showConstructors:t(pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:t(pe.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:t(pe.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:t(pe.showFields,this.defaultValue.showFields),showVariables:t(pe.showVariables,this.defaultValue.showVariables),showClasses:t(pe.showClasses,this.defaultValue.showClasses),showStructs:t(pe.showStructs,this.defaultValue.showStructs),showInterfaces:t(pe.showInterfaces,this.defaultValue.showInterfaces),showModules:t(pe.showModules,this.defaultValue.showModules),showProperties:t(pe.showProperties,this.defaultValue.showProperties),showEvents:t(pe.showEvents,this.defaultValue.showEvents),showOperators:t(pe.showOperators,this.defaultValue.showOperators),showUnits:t(pe.showUnits,this.defaultValue.showUnits),showValues:t(pe.showValues,this.defaultValue.showValues),showConstants:t(pe.showConstants,this.defaultValue.showConstants),showEnums:t(pe.showEnums,this.defaultValue.showEnums),showEnumMembers:t(pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:t(pe.showKeywords,this.defaultValue.showKeywords),showWords:t(pe.showWords,this.defaultValue.showWords),showColors:t(pe.showColors,this.defaultValue.showColors),showFiles:t(pe.showFiles,this.defaultValue.showFiles),showReferences:t(pe.showReferences,this.defaultValue.showReferences),showFolders:t(pe.showFolders,this.defaultValue.showFolders),showTypeParameters:t(pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:t(pe.showSnippets,this.defaultValue.showSnippets),showUsers:t(pe.showUsers,this.defaultValue.showUsers),showIssues:t(pe.showIssues,this.defaultValue.showIssues)}}}class Fe extends D{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:l.localize(181,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:l.localize(182,null),default:!0,type:"boolean"}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:t(Z.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:t(Z.selectSubwords,this.defaultValue.selectSubwords)}}}var Ue;(function(_){_[_.None=0]="None",_[_.Same=1]="Same",_[_.Indent=2]="Indent",_[_.DeepIndent=3]="DeepIndent"})(Ue||(e.WrappingIndent=Ue={}));class Qe extends D{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[l.localize(183,null),l.localize(184,null),l.localize(185,null),l.localize(186,null)],description:l.localize(187,null),default:"same"}})}validate(Z){switch(Z){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Z,pe,je){return pe.get(2)===2?0:je}}class Ge extends ${constructor(){super(144)}compute(Z,pe,je){const Oe=pe.get(143);return{isDominatedByLongLines:Z.isDominatedByLongLines,isWordWrapMinified:Oe.isWordWrapMinified,isViewportWrapping:Oe.isViewportWrapping,wrappingColumn:Oe.wrappingColumn}}}class _e extends D{constructor(){const Z={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",Z,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Z.enabled,markdownDescription:l.localize(188,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:l.localize(189,null),enum:["afterDrop","never"],enumDescriptions:[l.localize(190,null),l.localize(191,null)],default:"afterDrop"}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:t(pe.enabled,this.defaultValue.enabled),showDropSelector:s(pe.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class Xe extends D{constructor(){const Z={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",Z,{"editor.pasteAs.enabled":{type:"boolean",default:Z.enabled,markdownDescription:l.localize(192,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:l.localize(193,null),enum:["afterPaste","never"],enumDescriptions:[l.localize(194,null),l.localize(195,null)],default:"afterPaste"}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:t(pe.enabled,this.defaultValue.enabled),showPasteSelector:s(pe.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const xe="Consolas, 'Courier New', monospace",it="Menlo, Monaco, 'Courier New', monospace",tt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:C.$k?it:C.$l?tt:xe,fontWeight:"normal",fontSize:C.$k?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function ze(_){return e.editorOptionsRegistry[_.id]=_,_}var st;(function(_){_[_.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",_[_.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",_[_.accessibilitySupport=2]="accessibilitySupport",_[_.accessibilityPageSize=3]="accessibilityPageSize",_[_.ariaLabel=4]="ariaLabel",_[_.ariaRequired=5]="ariaRequired",_[_.autoClosingBrackets=6]="autoClosingBrackets",_[_.autoClosingComments=7]="autoClosingComments",_[_.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",_[_.autoClosingDelete=9]="autoClosingDelete",_[_.autoClosingOvertype=10]="autoClosingOvertype",_[_.autoClosingQuotes=11]="autoClosingQuotes",_[_.autoIndent=12]="autoIndent",_[_.automaticLayout=13]="automaticLayout",_[_.autoSurround=14]="autoSurround",_[_.bracketPairColorization=15]="bracketPairColorization",_[_.guides=16]="guides",_[_.codeLens=17]="codeLens",_[_.codeLensFontFamily=18]="codeLensFontFamily",_[_.codeLensFontSize=19]="codeLensFontSize",_[_.colorDecorators=20]="colorDecorators",_[_.colorDecoratorsLimit=21]="colorDecoratorsLimit",_[_.columnSelection=22]="columnSelection",_[_.comments=23]="comments",_[_.contextmenu=24]="contextmenu",_[_.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",_[_.cursorBlinking=26]="cursorBlinking",_[_.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",_[_.cursorStyle=28]="cursorStyle",_[_.cursorSurroundingLines=29]="cursorSurroundingLines",_[_.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",_[_.cursorWidth=31]="cursorWidth",_[_.disableLayerHinting=32]="disableLayerHinting",_[_.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",_[_.domReadOnly=34]="domReadOnly",_[_.dragAndDrop=35]="dragAndDrop",_[_.dropIntoEditor=36]="dropIntoEditor",_[_.emptySelectionClipboard=37]="emptySelectionClipboard",_[_.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",_[_.extraEditorClassName=39]="extraEditorClassName",_[_.fastScrollSensitivity=40]="fastScrollSensitivity",_[_.find=41]="find",_[_.fixedOverflowWidgets=42]="fixedOverflowWidgets",_[_.folding=43]="folding",_[_.foldingStrategy=44]="foldingStrategy",_[_.foldingHighlight=45]="foldingHighlight",_[_.foldingImportsByDefault=46]="foldingImportsByDefault",_[_.foldingMaximumRegions=47]="foldingMaximumRegions",_[_.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",_[_.fontFamily=49]="fontFamily",_[_.fontInfo=50]="fontInfo",_[_.fontLigatures=51]="fontLigatures",_[_.fontSize=52]="fontSize",_[_.fontWeight=53]="fontWeight",_[_.fontVariations=54]="fontVariations",_[_.formatOnPaste=55]="formatOnPaste",_[_.formatOnType=56]="formatOnType",_[_.glyphMargin=57]="glyphMargin",_[_.gotoLocation=58]="gotoLocation",_[_.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",_[_.hover=60]="hover",_[_.inDiffEditor=61]="inDiffEditor",_[_.inlineSuggest=62]="inlineSuggest",_[_.letterSpacing=63]="letterSpacing",_[_.lightbulb=64]="lightbulb",_[_.lineDecorationsWidth=65]="lineDecorationsWidth",_[_.lineHeight=66]="lineHeight",_[_.lineNumbers=67]="lineNumbers",_[_.lineNumbersMinChars=68]="lineNumbersMinChars",_[_.linkedEditing=69]="linkedEditing",_[_.links=70]="links",_[_.matchBrackets=71]="matchBrackets",_[_.minimap=72]="minimap",_[_.mouseStyle=73]="mouseStyle",_[_.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",_[_.mouseWheelZoom=75]="mouseWheelZoom",_[_.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",_[_.multiCursorModifier=77]="multiCursorModifier",_[_.multiCursorPaste=78]="multiCursorPaste",_[_.multiCursorLimit=79]="multiCursorLimit",_[_.occurrencesHighlight=80]="occurrencesHighlight",_[_.overviewRulerBorder=81]="overviewRulerBorder",_[_.overviewRulerLanes=82]="overviewRulerLanes",_[_.padding=83]="padding",_[_.pasteAs=84]="pasteAs",_[_.parameterHints=85]="parameterHints",_[_.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",_[_.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",_[_.quickSuggestions=88]="quickSuggestions",_[_.quickSuggestionsDelay=89]="quickSuggestionsDelay",_[_.readOnly=90]="readOnly",_[_.readOnlyMessage=91]="readOnlyMessage",_[_.renameOnType=92]="renameOnType",_[_.renderControlCharacters=93]="renderControlCharacters",_[_.renderFinalNewline=94]="renderFinalNewline",_[_.renderLineHighlight=95]="renderLineHighlight",_[_.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",_[_.renderValidationDecorations=97]="renderValidationDecorations",_[_.renderWhitespace=98]="renderWhitespace",_[_.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",_[_.roundedSelection=100]="roundedSelection",_[_.rulers=101]="rulers",_[_.scrollbar=102]="scrollbar",_[_.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",_[_.scrollBeyondLastLine=104]="scrollBeyondLastLine",_[_.scrollPredominantAxis=105]="scrollPredominantAxis",_[_.selectionClipboard=106]="selectionClipboard",_[_.selectionHighlight=107]="selectionHighlight",_[_.selectOnLineNumbers=108]="selectOnLineNumbers",_[_.showFoldingControls=109]="showFoldingControls",_[_.showUnused=110]="showUnused",_[_.snippetSuggestions=111]="snippetSuggestions",_[_.smartSelect=112]="smartSelect",_[_.smoothScrolling=113]="smoothScrolling",_[_.stickyScroll=114]="stickyScroll",_[_.stickyTabStops=115]="stickyTabStops",_[_.stopRenderingLineAfter=116]="stopRenderingLineAfter",_[_.suggest=117]="suggest",_[_.suggestFontSize=118]="suggestFontSize",_[_.suggestLineHeight=119]="suggestLineHeight",_[_.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",_[_.suggestSelection=121]="suggestSelection",_[_.tabCompletion=122]="tabCompletion",_[_.tabIndex=123]="tabIndex",_[_.unicodeHighlighting=124]="unicodeHighlighting",_[_.unusualLineTerminators=125]="unusualLineTerminators",_[_.useShadowDOM=126]="useShadowDOM",_[_.useTabStops=127]="useTabStops",_[_.wordBreak=128]="wordBreak",_[_.wordSeparators=129]="wordSeparators",_[_.wordWrap=130]="wordWrap",_[_.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",_[_.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",_[_.wordWrapColumn=133]="wordWrapColumn",_[_.wordWrapOverride1=134]="wordWrapOverride1",_[_.wordWrapOverride2=135]="wordWrapOverride2",_[_.wrappingIndent=136]="wrappingIndent",_[_.wrappingStrategy=137]="wrappingStrategy",_[_.showDeprecated=138]="showDeprecated",_[_.inlayHints=139]="inlayHints",_[_.editorClassName=140]="editorClassName",_[_.pixelRatio=141]="pixelRatio",_[_.tabFocusMode=142]="tabFocusMode",_[_.layoutInfo=143]="layoutInfo",_[_.wrappingInfo=144]="wrappingInfo",_[_.defaultColorDecorators=145]="defaultColorDecorators",_[_.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",_[_.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(st||(e.EditorOption=st={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ze(new n(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:l.localize(196,null)})),acceptSuggestionOnEnter:ze(new i(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",l.localize(197,null),""],markdownDescription:l.localize(198,null)})),accessibilitySupport:ze(new d),accessibilityPageSize:ze(new b(3,"accessibilityPageSize",10,1,1073741824,{description:l.localize(199,null),tags:["accessibility"]})),ariaLabel:ze(new r(4,"ariaLabel",l.localize(200,null))),ariaRequired:ze(new n(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:ze(new n(8,"screenReaderAnnounceInlineSuggestion",!0,{description:l.localize(201,null),tags:["accessibility"]})),autoClosingBrackets:ze(new i(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(202,null),l.localize(203,null),""],description:l.localize(204,null)})),autoClosingComments:ze(new i(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(205,null),l.localize(206,null),""],description:l.localize(207,null)})),autoClosingDelete:ze(new i(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",l.localize(208,null),""],description:l.localize(209,null)})),autoClosingOvertype:ze(new i(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",l.localize(210,null),""],description:l.localize(211,null)})),autoClosingQuotes:ze(new i(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(212,null),l.localize(213,null),""],description:l.localize(214,null)})),autoIndent:ze(new o(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],y,{enumDescriptions:[l.localize(215,null),l.localize(216,null),l.localize(217,null),l.localize(218,null),l.localize(219,null)],description:l.localize(220,null)})),automaticLayout:ze(new n(13,"automaticLayout",!1)),autoSurround:ze(new i(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[l.localize(221,null),l.localize(222,null),l.localize(223,null),""],description:l.localize(224,null)})),bracketPairColorization:ze(new Q),bracketPairGuides:ze(new H),stickyTabStops:ze(new n(115,"stickyTabStops",!1,{description:l.localize(225,null)})),codeLens:ze(new n(17,"codeLens",!0,{description:l.localize(226,null)})),codeLensFontFamily:ze(new r(18,"codeLensFontFamily","",{description:l.localize(227,null)})),codeLensFontSize:ze(new b(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:l.localize(228,null)})),colorDecorators:ze(new n(20,"colorDecorators",!0,{description:l.localize(229,null)})),colorDecoratorActivatedOn:ze(new i(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[l.localize(230,null),l.localize(231,null),l.localize(232,null)],description:l.localize(233,null)})),colorDecoratorsLimit:ze(new b(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:l.localize(234,null)})),columnSelection:ze(new n(22,"columnSelection",!1,{description:l.localize(235,null)})),comments:ze(new I),contextmenu:ze(new n(24,"contextmenu",!0)),copyWithSyntaxHighlighting:ze(new n(25,"copyWithSyntaxHighlighting",!0,{description:l.localize(236,null)})),cursorBlinking:ze(new o(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],u,{description:l.localize(237,null)})),cursorSmoothCaretAnimation:ze(new i(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[l.localize(238,null),l.localize(239,null),l.localize(240,null)],description:l.localize(241,null)})),cursorStyle:ze(new o(28,"cursorStyle",m.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],P,{description:l.localize(242,null)})),cursorSurroundingLines:ze(new b(29,"cursorSurroundingLines",0,0,1073741824,{description:l.localize(243,null)})),cursorSurroundingLinesStyle:ze(new i(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[l.localize(244,null),l.localize(245,null)],markdownDescription:l.localize(246,null)})),cursorWidth:ze(new b(31,"cursorWidth",0,0,1073741824,{markdownDescription:l.localize(247,null)})),disableLayerHinting:ze(new n(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:ze(new n(33,"disableMonospaceOptimizations",!1)),domReadOnly:ze(new n(34,"domReadOnly",!1)),dragAndDrop:ze(new n(35,"dragAndDrop",!0,{description:l.localize(248,null)})),emptySelectionClipboard:ze(new K),dropIntoEditor:ze(new _e),stickyScroll:ze(new ue),experimentalWhitespaceRendering:ze(new i(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[l.localize(249,null),l.localize(250,null),l.localize(251,null)],description:l.localize(252,null)})),extraEditorClassName:ze(new r(39,"extraEditorClassName","")),fastScrollSensitivity:ze(new v(40,"fastScrollSensitivity",5,_=>_<=0?5:_,{markdownDescription:l.localize(253,null)})),find:ze(new U),fixedOverflowWidgets:ze(new n(42,"fixedOverflowWidgets",!1)),folding:ze(new n(43,"folding",!0,{description:l.localize(254,null)})),foldingStrategy:ze(new i(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[l.localize(255,null),l.localize(256,null)],description:l.localize(257,null)})),foldingHighlight:ze(new n(45,"foldingHighlight",!0,{description:l.localize(258,null)})),foldingImportsByDefault:ze(new n(46,"foldingImportsByDefault",!1,{description:l.localize(259,null)})),foldingMaximumRegions:ze(new b(47,"foldingMaximumRegions",5e3,10,65e3,{description:l.localize(260,null)})),unfoldOnClickAfterEndOfLine:ze(new n(48,"unfoldOnClickAfterEndOfLine",!1,{description:l.localize(261,null)})),fontFamily:ze(new r(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:l.localize(262,null)})),fontInfo:ze(new N),fontLigatures2:ze(new B),fontSize:ze(new te),fontWeight:ze(new Y),fontVariations:ze(new O),formatOnPaste:ze(new n(55,"formatOnPaste",!1,{description:l.localize(263,null)})),formatOnType:ze(new n(56,"formatOnType",!1,{description:l.localize(264,null)})),glyphMargin:ze(new n(57,"glyphMargin",!0,{description:l.localize(265,null)})),gotoLocation:ze(new ye),hideCursorInOverviewRuler:ze(new n(59,"hideCursorInOverviewRuler",!1,{description:l.localize(266,null)})),hover:ze(new Ee),inDiffEditor:ze(new n(61,"inDiffEditor",!1)),letterSpacing:ze(new v(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,_=>v.clamp(_,-5,20),{description:l.localize(267,null)})),lightbulb:ze(new Se),lineDecorationsWidth:ze(new ie),lineHeight:ze(new z),lineNumbers:ze(new he),lineNumbersMinChars:ze(new b(68,"lineNumbersMinChars",5,1,300)),linkedEditing:ze(new n(69,"linkedEditing",!1,{description:l.localize(268,null)})),links:ze(new n(70,"links",!0,{description:l.localize(269,null)})),matchBrackets:ze(new i(71,"matchBrackets","always",["always","near","never"],{description:l.localize(270,null)})),minimap:ze(new V),mouseStyle:ze(new i(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ze(new v(74,"mouseWheelScrollSensitivity",1,_=>_===0?1:_,{markdownDescription:l.localize(271,null)})),mouseWheelZoom:ze(new n(75,"mouseWheelZoom",!1,{markdownDescription:l.localize(272,null)})),multiCursorMergeOverlapping:ze(new n(76,"multiCursorMergeOverlapping",!0,{description:l.localize(273,null)})),multiCursorModifier:ze(new o(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],le,{markdownEnumDescriptions:[l.localize(274,null),l.localize(275,null)],markdownDescription:l.localize(276,null)})),multiCursorPaste:ze(new i(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[l.localize(277,null),l.localize(278,null)],markdownDescription:l.localize(279,null)})),multiCursorLimit:ze(new b(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:l.localize(280,null)})),occurrencesHighlight:ze(new n(80,"occurrencesHighlight",!0,{description:l.localize(281,null)})),overviewRulerBorder:ze(new n(81,"overviewRulerBorder",!0,{description:l.localize(282,null)})),overviewRulerLanes:ze(new b(82,"overviewRulerLanes",3,0,3)),padding:ze(new we),pasteAs:ze(new Xe),parameterHints:ze(new ve),peekWidgetDefaultFocus:ze(new i(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[l.localize(283,null),l.localize(284,null)],description:l.localize(285,null)})),definitionLinkOpensInPeek:ze(new n(87,"definitionLinkOpensInPeek",!1,{description:l.localize(286,null)})),quickSuggestions:ze(new De),quickSuggestionsDelay:ze(new b(89,"quickSuggestionsDelay",10,0,1073741824,{description:l.localize(287,null)})),readOnly:ze(new n(90,"readOnly",!1)),readOnlyMessage:ze(new de),renameOnType:ze(new n(92,"renameOnType",!1,{description:l.localize(288,null),markdownDeprecationMessage:l.localize(289,null)})),renderControlCharacters:ze(new n(93,"renderControlCharacters",!0,{description:l.localize(290,null),restricted:!0})),renderFinalNewline:ze(new i(94,"renderFinalNewline",C.$l?"dimmed":"on",["off","on","dimmed"],{description:l.localize(291,null)})),renderLineHighlight:ze(new i(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",l.localize(292,null)],description:l.localize(293,null)})),renderLineHighlightOnlyWhenFocus:ze(new n(96,"renderLineHighlightOnlyWhenFocus",!1,{description:l.localize(294,null)})),renderValidationDecorations:ze(new i(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ze(new i(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",l.localize(295,null),l.localize(296,null),l.localize(297,null),""],description:l.localize(298,null)})),revealHorizontalRightPadding:ze(new b(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:ze(new n(100,"roundedSelection",!0,{description:l.localize(299,null)})),rulers:ze(new oe),scrollbar:ze(new T),scrollBeyondLastColumn:ze(new b(103,"scrollBeyondLastColumn",4,0,1073741824,{description:l.localize(300,null)})),scrollBeyondLastLine:ze(new n(104,"scrollBeyondLastLine",!0,{description:l.localize(301,null)})),scrollPredominantAxis:ze(new n(105,"scrollPredominantAxis",!0,{description:l.localize(302,null)})),selectionClipboard:ze(new n(106,"selectionClipboard",!0,{description:l.localize(303,null),included:C.$l})),selectionHighlight:ze(new n(107,"selectionHighlight",!0,{description:l.localize(304,null)})),selectOnLineNumbers:ze(new n(108,"selectOnLineNumbers",!0)),showFoldingControls:ze(new i(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[l.localize(305,null),l.localize(306,null),l.localize(307,null)],description:l.localize(308,null)})),showUnused:ze(new n(110,"showUnused",!0,{description:l.localize(309,null)})),showDeprecated:ze(new n(138,"showDeprecated",!0,{description:l.localize(310,null)})),inlayHints:ze(new $e),snippetSuggestions:ze(new i(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[l.localize(311,null),l.localize(312,null),l.localize(313,null),l.localize(314,null)],description:l.localize(315,null)})),smartSelect:ze(new Fe),smoothScrolling:ze(new n(113,"smoothScrolling",!1,{description:l.localize(316,null)})),stopRenderingLineAfter:ze(new b(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ze(new ce),inlineSuggest:ze(new J),inlineCompletionsAccessibilityVerbose:ze(new n(147,"inlineCompletionsAccessibilityVerbose",!1,{description:l.localize(317,null)})),suggestFontSize:ze(new b(118,"suggestFontSize",0,0,1e3,{markdownDescription:l.localize(318,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:ze(new b(119,"suggestLineHeight",0,0,1e3,{markdownDescription:l.localize(319,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:ze(new n(120,"suggestOnTriggerCharacters",!0,{description:l.localize(320,null)})),suggestSelection:ze(new i(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[l.localize(321,null),l.localize(322,null),l.localize(323,null)],description:l.localize(324,null)})),tabCompletion:ze(new i(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[l.localize(325,null),l.localize(326,null),l.localize(327,null)],description:l.localize(328,null)})),tabIndex:ze(new b(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:ze(new q),unusualLineTerminators:ze(new i(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[l.localize(329,null),l.localize(330,null),l.localize(331,null)],description:l.localize(332,null)})),useShadowDOM:ze(new n(126,"useShadowDOM",!0)),useTabStops:ze(new n(127,"useTabStops",!0,{description:l.localize(333,null)})),wordBreak:ze(new i(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[l.localize(334,null),l.localize(335,null)],description:l.localize(336,null)})),wordSeparators:ze(new r(129,"wordSeparators",A.$Zr,{description:l.localize(337,null)})),wordWrap:ze(new i(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[l.localize(338,null),l.localize(339,null),l.localize(340,null),l.localize(341,null)],description:l.localize(342,null)})),wordWrapBreakAfterCharacters:ze(new r(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ze(new r(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ze(new b(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:l.localize(343,null)})),wordWrapOverride1:ze(new i(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ze(new i(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:ze(new W),defaultColorDecorators:ze(new n(145,"defaultColorDecorators",!1,{markdownDescription:l.localize(344,null)})),pixelRatio:ze(new me),tabFocusMode:ze(new n(142,"tabFocusMode",!1,{markdownDescription:l.localize(345,null)})),layoutInfo:ze(new X),wrappingInfo:ze(new Ge),wrappingIndent:ze(new Qe),wrappingStrategy:ze(new ae)}}),define(Re[137],Me([10,11]),function(be,e){return be.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Re[138],Me([10,11]),function(be,e){return be.create("vs/platform/contextkey/common/contextkey",e)}),define(Re[139],Me([10,11]),function(be,e){return be.create("vs/platform/contextkey/common/scanner",e)}),define(Re[140],Me([10,11]),function(be,e){return be.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Re[141],Me([10,11]),function(be,e){return be.create("vs/platform/extensions/common/extensionValidator",e)}),define(Re[142],Me([10,11]),function(be,e){return be.create("vs/platform/files/common/files",e)}),define(Re[143],Me([10,11]),function(be,e){return be.create("vs/platform/markers/common/markers",e)}),define(Re[144],Me([10,11]),function(be,e){return be.create("vs/platform/theme/common/iconRegistry",e)}),define(Re[145],Me([10,11]),function(be,e){return be.create("vs/platform/workspace/common/workspace",e)}),define(Re[146],Me([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostChat",e)}),define(Re[147],Me([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Re[148],Me([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Re[149],Me([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Re[150],Me([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostLogService",e)}),define(Re[151],Me([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostNotebook",e)}),define(Re[152],Me([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostProgress",e)}),define(Re[153],Me([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Re[154],Me([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Re[155],Me([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Re[156],Me([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Re[157],Me([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Re[158],Me([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Re[159],Me([10,11]),function(be,e){return be.create("vs/workbench/common/editor",e)}),define(Re[160],Me([10,11]),function(be,e){return be.create("vs/workbench/common/views",e)}),define(Re[161],Me([10,11]),function(be,e){return be.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Re[162],Me([10,11]),function(be,e){return be.create("vs/workbench/contrib/debug/common/debug",e)}),define(Re[163],Me([10,11]),function(be,e){return be.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Re[164],Me([10,11]),function(be,e){return be.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Re[165],Me([10,11]),function(be,e){return be.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Re[166],Me([10,11]),function(be,e){return be.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Re[167],Me([10,11]),function(be,e){return be.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Re[168],Me([1,0,9,139]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=e.TokenType=void 0;var C;(function(f){f[f.LParen=0]="LParen",f[f.RParen=1]="RParen",f[f.Neg=2]="Neg",f[f.Eq=3]="Eq",f[f.NotEq=4]="NotEq",f[f.Lt=5]="Lt",f[f.LtEq=6]="LtEq",f[f.Gt=7]="Gt",f[f.GtEq=8]="GtEq",f[f.RegexOp=9]="RegexOp",f[f.RegexStr=10]="RegexStr",f[f.True=11]="True",f[f.False=12]="False",f[f.In=13]="In",f[f.Not=14]="Not",f[f.And=15]="And",f[f.Or=16]="Or",f[f.Str=17]="Str",f[f.QuotedStr=18]="QuotedStr",f[f.Error=19]="Error",f[f.EOF=20]="EOF"})(C||(e.TokenType=C={}));function F(...f){switch(f.length){case 1:return(0,M.localize)(0,null,f[0]);case 2:return(0,M.localize)(1,null,f[0],f[1]);case 3:return(0,M.localize)(2,null,f[0],f[1],f[2]);default:return}}const A=(0,M.localize)(3,null),l=(0,M.localize)(4,null);class k{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(R){switch(R.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return R.isTripleEq?"===":"==";case 4:return R.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return R.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return R.lexeme;case 18:return R.lexeme;case 19:return R.lexeme;case 20:return"EOF";default:throw(0,w.$7)(`unhandled token type: ${JSON.stringify(R)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(R=>R.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(R){return this.c=R,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const D=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:D})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const D=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:D})}else this.h(126)?this.k(9):this.l(F("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(F("&&"));break;case 124:this.h(124)?this.k(16):this.l(F("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(R){return this.r()||this.c.charCodeAt(this.e)!==R?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(R){this.f.push({type:R,offset:this.d})}l(R){const D=this.d,c=this.c.substring(this.d,this.e),p={type:19,offset:this.d,lexeme:c};this.g.push({offset:D,lexeme:c,additionalInfo:R}),this.f.push(p)}n(){this.m.lastIndex=this.d;const R=this.m.exec(this.c);if(R){this.e=this.d+R[0].length;const D=this.c.substring(this.d,this.e),c=k.b.get(D);c?this.k(c):this.f.push({type:17,lexeme:D,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let R=this.e,D=!1,c=!1;for(;;){if(R>=this.c.length){this.e=R,this.l(l);return}const $=this.c.charCodeAt(R);if(D)D=!1;else if($===47&&!c){R++;break}else $===91?c=!0:$===92?D=!0:$===93&&(c=!1);R++}for(;R<this.c.length&&k.a.has(this.c.charCodeAt(R));)R++;this.e=R;const p=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:p,offset:this.d})}r(){return this.e>=this.c.length}}e.$Ii=k}),define(Re[169],Me([1,0,23,29,141,276]),function(be,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,l=/^-(\d{4})(\d{2})(\d{2})$/;function k(n){return n=n.trim(),n==="*"||A.test(n)}e.$Ho=k;function f(n){if(!k(n))return null;if(n=n.trim(),n==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const a=n.match(A);return a?{hasCaret:a[1]==="^",hasGreaterEquals:a[1]===">=",majorBase:a[2]==="x"?0:parseInt(a[2],10),majorMustEqual:a[2]!=="x",minorBase:a[4]==="x"?0:parseInt(a[4],10),minorMustEqual:a[4]!=="x",patchBase:a[6]==="x"?0:parseInt(a[6],10),patchMustEqual:a[6]!=="x",preRelease:a[8]||null}:null}e.$Io=f;function R(n){if(!n)return null;const a=n.majorBase,b=n.majorMustEqual,E=n.minorBase;let v=n.minorMustEqual;const r=n.patchBase;let s=n.patchMustEqual;n.hasCaret&&(a===0||(v=!1),s=!1);let i=0;if(n.preRelease){const o=l.exec(n.preRelease);if(o){const[,y,d,I]=o;i=Date.UTC(Number(y),Number(d)-1,Number(I))}}return{majorBase:a,majorMustEqual:b,minorBase:E,minorMustEqual:v,patchBase:r,patchMustEqual:s,isMinimum:n.hasGreaterEquals,notBefore:i}}e.$Jo=R;function D(n,a,b){let E;typeof n=="string"?E=R(f(n)):E=n;let v;a instanceof Date?v=a.getTime():typeof a=="string"&&(v=new Date(a).getTime());let r;if(typeof b=="string"?r=R(f(b)):r=b,!E||!r)return!1;const s=E.majorBase,i=E.minorBase,o=E.patchBase;let y=r.majorBase,d=r.minorBase,I=r.patchBase;const S=r.notBefore;let u=r.majorMustEqual,m=r.minorMustEqual,h=r.patchMustEqual;return r.isMinimum?s>y?!0:s<y?!1:i>d?!0:i<d||v&&v<S?!1:o>=I:(s===1&&y===0&&(!u||!m||!h)&&(y=1,d=0,I=0,u=!0,m=!1,h=!1),s<y?!1:s>y?!u:i<d?!1:i>d?!m:o<I?!1:o>I?!h:!(v&&v<S))}e.$Ko=D;function c(n,a,b,E,v){const r=[];if(typeof E.publisher<"u"&&typeof E.publisher!="string")return r.push([M.default.Error,C.localize(0,null)]),r;if(typeof E.name!="string")return r.push([M.default.Error,C.localize(1,null,"name")]),r;if(typeof E.version!="string")return r.push([M.default.Error,C.localize(2,null,"version")]),r;if(!E.engines)return r.push([M.default.Error,C.localize(3,null,"engines")]),r;if(typeof E.engines.vscode!="string")return r.push([M.default.Error,C.localize(4,null,"engines.vscode")]),r;if(typeof E.extensionDependencies<"u"&&!t(E.extensionDependencies))return r.push([M.default.Error,C.localize(5,null,"extensionDependencies")]),r;if(typeof E.activationEvents<"u"){if(!t(E.activationEvents))return r.push([M.default.Error,C.localize(6,null,"activationEvents")]),r;if(typeof E.main>"u"&&typeof E.browser>"u")return r.push([M.default.Error,C.localize(7,null,"activationEvents","main","browser")]),r}if(typeof E.extensionKind<"u"&&typeof E.main>"u"&&r.push([M.default.Warning,C.localize(8,null,"extensionKind")]),typeof E.main<"u"){if(typeof E.main!="string")return r.push([M.default.Error,C.localize(9,null,"main")]),r;{const o=(0,w.$ug)(b,E.main);(0,w.$og)(o,b)||r.push([M.default.Warning,C.localize(10,null,o.path,b.path)])}}if(typeof E.browser<"u"){if(typeof E.browser!="string")return r.push([M.default.Error,C.localize(11,null,"browser")]),r;{const o=(0,w.$ug)(b,E.browser);(0,w.$og)(o,b)||r.push([M.default.Warning,C.localize(12,null,o.path,b.path)])}}if(!F.valid(E.version))return r.push([M.default.Error,C.localize(13,null)]),r;const s=[];if(!p(n,a,E,v,s))for(const o of s)r.push([M.default.Error,o]);return r}e.$Lo=c;function p(n,a,b,E,v){return E||typeof b.main>"u"&&typeof b.browser>"u"?!0:g(n,a,b.engines.vscode,v)}e.$Mo=p;function $(n,a,b){return n==="*"||g(a,b,n)}e.$No=$;function g(n,a,b,E=[]){const v=R(f(b));if(!v)return E.push(C.localize(14,null,b)),!1;if(v.majorBase===0){if(!v.majorMustEqual||!v.minorMustEqual)return E.push(C.localize(15,null,b)),!1}else if(!v.majorMustEqual)return E.push(C.localize(16,null,b)),!1;return D(n,a,v)?!0:(E.push(C.localize(17,null,n,b)),!1)}function t(n){if(!Array.isArray(n))return!1;for(let a=0,b=n.length;a<b;a++)if(typeof n[a]!="string")return!1;return!0}}),define(Re[68],Me([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kh=void 0;class w{constructor(C,F=[],A=!1){this.ctor=C,this.staticArguments=F,this.supportsDelayedInstantiation=A}}e.$Kh=w}),define(Re[69],Me([1,0,68]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tr=e.$sr=e.InstantiationType=void 0;const M=[];var C;(function(l){l[l.Eager=0]="Eager",l[l.Delayed=1]="Delayed"})(C||(e.InstantiationType=C={}));function F(l,k,f){k instanceof w.$Kh||(k=new w.$Kh(k,[],!!f)),M.push([l,k])}e.$sr=F;function A(){return M}e.$tr=A}),define(Re[170],Me([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$p=e.$0p=void 0;class w{constructor(F,A){this.key=F,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$0p=w;class M{constructor(F){this.b=F,this.a=new Map}roots(){const F=[];for(const A of this.a.values())A.outgoing.size===0&&F.push(A);return F}insertEdge(F,A){const l=this.lookupOrInsertNode(F),k=this.lookupOrInsertNode(A);l.outgoing.set(k.key,k),k.incoming.set(l.key,l)}removeNode(F){const A=this.b(F);this.a.delete(A);for(const l of this.a.values())l.outgoing.delete(A),l.incoming.delete(A)}lookupOrInsertNode(F){const A=this.b(F);let l=this.a.get(A);return l||(l=new w(A,F),this.a.set(A,l)),l}lookup(F){return this.a.get(this.b(F))}isEmpty(){return this.a.size===0}toString(){const F=[];for(const[A,l]of this.a)F.push(`${A}
	(-> incoming)[${[...l.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...l.outgoing.keys()].join(",")}]
`);return F.join(`
`)}findCycleSlow(){for(const[F,A]of this.a){const l=new Set([F]),k=this.c(A,l);if(k)return k}}c(F,A){for(const[l,k]of F.outgoing){if(A.has(l))return[...A,l].join(" -> ");A.add(l);const f=this.c(k,A);if(f)return f;A.delete(l)}}}e.$$p=M}),define(Re[4],Me([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oh=e.$Nh=e.$Mh=e._util=void 0;var w;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function l(k){return k[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=l})(w||(e._util=w={})),e.$Mh=C("instantiationService");function M(A,l,k){l[w.DI_TARGET]===l?l[w.DI_DEPENDENCIES].push({id:A,index:k}):(l[w.DI_DEPENDENCIES]=[{id:A,index:k}],l[w.DI_TARGET]=l)}function C(A){if(w.serviceIds.has(A))return w.serviceIds.get(A);const l=function(k,f,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");M(l,k,R)};return l.toString=()=>A,w.serviceIds.set(A,l),l}e.$Nh=C;function F(A){return A}e.$Oh=F}),define(Re[43],Me([1,0,16,2,4]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.ConfigurationTarget=e.$ji=e.$ii=e.$hi=void 0,e.$hi=(0,C.$Nh)("configurationService");function F(n){return n&&typeof n=="object"&&(!n.overrideIdentifier||typeof n.overrideIdentifier=="string")&&(!n.resource||n.resource instanceof M.URI)}e.$ii=F;function A(n){return n&&typeof n=="object"&&(!n.overrideIdentifiers||Array.isArray(n.overrideIdentifiers))&&!n.overrideIdentifier&&(!n.resource||n.resource instanceof M.URI)}e.$ji=A;var l;(function(n){n[n.APPLICATION=1]="APPLICATION",n[n.USER=2]="USER",n[n.USER_LOCAL=3]="USER_LOCAL",n[n.USER_REMOTE=4]="USER_REMOTE",n[n.WORKSPACE=5]="WORKSPACE",n[n.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",n[n.DEFAULT=7]="DEFAULT",n[n.MEMORY=8]="MEMORY"})(l||(e.ConfigurationTarget=l={}));function k(n){switch(n){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$ki=k;function f(n){return n.applicationValue!==void 0||n.userValue!==void 0||n.userLocalValue!==void 0||n.userRemoteValue!==void 0||n.workspaceValue!==void 0||n.workspaceFolderValue!==void 0}e.$li=f;function R(n,a){const b=Object.create(null);for(const E in n)D(b,E,n[E],a);return b}e.$mi=R;function D(n,a,b,E){const v=a.split("."),r=v.pop();let s=n;for(let i=0;i<v.length;i++){const o=v[i];let y=s[o];switch(typeof y){case"undefined":y=s[o]=Object.create(null);break;case"object":break;default:E(`Ignoring ${a} as ${v.slice(0,i+1).join(".")} is ${JSON.stringify(y)}`);return}s=y}if(typeof s=="object"&&s!==null)try{s[r]=b}catch{E(`Ignoring ${a} as ${v.join(".")} is ${JSON.stringify(s)}`)}else E(`Ignoring ${a} as ${v.join(".")} is ${JSON.stringify(s)}`)}e.$ni=D;function c(n,a){const b=a.split(".");p(n,b)}e.$oi=c;function p(n,a){const b=a.shift();if(a.length===0){delete n[b];return}if(Object.keys(n).indexOf(b)!==-1){const E=n[b];typeof E=="object"&&!Array.isArray(E)&&(p(E,a),Object.keys(E).length===0&&delete n[b])}}function $(n,a,b){function E(s,i){let o=s;for(const y of i){if(typeof o!="object"||o===null)return;o=o[y]}return o}const v=a.split("."),r=E(n,v);return typeof r>"u"?b:r}e.$pi=$;function g(n,a,b){Object.keys(a).forEach(E=>{E!=="__proto__"&&(E in n?w.$zf(n[E])&&w.$zf(a[E])?g(n[E],a[E],b):b&&(n[E]=a[E]):n[E]=a[E])})}e.$qi=g;function t(n){return n.replace(/[\[\]]/g,"")}e.$ri=t}),define(Re[32],Me([1,0,22,15,168,4,138,9]),function(be,e,w,M,C,F,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.ContextKeyExprType=e.$Ji=void 0;const k=new Map;k.set("false",!1),k.set("true",!0),k.set("isMac",w.$k),k.set("isLinux",w.$l),k.set("isWindows",w.$j),k.set("isWeb",w.$p),k.set("isMacNative",w.$k&&!w.$p),k.set("isEdge",w.$H),k.set("isFirefox",w.$F),k.set("isChrome",w.$E),k.set("isSafari",w.$G);function f(ie,z){if(k.get(ie)!==void 0)throw(0,l.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");k.set(ie,z)}e.$Ji=f;const R=Object.prototype.hasOwnProperty;var D;(function(ie){ie[ie.False=0]="False",ie[ie.True=1]="True",ie[ie.Defined=2]="Defined",ie[ie.Not=3]="Not",ie[ie.Equals=4]="Equals",ie[ie.NotEquals=5]="NotEquals",ie[ie.And=6]="And",ie[ie.Regex=7]="Regex",ie[ie.NotRegex=8]="NotRegex",ie[ie.Or=9]="Or",ie[ie.In=10]="In",ie[ie.NotIn=11]="NotIn",ie[ie.Greater=12]="Greater",ie[ie.GreaterEquals=13]="GreaterEquals",ie[ie.Smaller=14]="Smaller",ie[ie.SmallerEquals=15]="SmallerEquals"})(D||(e.ContextKeyExprType=D={}));const c={regexParsingWithErrorRecovery:!0},p=(0,A.localize)(0,null),$=(0,A.localize)(1,null),g=(0,A.localize)(2,null),t=(0,A.localize)(3,null),n=(0,A.localize)(4,null),a=(0,A.localize)(5,null),b=(0,A.localize)(6,null),E=(0,A.localize)(7,null);class v{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(z=c){this.k=z,this.d=new C.$Ii,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(z){if(z===""){this.h.push({message:p,offset:0,lexeme:"",additionalInfo:$});return}this.f=this.d.reset(z).scan(),this.g=0,this.h=[];try{const V=this.l();if(!this.E()){const le=this.D(),we=le.type===17?a:void 0;throw this.h.push({message:n,offset:le.offset,lexeme:C.$Ii.getLexeme(le),additionalInfo:we}),v.c}return V}catch(V){if(V!==v.c)throw V;return}}l(){return this.m()}m(){const z=[this.o()];for(;this.y(16);){const V=this.o();z.push(V)}return z.length===1?z[0]:r.or(...z)}o(){const z=[this.s()];for(;this.y(15);){const V=this.s();z.push(V)}return z.length===1?z[0]:r.and(...z)}s(){if(this.y(2)){const z=this.D();switch(z.type){case 11:return this.z(),y.INSTANCE;case 12:return this.z(),d.INSTANCE;case 0:{this.z();const V=this.l();return this.A(1,t),V?.negate()}case 17:return this.z(),P.create(z.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",z)}}return this.t()}t(){const z=this.D();switch(z.type){case 11:return this.z(),r.true();case 12:return this.z(),r.false();case 0:{this.z();const V=this.l();return this.A(1,t),V}case 17:{const V=z.lexeme;if(this.z(),this.y(9)){const we=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),we.type!==10)throw this.B("REGEX",we);const ve=we.lexeme,me=ve.lastIndexOf("/"),De=me===ve.length-1?void 0:this.w(ve.substring(me+1));let re;try{re=new RegExp(ve.substring(1,me),De)}catch{throw this.B("REGEX",we)}return N.create(V,re)}switch(we.type){case 10:case 19:{const ve=[we.lexeme];this.z();let me=this.D(),De=0;for(let de=0;de<we.lexeme.length;de++)we.lexeme.charCodeAt(de)===40?De++:we.lexeme.charCodeAt(de)===41&&De--;for(;!this.E()&&me.type!==15&&me.type!==16;){switch(me.type){case 0:De++;break;case 1:De--;break;case 10:case 18:for(let de=0;de<me.lexeme.length;de++)me.lexeme.charCodeAt(de)===40?De++:we.lexeme.charCodeAt(de)===41&&De--}if(De<0)break;ve.push(C.$Ii.getLexeme(me)),this.z(),me=this.D()}const re=ve.join(""),he=re.lastIndexOf("/"),se=he===re.length-1?void 0:this.w(re.substring(he+1));let oe;try{oe=new RegExp(re.substring(1,he),se)}catch{throw this.B("REGEX",we)}return r.regex(V,oe)}case 18:{const ve=we.lexeme;this.z();let me=null;if(!(0,M.$Ae)(ve)){const De=ve.indexOf("/"),re=ve.lastIndexOf("/");if(De!==re&&De>=0){const he=ve.slice(De+1,re),se=ve[re+1]==="i"?"i":"";try{me=new RegExp(he,se)}catch{throw this.B("REGEX",we)}}}if(me===null)throw this.B("REGEX",we);return N.create(V,me)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,g);const we=this.u();return r.notIn(V,we)}switch(this.D().type){case 3:{this.z();const we=this.u();if(this.x().type===18)return r.equals(V,we);switch(we){case"true":return r.has(V);case"false":return r.not(V);default:return r.equals(V,we)}}case 4:{this.z();const we=this.u();if(this.x().type===18)return r.notEquals(V,we);switch(we){case"true":return r.not(V);case"false":return r.has(V);default:return r.notEquals(V,we)}}case 5:return this.z(),B.create(V,this.u());case 6:return this.z(),O.create(V,this.u());case 7:return this.z(),K.create(V,this.u());case 8:return this.z(),U.create(V,this.u());case 13:return this.z(),r.in(V,this.u());default:return r.has(V)}}case 20:throw this.h.push({message:b,offset:z.offset,lexeme:"",additionalInfo:E}),v.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const z=this.D();switch(z.type){case 17:case 18:return this.z(),z.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(z){return z.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(z){return this.C(z)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(z,V){if(this.C(z))return this.z();throw this.B(V,this.D())}B(z,V,le){const we=(0,A.localize)(8,null,z,C.$Ii.getLexeme(V)),ve=V.offset,me=C.$Ii.getLexeme(V);return this.h.push({message:we,offset:ve,lexeme:me,additionalInfo:le}),v.c}C(z){return this.D().type===z}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Ki=v;class r{static false(){return y.INSTANCE}static true(){return d.INSTANCE}static has(z){return I.create(z)}static equals(z,V){return S.create(z,V)}static notEquals(z,V){return h.create(z,V)}static regex(z,V){return N.create(z,V)}static in(z,V){return u.create(z,V)}static notIn(z,V){return m.create(z,V)}static not(z){return P.create(z)}static and(...z){return ye.create(z,null,!0)}static or(...z){return Ee.create(z,null,!0)}static greater(z,V){return K.create(z,V)}static greaterEquals(z,V){return U.create(z,V)}static smaller(z,V){return B.create(z,V)}static smallerEquals(z,V){return O.create(z,V)}static{this.c=new v({regexParsingWithErrorRecovery:!1})}static deserialize(z){return z==null?void 0:this.c.parse(z)}}e.$Li=r;function s(ie){const z=new v({regexParsingWithErrorRecovery:!1});return ie.map(V=>(z.parse(V),z.lexingErrors.length>0?z.lexingErrors.map(le=>({errorMessage:le.additionalInfo?(0,A.localize)(9,null,le.additionalInfo):(0,A.localize)(10,null),offset:le.offset,length:le.lexeme.length})):z.parsingErrors.length>0?z.parsingErrors.map(le=>({errorMessage:le.additionalInfo?`${le.message}. ${le.additionalInfo}`:le.message,offset:le.offset,length:le.lexeme.length})):[]))}e.$Mi=s;function i(ie,z){const V=ie?ie.substituteConstants():void 0,le=z?z.substituteConstants():void 0;return!V&&!le?!0:!V||!le?!1:V.equals(le)}e.$Ni=i;function o(ie,z){return ie.cmp(z)}class y{static{this.INSTANCE=new y}constructor(){this.type=0}cmp(z){return this.type-z.type}equals(z){return z.type===this.type}substituteConstants(){return this}evaluate(z){return!1}serialize(){return"false"}keys(){return[]}map(z){return this}negate(){return d.INSTANCE}}e.$Oi=y;class d{static{this.INSTANCE=new d}constructor(){this.type=1}cmp(z){return this.type-z.type}equals(z){return z.type===this.type}substituteConstants(){return this}evaluate(z){return!0}serialize(){return"true"}keys(){return[]}map(z){return this}negate(){return y.INSTANCE}}e.$Pi=d;class I{static create(z,V=null){const le=k.get(z);return typeof le=="boolean"?le?d.INSTANCE:y.INSTANCE:new I(z,V)}constructor(z,V){this.key=z,this.c=V,this.type=2}cmp(z){return z.type!==this.type?this.type-z.type:X(this.key,z.key)}equals(z){return z.type===this.type?this.key===z.key:!1}substituteConstants(){const z=k.get(this.key);return typeof z=="boolean"?z?d.INSTANCE:y.INSTANCE:this}evaluate(z){return!!z.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(z){return z.mapDefined(this.key)}negate(){return this.c||(this.c=P.create(this.key,this)),this.c}}e.$Qi=I;class S{static create(z,V,le=null){if(typeof V=="boolean")return V?I.create(z,le):P.create(z,le);const we=k.get(z);return typeof we=="boolean"?V===(we?"true":"false")?d.INSTANCE:y.INSTANCE:new S(z,V,le)}constructor(z,V,le){this.c=z,this.d=V,this.f=le,this.type=4}cmp(z){return z.type!==this.type?this.type-z.type:ae(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){const z=k.get(this.c);if(typeof z=="boolean"){const V=z?"true":"false";return this.d===V?d.INSTANCE:y.INSTANCE}return this}evaluate(z){return z.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(z){return z.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=h.create(this.c,this.d,this)),this.f}}e.$Ri=S;class u{static create(z,V){return new u(z,V)}constructor(z,V){this.d=z,this.f=V,this.type=10,this.c=null}cmp(z){return z.type!==this.type?this.type-z.type:ae(this.d,this.f,z.d,z.f)}equals(z){return z.type===this.type?this.d===z.d&&this.f===z.f:!1}substituteConstants(){return this}evaluate(z){const V=z.getValue(this.f),le=z.getValue(this.d);return Array.isArray(V)?V.includes(le):typeof le=="string"&&typeof V=="object"&&V!==null?R.call(V,le):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(z){return z.mapIn(this.d,this.f)}negate(){return this.c||(this.c=m.create(this.d,this.f)),this.c}}e.$Si=u;class m{static create(z,V){return new m(z,V)}constructor(z,V){this.d=z,this.f=V,this.type=11,this.c=u.create(z,V)}cmp(z){return z.type!==this.type?this.type-z.type:this.c.cmp(z.c)}equals(z){return z.type===this.type?this.c.equals(z.c):!1}substituteConstants(){return this}evaluate(z){return!this.c.evaluate(z)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(z){return z.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Ti=m;class h{static create(z,V,le=null){if(typeof V=="boolean")return V?P.create(z,le):I.create(z,le);const we=k.get(z);return typeof we=="boolean"?V===(we?"true":"false")?y.INSTANCE:d.INSTANCE:new h(z,V,le)}constructor(z,V,le){this.c=z,this.d=V,this.f=le,this.type=5}cmp(z){return z.type!==this.type?this.type-z.type:ae(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){const z=k.get(this.c);if(typeof z=="boolean"){const V=z?"true":"false";return this.d===V?y.INSTANCE:d.INSTANCE}return this}evaluate(z){return z.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(z){return z.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=S.create(this.c,this.d,this)),this.f}}e.$Ui=h;class P{static create(z,V=null){const le=k.get(z);return typeof le=="boolean"?le?y.INSTANCE:d.INSTANCE:new P(z,V)}constructor(z,V){this.c=z,this.d=V,this.type=3}cmp(z){return z.type!==this.type?this.type-z.type:X(this.c,z.c)}equals(z){return z.type===this.type?this.c===z.c:!1}substituteConstants(){const z=k.get(this.c);return typeof z=="boolean"?z?y.INSTANCE:d.INSTANCE:this}evaluate(z){return!z.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(z){return z.mapNot(this.c)}negate(){return this.d||(this.d=I.create(this.c,this)),this.d}}e.$Vi=P;function W(ie,z){if(typeof ie=="string"){const V=parseFloat(ie);isNaN(V)||(ie=V)}return typeof ie=="string"||typeof ie=="number"?z(ie):y.INSTANCE}class K{static create(z,V,le=null){return W(V,we=>new K(z,we,le))}constructor(z,V,le){this.c=z,this.d=V,this.f=le,this.type=12}cmp(z){return z.type!==this.type?this.type-z.type:ae(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(z){return z.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$Wi=K;class U{static create(z,V,le=null){return W(V,we=>new U(z,we,le))}constructor(z,V,le){this.c=z,this.d=V,this.f=le,this.type=13}cmp(z){return z.type!==this.type?this.type-z.type:ae(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(z){return z.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=B.create(this.c,this.d,this)),this.f}}e.$Xi=U;class B{static create(z,V,le=null){return W(V,we=>new B(z,we,le))}constructor(z,V,le){this.c=z,this.d=V,this.f=le,this.type=14}cmp(z){return z.type!==this.type?this.type-z.type:ae(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(z){return z.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$Yi=B;class O{static create(z,V,le=null){return W(V,we=>new O(z,we,le))}constructor(z,V,le){this.c=z,this.d=V,this.f=le,this.type=15}cmp(z){return z.type!==this.type?this.type-z.type:ae(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(z){return z.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=K.create(this.c,this.d,this)),this.f}}e.$Zi=O;class N{static create(z,V){return new N(z,V)}constructor(z,V){this.d=z,this.f=V,this.type=7,this.c=null}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.d<z.d)return-1;if(this.d>z.d)return 1;const V=this.f?this.f.source:"",le=z.f?z.f.source:"";return V<le?-1:V>le?1:0}equals(z){if(z.type===this.type){const V=this.f?this.f.source:"",le=z.f?z.f.source:"";return this.d===z.d&&V===le}return!1}substituteConstants(){return this}evaluate(z){const V=z.getValue(this.d);return this.f?this.f.test(V):!1}serialize(){const z=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${z}`}keys(){return[this.d]}map(z){return z.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=te.create(this)),this.c}}e.$1i=N;class te{static create(z){return new te(z)}constructor(z){this.c=z,this.type=8}cmp(z){return z.type!==this.type?this.type-z.type:this.c.cmp(z.c)}equals(z){return z.type===this.type?this.c.equals(z.c):!1}substituteConstants(){return this}evaluate(z){return!this.c.evaluate(z)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(z){return new te(this.c.map(z))}negate(){return this.c}}e.$2i=te;function Y(ie){let z=null;for(let V=0,le=ie.length;V<le;V++){const we=ie[V].substituteConstants();if(ie[V]!==we&&z===null){z=[];for(let ve=0;ve<V;ve++)z[ve]=ie[ve]}z!==null&&(z[V]=we)}return z===null?ie:z}class ye{static create(z,V,le){return ye.d(z,V,le)}constructor(z,V){this.expr=z,this.c=V,this.type=6}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.expr.length<z.expr.length)return-1;if(this.expr.length>z.expr.length)return 1;for(let V=0,le=this.expr.length;V<le;V++){const we=o(this.expr[V],z.expr[V]);if(we!==0)return we}return 0}equals(z){if(z.type===this.type){if(this.expr.length!==z.expr.length)return!1;for(let V=0,le=this.expr.length;V<le;V++)if(!this.expr[V].equals(z.expr[V]))return!1;return!0}return!1}substituteConstants(){const z=Y(this.expr);return z===this.expr?this:ye.create(z,this.c,!1)}evaluate(z){for(let V=0,le=this.expr.length;V<le;V++)if(!this.expr[V].evaluate(z))return!1;return!0}static d(z,V,le){const we=[];let ve=!1;for(const me of z)if(me){if(me.type===1){ve=!0;continue}if(me.type===0)return y.INSTANCE;if(me.type===6){we.push(...me.expr);continue}we.push(me)}if(we.length===0&&ve)return d.INSTANCE;if(we.length!==0){if(we.length===1)return we[0];we.sort(o);for(let me=1;me<we.length;me++)we[me-1].equals(we[me])&&(we.splice(me,1),me--);if(we.length===1)return we[0];for(;we.length>1;){const me=we[we.length-1];if(me.type!==9)break;we.pop();const De=we.pop(),re=we.length===0,he=Ee.create(me.expr.map(se=>ye.create([se,De],null,le)),null,re);he&&(we.push(he),we.sort(o))}if(we.length===1)return we[0];if(le){for(let me=0;me<we.length;me++)for(let De=me+1;De<we.length;De++)if(we[me].negate().equals(we[De]))return y.INSTANCE;if(we.length===1)return we[0]}return new ye(we,V)}}serialize(){return this.expr.map(z=>z.serialize()).join(" && ")}keys(){const z=[];for(const V of this.expr)z.push(...V.keys());return z}map(z){return new ye(this.expr.map(V=>V.map(z)),null)}negate(){if(!this.c){const z=[];for(const V of this.expr)z.push(V.negate());this.c=Ee.create(z,this,!0)}return this.c}}e.$3i=ye;class Ee{static create(z,V,le){return Ee.d(z,V,le)}constructor(z,V){this.expr=z,this.c=V,this.type=9}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.expr.length<z.expr.length)return-1;if(this.expr.length>z.expr.length)return 1;for(let V=0,le=this.expr.length;V<le;V++){const we=o(this.expr[V],z.expr[V]);if(we!==0)return we}return 0}equals(z){if(z.type===this.type){if(this.expr.length!==z.expr.length)return!1;for(let V=0,le=this.expr.length;V<le;V++)if(!this.expr[V].equals(z.expr[V]))return!1;return!0}return!1}substituteConstants(){const z=Y(this.expr);return z===this.expr?this:Ee.create(z,this.c,!1)}evaluate(z){for(let V=0,le=this.expr.length;V<le;V++)if(this.expr[V].evaluate(z))return!0;return!1}static d(z,V,le){let we=[],ve=!1;if(z){for(let me=0,De=z.length;me<De;me++){const re=z[me];if(re){if(re.type===0){ve=!0;continue}if(re.type===1)return d.INSTANCE;if(re.type===9){we=we.concat(re.expr);continue}we.push(re)}}if(we.length===0&&ve)return y.INSTANCE;we.sort(o)}if(we.length!==0){if(we.length===1)return we[0];for(let me=1;me<we.length;me++)we[me-1].equals(we[me])&&(we.splice(me,1),me--);if(we.length===1)return we[0];if(le){for(let me=0;me<we.length;me++)for(let De=me+1;De<we.length;De++)if(we[me].negate().equals(we[De]))return d.INSTANCE;if(we.length===1)return we[0]}return new Ee(we,V)}}serialize(){return this.expr.map(z=>z.serialize()).join(" || ")}keys(){const z=[];for(const V of this.expr)z.push(...V.keys());return z}map(z){return new Ee(this.expr.map(V=>V.map(z)),null)}negate(){if(!this.c){const z=[];for(const V of this.expr)z.push(V.negate());for(;z.length>1;){const V=z.shift(),le=z.shift(),we=[];for(const ve of $e(V))for(const me of $e(le))we.push(ye.create([ve,me],null,!1));z.unshift(Ee.create(we,null,!1))}this.c=Ee.create(z,this,!0)}return this.c}}e.$4i=Ee;class Pe extends I{static{this.d=[]}static all(){return Pe.d.values()}constructor(z,V,le){super(z,null),this.f=V,typeof le=="object"?Pe.d.push({...le,key:z}):le!==!0&&Pe.d.push({key:z,description:le,type:V!=null?typeof V:void 0})}bindTo(z){return z.createKey(this.key,this.f)}getValue(z){return z.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(z){return S.create(this.key,z)}notEqualsTo(z){return h.create(this.key,z)}}e.$5i=Pe,e.$6i=(0,F.$Nh)("contextKeyService");function X(ie,z){return ie<z?-1:ie>z?1:0}function ae(ie,z,V,le){return ie<V?-1:ie>V?1:z<le?-1:z>le?1:0}function Se(ie,z){if(ie.type===0||z.type===1)return!0;if(ie.type===9)return z.type===9?ue(ie.expr,z.expr):!1;if(z.type===9){for(const V of z.expr)if(Se(ie,V))return!0;return!1}if(ie.type===6){if(z.type===6)return ue(z.expr,ie.expr);for(const V of ie.expr)if(Se(V,z))return!0;return!1}return ie.equals(z)}e.$7i=Se;function ue(ie,z){let V=0,le=0;for(;V<ie.length&&le<z.length;){const we=ie[V].cmp(z[le]);if(we<0)return!1;we===0&&V++,le++}return V===ie.length}function $e(ie){return ie.type===9?ie.expr:[ie]}}),define(Re[171],Me([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vh=e.$Uh=void 0,e.$Uh=(0,w.$Nh)("environmentService"),e.$Vh=(0,w.$Oh)(e.$Uh)}),define(Re[92],Me([1,0,140,4]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$6n=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=void 0,e.$Sn="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Tn=new RegExp(e.$Sn),e.$Un="__web_extension",e.$Vn="skipWalkthrough",e.$Wn="extensionsSync",e.$Xn="dependecyOrPackExtensionInstall";function C(a){switch(a){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Yn=C;function F(a){switch(a){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Zn=F;function A(a,b){switch(a){case 3:return b==="x64"?"win32-x64":b==="ia32"?"win32-ia32":b==="arm64"?"win32-arm64":"unknown";case 2:return b==="x64"?"linux-x64":b==="arm64"?"linux-arm64":b==="arm"?"linux-armhf":"unknown";case"alpine":return b==="x64"?"alpine-x64":b==="arm64"?"alpine-arm64":"unknown";case 1:return b==="x64"?"darwin-x64":b==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$1n=A;function l(a,b){return b==="web"&&!a.includes("web")}e.$2n=l;function k(a,b,E){return l(b,E)?!1:a==="undefined"||a==="universal"?!0:a==="unknown"?!1:a===E?!0:f(E).includes(a)}e.$3n=k;function f(a){switch(a){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$4n=f;function R(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(!a.uuid||typeof a.uuid=="string")}e.$5n=R;var D;(function(a){a[a.NoneOrRelevance=0]="NoneOrRelevance",a[a.LastUpdatedDate=1]="LastUpdatedDate",a[a.Title=2]="Title",a[a.PublisherName=3]="PublisherName",a[a.InstallCount=4]="InstallCount",a[a.PublishedDate=10]="PublishedDate",a[a.AverageRating=6]="AverageRating",a[a.WeightedRating=12]="WeightedRating"})(D||(e.SortBy=D={}));var c;(function(a){a[a.Default=0]="Default",a[a.Ascending=1]="Ascending",a[a.Descending=2]="Descending"})(c||(e.SortOrder=c={}));var p;(function(a){a.Install="install",a.Uninstall="uninstall"})(p||(e.StatisticType=p={}));var $;(function(a){a[a.None=1]="None",a[a.Install=2]="Install",a[a.Update=3]="Update",a[a.Migrate=4]="Migrate"})($||(e.InstallOperation=$={})),e.$6n=(0,M.$Nh)("extensionGalleryService");var g;(function(a){a.Unsupported="Unsupported",a.Deprecated="Deprecated",a.Malicious="Malicious",a.Incompatible="Incompatible",a.IncompatibleTargetPlatform="IncompatibleTargetPlatform",a.ReleaseVersionNotFound="ReleaseVersionNotFound",a.Invalid="Invalid",a.Download="Download",a.Extract="Extract",a.Delete="Delete",a.Rename="Rename",a.CorruptZip="CorruptZip",a.IncompleteZip="IncompleteZip",a.Signature="Signature",a.Internal="Internal"})(g||(e.ExtensionManagementErrorCode=g={}));var t;(function(a){a.UnknownError="UnknownError",a.PackageIsInvalidZip="PackageIsInvalidZip",a.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(t||(e.ExtensionSignaturetErrorCode=t={}));class n extends Error{constructor(b,E){super(b),this.code=E,this.name=E}}e.$7n=n,e.$8n=(0,M.$Nh)("extensionManagementService"),e.$9n="extensionsIdentifiers/disabled",e.$0n="extensionsIdentifiers/enabled",e.$$n=(0,M.$Nh)("IGlobalExtensionEnablementService"),e.$_n=(0,M.$Nh)("IExtensionTipsService"),e.$ao=(0,w.localize)(0,null),e.$bo={value:e.$ao,original:"Extensions"},e.$co={value:(0,w.localize)(1,null),original:"Preferences"}}),define(Re[38],Me([1,0,49,19,15,16,2,142,4,22,13]),function(be,e,w,M,C,F,A,l,k,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ek=e.$Dk=e.$Ck=e.$Bk=e.$Ak=e.FileKind=e.$zk=e.$yk=e.$xk=e.$wk=e.$vk=e.$uk=e.$tk=e.FileOperationResult=e.$sk=e.$rk=e.$qk=e.$pk=e.$ok=e.FileChangeType=e.$nk=e.FileOperation=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.FileSystemProviderErrorCode=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$0j=e.$9j=void 0,e.$9j=(0,k.$Nh)("fileService");function D(X){return X.create===!0}e.$0j=D;var c;(function(X){X[X.Unknown=0]="Unknown",X[X.File=1]="File",X[X.Directory=2]="Directory",X[X.SymbolicLink=64]="SymbolicLink"})(c||(e.FileType=c={}));var p;(function(X){X[X.Readonly=1]="Readonly",X[X.Locked=2]="Locked"})(p||(e.FilePermission=p={}));var $;(function(X){X[X.None=0]="None",X[X.FileReadWrite=2]="FileReadWrite",X[X.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",X[X.FileReadStream=16]="FileReadStream",X[X.FileFolderCopy=8]="FileFolderCopy",X[X.PathCaseSensitive=1024]="PathCaseSensitive",X[X.Readonly=2048]="Readonly",X[X.Trash=4096]="Trash",X[X.FileWriteUnlock=8192]="FileWriteUnlock",X[X.FileAtomicRead=16384]="FileAtomicRead",X[X.FileAtomicWrite=32768]="FileAtomicWrite",X[X.FileAtomicDelete=65536]="FileAtomicDelete",X[X.FileClone=131072]="FileClone"})($||(e.FileSystemProviderCapabilities=$={}));function g(X){return!!(X.capabilities&2)}e.$$j=g;function t(X){return!!(X.capabilities&8)}e.$_j=t;function n(X){return!!(X.capabilities&131072)}e.$ak=n;function a(X){return!!(X.capabilities&4)}e.$bk=a;function b(X){return!!(X.capabilities&16)}e.$ck=b;function E(X){return g(X)?!!(X.capabilities&16384):!1}e.$dk=E;function v(X){return g(X)?!!(X.capabilities&32768):!1}e.$ek=v;function r(X){return!!(X.capabilities&65536)}e.$fk=r;function s(X){return!!(X.capabilities&2048)}e.$gk=s;var i;(function(X){X.FileExists="EntryExists",X.FileNotFound="EntryNotFound",X.FileNotADirectory="EntryNotADirectory",X.FileIsADirectory="EntryIsADirectory",X.FileExceedsStorageQuota="EntryExceedsStorageQuota",X.FileTooLarge="EntryTooLarge",X.FileWriteLocked="EntryWriteLocked",X.NoPermissions="NoPermissions",X.Unavailable="Unavailable",X.Unknown="Unknown"})(i||(e.FileSystemProviderErrorCode=i={}));class o extends Error{static create(ae,Se){const ue=new o(ae.toString(),Se);return I(ue,Se),ue}constructor(ae,Se){super(ae),this.code=Se}}e.$hk=o;function y(X,ae){return o.create(X,ae)}e.$ik=y;function d(X){return X||y((0,l.localize)(0,null),i.Unknown)}e.$jk=d;function I(X,ae){return X.name=ae?`${ae} (FileSystemError)`:"FileSystemError",X}e.$kk=I;function S(X){if(!X)return i.Unknown;if(X instanceof o)return X.code;const ae=/^(.+) \(FileSystemError\)$/.exec(X.name);if(!ae)return i.Unknown;switch(ae[1]){case i.FileExists:return i.FileExists;case i.FileIsADirectory:return i.FileIsADirectory;case i.FileNotADirectory:return i.FileNotADirectory;case i.FileNotFound:return i.FileNotFound;case i.FileTooLarge:return i.FileTooLarge;case i.FileWriteLocked:return i.FileWriteLocked;case i.NoPermissions:return i.NoPermissions;case i.Unavailable:return i.Unavailable}return i.Unknown}e.$lk=S;function u(X){if(X instanceof U)return X.fileOperationResult;switch(S(X)){case i.FileNotFound:return 1;case i.FileIsADirectory:return 0;case i.FileNotADirectory:return 9;case i.FileWriteLocked:return 5;case i.NoPermissions:return 6;case i.FileExists:return 4;case i.FileTooLarge:return 7;default:return 10}}e.$mk=u;var m;(function(X){X[X.CREATE=0]="CREATE",X[X.DELETE=1]="DELETE",X[X.MOVE=2]="MOVE",X[X.COPY=3]="COPY",X[X.WRITE=4]="WRITE"})(m||(e.FileOperation=m={}));class h{constructor(ae,Se,ue){this.resource=ae,this.operation=Se,this.target=ue}isOperation(ae){return this.operation===ae}}e.$nk=h;var P;(function(X){X[X.UPDATED=0]="UPDATED",X[X.ADDED=1]="ADDED",X[X.DELETED=2]="DELETED"})(P||(e.FileChangeType=P={}));class W{constructor(ae,Se){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ue=new Map;for(const $e of ae){const ie=ue.get($e.type);switch(ie?ie.push([$e.resource,$e]):ue.set($e.type,[[$e.resource,$e]]),$e.type){case 1:this.rawAdded.push($e.resource);break;case 0:this.rawUpdated.push($e.resource);break;case 2:this.rawDeleted.push($e.resource);break}}for(const[$e,ie]of ue)switch($e){case 1:this.a=w.$Th.forUris(()=>Se),this.a.fill(ie);break;case 0:this.b=w.$Th.forUris(()=>Se),this.b.fill(ie);break;case 2:this.c=w.$Th.forUris(()=>Se),this.c.fill(ie);break}}contains(ae,...Se){return this.d(ae,{includeChildren:!1},...Se)}affects(ae,...Se){return this.d(ae,{includeChildren:!0},...Se)}d(ae,Se,...ue){if(!ae)return!1;const $e=ue.length>0;return!!((!$e||ue.includes(1))&&(this.a?.get(ae)||Se.includeChildren&&this.a?.findSuperstr(ae))||(!$e||ue.includes(0))&&(this.b?.get(ae)||Se.includeChildren&&this.b?.findSuperstr(ae))||(!$e||ue.includes(2))&&(this.c?.findSubstr(ae)||Se.includeChildren&&this.c?.findSuperstr(ae)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.$ok=W;function K(X,ae,Se){return!X||!ae||X===ae||ae.length>X.length?!1:(ae.charAt(ae.length-1)!==M.sep&&(ae+=M.sep),Se?(0,C.$2e)(X,ae):X.indexOf(ae)===0)}e.$pk=K;class U extends Error{constructor(ae,Se,ue){super(ae),this.fileOperationResult=Se,this.options=ue}}e.$qk=U;class B extends U{constructor(ae,Se,ue,$e){super(ae,Se,$e),this.fileOperationResult=Se,this.size=ue}}e.$rk=B;class O extends U{constructor(ae,Se,ue){super(ae,2,ue),this.stat=Se}}e.$sk=O;var N;(function(X){X[X.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",X[X.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",X[X.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",X[X.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",X[X.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",X[X.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",X[X.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",X[X.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",X[X.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",X[X.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",X[X.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(N||(e.FileOperationResult=N={})),e.$tk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$uk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$vk="files.associations",e.$wk="files.exclude",e.$xk="files.readonlyInclude",e.$yk="files.readonlyExclude",e.$zk="files.readonlyFromPermissions";var te;(function(X){X[X.FILE=0]="FILE",X[X.FOLDER=1]="FOLDER",X[X.ROOT_FOLDER=2]="ROOT_FOLDER"})(te||(e.FileKind=te={})),e.$Ak="";function Y(X){if(!(typeof X.size!="number"||typeof X.mtime!="number"))return X.mtime.toString(29)+X.size.toString(31)}e.$Bk=Y;async function ye(X,ae){if(!ae.hasProvider(A.URI.from({scheme:X.scheme})))return new Promise(Se=>{const ue=ae.onDidChangeFileSystemProviderRegistrations($e=>{$e.scheme===X.scheme&&$e.added&&(ue.dispose(),Se())})})}e.$Ck=ye;class Ee{static{this.KB=1024}static{this.MB=Ee.KB*Ee.KB}static{this.GB=Ee.MB*Ee.KB}static{this.TB=Ee.GB*Ee.KB}static formatSize(ae){return(0,F.$Bf)(ae)||(ae=0),ae<Ee.KB?(0,l.localize)(1,null,ae.toFixed(0)):ae<Ee.MB?(0,l.localize)(2,null,(ae/Ee.KB).toFixed(2)):ae<Ee.GB?(0,l.localize)(3,null,(ae/Ee.MB).toFixed(2)):ae<Ee.TB?(0,l.localize)(4,null,(ae/Ee.GB).toFixed(2)):(0,l.localize)(5,null,(ae/Ee.TB).toFixed(2))}}e.$Dk=Ee;function Pe(X){const ae=typeof X=="string"||X?.scheme===R.Schemas.vscodeRemote;return typeof X!="string"&&X?.scheme===R.Schemas.file?1024*Ee.MB:ae?10*Ee.MB:f.$p?50*Ee.MB:1024*Ee.MB}e.$Ek=Pe}),define(Re[70],Me([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lh=void 0;class w{constructor(...C){this.a=new Map;for(const[F,A]of C)this.set(F,A)}set(C,F){const A=this.a.get(C);return this.a.set(C,F),A}has(C){return this.a.has(C)}get(C){return this.a.get(C)}}e.$Lh=w}),define(Re[172],Me([1,0,12,9,6,68,170,4,70,173]),function(be,e,w,M,C,F,A,l,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aq=e.$_p=void 0;const R=!1;class D extends Error{constructor(t){super("cyclic dependency between services"),this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class c{constructor(t=new k.$Lh,n=!1,a,b=R){this.f=t,this.g=n,this.h=a,this.i=b,this.o=new Set,this.f.set(l.$Mh,this),this._globalGraph=b?a?._globalGraph??new A.$$p(E=>E):void 0}createChild(t){return new c(t,this.g,this,this.i)}invokeFunction(t,...n){const a=$.traceInvocation(this.i,t);let b=!1;try{return t({get:v=>{if(b)throw(0,M.$7)("service accessor is only valid during the invocation of its target method");const r=this.m(v,a);if(!r)throw new Error(`[invokeFunction] unknown service '${v}'`);return r}},...n)}finally{b=!0,a.stop()}}createInstance(t,...n){let a,b;return t instanceof F.$Kh?(a=$.traceCreation(this.i,t.ctor),b=this.j(t.ctor,t.staticArguments.concat(n),a)):(a=$.traceCreation(this.i,t),b=this.j(t,n,a)),a.stop(),b}j(t,n=[],a){const b=l._util.getServiceDependencies(t).sort((r,s)=>r.index-s.index),E=[];for(const r of b){const s=this.m(r.id,a);s||this.u(`[createInstance] ${t.name} depends on UNKNOWN service ${r.id}.`,!1),E.push(s)}const v=b.length>0?b[0].index:n.length;if(n.length!==v){console.trace(`[createInstance] First service dependency of ${t.name} at position ${v+1} conflicts with ${n.length} static arguments`);const r=v-n.length;r>0?n=n.concat(new Array(r)):n=n.slice(0,v)}return Reflect.construct(t,n.concat(E))}k(t,n){if(this.f.get(t)instanceof F.$Kh)this.f.set(t,n);else if(this.h)this.h.k(t,n);else throw new Error("illegalState - setting UNKNOWN service instance")}l(t){const n=this.f.get(t);return!n&&this.h?this.h.l(t):n}m(t,n){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(t));const a=this.l(t);return a instanceof F.$Kh?this.q(t,a,n.branch(t,!0)):(n.branch(t,!1),a)}q(t,n,a){if(this.o.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this.o.add(t);try{return this.r(t,n,a)}finally{this.o.delete(t)}}r(t,n,a){const b=new A.$$p(r=>r.id.toString());let E=0;const v=[{id:t,desc:n,_trace:a}];for(;v.length;){const r=v.pop();if(b.lookupOrInsertNode(r),E++>1e3)throw new D(b);for(const s of l._util.getServiceDependencies(r.desc.ctor)){const i=this.l(s.id);if(i||this.u(`[createInstance] ${t} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(r.id),String(s.id)),i instanceof F.$Kh){const o={id:s.id,desc:i,_trace:r._trace.branch(s.id,!0)};b.insertEdge(r,o),v.push(o)}}}for(;;){const r=b.roots();if(r.length===0){if(!b.isEmpty())throw new D(b);break}for(const{data:s}of r){if(this.l(s.id)instanceof F.$Kh){const o=this.s(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.k(s.id,o)}b.removeNode(s)}}return this.l(t)}s(t,n,a=[],b,E){if(this.f.get(t)instanceof F.$Kh)return this.t(t,n,a,b,E);if(this.h)return this.h.s(t,n,a,b,E);throw new Error(`illegalState - creating UNKNOWN service instance ${n.name}`)}t(t,n,a=[],b,E){if(b){const v=new c(void 0,this.g,this,this.i);v.c=String(t);const r=new Map,s=new w.$0g(()=>{const i=v.j(n,a,E);for(const[o,y]of r){const d=i[o];if(typeof d=="function")for(const I of y)d.apply(i,I)}return r.clear(),i});return new Proxy(Object.create(null),{get(i,o){if(!s.isInitialized&&typeof o=="string"&&(o.startsWith("onDid")||o.startsWith("onWill"))){let I=r.get(o);return I||(I=new f.$1c,r.set(o,I)),(u,m,h)=>{const P=I.push([u,m,h]);return(0,C.$Pc)(P)}}if(o in i)return i[o];const y=s.value;let d=y[o];return typeof d!="function"||(d=d.bind(y),i[o]=d),d},set(i,o,y){return s.value[o]=y,!0},getPrototypeOf(i){return n.prototype}})}else return this.j(n,a,E)}u(t,n){if(n&&console.warn(t),this.g)throw new Error(t)}}e.$_p=c;var p;(function(g){g[g.None=0]="None",g[g.Creation=1]="Creation",g[g.Invocation=2]="Invocation",g[g.Branch=3]="Branch"})(p||(p={}));class ${static{this.all=new Set}static{this.c=new class extends ${constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(t,n){return t?new $(2,n.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):$.c}static traceCreation(t,n){return t?new $(1,n.name):$.c}static{this.f=0}constructor(t,n){this.type=t,this.name=n,this.g=Date.now(),this.h=[]}branch(t,n){const a=new $(3,t.toString());return this.h.push([t,n,a]),a}stop(){const t=Date.now()-this.g;$.f+=t;let n=!1;function a(E,v){const r=[],s=new Array(E+1).join("	");for(const[i,o,y]of v.h)if(o&&y){n=!0,r.push(`${s}CREATES -> ${i}`);const d=a(E+1,y);d&&r.push(d)}else r.push(`${s}uses -> ${i}`);return r.join(`
`)}const b=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${a(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${$.f.toFixed(2)}ms)`];(t>2||n)&&$.all.add(b.join(`
`))}}e.$aq=$}),define(Re[14],Me([1,0,41,5,93,6,28,22,23,16,2,32,4]),function(be,e,w,M,C,F,A,l,k,f,R,D,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.log=e.$$i=e.LogLevel=e.$0i=e.$9i=e.$8i=void 0,e.$8i=(0,c.$Nh)("logService"),e.$9i=(0,c.$Nh)("loggerService");function p(){return new Date().toISOString()}function $(u){return(0,f.$Bf)(u)}e.$0i=$;var g;(function(u){u[u.Off=0]="Off",u[u.Trace=1]="Trace",u[u.Debug=2]="Debug",u[u.Info=3]="Info",u[u.Warning=4]="Warning",u[u.Error=5]="Error"})(g||(e.LogLevel=g={})),e.$$i=g.Info;function t(u,m,h){switch(m){case g.Trace:u.trace(h);break;case g.Debug:u.debug(h);break;case g.Info:u.info(h);break;case g.Warning:u.warn(h);break;case g.Error:u.error(h);break;case g.Off:break;default:throw new Error(`Invalid log level ${m}`)}}e.log=t;function n(u,m=!1){let h="";for(let P=0;P<u.length;P++){let W=u[P];if(W instanceof Error&&(W=(0,w.$yi)(W,m)),typeof W=="object")try{W=JSON.stringify(W)}catch{}h+=(P>0?" ":"")+W}return h}class a extends F.$Rc{constructor(){super(...arguments),this.b=e.$$i,this.c=this.B(new M.$Md),this.onDidChangeLogLevel=this.c.event}setLevel(m){this.b!==m&&(this.b=m,this.c.fire(this.b))}getLevel(){return this.b}f(m){return this.b!==g.Off&&this.b<=m}}e.$aj=a;class b extends a{constructor(m){super(),this.h=m}f(m){return this.h||super.f(m)}trace(m,...h){this.f(g.Trace)&&this.g(g.Trace,n([m,...h],!0))}debug(m,...h){this.f(g.Debug)&&this.g(g.Debug,n([m,...h]))}info(m,...h){this.f(g.Info)&&this.g(g.Info,n([m,...h]))}warn(m,...h){this.f(g.Warning)&&this.g(g.Warning,n([m,...h]))}error(m,...h){if(this.f(g.Error))if(m instanceof Error){const P=Array.prototype.slice.call(arguments);P[0]=m.stack,this.g(g.Error,n(P))}else this.g(g.Error,n([m,...h]))}flush(){}}e.$bj=b;class E extends a{constructor(m=e.$$i){super(),this.setLevel(m),this.g=!l.$j}trace(m,...h){this.f(g.Trace)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,m,...h):console.log(`[main ${p()}]`,m,...h))}debug(m,...h){this.f(g.Debug)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,m,...h):console.log(`[main ${p()}]`,m,...h))}info(m,...h){this.f(g.Info)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,m,...h):console.log(`[main ${p()}]`,m,...h))}warn(m,...h){this.f(g.Warning)&&(this.g?console.warn(`\x1B[93m[main ${p()}]\x1B[0m`,m,...h):console.warn(`[main ${p()}]`,m,...h))}error(m,...h){this.f(g.Error)&&(this.g?console.error(`\x1B[91m[main ${p()}]\x1B[0m`,m,...h):console.error(`[main ${p()}]`,m,...h))}dispose(){}flush(){}}e.$cj=E;class v extends a{constructor(m=e.$$i,h=!0){super(),this.g=h,this.setLevel(m)}trace(m,...h){this.f(g.Trace)&&(this.g?console.log("%cTRACE","color: #888",m,...h):console.log(m,...h))}debug(m,...h){this.f(g.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",m,...h):console.log(m,...h))}info(m,...h){this.f(g.Info)&&(this.g?console.log("%c INFO","color: #33f",m,...h):console.log(m,...h))}warn(m,...h){this.f(g.Warning)&&(this.g?console.log("%c WARN","color: #993",m,...h):console.log(m,...h))}error(m,...h){this.f(g.Error)&&(this.g?console.log("%c  ERR","color: #f33",m,...h):console.error(m,...h))}dispose(){}flush(){}}e.$dj=v;class r extends a{constructor(m,h=e.$$i){super(),this.g=m,this.setLevel(h)}trace(m,...h){this.f(g.Trace)&&this.g.log(g.Trace,[this.h(m),...h])}debug(m,...h){this.f(g.Debug)&&this.g.log(g.Debug,[this.h(m),...h])}info(m,...h){this.f(g.Info)&&this.g.log(g.Info,[this.h(m),...h])}warn(m,...h){this.f(g.Warning)&&this.g.log(g.Warning,[this.h(m),...h])}error(m,...h){this.f(g.Error)&&this.g.log(g.Error,[this.h(m),...h])}h(m){return typeof m=="string"?m:(0,w.$yi)(m,this.f(g.Trace))}dispose(){}flush(){}}e.$ej=r;class s extends a{constructor(m){super(),this.g=m,m.length&&this.setLevel(m[0].getLevel())}setLevel(m){for(const h of this.g)h.setLevel(m);super.setLevel(m)}trace(m,...h){for(const P of this.g)P.trace(m,...h)}debug(m,...h){for(const P of this.g)P.debug(m,...h)}info(m,...h){for(const P of this.g)P.info(m,...h)}warn(m,...h){for(const P of this.g)P.warn(m,...h)}error(m,...h){for(const P of this.g)P.error(m,...h)}flush(){for(const m of this.g)m.flush()}dispose(){for(const m of this.g)m.dispose()}}e.$fj=s;class i extends F.$Rc{constructor(m,h,P){if(super(),this.h=m,this.j=h,this.b=new A.$zc,this.c=this.B(new M.$Md),this.onDidChangeLoggers=this.c.event,this.f=this.B(new M.$Md),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new M.$Md),this.onDidChangeVisibility=this.g.event,P)for(const W of P)this.b.set(W.resource,{logger:void 0,info:W})}m(m){return(0,f.$xf)(m)?[...this.b.values()].find(h=>h.info.id===m):this.b.get(m)}getLogger(m){return this.m(m)?.logger}createLogger(m,h){const P=this.n(m),W=(0,f.$xf)(m)?m:h?.id??(0,C.$Bi)(P.toString()).toString(16);let K=this.b.get(P)?.logger;const U=h?.logLevel==="always"?g.Trace:h?.logLevel;K||(K=this.s(P,U??this.getLogLevel(P)??this.h,{...h,id:W}));const B={logger:K,info:{resource:P,id:W,logLevel:U,name:h?.name,hidden:h?.hidden,extensionId:h?.extensionId,when:h?.when}};return this.registerLogger(B.info),this.b.set(P,B),K}n(m){return(0,f.$xf)(m)?(0,k.$ug)(this.j,`${m}.log`):m}setLogLevel(m,h){if(R.URI.isUri(m)){const P=m,W=h,K=this.b.get(P);K&&W!==K.info.logLevel&&(K.info.logLevel=W===this.h?void 0:W,K.logger?.setLevel(W),this.b.set(K.info.resource,K),this.f.fire([P,W]))}else{this.h=m;for(const[P,W]of this.b.entries())this.b.get(P)?.info.logLevel===void 0&&W.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(m,h){const P=this.m(m);P&&h!==!P.info.hidden&&(P.info.hidden=!h,this.b.set(P.info.resource,P),this.g.fire([P.info.resource,h]))}getLogLevel(m){let h;return m&&(h=this.b.get(m)?.info.logLevel),h??this.h}registerLogger(m){const h=this.b.get(m.resource);h?h.info.hidden!==m.hidden&&this.setVisibility(m.resource,!m.hidden):(this.b.set(m.resource,{info:m,logger:void 0}),this.c.fire({added:[m],removed:[]}))}deregisterLogger(m){const h=this.b.get(m);h&&(h.logger&&h.logger.dispose(),this.b.delete(m),this.c.fire({added:[],removed:[h.info]}))}*getRegisteredLoggers(){for(const m of this.b.values())yield m.info}getRegisteredLogger(m){return this.b.get(m)?.info}dispose(){this.b.forEach(m=>m.logger?.dispose()),this.b.clear(),super.dispose()}}e.$gj=i;class o{constructor(){this.onDidChangeLogLevel=new M.$Md().event}setLevel(m){}getLevel(){return g.Info}trace(m,...h){}debug(m,...h){}info(m,...h){}warn(m,...h){}error(m,...h){}critical(m,...h){}dispose(){}flush(){}}e.$hj=o;class y extends o{}e.$ij=y;function d(u){if(u.verbose)return g.Trace;if(typeof u.logLevel=="string"){const m=S(u.logLevel.toLowerCase());if(m!==void 0)return m}return e.$$i}e.$jj=d;function I(u){switch(u){case g.Trace:return"trace";case g.Debug:return"debug";case g.Info:return"info";case g.Warning:return"warn";case g.Error:return"error";case g.Off:return"off"}}e.$kj=I;function S(u){switch(u){case"trace":return g.Trace;case"debug":return g.Debug;case"info":return g.Info;case"warn":return g.Warning;case"error":return g.Error;case"critical":return g.Error;case"off":return g.Off}}e.$lj=S,e.$mj=new D.$5i("logLevel",I(g.Info))}),define(Re[174],Me([1,0,6,14]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xN=void 0;class C extends w.$Rc{constructor(A,l=[]){super(),this.a=new M.$fj([A,...l]),this.B(A.onDidChangeLogLevel(k=>this.setLevel(k)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...l){this.a.trace(A,...l)}debug(A,...l){this.a.debug(A,...l)}info(A,...l){this.a.info(A,...l)}warn(A,...l){this.a.warn(A,...l)}error(A,...l){this.a.error(A,...l)}flush(){this.a.flush()}}e.$xN=C}),define(Re[94],Me([1,0,29,143,4]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7s=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var F;(function(k){k[k.Unnecessary=1]="Unnecessary",k[k.Deprecated=2]="Deprecated"})(F||(e.MarkerTag=F={}));var A;(function(k){k[k.Hint=1]="Hint",k[k.Info=2]="Info",k[k.Warning=4]="Warning",k[k.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function(k){function f($,g){return g-$}k.compare=f;const R=Object.create(null);R[k.Error]=(0,M.localize)(0,null),R[k.Warning]=(0,M.localize)(1,null),R[k.Info]=(0,M.localize)(2,null);function D($){return R[$]||""}k.toString=D;function c($){switch($){case w.default.Error:return k.Error;case w.default.Warning:return k.Warning;case w.default.Info:return k.Info;case w.default.Ignore:return k.Hint}}k.fromSeverity=c;function p($){switch($){case k.Error:return w.default.Error;case k.Warning:return w.default.Warning;case k.Info:return w.default.Info;case k.Hint:return w.default.Ignore}}k.toSeverity=p}(A||(e.MarkerSeverity=A={}));var l;(function(k){const f="";function R(c){return D(c,!0)}k.makeKey=R;function D(c,p){const $=[f];return c.source?$.push(c.source.replace("\xA6","\\\xA6")):$.push(f),c.code?typeof c.code=="string"?$.push(c.code.replace("\xA6","\\\xA6")):$.push(c.code.value.replace("\xA6","\\\xA6")):$.push(f),c.severity!==void 0&&c.severity!==null?$.push(A.toString(c.severity)):$.push(f),c.message&&p?$.push(c.message.replace("\xA6","\\\xA6")):$.push(f),c.startLineNumber!==void 0&&c.startLineNumber!==null?$.push(c.startLineNumber.toString()):$.push(f),c.startColumn!==void 0&&c.startColumn!==null?$.push(c.startColumn.toString()):$.push(f),c.endLineNumber!==void 0&&c.endLineNumber!==null?$.push(c.endLineNumber.toString()):$.push(f),c.endColumn!==void 0&&c.endColumn!==null?$.push(c.endColumn.toString()):$.push(f),$.push(f),$.join("\xA6")}k.makeKeyOptionalMessage=D})(l||(e.IMarkerData=l={})),e.$7s=(0,C.$Nh)("markerService")}),define(Re[175],Me([1,0,5,29,4]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wu=e.$Vu=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Uu=e.Severity=void 0,e.Severity=M.default,e.$Uu=(0,C.$Nh)("notificationService");var F;(function(R){R[R.DEFAULT=0]="DEFAULT",R[R.SILENT=1]="SILENT",R[R.URGENT=2]="URGENT"})(F||(e.NotificationPriority=F={}));var A;(function(R){R[R.WORKSPACE=0]="WORKSPACE",R[R.PROFILE=1]="PROFILE",R[R.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));var l;(function(R){R[R.OFF=0]="OFF",R[R.SILENT=1]="SILENT",R[R.ERROR=2]="ERROR"})(l||(e.NotificationsFilter=l={}));class k{constructor(){this.progress=new f,this.onDidClose=w.Event.None,this.onDidChangeVisibility=w.Event.None}updateSeverity(D){}updateMessage(D){}updateActions(D){}close(){}}e.$Vu=k;class f{infinite(){}done(){}total(D){}worked(D){}}e.$Wu=f}),define(Re[95],Me([1,0,15,2,4]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_T=e.$$T=e.$0T=e.$9T=e.$8T=void 0,e.$8T=(0,C.$Nh)("openerService");function F(f,R){return M.URI.isUri(f)?(0,w.$1e)(f.scheme,R):(0,w.$2e)(f,R+":")}e.$9T=F;function A(f,...R){return R.some(D=>F(f,D))}e.$0T=A;function l(f,R){return f.with({fragment:`${R.startLineNumber},${R.startColumn}${R.endLineNumber?`-${R.endLineNumber}${R.endColumn?`,${R.endColumn}`:""}`:""}`})}e.$$T=l;function k(f){let R;const D=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(f.fragment);return D&&(R={startLineNumber:parseInt(D[1]),startColumn:D[2]?parseInt(D[2]):1,endLineNumber:D[4]?parseInt(D[4]):void 0,endColumn:D[4]?D[5]?parseInt(D[5]):1:void 0},f=f.with({fragment:""})),{selection:R,uri:f}}e.$_T=k}),define(Re[176],Me([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oj=e.$nj=void 0,e.$nj=(0,w.$Nh)("productService"),e.$oj="vscode://schemas/vscode-product"});var qe=this&&this.__decorate||function(be,e,w,M){var C=arguments.length,F=C<3?e:M===null?M=Object.getOwnPropertyDescriptor(e,w):M,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")F=Reflect.decorate(be,e,w,M);else for(var l=be.length-1;l>=0;l--)(A=be[l])&&(F=(C<3?A(F):C>3?A(e,w,F):A(e,w))||F);return C>3&&F&&Object.defineProperty(e,w,F),F},We=this&&this.__param||function(be,e){return function(w,M){e(w,M,be)}};define(Re[71],Me([1,0,12,21,6,4]),function(be,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3u=e.$2u=e.$1u=e.$Zu=e.$Yu=e.ProgressLocation=e.$Xu=void 0,e.$Xu=(0,F.$Nh)("progressService");var A;(function(R){R[R.Explorer=1]="Explorer",R[R.Scm=3]="Scm",R[R.Extensions=5]="Extensions",R[R.Window=10]="Window",R[R.Notification=15]="Notification",R[R.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.$Yu=Object.freeze({total(){},worked(){},done(){}});class l{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(D,c){this.e=D,this.report=c?.async?this.g.bind(this):this.f.bind(this)}f(D){this.a=D,this.e(this.a)}g(D){this.b?this.b.push(D):this.b=[D],this.h()}async h(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const D=this.b.shift();this.a=D,await this.e(this.a)}}finally{this.c=!1;const D=this.d;this.d=void 0,D?.()}}drain(){return this.c?new Promise(D=>{const c=this.d;this.d=()=>{c?.(),D()}}):Promise.resolve()}}e.$Zu=l;let k=class extends C.$Rc{constructor(D,c){super(),this.a=new w.$bh,c.withProgress(D,p=>(this.b=p,this.c&&p.report(this.c),this.a.p)),this.B((0,C.$Pc)(()=>this.a.complete()))}report(D){this.b?this.b.report(D):this.c=D}};e.$1u=k,e.$1u=k=qe([We(1,e.$Xu)],k);class f extends C.$Rc{constructor(D){super(),this.g=D,this.a=0,this.b=this.B(new C.$Qc)}start(D){this.stop();const c=++this.a,p=new M.$Wd;return this.f=setTimeout(()=>{c===this.a&&(this.c=this.g.show(!0))},D),this.b.add((0,C.$Pc)(()=>clearTimeout(this.f))),this.b.add((0,C.$Pc)(()=>p.cancel())),this.b.add((0,C.$Pc)(()=>this.c?this.c.done():void 0)),{id:c,token:p.token,stop:()=>this.h(c),isCurrent:()=>this.a===c}}stop(){this.h(this.a)}h(D){this.a===D&&this.b.clear()}}e.$2u=f,e.$3u=(0,F.$Nh)("editorProgressService")}),define(Re[30],Me([1,0,51,16]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bn=void 0;class C{constructor(){this.a=new Map}add(A,l){w.ok(M.$xf(A)),w.ok(M.$zf(l)),w.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,l)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$bn=new C}),define(Re[72],Me([1,0,5,30]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cn=void 0,e.$cn={JSONContribution:"base.contributions.json"};function C(l){return l.length>0&&l.charAt(l.length-1)==="#"?l.substring(0,l.length-1):l}class F{constructor(){this.b=new w.$Md,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(k,f){this.a[C(k)]=f,this.b.fire(k)}notifySchemaChanged(k){this.b.fire(k)}getSchemaContributions(){return{schemas:this.a}}}const A=new F;M.$bn.add(e.$cn.JSONContribution,A)}),define(Re[96],Me([1,0,18,5,16,137,43,72,30]),function(be,e,w,M,C,F,A,l,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.ConfigurationScope=e.$gn=e.EditPresentationTypes=void 0;var f;(function(v){v.Multiline="multilineText",v.Singleline="singlelineText"})(f||(e.EditPresentationTypes=f={})),e.$gn={Configuration:"base.contributions.configuration"};var R;(function(v){v[v.APPLICATION=1]="APPLICATION",v[v.MACHINE=2]="MACHINE",v[v.WINDOW=3]="WINDOW",v[v.RESOURCE=4]="RESOURCE",v[v.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",v[v.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R||(e.ConfigurationScope=R={})),e.$hn={properties:{},patternProperties:{}},e.$in={properties:{},patternProperties:{}},e.$jn={properties:{},patternProperties:{}},e.$kn={properties:{},patternProperties:{}},e.$ln={properties:{},patternProperties:{}},e.$mn={properties:{},patternProperties:{}},e.$nn="vscode://schemas/settings/resourceLanguage",e.$on="vscode://schemas/settings/configurationDefaults";const D=k.$bn.as(l.$cn.JSONContribution);class c{constructor(){this.h=new Set,this.i=new M.$Md,this.onDidSchemaChange=this.i.event,this.j=new M.$Md,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:F.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},D.registerSchema(e.$nn,this.g),this.v()}registerConfiguration(r,s=!0){this.registerConfigurations([r],s)}registerConfigurations(r,s=!0){const i=new Set;this.n(r,s,i),D.registerSchema(e.$nn,this.g),this.i.fire(),this.j.fire({properties:i})}deregisterConfigurations(r){const s=new Set;this.o(r,s),D.registerSchema(e.$nn,this.g),this.i.fire(),this.j.fire({properties:s})}updateConfigurations({add:r,remove:s}){const i=new Set;this.o(s,i),this.n(r,!1,i),D.registerSchema(e.$nn,this.g),this.i.fire(),this.j.fire({properties:i})}registerDefaultConfigurations(r){const s=new Set;this.k(r,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}k(r,s){const i=[];for(const{overrides:o,source:y}of r)for(const d in o)if(s.add(d),e.$qn.test(d)){const I=this.a.get(d),S=I?.valuesSources??new Map;if(y)for(const P of Object.keys(o[d]))S.set(P,y);const u={...I?.value||{},...o[d]};this.a.set(d,{source:y,value:u,valuesSources:S});const m=(0,A.$ri)(d),h={type:"object",default:u,description:F.localize(1,null,m),$ref:e.$nn,defaultDefaultValue:u,source:C.$xf(y)?void 0:y,defaultValueSource:y};i.push(...g(d)),this.d[d]=h,this.b.properties[d]=h}else{this.a.set(d,{value:o[d],source:y});const I=this.d[d];I&&(this.w(d,I),this.r(d,I))}this.m(i)}deregisterDefaultConfigurations(r){const s=new Set;this.l(r,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}l(r,s){for(const{overrides:i,source:o}of r)for(const y in i){const d=this.a.get(y),I=C.$xf(o)?o:o?.id,S=C.$xf(d?.source)?d?.source:d?.source?.id;if(I===S)if(s.add(y),this.a.delete(y),e.$qn.test(y))delete this.d[y],delete this.b.properties[y];else{const u=this.d[y];u&&(this.w(y,u),this.r(y,u))}}this.u()}deltaConfiguration(r){let s=!1;const i=new Set;r.removedDefaults&&(this.l(r.removedDefaults,i),s=!0),r.addedDefaults&&(this.k(r.addedDefaults,i),s=!0),r.removedConfigurations&&this.o(r.removedConfigurations,i),r.addedConfigurations&&this.n(r.addedConfigurations,!1,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...r){this.i.fire()}registerOverrideIdentifiers(r){this.m(r),this.i.fire()}m(r){for(const s of r)this.h.add(s);this.u()}n(r,s,i){r.forEach(o=>{this.p(o,s,o.extensionInfo,o.restrictedProperties,void 0,i),this.c.push(o),this.q(o)})}o(r,s){const i=o=>{if(o.properties)for(const y in o.properties){s.add(y);const d=this.d[y];d?.policy?.name&&this.e.delete(d.policy.name),delete this.d[y],this.s(y,o.properties[y])}o.allOf?.forEach(y=>i(y))};for(const o of r){i(o);const y=this.c.indexOf(o);y!==-1&&this.c.splice(y,1)}}p(r,s=!0,i,o,y=3,d){y=C.$Gf(r.scope)?y:r.scope;const I=r.properties;if(I)for(const u in I){const m=I[u];if(s&&b(u,m)){delete I[u];continue}if(m.source=i,m.defaultDefaultValue=I[u].default,this.w(u,m),e.$qn.test(u)?m.scope=void 0:(m.scope=C.$Gf(m.scope)?y:m.scope,m.restricted=C.$Gf(m.restricted)?!!o?.includes(u):m.restricted),I[u].hasOwnProperty("included")&&!I[u].included){this.f[u]=I[u],delete I[u];continue}else this.d[u]=I[u],I[u].policy?.name&&this.e.set(I[u].policy.name,u);!I[u].deprecationMessage&&I[u].markdownDeprecationMessage&&(I[u].deprecationMessage=I[u].markdownDeprecationMessage),d.add(u)}const S=r.allOf;if(S)for(const u of S)this.p(u,s,i,o,y,d)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(r){const s=i=>{const o=i.properties;if(o)for(const d in o)this.r(d,o[d]);i.allOf?.forEach(s)};s(r)}r(r,s){switch(e.$hn.properties[r]=s,s.scope){case 1:e.$in.properties[r]=s;break;case 2:e.$jn.properties[r]=s;break;case 6:e.$kn.properties[r]=s;break;case 3:e.$ln.properties[r]=s;break;case 4:e.$mn.properties[r]=s;break;case 5:e.$mn.properties[r]=s,this.g.properties[r]=s;break}}s(r,s){switch(delete e.$hn.properties[r],s.scope){case 1:delete e.$in.properties[r];break;case 2:delete e.$jn.properties[r];break;case 6:delete e.$kn.properties[r];break;case 3:delete e.$ln.properties[r];break;case 4:case 5:delete e.$mn.properties[r],delete this.g.properties[r];break}}u(){for(const r of this.h.values()){const s=`[${r}]`,i={type:"object",description:F.localize(2,null),errorMessage:F.localize(3,null),$ref:e.$nn};this.w(s,i),e.$hn.properties[s]=i,e.$in.properties[s]=i,e.$jn.properties[s]=i,e.$kn.properties[s]=i,e.$ln.properties[s]=i,e.$mn.properties[s]=i}}v(){const r={type:"object",description:F.localize(4,null),errorMessage:F.localize(5,null),$ref:e.$nn};e.$hn.patternProperties[e.$pn]=r,e.$in.patternProperties[e.$pn]=r,e.$jn.patternProperties[e.$pn]=r,e.$kn.patternProperties[e.$pn]=r,e.$ln.patternProperties[e.$pn]=r,e.$mn.patternProperties[e.$pn]=r,this.i.fire()}w(r,s){const i=this.a.get(r);let o=i?.value,y=i?.source;C.$Ef(o)&&(o=s.defaultDefaultValue,y=void 0),C.$Ef(o)&&(o=n(s.type)),s.default=o,s.defaultValueSource=y}}const p="\\[([^\\]]+)\\]",$=new RegExp(p,"g");e.$pn=`^(${p})+$`,e.$qn=new RegExp(e.$pn);function g(v){const r=[];if(e.$qn.test(v)){let s=$.exec(v);for(;s?.length;){const i=s[1].trim();i&&r.push(i),s=$.exec(v)}}return(0,w.$Lb)(r)}e.$rn=g;function t(v){return v.reduce((r,s)=>`${r}[${s}]`,"")}e.$sn=t;function n(v){switch(Array.isArray(v)?v[0]:v){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$tn=n;const a=new c;k.$bn.add(e.$gn.Configuration,a);function b(v,r){return v.trim()?e.$qn.test(v)?F.localize(7,null,v):a.getConfigurationProperties()[v]!==void 0?F.localize(8,null,v):r.policy?.name&&a.getPolicyConfigurations().get(r.policy?.name)!==void 0?F.localize(9,null,v,r.policy?.name,a.getPolicyConfigurations().get(r.policy?.name)):null:F.localize(6,null)}e.$un=b;function E(){const v=[],r=a.getConfigurationProperties();for(const s of Object.keys(r))v.push([s,r[s].scope]);return v.push(["launch",4]),v.push(["task",4]),v}e.$vn=E}),define(Re[177],Me([1,0,18,5,115,6,28,24,16,2,43,96,30]),function(be,e,w,M,C,F,A,l,k,f,R,D,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.$wn=void 0;function p(s){return Object.isFrozen(s)?s:l.$3m(s)}class ${constructor(i={},o=[],y=[],d){this.b=i,this.c=o,this.d=y,this.raw=d,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const i=this.raw.map(o=>{if(o instanceof $)return o;const y=new g("");return y.parseRaw(o),y.configurationModel});this.f=i.reduce((o,y)=>y===o?y:o.merge(y),i[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(i){return i?(0,R.$pi)(this.contents,i):this.contents}inspect(i,o){const y=this.rawConfiguration.getValue(i),d=o?this.rawConfiguration.getOverrideValue(i,o):void 0,I=o?this.rawConfiguration.override(o).getValue(i):y;return{value:y,override:d,merged:I}}getOverrideValue(i,o){const y=this.i(o);return y?i?(0,R.$pi)(y,i):y:void 0}getKeysForOverrideIdentifier(i){const o=[];for(const y of this.overrides)y.identifiers.includes(i)&&o.push(...y.keys);return w.$Lb(o)}getAllOverrideIdentifiers(){const i=[];for(const o of this.overrides)i.push(...o.identifiers);return w.$Lb(i)}override(i){let o=this.a.get(i);return o||(o=this.g(i),this.a.set(i,o)),o}merge(...i){const o=l.$2m(this.contents),y=l.$2m(this.overrides),d=[...this.keys],I=this.raw?.length?[...this.raw]:[this];for(const S of i)if(I.push(...S.raw?.length?S.raw:[S]),!S.isEmpty()){this.h(o,S.contents);for(const u of S.overrides){const[m]=y.filter(h=>w.$tb(h.identifiers,u.identifiers));m?(this.h(m.contents,u.contents),m.keys.push(...u.keys),m.keys=w.$Lb(m.keys)):y.push(l.$2m(u))}for(const u of S.keys)d.indexOf(u)===-1&&d.push(u)}return new $(o,d,y,I.every(S=>S instanceof $)?void 0:I)}g(i){const o=this.i(i);if(!o||typeof o!="object"||!Object.keys(o).length)return this;const y={};for(const d of w.$Lb([...Object.keys(this.contents),...Object.keys(o)])){let I=this.contents[d];const S=o[d];S&&(typeof I=="object"&&typeof S=="object"?(I=l.$2m(I),this.h(I,S)):I=S),y[d]=I}return new $(y,this.keys,this.overrides)}h(i,o){for(const y of Object.keys(o)){if(y in i&&k.$zf(i[y])&&k.$zf(o[y])){this.h(i[y],o[y]);continue}i[y]=l.$2m(o[y])}}i(i){let o=null,y=null;const d=I=>{I&&(y?this.h(y,I):y=l.$2m(I))};for(const I of this.overrides)I.identifiers.length===1&&I.identifiers[0]===i?o=I.contents:I.identifiers.includes(i)&&d(I.contents);return d(o),y}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,o){this.j(i,o,!0)}setValue(i,o){this.j(i,o,!1)}removeValue(i){const o=this.keys.indexOf(i);o!==-1&&(this.keys.splice(o,1),(0,R.$oi)(this.contents,i),D.$qn.test(i)&&this.overrides.splice(this.overrides.findIndex(y=>w.$tb(y.identifiers,(0,D.$rn)(i))),1))}j(i,o,y){(0,R.$ni)(this.contents,i,o,d=>console.error(d)),y=y||this.keys.indexOf(i)===-1,y&&this.keys.push(i),D.$qn.test(i)&&this.overrides.push({identifiers:(0,D.$rn)(i),keys:Object.keys(this.contents[i]),contents:(0,R.$mi)(this.contents[i],d=>console.error(d))})}}e.$wn=$;class g{constructor(i){this.f=i,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new $}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(i,o){if(!k.$Gf(i)){const y=this.g(i);this.parseRaw(y,o)}}reparse(i){this.a&&this.parseRaw(this.a,i)}parseRaw(i,o){this.a=i;const{contents:y,keys:d,overrides:I,restricted:S,hasExcludedProperties:u}=this.h(i,o);this.b=new $(y,d,I,u?[i]:void 0),this.c=S||[]}g(i){let o={},y=null,d=[];const I=[],S=[];function u(h){Array.isArray(d)?d.push(h):y!==null&&(d[y]=h)}const m={onObjectBegin:()=>{const h={};u(h),I.push(d),d=h,y=null},onObjectProperty:h=>{y=h},onObjectEnd:()=>{d=I.pop()},onArrayBegin:()=>{const h=[];u(h),I.push(d),d=h,y=null},onArrayEnd:()=>{d=I.pop()},onLiteralValue:u,onError:(h,P,W)=>{S.push({error:h,offset:P,length:W})}};if(i)try{C.$Ym(i,m),o=d[0]||{}}catch(h){console.error(`Error while parsing settings file ${this.f}: ${h}`),this.d=[h]}return o}h(i,o){const y=c.$bn.as(D.$gn.Configuration).getConfigurationProperties(),d=this.i(i,y,!0,o);i=d.raw;const I=(0,R.$mi)(i,m=>console.error(`Conflict in settings file ${this.f}: ${m}`)),S=Object.keys(i),u=this.j(i,m=>console.error(`Conflict in settings file ${this.f}: ${m}`));return{contents:I,keys:S,overrides:u,restricted:d.restricted,hasExcludedProperties:d.hasExcludedProperties}}i(i,o,y,d){let I=!1;if(!d?.scopes&&!d?.skipRestricted&&!d?.exclude?.length)return{raw:i,restricted:[],hasExcludedProperties:I};const S={},u=[];for(const m in i)if(D.$qn.test(m)&&y){const h=this.i(i[m],o,!1,d);S[m]=h.raw,I=I||h.hasExcludedProperties,u.push(...h.restricted)}else{const h=o[m],P=h?typeof h.scope<"u"?h.scope:3:void 0;h?.restricted&&u.push(m),!d.exclude?.includes(m)&&(d.include?.includes(m)||(P===void 0||d.scopes===void 0||d.scopes.includes(P))&&!(d.skipRestricted&&h?.restricted))?S[m]=i[m]:I=!0}return{raw:S,restricted:u,hasExcludedProperties:I}}j(i,o){const y=[];for(const d of Object.keys(i))if(D.$qn.test(d)){const I={};for(const S in i[d])I[S]=i[d][S];y.push({identifiers:(0,D.$rn)(d),keys:Object.keys(I),contents:(0,R.$mi)(I,o)})}return y}}e.$xn=g;class t extends F.$Rc{constructor(i,o,y,d){super(),this.c=i,this.f=o,this.g=d,this.b=this.B(new M.$Md),this.onDidChange=this.b.event,this.a=new g(this.c.toString()),this.B(this.g.watch(y.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(M.Event.any(M.Event.filter(this.g.onDidFilesChange,I=>I.contains(this.c)),M.Event.filter(this.g.onDidRunOperation,I=>(I.isOperation(0)||I.isOperation(3)||I.isOperation(1)||I.isOperation(4))&&y.isEqual(I.resource,i)))(()=>this.b.fire()))}async loadConfiguration(){try{const i=await this.g.readFile(this.c);return this.a.parse(i.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new $}}reparse(i){return i&&(this.f=i),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$yn=t;class n{constructor(i,o,y,d,I,S,u,m,h,P,W,K,U){this.a=i,this.b=o,this.c=y,this.overrideIdentifiers=d,this.d=I,this.f=S,this.g=u,this.h=m,this.i=h,this.j=P,this.k=W,this.l=K,this.m=U}get value(){return p(this.c)}n(i,o,y){const d=i.inspect(o,y);return{get value(){return p(d.value)},get override(){return p(d.override)},get merged(){return p(d.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class a{constructor(i,o,y,d,I=new $,S=new $,u=new A.$zc,m=new $,h=new A.$zc){this.c=i,this.d=o,this.f=y,this.g=d,this.h=I,this.i=S,this.j=u,this.l=m,this.m=h,this.a=null,this.b=new A.$zc,this.n=null}getValue(i,o,y){return this.q(i,o,y).getValue(i)}updateValue(i,o,y={}){let d;y.resource?(d=this.m.get(y.resource),d||(d=new $,this.m.set(y.resource,d))):d=this.l,o===void 0?d.removeValue(i):d.setValue(i,o),y.resource||(this.a=null)}inspect(i,o,y){const d=this.q(i,o,y),I=this.u(o.resource,y),S=o.resource?this.m.get(o.resource)||this.l:this.l,u=new Set;for(const m of d.overrides)for(const h of m.identifiers)d.getOverrideValue(i,h)!==void 0&&u.add(h);return new n(i,o,d.getValue(i),u.size?[...u]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,y?this.i:void 0,I||void 0,S)}keys(i){const o=this.u(void 0,i);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:o?o.keys.slice(0):[]}}updateDefaultConfiguration(i){this.c=i,this.a=null,this.b.clear()}updatePolicyConfiguration(i){this.d=i}updateApplicationConfiguration(i){this.f=i,this.a=null,this.b.clear()}updateLocalUserConfiguration(i){this.g=i,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(i){this.h=i,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(i){this.i=i,this.a=null,this.b.clear()}updateFolderConfiguration(i,o){this.j.set(i,o),this.b.delete(i)}deleteFolderConfiguration(i){this.p.delete(i),this.b.delete(i)}compareAndUpdateDefaultConfiguration(i,o){const y=[];if(!o){const{added:d,updated:I,removed:S}=v(this.c,i);o=[...d,...I,...S]}for(const d of o)for(const I of(0,D.$rn)(d)){const S=this.c.getKeysForOverrideIdentifier(I),u=i.getKeysForOverrideIdentifier(I),m=[...u.filter(h=>S.indexOf(h)===-1),...S.filter(h=>u.indexOf(h)===-1),...S.filter(h=>!l.$6m(this.c.override(I).getValue(h),i.override(I).getValue(h)))];y.push([I,m])}return this.updateDefaultConfiguration(i),{keys:o,overrides:y}}compareAndUpdatePolicyConfiguration(i){const{added:o,updated:y,removed:d}=v(this.d,i),I=[...o,...y,...d];return I.length&&this.updatePolicyConfiguration(i),{keys:I,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:o,updated:y,removed:d,overrides:I}=v(this.applicationConfiguration,i),S=[...o,...y,...d];return S.length&&this.updateApplicationConfiguration(i),{keys:S,overrides:I}}compareAndUpdateLocalUserConfiguration(i){const{added:o,updated:y,removed:d,overrides:I}=v(this.localUserConfiguration,i),S=[...o,...y,...d];return S.length&&this.updateLocalUserConfiguration(i),{keys:S,overrides:I}}compareAndUpdateRemoteUserConfiguration(i){const{added:o,updated:y,removed:d,overrides:I}=v(this.remoteUserConfiguration,i),S=[...o,...y,...d];return S.length&&this.updateRemoteUserConfiguration(i),{keys:S,overrides:I}}compareAndUpdateWorkspaceConfiguration(i){const{added:o,updated:y,removed:d,overrides:I}=v(this.workspaceConfiguration,i),S=[...o,...y,...d];return S.length&&this.updateWorkspaceConfiguration(i),{keys:S,overrides:I}}compareAndUpdateFolderConfiguration(i,o){const y=this.p.get(i),{added:d,updated:I,removed:S,overrides:u}=v(y,o),m=[...d,...I,...S];return(m.length||!y)&&this.updateFolderConfiguration(i,o),{keys:m,overrides:u}}compareAndDeleteFolderConfiguration(i){const o=this.p.get(i);if(!o)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:y,updated:d,removed:I,overrides:S}=v(o,void 0);return{keys:[...y,...d,...I],overrides:S}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(i,o,y){let d=this.r(o,y);return o.overrideIdentifier&&(d=d.override(o.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(i)!==void 0&&(d=d.merge(this.d)),d}r({resource:i},o){let y=this.s();if(o&&i){const d=o.getFolder(i);d&&(y=this.t(d.uri)||y);const I=this.m.get(i);I&&(y=y.merge(I))}return y}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(i){let o=this.b.get(i);if(!o){const y=this.s(),d=this.j.get(i);d?(o=y.merge(d),this.b.set(i,o)):o=y}return o}u(i,o){if(o&&i){const y=o.getFolder(i);if(y)return this.j.get(y.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((i,o)=>{const{contents:y,overrides:d,keys:I}=this.j.get(o);return i.push([o,{contents:y,overrides:d,keys:I}]),i},[])}}allKeys(){const i=new Set;return this.c.keys.forEach(o=>i.add(o)),this.userConfiguration.keys.forEach(o=>i.add(o)),this.i.keys.forEach(o=>i.add(o)),this.j.forEach(o=>o.keys.forEach(y=>i.add(y))),[...i.values()]}v(){const i=new Set;return this.c.getAllOverrideIdentifiers().forEach(o=>i.add(o)),this.userConfiguration.getAllOverrideIdentifiers().forEach(o=>i.add(o)),this.i.getAllOverrideIdentifiers().forEach(o=>i.add(o)),this.j.forEach(o=>o.getAllOverrideIdentifiers().forEach(y=>i.add(y))),[...i.values()]}w(i){const o=new Set;return this.c.getKeysForOverrideIdentifier(i).forEach(y=>o.add(y)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(y=>o.add(y)),this.i.getKeysForOverrideIdentifier(i).forEach(y=>o.add(y)),this.j.forEach(y=>y.getKeysForOverrideIdentifier(i).forEach(d=>o.add(d))),[...o.values()]}static parse(i){const o=this.x(i.defaults),y=this.x(i.policy),d=this.x(i.application),I=this.x(i.user),S=this.x(i.workspace),u=i.folders.reduce((m,h)=>(m.set(f.URI.revive(h[0]),this.x(h[1])),m),new A.$zc);return new a(o,y,d,I,new $,S,u,new $,new A.$zc)}static x(i){return new $(i.contents,i.keys,i.overrides)}}e.$zn=a;function b(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const i=new Set,o=new Map;for(const d of s)d.keys.forEach(I=>i.add(I)),d.overrides.forEach(([I,S])=>{const u=(0,A.$wc)(o,I,new Set);S.forEach(m=>u.add(m))});const y=[];return o.forEach((d,I)=>y.push([I,[...d.values()]])),{keys:[...i.values()],overrides:y}}e.$An=b;class E{constructor(i,o,y,d){this.change=i,this.f=o,this.g=y,this.h=d,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const I of i.keys)this.affectedKeys.add(I);for(const[,I]of i.overrides)for(const S of I)this.affectedKeys.add(S);this.d=this.a;for(const I of this.affectedKeys)this.d+=I+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=a.parse(this.f.data)),this.i}affectsConfiguration(i,o){const y=this.a+i,d=this.d.indexOf(y);if(d<0)return!1;const I=d+y.length;if(I>=this.d.length)return!1;const S=this.d.charCodeAt(I);if(S!==this.b&&S!==this.c)return!1;if(o){const u=this.previousConfiguration?this.previousConfiguration.getValue(i,o,this.f?.workspace):void 0,m=this.g.getValue(i,o,this.h);return!l.$6m(u,m)}return!0}}e.$Bn=E;function v(s,i){const{added:o,removed:y,updated:d}=r(i?.rawConfiguration,s?.rawConfiguration),I=[],S=s?.getAllOverrideIdentifiers()||[],u=i?.getAllOverrideIdentifiers()||[];if(i){const m=u.filter(h=>!S.includes(h));for(const h of m)I.push([h,i.getKeysForOverrideIdentifier(h)])}if(s){const m=S.filter(h=>!u.includes(h));for(const h of m)I.push([h,s.getKeysForOverrideIdentifier(h)])}if(i&&s){for(const m of S)if(u.includes(m)){const h=r({contents:s.getOverrideValue(void 0,m)||{},keys:s.getKeysForOverrideIdentifier(m)},{contents:i.getOverrideValue(void 0,m)||{},keys:i.getKeysForOverrideIdentifier(m)});I.push([m,[...h.added,...h.removed,...h.updated]])}}return{added:o,removed:y,updated:d,overrides:I}}function r(s,i){const o=s?i?s.keys.filter(I=>i.keys.indexOf(I)===-1):[...s.keys]:[],y=i?s?i.keys.filter(I=>s.keys.indexOf(I)===-1):[...i.keys]:[],d=[];if(s&&i){for(const I of i.keys)if(s.keys.indexOf(I)!==-1){const S=(0,R.$pi)(i.contents,I),u=(0,R.$pi)(s.contents,I);l.$6m(S,u)||d.push(I)}}return{added:o,removed:y,updated:d}}}),define(Re[97],Me([1,0,9,4]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qk=e.$Pk=e.RemoteAuthorityResolverErrorCode=e.$Ok=e.$Nk=e.RemoteConnectionType=e.$Mk=void 0,e.$Mk=(0,M.$Nh)("remoteAuthorityResolverService");var C;(function(R){R[R.WebSocket=0]="WebSocket",R[R.Managed=1]="Managed"})(C||(e.RemoteConnectionType=C={}));class F{constructor(D){this.id=D,this.type=1}toString(){return`Managed(${this.id})`}}e.$Nk=F;class A{constructor(D,c){this.host=D,this.port=c,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Ok=A;var l;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound",R.InvalidAuthority="InvalidAuthority"})(l||(e.RemoteAuthorityResolverErrorCode=l={}));class k extends w.$ab{static isNotAvailable(D){return D instanceof k&&D._code===l.NotAvailable}static isTemporarilyNotAvailable(D){return D instanceof k&&D._code===l.TemporarilyNotAvailable}static isNoResolverFound(D){return D instanceof k&&D._code===l.NoResolverFound}static isInvalidAuthority(D){return D instanceof k&&D._code===l.InvalidAuthority}static isHandled(D){return D instanceof k&&D.isHandled}constructor(D,c=l.Unknown,p){super(D),this._message=D,this._code=c,this._detail=p,this.isHandled=c===l.NotAvailable&&p===!0,Object.setPrototypeOf(this,k.prototype)}}e.$Pk=k;function f(R){const D=R.indexOf("+");return D===-1?R:R.substring(0,D)}e.$Qk=f}),define(Re[52],Me([1,0,13]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vk=e.$Uk=e.$Tk=e.$Sk=e.$Rk=void 0;function M(f){return f.scheme===w.Schemas.vscodeRemote?f.authority:void 0}e.$Rk=M;function C(f){if(!f)return;const R=f.indexOf("+");return R<0?f:f.substr(0,R)}e.$Sk=C;function F(f){return`/${f.quality??"oss"}-${f.commit??"dev"}`}e.$Tk=F;function A(f){const{host:R,port:D}=k(f);if(typeof D>"u")throw new Error("Remote authority doesn't contain a port!");return{host:R,port:D}}e.$Uk=A;function l(f,R){let{host:D,port:c}=k(f);return typeof c>"u"&&(c=R),{host:D,port:c}}e.$Vk=l;function k(f){const R=f.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(R)return{host:R[1],port:parseInt(R[2],10)};const D=f.match(/^(\[[0-9a-z:]+\])$/);if(D)return{host:D[1],port:void 0};const c=f.match(/(.*):(\d+)$/);return c?{host:c[1],port:parseInt(c[2],10)}:{host:f,port:void 0}}}),define(Re[20],Me([1,0,15,4,52]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=e.TargetPlatform=e.ExtensionType=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.$Vl=void 0,e.$Vl="extensions.user.cache",e.$Wl="extensions.builtin.cache",e.$Xl="undefined_publisher",e.$Yl=["ui","workspace","web"];function F(g){if(typeof g=="object"&&g!==null&&g.supported!==!0)return g.description}e.$Zl=F,e.$1l=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(g){g[g.System=0]="System",g[g.User=1]="User"})(A||(e.ExtensionType=A={}));var l;(function(g){g.WIN32_X64="win32-x64",g.WIN32_IA32="win32-ia32",g.WIN32_ARM64="win32-arm64",g.LINUX_X64="linux-x64",g.LINUX_ARM64="linux-arm64",g.LINUX_ARMHF="linux-armhf",g.ALPINE_X64="alpine-x64",g.ALPINE_ARM64="alpine-arm64",g.DARWIN_X64="darwin-x64",g.DARWIN_ARM64="darwin-arm64",g.WEB="web",g.UNIVERSAL="universal",g.UNKNOWN="unknown",g.UNDEFINED="undefined"})(l||(e.TargetPlatform=l={}));class k{constructor(t){this.value=t,this._lower=t.toLowerCase()}static equals(t,n){if(typeof t>"u"||t===null)return typeof n>"u"||n===null;if(typeof n>"u"||n===null)return!1;if(typeof t=="string"||typeof n=="string"){const a=typeof t=="string"?t:t.value,b=typeof n=="string"?n:n.value;return w.$1e(a,b)}return t._lower===n._lower}static toKey(t){return typeof t=="string"?t.toLowerCase():t._lower}}e.$2l=k;class f{get size(){return this.c.size}constructor(t){if(this.c=new Set,t)for(const n of t)this.add(n)}add(t){this.c.add(k.toKey(t))}delete(t){return this.c.delete(k.toKey(t))}has(t){return this.c.has(k.toKey(t))}}e.$3l=f;class R{constructor(){this.c=new Map}clear(){this.c.clear()}delete(t){this.c.delete(k.toKey(t))}get(t){return this.c.get(k.toKey(t))}has(t){return this.c.has(k.toKey(t))}set(t,n){this.c.set(k.toKey(t),n)}values(){return this.c.values()}forEach(t){this.c.forEach(t)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$4l=R;function D(g){return c(g)}e.$5l=D;function c(g){return g.contributes&&g.contributes.localizations?g.contributes.localizations.length>0:!1}e.$6l=c;function p(g){return g.contributes&&g.contributes.authentication?g.contributes.authentication.length>0:!1}e.$7l=p;function $(g,t){if(t){const n=`onResolveRemoteAuthority:${(0,C.$Sk)(t)}`;return!!g.activationEvents?.includes(n)}return!1}e.$8l=$,e.$9l=(0,M.$Nh)("IBuiltinExtensionsScannerService")}),define(Re[98],Me([1,0,9,20]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QE=e.$PE=void 0;class C{constructor(){this.a=new Map,this.b=new WeakMap}register(A,l){this.a.set(A,l)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const l=Object.create(null);for(const k of A){const f=this.readActivationEvents(k);f.length>0&&(l[M.$2l.toKey(k.identifier)]=f)}return l}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const l=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];if(!A.contributes)return l;for(const k in A.contributes){const f=this.a.get(k);if(!f)continue;const R=A.contributes[k],D=Array.isArray(R)?R:[R];try{f(D,l)}catch(c){(0,w.$Z)(c)}}return l}}e.$PE=C,e.$QE=new C}),define(Re[178],Me([1,0,22,73,36]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eo=e.$do=void 0;function F(k){if(w.$u===2&&/^penguin(\.|$)/i.test(k))return"chromebook"}function A(k,f,R,D,c,p,$,g){const t=Object.create(null);t["common.machineId"]=p,t.sessionID=(0,C.$dg)()+Date.now(),t.commitHash=D,t.version=c,t["common.platformVersion"]=(k||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),t["common.platform"]=(0,w.$i)(w.$u),t["common.nodePlatform"]=M.$cc,t["common.nodeArch"]=R,t["common.product"]=g||"desktop",$&&(t["common.msftInternal"]=$);let n=0;const a=Date.now();Object.defineProperties(t,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-a,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),w.$m&&(t["common.snap"]="true");const b=F(f);return b&&(t["common.platformDetail"]=b),t}e.$do=A;function l(k){const f=M.env.USERDNSDOMAIN;if(!f)return!1;const R=f.toLowerCase();return k.some(D=>R===D)}e.$eo=l}),define(Re[179],Me([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$il=e.$hl=e.$gl=e.$fl=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.$_k=void 0,e.$_k=(0,w.$Nh)("telemetryService"),e.$al=(0,w.$Nh)("customEndpointTelemetryService"),e.$bl="telemetry.currentSessionDate",e.$cl="telemetry.firstSessionDate",e.$dl="telemetry.lastSessionDate",e.$el="telemetry.machineId",e.$fl="telemetry",e.$gl="telemetry.telemetryLevel",e.$hl="telemetry.enableCrashReporter",e.$il="telemetry.enableTelemetry";var M;(function(F){F[F.NONE=0]="NONE",F[F.CRASH=1]="CRASH",F[F.ERROR=2]="ERROR",F[F.USAGE=3]="USAGE"})(M||(e.TelemetryLevel=M={}));var C;(function(F){F.OFF="off",F.CRASH="crash",F.ERROR="error",F.ON="all"})(C||(e.TelemetryConfiguration=C={}))}),define(Re[53],Me([1,0,24,16,5,43,52,178,179]),function(be,e,w,M,C,F,A,l,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=void 0;class f{constructor(y){this.value=y,this.isTrustedTelemetryValue=!0}}e.$fo=f;class R{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$go=R,e.$ho=new R;class D{async publicLog(y,d,I){}async publicLogError(y,d,I){}}e.$io=D,e.$jo="telemetry",e.$ko="extensionTelemetryLog",e.$lo={log:()=>null,flush:()=>Promise.resolve(null)};function c(o,y){return C.Event.debounce(y.onDidChangeConfiguration,(I,S)=>{const u=I?new Set([...I.affectedKeys,...S.affectedKeys]):S.affectedKeys;return{...S,affectedKeys:u}},1e3,!0)(I=>{I.source!==7&&o.publicLog2("updateConfiguration",{configurationSource:(0,F.$ki)(I.source),configurationKeys:Array.from(I.affectedKeys)})})}e.$mo=c;function p(o,y){return!y.isBuilt&&!y.disableTelemetry?!0:!(y.disableTelemetry||!o.enableTelemetry)}e.$no=p;function $(o,y){return y.extensionTestsLocationURI?!0:!(y.isBuilt||y.disableTelemetry||o.enableTelemetry&&o.aiConfig?.ariaKey)}e.$oo=$;function g(o){const y=o.getValue(k.$gl),d=o.getValue(k.$hl);if(o.getValue(k.$il)===!1||d===!1)return 0;switch(y??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$po=g;function t(o){const y={},d={},I={};b(o,I);for(let S in I){S=S.length>150?S.substr(S.length-149):S;const u=I[S];typeof u=="number"?d[S]=u:typeof u=="boolean"?d[S]=u?1:0:typeof u=="string"?(u.length>8192&&console.warn(`Telemetry property: ${S} has been trimmed to 8192, the original length is ${u.length}`),y[S]=u.substring(0,8191)):typeof u<"u"&&u!==null&&(y[S]=u)}return{properties:y,measurements:d}}e.$qo=t;const n=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function a(o){if(!o)return"none";const y=(0,A.$Sk)(o);return n.has(y)?y:"other"}e.$ro=a;function b(o,y,d=0,I){if(o)for(const S of Object.getOwnPropertyNames(o)){const u=o[S],m=I?I+S:S;Array.isArray(u)?y[m]=(0,w.$7m)(u):u instanceof Date?y[m]=u.toISOString():(0,M.$zf)(u)?d<2?b(u,y,d+1,m+"."):y[m]=(0,w.$7m)(u):y[m]=u}}function E(o,y){const d=o.msftInternalDomains||[],I=y.getValue("telemetry.internalTesting");return(0,l.$eo)(d)||I}e.$so=E;function v(o){return[o.appRoot,o.extensionsPath,o.userHome.fsPath,o.tmpDir.fsPath,o.userDataPath]}e.$to=v;function r(o,y){if(!o||!o.includes("/")&&!o.includes("\\"))return o;let d=o;const I=[];for(const h of y)for(;;){const P=h.exec(o);if(!P)break;I.push([P.index,h.lastIndex])}const S=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,u=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let m=0;for(d="";;){const h=u.exec(o);if(!h)break;const P=I.some(([W,K])=>h.index<K&&W<u.lastIndex);!S.test(h[0])&&!P&&(d+=o.substring(m,h.index)+"<REDACTED: user-file-path>",m=u.lastIndex)}return m<o.length&&(d+=o.substr(m)),d}function s(o){if(!o)return o;const y=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const d of y)if(d.regex.test(o))return`<REDACTED: ${d.label}>`;return o}function i(o,y){return(0,w.$4m)(o,d=>{if(d instanceof f||Object.hasOwnProperty.call(d,"isTrustedTelemetryValue"))return d.value;if(typeof d=="string"){let I=d.replaceAll("%20"," ");I=r(I,y);for(const S of y)I=I.replace(S,"");return I=s(I),I}})}e.$uo=i}),define(Re[180],Me([1,0,15,92,20,22,2,9,73,53]),function(be,e,w,M,C,F,A,l,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=void 0;function R(i,o){return i.uuid&&o.uuid?i.uuid===o.uuid:i.id===o.id?!0:(0,w.$Ve)(i.id,o.id)===0}e.$vo=R;const D=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class c{static create(o){const y=o.manifest?o.manifest.version:o.version,d=o.manifest?o.targetPlatform:o.properties.targetPlatform;return new c(o.identifier,y,d)}static parse(o){const y=D.exec(o);return y&&y[1]&&y[2]?new c({id:y[1]},y[2],y[4]||void 0):null}constructor(o,y,d="undefined"){this.version=y,this.targetPlatform=d,this.id=o.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(o){return o instanceof c?R(this,o)&&this.version===o.version&&this.targetPlatform===o.targetPlatform:!1}}e.$wo=c;const p=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function $(i){const o=p.exec(i);return o&&o[1]?[t(o[1]),o[2]]:[t(i),void 0]}e.$xo=$;function g(i,o){return`${i}.${o}`}e.$yo=g;function t(i){return i.toLowerCase()}e.$zo=t;function n(i,o){return t(g(i??C.$Xl,o))}e.$Ao=n;function a(i,o){const y=[],d=I=>{for(const S of y)if(S.some(u=>R(o(u),o(I))))return S;return null};for(const I of i){const S=d(I);S?S.push(I):y.push([I])}return y}e.$Bo=a;function b(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.$Co=b;function E(i){return{id:new f.$fo(i.identifier.id),name:new f.$fo(i.name),galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),isSigned:i.isSigned,...i.telemetryData}}e.$Do=E,e.$Eo=new C.$2l("pprice.better-merge");function v(i,o){const y=[],d=o.manifest.extensionDependencies?.slice(0)??[];for(;d.length;){const I=d.shift();if(I&&y.every(S=>!R(S.identifier,{id:I}))){const S=i.filter(u=>R(u.identifier,{id:I}));S.length===1&&(y.push(S[0]),d.push(...S[0].manifest.extensionDependencies?.slice(0)??[]))}}return y}e.$Fo=v;async function r(i,o){if(!F.$l)return!1;let y;try{y=(await i.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{y=(await i.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(I){o.debug("Error while getting the os-release file.",(0,l.$9)(I))}}return!!y&&(y.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function s(i,o){const y=await r(i,o),d=(0,M.$1n)(y?"alpine":F.$u,k.$dc);return o.debug("ComputeTargetPlatform:",d),d}e.$Go=s}),define(Re[181],Me([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lr=e.$kr=e.$jr=e.$ir=e.$hr=e.$gr=void 0;function w(k){return[...k.entries()]}e.$gr=w;function M(k){return k?[...k.entries()]:[]}e.$hr=M;function C(k){return new Map(k)}e.$ir=C;function F(k){return new Map(k??[])}e.$jr=F;function A(k){return Array.from(k.entries()).map(f=>[f[0],w(f[1].map),M(f[1].descriptionMap)])}e.$kr=A;function l(k){return new Map(k.map(f=>[f[0],{map:C(f[1]),descriptionMap:F(f[2])}]))}e.$lr=l}),define(Re[182],Me([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lkb=void 0;class w{constructor(C){this.b=C,this.a=new Map}dispose(){for(const C of this.a.values())C.dispose()}startBuffering(C,F,A=5){const l=F(k=>{const f=typeof k=="string"?k:k.data;let R=this.a.get(C);if(R){R.data.push(f);return}const D=setTimeout(()=>this.flushBuffer(C),A);R={data:[f],timeoutId:D,dispose:()=>{clearTimeout(D),this.flushBuffer(C),l.dispose()}},this.a.set(C,R)});return l}stopBuffering(C){this.a.get(C)?.dispose()}flushBuffer(C){const F=this.a.get(C);F&&(this.a.delete(C),this.b(C,F.data.join("")))}}e.$Lkb=w}),define(Re[183],Me([1,0,12,89,40,5,16,2,144,72,30]),function(be,e,w,M,C,F,A,l,k,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7v=e.$6v=e.$5v=e.$4v=e.$3v=e.$2v=e.$1v=e.$Zv=e.IconFontDefinition=e.IconContribution=e.$Yv=void 0,e.$Yv={IconContribution:"base.contributions.icons"};var D;(function(E){function v(r,s){let i=r.defaults;for(;C.ThemeIcon.isThemeIcon(i);){const o=$.getIcon(i.id);if(!o)return;i=o.defaults}return i}E.getDefinition=v})(D||(e.IconContribution=D={}));var c;(function(E){function v(s){return{weight:s.weight,style:s.style,src:s.src.map(i=>({format:i.format,location:i.location.toString()}))}}E.toJSONObject=v;function r(s){const i=o=>(0,A.$xf)(o)?o:void 0;if(s&&Array.isArray(s.src)&&s.src.every(o=>(0,A.$xf)(o.format)&&(0,A.$xf)(o.location)))return{weight:i(s.weight),style:i(s.style),src:s.src.map(o=>({format:o.format,location:l.URI.parse(o.location)}))}}E.fromJSONObject=r})(c||(e.IconFontDefinition=c={}));class p{constructor(){this.a=new F.$Md,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,k.localize)(0,null)},fontCharacter:{type:"string",description:(0,k.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${C.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(v,r,s,i){const o=this.b[v];if(o){if(s&&!o.description){o.description=s,this.d.properties[v].markdownDescription=`${s} $(${v})`;const I=this.e.enum.indexOf(v);I!==-1&&(this.e.enumDescriptions[I]=s),this.a.fire()}return o}const y={id:v,description:s,defaults:r,deprecationMessage:i};this.b[v]=y;const d={$ref:"#/definitions/icons"};return i&&(d.deprecationMessage=i),s&&(d.markdownDescription=`${s}: $(${v})`),this.d.properties[v]=d,this.e.enum.push(v),this.e.enumDescriptions.push(s||""),this.a.fire(),{id:v}}deregisterIcon(v){delete this.b[v],delete this.d.properties[v];const r=this.e.enum.indexOf(v);r!==-1&&(this.e.enum.splice(r,1),this.e.enumDescriptions.splice(r,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(v=>this.b[v])}getIcon(v){return this.b[v]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(v,r){const s=this.f[v];return s||(this.f[v]=r,this.a.fire(),r)}deregisterIconFont(v){delete this.f[v]}getIconFont(v){return this.f[v]}toString(){const v=(o,y)=>o.id.localeCompare(y.id),r=o=>{for(;C.ThemeIcon.isThemeIcon(o.defaults);)o=this.b[o.defaults.id];return`codicon codicon-${o?o.id:""}`},s=[];s.push("| preview     | identifier                        | default codicon ID                | description"),s.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const i=Object.keys(this.b).map(o=>this.b[o]);for(const o of i.filter(y=>!!y.description).sort(v))s.push(`|<i class="${r(o)}"></i>|${o.id}|${C.ThemeIcon.isThemeIcon(o.defaults)?o.defaults.id:o.id}|${o.description||""}|`);s.push("| preview     | identifier                        "),s.push("| ----------- | --------------------------------- |");for(const o of i.filter(y=>!C.ThemeIcon.isThemeIcon(y.defaults)).sort(v))s.push(`|<i class="${r(o)}"></i>|${o.id}|`);return s.join(`
`)}}const $=new p;R.$bn.add(e.$Yv.IconContribution,$);function g(E,v,r,s){return $.registerIcon(E,v,r,s)}e.$Zv=g;function t(){return $}e.$1v=t;function n(){const E=(0,M.$Qj)();for(const v in E){const r="\\"+E[v].toString(16);$.registerIcon(v,{fontCharacter:r})}}n(),e.$2v="vscode://schemas/icons";const a=R.$bn.as(f.$cn.JSONContribution);a.registerSchema(e.$2v,$.getIconSchema());const b=new w.$5g(()=>a.notifySchemaChanged(e.$2v),200);$.onDidChange(()=>{b.isScheduled()||b.schedule()}),e.$3v=g("widget-close",M.$Sj.close,(0,k.localize)(2,null)),e.$4v=g("goto-previous-location",M.$Sj.arrowUp,(0,k.localize)(3,null)),e.$5v=g("goto-next-location",M.$Sj.arrowDown,(0,k.localize)(4,null)),e.$6v=C.ThemeIcon.modify(M.$Sj.sync,"spin"),e.$7v=C.ThemeIcon.modify(M.$Sj.loading,"spin")}),define(Re[184],Me([1,0,5,43,4,14]),function(be,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bv=e.$av=e.$_u=e.$$u=e.$0u=e.$9u=e.$8u=e.$7u=e.ProvidedOnAutoForward=e.$6u=e.TunnelPrivacyId=e.TunnelProtocol=e.$5u=e.$4u=void 0,e.$4u=(0,C.$Nh)("tunnelService"),e.$5u=(0,C.$Nh)("sharedTunnelsService");var A;(function(t){t.Http="http",t.Https="https"})(A||(e.TunnelProtocol=A={}));var l;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})(l||(e.TunnelPrivacyId=l={}));function k(t){return!!t.forwardPort}e.$6u=k;var f;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(f||(e.ProvidedOnAutoForward=f={}));function R(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const n=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(n)return{address:n[1],port:+n[2]}}e.$7u=R,e.$8u=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function D(t){return e.$8u.indexOf(t)>=0}e.$9u=D,e.$0u=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function c(t){return e.$0u.indexOf(t)>=0}e.$$u=c;function p(t,n,a,b){if(a===1)return!1;if(a===2&&c(n)){const E=/(\d+)\.(\d+)\.(\d+)/g.exec(b);if(E?.length===4&&parseInt(E[1])>=18)return!1}return t<1024}e.$_u=p;class ${constructor(n,a,b){this.remoteAddress=n,this.localAddress=a,this.b=b,this.a=new w.$Md,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$av=$;let g=class{constructor(n,a){this.j=n,this.k=a,this.a=new w.$Md,this.onTunnelOpened=this.a.event,this.b=new w.$Md,this.onTunnelClosed=this.b.event,this.c=new w.$Md,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const n=this.k.getValue("remote.localPortHost");return!n||n==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(n){return this.f=n,n?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(n){this.g=n.elevation,this.h=n.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const n=[],a=Array.from(this.e.values());for(const b of a){const E=Array.from(b.values());for(const v of E){const r=await v.value;r&&typeof r!="string"&&n.push(r)}}return n}async dispose(){for(const n of this.e.values()){for(const{value:a}of n.values())await a.then(b=>typeof b!="string"?b?.dispose():void 0);n.clear()}this.e.clear()}setEnvironmentTunnel(n,a,b,E,v){this.p(n,a,Promise.resolve({tunnelRemoteHost:n,tunnelRemotePort:a,localAddress:b,privacy:E,protocol:v,dispose:()=>Promise.resolve()}))}async getExistingTunnel(n,a){(c(n)||D(n))&&(n=e.$8u[0]);const b=this.r(n,a);if(b)return++b.refcount,b.value}openTunnel(n,a,b,E,v,r=!1,s,i){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${a}:${b} on local port ${v}.`);const o=this.f??n;if(!o)return;if(a||(a="localhost"),E||(E=this.l),this.f&&this.i.has(b)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const y=this.s(o,a,b,E,v,r,s,i);return y?y.then(d=>{if(d){if(typeof d=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(a,b),d}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(a,b);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const I=this.n(d);return(d.tunnelRemoteHost!==a||d.tunnelRemotePort!==b)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),s&&d.privacy!==s&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(I),I}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),y)}n(n){return{tunnelRemotePort:n.tunnelRemotePort,tunnelRemoteHost:n.tunnelRemoteHost,tunnelLocalPort:n.tunnelLocalPort,localAddress:n.localAddress,privacy:n.privacy,protocol:n.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${n.tunnelRemoteHost}:${n.tunnelRemotePort} `);const a=this.e.get(n.tunnelRemoteHost);if(a){const b=a.get(n.tunnelRemotePort);b&&(b.refcount--,await this.o(n.tunnelRemoteHost,n.tunnelRemotePort,b))}}}}async o(n,a,b){if(b.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${n}:${a}.`);const E=b.value.then(async v=>{v&&typeof v!="string"&&(await v.dispose(!0),this.b.fire({host:v.tunnelRemoteHost,port:v.tunnelRemotePort}))});return this.e.has(n)&&this.e.get(n).delete(a),E}}async closeTunnel(n,a){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${n}:${a} `);const b=this.e.get(n);if(b&&b.has(a)){const E=b.get(a);E.refcount=0,await this.o(n,a,E)}}p(n,a,b){this.e.has(n)||this.e.set(n,new Map),this.e.get(n).set(a,{refcount:1,value:b})}async q(n,a){const b=this.e.get(n);if(b){const E=b.get(a),v=E?await E.value:void 0;(!v||typeof v=="string")&&b.delete(a),b.size===0&&this.e.delete(n)}}r(n,a){const b=[n];D(n)?(b.push(...e.$8u),b.push(...e.$0u)):c(n)&&b.push(...e.$0u);const E=b.map(v=>this.e.get(v));for(const v of E){const r=v?.get(a);if(r)return r}}canTunnel(n){return!!R(n)}t(n,a,b,E,v,r,s){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${a}:${b} on local port ${E}.`);const i=b;this.i.add(i);const o=E===void 0?b:E,y={elevationRequired:v?this.isPortPrivileged(o):!1},d={remoteAddress:{host:a,port:b},localAddressPort:E,privacy:r,public:r?r!==l.Private:void 0,protocol:s},I=n.forwardPort(d,y);return I?(this.p(a,b,I),I.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(i)})):this.i.delete(i),I}};e.$bv=g,e.$bv=g=qe([We(0,F.$8i),We(1,M.$hi)],g)}),define(Re[185],Me([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$cv=void 0,e.$cv=(0,w.$Nh)("editSessionIdentityService");var M;(function(C){C[C.Complete=100]="Complete",C[C.Partial=50]="Partial",C[C.None=0]="None"})(M||(e.EditSessionIdentityMatch=M={}))}),define(Re[186],Me([1,0,13]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MJ=e.$LJ=e.$KJ=e.$JJ=e.$IJ=void 0;function M(k){return k.scheme!==w.Schemas.file&&k.scheme!==w.Schemas.vscodeRemote}e.$IJ=M;function C(k){if(k.folders.length)return k.folders.every(f=>M(f.uri))?k.folders[0].uri:void 0;if(k.configuration&&M(k.configuration))return k.configuration}e.$JJ=C;function F(k){return C(k)?.scheme}e.$KJ=F;function A(k){return C(k)?.authority}e.$LJ=A;function l(k){return C(k)!==void 0}e.$MJ=l}),define(Re[54],Me([1,0,145,19,49,23,2,4,13]),function(be,e,w,M,C,F,A,l,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=e.$6h=e.$5h=e.WorkbenchState=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=void 0,e.$Wh=(0,l.$Nh)("contextService");function f(o){const y=o;return typeof y?.id=="string"&&A.URI.isUri(y.uri)}e.$Xh=f;function R(o){return typeof o?.id=="string"&&!f(o)&&!c(o)}e.$Yh=R,e.$Zh={id:"ext-dev"},e.$1h={id:"empty-window"};function D(o,y){if(typeof o=="string"||typeof o>"u")return typeof o=="string"?{id:(0,M.$mc)(o)}:y?e.$Zh:e.$1h;const d=o;return d.configuration?{id:d.id,configPath:d.configuration}:d.folders.length===1?{id:d.id,uri:d.folders[0].uri}:{id:d.id}}e.$2h=D;function c(o){const y=o;return typeof y?.id=="string"&&A.URI.isUri(y.configPath)}e.$3h=c;function p(o){const y=o;if(y?.uri)return{id:y.id,uri:A.URI.revive(y.uri)};const d=o;if(d?.configPath)return{id:d.id,configPath:A.URI.revive(d.configPath)};if(o?.id)return{id:o.id}}e.$4h=p;var $;(function(o){o[o.EMPTY=1]="EMPTY",o[o.FOLDER=2]="FOLDER",o[o.WORKSPACE=3]="WORKSPACE"})($||(e.WorkbenchState=$={}));function g(o){const y=o;return!!(y&&typeof y=="object"&&typeof y.id=="string"&&Array.isArray(y.folders))}e.$5h=g;function t(o){const y=o;return!!(y&&typeof y=="object"&&A.URI.isUri(y.uri)&&typeof y.name=="string"&&typeof y.toResource=="function")}e.$6h=t;class n{constructor(y,d,I,S,u){this.h=y,this.j=I,this.k=S,this.l=u,this.c=C.$Th.forUris(this.l,()=>!0),this.folders=d}update(y){this.h=y.id,this.k=y.configuration,this.j=y.transient,this.l=y.l,this.folders=y.folders}get folders(){return this.g}set folders(y){this.g=y,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(y){this.k=y}getFolder(y){return y&&this.c.findSubstr(y)||null}n(){this.c=C.$Th.forUris(this.l,()=>!0);for(const y of this.folders)this.c.set(y.uri,y)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$7h=n;class a{constructor(y,d){this.raw=d,this.uri=y.uri,this.index=y.index,this.name=y.name}toResource(y){return(0,F.$ug)(this.uri,y)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$8h=a;function b(o){return new a({uri:o,index:0,name:(0,F.$qg)(o)},{uri:o.toString()})}e.$9h=b,e.$0h="code-workspace",e.$$h=`.${e.$0h}`,e.$_h=[{name:(0,w.localize)(0,null),extensions:[e.$0h]}],e.$ai="workspace.json";function E(o,y){return F.$lg.isEqualOrParent(o,y.untitledWorkspacesHome)}e.$bi=E;function v(o){let y;return A.URI.isUri(o)?y=o:y=o.configuration,y?.scheme===k.Schemas.tmp}e.$ci=v,e.$di="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function r(o){return o.id===e.$di}e.$ei=r;function s(o,y){return!E(o,y)&&!v(o)}e.$fi=s;function i(o){return(typeof o=="string"?(0,M.$nc)(o):(0,F.$sg)(o))===e.$$h}e.$gi=i}),define(Re[74],Me([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jbc=void 0;class w{static{this.a=!1}constructor(C){this.d=C,this.b=new Map,this.c=1}add(C){const F=this.c++;return this.b.set(F,C),this.e(),F}get(C,F){return this.b.has(C)?this.b.get(C)[F]:void 0}delete(C){this.b.delete(C),this.e()}e(){w.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Jbc=w}),define(Re[39],Me([1,0,13,23,4]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mbc=e.$Lbc=void 0;class F{constructor(){this.a=new Set(Object.keys(w.Schemas)),this.b=new Map,this.extUri=new M.$jg(l=>{const k=this.b.get(l.scheme);return!(k===void 0||k&1024)})}$acceptProviderInfos(l,k){k===null?this.b.delete(l.scheme):this.b.set(l.scheme,k)}isFreeScheme(l){return!this.b.has(l)&&!this.a.has(l)}getCapabilities(l){return this.b.get(l)}}e.$Lbc=F,e.$Mbc=(0,C.$Nh)("IExtHostFileSystemInfo")}),define(Re[27],Me([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qM=void 0,e.$qM=(0,w.$Nh)("IExtHostInitDataService")}),define(Re[187],Me([1,0,150,14,174,27]),function(be,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sdc=void 0;let A=class extends C.$xN{constructor(k,f,R){const D=R.remote.isRemote?"remoteexthost":k?"workerexthost":"exthost",c=R.remote.isRemote?(0,w.localize)(0,null):k?(0,w.localize)(1,null):(0,w.localize)(2,null);super(f.createLogger(D,{name:c}))}};e.$Sdc=A,e.$Sdc=A=qe([We(1,M.$9i),We(2,F.$qM)],A)}),define(Re[188],Me([1,0,12]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dcc=e.$ccc=void 0;class M{constructor(A,l,k){this.h=new Map,this.a=A,this.b=l,this.c=k,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(f=>(this.f=f,this)),this.g=this.c.onDidChangeStorage(f=>{f.shared===this.b&&f.key===this.a&&(this.f=f.value)}),this.i=new w.$5g(()=>{const f=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const R of f.values())R.complete()}catch(R){for(const D of f.values())D.error(R)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this.d}get(A,l){let k=this.f[A];return typeof k>"u"&&(k=l),k}update(A,l){this.f[A]=l;const k=this.h.get(A);if(k!==void 0)return k.p;const f=new w.$bh;return this.h.set(A,f),this.i.isScheduled()||this.i.schedule(),f.p}dispose(){this.g.dispose()}}e.$ccc=M;class C extends M{setKeysForSync(A){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},A)}constructor(A,l){super(A.identifier.value,!0,l),this.j=A}}e.$dcc=C}),define(Re[189],Me([1,0,5,2]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bdc=void 0;class C{constructor(A){this.c=A,this.a=new w.$Md,this.onDidSaveNotebookDocument=this.a.event,this.b=new w.$Md,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(A,l,k,f){const D=this.c.getNotebookDocument(M.URI.revive(A)).acceptModelChanged(l.value,k,f);this.b.fire(D)}$acceptDirtyStateChanged(A,l){this.c.getNotebookDocument(M.URI.revive(A)).acceptDirty(l)}$acceptModelSaved(A){const l=this.c.getNotebookDocument(M.URI.revive(A));this.a.fire(l.apiNotebook)}}e.$Bdc=C}),define(Re[17],Me([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bM=e.$aM=void 0,e.$aM=(0,w.$Nh)("IExtHostRpcService");class M{constructor(F){this.getProxy=F.getProxy.bind(F),this.set=F.set.bind(F),this.dispose=F.dispose.bind(F),this.assertRegistered=F.assertRegistered.bind(F),this.drain=F.drain.bind(F)}}e.$bM=M}),define(Re[190],Me([1,0,20,5]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$occ=void 0;class C{#e;constructor(A,l){this.b=new M.$Md,this.onDidChange=this.b.event,this.a=w.$2l.toKey(A.identifier),this.#e=l,this.#e.onDidChangePassword(k=>{k.extensionId===this.a&&this.b.fire({key:k.key})})}get(A){return this.#e.get(this.a,A)}store(A,l){return this.#e.store(this.a,A,l)}delete(A){return this.#e.delete(this.a,A)}}e.$occ=C}),define(Re[55],Me([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xbc=e.$Wbc=void 0,e.$Wbc=(0,w.$Nh)("IURITransformerService");class M{constructor(F){F?(this.transformIncoming=F.transformIncoming.bind(F),this.transformOutgoing=F.transformOutgoing.bind(F),this.transformOutgoingURI=F.transformOutgoingURI.bind(F),this.transformOutgoingScheme=F.transformOutgoingScheme.bind(F)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.$Xbc=M}),define(Re[191],Me([1,0,26]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$scb=e.$rcb=void 0;class M{constructor(){this.buffers=[]}add(k){let f=this.buffers.indexOf(k);return f<0&&(f=this.buffers.length,this.buffers.push(k)),f}}function C(l,k){if(k.serializeBuffersForPostMessage){const f=new M,D=JSON.stringify(l,(p,$)=>{if($ instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:f.add($)};if(ArrayBuffer.isView($)){const g=F($);if(g)return{$$vscode_array_buffer_reference$$:!0,index:f.add($.buffer),view:{type:g,byteLength:$.byteLength,byteOffset:$.byteOffset}}}return $}),c=f.buffers.map(p=>{const $=new Uint8Array(p);return w.$ae.wrap($)});return{message:D,buffers:c}}else return{message:JSON.stringify(l),buffers:[]}}e.$rcb=C;function F(l){switch(l.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(l,k){const f=k.map(c=>{const p=new ArrayBuffer(c.byteLength);return new Uint8Array(p).set(c.buffer),p}),R=k.length?(c,p)=>{if(p&&typeof p=="object"&&p.$$vscode_array_buffer_reference$$){const $=p,{index:g}=$,t=f[g];if($.view)switch($.view.type){case 1:return new Int8Array(t,$.view.byteOffset,$.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(t,$.view.byteOffset,$.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(t,$.view.byteOffset,$.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(t,$.view.byteOffset,$.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(t,$.view.byteOffset,$.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(t,$.view.byteOffset,$.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(t,$.view.byteOffset,$.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(t,$.view.byteOffset,$.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(t,$.view.byteOffset,$.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(t,$.view.byteOffset,$.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(t,$.view.byteOffset,$.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return t}return p}:void 0;return{message:JSON.parse(l,R),arrayBuffers:f}}e.$scb=A}),define(Re[99],Me([1,0,159,16,2,6,4,30,38,13,41,127,29]),function(be,e,w,M,C,F,A,l,k,f,R,D,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aE=e.$_D=e.$$D=e.EditorsOrder=e.$0D=e.CloseDirection=e.$9D=e.$8D=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$7D=e.$6D=e.$5D=e.$4D=e.$3D=e.$2D=e.$1D=e.$ZD=e.EditorInputCapabilities=e.$YD=e.SaveReason=e.Verbosity=e.$XD=e.$WD=e.$VD=e.$UD=e.$TD=e.$SD=e.$RD=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$QD=e.$PD=e.$OD=e.$ND=e.$MD=void 0,e.$MD={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$ND={id:"default",displayName:(0,w.localize)(0,null),providerDisplayName:(0,w.localize)(1,null)},e.$OD="workbench.editor.sidebysideEditor",e.$PD="workbench.editors.textDiffEditor",e.$QD="workbench.editors.binaryResourceDiffEditor";var p;(function(ue){ue[ue.PROGRAMMATIC=1]="PROGRAMMATIC",ue[ue.USER=2]="USER",ue[ue.EDIT=3]="EDIT",ue[ue.NAVIGATION=4]="NAVIGATION",ue[ue.JUMP=5]="JUMP"})(p||(e.EditorPaneSelectionChangeReason=p={}));var $;(function(ue){ue[ue.IDENTICAL=1]="IDENTICAL",ue[ue.SIMILAR=2]="SIMILAR",ue[ue.DIFFERENT=3]="DIFFERENT"})($||(e.EditorPaneSelectionCompareResult=$={}));function g(ue){const $e=ue;return!!$e&&typeof $e.getSelection=="function"&&!!$e.onDidChangeSelection}e.$RD=g;function t(ue,$e,ie){for(const z of ie.visibleEditorPanes)if(z.group.id===$e&&ue.matches(z.input))return z.getViewState()}e.$SD=t;function n(ue){if(d(ue))return!1;const $e=ue;return C.URI.isUri($e?.resource)}e.$TD=n;function a(ue){if(d(ue))return!1;const $e=ue;return $e?.original!==void 0&&$e.modified!==void 0}e.$UD=a;function b(ue){if(d(ue)||a(ue))return!1;const $e=ue;return $e?.primary!==void 0&&$e.secondary!==void 0}e.$VD=b;function E(ue){if(d(ue))return!1;const $e=ue;return $e?$e.resource===void 0||$e.resource.scheme===f.Schemas.untitled||$e.forceUntitled===!0:!1}e.$WD=E;function v(ue){if(d(ue))return!1;const $e=ue;return C.URI.isUri($e?.base?.resource)&&C.URI.isUri($e?.input1?.resource)&&C.URI.isUri($e?.input2?.resource)&&C.URI.isUri($e?.result?.resource)}e.$XD=v;var r;(function(ue){ue[ue.SHORT=0]="SHORT",ue[ue.MEDIUM=1]="MEDIUM",ue[ue.LONG=2]="LONG"})(r||(e.Verbosity=r={}));var s;(function(ue){ue[ue.EXPLICIT=1]="EXPLICIT",ue[ue.AUTO=2]="AUTO",ue[ue.FOCUS_CHANGE=3]="FOCUS_CHANGE",ue[ue.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(s||(e.SaveReason=s={}));class i{constructor(){this.a=new Map}registerSource($e,ie){let z=this.a.get($e);return z||(z={source:$e,label:ie},this.a.set($e,z)),z.source}getSourceLabel($e){return this.a.get($e)?.label??$e}}e.$YD=new i;var o;(function(ue){ue[ue.None=0]="None",ue[ue.Readonly=2]="Readonly",ue[ue.Untitled=4]="Untitled",ue[ue.Singleton=8]="Singleton",ue[ue.RequiresTrust=16]="RequiresTrust",ue[ue.CanSplitInGroup=32]="CanSplitInGroup",ue[ue.ForceDescription=64]="ForceDescription",ue[ue.CanDropIntoEditor=128]="CanDropIntoEditor",ue[ue.MultipleEditors=256]="MultipleEditors",ue[ue.Scratchpad=512]="Scratchpad"})(o||(e.EditorInputCapabilities=o={}));class y extends F.$Rc{}e.$ZD=y;function d(ue){return ue instanceof y}e.$1D=d;function I(ue){const $e=ue;return C.URI.isUri($e?.preferredResource)}function S(ue){const $e=ue;return d($e?.primary)&&d($e?.secondary)}e.$2D=S;function u(ue){const $e=ue;return d($e?.modified)&&d($e?.original)}e.$3D=u;function m(ue,$e,ie,z,V){return Se(z,[(0,D.$xi)({id:"workbench.action.openLargeFile",label:(0,w.localize)(2,null),run:()=>{const le={...ie,limits:{size:Number.MAX_VALUE}};ue.openEditor($e,le)}}),(0,D.$xi)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,w.localize)(3,null),run:()=>V.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:c.default.Warning})}e.$4D=m;function h(ue){return d(ue?.editor)}e.$5D=h;function P(ue){const $e=ue;return h(ue)&&$e?.group!==void 0}e.$6D=P;function W(ue){const $e=ue;return typeof $e?.groupId=="number"&&d($e.editor)}e.$7D=W;var K;(function(ue){ue[ue.UNKNOWN=0]="UNKNOWN",ue[ue.REPLACE=1]="REPLACE",ue[ue.MOVE=2]="MOVE",ue[ue.UNPIN=3]="UNPIN"})(K||(e.EditorCloseContext=K={}));var U;(function(ue){ue[ue.GROUP_ACTIVE=0]="GROUP_ACTIVE",ue[ue.GROUP_INDEX=1]="GROUP_INDEX",ue[ue.GROUP_LOCKED=2]="GROUP_LOCKED",ue[ue.EDITOR_OPEN=3]="EDITOR_OPEN",ue[ue.EDITOR_CLOSE=4]="EDITOR_CLOSE",ue[ue.EDITOR_MOVE=5]="EDITOR_MOVE",ue[ue.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",ue[ue.EDITOR_LABEL=7]="EDITOR_LABEL",ue[ue.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",ue[ue.EDITOR_PIN=9]="EDITOR_PIN",ue[ue.EDITOR_STICKY=10]="EDITOR_STICKY",ue[ue.EDITOR_DIRTY=11]="EDITOR_DIRTY",ue[ue.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(U||(e.GroupModelChangeKind=U={}));var B;(function(ue){ue[ue.PRIMARY=1]="PRIMARY",ue[ue.SECONDARY=2]="SECONDARY",ue[ue.BOTH=3]="BOTH",ue[ue.ANY=4]="ANY"})(B||(e.SideBySideEditor=B={}));class O{getOriginalUri($e,ie){if(!$e)return;if(v($e))return e.$9D.getOriginalUri($e.result,ie);if(ie?.supportSideBySide){const{primary:V,secondary:le}=this.a($e);if(V&&le){if(ie?.supportSideBySide===B.BOTH)return{primary:this.getOriginalUri(V,{filterByScheme:ie.filterByScheme}),secondary:this.getOriginalUri(le,{filterByScheme:ie.filterByScheme})};if(ie?.supportSideBySide===B.ANY)return this.getOriginalUri(V,{filterByScheme:ie.filterByScheme})??this.getOriginalUri(le,{filterByScheme:ie.filterByScheme});$e=ie.supportSideBySide===B.PRIMARY?V:le}}if(a($e)||b($e)||v($e))return;const z=I($e)?$e.preferredResource:$e.resource;return!z||!ie||!ie.filterByScheme?z:this.b(z,ie.filterByScheme)}a($e){return S($e)||b($e)?{primary:$e.primary,secondary:$e.secondary}:u($e)||a($e)?{primary:$e.modified,secondary:$e.original}:{primary:void 0,secondary:void 0}}getCanonicalUri($e,ie){if(!$e)return;if(v($e))return e.$9D.getCanonicalUri($e.result,ie);if(ie?.supportSideBySide){const{primary:V,secondary:le}=this.a($e);if(V&&le){if(ie?.supportSideBySide===B.BOTH)return{primary:this.getCanonicalUri(V,{filterByScheme:ie.filterByScheme}),secondary:this.getCanonicalUri(le,{filterByScheme:ie.filterByScheme})};if(ie?.supportSideBySide===B.ANY)return this.getCanonicalUri(V,{filterByScheme:ie.filterByScheme})??this.getCanonicalUri(le,{filterByScheme:ie.filterByScheme});$e=ie.supportSideBySide===B.PRIMARY?V:le}}if(a($e)||b($e)||v($e))return;const z=$e.resource;return!z||!ie||!ie.filterByScheme?z:this.b(z,ie.filterByScheme)}b($e,ie){if(Array.isArray(ie)){if(ie.some(z=>$e.scheme===z))return $e}else if(ie===$e.scheme)return $e}}var N;(function(ue){ue[ue.UNKNOWN=0]="UNKNOWN",ue[ue.KEYBOARD=1]="KEYBOARD",ue[ue.MOUSE=2]="MOUSE"})(N||(e.EditorCloseMethod=N={}));function te(ue,$e,ie,z){if(!ue.isSticky($e))return!1;switch(z.preventPinnedEditorClose){case"keyboardAndMouse":return ie===N.MOUSE||ie===N.KEYBOARD;case"mouse":return ie===N.MOUSE;case"keyboard":return ie===N.KEYBOARD}return!1}e.$8D=te,e.$9D=new O;var Y;(function(ue){ue[ue.LEFT=0]="LEFT",ue[ue.RIGHT=1]="RIGHT"})(Y||(e.CloseDirection=Y={}));class ye{constructor(){this.c=new Map,this.d=new Map}start($e){const ie=this.a=$e.get(A.$Mh);for(const[z,V]of this.c)this.e(z,V,ie);this.c.clear()}e($e,ie,z){const V=z.createInstance(ie);this.d.set($e,V)}registerFileEditorFactory($e){if(this.b)throw new Error("Can only register one file editor factory.");this.b=$e}getFileEditorFactory(){return(0,M.$If)(this.b)}registerEditorSerializer($e,ie){if(this.c.has($e)||this.d.has($e))throw new Error(`A editor serializer with type ID '${$e}' was already registered.`);return this.a?this.e($e,ie,this.a):this.c.set($e,ie),(0,F.$Pc)(()=>{this.c.delete($e),this.d.delete($e)})}getEditorSerializer($e){return this.d.get(typeof $e=="string"?$e:$e.typeId)}}l.$bn.add(e.$MD.EditorFactory,new ye);async function Ee(ue,$e,ie){return!ue||!ue.length?[]:await Promise.all(ue.map(async z=>{const V=C.URI.revive(z.fileUri);if(!V){ie.info("Cannot resolve the path because it is not valid.",z);return}if(!await $e.canHandleResource(V)){ie.info("Cannot resolve the path because it cannot be handled",z);return}let we=z.exists,ve=z.type;if(typeof we!="boolean"||typeof ve!="number")try{ve=(await $e.stat(V)).isDirectory?k.FileType.Directory:k.FileType.Unknown,we=!0}catch(De){ie.error(De),we=!1}if(!we&&z.openOnlyIfExists){ie.info("Cannot resolve the path because it does not exist",z);return}if(ve===k.FileType.Directory){ie.info("Cannot resolve the path because it is a directory",z);return}const me={...z.options,pinned:!0};return we?{resource:V,options:me}:{resource:V,options:me,forceUntitled:!0}}))}e.$0D=Ee;var Pe;(function(ue){ue[ue.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ue[ue.SEQUENTIAL=1]="SEQUENTIAL"})(Pe||(e.EditorsOrder=Pe={}));function X(ue){const $e=ue;if(!$e)return!1;const ie=$e;if(ie.modified)return X(ie.modified);const z=$e;return!!(z.contributionsState&&z.viewState&&Array.isArray(z.cursorState))}e.$$D=X;function ae(ue){return(0,R.$zi)(ue)}e.$_D=ae;function Se(ue,$e,ie){const z=(0,R.$Ai)(ue,$e);return z.forceMessage=ie?.forceMessage,z.forceSeverity=ie?.forceSeverity,z.allowDialog=ie?.allowDialog,z}e.$aE=Se}),define(Re[192],Me([1,0,5,160,4,6,28,30,18,24,89,183]),function(be,e,w,M,C,F,A,l,k,f,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lE=e.$kE=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$jE=e.$iE=e.ViewContentGroups=e.$hE=e.$gE=e.ViewContainerLocation=e.Extensions=e.$fE=e.$eE=e.$dE=void 0,e.$dE="views",e.$eE=(0,M.localize)(0,null),e.$fE=(0,D.$Zv)("default-view-icon",R.$Sj.window,(0,M.localize)(1,null));var c;(function(s){s.ViewContainersRegistry="workbench.registry.view.containers",s.ViewsRegistry="workbench.registry.view"})(c||(e.Extensions=c={}));var p;(function(s){s[s.Sidebar=0]="Sidebar",s[s.Panel=1]="Panel",s[s.AuxiliaryBar=2]="AuxiliaryBar"})(p||(e.ViewContainerLocation=p={})),e.$gE=[0,1,2];function $(s){switch(s){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$hE=$;class g extends F.$Rc{constructor(){super(...arguments),this.c=this.B(new w.$Md),this.onDidRegister=this.c.event,this.f=this.B(new w.$Md),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,k.$Qb)([...this.g.values()])}registerViewContainer(i,o,y){const d=this.get(i.id);if(d)return d;const I=i;return I.openCommandActionDescriptor=y?.doNotRegisterOpenCommand?void 0:I.openCommandActionDescriptor??{id:I.id},(0,A.$wc)(this.g,o,[]).push(I),y?.isDefault&&this.h.push(I),this.c.fire({viewContainer:I,viewContainerLocation:o}),I}deregisterViewContainer(i){for(const o of this.g.keys()){const y=this.g.get(o),d=y?.indexOf(i);if(d!==-1){y?.splice(d,1),y.length===0&&this.g.delete(o),this.f.fire({viewContainer:i,viewContainerLocation:o});return}}}get(i){return this.all.filter(o=>o.id===i)[0]}getViewContainers(i){return[...this.g.get(i)||[]]}getViewContainerLocation(i){return[...this.g.keys()].filter(o=>this.getViewContainers(o).filter(y=>y?.id===i.id).length>0)[0]}getDefaultViewContainer(i){return this.h.find(o=>this.getViewContainerLocation(o)===i)}}l.$bn.add(c.ViewContainersRegistry,new g);var t;(function(s){s.Open="2_open",s.Debug="4_debug",s.SCM="5_scm",s.More="9_more"})(t||(e.ViewContentGroups=t={}));function n(s,i){const o=s.group??t.More,y=i.group??t.More;return o!==y?o.localeCompare(y):(s.order??5)-(i.order??5)}class a extends F.$Rc{constructor(){super(...arguments),this.c=this.B(new w.$Md),this.onViewsRegistered=this.c.event,this.f=this.B(new w.$Md),this.onViewsDeregistered=this.f.event,this.g=this.B(new w.$Md),this.onDidChangeContainer=this.g.event,this.h=this.B(new w.$Md),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new A.$Fc}registerViews(i,o){this.registerViews2([{views:i,viewContainer:o}])}registerViews2(i){i.forEach(({views:o,viewContainer:y})=>this.r(o,y)),this.c.fire(i)}deregisterViews(i,o){const y=this.s(i,o);y.length&&this.f.fire({views:y,viewContainer:o})}moveViews(i,o){for(const y of this.m.keys())if(y!==o){const d=this.s(i,y);d.length&&(this.r(d,o),this.g.fire({views:d,from:y,to:o}))}}getViews(i){return this.m.get(i)||[]}getView(i){for(const o of this.j){const y=(this.m.get(o)||[]).filter(d=>d.id===i)[0];if(y)return y}return null}getViewContainer(i){for(const o of this.j)if((this.m.get(o)||[]).filter(d=>d.id===i)[0])return o;return null}registerViewWelcomeContent(i,o){return this.n.add(i,o),this.h.fire(i),(0,F.$Pc)(()=>{this.n.delete(i,o),this.h.fire(i)})}registerViewWelcomeContent2(i,o){const y=new Map;for(const[d,I]of o)this.n.add(i,I),y.set(d,(0,F.$Pc)(()=>{this.n.delete(i,I),this.h.fire(i)}));return this.h.fire(i),y}getViewWelcomeContent(i){const o=[];return this.n.forEach(i,y=>o.push(y)),o.sort(n)}r(i,o){let y=this.m.get(o);y||(y=[],this.m.set(o,y),this.j.push(o));for(const d of i){if(this.getView(d.id)!==null)throw new Error((0,M.localize)(2,null,d.id));y.push(d)}}s(i,o){const y=this.m.get(o);if(!y)return[];const d=[],I=[];for(const S of y)i.includes(S)?d.push(S):I.push(S);return d.length&&(I.length?this.m.set(o,I):(this.m.delete(o),this.j.splice(this.j.indexOf(o),1))),d}}l.$bn.add(c.ViewsRegistry,new a),e.$iE=(0,C.$Nh)("viewsService"),e.$jE=(0,C.$Nh)("viewDescriptorService");var b;(function(s){s[s.Default=0]="Default",s[s.Expand=1]="Expand"})(b||(e.ViewVisibilityState=b={}));var E;(function(s){s[s.None=0]="None",s[s.Collapsed=1]="Collapsed",s[s.Expanded=2]="Expanded"})(E||(e.TreeItemCollapsibleState=E={}));class v{constructor(i,o){this.c=!1,this.d=!1,(0,f.$5m)(this,i),this.d=!!o,this.resolve=async y=>{if(o&&!this.c){const d=await o(y);d&&(this.tooltip=this.tooltip??d.tooltip,this.command=this.command??d.command)}y.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$kE=v;class r extends Error{constructor(i){super((0,M.localize)(3,null,i)),this.name="NoTreeViewError"}static is(i){return i.name==="NoTreeViewError"}}e.$lE=r}),define(Re[193],Me([1,0,5,12,161]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xcb=void 0;class F{constructor(){this.f=new Map,this.k=[],this.m=new w.$Md,this.n=new w.$Md,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(l){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=l}onEvent(l){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=l}onRequest(l){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=l}sendResponse(l){l.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${l.command}`)):this.s("response",l)}sendRequest(l,k,f,R){const D={command:l};if(k&&Object.keys(k).length>0&&(D.arguments=k),this.s("request",D),typeof R=="number"){const c=setTimeout(()=>{clearTimeout(c);const p=this.f.get(D.seq);if(p){this.f.delete(D.seq);const $={type:"response",seq:0,request_seq:D.seq,success:!1,command:l,message:(0,C.localize)(0,null,R,l)};p($)}},R)}return f&&this.f.set(D.seq,f),D.seq}acceptMessage(l){this.j?this.j(l):(this.k.push(l),this.k.length===1&&this.q())}o(l,k){return l.type!=="event"||k.type!=="event"}async q(){let l;for(;this.k.length;){if((!l||this.o(this.k[0],l))&&await(0,M.$Tg)(0),l=this.k.shift(),!l)return;switch(l.type){case"event":this.i?.(l);break;case"request":this.g?.(l);break;case"response":{const k=l,f=this.f.get(k.request_seq);f&&(this.f.delete(k.request_seq),f(k));break}}}}s(l,k){k.type=l,k.seq=this.d++,this.sendMessage(k)}async u(){if(this.f.size===0)return Promise.resolve();const l=new Map;this.f.forEach((k,f)=>l.set(f,k)),await(0,M.$Tg)(500),l.forEach((k,f)=>{k({type:"response",seq:0,request_seq:f,success:!1,command:"canceled",message:"canceled"}),this.f.delete(f)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$Xcb=F}),define(Re[194],Me([1,0,162,32,4]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$2G=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$1G=e.MemoryRangeType=e.$ZG=e.State=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=e.$$F=e.$0F=e.$9F=e.$8F=e.$7F=e.$6F=e.$5F=e.$4F=e.$3F=e.$2F=e.$1F=e.$ZF=e.$YF=e.$XF=void 0,e.$XF="workbench.view.debug",e.$YF="workbench.debug.variablesView",e.$ZF="workbench.debug.watchExpressionsView",e.$1F="workbench.debug.callStackView",e.$2F="workbench.debug.loadedScriptsView",e.$3F="workbench.debug.breakPointsView",e.$4F="workbench.debug.disassemblyView",e.$5F="workbench.panel.repl",e.$6F="workbench.panel.repl.view",e.$7F=new M.$5i("debugType",void 0,{type:"string",description:w.localize(0,null)}),e.$8F=new M.$5i("debugConfigurationType",void 0,{type:"string",description:w.localize(1,null)}),e.$9F=new M.$5i("debugState","inactive",{type:"string",description:w.localize(2,null)}),e.$0F="debugUx",e.$$F=new M.$5i(e.$0F,"default",{type:"string",description:w.localize(3,null)}),e.$_F=new M.$5i("hasDebugged",!1,{type:"boolean",description:w.localize(4,null)}),e.$aG=new M.$5i("inDebugMode",!1,{type:"boolean",description:w.localize(5,null)}),e.$bG=new M.$5i("inDebugRepl",!1,{type:"boolean",description:w.localize(6,null)}),e.$cG=new M.$5i("breakpointWidgetVisible",!1,{type:"boolean",description:w.localize(7,null)}),e.$dG=new M.$5i("inBreakpointWidget",!1,{type:"boolean",description:w.localize(8,null)}),e.$eG=new M.$5i("breakpointsFocused",!0,{type:"boolean",description:w.localize(9,null)}),e.$fG=new M.$5i("watchExpressionsFocused",!0,{type:"boolean",description:w.localize(10,null)}),e.$gG=new M.$5i("watchExpressionsExist",!1,{type:"boolean",description:w.localize(11,null)}),e.$hG=new M.$5i("variablesFocused",!0,{type:"boolean",description:w.localize(12,null)}),e.$iG=new M.$5i("expressionSelected",!1,{type:"boolean",description:w.localize(13,null)}),e.$jG=new M.$5i("breakpointInputFocused",!1,{type:"boolean",description:w.localize(14,null)}),e.$kG=new M.$5i("callStackItemType",void 0,{type:"string",description:w.localize(15,null)}),e.$lG=new M.$5i("callStackSessionIsAttach",!1,{type:"boolean",description:w.localize(16,null)}),e.$mG=new M.$5i("callStackItemStopped",!1,{type:"boolean",description:w.localize(17,null)}),e.$nG=new M.$5i("callStackSessionHasOneThread",!1,{type:"boolean",description:w.localize(18,null)}),e.$oG=new M.$5i("watchItemType",void 0,{type:"string",description:w.localize(19,null)}),e.$pG=new M.$5i("canViewMemory",void 0,{type:"boolean",description:w.localize(20,null)}),e.$qG=new M.$5i("breakpointItemType",void 0,{type:"string",description:w.localize(21,null)}),e.$rG=new M.$5i("breakpointSupportsCondition",!1,{type:"boolean",description:w.localize(22,null)}),e.$sG=new M.$5i("loadedScriptsSupported",!1,{type:"boolean",description:w.localize(23,null)}),e.$tG=new M.$5i("loadedScriptsItemType",void 0,{type:"string",description:w.localize(24,null)}),e.$uG=new M.$5i("focusedSessionIsAttach",!1,{type:"boolean",description:w.localize(25,null)}),e.$vG=new M.$5i("stepBackSupported",!1,{type:"boolean",description:w.localize(26,null)}),e.$wG=new M.$5i("restartFrameSupported",!1,{type:"boolean",description:w.localize(27,null)}),e.$xG=new M.$5i("stackFrameSupportsRestart",!1,{type:"boolean",description:w.localize(28,null)}),e.$yG=new M.$5i("jumpToCursorSupported",!1,{type:"boolean",description:w.localize(29,null)}),e.$zG=new M.$5i("stepIntoTargetsSupported",!1,{type:"boolean",description:w.localize(30,null)}),e.$AG=new M.$5i("breakpointsExist",!1,{type:"boolean",description:w.localize(31,null)}),e.$BG=new M.$5i("debuggersAvailable",!1,{type:"boolean",description:w.localize(32,null)}),e.$CG=new M.$5i("debugExtensionAvailable",!0,{type:"boolean",description:w.localize(33,null)}),e.$DG=new M.$5i("debugProtocolVariableMenuContext",void 0,{type:"string",description:w.localize(34,null)}),e.$EG=new M.$5i("debugSetVariableSupported",!1,{type:"boolean",description:w.localize(35,null)}),e.$FG=new M.$5i("debugSetExpressionSupported",!1,{type:"boolean",description:w.localize(36,null)}),e.$GG=new M.$5i("breakWhenValueChangesSupported",!1,{type:"boolean",description:w.localize(37,null)}),e.$HG=new M.$5i("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:w.localize(38,null)}),e.$IG=new M.$5i("breakWhenValueIsReadSupported",!1,{type:"boolean",description:w.localize(39,null)}),e.$JG=new M.$5i("terminateDebuggeeSupported",!1,{type:"boolean",description:w.localize(40,null)}),e.$KG=new M.$5i("suspendDebuggeeSupported",!1,{type:"boolean",description:w.localize(41,null)}),e.$LG=new M.$5i("variableEvaluateNamePresent",!1,{type:"boolean",description:w.localize(42,null)}),e.$MG=new M.$5i("variableIsReadonly",!1,{type:"boolean",description:w.localize(43,null)}),e.$NG=new M.$5i("exceptionWidgetVisible",!1,{type:"boolean",description:w.localize(44,null)}),e.$OG=new M.$5i("multiSessionRepl",!1,{type:"boolean",description:w.localize(45,null)}),e.$PG=new M.$5i("multiSessionDebug",!1,{type:"boolean",description:w.localize(46,null)}),e.$QG=new M.$5i("disassembleRequestSupported",!1,{type:"boolean",description:w.localize(47,null)}),e.$RG=new M.$5i("disassemblyViewFocus",!1,{type:"boolean",description:w.localize(48,null)}),e.$SG=new M.$5i("languageSupportsDisassembleRequest",!1,{type:"boolean",description:w.localize(49,null)}),e.$TG=new M.$5i("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:w.localize(50,null)});const F=c=>w.localize(51,null,c);e.$UG=F,e.$VG="editor.contrib.debug",e.$WG="editor.contrib.breakpoint",e.$XG="debug",e.$YG={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:w.localize(52,null)};var A;(function(c){c[c.Inactive=0]="Inactive",c[c.Initializing=1]="Initializing",c[c.Stopped=2]="Stopped",c[c.Running=3]="Running"})(A||(e.State=A={}));function l(c){switch(c){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$ZG=l;var k;(function(c){c[c.Valid=0]="Valid",c[c.Unreadable=1]="Unreadable",c[c.Error=2]="Error"})(k||(e.MemoryRangeType=k={})),e.$1G="vscode-debug-memory";var f;(function(c){c[c.Initial=1]="Initial",c[c.Dynamic=2]="Dynamic"})(f||(e.DebugConfigurationProviderTriggerKind=f={}));var R;(function(c){c.UnverifiedBreakpoints="unverifiedBreakpoints"})(R||(e.DebuggerString=R={})),e.$2G=(0,C.$Nh)("debugService");var D;(function(c){c[c.CONDITION=0]="CONDITION",c[c.HIT_COUNT=1]="HIT_COUNT",c[c.LOG_MESSAGE=2]="LOG_MESSAGE"})(D||(e.BreakpointWidgetContext=D={}))}),define(Re[195],Me([1,0,15,2,19,24,13,44,21,18]),function(be,e,w,M,C,F,A,l,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yF=e.$xF=e.$wF=e.$vF=e.$uF=e.$tF=e.$sF=e.$rF=e.$qF=e.$pF=e.$oF=e.$nF=e.$mF=void 0;const R=/{([^}]+)}/g;function D(S,u,m){return S.replace(R,function(h,P){return u&&P.length>0&&P[0]!=="_"?h:m&&m.hasOwnProperty(P)?m[P]:h})}e.$mF=D;function c(S){const u={};for(const m of Object.keys(S))m.startsWith("!")||(u[m]=S[m]);return u}e.$nF=c;function p(S){return S.configuration.request==="attach"&&!$(S)&&(!S.parentSession||p(S.parentSession))}e.$oF=p;function $(S){let u=S.configuration.type;if(u)return u==="vslsShare"&&(u=S.configuration.adapterProxy.configuration.type),(0,w.$1e)(u,"extensionhost")||(0,w.$1e)(u,"pwa-extensionhost")?S:S.parentSession?$(S.parentSession):void 0}e.$pF=$;function g(S){return S.type&&(S.label||S.program||S.runtime)}e.$qF=g;function t(S,u,m){let h,P=0;const W=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let K=null;for(;K=W.exec(S);){const U=K.index+1,B=U+K[0].length;if(U<=u&&B>=m){h=K[0],P=U;break}}if(h){const U=/\w+/g;let B=null;for(;(B=U.exec(h))&&!(B.index+1+P+B[0].length>=m););B&&(h=h.substring(0,U.lastIndex))}return h?{start:P,end:P+h.length-1}:{start:0,end:0}}e.$rF=t;async function n(S,u,m,h){if(S.evaluatableExpressionProvider.has(u)){const P=S.evaluatableExpressionProvider.ordered(u),W=(0,f.$Gb)(await Promise.all(P.map(async K=>{try{return await K.provideEvaluatableExpression(u,m,h??k.CancellationToken.None)}catch{return}})));if(W.length>0){let K=W[0].expression;const U=W[0].range;return K||(K=u.getLineContent(m.lineNumber).substring(U.startColumn-1,U.endColumn-1)),{range:U,matchingExpression:K}}}else{const P=u.getLineContent(m.lineNumber),{start:W,end:K}=t(P,m.column,m.column),U=P.substring(W-1,K);return{matchingExpression:U,range:new l.$os(m.lineNumber,W,m.lineNumber,W+U.length)}}return null}e.$sF=n;const a=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function b(S){return!!(S&&S.match(a))}e.$tF=b;function E(S){if(typeof S.path=="string"&&!(typeof S.sourceReference=="number"&&S.sourceReference>0)){if(b(S.path))return M.URI.parse(S.path);if((0,C.$hc)(S.path))return M.URI.file(S.path)}return S.path}function v(S){if(typeof S.path=="object"){const u=M.URI.revive(S.path);if(u)return u.scheme===A.Schemas.file?u.fsPath:u.toString()}return S.path}function r(S,u){const m=u?E:v,h=(0,F.$2m)(S);return i(h,(P,W)=>{P&&W&&(W.path=m(W))}),h}e.$uF=r;function s(S,u){const m=u?E:v,h=(0,F.$2m)(S);return i(h,(P,W)=>{!P&&W&&(W.path=m(W))}),h}e.$vF=s;function i(S,u){switch(S.type){case"event":{const m=S;switch(m.event){case"output":u(!1,m.body.source);break;case"loadedSource":u(!1,m.body.source);break;case"breakpoint":u(!1,m.body.breakpoint.source);break;default:break}break}case"request":{const m=S;switch(m.command){case"setBreakpoints":u(!0,m.arguments.source);break;case"breakpointLocations":u(!0,m.arguments.source);break;case"source":u(!0,m.arguments.source);break;case"gotoTargets":u(!0,m.arguments.source);break;case"launchVSCode":m.arguments.args.forEach(h=>u(!1,h));break;default:break}break}case"response":{const m=S;if(m.success&&m.body)switch(m.command){case"stackTrace":m.body.stackFrames.forEach(h=>u(!1,h.source));break;case"loadedSources":m.body.sources.forEach(h=>u(!1,h));break;case"scopes":m.body.scopes.forEach(h=>u(!1,h.source));break;case"setFunctionBreakpoints":m.body.breakpoints.forEach(h=>u(!1,h.source));break;case"setBreakpoints":m.body.breakpoints.forEach(h=>u(!1,h.source));break;case"disassemble":m.body?.instructions.forEach(P=>u(!1,P.location));break;default:break}break}}}function o(S){return S.filter(u=>!u.presentation?.hidden).sort((u,m)=>u.presentation?m.presentation?u.presentation.group?m.presentation.group?u.presentation.group!==m.presentation.group?u.presentation.group.localeCompare(m.presentation.group):y(u.presentation.order,m.presentation.order):-1:m.presentation.group?1:y(u.presentation.order,m.presentation.order):-1:m.presentation?1:0)}e.$wF=o;function y(S,u){return typeof S!="number"?typeof u!="number"?0:1:typeof u!="number"?-1:S-u}async function d(S,u){const m=S.getValue("debug.saveBeforeStart",{overrideIdentifier:u.activeTextEditorLanguageId});if(m!=="none"&&(await u.saveAll(),m==="allEditorsInActiveGroup")){const h=u.activeEditorPane;h&&h.input.resource?.scheme===A.Schemas.untitled&&await u.save({editor:h.input,groupId:h.group.id})}await S.reloadConfiguration()}e.$xF=d;const I=(S,u)=>!S||!u?S===u:S.name===u.name&&S.path===u.path&&S.sourceReference===u.sourceReference;e.$yF=I}),define(Re[75],Me([1,0,26,37,65,66,13,19,22,32]),function(be,e,w,M,C,F,A,l,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nI=e.$mI=e.$lI=e.$kI=e.CellStatusbarAlignment=e.$jI=e.$iI=e.$hI=e.NotebookEditorPriority=e.$gI=e.$fI=e.$eI=e.$dI=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$cI=e.$bI=e.$aI=e.$_H=e.CellKind=e.$$H=e.$0H=e.$9H=void 0,e.$9H="workbench.editor.notebook",e.$0H="workbench.editor.notebookTextDiffEditor",e.$$H="workbench.editor.interactive";var R;(function(N){N[N.Markup=1]="Markup",N[N.Code=2]="Code"})(R||(e.CellKind=R={})),e.$_H=["application/json","application/javascript","text/html","image/svg+xml",F.$Lr.latex,F.$Lr.markdown,"image/png","image/jpeg",F.$Lr.text],e.$aI=[F.$Lr.latex,F.$Lr.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",F.$Lr.text],e.$bI=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$cI="_notAvailable";var D;(function(N){N[N.Running=1]="Running",N[N.Idle=2]="Idle"})(D||(e.NotebookRunState=D={}));var c;(function(N){N[N.Unconfirmed=1]="Unconfirmed",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(c||(e.NotebookCellExecutionState=c={}));var p;(function(N){N[N.Unconfirmed=1]="Unconfirmed",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(p||(e.NotebookExecutionState=p={}));var $;(function(N){N[N.WithHardKernelDependency=0]="WithHardKernelDependency",N[N.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",N[N.Pure=2]="Pure",N[N.Never=3]="Never"})($||(e.NotebookRendererMatch=$={}));var g;(function(N){N.Always="always",N.Never="never",N.Optional="optional"})(g||(e.RendererMessagingSpec=g={}));var t;(function(N){N[N.ModelChange=1]="ModelChange",N[N.Move=2]="Move",N[N.ChangeCellLanguage=5]="ChangeCellLanguage",N[N.Initialize=6]="Initialize",N[N.ChangeCellMetadata=7]="ChangeCellMetadata",N[N.Output=8]="Output",N[N.OutputItem=9]="OutputItem",N[N.ChangeCellContent=10]="ChangeCellContent",N[N.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",N[N.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",N[N.ChangeCellMime=13]="ChangeCellMime",N[N.Unknown=100]="Unknown"})(t||(e.NotebookCellsChangeType=t={}));var n;(function(N){N[N.Handle=0]="Handle",N[N.Index=1]="Index"})(n||(e.SelectionStateType=n={}));var a;(function(N){N[N.Replace=1]="Replace",N[N.Output=2]="Output",N[N.Metadata=3]="Metadata",N[N.CellLanguage=4]="CellLanguage",N[N.DocumentMetadata=5]="DocumentMetadata",N[N.Move=6]="Move",N[N.OutputItems=7]="OutputItems",N[N.PartialMetadata=8]="PartialMetadata",N[N.PartialInternalMetadata=9]="PartialInternalMetadata"})(a||(e.CellEditType=a={}));var b;(function(N){N.scheme=A.Schemas.vscodeNotebookCell;const te=["W","X","Y","Z","a","b","c","d","e","f"],Y=new RegExp(`^[${te.join("")}]+`),ye=7;function Ee($e,ie){const z=ie.toString(ye),le=`${z.length<te.length?te[z.length-1]:"z"}${z}s${(0,w.$ue)(w.$ae.fromString($e.scheme),!0,!0)}`;return $e.with({scheme:N.scheme,fragment:le})}N.generate=Ee;function Pe($e){if($e.scheme!==N.scheme)return;const ie=$e.fragment.indexOf("s");if(ie<0)return;const z=parseInt($e.fragment.substring(0,ie).replace(Y,""),ye),V=(0,w.$te)($e.fragment.substring(ie+1)).toString();if(!isNaN(z))return{handle:z,notebook:$e.with({scheme:V,fragment:null})}}N.parse=Pe;function X($e,ie){return $e.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${ie??""},${$e.scheme!==A.Schemas.file?$e.scheme:""}`})}N.generateCellOutputUri=X;function ae($e){if($e.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const ie=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec($e.fragment);if(!ie)return;const z=ie[1]&&ie[1]!==""?ie[1]:void 0,V=ie[2];return{outputId:z,notebook:$e.with({scheme:V||A.Schemas.file,fragment:null})}}N.parseCellOutputUri=ae;function Se($e,ie,z){return N.generate($e,ie).with({scheme:z})}N.generateCellPropertyUri=Se;function ue($e,ie){if($e.scheme===ie)return N.parse($e.with({scheme:N.scheme}))}N.parseCellPropertyUri=ue})(b||(e.CellUri=b={}));const E=N=>k.$j?N.replace(/\//g,"\\"):N;class v{constructor(te=[],Y=e.$_H){this.e=Y,this.d=[...new Set(te)].map(ye=>({pattern:ye,matches:M.$uj(E(ye))}))}sort(te){const Y=new Map(C.Iterable.map(te,Ee=>[Ee,E(Ee)]));let ye=[];for(const{matches:Ee}of this.d)for(const[Pe,X]of Y)if(Ee(X)){ye.push(Pe),Y.delete(Pe);break}return Y.size&&(ye=ye.concat([...Y.keys()].sort((Ee,Pe)=>this.e.indexOf(Ee)-this.e.indexOf(Pe)))),ye}prioritize(te,Y){const ye=this.f(te);if(ye===-1){this.d.unshift({pattern:te,matches:M.$uj(E(te))});return}const Ee=new Set(Y.map(X=>this.f(X,ye)));Ee.delete(-1);const Pe=Array.from(Ee).sort();this.d.splice(ye+1,0,...Pe.map(X=>this.d[X]));for(let X=Pe.length-1;X>=0;X--)this.d.splice(Pe[X],1)}toArray(){return this.d.map(te=>te.pattern)}f(te,Y=this.d.length){const ye=E(te);for(let Ee=0;Ee<Y;Ee++)if(this.d[Ee].matches(ye))return Ee;return-1}}e.$dI=v;function r(N,te,Y,ye=(Ee,Pe)=>Ee===Pe){const Ee=[];function Pe(Se,ue,$e){if(ue===0&&$e.length===0)return;const ie=Ee[Ee.length-1];ie&&ie.start+ie.deleteCount===Se?(ie.deleteCount+=ue,ie.toInsert.push(...$e)):Ee.push({start:Se,deleteCount:ue,toInsert:$e})}let X=0,ae=0;for(;;){if(X===N.length){Pe(X,0,te.slice(ae));break}if(ae===te.length){Pe(X,N.length-X,[]);break}const Se=N[X],ue=te[ae];if(ye(Se,ue)){X+=1,ae+=1;continue}Y(ue)?(Pe(X,1,[]),X+=1):(Pe(X,0,[ue]),ae+=1)}return Ee}e.$eI=r,e.$fI=new f.$5i("notebookEditorCursorAtBoundary","none"),e.$gI=new f.$5i("notebookEditorCursorAtLineBoundary","none");var s;(function(N){N.default="default",N.option="option"})(s||(e.NotebookEditorPriority=s={}));function i(N){const te=N;return!!((typeof te.include=="string"||M.$vj(te.include))&&(typeof te.exclude=="string"||M.$vj(te.exclude)))}e.$hI=i;function o(N,te,Y){if(Array.isArray(N.viewType)&&N.viewType.indexOf(te)>=0||N.viewType===te)return!0;if(N.filenamePattern){const ye=i(N.filenamePattern)?N.filenamePattern.include:N.filenamePattern,Ee=i(N.filenamePattern)?N.filenamePattern.exclude:void 0;if(M.$tj(ye,(0,l.$mc)(Y.fsPath).toLowerCase()))return!(Ee&&M.$tj(Ee,(0,l.$mc)(Y.fsPath).toLowerCase()))}return!1}e.$iI=o,e.$jI={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell"};var y;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(y||(e.CellStatusbarAlignment=y={}));class d{static{this.d="notebook/"}static create(te){return`${d.d}${te}`}static parse(te){if(te.startsWith(d.d))return te.substring(d.d.length)}}e.$kI=d;function I(N){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(N)}e.$lI=I;const S=new TextDecoder;function u(N){const te=[];let Y=!1;for(const X of N)(te.length===0||Y)&&(te.push(X),Y=!0);let ye=P(te);const Ee=w.$ae.concat(te.map(X=>w.$ae.wrap(X))),Pe=O(Ee);return ye=ye||Pe.byteLength!==Ee.byteLength,{data:Pe,didCompression:ye}}e.$mI=u,e.$nI=`${String.fromCharCode(27)}[A`;const m=e.$nI.split("").map(N=>N.charCodeAt(0)),h=10;function P(N){let te=!1;return N.forEach((Y,ye)=>{if(ye===0||Y.length<e.$nI.length)return;const Ee=N[ye-1],Pe=Y.subarray(0,e.$nI.length);if(Pe[0]===m[0]&&Pe[1]===m[1]&&Pe[2]===m[2]){const X=Ee.lastIndexOf(h);if(X===-1)return;te=!0,N[ye-1]=Ee.subarray(0,X),N[ye]=Y.subarray(e.$nI.length)}}),te}function W(N){let te=N;do N=te,te=N.replace(/[^\n]\x08/gm,"");while(te.length<N.length);return N}function K(N){for(N=N.replace(/\r+\n/gm,`
`);N.search(/\r[^$]/g)>-1;){const te=N.match(/^(.*)\r+/m)[1];let Y=N.match(/\r+(.*)$/m)[1];Y=Y+te.slice(Y.length,te.length),N=N.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,Y)}return N}const U="\b".charCodeAt(0),B="\r".charCodeAt(0);function O(N){return!N.buffer.includes(U)&&!N.buffer.includes(B)?N:w.$ae.fromString(K(W(S.decode(N.buffer))))}}),define(Re[7],Me([1,0,18,9,50,28,66,15,16,2,36,20,38,97,75]),function(be,e,w,M,C,F,A,l,k,f,R,D,c,p,$){"use strict";var g,t,n,a,b,E,v,r,s,i,o,y,d,I,S,u,m,h;Object.defineProperty(e,"__esModule",{value:!0}),e.RelatedInformationType=e.$2L=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$1L=e.$ZL=e.$YL=e.$XL=e.$WL=e.$VL=e.$UL=e.$TL=e.$SL=e.$RL=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$QL=e.$PL=e.$OL=e.$NL=e.$ML=e.$LL=e.$KL=e.$JL=e.TestRunProfileKind=e.TestResultState=e.$IL=e.$HL=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$GL=e.$FL=e.$EL=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$DL=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$CL=e.$BL=e.$AL=e.$zL=e.$yL=e.ColorThemeKind=e.$xL=e.$wL=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$vL=e.DebugConsoleMode=e.$uL=e.$tL=e.$sL=e.$rL=e.$qL=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$pL=e.$oL=e.FileChangeType=e.$nL=e.$mL=e.$lL=e.$kL=e.InlineCompletionTriggerKind=e.$jL=e.$iL=e.$hL=e.$gL=e.$fL=e.$eL=e.$dL=e.$cL=e.$bL=e.$aL=e.$_K=e.$$K=e.$0K=e.ConfigurationTarget=e.$9K=e.$8K=e.$7K=e.$6K=e.$5K=e.$4K=e.$3K=e.$2K=e.$1K=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$ZK=e.ViewBadge=e.ProgressLocation=e.$YK=e.$XK=e.TaskScope=e.ShellQuoting=e.$WK=e.$VK=e.$UK=e.TaskPanelKind=e.TaskRevealKind=e.$TK=e.TerminalLocation=e.$SK=e.$RK=e.$QK=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$PK=e.$OK=e.$NK=e.$MK=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$LK=e.StatusBarAlignment=e.ViewColumn=e.$KK=e.$JK=e.$IK=e.$HK=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$GK=e.$FK=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$EK=e.$DK=e.$CK=e.$BK=e.$AK=e.LanguageStatusSeverity=e.$zK=e.$yK=e.$xK=e.$wK=e.$vK=e.$uK=e.CodeActionTriggerKind=e.$tK=e.$sK=e.SymbolTag=e.SymbolKind=e.$rK=e.DocumentHighlightKind=e.$qK=e.$pK=e.$oK=e.$nK=e.DiagnosticSeverity=e.DiagnosticTag=e.$mK=e.$lK=e.FileEditType=e.$kK=e.$jK=e.$iK=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$hK=e.$gK=e.$fK=e.$eK=e.$dK=e.$cK=e.$bK=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function P(j){return Object.assign(j,{apply:function(...ne){if(ne.length===0)return Reflect.construct(j,[]);{const ke=ne.length===1?[]:ne[1];return Reflect.construct(j,ke,ne[0].constructor)}},call:function(...ne){if(ne.length===0)return Reflect.construct(j,[]);{const[ke,...He]=ne;return Reflect.construct(j,He,ke.constructor)}}})}var W;(function(j){j[j.Top=0]="Top",j[j.Bottom=1]="Bottom"})(W||(e.TerminalOutputAnchor=W={}));var K;(function(j){j[j.TerminalCommand=0]="TerminalCommand",j[j.Opener=1]="Opener",j[j.Command=3]="Command"})(K||(e.TerminalQuickFixType=K={}));let U=g=class{static from(...L){let ne=L;return new g(function(){if(ne){for(const ke of ne)ke&&typeof ke.dispose=="function"&&ke.dispose();ne=void 0}})}#e;constructor(L){this.#e=L}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$bK=U,e.$bK=U=g=qe([P],U);let B=t=class{static Min(...L){if(L.length===0)throw new TypeError;let ne=L[0];for(let ke=1;ke<L.length;ke++){const He=L[ke];He.isBefore(ne)&&(ne=He)}return ne}static Max(...L){if(L.length===0)throw new TypeError;let ne=L[0];for(let ke=1;ke<L.length;ke++){const He=L[ke];He.isAfter(ne)&&(ne=He)}return ne}static isPosition(L){if(!L)return!1;if(L instanceof t)return!0;const{line:ne,character:ke}=L;return typeof ne=="number"&&typeof ke=="number"}static of(L){if(L instanceof t)return L;if(this.isPosition(L))return new t(L.line,L.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(L,ne){if(L<0)throw(0,M.$6)("line must be non-negative");if(ne<0)throw(0,M.$6)("character must be non-negative");this.c=L,this.e=ne}isBefore(L){return this.c<L.c?!0:L.c<this.c?!1:this.e<L.e}isBeforeOrEqual(L){return this.c<L.c?!0:L.c<this.c?!1:this.e<=L.e}isAfter(L){return!this.isBeforeOrEqual(L)}isAfterOrEqual(L){return!this.isBefore(L)}isEqual(L){return this.c===L.c&&this.e===L.e}compareTo(L){return this.c<L.c?-1:this.c>L.line?1:this.e<L.e?-1:this.e>L.e?1:0}translate(L,ne=0){if(L===null||ne===null)throw(0,M.$6)();let ke;return typeof L>"u"?ke=0:typeof L=="number"?ke=L:(ke=typeof L.lineDelta=="number"?L.lineDelta:0,ne=typeof L.characterDelta=="number"?L.characterDelta:0),ke===0&&ne===0?this:new t(this.line+ke,this.character+ne)}with(L,ne=this.character){if(L===null||ne===null)throw(0,M.$6)();let ke;return typeof L>"u"?ke=this.line:typeof L=="number"?ke=L:(ke=typeof L.line=="number"?L.line:this.line,ne=typeof L.character=="number"?L.character:this.character),ke===this.line&&ne===this.character?this:new t(ke,ne)}toJSON(){return{line:this.line,character:this.character}}};e.$cK=B,e.$cK=B=t=qe([P],B);let O=n=class{static isRange(L){return L instanceof n?!0:L?B.isPosition(L.start)&&B.isPosition(L.end):!1}static of(L){if(L instanceof n)return L;if(this.isRange(L))return new n(L.start,L.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(L,ne,ke,He){let Ye,ot;if(typeof L=="number"&&typeof ne=="number"&&typeof ke=="number"&&typeof He=="number"?(Ye=new B(L,ne),ot=new B(ke,He)):B.isPosition(L)&&B.isPosition(ne)&&(Ye=B.of(L),ot=B.of(ne)),!Ye||!ot)throw new Error("Invalid arguments");Ye.isBefore(ot)?(this.c=Ye,this.e=ot):(this.c=ot,this.e=Ye)}contains(L){return n.isRange(L)?this.contains(L.start)&&this.contains(L.end):B.isPosition(L)?!(B.of(L).isBefore(this.c)||this.e.isBefore(L)):!1}isEqual(L){return this.c.isEqual(L.c)&&this.e.isEqual(L.e)}intersection(L){const ne=B.Max(L.start,this.c),ke=B.Min(L.end,this.e);if(!ne.isAfter(ke))return new n(ne,ke)}union(L){if(this.contains(L))return this;if(L.contains(this))return L;const ne=B.Min(L.start,this.c),ke=B.Max(L.end,this.end);return new n(ne,ke)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(L,ne=this.end){if(L===null||ne===null)throw(0,M.$6)();let ke;return L?B.isPosition(L)?ke=L:(ke=L.start||this.start,ne=L.end||this.end):ke=this.start,ke.isEqual(this.c)&&ne.isEqual(this.end)?this:new n(ke,ne)}toJSON(){return[this.start,this.end]}};e.$dK=O,e.$dK=O=n=qe([P],O);let N=a=class extends O{static isSelection(L){return L instanceof a?!0:L?O.isRange(L)&&B.isPosition(L.anchor)&&B.isPosition(L.active)&&typeof L.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(L,ne,ke,He){let Ye,ot;if(typeof L=="number"&&typeof ne=="number"&&typeof ke=="number"&&typeof He=="number"?(Ye=new B(L,ne),ot=new B(ke,He)):B.isPosition(L)&&B.isPosition(ne)&&(Ye=B.of(L),ot=B.of(ne)),!Ye||!ot)throw new Error("Invalid arguments");super(Ye,ot),this.f=Ye,this.g=ot}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$eK=N,e.$eK=N=a=qe([P],N);const te=j=>{if(typeof j!="string"||j.length===0||!/^[0-9A-Za-z_\-]+$/.test(j))throw(0,M.$6)("connectionToken")};class Y{static isResolvedAuthority(L){return L&&typeof L=="object"&&typeof L.host=="string"&&typeof L.port=="number"&&(L.connectionToken===void 0||typeof L.connectionToken=="string")}constructor(L,ne,ke){if(typeof L!="string"||L.length===0)throw(0,M.$6)("host");if(typeof ne!="number"||ne===0||Math.round(ne)!==ne)throw(0,M.$6)("port");typeof ke<"u"&&te(ke),this.host=L,this.port=Math.round(ne),this.connectionToken=ke}}e.$fK=Y;class ye{static isManagedResolvedAuthority(L){return L&&typeof L=="object"&&typeof L.makeConnection=="function"&&(L.connectionToken===void 0||typeof L.connectionToken=="string")}constructor(L,ne){this.makeConnection=L,this.connectionToken=ne,typeof ne<"u"&&te(ne)}}e.$gK=ye;class Ee extends Error{static NotAvailable(L,ne){return new Ee(L,p.RemoteAuthorityResolverErrorCode.NotAvailable,ne)}static TemporarilyNotAvailable(L){return new Ee(L,p.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(L,ne=p.RemoteAuthorityResolverErrorCode.Unknown,ke){super(L),this._message=L,this._code=ne,this._detail=ke,Object.setPrototypeOf(this,Ee.prototype)}}e.$hK=Ee;var Pe;(function(j){j[j.LF=1]="LF",j[j.CRLF=2]="CRLF"})(Pe||(e.EndOfLine=Pe={}));var X;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(X||(e.EnvironmentVariableMutatorType=X={}));let ae=b=class{static isTextEdit(L){return L instanceof b?!0:L?O.isRange(L)&&typeof L.newText=="string":!1}static replace(L,ne){return new b(L,ne)}static insert(L,ne){return b.replace(new O(L,L),ne)}static delete(L){return b.replace(L,"")}static setEndOfLine(L){const ne=new b(new O(new B(0,0),new B(0,0)),"");return ne.newEol=L,ne}get range(){return this.c}set range(L){if(L&&!O.isRange(L))throw(0,M.$6)("range");this.c=L}get newText(){return this.e||""}set newText(L){if(L&&typeof L!="string")throw(0,M.$6)("newText");this.e=L}get newEol(){return this.f}set newEol(L){if(L&&typeof L!="number")throw(0,M.$6)("newEol");this.f=L}constructor(L,ne){this.c=L,this.e=ne}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$iK=ae,e.$iK=ae=b=qe([P],ae);let Se=E=class{static isNotebookCellEdit(L){return L instanceof E?!0:L?_t.isNotebookRange(L)&&Array.isArray(L.newCells):!1}static replaceCells(L,ne){return new E(L,ne)}static insertCells(L,ne){return new E(new _t(L,L),ne)}static deleteCells(L){return new E(L,[])}static updateCellMetadata(L,ne){const ke=new E(new _t(L,L),[]);return ke.newCellMetadata=ne,ke}static updateNotebookMetadata(L){const ne=new E(new _t(0,0),[]);return ne.newNotebookMetadata=L,ne}constructor(L,ne){this.range=L,this.newCells=ne}};e.$jK=Se,e.$jK=Se=E=qe([P],Se);class ue{static isSnippetTextEdit(L){return L instanceof ue?!0:L?O.isRange(L.range)&&z.isSnippetString(L.snippet):!1}static replace(L,ne){return new ue(L,ne)}static insert(L,ne){return ue.replace(new O(L,L),ne)}constructor(L,ne){this.range=L,this.snippet=ne}}e.$kK=ue;var $e;(function(j){j[j.File=1]="File",j[j.Text=2]="Text",j[j.Cell=3]="Cell",j[j.CellReplace=5]="CellReplace",j[j.Snippet=6]="Snippet"})($e||(e.FileEditType=$e={}));let ie=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(L,ne,ke,He){this.c.push({_type:1,from:L,to:ne,options:ke,metadata:He})}createFile(L,ne,ke){this.c.push({_type:1,from:void 0,to:L,options:ne,metadata:ke})}deleteFile(L,ne,ke){this.c.push({_type:1,from:L,to:void 0,options:ne,metadata:ke})}e(L,ne,ke){this.c.push({_type:3,metadata:ke,uri:L,edit:{editType:5,metadata:ne},notebookMetadata:ne})}f(L,ne,ke,He){const Ye=ne.start,ot=ne.end;(Ye!==ot||ke.length>0)&&this.c.push({_type:5,uri:L,index:Ye,count:ot-Ye,cells:ke,metadata:He})}g(L,ne,ke,He){this.c.push({_type:3,metadata:He,uri:L,edit:{editType:3,index:ne,metadata:ke}})}replace(L,ne,ke,He){this.c.push({_type:2,uri:L,edit:new ae(ne,ke),metadata:He})}insert(L,ne,ke,He){this.replace(L,new O(ne,ne),ke,He)}delete(L,ne,ke){this.replace(L,ne,"",ke)}has(L){return this.c.some(ne=>ne._type===2&&ne.uri.toString()===L.toString())}set(L,ne){if(ne)for(const ke of ne){if(!ke)continue;let He,Ye;Array.isArray(ke)?(He=ke[0],Ye=ke[1]):He=ke,Se.isNotebookCellEdit(He)?He.newCellMetadata?this.g(L,He.range.start,He.newCellMetadata,Ye):He.newNotebookMetadata?this.e(L,He.newNotebookMetadata,Ye):this.f(L,He.range,He.newCells,Ye):ue.isSnippetTextEdit(He)?this.c.push({_type:6,uri:L,range:He.range,edit:He.snippet,metadata:Ye}):this.c.push({_type:2,uri:L,edit:He,metadata:Ye})}else{for(let ke=0;ke<this.c.length;ke++){const He=this.c[ke];switch(He._type){case 2:case 6:case 3:case 5:He.uri.toString()===L.toString()&&(this.c[ke]=void 0);break}}(0,w.$Hb)(this.c)}}get(L){const ne=[];for(const ke of this.c)ke._type===2&&ke.uri.toString()===L.toString()&&ne.push(ke.edit);return ne}entries(){const L=new F.$zc;for(const ne of this.c)if(ne._type===2){let ke=L.get(ne.uri);ke||(ke=[ne.uri,[]],L.set(ne.uri,ke)),ke[1].push(ne.edit)}return[...L.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$lK=ie,e.$lK=ie=qe([P],ie);let z=v=class{static isSnippetString(L){return L instanceof v?!0:L?typeof L.value=="string":!1}static c(L){return L.replace(/\$|}|\\/g,"\\$&")}constructor(L){this.e=1,this.value=L||""}appendText(L){return this.value+=v.c(L),this}appendTabstop(L=this.e++){return this.value+="$",this.value+=L,this}appendPlaceholder(L,ne=this.e++){if(typeof L=="function"){const ke=new v;ke.e=this.e,L(ke),this.e=ke.e,L=ke.value}else L=v.c(L);return this.value+="${",this.value+=ne,this.value+=":",this.value+=L,this.value+="}",this}appendChoice(L,ne=this.e++){const ke=L.map(He=>He.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ne,this.value+="|",this.value+=ke,this.value+="|}",this}appendVariable(L,ne){if(typeof ne=="function"){const ke=new v;ke.e=this.e,ne(ke),this.e=ke.e,ne=ke.value}else typeof ne=="string"&&(ne=ne.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=L,ne&&(this.value+=":",this.value+=ne),this.value+="}",this}};e.$mK=z,e.$mK=z=v=qe([P],z);var V;(function(j){j[j.Unnecessary=1]="Unnecessary",j[j.Deprecated=2]="Deprecated"})(V||(e.DiagnosticTag=V={}));var le;(function(j){j[j.Hint=3]="Hint",j[j.Information=2]="Information",j[j.Warning=1]="Warning",j[j.Error=0]="Error"})(le||(e.DiagnosticSeverity=le={}));let we=r=class{static isLocation(L){return L instanceof r?!0:L?O.isRange(L.range)&&f.URI.isUri(L.uri):!1}constructor(L,ne){if(this.uri=L,ne)if(O.isRange(ne))this.range=O.of(ne);else if(B.isPosition(ne))this.range=new O(ne,ne);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$nK=we,e.$nK=we=r=qe([P],we);let ve=class{static is(L){return L?typeof L.message=="string"&&L.location&&O.isRange(L.location.range)&&f.URI.isUri(L.location.uri):!1}constructor(L,ne){this.location=L,this.message=ne}static isEqual(L,ne){return L===ne?!0:!L||!ne?!1:L.message===ne.message&&L.location.range.isEqual(ne.location.range)&&L.location.uri.toString()===ne.location.uri.toString()}};e.$oK=ve,e.$oK=ve=qe([P],ve);let me=class{constructor(L,ne,ke=le.Error){if(!O.isRange(L))throw new TypeError("range must be set");if(!ne)throw new TypeError("message must be set");this.range=L,this.message=ne,this.severity=ke}toJSON(){return{severity:le[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(L,ne){return L===ne?!0:!L||!ne?!1:L.message===ne.message&&L.severity===ne.severity&&L.code===ne.code&&L.severity===ne.severity&&L.source===ne.source&&L.range.isEqual(ne.range)&&(0,w.$tb)(L.tags,ne.tags)&&(0,w.$tb)(L.relatedInformation,ne.relatedInformation,ve.isEqual)}};e.$pK=me,e.$pK=me=qe([P],me);let De=class{constructor(L,ne){if(!L)throw new Error("Illegal argument, contents must be defined");Array.isArray(L)?this.contents=L:this.contents=[L],this.range=ne}};e.$qK=De,e.$qK=De=qe([P],De);var re;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(re||(e.DocumentHighlightKind=re={}));let he=class{constructor(L,ne=re.Text){this.range=L,this.kind=ne}toJSON(){return{range:this.range,kind:re[this.kind]}}};e.$rK=he,e.$rK=he=qe([P],he);var se;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(se||(e.SymbolKind=se={}));var oe;(function(j){j[j.Deprecated=1]="Deprecated"})(oe||(e.SymbolTag=oe={}));let de=s=class{static validate(L){if(!L.name)throw new Error("name must not be falsy")}constructor(L,ne,ke,He,Ye){this.name=L,this.kind=ne,this.containerName=Ye,typeof ke=="string"&&(this.containerName=ke),He instanceof we?this.location=He:ke instanceof O&&(this.location=new we(He,ke)),s.validate(this)}toJSON(){return{name:this.name,kind:se[this.kind],location:this.location,containerName:this.containerName}}};e.$sK=de,e.$sK=de=s=qe([P],de);let Ie=i=class{static validate(L){if(!L.name)throw new Error("name must not be falsy");if(!L.range.contains(L.selectionRange))throw new Error("selectionRange must be contained in fullRange");L.children?.forEach(i.validate)}constructor(L,ne,ke,He,Ye){this.name=L,this.detail=ne,this.kind=ke,this.range=He,this.selectionRange=Ye,this.children=[],i.validate(this)}};e.$tK=Ie,e.$tK=Ie=i=qe([P],Ie);var T;(function(j){j[j.Invoke=1]="Invoke",j[j.Automatic=2]="Automatic"})(T||(e.CodeActionTriggerKind=T={}));let q=class{constructor(L,ne){this.title=L,this.kind=ne}};e.$uK=q,e.$uK=q=qe([P],q);let J=class{static{o=this}static{this.c="."}constructor(L){this.value=L}append(L){return new o(this.value?this.value+o.c+L:L)}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+o.c)}};e.$vK=J,e.$vK=J=o=qe([P],J),J.Empty=new J(""),J.QuickFix=J.Empty.append("quickfix"),J.Refactor=J.Empty.append("refactor"),J.RefactorExtract=J.Refactor.append("extract"),J.RefactorInline=J.Refactor.append("inline"),J.RefactorMove=J.Refactor.append("move"),J.RefactorRewrite=J.Refactor.append("rewrite"),J.Source=J.Empty.append("source"),J.SourceOrganizeImports=J.Source.append("organizeImports"),J.SourceFixAll=J.Source.append("fixAll"),J.Notebook=J.Empty.append("notebook");let Q=class{constructor(L,ne){if(this.range=L,this.parent=ne,ne&&!ne.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$wK=Q,e.$wK=Q=qe([P],Q);class H{constructor(L,ne,ke,He,Ye,ot){this.kind=L,this.name=ne,this.detail=ke,this.uri=He,this.range=Ye,this.selectionRange=ot}}e.$xK=H;class x{constructor(L,ne){this.fromRanges=ne,this.from=L}}e.$yK=x;class ce{constructor(L,ne){this.fromRanges=ne,this.to=L}}e.$zK=ce;var Fe;(function(j){j[j.Information=0]="Information",j[j.Warning=1]="Warning",j[j.Error=2]="Error"})(Fe||(e.LanguageStatusSeverity=Fe={}));let Ue=class{constructor(L,ne){this.range=L,this.command=ne}get isResolved(){return!!this.command}};e.$AK=Ue,e.$AK=Ue=qe([P],Ue);let Qe=y=class{#e;static isMarkdownString(L){return L instanceof y?!0:L&&L.appendCodeblock&&L.appendMarkdown&&L.appendText&&L.value!==void 0}constructor(L,ne=!1){this.#e=new C.$1j(L,{supportThemeIcons:ne})}get value(){return this.#e.value}set value(L){this.#e.value=L}get isTrusted(){return this.#e.isTrusted}set isTrusted(L){this.#e.isTrusted=L}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(L){this.#e.supportThemeIcons=L}get supportHtml(){return this.#e.supportHtml}set supportHtml(L){this.#e.supportHtml=L}get baseUri(){return this.#e.baseUri}set baseUri(L){this.#e.baseUri=L}appendText(L){return this.#e.appendText(L),this}appendMarkdown(L){return this.#e.appendMarkdown(L),this}appendCodeblock(L,ne){return this.#e.appendCodeblock(ne??"",L),this}};e.$BK=Qe,e.$BK=Qe=y=qe([P],Qe);let Ge=class{constructor(L,ne){this.label=L,this.documentation=ne}};e.$CK=Ge,e.$CK=Ge=qe([P],Ge);let _e=class{constructor(L,ne){this.label=L,this.documentation=ne,this.parameters=[]}};e.$DK=_e,e.$DK=_e=qe([P],_e);let Xe=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$EK=Xe,e.$EK=Xe=qe([P],Xe);var xe;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(xe||(e.SignatureHelpTriggerKind=xe={}));var it;(function(j){j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(it||(e.InlayHintKind=it={}));let tt=class{constructor(L){this.value=L}};e.$FK=tt,e.$FK=tt=qe([P],tt);let ze=class{constructor(L,ne,ke){this.position=L,this.label=ne,this.kind=ke}};e.$GK=ze,e.$GK=ze=qe([P],ze);var st;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(st||(e.CompletionTriggerKind=st={}));var _;(function(j){j[j.Text=0]="Text",j[j.Method=1]="Method",j[j.Function=2]="Function",j[j.Constructor=3]="Constructor",j[j.Field=4]="Field",j[j.Variable=5]="Variable",j[j.Class=6]="Class",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Unit=10]="Unit",j[j.Value=11]="Value",j[j.Enum=12]="Enum",j[j.Keyword=13]="Keyword",j[j.Snippet=14]="Snippet",j[j.Color=15]="Color",j[j.File=16]="File",j[j.Reference=17]="Reference",j[j.Folder=18]="Folder",j[j.EnumMember=19]="EnumMember",j[j.Constant=20]="Constant",j[j.Struct=21]="Struct",j[j.Event=22]="Event",j[j.Operator=23]="Operator",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue"})(_||(e.CompletionItemKind=_={}));var Z;(function(j){j[j.Deprecated=1]="Deprecated"})(Z||(e.CompletionItemTag=Z={}));let pe=class{constructor(L,ne){this.label=L,this.kind=ne}toJSON(){return{label:this.label,kind:this.kind&&_[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$HK=pe,e.$HK=pe=qe([P],pe);let je=class{constructor(L=[],ne=!1){this.items=L,this.isIncomplete=ne}};e.$IK=je,e.$IK=je=qe([P],je);let Oe=class{constructor(L,ne,ke){this.insertText=L,this.range=ne,this.command=ke}};e.$JK=Oe,e.$JK=Oe=qe([P],Oe);let Ze=class{constructor(L){this.commands=void 0,this.suppressSuggestions=void 0,this.items=L}};e.$KK=Ze,e.$KK=Ze=qe([P],Ze);var rt;(function(j){j[j.Active=-1]="Active",j[j.Beside=-2]="Beside",j[j.One=1]="One",j[j.Two=2]="Two",j[j.Three=3]="Three",j[j.Four=4]="Four",j[j.Five=5]="Five",j[j.Six=6]="Six",j[j.Seven=7]="Seven",j[j.Eight=8]="Eight",j[j.Nine=9]="Nine"})(rt||(e.ViewColumn=rt={}));var mt;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(mt||(e.StatusBarAlignment=mt={}));function wt(j,L){return`${D.$2l.toKey(j)}.${L}`}e.$LK=wt;var Ct;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative"})(Ct||(e.TextEditorLineNumbersStyle=Ct={}));var Yt;(function(j){j[j.Manual=1]="Manual",j[j.AfterDelay=2]="AfterDelay",j[j.FocusOut=3]="FocusOut"})(Yt||(e.TextDocumentSaveReason=Yt={}));var qt;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(qt||(e.TextEditorRevealType=qt={}));var vt;(function(j){j[j.Keyboard=1]="Keyboard",j[j.Mouse=2]="Mouse",j[j.Command=3]="Command"})(vt||(e.TextEditorSelectionChangeKind=vt={}));var jt;(function(j){j[j.Undo=1]="Undo",j[j.Redo=2]="Redo"})(jt||(e.TextDocumentChangeReason=jt={}));var Ft;(function(j){j[j.OpenOpen=0]="OpenOpen",j[j.ClosedClosed=1]="ClosedClosed",j[j.OpenClosed=2]="OpenClosed",j[j.ClosedOpen=3]="ClosedOpen"})(Ft||(e.DecorationRangeBehavior=Ft={})),function(j){function L(ne){switch(ne){case"keyboard":return j.Keyboard;case"mouse":return j.Mouse;case"api":return j.Command}}j.fromValue=L}(vt||(e.TextEditorSelectionChangeKind=vt={}));var Bt;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(Bt||(e.SyntaxTokenType=Bt={})),function(j){function L(ne){switch(ne){case j.Other:return"other";case j.Comment:return"comment";case j.String:return"string";case j.RegEx:return"regex"}return"other"}j.toString=L}(Bt||(e.SyntaxTokenType=Bt={}));let Pt=class{constructor(L,ne){if(ne&&!f.URI.isUri(ne))throw(0,M.$6)("target");if(!O.isRange(L)||L.isEmpty)throw(0,M.$6)("range");this.range=L,this.target=ne}};e.$MK=Pt,e.$MK=Pt=qe([P],Pt);let At=class{constructor(L,ne,ke,He){this.red=L,this.green=ne,this.blue=ke,this.alpha=He}};e.$NK=At,e.$NK=At=qe([P],At);let Nt=class{constructor(L,ne){if(ne&&!(ne instanceof At))throw(0,M.$6)("color");if(!O.isRange(L)||L.isEmpty)throw(0,M.$6)("range");this.range=L,this.color=ne}};e.$OK=Nt,e.$OK=Nt=qe([P],Nt);let Wt=class{constructor(L){if(!L||typeof L!="string")throw(0,M.$6)("label");this.label=L}};e.$PK=Wt,e.$PK=Wt=qe([P],Wt);var Ht;(function(j){j[j.RGB=0]="RGB",j[j.HEX=1]="HEX",j[j.HSL=2]="HSL"})(Ht||(e.ColorFormat=Ht={}));var Kt;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information"})(Kt||(e.SourceControlInputBoxValidationType=Kt={}));var at;(function(j){j[j.Unknown=0]="Unknown",j[j.Shutdown=1]="Shutdown",j[j.Process=2]="Process",j[j.User=3]="User",j[j.Extension=4]="Extension"})(at||(e.TerminalExitReason=at={}));class ut{constructor(L,ne,ke){if(this.startIndex=L,this.length=ne,this.tooltip=ke,typeof L!="number"||L<0)throw(0,M.$6)("startIndex");if(typeof ne!="number"||ne<1)throw(0,M.$6)("length");if(ke!==void 0&&typeof ke!="string")throw(0,M.$6)("tooltip")}}e.$QK=ut;class Jt{constructor(L){this.uri=L}}e.$RK=Jt;class It{constructor(L){this.terminalCommand=L}}e.$SK=It;var Et;(function(j){j[j.Panel=1]="Panel",j[j.Editor=2]="Editor"})(Et||(e.TerminalLocation=Et={}));class dt{constructor(L){if(this.options=L,typeof L!="object")throw(0,M.$6)("options")}}e.$TK=dt;var kt;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(kt||(e.TaskRevealKind=kt={}));var Lt;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(Lt||(e.TaskPanelKind=Lt={}));let yt=class{static{d=this}static{this.Clean=new d("clean","Clean")}static{this.Build=new d("build","Build")}static{this.Rebuild=new d("rebuild","Rebuild")}static{this.Test=new d("test","Test")}static from(L){switch(L){case"clean":return d.Clean;case"build":return d.Build;case"rebuild":return d.Rebuild;case"test":return d.Test;default:return}}constructor(L,ne){if(this.label=ne,typeof L!="string"||typeof ne!="string")throw(0,M.$6)("name");this.c=L}get id(){return this.c}};e.$UK=yt,e.$UK=yt=d=qe([P],yt);function Ke(j){let L="";for(let ne=0;ne<j.length;ne++)L+=j[ne].replace(/,/g,",,")+",";return L}let Ot=class{constructor(L,ne,ke){if(typeof L!="string")throw(0,M.$6)("process");this.e=[],this.c=L,ne!==void 0&&(Array.isArray(ne)?(this.e=ne,this.f=ke):this.f=ne)}get process(){return this.c}set process(L){if(typeof L!="string")throw(0,M.$6)("process");this.c=L}get args(){return this.e}set args(L){Array.isArray(L)||(L=[]),this.e=L}get options(){return this.f}set options(L){this.f=L}computeId(){const L=[];if(L.push("process"),this.c!==void 0&&L.push(this.c),this.e&&this.e.length>0)for(const ne of this.e)L.push(ne);return Ke(L)}};e.$VK=Ot,e.$VK=Ot=qe([P],Ot);let zt=class{constructor(L,ne,ke){if(this.f=[],Array.isArray(ne)){if(!L)throw(0,M.$6)("command can't be undefined or null");if(typeof L!="string"&&typeof L.value!="string")throw(0,M.$6)("command");this.e=L,this.f=ne,this.g=ke}else{if(typeof L!="string")throw(0,M.$6)("commandLine");this.c=L,this.g=ne}}get commandLine(){return this.c}set commandLine(L){if(typeof L!="string")throw(0,M.$6)("commandLine");this.c=L}get command(){return this.e?this.e:""}set command(L){if(typeof L!="string"&&typeof L.value!="string")throw(0,M.$6)("command");this.e=L}get args(){return this.f}set args(L){this.f=L||[]}get options(){return this.g}set options(L){this.g=L}computeId(){const L=[];if(L.push("shell"),this.c!==void 0&&L.push(this.c),this.e!==void 0&&L.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ne of this.f)L.push(typeof ne=="string"?ne:ne.value);return Ke(L)}};e.$WK=zt,e.$WK=zt=qe([P],zt);var Ce;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(Ce||(e.ShellQuoting=Ce={}));var Ae;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace"})(Ae||(e.TaskScope=Ae={}));class ge{constructor(L){this.c=L}computeId(){return"customExecution"+(0,R.$dg)()}set callback(L){this.c=L}get callback(){return this.c}}e.$XK=ge;let G=class{static{I=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(L,ne,ke,He,Ye,ot){this.j=!1,this.k=this.definition=L;let lt;typeof ne=="string"?(this.m=this.name=ne,this.t=this.source=ke,this.execution=He,lt=Ye,this.j=!0):ne===Ae.Global||ne===Ae.Workspace?(this.target=ne,this.m=this.name=ke,this.t=this.source=He,this.execution=Ye,lt=ot):(this.target=ne,this.m=this.name=ke,this.t=this.source=He,this.execution=Ye,lt=ot),typeof lt=="string"?(this.o=[lt],this.q=!0):Array.isArray(lt)?(this.o=lt,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.w=Object.create(null),this.x=Object.create(null)}get _id(){return this.h}set _id(L){this.h=L}get _deprecated(){return this.j}z(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.A())}A(){this.n instanceof Ot?this.k={type:I.e,id:this.n.computeId()}:this.n instanceof zt?this.k={type:I.f,id:this.n.computeId()}:this.n instanceof ge?this.k={type:I.c,id:this.n.computeId()}:this.k={type:I.g,id:(0,R.$dg)()}}get definition(){return this.k}set definition(L){if(L==null)throw(0,M.$6)("Kind can't be undefined or null");this.z(),this.k=L}get scope(){return this.l}set target(L){this.z(),this.l=L}get name(){return this.m}set name(L){if(typeof L!="string")throw(0,M.$6)("name");this.z(),this.m=L}get execution(){return this.n}set execution(L){L===null&&(L=void 0),this.z(),this.n=L;const ne=this.k.type;(I.g===ne||I.e===ne||I.f===ne||I.c===ne)&&this.A()}get problemMatchers(){return this.o}set problemMatchers(L){if(Array.isArray(L))this.z(),this.o=L,this.q=!0;else{this.z(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(L){L!==!0&&L!==!1&&(L=!1),this.z(),this.r=L}get source(){return this.t}set source(L){if(typeof L!="string"||L.length===0)throw(0,M.$6)("source must be a string of length > 0");this.z(),this.t=L}get group(){return this.u}set group(L){L===null&&(L=void 0),this.z(),this.u=L}get detail(){return this.y}set detail(L){L===null&&(L=void 0),this.y=L}get presentationOptions(){return this.w}set presentationOptions(L){L==null&&(L=Object.create(null)),this.z(),this.w=L}get runOptions(){return this.x}set runOptions(L){L==null&&(L=Object.create(null)),this.z(),this.x=L}};e.$YK=G,e.$YK=G=I=qe([P],G);var Te;(function(j){j[j.SourceControl=1]="SourceControl",j[j.Window=10]="Window",j[j.Notification=15]="Notification"})(Te||(e.ProgressLocation=Te={}));var Be;(function(j){function L(ne){const ke=ne;return(0,k.$Bf)(ke.value)?ke.tooltip&&!(0,k.$xf)(ke.tooltip)?(console.log("INVALID view badge, invalid tooltip",ke.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",ke.value),!1)}j.isViewBadge=L})(Be||(e.ViewBadge=Be={}));let Je=S=class{static isTreeItem(L,ne){const ke=L;if(ke.checkboxState!==void 0){const He=(0,k.$Bf)(ke.checkboxState)?ke.checkboxState:(0,k.$zf)(ke.checkboxState)&&(0,k.$Bf)(ke.checkboxState.state)?ke.checkboxState.state:void 0,Ye=!(0,k.$Bf)(ke.checkboxState)&&(0,k.$zf)(ke.checkboxState)?ke.checkboxState.tooltip:void 0;if(He===void 0||He!==et.Checked&&He!==et.Unchecked||Ye!==void 0&&!(0,k.$xf)(Ye))return console.log("INVALID tree item, invalid checkboxState",ke.checkboxState),!1}if(L instanceof S)return!0;if(ke.label!==void 0&&!(0,k.$xf)(ke.label)&&!ke.label?.label)return console.log("INVALID tree item, invalid label",ke.label),!1;if(ke.id!==void 0&&!(0,k.$xf)(ke.id))return console.log("INVALID tree item, invalid id",ke.id),!1;if(ke.iconPath!==void 0&&!(0,k.$xf)(ke.iconPath)&&!f.URI.isUri(ke.iconPath)&&(!ke.iconPath||!(0,k.$xf)(ke.iconPath.id))){const He=ke.iconPath;if(!He||!(0,k.$xf)(He.light)&&!f.URI.isUri(He.light)&&!(0,k.$xf)(He.dark)&&!f.URI.isUri(He.dark))return console.log("INVALID tree item, invalid iconPath",ke.iconPath),!1}return ke.description!==void 0&&!(0,k.$xf)(ke.description)&&typeof ke.description!="boolean"?(console.log("INVALID tree item, invalid description",ke.description),!1):ke.resourceUri!==void 0&&!f.URI.isUri(ke.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",ke.resourceUri),!1):ke.tooltip!==void 0&&!(0,k.$xf)(ke.tooltip)&&!(ke.tooltip instanceof Qe)?(console.log("INVALID tree item, invalid tooltip",ke.tooltip),!1):ke.command!==void 0&&!ke.command.command?(console.log("INVALID tree item, invalid command",ke.command),!1):ke.collapsibleState!==void 0&&ke.collapsibleState<Ve.None&&ke.collapsibleState>Ve.Expanded?(console.log("INVALID tree item, invalid collapsibleState",ke.collapsibleState),!1):ke.contextValue!==void 0&&!(0,k.$xf)(ke.contextValue)?(console.log("INVALID tree item, invalid contextValue",ke.contextValue),!1):ke.accessibilityInformation!==void 0&&!ke.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",ke.accessibilityInformation),!1):!0}constructor(L,ne=Ve.None){this.collapsibleState=ne,f.URI.isUri(L)?this.resourceUri=L:this.label=L}};e.$ZK=Je,e.$ZK=Je=S=qe([P],Je);var Ve;(function(j){j[j.None=0]="None",j[j.Collapsed=1]="Collapsed",j[j.Expanded=2]="Expanded"})(Ve||(e.TreeItemCollapsibleState=Ve={}));var et;(function(j){j[j.Unchecked=0]="Unchecked",j[j.Checked=1]="Checked"})(et||(e.TreeItemCheckboxState=et={}));let gt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(L){this.value=L}};e.$1K=gt,e.$1K=gt=qe([P],gt);class ft extends gt{}e.$2K=ft;class pt extends ft{#e;constructor(L){super(""),this.#e=L}asFile(){return this.#e}}e.$3K=pt;class ht{constructor(L,ne,ke,He){this.name=L,this.uri=ne,this._itemId=ke,this.c=He}data(){return this.c()}}e.$4K=ht;let Rt=class{#e=new Map;constructor(L){for(const[ne,ke]of L??[]){const He=this.#e.get(this.#t(ne));He?He.push(ke):this.#e.set(this.#t(ne),[ke])}}get(L){return this.#e.get(this.#t(L))?.[0]}set(L,ne){this.#e.set(this.#t(L),[ne])}forEach(L,ne){for(const[ke,He]of this.#e)for(const Ye of He)L.call(ne,Ye,ke,this)}*[Symbol.iterator](){for(const[L,ne]of this.#e)for(const ke of ne)yield[L,ke]}#t(L){return L.toLowerCase()}};e.$5K=Rt,e.$5K=Rt=qe([P],Rt);let Gt=class{constructor(L){this.insertText=L}};e.$6K=Gt,e.$6K=Gt=qe([P],Gt);let Ei=class{constructor(L,ne){this.label=ne,this.insertText=L}};e.$7K=Ei,e.$7K=Ei=qe([P],Ei);let Vt=class{constructor(L,ne){this.id=L,this.color=ne}static isThemeIcon(L){return typeof L.id!="string"?(console.log("INVALID ThemeIcon, invalid id",L.id),!1):!0}};e.$8K=Vt,e.$8K=Vt=qe([P],Vt),Vt.File=new Vt("file"),Vt.Folder=new Vt("folder");let mi=class{constructor(L){this.id=L}};e.$9K=mi,e.$9K=mi=qe([P],mi);var St;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.WorkspaceFolder=3]="WorkspaceFolder"})(St||(e.ConfigurationTarget=St={}));let Di=class{get base(){return this.c}set base(L){this.c=L,this.e=f.URI.file(L)}get baseUri(){return this.e}set baseUri(L){this.e=L,this.c=L.fsPath}constructor(L,ne){if(typeof L!="string"&&(!L||!f.URI.isUri(L)&&!f.URI.isUri(L.uri)))throw(0,M.$6)("base");if(typeof ne!="string")throw(0,M.$6)("pattern");typeof L=="string"?this.baseUri=f.URI.file(L):f.URI.isUri(L)?this.baseUri=L:this.baseUri=L.uri,this.pattern=ne}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$0K=Di,e.$0K=Di=qe([P],Di);const Ki=new WeakMap;function Dt(j,L){Ki.set(j,L)}e.$$K=Dt;let ii=class{constructor(L,ne,ke,He){this.enabled=typeof L=="boolean"?L:!0,typeof ne=="string"&&(this.condition=ne),typeof ke=="string"&&(this.hitCondition=ke),typeof He=="string"&&(this.logMessage=He)}get id(){return this.c||(this.c=Ki.get(this)??(0,R.$dg)()),this.c}};e.$_K=ii,e.$_K=ii=qe([P],ii);let $i=class extends ii{constructor(L,ne,ke,He,Ye){if(super(ne,ke,He,Ye),L===null)throw(0,M.$6)("location");this.location=L}};e.$aL=$i,e.$aL=$i=qe([P],$i);let oi=class extends ii{constructor(L,ne,ke,He,Ye){super(ne,ke,He,Ye),this.functionName=L}};e.$bL=oi,e.$bL=oi=qe([P],oi);let ki=class extends ii{constructor(L,ne,ke,He,Ye,ot,lt){if(super(He,Ye,ot,lt),!ne)throw(0,M.$6)("dataId");this.label=L,this.dataId=ne,this.canPersist=ke}};e.$cL=ki,e.$cL=ki=qe([P],ki);let Si=class{constructor(L,ne,ke){this.command=L,this.args=ne||[],this.options=ke}};e.$dL=Si,e.$dL=Si=qe([P],Si);let Mt=class{constructor(L,ne){this.port=L,this.host=ne}};e.$eL=Mt,e.$eL=Mt=qe([P],Mt);let pi=class{constructor(L){this.path=L}};e.$fL=pi,e.$fL=pi=qe([P],pi);let Ii=class{constructor(L){this.implementation=L}};e.$gL=Ii,e.$gL=Ii=qe([P],Ii);let ai=class{constructor(L,ne,ke){this.session=L,this.threadId=ne,this.frameId=ke}};e.$hL=ai,e.$hL=ai=qe([P],ai);let ci=class{constructor(L,ne){this.session=L,this.threadId=ne}};e.$iL=ci,e.$iL=ci=qe([P],ci);let ct=class{constructor(L,ne){this.range=L,this.expression=ne}};e.$jL=ct,e.$jL=ct=qe([P],ct);var Vi;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(Vi||(e.InlineCompletionTriggerKind=Vi={}));let Xt=class{constructor(L,ne){this.range=L,this.text=ne}};e.$kL=Xt,e.$kL=Xt=qe([P],Xt);let ni=class{constructor(L,ne,ke=!0){this.range=L,this.variableName=ne,this.caseSensitiveLookup=ke}};e.$lL=ni,e.$lL=ni=qe([P],ni);let vi=class{constructor(L,ne){this.range=L,this.expression=ne}};e.$mL=vi,e.$mL=vi=qe([P],vi);let Ci=class{constructor(L,ne){this.frameId=L,this.stoppedLocation=ne}};e.$nL=Ci,e.$nL=Ci=qe([P],Ci);var qi;(function(j){j[j.Changed=1]="Changed",j[j.Created=2]="Created",j[j.Deleted=3]="Deleted"})(qi||(e.FileChangeType=qi={}));let Pi=u=class extends Error{static FileExists(L){return new u(L,c.FileSystemProviderErrorCode.FileExists,u.FileExists)}static FileNotFound(L){return new u(L,c.FileSystemProviderErrorCode.FileNotFound,u.FileNotFound)}static FileNotADirectory(L){return new u(L,c.FileSystemProviderErrorCode.FileNotADirectory,u.FileNotADirectory)}static FileIsADirectory(L){return new u(L,c.FileSystemProviderErrorCode.FileIsADirectory,u.FileIsADirectory)}static NoPermissions(L){return new u(L,c.FileSystemProviderErrorCode.NoPermissions,u.NoPermissions)}static Unavailable(L){return new u(L,c.FileSystemProviderErrorCode.Unavailable,u.Unavailable)}constructor(L,ne=c.FileSystemProviderErrorCode.Unknown,ke){super(f.URI.isUri(L)?L.toString(!0):L),this.code=ke?.name??"Unknown",(0,c.$kk)(this,ne),Object.setPrototypeOf(this,u.prototype),typeof Error.captureStackTrace=="function"&&typeof ke=="function"&&Error.captureStackTrace(this,ke)}};e.$oL=Pi,e.$oL=Pi=u=qe([P],Pi);let bi=class{constructor(L,ne,ke){this.start=L,this.end=ne,this.kind=ke}};e.$pL=bi,e.$pL=bi=qe([P],bi);var Hi;(function(j){j[j.Comment=1]="Comment",j[j.Imports=2]="Imports",j[j.Region=3]="Region"})(Hi||(e.FoldingRangeKind=Hi={}));var Ai;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(Ai||(e.CommentThreadCollapsibleState=Ai={}));var ui;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(ui||(e.CommentMode=ui={}));var Gi;(function(j){j[j.Published=0]="Published",j[j.Draft=1]="Draft"})(Gi||(e.CommentState=Gi={}));var wi;(function(j){j[j.Unresolved=0]="Unresolved",j[j.Resolved=1]="Resolved"})(wi||(e.CommentThreadState=wi={}));class Ri{constructor(L,ne=[]){this.tokenTypes=L,this.tokenModifiers=ne}}e.$qL=Ri;function cn(j){return typeof j>"u"||(0,k.$yf)(j)}class Mi{constructor(L){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,L){this.l=!0;for(let ne=0,ke=L.tokenTypes.length;ne<ke;ne++)this.j.set(L.tokenTypes[ne],ne);for(let ne=0,ke=L.tokenModifiers.length;ne<ke;ne++)this.k.set(L.tokenModifiers[ne],ne)}}push(L,ne,ke,He,Ye){if(typeof L=="number"&&typeof ne=="number"&&typeof ke=="number"&&typeof He=="number"&&(typeof Ye=="number"||typeof Ye>"u"))return typeof Ye>"u"&&(Ye=0),this.n(L,ne,ke,He,Ye);if(O.isRange(L)&&typeof ne=="string"&&cn(ke))return this.m(L,ne,ke);throw(0,M.$6)()}m(L,ne,ke){if(!this.l)throw new Error("Legend must be provided in constructor");if(L.start.line!==L.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(ne))throw new Error("`tokenType` is not in the provided legend");const He=L.start.line,Ye=L.start.character,ot=L.end.character-L.start.character,lt=this.j.get(ne);let Ut=0;if(ke)for(const Zt of ke){if(!this.k.has(Zt))throw new Error("`tokenModifier` is not in the provided legend");const ei=this.k.get(Zt);Ut|=1<<ei>>>0}this.n(He,Ye,ot,lt,Ut)}n(L,ne,ke,He,Ye){if(this.f&&(L<this.c||L===this.c&&ne<this.e)){this.f=!1;const Ut=this.g.length/5|0;let Zt=0,ei=0;for(let ti=0;ti<Ut;ti++){let si=this.g[5*ti],Bi=this.g[5*ti+1];si===0?(si=Zt,Bi+=ei):si+=Zt,this.g[5*ti]=si,this.g[5*ti+1]=Bi,Zt=si,ei=Bi}}let ot=L,lt=ne;this.f&&this.h>0&&(ot-=this.c,ot===0&&(lt-=this.e)),this.g[this.h++]=ot,this.g[this.h++]=lt,this.g[this.h++]=ke,this.g[this.h++]=He,this.g[this.h++]=Ye,this.c=L,this.e=ne}static o(L){const ne=[],ke=L.length/5|0;for(let lt=0;lt<ke;lt++)ne[lt]=lt;ne.sort((lt,Ut)=>{const Zt=L[5*lt],ei=L[5*Ut];if(Zt===ei){const ti=L[5*lt+1],si=L[5*Ut+1];return ti-si}return Zt-ei});const He=new Uint32Array(L.length);let Ye=0,ot=0;for(let lt=0;lt<ke;lt++){const Ut=5*ne[lt],Zt=L[Ut+0],ei=L[Ut+1],ti=L[Ut+2],si=L[Ut+3],Bi=L[Ut+4],wn=Zt-Ye,Mn=wn===0?ei-ot:ei,Wi=5*lt;He[Wi+0]=wn,He[Wi+1]=Mn,He[Wi+2]=ti,He[Wi+3]=si,He[Wi+4]=Bi,Ye=Zt,ot=ei}return He}build(L){return this.f?new ri(new Uint32Array(this.g),L):new ri(Mi.o(this.g),L)}}e.$rL=Mi;class ri{constructor(L,ne){this.resultId=ne,this.data=L}}e.$sL=ri;class un{constructor(L,ne,ke){this.start=L,this.deleteCount=ne,this.data=ke}}e.$tL=un;class ln{constructor(L,ne){this.resultId=ne,this.edits=L}}e.$uL=ln;var Ji;(function(j){j[j.Separate=0]="Separate",j[j.MergeWithParent=1]="MergeWithParent"})(Ji||(e.DebugConsoleMode=Ji={}));let fi=class{static{this.Back={iconPath:new Vt("arrow-left")}}constructor(){}};e.$vL=fi,e.$vL=fi=qe([P],fi);var Qi;(function(j){j[j.Separator=-1]="Separator",j[j.Default=0]="Default"})(Qi||(e.QuickPickItemKind=Qi={}));var Zi;(function(j){j[j.Info=1]="Info",j[j.Warning=2]="Warning",j[j.Error=3]="Error"})(Zi||(e.InputBoxValidationSeverity=Zi={}));var gi;(function(j){j[j.UI=1]="UI",j[j.Workspace=2]="Workspace"})(gi||(e.ExtensionKind=gi={}));class Yi{static validate(L){if(typeof L.badge=="string"){let ne=(0,l.$$e)(L.badge,0);if(ne<L.badge.length&&(ne+=(0,l.$$e)(L.badge,ne)),L.badge.length>ne)throw new Error("The 'badge'-property must be undefined or a short character")}else if(L.badge&&!Vt.isThemeIcon(L.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!L.color&&!L.badge&&!L.tooltip)throw new Error("The decoration is empty");return!0}constructor(L,ne,ke){this.badge=L,this.tooltip=ne,this.color=ke}}e.$wL=Yi;let Ti=class{constructor(L){this.kind=L}};e.$xL=Ti,e.$xL=Ti=qe([P],Ti);var Xi;(function(j){j[j.Light=1]="Light",j[j.Dark=2]="Dark",j[j.HighContrast=3]="HighContrast",j[j.HighContrastLight=4]="HighContrastLight"})(Xi||(e.ColorThemeKind=Xi={}));class _t{static isNotebookRange(L){return L instanceof _t?!0:L?typeof L.start=="number"&&typeof L.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(L,ne){if(L<0)throw(0,M.$6)("start must be positive");if(ne<0)throw(0,M.$6)("end must be positive");L<=ne?(this.c=L,this.e=ne):(this.c=ne,this.e=L)}with(L){let ne=this.c,ke=this.e;return L.start!==void 0&&(ne=L.start),L.end!==void 0&&(ke=L.end),ne===this.c&&ke===this.e?this:new _t(ne,ke)}}e.$yL=_t;class yi{static validate(L){if(typeof L.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof L.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof L.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(L){return Array.isArray(L)&&L.every(ne=>yi.isNotebookCellData(ne))}static isNotebookCellData(L){return!0}constructor(L,ne,ke,He,Ye,ot,lt){this.kind=L,this.value=ne,this.languageId=ke,this.mime=He,this.outputs=Ye??[],this.metadata=ot,this.executionSummary=lt,yi.validate(this)}}e.$zL=yi;class hn{constructor(L){this.cells=L}}e.$AL=hn;class Qt{static isNotebookCellOutputItem(L){return L instanceof Qt?!0:L?typeof L.mime=="string"&&L.data instanceof Uint8Array:!1}static error(L){const ne={name:L.name,message:L.message,stack:L.stack};return Qt.json(ne,"application/vnd.code.notebook.error")}static stdout(L){return Qt.text(L,"application/vnd.code.notebook.stdout")}static stderr(L){return Qt.text(L,"application/vnd.code.notebook.stderr")}static bytes(L,ne="application/octet-stream"){return new Qt(L,ne)}static#e=new TextEncoder;static text(L,ne=A.$Lr.text){const ke=Qt.#e.encode(String(L));return new Qt(ke,ne)}static json(L,ne="text/x-json"){const ke=JSON.stringify(L,void 0,"	");return Qt.text(ke,ne)}constructor(L,ne){this.data=L,this.mime=ne;const ke=(0,A.$Pr)(ne,!0);if(!ke)throw new Error(`INVALID mime type: ${ne}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=ke}}e.$BL=Qt;class li{static isNotebookCellOutput(L){return L instanceof li?!0:!L||typeof L!="object"?!1:typeof L.id=="string"&&Array.isArray(L.items)}static ensureUniqueMimeTypes(L,ne=!1){const ke=new Set,He=new Set;for(let Ye=0;Ye<L.length;Ye++){const ot=L[Ye],lt=(0,A.$Pr)(ot.mime);if(!ke.has(lt)||(0,$.$lI)(lt)){ke.add(lt);continue}He.add(Ye),ne&&console.warn(`DUPLICATED mime type '${ot.mime}' will be dropped`)}return He.size===0?L:L.filter((Ye,ot)=>!He.has(ot))}constructor(L,ne,ke){this.items=li.ensureUniqueMimeTypes(L,!0),typeof ne=="string"?(this.id=ne,this.metadata=ke):(this.id=(0,R.$dg)(),this.metadata=ne??ke)}}e.$CL=li;var Li;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(Li||(e.NotebookCellKind=Li={}));var Ne;(function(j){j[j.Idle=1]="Idle",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(Ne||(e.NotebookCellExecutionState=Ne={}));var xt;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(xt||(e.NotebookCellStatusBarAlignment=xt={}));var Fi;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(Fi||(e.NotebookEditorRevealType=Fi={}));class $t{constructor(L,ne){this.text=L,this.alignment=ne}}e.$DL=$t;var _i;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred"})(_i||(e.NotebookControllerAffinity=_i={}));var xi;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred",j[j.Hidden=-1]="Hidden"})(xi||(e.NotebookControllerAffinity2=xi={}));class en{constructor(L,ne=[]){this.uri=L,this.provides=(0,w.$2b)(ne)}}e.$EL=en;class dn{constructor(L){this.label=L}}e.$FL=dn;let hi=class{constructor(L,ne){this.label=L,this.timestamp=ne}};e.$GL=hi,e.$GL=hi=qe([P],hi);var tn;(function(j){j[j.Production=1]="Production",j[j.Development=2]="Development",j[j.Test=3]="Test"})(tn||(e.ExtensionMode=tn={}));var nn;(function(j){j[j.Node=1]="Node",j[j.Webworker=2]="Webworker"})(nn||(e.ExtensionRuntime=nn={}));var rn;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(rn||(e.StandardTokenType=rn={}));class sn{constructor(L,ne){this.ranges=L,this.wordPattern=ne}}e.$HL=sn;class fn{constructor(L){this.c=L}get autoForwardAction(){return this.c}}e.$IL=fn;var on;(function(j){j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(on||(e.TestResultState=on={}));var an;(function(j){j[j.Run=1]="Run",j[j.Debug=2]="Debug",j[j.Coverage=3]="Coverage"})(an||(e.TestRunProfileKind=an={}));let Ni=class{constructor(L=void 0,ne=void 0,ke=void 0,He=!1){this.include=L,this.exclude=ne,this.profile=ke,this.continuous=He}};e.$JL=Ni,e.$JL=Ni=qe([P],Ni);let Oi=m=class{static diff(L,ne,ke){const He=new m(L);return He.expectedOutput=ne,He.actualOutput=ke,He}constructor(L){this.message=L}};e.$KL=Oi,e.$KL=Oi=m=qe([P],Oi);let zi=class{constructor(L){this.id=L}};e.$LL=zi,e.$LL=zi=qe([P],zi);let di=class{constructor(L,ne){this.covered=L,this.total=ne}};e.$ML=di,e.$ML=di=qe([P],di);let Ui=h=class{static fromDetails(L,ne){const ke=new di(0,0),He=new di(0,0),Ye=new di(0,0);for(const lt of ne)if("branches"in lt){ke.total+=1,ke.covered+=lt.executionCount>0?1:0;for(const Ut of lt.branches)He.total+=1,He.covered+=Ut.executionCount>0?1:0}else Ye.total+=1,Ye.covered+=lt.executionCount>0?1:0;const ot=new h(L,ke,He.total>0?He:void 0,Ye.total>0?Ye:void 0);return ot.detailedCoverage=ne,ot}constructor(L,ne,ke,He){this.uri=L,this.statementCoverage=ne,this.branchCoverage=ke,this.functionCoverage=He}};e.$NL=Ui,e.$NL=Ui=h=qe([P],Ui);let ji=class{constructor(L,ne,ke=[]){this.executionCount=L,this.location=ne,this.branches=ke}};e.$OL=ji,e.$OL=ji=qe([P],ji);let ee=class{constructor(L,ne){this.executionCount=L,this.location=ne}};e.$PL=ee,e.$PL=ee=qe([P],ee);let fe=class{constructor(L,ne){this.executionCount=L,this.location=ne}};e.$QL=fe,e.$QL=fe=qe([P],fe);var Le;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(Le||(e.ExternalUriOpenerPriority=Le={}));var nt;(function(j){j[j.Untrusted=0]="Untrusted",j[j.Trusted=1]="Trusted",j[j.Unspecified=2]="Unspecified"})(nt||(e.WorkspaceTrustState=nt={}));var bt;(function(j){j[j.Notify=1]="Notify",j[j.OpenBrowser=2]="OpenBrowser",j[j.OpenPreview=3]="OpenPreview",j[j.Silent=4]="Silent",j[j.Ignore=5]="Ignore",j[j.OpenBrowserOnce=6]="OpenBrowserOnce"})(bt||(e.PortAutoForwardAction=bt={}));class Tt{constructor(L,ne,ke,He,Ye,ot){this.kind=L,this.name=ne,this.detail=ke,this.uri=He,this.range=Ye,this.selectionRange=ot}}e.$RL=Tt;class yn{constructor(L){this.uri=L}}e.$SL=yn;class En{constructor(L,ne){this.original=L,this.modified=ne}}e.$TL=En;class Dn{constructor(L,ne,ke,He){this.base=L,this.input1=ne,this.input2=ke,this.result=He}}e.$UL=Dn;class kn{constructor(L,ne){this.uri=L,this.viewType=ne}}e.$VL=kn;class Sn{constructor(L){this.viewType=L}}e.$WL=Sn;class In{constructor(L,ne){this.uri=L,this.notebookType=ne}}e.$XL=In;class Cn{constructor(L,ne,ke){this.original=L,this.modified=ne,this.notebookType=ke}}e.$YL=Cn;class Pn{constructor(){}}e.$ZL=Pn;class An{constructor(L,ne){this.uri=L,this.inputBoxUri=ne}}e.$1L=An;var gn;(function(j){j[j.Up=1]="Up",j[j.Down=2]="Down"})(gn||(e.InteractiveSessionVoteDirection=gn={}));var mn;(function(j){j[j.Action=1]="Action",j[j.Toolbar=2]="Toolbar"})(mn||(e.InteractiveSessionCopyKind=mn={}));var $n;(function(j){j[j.Unhelpful=0]="Unhelpful",j[j.Helpful=1]="Helpful",j[j.Undone=2]="Undone",j[j.Accepted=3]="Accepted"})($n||(e.InteractiveEditorResponseFeedbackKind=$n={}));var pn;(function(j){j[j.System=0]="System",j[j.User=1]="User",j[j.Assistant=2]="Assistant",j[j.Function=3]="Function"})(pn||(e.ChatMessageRole=pn={}));var vn;(function(j){j[j.Short=1]="Short",j[j.Medium=2]="Medium",j[j.Full=3]="Full"})(vn||(e.ChatVariableLevel=vn={}));class Rn{constructor(L,ne){this.role=L,this.content=ne}}e.$2L=Rn;var bn;(function(j){j[j.SymbolInformation=1]="SymbolInformation",j[j.CommandInformation=2]="CommandInformation",j[j.SearchInformation=3]="SearchInformation",j[j.SettingInformation=4]="SettingInformation"})(bn||(e.RelatedInformationType=bn={}))}),define(Re[100],Me([1,0,51,13,15,277,136,7,18]),function(be,e,w,M,C,F,A,l,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eM=e.$dM=e.$cM=void 0;const f=new Map;function R($,g){g?f.set($,g):f.delete($)}e.$cM=R;function D($){return f.get($)}class c extends F.$Qu{constructor(g,t,n,a,b,E,v,r){super(t,n,a,b),this.c=g,this.m=E,this.q=v,this.notebook=r,this.b=!1}dispose(){(0,w.ok)(!this.b),this.b=!0,this.q=!1}equalLines(g){return(0,k.$tb)(this.f,g)}get document(){if(!this.a){const g=this;this.a={get uri(){return g.d},get fileName(){return g.d.fsPath},get isUntitled(){return g.d.scheme===M.Schemas.untitled},get languageId(){return g.m},get version(){return g.h},get isClosed(){return g.b},get isDirty(){return g.q},save(){return g.r()},getText(t){return t?g.s(t):g.getText()},get eol(){return g.g===`
`?l.EndOfLine.LF:l.EndOfLine.CRLF},get lineCount(){return g.f.length},lineAt(t){return g.t(t)},offsetAt(t){return g.u(t)},positionAt(t){return g.v(t)},validateRange(t){return g.w(t)},validatePosition(t){return g.x(t)},getWordRangeAtPosition(t,n){return g.y(t,n)}}}return Object.freeze(this.a)}_acceptLanguageId(g){(0,w.ok)(!this.b),this.m=g}_acceptIsDirty(g){(0,w.ok)(!this.b),this.q=g}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(g){const t=this.w(g);if(t.isEmpty)return"";if(t.isSingleLine)return this.f[t.start.line].substring(t.start.character,t.end.character);const n=this.g,a=t.start.line,b=t.end.line,E=[];E.push(this.f[a].substring(t.start.character));for(let v=a+1;v<b;v++)E.push(this.f[v]);return E.push(this.f[b].substring(0,t.end.character)),E.join(n)}t(g){let t;if(g instanceof l.$cK?t=g.line:typeof g=="number"&&(t=g),typeof t!="number"||t<0||t>=this.f.length||Math.floor(t)!==t)throw new Error("Illegal value for `line`");return new p(t,this.f[t],t===this.f.length-1)}u(g){return g=this.x(g),this.l(),this.j.getPrefixSum(g.line-1)+g.character}v(g){g=Math.floor(g),g=Math.max(0,g),this.l();const t=this.j.getIndexOf(g),n=this.f[t.index].length;return new l.$cK(t.index,Math.min(t.remainder,n))}w(g){if(!(g instanceof l.$dK))throw new Error("Invalid argument");const t=this.x(g.start),n=this.x(g.end);return t===g.start&&n===g.end?g:new l.$dK(t.line,t.character,n.line,n.character)}x(g){if(!(g instanceof l.$cK))throw new Error("Invalid argument");if(this.f.length===0)return g.with(0,0);let{line:t,character:n}=g,a=!1;if(t<0)t=0,n=0,a=!0;else if(t>=this.f.length)t=this.f.length-1,n=this.f[t].length,a=!0;else{const b=this.f[t].length;n<0?(n=0,a=!0):n>b&&(n=b,a=!0)}return a?new l.$cK(t,n):g}y(g,t){const n=this.x(g);if(!t)t=D(this.m);else if((0,C.$Ne)(t))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${t.source}' because it matches the empty string.`);const a=(0,A.$4r)(n.character+1,(0,A.$2r)(t),this.f[n.line],0);if(a)return new l.$dK(n.line,a.startColumn-1,n.line,a.endColumn-1)}}e.$dM=c;class p{constructor(g,t,n){this.a=g,this.b=t,this.c=n}get lineNumber(){return this.a}get text(){return this.b}get range(){return new l.$dK(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new l.$dK(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$eM=p}),define(Re[196],Me([1,0,7,17,5]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kdc=void 0;let F=class{constructor(l){this.a=new w.$xL(w.ColorThemeKind.Dark),this.b=new C.$Md}get activeColorTheme(){return this.a}$onColorThemeChange(l){let k;switch(l){case"light":k=w.ColorThemeKind.Light;break;case"hcDark":k=w.ColorThemeKind.HighContrast;break;case"hcLight":k=w.ColorThemeKind.HighContrastLight;break;default:k=w.ColorThemeKind.Dark}this.a=new w.$xL(k),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$kdc=F,e.$kdc=F=qe([We(0,M.$aM)],F)}),define(Re[197],Me([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pI=e.CellExecutionUpdateType=void 0;var M;(function(C){C[C.Output=1]="Output",C[C.OutputItems=2]="OutputItems",C[C.ExecutionState=3]="ExecutionState"})(M||(e.CellExecutionUpdateType=M={})),e.$pI=(0,w.$Nh)("INotebookExecutionService")}),define(Re[45],Me([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5I=e.TestPosition=e.TestIdPathParts=void 0;var w;(function(F){F.Delimiter="\0"})(w||(e.TestIdPathParts=w={}));var M;(function(F){F[F.IsSame=0]="IsSame",F[F.Disconnected=1]="Disconnected",F[F.IsChild=2]="IsChild",F[F.IsParent=3]="IsParent"})(M||(e.TestPosition=M={}));class C{static fromExtHostTestItem(A,l,k=A.parent){if(A._isRoot)return new C([l]);const f=[A.id];for(let R=k;R&&R.id!==l;R=R.parent)f.push(R.id);return f.push(l),new C(f.reverse())}static isRoot(A){return!A.includes("\0")}static root(A){const l=A.indexOf("\0");return l===-1?A:A.slice(0,l)}static fromString(A){return new C(A.split("\0"))}static join(A,l){return new C([...A.path,l])}static joinToString(A,l){return A.toString()+"\0"+l}static parentId(A){const l=A.lastIndexOf("\0");return l===-1?void 0:A.slice(0,l)}static localId(A){const l=A.lastIndexOf("\0");return l===-1?A:A.slice(l+1)}static isChild(A,l){return l.startsWith(A)&&l[A.length]==="\0"}static compare(A,l){return A===l?0:C.isChild(A,l)?2:C.isChild(l,A)?3:1}constructor(A,l=A.length){if(this.path=A,this.d=l,A.length===0||l<1)throw new Error("cannot create test with empty path")}get rootId(){return new C(this.path,1)}get parentId(){return this.d>1?new C(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new C(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new C(this.path,A)}compare(A){if(typeof A=="string")return C.compare(this.toString(),A);for(let l=0;l<A.d&&l<this.d;l++)if(A.path[l]!==this.path[l])return 1;return A.d>this.d?2:A.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+="\0",this.c+=this.path[A]}return this.c}}e.$5I=C}),define(Re[56],Me([1,0,2,44,45]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_I=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.$$I=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$0I=e.$9I=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$8I=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$7I=e.$6I=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var F;(function(S){S[S.Unset=0]="Unset",S[S.Queued=1]="Queued",S[S.Running=2]="Running",S[S.Passed=3]="Passed",S[S.Failed=4]="Failed",S[S.Skipped=5]="Skipped",S[S.Errored=6]="Errored"})(F||(e.TestResultState=F={}));var A;(function(S){S[S.Run=1]="Run",S[S.Debug=2]="Debug",S[S.Coverage=3]="Coverage"})(A||(e.ExtTestRunProfileKind=A={}));var l;(function(S){S[S.Run=2]="Run",S[S.Debug=4]="Debug",S[S.Coverage=8]="Coverage",S[S.HasNonDefaultProfile=16]="HasNonDefaultProfile",S[S.HasConfigurable=32]="HasConfigurable",S[S.SupportsContinuousRun=64]="SupportsContinuousRun"})(l||(e.TestRunProfileBitset=l={})),e.$6I=[2,4,8,16,32,64];const k=S=>"runId"in S;e.$7I=k;var f;(function(S){S.serialize=u=>({range:u.range.toJSON(),uri:u.uri.toJSON()}),S.deserialize=u=>({range:M.$os.lift(u.range),uri:w.URI.revive(u.uri)})})(f||(e.IRichLocation=f={}));var R;(function(S){S[S.Error=0]="Error",S[S.Output=1]="Output"})(R||(e.TestMessageType=R={}));var D;(function(S){S.serialize=u=>({message:u.message,type:0,expected:u.expected,actual:u.actual,contextValue:u.contextValue,location:u.location&&f.serialize(u.location)}),S.deserialize=u=>({message:u.message,type:0,expected:u.expected,actual:u.actual,contextValue:u.contextValue,location:u.location&&f.deserialize(u.location)})})(D||(e.ITestErrorMessage=D={}));const c=(S,u)=>`${u?"s":"e"}${S}`;e.$8I=c;var p;(function(S){S.serialize=u=>({message:u.message,type:1,offset:u.offset,length:u.length,location:u.location&&f.serialize(u.location)}),S.deserialize=u=>({message:u.message,type:1,offset:u.offset,length:u.length,location:u.location&&f.deserialize(u.location)})})(p||(e.ITestOutputMessage=p={}));var $;(function(S){S.serialize=u=>u.type===0?D.serialize(u):p.serialize(u),S.deserialize=u=>u.type===0?D.deserialize(u):p.deserialize(u)})($||(e.ITestMessage=$={}));var g;(function(S){S.serializeWithoutMessages=u=>({state:u.state,duration:u.duration,messages:[]}),S.serialize=u=>({state:u.state,duration:u.duration,messages:u.messages.map($.serialize)}),S.deserialize=u=>({state:u.state,duration:u.duration,messages:u.messages.map($.deserialize)})})(g||(e.ITestTaskState=g={}));const t="\0",n=(S,u)=>S+t+u;e.$9I=n;const a=S=>{const u=S.indexOf(t);return{ctrlId:S.slice(0,u),tagId:S.slice(u+1)}};e.$0I=a;var b;(function(S){S.serialize=u=>({extId:u.extId,label:u.label,tags:u.tags,busy:u.busy,children:void 0,uri:u.uri?.toJSON(),range:u.range?.toJSON()||null,description:u.description,error:u.error,sortText:u.sortText}),S.deserialize=u=>({extId:u.extId,label:u.label,tags:u.tags,busy:u.busy,children:void 0,uri:u.uri?w.URI.revive(u.uri):void 0,range:u.range?M.$os.lift(u.range):null,description:u.description,error:u.error,sortText:u.sortText})})(b||(e.ITestItem=b={}));var E;(function(S){S[S.NotExpandable=0]="NotExpandable",S[S.Expandable=1]="Expandable",S[S.BusyExpanding=2]="BusyExpanding",S[S.Expanded=3]="Expanded"})(E||(e.TestItemExpandState=E={}));var v;(function(S){S.serialize=u=>({expand:u.expand,item:b.serialize(u.item)}),S.deserialize=u=>({controllerId:C.$5I.root(u.item.extId),expand:u.expand,item:b.deserialize(u.item)})})(v||(e.InternalTestItem=v={}));var r;(function(S){S.serialize=u=>{let m;return u.item&&(m={},u.item.label!==void 0&&(m.label=u.item.label),u.item.tags!==void 0&&(m.tags=u.item.tags),u.item.busy!==void 0&&(m.busy=u.item.busy),u.item.uri!==void 0&&(m.uri=u.item.uri?.toJSON()),u.item.range!==void 0&&(m.range=u.item.range?.toJSON()),u.item.description!==void 0&&(m.description=u.item.description),u.item.error!==void 0&&(m.error=u.item.error),u.item.sortText!==void 0&&(m.sortText=u.item.sortText)),{extId:u.extId,expand:u.expand,item:m}},S.deserialize=u=>{let m;return u.item&&(m={},u.item.label!==void 0&&(m.label=u.item.label),u.item.tags!==void 0&&(m.tags=u.item.tags),u.item.busy!==void 0&&(m.busy=u.item.busy),u.item.range!==void 0&&(m.range=u.item.range?M.$os.lift(u.item.range):null),u.item.description!==void 0&&(m.description=u.item.description),u.item.error!==void 0&&(m.error=u.item.error),u.item.sortText!==void 0&&(m.sortText=u.item.sortText)),{extId:u.extId,expand:u.expand,item:m}}})(r||(e.ITestItemUpdate=r={}));const s=(S,u)=>{u.expand!==void 0&&(S.expand=u.expand),u.item!==void 0&&(S.item=S.item?Object.assign(S.item,u.item):u.item)};e.$$I=s;var i;(function(S){S.serializeWithoutMessages=u=>({...v.serialize(u),ownComputedState:u.ownComputedState,computedState:u.computedState,tasks:u.tasks.map(g.serializeWithoutMessages)}),S.serialize=u=>({...v.serialize(u),ownComputedState:u.ownComputedState,computedState:u.computedState,tasks:u.tasks.map(g.serialize)}),S.deserialize=u=>({...v.deserialize(u),ownComputedState:u.ownComputedState,computedState:u.computedState,tasks:u.tasks.map(g.deserialize),retired:!0})})(i||(e.TestResultItem=i={}));var o;(function(S){S[S.Function=0]="Function",S[S.Statement=1]="Statement"})(o||(e.DetailType=o={}));var y;(function(S){S[S.Add=0]="Add",S[S.Update=1]="Update",S[S.DocumentSynced=2]="DocumentSynced",S[S.Remove=3]="Remove",S[S.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",S[S.Retire=5]="Retire",S[S.AddTag=6]="AddTag",S[S.RemoveTag=7]="RemoveTag"})(y||(e.TestDiffOpType=y={}));var d;(function(S){S.deserialize=u=>u.op===0?{op:u.op,item:v.deserialize(u.item)}:u.op===1?{op:u.op,item:r.deserialize(u.item)}:u.op===2?{op:u.op,uri:w.URI.revive(u.uri),docv:u.docv}:u,S.serialize=u=>u.op===0?{op:u.op,item:v.serialize(u.item)}:u.op===1?{op:u.op,item:r.serialize(u.item)}:u})(d||(e.TestsDiffOp=d={}));class I{constructor(){this.d=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.d}apply(u){const m=this.p();for(const h of u)switch(h.op){case 0:this.k(v.deserialize(h.item),m);break;case 1:this.l(r.deserialize(h.item),m);break;case 3:this.m(h.itemId,m);break;case 5:this.o(h.itemId);break;case 4:this.updatePendingRoots(h.amount);break;case 6:this.d.set(h.tag.id,h.tag);break;case 7:this.d.delete(h.id);break}m.complete?.()}k(u,m){const h=C.$5I.parentId(u.item.extId)?.toString();let P;if(!h)P=this.q(u),this.g.add(P),this.f.set(u.item.extId,P);else if(this.f.has(h)){const W=this.f.get(h);W.children.add(u.item.extId),P=this.q(u,W),this.f.set(u.item.extId,P)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(u)}`);return}return m.add?.(P),u.expand===2&&this.h++,P}l(u,m){const h=this.f.get(u.extId);if(h)return u.expand!==void 0&&(h.expand===2&&this.h--,u.expand===2&&this.h++),(0,e.$$I)(h,u),m.update?.(h),h}m(u,m){const h=this.f.get(u);if(!h)return;const P=C.$5I.parentId(h.item.extId)?.toString();P?this.f.get(P).children.delete(h.item.extId):this.g.delete(h);const W=[[u]];for(;W.length;)for(const K of W.pop()){const U=this.f.get(K);U&&(W.push(U.children),this.f.delete(K),m.remove?.(U,U!==h),U.expand===2&&this.h--)}}o(u){}updatePendingRoots(u){this.j+=u}p(){return{}}}e.$_I=I}),define(Re[76],Me([1,0,12,5,6,51,56,45]),function(be,e,w,M,C,F,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7L=e.$6L=e.$5L=e.$4L=e.$3L=e.TestItemEventOp=void 0;var k;(function(a){a[a.Upsert=0]="Upsert",a[a.SetTags=1]="SetTags",a[a.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",a[a.RemoveChild=3]="RemoveChild",a[a.SetProp=4]="SetProp",a[a.Bulk=5]="Bulk",a[a.DocumentSynced=6]="DocumentSynced"})(k||(e.TestItemEventOp=k={}));const f=(a,b)=>a===b,D=Object.entries({range:(a,b)=>a===b?!0:!a||!b?!1:a.equalsRange(b),busy:f,label:f,description:f,error:f,sortText:f,tags:(a,b)=>!(a.length!==b.length||a.some(E=>!b.includes(E)))}),c=(a,b)=>{let E;for(const[v,r]of D)r(a[v],b[v])||(E?E[v]=b[v]:E={[v]:b[v]});return E};class p extends C.$Rc{get root(){return this.s.root}constructor(b){super(),this.s=b,this.f=this.B(new w.$5g(()=>this.flushDiff(),200)),this.g=this.B(new M.$Md),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.y(this.root,void 0)}set resolveHandler(b){this.h=b;for(const E of this.tree.values())this.I(E)}get resolveHandler(){return this.h}collectDiff(){const b=this.m;return this.m=[],b}pushDiff(b){switch(b.op){case 2:{for(const E of this.m)if(E.op===2&&E.uri===b.uri){E.docv=b.docv;return}break}case 1:{const E=this.m[this.m.length-1];if(E){if(E.op===1&&E.item.extId===b.item.extId){(0,A.$$I)(E.item,b.item);return}if(E.op===0&&E.item.item.extId===b.item.extId){(0,A.$$I)(E.item,b.item);return}}break}}this.m.push(b),this.f.isScheduled()||this.f.schedule()}expand(b,E){const v=this.tree.get(b);if(v){if((v.expandLevels===void 0||E>v.expandLevels)&&(v.expandLevels=E),v.expand===1){const r=this.L(v);return r.isOpen()?this.J(v,E-1):r.wait().then(()=>this.J(v,E-1))}else if(v.expand===3)return v.resolveBarrier?.isOpen()===!1?v.resolveBarrier.wait().then(()=>this.J(v,E-1)):this.J(v,E-1)}}dispose(){for(const b of this.tree.values())this.s.getApiFor(b.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}u(b,E){switch(E.op){case 3:this.N(l.$5I.joinToString(b.fullId,E.id));break;case 0:this.y(E.item,b);break;case 5:for(const v of E.ops)this.u(b,v);break;case 1:this.z(E.new,E.old,b.fullId.toString());break;case 2:this.I(b);break;case 4:this.pushDiff({op:1,item:{extId:b.fullId.toString(),item:E.update}});break;case 6:this.w(b.actual.uri);break;default:(0,F.$3c)(E)}}w(b){b&&this.pushDiff({op:2,uri:b,docv:this.s.getDocumentVersion(b)})}y(b,E){const v=l.$5I.fromExtHostTestItem(b,this.root.id,E?.actual),r=this.s.getApiFor(b);r.parent&&r.parent!==E?.actual&&this.s.getChildren(r.parent).delete(b.id);let s=this.tree.get(v.toString());if(!s){s={fullId:v,actual:b,expandLevels:E?.expandLevels?E.expandLevels-1:void 0,expand:0},b.tags.forEach(this.C,this),this.tree.set(s.fullId.toString(),s),this.F(b,E),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:s.expand,item:this.s.toITestItem(b)}}),this.H(b,s,E);return}if(s.actual===b){this.G(b,s,E);return}if(s.actual.uri?.toString()!==b.uri?.toString())return this.N(v.toString()),this.y(b,E);const i=this.s.getChildren(s.actual),o=s.actual,y=c(this.s.toITestItem(o),this.s.toITestItem(b));this.s.getApiFor(o).listener=void 0,s.actual=b,s.expand=0,y&&(y.hasOwnProperty("tags")&&(this.z(b.tags,o.tags,v.toString()),delete y.tags),this.u(s,{op:4,update:y})),this.H(b,s,E);for(const[d,I]of i)this.s.getChildren(b).get(I.id)||this.N(l.$5I.joinToString(v,I.id));this.w(s.actual.uri)}z(b,E,v){const r=new Set(E.map(s=>s.id));for(const s of b)r.delete(s.id)||this.C(s);this.pushDiff({op:1,item:{extId:v,item:{tags:b.map(s=>(0,A.$9I)(this.s.controllerId,s.id))}}}),r.forEach(this.D,this)}C(b){const E=this.j.get(b.id);E?E.refCount++:(this.j.set(b.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,A.$9I)(this.s.controllerId,b.id)}}))}D(b){const E=this.j.get(b);E&&!--E.refCount&&(this.j.delete(b),this.pushDiff({op:7,id:(0,A.$9I)(this.s.controllerId,b)}))}F(b,E){this.s.getApiFor(b).parent=E&&E.actual!==this.root?E.actual:void 0}G(b,E,v){this.F(b,v);const r=this.s.getApiFor(b);r.parent=v?.actual,r.listener=s=>this.u(E,s),this.I(E)}H(b,E,v){this.G(b,E,v);for(const[r,s]of this.s.getChildren(b))this.y(s,E)}I(b){let E;this.h?b.resolveBarrier?E=b.resolveBarrier.isOpen()?3:2:E=b.actual.canResolveChildren?1:0:E=0,E!==b.expand&&(b.expand=E,this.pushDiff({op:1,item:{extId:b.fullId.toString(),expand:E}}),E===1&&b.expandLevels!==void 0&&this.L(b))}J(b,E){if(E<0)return;const v=[];for(const[r,s]of this.s.getChildren(b.actual)){const i=this.expand(l.$5I.joinToString(b.fullId,s.id),E);(0,w.$Fg)(i)&&v.push(i)}if(v.length)return Promise.all(v).then(()=>{})}L(b){if(b.resolveBarrier)return b.resolveBarrier;if(!this.h){const s=new w.$Rg;return s.open(),s}b.expand=2,this.M(b);const E=b.resolveBarrier=new w.$Rg,v=s=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,s)};let r;try{r=this.h(b.actual===this.root?void 0:b.actual)}catch(s){v(s)}return(0,w.$Fg)(r)?r.catch(v).then(()=>{E.open(),this.I(b)}):(E.open(),this.I(b)),b.resolveBarrier}M(b){this.pushDiff({op:1,item:{extId:b.fullId.toString(),expand:b.expand}})}N(b){const E=this.tree.get(b);if(!E)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:b});const v=[E];for(;v.length;){const r=v.pop();if(r){this.s.getApiFor(r.actual).listener=void 0;for(const s of r.actual.tags)this.D(s.id);this.tree.delete(r.fullId.toString());for(const[s,i]of this.s.getChildren(r.actual))v.push(this.tree.get(l.$5I.joinToString(r.fullId,i.id)))}}}flushDiff(){const b=this.collectDiff();b.length&&this.g.fire(b)}}e.$3L=p;class $ extends Error{constructor(b){super(`Attempted to insert a duplicate test item ID ${b}`)}}e.$4L=$;class g extends Error{constructor(b){super(`TestItem with ID "${b}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$5L=g;class t extends Error{constructor(b,E,v){super(`TestItem with ID "${b}" is from controller "${E}" and cannot be added as a child of an item from controller "${v}".`)}}e.$6L=t;const n=(a,b,E)=>{let v=new Map;return{get size(){return v.size},forEach(r,s){for(const i of v.values())r.call(s,i,this)},[Symbol.iterator](){return v.entries()},replace(r){const s=new Map,i=new Set(v.keys()),o={op:5,ops:[]};for(const y of r){if(!(y instanceof E))throw new g(y.id);const d=b(y).controllerId;if(d!==a.controllerId)throw new t(y.id,d,a.controllerId);if(s.has(y.id))throw new $(y.id);s.set(y.id,y),i.delete(y.id),o.ops.push({op:0,item:y})}for(const y of i.keys())o.ops.push({op:3,id:y});a.listener?.(o),v=s},add(r){if(!(r instanceof E))throw new g(r.id);v.set(r.id,r),a.listener?.({op:0,item:r})},delete(r){v.delete(r)&&a.listener?.({op:3,id:r})},get(r){return v.get(r)},toJSON(){return Array.from(v.values())}}};e.$7L=n}),define(Re[101],Me([1,0,76]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9L=e.$8L=void 0;const M=new WeakMap,C=(A,l)=>{const k={controllerId:l};return M.set(A,k),k};e.$8L=C;const F=A=>{const l=M.get(A);if(!l)throw new w.$5L(A?.id||"<unknown>");return l};e.$9L=F}),define(Re[77],Me([1,0,13,2]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2ob=e.$1ob=e.$Zob=e.$Yob=e.$Xob=void 0,e.$Xob="vscode-cdn.net",e.$Yob=`vscode-resource.${e.$Xob}`,e.$Zob=`'self' https://*.${e.$Xob}`;function C(l,k){return l.scheme===w.Schemas.http||l.scheme===w.Schemas.https?l:(k&&k.authority&&k.isRemote&&l.scheme===w.Schemas.file&&(l=M.URI.from({scheme:w.Schemas.vscodeRemote,authority:k.authority,path:l.path})),M.URI.from({scheme:w.Schemas.https,authority:`${l.scheme}+${F(l.authority)}.${e.$Yob}`,path:l.path,fragment:l.fragment,query:l.query}))}e.$1ob=C;function F(l){return l.replace(/./g,k=>{const f=k.charCodeAt(0);return f>=97&&f<=122||f>=65&&f<=90||f>=48&&f<=57?k:"-"+f.toString(16).padStart(4,"0")})}function A(l){return l.replace(/-([0-9a-f]{4})/g,(k,f)=>String.fromCharCode(parseInt(f,16)))}e.$2ob=A}),define(Re[198],Me([1,0,5,6,77]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ucc=void 0;class F{constructor(l,k,f){this.d=l,this.e=k,this.f=f,this.a=0,this.b=new M.$Qc,this.c=new Map,this.b.add(k.onDidChangeVisibleTextEditors(()=>{const R=k.getVisibleTextEditors();for(const D of this.c.values())R.indexOf(D.editor)<0&&D.inset.dispose()}))}dispose(){this.c.forEach(l=>l.inset.dispose()),this.b.dispose()}createWebviewEditorInset(l,k,f,R,D){let c;for(const b of this.e.getVisibleTextEditors(!0))if(b.value===l){c=b;break}if(!c)throw new Error("not a visible editor");const p=this,$=this.a++,g=new w.$Md,t=new w.$Md,n=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(b){return(0,C.$1ob)(b,p.f)}get cspSource(){return C.$Zob}set options(b){this.b=b,p.d.$setOptions($,b)}get options(){return this.b}set html(b){this.a=b,p.d.$setHtml($,b)}get html(){return this.a}get onDidReceiveMessage(){return g.event}postMessage(b){return p.d.$postMessage($,b)}},a=new class{constructor(){this.editor=l,this.line=k,this.height=f,this.webview=n,this.onDidDispose=t.event}dispose(){p.c.has($)&&(p.c.delete($),p.d.$disposeEditorInset($),t.fire(),t.dispose(),g.dispose())}};return this.d.$createEditorInset($,c.id,c.value.document.uri,k+1,f,R||{},D.identifier,D.extensionLocation),this.c.set($,{editor:l,inset:a,onDidReceiveMessage:g}),a}$onDidDispose(l){const k=this.c.get(l);k&&k.inset.dispose()}$onDidReceiveMessage(l,k){this.c.get(l)?.onDidReceiveMessage.fire(k)}}e.$Ucc=F}),define(Re[199],Me([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZM=e.VariableKind=e.$YM=void 0,e.$YM=(0,w.$Nh)("configurationResolverService");var M;(function(F){F.Unknown="unknown",F.Env="env",F.Config="config",F.Command="command",F.Input="input",F.ExtensionInstallFolder="extensionInstallFolder",F.WorkspaceFolder="workspaceFolder",F.Cwd="cwd",F.WorkspaceFolderBasename="workspaceFolderBasename",F.UserHome="userHome",F.LineNumber="lineNumber",F.SelectedText="selectedText",F.File="file",F.FileWorkspaceFolder="fileWorkspaceFolder",F.RelativeFile="relativeFile",F.RelativeFileDirname="relativeFileDirname",F.FileDirname="fileDirname",F.FileExtname="fileExtname",F.FileBasename="fileBasename",F.FileBasenameNoExtension="fileBasenameNoExtension",F.FileDirnameBasename="fileDirnameBasename",F.ExecPath="execPath",F.ExecInstallFolder="execInstallFolder",F.PathSeparator="pathSeparator"})(M||(e.VariableKind=M={}));class C extends Error{constructor(A,l){super(l),this.variable=A}}e.$ZM=C}),define(Re[200],Me([1,0,19,73,16,24,22,90,165,199,15]),function(be,e,w,M,C,F,A,l,k,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bN=void 0;class D{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(p,$,g,t){this.h=new Map,this.a=p,this.b=$,this.g=g,t&&(this.c=t.then(n=>this.i(n)))}i(p){if(A.$j){const $=Object.create(null);return Object.keys(p).forEach(g=>{$[g.toLowerCase()]=p[g]}),$}return p}resolveWithEnvironment(p,$,g){return this.l({env:this.i(p),userHome:void 0},$?$.uri:void 0,g)}async resolveAsync(p,$){const g={env:await this.c,userHome:await this.g};return this.l(g,p?p.uri:void 0,$)}async j(p,$,g,t){const n=F.$2m($);A.$j&&n.windows?Object.keys(n.windows).forEach(b=>n[b]=n.windows[b]):A.$k&&n.osx?Object.keys(n.osx).forEach(b=>n[b]=n.osx[b]):A.$l&&n.linux&&Object.keys(n.linux).forEach(b=>n[b]=n.linux[b]),delete n.windows,delete n.osx,delete n.linux;const a={env:await this.c,userHome:await this.g};return this.l(a,p?p.uri:void 0,n,g,t)}async resolveAnyAsync(p,$,g){return this.j(p,$,g)}async resolveAnyMap(p,$,g){const t=new Map;return{newConfig:await this.j(p,$,g,t),resolvedVariables:t}}resolveWithInteractionReplace(p,$,g,t){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(p,$,g,t){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(p,$){if(this.h.has(p))throw new Error("Variable "+p+" is contributed twice.");this.h.set(p,$)}async l(p,$,g,t,n){if(C.$xf(g))return this.m(p,$,g,t,n);if(Array.isArray(g))return Promise.all(g.map(a=>this.l(p,$,a,t,n)));if(C.$zf(g)){const a=Object.create(null),b=await Promise.all(Object.keys(g).map(async E=>[await this.m(p,$,E,t,n),await this.l(p,$,g[E],t,n)]));for(const[E,v]of b)a[E]=v;return a}return g}m(p,$,g,t,n){return(0,R.$Se)(g,D.VARIABLE_REGEXP,async(a,b)=>{if(b.includes(D.VARIABLE_LHS))return a;let E=await this.o(p,a,b,$,t);return n?.set(b,E),E!==a&&C.$xf(E)&&E.match(D.VARIABLE_REGEXP)&&(E=await this.m(p,$,E,t,n)),E})}n(p){return this.b?this.b.getUriLabel(p,{noPrefix:!0}):p.fsPath}async o(p,$,g,t,n){let a;const b=g.split(":");b.length>1&&(g=b[0],a=b[1]);const E=s=>{const i=this.a.getFilePath();if(i)return(0,l.$mv)(i);throw new f.$ZM(s,(0,k.localize)(0,null,$))},v=s=>{const i=E(s);if(this.a.getWorkspaceFolderPathForFile){const o=this.a.getWorkspaceFolderPathForFile();if(o)return(0,l.$mv)(o)}throw new f.$ZM(s,(0,k.localize)(1,null,$,w.$mc(i)))},r=s=>{if(a){const i=this.a.getFolderUri(a);if(i)return i;throw new f.$ZM(s,(0,k.localize)(2,null,$,a))}if(t)return t;throw this.a.getWorkspaceFolderCount()>1?new f.$ZM(s,(0,k.localize)(3,null,$)):new f.$ZM(s,(0,k.localize)(4,null,$))};switch(g){case"env":if(a){if(p.env){const s=p.env[A.$j?a.toLowerCase():a];if(C.$xf(s))return s}return""}throw new f.$ZM(f.VariableKind.Env,(0,k.localize)(5,null,$));case"config":if(a){const s=this.a.getConfigurationValue(t,a);if(C.$Gf(s))throw new f.$ZM(f.VariableKind.Config,(0,k.localize)(6,null,$,a));if(C.$zf(s))throw new f.$ZM(f.VariableKind.Config,(0,k.localize)(7,null,$,a));return s}throw new f.$ZM(f.VariableKind.Config,(0,k.localize)(8,null,$));case"command":return this.p(f.VariableKind.Command,$,a,n,"command");case"input":return this.p(f.VariableKind.Input,$,a,n,"input");case"extensionInstallFolder":if(a){const s=await this.a.getExtension(a);if(!s)throw new f.$ZM(f.VariableKind.ExtensionInstallFolder,(0,k.localize)(9,null,$,a));return this.n(s.extensionLocation)}throw new f.$ZM(f.VariableKind.ExtensionInstallFolder,(0,k.localize)(10,null,$));default:switch(g){case"workspaceRoot":case"workspaceFolder":return(0,l.$mv)(this.n(r(f.VariableKind.WorkspaceFolder)));case"cwd":return t||a?(0,l.$mv)(this.n(r(f.VariableKind.Cwd))):M.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,l.$mv)(w.$mc(this.n(r(f.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(p.userHome)return p.userHome;throw new f.$ZM(f.VariableKind.UserHome,(0,k.localize)(11,null,$))}case"lineNumber":{const s=this.a.getLineNumber();if(s)return s;throw new f.$ZM(f.VariableKind.LineNumber,(0,k.localize)(12,null,$))}case"selectedText":{const s=this.a.getSelectedText();if(s)return s;throw new f.$ZM(f.VariableKind.SelectedText,(0,k.localize)(13,null,$))}case"file":return E(f.VariableKind.File);case"fileWorkspaceFolder":return v(f.VariableKind.FileWorkspaceFolder);case"relativeFile":return t||a?w.$kc(this.n(r(f.VariableKind.RelativeFile)),E(f.VariableKind.RelativeFile)):E(f.VariableKind.RelativeFile);case"relativeFileDirname":{const s=w.$lc(E(f.VariableKind.RelativeFileDirname));if(t||a){const i=w.$kc(this.n(r(f.VariableKind.RelativeFileDirname)),s);return i.length===0?".":i}return s}case"fileDirname":return w.$lc(E(f.VariableKind.FileDirname));case"fileExtname":return w.$nc(E(f.VariableKind.FileExtname));case"fileBasename":return w.$mc(E(f.VariableKind.FileBasename));case"fileBasenameNoExtension":{const s=w.$mc(E(f.VariableKind.FileBasenameNoExtension));return s.slice(0,s.length-w.$nc(s).length)}case"fileDirnameBasename":return w.$mc(w.$lc(E(f.VariableKind.FileDirnameBasename)));case"execPath":{const s=this.a.getExecPath();return s||$}case"execInstallFolder":{const s=this.a.getAppRoot();return s||$}case"pathSeparator":return w.sep;default:try{const s=a?`${g}:${a}`:g;return this.p(f.VariableKind.Unknown,$,s,n,void 0)}catch{return $}}}}p(p,$,g,t,n){if(g&&t){const a=n===void 0?t[g]:t[n+":"+g];if(typeof a=="string")return a;throw new f.$ZM(p,(0,k.localize)(14,null,$))}return $}}e.$bN=D}),define(Re[102],Me([1,0,4,99]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bC=e.$aC=e.OpenEditorContext=e.GroupsOrder=e.$_B=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$$B=void 0,e.$$B=(0,w.$Nh)("editorGroupsService");var C;(function($){$[$.UP=0]="UP",$[$.DOWN=1]="DOWN",$[$.LEFT=2]="LEFT",$[$.RIGHT=3]="RIGHT"})(C||(e.GroupDirection=C={}));var F;(function($){$[$.HORIZONTAL=0]="HORIZONTAL",$[$.VERTICAL=1]="VERTICAL"})(F||(e.GroupOrientation=F={}));var A;(function($){$[$.FIRST=0]="FIRST",$[$.LAST=1]="LAST",$[$.NEXT=2]="NEXT",$[$.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var l;(function($){$[$.MAXIMIZE=0]="MAXIMIZE",$[$.EVEN=1]="EVEN",$[$.TOGGLE=2]="TOGGLE"})(l||(e.GroupsArrangement=l={}));var k;(function($){$[$.COPY_EDITORS=0]="COPY_EDITORS",$[$.MOVE_EDITORS=1]="MOVE_EDITORS"})(k||(e.MergeGroupMode=k={}));function f($){const g=$;return(0,M.$1D)(g?.editor)&&(0,M.$1D)(g?.replacement)}e.$_B=f;var R;(function($){$[$.CREATION_TIME=0]="CREATION_TIME",$[$.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",$[$.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R||(e.GroupsOrder=R={}));var D;(function($){$[$.NEW_EDITOR=1]="NEW_EDITOR",$[$.MOVE_EDITOR=2]="MOVE_EDITOR",$[$.COPY_EDITOR=3]="COPY_EDITOR"})(D||(e.OpenEditorContext=D={}));function c($){const g=$;return!!g&&typeof g.id=="number"&&Array.isArray(g.editors)}e.$aC=c;function p($){return $.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$bC=p}),define(Re[201],Me([1,0,4,102]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fC=e.$eC=e.$dC=e.$cC=void 0,e.$cC=(0,w.$Nh)("editorService"),e.$dC=-1,e.$eC=-2;function C(F){const A=F;return typeof F=="number"||(0,M.$aC)(A)}e.$fC=C}),define(Re[8],Me([1,0,18,26,122,202,50,28,116,67,66,24,16,2,44,78,94,101,99,75,45,56,201,7]),function(be,e,w,M,C,F,A,l,k,f,R,D,c,p,$,g,t,n,a,b,E,v,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$_L=e.$$L=e.MarkdownString=e.$0L=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var i;(function(Ce){function Ae(G){const{selectionStartLineNumber:Te,selectionStartColumn:Be,positionLineNumber:Je,positionColumn:Ve}=G,et=new s.$cK(Te-1,Be-1),gt=new s.$cK(Je-1,Ve-1);return new s.$eK(et,gt)}Ce.to=Ae;function ge(G){const{anchor:Te,active:Be}=G;return{selectionStartLineNumber:Te.line+1,selectionStartColumn:Te.character+1,positionLineNumber:Be.line+1,positionColumn:Be.character+1}}Ce.from=ge})(i||(e.Selection=i={}));var o;(function(Ce){function Ae(G){if(!G)return;const{start:Te,end:Be}=G;return{startLineNumber:Te.line+1,startColumn:Te.character+1,endLineNumber:Be.line+1,endColumn:Be.character+1}}Ce.from=Ae;function ge(G){if(!G)return;const{startLineNumber:Te,startColumn:Be,endLineNumber:Je,endColumn:Ve}=G;return new s.$dK(Te-1,Be-1,Je-1,Ve-1)}Ce.to=ge})(o||(e.Range=o={}));var y;(function(Ce){function Ae(ge){switch(ge){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 3:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}Ce.to=Ae})(y||(e.TokenType=y={}));var d;(function(Ce){function Ae(G){return new s.$cK(G.lineNumber-1,G.column-1)}Ce.to=Ae;function ge(G){return{lineNumber:G.line+1,column:G.character+1}}Ce.from=ge})(d||(e.Position=d={}));var I;(function(Ce){function Ae(Te,Be,Je){return(0,w.$Gb)((0,w.$2b)(Te).map(Ve=>ge(Ve,Be,Je)))}Ce.from=Ae;function ge(Te,Be,Je){if(typeof Te=="string")return{$serialized:!0,language:Te,isBuiltin:Je?.isBuiltin};if(Te)return{$serialized:!0,language:Te.language,scheme:G(Te.scheme,Be),pattern:st.from(Te.pattern)??void 0,exclusive:Te.exclusive,notebookType:Te.notebookType,isBuiltin:Je?.isBuiltin}}function G(Te,Be){return Be&&typeof Te=="string"?Be.transformOutgoingScheme(Te):Te}})(I||(e.DocumentSelector=I={}));var S;(function(Ce){function Ae(G){switch(G){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}Ce.from=Ae;function ge(G){switch(G){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}Ce.to=ge})(S||(e.DiagnosticTag=S={}));var u;(function(Ce){function Ae(G){let Te;return G.code&&((0,c.$xf)(G.code)||(0,c.$Bf)(G.code)?Te=String(G.code):Te={value:String(G.code.value),target:G.code.target}),{...o.from(G.range),message:G.message,source:G.source,code:Te,severity:h.from(G.severity),relatedInformation:G.relatedInformation&&G.relatedInformation.map(m.from),tags:Array.isArray(G.tags)?(0,w.$Gb)(G.tags.map(S.from)):void 0}}Ce.from=Ae;function ge(G){const Te=new s.$pK(o.to(G),G.message,h.to(G.severity));return Te.source=G.source,Te.code=(0,c.$xf)(G.code)?G.code:G.code?.value,Te.relatedInformation=G.relatedInformation&&G.relatedInformation.map(m.to),Te.tags=G.tags&&(0,w.$Gb)(G.tags.map(S.to)),Te}Ce.to=ge})(u||(e.Diagnostic=u={}));var m;(function(Ce){function Ae(G){return{...o.from(G.location.range),message:G.message,resource:G.location.uri}}Ce.from=Ae;function ge(G){return new s.$oK(new s.$nK(G.resource,o.to(G)),G.message)}Ce.to=ge})(m||(e.DiagnosticRelatedInformation=m={}));var h;(function(Ce){function Ae(G){switch(G){case s.DiagnosticSeverity.Error:return t.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return t.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return t.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return t.MarkerSeverity.Hint}return t.MarkerSeverity.Error}Ce.from=Ae;function ge(G){switch(G){case t.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case t.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case t.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case t.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}Ce.to=ge})(h||(e.DiagnosticSeverity=h={}));var P;(function(Ce){function Ae(G){return typeof G=="number"&&G>=s.ViewColumn.One?G-1:G===s.ViewColumn.Beside?r.$eC:r.$dC}Ce.from=Ae;function ge(G){if(typeof G=="number"&&G>=0)return G+1;throw new Error("invalid 'EditorGroupColumn'")}Ce.to=ge})(P||(e.ViewColumn=P={}));function W(Ce){return typeof Ce.range<"u"}function K(Ce){return Ce.length===0?!0:!!W(Ce[0])}e.$0L=K;var U;(function(Ce){function Ae(Ve){return Ve.map(Ce.from)}Ce.fromMany=Ae;function ge(Ve){return Ve&&typeof Ve=="object"&&typeof Ve.language=="string"&&typeof Ve.value=="string"}function G(Ve){let et;if(ge(Ve)){const{language:ht,value:Rt}=Ve;et={value:"```"+ht+`
`+Rt+"\n```\n"}}else s.$BK.isMarkdownString(Ve)?et={value:Ve.value,isTrusted:Ve.isTrusted,supportThemeIcons:Ve.supportThemeIcons,supportHtml:Ve.supportHtml,baseUri:Ve.baseUri}:typeof Ve=="string"?et={value:Ve}:et={value:""};const gt=Object.create(null);et.uris=gt;const ft=ht=>{try{let Rt=p.URI.parse(ht,!0);Rt=Rt.with({query:Te(Rt.query,gt)}),gt[ht]=Rt}catch{}return""},pt=new k.marked.Renderer;return pt.link=ft,pt.image=ht=>typeof ht=="string"?ft(A.$8j(ht).href):"",(0,k.marked)(et.value,{renderer:pt}),et}Ce.from=G;function Te(Ve,et){if(!Ve)return Ve;let gt;try{gt=(0,f.$jh)(Ve)}catch{}if(!gt)return Ve;let ft=!1;return gt=(0,D.$4m)(gt,pt=>{if(p.URI.isUri(pt)){const ht=`__uri_${Math.random().toString(16).slice(2,8)}`;return et[ht]=pt,ft=!0,ht}else return}),ft?JSON.stringify(gt):Ve}function Be(Ve){const et=new s.$BK(Ve.value,Ve.supportThemeIcons);return et.isTrusted=Ve.isTrusted,et.supportHtml=Ve.supportHtml,et.baseUri=Ve.baseUri?p.URI.from(Ve.baseUri):void 0,et}Ce.to=Be;function Je(Ve){if(Ve)return typeof Ve=="string"?Ve:Ce.from(Ve)}Ce.fromStrict=Je})(U||(e.MarkdownString=U={}));function B(Ce){return K(Ce)?Ce.map(Ae=>({range:o.from(Ae.range),hoverMessage:Array.isArray(Ae.hoverMessage)?U.fromMany(Ae.hoverMessage):Ae.hoverMessage?U.from(Ae.hoverMessage):void 0,renderOptions:Ae.renderOptions})):Ce.map(Ae=>({range:o.from(Ae)}))}e.$$L=B;function O(Ce){return typeof Ce>"u"?Ce:typeof Ce=="string"?p.URI.file(Ce):Ce}e.$_L=O;var N;(function(Ce){function Ae(ge){return typeof ge>"u"?ge:{contentText:ge.contentText,contentIconPath:ge.contentIconPath?O(ge.contentIconPath):void 0,border:ge.border,borderColor:ge.borderColor,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,color:ge.color,backgroundColor:ge.backgroundColor,margin:ge.margin,width:ge.width,height:ge.height}}Ce.from=Ae})(N||(e.ThemableDecorationAttachmentRenderOptions=N={}));var te;(function(Ce){function Ae(ge){return typeof ge>"u"?ge:{backgroundColor:ge.backgroundColor,outline:ge.outline,outlineColor:ge.outlineColor,outlineStyle:ge.outlineStyle,outlineWidth:ge.outlineWidth,border:ge.border,borderColor:ge.borderColor,borderRadius:ge.borderRadius,borderSpacing:ge.borderSpacing,borderStyle:ge.borderStyle,borderWidth:ge.borderWidth,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,cursor:ge.cursor,color:ge.color,opacity:ge.opacity,letterSpacing:ge.letterSpacing,gutterIconPath:ge.gutterIconPath?O(ge.gutterIconPath):void 0,gutterIconSize:ge.gutterIconSize,overviewRulerColor:ge.overviewRulerColor,before:ge.before?N.from(ge.before):void 0,after:ge.after?N.from(ge.after):void 0}}Ce.from=Ae})(te||(e.ThemableDecorationRenderOptions=te={}));var Y;(function(Ce){function Ae(ge){if(typeof ge>"u")return ge;switch(ge){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}Ce.from=Ae})(Y||(e.DecorationRangeBehavior=Y={}));var ye;(function(Ce){function Ae(ge){return{isWholeLine:ge.isWholeLine,rangeBehavior:ge.rangeBehavior?Y.from(ge.rangeBehavior):void 0,overviewRulerLane:ge.overviewRulerLane,light:ge.light?te.from(ge.light):void 0,dark:ge.dark?te.from(ge.dark):void 0,backgroundColor:ge.backgroundColor,outline:ge.outline,outlineColor:ge.outlineColor,outlineStyle:ge.outlineStyle,outlineWidth:ge.outlineWidth,border:ge.border,borderColor:ge.borderColor,borderRadius:ge.borderRadius,borderSpacing:ge.borderSpacing,borderStyle:ge.borderStyle,borderWidth:ge.borderWidth,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,cursor:ge.cursor,color:ge.color,opacity:ge.opacity,letterSpacing:ge.letterSpacing,gutterIconPath:ge.gutterIconPath?O(ge.gutterIconPath):void 0,gutterIconSize:ge.gutterIconSize,overviewRulerColor:ge.overviewRulerColor,before:ge.before?N.from(ge.before):void 0,after:ge.after?N.from(ge.after):void 0}}Ce.from=Ae})(ye||(e.DecorationRenderOptions=ye={}));var Ee;(function(Ce){function Ae(G){return{text:G.newText,eol:G.newEol&&Xe.from(G.newEol),range:o.from(G.range)}}Ce.from=Ae;function ge(G){const Te=new s.$iK(o.to(G.range),G.text);return Te.newEol=typeof G.eol>"u"?void 0:Xe.to(G.eol),Te}Ce.to=ge})(Ee||(e.TextEdit=Ee={}));var Pe;(function(Ce){function Ae(G,Te){const Be={edits:[]};if(G instanceof s.$lK){const Je=new l.$Ac;for(const Ve of G._allEntries())Ve._type===1&&p.URI.isUri(Ve.to)&&Ve.from===void 0&&Je.add(Ve.to);for(const Ve of G._allEntries())if(Ve._type===1){let et;Ve.options?.contents&&(ArrayBuffer.isView(Ve.options.contents)?et={type:"base64",value:(0,M.$ue)(M.$ae.wrap(Ve.options.contents))}:et={type:"dataTransferItem",id:Ve.options.contents._itemId}),Be.edits.push({oldResource:Ve.from,newResource:Ve.to,options:{...Ve.options,contents:et},metadata:Ve.metadata})}else Ve._type===2?Be.edits.push({resource:Ve.uri,textEdit:Ee.from(Ve.edit),versionId:Je.has(Ve.uri)?void 0:Te?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===6?Be.edits.push({resource:Ve.uri,textEdit:{range:o.from(Ve.range),text:Ve.edit.value,insertAsSnippet:!0},versionId:Je.has(Ve.uri)?void 0:Te?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===3?Be.edits.push({metadata:Ve.metadata,resource:Ve.uri,cellEdit:Ve.edit,notebookMetadata:Ve.notebookMetadata,notebookVersionId:Te?.getNotebookDocumentVersion(Ve.uri)}):Ve._type===5&&Be.edits.push({metadata:Ve.metadata,resource:Ve.uri,notebookVersionId:Te?.getNotebookDocumentVersion(Ve.uri),cellEdit:{editType:1,index:Ve.index,count:Ve.count,cells:Ve.cells.map(mt.from)}})}return Be}Ce.from=Ae;function ge(G){const Te=new s.$lK,Be=new l.$zc;for(const Je of G.edits)if(Je.textEdit){const Ve=Je,et=p.URI.revive(Ve.resource),gt=o.to(Ve.textEdit.range),ft=Ve.textEdit.text,pt=Ve.textEdit.insertAsSnippet;let ht;pt?ht=s.$kK.replace(gt,new s.$mK(ft)):ht=s.$iK.replace(gt,ft);const Rt=Be.get(et);Rt?Rt.push(ht):Be.set(et,[ht])}else Te.renameFile(p.URI.revive(Je.oldResource),p.URI.revive(Je.newResource),Je.options);for(const[Je,Ve]of Be)Te.set(Je,Ve);return Te}Ce.to=ge})(Pe||(e.WorkspaceEdit=Pe={}));var X;(function(Ce){const Ae=Object.create(null);Ae[s.SymbolKind.File]=0,Ae[s.SymbolKind.Module]=1,Ae[s.SymbolKind.Namespace]=2,Ae[s.SymbolKind.Package]=3,Ae[s.SymbolKind.Class]=4,Ae[s.SymbolKind.Method]=5,Ae[s.SymbolKind.Property]=6,Ae[s.SymbolKind.Field]=7,Ae[s.SymbolKind.Constructor]=8,Ae[s.SymbolKind.Enum]=9,Ae[s.SymbolKind.Interface]=10,Ae[s.SymbolKind.Function]=11,Ae[s.SymbolKind.Variable]=12,Ae[s.SymbolKind.Constant]=13,Ae[s.SymbolKind.String]=14,Ae[s.SymbolKind.Number]=15,Ae[s.SymbolKind.Boolean]=16,Ae[s.SymbolKind.Array]=17,Ae[s.SymbolKind.Object]=18,Ae[s.SymbolKind.Key]=19,Ae[s.SymbolKind.Null]=20,Ae[s.SymbolKind.EnumMember]=21,Ae[s.SymbolKind.Struct]=22,Ae[s.SymbolKind.Event]=23,Ae[s.SymbolKind.Operator]=24,Ae[s.SymbolKind.TypeParameter]=25;function ge(Te){return typeof Ae[Te]=="number"?Ae[Te]:6}Ce.from=ge;function G(Te){for(const Be in Ae)if(Ae[Be]===Te)return Number(Be);return s.SymbolKind.Property}Ce.to=G})(X||(e.SymbolKind=X={}));var ae;(function(Ce){function Ae(G){switch(G){case s.SymbolTag.Deprecated:return 1}}Ce.from=Ae;function ge(G){switch(G){case 1:return s.SymbolTag.Deprecated}}Ce.to=ge})(ae||(e.SymbolTag=ae={}));var Se;(function(Ce){function Ae(G){return{name:G.name,kind:X.from(G.kind),tags:G.tags&&G.tags.map(ae.from),containerName:G.containerName,location:V.from(G.location)}}Ce.from=Ae;function ge(G){const Te=new s.$sK(G.name,X.to(G.kind),G.containerName,V.to(G.location));return Te.tags=G.tags&&G.tags.map(ae.to),Te}Ce.to=ge})(Se||(e.WorkspaceSymbol=Se={}));var ue;(function(Ce){function Ae(G){const Te={name:G.name||"!!MISSING: name!!",detail:G.detail,range:o.from(G.range),selectionRange:o.from(G.selectionRange),kind:X.from(G.kind),tags:G.tags?.map(ae.from)??[]};return G.children&&(Te.children=G.children.map(Ae)),Te}Ce.from=Ae;function ge(G){const Te=new s.$tK(G.name,G.detail,X.to(G.kind),o.to(G.range),o.to(G.selectionRange));return(0,w.$Kb)(G.tags)&&(Te.tags=G.tags.map(ae.to)),G.children&&(Te.children=G.children.map(ge)),Te}Ce.to=ge})(ue||(e.DocumentSymbol=ue={}));var $e;(function(Ce){function Ae(G){const Te=new s.$xK(X.to(G.kind),G.name,G.detail||"",p.URI.revive(G.uri),o.to(G.range),o.to(G.selectionRange));return Te._sessionId=G._sessionId,Te._itemId=G._itemId,Te}Ce.to=Ae;function ge(G,Te,Be){if(Te=Te??G._sessionId,Be=Be??G._itemId,Te===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Te,_itemId:Be,name:G.name,detail:G.detail,kind:X.from(G.kind),uri:G.uri,range:o.from(G.range),selectionRange:o.from(G.selectionRange),tags:G.tags?.map(ae.from)}}Ce.from=ge})($e||(e.CallHierarchyItem=$e={}));var ie;(function(Ce){function Ae(ge){return new s.$yK($e.to(ge.from),ge.fromRanges.map(G=>o.to(G)))}Ce.to=Ae})(ie||(e.CallHierarchyIncomingCall=ie={}));var z;(function(Ce){function Ae(ge){return new s.$zK($e.to(ge.to),ge.fromRanges.map(G=>o.to(G)))}Ce.to=Ae})(z||(e.CallHierarchyOutgoingCall=z={}));var V;(function(Ce){function Ae(G){return{range:G.range&&o.from(G.range),uri:G.uri}}Ce.from=Ae;function ge(G){return new s.$nK(p.URI.revive(G.uri),o.to(G.range))}Ce.to=ge})(V||(e.location=V={}));var le;(function(Ce){function Ae(G){const Te=G,Be=G;return{originSelectionRange:Te.originSelectionRange?o.from(Te.originSelectionRange):void 0,uri:Te.targetUri?Te.targetUri:Be.uri,range:o.from(Te.targetRange?Te.targetRange:Be.range),targetSelectionRange:Te.targetSelectionRange?o.from(Te.targetSelectionRange):void 0}}Ce.from=Ae;function ge(G){return{targetUri:p.URI.revive(G.uri),targetRange:o.to(G.range),targetSelectionRange:G.targetSelectionRange?o.to(G.targetSelectionRange):void 0,originSelectionRange:G.originSelectionRange?o.to(G.originSelectionRange):void 0}}Ce.to=ge})(le||(e.DefinitionLink=le={}));var we;(function(Ce){function Ae(G){return{range:o.from(G.range),contents:U.fromMany(G.contents)}}Ce.from=Ae;function ge(G){return new s.$qK(G.contents.map(U.to),o.to(G.range))}Ce.to=ge})(we||(e.Hover=we={}));var ve;(function(Ce){function Ae(G){return{range:o.from(G.range),expression:G.expression}}Ce.from=Ae;function ge(G){return new s.$jL(o.to(G.range),G.expression)}Ce.to=ge})(ve||(e.EvaluatableExpression=ve={}));var me;(function(Ce){function Ae(G){if(G instanceof s.$kL)return{type:"text",range:o.from(G.range),text:G.text};if(G instanceof s.$lL)return{type:"variable",range:o.from(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};if(G instanceof s.$mL)return{type:"expression",range:o.from(G.range),expression:G.expression};throw new Error("Unknown 'InlineValue' type")}Ce.from=Ae;function ge(G){switch(G.type){case"text":return{range:o.to(G.range),text:G.text};case"variable":return{range:o.to(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};case"expression":return{range:o.to(G.range),expression:G.expression}}}Ce.to=ge})(me||(e.InlineValue=me={}));var De;(function(Ce){function Ae(G){return{frameId:G.frameId,stoppedLocation:o.from(G.stoppedLocation)}}Ce.from=Ae;function ge(G){return new s.$nL(G.frameId,o.to(G.stoppedLocation))}Ce.to=ge})(De||(e.InlineValueContext=De={}));var re;(function(Ce){function Ae(G){return{range:o.from(G.range),kind:G.kind}}Ce.from=Ae;function ge(G){return new s.$rK(o.to(G.range),G.kind)}Ce.to=ge})(re||(e.DocumentHighlight=re={}));var he;(function(Ce){function Ae(ge){switch(ge){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}Ce.to=Ae})(he||(e.CompletionTriggerKind=he={}));var se;(function(Ce){function Ae(ge){return{triggerKind:he.to(ge.triggerKind),triggerCharacter:ge.triggerCharacter}}Ce.to=Ae})(se||(e.CompletionContext=se={}));var oe;(function(Ce){function Ae(G){switch(G){case s.CompletionItemTag.Deprecated:return 1}}Ce.from=Ae;function ge(G){switch(G){case 1:return s.CompletionItemTag.Deprecated}}Ce.to=ge})(oe||(e.CompletionItemTag=oe={}));var de;(function(Ce){const Ae=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function ge(Be){return Ae.get(Be)??9}Ce.from=ge;const G=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function Te(Be){return G.get(Be)??s.CompletionItemKind.Property}Ce.to=Te})(de||(e.CompletionItemKind=de={}));var Ie;(function(Ce){function Ae(ge,G){const Te=new s.$HK(ge.label);return Te.insertText=ge.insertText,Te.kind=de.to(ge.kind),Te.tags=ge.tags?.map(oe.to),Te.detail=ge.detail,Te.documentation=A.$3j(ge.documentation)?U.to(ge.documentation):ge.documentation,Te.sortText=ge.sortText,Te.filterText=ge.filterText,Te.preselect=ge.preselect,Te.commitCharacters=ge.commitCharacters,$.$os.isIRange(ge.range)?Te.range=o.to(ge.range):typeof ge.range=="object"&&(Te.range={inserting:o.to(ge.range.insert),replacing:o.to(ge.range.replace)}),Te.keepWhitespace=typeof ge.insertTextRules>"u"?!1:!!(ge.insertTextRules&1),typeof ge.insertTextRules<"u"&&ge.insertTextRules&4?Te.insertText=new s.$mK(ge.insertText):(Te.insertText=ge.insertText,Te.textEdit=Te.range instanceof s.$dK?new s.$iK(Te.range,Te.insertText):void 0),ge.additionalTextEdits&&ge.additionalTextEdits.length>0&&(Te.additionalTextEdits=ge.additionalTextEdits.map(Be=>Ee.to(Be))),Te.command=G&&ge.command?G.fromInternal(ge.command):void 0,Te}Ce.to=Ae})(Ie||(e.CompletionItem=Ie={}));var T;(function(Ce){function Ae(G){if(typeof G.label!="string"&&!Array.isArray(G.label))throw new TypeError("Invalid label");return{label:G.label,documentation:U.fromStrict(G.documentation)}}Ce.from=Ae;function ge(G){return{label:G.label,documentation:A.$3j(G.documentation)?U.to(G.documentation):G.documentation}}Ce.to=ge})(T||(e.ParameterInformation=T={}));var q;(function(Ce){function Ae(G){return{label:G.label,documentation:U.fromStrict(G.documentation),parameters:Array.isArray(G.parameters)?G.parameters.map(T.from):[],activeParameter:G.activeParameter}}Ce.from=Ae;function ge(G){return{label:G.label,documentation:A.$3j(G.documentation)?U.to(G.documentation):G.documentation,parameters:Array.isArray(G.parameters)?G.parameters.map(T.to):[],activeParameter:G.activeParameter}}Ce.to=ge})(q||(e.SignatureInformation=q={}));var J;(function(Ce){function Ae(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(q.from):[]}}Ce.from=Ae;function ge(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(q.to):[]}}Ce.to=ge})(J||(e.SignatureHelp=J={}));var Q;(function(Ce){function Ae(ge,G){const Te=new s.$GK(d.to(G.position),typeof G.label=="string"?G.label:G.label.map(H.to.bind(void 0,ge)),G.kind&&x.to(G.kind));return Te.textEdits=G.textEdits&&G.textEdits.map(Ee.to),Te.tooltip=A.$3j(G.tooltip)?U.to(G.tooltip):G.tooltip,Te.paddingLeft=G.paddingLeft,Te.paddingRight=G.paddingRight,Te}Ce.to=Ae})(Q||(e.InlayHint=Q={}));var H;(function(Ce){function Ae(ge,G){const Te=new s.$FK(G.label);return Te.tooltip=A.$3j(G.tooltip)?U.to(G.tooltip):G.tooltip,g.Command.is(G.command)&&(Te.command=ge.fromInternal(G.command)),G.location&&(Te.location=V.to(G.location)),Te}Ce.to=Ae})(H||(e.InlayHintLabelPart=H={}));var x;(function(Ce){function Ae(G){return G}Ce.from=Ae;function ge(G){return G}Ce.to=ge})(x||(e.InlayHintKind=x={}));var ce;(function(Ce){function Ae(G){return{range:o.from(G.range),url:G.target,tooltip:G.tooltip}}Ce.from=Ae;function ge(G){let Te;if(G.url)try{Te=typeof G.url=="string"?p.URI.parse(G.url,!0):p.URI.revive(G.url)}catch{}return new s.$MK(o.to(G.range),Te)}Ce.to=ge})(ce||(e.DocumentLink=ce={}));var Fe;(function(Ce){function Ae(G){const Te=new s.$PK(G.label);return G.textEdit&&(Te.textEdit=Ee.to(G.textEdit)),G.additionalTextEdits&&(Te.additionalTextEdits=G.additionalTextEdits.map(Be=>Ee.to(Be))),Te}Ce.to=Ae;function ge(G){return{label:G.label,textEdit:G.textEdit?Ee.from(G.textEdit):void 0,additionalTextEdits:G.additionalTextEdits?G.additionalTextEdits.map(Te=>Ee.from(Te)):void 0}}Ce.from=ge})(Fe||(e.ColorPresentation=Fe={}));var Ue;(function(Ce){function Ae(G){return new s.$NK(G[0],G[1],G[2],G[3])}Ce.to=Ae;function ge(G){return[G.red,G.green,G.blue,G.alpha]}Ce.from=ge})(Ue||(e.Color=Ue={}));var Qe;(function(Ce){function Ae(G){return{range:o.from(G.range)}}Ce.from=Ae;function ge(G){return new s.$wK(o.to(G.range))}Ce.to=ge})(Qe||(e.SelectionRange=Qe={}));var Ge;(function(Ce){function Ae(ge){switch(ge){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}Ce.to=Ae})(Ge||(e.TextDocumentSaveReason=Ge={}));var _e;(function(Ce){function Ae(G){switch(G){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.On:default:return 1}}Ce.from=Ae;function ge(G){switch(G){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 1:default:return s.TextEditorLineNumbersStyle.On}}Ce.to=ge})(_e||(e.TextEditorLineNumbersStyle=_e={}));var Xe;(function(Ce){function Ae(G){if(G===s.EndOfLine.CRLF)return 1;if(G===s.EndOfLine.LF)return 0}Ce.from=Ae;function ge(G){if(G===1)return s.EndOfLine.CRLF;if(G===0)return s.EndOfLine.LF}Ce.to=ge})(Xe||(e.EndOfLine=Xe={}));var xe;(function(Ce){function Ae(ge){if(typeof ge=="object")return ge.viewId;switch(ge){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ce.from=Ae})(xe||(e.ProgressLocation=xe={}));var it;(function(Ce){function Ae(G){const Te={start:G.start+1,end:G.end+1};return G.kind&&(Te.kind=tt.from(G.kind)),Te}Ce.from=Ae;function ge(G){const Te={start:G.start-1,end:G.end-1};return G.kind&&(Te.kind=tt.to(G.kind)),Te}Ce.to=ge})(it||(e.FoldingRange=it={}));var tt;(function(Ce){function Ae(G){if(G)switch(G){case s.FoldingRangeKind.Comment:return g.$dt.Comment;case s.FoldingRangeKind.Imports:return g.$dt.Imports;case s.FoldingRangeKind.Region:return g.$dt.Region}}Ce.from=Ae;function ge(G){if(G)switch(G.value){case g.$dt.Comment.value:return s.FoldingRangeKind.Comment;case g.$dt.Imports.value:return s.FoldingRangeKind.Imports;case g.$dt.Region.value:return s.FoldingRangeKind.Region}}Ce.to=ge})(tt||(e.FoldingRangeKind=tt={}));var ze;(function(Ce){function Ae(ge){if(ge)return{pinned:typeof ge.preview=="boolean"?!ge.preview:void 0,inactive:ge.background,preserveFocus:ge.preserveFocus,selection:typeof ge.selection=="object"?o.from(ge.selection):void 0,override:typeof ge.override=="boolean"?a.$ND.id:void 0}}Ce.from=Ae})(ze||(e.TextEditorOpenOptions=ze={}));var st;(function(Ce){function Ae(Be){return Be instanceof s.$0K?Be.toJSON():typeof Be=="string"?Be:ge(Be)||G(Be)?new s.$0K(Be.baseUri??Be.base,Be.pattern).toJSON():Be}Ce.from=Ae;function ge(Be){const Je=Be;return Je?p.URI.isUri(Je.baseUri)&&typeof Je.pattern=="string":!1}function G(Be){const Je=Be;return Je?typeof Je.base=="string"&&typeof Je.pattern=="string":!1}function Te(Be){return typeof Be=="string"?Be:new s.$0K(p.URI.revive(Be.baseUri),Be.pattern)}Ce.to=Te})(st||(e.GlobPattern=st={}));var _;(function(Ce){function Ae(ge){if(ge){if(Array.isArray(ge))return ge.map(Ae);if(typeof ge=="string")return ge;{const G=ge;return{language:G.language,scheme:G.scheme,pattern:st.from(G.pattern),exclusive:G.exclusive,notebookType:G.notebookType}}}else return}Ce.from=Ae})(_||(e.LanguageSelector=_={}));var Z;(function(Ce){function Ae(G){return!!G&&typeof G=="object"&&"documents"in G&&Array.isArray(G.documents)&&G.documents.every(Te=>Array.isArray(Te)&&Te.every(Be=>Be&&typeof Be=="object"&&"uri"in Be&&p.URI.isUri(Be.uri)&&"version"in Be&&typeof Be.version=="number"&&"ranges"in Be&&Array.isArray(Be.ranges)&&Be.ranges.every(Je=>Je instanceof s.$dK)))}Ce.is=Ae;function ge(G){return{documents:G.documents.map(Te=>Te.map(Be=>({uri:p.URI.from(Be.uri),version:Be.version,ranges:Be.ranges.map(Je=>o.from(Je))})))}}Ce.from=ge})(Z||(e.MappedEditsContext=Z={}));var pe;(function(Ce){function Ae(G){return{start:G.start,end:G.end}}Ce.from=Ae;function ge(G){return new s.$yL(G.start,G.end)}Ce.to=ge})(pe||(e.NotebookRange=pe={}));var je;(function(Ce){function Ae(G){return{timing:typeof G.runStartTime=="number"&&typeof G.runEndTime=="number"?{startTime:G.runStartTime,endTime:G.runEndTime}:void 0,executionOrder:G.executionOrder,success:G.lastRunSuccess}}Ce.to=Ae;function ge(G){return{lastRunSuccess:G.success,runStartTime:G.timing?.startTime,runEndTime:G.timing?.endTime,executionOrder:G.executionOrder}}Ce.from=ge})(je||(e.NotebookCellExecutionSummary=je={}));var Oe;(function(Ce){function Ae(ge){if(ge===b.NotebookCellExecutionState.Unconfirmed)return s.NotebookCellExecutionState.Pending;if(ge===b.NotebookCellExecutionState.Pending)return;if(ge===b.NotebookCellExecutionState.Executing)return s.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ge}`)}Ce.to=Ae})(Oe||(e.NotebookCellExecutionState=Oe={}));var Ze;(function(Ce){function Ae(G){switch(G){case s.NotebookCellKind.Markup:return b.CellKind.Markup;case s.NotebookCellKind.Code:default:return b.CellKind.Code}}Ce.from=Ae;function ge(G){switch(G){case b.CellKind.Markup:return s.NotebookCellKind.Markup;case b.CellKind.Code:default:return s.NotebookCellKind.Code}}Ce.to=ge})(Ze||(e.NotebookCellKind=Ze={}));var rt;(function(Ce){function Ae(G){const Te={metadata:G.metadata??Object.create(null),cells:[]};for(const Be of G.cells)s.$zL.validate(Be),Te.cells.push(mt.from(Be));return Te}Ce.from=Ae;function ge(G){const Te=new s.$AL(G.cells.map(mt.to));return(0,c.$Kf)(G.metadata)||(Te.metadata=G.metadata),Te}Ce.to=ge})(rt||(e.NotebookData=rt={}));var mt;(function(Ce){function Ae(G){return{cellKind:Ze.from(G.kind),language:G.languageId,mime:G.mime,source:G.value,metadata:G.metadata,internalMetadata:je.from(G.executionSummary??{}),outputs:G.outputs?G.outputs.map(Ct.from):[]}}Ce.from=Ae;function ge(G){return new s.$zL(Ze.to(G.cellKind),G.source,G.language,G.mime,G.outputs?G.outputs.map(Ct.to):void 0,G.metadata,G.internalMetadata?je.to(G.internalMetadata):void 0)}Ce.to=ge})(mt||(e.NotebookCellData=mt={}));var wt;(function(Ce){function Ae(G){return{mime:G.mime,valueBytes:M.$ae.wrap(G.data)}}Ce.from=Ae;function ge(G){return new s.$BL(G.valueBytes.buffer,G.mime)}Ce.to=ge})(wt||(e.NotebookCellOutputItem=wt={}));var Ct;(function(Ce){function Ae(G){return{outputId:G.id,items:G.items.map(wt.from),metadata:G.metadata}}Ce.from=Ae;function ge(G){const Te=G.items.map(wt.to);return new s.$CL(Te,G.outputId,G.metadata)}Ce.to=ge})(Ct||(e.NotebookCellOutput=Ct={}));var Yt;(function(Ce){function Ae(Te){return G(Te)?{include:st.from(Te.include)??void 0,exclude:st.from(Te.exclude)??void 0}:st.from(Te)??void 0}Ce.from=Ae;function ge(Te){return G(Te)?{include:st.to(Te.include),exclude:st.to(Te.exclude)}:st.to(Te)}Ce.to=ge;function G(Te){const Be=Te;return Be?!(0,c.$Gf)(Be.include)&&!(0,c.$Gf)(Be.exclude):!1}})(Yt||(e.NotebookExclusiveDocumentPattern=Yt={}));var qt;(function(Ce){function Ae(ge,G,Te){const Be=typeof ge.command=="string"?{title:"",command:ge.command}:ge.command;return{alignment:ge.alignment===s.NotebookCellStatusBarAlignment.Left?1:2,command:G.toInternal(Be,Te),text:ge.text,tooltip:ge.tooltip,accessibilityInformation:ge.accessibilityInformation,priority:ge.priority}}Ce.from=Ae})(qt||(e.NotebookStatusBarItem=qt={}));var vt;(function(Ce){function Ae(ge,G,Te){const Be=typeof ge.command=="string"?{title:"",command:ge.command}:ge.command;return{command:G.toInternal(Be,Te),label:ge.label,description:ge.description,detail:ge.detail,documentation:ge.documentation}}Ce.from=Ae})(vt||(e.NotebookKernelSourceAction=vt={}));var jt;(function(Ce){function Ae(ge){return{transientOutputs:ge?.transientOutputs??!1,transientCellMetadata:ge?.transientCellMetadata??{},transientDocumentMetadata:ge?.transientDocumentMetadata??{},cellContentMetadata:ge?.cellContentMetadata??{}}}Ce.from=Ae})(jt||(e.NotebookDocumentContentOptions=jt={}));var Ft;(function(Ce){function Ae(G){return{uri:G.uri,provides:G.provides}}Ce.from=Ae;function ge(G){return new s.$EL(p.URI.revive(G.uri),G.provides)}Ce.to=ge})(Ft||(e.NotebookRendererScript=Ft={}));var Bt;(function(Ce){function Ae(G){return{message:U.fromStrict(G.message)||"",type:0,expected:G.expectedOutput,actual:G.actualOutput,contextValue:G.contextValue,location:G.location&&{range:o.from(G.location.range),uri:G.location.uri}}}Ce.from=Ae;function ge(G){const Te=new s.$KL(typeof G.message=="string"?G.message:U.to(G.message));return Te.actualOutput=G.actual,Te.expectedOutput=G.expected,Te.contextValue=G.contextValue,Te.location=G.location?V.to(G.location):void 0,Te}Ce.to=ge})(Bt||(e.TestMessage=Bt={}));var Pt;(function(Ce){Ce.namespace=v.$9I,Ce.denamespace=v.$0I})(Pt||(e.TestTag=Pt={}));var At;(function(Ce){function Ae(G){const Te=(0,n.$9L)(G).controllerId;return{extId:E.$5I.fromExtHostTestItem(G,Te).toString(),label:G.label,uri:p.URI.revive(G.uri),busy:G.busy,tags:G.tags.map(Be=>Pt.namespace(Te,Be.id)),range:$.$os.lift(o.from(G.range)),description:G.description||null,sortText:G.sortText||null,error:G.error&&U.fromStrict(G.error)||null}}Ce.from=Ae;function ge(G){return{parent:void 0,error:void 0,id:E.$5I.fromString(G.extId).localId,label:G.label,uri:p.URI.revive(G.uri),tags:(G.tags||[]).map(Te=>{const{tagId:Be}=Pt.denamespace(Te);return new s.$LL(Be)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:o.to(G.range||void 0),canResolveChildren:!1,busy:G.busy,description:G.description||void 0,sortText:G.sortText||void 0}}Ce.toPlain=ge})(At||(e.TestItem=At={})),function(Ce){function Ae(G){return{id:G.id}}Ce.from=Ae;function ge(G){return new s.$LL(G.id)}Ce.to=ge}(Pt||(e.TestTag=Pt={}));var Nt;(function(Ce){const Ae=(G,Te)=>{const Be=[];for(const[Ve,et]of Te)E.$5I.compare(et.item.extId,Ve)===2&&(Te.delete(Ve),Be.push(et));const Je={...At.toPlain(G.item),parent:void 0,taskStates:G.tasks.map(Ve=>({state:Ve.state,duration:Ve.duration,messages:Ve.messages.filter(et=>et.type===0).map(Bt.to)})),children:Be.map(Ve=>Ae(Ve,Te))};for(const Ve of Je.children)Ve.parent=Je;return Je};function ge(G){const Te=[],Be=new Map;for(const Je of G.items){Be.set(Je.item.extId,Je);const Ve=E.$5I.root(Je.item.extId);G.request.targets.some(et=>et.controllerId===Ve&&et.testIds.includes(Je.item.extId))&&Te.push(Je)}return{completedAt:G.completedAt,results:Te.map(Je=>Ae(Je,Be))}}Ce.to=ge})(Nt||(e.TestResults=Nt={}));var Wt;(function(Ce){function Ae(Be){return{covered:Be.covered,total:Be.covered}}function ge(Be){return"line"in Be?d.from(Be):o.from(Be)}function G(Be){return"branches"in Be?{count:Be.executionCount,location:ge(Be.location),type:1,branches:Be.branches.length?Be.branches.map(Je=>({count:Je.executionCount,location:Je.location&&ge(Je.location)})):void 0}:{type:0,count:Be.executionCount,location:ge(Be.location)}}Ce.fromDetailed=G;function Te(Be){return{uri:Be.uri,statement:Ae(Be.statementCoverage),branch:Be.branchCoverage&&Ae(Be.branchCoverage),function:Be.functionCoverage&&Ae(Be.functionCoverage),details:Be.detailedCoverage?.map(G)}}Ce.fromFile=Te})(Wt||(e.TestCoverage=Wt={}));var Ht;(function(Ce){function Ae(ge){switch(ge){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}Ce.to=Ae})(Ht||(e.CodeActionTriggerKind=Ht={}));var Kt;(function(Ce){function Ae(G){const Te=new s.$RL(X.to(G.kind),G.name,G.detail||"",p.URI.revive(G.uri),o.to(G.range),o.to(G.selectionRange));return Te._sessionId=G._sessionId,Te._itemId=G._itemId,Te}Ce.to=Ae;function ge(G,Te,Be){if(Te=Te??G._sessionId,Be=Be??G._itemId,Te===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Te,_itemId:Be,kind:X.from(G.kind),name:G.name,detail:G.detail??"",uri:G.uri,range:o.from(G.range),selectionRange:o.from(G.selectionRange),tags:G.tags?.map(ae.from)}}Ce.from=ge})(Kt||(e.TypeHierarchyItem=Kt={}));var at;(function(Ce){function Ae(ge){if(ge)return{value:ge.value,tooltip:ge.tooltip}}Ce.from=Ae})(at||(e.ViewBadge=at={}));var ut;(function(Ce){function Ae(Be,Je,Ve){const et=Je.fileData;return et?new s.$3K(new s.$4K(et.name,p.URI.revive(et.uri),et.id,(0,F.$cb)(()=>Ve(et.id)))):Be===R.$Lr.uriList&&Je.uriListData?new s.$2K(Te(Je.uriListData)):new s.$2K(Je.asString)}Ce.to=Ae;async function ge(Be,Je){const Ve=await Je.asString();if(Be===R.$Lr.uriList)return{asString:Ve,fileData:void 0,uriListData:G(Ve)};const et=Je.asFile();return{asString:Ve,fileData:et?{name:et.name,uri:et.uri,id:et._itemId??et.id}:void 0}}Ce.from=ge;function G(Be){return C.$Xs.split(Be).map(Je=>{if(Je.startsWith("#"))return Je;try{return p.URI.parse(Je)}catch{}return Je})}function Te(Be){return C.$Xs.create(Be.map(Je=>typeof Je=="string"?Je:p.URI.revive(Je)))}})(ut||(e.DataTransferItem=ut={}));var Jt;(function(Ce){function Ae(G,Te){const Be=G.items.map(([Je,Ve])=>[Je,ut.to(Je,Ve,Te)]);return new s.$5K(Be)}Ce.toDataTransfer=Ae;async function ge(G){const Te={items:[]},Be=[];for(const[Je,Ve]of G)Be.push((async()=>{Te.items.push([Je,await ut.from(Je,Ve)])})());return await Promise.all(Be),Te}Ce.from=ge})(Jt||(e.DataTransfer=Jt={}));var It;(function(Ce){function Ae(G){return{message:G.message,metadata:G.metadata,title:G.title,tooltip:G.tooltip}}Ce.to=Ae;function ge(G){return{kind:"reply",message:G.message,metadata:G.metadata,title:G.title,tooltip:G.tooltip}}Ce.from=ge})(It||(e.ChatReplyFollowup=It={}));var Et;(function(Ce){function Ae(ge){return typeof ge=="string"?{title:ge,message:ge,kind:"reply"}:"commandId"in ge?{kind:"command",title:ge.title??"",commandId:ge.commandId??"",when:ge.when??"",args:ge.args}:It.from(ge)}Ce.from=Ae})(Et||(e.ChatFollowup=Et={}));var dt;(function(Ce){function Ae(G){const Te=new s.$2L(kt.to(G.role),G.content);return Te.name=G.name,Te}Ce.to=Ae;function ge(G){return{role:kt.from(G.role),content:G.content,name:G.name}}Ce.from=ge})(dt||(e.ChatMessage=dt={}));var kt;(function(Ce){function Ae(G){switch(G){case 0:return s.ChatMessageRole.System;case 1:return s.ChatMessageRole.User;case 2:return s.ChatMessageRole.Assistant;case 3:return s.ChatMessageRole.Function}}Ce.to=Ae;function ge(G){switch(G){case s.ChatMessageRole.System:return 0;case s.ChatMessageRole.Assistant:return 2;case s.ChatMessageRole.Function:return 3;case s.ChatMessageRole.User:default:return 1}}Ce.from=ge})(kt||(e.ChatMessageRole=kt={}));var Lt;(function(Ce){function Ae(G){return{level:yt.to(G.level),value:G.value,description:G.description}}Ce.to=Ae;function ge(G){return{level:yt.from(G.level),value:G.value,description:G.description}}Ce.from=ge})(Lt||(e.ChatVariable=Lt={}));var yt;(function(Ce){function Ae(G){switch(G){case"short":return s.ChatVariableLevel.Short;case"medium":return s.ChatVariableLevel.Medium;case"full":default:return s.ChatVariableLevel.Full}}Ce.to=Ae;function ge(G){switch(G){case s.ChatVariableLevel.Short:return"short";case s.ChatVariableLevel.Medium:return"medium";case s.ChatVariableLevel.Full:default:return"full"}}Ce.from=ge})(yt||(e.ChatVariableLevel=yt={}));var Ke;(function(Ce){function Ae(ge){switch(ge){case 1:return s.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return s.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return s.InteractiveEditorResponseFeedbackKind.Undone;case 3:return s.InteractiveEditorResponseFeedbackKind.Accepted}}Ce.to=Ae})(Ke||(e.InteractiveEditorResponseFeedbackKind=Ke={}));var Ot;(function(Ce){function Ae(ge){return"placeholder"in ge&&"resolvedContent"in ge?{placeholder:ge.placeholder}:"responseId"in ge?{requestId:ge.responseId}:"content"in ge?{content:typeof ge.content=="string"?ge.content:U.from(ge.content)}:"documents"in ge?{documents:ge.documents.map(G=>({uri:G.uri,version:G.version,ranges:G.ranges.map(Te=>o.from(Te))}))}:"reference"in ge?{reference:"uri"in ge.reference?{uri:ge.reference.uri,range:o.from(ge.reference.range)}:ge.reference}:ge}Ce.from=Ae})(Ot||(e.ChatResponseProgress=Ot={}));var zt;(function(Ce){function Ae(ge,G,Te){return"terminalCommand"in ge?{terminalCommand:ge.terminalCommand}:"uri"in ge?{uri:ge.uri}:G.toInternal(ge,Te)}Ce.from=Ae})(zt||(e.TerminalQuickFix=zt={}))}),define(Re[203],Me([1,0,2,9,7,8,173]),function(be,e,w,M,C,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6bc=void 0;class l{constructor(f,R,D,c={timeout:1500,errors:3}){this.c=f,this.d=R,this.f=D,this.g=c,this.a=new A.$1c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(f){return(R,D,c)=>{const $={dispose:this.a.push([R,D,f])};return Array.isArray(c)&&c.push($),$}}async $participateInSave(f,R){const D=w.URI.revive(f);let c=!1;const p=setTimeout(()=>c=!0,this.g.timeout),$=[];try{for(const g of[...this.a]){if(c)break;const t=this.d.getDocument(D),n=await this.h(g,{document:t,reason:F.TextDocumentSaveReason.to(R)});$.push(n)}}finally{clearTimeout(p)}return $}h([f,R,D],c){const p=this.b.get(f);return typeof p=="number"&&p>this.g.errors?Promise.resolve(!1):this.i(D,f,R,c).then(()=>!0,$=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' threw ERROR`),this.c.error($),!($ instanceof Error)||$.message!=="concurrent_edits"){const g=this.b.get(f);this.b.set(f,g?g+1:1),typeof g=="number"&&g>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(f,R,D,c){const p=[],$=Date.now(),{document:g,reason:t}=c,{version:n}=g,a=Object.freeze({document:g,reason:t,waitUntil(b){if(Object.isFrozen(p))throw(0,M.$7)("waitUntil can not be called async");p.push(Promise.resolve(b))}});try{R.apply(D,[a])}catch(b){return Promise.reject(b)}return Object.freeze(p),new Promise((b,E)=>{const v=setTimeout(()=>E(new Error("timeout")),this.g.timeout);return Promise.all(p).then(r=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${f.identifier.value}' finished after ${Date.now()-$}ms`),clearTimeout(v),b(r)}).catch(r=>{clearTimeout(v),E(r)})}).then(b=>{const E={edits:[]};for(const v of b)if(Array.isArray(v)&&v.every(r=>r instanceof C.$iK))for(const{newText:r,newEol:s,range:i}of v)E.edits.push({resource:g.uri,versionId:void 0,textEdit:{range:i&&F.Range.from(i),text:r,eol:s&&F.EndOfLine.from(s)}});if(E.edits.length!==0)return n===g.version?this.f.$tryApplyWorkspaceEdit(E):Promise.reject(new Error("concurrent_edits"))})}}e.$6bc=l}),define(Re[204],Me([1,0,13,2,8,7,75]),function(be,e,w,M,C,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hdc=e.$gdc=void 0;class l{constructor(D,c,p,$){this.start=D,this.deletedCount=c,this.deletedItems=p,this.items=$}asApiEvent(){return{range:new F.$yL(this.start,this.start+this.deletedCount),addedCells:this.items.map(D=>D.apiCell),removedCells:this.deletedItems}}}class k{static asModelAddData(D,c){return{EOL:c.eol,lines:c.source,languageId:c.language,uri:c.uri,isDirty:!1,versionId:1,notebook:D}}constructor(D,c,p){this.notebook=D,this.h=c,this.j=p,this.handle=p.handle,this.uri=M.URI.revive(p.uri),this.cellKind=p.cellKind,this.a=p.outputs.map(C.NotebookCellOutput.to),this.e=p.internalMetadata??{},this.b=Object.freeze(p.metadata??{}),this.d=Object.freeze(C.NotebookCellExecutionSummary.to(p.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const D=this,c=this.h.getDocument(this.uri);if(!c)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const p={get index(){return D.notebook.getCellIndex(D)},notebook:D.notebook.apiNotebook,kind:C.NotebookCellKind.to(this.j.cellKind),document:c.document,get mime(){return D.g},set mime($){D.g=$},get outputs(){return D.a.slice(0)},get metadata(){return D.b},get executionSummary(){return D.d}};this.f=Object.freeze(p)}return this.f}setOutputs(D){this.a=D.map(C.NotebookCellOutput.to)}setOutputItems(D,c,p){const $=p.map(C.NotebookCellOutputItem.to),g=this.a.find(t=>t.id===D);if(g&&(c||(g.items.length=0),g.items.push(...$),g.items.length>1&&g.items.every(t=>A.$lI(t.mime)))){const t=new Map,n=[];g.items.forEach(a=>{let b;t.has(a.mime)?b=t.get(a.mime):(b=[],t.set(a.mime,b),n.push(a.mime)),b.push(a.data)}),g.items.length=0,n.forEach(a=>{const b=A.$mI(t.get(a));g.items.push({mime:a,data:b.data.buffer})})}}setMetadata(D){this.b=Object.freeze(D)}setInternalMetadata(D){this.e=D,this.d=Object.freeze(C.NotebookCellExecutionSummary.to(D))}setMime(D){}}e.$gdc=k;class f{static{this.a=0}constructor(D,c,p,$,g){this.k=D,this.l=c,this.m=p,this.uri=$,this.handle=f.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=g.viewType,this.f=Object.freeze(g.metadata??Object.create(null)),this.r([[0,0,g.cells]],!0,void 0),this.g=g.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const D=this,c={get uri(){return D.uri},get version(){return D.g},get notebookType(){return D.d},get isDirty(){return D.h},get isUntitled(){return D.uri.scheme===w.Schemas.untitled},get isClosed(){return D.j},get metadata(){return D.f},get cellCount(){return D.b.length},cellAt(p){return p=D.n(p),D.b[p].apiCell},getCells(p){return(p?D.p(p):D.b).map(g=>g.apiCell)},save(){return D.q()}};this.e=Object.freeze(c)}return this.e}acceptDocumentPropertiesChanged(D){D.metadata&&(this.f=Object.freeze({...this.f,...D.metadata}))}acceptDirty(D){this.h=D}acceptModelChanged(D,c,p){this.g=D.versionId,this.h=c,this.acceptDocumentPropertiesChanged({metadata:p});const $={notebook:this.apiNotebook,metadata:p,cellChanges:[],contentChanges:[]},g=[];for(const n of D.rawEvents)n.kind===A.NotebookCellsChangeType.ModelChange?this.r(n.changes,!1,$.contentChanges):n.kind===A.NotebookCellsChangeType.Move?this.s(n.index,n.length,n.newIdx,$.contentChanges):n.kind===A.NotebookCellsChangeType.Output?(this.t(n.index,n.outputs),g.push({cell:this.b[n.index].apiCell,outputs:this.b[n.index].apiCell.outputs})):n.kind===A.NotebookCellsChangeType.OutputItem?(this.u(n.index,n.outputId,n.append,n.outputItems),g.push({cell:this.b[n.index].apiCell,outputs:this.b[n.index].apiCell.outputs})):n.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this.v(n.index,n.language),g.push({cell:this.b[n.index].apiCell,document:this.b[n.index].apiCell.document})):n.kind===A.NotebookCellsChangeType.ChangeCellContent?g.push({cell:this.b[n.index].apiCell,document:this.b[n.index].apiCell.document}):n.kind===A.NotebookCellsChangeType.ChangeCellMime?this.w(n.index,n.mime):n.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this.x(n.index,n.metadata),g.push({cell:this.b[n.index].apiCell,metadata:this.b[n.index].apiCell.metadata})):n.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(n.index,n.internalMetadata),g.push({cell:this.b[n.index].apiCell,executionSummary:this.b[n.index].apiCell.executionSummary}));const t=new Map;for(let n=0;n<g.length;n++){const a=g[n],b=t.get(a.cell);if(b===void 0){const E=$.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...a});t.set(a.cell,E-1)}else $.cellChanges[b]={...$.cellChanges[b],...a}}return Object.freeze($),Object.freeze($.cellChanges),Object.freeze($.contentChanges),$}n(D){return D=D|0,D<0?0:D>=this.b.length?this.b.length-1:D}o(D){let c=D.start|0,p=D.end|0;return c<0&&(c=0),p>this.b.length&&(p=this.b.length),D.with({start:c,end:p})}p(D){D=this.o(D);const c=[];for(let p=D.start;p<D.end;p++)c.push(this.b[p]);return c}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(D,c,p){if(this.j)return;const $=[],g=[],t=[];if(D.reverse().forEach(n=>{const b=n[2].map(r=>{const s=new k(this,this.l,r);return c||g.push(k.asModelAddData(this.apiNotebook,r)),s}),E=new l(n[0],n[1],[],b),v=this.b.splice(n[0],n[1],...b);for(const r of v)t.push(r.uri),E.deletedItems.push(r.apiCell);$.push(E)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:g,removedDocuments:t}),p)for(const n of $)p.push(n.asApiEvent())}s(D,c,p,$){const g=this.b.splice(D,c);this.b.splice(p,0,...g);const t=[new l(D,c,g.map(n=>n.apiCell),[]),new l(p,0,[],g)];for(const n of t)$.push(n.asApiEvent())}t(D,c){this.b[D].setOutputs(c)}u(D,c,p,$){this.b[D].setOutputItems(c,p,$)}v(D,c){const p=this.b[D];p.apiCell.document.languageId!==c&&this.m.$acceptModelLanguageChanged(p.uri,c)}w(D,c){const p=this.b[D];p.apiCell.mime=c}x(D,c){this.b[D].setMetadata(c)}y(D,c){this.b[D].setInternalMetadata(c)}getCellFromApiCell(D){return this.b.find(c=>c.apiCell===D)}getCellFromIndex(D){return this.b[D]}getCell(D){return this.b.find(c=>c.handle===D)}getCellIndex(D){return this.b.indexOf(D)}}e.$hdc=f}),define(Re[205],Me([1,0,5,2,8,7]),function(be,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hdc=void 0;class A{constructor(k,f,R,D={timeout:1500,errors:3}){this.b=k,this.c=f,this.d=R,this.f=D,this.a=new w.$Od}dispose(){}getOnWillSaveNotebookDocumentEvent(k){return(f,R,D)=>{const c=function($){f.call(R,$)};return c.extension=k,this.a.event(c,void 0,D)}}async $participateInSave(k,f,R){const D=M.URI.revive(k),c=this.c.getNotebookDocument(D);if(!c)throw new Error("Unable to resolve notebook document");const p=[];if(await this.a.fireAsync({notebook:c.apiNotebook,reason:C.TextDocumentSaveReason.to(f)},R,async(g,t)=>{const n=Date.now(),a=await await Promise.resolve(g);Date.now()-n>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier),!R.isCancellationRequested&&a&&(a instanceof F.$lK?p.push(a):this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier,"ignored due to invalid data"))}),R.isCancellationRequested)return!1;if(p.length===0)return!0;const $={edits:[]};for(const g of p){const{edits:t}=C.WorkspaceEdit.from(g);$.edits=$.edits.concat(t)}return this.d.$tryApplyWorkspaceEdit($)}}e.$Hdc=A}),define(Re[103],Me([1,0,9,8,7]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$idc=void 0;class F{static{this.apiEditorsToExtHost=new WeakMap}constructor(l,k,f,R,D,c){this.id=l,this.f=k,this.notebookData=f,this.a=[],this.b=[],this.d=!1,this.a=D,this.b=R,this.c=c}get apiEditor(){if(!this.e){const l=this;this.e={get notebook(){return l.notebookData.apiNotebook},get selection(){return l.a[0]},set selection(k){this.selections=[k]},get selections(){return l.a},set selections(k){if(!Array.isArray(k)||!k.every(C.$yL.isNotebookRange))throw(0,w.$6)("selections");l.a=k,l.g(k)},get visibleRanges(){return l.b},revealRange(k,f){l.f.$tryRevealRange(l.id,M.NotebookRange.from(k),f??C.NotebookEditorRevealType.Default)},get viewColumn(){return l.c}},F.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(l){this.d=l}_acceptVisibleRanges(l){this.b=l}_acceptSelections(l){this.a=l}g(l){this.f.$trySetSelections(this.id,l.map(M.NotebookRange.from))}_acceptViewColumn(l){this.c=l}}e.$idc=F}),define(Re[206],Me([1,0,9,5,14,8]),function(be,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Adc=void 0;let A=class{constructor(k,f){this.c=k,this.d=f,this.a=new M.$Md({onListenerError:w.$1}),this.b=new M.$Md({onListenerError:w.$1}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(k,f){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",k,f);const R=this.d.getEditorById(k);f.visibleRanges&&R._acceptVisibleRanges(f.visibleRanges.ranges.map(F.NotebookRange.to)),f.selections&&R._acceptSelections(f.selections.selections.map(F.NotebookRange.to)),f.visibleRanges&&this.b.fire({notebookEditor:R.apiEditor,visibleRanges:R.apiEditor.visibleRanges}),f.selections&&this.a.fire(Object.freeze({notebookEditor:R.apiEditor,selections:R.apiEditor.selections}))}$acceptEditorViewColumns(k){for(const f in k)this.d.getEditorById(f)._acceptViewColumn(F.ViewColumn.to(k[f]))}};e.$Adc=A,e.$Adc=A=qe([We(0,C.$8i)],A)}),define(Re[207],Me([1,0,8,71,152,21,64,9]),function(be,e,w,M,C,F,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ecc=void 0;class k{constructor(c){this.b=0,this.c=new Map,this.a=c}async withProgress(c,p,$){const g=this.b++,{title:t,location:n,cancellable:a}=p,b={label:(0,C.localize)(0,null,c.displayName||c.name),id:c.identifier.value};return this.a.$startProgress(g,{location:w.ProgressLocation.from(n),title:t,source:b,cancellable:a},c.isUnderDevelopment?void 0:c.identifier.value).catch(l.$1),this.d(g,$,!!a)}d(c,p,$){let g;$&&(g=new F.$Wd,this.c.set(c,g));const t=a=>{this.a.$progressEnd(a),this.c.delete(a),g?.dispose()};let n;try{n=p(new R(this.a,c),$&&g?g.token:F.CancellationToken.None)}catch(a){throw t(c),a}return n.then(a=>t(c),a=>t(c)),n}$acceptProgressCanceled(c){const p=this.c.get(c);p&&(p.cancel(),this.c.delete(c))}}e.$Ecc=k;function f(D,c){return D.message=c.message,typeof c.increment=="number"&&(typeof D.increment=="number"?D.increment+=c.increment:D.increment=c.increment),D}class R extends M.$Zu{constructor(c,p){super($=>this.throttledReport($)),this.i=c,this.j=p}throttledReport(c){this.i.$progressReport(this.j,c)}}qe([(0,A.$hh)(100,(D,c)=>f(D,c),()=>Object.create(null))],R.prototype,"throttledReport",null)}),define(Re[104],Me([1,0,44,101,45,76,56,8,2]),function(be,e,w,M,C,F,A,l,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pM=e.$oM=e.$nM=e.$mM=void 0;const f=(b,E,v,r)=>{let s=E;return{enumerable:!0,configurable:!1,get(){return s},set(i){if(!v(s,i)){const o=s;s=i,b.listener?.(r(i,o))}}}},R=(b,E)=>b===E,D={range:(b,E)=>b===E?!0:!b||!E?!1:b.isEqual(E),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(b,E)=>!(b.length!==E.length||b.some(v=>!E.find(r=>v.id===r.id)))},c=b=>E=>({op:4,update:b(E)}),p=(b,E)=>({range:(()=>{let v;const r=c(s=>({range:w.$os.lift(l.Range.from(s))}));return{enumerable:!0,configurable:!1,get(){return v},set(s){b.listener?.({op:6}),D.range(v,s)||(v=s,b.listener?.(r(s)))}}})(),label:f(b,E,D.label,c(v=>({label:v}))),description:f(b,void 0,D.description,c(v=>({description:v}))),sortText:f(b,void 0,D.sortText,c(v=>({sortText:v}))),canResolveChildren:f(b,!1,D.canResolveChildren,v=>({op:2,state:v})),busy:f(b,!1,D.busy,c(v=>({busy:v}))),error:f(b,void 0,D.error,c(v=>({error:l.MarkdownString.fromStrict(v)||null}))),tags:f(b,[],D.tags,(v,r)=>({op:1,new:v.map(l.TestTag.from),old:r.map(l.TestTag.from)}))}),$=b=>{const E=C.$5I.fromString(b.extId),v=new t(E.controllerId,E.localId,b.label,k.URI.revive(b.uri)||void 0);return v.range=l.Range.to(b.range||void 0),v.description=b.description||void 0,v.sortText=b.sortText||void 0,v.tags=b.tags.map(r=>l.TestTag.to({id:(0,A.$0I)(r).tagId})),v},g=b=>{let E;for(const v of b.tests){const r=$(v.item);(0,M.$9L)(r).parent=E,E=r}return E};e.$mM=g;class t{constructor(E,v,r,s){if(v.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(v)} symbol`);const i=(0,M.$8L)(this,E);Object.defineProperties(this,{id:{value:v,enumerable:!0,writable:!1},uri:{value:s,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return i.parent instanceof n?void 0:i.parent}},children:{value:(0,F.$7L)(i,M.$9L,t),enumerable:!0,writable:!1},...p(i,r)})}}e.$nM=t;class n extends t{constructor(E,v){super(E,E,v,void 0),this._isRoot=!0}}e.$oM=n;class a extends F.$3L{constructor(E,v,r){super({controllerId:E,getDocumentVersion:s=>s&&r.getDocument(s)?.version,getApiFor:M.$9L,getChildren:s=>s.children,root:new n(E,v),toITestItem:l.TestItem.from})}}e.$pM=a}),define(Re[105],Me([1,0,51,9,88,8,7]),function(be,e,w,M,C,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jM=e.$iM=e.$hM=void 0;class l{static{this.c=new C.$fM("TextEditorDecorationType")}constructor(c,p,$){const g=l.c.nextId();c.$registerTextEditorDecorationType(p.identifier,g,F.DecorationRenderOptions.from($)),this.value=Object.freeze({key:g,dispose(){c.$removeTextEditorDecorationType(g)}})}}e.$hM=l;class k{constructor(c,p){this.g=[],this.h=void 0,this.j=!1,this.c=c,this.d=c.version,this.e=p.undoStopBefore,this.f=p.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(c,p){this.k();let $=null;if(c instanceof A.$cK)$=new A.$dK(c,c);else if(c instanceof A.$dK)$=c;else throw new Error("Unrecognized location");this.l($,p,!1)}insert(c,p){this.k(),this.l(new A.$dK(c,c),p,!0)}delete(c){this.k();let p=null;if(c instanceof A.$dK)p=c;else throw new Error("Unrecognized location");this.l(p,null,!0)}l(c,p,$){const g=this.c.validateRange(c);this.g.push({range:g,text:p,forceMoveMarkers:$})}setEndOfLine(c){if(this.k(),c!==A.EndOfLine.LF&&c!==A.EndOfLine.CRLF)throw(0,M.$6)("endOfLine");this.h=c}}class f{constructor(c,p,$,g){this.c=c,this.d=p,this._accept($),this.e=g;const t=this;this.value={get tabSize(){return t.f},set tabSize(n){t.m(n)},get indentSize(){return t.g},set indentSize(n){t.o(n)},get insertSpaces(){return t.h},set insertSpaces(n){t.q(n)},get cursorStyle(){return t.j},set cursorStyle(n){t.s(n)},get lineNumbers(){return t.k},set lineNumbers(n){t.t(n)}}}_accept(c){this.f=c.tabSize,this.g=c.indentSize,this.h=c.insertSpaces,this.j=c.cursorStyle,this.k=F.TextEditorLineNumbersStyle.to(c.lineNumbers)}l(c){if(c==="auto")return"auto";if(typeof c=="number"){const p=Math.floor(c);return p>0?p:null}if(typeof c=="string"){const p=parseInt(c,10);return isNaN(p)?null:p>0?p:null}return null}m(c){const p=this.l(c);if(p!==null){if(typeof p=="number"){if(this.f===p)return;this.f=p}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:p}))}}n(c){if(c==="tabSize")return"tabSize";if(typeof c=="number"){const p=Math.floor(c);return p>0?p:null}if(typeof c=="string"){const p=parseInt(c,10);return isNaN(p)?null:p>0?p:null}return null}o(c){const p=this.n(c);if(p!==null){if(typeof p=="number"){if(this.g===p)return;this.g=p}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:p}))}}p(c){return c==="auto"?"auto":c==="false"?!1:!!c}q(c){const p=this.p(c);if(typeof p=="boolean"){if(this.h===p)return;this.h=p}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:p}))}s(c){this.j!==c&&(this.j=c,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:c})))}t(c){this.k!==c&&(this.k=c,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:F.TextEditorLineNumbersStyle.from(c)})))}assign(c){const p={};let $=!1;if(typeof c.tabSize<"u"){const g=this.l(c.tabSize);g==="auto"?($=!0,p.tabSize=g):typeof g=="number"&&this.f!==g&&(this.f=g,$=!0,p.tabSize=g)}if(typeof c.indentSize<"u"){const g=this.n(c.indentSize);g==="tabSize"?($=!0,p.indentSize=g):typeof g=="number"&&this.g!==g&&(this.g=g,$=!0,p.indentSize=g)}if(typeof c.insertSpaces<"u"){const g=this.p(c.insertSpaces);g==="auto"?($=!0,p.insertSpaces=g):this.h!==g&&(this.h=g,$=!0,p.insertSpaces=g)}typeof c.cursorStyle<"u"&&this.j!==c.cursorStyle&&(this.j=c.cursorStyle,$=!0,p.cursorStyle=c.cursorStyle),typeof c.lineNumbers<"u"&&this.k!==c.lineNumbers&&(this.k=c.lineNumbers,$=!0,p.lineNumbers=F.TextEditorLineNumbersStyle.from(c.lineNumbers)),$&&this.u("setOptions",this.c.$trySetOptions(this.d,p))}u(c,p){p.catch($=>{this.e.warn(`ExtHostTextEditorOptions '${c}' failed:'`),this.e.warn($)})}}e.$iM=f;class R{constructor(c,p,$,g,t,n,a,b){this.id=c,this.j=p,this.k=$,this.g=!1,this.h=new Set,this.c=t,this.d=new f(this.j,this.id,n,$),this.e=a,this.f=b;const E=this;this.value=Object.freeze({get document(){return g.value},set document(v){throw new M.$8("document")},get selection(){return E.c&&E.c[0]},set selection(v){if(!(v instanceof A.$eK))throw(0,M.$6)("selection");E.c=[v],E.l()},get selections(){return E.c},set selections(v){if(!Array.isArray(v)||v.some(r=>!(r instanceof A.$eK)))throw(0,M.$6)("selections");E.c=v,E.l()},get visibleRanges(){return E.e},set visibleRanges(v){throw new M.$8("visibleRanges")},get options(){return E.d.value},set options(v){E.g||E.d.assign(v)},get viewColumn(){return E.f},set viewColumn(v){throw new M.$8("viewColumn")},edit(v,r={undoStopBefore:!0,undoStopAfter:!0}){if(E.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const s=new k(g.value,r);return v(s),E.m(s)},insertSnippet(v,r,s={undoStopBefore:!0,undoStopAfter:!0}){if(E.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let i;if(!r||Array.isArray(r)&&r.length===0)i=E.c.map(o=>F.Range.from(o));else if(r instanceof A.$cK){const{lineNumber:o,column:y}=F.Position.from(r);i=[{startLineNumber:o,startColumn:y,endLineNumber:o,endColumn:y}]}else if(r instanceof A.$dK)i=[F.Range.from(r)];else{i=[];for(const o of r)if(o instanceof A.$dK)i.push(F.Range.from(o));else{const{lineNumber:y,column:d}=F.Position.from(o);i.push({startLineNumber:y,startColumn:d,endLineNumber:y,endColumn:d})}}return p.$tryInsertSnippet(c,g.value.version,v.value,i,s)},setDecorations(v,r){const s=r.length===0;s&&!E.h.has(v.key)||(s?E.h.delete(v.key):E.h.add(v.key),E.n(()=>{if(F.$0L(r))return p.$trySetDecorations(c,v.key,F.$$L(r));{const i=new Array(4*r.length);for(let o=0,y=r.length;o<y;o++){const d=r[o];i[4*o]=d.start.line+1,i[4*o+1]=d.start.character+1,i[4*o+2]=d.end.line+1,i[4*o+3]=d.end.character+1}return p.$trySetDecorationsFast(c,v.key,i)}}))},revealRange(v,r){E.n(()=>p.$tryRevealRange(c,F.Range.from(v),r||A.TextEditorRevealType.Default))},show(v){p.$tryShowEditor(c,F.ViewColumn.from(v))},hide(){p.$tryHideEditor(c)}})}dispose(){(0,w.ok)(!this.g),this.g=!0}_acceptOptions(c){(0,w.ok)(!this.g),this.d._accept(c)}_acceptVisibleRanges(c){(0,w.ok)(!this.g),this.e=c}_acceptViewColumn(c){(0,w.ok)(!this.g),this.f=c}_acceptSelections(c){(0,w.ok)(!this.g),this.c=c}async l(){const c=this.c.map(F.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,c)),this.value}m(c){const p=c.finalize();if(p.edits.length===0&&!p.setEndOfLine)return Promise.resolve(!0);const $=p.edits.map(t=>t.range);$.sort((t,n)=>t.end.line===n.end.line?t.end.character===n.end.character?t.start.line===n.start.line?t.start.character-n.start.character:t.start.line-n.start.line:t.end.character-n.end.character:t.end.line-n.end.line);for(let t=0,n=$.length-1;t<n;t++){const a=$[t].end;if($[t+1].start.isBefore(a))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const g=p.edits.map(t=>({range:F.Range.from(t.range),text:t.text,forceMoveMarkers:t.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,p.documentVersionId,g,{setEndOfLine:typeof p.setEndOfLine=="number"?F.EndOfLine.from(p.setEndOfLine):void 0,undoStopBefore:p.undoStopBefore,undoStopAfter:p.undoStopAfter})}n(c){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):c().then(()=>this,p=>(p instanceof Error&&p.name==="DISPOSED"||this.k.warn(p),null))}}e.$jM=R}),define(Re[208],Me([1,0,4,171]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wJ=void 0,e.$wJ=(0,w.$Oh)(M.$Uh)}),define(Re[106],Me([1,0,20,5,19,6]),function(be,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d4b=e.$c4b=e.$b4b=e.$a4b=e.$_3b=e.$$3b=void 0;class A{constructor(n,a){this.versionId=n,this.removedDueToLooping=a}}e.$$3b=A;class l{static isHostExtension(n,a,b){if(a.getExtensionDescription(n))return!1;const E=b.getExtensionDescription(n);return E?!!((E.main||E.browser)&&E.api==="none"):!1}constructor(n,a){this.j=n,this.c=new M.$Md,this.onDidChange=this.c.event,this.d=0,this.e=a,this.k()}k(){this.e.sort($),this.f=new w.$4l,this.g=[],this.h=new Map;for(const n of this.e){if(this.f.has(n.identifier)){console.error("Extension `"+n.identifier.value+"` is already registered");continue}this.f.set(n.identifier,n),this.g.push(n);const a=this.j.readActivationEvents(n);if(Array.isArray(a))for(let b of a)b==="onUri"&&(b=`onUri:${w.$2l.toKey(n.identifier)}`),this.h.has(b)||this.h.set(b,[]),this.h.get(b).push(n)}}set(n){return this.e=n,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(n,a){this.e=g(this.e,a),this.e=this.e.concat(n);const b=l.l(this.e);return this.e=g(this.e,b.map(E=>E.identifier)),this.k(),this.d++,this.c.fire(void 0),new A(this.d,b)}static l(n){const a=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(s){this.d.has(s)||(this.d.add(s),this.e.push(s))}addArc(s,i){this.addNode(s),this.addNode(i),this.c.has(s)?this.c.get(s).push(i):this.c.set(s,[i])}getArcs(s){return this.c.has(s)?this.c.get(s):[]}hasOnlyGoodArcs(s,i){const o=a.getArcs(s);for(let y=0;y<o.length;y++)if(!i.has(o[y]))return!1;return!0}getNodes(){return this.e}},b=new w.$4l;for(const s of n)if(b.set(s.identifier,s),s.extensionDependencies)for(const i of s.extensionDependencies)a.addArc(w.$2l.toKey(s.identifier),w.$2l.toKey(i));const E=new Set;a.getNodes().filter(s=>a.getArcs(s).length===0).forEach(s=>E.add(s));const v=a.getNodes().filter(s=>!E.has(s));let r;do{r=!1;for(let s=0;s<v.length;s++){const i=v[s];a.hasOnlyGoodArcs(i,E)&&(v.splice(s,1),s--,E.add(i),r=!0)}}while(r);return v.map(s=>b.get(s))}containsActivationEvent(n){return this.h.has(n)}containsExtension(n){return this.f.has(n)}getExtensionDescriptionsForActivationEvent(n){const a=this.h.get(n);return a?a.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new k(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(n){const a=this.f.get(n);return a||void 0}getExtensionDescriptionByUUID(n){for(const a of this.g)if(a.uuid===n)return a}getExtensionDescriptionByIdOrUUID(n,a){return this.getExtensionDescription(n)??(a?this.getExtensionDescriptionByUUID(a):void 0)}}e.$_3b=l;class k{constructor(n,a){this.versionId=n,this.extensions=a}}e.$a4b=k,e.$b4b={readActivationEvents:t=>t.activationEvents};class f{constructor(n){this.d=new c,this.c=new l(n,[])}async acquireLock(n){const a=await this.d.acquire(n);return new R(this,a)}deltaExtensions(n,a,b){if(!n.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(a,b)}containsActivationEvent(n){return this.c.containsActivationEvent(n)}containsExtension(n){return this.c.containsExtension(n)}getExtensionDescriptionsForActivationEvent(n){return this.c.getExtensionDescriptionsForActivationEvent(n)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(n){return this.c.getExtensionDescription(n)}getExtensionDescriptionByUUID(n){return this.c.getExtensionDescriptionByUUID(n)}getExtensionDescriptionByIdOrUUID(n,a){return this.c.getExtensionDescriptionByIdOrUUID(n,a)}}e.$c4b=f;class R extends F.$Rc{constructor(n,a){super(),this.f=n,this.c=!1,this.B(a)}isAcquiredFor(n){return!this.c&&this.f===n}}e.$d4b=R;class D{constructor(n){this.name=n,this.promise=new Promise((a,b)=>{this.c=a})}resolve(n){this.c(n)}}class c{constructor(){this.c=[],this.d=!1}async acquire(n){const a=new D(n);return this.c.push(a),this.e(),a.promise}e(){if(this.d||this.c.length===0)return;const n=this.c.shift();this.d=!0;let a=!0;const b=setTimeout(()=>{a&&console.warn(`The customer named ${n.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),E=()=>{a&&(clearTimeout(b),a=!1,this.d=!1,this.e())};n.resolve((0,F.$Pc)(E))}}var p;(function(t){t[t.Builtin=0]="Builtin",t[t.User=1]="User",t[t.Dev=2]="Dev"})(p||(p={}));function $(t,n){const a=t.isBuiltin?0:t.isUnderDevelopment?2:1,b=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(a!==b)return a-b;const E=C.$fc.basename(t.extensionLocation.path),v=C.$fc.basename(n.extensionLocation.path);return E<v?-1:E>v?1:0}function g(t,n){const a=new w.$3l(n);return t.filter(b=>!a.has(b.identifier))}}),define(Re[79],Me([1,0,26]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$$l=e.$0l=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var M;(function(f){f[f.Desktop=1]="Desktop",f[f.Web=2]="Web"})(M||(e.UIKind=M={}));var C;(function(f){f[f.VersionMismatch=55]="VersionMismatch",f[f.UnexpectedError=81]="UnexpectedError"})(C||(e.ExtensionHostExitCode=C={}));var F;(function(f){f[f.Initialized=0]="Initialized",f[f.Ready=1]="Ready",f[f.Terminate=2]="Terminate"})(F||(e.MessageType=F={}));function A(f){const R=w.$ae.alloc(1);switch(f){case 0:R.writeUInt8(1,0);break;case 1:R.writeUInt8(2,0);break;case 2:R.writeUInt8(3,0);break}return R}e.$0l=A;function l(f,R){if(f.byteLength!==1)return!1;switch(f.readUInt8(0)){case 1:return R===0;case 2:return R===1;case 3:return R===2;default:return!1}}e.$$l=l;var k;(function(f){f.Start="START_NATIVE_LOG",f.End="END_NATIVE_LOG"})(k||(e.NativeLogMarkers=k={}))}),define(Re[57],Me([1,0,4,5,14,27,79,52,53,24,2,6,154]),function(be,e,w,M,C,F,A,l,k,f,R,D,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uM=e.$tM=e.$sM=e.$rM=void 0;let p=class extends D.$Rc{constructor(n,a){super(),this.s=n,this.t=a,this.a=this.B(new M.$Md),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new M.$Md),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=R.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=a.createLogger(this.m,{id:k.$ko,name:(0,c.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(a.onDidChangeLogLevel(b=>{(0,C.$0i)(b)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===C.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(n,a,b){const E=this.getTelemetryDetails(),v=new $(a,b,n,this.n,this.j,this.getBuiltInCommonProperties(n),{isUsageEnabled:E.isUsageEnabled,isErrorsEnabled:E.isErrorsEnabled}),r=this.r.get(n.identifier.value)??[];return this.r.set(n.identifier.value,[...r,v]),v.apiTelemetryLogger}$initializeTelemetryLevel(n,a,b){this.f=n,this.g=a,this.c=b??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(n){const a=Object.create(null);switch(a["common.extname"]=`${n.publisher}.${n.name}`,a["common.extversion"]=n.version,a["common.vscodemachineid"]=this.s.telemetryInfo.machineId,a["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,a["common.vscodeversion"]=this.s.version,a["common.isnewappinstall"]=g(this.s.telemetryInfo.firstSessionDate),a["common.product"]=this.s.environment.appHost,this.s.uiKind){case A.UIKind.Web:a["common.uikind"]="web";break;case A.UIKind.Desktop:a["common.uikind"]="desktop";break;default:a["common.uikind"]="unknown"}return a["common.remotename"]=(0,l.$Sk)((0,k.$ro)(this.s.remote.authority)),a}$onDidChangeTelemetryLevel(n){this.h=this.getTelemetryConfiguration(),this.f=n;const a=this.getTelemetryDetails();this.r.forEach((b,E)=>{const v=b.filter(r=>!r.isDisposed);v.length===0?this.r.delete(E):this.r.set(E,v)}),this.r.forEach(b=>{for(const E of b)E.updateTelemetryEnablements(a.isUsageEnabled,a.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(n,a){const E=this.r.get(n.value)?.filter(r=>!r.isDisposed);if(!E)return this.r.delete(n.value),!1;let v=!1;for(const r of E)r.ignoreUnhandledExtHostErrors||(r.logError(a),v=!0);return v}};e.$rM=p,e.$rM=p=qe([We(0,F.$qM),We(1,C.$9i)],p);class ${static validateSender(n){if(typeof n!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof n.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof n.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof n.flush<"u"&&typeof n.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(n,a,b,E,v,r,s){this.g=b,this.h=E,this.i=v,this.j=r,this.a=new M.$Md,this.ignoreUnhandledExtHostErrors=a?.ignoreUnhandledErrors??!1,this.b=a?.ignoreBuiltInCommonProperties??!1,this.c=a?.additionalCommonProperties,this.f=n,this.d={isUsageEnabled:s.isUsageEnabled,isErrorsEnabled:s.isErrorsEnabled}}updateTelemetryEnablements(n,a){this.e&&(this.d={isUsageEnabled:n,isErrorsEnabled:a},this.a.fire(this.e))}mixInCommonPropsAndCleanData(n){let a="properties"in n?n.properties??{}:n;return a=(0,k.$uo)(a,[]),this.c&&(a=(0,f.$5m)(a,this.c)),this.b||(a=(0,f.$5m)(a,this.j)),"properties"in n?n.properties=a:n=a,n}k(n,a){this.f&&(this.g.publisher==="vscode"?n=this.g.name+"/"+n:n=this.g.identifier.value+"/"+n,a=this.mixInCommonPropsAndCleanData(a||{}),this.i||this.f?.sendEventData(n,a),this.h.trace(n,a))}logUsage(n,a){this.d.isUsageEnabled&&this.k(n,a)}logError(n,a){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof n=="string")this.k(n,a);else{const b={name:n.name,message:n.message,stack:n.stack,cause:n.cause},E=(0,k.$uo)(b,[]),v=new Error(E.message,{cause:E.cause});v.stack=E.stack,v.name=E.name,a=this.mixInCommonPropsAndCleanData(a||{}),this.i||this.f.sendErrorData(v,a),this.h.trace("exception",a)}}get apiTelemetryLogger(){if(!this.e){const n=this,a={logUsage:n.logUsage.bind(n),get isUsageEnabled(){return n.d.isUsageEnabled},get isErrorsEnabled(){return n.d.isErrorsEnabled},logError:n.logError.bind(n),dispose:n.dispose.bind(n),onDidChangeEnableStates:n.a.event.bind(n)};this.e=Object.freeze(a)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let n=this.f;this.f=void 0,Promise.resolve(n.flush()).then(n=void 0),this.e=void 0}else this.f=void 0}}e.$sM=$;function g(t){const n=Date.now()-new Date(t).getTime();return isNaN(n)?!1:n<1e3*60*60*24}e.$tM=g,e.$uM=(0,w.$Nh)("IExtHostTelemetry")}),define(Re[25],Me([1,0,5,2,180,98,20,4]),function(be,e,w,M,C,F,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eF=e.$dF=e.$cF=e.ActivationKind=e.$bF=e.$aF=e.$_E=e.$$E=e.$0E=e.ExtensionHostStartup=e.$9E=e.$8E=e.$7E=e.$6E=void 0,e.$6E=Object.freeze({identifier:new A.$2l("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:M.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$7E="extensions.webWorker",e.$8E=(0,l.$Nh)("extensionService");class k{constructor(v){this.dependency=v}}e.$9E=k;var f;(function(E){E[E.EagerAutoStart=1]="EagerAutoStart",E[E.EagerManualStart=2]="EagerManualStart",E[E.Lazy=3]="Lazy"})(f||(e.ExtensionHostStartup=f={}));class R{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(v,r,s){this.c=v,this.d=r.slice(0),this.e=s.slice(0)}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:F.$QE.createActivationEventsMap(this.d)}}set(v,r,s){if(this.c>v)throw new Error(`ExtensionHostExtensions: invalid versionId ${v} (current: ${this.c})`);const i=[],o=[],y=[],d=[],I=D(this.d),S=D(r),u=(K,U)=>K.extensionLocation.toString()===U.extensionLocation.toString()||K.isBuiltin===U.isBuiltin||K.isUserBuiltin===U.isUserBuiltin||K.isUnderDevelopment===U.isUnderDevelopment;for(const K of this.d){const U=S.get(K.identifier);if(!U){i.push(K.identifier),I.delete(K.identifier);continue}if(!u(K,U)){i.push(K.identifier),I.delete(K.identifier);continue}}for(const K of r){const U=I.get(K.identifier);if(!U){o.push(K);continue}if(!u(U,K)){i.push(U.identifier),I.delete(U.identifier);continue}}const m=new A.$3l(this.e),h=new A.$3l(s);for(const K of this.e)h.has(K)||y.push(K);for(const K of s)m.has(K)||d.push(K);const P=F.$QE.createActivationEventsMap(o),W={versionId:v,toRemove:i,toAdd:o,addActivationEvents:P,myToRemove:y,myToAdd:d};return this.delta(W),W}delta(v){if(this.c>=v.versionId)return null;const{toRemove:r,toAdd:s,myToRemove:i,myToAdd:o}=v,y=new A.$3l(r),d=new A.$3l(i);for(let I=0;I<this.d.length;I++)y.has(this.d[I].identifier)&&(this.d.splice(I,1),I--);for(let I=0;I<this.e.length;I++)d.has(this.e[I])&&(this.e.splice(I,1),I--);for(const I of s)this.d.push(I);for(const I of o)this.e.push(I);return v}containsExtension(v){for(const r of this.e)if(A.$2l.equals(r,v))return!0;return!1}}e.$0E=R;function D(E){const v=new A.$4l;for(const r of E)v.set(r.identifier,r);return v}function c(E,v){return E.enabledApiProposals?E.enabledApiProposals.includes(v):!1}e.$$E=c;function p(E,v){if(!c(E,v))throw new Error(`Extension '${E.identifier.value}' CANNOT use API proposal: ${v}.
Its package.json#enabledApiProposals-property declares: ${E.enabledApiProposals?.join(", ")??"[]"} but NOT ${v}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${E.identifier.value}`)}e.$_E=p;class ${constructor(v,r,s,i){this.codeLoadingTime=v,this.activateCallTime=r,this.activateResolvedTime=s,this.activationReason=i}}e.$aF=$;class g{constructor(v,r){this.description=v,this.value=r}}e.$bF=g;var t;(function(E){E[E.Normal=0]="Normal",E[E.Immediate=1]="Immediate"})(t||(e.ActivationKind=t={}));function n(E){return{type:E.isBuiltin?0:1,isBuiltin:E.isBuiltin||E.isUserBuiltin,identifier:{id:(0,C.$Ao)(E.publisher,E.name),uuid:E.uuid},manifest:E,location:E.extensionLocation,targetPlatform:E.targetPlatform,validations:[],isValid:!0}}e.$cF=n;function a(E,v){return{identifier:new A.$2l((0,C.$yo)(E.manifest.publisher,E.manifest.name)),isBuiltin:E.type===0,isUserBuiltin:E.type===1&&E.isBuiltin,isUnderDevelopment:!!v,extensionLocation:E.location,...E.manifest,uuid:E.identifier.uuid,targetPlatform:E.targetPlatform}}e.$dF=a;class b{constructor(){this.onDidRegisterExtensions=w.Event.None,this.onDidChangeExtensionsStatus=w.Event.None,this.onDidChangeExtensions=w.Event.None,this.onWillActivateByEvent=w.Event.None,this.onDidChangeResponsiveChange=w.Event.None,this.onWillStop=w.Event.None,this.extensions=[]}activateByEvent(v){return Promise.resolve(void 0)}activationEventIsDone(v){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(v){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(v,r){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(v){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$eF=b}),define(Re[209],Me([1,0,9,106,20,25,14,12]),function(be,e,w,M,C,F,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_bc=e.$$bc=e.$0bc=e.$9bc=e.$8bc=e.$7bc=void 0;class k{static{this.NONE=new k(!1,-1,-1,-1)}constructor(n,a,b,E){this.startup=n,this.codeLoadingTime=a,this.activateCallTime=b,this.activateResolvedTime=E}}e.$7bc=k;class f{constructor(n){this.a=n,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(n,a){return n===-1||a===-1?-1:a-n}build(){return new k(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$8bc=f;class R{constructor(n,a,b,E,v,r){this.activationFailed=n,this.activationFailedError=a,this.activationTimes=b,this.module=E,this.exports=v,this.subscriptions=r}}e.$9bc=R;class D extends R{constructor(n){super(!1,null,n,{activate:void 0,deactivate:void 0},void 0,[])}}e.$0bc=D;class c extends R{constructor(){super(!1,null,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$$bc=c;class p extends R{constructor(n){super(!0,n,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let $=class{constructor(n,a,b,E){this.g=E,this.a=n,this.b=a,this.c=b,this.d=new C.$4l,this.f=Object.create(null)}dispose(){for(const[n,a]of this.d)a.dispose()}async waitForActivatingExtensions(){const n=[];for(const[a,b]of this.d)n.push(b.wait());await Promise.all(n)}isActivated(n){const a=this.d.get(n);return!!(a&&a.value)}getActivatedExtension(n){const a=this.d.get(n);if(!a||!a.value)throw new Error(`Extension '${n.value}' is not known or not activated`);return a.value}async activateByEvent(n,a){if(this.f[n])return;const b=this.a.getExtensionDescriptionsForActivationEvent(n);await this.h(b.map(E=>({id:E.identifier,reason:{startup:a,extensionId:E.identifier,activationEvent:n}}))),this.f[n]=!0}activateById(n,a){const b=this.a.getExtensionDescription(n);if(!b)throw new Error(`Extension '${n}' is not known`);return this.h([{id:b.identifier,reason:a}])}async h(n){const a=n.filter(b=>!this.isActivated(b.id)).map(b=>this.j(b));await Promise.all(a.map(b=>b.wait()))}j(n){if(this.d.has(n.id))return this.d.get(n.id);if(this.l(n.id))return this.k(n,null,[],null);const a=this.a.getExtensionDescription(n.id);if(!a){const v=new Error(`Cannot activate unknown extension '${n.id.value}'`),r=this.k(n,null,[],new p(v));return this.c.onExtensionActivationError(n.id,v,new F.$9E(n.id.value)),r}const b=[],E=typeof a.extensionDependencies>"u"?[]:a.extensionDependencies;for(const v of E){if(this.m(v))continue;const r=this.d.get(v);if(r){b.push(r);continue}if(this.l(v)){b.push(this.j({id:this.b.getExtensionDescription(v).identifier,reason:n.reason}));continue}const s=this.a.getExtensionDescription(v);if(s){if(!s.main&&!s.browser)continue;b.push(this.j({id:s.identifier,reason:n.reason}));continue}const i=a.displayName||a.identifier.value,o=new Error(`Cannot activate the '${i}' extension because it depends on unknown extension '${v}'`),y=this.k(n,a.displayName,[],new p(o));return this.c.onExtensionActivationError(a.identifier,o,new F.$9E(v)),y}return this.k(n,a.displayName,b,null)}k(n,a,b,E){const v=new g(n.id,a,n.reason,b,E,this.c,this.g);return this.d.set(n.id,v),v}l(n){return M.$_3b.isHostExtension(n,this.a,this.b)}m(n){const a=this.b.getExtensionDescription(n);return a?!a.main&&!a.browser:!1}};e.$_bc=$,e.$_bc=$=qe([We(3,A.$8i)],$);let g=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(n,a,b,E,v,r,s){this.c=n,this.d=a,this.f=b,this.g=E,this.h=v,this.j=r,this.k=s,this.a=new l.$Rg,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let n=0;n<this.g.length;n++){const a=this.g[n];if(a.value&&!a.value.activationFailed){this.g.splice(n,1),n--;continue}if(a.value&&a.value.activationFailed){const b=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${a.friendlyName}' failed to activate`);b.detail=a.value.activationFailedError,this.h=new p(b),this.j.onExtensionActivationError(this.c,b,null);return}}this.g.length>0&&await Promise.race(this.g.map(n=>n.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(n){const a=new Error;if(n&&n.name&&(a.name=n.name),n&&n.message?a.message=`Activating extension '${this.c.value}' failed: ${n.message}.`:a.message=`Activating extension '${this.c.value}' failed: ${n}.`,n&&n.stack&&(a.stack=n.stack),this.h=new p(a),this.b&&w.$3(n))return;this.j.onExtensionActivationError(this.c,a,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(n)}}};g=qe([We(6,A.$8i)],g)}),define(Re[210],Me([1,0,156,23,2,5,6,192,12,7,16,18,8,50,21,125,25]),function(be,e,w,M,C,F,A,l,k,f,R,D,c,p,$,g,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lcc=void 0;function n(E,v){if((0,R.$xf)(E))return{label:E};if(E&&typeof E=="object"&&typeof E.label=="string"){let r;return Array.isArray(E.highlights)&&(r=E.highlights.filter(s=>s.length===2&&typeof s[0]=="number"&&typeof s[1]=="number"),r=r.length?r:void 0),{label:E.label,highlights:r}}}class a extends A.$Rc{constructor(v,r,s){super(),this.f=v,this.g=r,this.h=s,this.a=new Map,this.b=new g.$F7;function i(o){return o&&o.$treeViewId&&(o.$treeItemHandle||o.$selectedTreeItems||o.$focusedTreeItem)}r.registerArgumentProcessor({processArgument:o=>i(o)?this.r(o):Array.isArray(o)&&o.length>0?o.map(y=>i(y)?this.r(y):y):o})}registerTreeDataProvider(v,r,s){const i=this.createTreeView(v,{treeDataProvider:r},s);return{dispose:()=>i.dispose()}}createTreeView(v,r,s){if(!r||!r.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const i=r.dragAndDropController?.dropMimeTypes??[],o=r.dragAndDropController?.dragMimeTypes??[],y=!!r.dragAndDropController?.handleDrag,d=!!r.dragAndDropController?.handleDrop,I=this.m(v,r,s),S={showCollapseAll:!!r.showCollapseAll,canSelectMany:!!r.canSelectMany,dropMimeTypes:i,dragMimeTypes:o,hasHandleDrag:y,hasHandleDrop:d,manuallyManageCheckboxes:!!r.manageCheckboxStateManually},u=this.f.$registerTreeViewDataProvider(v,S),m={get onDidCollapseElement(){return I.onDidCollapseElement},get onDidExpandElement(){return I.onDidExpandElement},get selection(){return I.selectedElements},get onDidChangeSelection(){return I.onDidChangeSelection},get activeItem(){return(0,t.$_E)(s,"treeViewActiveItem"),I.focusedElement},get onDidChangeActiveItem(){return(0,t.$_E)(s,"treeViewActiveItem"),I.onDidChangeActiveItem},get visible(){return I.visible},get onDidChangeVisibility(){return I.onDidChangeVisibility},get onDidChangeCheckboxState(){return I.onDidChangeCheckboxState},get message(){return I.message},set message(h){(0,p.$3j)(h)&&(0,t.$_E)(s,"treeViewMarkdownMessage"),I.message=h},get title(){return I.title},set title(h){I.title=h},get description(){return I.description},set description(h){I.description=h},get badge(){return I.badge},set badge(h){h!==void 0&&f.ViewBadge.isViewBadge(h)?I.badge={value:Math.floor(Math.abs(h.value)),tooltip:h.tooltip}:h===void 0&&(I.badge=void 0)},reveal:(h,P)=>I.reveal(h,P),dispose:async()=>{await u,this.a.delete(v),I.dispose()}};return this.B(m),m}$getChildren(v,r){const s=this.a.get(v);return s?s.getChildren(r):Promise.reject(new l.$lE(v))}async $handleDrop(v,r,s,i,o,y,d,I){const S=this.a.get(v);if(!S)return Promise.reject(new l.$lE(v));const u=c.DataTransfer.toDataTransfer(s,async m=>(await this.f.$resolveDropFileData(v,r,m)).buffer);return d===v&&I&&await this.j(u,S,I,o,y),S.onDrop(u,i,o)}async j(v,r,s,i,o){const y=this.b.removeDragOperationTransfer(o);if(y)(await y)?.forEach((d,I)=>{d&&v.set(I,d)});else if(o&&r.handleDrag){const d=r.handleDrag(s,v,i);this.b.addDragOperationTransfer(o,d),await d}return v}async $handleDrag(v,r,s,i){const o=this.a.get(v);if(!o)return Promise.reject(new l.$lE(v));const y=await this.j(new f.$5K,o,r,i,s);if(!(!y||i.isCancellationRequested))return c.DataTransfer.from(y)}async $hasResolve(v){const r=this.a.get(v);if(!r)throw new l.$lE(v);return r.hasResolve}$resolve(v,r,s){const i=this.a.get(v);if(!i)throw new l.$lE(v);return i.resolveTreeItem(r,s)}$setExpanded(v,r,s){const i=this.a.get(v);if(!i)throw new l.$lE(v);i.setExpanded(r,s)}$setSelectionAndFocus(v,r,s){const i=this.a.get(v);if(!i)throw new l.$lE(v);i.setSelectionAndFocus(r,s)}$setVisible(v,r){const s=this.a.get(v);if(!s){if(!r)return;throw new l.$lE(v)}s.setVisible(r)}$changeCheckboxState(v,r){const s=this.a.get(v);if(!s)throw new l.$lE(v);s.setCheckboxState(r)}m(v,r,s){const i=this.B(new b(v,r,this.f,this.g.converter,this.h,s));return this.a.set(v,i),i}r(v){const r=this.a.get(v.$treeViewId);return r&&"$treeItemHandle"in v?r.getExtensionElement(v.$treeItemHandle):r&&"$focusedTreeItem"in v&&v.$focusedTreeItem?r.focusedElement:null}}e.$Lcc=a;class b extends A.$Rc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(v=>this.getExtensionElement(v)).filter(v=>!(0,R.$Gf)(v))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(v,r,s,i,o,y){if(super(),this.I=v,this.J=s,this.L=i,this.M=o,this.N=y,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new F.$Md),this.onDidExpandElement=this.u.event,this.w=this.B(new F.$Md),this.onDidCollapseElement=this.w.event,this.y=this.B(new F.$Md),this.onDidChangeSelection=this.y.event,this.z=this.B(new F.$Md),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new F.$Md),this.onDidChangeVisibility=this.C.event,this.D=this.B(new F.$Md),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new F.$Md),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new $.$Wd,y.contributes&&y.contributes.views)for(const u in y.contributes.views)for(const m of y.contributes.views[u])m.id===v&&(this.P=m.name);this.f=r.treeDataProvider,this.g=r.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(u=>this.F.fire({message:!1,element:u})));let d,I;const S=F.Event.debounce(this.F.event,(u,m)=>(u||(u={message:!1,elements:[]}),m.element!==!1&&(d||(d=new Promise(h=>I=h),this.G=this.G.then(()=>d)),Array.isArray(m.element)?u.elements.push(...m.element):u.elements.push(m.element)),m.message&&(u.message=!0),u),200,!0);this.B(S(({message:u,elements:m})=>{m.length&&(this.H=this.H.then(()=>{const h=I;return d=null,this.$(m).then(()=>h())})),u&&this.J.$setMessage(this.I,c.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(v){const r=v?this.getExtensionElement(v):void 0;if(v&&!r)return this.M.error(`No tree item with id '${v}' found.`),Promise.resolve([]);let s=this.X(v);return s||(s=await this.Y(r)),s?s.map(i=>i.item):void 0}getExtensionElement(v){return this.j.get(v)}reveal(v,r){r=r||{select:!0,focus:!1};const s=(0,R.$Gf)(r.select)?!0:r.select,i=(0,R.$Gf)(r.focus)?!1:r.focus,o=(0,R.$Gf)(r.expand)?!1:r.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):v?this.G.then(()=>this.S(v)).then(y=>this.W(v,y[y.length-1]).then(d=>this.J.$reveal(this.I,{item:d.item,parentChain:y.map(I=>I.item)},{select:s,focus:i,expand:o})),y=>this.M.error(y)):this.J.$reveal(this.I,void 0,{select:s,focus:i,expand:o})}get message(){return this.O}set message(v){this.O=v,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(v){this.P=v,this.J.$setTitle(this.I,v,this.Q)}get description(){return this.Q}set description(v){this.Q=v,this.J.$setTitle(this.I,this.P,v)}get badge(){return this.R}set badge(v){this.R?.value===v?.value&&this.R?.tooltip===v?.tooltip||(this.R=c.ViewBadge.from(v),this.J.$setBadge(this.I,v))}setExpanded(v,r){const s=this.getExtensionElement(v);s&&(r?this.u.fire(Object.freeze({element:s})):this.w.fire(Object.freeze({element:s})))}setSelectionAndFocus(v,r){const s=!(0,D.$tb)(this.s,v);this.s=v;const i=this.t!==r;this.t=r,s&&this.y.fire(Object.freeze({selection:this.selectedElements})),i&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(v){v!==this.r&&(this.r=v,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(v){const r=(await Promise.all(v.map(async s=>{const i=this.getExtensionElement(s.treeItemHandle);return i?{extensionItem:i,treeItem:await this.f.getTreeItem(i),newState:s.newState?f.TreeItemCheckboxState.Checked:f.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(s=>s!==void 0);r.forEach(s=>{s.treeItem.checkboxState=s.newState?f.TreeItemCheckboxState.Checked:f.TreeItemCheckboxState.Unchecked}),this.D.fire({items:r.map(s=>[s.extensionItem,s.newState])})}async handleDrag(v,r,s){const i=[];for(const o of v){const y=this.getExtensionElement(o);y&&i.push(y)}if(!(!this.g?.handleDrag||i.length===0))return await this.g.handleDrag(i,r,s),r}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(v,r,s){const i=r?this.getExtensionElement(r):void 0;if(!(!i&&r||!this.g?.handleDrop))return(0,k.$Lg)(()=>this.g?.handleDrop?this.g.handleDrop(i,v,s):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(v,r){if(!this.f.resolveTreeItem)return;const s=this.j.get(v);if(s){const i=this.m.get(s);if(i){const o=await this.f.resolveTreeItem(i.extensionItem,s,r)??i.extensionItem;return this.hb(o),i.item.tooltip=this.eb(o.tooltip),i.item.command=this.fb(i.disposableStore,o.command),i.item}}}S(v){return this.U(v).then(r=>r?this.S(r).then(s=>this.W(r,s[s.length-1]).then(i=>(s.push(i),s))):Promise.resolve([]))}U(v){const r=this.m.get(v);return r?Promise.resolve(r.parent?this.j.get(r.parent.item.handle):void 0):(0,k.$Lg)(()=>this.f.getParent(v))}W(v,r){const s=this.m.get(v);return s?Promise.resolve(s):(0,k.$Lg)(()=>this.f.getTreeItem(v)).then(i=>this.kb(v,i,r,!0)).then(i=>this.getChildren(r?r.item.handle:void 0).then(()=>{const o=this.getExtensionElement(i);if(o){const y=this.m.get(o);if(y)return Promise.resolve(y)}throw new Error(`Cannot resolve tree item for element ${i} from extension ${this.N.identifier.value}`)}))}X(v){if(v){let r;if(typeof v=="string"){const s=this.getExtensionElement(v);r=s?this.m.get(s):void 0}else r=v;return r&&r.children||void 0}return this.h}async Y(v){this.rb(v);const r=new $.$Wd(this.Z.token);try{const s=v?this.m.get(v):void 0,i=await this.f.getChildren(v);if(r.token.isCancellationRequested)return;const o=await Promise.all((0,D.$Gb)(i||[]).map(async y=>{const d=await this.f.getTreeItem(y);return d&&!r.token.isCancellationRequested?this.db(y,d,s):null}));return r.token.isCancellationRequested?void 0:(0,D.$Gb)(o)}finally{r.dispose()}}$(v){if(v.some(s=>!s))return this.Z.dispose(!0),this.Z=new $.$Wd,this.tb(),this.J.$refresh(this.I);{const s=this.ab(v);if(s.length)return this.bb(s)}return Promise.resolve(void 0)}ab(v){const r=new Set,s=v.map(o=>this.m.get(o));for(const o of s)if(o&&!r.has(o.item.handle)){let y=o;for(;y&&y.parent&&s.findIndex(d=>y&&y.parent&&d&&d.item.handle===y.parent.item.handle)===-1;){const d=this.j.get(y.parent.item.handle);y=d?this.m.get(d):void 0}y&&!y.parent&&r.add(o.item.handle)}const i=[];return r.forEach(o=>{const y=this.j.get(o);if(y){const d=this.m.get(y);d&&(!d.parent||!r.has(d.parent.item.handle))&&i.push(o)}}),i}bb(v){const r={};return Promise.all(v.map(s=>this.cb(s).then(i=>{i&&(r[s]=i.item)}))).then(()=>Object.keys(r).length?this.J.$refresh(this.I,r):void 0)}cb(v){const r=this.getExtensionElement(v);if(r){const s=this.m.get(r);if(s)return this.rb(r),(0,k.$Lg)(()=>this.f.getTreeItem(r)).then(i=>{if(i){const o=this.ib(r,i,s.parent);return this.pb(r,o,s,s.parent),s.dispose(),o}return null})}return Promise.resolve(null)}db(v,r,s){const i=this.ib(v,r,s);if(r.id&&this.j.has(i.item.handle))throw new Error((0,w.localize)(0,null,r.id));return this.ob(v,i),this.qb(i,s),i}eb(v){return f.$BK.isMarkdownString(v)?c.MarkdownString.from(v):v}fb(v,r){return r?{...this.L.toInternal(r,v),originalId:r.command}:void 0}gb(v){if(v.checkboxState===void 0)return;let r,s,i;return typeof v.checkboxState=="number"?r=v.checkboxState:(r=v.checkboxState.state,s=v.checkboxState.tooltip,i=v.checkboxState.accessibilityInformation),{isChecked:r===f.TreeItemCheckboxState.Checked,tooltip:s,accessibilityInformation:i}}hb(v){if(!f.$ZK.isTreeItem(v,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(v,r,s){this.hb(r);const i=this.B(new A.$Qc),o=this.kb(v,r,s),y=this.lb(r);return{item:{handle:o,parentHandle:s?s.item.handle:void 0,label:n(r.label,this.N),description:r.description,resourceUri:r.resourceUri,tooltip:this.eb(r.tooltip),command:this.fb(i,r.command),contextValue:r.contextValue,icon:y,iconDark:this.mb(r)||y,themeIcon:this.jb(r),collapsibleState:(0,R.$Gf)(r.collapsibleState)?f.TreeItemCollapsibleState.None:r.collapsibleState,accessibilityInformation:r.accessibilityInformation,checkbox:this.gb(r)},extensionItem:r,parent:s,children:void 0,disposableStore:i,dispose(){i.dispose()}}}jb(v){return v.iconPath instanceof f.$8K?v.iconPath:void 0}kb(v,{id:r,label:s,resourceUri:i},o,y){if(r)return`${b.b}/${r}`;const d=n(s,this.N),I=o?o.item.handle:b.a;let S=d?d.label:i?(0,M.$rg)(i):"";S=S.indexOf("/")!==-1?S.replace("/","//"):S;const u=this.m.has(v)?this.m.get(v).item.handle:void 0,m=this.X(o)||[];let h,P=0;do{if(h=`${I}/${P}:${S}`,y||!this.j.has(h)||u===h)break;P++}while(P<=m.length);return h}lb(v){if(v.iconPath&&!(v.iconPath instanceof f.$8K))return typeof v.iconPath=="string"||C.URI.isUri(v.iconPath)?this.nb(v.iconPath):this.nb(v.iconPath.light)}mb(v){if(v.iconPath&&!(v.iconPath instanceof f.$8K)&&v.iconPath.dark)return this.nb(v.iconPath.dark)}nb(v){return C.URI.isUri(v)?v:C.URI.file(v)}ob(v,r){this.j.set(r.item.handle,v),this.m.set(v,r)}pb(v,r,s,i){this.j.delete(r.item.handle),this.m.delete(v),r.item.handle!==s.item.handle&&this.j.delete(s.item.handle),this.ob(v,r);const o=this.X(i)||[],y=o.filter(d=>d.item.handle===s.item.handle)[0];y&&o.splice(o.indexOf(y),1,r)}qb(v,r){r?(r.children||(r.children=[]),r.children.push(v)):(this.h||(this.h=[]),this.h.push(v))}rb(v){if(v){const r=this.m.get(v);if(r){if(r.children)for(const s of r.children){const i=this.j.get(s.item.handle);i&&this.sb(i)}r.children=void 0}}else this.tb()}sb(v){const r=this.m.get(v);if(r){if(r.children)for(const s of r.children){const i=this.j.get(s.item.handle);i&&this.sb(i)}this.m.delete(v),this.j.delete(r.item.handle),r.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(v=>v.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Re[211],Me([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testMessageContextValue:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testMessageContextValue.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Re[212],Me([1,0,166,9,29,92,72,30,20,211,176,98]),function(be,e,w,M,C,F,A,l,k,f,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5E=e.$4E=e.$3E=e.$2E=e.$1E=e.$ZE=void 0;const c=l.$bn.as(A.$cn.JSONContribution);class p{constructor(v,r,s){this.a=v,this.b=r,this.c=s}d(v,r){this.a({type:v,message:r,extensionId:this.b.identifier,extensionPointId:this.c})}error(v){this.d(C.default.Error,v)}warn(v){this.d(C.default.Warning,v)}info(v){this.d(C.default.Info,v)}}e.$ZE=p;class ${static a(v){const r=new k.$3l;for(let s=0,i=v.length;s<i;s++)r.add(v[s].description.identifier);return r}static compute(v,r){if(!v||!v.length)return new $(r,[]);if(!r||!r.length)return new $([],v);const s=this.a(v),i=this.a(r),o=r.filter(d=>!s.has(d.description.identifier)),y=v.filter(d=>!i.has(d.description.identifier));return new $(o,y)}constructor(v,r){this.added=v,this.removed=r}}e.$1E=$;class g{constructor(v,r){this.name=v,this.defaultExtensionKind=r,this.a=null,this.b=null,this.c=null}setHandler(v){if(this.a!==null)throw new Error("Handler already set!");this.a=v,this.d()}acceptUsers(v){this.c=$.compute(this.b,v),this.b=v,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(v){(0,M.$Z)(v)}}}e.$2E=g;const t={type:"string",enum:["ui","workspace"],enumDescriptions:[w.localize(0,null),w.localize(1,null)]},n="vscode://schemas/vscode-extensions";e.$3E={properties:{engines:{type:"object",description:w.localize(2,null),properties:{vscode:{type:"string",description:w.localize(3,null),default:"^1.22.0"}}},publisher:{description:w.localize(4,null),type:"string"},displayName:{description:w.localize(5,null),type:"string"},categories:{description:w.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:k.$1l},{type:"string",const:"Languages",deprecationMessage:w.localize(7,null)}]}},galleryBanner:{type:"object",description:w.localize(8,null),properties:{color:{description:w.localize(9,null),type:"string"},theme:{description:w.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:w.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:w.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:w.localize(13,null)},enabledApiProposals:{markdownDescription:w.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(f.allApiProposals),markdownEnumDescriptions:Object.values(f.allApiProposals)}},api:{markdownDescription:w.localize(15,null),type:"string",enum:["none"],enumDescriptions:[w.localize(16,null)]},activationEvents:{description:w.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:w.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:w.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:w.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:w.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:w.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:w.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:w.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:w.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:w.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:w.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:w.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:w.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:w.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:w.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:w.localize(32,null)},{label:"onUri",body:"onUri",description:w.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:w.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:w.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:w.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:w.localize(37,null)},{label:"onRenderer",description:w.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:w.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:w.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:w.localize(41,null)},{label:"*",description:w.localize(42,null),body:"*"}]}},badges:{type:"array",description:w.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:w.localize(44,null)},href:{type:"string",description:w.localize(45,null)},description:{type:"string",description:w.localize(46,null)}}}},markdown:{type:"string",description:w.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:w.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:w.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:F.$Sn}},extensionPack:{description:w.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:F.$Sn}},extensionKind:{description:w.localize(51,null),type:"array",items:t,default:["workspace"],defaultSnippets:[{body:["ui"],description:w.localize(52,null)},{body:["workspace"],description:w.localize(53,null)},{body:["ui","workspace"],description:w.localize(54,null)},{body:["workspace","ui"],description:w.localize(55,null)},{body:[],description:w.localize(56,null)}]},capabilities:{description:w.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:w.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:w.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[w.localize(60,null),w.localize(61,null),w.localize(62,null)]},description:{type:"string",markdownDescription:w.localize(63,null)}}},untrustedWorkspaces:{description:w.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:w.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[w.localize(66,null),w.localize(67,null),w.localize(68,null)]},restrictedConfigurations:{description:w.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:w.localize(70,null)}}}}},sponsor:{description:w.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:w.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:w.localize(73,null),type:"string"},"vscode:uninstall":{description:w.localize(74,null),type:"string"}}},icon:{type:"string",description:w.localize(75,null)},l10n:{type:"string",description:w.localize(76,null)},pricing:{type:"string",markdownDescription:w.localize(77,null),enum:["Free","Trial"],default:"Free"}}};class a{constructor(){this.a=new Map}registerExtensionPoint(v){if(this.a.has(v.extensionPoint))throw new Error("Duplicate extension point: "+v.extensionPoint);const r=new g(v.extensionPoint,v.defaultExtensionKind);return this.a.set(v.extensionPoint,r),v.activationEventsGenerator&&D.$QE.register(v.extensionPoint,v.activationEventsGenerator),e.$3E.properties.contributes.properties[v.extensionPoint]=v.jsonSchema,c.registerSchema(n,e.$3E),r}getExtensionPoints(){return Array.from(this.a.values())}}e.$4E=a;const b={ExtensionsRegistry:"ExtensionsRegistry"};l.$bn.add(b.ExtensionsRegistry,new a),e.$5E=l.$bn.as(b.ExtensionsRegistry),c.registerSchema(n,e.$3E),c.registerSchema(R.$oj,{properties:{extensionEnabledApiProposals:{description:w.localize(78,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(f.allApiProposals),markdownEnumDescriptions:Object.values(f.allApiProposals)}}]}}}})}),define(Re[213],Me([1,0,163,16,24,212,32,5]),function(be,e,w,M,C,F,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MF=void 0;const k={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:w.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:w.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:w.localize(2,null),default:""}}};var f;(function(c){function p($,g,t){if(!$)return;const n=M.$xf($.type)?$.type:void 0;if(!n||n.length===0){t.error(w.localize(3,null));return}const a=[];if(Array.isArray($.required))for(const b of $.required)M.$xf(b)&&a.push(b);return{extensionId:g.value,taskType:n,required:a,properties:$.properties?C.$2m($.properties):{},when:$.when?A.$Li.deserialize($.when):void 0}}c.from=p})(f||(f={}));const R=F.$5E.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(c,p)=>{for(const $ of c)$.type&&p.push(`onTaskType:${$.type}`)},jsonSchema:{description:w.localize(4,null),type:"array",items:k}});class D{constructor(){this.d=new l.$Md,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((p,$)=>{R.setHandler((g,t)=>{this.c=void 0;try{for(const n of t.removed){const a=n.value;for(const b of a)this.a&&b.type&&this.a[b.type]&&delete this.a[b.type]}for(const n of t.added){const a=n.value;for(const b of a){const E=f.from(b,n.description.identifier,n.collector);E&&(this.a[E.taskType]=E)}}(t.removed.length>0||t.added.length>0)&&this.d.fire()}catch{}p(void 0)})})}onReady(){return this.b}get(p){return this.a[p]}all(){return Object.keys(this.a).map(p=>this.a[p])}getJsonSchema(){if(this.c===void 0){const p=[];for(const $ of this.all()){const g={type:"object",additionalProperties:!1};$.required.length>0&&(g.required=$.required.slice(0)),$.properties!==void 0?g.properties=C.$2m($.properties):g.properties=Object.create(null),g.properties.type={type:"string",enum:[$.taskType]},p.push(g)}this.c={oneOf:p}}return this.c}}e.$MF=new D}),define(Re[214],Me([1,0,164,16,23,24,32,213]),function(be,e,w,M,C,F,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$WF=e.JsonSchemaVersion=e.ExecutionEngine=e.$VF=e.$UF=e.$TF=e.$SF=e.$RF=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$QF=e.ShellQuoting=e.$PF=e.$OF=e.$NF=void 0,e.$NF="settings",e.$OF=new A.$5i("taskRunning",!1,w.localize(0,null)),e.$PF={value:w.localize(1,null),original:"Tasks"};var k;(function(O){O[O.Escape=1]="Escape",O[O.Strong=2]="Strong",O[O.Weak=3]="Weak"})(k||(e.ShellQuoting=k={})),e.$QF="$customized",function(O){function N(te){if(!te)return O.Strong;switch(te.toLowerCase()){case"escape":return O.Escape;case"strong":return O.Strong;case"weak":return O.Weak;default:return O.Strong}}O.from=N}(k||(e.ShellQuoting=k={}));var f;(function(O){O.defaults={cwd:"${workspaceFolder}"}})(f||(e.CommandOptions=f={}));var R;(function(O){O[O.Always=1]="Always",O[O.Silent=2]="Silent",O[O.Never=3]="Never"})(R||(e.RevealKind=R={})),function(O){function N(te){switch(te.toLowerCase()){case"always":return O.Always;case"silent":return O.Silent;case"never":return O.Never;default:return O.Always}}O.fromString=N}(R||(e.RevealKind=R={}));var D;(function(O){O[O.Never=1]="Never",O[O.OnProblem=2]="OnProblem",O[O.Always=3]="Always"})(D||(e.RevealProblemKind=D={})),function(O){function N(te){switch(te.toLowerCase()){case"always":return O.Always;case"never":return O.Never;case"onproblem":return O.OnProblem;default:return O.OnProblem}}O.fromString=N}(D||(e.RevealProblemKind=D={}));var c;(function(O){O[O.Shared=1]="Shared",O[O.Dedicated=2]="Dedicated",O[O.New=3]="New"})(c||(e.PanelKind=c={})),function(O){function N(te){switch(te.toLowerCase()){case"shared":return O.Shared;case"dedicated":return O.Dedicated;case"new":return O.New;default:return O.Shared}}O.fromString=N}(c||(e.PanelKind=c={}));var p;(function(O){O.defaults={echo:!0,reveal:R.Always,revealProblems:D.Never,focus:!1,panel:c.Shared,showReuseMessage:!0,clear:!1}})(p||(e.PresentationOptions=p={}));var $;(function(O){O[O.Shell=1]="Shell",O[O.Process=2]="Process",O[O.CustomExecution=3]="CustomExecution"})($||(e.RuntimeType=$={})),function(O){function N(Y){switch(Y.toLowerCase()){case"shell":return O.Shell;case"process":return O.Process;case"customExecution":return O.CustomExecution;default:return O.Process}}O.fromString=N;function te(Y){switch(Y){case O.Shell:return"shell";case O.Process:return"process";case O.CustomExecution:return"customExecution";default:return"process"}}O.toString=te}($||(e.RuntimeType=$={}));var g;(function(O){function N(te){return M.$xf(te)?te:te.value}O.value=N})(g||(e.CommandString=g={}));var t;(function(O){O.Clean={_id:"clean",isDefault:!1},O.Build={_id:"build",isDefault:!1},O.Rebuild={_id:"rebuild",isDefault:!1},O.Test={_id:"test",isDefault:!1};function N(Y){return Y===O.Clean._id||Y===O.Build._id||Y===O.Rebuild._id||Y===O.Test._id}O.is=N;function te(Y){if(Y!==void 0)return M.$xf(Y)?N(Y)?{_id:Y,isDefault:!1}:void 0:Y}O.from=te})(t||(e.TaskGroup=t={}));var n;(function(O){O[O.Global=1]="Global",O[O.Workspace=2]="Workspace",O[O.Folder=3]="Folder"})(n||(e.TaskScope=n={}));var a;(function(O){O.Workspace="workspace",O.Extension="extension",O.InMemory="inMemory",O.WorkspaceFile="workspaceFile",O.User="user";function N(te){switch(te){case O.User:return 2;case O.WorkspaceFile:return 5;default:return 6}}O.toConfigurationTarget=N})(a||(e.TaskSourceKind=a={}));var b;(function(O){O.parallel="parallel",O.sequence="sequence"})(b||(e.DependsOrder=b={}));var E;(function(O){O[O.default=1]="default",O[O.folderOpen=2]="folderOpen"})(E||(e.RunOnOptions=E={}));var v;(function(O){O.defaults={reevaluateOnRerun:!0,runOn:E.default,instanceLimit:1}})(v||(e.RunOptions=v={}));class r{constructor(N,te,Y,ye,Ee,Pe){this._label="",this._id=N,te&&(this._label=te),Y&&(this.type=Y),this.runOptions=ye,this.configurationProperties=Ee,this._source=Pe}getDefinition(N){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const N={folder:this.d(),id:this._id};return JSON.stringify(N)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(N,te=!1){if(N===void 0)return!1;if(M.$xf(N))return N===this._label||N===this.configurationProperties.identifier||te&&N===this._id;const Y=this.getDefinition(!0);return Y!==void 0&&Y._key===N._key}getQualifiedLabel(){const N=this.getWorkspaceFolder();return N?`${this._label} (${N.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(N){this.c===void 0&&(this.c=[]),N&&(this.c=this.c.concat(N))}get taskLoadMessages(){return this.c}}e.$RF=r;class s extends r{constructor(N,te,Y,ye,Ee,Pe,X,ae){super(N,Y,void 0,X,ae,te),this.command={},this._source=te,this.hasDefinedMatchers=Pe,Ee&&(this.command=Ee)}clone(){return new s(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(N=!1){if(N&&this._source.customizes!==void 0)return this._source.customizes;{let te;switch(this.command?this.command.runtime:void 0){case $.Shell:te="shell";break;case $.Process:te="process";break;case $.CustomExecution:te="customExecution";break;case void 0:te="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:te,_key:this._id,id:this._id}}}static is(N){return N instanceof s}getMapKey(){const N=this._source.config.workspaceFolder;return N?`${N.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===a.User?e.$NF:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const N=this.d();if(!N)return;let te=this.configurationProperties.identifier;this._source.kind!==a.Workspace&&(te+=this._source.kind);const Y={type:e.$QF,folder:N,id:te};return JSON.stringify(Y)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$rg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(N){return new s(N._id,N._source,N._label,N.type,N.command,N.hasDefinedMatchers,N.runOptions,N.configurationProperties)}}e.$SF=s;class i extends r{constructor(N,te,Y,ye,Ee,Pe,X){super(N,Y,ye,Pe,X,te),this._source=te,this.configures=Ee}static is(N){return N instanceof i}f(N){return N}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$rg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===a.User?e.$NF:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const N=this.d();if(!N)return;let te=this.configurationProperties.identifier;this._source.kind!==a.Workspace&&(te+=this._source.kind);const Y={type:e.$QF,folder:N,id:te};return JSON.stringify(Y)}}e.$TF=i;class o extends r{constructor(N,te,Y,ye,Ee,Pe,X,ae,Se){super(N,Y,ye,ae,Se,te),this.defines=Ee,this.hasDefinedMatchers=X,this.command=Pe,this.icon=Se.icon,this.hide=Se.hide}clone(){return new o(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(N){return N instanceof o}getMapKey(){const N=this._source.workspaceFolder;return N?`${this._source.scope.toString()}|${N.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const N={type:"contributed",scope:this._source.scope,id:this._id};return N.folder=this.d(),JSON.stringify(N)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(N){return new o(N._id,N._source,N._label,N.type,N.defines,N.command,N.hasDefinedMatchers,N.runOptions,N.configurationProperties)}}e.$UF=o;class y extends r{constructor(N,te,Y,ye,Ee,Pe){super(N,Y,ye,Ee,Pe,te),this._source=te}clone(){return new y(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(N){return N instanceof y}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(N){return new y(N._id,N._source,N._label,N.type,N.runOptions,N.configurationProperties)}}e.$VF=y;var d;(function(O){O[O.Process=1]="Process",O[O.Terminal=2]="Terminal"})(d||(e.ExecutionEngine=d={})),function(O){O._default=O.Terminal}(d||(e.ExecutionEngine=d={}));var I;(function(O){O[O.V0_1_0=1]="V0_1_0",O[O.V2_0_0=2]="V2_0_0"})(I||(e.JsonSchemaVersion=I={}));class S{constructor(N){this.c=new Map;for(let te=0;te<N.length;te++)this.c.set(N[te].uri.toString(),te)}compare(N,te){const Y=N.getWorkspaceFolder(),ye=te.getWorkspaceFolder();if(Y&&ye){let Ee=this.c.get(Y.uri.toString());Ee=Ee===void 0?0:Ee+1;let Pe=this.c.get(ye.uri.toString());return Pe=Pe===void 0?0:Pe+1,Ee===Pe?N._label.localeCompare(te._label):Ee-Pe}else return!Y&&ye?-1:Y&&!ye?1:0}}e.$WF=S;var u;(function(O){O.DependsOnStarted="dependsOnStarted",O.AcquiredInput="acquiredInput",O.Start="start",O.ProcessStarted="processStarted",O.Active="active",O.Inactive="inactive",O.Changed="changed",O.Terminated="terminated",O.ProcessEnded="processEnded",O.End="end"})(u||(e.TaskEventKind=u={}));var m;(function(O){O.SingleRun="singleRun",O.Background="background"})(m||(e.TaskRunType=m={}));var h;(function(O){O[O.System=0]="System",O[O.User=1]="User",O[O.FolderOpen=2]="FolderOpen",O[O.ConfigurationChange=3]="ConfigurationChange",O[O.Reconnect=4]="Reconnect"})(h||(e.TaskRunSource=h={}));var P;(function(O){function N(ae){return{taskId:ae._id,taskName:ae.configurationProperties.name,runType:ae.configurationProperties.isBackground?"background":"singleRun",group:ae.configurationProperties.group,__task:ae}}function te(ae,Se,ue){return{...N(ae),kind:"start",terminalId:Se,resolvedVariables:ue}}O.start=te;function Y(ae,Se,ue){return{...N(ae),kind:"processStarted",terminalId:Se,processId:ue}}O.processStarted=Y;function ye(ae,Se,ue){return{...N(ae),kind:"processEnded",terminalId:Se,exitCode:ue}}O.processEnded=ye;function Ee(ae,Se,ue){return{...N(ae),kind:"terminated",exitReason:ue,terminalId:Se}}O.terminated=Ee;function Pe(ae,Se,ue){return{...N(Se),kind:ae,terminalId:ue}}O.general=Pe;function X(){return{kind:"changed"}}O.changed=X})(P||(e.TaskEvent=P={}));var W;(function(O){function N(Y){const ye=Object.keys(Y).sort();let Ee="";for(const Pe of ye){let X=Y[Pe];X instanceof Object?X=N(X):typeof X=="string"&&(X=X.replace(/,/g,",,")),Ee+=Pe+","+X+","}return Ee}function te(Y){const Ee={_key:N(Y),type:Y.taskType};return Object.assign(Ee,Y),Ee}O.create=te})(W||(e.KeyedTaskIdentifier=W={}));var K;(function(O){O.AutoDetect="task.autoDetect",O.SaveBeforeRun="task.saveBeforeRun",O.ShowDecorations="task.showDecorations",O.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",O.SlowProviderWarning="task.slowProviderWarning",O.QuickOpenHistory="task.quickOpen.history",O.QuickOpenDetail="task.quickOpen.detail",O.QuickOpenSkip="task.quickOpen.skip",O.QuickOpenShowAll="task.quickOpen.showAll",O.AllowAutomaticTasks="task.allowAutomaticTasks",O.Reconnection="task.reconnection"})(K||(e.TaskSettingId=K={}));var U;(function(O){O.Tasks="tasks",O.SuppressTaskName="tasks.suppressTaskName",O.Windows="tasks.windows",O.Osx="tasks.osx",O.Linux="tasks.linux",O.ShowOutput="tasks.showOutput",O.IsShellCommand="tasks.isShellCommand",O.ServiceTestSetting="tasks.service.testSetting"})(U||(e.TasksSchemaProperties=U={}));var B;(function(O){function N(te,Y){const ye=l.$MF.get(te.type);if(ye===void 0){const ae=F.$2m(te);return delete ae._key,W.create(ae)}const Ee=Object.create(null);Ee.type=ye.taskType;const Pe=new Set;ye.required.forEach(ae=>Pe.add(ae));const X=ye.properties;for(const ae of Object.keys(X)){const Se=te[ae];if(Se!=null)Ee[ae]=Se;else if(Pe.has(ae)){const ue=X[ae];if(ue.default!==void 0)Ee[ae]=F.$2m(ue.default);else switch(ue.type){case"boolean":Ee[ae]=!1;break;case"number":case"integer":Ee[ae]=0;break;case"string":Ee[ae]="";break;default:Y.error(w.localize(2,null,JSON.stringify(te,void 0,0),ae));return}}}return W.create(Ee)}O.createTaskIdentifier=N})(B||(e.TaskDefinition=B={}))}),define(Re[215],Me([1,0,9]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f4b=e.$e4b=void 0;class M{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((A,l)=>{this.b=A,this.d=l,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(A){this.f||this.h||(this.f=!0,this.g=A,this.a&&this.b(A))}resolveErr(A){this.f||this.h||(this.h=!0,this.i=A,this.a?this.d(A):(0,w.$Z)(A))}then(A,l){return this.j().then(A,l)}catch(A){return this.j().then(void 0,A)}finally(A){return this.j().finally(A)}}e.$e4b=M;class C extends M{constructor(){super(),this.h=!0,this.i=new w.$4}}e.$f4b=C}),define(Re[46],Me([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kv=e.$jv=e.$iv=e.$hv=void 0;class w{static{this.count=0}constructor(k){this._proxyIdentifierBrand=void 0,this.sid=k,this.nid=++w.count}}e.$hv=w;const M=[];function C(l){const k=new w(l);return M[k.nid]=k,k}e.$iv=C;function F(l){return M[l].sid}e.$jv=F;class A{constructor(k){this.value=k}}e.$kv=A}),define(Re[3],Me([1,0,46]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aK=e.$_J=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$$J=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var M;(function(g){g[g.Default=0]="Default",g[g.InCenter=1]="InCenter",g[g.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",g[g.AtTop=3]="AtTop"})(M||(e.TextEditorRevealType=M={}));var C;(function(g){g[g.UnknownInput=0]="UnknownInput",g[g.TextInput=1]="TextInput",g[g.TextDiffInput=2]="TextDiffInput",g[g.TextMergeInput=3]="TextMergeInput",g[g.NotebookInput=4]="NotebookInput",g[g.NotebookDiffInput=5]="NotebookDiffInput",g[g.CustomEditorInput=6]="CustomEditorInput",g[g.WebviewEditorInput=7]="WebviewEditorInput",g[g.TerminalEditorInput=8]="TerminalEditorInput",g[g.InteractiveEditorInput=9]="InteractiveEditorInput"})(C||(e.TabInputKind=C={}));var F;(function(g){g[g.TAB_OPEN=0]="TAB_OPEN",g[g.TAB_CLOSE=1]="TAB_CLOSE",g[g.TAB_UPDATE=2]="TAB_UPDATE",g[g.TAB_MOVE=3]="TAB_MOVE"})(F||(e.TabModelOperationKind=F={}));var A;(function(g){g[g.Editable=0]="Editable",g[g.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var l;(function(g){g[g.Int8Array=1]="Int8Array",g[g.Uint8Array=2]="Uint8Array",g[g.Uint8ClampedArray=3]="Uint8ClampedArray",g[g.Int16Array=4]="Int16Array",g[g.Uint16Array=5]="Uint16Array",g[g.Int32Array=6]="Int32Array",g[g.Uint32Array=7]="Uint32Array",g[g.Float32Array=8]="Float32Array",g[g.Float64Array=9]="Float64Array",g[g.BigInt64Array=10]="BigInt64Array",g[g.BigUint64Array=11]="BigUint64Array"})(l||(e.WebviewMessageArrayBufferViewType=l={}));var k;(function(g){g[g.Text=1]="Text",g[g.Error=2]="Error",g[g.Rich=3]="Rich"})(k||(e.CellOutputKind=k={}));var f;(function(g){g[g.Default=0]="Default",g[g.InCenter=1]="InCenter",g[g.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",g[g.AtTop=3]="AtTop"})(f||(e.NotebookEditorRevealType=f={}));var R;(function(g){g[g.None=0]="None",g[g.Process=1]="Process",g[g.Output=2]="Output"})(R||(e.CandidatePortSource=R={}));class D{static{this.a=0}static mixin(t){return t._id=D.a++,t}}e.$$J=D;var c;(function(g){g.label="a",g.kind="b",g.detail="c",g.documentation="d",g.sortText="e",g.filterText="f",g.preselect="g",g.insertText="h",g.insertTextRules="i",g.range="j",g.commitCharacters="k",g.additionalTextEdits="l",g.kindModifier="m",g.commandIdent="n",g.commandId="o",g.commandArguments="p"})(c||(e.ISuggestDataDtoField=c={}));var p;(function(g){g.defaultRanges="a",g.completions="b",g.isIncomplete="c",g.duration="d"})(p||(e.ISuggestResultDtoField=p={}));var $;(function(g){g[g.Workspace=0]="Workspace",g[g.TextDocument=1]="TextDocument"})($||(e.ExtHostTestingResource=$={})),e.$_J={MainThreadAuthentication:(0,w.$iv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,w.$iv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,w.$iv)("MainThreadChatProvider"),MainThreadChatAgents:(0,w.$iv)("MainThreadChatAgents"),MainThreadChatVariables:(0,w.$iv)("MainThreadChatVariables"),MainThreadClipboard:(0,w.$iv)("MainThreadClipboard"),MainThreadCommands:(0,w.$iv)("MainThreadCommands"),MainThreadComments:(0,w.$iv)("MainThreadComments"),MainThreadConfiguration:(0,w.$iv)("MainThreadConfiguration"),MainThreadConsole:(0,w.$iv)("MainThreadConsole"),MainThreadDebugService:(0,w.$iv)("MainThreadDebugService"),MainThreadDecorations:(0,w.$iv)("MainThreadDecorations"),MainThreadDiagnostics:(0,w.$iv)("MainThreadDiagnostics"),MainThreadDialogs:(0,w.$iv)("MainThreadDiaglogs"),MainThreadDocuments:(0,w.$iv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,w.$iv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,w.$iv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,w.$iv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,w.$iv)("MainThreadEditorTabs"),MainThreadErrors:(0,w.$iv)("MainThreadErrors"),MainThreadTreeViews:(0,w.$iv)("MainThreadTreeViews"),MainThreadDownloadService:(0,w.$iv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,w.$iv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,w.$iv)("MainThreadLanguages"),MainThreadLogger:(0,w.$iv)("MainThreadLogger"),MainThreadMessageService:(0,w.$iv)("MainThreadMessageService"),MainThreadOutputService:(0,w.$iv)("MainThreadOutputService"),MainThreadProgress:(0,w.$iv)("MainThreadProgress"),MainThreadQuickDiff:(0,w.$iv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,w.$iv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,w.$iv)("MainThreadStatusBar"),MainThreadSecretState:(0,w.$iv)("MainThreadSecretState"),MainThreadStorage:(0,w.$iv)("MainThreadStorage"),MainThreadTelemetry:(0,w.$iv)("MainThreadTelemetry"),MainThreadTerminalService:(0,w.$iv)("MainThreadTerminalService"),MainThreadWebviews:(0,w.$iv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,w.$iv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,w.$iv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,w.$iv)("MainThreadCustomEditors"),MainThreadUrls:(0,w.$iv)("MainThreadUrls"),MainThreadUriOpeners:(0,w.$iv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,w.$iv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,w.$iv)("MainThreadWorkspace"),MainThreadFileSystem:(0,w.$iv)("MainThreadFileSystem"),MainThreadExtensionService:(0,w.$iv)("MainThreadExtensionService"),MainThreadSCM:(0,w.$iv)("MainThreadSCM"),MainThreadSearch:(0,w.$iv)("MainThreadSearch"),MainThreadShare:(0,w.$iv)("MainThreadShare"),MainThreadTask:(0,w.$iv)("MainThreadTask"),MainThreadWindow:(0,w.$iv)("MainThreadWindow"),MainThreadLabelService:(0,w.$iv)("MainThreadLabelService"),MainThreadNotebook:(0,w.$iv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,w.$iv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,w.$iv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,w.$iv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,w.$iv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,w.$iv)("MainThreadInteractive"),MainThreadChat:(0,w.$iv)("MainThreadChat"),MainThreadInlineChat:(0,w.$iv)("MainThreadInlineChatShape"),MainThreadTheming:(0,w.$iv)("MainThreadTheming"),MainThreadTunnelService:(0,w.$iv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,w.$iv)("MainThreadManagedSockets"),MainThreadTimeline:(0,w.$iv)("MainThreadTimeline"),MainThreadTesting:(0,w.$iv)("MainThreadTesting"),MainThreadLocalization:(0,w.$iv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,w.$iv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,w.$iv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,w.$iv)("MainThreadIssueReporter")},e.$aK={ExtHostCommands:(0,w.$iv)("ExtHostCommands"),ExtHostConfiguration:(0,w.$iv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,w.$iv)("ExtHostDiagnostics"),ExtHostDebugService:(0,w.$iv)("ExtHostDebugService"),ExtHostDecorations:(0,w.$iv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,w.$iv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,w.$iv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,w.$iv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,w.$iv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,w.$iv)("ExtHostEditors"),ExtHostTreeViews:(0,w.$iv)("ExtHostTreeViews"),ExtHostFileSystem:(0,w.$iv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,w.$iv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,w.$iv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,w.$iv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,w.$iv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,w.$iv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,w.$iv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,w.$iv)("ExtHostStatusBar"),ExtHostShare:(0,w.$iv)("ExtHostShare"),ExtHostExtensionService:(0,w.$iv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,w.$iv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,w.$iv)("ExtHostTerminalService"),ExtHostSCM:(0,w.$iv)("ExtHostSCM"),ExtHostSearch:(0,w.$iv)("ExtHostSearch"),ExtHostTask:(0,w.$iv)("ExtHostTask"),ExtHostWorkspace:(0,w.$iv)("ExtHostWorkspace"),ExtHostWindow:(0,w.$iv)("ExtHostWindow"),ExtHostWebviews:(0,w.$iv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,w.$iv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,w.$iv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,w.$iv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,w.$iv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,w.$iv)("ExtHostEditorTabs"),ExtHostProgress:(0,w.$iv)("ExtHostProgress"),ExtHostComments:(0,w.$iv)("ExtHostComments"),ExtHostSecretState:(0,w.$iv)("ExtHostSecretState"),ExtHostStorage:(0,w.$iv)("ExtHostStorage"),ExtHostUrls:(0,w.$iv)("ExtHostUrls"),ExtHostUriOpeners:(0,w.$iv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,w.$iv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,w.$iv)("ExtHostOutputService"),ExtHosLabelService:(0,w.$iv)("ExtHostLabelService"),ExtHostNotebook:(0,w.$iv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,w.$iv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,w.$iv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,w.$iv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,w.$iv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,w.$iv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,w.$iv)("ExtHostInteractive"),ExtHostInlineChat:(0,w.$iv)("ExtHostInlineChatShape"),ExtHostChat:(0,w.$iv)("ExtHostChat"),ExtHostChatAgents:(0,w.$iv)("ExtHostChatAgents"),ExtHostChatVariables:(0,w.$iv)("ExtHostChatVariables"),ExtHostChatProvider:(0,w.$iv)("ExtHostChatProvider"),ExtHostAiRelatedInformation:(0,w.$iv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,w.$iv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,w.$iv)("ExtHostTheming"),ExtHostTunnelService:(0,w.$iv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,w.$iv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,w.$iv)("ExtHostAuthentication"),ExtHostTimeline:(0,w.$iv)("ExtHostTimeline"),ExtHostTesting:(0,w.$iv)("ExtHostTesting"),ExtHostTelemetry:(0,w.$iv)("ExtHostTelemetry"),ExtHostLocalization:(0,w.$iv)("ExtHostLocalization"),ExtHostIssueReporter:(0,w.$iv)("ExtHostIssueReporter")}}),define(Re[216],Me([1,0,3,7]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mdc=void 0;class C{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(w.$_J.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,l,k){if(this.a.size===0)throw new Error("No related information providers registered");const f=this.a.get(A);if(!f)throw new Error("related information provider not found");return await f.provideRelatedInformation(l,k)??[]}getRelatedInformation(A,l,k){return this.c.$getAiRelatedInformation(l,k)}registerRelatedInformationProvider(A,l,k){const f=this.b;return this.b++,this.a.set(f,k),this.c.$registerAiRelatedInformationProvider(f,l),new M.$bK(()=>{this.c.$unregisterAiRelatedInformationProvider(f),this.a.delete(f)})}}e.$Mdc=C}),define(Re[80],Me([1,0,4,14,3,17]),function(be,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rbc=e.$Qbc=e.$Pbc=void 0,e.$Pbc=(0,w.$Nh)("IExtHostApiDeprecationService");let A=class{constructor(k,f){this.c=f,this.a=new Set,this.b=k.getProxy(C.$_J.MainThreadTelemetry)}report(k,f,R){const D=this.d(k,f);this.a.has(D)||(this.a.add(D),f.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${k}' is deprecated. ${R}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:f.identifier.value,apiId:k}))}d(k,f){return`${k}-${f.identifier.value}`}};e.$Qbc=A,e.$Qbc=A=qe([We(0,F.$aM),We(1,M.$8i)],A),e.$Rbc=Object.freeze(new class{report(l,k,f){}})}),define(Re[217],Me([1,0,5,3,7,20]),function(be,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ldc=void 0;class A{constructor(f){this.b=new Map,this.c=[],this.d=new w.$Md,this.onDidChangeSessions=this.d.event,this.f=new l,this.g=new l,this.a=f.getProxy(M.$_J.MainThreadAuthentication)}$setProviders(f){return this.c=f,Promise.resolve()}async getSession(f,R,D,c={}){const p=F.$2l.toKey(f.identifier),$=[...D].sort().join(" ");return await this.f.getOrCreate(`${p} ${R} ${$}`,async()=>{await this.a.$ensureProvider(R);const g=f.displayName||f.name;return this.a.$getSession(R,D,p,g,c)})}async getSessions(f,R,D){const c=F.$2l.toKey(f.identifier),p=[...D].sort().join(" ");return await this.g.getOrCreate(`${c} ${p}`,async()=>{await this.a.$ensureProvider(R);const $=f.displayName||f.name;return this.a.$getSessions(R,D,c,$)})}async removeSession(f,R){const D=this.b.get(f);return D?D.provider.removeSession(R):this.a.$removeSession(f,R)}registerAuthenticationProvider(f,R,D,c){if(this.b.get(f))throw new Error(`An authentication provider with id '${f}' is already registered.`);this.b.set(f,{label:R,provider:D,options:c??{supportsMultipleAccounts:!1}}),this.c.find($=>$.id===f)||this.c.push({id:f,label:R});const p=D.onDidChangeSessions($=>{this.a.$sendDidChangeSessions(f,{added:$.added??[],changed:$.changed??[],removed:$.removed??[]})});return this.a.$registerAuthenticationProvider(f,R,c?.supportsMultipleAccounts??!1),new C.$bK(()=>{p.dispose(),this.b.delete(f);const $=this.c.findIndex(g=>g.id===f);$>-1&&this.c.splice($),this.a.$unregisterAuthenticationProvider(f)})}$createSession(f,R,D){const c=this.b.get(f);if(c)return Promise.resolve(c.provider.createSession(R,D));throw new Error(`Unable to find authentication provider with handle: ${f}`)}$removeSession(f,R){const D=this.b.get(f);if(D)return Promise.resolve(D.provider.removeSession(R));throw new Error(`Unable to find authentication provider with handle: ${f}`)}$getSessions(f,R){const D=this.b.get(f);if(D)return Promise.resolve(D.provider.getSessions(R));throw new Error(`Unable to find authentication provider with handle: ${f}`)}$onDidChangeAuthenticationSessions(f,R){return this.d.fire({provider:{id:f,label:R}}),Promise.resolve()}}e.$ldc=A;class l{constructor(){this.a=new Map}getOrCreate(f,R){const D=this.a.get(f);if(D)return D;const c=R().finally(()=>this.a.delete(f));return this.a.set(f,c),c}}}),define(Re[218],Me([1,0,3,17,8]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rdc=void 0;let F=class{constructor(l,k){this.a=l.getProxy(w.$_J.MainThreadBulkEdits),this.b={getTextDocumentVersion:f=>k.getDocument(f)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(l,k,f){const R=C.WorkspaceEdit.from(l,this.b);return this.a.$tryApplyWorkspaceEdit(R,void 0,f?.isRefactoring??!1)}};e.$rdc=F,e.$rdc=F=qe([We(0,M.$aM)],F)}),define(Re[219],Me([1,0,12,5,65,6,58,146,3,8]),function(be,e,w,M,C,F,A,l,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fdc=void 0;class R{static{this.a=0}constructor(p,$){this.extension=p,this.provider=$,this.handle=R.a++}}class D{static{this.a=0}constructor(p,$){this.h=$,this.b=new Map,this.d=new Map,this.e=new M.$Md,this.onDidPerformUserAction=this.e.event,this.g=p.getProxy(k.$_J.MainThreadChat)}registerChatProvider(p,$,g){const t=new R(p,g);return this.b.set(t.handle,t),this.g.$registerChatProvider(t.handle,$),(0,F.$Pc)(()=>{this.g.$unregisterChatProvider(t.handle),this.b.delete(t.handle)})}transferChatSession(p,$){const g=C.Iterable.find(this.d.keys(),t=>this.d.get(t)===p)??0;typeof g=="number"&&this.g.$transferChatSession(g,$)}sendInteractiveRequestToProvider(p,$){this.g.$sendRequestToProvider(p,$)}async $prepareChat(p,$,g){const t=this.b.get(p);if(!t)return;const n=await t.provider.prepareSession($,g);if(!n)return;const a=D.a++;return this.d.set(a,n),{id:a,requesterUsername:n.requester?.name,requesterAvatarIconUri:n.requester?.icon,responderUsername:n.responder?.name,responderAvatarIconUri:n.responder?.icon,inputPlaceholder:n.inputPlaceholder}}async $provideWelcomeMessage(p,$){const g=this.b.get(p);if(!g||!g.provider.provideWelcomeMessage)return;const t=await g.provider.provideWelcomeMessage($);if(t)return t.map(n=>typeof n=="string"?n:n.map(a=>f.ChatReplyFollowup.from(a)))}async $provideFollowups(p,$,g){const t=this.b.get(p);if(!t)return;const n=this.d.get($);return!n||!t.provider.provideFollowups?void 0:(await t.provider.provideFollowups(n,g))?.map(b=>f.ChatFollowup.from(b))}$removeRequest(p,$,g){const t=this.b.get(p);if(!t)return;const n=this.d.get($);n&&t.provider.removeRequest&&t.provider.removeRequest(n,g)}async $provideReply(p,$,g,t){const n=this.b.get(p);if(!n)return;const a=this.d.get($);if(!a)return;const b={session:a,message:typeof g.message=="string"?g.message:f.ChatReplyFollowup.to(g.message),variables:{}};if(g.variables)for(const o of Object.keys(g.variables))b.variables[o]=g.variables[o].map(f.ChatVariable.to);const E=A.$Id.create(!1);let v;const r={report:o=>{if(t.isCancellationRequested)return;typeof v>"u"&&(v=E.elapsed());const y=f.ChatResponseProgress.from(o);if("placeholder"in o&&"resolvedContent"in o){const d=Promise.all([this.g.$acceptResponseProgress(p,$,y),o.resolvedContent]);(0,w.$Hg)(d,t).then(I=>{if(!I)return;const[S,u]=I;this.g.$acceptResponseProgress(p,$,u,S??void 0)})}else this.g.$acceptResponseProgress(p,$,y)}};let s;try{s=await n.provider.provideResponseWithProgress(b,r,t),s||(s={errorDetails:{message:(0,l.localize)(0,null)}})}catch(o){s={errorDetails:{message:(0,l.localize)(1,null,o.message),responseIsIncomplete:!0}},this.h.error(o)}try{if(a.saveState&&this.d.has($)){const o=a.saveState();this.g.$acceptChatState($,o)}}catch(o){this.h.warn(o)}const i={firstProgress:v??0,totalElapsed:E.elapsed()};return{errorDetails:s.errorDetails,timings:i}}async $provideSlashCommands(p,$,g){const t=this.b.get(p);if(!t)return;const n=this.d.get($);return!n||!t.provider.provideSlashCommands?void 0:(await t.provider.provideSlashCommands(n,g))?.map(b=>({...b,kind:f.CompletionItemKind.from(b.kind)}))}$releaseSession(p){this.d.delete(p)}async $onDidPerformUserAction(p){this.e.fire(p)}}e.$Fdc=D}),define(Re[220],Me([1,0,12,6,71,3,8,7]),function(be,e,w,M,C,F,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Odc=void 0;class k{static{this.a=0}constructor(D,c,p){this.d=c,this.e=p,this.b=new Map,this.c=D.getProxy(F.$_J.MainThreadChatAgents)}registerAgent(D,c,p,$){const g=k.a++;return this.b.set(g,{extension:D,agent:p}),this.c.$registerAgent(g,c,$),(0,M.$Pc)(()=>{this.c.$unregisterAgent(g),this.b.delete(g)})}async $invokeAgent(D,c,p,$,g){const t=this.b.get(D);if(!t){this.e.warn(`[CHAT](${D}) CANNOT invoke agent because the agent is not registered`);return}let n=!1;function a(){if(n)throw new Error("Only valid while executing the command")}const b=new w.$bh;g.onCancellationRequested(()=>b.complete()),setTimeout(()=>b.complete(),10*1e3),this.d.allowListExtensionWhile(t.extension,b.p);const E=t.agent({role:l.ChatMessageRole.User,content:p},{history:$.history.map(A.ChatMessage.to)},new C.$Zu(v=>{a(),this.c.$handleProgressChunk(c,{content:f(v.message)?v.message:v.message.value})}),g);try{return await(0,w.$Hg)(Promise.resolve(E).then(v=>{if(v&&"followUp"in v)return{followUp:v?.followUp?.map(s=>A.ChatFollowup.from(s))}}),g)}finally{n=!0,b.complete()}}}e.$Odc=k;function f(R){return!!R&&typeof R=="object"&&"treeData"in R}}),define(Re[221],Me([1,0,6,3,8,71,20]),function(be,e,w,M,C,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kdc=void 0;class l{static{this.a=1}constructor(f,R){this.d=R,this.c=new Map,this.e=new Map,this.f=new A.$4l,this.b=f.getProxy(M.$_J.MainThreadChatProvider)}registerProvider(f,R,D,c){const p=l.a++;return this.c.set(p,{extension:f,provider:D}),this.b.$registerProvider(p,R,{extension:f,displayName:c.name??f.value}),(0,w.$Pc)(()=>{this.b.$unregisterProvider(p),this.c.delete(p)})}async $provideChatResponse(f,R,D,c,p){const $=this.c.get(f);if(!$)return;const g=new F.$Zu(async t=>{if(p.isCancellationRequested){this.d.warn(`[CHAT](${$.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}await this.b.$handleProgressChunk(R,{index:t.index,part:t.part})},{async:!0});return $.provider.provideChatResponse(D.map(C.ChatMessage.to),c,g,p)}allowListExtensionWhile(f,R){this.f.set(f,R),R.finally(()=>this.f.delete(f))}async requestChatResponseProvider(f,R){if(!this.f.has(f))throw new Error("Extension is NOT allowed to make chat requests");const D=this;return{get isRevoked(){return!D.f.has(f)},async makeRequest(c,p,$,g){if(!D.f.has(f))throw new Error("Access to chat has been revoked");const t=Math.random()*1e6|0;D.e.set(t,$);try{await D.b.$fetchResponse(f,R,t,c.map(C.ChatMessage.from),p,g)}finally{D.e.delete(t)}}}}async $handleResponseFragment(f,R){this.e.get(f)?.report(R)}}e.$Kdc=l}),define(Re[222],Me([1,0,6,3,9,8]),function(be,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ldc=void 0;class A{static{this.a=0}constructor(k){this.b=new Map,this.c=k.getProxy(M.$_J.MainThreadChatVariables)}async $resolveVariable(k,f,R){const D=this.b.get(k);if(D)try{const c=await D.resolver.resolve(D.data.name,{message:f},R);if(c)return c.map(F.ChatVariable.from)}catch(c){(0,C.$1)(c)}}registerVariableResolver(k,f,R,D){const c=A.a++;return this.b.set(c,{extension:k.identifier,data:{name:f,description:R},resolver:D}),this.c.$registerVariable(c,{name:f,description:R}),(0,w.$Pc)(()=>{this.b.delete(c),this.c.$unregisterVariable(c)})}}e.$Ldc=A}),define(Re[223],Me([1,0,3]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ubc=void 0;class M{constructor(F){const A=F.getProxy(w.$_J.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(l){return A.$writeText(l)}})}}e.$Ubc=M}),define(Re[31],Me([1,0,16,7,8,24,3,18,14,67,44,278,2,6,4,17,104,26,46,41,58,53,57]),function(be,e,w,M,C,F,A,l,k,f,R,D,c,p,$,g,t,n,a,b,E,v,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AM=e.$zM=e.$yM=e.$xM=e.$wM=e.$vM=void 0;let s=class{#e;#t;#i;constructor(S,u,m){this.b=new Map,this.c=new Map,this.#e=S.getProxy(A.$_J.MainThreadCommands),this.d=u,this.#i=m,this.#t=S.getProxy(A.$_J.MainThreadTelemetry),this.converter=new i(this,h=>{const P=this.c.get(h);return P?.result===y.Void?P:void 0},u),this.f=[{processArgument(h){return(0,f.$kh)(h)}},{processArgument(h){return(0,F.$4m)(h,function(P){if(R.$os.isIRange(P))return C.Range.to(P);if(D.$ns.isIPosition(P))return C.Position.to(P);if(R.$os.isIRange(P.range)&&c.URI.isUri(P.uri))return C.location.to(P);if(P instanceof n.$ae)return P.buffer.buffer;if(!Array.isArray(P))return P})}}]}registerArgumentProcessor(S){this.f.push(S)}registerApiCommand(S){const u=this.registerCommand(!1,S.id,async(...m)=>{const h=S.args.map((W,K)=>{if(!W.validate(m[K]))throw new Error(`Invalid argument '${W.name}' when running '${S.id}', received: ${typeof m[K]=="object"?JSON.stringify(m[K],null,"	"):m[K]} `);return W.convert(m[K])}),P=await this.executeCommand(S.internalId,...h);return S.result.convert(P,m,this.converter)},void 0,{description:S.description,args:S.args,returns:S.result.description});return this.c.set(S.id,S),new M.$bK(()=>{u.dispose(),this.c.delete(S.id)})}registerCommand(S,u,m,h,P,W){if(this.d.trace("ExtHostCommands#registerCommand",u),!u.trim().length)throw new Error("invalid id");if(this.b.has(u))throw new Error(`command '${u}' already exists`);return this.b.set(u,{callback:m,thisArg:h,metadata:P,extension:W}),S&&this.#e.$registerCommand(u),new M.$bK(()=>{this.b.delete(u)&&S&&this.#e.$unregisterCommand(u)})}executeCommand(S,...u){return this.d.trace("ExtHostCommands#executeCommand",S),this.g(S,u,!0)}async g(S,u,m){if(this.b.has(S))return this.#e.$fireCommandActivationEvent(S),this.h(S,u,!1);{let h=!1;const P=(0,F.$4m)(u,function(W){if(W instanceof M.$cK)return C.Position.from(W);if(W instanceof M.$dK)return C.Range.from(W);if(W instanceof M.$nK)return C.location.from(W);if(M.$yL.isNotebookRange(W))return C.NotebookRange.from(W);if(W instanceof ArrayBuffer)return h=!0,n.$ae.wrap(new Uint8Array(W));if(W instanceof Uint8Array)return h=!0,n.$ae.wrap(W);if(W instanceof n.$ae)return h=!0,W;if(!Array.isArray(W))return W});try{const W=await this.#e.$executeCommand(S,h?new a.$kv(P):P,m);return(0,f.$kh)(W)}catch(W){if(W instanceof Error&&W.message==="$executeCommand:retry")return this.g(S,u,!1);throw W}}}async h(S,u,m){const h=this.b.get(S);if(!h)throw new Error("Unknown command");const{callback:P,thisArg:W,metadata:K}=h;if(K?.args)for(let B=0;B<K.args.length;B++)try{(0,w.$Of)(u[B],K.args[B].constraint)}catch{throw new Error(`Running the contributed command: '${S}' failed. Illegal argument '${K.args[B].name}' - ${K.args[B].description}`)}const U=E.$Id.create();try{return await P.apply(W,u)}catch(B){if(S===this.converter.delegatingCommandId){const O=this.converter.getActualCommand(...u);O&&(S=O.command)}if(this.d.error(B,S,h.extension?.identifier),!m)throw B;if(h.extension?.identifier){const O=this.#i.onExtensionError(h.extension.identifier,B);this.d.trace("forwarded error to extension?",O,h.extension?.identifier)}throw new class extends Error{constructor(){super((0,b.$yi)(B)),this.id=S,this.source=h.extension?.displayName??h.extension?.name}}}finally{this.j(h,S,U.elapsed())}}j(S,u,m){S.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:S.extension.identifier.value,id:new v.$fo(u),duration:m})}$executeContributedCommand(S,...u){this.d.trace("ExtHostCommands#$executeContributedCommand",S);const m=this.b.get(S);return m?(u=u.map(h=>this.f.reduce((P,W)=>W.processArgument(P,m.extension?.identifier),h)),this.h(S,u,!0)):Promise.reject(new Error(`Contributed command '${S}' does not exist.`))}getCommands(S=!1){return this.d.trace("ExtHostCommands#getCommands",S),this.#e.$getCommands().then(u=>(S&&(u=u.filter(m=>m[0]!=="_")),u))}$getContributedCommandMetadata(){const S=Object.create(null);for(const[u,m]of this.b){const{metadata:h}=m;h&&(S[u]=h)}return Promise.resolve(S)}};e.$vM=s,e.$vM=s=qe([We(0,g.$aM),We(1,k.$8i),We(2,r.$uM)],s),e.$wM=(0,$.$Nh)("IExtHostCommands");class i{constructor(S,u,m){this.d=S,this.f=u,this.g=m,this.delegatingCommandId=`__vsc${Date.now().toString(36)} `,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(S,u){if(!S)return;const m={$ident:void 0,id:S.command,title:S.title,tooltip:S.tooltip};if(!S.command)return m;const h=this.f(S.command);if(h)m.id=h.internalId,m.arguments=h.args.map((P,W)=>P.convert(S.arguments&&S.arguments[W]));else if((0,l.$Kb)(S.arguments)){const P=`${S.command} /${++this.c}`;this.b.set(P,S),u.add((0,p.$Pc)(()=>{this.b.delete(P),this.g.trace("CommandsConverter#DISPOSE",P)})),m.$ident=P,m.id=this.delegatingCommandId,m.arguments=[P],this.g.trace("CommandsConverter#CREATE",S.command,P)}return m}fromInternal(S){return typeof S.$ident=="string"?this.b.get(S.$ident):{command:S.id,title:S.title,arguments:S.arguments}}getActualCommand(...S){return this.b.get(S[0])}h(...S){const u=this.getActualCommand(...S);return this.g.trace("CommandsConverter#EXECUTE",S[0],u?u.command:"MISSING"),u?this.d.executeCommand(u.command,...u.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${S[0]}`)}}e.$xM=i;class o{static{this.Uri=new o("uri","Uri of a text document",S=>c.URI.isUri(S),S=>S)}static{this.Position=new o("position","A position in a text document",S=>M.$cK.isPosition(S),C.Position.from)}static{this.Range=new o("range","A range in a text document",S=>M.$dK.isRange(S),C.Range.from)}static{this.Selection=new o("selection","A selection in a text document",S=>M.$eK.isSelection(S),C.Selection.from)}static{this.Number=new o("number","",S=>typeof S=="number",S=>S)}static{this.String=new o("string","",S=>typeof S=="string",S=>S)}static{this.StringArray=o.Arr(o.String)}static Arr(S){return new o(`${S.name}_array`,`Array of ${S.name}, ${S.description}`,u=>Array.isArray(u)&&u.every(m=>S.validate(m)),u=>u.map(m=>S.convert(m)))}static{this.CallHierarchyItem=new o("item","A call hierarchy item",S=>S instanceof M.$xK,C.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new o("item","A type hierarchy item",S=>S instanceof M.$RL,C.TypeHierarchyItem.from)}static{this.TestItem=new o("testItem","A VS Code TestItem",S=>S instanceof t.$nM,C.TestItem.from)}constructor(S,u,m,h){this.name=S,this.description=u,this.validate=m,this.convert=h}optional(){return new o(this.name,`(optional) ${this.description}`,S=>S==null||this.validate(S),S=>S===void 0?void 0:S===null?null:this.convert(S))}with(S,u){return new o(S??this.name,u??this.description,this.validate,this.convert)}}e.$yM=o;class y{static{this.Void=new y("no result",S=>S)}constructor(S,u){this.description=S,this.convert=u}}e.$zM=y;class d{constructor(S,u,m,h,P){this.id=S,this.internalId=u,this.description=m,this.args=h,this.result=P}}e.$AM=d}),define(Re[224],Me([1,0,18,13,2,78,91,32,95,31,8,7]),function(be,e,w,M,C,F,A,l,k,f,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tbc=void 0;const c=[new f.$AM("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[f.$yM.Uri,f.$yM.Position],new f.$zM("A promise that resolves to an array of DocumentHighlight-instances.",$(R.DocumentHighlight.to))),new f.$AM("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[f.$yM.Uri],new f.$zM("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(t,n)=>{if((0,w.$Jb)(t))return;class a extends D.$sK{static to(E){const v=new a(E.name,R.SymbolKind.to(E.kind),E.containerName||"",new D.$nK(n[0],R.Range.to(E.range)));return v.detail=E.detail,v.range=v.location.range,v.selectionRange=R.Range.to(E.selectionRange),v.children=E.children?E.children.map(a.to):[],v}}return t.map(a.to)})),new f.$AM("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[f.$yM.Uri,new f.$yM("options","Formatting options",t=>!0,t=>t)],new f.$zM("A promise that resolves to an array of TextEdits.",$(R.TextEdit.to))),new f.$AM("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[f.$yM.Uri,f.$yM.Range,new f.$yM("options","Formatting options",t=>!0,t=>t)],new f.$zM("A promise that resolves to an array of TextEdits.",$(R.TextEdit.to))),new f.$AM("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[f.$yM.Uri,f.$yM.Position,new f.$yM("ch","Trigger character",t=>typeof t=="string",t=>t),new f.$yM("options","Formatting options",t=>!0,t=>t)],new f.$zM("A promise that resolves to an array of TextEdits.",$(R.TextEdit.to))),new f.$AM("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[f.$yM.Uri,f.$yM.Position],new f.$zM("A promise that resolves to an array of Location or LocationLink instances.",g)),new f.$AM("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[f.$yM.Uri,f.$yM.Position],new f.$zM("A promise that resolves to an array of Location or LocationLink instances.",g)),new f.$AM("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[f.$yM.Uri,f.$yM.Position],new f.$zM("A promise that resolves to an array of Location or LocationLink instances.",g)),new f.$AM("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[f.$yM.Uri,f.$yM.Position],new f.$zM("A promise that resolves to an array of Location or LocationLink instances.",g)),new f.$AM("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[f.$yM.Uri,f.$yM.Position],new f.$zM("A promise that resolves to an array of Location-instances.",$(R.location.to))),new f.$AM("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[f.$yM.Uri,f.$yM.Position],new f.$zM("A promise that resolves to an array of Hover-instances.",$(R.Hover.to))),new f.$AM("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[f.$yM.Uri,new f.$yM("position","A position in a text document",t=>Array.isArray(t)&&t.every(n=>D.$cK.isPosition(n)),t=>t.map(R.Position.from))],new f.$zM("A promise that resolves to an array of ranges.",t=>t.map(n=>{let a;for(const b of n.reverse())a=new D.$wK(R.Range.to(b),a);return a}))),new f.$AM("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[f.$yM.String.with("query","Search string")],new f.$zM("A promise that resolves to an array of SymbolInformation-instances.",t=>t.map(R.WorkspaceSymbol.to))),new f.$AM("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[f.$yM.Uri,f.$yM.Position],new f.$zM("A promise that resolves to an array of CallHierarchyItem-instances",t=>t.map(R.CallHierarchyItem.to))),new f.$AM("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[f.$yM.CallHierarchyItem],new f.$zM("A promise that resolves to an array of CallHierarchyIncomingCall-instances",t=>t.map(R.CallHierarchyIncomingCall.to))),new f.$AM("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[f.$yM.CallHierarchyItem],new f.$zM("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",t=>t.map(R.CallHierarchyOutgoingCall.to))),new f.$AM("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[f.$yM.Uri,f.$yM.Position],new f.$zM("A promise that resolves to a range and placeholder text.",t=>{if(t)return{range:R.Range.to(t.range),placeholder:t.text}})),new f.$AM("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[f.$yM.Uri,f.$yM.Position,f.$yM.String.with("newName","The new symbol name")],new f.$zM("A promise that resolves to a WorkspaceEdit.",t=>{if(t){if(t.rejectReason)throw new Error(t.rejectReason);return R.WorkspaceEdit.to(t)}})),new f.$AM("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[f.$yM.Uri,f.$yM.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new f.$zM("A promise that resolves to an array of DocumentLink-instances.",t=>t.map(R.DocumentLink.to))),new f.$AM("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[f.$yM.Uri],new f.$zM("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new D.$qL(t.tokenTypes,t.tokenModifiers)})),new f.$AM("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[f.$yM.Uri],new f.$zM("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const n=(0,A.$Q0)(t);if(n.type==="full")return new D.$sL(n.data,void 0)})),new f.$AM("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[f.$yM.Uri,f.$yM.Range.optional()],new f.$zM("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new D.$qL(t.tokenTypes,t.tokenModifiers)})),new f.$AM("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[f.$yM.Uri,f.$yM.Range],new f.$zM("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const n=(0,A.$Q0)(t);if(n.type==="full")return new D.$sL(n.data,void 0)})),new f.$AM("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[f.$yM.Uri,f.$yM.Position,f.$yM.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),f.$yM.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new f.$zM("A promise that resolves to a CompletionList-instance.",(t,n,a)=>{if(!t)return new D.$IK([]);const b=t.suggestions.map(E=>R.CompletionItem.to(E,a));return new D.$IK(b,t.incomplete)})),new f.$AM("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[f.$yM.Uri,f.$yM.Position,f.$yM.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new f.$zM("A promise that resolves to SignatureHelp.",t=>{if(t)return R.SignatureHelp.to(t)})),new f.$AM("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[f.$yM.Uri,f.$yM.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new f.$zM("A promise that resolves to an array of CodeLens-instances.",(t,n,a)=>$(b=>new D.$AK(R.Range.to(b.range),b.command&&a.fromInternal(b.command)))(t))),new f.$AM("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[f.$yM.Uri,new f.$yM("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",t=>D.$dK.isRange(t),t=>D.$eK.isSelection(t)?R.Selection.from(t):R.Range.from(t)),f.$yM.String.with("kind","Code action kind to return code actions for").optional(),f.$yM.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new f.$zM("A promise that resolves to an array of Command-instances.",(t,n,a)=>$(b=>{if(b._isSynthetic){if(!b.command)throw new Error("Synthetic code actions must have a command");return a.fromInternal(b.command)}else{const E=new D.$uK(b.title,b.kind?new D.$vK(b.kind):void 0);return b.edit&&(E.edit=R.WorkspaceEdit.to(b.edit)),b.command&&(E.command=a.fromInternal(b.command)),E.isPreferred=b.isPreferred,E}})(t))),new f.$AM("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[f.$yM.Uri],new f.$zM("A promise that resolves to an array of ColorInformation objects.",t=>t?t.map(n=>new D.$OK(R.Range.to(n.range),R.Color.to(n.color))):[])),new f.$AM("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new f.$yM("color","The color to show and insert",t=>t instanceof D.$NK,R.Color.from),new f.$yM("context","Context object with uri and range",t=>!0,t=>({uri:t.uri,range:R.Range.from(t.range)}))],new f.$zM("A promise that resolves to an array of ColorPresentation objects.",t=>t?t.map(R.ColorPresentation.to):[])),new f.$AM("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[f.$yM.Uri,f.$yM.Range],new f.$zM("A promise that resolves to an array of Inlay objects",(t,n,a)=>t.map(R.InlayHint.to.bind(void 0,a)))),new f.$AM("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[f.$yM.Uri],new f.$zM("A promise that resolves to an array of FoldingRange objects",(t,n)=>{if(t)return t.map(R.FoldingRange.to)})),new f.$AM("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new f.$zM("A promise that resolves to an array of NotebookContentProvider static info objects.",$(t=>({viewType:t.viewType,displayName:t.displayName,options:{transientOutputs:t.options.transientOutputs,transientCellMetadata:t.options.transientCellMetadata,transientDocumentMetadata:t.options.transientDocumentMetadata},filenamePattern:t.filenamePattern.map(n=>R.NotebookExclusiveDocumentPattern.to(n))})))),new f.$AM("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[f.$yM.Uri,f.$yM.Range,new f.$yM("context","An InlineValueContext",t=>t&&typeof t.frameId=="number"&&t.stoppedLocation instanceof D.$dK,t=>R.InlineValueContext.from(t))],new f.$zM("A promise that resolves to an array of InlineValue objects",t=>t.map(R.InlineValue.to))),new f.$AM("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new f.$yM("uriOrString","Uri-instance or string (only http/https)",t=>C.URI.isUri(t)||typeof t=="string"&&(0,k.$0T)(t,M.Schemas.http,M.Schemas.https),t=>t),new f.$yM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[R.ViewColumn.from(t),void 0]:[R.ViewColumn.from(t.viewColumn),R.TextEditorOpenOptions.from(t)])).optional(),f.$yM.String.with("label","").optional()],f.$zM.Void),new f.$AM("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[f.$yM.Uri.with("resource","Resource to open"),f.$yM.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new f.$yM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[R.ViewColumn.from(t),void 0]:[R.ViewColumn.from(t.viewColumn),R.TextEditorOpenOptions.from(t)])).optional()],f.$zM.Void),new f.$AM("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[f.$yM.Uri.with("left","Left-hand side resource of the diff editor"),f.$yM.Uri.with("right","Right-hand side resource of the diff editor"),f.$yM.String.with("title","Human readable title for the diff editor").optional(),new f.$yM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="object",t=>t&&[R.ViewColumn.from(t.viewColumn),R.TextEditorOpenOptions.from(t)]).optional()],f.$zM.Void),new f.$AM("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[f.$yM.Uri,f.$yM.Position],new f.$zM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(R.TypeHierarchyItem.to))),new f.$AM("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[f.$yM.TypeHierarchyItem],new f.$zM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(R.TypeHierarchyItem.to))),new f.$AM("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[f.$yM.TypeHierarchyItem],new f.$zM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(R.TypeHierarchyItem.to))),new f.$AM("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[f.$yM.TestItem],f.$zM.Void),new f.$AM("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[f.$yM.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],f.$zM.Void),new f.$AM("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[f.$yM.String.with("name","The context key name"),new f.$yM("value","The context key value",()=>!0,t=>t)],f.$zM.Void),new f.$AM("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[f.$yM.Uri,f.$yM.StringArray,new f.$yM("MappedEditsContext","Mapped Edits Context",t=>R.MappedEditsContext.is(t),t=>R.MappedEditsContext.from(t))],new f.$zM("A promise that resolves to a workspace edit or null",t=>t?R.WorkspaceEdit.to(t):null))];class p{static register(n){c.forEach(n.registerApiCommand,n),this.a(n)}static a(n){n.registerCommand(!1,"_validateWhenClauses",l.$Mi)}}e.$Tbc=p;function $(t){return n=>{if(Array.isArray(n))return n.map(t)}}function g(t){if(!Array.isArray(t))return;const n=[];for(const a of t)F.$_s(a)?n.push(R.DefinitionLink.to(a)):n.push(R.location.to(a));return n}}),define(Re[225],Me([1,0,12,64,5,6,2,78,20,8,7,3,25]),function(be,e,w,M,C,F,A,l,k,f,R,D,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vbc=void 0;function p($,g,t){const n=$.getProxy(D.$_J.MainThreadComments);class a{static{this.a=0}constructor(){this.b=new Map,this.c=new k.$4l,g.registerArgumentProcessor({processArgument:d=>{if(d&&d.$mid===6){const I=this.b.get(d.handle);return I?I.value:d}else if(d&&d.$mid===7){const I=this.b.get(d.commentControlHandle);if(!I)return d;const S=I.getCommentThread(d.commentThreadHandle);return S?S.value:d}else if(d&&(d.$mid===9||d.$mid===8)){const I=this.b.get(d.thread.commentControlHandle);if(!I)return d;const S=I.getCommentThread(d.thread.commentThreadHandle);return S?d.$mid===8?S.value:{thread:S.value,text:d.text}:d}else if(d&&d.$mid===10){const I=this.b.get(d.thread.commentControlHandle);if(!I)return d;const S=I.getCommentThread(d.thread.commentThreadHandle);if(!S)return d;const u=d.commentUniqueId,m=S.getCommentByUniqueId(u);return m||d}else if(d&&d.$mid===11){const I=this.b.get(d.thread.commentControlHandle);if(!I)return d;const S=I.getCommentThread(d.thread.commentThreadHandle);if(!S)return d;const u=d.text,m=d.commentUniqueId,h=S.getCommentByUniqueId(m);return h?(typeof h.body=="string"?h.body=u:h.body=new R.$BK(u),h):d}return d}})}createCommentController(d,I,S){const u=a.a++,m=new E(d,u,I,S);this.b.set(m.handle,m);const h=this.c.get(d.identifier)||[];return h.push(m),this.c.set(d.identifier,h),m.value}$createCommentThreadTemplate(d,I,S){const u=this.b.get(d);u&&u.$createCommentThreadTemplate(I,S)}async $updateCommentThreadTemplate(d,I,S){const u=this.b.get(d);u&&u.$updateCommentThreadTemplate(I,S)}$deleteCommentThread(d,I){this.b.get(d)?.$deleteCommentThread(I)}$provideCommentingRanges(d,I,S){const u=this.b.get(d);if(!u||!u.commentingRangeProvider)return Promise.resolve(void 0);const m=t.getDocument(A.URI.revive(I));return(0,w.$Lg)(async()=>{const h=await u.commentingRangeProvider.provideCommentingRanges(m,S);let P;return Array.isArray(h)?P={ranges:h,fileComments:!1}:h?P={ranges:h.ranges||[],fileComments:h.fileComments||!1}:P=h??void 0,P}).then(h=>{let P;return h&&(P={ranges:h.ranges.map(W=>f.Range.from(W)),fileComments:h.fileComments}),P})}$toggleReaction(d,I,S,u,m){const h=this.b.get(d);return!h||!h.reactionHandler?Promise.resolve(void 0):(0,w.$Lg)(()=>{const P=h.getCommentThread(I);if(P){const W=P.getCommentByUniqueId(u.uniqueIdInThread);if(h!==void 0&&W&&h.reactionHandler)return h.reactionHandler(W,s(m))}return Promise.resolve(void 0)})}}class b{static{this.a=0}set threadId(d){this.n=d}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(d){(d===void 0!=(this.p===void 0)||!d||!this.p||!d.isEqual(this.p))&&(this.p=d,this.b.range=d,this.c.fire())}get range(){return this.p}set canReply(d){this.d!==d&&(this.d=d,this.b.canReply=d,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(d){this.e=d,this.b.label=d,this.c.fire()}get contextValue(){return this.f}set contextValue(d){this.f=d,this.b.contextValue=d,this.c.fire()}get comments(){return this.q}set comments(d){this.q=d,this.b.comments=d,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(d){this.g=d,this.b.collapsibleState=d,this.c.fire()}get state(){return this.h}set state(d){this.h=d,this.b.state=d,this.c.fire()}get isDisposed(){return this.j}constructor(d,I,S,u,m,h,P,W){this.m=I,this.n=S,this.o=u,this.p=m,this.q=h,this.extensionDescription=P,this.r=W,this.handle=b.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new C.$Md,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new F.$Sc,this.l.value=new F.$Qc,this.n===void 0&&(this.n=`${d}.${this.handle}`),n.$createCommentThread(I,this.handle,this.n,this.o,f.Range.from(this.p),P.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=h,this.i.push({dispose:()=>{n.$deleteCommentThread(I,this.handle)}});const K=this;this.value={get uri(){return K.uri},get range(){return K.range},set range(U){K.range=U},get comments(){return K.comments},set comments(U){K.comments=U},get collapsibleState(){return K.collapsibleState},set collapsibleState(U){K.collapsibleState=U},get canReply(){return K.canReply},set canReply(U){K.canReply=U},get contextValue(){return K.contextValue},set contextValue(U){K.contextValue=U},get label(){return K.label},set label(U){K.label=U},get state(){return K.state},set state(U){K.state=U},dispose:()=>{K.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new F.$Qc);const d=S=>Object.prototype.hasOwnProperty.call(this.b,S),I={};d("range")&&(I.range=f.Range.from(this.p)),d("label")&&(I.label=this.label),d("contextValue")&&(I.contextValue=this.contextValue??null),d("comments")&&(I.comments=this.q.map(S=>v(this,S,this.k,this.extensionDescription))),d("collapsibleState")&&(I.collapseState=i(this.g)),d("canReply")&&(I.canReply=this.canReply),d("state")&&(I.state=o(this.h)),d("isTemplate")&&(I.isTemplate=this.r),this.b={},n.$updateCommentThread(this.m,this.handle,this.n,this.o,I)}getCommentByUniqueId(d){for(const I of this.k){const S=I[0],u=I[1];if(d===u)return S}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(d=>d.dispose())}}qe([(0,M.$gh)(100)],b.prototype,"eventuallyUpdateCommentThread",null);class E{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(d){this.b=d,n.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(d){this.c=d,n.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!d})}get options(){return this.d}set options(d){this.d=d,n.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(d,I,S,u){this.f=d,this.g=I,this.h=S,this.i=u,this.a=new Map,n.$registerCommentController(this.handle,S,u,this.f.identifier.value);const m=this;this.value=Object.freeze({id:m.id,label:m.label,get options(){return m.options},set options(h){m.options=h},get commentingRangeProvider(){return m.commentingRangeProvider},set commentingRangeProvider(h){m.commentingRangeProvider=h},get reactionHandler(){return m.reactionHandler},set reactionHandler(h){m.reactionHandler=h},createCommentThread(h,P,W){return m.createCommentThread(h,P,W).value},dispose:()=>{m.dispose()}}),this.e=[],this.e.push({dispose:()=>{n.$unregisterCommentController(this.handle)}})}createCommentThread(d,I,S){I===void 0&&(0,c.$_E)(this.f,"fileComments");const u=new b(this.id,this.handle,void 0,d,I,S,this.f,!1);return this.a.set(u.handle,u),u}$createCommentThreadTemplate(d,I){const S=new b(this.id,this.handle,void 0,A.URI.revive(d),f.Range.to(I),[],this.f,!0);return S.collapsibleState=l.CommentThreadCollapsibleState.Expanded,this.a.set(S.handle,S),S}$updateCommentThreadTemplate(d,I){const S=this.a.get(d);S&&(S.range=f.Range.to(I))}$deleteCommentThread(d){this.a.get(d)?.dispose(),this.a.delete(d)}getCommentThread(d){return this.a.get(d)}dispose(){this.a.forEach(d=>{d.dispose()}),this.e.forEach(d=>d.dispose())}}function v(y,d,I,S){let u=I.get(d);return u||(u=++y.commentHandle,I.set(d,u)),d.state!==void 0&&(0,c.$_E)(S,"commentsDraftState"),{mode:d.mode,contextValue:d.contextValue,uniqueIdInThread:u,body:typeof d.body=="string"?d.body:f.MarkdownString.from(d.body),userName:d.author.name,userIconPath:d.author.iconPath,label:d.label,commentReactions:d.reactions?d.reactions.map(m=>r(m)):void 0,state:d.state,timestamp:d.timestamp?.toJSON()}}function r(y){return{label:y.label,iconPath:y.iconPath?f.$_L(y.iconPath):void 0,count:y.count,hasReacted:y.authorHasReacted}}function s(y){return{label:y.label||"",count:y.count||0,iconPath:y.iconPath?A.URI.revive(y.iconPath):"",authorHasReacted:y.hasReacted||!1}}function i(y){if(y!==void 0)switch(y){case R.CommentThreadCollapsibleState.Expanded:return l.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return l.CommentThreadCollapsibleState.Collapsed}return l.CommentThreadCollapsibleState.Collapsed}function o(y){if(y!==void 0)switch(y){case R.CommentThreadState.Unresolved:return l.CommentThreadState.Unresolved;case R.CommentThreadState.Resolved:return l.CommentThreadState.Resolved}return l.CommentThreadState.Unresolved}return new a}e.$Vbc=p}),define(Re[226],Me([1,0,24,3,27,17]),function(be,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rdc=void 0;let A=class{constructor(R,D){this.a=R.getProxy(M.$_J.MainThreadConsole),this.b=D.consoleForward.includeStack,this.c=D.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(R,D){const c=this,p=console[R];Object.defineProperty(console,R,{set:()=>{},get:()=>function(){c.e(R,D,p,arguments)}})}e(R,D,c,p){this.a.$logExtensionHostMessage({type:"__$console",severity:D,arguments:k(p,this.b)}),this.c&&this.f(R,c,p)}};e.$Rdc=A,e.$Rdc=A=qe([We(0,F.$aM),We(1,C.$qM)],A);const l=1e5;function k(f,R){const D=[];if(f.length)for(let c=0;c<f.length;c++){let p=f[c];if(typeof p>"u")p="undefined";else if(p instanceof Error){const $=p;$.stack?p=$.stack:p=$.toString()}D.push(p)}if(R){const c=new Error().stack;c&&D.push({__$stack:c.split(`
`).slice(3).join(`
`)})}try{const c=(0,w.$7m)(D);return c.length>l?"Output omitted for a large object that exceeds the limits":c}catch(c){return`Output omitted for an object that cannot be inspected ('${c.toString()}')`}}}),define(Re[107],Me([1,0,2,3,7,4,17,14,18,15,19,25]),function(be,e,w,M,C,F,A,l,k,f,R,D){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$Xcc=e.$Wcc=void 0;let p=class{static{c=this}static{this.c=0}static{this.d=250}constructor(g,t){this.h=t,this.f=new Map,this.g=g.getProxy(M.$_J.MainThreadDecorations)}registerFileDecorationProvider(g,t){const n=c.c++;this.f.set(n,{provider:g,extensionDescription:t}),this.g.$registerDecorationProvider(n,t.identifier.value);const a=g.onDidChangeFileDecorations&&g.onDidChangeFileDecorations(b=>{if(!b){this.g.$onDidChange(n,null);return}const E=(0,k.$2b)(b);if(E.length<=c.d){this.g.$onDidChange(n,E);return}this.h.warn("[Decorations] CAPPING events from decorations provider",t.identifier.value,E.length);const v=E.map(i=>({uri:i,rank:(0,f.$Fe)(i.path,"/")})),r=(0,k.$yb)(v,(i,o)=>i.rank-o.rank||(0,f.$Te)(i.uri.path,o.uri.path)),s=[];e:for(const i of r){let o;for(const y of i){const d=(0,R.$lc)(y.uri.path);if(o!==d&&(o=d,s.push(y.uri)>=c.d))break e}}this.g.$onDidChange(n,s)});return new C.$bK(()=>{a?.dispose(),this.g.$unregisterDecorationProvider(n),this.f.delete(n)})}async $provideDecorations(g,t,n){if(!this.f.has(g))return Object.create(null);const a=Object.create(null),{provider:b,extensionDescription:E}=this.f.get(g);return await Promise.all(t.map(async v=>{try{const{uri:r,id:s}=v,i=await Promise.resolve(b.provideFileDecoration(w.URI.revive(r),n));if(!i)return;try{C.$wL.validate(i),i.badge&&typeof i.badge!="string"&&(0,D.$_E)(E,"codiconDecoration"),a[s]=[i.propagate,i.tooltip,i.badge,i.color]}catch(o){this.h.warn(`INVALID decoration from extension '${E.identifier.value}': ${o}`)}}catch(r){this.h.error(r)}})),a}};e.$Wcc=p,e.$Wcc=p=c=qe([We(0,A.$aM),We(1,l.$8i)],p),e.$Xcc=(0,F.$Nh)("IExtHostDecorations")}),define(Re[227],Me([1,0,147,94,2,3,7,8,5,14,28,39]),function(be,e,w,M,C,F,A,l,k,f,R,D){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$Obc=e.$Nbc=void 0;class p{#e;#t;#i;constructor(t,n,a,b,E,v,r,s){this.d=t,this.e=n,this.f=a,this.g=b,this.h=E,this.c=!1,this.f=Math.max(b,a),this.#i=new R.$zc(i=>v.getComparisonKey(i)),this.#e=r,this.#t=s}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(t,n){if(!t){this.clear();return}this.j();let a=[];if(C.URI.isUri(t)){if(!n){this.delete(t);return}this.#i.set(t,n.slice()),a=[t]}else if(Array.isArray(t)){a=[];let v;t=[...t].sort(p.k);for(const r of t){const[s,i]=r;if((!v||s.toString()!==v.toString())&&(v&&this.#i.get(v).length===0&&this.#i.delete(v),v=s,a.push(s),this.#i.set(s,[])),i)this.#i.get(s)?.push(...i);else{const o=this.#i.get(s);o&&(o.length=0)}}}if(this.#t.fire(a),!this.#e)return;const b=[];let E=0;for(const v of a){let r=[];const s=this.#i.get(v);if(s)if(s.length>this.g){r=[];const i=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let o=0;o<4;o++)for(const y of s)if(y.severity===i[o]&&r.push({...l.Diagnostic.from(y),modelVersionId:this.h(v)})===this.g)break e;r.push({severity:M.MarkerSeverity.Info,message:(0,w.localize)(0,null,s.length-this.g),startLineNumber:r[r.length-1].startLineNumber,startColumn:r[r.length-1].startColumn,endLineNumber:r[r.length-1].endLineNumber,endColumn:r[r.length-1].endColumn})}else r=s.map(i=>({...l.Diagnostic.from(i),modelVersionId:this.h(v)}));if(b.push([v,r]),E+=r.length,E>this.f)break}this.#e.$changeMany(this.e,b)}delete(t){this.j(),this.#t.fire([t]),this.#i.delete(t),this.#e?.$changeMany(this.e,[[t,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(t,n){this.j();for(const[a,b]of this)t.call(n,a,b,this)}*[Symbol.iterator](){this.j();for(const t of this.#i.keys())yield[t,this.get(t)]}get(t){this.j();const n=this.#i.get(t);return Array.isArray(n)?Object.freeze(n.slice(0)):[]}has(t){return this.j(),Array.isArray(this.#i.get(t))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(t,n){return t[0].toString()<n[0].toString()?-1:t[0].toString()>n[0].toString()?1:0}}e.$Nbc=p;let $=class{static{c=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*c.d}static _mapper(t){const n=new R.$zc;for(const a of t)n.set(a,a);return{uris:Object.freeze(Array.from(n.values()))}}constructor(t,n,a,b){this.j=n,this.k=a,this.l=b,this.g=new Map,this.h=new k.$Qd({merge:E=>E.flat(),delay:50}),this.onDidChangeDiagnostics=k.Event.map(this.h.event,c._mapper),this.f=t.getProxy(F.$_J.MainThreadDiagnostics)}createDiagnosticCollection(t,n){const{g:a,f:b,h:E,j:v,k:r,l:s}=this,i=new class{$changeMany(d,I){b.$changeMany(d,I),v.trace("[DiagnosticCollection] change many (extension, owner, uris)",t.value,d,I.length===0?"CLEARING":I)}$clear(d){b.$clear(d),v.trace("[DiagnosticCollection] remove all (extension, owner)",t.value,d)}dispose(){b.dispose()}};let o;if(!n)n="_generated_diagnostic_collection_name_#"+c.c++,o=n;else if(!a.has(n))o=n;else{this.j.warn(`DiagnosticCollection with name '${n}' does already exist.`);do o=n+c.c++;while(a.has(o))}return new class extends p{constructor(){super(n,o,c.e,c.d,d=>s.getDocument(d)?.version,r.extUri,i,E),a.set(o,this)}dispose(){super.dispose(),a.delete(o)}}}getDiagnostics(t){if(t)return this.m(t);{const n=new Map,a=[];for(const b of this.g.values())b.forEach((E,v)=>{let r=n.get(E.toString());typeof r>"u"&&(r=a.length,n.set(E.toString(),r),a.push([E,[]])),a[r][1]=a[r][1].concat(...v)});return a}}m(t){let n=[];for(const a of this.g.values())a.has(t)&&(n=n.concat(a.get(t)));return n}$acceptMarkersChange(t){if(!this.n){const n="_generated_mirror",a=new p(n,n,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,b=>{},this.k.extUri,void 0,this.h);this.g.set(n,a),this.n=a}for(const[n,a]of t)this.n.set(C.URI.revive(n),a.map(l.Diagnostic.to))}};e.$Obc=$,e.$Obc=$=c=qe([We(1,f.$8i),We(2,D.$Mbc)],$)}),define(Re[228],Me([1,0,2,3,25]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4bc=void 0;class F{constructor(l){this.a=l.getProxy(M.$_J.MainThreadDialogs)}showOpenDialog(l,k){return k?.allowUIResources&&(0,C.$_E)(l,"showLocal"),this.a.$showOpenDialog(k).then(f=>f?f.map(R=>w.URI.revive(R)):void 0)}showSaveDialog(l){return this.a.$showSaveDialog(l).then(k=>k?w.URI.revive(k):void 0)}}e.$4bc=F}),define(Re[229],Me([1,0,9,2,7,3,13,21,15]),function(be,e,w,M,C,F,A,l,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5bc=void 0;class f{static{this.a=0}constructor(D,c,p){this.d=c,this.e=p,this.b=new Map,this.c=D.getProxy(F.$_J.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(D,c){if(Object.keys(A.Schemas).indexOf(D)>=0)throw new Error(`scheme '${D}' already registered`);const p=f.a++;this.b.set(p,c),this.c.$registerTextContentProvider(p,D);let $;return typeof c.onDidChange=="function"&&($=c.onDidChange(g=>{if(g.scheme!==D){this.e.warn(`Provider for scheme '${D}' is firing event for schema '${g.scheme}' which will be IGNORED`);return}this.d.getDocument(g)&&this.$provideTextDocumentContent(p,g).then(t=>{if(!t&&typeof t!="string")return;const n=this.d.getDocument(g);if(!n)return;const a=(0,k.$Oe)(t);if(!n.equalLines(a))return this.c.$onVirtualDocumentChange(g,t)},w.$Z)})),new C.$bK(()=>{this.b.delete(p)&&this.c.$unregisterTextContentProvider(p),$&&($.dispose(),$=void 0)})}$provideTextDocumentContent(D,c){const p=this.b.get(D);return p?Promise.resolve(p.provideTextDocumentContent(M.URI.revive(c),l.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${c.scheme}`))}}e.$5bc=f}),define(Re[230],Me([1,0,5,6,2,3,100,8,16,24,7,9]),function(be,e,w,M,C,F,A,l,k,f,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kbc=void 0;class c{constructor($,g){this.a=new w.$Md({onListenerError:D.$1}),this.b=new w.$Md({onListenerError:D.$1}),this.c=new w.$Md({onListenerError:D.$1}),this.d=new w.$Md({onListenerError:D.$1}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new M.$Qc,this.h=new Map,this.f=$.getProxy(F.$_J.MainThreadDocuments),this.g=g,this.g.onDidRemoveDocuments(t=>{for(const n of t)this.b.fire(n.document)},void 0,this.e),this.g.onDidAddDocuments(t=>{for(const n of t)this.a.fire(n.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData($){if(!$)return;const g=this.g.getDocument($);if(g)return g}getDocument($){const g=this.getDocumentData($);if(!g?.document)throw new Error(`Unable to retrieve document from URI '${$}'`);return g.document}ensureDocumentData($){const g=this.g.getDocument($);if(g)return Promise.resolve(g);let t=this.h.get($.toString());return t||(t=this.f.$tryOpenDocument($).then(n=>{this.h.delete($.toString());const a=C.URI.revive(n);return(0,k.$If)(this.g.getDocument(a))},n=>(this.h.delete($.toString()),Promise.reject(n))),this.h.set($.toString(),t)),t}createDocumentData($){return this.f.$tryCreateDocument($).then(g=>C.URI.revive(g))}$acceptModelLanguageChanged($,g){const t=C.URI.revive($),n=this.g.getDocument(t);if(!n)throw new Error("unknown document");this.b.fire(n.document),n._acceptLanguageId(g),this.a.fire(n.document)}$acceptModelSaved($){const g=C.URI.revive($),t=this.g.getDocument(g);if(!t)throw new Error("unknown document");this.$acceptDirtyStateChanged($,!1),this.d.fire(t.document)}$acceptDirtyStateChanged($,g){const t=C.URI.revive($),n=this.g.getDocument(t);if(!n)throw new Error("unknown document");n._acceptIsDirty(g),this.c.fire({document:n.document,contentChanges:[],reason:void 0})}$acceptModelChanged($,g,t){const n=C.URI.revive($),a=this.g.getDocument(n);if(!a)throw new Error("unknown document");a._acceptIsDirty(t),a.onEvents(g);let b;g.isUndoing?b=R.TextDocumentChangeReason.Undo:g.isRedoing&&(b=R.TextDocumentChangeReason.Redo),this.c.fire((0,f.$3m)({document:a.document,contentChanges:g.changes.map(E=>({range:l.Range.to(E.range),rangeOffset:E.rangeOffset,rangeLength:E.rangeLength,text:E.text})),reason:b}))}setWordDefinitionFor($,g){(0,A.$cM)($,g)}}e.$Kbc=c}),define(Re[59],Me([1,0,51,5,6,2,4,3,100,17,105,8,14,28,13,65,48]),function(be,e,w,M,C,F,A,l,k,f,R,D,c,p,$,g,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lM=e.$kM=void 0;class n{constructor(E){this.value=E,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let a=class{constructor(E,v){this.h=E,this.i=v,this.a=null,this.b=new Map,this.c=new p.$zc,this.d=new M.$Md,this.e=new M.$Md,this.f=new M.$Md,this.g=new M.$Md,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(E){this.acceptDocumentsAndEditorsDelta(E)}acceptDocumentsAndEditorsDelta(E){const v=[],r=[],s=[];if(E.removedDocuments)for(const i of E.removedDocuments){const o=F.URI.revive(i),y=this.c.get(o);y?.unref()&&(this.c.delete(o),v.push(y.value))}if(E.addedDocuments)for(const i of E.addedDocuments){const o=F.URI.revive(i.uri);let y=this.c.get(o);if(y&&o.scheme!==$.Schemas.vscodeNotebookCell&&o.scheme!==$.Schemas.vscodeInteractiveInput)throw new Error(`document '${o} already exists!'`);y||(y=new n(new k.$dM(this.h.getProxy(l.$_J.MainThreadDocuments),o,i.lines,i.EOL,i.versionId,i.languageId,i.isDirty,i.notebook)),this.c.set(o,y),r.push(y.value)),y.ref()}if(E.removedEditors)for(const i of E.removedEditors){const o=this.b.get(i);this.b.delete(i),o&&s.push(o)}if(E.addedEditors)for(const i of E.addedEditors){const o=F.URI.revive(i.documentUri);w.ok(this.c.has(o),`document '${o}' does not exist`),w.ok(!this.b.has(i.id),`editor '${i.id}' already exists!`);const y=this.c.get(o).value,d=new R.$jM(i.id,this.h.getProxy(l.$_J.MainThreadTextEditors),this.i,new t.$U(()=>y.document),i.selections.map(D.Selection.to),i.options,i.visibleRanges.map(I=>D.Range.to(I)),typeof i.editorPosition=="number"?D.ViewColumn.to(i.editorPosition):void 0);this.b.set(i.id,d)}E.newActiveEditor!==void 0&&(w.ok(E.newActiveEditor===null||this.b.has(E.newActiveEditor),`active editor '${E.newActiveEditor}' does not exist`),this.a=E.newActiveEditor),(0,C.$Mc)(v),(0,C.$Mc)(s),E.removedDocuments&&this.e.fire(v),E.addedDocuments&&this.d.fire(r),(E.removedEditors||E.addedEditors)&&this.f.fire(this.allEditors().map(i=>i.value)),E.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(E){return this.c.get(E)?.value}allDocuments(){return g.Iterable.map(this.c.values(),E=>E.value)}getEditor(E){return this.b.get(E)}activeEditor(E){if(!this.a)return;const v=this.b.get(this.a);return E?v:v?.value}allEditors(){return[...this.b.values()]}};e.$kM=a,e.$kM=a=qe([We(0,f.$aM),We(1,c.$8i)],a),e.$lM=(0,A.$Nh)("IExtHostDocumentsAndEditors")}),define(Re[60],Me([1,0,8,3,2,5,4,7,17,16,231]),function(be,e,w,M,C,F,A,l,k,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3cc=e.$2cc=void 0,e.$2cc=(0,A.$Nh)("IExtHostEditorTabs");class D{constructor(t,n,a){this.e=a,this.d=n,this.acceptDtoUpdate(t)}get apiObject(){if(!this.a){const t=this,n={get isActive(){return t.b.id===t.e()},get label(){return t.b.label},get input(){return t.c},get isDirty(){return t.b.isDirty},get isPinned(){return t.b.isPinned},get isPreview(){return t.b.isPreview},get group(){return t.d.apiObject}};this.a=Object.freeze(n)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(t){this.b=t,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new l.$SL(C.URI.revive(this.b.input.uri));case 2:return new l.$TL(C.URI.revive(this.b.input.original),C.URI.revive(this.b.input.modified));case 3:return new l.$UL(C.URI.revive(this.b.input.base),C.URI.revive(this.b.input.input1),C.URI.revive(this.b.input.input2),C.URI.revive(this.b.input.result));case 6:return new l.$VL(C.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new l.$WL(this.b.input.viewType);case 4:return new l.$XL(C.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new l.$YL(C.URI.revive(this.b.input.original),C.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new l.$ZL;case 9:return new l.$1L(C.URI.revive(this.b.input.uri),C.URI.revive(this.b.input.inputBoxUri));default:return}}}class c{constructor(t,n){this.c=[],this.d="",this.b=t,this.e=n;for(const a of t.tabs)a.isActive&&(this.d=a.id),this.c.push(new D(a,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const t=this,n={get isActive(){return t.b.groupId===t.e()},get viewColumn(){return w.ViewColumn.to(t.b.viewColumn)},get activeTab(){return t.c.find(a=>a.tabId===t.d)?.apiObject},get tabs(){return Object.freeze(t.c.map(a=>a.apiObject))}};this.a=Object.freeze(n)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(t){this.b=t}acceptTabOperation(t){if(t.kind===0){const a=new D(t.tabDto,this,()=>this.activeTabId());return this.c.splice(t.index,0,a),t.tabDto.isActive&&(this.d=a.tabId),a}else if(t.kind===1){const a=this.c.splice(t.index,1)[0];if(!a)throw new Error(`Tab close updated received for index ${t.index} which does not exist`);return a.tabId===this.d&&(this.d=""),a}else if(t.kind===3){if(t.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const a=this.c.splice(t.oldIndex,1)[0];if(!a)throw new Error(`Tab move updated received for index ${t.oldIndex} which does not exist`);return this.c.splice(t.index,0,a),a}const n=this.c.find(a=>a.tabId===t.tabDto.id);if(!n)throw new Error("INVALID tab");return t.tabDto.isActive?this.d=t.tabDto.id:this.d===t.tabDto.id&&!t.tabDto.isActive&&(this.d=""),n.acceptDtoUpdate(t.tabDto),n}activeTabId(){return this.d}}let p=class{constructor(t){this.b=new F.$Md,this.c=new F.$Md,this.e=[],this.a=t.getProxy(M.$_J.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const t=this,n={onDidChangeTabGroups:t.c.event,onDidChangeTabs:t.b.event,get all(){return Object.freeze(t.e.map(a=>a.apiObject))},get activeTabGroup(){const a=t.d;return(0,f.$If)(t.e.find(E=>E.groupId===a)?.apiObject)},close:async(a,b)=>{const E=Array.isArray(a)?a:[a];return E.length?$(E[0])?this.j(E,b):this.i(E,b):!0}};this.f=Object.freeze(n)}return this.f}$acceptEditorTabModel(t){const n=new Set(this.e.map(i=>i.groupId)),a=new Set(t.map(i=>i.groupId)),b=(0,R.$K)(n,a),E=this.e.filter(i=>b.removed.includes(i.groupId)).map(i=>i.apiObject),v=[],r=[];this.e=t.map(i=>{const o=new c(i,()=>this.d);return b.added.includes(o.groupId)?v.push(o.apiObject):r.push(o.apiObject),o});const s=(0,f.$If)(t.find(i=>i.isActive===!0)?.groupId);s!==void 0&&this.d!==s&&(this.d=s),this.c.fire(Object.freeze({opened:v,closed:E,changed:r}))}$acceptTabGroupUpdate(t){const n=this.e.find(a=>a.groupId===t.groupId);if(!n)throw new Error("Update Group IPC call received before group creation.");n.acceptGroupDtoUpdate(t),t.isActive&&(this.d=t.groupId),this.c.fire(Object.freeze({changed:[n.apiObject],opened:[],closed:[]}))}$acceptTabOperation(t){const n=this.e.find(b=>b.groupId===t.groupId);if(!n)throw new Error("Update Tabs IPC call received before group creation.");const a=n.acceptTabOperation(t);switch(t.kind){case 0:this.b.fire(Object.freeze({opened:[a.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[a.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[a.apiObject]}));return}}g(t){for(const n of this.e)for(const a of n.tabs)if(a.apiObject===t)return a}h(t){return this.e.find(n=>n.apiObject===t)}async i(t,n){const a=[];for(const b of t){const E=this.g(b);if(!E)throw new Error("Tab close: Invalid tab not found!");a.push(E.tabId)}return this.a.$closeTab(a,n)}async j(t,n){const a=[];for(const b of t){const E=this.h(b);if(!E)throw new Error("Group close: Invalid group not found!");a.push(E.groupId)}return this.a.$closeGroup(a,n)}};e.$3cc=p,e.$3cc=p=qe([We(0,k.$aM)],p);function $(g){return g.tabs!==void 0}}),define(Re[232],Me([1,0,3,7]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ndc=void 0;class C{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(w.$_J.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,l,k){if(this.a.size===0)throw new Error("No embedding vector providers registered");const f=this.a.get(A);if(!f)throw new Error("Embedding vector provider not found");const R=await f.provideEmbeddingVector(l,k);if(!R)throw new Error("Embedding vector provider returned undefined");return R}registerEmbeddingVectorProvider(A,l,k){const f=this.b;return this.b++,this.a.set(f,k),this.c.$registerAiEmbeddingVectorProvider(l,f),new M.$bK(()=>{this.c.$unregisterAiEmbeddingVectorProvider(f),this.a.delete(f)})}}e.$Ndc=C}),define(Re[233],Me([1,0,2,3,6,7,8,279,15,26,25,50]),function(be,e,w,M,C,F,A,l,k,f,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ycc=void 0;class c{constructor(){this.a=[]}add(g){this.b=void 0,this.a.push(g)}delete(g){const t=this.a.indexOf(g);t>=0&&(this.a.splice(t,1),this.b=void 0)}c(){if(!this.b){const g=this.a.sort(),t=[];let n,a,b=14,E=14;for(const v of g){let r=n?(0,k.$3e)(n,v):0;for(r===0?a=1:a=E;r<v.length;r++)r+1===v.length?(b=E,E=9):E+=1,t.push([a,v.toUpperCase().charCodeAt(r),E]),t.push([a,v.toLowerCase().charCodeAt(r),E]),a=E;n=v,E=b}t.push([9,58,10]),t.push([10,47,12]),this.b=new l.$SY(t)}}provideDocumentLinks(g){this.c();const t=[],n=l.$TY.computeLinks({getLineContent(a){return g.lineAt(a-1).text},getLineCount(){return g.lineCount}},this.b);for(const a of n){const b=A.DocumentLink.to(a);b.target&&t.push(b)}return t}}class p{constructor(g,t){this.i=t,this.b=new c,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=g.getProxy(M.$_J.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(g,t,n,a={}){if(p.j(n),this.d.has(t))throw new Error(`a provider for the scheme '${t}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(g,"*",this.b));const b=this.h++;this.b.add(t),this.d.add(t),this.c.set(b,n);let E=2;a.isCaseSensitive&&(E+=1024),a.isReadonly&&(E+=2048),typeof n.copy=="function"&&(E+=8),typeof n.open=="function"&&typeof n.close=="function"&&typeof n.read=="function"&&typeof n.write=="function"&&((0,R.$_E)(g,"fsChunks"),E+=4);let v;a.isReadonly&&(0,D.$3j)(a.isReadonly)&&((0,R.$_E)(g,"readonlyMessage"),v={value:a.isReadonly.value,isTrusted:a.isReadonly.isTrusted,supportThemeIcons:a.isReadonly.supportThemeIcons,supportHtml:a.isReadonly.supportHtml,baseUri:a.isReadonly.baseUri,uris:a.isReadonly.uris}),this.a.$registerFileSystemProvider(b,t,E,v).catch(s=>{console.error(`FAILED to register filesystem provider of ${g.identifier.value}-extension for the scheme ${t}`),console.error(s)});const r=n.onDidChangeFile(s=>{const i=[];for(const o of s){const{uri:y,type:d}=o;if(y.scheme!==t)continue;let I;switch(d){case F.FileChangeType.Changed:I=0;break;case F.FileChangeType.Created:I=1;break;case F.FileChangeType.Deleted:I=2;break;default:throw new Error("Unknown FileChangeType")}i.push({resource:y,type:I})}this.a.$onFileSystemChange(b,i)});return(0,C.$Pc)(()=>{r.dispose(),this.b.delete(t),this.d.delete(t),this.c.delete(b),this.a.$unregisterProvider(b)})}static j(g){if(!g)throw new Error("MISSING provider");if(typeof g.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof g.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof g.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof g.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof g.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof g.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof g.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof g.rename!="function")throw new Error("Provider does NOT implement rename")}static k(g){const{type:t,ctime:n,mtime:a,size:b,permissions:E}=g;return{type:t,ctime:n,mtime:a,size:b,permissions:E}}$stat(g,t){return Promise.resolve(this.l(g).stat(w.URI.revive(t))).then(n=>p.k(n))}$readdir(g,t){return Promise.resolve(this.l(g).readDirectory(w.URI.revive(t)))}$readFile(g,t){return Promise.resolve(this.l(g).readFile(w.URI.revive(t))).then(n=>f.$ae.wrap(n))}$writeFile(g,t,n,a){return Promise.resolve(this.l(g).writeFile(w.URI.revive(t),n.buffer,a))}$delete(g,t,n){return Promise.resolve(this.l(g).delete(w.URI.revive(t),n))}$rename(g,t,n,a){return Promise.resolve(this.l(g).rename(w.URI.revive(t),w.URI.revive(n),a))}$copy(g,t,n,a){const b=this.l(g);if(!b.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(b.copy(w.URI.revive(t),w.URI.revive(n),a))}$mkdir(g,t){return Promise.resolve(this.l(g).createDirectory(w.URI.revive(t)))}$watch(g,t,n,a){const b=this.l(g).watch(w.URI.revive(n),a);this.f.set(t,b)}$unwatch(g,t){const n=this.f.get(t);n&&(n.dispose(),this.f.delete(t))}$open(g,t,n){const a=this.l(g);if(!a.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(a.open(w.URI.revive(t),n))}$close(g,t){const n=this.l(g);if(!n.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(n.close(t))}$read(g,t,n,a){const b=this.l(g);if(!b.read)throw new Error('FileSystemProvider does not implement "read"');const E=f.$ae.alloc(a);return Promise.resolve(b.read(t,n,E.buffer,0,a)).then(v=>E.slice(0,v))}$write(g,t,n,a){const b=this.l(g);if(!b.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(b.write(t,n,a.buffer,0,a.byteLength))}l(g){const t=this.c.get(g);if(!t){const n=new Error;throw n.name="ENOPRO",n.message="no provider",n}return t}}e.$ycc=p}),define(Re[61],Me([1,0,3,38,7,26,4,17,39,6,12,23,13]),function(be,e,w,M,C,F,A,l,k,f,R,D,c){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$fcc=e.$ecc=void 0;let $=p=class{constructor(t,n){this.b=new Map,this.c=new R.$2g,this.a=t.getProxy(w.$_J.MainThreadFileSystem);const a=this;this.value=Object.freeze({async stat(b){try{let E;const v=a.b.get(b.scheme);return v?(await a.a.$ensureActivation(b.scheme),E=await v.impl.stat(b)):E=await a.a.$stat(b),{type:E.type,ctime:E.ctime,mtime:E.mtime,size:E.size,permissions:E.permissions===M.FilePermission.Readonly?1:void 0}}catch(E){p.e(E)}},async readDirectory(b){try{const E=a.b.get(b.scheme);return E?(await a.a.$ensureActivation(b.scheme),(await E.impl.readDirectory(b)).slice()):await a.a.$readdir(b)}catch(E){return p.e(E)}},async createDirectory(b){try{const E=a.b.get(b.scheme);return E&&!E.isReadonly?(await a.a.$ensureActivation(b.scheme),await a.d(E.impl,E.extUri,b)):await a.a.$mkdir(b)}catch(E){return p.e(E)}},async readFile(b){try{const E=a.b.get(b.scheme);return E?(await a.a.$ensureActivation(b.scheme),(await E.impl.readFile(b)).slice()):(await a.a.$readFile(b)).buffer}catch(E){return p.e(E)}},async writeFile(b,E){try{const v=a.b.get(b.scheme);return v&&!v.isReadonly?(await a.a.$ensureActivation(b.scheme),await a.d(v.impl,v.extUri,v.extUri.dirname(b)),await a.c.queueFor(b).queue(()=>Promise.resolve(v.impl.writeFile(b,E,{create:!0,overwrite:!0})))):await a.a.$writeFile(b,F.$ae.wrap(E))}catch(v){return p.e(v)}},async delete(b,E){try{const v=a.b.get(b.scheme);return v&&!v.isReadonly?(await a.a.$ensureActivation(b.scheme),await v.impl.delete(b,{recursive:!1,...E})):await a.a.$delete(b,{recursive:!1,useTrash:!1,atomic:!1,...E})}catch(v){return p.e(v)}},async rename(b,E,v){try{return await a.a.$rename(b,E,{overwrite:!1,...v})}catch(r){return p.e(r)}},async copy(b,E,v){try{return await a.a.$copy(b,E,{overwrite:!1,...v})}catch(r){return p.e(r)}},isWritableFileSystem(b){const E=n.getCapabilities(b);if(typeof E=="number")return!(E&2048)}})}async d(t,n,a){const b=[];for(;!n.isEqual(a,n.dirname(a));)try{if(!((await t.stat(a)).type&M.FileType.Directory))throw C.$oL.FileExists(`Unable to create folder '${a.scheme===c.Schemas.file?a.fsPath:a.toString(!0)}' that already exists but is not a directory`);break}catch(E){if(M.$lk(E)!==M.FileSystemProviderErrorCode.FileNotFound)throw E;b.push(n.basename(a)),a=n.dirname(a)}for(let E=b.length-1;E>=0;E--){a=n.joinPath(a,b[E]);try{await t.createDirectory(a)}catch(v){if(M.$lk(v)!==M.FileSystemProviderErrorCode.FileExists)throw v}}}static e(t){if(t instanceof C.$oL)throw t;if(t instanceof M.$hk)switch(t.code){case M.FileSystemProviderErrorCode.FileExists:throw C.$oL.FileExists(t.message);case M.FileSystemProviderErrorCode.FileNotFound:throw C.$oL.FileNotFound(t.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw C.$oL.FileNotADirectory(t.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw C.$oL.FileIsADirectory(t.message);case M.FileSystemProviderErrorCode.NoPermissions:throw C.$oL.NoPermissions(t.message);case M.FileSystemProviderErrorCode.Unavailable:throw C.$oL.Unavailable(t.message);default:throw new C.$oL(t.message,t.name)}if(!(t instanceof Error))throw new C.$oL(String(t));if(t.name==="ENOPRO"||t.message.includes("ENOPRO"))throw C.$oL.Unavailable(t.message);switch(t.name){case M.FileSystemProviderErrorCode.FileExists:throw C.$oL.FileExists(t.message);case M.FileSystemProviderErrorCode.FileNotFound:throw C.$oL.FileNotFound(t.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw C.$oL.FileNotADirectory(t.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw C.$oL.FileIsADirectory(t.message);case M.FileSystemProviderErrorCode.NoPermissions:throw C.$oL.NoPermissions(t.message);case M.FileSystemProviderErrorCode.Unavailable:throw C.$oL.Unavailable(t.message);default:throw new C.$oL(t.message,t.name)}}addFileSystemProvider(t,n,a){return this.b.set(t,{impl:n,extUri:a?.isCaseSensitive?D.$kg:D.$mg,isReadonly:!!a?.isReadonly}),(0,f.$Pc)(()=>this.b.delete(t))}getFileSystemProviderExtUri(t){return this.b.get(t)?.extUri??D.$kg}};e.$ecc=$,e.$ecc=$=p=qe([We(0,l.$aM),We(1,k.$Mbc)],$),e.$fcc=(0,A.$Nh)("IExtHostConsumerFileSystem")}),define(Re[234],Me([1,0,5,37,2,3,8,7,48]),function(be,e,w,M,C,F,A,l,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zcc=void 0;class f{get ignoreCreateEvents(){return!!(this.g&1)}get ignoreChangeEvents(){return!!(this.g&2)}get ignoreDeleteEvents(){return!!(this.g&4)}constructor(p,$,g,t,n,a,b,E){this.a=new w.$Md,this.b=new w.$Md,this.c=new w.$Md;const v=this.h(p,g,n);this.g=0,a&&(this.g+=1),b&&(this.g+=2),E&&(this.g+=4);const r=(0,M.$uj)(n),s=typeof n=="string",i=t(o=>{if(!a)for(const y of o.created){const d=C.URI.revive(y);r(d.fsPath)&&(!s||$.getWorkspaceFolder(d))&&this.a.fire(d)}if(!b)for(const y of o.changed){const d=C.URI.revive(y);r(d.fsPath)&&(!s||$.getWorkspaceFolder(d))&&this.b.fire(d)}if(!E)for(const y of o.deleted){const d=C.URI.revive(y);r(d.fsPath)&&(!s||$.getWorkspaceFolder(d))&&this.c.fire(d)}});this.d=l.$bK.from(v,this.a,this.b,this.c,i)}h(p,$,g){const t=l.$bK.from();if(typeof g=="string")return t;const n=p.getProxy(F.$_J.MainThreadFileSystem);let a=!1;(g.pattern.includes(M.$qj)||g.pattern.includes(M.$rj))&&(a=!0);const b=Math.random();return n.$watch($.identifier.value,b,g.baseUri,{recursive:a,excludes:[]}),l.$bK.from({dispose:()=>n.$unwatch(b)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class R{constructor(p){this.a=p,this.b=new k.$U(()=>this.a.created.map(C.URI.revive)),this.c=new k.$U(()=>this.a.changed.map(C.URI.revive)),this.d=new k.$U(()=>this.a.deleted.map(C.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class D{constructor(p,$,g){this.j=p,this.k=$,this.l=g,this.a=new w.$Md,this.b=new w.$Md,this.c=new w.$Md,this.d=new w.$Md,this.g=new w.$Od,this.h=new w.$Od,this.i=new w.$Od,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(p,$,g,t,n,a){return new f(this.j,p,$,this.a.event,A.GlobPattern.from(g),t,n,a)}$onFileEvent(p){this.a.fire(new R(p))}$onDidRunFileOperation(p,$){switch(p){case 2:this.b.fire(Object.freeze({files:$.map(g=>({oldUri:C.URI.revive(g.source),newUri:C.URI.revive(g.target)}))}));break;case 1:this.d.fire(Object.freeze({files:$.map(g=>C.URI.revive(g.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:$.map(g=>C.URI.revive(g.target))}));break;default:}}getOnWillRenameFileEvent(p){return this.m(p,this.g)}getOnWillCreateFileEvent(p){return this.m(p,this.h)}getOnWillDeleteFileEvent(p){return this.m(p,this.i)}m(p,$){return(g,t,n)=>{const a=function(E){g.call(t,E)};return a.extension=p,$.event(a,void 0,n)}}async $onWillRunFileOperation(p,$,g,t){switch(p){case 2:return await this.n(this.g,{files:$.map(n=>({oldUri:C.URI.revive(n.source),newUri:C.URI.revive(n.target)}))},g,t);case 1:return await this.n(this.i,{files:$.map(n=>C.URI.revive(n.target))},g,t);case 0:case 3:return await this.n(this.h,{files:$.map(n=>C.URI.revive(n.target))},g,t)}}async n(p,$,g,t){const n=new Set,a=[];if(await p.fireAsync($,t,async(E,v)=>{const r=Date.now(),s=await Promise.resolve(E);s instanceof l.$lK&&(a.push([v.extension,s]),n.add(v.extension.displayName??v.extension.identifier.value)),Date.now()-r>g&&this.k.warn("SLOW file-participant",v.extension.identifier)}),t.isCancellationRequested||a.length===0)return;const b={edits:[]};for(const[,E]of a){const{edits:v}=A.WorkspaceEdit.from(E,{getTextDocumentVersion:r=>this.l.getDocument(r)?.version,getNotebookDocumentVersion:()=>{}});b.edits=b.edits.concat(v)}return{edit:b,extensionNames:Array.from(n)}}}e.$zcc=D}),define(Re[235],Me([1,0,6,2,3,8,7,31,12]),function(be,e,w,M,C,F,A,l,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gdc=void 0;class f{static{this.a=0}constructor(p,$){this.extension=p,this.provider=$,this.handle=f.a++}}class R{constructor(p){this.session=p,this.responses=[]}}class D{static{this.a=0}constructor(p,$,g,t){this.f=g,this.g=t,this.b=new Map,this.d=new Map,this.e=p.getProxy(C.$_J.MainThreadInlineChat),$.registerApiCommand(new l.$AM("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new l.$yM("Run arguments","",n=>!0,n=>{if(n)return{initialRange:n.initialRange?F.Range.from(n.initialRange):void 0,initialSelection:n.initialSelection?F.Selection.from(n.initialSelection):void 0,message:n.message,autoSend:n.autoSend,position:n.position?F.Position.from(n.position):void 0}})],l.$zM.Void))}registerProvider(p,$,g){const t=new f(p,$);return this.b.set(t.handle,t),this.e.$registerInteractiveEditorProvider(t.handle,g.label,p.identifier.value,typeof $.handleInteractiveEditorResponseFeedback=="function"),(0,w.$Pc)(()=>{this.e.$unregisterInteractiveEditorProvider(t.handle),this.b.delete(t.handle)})}async $prepareSession(p,$,g,t){const n=this.b.get(p);if(!n){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const a=this.f.getDocument(M.URI.revive($)),b=F.Selection.to(g),E=await n.provider.prepareInteractiveEditorSession({document:a,selection:b},t);if(!E)return;if(E.wholeRange&&!E.wholeRange.contains(b))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const v=D.a++;return this.d.set(v,new R(E)),{id:v,placeholder:E.placeholder,slashCommands:E.slashCommands?.map(r=>({command:r.command,detail:r.detail,refer:r.refer,executeImmediately:r.executeImmediately})),wholeRange:F.Range.from(E.wholeRange),message:E.message}}async $provideResponse(p,$,g,t){const n=this.b.get(p);if(!n)return;const a=this.d.get($.id);if(!a)return;const b={prompt:g.prompt,selection:F.Selection.to(g.selection),wholeRange:F.Range.to(g.wholeRange),attempt:g.attempt,live:g.live};let E=!1;const v={report:async d=>{if(!g.live)throw new Error("Progress reporting is only supported for live sessions");E||t.isCancellationRequested||await this.e.$handleProgressChunk(g.requestId,{message:d.message,edits:d.edits?.map(F.TextEdit.from),slashCommand:d.slashCommand?.command})}},r=Promise.resolve(n.provider.provideInteractiveEditorResponse(a.session,b,v,t));let s;try{s=await(0,k.$Hg)(r,t)}finally{E=!0}if(!s)return;const i=a.responses.push(s)-1,o={wholeRange:F.Range.from(s.wholeRange),placeholder:s.placeholder};if(D.h(s))return{...o,id:i,type:"message",message:F.MarkdownString.from(s.contents)};const{edits:y}=s;return y instanceof A.$lK?{...o,id:i,type:"bulkEdit",edits:F.WorkspaceEdit.from(y)}:{...o,id:i,type:"editorEdit",edits:y.map(F.TextEdit.from)}}$handleFeedback(p,$,g,t){const n=this.b.get(p),a=this.d.get($),b=a?.responses[g];if(n&&b){const E=F.InteractiveEditorResponseFeedbackKind.to(t);n.provider.handleInteractiveEditorResponseFeedback?.(a.session,b,E)}}$releaseSession(p,$){}static h(p){return typeof p=="object"&&typeof p.contents=="object"}}e.$Gdc=D}),define(Re[236],Me([1,0,2,31]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cdc=void 0;class C{constructor(A,l,k,f,R){this.a=l,this.b=k,this.c=f;const D=new M.$AM("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new M.$yM("showOptions","Show Options",c=>!0,c=>c),new M.$yM("resource","Interactive resource Uri",c=>!0,c=>c),new M.$yM("controllerId","Notebook controller Id",c=>!0,c=>c),new M.$yM("title","Interactive editor title",c=>!0,c=>c)],new M.$zM("Notebook and input URI",c=>{if(R.debug("[ExtHostInteractive] open iw with notebook editor id",c.notebookEditorId),c.notebookEditorId!==void 0){const p=this.a.getEditorById(c.notebookEditorId);return R.debug("[ExtHostInteractive] notebook editor found",p.id),{notebookUri:w.URI.revive(c.notebookUri),inputUri:w.URI.revive(c.inputUri),notebookEditor:p.apiEditor}}return R.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",c.notebookUri,c.inputUri),{notebookUri:w.URI.revive(c.notebookUri),inputUri:w.URI.revive(c.inputUri)}}));this.c.registerApiCommand(D)}$willAddInteractiveDocument(A,l,k,f){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:l,lines:[""],languageId:k,uri:A,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(w.URI.revive(f))?.apiNotebook}]})}$willRemoveInteractiveDocument(A,l){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.$Cdc=C}),define(Re[237],Me([1,0,3,7]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Idc=void 0;class C{constructor(A){this.a=new Map,this.b=A.getProxy(w.$_J.MainThreadIssueReporter)}async $getIssueReporterUri(A,l){if(this.a.size===0)throw new Error("No issue request handlers registered");const k=this.a.get(A);if(!k)throw new Error("Issue request handler not found");const f=await k.handleIssueUrlRequest();if(!f)throw new Error("Issue request handler returned no result");return f}registerIssueUriRequestHandler(A,l){const k=A.identifier.value;return this.a.set(k,l),this.b.$registerIssueUriRequestHandler(k),new M.$bK(()=>{this.b.$unregisterIssueUriRequestHandler(k),this.a.delete(k)})}}e.$Idc=C}),define(Re[238],Me([1,0,6,3]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vcc=void 0;class C{constructor(A){this.b=0,this.a=A.getProxy(M.$_J.MainThreadLabelService)}$registerResourceLabelFormatter(A){const l=this.b++;return this.a.$registerResourceLabelFormatter(l,A),(0,w.$Pc)(()=>{this.a.$unregisterResourceLabelFormatter(l)})}}e.$Vcc=C}),define(Re[239],Me([1,0,2,24,8,7,78,3,15,44,18,16,280,21,20,6,91,88,74,58,9,12,25,149]),function(be,e,w,M,C,F,A,l,k,f,R,D,c,p,$,g,t,n,a,b,E,v,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sbc=void 0;class i{constructor(T,q){this.d=T,this.e=q}async provideDocumentSymbols(T,q){const J=this.d.getDocument(T),Q=await this.e.provideDocumentSymbols(J,q);if(!(0,R.$Jb)(Q))return Q[0]instanceof F.$tK?Q.map(C.DocumentSymbol.from):i.f(Q)}static f(T){T=T.slice(0).sort((Q,H)=>{let x=Q.location.range.start.compareTo(H.location.range.start);return x===0&&(x=H.location.range.end.compareTo(Q.location.range.end)),x});const q=[],J=[];for(const Q of T){const H={name:Q.name||"!!MISSING: name!!",kind:C.SymbolKind.from(Q.kind),tags:Q.tags?.map(C.SymbolTag.from)||[],detail:"",containerName:Q.containerName,range:C.Range.from(Q.location.range),selectionRange:C.Range.from(Q.location.range),children:[]};for(;;){if(J.length===0){J.push(H),q.push(H);break}const x=J[J.length-1];if(f.$os.containsRange(x.range,H.range)&&!f.$os.equalsRange(x.range,H.range)){x.children?.push(H),J.push(H);break}J.pop()}}return q}}class o{static{this.d={command:"missing",title:"!!MISSING: command!!"}}constructor(T,q,J){this.g=T,this.h=q,this.j=J,this.e=new a.$Jbc("CodeLens"),this.f=new Map}async provideCodeLenses(T,q){const J=this.g.getDocument(T),Q=await this.j.provideCodeLenses(J,q);if(!Q||q.isCancellationRequested)return;const H=this.e.add(Q),x=new g.$Qc;this.f.set(H,x);const ce={cacheId:H,lenses:[]};for(let Fe=0;Fe<Q.length;Fe++)ce.lenses.push({cacheId:[H,Fe],range:C.Range.from(Q[Fe].range),command:this.h.toInternal(Q[Fe].command,x)});return ce}async resolveCodeLens(T,q){const J=T.cacheId&&this.e.get(...T.cacheId);if(!J)return;let Q;if(typeof this.j.resolveCodeLens!="function"||J.isResolved?Q=J:Q=await this.j.resolveCodeLens(J,q),Q||(Q=J),q.isCancellationRequested)return;const H=T.cacheId&&this.f.get(T.cacheId[0]);if(H)return T.command=this.h.toInternal(Q.command??o.d,H),T}releaseCodeLenses(T){this.f.get(T)?.dispose(),this.f.delete(T),this.e.delete(T)}}function y(Ie){return Array.isArray(Ie)?Ie.map(C.DefinitionLink.from):Ie?[C.DefinitionLink.from(Ie)]:[]}class d{constructor(T,q){this.d=T,this.e=q}async provideDefinition(T,q,J){const Q=this.d.getDocument(T),H=C.Position.to(q),x=await this.e.provideDefinition(Q,H,J);return y(x)}}class I{constructor(T,q){this.d=T,this.e=q}async provideDeclaration(T,q,J){const Q=this.d.getDocument(T),H=C.Position.to(q),x=await this.e.provideDeclaration(Q,H,J);return y(x)}}class S{constructor(T,q){this.d=T,this.e=q}async provideImplementation(T,q,J){const Q=this.d.getDocument(T),H=C.Position.to(q),x=await this.e.provideImplementation(Q,H,J);return y(x)}}class u{constructor(T,q){this.d=T,this.e=q}async provideTypeDefinition(T,q,J){const Q=this.d.getDocument(T),H=C.Position.to(q),x=await this.e.provideTypeDefinition(Q,H,J);return y(x)}}class m{constructor(T,q){this.d=T,this.e=q}async provideHover(T,q,J){const Q=this.d.getDocument(T),H=C.Position.to(q),x=await this.e.provideHover(Q,H,J);if(!(!x||(0,R.$Jb)(x.contents)))return x.range||(x.range=Q.getWordRangeAtPosition(H)),x.range||(x.range=new F.$dK(H,H)),C.Hover.from(x)}}class h{constructor(T,q){this.d=T,this.e=q}async provideEvaluatableExpression(T,q,J){const Q=this.d.getDocument(T),H=C.Position.to(q),x=await this.e.provideEvaluatableExpression(Q,H,J);if(x)return C.EvaluatableExpression.from(x)}}class P{constructor(T,q){this.d=T,this.e=q}async provideInlineValues(T,q,J,Q){const H=this.d.getDocument(T),x=await this.e.provideInlineValues(H,C.Range.to(q),C.InlineValueContext.to(J),Q);if(Array.isArray(x))return x.map(ce=>C.InlineValue.from(ce))}}class W{constructor(T,q){this.d=T,this.e=q}async provideDocumentHighlights(T,q,J){const Q=this.d.getDocument(T),H=C.Position.to(q),x=await this.e.provideDocumentHighlights(Q,H,J);if(Array.isArray(x))return x.map(C.DocumentHighlight.from)}}class K{constructor(T,q){this.d=T,this.e=q}async provideLinkedEditingRanges(T,q,J){const Q=this.d.getDocument(T),H=C.Position.to(q),x=await this.e.provideLinkedEditingRanges(Q,H,J);if(x&&Array.isArray(x.ranges))return{ranges:(0,R.$Gb)(x.ranges.map(C.Range.from)),wordPattern:x.wordPattern}}}class U{constructor(T,q){this.d=T,this.e=q}async provideReferences(T,q,J,Q){const H=this.d.getDocument(T),x=C.Position.to(q),ce=await this.e.provideReferences(H,x,J,Q);if(Array.isArray(ce))return ce.map(C.location.from)}}class B{static{this.d=1e3}constructor(T,q,J,Q,H,x,ce){this.g=T,this.h=q,this.j=J,this.k=Q,this.l=H,this.m=x,this.n=ce,this.e=new a.$Jbc("CodeAction"),this.f=new Map}async provideCodeActions(T,q,J,Q){const H=this.g.getDocument(T),x=c.$qs.isISelection(q)?C.Selection.to(q):C.Range.to(q),ce=[];for(const Xe of this.j.getDiagnostics(T))if(x.intersection(Xe.range)&&ce.push(Xe)>B.d)break;const Fe={diagnostics:ce,only:J.only?new F.$vK(J.only):void 0,triggerKind:C.CodeActionTriggerKind.to(J.trigger)},Ue=await this.k.provideCodeActions(H,x,Fe,Q);if(!(0,R.$Kb)(Ue)||Q.isCancellationRequested)return;const Qe=this.e.add(Ue),Ge=new g.$Qc;this.f.set(Qe,Ge);const _e=[];for(let Xe=0;Xe<Ue.length;Xe++){const xe=Ue[Xe];xe&&(B.o(xe)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),_e.push({_isSynthetic:!0,title:xe.title,command:this.h.toInternal(xe,Ge)})):(Fe.only&&(xe.kind?Fe.only.contains(xe.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Fe.only.value} 'requested but returned code action is of kind '${xe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Fe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),_e.push({cacheId:[Qe,Xe],title:xe.title,command:xe.command&&this.h.toInternal(xe.command,Ge),diagnostics:xe.diagnostics&&xe.diagnostics.map(C.Diagnostic.from),edit:xe.edit&&C.WorkspaceEdit.from(xe.edit,void 0),kind:xe.kind&&xe.kind.value,isPreferred:xe.isPreferred,isAI:(0,r.$$E)(this.m,"codeActionAI")?xe.isAI:!1,disabled:xe.disabled?.reason})))}return{cacheId:Qe,actions:_e}}async resolveCodeAction(T,q){const[J,Q]=T,H=this.e.get(J,Q);if(!H||B.o(H))return{};if(!this.k.resolveCodeAction)return{};const x=await this.k.resolveCodeAction(H,q)??H;let ce;x.edit&&(ce=C.WorkspaceEdit.from(x.edit,void 0));let Fe;if(x.command){const Ue=this.f.get(J);Ue&&(Fe=this.h.toInternal(x.command,Ue))}return{edit:ce,command:Fe}}releaseCodeActions(T){this.f.get(T)?.dispose(),this.f.delete(T),this.e.delete(T)}static o(T){return typeof T.command=="string"&&typeof T.title=="string"}}class O{static toInternalProviderId(T,q){return T+"."+q}constructor(T,q,J,Q,H){this.d=T,this.e=q,this.f=J,this.g=Q,this.h=H}async prepareDocumentPaste(T,q,J,Q){if(!this.f.prepareDocumentPaste)return;const H=this.e.getDocument(T),x=q.map(Ue=>C.Range.to(Ue)),ce=C.DataTransfer.toDataTransfer(J,()=>{throw new E.$0});if(await this.f.prepareDocumentPaste(H,x,ce,Q),Q.isCancellationRequested)return;const Fe=Array.from(ce).filter(([,Ue])=>!(Ue instanceof F.$2K));return C.DataTransfer.from(Fe)}async providePasteEdits(T,q,J,Q,H){if(!this.f.provideDocumentPasteEdits)return;const x=this.e.getDocument(q),ce=J.map(Qe=>C.Range.to(Qe)),Fe=C.DataTransfer.toDataTransfer(Q,async Qe=>(await this.d.$resolvePasteFileData(this.g,T,Qe)).buffer),Ue=await this.f.provideDocumentPasteEdits(x,ce,Fe,H);if(Ue)return{label:Ue.label??(0,s.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:Ue.yieldTo?.map(Qe=>"mimeType"in Qe?Qe:{providerId:O.toInternalProviderId(Qe.extensionId,Qe.providerId)}),insertText:typeof Ue.insertText=="string"?Ue.insertText:{snippet:Ue.insertText.value},additionalEdit:Ue.additionalEdit?C.WorkspaceEdit.from(Ue.additionalEdit,void 0):void 0}}}class N{constructor(T,q){this.d=T,this.e=q}async provideDocumentFormattingEdits(T,q,J){const Q=this.d.getDocument(T),H=await this.e.provideDocumentFormattingEdits(Q,q,J);if(Array.isArray(H))return H.map(C.TextEdit.from)}}class te{constructor(T,q){this.d=T,this.e=q}async provideDocumentRangeFormattingEdits(T,q,J,Q){const H=this.d.getDocument(T),x=C.Range.to(q),ce=await this.e.provideDocumentRangeFormattingEdits(H,x,J,Q);if(Array.isArray(ce))return ce.map(C.TextEdit.from)}async provideDocumentRangesFormattingEdits(T,q,J,Q){(0,D.$Hf)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const H=this.d.getDocument(T),x=q.map(C.Range.to),ce=await this.e.provideDocumentRangesFormattingEdits(H,x,J,Q);if(Array.isArray(ce))return ce.map(C.TextEdit.from)}}class Y{constructor(T,q){this.d=T,this.e=q,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(T,q,J,Q,H){const x=this.d.getDocument(T),ce=C.Position.to(q),Fe=await this.e.provideOnTypeFormattingEdits(x,ce,J,Q,H);if(Array.isArray(Fe))return Fe.map(C.TextEdit.from)}}class ye{constructor(T,q){this.e=T,this.f=q,this.d=new a.$Jbc("WorkspaceSymbols")}async provideWorkspaceSymbols(T,q){const J=await this.e.provideWorkspaceSymbols(T,q);if(!(0,R.$Kb)(J))return{symbols:[]};const Q=this.d.add(J),H={cacheId:Q,symbols:[]};for(let x=0;x<J.length;x++){const ce=J[x];if(!ce||!ce.name){this.f.warn("INVALID SymbolInformation",ce);continue}H.symbols.push({...C.WorkspaceSymbol.from(ce),cacheId:[Q,x]})}return H}async resolveWorkspaceSymbol(T,q){if(typeof this.e.resolveWorkspaceSymbol!="function"||!T.cacheId)return T;const J=this.d.get(...T.cacheId);if(J){const Q=await this.e.resolveWorkspaceSymbol(J,q);return Q&&(0,M.$5m)(T,C.WorkspaceSymbol.from(Q),!0)}}releaseWorkspaceSymbols(T){this.d.delete(T)}}class Ee{static supportsResolving(T){return typeof T.prepareRename=="function"}constructor(T,q,J){this.d=T,this.e=q,this.f=J}async provideRenameEdits(T,q,J,Q){const H=this.d.getDocument(T),x=C.Position.to(q);try{const ce=await this.e.provideRenameEdits(H,x,J,Q);return ce?C.WorkspaceEdit.from(ce):void 0}catch(ce){const Fe=Ee.g(ce);return Fe?{rejectReason:Fe,edits:void 0}:Promise.reject(ce)}}async resolveRenameLocation(T,q,J){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const Q=this.d.getDocument(T),H=C.Position.to(q);try{const x=await this.e.prepareRename(Q,H,J);let ce,Fe;if(F.$dK.isRange(x)?(ce=x,Fe=Q.getText(x)):(0,D.$zf)(x)&&(ce=x.range,Fe=x.placeholder),!ce||!Fe)return;if(ce.start.line>H.line||ce.end.line<H.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:C.Range.from(ce),text:Fe}}catch(x){const ce=Ee.g(x);return ce?{rejectReason:ce,range:void 0,text:void 0}:Promise.reject(x)}}static g(T){return typeof T=="string"?T:T instanceof Error&&typeof T.message=="string"?T.message:void 0}}class Pe{constructor(T,q){this.resultId=T,this.tokens=q}}class X{constructor(T,q){this.f=T,this.g=q,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(T,q,J){const Q=this.f.getDocument(T),H=q!==0?this.d.get(q):null;let x=typeof H?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(Q,H.resultId,J):await this.g.provideDocumentSemanticTokens(Q,J);return H&&this.d.delete(q),x?(x=X.h(x),this.o(X.n(H,x),x)):null}async releaseDocumentSemanticColoring(T){this.d.delete(T)}static h(T){return X.j(T)?X.k(T)?T:new F.$sL(new Uint32Array(T.data),T.resultId):X.l(T)?X.m(T)?T:new F.$uL(T.edits.map(q=>new F.$tL(q.start,q.deleteCount,q.data?new Uint32Array(q.data):q.data)),T.resultId):T}static j(T){return T&&!!T.data}static k(T){return T.data instanceof Uint32Array}static l(T){return T&&Array.isArray(T.edits)}static m(T){for(const q of T.edits)if(!(q.data instanceof Uint32Array))return!1;return!0}static n(T,q){if(!X.j(q)||!T||!T.tokens)return q;const J=T.tokens,Q=J.length,H=q.data,x=H.length;let ce=0;const Fe=Math.min(Q,x);for(;ce<Fe&&J[ce]===H[ce];)ce++;if(ce===Q&&ce===x)return new F.$uL([],q.resultId);let Ue=0;const Qe=Fe-ce;for(;Ue<Qe&&J[Q-Ue-1]===H[x-Ue-1];)Ue++;return new F.$uL([{start:ce,deleteCount:Q-ce-Ue,data:H.subarray(ce,x-Ue)}],q.resultId)}o(T,q){if(X.j(T)){const J=this.e++;return this.d.set(J,new Pe(T.resultId,T.data)),(0,t.$P0)({id:J,type:"full",data:T.data})}if(X.l(T)){const J=this.e++;return X.j(q)?this.d.set(J,new Pe(q.resultId,q.data)):this.d.set(J,new Pe(T.resultId)),(0,t.$P0)({id:J,type:"delta",deltas:(T.edits||[]).map(Q=>({start:Q.start,deleteCount:Q.deleteCount,data:Q.data}))})}return null}}class ae{constructor(T,q){this.d=T,this.e=q}async provideDocumentRangeSemanticTokens(T,q,J){const Q=this.d.getDocument(T),H=await this.e.provideDocumentRangeSemanticTokens(Q,C.Range.to(q),J);return H?this.f(H):null}f(T){return(0,t.$P0)({id:0,type:"full",data:T.data})}}class Se{static supportsResolving(T){return typeof T.resolveCompletionItem=="function"}constructor(T,q,J,Q,H){this.f=T,this.g=q,this.h=J,this.j=Q,this.k=H,this.d=new a.$Jbc("CompletionItem"),this.e=new Map}async provideCompletionItems(T,q,J,Q){const H=this.f.getDocument(T),x=C.Position.to(q),ce=H.getWordRangeAtPosition(x)||new F.$dK(x,x),Fe=ce.with({end:x}),Ue=new b.$Id,Qe=await this.h.provideCompletionItems(H,x,Q,C.CompletionContext.to(J));if(!Qe||Q.isCancellationRequested)return;const Ge=Array.isArray(Qe)?new F.$IK(Qe):Qe,_e=Se.supportsResolving(this.h)?this.d.add(Ge.items):this.d.add([]),Xe=new g.$Qc;this.e.set(_e,Xe);const xe=[],it={x:_e,b:xe,a:{replace:C.Range.from(ce),insert:C.Range.from(Fe)},c:Ge.isIncomplete||void 0,d:Ue.elapsed()};for(let tt=0;tt<Ge.items.length;tt++){const ze=Ge.items[tt],st=this.l(ze,[_e,tt],Fe,ce);xe.push(st)}return it}async resolveCompletionItem(T,q){if(typeof this.h.resolveCompletionItem!="function")return;const J=this.d.get(...T);if(!J)return;const Q=this.l(J,T),H=await this.h.resolveCompletionItem(J,q);if(!H)return;const x=this.l(H,T);return(Q.h!==x.h||Q.i!==x.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(Q.n!==x.n||Q.o!==x.o||!(0,M.$6m)(Q.p,x.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...Q,d:x.d,c:x.c,l:x.l,h:x.h,i:x.i,n:x.n,o:x.o,p:x.p}}releaseCompletionItems(T){this.e.get(T)?.dispose(),this.e.delete(T),this.d.delete(T)}l(T,q,J,Q){const H=this.e.get(q[0]);if(!H)throw Error("DisposableStore is missing...");const x=this.g.toInternal(T.command,H),ce={x:q,a:T.label,b:T.kind!==void 0?C.CompletionItemKind.from(T.kind):void 0,m:T.tags&&T.tags.map(C.CompletionItemTag.from),c:T.detail,d:typeof T.documentation>"u"?void 0:C.MarkdownString.fromStrict(T.documentation),e:T.sortText!==T.label?T.sortText:void 0,f:T.filterText!==T.label?T.filterText:void 0,g:T.preselect||void 0,i:T.keepWhitespace?1:0,k:T.commitCharacters?.join(""),l:T.additionalTextEdits&&T.additionalTextEdits.map(C.TextEdit.from),n:x?.$ident,o:x?.id,p:x?.$ident?void 0:x?.arguments};T.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ce.h=T.textEdit.newText):typeof T.insertText=="string"?ce.h=T.insertText:T.insertText instanceof F.$mK&&(ce.h=T.insertText.value,ce.i|=4);let Fe;return T.textEdit?Fe=T.textEdit.range:T.range&&(Fe=T.range),F.$dK.isRange(Fe)?ce.j=C.Range.from(Fe):Fe&&(!J?.isEqual(Fe.inserting)||!Q?.isEqual(Fe.replacing))&&(ce.j={insert:C.Range.from(Fe.inserting),replace:C.Range.from(Fe.replacing)}),ce}}class ue{async provideInlineCompletions(T,q,J,Q){}disposeCompletions(T){}handleDidShowCompletionItem(T,q,J){}handlePartialAccept(T,q,J){}}class $e extends ue{constructor(T,q,J,Q){super(),this.f=T,this.g=q,this.h=J,this.j=Q,this.d=new ie,this.e=(0,r.$$E)(this.f,"inlineCompletionsAdditions"),this.k={[A.InlineCompletionTriggerKind.Automatic]:F.InlineCompletionTriggerKind.Automatic,[A.InlineCompletionTriggerKind.Explicit]:F.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,r.$$E)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(T,q,J,Q){const H=this.g.getDocument(T),x=C.Position.to(q),ce=await this.h.provideInlineCompletionItems(H,x,{selectedCompletionInfo:J.selectedSuggestionInfo?{range:C.Range.to(J.selectedSuggestionInfo.range),text:J.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[J.triggerKind]},Q);if(!ce||Q.isCancellationRequested)return;const Fe=Array.isArray(ce)?ce:ce.items,Ue=this.e?Array.isArray(ce)?[]:ce.commands||[]:[],Qe=this.e&&!Array.isArray(ce)?ce.enableForwardStability:void 0;let Ge;return{pid:this.d.createReferenceId({dispose(){Ge?.dispose()},items:Fe}),items:Fe.map((Xe,xe)=>{let it;Xe.command&&(Ge||(Ge=new g.$Qc),it=this.j.toInternal(Xe.command,Ge));const tt=Xe.insertText;return{insertText:typeof tt=="string"?tt:{snippet:tt.value},filterText:Xe.filterText,range:Xe.range?C.Range.from(Xe.range):void 0,command:it,idx:xe,completeBracketPairs:this.e?Xe.completeBracketPairs:!1}}),commands:Ue.map(Xe=>(Ge||(Ge=new g.$Qc),this.j.toInternal(Xe,Ge))),suppressSuggestions:!1,enableForwardStability:Qe}}disposeCompletions(T){this.d.disposeReferenceId(T)?.dispose()}handleDidShowCompletionItem(T,q,J){const Q=this.d.get(T)?.items[q];Q&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(Q,J)}handlePartialAccept(T,q,J){const Q=this.d.get(T)?.items[q];Q&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(Q,J)}}class ie{constructor(){this.d=new Map,this.e=1}createReferenceId(T){const q=this.e++;return this.d.set(q,T),q}disposeReferenceId(T){const q=this.d.get(T);return this.d.delete(T),q}get(T){return this.d.get(T)}}class z{constructor(T,q){this.e=T,this.f=q,this.d=new a.$Jbc("SignatureHelp")}async provideSignatureHelp(T,q,J,Q){const H=this.e.getDocument(T),x=C.Position.to(q),ce=this.g(J),Fe=await this.f.provideSignatureHelp(H,x,Q,ce);if(Fe){const Ue=this.d.add([Fe]);return{...C.SignatureHelp.from(Fe),id:Ue}}}g(T){let q;if(T.activeSignatureHelp){const J=C.SignatureHelp.to(T.activeSignatureHelp),Q=this.d.get(T.activeSignatureHelp.id,0);Q?(q=Q,q.activeSignature=J.activeSignature,q.activeParameter=J.activeParameter):q=J}return{...T,activeSignatureHelp:q}}releaseSignatureHelp(T){this.d.delete(T)}}class V{constructor(T,q,J,Q,H){this.f=T,this.g=q,this.h=J,this.j=Q,this.k=H,this.d=new a.$Jbc("InlayHints"),this.e=new Map}async provideInlayHints(T,q,J){const Q=this.f.getDocument(T),H=C.Range.to(q),x=await this.h.provideInlayHints(Q,H,J);if(!Array.isArray(x)||x.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${q}`);return}if(J.isCancellationRequested)return;const ce=this.d.add(x);this.e.set(ce,new g.$Qc);const Fe={hints:[],cacheId:ce};for(let Ue=0;Ue<x.length;Ue++)this.l(x[Ue],H)&&Fe.hints.push(this.m(x[Ue],[ce,Ue]));return this.j.trace(`[InlayHints] ${Fe.hints.length} inlay hints from '${this.k.identifier.value}' for ${q}`),Fe}async resolveInlayHint(T,q){if(typeof this.h.resolveInlayHint!="function")return;const J=this.d.get(...T);if(!J)return;const Q=await this.h.resolveInlayHint(J,q);if(Q&&this.l(Q))return this.m(Q,T)}releaseHints(T){this.e.get(T)?.dispose(),this.e.delete(T),this.d.delete(T)}l(T,q){return T.label.length===0||Array.isArray(T.label)&&T.label.every(J=>J.value.length===0)?(console.log("INVALID inlay hint, empty label",T),!1):!(q&&!q.contains(T.position))}m(T,q){const J=this.e.get(q[0]);if(!J)throw Error("DisposableStore is missing...");const Q={label:"",cacheId:q,tooltip:C.MarkdownString.fromStrict(T.tooltip),position:C.Position.from(T.position),textEdits:T.textEdits&&T.textEdits.map(C.TextEdit.from),kind:T.kind&&C.InlayHintKind.from(T.kind),paddingLeft:T.paddingLeft,paddingRight:T.paddingRight};return typeof T.label=="string"?Q.label=T.label:Q.label=T.label.map(H=>{const x={label:H.value};return x.tooltip=C.MarkdownString.fromStrict(H.tooltip),F.$nK.isLocation(H.location)&&(x.location=C.location.from(H.location)),H.command&&(x.command=this.g.toInternal(H.command,J)),x}),Q}}class le{constructor(T,q){this.e=T,this.f=q,this.d=new a.$Jbc("DocumentLink")}async provideLinks(T,q){const J=this.e.getDocument(T),Q=await this.f.provideDocumentLinks(J,q);if(!(!Array.isArray(Q)||Q.length===0)&&!q.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:Q.filter(le.g).map(C.DocumentLink.from)};{const H=this.d.add(Q),x={links:[],cacheId:H};for(let ce=0;ce<Q.length;ce++){if(!le.g(Q[ce]))continue;const Fe=C.DocumentLink.from(Q[ce]);Fe.cacheId=[H,ce],x.links.push(Fe)}return x}}}static g(T){return T.target&&T.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(T,q){if(typeof this.f.resolveDocumentLink!="function")return;const J=this.d.get(...T);if(!J)return;const Q=await this.f.resolveDocumentLink(J,q);if(!(!Q||!le.g(Q)))return C.DocumentLink.from(Q)}releaseLinks(T){this.d.delete(T)}}class we{constructor(T,q){this.d=T,this.e=q}async provideColors(T,q){const J=this.d.getDocument(T),Q=await this.e.provideDocumentColors(J,q);return Array.isArray(Q)?Q.map(x=>({color:C.Color.from(x.color),range:C.Range.from(x.range)})):[]}async provideColorPresentations(T,q,J){const Q=this.d.getDocument(T),H=C.Range.to(q.range),x=C.Color.to(q.color),ce=await this.e.provideColorPresentations(x,{document:Q,range:H},J);if(Array.isArray(ce))return ce.map(C.ColorPresentation.from)}}class ve{constructor(T,q){this.d=T,this.e=q}async provideFoldingRanges(T,q,J){const Q=this.d.getDocument(T),H=await this.e.provideFoldingRanges(Q,q,J);if(Array.isArray(H))return H.map(C.FoldingRange.from)}}class me{constructor(T,q,J){this.d=T,this.e=q,this.f=J}async provideSelectionRanges(T,q,J){const Q=this.d.getDocument(T),H=q.map(C.Position.to),x=await this.e.provideSelectionRanges(Q,H,J);if(!(0,R.$Kb)(x))return[];if(x.length!==H.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ce=[];for(let Fe=0;Fe<H.length;Fe++){const Ue=[];ce.push(Ue);let Qe=H[Fe],Ge=x[Fe];for(;;){if(!Ge.range.contains(Qe))throw new Error("INVALID selection range, must contain the previous range");if(Ue.push(C.SelectionRange.from(Ge)),!Ge.parent)break;Qe=Ge.range,Ge=Ge.parent}}return ce}}class De{constructor(T,q){this.f=T,this.g=q,this.d=new n.$fM(""),this.e=new Map}async prepareSession(T,q,J){const Q=this.f.getDocument(T),H=C.Position.to(q),x=await this.g.prepareCallHierarchy(Q,H,J);if(!x)return;const ce=this.d.nextId();return this.e.set(ce,new Map),Array.isArray(x)?x.map(Fe=>this.h(ce,Fe)):[this.h(ce,x)]}async provideCallsTo(T,q,J){const Q=this.j(T,q);if(!Q)throw new Error("missing call hierarchy item");const H=await this.g.provideCallHierarchyIncomingCalls(Q,J);if(H)return H.map(x=>({from:this.h(T,x.from),fromRanges:x.fromRanges.map(ce=>C.Range.from(ce))}))}async provideCallsFrom(T,q,J){const Q=this.j(T,q);if(!Q)throw new Error("missing call hierarchy item");const H=await this.g.provideCallHierarchyOutgoingCalls(Q,J);if(H)return H.map(x=>({to:this.h(T,x.to),fromRanges:x.fromRanges.map(ce=>C.Range.from(ce))}))}releaseSession(T){this.e.delete(T)}h(T,q){const J=this.e.get(T),Q=C.CallHierarchyItem.from(q,T,J.size.toString(36));return J.set(Q._itemId,q),Q}j(T,q){return this.e.get(T)?.get(q)}}class re{constructor(T,q){this.f=T,this.g=q,this.d=new n.$fM(""),this.e=new Map}async prepareSession(T,q,J){const Q=this.f.getDocument(T),H=C.Position.to(q),x=await this.g.prepareTypeHierarchy(Q,H,J);if(!x)return;const ce=this.d.nextId();return this.e.set(ce,new Map),Array.isArray(x)?x.map(Fe=>this.h(ce,Fe)):[this.h(ce,x)]}async provideSupertypes(T,q,J){const Q=this.j(T,q);if(!Q)throw new Error("missing type hierarchy item");const H=await this.g.provideTypeHierarchySupertypes(Q,J);if(H)return H.map(x=>this.h(T,x))}async provideSubtypes(T,q,J){const Q=this.j(T,q);if(!Q)throw new Error("missing type hierarchy item");const H=await this.g.provideTypeHierarchySubtypes(Q,J);if(H)return H.map(x=>this.h(T,x))}releaseSession(T){this.e.delete(T)}h(T,q){const J=this.e.get(T),Q=C.TypeHierarchyItem.from(q,T,J.size.toString(36));return J.set(Q._itemId,q),Q}j(T,q){return this.e.get(T)?.get(q)}}class he{static toInternalProviderId(T,q){return T+"."+q}constructor(T,q,J,Q,H){this.d=T,this.e=q,this.f=J,this.g=Q,this.h=H}async provideDocumentOnDropEdits(T,q,J,Q,H){const x=this.e.getDocument(q),ce=C.Position.to(J),Fe=C.DataTransfer.toDataTransfer(Q,async Qe=>(await this.d.$resolveDocumentOnDropFileData(this.g,T,Qe)).buffer),Ue=await this.f.provideDocumentDropEdits(x,ce,Fe,H);if(Ue)return{label:Ue.label??(0,s.localize)(1,null,this.h.displayName||this.h.name),yieldTo:Ue.yieldTo?.map(Qe=>"mimeType"in Qe?Qe:{providerId:he.toInternalProviderId(Qe.extensionId,Qe.providerId)}),insertText:typeof Ue.insertText=="string"?Ue.insertText:{snippet:Ue.insertText.value},additionalEdit:Ue.additionalEdit?C.WorkspaceEdit.from(Ue.additionalEdit,void 0):void 0}}}class se{constructor(T,q){this.d=T,this.e=q}async provideMappedEdits(T,q,J,Q){const H=w.URI.revive(T),x=this.d.getDocument(H),ce=J.documents.map(Qe=>Qe.map(Ge=>({uri:w.URI.revive(Ge.uri),version:Ge.version,ranges:Ge.ranges.map(_e=>C.Range.to(_e))}))),Fe={documents:ce,selections:ce[0]?.[0]?.ranges??[]},Ue=await this.e.provideMappedEdits(x,q,Fe,Q);return Ue?C.WorkspaceEdit.from(Ue):null}}class oe{constructor(T,q){this.adapter=T,this.extension=q}}class de{static{this.d=0}constructor(T,q,J,Q,H,x,ce,Fe){this.g=q,this.h=J,this.j=Q,this.k=H,this.l=x,this.m=ce,this.n=Fe,this.f=new Map,this.e=T.getProxy(l.$_J.MainThreadLanguageFeatures)}o(T,q){return C.DocumentSelector.from(T,this.g,q)}p(T){return new F.$bK(()=>{this.f.delete(T),this.e.$unregister(T)})}q(){return de.d++}async s(T,q,J,Q,H,x=!1){const ce=this.f.get(T);if(!ce||!(ce.adapter instanceof q))return Q;const Fe=Date.now();x||this.l.trace(`[${ce.extension.identifier.value}] INVOKE provider '${J.toString().replace(/[\r\n]/g,"")}'`);const Ue=J(ce.adapter,ce.extension);return Promise.resolve(Ue).catch(Qe=>{(0,E.$3)(Qe)||(this.l.error(`[${ce.extension.identifier.value}] provider FAILED`),this.l.error(Qe),this.n.onExtensionError(ce.extension.identifier,Qe))}).finally(()=>{x||this.l.trace(`[${ce.extension.identifier.value}] provider DONE after ${Date.now()-Fe}ms`)}),p.CancellationToken.isCancellationToken(H)?(0,v.$Ig)(Ue,H):Ue}t(T,q){const J=this.q();return this.f.set(J,new oe(T,q)),J}static u(T){return T.displayName||T.name}registerDocumentSymbolProvider(T,q,J,Q){const H=this.t(new i(this.h,J),T),x=Q&&Q.label||de.u(T);return this.e.$registerDocumentSymbolProvider(H,this.o(q,T),x),this.p(H)}$provideDocumentSymbols(T,q,J){return this.s(T,i,Q=>Q.provideDocumentSymbols(w.URI.revive(q),J),void 0,J)}registerCodeLensProvider(T,q,J){const Q=this.q(),H=typeof J.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(Q,new oe(new o(this.h,this.j.converter,J),T)),this.e.$registerCodeLensSupport(Q,this.o(q,T),H);let x=this.p(Q);if(H!==void 0){const ce=J.onDidChangeCodeLenses(Fe=>this.e.$emitCodeLensEvent(H));x=F.$bK.from(x,ce)}return x}$provideCodeLenses(T,q,J){return this.s(T,o,Q=>Q.provideCodeLenses(w.URI.revive(q),J),void 0,J)}$resolveCodeLens(T,q,J){return this.s(T,o,Q=>Q.resolveCodeLens(q,J),void 0,void 0)}$releaseCodeLenses(T,q){this.s(T,o,J=>Promise.resolve(J.releaseCodeLenses(q)),void 0,void 0)}registerDefinitionProvider(T,q,J){const Q=this.t(new d(this.h,J),T);return this.e.$registerDefinitionSupport(Q,this.o(q,T)),this.p(Q)}$provideDefinition(T,q,J,Q){return this.s(T,d,H=>H.provideDefinition(w.URI.revive(q),J,Q),[],Q)}registerDeclarationProvider(T,q,J){const Q=this.t(new I(this.h,J),T);return this.e.$registerDeclarationSupport(Q,this.o(q,T)),this.p(Q)}$provideDeclaration(T,q,J,Q){return this.s(T,I,H=>H.provideDeclaration(w.URI.revive(q),J,Q),[],Q)}registerImplementationProvider(T,q,J){const Q=this.t(new S(this.h,J),T);return this.e.$registerImplementationSupport(Q,this.o(q,T)),this.p(Q)}$provideImplementation(T,q,J,Q){return this.s(T,S,H=>H.provideImplementation(w.URI.revive(q),J,Q),[],Q)}registerTypeDefinitionProvider(T,q,J){const Q=this.t(new u(this.h,J),T);return this.e.$registerTypeDefinitionSupport(Q,this.o(q,T)),this.p(Q)}$provideTypeDefinition(T,q,J,Q){return this.s(T,u,H=>H.provideTypeDefinition(w.URI.revive(q),J,Q),[],Q)}registerHoverProvider(T,q,J,Q){const H=this.t(new m(this.h,J),T);return this.e.$registerHoverProvider(H,this.o(q,T)),this.p(H)}$provideHover(T,q,J,Q){return this.s(T,m,H=>H.provideHover(w.URI.revive(q),J,Q),void 0,Q)}registerEvaluatableExpressionProvider(T,q,J,Q){const H=this.t(new h(this.h,J),T);return this.e.$registerEvaluatableExpressionProvider(H,this.o(q,T)),this.p(H)}$provideEvaluatableExpression(T,q,J,Q){return this.s(T,h,H=>H.provideEvaluatableExpression(w.URI.revive(q),J,Q),void 0,Q)}registerInlineValuesProvider(T,q,J,Q){const H=typeof J.onDidChangeInlineValues=="function"?this.q():void 0,x=this.t(new P(this.h,J),T);this.e.$registerInlineValuesProvider(x,this.o(q,T),H);let ce=this.p(x);if(H!==void 0){const Fe=J.onDidChangeInlineValues(Ue=>this.e.$emitInlineValuesEvent(H));ce=F.$bK.from(ce,Fe)}return ce}$provideInlineValues(T,q,J,Q,H){return this.s(T,P,x=>x.provideInlineValues(w.URI.revive(q),J,Q,H),void 0,H)}registerDocumentHighlightProvider(T,q,J){const Q=this.t(new W(this.h,J),T);return this.e.$registerDocumentHighlightProvider(Q,this.o(q,T)),this.p(Q)}$provideDocumentHighlights(T,q,J,Q){return this.s(T,W,H=>H.provideDocumentHighlights(w.URI.revive(q),J,Q),void 0,Q)}registerLinkedEditingRangeProvider(T,q,J){const Q=this.t(new K(this.h,J),T);return this.e.$registerLinkedEditingRangeProvider(Q,this.o(q,T)),this.p(Q)}$provideLinkedEditingRanges(T,q,J,Q){return this.s(T,K,async H=>{const x=await H.provideLinkedEditingRanges(w.URI.revive(q),J,Q);if(x)return{ranges:x.ranges,wordPattern:x.wordPattern?de.w(x.wordPattern):void 0}},void 0,Q)}registerReferenceProvider(T,q,J){const Q=this.t(new U(this.h,J),T);return this.e.$registerReferenceSupport(Q,this.o(q,T)),this.p(Q)}$provideReferences(T,q,J,Q,H){return this.s(T,U,x=>x.provideReferences(w.URI.revive(q),J,Q,H),void 0,H)}registerCodeActionProvider(T,q,J,Q){const H=new g.$Qc,x=this.t(new B(this.h,this.j.converter,this.k,J,this.l,T,this.m),T);return this.e.$registerQuickFixSupport(x,this.o(q,T),{providedKinds:Q?.providedCodeActionKinds?.map(ce=>ce.value),documentation:Q?.documentation?.map(ce=>({kind:ce.kind.value,command:this.j.converter.toInternal(ce.command,H)}))},de.u(T),!!J.resolveCodeAction),H.add(this.p(x)),H}$provideCodeActions(T,q,J,Q,H){return this.s(T,B,x=>x.provideCodeActions(w.URI.revive(q),J,Q,H),void 0,H)}$resolveCodeAction(T,q,J){return this.s(T,B,Q=>Q.resolveCodeAction(q,J),{},void 0)}$releaseCodeActions(T,q){this.s(T,B,J=>Promise.resolve(J.releaseCodeActions(q)),void 0,void 0)}registerDocumentFormattingEditProvider(T,q,J){const Q=this.t(new N(this.h,J),T);return this.e.$registerDocumentFormattingSupport(Q,this.o(q,T),T.identifier,T.displayName||T.name),this.p(Q)}$provideDocumentFormattingEdits(T,q,J,Q){return this.s(T,N,H=>H.provideDocumentFormattingEdits(w.URI.revive(q),J,Q),void 0,Q)}registerDocumentRangeFormattingEditProvider(T,q,J){const Q=typeof J.provideDocumentRangesFormattingEdits=="function",H=this.t(new te(this.h,J),T);return this.e.$registerRangeFormattingSupport(H,this.o(q,T),T.identifier,T.displayName||T.name,Q),this.p(H)}$provideDocumentRangeFormattingEdits(T,q,J,Q,H){return this.s(T,te,x=>x.provideDocumentRangeFormattingEdits(w.URI.revive(q),J,Q,H),void 0,H)}$provideDocumentRangesFormattingEdits(T,q,J,Q,H){return this.s(T,te,x=>x.provideDocumentRangesFormattingEdits(w.URI.revive(q),J,Q,H),void 0,H)}registerOnTypeFormattingEditProvider(T,q,J,Q){const H=this.t(new Y(this.h,J),T);return this.e.$registerOnTypeFormattingSupport(H,this.o(q,T),Q,T.identifier),this.p(H)}$provideOnTypeFormattingEdits(T,q,J,Q,H,x){return this.s(T,Y,ce=>ce.provideOnTypeFormattingEdits(w.URI.revive(q),J,Q,H,x),void 0,x)}registerWorkspaceSymbolProvider(T,q){const J=this.t(new ye(q,this.l),T);return this.e.$registerNavigateTypeSupport(J,typeof q.resolveWorkspaceSymbol=="function"),this.p(J)}$provideWorkspaceSymbols(T,q,J){return this.s(T,ye,Q=>Q.provideWorkspaceSymbols(q,J),{symbols:[]},J)}$resolveWorkspaceSymbol(T,q,J){return this.s(T,ye,Q=>Q.resolveWorkspaceSymbol(q,J),void 0,void 0)}$releaseWorkspaceSymbols(T,q){this.s(T,ye,J=>J.releaseWorkspaceSymbols(q),void 0,void 0)}registerRenameProvider(T,q,J){const Q=this.t(new Ee(this.h,J,this.l),T);return this.e.$registerRenameSupport(Q,this.o(q,T),Ee.supportsResolving(J)),this.p(Q)}$provideRenameEdits(T,q,J,Q,H){return this.s(T,Ee,x=>x.provideRenameEdits(w.URI.revive(q),J,Q,H),void 0,H)}$resolveRenameLocation(T,q,J,Q){return this.s(T,Ee,H=>H.resolveRenameLocation(w.URI.revive(q),J,Q),void 0,Q)}registerDocumentSemanticTokensProvider(T,q,J,Q){const H=this.t(new X(this.h,J),T),x=typeof J.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(H,this.o(q,T),Q,x);let ce=this.p(H);if(x){const Fe=J.onDidChangeSemanticTokens(Ue=>this.e.$emitDocumentSemanticTokensEvent(x));ce=F.$bK.from(ce,Fe)}return ce}$provideDocumentSemanticTokens(T,q,J,Q){return this.s(T,X,H=>H.provideDocumentSemanticTokens(w.URI.revive(q),J,Q),null,Q)}$releaseDocumentSemanticTokens(T,q){this.s(T,X,J=>J.releaseDocumentSemanticColoring(q),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(T,q,J,Q){const H=this.t(new ae(this.h,J),T);return this.e.$registerDocumentRangeSemanticTokensProvider(H,this.o(q,T),Q),this.p(H)}$provideDocumentRangeSemanticTokens(T,q,J,Q){return this.s(T,ae,H=>H.provideDocumentRangeSemanticTokens(w.URI.revive(q),J,Q),null,Q)}registerCompletionItemProvider(T,q,J,Q){const H=this.t(new Se(this.h,this.j.converter,J,this.m,T),T);return this.e.$registerCompletionsProvider(H,this.o(q,T),Q,Se.supportsResolving(J),T.identifier),this.p(H)}$provideCompletionItems(T,q,J,Q,H){return this.s(T,Se,x=>x.provideCompletionItems(w.URI.revive(q),J,Q,H),void 0,H)}$resolveCompletionItem(T,q,J){return this.s(T,Se,Q=>Q.resolveCompletionItem(q,J),void 0,J)}$releaseCompletionItems(T,q){this.s(T,Se,J=>J.releaseCompletionItems(q),void 0,void 0)}registerInlineCompletionsProvider(T,q,J,Q){const H=new $e(T,this.h,J,this.j.converter),x=this.t(H,T);return this.e.$registerInlineCompletionsSupport(x,this.o(q,T),H.supportsHandleEvents,$.$2l.toKey(T.identifier.value),Q?.yieldTo?.map(ce=>$.$2l.toKey(ce))||[]),this.p(x)}$provideInlineCompletions(T,q,J,Q,H){return this.s(T,ue,x=>x.provideInlineCompletions(w.URI.revive(q),J,Q,H),void 0,H)}$handleInlineCompletionDidShow(T,q,J,Q){this.s(T,ue,async H=>{H.handleDidShowCompletionItem(q,J,Q)},void 0,void 0)}$handleInlineCompletionPartialAccept(T,q,J,Q){this.s(T,ue,async H=>{H.handlePartialAccept(q,J,Q)},void 0,void 0)}$freeInlineCompletionsList(T,q){this.s(T,ue,async J=>{J.disposeCompletions(q)},void 0,void 0)}registerSignatureHelpProvider(T,q,J,Q){const H=Array.isArray(Q)?{triggerCharacters:Q,retriggerCharacters:[]}:Q,x=this.t(new z(this.h,J),T);return this.e.$registerSignatureHelpProvider(x,this.o(q,T),H),this.p(x)}$provideSignatureHelp(T,q,J,Q,H){return this.s(T,z,x=>x.provideSignatureHelp(w.URI.revive(q),J,Q,H),void 0,H)}$releaseSignatureHelp(T,q){this.s(T,z,J=>J.releaseSignatureHelp(q),void 0,void 0)}registerInlayHintsProvider(T,q,J){const Q=typeof J.onDidChangeInlayHints=="function"?this.q():void 0,H=this.t(new V(this.h,this.j.converter,J,this.l,T),T);this.e.$registerInlayHintsProvider(H,this.o(q,T),typeof J.resolveInlayHint=="function",Q,de.u(T));let x=this.p(H);if(Q!==void 0){const ce=J.onDidChangeInlayHints(Fe=>this.e.$emitInlayHintsEvent(Q));x=F.$bK.from(x,ce)}return x}$provideInlayHints(T,q,J,Q){return this.s(T,V,H=>H.provideInlayHints(w.URI.revive(q),J,Q),void 0,Q)}$resolveInlayHint(T,q,J){return this.s(T,V,Q=>Q.resolveInlayHint(q,J),void 0,J)}$releaseInlayHints(T,q){this.s(T,V,J=>J.releaseHints(q),void 0,void 0)}registerDocumentLinkProvider(T,q,J){const Q=this.t(new le(this.h,J),T);return this.e.$registerDocumentLinkProvider(Q,this.o(q,T),typeof J.resolveDocumentLink=="function"),this.p(Q)}$provideDocumentLinks(T,q,J){return this.s(T,le,Q=>Q.provideLinks(w.URI.revive(q),J),void 0,J,q.scheme==="output")}$resolveDocumentLink(T,q,J){return this.s(T,le,Q=>Q.resolveLink(q,J),void 0,void 0,!0)}$releaseDocumentLinks(T,q){this.s(T,le,J=>J.releaseLinks(q),void 0,void 0,!0)}registerColorProvider(T,q,J){const Q=this.t(new we(this.h,J),T);return this.e.$registerDocumentColorProvider(Q,this.o(q,T)),this.p(Q)}$provideDocumentColors(T,q,J){return this.s(T,we,Q=>Q.provideColors(w.URI.revive(q),J),[],J)}$provideColorPresentations(T,q,J,Q){return this.s(T,we,H=>H.provideColorPresentations(w.URI.revive(q),J,Q),void 0,Q)}registerFoldingRangeProvider(T,q,J){const Q=this.q(),H=typeof J.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(Q,new oe(new ve(this.h,J),T)),this.e.$registerFoldingRangeProvider(Q,this.o(q,T),T.identifier,H);let x=this.p(Q);if(H!==void 0){const ce=J.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(H));x=F.$bK.from(x,ce)}return x}$provideFoldingRanges(T,q,J,Q){return this.s(T,ve,H=>H.provideFoldingRanges(w.URI.revive(q),J,Q),void 0,Q)}registerSelectionRangeProvider(T,q,J){const Q=this.t(new me(this.h,J,this.l),T);return this.e.$registerSelectionRangeProvider(Q,this.o(q,T)),this.p(Q)}$provideSelectionRanges(T,q,J,Q){return this.s(T,me,H=>H.provideSelectionRanges(w.URI.revive(q),J,Q),[],Q)}registerCallHierarchyProvider(T,q,J){const Q=this.t(new De(this.h,J),T);return this.e.$registerCallHierarchyProvider(Q,this.o(q,T)),this.p(Q)}$prepareCallHierarchy(T,q,J,Q){return this.s(T,De,H=>Promise.resolve(H.prepareSession(w.URI.revive(q),J,Q)),void 0,Q)}$provideCallHierarchyIncomingCalls(T,q,J,Q){return this.s(T,De,H=>H.provideCallsTo(q,J,Q),void 0,Q)}$provideCallHierarchyOutgoingCalls(T,q,J,Q){return this.s(T,De,H=>H.provideCallsFrom(q,J,Q),void 0,Q)}$releaseCallHierarchy(T,q){this.s(T,De,J=>Promise.resolve(J.releaseSession(q)),void 0,void 0)}registerTypeHierarchyProvider(T,q,J){const Q=this.t(new re(this.h,J),T);return this.e.$registerTypeHierarchyProvider(Q,this.o(q,T)),this.p(Q)}$prepareTypeHierarchy(T,q,J,Q){return this.s(T,re,H=>Promise.resolve(H.prepareSession(w.URI.revive(q),J,Q)),void 0,Q)}$provideTypeHierarchySupertypes(T,q,J,Q){return this.s(T,re,H=>H.provideSupertypes(q,J,Q),void 0,Q)}$provideTypeHierarchySubtypes(T,q,J,Q){return this.s(T,re,H=>H.provideSubtypes(q,J,Q),void 0,Q)}$releaseTypeHierarchy(T,q){this.s(T,re,J=>Promise.resolve(J.releaseSession(q)),void 0,void 0)}registerDocumentOnDropEditProvider(T,q,J,Q){const H=this.q();this.f.set(H,new oe(new he(this.e,this.h,J,H,T),T));const x=(0,r.$$E)(T,"dropMetadata")&&Q?he.toInternalProviderId(T.identifier.value,Q.id):void 0;return this.e.$registerDocumentOnDropEditProvider(H,this.o(q,T),x,(0,r.$$E)(T,"dropMetadata")?Q:void 0),this.p(H)}$provideDocumentOnDropEdits(T,q,J,Q,H,x){return this.s(T,he,ce=>Promise.resolve(ce.provideDocumentOnDropEdits(q,w.URI.revive(J),Q,H,x)),void 0,void 0)}registerMappedEditsProvider(T,q,J){const Q=this.t(new se(this.h,J),T);return this.e.$registerMappedEditsProvider(Q,this.o(q,T)),this.p(Q)}$provideMappedEdits(T,q,J,Q,H){return this.s(T,se,x=>Promise.resolve(x.provideMappedEdits(q,J,Q,H)),null,H)}registerDocumentPasteEditProvider(T,q,J,Q){const H=this.q();this.f.set(H,new oe(new O(this.e,this.h,J,H,T),T));const x=O.toInternalProviderId(T.identifier.value,Q.id);return this.e.$registerPasteEditProvider(H,this.o(q,T),x,{supportsCopy:!!J.prepareDocumentPaste,supportsPaste:!!J.provideDocumentPasteEdits,copyMimeTypes:Q.copyMimeTypes,pasteMimeTypes:Q.pasteMimeTypes}),this.p(H)}$prepareDocumentPaste(T,q,J,Q,H){return this.s(T,O,x=>x.prepareDocumentPaste(w.URI.revive(q),J,Q,H),void 0,H)}$providePasteEdits(T,q,J,Q,H,x){return this.s(T,O,ce=>ce.providePasteEdits(q,w.URI.revive(J),Q,H,x),void 0,x)}static w(T){return{pattern:T.source,flags:T.flags}}static y(T){return{decreaseIndentPattern:de.w(T.decreaseIndentPattern),increaseIndentPattern:de.w(T.increaseIndentPattern),indentNextLinePattern:T.indentNextLinePattern?de.w(T.indentNextLinePattern):void 0,unIndentedLinePattern:T.unIndentedLinePattern?de.w(T.unIndentedLinePattern):void 0}}static z(T){return{beforeText:de.w(T.beforeText),afterText:T.afterText?de.w(T.afterText):void 0,previousLineText:T.previousLineText?de.w(T.previousLineText):void 0,action:T.action}}static B(T){return T.map(de.z)}static C(T){return{open:T.open,close:T.close,notIn:T.notIn?T.notIn.map(q=>F.SyntaxTokenType.toString(q)):void 0}}static D(T){return T.map(de.C)}setLanguageConfiguration(T,q,J){const{wordPattern:Q}=J;if(Q&&(0,k.$Ne)(Q))throw new Error(`Invalid language configuration: wordPattern '${Q}' is not allowed to match the empty string.`);Q?this.h.setWordDefinitionFor(q,Q):this.h.setWordDefinitionFor(q,void 0),J.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",T,"Do not use."),J.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",T,"Do not use.");const H=this.q(),x={comments:J.comments,brackets:J.brackets,wordPattern:J.wordPattern?de.w(J.wordPattern):void 0,indentationRules:J.indentationRules?de.y(J.indentationRules):void 0,onEnterRules:J.onEnterRules?de.B(J.onEnterRules):void 0,__electricCharacterSupport:J.__electricCharacterSupport,__characterPairSupport:J.__characterPairSupport,autoClosingPairs:J.autoClosingPairs?de.D(J.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(H,q,x),this.p(H)}$setWordDefinitions(T){for(const q of T)this.h.setWordDefinitionFor(q.languageId,new RegExp(q.regexSource,q.regexFlags))}}e.$Sbc=de}),define(Re[240],Me([1,0,3,8,7,29,12,6,25]),function(be,e,w,M,C,F,A,l,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Acc=void 0;class f{constructor(D,c,p,$){this.c=c,this.d=p,this.e=$,this.b=[],this.f=0,this.g=new Set,this.a=D.getProxy(w.$_J.MainThreadLanguages)}$acceptLanguageIds(D){this.b=D}async getLanguages(){return this.b.slice(0)}async changeLanguage(D,c){await this.a.$changeLanguage(D,c);const p=this.c.getDocumentData(D);if(!p)throw new Error(`document '${D.toString()}' NOT found`);return p.document}async tokenAtPosition(D,c){const p=D.version,$=M.Position.from(c),g=await this.a.$tokensAtPosition(D.uri,$),t={type:C.StandardTokenType.Other,range:D.getWordRangeAtPosition(c)??new C.$dK(c.line,c.character,c.line,c.character)};if(!g)return t;const n={range:M.Range.to(g.range),type:M.TokenType.to(g.type)};return!n.range.contains(c)||p!==D.version?t:n}createLanguageStatusItem(D,c,p){const $=this.f++,g=this.a,t=this.g,n=`${D.identifier.value}/${c}`;if(t.has(n))throw new Error(`LanguageStatusItem with id '${c}' ALREADY exists`);t.add(n);const a={selector:p,id:c,name:D.displayName??D.name,severity:C.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let b;const E=new l.$Qc,v=()=>{if(b?.dispose(),!t.has(n)){console.warn(`LanguageStatusItem (${c}) from ${D.identifier.value} has been disposed and CANNOT be updated anymore`);return}b=(0,A.$Ug)(()=>{E.clear(),this.a.$setLanguageStatus($,{id:n,name:a.name??D.displayName??D.name,source:D.displayName??D.name,selector:M.DocumentSelector.from(a.selector,this.e),label:a.text,detail:a.detail??"",severity:a.severity===C.LanguageStatusSeverity.Error?F.default.Error:a.severity===C.LanguageStatusSeverity.Warning?F.default.Warning:F.default.Info,command:a.command&&this.d.toInternal(a.command,E),accessibilityInfo:a.accessibilityInformation,busy:a.busy})},0)},r={dispose(){E.dispose(),b?.dispose(),g.$removeLanguageStatus($),t.delete(n)},get id(){return a.id},get name(){return a.name},set name(s){a.name=s,v()},get selector(){return a.selector},set selector(s){a.selector=s,v()},get text(){return a.text},set text(s){a.text=s,v()},set text2(s){(0,k.$_E)(D,"languageStatusText"),a.text=s,v()},get text2(){return(0,k.$_E)(D,"languageStatusText"),a.text},get detail(){return a.detail},set detail(s){a.detail=s,v()},get severity(){return a.severity},set severity(s){a.severity=s,v()},get accessibilityInformation(){return a.accessibilityInformation},set accessibilityInformation(s){a.accessibilityInformation=s,v()},get command(){return a.command},set command(s){a.command=s,v()},get busy(){return a.busy},set busy(s){a.busy=s,v()}};return v(),r}}e.$Acc=f}),define(Re[81],Me([1,0,22,15,2,4,14,3,27,17]),function(be,e,w,M,C,F,A,l,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qcc=e.$pcc=void 0;let R=class{constructor(c,p,$){this.f=$,this.d=new Map,this.a=p.getProxy(l.$_J.MainThreadLocalization),this.b=c.environment.appLanguage,this.c=this.b===w.$g}getMessage(c,p){const{message:$,args:g,comment:t}=p;if(this.c)return(0,M.$Ce)($,g??{});let n=$;t&&t.length>0&&(n+=`/${Array.isArray(t)?t.join(""):t}`);const a=this.d.get(c)?.contents[n];return a||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${n}`),(0,M.$Ce)(a??$,g??{})}getBundle(c){return this.d.get(c)?.contents}getBundleUri(c){return this.d.get(c)?.uri}async initializeLocalizedMessages(c){if(this.c||!c.l10n&&!c.isBuiltin||this.d.has(c.identifier.value))return;let p;const $=await this.g(c);if(!$){this.f.error(`No bundle location found for extension ${c.identifier.value}`);return}try{const g=await this.a.$fetchBundleContents($),t=JSON.parse(g);p=c.isBuiltin?t.contents?.bundle:t}catch(g){this.f.error(`Failed to load translations for ${c.identifier.value} from ${$}: ${g.message}`);return}p&&this.d.set(c.identifier.value,{contents:p,uri:$})}async g(c){if(c.isBuiltin){const p=await this.a.$fetchBuiltInBundleUri(c.identifier.value,this.b);return C.URI.revive(p)}return c.l10n?C.URI.joinPath(c.extensionLocation,c.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$pcc=R,e.$pcc=R=qe([We(0,k.$qM),We(1,f.$aM),We(2,A.$8i)],R),e.$qcc=(0,F.$Nh)("IExtHostLocalizationService")}),define(Re[241],Me([1,0,14,3,27,17,2,67]),function(be,e,w,M,C,F,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qdc=void 0;let k=class extends w.$gj{constructor(D,c){super(c.logLevel,c.logsLocation,c.loggers.map(p=>(0,l.$kh)(p))),this.r=D.getProxy(M.$_J.MainThreadLogger)}$setLogLevel(D,c){c?this.setLogLevel(A.URI.revive(c),D):this.setLogLevel(D)}setVisibility(D,c){super.setVisibility(D,c),this.r.$setVisibility(D,c)}s(D,c,p){return new f(this.r,D,c,p)}};e.$Qdc=k,e.$Qdc=k=qe([We(0,F.$aM),We(1,C.$qM)],k);class f extends w.$bj{constructor(D,c,p,$){super($?.logLevel==="always"),this.r=D,this.s=c,this.m=!1,this.n=[],this.setLevel(p),this.r.$createLogger(c,$).then(()=>{this.u(this.n),this.m=!0})}g(D,c){const p=[[D,c]];this.m?this.u(p):this.n.push(...p)}u(D){this.r.$log(this.s,D)}flush(){this.r.$flush(this.s)}}}),define(Re[82],Me([1,0,3,4,6,17,26]),function(be,e,w,M,C,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$scc=e.$rcc=void 0,e.$rcc=(0,M.$Nh)("IExtHostManagedSockets");let l=class{constructor(D){this.b=0,this.c=null,this.d=new Map,this.a=D.getProxy(w.$_J.MainThreadManagedSockets)}setFactory(D,c){for(const p of this.d.values())p.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new k(D,c),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(D){if(!this.c||this.c.socketFactoryId!==D)throw new Error(`No socket factory with id ${D}`);const c=++this.b,p=await this.c.makeConnection(),$=new C.$Qc;return this.d.set(c,new f(c,p,$)),$.add((0,C.$Pc)(()=>this.d.delete(c))),$.add(p.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(c),$.dispose()})),$.add(p.onDidClose(g=>{this.a.$onDidManagedSocketClose(c,g?.stack??g?.message),$.dispose()})),$.add(p.onDidReceiveMessage(g=>this.a.$onDidManagedSocketHaveData(c,A.$ae.wrap(g)))),c}$remoteSocketWrite(D,c){this.d.get(D)?.actual.send(c.buffer)}$remoteSocketEnd(D){const c=this.d.get(D);c&&(c.actual.end(),c.dispose())}async $remoteSocketDrain(D){await this.d.get(D)?.actual.drain?.()}};e.$scc=l,e.$scc=l=qe([We(0,F.$aM)],l);class k{constructor(D,c){this.socketFactoryId=D,this.makeConnection=c}}class f extends C.$Rc{constructor(D,c,p){super(),this.socketId=D,this.actual=c,this.B(p)}}}),define(Re[242],Me([1,0,3,14,25]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bcc=void 0;function F(l){return l&&l.title}let A=class{constructor(k,f){this.b=f,this.a=k.getProxy(w.$_J.MainThreadMessageService)}showMessage(k,f,R,D,c){const p={source:{identifier:k.identifier,label:k.displayName||k.name}};let $;typeof D=="string"||F(D)?$=[D,...c]:(p.modal=D?.modal,p.useCustom=D?.useCustom,p.detail=D?.detail,$=c),p.useCustom&&(0,C.$_E)(k,"resolvers");const g=[];for(let t=0;t<$.length;t++){const n=$[t];if(typeof n=="string")g.push({title:n,handle:t,isCloseAffordance:!1});else if(typeof n=="object"){const{title:a,isCloseAffordance:b}=n;g.push({title:a,isCloseAffordance:!!b,handle:t})}else this.b.warn("Invalid message item:",n)}return this.a.$showMessage(f,R,p,g).then(t=>{if(typeof t=="number")return $[t]})}};e.$Bcc=A,e.$Bcc=A=qe([We(1,M.$8i)],A)}),define(Re[243],Me([1,0,151,26,5,6,28,15,16,2,38,74,3,31,8,7,46,204,103,9,24,13]),function(be,e,w,M,C,F,A,l,k,f,R,D,c,p,$,g,t,n,a,b,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jdc=void 0;class r{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(i=>i.apiEditor)}constructor(i,o,y,d,I){this.q=y,this.r=d,this.s=I,this.f=new Map,this.g=new A.$zc,this.h=new Map,this.j=new C.$Md({onListenerError:b.$1}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new C.$Md({onListenerError:b.$1}),this.onDidOpenNotebookDocument=this.m.event,this.n=new C.$Md({onListenerError:b.$1}),this.onDidCloseNotebookDocument=this.n.event,this.o=new C.$Md({onListenerError:b.$1}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new D.$Jbc("NotebookCellStatusBarCache"),this.u=0,this.w=new Map,this.b=i.getProxy(c.$_J.MainThreadNotebook),this.c=i.getProxy(c.$_J.MainThreadNotebookDocuments),this.d=i.getProxy(c.$_J.MainThreadNotebookEditors),this.i=o.converter,o.registerArgumentProcessor({processArgument:S=>{if(S&&S.$mid===13){const u=S.notebookEditor?.notebookUri,m=S.cell.handle,P=this.g.get(u)?.getCell(m);if(P)return P.apiCell}if(S&&S.$mid===14){const u=S.uri,m=this.g.get(u);if(m)return m.apiNotebook}return S}}),r.A(o)}getEditorById(i){const o=this.h.get(i);if(!o)throw new Error(`unknown text editor: ${i}. known editors: ${[...this.h.keys()]} `);return o}getIdByEditor(i){for(const[o,y]of this.h)if(y.apiEditor===i)return o}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(i,o){const y=this.g.get(i);if(!y&&!o)throw new Error(`NO notebook document for '${i}'`);return y}static t(i,o){if(!o)return;const y=o.filenamePattern.map(d=>$.NotebookExclusiveDocumentPattern.from(d)).filter(d=>d!==void 0);if(o.filenamePattern&&!y){console.warn(`Notebook content provider view options file name pattern is invalid ${o.filenamePattern}`);return}return{extension:i.identifier,providerDisplayName:i.displayName||i.name,displayName:o.displayName,filenamePattern:y,exclusive:o.exclusive||!1}}registerNotebookCellStatusBarItemProvider(i,o,y){const d=r.a++,I=typeof y.onDidChangeCellStatusBarItems=="function"?r.a++:void 0;this.f.set(d,y),this.b.$registerNotebookCellStatusBarItemProvider(d,I,o);let S;return I!==void 0&&(S=y.onDidChangeCellStatusBarItems(u=>this.b.$emitCellStatusBarEvent(I))),new g.$bK(()=>{this.f.delete(d),this.b.$unregisterNotebookCellStatusBarItemProvider(d,I),S?.dispose()})}async createNotebookDocument(i){const o=await this.c.$tryCreateNotebook({viewType:i.viewType,content:i.content&&$.NotebookData.from(i.content)});return f.URI.revive(o)}async openNotebookDocument(i){const o=this.g.get(i);if(o)return o.apiNotebook;const y=await this.c.$tryOpenNotebook(i),d=this.g.get(f.URI.revive(y));return(0,k.$If)(d?.apiNotebook)}async showNotebookDocument(i,o){f.URI.isUri(i)&&(i=await this.openNotebookDocument(i));let y;typeof o=="object"?y={position:$.ViewColumn.from(o.viewColumn),preserveFocus:o.preserveFocus,selections:o.selections&&o.selections.map($.NotebookRange.from),pinned:typeof o.preview=="boolean"?!o.preview:void 0}:y={preserveFocus:!1};const d=await this.d.$tryShowNotebookDocument(i.uri,i.notebookType,y),I=d&&this.h.get(d)?.apiEditor;if(I)return I;throw d?new Error(`Could NOT open editor for "${i.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${i.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(i,o,y,d){const I=this.f.get(i),S=f.URI.revive(o),u=this.g.get(S);if(!u||!I)return;const m=u.getCellFromIndex(y);if(!m)return;const h=await I.provideCellStatusBarItems(m.apiCell,d);if(!h)return;const P=new F.$Qc,W=this.p.add([P]),U=(Array.isArray(h)?h:[h]).map(B=>$.NotebookStatusBarItem.from(B,this.i,P));return{cacheId:W,items:U}}$releaseNotebookCellStatusBarItems(i){this.p.delete(i)}registerNotebookSerializer(i,o,y,d,I){if((0,l.$Ae)(o))throw new Error("viewType cannot be empty or just whitespace");const S=this.u++;return this.w.set(S,{viewType:o,serializer:y,options:d}),this.b.$registerNotebookSerializer(S,{id:i.identifier,location:i.extensionLocation},o,$.NotebookDocumentContentOptions.from(d),r.t(i,I)),(0,F.$Pc)(()=>{this.b.$unregisterNotebookSerializer(S)})}async $dataToNotebook(i,o,y){const d=this.w.get(i);if(!d)throw new Error("NO serializer found");const I=await d.serializer.deserializeNotebook(o.buffer,y);return new t.$kv($.NotebookData.from(I))}async $notebookToData(i,o,y){const d=this.w.get(i);if(!d)throw new Error("NO serializer found");const I=await d.serializer.serializeNotebook($.NotebookData.to(o.value),y);return M.$ae.wrap(I)}async $saveNotebook(i,o,y,d,I){const S=f.URI.revive(o),u=this.w.get(i);if(!u)throw new Error("NO serializer found");const m=this.g.get(S);if(!m)throw new Error("Document NOT found");if(m.versionId!==y)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(S.scheme))throw new R.$qk((0,w.localize)(0,null,this.y(S)),6);await this.x(S,d);const h={metadata:(0,E.$0m)(m.apiNotebook.metadata,B=>!(u.options?.transientDocumentMetadata??{})[B]),cells:[]};for(const B of m.apiNotebook.getCells()){const O=new g.$zL(B.kind,B.document.getText(),B.document.languageId,B.mime,u.options?.transientOutputs?[]:[...B.outputs],B.metadata,B.executionSummary);O.metadata=(0,E.$0m)(B.metadata,N=>!(u.options?.transientCellMetadata??{})[N]),h.cells.push(O)}const P=await u.serializer.serializeNotebook(h,I);await this.s.value.writeFile(S,P);const W=this.s.getFileSystemProviderExtUri(S.scheme),K=await this.s.value.stat(S);return{name:W.basename(S),isFile:(K.type&R.FileType.File)!==0,isDirectory:(K.type&R.FileType.Directory)!==0,isSymbolicLink:(K.type&R.FileType.SymbolicLink)!==0,mtime:K.mtime,ctime:K.ctime,size:K.size,readonly:!!((K.permissions??0)&R.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(S.scheme),locked:!!((K.permissions??0)&R.FilePermission.Locked),etag:R.$Bk({mtime:K.mtime,size:K.size}),children:void 0}}async x(i,o){const y=await this.s.value.stat(i);if(typeof o?.mtime=="number"&&typeof o.etag=="string"&&o.etag!==R.$Ak&&typeof y.mtime=="number"&&typeof y.size=="number"&&o.mtime<y.mtime&&o.etag!==R.$Bk({mtime:o.mtime,size:y.size}))throw new R.$qk((0,w.localize)(1,null),3,o)}y(i){return i.scheme===v.Schemas.file?i.fsPath:i.toString()}z(i,o,y){if(this.h.has(o))throw new Error(`editor with id ALREADY EXSIST: ${o}`);const d=new a.$idc(o,this.d,i,y.visibleRanges.map($.NotebookRange.to),y.selections.map($.NotebookRange.to),typeof y.viewColumn=="number"?$.ViewColumn.to(y.viewColumn):void 0);this.h.set(o,d)}$acceptDocumentAndEditorsDelta(i){if(i.value.removedDocuments)for(const y of i.value.removedDocuments){const d=f.URI.revive(y),I=this.g.get(d);I&&(I.dispose(),this.g.delete(d),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:I.apiNotebook.getCells().map(S=>S.document.uri)}),this.n.fire(I.apiNotebook));for(const S of this.h.values())S.notebookData.uri.toString()===d.toString()&&this.h.delete(S.id)}if(i.value.addedDocuments){const y=[];for(const d of i.value.addedDocuments){const I=f.URI.revive(d.uri);if(this.g.has(I))throw new Error(`adding EXISTING notebook ${I} `);const S=new n.$hdc(this.c,this.q,this.r,I,d);y.push(...d.cells.map(u=>n.$gdc.asModelAddData(S.apiNotebook,u))),this.g.get(I)?.dispose(),this.g.set(I,S),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:y}),this.m.fire(S.apiNotebook)}}if(i.value.addedEditors)for(const y of i.value.addedEditors){if(this.h.has(y.id))return;const d=f.URI.revive(y.documentUri),I=this.g.get(d);I&&this.z(I,y.id,y)}const o=[];if(i.value.removedEditors)for(const y of i.value.removedEditors){const d=this.h.get(y);d&&(this.h.delete(y),this.k?.id===d.id&&(this.k=void 0),o.push(d))}if(i.value.visibleEditors){this.l=i.value.visibleEditors.map(d=>this.h.get(d)).filter(d=>!!d);const y=new Set;this.l.forEach(d=>y.add(d.id));for(const d of this.h.values()){const I=y.has(d.id);d._acceptVisibility(I)}this.l=[...this.h.values()].map(d=>d).filter(d=>d.visible),this.o.fire(this.visibleNotebookEditors)}i.value.newActiveEditor===null?this.k=void 0:i.value.newActiveEditor&&(this.h.get(i.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${i.value.newActiveEditor}`),this.k=this.h.get(i.value.newActiveEditor)),i.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static A(i){const o=p.$yM.String.with("notebookType","A notebook type"),y=new p.$AM("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[o,new p.$yM("data","Bytes to convert to data",I=>I instanceof Uint8Array,I=>M.$ae.wrap(I))],new p.$zM("Notebook Data",I=>$.NotebookData.to(I.value))),d=new p.$AM("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[o,new p.$yM("NotebookData","Notebook data to convert to bytes",I=>!0,I=>new t.$kv($.NotebookData.from(I)))],new p.$zM("Bytes",I=>I.buffer));i.registerApiCommand(y),i.registerApiCommand(d)}}e.$jdc=r}),define(Re[244],Me([1,0,18,12,21,5,6,28,2,20,14,3,31,8,7,77,197,25,46]),function(be,e,w,M,C,F,A,l,k,f,R,D,c,p,$,g,t,n,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ydc=e.$xdc=void 0;let b=class{constructor(d,I,S,u,m){this.l=I,this.m=S,this.n=u,this.o=m,this.b=new l.$zc,this.c=new l.$zc,this.e=new Map,this.f=0,this.g=new Map,this.h=0,this.i=new Map,this.j=0,this.k=new F.$Md,this.onDidChangeNotebookCellExecutionState=this.k.event,this.a=d.getProxy(D.$_J.MainThreadNotebookKernels);const h=new c.$AM("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new c.$yM("options","Select kernel options",P=>!0,P=>{if(P&&"notebookEditor"in P&&"id"in P){const W=this.m.getIdByEditor(P.notebookEditor);return{id:P.id,extension:P.extension,notebookEditorId:W}}else if(P&&"notebookEditor"in P){const W=this.m.getIdByEditor(P.notebookEditor);if(W===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${P.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:W}}return P})],c.$zM.Void);this.n.registerApiCommand(h)}createNotebookController(d,I,S,u,m,h){for(const ae of this.i.values())if(ae.controller.id===I&&f.$2l.equals(d.identifier,ae.extensionId))throw new Error(`notebook controller with id '${I}' ALREADY exist`);const P=this.j++,W=this;this.o.trace(`NotebookController[${P}], CREATED by ${d.identifier.value}, ${I}`);const K=()=>console.warn(`NO execute handler from notebook controller '${N.id}' of extension: '${d.identifier}'`);let U=!1;const B=new F.$Md,O=new F.$Md,N={id:o(d.identifier,I),notebookType:S,extensionId:d.identifier,extensionLocation:d.extensionLocation,label:u||d.identifier.value,preloads:h?h.map(p.NotebookRendererScript.from):[]};let te=m??K,Y;this.a.$addKernel(P,N).catch(ae=>{console.log(ae),U=!0});let ye=0;const Ee=()=>{if(U)return;const ae=++ye;Promise.resolve().then(()=>{ae===ye&&this.a.$updateKernel(P,N)})},Pe=new l.$zc,X={get id(){return I},get notebookType(){return N.notebookType},onDidChangeSelectedNotebooks:B.event,get label(){return N.label},set label(ae){N.label=ae??d.displayName??d.name,Ee()},get detail(){return N.detail??""},set detail(ae){N.detail=ae,Ee()},get description(){return N.description??""},set description(ae){N.description=ae,Ee()},get supportedLanguages(){return N.supportedLanguages},set supportedLanguages(ae){N.supportedLanguages=ae,Ee()},get supportsExecutionOrder(){return N.supportsExecutionOrder??!1},set supportsExecutionOrder(ae){N.supportsExecutionOrder=ae,Ee()},get rendererScripts(){return N.preloads?N.preloads.map(p.NotebookRendererScript.to):[]},get executeHandler(){return te},set executeHandler(ae){te=ae??K},get interruptHandler(){return Y},set interruptHandler(ae){Y=ae,N.supportsInterrupt=!!ae,Ee()},createNotebookCellExecution(ae){if(U)throw new Error("notebook controller is DISPOSED");if(!Pe.has(ae.notebook.uri))throw W.o.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Pe.keys()).map(Se=>Se.toString())),new Error(`notebook controller is NOT associated to notebook: ${ae.notebook.uri.toString()}`);return W._createNotebookCellExecution(ae,o(d.identifier,this.id))},createNotebookExecution(ae){if((0,n.$_E)(d,"notebookExecution"),U)throw new Error("notebook controller is DISPOSED");if(!Pe.has(ae.uri))throw W.o.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Pe.keys()).map(Se=>Se.toString())),new Error(`notebook controller is NOT associated to notebook: ${ae.uri.toString()}`);return W._createNotebookExecution(ae,o(d.identifier,this.id))},dispose:()=>{U||(this.o.trace(`NotebookController[${P}], DISPOSED`),U=!0,this.i.delete(P),B.dispose(),O.dispose(),this.a.$removeKernel(P))},updateNotebookAffinity(ae,Se){Se===$.NotebookControllerAffinity2.Hidden&&(0,n.$_E)(d,"notebookControllerAffinityHidden"),W.a.$updateNotebookPriority(P,ae.uri,Se)},onDidReceiveMessage:O.event,postMessage(ae,Se){return(0,n.$_E)(d,"notebookMessaging"),W.a.$postMessage(P,Se&&W.m.getIdByEditor(Se),ae)},asWebviewUri(ae){return(0,n.$_E)(d,"notebookMessaging"),(0,g.$1ob)(ae,W.l.remote)}};return this.i.set(P,{extensionId:d.identifier,controller:X,onDidReceiveMessage:O,onDidChangeSelection:B,associatedNotebooks:Pe}),X}getIdByController(d){for(const[I,S]of this.i)if(S.controller===d)return o(S.extensionId,d.id);return null}createNotebookControllerDetectionTask(d,I){const S=this.f++,u=this;this.o.trace(`NotebookControllerDetectionTask[${S}], CREATED by ${d.identifier.value}`),this.a.$addKernelDetectionTask(S,I);const m={dispose:()=>{this.e.delete(S),u.a.$removeKernelDetectionTask(S)}};return this.e.set(S,m),m}registerKernelSourceActionProvider(d,I,S){const u=this.h++,m=typeof S.onDidChangeNotebookKernelSourceActions=="function"?u:void 0,h=this;this.g.set(u,S),this.o.trace(`NotebookKernelSourceActionProvider[${u}], CREATED by ${d.identifier.value}`),this.a.$addKernelSourceActionProvider(u,u,I);let P;return m!==void 0&&(P=S.onDidChangeNotebookKernelSourceActions(W=>this.a.$emitNotebookKernelSourceActionsChangeEvent(m))),{dispose:()=>{this.g.delete(u),h.a.$removeKernelSourceActionProvider(u,u),P?.dispose()}}}async $provideKernelSourceActions(d,I){const S=this.g.get(d);if(S){const u=new A.$Qc;return(await S.provideNotebookKernelSourceActions(I)??[]).map(h=>p.NotebookKernelSourceAction.from(h,this.n.converter,u))}return[]}$acceptNotebookAssociation(d,I,S){const u=this.i.get(d);if(u){const m=this.m.getNotebookDocument(k.URI.revive(I));S?u.associatedNotebooks.set(m.uri,!0):u.associatedNotebooks.delete(m.uri),this.o.trace(`NotebookController[${d}] ASSOCIATE notebook`,m.uri.toString(),S),u.onDidChangeSelection.fire({selected:S,notebook:m.apiNotebook})}}async $executeCells(d,I,S){const u=this.i.get(d);if(!u)return;const m=this.m.getNotebookDocument(k.URI.revive(I)),h=[];for(const P of S){const W=m.getCell(P);W&&h.push(W.apiCell)}try{this.o.trace(`NotebookController[${d}] EXECUTE cells`,m.uri.toString(),h.length),await u.controller.executeHandler.call(u.controller,h,m.apiNotebook,u.controller)}catch(P){this.o.error(`NotebookController[${d}] execute cells FAILED`,P),console.error(P)}}async $cancelCells(d,I,S){const u=this.i.get(d);if(!u)return;const m=this.m.getNotebookDocument(k.URI.revive(I));if(u.controller.interruptHandler)await u.controller.interruptHandler.call(u.controller,m.apiNotebook);else for(const h of S){const P=m.getCell(h);P&&this.b.get(P.uri)?.cancel()}if(u.controller.interruptHandler){const h=this.c.get(m.uri);S.length&&Array.isArray(h)&&h.length&&h.forEach(P=>P.dispose())}}$acceptKernelMessageFromRenderer(d,I,S){const u=this.i.get(d);if(!u)return;const m=this.m.getEditorById(I);u.onDidReceiveMessage.fire(Object.freeze({editor:m.apiEditor,message:S}))}$cellExecutionChanged(d,I,S){const m=this.m.getNotebookDocument(k.URI.revive(d)).getCell(I);if(m){const h=S?p.NotebookCellExecutionState.to(S):$.NotebookCellExecutionState.Idle;h!==void 0&&this.k.fire({cell:m.apiCell,state:h})}}_createNotebookCellExecution(d,I){if(d.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const u=this.m.getNotebookDocument(d.notebook.uri).getCellFromApiCell(d);if(!u)throw new Error("invalid cell");if(this.b.has(u.uri))throw new Error(`duplicate execution for ${u.uri}`);const m=new v(I,u,this.a);this.b.set(u.uri,m);const h=m.onDidChangeState(()=>{m.state===E.Resolved&&(m.dispose(),h.dispose(),this.b.delete(u.uri))});return m.asApiObject()}_createNotebookExecution(d,I){const S=this.m.getNotebookDocument(d.uri),u=d.getCells().find(P=>{const W=S.getCellFromApiCell(P);return W&&this.b.has(W.uri)});if(u)throw new Error(`duplicate cell execution for ${u.document.uri}`);if(this.c.has(S.uri))throw new Error(`duplicate notebook execution for ${S.uri}`);const m=new s(I,S,this.a),h=m.onDidChangeState(()=>{m.state===r.Resolved&&(m.dispose(),h.dispose(),this.c.delete(S.uri))});return this.c.set(S.uri,[m,h]),m.asApiObject()}};e.$xdc=b,e.$xdc=b=qe([We(4,R.$8i)],b);var E;(function(y){y[y.Init=0]="Init",y[y.Started=1]="Started",y[y.Resolved=2]="Resolved"})(E||(E={}));class v extends A.$Rc{static{this.a=0}get state(){return this.f}constructor(d,I,S){super(),this.m=I,this.n=S,this.b=v.a++,this.c=new F.$Md,this.onDidChangeState=this.c.event,this.f=E.Init,this.g=this.B(new C.$Wd),this.h=new i(10,u=>this.s(u)),this.j=I.internalMetadata.executionOrder,this.n.$createExecution(this.b,d,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(d){await this.h.addItem(d)}async s(d){const I=Array.isArray(d)?d:[d];return this.n.$updateExecution(this.b,new a.$kv(I))}t(){if(this.f===E.Init)throw new Error("Must call start before modifying cell output");if(this.f===E.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(d){let I=this.m;if(d&&(I=this.m.notebook.getCellFromApiCell(d)),!I)throw new Error("INVALID cell");return I.handle}y(d){return d.map(I=>{const S=$.$CL.ensureUniqueMimeTypes(I.items,!0);return S===I.items?p.NotebookCellOutput.from(I):p.NotebookCellOutput.from({items:S,id:I.id,metadata:I.metadata})})}async z(d,I,S){const u=this.w(I),m=this.y((0,w.$2b)(d));return this.r({editType:t.CellExecutionUpdateType.Output,cellHandle:u,append:S,outputs:m})}async C(d,I,S){return d=$.$CL.ensureUniqueMimeTypes((0,w.$2b)(d),!0),this.r({editType:t.CellExecutionUpdateType.OutputItems,items:d.map(p.NotebookCellOutputItem.from),outputId:I.id,append:S})}asApiObject(){const d=this;return Object.freeze({get token(){return d.g.token},get cell(){return d.m.apiCell},get executionOrder(){return d.j},set executionOrder(S){d.j=S,d.s([{editType:t.CellExecutionUpdateType.ExecutionState,executionOrder:d.j}])},start(S){if(d.f===E.Resolved||d.f===E.Started)throw new Error("Cannot call start again");d.f=E.Started,d.c.fire(),d.s({editType:t.CellExecutionUpdateType.ExecutionState,runStartTime:S})},end(S,u){if(d.f===E.Resolved)throw new Error("Cannot call resolve twice");d.f=E.Resolved,d.c.fire(),d.h.flush(),d.n.$completeExecution(d.b,new a.$kv({runEndTime:u,lastRunSuccess:S}))},clearOutput(S){return d.t(),d.z([],S,!1)},appendOutput(S,u){return d.t(),d.z(S,u,!0)},replaceOutput(S,u){return d.t(),d.z(S,u,!1)},appendOutputItems(S,u){return d.t(),d.C(S,u,!0)},replaceOutputItems(S,u){return d.t(),d.C(S,u,!1)}})}}var r;(function(y){y[y.Init=0]="Init",y[y.Started=1]="Started",y[y.Resolved=2]="Resolved"})(r||(r={}));class s extends A.$Rc{static{this.a=0}get state(){return this.f}constructor(d,I,S){super(),this.h=I,this.j=S,this.b=s.a++,this.c=new F.$Md,this.onDidChangeState=this.c.event,this.f=r.Init,this.g=this.B(new C.$Wd),this.j.$createNotebookExecution(this.b,d,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===r.Resolved||this.f===r.Started)throw new Error("Cannot call start again");this.f=r.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===r.Resolved)throw new Error("Cannot call resolve twice");this.f=r.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class i{constructor(d,I){this.e=d,this.f=I,this.a=[],this.b=Date.now()}addItem(d){return this.a.push(d),this.c||(this.c=new M.$bh,this.b=Date.now(),(0,M.$Tg)(this.e).then(()=>this.flush())),Date.now()-this.b>this.e?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const d=this.c;this.c=void 0;const I=this.a;return this.a=[],this.f(I).finally(()=>d.complete())}}function o(y,d){return`${y.value}/${d}`}e.$ydc=o}),define(Re[245],Me([1,0,5,3,103]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zdc=void 0;class F{constructor(l,k){this.c=k,this.a=new Map,this.b=l.getProxy(M.$_J.MainThreadNotebookRenderers)}$postRendererMessage(l,k,f){const R=this.c.getEditorById(l);this.a.get(k)?.fire({editor:R.apiEditor,message:f})}createRendererMessaging(l,k){if(!l.contributes?.notebookRenderer?.some(R=>R.id===k))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${k})`);return{onDidReceiveMessage:(R,D,c)=>this.d(k).event(R,D,c),postMessage:(R,D)=>{C.$idc.apiEditorsToExtHost.has(R)&&([R,D]=[D,R]);const c=D&&C.$idc.apiEditorsToExtHost.get(D);return this.b.$postMessage(c?.id,k,R)}}}d(l){let k=this.a.get(l);return k||(k=new w.$Md({onDidRemoveLastListener:()=>{k?.dispose(),this.a.delete(l)}}),this.a.set(l,k),k)}}e.$zdc=F}),define(Re[246],Me([1,0,6,16,2,25,3]),function(be,e,w,M,C,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ddc=void 0;class l{constructor(f){this.b=new Map,this.a=f.getProxy(A.$_J.MainThreadProfileContentHandlers)}registrProfileContentHandler(f,R,D){if((0,F.$_E)(f,"profileContentHandlers"),this.b.has(R))throw new Error(`Handler with id '${R}' already registered`);return this.b.set(R,D),this.a.$registerProfileContentHandler(R,D.name,D.description,f.identifier.value),(0,w.$Pc)(()=>{this.b.delete(R),this.a.$unregisterProfileContentHandler(R)})}async $saveProfile(f,R,D,c){const p=this.b.get(f);if(!p)throw new Error(`Unknown handler with id: ${f}`);return p.saveProfile(R,D,c)}async $readProfile(f,R,D){const c=this.b.get(f);if(!c)throw new Error(`Unknown handler with id: ${f}`);return c.readProfile((0,M.$xf)(R)?R:C.URI.revive(R),D)}}e.$Ddc=l}),define(Re[247],Me([1,0,2,3,12,8]),function(be,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Edc=void 0;class A{static{this.a=0}constructor(k,f){this.d=f,this.c=new Map,this.b=k.getProxy(M.$_J.MainThreadQuickDiff)}$provideOriginalResource(k,f,R){const D=w.URI.revive(f),c=this.c.get(k);return c?(0,C.$Lg)(()=>c.provideOriginalResource(D,R)).then(p=>p||null):Promise.resolve(null)}registerQuickDiffProvider(k,f,R,D){const c=A.a++;return this.c.set(c,f),this.b.$registerQuickDiffProvider(c,F.DocumentSelector.from(k,this.d),R,D),{dispose:()=>{this.b.$unregisterQuickDiffProvider(c),this.c.delete(c)}}}}e.$Edc=A}),define(Re[248],Me([1,0,21,5,6,3,2,7,9,18,29,40,25,8]),function(be,e,w,M,C,F,A,l,k,f,R,D,c,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fcc=void 0;function $(g,t,n){const a=g.getProxy(F.$_J.MainThreadQuickOpen);class b{constructor(I,S){this.e=new Map,this.f=0,this.a=I,this.b=S}showQuickPick(I,S,u,m=w.CancellationToken.None){this.c=void 0;const h=Promise.resolve(S),P=++this.f,W=a.$show(P,{title:u?.title,placeHolder:u?.placeHolder,matchOnDescription:u?.matchOnDescription,matchOnDetail:u?.matchOnDetail,ignoreFocusLost:u?.ignoreFocusOut,canPickMany:u?.canPickMany},m),K={},U=W.then(()=>K);return Promise.race([U,h]).then(B=>{if(B===K)return;const O=(0,c.$$E)(I,"quickPickItemTooltip");return h.then(N=>{const te=[];for(let Y=0;Y<N.length;Y++){const ye=N[Y];if(typeof ye=="string")te.push({label:ye,handle:Y});else if(ye.kind===l.QuickPickItemKind.Separator)te.push({type:"separator",label:ye.label});else{ye.tooltip&&!O&&console.warn(`Extension '${I.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${I.identifier.value}`);const Ee=ye.iconPath?i(ye.iconPath):void 0;te.push({label:ye.label,iconPath:Ee?.iconPath,iconClass:Ee?.iconClass,description:ye.description,detail:ye.detail,picked:ye.picked,alwaysShow:ye.alwaysShow,tooltip:O?p.MarkdownString.fromStrict(ye.tooltip):void 0,handle:Y})}}return u&&typeof u.onDidSelectItem=="function"&&(this.c=Y=>{u.onDidSelectItem(N[Y])}),a.$setItems(P,te),W.then(Y=>{if(typeof Y=="number")return N[Y];if(Array.isArray(Y))return Y.map(ye=>N[ye])})})}).then(void 0,B=>{if(!(0,k.$3)(B))return a.$setError(P,B),Promise.reject(B)})}$onItemSelected(I){this.c?.(I)}showInput(I,S=w.CancellationToken.None){return this.d=I?.validateInput,a.$input(I,typeof this.d=="function",S).then(void 0,u=>{if(!(0,k.$3)(u))return Promise.reject(u)})}async $validateInput(I){if(!this.d)return;const S=await this.d(I);if(!S||typeof S=="string")return S;let u;switch(S.severity){case l.InputBoxValidationSeverity.Info:u=R.default.Info;break;case l.InputBoxValidationSeverity.Warning:u=R.default.Warning;break;case l.InputBoxValidationSeverity.Error:u=R.default.Error;break;default:u=S.message?R.default.Error:R.default.Ignore;break}return{content:S.message,severity:u}}async showWorkspaceFolderPick(I,S=w.CancellationToken.None){const u=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[I]);if(!u)return;const m=await this.a.getWorkspaceFolders2();if(m)return m.find(h=>h.uri.toString()===u.uri.toString())}createQuickPick(I){const S=new o(I,()=>this.e.delete(S._id));return this.e.set(S._id,S),S}createInputBox(I){const S=new y(I,()=>this.e.delete(S._id));return this.e.set(S._id,S),S}$onDidChangeValue(I,S){this.e.get(I)?._fireDidChangeValue(S)}$onDidAccept(I){this.e.get(I)?._fireDidAccept()}$onDidChangeActive(I,S){const u=this.e.get(I);u instanceof o&&u._fireDidChangeActive(S)}$onDidChangeSelection(I,S){const u=this.e.get(I);u instanceof o&&u._fireDidChangeSelection(S)}$onDidTriggerButton(I,S){this.e.get(I)?._fireDidTriggerButton(S)}$onDidTriggerItemButton(I,S,u){const m=this.e.get(I);m instanceof o&&m._fireDidTriggerItemButton(S,u)}$onDidHide(I){this.e.get(I)?._fireDidHide()}}class E{static{this.a=1}constructor(I,S){this.x=I,this.y=S,this._id=o.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new M.$Md,this.q=new M.$Md,this.r=new M.$Md,this.s=new M.$Md,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(I){this.b=I,this.z({title:I})}get step(){return this.c}set step(I){this.c=I,this.z({step:I})}get totalSteps(){return this.d}set totalSteps(I){this.d=I,this.z({totalSteps:I})}get enabled(){return this.g}set enabled(I){this.g=I,this.z({enabled:I})}get busy(){return this.j}set busy(I){this.j=I,this.z({busy:I})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(I){this.k=I,this.z({ignoreFocusOut:I})}get value(){return this.l}set value(I){this.l=I,this.z({value:I})}get placeholder(){return this.m}set placeholder(I){this.m=I,this.z({placeholder:I})}get buttons(){return this.n}set buttons(I){this.n=I.slice(),this.o.clear(),I.forEach((S,u)=>{const m=S===l.$vL.Back?-1:u;this.o.set(m,S)}),this.z({buttons:I.map((S,u)=>({...i(S.iconPath),tooltip:S.tooltip,handle:S===l.$vL.Back?-1:u}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(I){this.l=I,this.q.fire(I)}_fireDidTriggerButton(I){const S=this.o.get(I);S&&this.r.fire(S)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,C.$Mc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),a.$dispose(this._id))}z(I){if(!this.v){for(const S of Object.keys(I)){const u=I[S];this.u[S]=u===void 0?null:u}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){a.$createOrUpdate(this.u),this.u={id:this._id}}}function v(d){if(d instanceof l.$8K)return{id:d.id};const I=s(d),S=r(d);return{dark:typeof I=="string"?A.URI.file(I):I,light:typeof S=="string"?A.URI.file(S):S}}function r(d){return typeof d=="object"&&"light"in d?d.light:d}function s(d){return typeof d=="object"&&"dark"in d?d.dark:d}function i(d){const I=v(d);let S,u;return"id"in I?u=D.ThemeIcon.asClassName(I):S=I,{iconPath:S,iconClass:u}}class o extends E{constructor(I,S){super(I.identifier,S),this.O=I,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new M.$Md,this.L=[],this.M=new M.$Md,this.N=new M.$Md,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(I){this.B=I.slice(),this.C.clear(),this.D.clear(),I.forEach((m,h)=>{this.C.set(h,m),this.D.set(m,h)});const S=(0,c.$$E)(this.O,"quickPickItemTooltip"),u=[];for(let m=0;m<I.length;m++){const h=I[m];if(h.kind===l.QuickPickItemKind.Separator)u.push({type:"separator",label:h.label});else{h.tooltip&&!S&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const P=h.iconPath?i(h.iconPath):void 0;u.push({handle:m,label:h.label,iconPath:P?.iconPath,iconClass:P?.iconClass,description:h.description,detail:h.detail,picked:h.picked,alwaysShow:h.alwaysShow,tooltip:S?p.MarkdownString.fromStrict(h.tooltip):void 0,buttons:h.buttons?.map((W,K)=>({...i(W.iconPath),tooltip:W.tooltip,handle:K}))})}}this.z({items:u})}get canSelectMany(){return this.E}set canSelectMany(I){this.E=I,this.z({canSelectMany:I})}get matchOnDescription(){return this.F}set matchOnDescription(I){this.F=I,this.z({matchOnDescription:I})}get matchOnDetail(){return this.G}set matchOnDetail(I){this.G=I,this.z({matchOnDetail:I})}get sortByLabel(){return this.H}set sortByLabel(I){this.H=I,this.z({sortByLabel:I})}get keepScrollPosition(){return this.I}set keepScrollPosition(I){this.I=I,this.z({keepScrollPosition:I})}get activeItems(){return this.J}set activeItems(I){this.J=I.filter(S=>this.D.has(S)),this.z({activeItems:this.J.map(S=>this.D.get(S))})}get selectedItems(){return this.L}set selectedItems(I){this.L=I.filter(S=>this.D.has(S)),this.z({selectedItems:this.L.map(S=>this.D.get(S))})}_fireDidChangeActive(I){const S=(0,f.$Gb)(I.map(u=>this.C.get(u)));this.J=S,this.K.fire(S)}_fireDidChangeSelection(I){const S=(0,f.$Gb)(I.map(u=>this.C.get(u)));this.L=S,this.M.fire(S)}_fireDidTriggerItemButton(I,S){const u=this.C.get(I);if(!u||!u.buttons||!u.buttons.length)return;const m=u.buttons[S];m&&this.N.fire({button:m,item:u})}}class y extends E{constructor(I,S){super(I.identifier,S),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(I){this.B=I,this.z({password:I})}get prompt(){return this.C}set prompt(I){this.C=I,this.z({prompt:I})}get valueSelection(){return this.D}set valueSelection(I){this.D=I,this.z({valueSelection:I})}get validationMessage(){return this.E}set validationMessage(I){this.E=I,I?typeof I=="string"?this.z({validationMessage:I,severity:R.default.Error}):this.z({validationMessage:I.message,severity:I.severity??R.default.Error}):this.z({validationMessage:void 0,severity:R.default.Ignore})}}return new b(t,n)}e.$Fcc=$}),define(Re[249],Me([1,0,2,5,64,6,12,3,18,131,14,20,40,8,25,13]),function(be,e,w,M,C,F,A,l,k,f,R,D,c,p,$,g){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hcc=e.$Gcc=void 0;function n(m){if(m)return typeof m.iconPath=="string"?w.URI.file(m.iconPath):w.URI.isUri(m.iconPath)||c.ThemeIcon.isThemeIcon(m.iconPath)?m.iconPath:void 0}function a(m){if(m.icon){if(w.URI.isUri(m.icon))return m.icon;if(c.ThemeIcon.isThemeIcon(m.icon))return m.icon;{const h=m.icon;return{light:h.light,dark:h.dark}}}else return}function b(m,h){if(!m.iconPath&&!h.iconPath)return 0;if(m.iconPath){if(!h.iconPath)return 1}else return-1;const P=typeof m.iconPath=="string"?m.iconPath:w.URI.isUri(m.iconPath)?m.iconPath.fsPath:m.iconPath.id,W=typeof h.iconPath=="string"?h.iconPath:w.URI.isUri(h.iconPath)?h.iconPath.fsPath:h.iconPath.id;return(0,f.$nq)(P,W)}function E(m,h){let P=0;if(m.strikeThrough!==h.strikeThrough)return m.strikeThrough?1:-1;if(m.faded!==h.faded)return m.faded?1:-1;if(m.tooltip!==h.tooltip)return(m.tooltip||"").localeCompare(h.tooltip||"");if(P=b(m,h),P!==0)return P;if(m.light&&h.light)P=b(m.light,h.light);else{if(m.light)return 1;if(h.light)return-1}if(P!==0)return P;if(m.dark&&h.dark)P=b(m.dark,h.dark);else{if(m.dark)return 1;if(h.dark)return-1}return P}function v(m,h){if(m.command!==h.command)return m.command<h.command?-1:1;if(m.title!==h.title)return m.title<h.title?-1:1;if(m.tooltip!==h.tooltip){if(m.tooltip!==void 0&&h.tooltip!==void 0)return m.tooltip<h.tooltip?-1:1;if(m.tooltip!==void 0)return 1;if(h.tooltip!==void 0)return-1}if(m.arguments===h.arguments)return 0;if(m.arguments)if(h.arguments){if(m.arguments.length!==h.arguments.length)return m.arguments.length-h.arguments.length}else return 1;else return-1;for(let P=0;P<m.arguments.length;P++){const W=m.arguments[P],K=h.arguments[P];if(W!==K)return W<K?-1:1}return 0}function r(m,h){let P=(0,f.$nq)(m.resourceUri.fsPath,h.resourceUri.fsPath,!0);if(P!==0)return P;if(m.command&&h.command)P=v(m.command,h.command);else{if(m.command)return 1;if(h.command)return-1}if(P!==0)return P;if(m.decorations&&h.decorations)P=E(m.decorations,h.decorations);else{if(m.decorations)return 1;if(h.decorations)return-1}return P}function s(m,h){for(let P=0;P<m.length;P++)if(m[P]!==h[P])return!1;return!0}function i(m,h){return m.command===h.command&&m.title===h.title&&m.tooltip===h.tooltip&&(m.arguments&&h.arguments?s(m.arguments,h.arguments):m.arguments===h.arguments)}function o(m,h){return(0,k.$tb)(m,h,i)}function y(m,h){return m===h?!0:!m||!h?!1:m.id===h.id&&m.label===h.label&&m.upstream?.id===h.upstream?.id&&m.upstream?.label===h.upstream?.label}class d{#e;#t;get value(){return this.d}set value(h){h=h??"",this.#e.$setInputBoxValue(this.l,h),this.n(h)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(h){this.#e.$setInputBoxPlaceholder(this.l,h),this.f=h}get validateInput(){return(0,$.$_E)(this.k,"scmValidation"),this.g}set validateInput(h){if((0,$.$_E)(this.k,"scmValidation"),h&&typeof h!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=h,this.#e.$setValidationProviderIsEnabled(this.l,!!h)}get enabled(){return this.h}set enabled(h){h=!!h,this.h!==h&&(this.h=h,this.#e.$setInputBoxEnablement(this.l,h))}get visible(){return this.j}set visible(h){h=!!h,this.j!==h&&(this.j=h,this.#e.$setInputBoxVisibility(this.l,h))}get document(){return(0,$.$_E)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(h,P,W,K,U){this.k=h,this.l=K,this.m=U,this.d="",this.e=new M.$Md,this.f="",this.h=!0,this.j=!0,this.#t=P,this.#e=W}showValidationMessage(h,P){(0,$.$_E)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,h,P)}$onInputBoxValueChange(h){this.n(h)}n(h){this.d=h,this.e.fire(h)}}e.$Gcc=d;class I{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(h){this.v=h,this.q.$updateGroupLabel(this.t,this.handle,h)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(h){this.p=h,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(h){this.f=[...h],this.k.fire()}constructor(h,P,W,K,U){this.q=h,this.s=P,this.t=W,this.u=K,this.v=U,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new M.$Md,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new M.$Md,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=I.d++}getResourceState(h){return this.g.get(h)}$executeResourceCommand(h,P){const W=this.h.get(h);return W?(0,A.$Lg)(()=>this.s.executeCommand(W.command,...W.arguments||[],P)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const h=[...this.f].sort(r),W=(0,k.$Cb)(this.o,h,r).map(B=>{const O=B.toInsert.map(N=>{const te=this.e++;this.g.set(te,N);const Y=N.resourceUri;let ye;if(N.command)if(N.command.command==="vscode.open"||N.command.command==="vscode.diff"){const V=new F.$Qc;ye=this.s.converter.toInternal(N.command,V),this.j.set(te,V)}else this.h.set(te,N.command);const Ee=n(N.decorations),Pe=N.decorations&&n(N.decorations.light)||Ee,X=N.decorations&&n(N.decorations.dark)||Ee,ae=[Pe,X],Se=N.decorations&&N.decorations.tooltip||"",ue=N.decorations&&!!N.decorations.strikeThrough,$e=N.decorations&&!!N.decorations.faded,ie=N.contextValue||"";return{rawResource:[te,Y,ae,Se,ue,$e,ie,ye],handle:te}});return{start:B.start,deleteCount:B.deleteCount,toInsert:O}}),K=W.map(({start:B,deleteCount:O,toInsert:N})=>[B,O,N.map(te=>te.rawResource)]),U=W.reverse();for(const{start:B,deleteCount:O,toInsert:N}of U){const te=N.map(ye=>ye.handle),Y=this.n.splice(B,O,...te);for(const ye of Y)this.g.delete(ye),this.h.delete(ye),this.j.get(ye)?.dispose(),this.j.delete(ye)}return this.o=h,K}dispose(){this.l=!0,this.m.fire()}}class S{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(h){this.g!==h&&(this.g=h,this.#e.$updateSourceControl(this.x,{count:h}))}get quickDiffProvider(){return this.h}set quickDiffProvider(h){this.h=h;let P;(0,$.$$E)(this.y,"quickDiffProvider")&&(P=h?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!h,quickDiffLabel:P})}get historyProvider(){return(0,$.$_E)(this.y,"scmHistoryProvider"),this.j}set historyProvider(h){(0,$.$_E)(this.y,"scmHistoryProvider"),this.j=h,this.k.value=new F.$Qc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!h}),h&&(this.k.value.add(h.onDidChangeCurrentHistoryItemGroup(()=>{y(this.l,h?.currentHistoryItemGroup)||(this.l=h?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.l))})),this.k.value.add(h.onDidChangeActionButton(()=>{(0,$.$_E)(this.y,"scmActionButton"),this.m.value=new F.$Qc;const P=h.actionButton!==void 0?{command:this.z.converter.toInternal(h.actionButton.command,this.m.value),description:h.actionButton.description,enabled:h.actionButton.enabled}:void 0;this.#e.$onDidChangeHistoryProviderActionButton(this.x,P??null)})))}get commitTemplate(){return this.n}set commitTemplate(h){h!==this.n&&(this.n=h,this.#e.$updateSourceControl(this.x,{commitTemplate:h}))}get acceptInputCommand(){return this.p}set acceptInputCommand(h){this.o.value=new F.$Qc,this.p=h;const P=this.z.converter.toInternal(h,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:P})}get actionButton(){return(0,$.$_E)(this.y,"scmActionButton"),this.s}set actionButton(h){(0,$.$_E)(this.y,"scmActionButton"),this.q.value=new F.$Qc,this.s=h;const P=h!==void 0?{command:this.z.converter.toInternal(h.command,this.q.value),secondaryCommands:h.secondaryCommands?.map(W=>W.map(K=>this.z.converter.toInternal(K,this.q.value))),description:h.description,enabled:h.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:P??null})}get statusBarCommands(){return this.u}set statusBarCommands(h){if(this.u&&h&&o(this.u,h))return;this.t.value=new F.$Qc,this.u=h;const P=(h||[]).map(W=>this.z.converter.toInternal(W,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:P})}get selected(){return this.v}constructor(h,P,W,K,U,B,O){this.y=h,this.z=K,this.A=U,this.B=B,this.C=O,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new F.$Sc,this.m=new F.$Sc,this.n=void 0,this.o=new F.$Sc,this.p=void 0,this.q=new F.$Sc,this.t=new F.$Sc,this.u=void 0,this.v=!1,this.w=new M.$Md,this.onDidChangeSelection=this.w.event,this.x=S.d++,this.D=new Map,this.E=new Set,this.#e=W;const N=w.URI.from({scheme:g.Schemas.vscodeSourceControl,path:`${U}/scm${this.x}/input`,query:O?`rootUri=${encodeURIComponent(O.toString())}`:void 0});this.f=new d(h,P,this.#e,this.x,N),this.#e.$registerSourceControl(this.x,U,B,O,N)}createResourceGroup(h,P){const W=new I(this.#e,this.z,this.x,h,P),K=M.Event.once(W.onDidDispose)(()=>this.D.delete(W));return this.D.set(W,K),this.eventuallyAddResourceGroups(),W}eventuallyAddResourceGroups(){const h=[],P=[];for(const[W,K]of this.D){K.dispose();const U=W.onDidUpdateResourceStates(()=>{this.E.add(W),this.eventuallyUpdateResourceStates()});M.Event.once(W.onDidDispose)(()=>{this.E.delete(W),U.dispose(),this.e.delete(W.handle),this.#e.$unregisterGroup(this.x,W.handle)}),h.push([W.handle,W.id,W.label,W.features]);const B=W._takeResourceStateSnapshot();B.length>0&&P.push([W.handle,B]),this.e.set(W.handle,W)}this.#e.$registerGroups(this.x,h,P),this.D.clear()}eventuallyUpdateResourceStates(){const h=[];this.E.forEach(P=>{const W=P._takeResourceStateSnapshot();W.length!==0&&h.push([P.handle,W])}),h.length>0&&this.#e.$spliceResourceStates(this.x,h),this.E.clear()}getResourceGroup(h){return this.e.get(h)}setSelectionState(h){this.v=h,this.w.fire(h)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(h=>h.dispose()),this.#e.$unregisterSourceControl(this.x)}}qe([(0,C.$gh)(100)],S.prototype,"eventuallyAddResourceGroups",null),qe([(0,C.$gh)(100)],S.prototype,"eventuallyUpdateResourceStates",null);let u=class{static{t=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(h,P,W,K){this.l=P,this.m=W,this.n=K,this.g=new Map,this.h=new D.$4l,this.j=new M.$Md,this.e=h.getProxy(l.$_J.MainThreadSCM),this.f=h.getProxy(l.$_J.MainThreadTelemetry),P.registerArgumentProcessor({processArgument:U=>{if(U&&U.$mid===3){const B=this.g.get(U.sourceControlHandle);if(!B)return U;const O=B.getResourceGroup(U.groupHandle);return O?O.getResourceState(U.handle):U}else if(U&&U.$mid===4){const B=this.g.get(U.sourceControlHandle);return B?B.getResourceGroup(U.groupHandle):U}else if(U&&U.$mid===5){const B=this.g.get(U.handle);return B||U}return U}})}createSourceControl(h,P,W,K){this.n.trace("ExtHostSCM#createSourceControl",h.identifier.value,P,W,K),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:h.identifier.value});const U=t.d++,B=new S(h,this.m,this.e,this.l,P,W,K);this.g.set(U,B);const O=this.h.get(h.identifier)||[];return O.push(B),this.h.set(h.identifier,O),B}getLastInputBox(h){this.n.trace("ExtHostSCM#getLastInputBox",h.identifier.value);const P=this.h.get(h.identifier),W=P&&P[P.length-1];return W&&W.inputBox}$provideOriginalResource(h,P,W){const K=w.URI.revive(P);this.n.trace("ExtHostSCM#$provideOriginalResource",h,K.toString());const U=this.g.get(h);return!U||!U.quickDiffProvider||!U.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.$Lg)(()=>U.quickDiffProvider.provideOriginalResource(K,W)).then(B=>B||null)}$onInputBoxValueChange(h,P){this.n.trace("ExtHostSCM#$onInputBoxValueChange",h);const W=this.g.get(h);return W&&W.inputBox.$onInputBoxValueChange(P),Promise.resolve(void 0)}$executeResourceCommand(h,P,W,K){this.n.trace("ExtHostSCM#$executeResourceCommand",h,P,W);const U=this.g.get(h);if(!U)return Promise.resolve(void 0);const B=U.getResourceGroup(P);return B?B.$executeResourceCommand(W,K):Promise.resolve(void 0)}$validateInput(h,P,W){this.n.trace("ExtHostSCM#$validateInput",h);const K=this.g.get(h);return!K||!K.inputBox.validateInput?Promise.resolve(void 0):(0,A.$Lg)(()=>K.inputBox.validateInput(P,W)).then(U=>{if(!U)return Promise.resolve(void 0);const B=p.MarkdownString.fromStrict(U.message);return B?Promise.resolve([B,U.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(h){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",h),h!==void 0&&this.g.get(h)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=h,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(h,P,W){return await this.g.get(h)?.historyProvider?.resolveHistoryItemGroupBase(P,W)??void 0}async $resolveHistoryItemGroupCommonAncestor(h,P,W,K){return await this.g.get(h)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(P,W,K)??void 0}async $provideHistoryItems(h,P,W,K){return(await this.g.get(h)?.historyProvider?.provideHistoryItems(P,W,K))?.map(O=>({id:O.id,parentIds:O.parentIds,label:O.label,description:O.description,icon:a(O),timestamp:O.timestamp}))??void 0}async $provideHistoryItemChanges(h,P,W){return await this.g.get(h)?.historyProvider?.provideHistoryItemChanges(P,W)??void 0}};e.$Hcc=u,e.$Hcc=u=t=qe([We(3,R.$8i)],u)}),define(Re[83],Me([1,0,3,5,4]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ncc=e.$mcc=void 0;class F{constructor(l){this.b=new M.$Md,this.onDidChangePassword=this.b.event,this.a=l.getProxy(w.$_J.MainThreadSecretState)}async $onDidChangePassword(l){this.b.fire(l)}get(l,k){return this.a.$getPassword(l,k)}store(l,k,f){return this.a.$setPassword(l,k,f)}delete(l,k){return this.a.$deletePassword(l,k)}}e.$mcc=F,e.$ncc=(0,C.$Nh)("IExtHostSecretState")}),define(Re[250],Me([1,0,3,8,2]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jdc=void 0;class F{static{this.a=0}constructor(l,k){this.d=k,this.c=new Map,this.b=l.getProxy(w.$_J.MainThreadShare)}async $provideShare(l,k,f){return await this.c.get(l)?.provideShare({selection:M.Range.to(k.selection),resourceUri:C.URI.revive(k.resourceUri)},f)??void 0}registerShareProvider(l,k){const f=F.a++;return this.c.set(f,k),this.b.$registerShareProvider(f,M.DocumentSelector.from(l,this.d),k.id,k.label,k.priority),{dispose:()=>{this.b.$unregisterShareProvider(f),this.c.delete(f)}}}}e.$Jdc=F}),define(Re[251],Me([1,0,7,3,153,6,8,16]),function(be,e,w,M,C,F,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jcc=e.$Icc=void 0;class k{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new w.$9K("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new w.$9K("statusBarItem.warningForeground")]])}#e;#t;constructor(c,p,$,g,t,n=w.StatusBarAlignment.Left,a){if(this.i=!1,this.k="",this.q=new F.$Qc,this.#e=c,this.#t=p,t&&g){this.c=(0,w.$LK)(g.identifier,t);const b=$.get(this.c);b&&(n=b.alignLeft?w.StatusBarAlignment.Left:w.StatusBarAlignment.Right,a=b.priority,this.j=!0,this.name=b.name,this.text=b.text,this.tooltip=b.tooltip,this.command=b.command,this.accessibilityInformation=b.accessibilityInformation)}else this.c=String(k.a++);this.e=g,this.f=t,this.g=n,this.h=this.u(a)}u(c){if((0,l.$Bf)(c))return c===Number.POSITIVE_INFINITY?Number.MAX_VALUE:c===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:c}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(c){this.k=c,this.v()}set name(c){this.m=c,this.v()}set tooltip(c){this.l=c,this.v()}set color(c){this.n=c,this.v()}set backgroundColor(c){c&&!k.b.has(c.id)&&(c=void 0),this.o=c,this.v()}set command(c){this.r?.fromApi!==c&&(this.p&&this.q.add(this.p),this.p=new F.$Qc,typeof c=="string"?this.r={fromApi:c,internal:this.#t.toInternal({title:"",command:c},this.p)}:c?this.r={fromApi:c,internal:this.#t.toInternal(c,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(c){this.t=c,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let c;this.e?this.f?c=`${this.e.identifier.value}.${this.f}`:c=this.e.identifier.value:c=this.f;let p;this.m?p=this.m:p=(0,C.localize)(0,null,this.e.displayName||this.e.name);let $=this.n;this.o&&($=k.b.get(this.o.id));const g=A.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,c,this.e?.identifier.value,p,this.k,g,this.r?.internal,$,this.o,this.g===w.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Icc=k;class f{constructor(c){this.b=[],this.a=c.createStatusBarEntry(void 0,"status.extensionMessage",w.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,C.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(c){const p={message:c};return this.b.unshift(p),this.c(),new w.$bK(()=>{const $=this.b.indexOf(p);$>=0&&(this.b.splice($,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class R{constructor(c,p){this.e=new Map,this.a=c.getProxy(M.$_J.MainThreadStatusBar),this.b=p,this.c=new f(this)}$acceptStaticEntries(c){for(const p of c)this.e.set(p.entryId,p)}createStatusBarEntry(c,p,$,g){return new k(this.a,this.b,this.e,c,p,$,g)}setStatusBarMessage(c,p){const $=this.c.setMessage(c);let g;return typeof p=="number"?g=setTimeout(()=>$.dispose(),p):typeof p<"u"&&p.then(()=>$.dispose(),()=>$.dispose()),new w.$bK(()=>{$.dispose(),clearTimeout(g)})}}e.$Jcc=R}),define(Re[84],Me([1,0,3,5,4]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bcc=e.$acc=void 0;class F{constructor(l,k){this.c=k,this.b=new M.$Md,this.onDidChangeStorage=this.b.event,this.a=l.getProxy(w.$_J.MainThreadStorage)}registerExtensionStorageKeysToSync(l,k){this.a.$registerExtensionStorageKeysToSync(l,k)}async initializeExtensionStorage(l,k,f){const R=await this.a.$initializeExtensionStorage(l,k);let D;return R&&(D=this.d(l,k,R)),D||f}setValue(l,k,f){return this.a.$setValue(l,k,f)}$acceptValue(l,k,f){const R=this.d(l,k,f);R&&this.b.fire({shared:l,key:k,value:R})}d(l,k,f){try{return JSON.parse(f)}catch(R){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${k}, global: ${l}): ${R}`)}}}e.$acc=F,e.$bcc=(0,C.$Nh)("IExtHostStorage")}),define(Re[85],Me([1,0,4,27,14,61,2]),function(be,e,w,M,C,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hcc=e.$gcc=void 0,e.$gcc=(0,w.$Nh)("IExtensionStoragePaths");let l=class{constructor(f,R,D){this.d=R,this.f=D,this.a=f.workspace??void 0,this.b=f.environment,this.whenReady=this.h().then(c=>this.c=c)}async g(f){return A.URI.joinPath(this.b.workspaceStorageHome,f)}async h(){if(!this.a)return Promise.resolve(void 0);const f=this.a.id,R=await this.g(f);try{return await this.f.value.stat(R),this.d.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",R),await this.f.value.createDirectory(R),await this.f.value.writeFile(A.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:A.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),R}catch(D){this.d.error("[ExtHostStorage]",D);return}}workspaceValue(f){if(this.c)return A.URI.joinPath(this.c,f.identifier.value)}globalValue(f){return A.URI.joinPath(this.b.globalStorageHome,f.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$hcc=l,e.$hcc=l=qe([We(0,M.$qM),We(1,C.$8i),We(2,F.$fcc)],l)}),define(Re[62],Me([1,0,5,3,4,2,17,6,7,155,9,181,21,36,182,40,12,8,31]),function(be,e,w,M,C,F,A,l,k,f,R,D,c,p,$,g,t,n,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lcc=e.$kcc=e.$jcc=e.$icc=void 0,e.$icc=(0,C.$Nh)("IExtHostTerminalService");class b{constructor(u,m,h,P){this.l=u,this._id=m,this.m=h,this.n=P,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(K=>this.f=K);const W=this;this.value={get name(){return W.n||""},get processId(){return W.b},get creationOptions(){return W.m},get exitStatus(){return W.h},get state(){return W.j},get selection(){return W.k},sendText(K,U=!0){W.q(),W.l.$sendText(W._id,K,U)},show(K){W.q(),W.l.$show(W._id,K)},hide(){W.q(),W.l.$hide(W._id)},dispose(){W.a||(W.a=!0,W.l.$dispose(W._id))},get dimensions(){if(!(W.d===void 0||W.g===void 0))return{columns:W.d,rows:W.g}}}}async create(u,m){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:u.name,shellPath:u.shellPath??void 0,shellArgs:u.shellArgs??void 0,cwd:u.cwd??void 0,env:u.env??void 0,icon:y(u.iconPath)??void 0,color:g.ThemeColor.isThemeColor(u.color)?u.color.id:void 0,initialText:u.message??void 0,strictEnv:u.strictEnv??void 0,hideFromUser:u.hideFromUser??void 0,isFeatureTerminal:m?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:m?.useShellEnvironment??void 0,location:m?.location||this.o(u.location,m?.resolvedExtHostIdentifier),isTransient:u.isTransient??void 0})}async createExtensionTerminal(u,m,h,P){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:h,color:g.ThemeColor.isThemeColor(P)?P.id:void 0,location:this.o(u,m),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(u,m){return typeof u=="object"?"parentTerminal"in u&&u.parentTerminal&&m?{parentTerminal:m}:"viewColumn"in u?{viewColumn:n.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus}:void 0:u}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(u){this.n=u}setExitStatus(u,m){this.h=Object.freeze({code:u,reason:m})}setDimensions(u,m){return u===this.d&&m===this.g||u===0||m===0?!1:(this.d=u,this.g=m,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(u){this.k=u}_setProcessId(u){this.f?(this.f(u),this.f=void 0):this.b.then(m=>{m!==u&&(this.b=Promise.resolve(u))})}}e.$jcc=b;class E{get onProcessReady(){return this.b.event}constructor(u){this.g=u,this.id=0,this.shouldPersist=!1,this.a=new w.$Md,this.onProcessData=this.a.event,this.b=new w.$Md,this.d=new w.$Md,this.onDidChangeProperty=this.d.event,this.f=new w.$Md,this.onProcessExit=this.f.event}refreshProperty(u){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${u}`)}updateProperty(u,m){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${u}, value: ${m}`)}async start(){}shutdown(){this.g.close()}input(u){this.g.handleInput?.(u)}resize(u,m){this.g.setDimensions?.({columns:u,rows:m})}clearBuffer(){}async processBinary(u){}acknowledgeDataEvent(u){}async setUnicodeVersion(u){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(u){this.g.onDidWrite(m=>this.a.fire(m)),this.g.onDidClose?.((m=void 0)=>{this.f.fire(m===void 0?void 0:m)}),this.g.onDidOverrideDimensions?.(m=>{m&&this.d.fire({type:"overrideDimensions",value:{cols:m.columns,rows:m.rows}})}),this.g.onDidChangeName?.(m=>{this.d.fire({type:"title",value:m})}),this.g.open(u||void 0),u&&this.g.setDimensions?.(u),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let v=1,r=class extends l.$Rc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(u=>u.value)}constructor(u,m,h){super(),this.Q=m,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new l.$Sc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new w.$Md,this.onDidCloseTerminal=this.H.event,this.I=new w.$Md,this.onDidOpenTerminal=this.I.event,this.J=new w.$Md,this.onDidChangeActiveTerminal=this.J.event,this.L=new w.$Md,this.onDidChangeTerminalDimensions=this.L.event,this.M=new w.$Md,this.onDidChangeTerminalState=this.M.event,this.N=new w.$Md,this.onDidChangeShell=this.N.event,this.O=new w.$Md({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new w.$Md({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=h.getProxy(M.$_J.MainThreadTerminalService),this.y=new $.$Lkb(this.a.$sendProcessData),this.a.$registerProcessSupport(u),this.Q.registerArgumentProcessor({processArgument:P=>{const W=K=>{const U=K;return this.W(U.instanceId)?.value};switch(P?.$mid){case 15:return W(P);default:{if(Array.isArray(P))for(let K=0;K<P.length&&P[K].$mid===15;K++)P[K]=W(P[K]);return P}}}}),this.B({dispose:()=>{for(const[P,W]of this.g)W.shutdown(!0)}})}getDefaultShell(u){return(u?this.u:this.s)?.path||""}getDefaultShellArgs(u){return(u?this.u:this.s)?.args||[]}createExtensionTerminal(u,m){const h=new b(this.a,(0,p.$dg)(),u,u.name),P=new E(u.pty);return h.createExtensionTerminal(u.location,this.R(u,m).resolvedExtHostIdentifier,y(u.iconPath),d(u.color)).then(W=>{const K=this.S(W,P);this.h[W]=K}),this.f.push(h),h.value}R(u,m){if(m=m||{},u.location&&typeof u.location=="object"&&"parentTerminal"in u.location){const h=u.location.parentTerminal;if(h){const P=this.f.find(W=>W.value===h);P&&(m.resolvedExtHostIdentifier=P._id)}}else u.location&&typeof u.location!="object"?m.location=u.location:m.location&&typeof m.location=="object"&&"splitActiveTerminal"in m.location&&(m.location={splitActiveTerminal:!0});return m}attachPtyToTerminal(u,m){if(!this.W(u))throw new Error(`Cannot resolve terminal with id ${u} for virtual process`);const P=new E(m),W=this.S(u,P);this.h[u]=W}async $acceptActiveTerminalChanged(u){const m=this.b;if(u===null){this.b=void 0,m!==this.b&&this.J.fire(this.b);return}const h=this.W(u);h&&(this.b=h,m!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(u,m){const h=this.W(u);h&&this.O.fire({terminal:h.value,data:m})}async $acceptTerminalDimensions(u,m,h){const P=this.W(u);P&&P.setDimensions(m,h)&&this.L.fire({terminal:P.value,dimensions:P.value.dimensions})}async $acceptDidExecuteCommand(u,m){const h=this.W(u);h&&this.P.fire({terminal:h.value,...m})}async $acceptTerminalMaximumDimensions(u,m,h){this.g.get(u)?.resize(m,h)}async $acceptTerminalTitleChange(u,m){const h=this.W(u);h&&(h.name=m)}async $acceptTerminalClosed(u,m,h){const P=this.Y(this.f,u);if(P!==null){const W=this.f.splice(P,1)[0];W.setExitStatus(m,h),this.H.fire(W.value)}}$acceptTerminalOpened(u,m,h,P){if(m){const U=this.Y(this.f,m);if(U!==null){this.f[U]._id=u,this.I.fire(this.terminals[U]),this.f[U].isOpen=!0;return}}const W={name:P.name,shellPath:P.executable,shellArgs:P.args,cwd:typeof P.cwd=="string"?P.cwd:F.URI.revive(P.cwd),env:P.env,hideFromUser:P.hideFromUser},K=new b(this.a,u,W,h);this.f.push(K),this.I.fire(K.value),K.isOpen=!0}async $acceptTerminalProcessId(u,m){this.W(u)?._setProcessId(m)}async $startExtensionTerminal(u,m){const h=this.W(u);if(!h)return{message:(0,f.localize)(0,null,u)};h.isOpen||await new Promise(W=>{const K=this.onDidOpenTerminal(async U=>{U===h.value&&(K.dispose(),W())})});const P=this.g.get(u);P?P.startSendingEvents(m):this.j[u]={initialDimensions:m}}S(u,m){const h=new l.$Qc;h.add(m.onProcessReady(W=>this.a.$sendProcessReady(u,W.pid,W.cwd,W.windowsPty))),h.add(m.onDidChangeProperty(W=>this.a.$sendProcessProperty(u,W))),this.y.startBuffering(u,m.onProcessData),h.add(m.onProcessExit(W=>this.U(u,W))),this.g.set(u,m);const P=this.j[u];return P&&m instanceof E&&(m.startSendingEvents(P.initialDimensions),delete this.j[u]),h}$acceptProcessAckDataEvent(u,m){this.g.get(u)?.acknowledgeDataEvent(m)}$acceptProcessInput(u,m){this.g.get(u)?.input(m)}$acceptTerminalInteraction(u){const m=this.W(u);m?.setInteractedWith()&&this.M.fire(m.value)}$acceptTerminalSelection(u,m){this.W(u)?.setSelection(m)}$acceptProcessResize(u,m,h){try{this.g.get(u)?.resize(m,h)}catch(P){if(P.code!=="EPIPE"&&P.code!=="ERR_IPC_CHANNEL_CLOSED")throw P}}$acceptProcessShutdown(u,m){this.g.get(u)?.shutdown(m)}$acceptProcessRequestInitialCwd(u){this.g.get(u)?.getInitialCwd().then(m=>this.a.$sendProcessProperty(u,{type:"initialCwd",value:m}))}$acceptProcessRequestCwd(u){this.g.get(u)?.getCwd().then(m=>this.a.$sendProcessProperty(u,{type:"cwd",value:m}))}$acceptProcessRequestLatency(u){return Promise.resolve(u)}registerLinkProvider(u){return this.z.add(u),this.z.size===1&&this.a.$startLinkProvider(),new k.$bK(()=>{this.z.delete(u),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(u,m,h){if(this.C.has(m))throw new Error(`Terminal profile provider "${m}" already registered`);return this.C.set(m,h),this.a.$registerProfileProvider(m,u.identifier.value),new k.$bK(()=>{this.C.delete(m),this.a.$unregisterProfileProvider(m)})}registerTerminalQuickFixProvider(u,m,h){if(this.D.has(u))throw new Error(`Terminal quick fix provider "${u}" is already registered`);return this.D.set(u,h),this.a.$registerQuickFixProvider(u,m),new k.$bK(()=>{this.D.delete(u),this.a.$unregisterQuickFixProvider(u)})}async $provideTerminalQuickFixes(u,m){const h=new c.$Wd().token;if(h.isCancellationRequested)return;const P=this.D.get(u);if(!P)return;const W=await P.provideTerminalQuickFixes(m,h);if(W===null||Array.isArray(W)&&W.length===0)return;const K=new l.$Qc;if(this.w.value=K,!Array.isArray(W))return W?n.TerminalQuickFix.from(W,this.Q.converter,K):void 0;const U=[];for(const B of W){const O=n.TerminalQuickFix.from(B,this.Q.converter,K);O&&U.push(O)}return U}async $createContributedProfileTerminal(u,m){const h=new c.$Wd().token;let P=await this.C.get(u)?.provideTerminalProfile(h);if(!h.isCancellationRequested){if(P&&!("options"in P)&&(P={options:P}),!P||!("options"in P))throw new Error(`No terminal profile options provided for id "${u}"`);if("pty"in P.options){this.createExtensionTerminal(P.options,m);return}this.createTerminalFromOptions(P.options,m)}}async $provideLinks(u,m){const h=this.W(u);if(!h)return[];this.F.delete(u),this.G.get(u)?.dispose(!0);const W=new c.$Wd;this.G.set(u,W);const K=[],U={terminal:h.value,line:m},B=[];for(const te of this.z)B.push(t.Promises.withAsyncBody(async Y=>{W.token.onCancellationRequested(()=>Y({provider:te,links:[]}));const ye=await te.provideTerminalLinks(U,W.token)||[];W.token.isCancellationRequested||Y({provider:te,links:ye})}));const O=await Promise.all(B);if(W.token.isCancellationRequested)return[];const N=new Map;for(const te of O)te&&te.links.length>0&&K.push(...te.links.map(Y=>{const ye={id:v++,startIndex:Y.startIndex,length:Y.length,label:Y.tooltip};return N.set(ye.id,{provider:te.provider,link:Y}),ye}));return this.F.set(u,N),K}$activateLink(u,m){const h=this.F.get(u)?.get(m);h&&h.provider.handleTerminalLink(h.link)}U(u,m){this.y.stopBuffering(u),this.g.delete(u),delete this.j[u];const h=this.h[u];h&&(h.dispose(),delete this.h[u]),this.a.$sendProcessExit(u,m)}W(u){return this.X(this.f,u)}X(u,m){const h=this.Y(u,m);return h!==null?u[h]:null}Y(u,m){const h=u.findIndex(P=>P._id===m);return h===-1?null:h}getEnvironmentVariableCollection(u){let m=this.n.get(u.identifier.value);return m||(m=new s,this.$(u.identifier.value,m)),m.getScopedEnvironmentVariableCollection(void 0)}Z(u,m){const h=(0,D.$gr)(m.map),P=(0,D.$hr)(m.descriptionMap);this.a.$setEnvironmentVariableCollection(u,m.persistent,h.length===0?void 0:h,P)}$initEnvironmentVariableCollections(u){u.forEach(m=>{const h=m[0],P=new s(m[1]);this.$(h,P)})}$acceptDefaultProfile(u,m){const h=this.s;this.s=u,this.u=m,h?.path!==u.path&&this.N.fire(u.path)}$(u,m){this.n.set(u,m),m.onDidChangeCollection(()=>{this.Z(u,m)})}};e.$kcc=r,e.$kcc=r=qe([We(1,a.$wM),We(2,A.$aM)],r);class s{get persistent(){return this.b}set persistent(u){this.b=u,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(u){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new w.$Md,this.map=new Map(u)}getScopedEnvironmentVariableCollection(u){const m=this.h(u);let h=this.a.get(m);return h||(h=new i(this,u),this.a.set(m,h),h.onDidChangeCollection(()=>this.d.fire())),h}replace(u,m,h,P){this.f(u,{value:m,type:k.EnvironmentVariableMutatorType.Replace,options:h??{applyAtProcessCreation:!0},scope:P})}append(u,m,h,P){this.f(u,{value:m,type:k.EnvironmentVariableMutatorType.Append,options:h??{applyAtProcessCreation:!0},scope:P})}prepend(u,m,h,P){this.f(u,{value:m,type:k.EnvironmentVariableMutatorType.Prepend,options:h??{applyAtProcessCreation:!0},scope:P})}f(u,m){if(m.options&&m.options.applyAtProcessCreation===!1&&!m.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const h=this.g(u,m.scope),P=this.map.get(h),W=m.options?{applyAtProcessCreation:m.options.applyAtProcessCreation??!1,applyAtShellIntegration:m.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!P||P.value!==m.value||P.type!==m.type||P.options?.applyAtProcessCreation!==W.applyAtProcessCreation||P.options?.applyAtShellIntegration!==W.applyAtShellIntegration||P.scope?.workspaceFolder?.index!==m.scope?.workspaceFolder?.index){const K=this.g(u,m.scope),U={variable:u,...m,options:W};this.map.set(K,U),this.d.fire()}}get(u,m){const h=this.g(u,m),P=this.map.get(h);return P?I(P):void 0}g(u,m){const h=this.h(m);return h.length?`${u}:::${h}`:u}h(u){return this.j(u?.workspaceFolder)??""}j(u){return u?u.uri.toString():void 0}getVariableMap(u){const m=new Map;for(const[h,P]of this.map)this.h(P.scope)===this.h(u)&&m.set(P.variable,I(P));return m}delete(u,m){const h=this.g(u,m);this.map.delete(h),this.d.fire()}clear(u){if(u?.workspaceFolder){for(const[m,h]of this.map)h.scope?.workspaceFolder?.index===u.workspaceFolder.index&&this.map.delete(m);this.k(u)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(u,m){const h=this.h(m),P=this.descriptionMap.get(h);if(!P||P.description!==u){let W;typeof u=="string"?W=u:W=u?.value.split(`

`)[0];const K={description:W,scope:m};this.descriptionMap.set(h,K),this.d.fire()}}getDescription(u){const m=this.h(u);return this.descriptionMap.get(m)?.description}k(u){const m=this.h(u);this.descriptionMap.delete(m)}}class i{get persistent(){return this.b.persistent}set persistent(u){this.b.persistent=u}get onDidChangeCollection(){return this.a&&this.a.event}constructor(u,m){this.b=u,this.d=m,this.a=new w.$Md}getScoped(u){return this.b.getScopedEnvironmentVariableCollection(u)}replace(u,m,h){this.b.replace(u,m,h,this.d)}append(u,m,h){this.b.append(u,m,h,this.d)}prepend(u,m,h){this.b.prepend(u,m,h,this.d)}get(u){return this.b.get(u,this.d)}forEach(u,m){this.b.getVariableMap(this.d).forEach((h,P)=>u.call(m,P,h,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(u){this.b.delete(u,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(u){this.b.setDescription(u,this.d)}get description(){return this.b.getDescription(this.d)}}let o=class extends r{constructor(u,m){super(!1,u,m)}createTerminal(u,m,h){throw new R.$$}createTerminalFromOptions(u,m){throw new R.$$}};e.$lcc=o,e.$lcc=o=qe([We(0,a.$wM),We(1,A.$aM)],o);function y(S){if(!(!S||typeof S=="string"))return"id"in S?{id:S.id,color:S.color}:S}function d(S){return g.ThemeColor.isThemeColor(S)?S:void 0}function I(S){const u={...S};return delete u.scope,u.options=u.options??void 0,delete u.variable,u}}),define(Re[252],Me([1,0,281,12,26,21,5,202,93,6,24,16,36,3,17,104,8,7,45,76,56,25]),function(be,e,w,M,C,F,A,l,k,f,R,D,c,p,$,g,t,n,a,b,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vdc=e.$udc=e.$tdc=e.$sdc=void 0;let r=class{constructor(U,B,O){this.k=O,this.d=new A.$Md,this.f=new Map,this.onResultsChanged=this.d.event,this.results=[],this.g=U.getProxy(p.$_J.MainThreadTesting),this.j=new h(this.g),this.h=new y(this.g),B.registerArgumentProcessor({processArgument:N=>{switch(N?.$mid){case 16:{const te=N,Y=te.tests[te.tests.length-1].item.extId;return this.f.get(a.$5I.root(Y))?.collection.tree.get(Y)?.actual??(0,g.$mM)(N)}case 18:{const{extId:te,message:Y}=N;return{test:this.f.get(a.$5I.root(te))?.collection.tree.get(te)?.actual,message:t.TestMessage.to(Y)}}default:return N}}}),B.registerCommand(!1,"testing.getExplorerSelection",async()=>{const N=await B.executeCommand("_testing.getExplorerSelection"),te=Y=>{const ye=this.f.get(a.$5I.root(Y));if(ye)return a.$5I.isRoot(Y)?ye.controller:ye.collection.tree.get(Y)?.actual};return{include:N?.include.map(te).filter(D.$Ff)||[],exclude:N?.exclude.map(te).filter(D.$Ff)||[]}})}createTestController(U,B,O,N){if(this.f.has(B))throw new Error(`Attempt to insert a duplicate controller with ID "${B}"`);const te=new f.$Qc,Y=te.add(new g.$pM(B,O,this.k));Y.root.label=O;const ye=new Map,Ee=this.g,Pe={items:Y.root.children,get label(){return O},set label(ae){O=ae,Y.root.label=ae,Ee.$updateController(B,{label:O})},get refreshHandler(){return N},set refreshHandler(ae){N=ae,Ee.$updateController(B,{canRefresh:!!ae})},get id(){return B},createRunProfile:(ae,Se,ue,$e,ie,z)=>{let V=(0,k.$Bi)(ae);for(;ye.has(V);)V++;return new P(this.g,ye,B,V,ae,Se,ue,$e,ie,z)},createTestItem(ae,Se,ue){return new g.$nM(B,ae,Se,ue)},createTestRun:(ae,Se,ue=!0)=>this.h.createTestRun(U,B,Y,ae,Se,ue),invalidateTestResults:ae=>{if(ae===void 0)this.g.$markTestRetired(void 0);else{const Se=ae instanceof Array?ae:[ae];this.g.$markTestRetired(Se.map(ue=>a.$5I.fromExtHostTestItem(ue,B).toString()))}},set resolveHandler(ae){Y.resolveHandler=ae},get resolveHandler(){return Y.resolveHandler},dispose:()=>{te.dispose()}};Ee.$registerTestController(B,O,!!N),te.add((0,f.$Pc)(()=>Ee.$unregisterTestController(B)));const X={controller:Pe,collection:Y,profiles:ye,extension:U};return this.f.set(B,X),te.add((0,f.$Pc)(()=>this.f.delete(B))),te.add(Y.onDidGenerateDiff(ae=>Ee.$publishDiff(B,ae.map(E.TestsDiffOp.serialize)))),Pe}createTestObserver(){return this.j.checkout()}async runTests(U,B=F.CancellationToken.None){const O=d(U);if(!O)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const N=this.f.get(O.controllerId);if(!N)throw new Error("Controller not found");await this.g.$runTests({isUiTriggered:!1,targets:[{testIds:U.include?.map(te=>a.$5I.fromExtHostTestItem(te,N.collection.root.id).toString())??[N.collection.root.id],profileGroup:W[O.kind],profileId:O.profileId,controllerId:O.controllerId}],exclude:U.exclude?.map(te=>te.id)},B)}$syncTests(){for(const{collection:U}of this.f.values())U.flushDiff();return Promise.resolve()}$provideFileCoverage(U,B,O){return(0,w.$qb)(this.h.trackers,te=>te.id===U?te.getCoverage(B):void 0)?.provideFileCoverage(O)??Promise.resolve([])}$resolveFileCoverage(U,B,O,N){return(0,w.$qb)(this.h.trackers,Y=>Y.id===U?Y.getCoverage(B):void 0)?.resolveFileCoverage(O,N)??Promise.resolve([])}$configureRunProfile(U,B){this.f.get(U)?.profiles.get(B)?.configureHandler?.()}async $refreshTests(U,B){await this.f.get(U)?.controller.refreshHandler?.(B)}$publishTestResults(U){this.results=Object.freeze(U.map(B=>(0,R.$3m)(t.TestResults.to(B))).concat(this.results).sort((B,O)=>O.completedAt-B.completedAt).slice(0,32)),this.d.fire()}async $expandTest(U,B){const O=this.f.get(a.$5I.fromString(U).controllerId)?.collection;O&&(await O.expand(U,B<0?1/0:B),O.flushDiff())}$acceptDiff(U){this.j.applyDiff(U.map(E.TestsDiffOp.deserialize))}async $runControllerTests(U,B){return Promise.all(U.map(O=>this.l(O,!1,B)))}async $startContinuousRun(U,B){const O=new F.$Wd(B),N=await Promise.all(U.map(te=>this.l(te,!0,O.token)));return!B.isCancellationRequested&&!N.some(te=>te.error)&&await new Promise(te=>B.onCancellationRequested(te)),O.dispose(!0),N}async l(U,B,O){const N=this.f.get(U.controllerId);if(!N)return{};const{collection:te,profiles:Y,extension:ye}=N,Ee=Y.get(U.profileId);if(!Ee)return{};const Pe=U.testIds.map(ue=>te.tree.get(ue)).filter(D.$Ff),X=U.excludeExtIds.map(ue=>N.collection.tree.get(ue)).filter(D.$Ff).filter(ue=>Pe.some($e=>$e.fullId.compare(ue.fullId)===2));if(!Pe.length)return{};const ae=new n.$JL(Pe.some(ue=>ue.actual instanceof g.$oM)?void 0:Pe.map(ue=>ue.actual),X.map(ue=>ue.actual),Ee,B),Se=(0,E.$7I)(U)&&this.h.prepareForMainThreadTestRun(ae,I.fromInternal(U,N.collection),ye,O);try{return await Ee.runHandler(ae,O),{}}catch(ue){return{error:String(ue)}}finally{Se&&(Se.hasRunningTasks&&!O.isCancellationRequested&&await A.Event.toPromise(Se.onEnd),Se.dispose())}}$cancelExtensionTestRun(U){U===void 0?this.h.cancelAllRuns():this.h.cancelRunById(U)}};e.$sdc=r,e.$sdc=r=qe([We(0,$.$aM)],r);const s=1e4;var i;(function(K){K[K.Running=0]="Running",K[K.Cancelling=1]="Cancelling",K[K.Ended=2]="Ended"})(i||(i={}));class o extends f.$Rc{get hasRunningTasks(){return this.g.size>0}get id(){return this.s.id}constructor(U,B,O,N){super(),this.s=U,this.u=B,this.w=O,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new A.$Md),this.onEnd=this.m.event,this.j=this.B(new F.$Wd(N));const te=this.B(new M.$5g(()=>this.y(),s));this.B(this.j.token.onCancellationRequested(()=>te.schedule()))}cancel(){this.f===0?(this.j.cancel(),this.f=1):this.f===1&&this.y()}getCoverage(U){return this.g.get(U)?.coverage}createRun(U){const B=this.s.id,O=this.s.controllerId,N=(0,c.$dg)(),te=new S(this.u,B,N),Y=X=>(ae,...Se)=>{if(Ee){console.warn(`Setting the state of test "${ae.id}" is a no-op after the run ends.`);return}this.s.isIncluded(ae)&&(this.C(ae),X(ae,...Se))},ye=(X,ae)=>{const Se=ae instanceof Array?ae.map(t.TestMessage.from):[t.TestMessage.from(ae)];if(Se.some(ue=>ue.contextValue!==void 0)&&(0,v.$_E)(this.w,"testMessageContextValue"),X.uri&&X.range){const ue={range:t.Range.from(X.range),uri:X.uri};for(const $e of Se)$e.location=$e.location||ue}this.u.$appendTestMessagesInRun(B,N,a.$5I.fromExtHostTestItem(X,O).toString(),Se)};let Ee=!1;const Pe={isPersisted:this.s.isPersisted,token:this.j.token,name:U,get coverageProvider(){return te.coverageProvider},set coverageProvider(X){te.coverageProvider=X},enqueued:Y(X=>{this.u.$updateTestStateInRun(B,N,a.$5I.fromExtHostTestItem(X,O).toString(),1)}),skipped:Y(X=>{this.u.$updateTestStateInRun(B,N,a.$5I.fromExtHostTestItem(X,O).toString(),5)}),started:Y(X=>{this.u.$updateTestStateInRun(B,N,a.$5I.fromExtHostTestItem(X,O).toString(),2)}),errored:Y((X,ae,Se)=>{ye(X,ae),this.u.$updateTestStateInRun(B,N,a.$5I.fromExtHostTestItem(X,O).toString(),6,Se)}),failed:Y((X,ae,Se)=>{ye(X,ae),this.u.$updateTestStateInRun(B,N,a.$5I.fromExtHostTestItem(X,O).toString(),4,Se)}),passed:Y((X,ae)=>{this.u.$updateTestStateInRun(B,N,a.$5I.fromExtHostTestItem(X,this.s.controllerId).toString(),3,ae)}),appendOutput:(X,ae,Se)=>{Ee||(Se&&(this.s.isIncluded(Se)?this.C(Se):Se=void 0),this.u.$appendOutputToRun(B,N,C.$ae.fromString(X),ae&&t.location.from(ae),Se&&a.$5I.fromExtHostTestItem(Se,O).toString()))},end:()=>{Ee||(Ee=!0,this.u.$finishedTestRunTask(B,N),this.g.delete(N),this.g.size||this.z())}};return this.g.set(N,{run:Pe,coverage:te}),this.u.$startedTestRunTask(B,{id:N,name:U,running:!0}),Pe}y(){for(const{run:U}of this.g.values())U.end()}z(){this.f!==2&&(this.f=2,this.m.fire())}C(U){if(!(U instanceof g.$nM))throw new b.$5L(U.id);if(this.h.has(a.$5I.fromExtHostTestItem(U,this.s.controllerId).toString()))return;const B=[],O=this.s.colllection.root;for(;;){const N=t.TestItem.from(U);if(B.unshift(N),this.h.has(N.extId)||(this.h.add(N.extId),U===O))break;U=U.parent||O}this.u.$addTestsToRun(this.s.controllerId,this.s.id,B)}dispose(){this.z(),super.dispose()}}class y{get trackers(){return this.d.values()}constructor(U){this.f=U,this.d=new Map}prepareForMainThreadTestRun(U,B,O,N){return this.g(U,B,O,N)}cancelRunById(U){for(const B of this.d.values())if(B.id===U){B.cancel();return}}cancelAllRuns(){for(const U of this.d.values())U.cancel()}createTestRun(U,B,O,N,te,Y){const ye=this.d.get(N);if(ye)return ye.createRun(te);const Ee=I.fromPublic(B,O,N,Y),Pe=d(N);this.f.$startedExtensionTestRun({controllerId:B,continuous:!!N.continuous,profile:Pe&&{group:W[Pe.kind],id:Pe.profileId},exclude:N.exclude?.map(ae=>a.$5I.fromExtHostTestItem(ae,O.root.id).toString())??[],id:Ee.id,include:N.include?.map(ae=>a.$5I.fromExtHostTestItem(ae,O.root.id).toString())??[O.root.id],persist:Y});const X=this.g(N,Ee,U);return A.Event.once(X.onEnd)(()=>{this.f.$finishedExtensionTestRun(Ee.id),X.dispose()}),X.createRun(te)}g(U,B,O,N){const te=new o(B,this.f,O,N);return this.d.set(U,te),A.Event.once(te.onEnd)(()=>this.d.delete(U)),te}}e.$tdc=y;const d=K=>{if(K.profile){if(!(K.profile instanceof P))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return K.profile}};class I{static fromPublic(U,B,O,N){return new I(U,(0,c.$dg)(),O.include?.map(te=>a.$5I.fromExtHostTestItem(te,U).toString())??[U],O.exclude?.map(te=>a.$5I.fromExtHostTestItem(te,U).toString())??[],N,B)}static fromInternal(U,B){return new I(U.controllerId,U.runId,U.testIds,U.excludeExtIds,!0,B)}constructor(U,B,O,N,te,Y){this.controllerId=U,this.id=B,this.isPersisted=te,this.colllection=Y,this.d=O.map(ye=>ye+"\0"),this.f=N.map(ye=>ye+"\0")}isIncluded(U){const B=a.$5I.fromExtHostTestItem(U,this.controllerId).toString()+"\0";for(const O of this.f)if(B===O||B.startsWith(O))return!1;for(const O of this.d)if(B===O||B.startsWith(O))return!0;return!1}}e.$udc=I;class S{set coverageProvider(U){if(this.d)throw new Error("The TestCoverageProvider cannot be replaced after being provided");U&&(this.d=U,this.g.$signalCoverageAvailable(this.h,this.j))}get coverageProvider(){return this.d}constructor(U,B,O){this.g=U,this.h=B,this.j=O}async provideFileCoverage(U){if(!this.d)return[];this.f||(this.f=(async()=>this.d.provideFileCoverage(U))());try{return(await this.f)?.map(t.TestCoverage.fromFile)??[]}catch(B){throw this.f=void 0,B}}async resolveFileCoverage(U,B){const O=await this.f;let N=O?.[U];return!this.d||!O||!N?[]:(N.detailedCoverage||(N=O[U]=await this.d.resolveFileCoverage?.(N,B)??N),N.detailedCoverage?.map(t.TestCoverage.fromDetailed)??[])}}class u{get isEmpty(){return this.d.size===0&&this.g.size===0&&this.f.size===0}constructor(U){this.j=U,this.d=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(U){this.d.add(U)}update(U){Object.assign(U.revived,t.TestItem.toPlain(U.item)),this.d.has(U)||this.f.add(U)}remove(U){if(this.d.has(U)){this.d.delete(U);return}this.f.delete(U);const B=a.$5I.parentId(U.item.extId);if(B&&this.h.has(B.toString())){this.h.add(U.item.extId);return}this.g.add(U)}getChangeEvent(){const{d:U,f:B,g:O}=this;return{get added(){return[...U].map(N=>N.revived)},get updated(){return[...B].map(N=>N.revived)},get removed(){return[...O].map(N=>N.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class m extends E.$_I{constructor(){super(...arguments),this.s=new A.$Md,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(U){return this.f.get(U)}getMirroredTestDataByReference(U){return this.f.get(U.id)}q(U,B){return{...U,revived:t.TestItem.toPlain(U.item),depth:B?B.depth+1:0,children:new Set}}p(){return new u(this.s)}}class h{constructor(U){this.f=U}checkout(){this.d||(this.d=this.g());const U=this.d;return U.observers++,{onDidChangeTest:U.tests.onDidChangeTests,get tests(){return[...U.tests.rootTests].map(B=>B.revived)},dispose:(0,l.$cb)(()=>{--U.observers===0&&(this.f.$unsubscribeFromDiffs(),this.d=void 0)})}}getMirroredTestDataByReference(U){return this.d?.tests.getMirroredTestDataByReference(U)}applyDiff(U){this.d?.tests.apply(U)}g(){const U=new m;return this.f.$subscribeToDiffs(),{observers:0,tests:U}}}class P{#e;#t;get label(){return this.f}set label(U){U!==this.f&&(this.f=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:U}))}get supportsContinuousRun(){return this.h}set supportsContinuousRun(U){U!==this.h&&(this.h=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:U}))}get isDefault(){return this.g}set isDefault(U){U!==this.g&&(this.g=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:U}))}get tag(){return this._tag}set tag(U){U?.id!==this._tag?.id&&(this._tag=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:U?t.TestTag.namespace(this.controllerId,U.id):null}))}get configureHandler(){return this.d}set configureHandler(U){U!==this.d&&(this.d=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!U}))}constructor(U,B,O,N,te,Y,ye,Ee=!1,Pe=void 0,X=!1){this.controllerId=O,this.profileId=N,this.f=te,this.kind=Y,this.runHandler=ye,this.g=Ee,this._tag=Pe,this.h=X,this.#e=U,this.#t=B,B.set(N,this);const ae=W[Y];if(typeof ae!="number")throw new Error(`Unknown TestRunProfile.group ${Y}`);this.#e.$publishTestRunProfile({profileId:N,controllerId:O,tag:Pe?t.TestTag.namespace(this.controllerId,Pe.id):null,label:te,group:ae,isDefault:Ee,hasConfigurationHandler:!1,supportsContinuousRun:X})}dispose(){this.#t?.delete(this.profileId)&&(this.#t=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.$vdc=P;const W={[n.TestRunProfileKind.Coverage]:8,[n.TestRunProfileKind.Debug]:4,[n.TestRunProfileKind.Run]:2}}),define(Re[253],Me([1,0,18,9,5,3,105,8,7]),function(be,e,w,M,C,F,A,l,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kcc=void 0;class f{constructor(D,c){this.i=c,this.a=new C.$Md({onListenerError:M.$1}),this.b=new C.$Md({onListenerError:M.$1}),this.c=new C.$Md({onListenerError:M.$1}),this.d=new C.$Md({onListenerError:M.$1}),this.f=new C.$Md({onListenerError:M.$1}),this.g=new C.$Md({onListenerError:M.$1}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=D.getProxy(F.$_J.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(p=>this.g.fire(p)),this.i.onDidChangeActiveTextEditor(p=>this.f.fire(p))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(D){const c=this.i.allEditors();return D?c:c.map(p=>p.value)}async showTextDocument(D,c,p){let $;typeof c=="number"?$={position:l.ViewColumn.from(c),preserveFocus:p}:typeof c=="object"?$={position:l.ViewColumn.from(c.viewColumn),preserveFocus:c.preserveFocus,selection:typeof c.selection=="object"?l.Range.from(c.selection):void 0,pinned:typeof c.preview=="boolean"?!c.preview:void 0}:$={preserveFocus:!1};const g=await this.h.$tryShowTextDocument(D.uri,$),t=g&&this.i.getEditor(g);if(t)return t.value;throw g?new Error(`Could NOT open editor for "${D.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${D.uri.toString()}".`)}createTextEditorDecorationType(D,c){return new A.$hM(this.h,D,c).value}$acceptEditorPropertiesChanged(D,c){const p=this.i.getEditor(D);if(!p)throw new Error("unknown text editor");if(c.options&&p._acceptOptions(c.options),c.selections){const $=c.selections.selections.map(l.Selection.to);p._acceptSelections($)}if(c.visibleRanges){const $=w.$Gb(c.visibleRanges.map(l.Range.to));p._acceptVisibleRanges($)}if(c.options&&this.b.fire({textEditor:p.value,options:{...c.options,lineNumbers:l.TextEditorLineNumbersStyle.to(c.options.lineNumbers)}}),c.selections){const $=k.TextEditorSelectionChangeKind.fromValue(c.selections.source),g=c.selections.selections.map(l.Selection.to);this.a.fire({textEditor:p.value,selections:g,kind:$})}if(c.visibleRanges){const $=w.$Gb(c.visibleRanges.map(l.Range.to));this.c.fire({textEditor:p.value,visibleRanges:$})}}$acceptEditorPositionData(D){for(const c in D){const p=this.i.getEditor(c);if(!p)throw new Error("Unknown text editor");const $=l.ViewColumn.to(D[c]);p.value.viewColumn!==$&&(p._acceptViewColumn($),this.d.fire({textEditor:p.value,viewColumn:$}))}}getDiffInformation(D){return Promise.resolve(this.h.$getDiffInformation(D))}}e.$Kcc=f}),define(Re[254],Me([1,0,2,4,3,6,7,8,20,16]),function(be,e,w,M,C,F,A,l,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ndc=e.$mdc=void 0,e.$mdc=(0,M.$Nh)("IExtHostTimeline");class R{constructor(p,$){this.b=new Map,this.c=new Map,this.a=p.getProxy(C.$_J.MainThreadTimeline),$.registerArgumentProcessor({processArgument:(g,t)=>{if(g&&g.$mid===12)if(this.b.get(g.source)&&k.$2l.equals(t,this.b.get(g.source)?.extension)){const n=g.uri===void 0?void 0:w.URI.revive(g.uri);return this.c.get(g.source)?.get(D(n))?.get(g.handle)}else return;return g}})}async $getTimeline(p,$,g,t){return this.b.get(p)?.provider.provideTimeline(w.URI.revive($),g,t)}registerTimelineProvider(p,$,g,t){const n=new F.$Qc,a=this.d($.id,t,n).bind(this);let b;$.onDidChange&&(b=$.onDidChange(v=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...v,id:$.id}),this));const E=this.c;return this.f({...$,scheme:p,onDidChange:void 0,async provideTimeline(v,r,s){r?.resetCache&&(n.clear(),E.get($.id)?.clear());const i=await $.provideTimeline(v,r,s);if(i==null)return;const o=a(v,r);return{...i,source:$.id,items:i.items.map(o)}},dispose(){for(const v of E.values())v.get($.id)?.clear();b?.dispose(),n.dispose()}},g)}d(p,$,g){return(t,n)=>{let a;if(n?.cacheResults){let b=this.c.get(p);b===void 0&&(b=new Map,this.c.set(p,b));const E=D(t);a=b.get(E),a===void 0&&(a=new Map,b.set(E,a))}return b=>{const{iconPath:E,...v}=b,r=`${p}|${b.id??b.timestamp}`;a?.set(r,b);let s,i,o;b.iconPath&&(E instanceof A.$8K?o={id:E.id,color:E.color}:w.URI.isUri(E)?(s=E,i=E):{light:s,dark:i}=E);let y;return A.$BK.isMarkdownString(v.tooltip)?y=l.MarkdownString.from(v.tooltip):(0,f.$xf)(v.tooltip)?y=v.tooltip:A.$BK.isMarkdownString(v.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),y=l.MarkdownString.from(v.detail)):(0,f.$xf)(v.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),y=v.detail),{...v,id:v.id??void 0,handle:r,source:p,command:b.command?$.toInternal(b.command,g):void 0,icon:s,iconDark:i,themeIcon:o,tooltip:y,accessibilityInformation:b.accessibilityInformation}}}}f(p,$){if(this.b.get(p.id))throw new Error(`Timeline Provider ${p.id} already exists.`);return this.a.$registerTimelineProvider({id:p.id,label:p.label,scheme:p.scheme}),this.b.set(p.id,{provider:p,extension:$}),(0,F.$Pc)(()=>{for(const t of this.c.values())t.get(p.id)?.clear();this.b.delete(p.id),this.a.$unregisterTimelineProvider(p.id),p.dispose()})}}e.$ndc=R;function D(c){return c?.toString()}}),define(Re[86],Me([1,0,21,5,6,157,4,14,184,3,27,17,7]),function(be,e,w,M,C,F,A,l,k,f,R,D,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xvb=e.$Wvb=e.TunnelDtoConverter=void 0;class p extends k.$av{}var $;(function(t){function n(b){return{remoteAddress:b.remoteAddress,localAddress:b.localAddress,public:!!b.public,privacy:b.privacy??(b.public?k.TunnelPrivacyId.Public:k.TunnelPrivacyId.Private),protocol:b.protocol}}t.fromApiTunnel=n;function a(b){return{remoteAddress:{host:b.tunnelRemoteHost,port:b.tunnelRemotePort},localAddress:b.localAddress,public:b.privacy!==k.TunnelPrivacyId.ConstantPrivate&&b.privacy!==k.TunnelPrivacyId.ConstantPrivate,privacy:b.privacy,protocol:b.protocol}}t.fromServiceTunnel=a})($||(e.TunnelDtoConverter=$={})),e.$Wvb=(0,A.$Nh)("IExtHostTunnelService");let g=class extends C.$Rc{constructor(n,a,b){super(),this.s=b,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new M.$Md,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=n.getProxy(f.$_J.MainThreadTunnelService)}async openTunnel(n,a){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${n.identifier.value} called openTunnel API for ${a.remoteAddress.host}:${a.remoteAddress.port}.`);const b=await this.a.$openTunnel(a,n.displayName);if(b){const E=new p(b.remoteAddress,b.localAddress,()=>this.a.$closeTunnel(b.remoteAddress));return this.B(E),E}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(n,a){const b=this.u();return this.r.set(b,{selector:n,provider:a}),this.a.$registerPortsAttributesProvider(n,b),new c.$bK(()=>{this.r.delete(b),this.a.$unregisterPortsAttributesProvider(b)})}async $providePortAttributes(n,a,b,E,v){const r=[];for(const i of n){const o=this.r.get(i);if(!o)return[];r.push(...await Promise.all(a.map(async y=>{let d;try{d=await o.provider.providePortAttributes({port:y,pid:b,commandLine:E},v)}catch{d=await o.provider.providePortAttributes(y,b,E,v)}return{providedAttributes:d,port:y}})))}const s=r.filter(i=>!!i.providedAttributes);return s.length>0?s.map(i=>({autoForwardAction:i.providedAttributes.autoForwardAction,port:i.port})):[]}async $registerCandidateFinder(n){}registerTunnelProvider(n,a){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(E,v)=>await n.provideTunnel(E,v,new w.$Wd().token)??void 0;const b=a.tunnelFeatures?{elevation:!!a.tunnelFeatures?.elevation,privacyOptions:a.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(b),Promise.resolve((0,C.$Pc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(n,a){if(n){n.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(n.candidatePortSource),n.showCandidatePort&&(this.f=n.showCandidatePort,this.a.$setCandidateFilter());const b=n.tunnelFactory??(a?this.w(a):void 0);if(b){this.b=b;let E=n.tunnelFeatures?.privacyOptions??[];n.tunnelFeatures?.public&&E.length===0&&(E=[{id:"private",label:F.localize(0,null),themeIcon:"lock"},{id:"public",label:F.localize(1,null),themeIcon:"eye"}]);const v=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,public:!!n.tunnelFeatures?.public,privacyOptions:E}:void 0;this.a.$setTunnelProvider(v)}}else this.b=void 0;return(0,C.$Pc)(()=>{this.b=void 0})}w(n){}async $closeTunnel(n,a){if(this.g.has(n.host)){const b=this.g.get(n.host);b.has(n.port)&&(a&&b.get(n.port).disposeListener.dispose(),await b.get(n.port).tunnel.dispose(),b.delete(n.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(n,a){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const b=this.b(n,a);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),b!==void 0){const E=await b;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),E===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(n.remoteAddress.host)||this.g.set(n.remoteAddress.host,new Map);const v=this.B(E.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(E.remoteAddress))));return this.g.get(n.remoteAddress.host).set(n.remoteAddress.port,{tunnel:E,disposeListener:v}),$.fromApiTunnel(E)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(b){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),b instanceof Error)return b.message}}async $applyCandidateFilter(n){const a=await Promise.all(n.map(E=>this.f(E.host,E.port,E.detail??""))),b=n.filter((E,v)=>a[v]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${n.map(E=>E.port).join(", ")} to ${b.map(E=>E.port).join(", ")}`),b}};e.$Xvb=g,e.$Xvb=g=qe([We(0,D.$aM),We(1,R.$qM),We(2,l.$8i)],g)}),define(Re[255],Me([1,0,6,13,2,3]),function(be,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wdc=void 0;class A{static{this.a=new Set([M.Schemas.http,M.Schemas.https])}constructor(k){this.c=new Map,this.b=k.getProxy(F.$_J.MainThreadUriOpeners)}registerExternalUriOpener(k,f,R,D){if(this.c.has(f))throw new Error(`Opener with id '${f}' already registered`);const c=D.schemes.find(p=>!A.a.has(p));if(c)throw new Error(`Scheme '${c}' is not supported. Only http and https are currently supported.`);return this.c.set(f,R),this.b.$registerUriOpener(f,D.schemes,k,D.label),(0,w.$Pc)(()=>{this.c.delete(f),this.b.$unregisterUriOpener(f)})}async $canOpenUri(k,f,R){const D=this.c.get(k);if(!D)throw new Error(`Unknown opener with id: ${k}`);const c=C.URI.revive(f);return D.canOpenExternalUri(c,R)}async $openUri(k,f,R){const D=this.c.get(k);if(!D)throw new Error(`Unknown opener id: '${k}'`);return D.openExternalUri(C.URI.revive(f.resolvedUri),{sourceUri:C.URI.revive(f.sourceUri)},R)}}e.$wdc=A}),define(Re[256],Me([1,0,3,2,6,9,20]),function(be,e,w,M,C,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mcc=void 0;class l{static{this.a=0}constructor(f){this.c=new A.$3l,this.d=new Map,this.b=f.getProxy(w.$_J.MainThreadUrls)}registerUriHandler(f,R){const D=f.identifier;if(this.c.has(D))throw new Error(`Protocol handler already registered for extension ${D}`);const c=l.a++;return this.c.add(D),this.d.set(c,R),this.b.$registerUriHandler(c,D,f.displayName||f.name),(0,C.$Pc)(()=>{this.c.delete(D),this.d.delete(c),this.b.$unregisterUriHandler(c)})}$handleExternalUri(f,R){const D=this.d.get(f);if(!D)return Promise.resolve(void 0);try{D.handleUri(M.URI.revive(R))}catch(c){(0,F.$Z)(c)}return Promise.resolve(void 0)}async createAppUri(f){return M.URI.revive(await this.b.$createAppUri(f))}}e.$Mcc=l}),define(Re[63],Me([1,0,5,6,13,24,2,169,191,77,3]),function(be,e,w,M,C,F,A,l,k,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rcc=e.$Qcc=e.$Pcc=e.$Occ=e.$Ncc=void 0;class D{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;constructor(E,v,r,s,i,o,y){this.#s="",this.#o=!1,this.#a=!1,this._onMessageEmitter=new w.$Md,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new w.$Md,this._onDidDispose=this.#h.event,this.#e=E,this.#t=v,this.#r=r,this.#l=s,this.#u=i,this.#n=o,this.#c=c(o),this.#d=p(o),this.#i=y}#h;dispose(){this.#o=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(E){return this.#a=!0,(0,f.$1ob)(E,this.#l)}get cspSource(){const E=this.#n.extensionLocation;if(E.scheme===C.Schemas.https||E.scheme===C.Schemas.http){let v=E.toString();return v.endsWith("/")||(v+="/"),v+" "+f.$Zob}return f.$Zob}get html(){return this.a(),this.#s}set html(E){this.a(),this.#s!==E&&(this.#s=E,this.#d&&!this.#a&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(E)&&(this.#a=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(E)))}get options(){return this.a(),this.#r}set options(E){this.a(),F.$6m(this.#r,E)||this.#t.$setOptions(this.#e,t(this.#n,this.#u,E)),this.#r=E}async postMessage(E){if(this.#o)return!1;const v=(0,k.$rcb)(E,{serializeBuffersForPostMessage:this.#c});return this.#t.$postMessage(this.#e,v.message,...v.buffers)}a(){if(this.#o)throw new Error("Webview is disposed")}b(E){if(!this.#d)return E;const v=this.#n.extensionLocation?.scheme===C.Schemas.vscodeRemote,r=this.#n.extensionLocation.scheme===C.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return E.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,i,o,y,d,I)=>{const S=A.URI.from({scheme:y||"file",path:decodeURIComponent(d)}),u=(0,f.$1ob)(S,{isRemote:v,authority:r}).toString();return`${i}${u}${I}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,i,o,y,d,I)=>{const S=A.URI.from({scheme:y||"file",path:decodeURIComponent(d)}),u=(0,f.$1ob)(S,{isRemote:v,authority:r}).toString();return`${i}${u}${I}`})}}e.$Ncc=D;function c(b){try{const E=(0,l.$Jo)((0,l.$Io)(b.engines.vscode));return!!E&&E.majorBase>=1&&E.minorBase>=57}catch{return!1}}e.$Occ=c;function p(b){try{const E=(0,l.$Jo)((0,l.$Io)(b.engines.vscode));return E?E.majorBase<1||E.majorBase===1&&E.minorBase<60:!1}catch{return!1}}class $ extends M.$Rc{constructor(E,v,r,s,i){super(),this.c=v,this.f=r,this.g=s,this.h=i,this.b=new Map,this.a=E.getProxy(R.$_J.MainThreadWebviews)}dispose(){super.dispose();for(const E of this.b.values())E.dispose();this.b.clear()}$onMessage(E,v,r){const s=this.j(E);if(s){const{message:i}=(0,k.$scb)(v,r.value);s._onMessageEmitter.fire(i)}}$onMissingCsp(E,v){this.g.warn(`${v} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(E,v,r){const s=new D(E,this.a,n(v),this.c,this.f,r,this.h);this.b.set(E,s);const i=s._onDidDispose(()=>{i.dispose(),this.deleteWebview(E)});return s}deleteWebview(E){this.b.delete(E)}j(E){return this.b.get(E)}}e.$Pcc=$;function g(b){return{id:b.identifier,location:b.extensionLocation}}e.$Qcc=g;function t(b,E,v){return{enableCommandUris:v.enableCommandUris,enableScripts:v.enableScripts,enableForms:v.enableForms,portMapping:v.portMapping,localResourceRoots:v.localResourceRoots||a(b,E)}}e.$Rcc=t;function n(b){return{enableCommandUris:b.enableCommandUris,enableScripts:b.enableScripts,enableForms:b.enableForms,portMapping:b.portMapping,localResourceRoots:b.localResourceRoots?.map(E=>A.URI.from(E))}}function a(b,E){return[...(E?.getWorkspaceFolders()||[]).map(v=>v.uri),b.extensionLocation]}}),define(Re[257],Me([1,0,21,93,6,13,23,2,8,63,74,3,7]),function(be,e,w,M,C,F,A,l,k,f,R,D,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qdc=void 0;class p{constructor(s,i){this.document=s,this.b=i,this.a=1,this.c=new R.$Jbc("custom documents")}addEdit(s){return this.c.add([s])}async undo(s,i){await this.f(s).undo(),i||this.disposeBackup()}async redo(s,i){await this.f(s).redo(),i||this.disposeBackup()}disposeEdits(s){for(const i of s)this.c.delete(i)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const s=v(this.document.uri)+this.a++;return(0,A.$ug)(this.b,s)}updateBackup(s){this.d?.delete(),this.d=s}disposeBackup(){this.d?.delete(),this.d=void 0}f(s){const i=this.c.get(s,0);if(!i)throw new Error("No edit found");return i}}class ${constructor(){this.a=new Map}get(s,i){return this.a.get(this.b(s,i))}add(s,i,o){const y=this.b(s,i.uri);if(this.a.has(y))throw new Error(`Document already exists for viewType:${s} resource:${i.uri}`);const d=new p(i,o);return this.a.set(y,d),d}delete(s,i){const o=this.b(s,i.uri);this.a.delete(o)}b(s,i){return`${s}@@@${i}`}}var g;(function(r){r[r.Text=0]="Text",r[r.Custom=1]="Custom"})(g||(g={}));class t{constructor(){this.a=new Map}addTextProvider(s,i,o){return this.b(0,s,i,o)}addCustomProvider(s,i,o){return this.b(1,s,i,o)}get(s){return this.a.get(s)}b(s,i,o,y){if(this.a.has(i))throw new Error(`Provider for viewType:${i} already registered`);return this.a.set(i,{type:s,extension:o,provider:y}),new c.$bK(()=>this.a.delete(i))}}class n{constructor(s,i,o,y,d){this.d=i,this.f=o,this.g=y,this.h=d,this.b=new t,this.c=new $,this.a=s.getProxy(D.$_J.MainThreadCustomEditors)}registerCustomEditorProvider(s,i,o,y){const d=new C.$Qc;return b(o)?(d.add(this.b.addTextProvider(i,s,o)),this.a.$registerTextEditorProvider((0,f.$Qcc)(s),i,y.webviewOptions||{},{supportsMove:!!o.moveCustomTextEditor},(0,f.$Occ)(s))):(d.add(this.b.addCustomProvider(i,s,o)),a(o)&&d.add(o.onDidChangeCustomDocument(I=>{const S=this.i(i,I.document.uri);if(E(I)){const u=S.addEdit(I);this.a.$onDidEdit(I.document.uri,i,u,I.label)}else this.a.$onContentChange(I.document.uri,i)})),this.a.$registerCustomEditorProvider((0,f.$Qcc)(s),i,y.webviewOptions||{},!!y.supportsMultipleEditorsPerDocument,(0,f.$Occ)(s))),c.$bK.from(d,new c.$bK(()=>{this.a.$unregisterEditorProvider(i)}))}async $createCustomDocument(s,i,o,y,d){const I=this.b.get(i);if(!I)throw new Error(`No provider found for '${i}'`);if(I.type!==1)throw new Error(`Invalid provide type for '${i}'`);const S=l.URI.revive(s),u=await I.provider.openCustomDocument(S,{backupId:o,untitledDocumentData:y?.buffer},d);let m;return a(I.provider)&&this.f&&(m=this.f.workspaceValue(I.extension)??this.f.globalValue(I.extension)),this.c.add(i,u,m),{editable:a(I.provider)}}async $disposeCustomDocument(s,i){const o=this.b.get(i);if(!o)throw new Error(`No provider found for '${i}'`);if(o.type!==1)throw new Error(`Invalid provider type for '${i}'`);const y=l.URI.revive(s),{document:d}=this.i(i,y);this.c.delete(i,d),d.dispose()}async $resolveCustomEditor(s,i,o,y,d,I){const S=this.b.get(o);if(!S)throw new Error(`No provider found for '${o}'`);const u=k.ViewColumn.to(d),m=this.g.createNewWebview(i,y.contentOptions,S.extension),h=this.h.createNewWebviewPanel(i,o,y.title,u,y.options,m,y.active),P=l.URI.revive(s);switch(S.type){case 1:{const{document:W}=this.i(o,P);return S.provider.resolveCustomEditor(W,h,I)}case 0:{const W=this.d.getDocument(P);return S.provider.resolveCustomTextEditor(W,h,I)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(s,i,o){this.i(i,s).disposeEdits(o)}async $onMoveCustomEditor(s,i,o){const y=this.b.get(o);if(!y)throw new Error(`No provider found for '${o}'`);if(!y.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${o}'`);const d=this.h.getWebviewPanel(s);if(!d)throw new Error("No webview found");const I=l.URI.revive(i),S=this.d.getDocument(I);await y.provider.moveCustomTextEditor(S,d,w.CancellationToken.None)}async $undo(s,i,o,y){return this.i(i,s).undo(o,y)}async $redo(s,i,o,y){return this.i(i,s).redo(o,y)}async $revert(s,i,o){const y=this.i(i,s);await this.j(i).revertCustomDocument(y.document,o),y.disposeBackup()}async $onSave(s,i,o){const y=this.i(i,s);await this.j(i).saveCustomDocument(y.document,o),y.disposeBackup()}async $onSaveAs(s,i,o,y){const d=this.i(i,s);return this.j(i).saveCustomDocumentAs(d.document,l.URI.revive(o),y)}async $backup(s,i,o){const y=this.i(i,s),I=await this.j(i).backupCustomDocument(y.document,{destination:y.getNewBackupUri()},o);return y.updateBackup(I),I.id}i(s,i){const o=this.c.get(s,l.URI.revive(i));if(!o)throw new Error("No custom document found");return o}j(s){const o=this.b.get(s)?.provider;if(!o||!a(o))throw new Error("Custom document is not editable");return o}}e.$qdc=n;function a(r){return!!r.onDidChangeCustomDocument}function b(r){return typeof r.resolveCustomTextEditor=="function"}function E(r){return typeof r.undo=="function"&&typeof r.redo=="function"}function v(r){const s=r.scheme===F.Schemas.file||r.scheme===F.Schemas.untitled?r.fsPath:r.toString();return(0,M.$Bi)(s)+""}}),define(Re[258],Me([1,0,5,6,2,36,8,63,3,7]),function(be,e,w,M,C,F,A,l,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pdc=void 0;class R extends M.$Rc{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;#h;constructor($,g,t,n){super(),this.#r=void 0,this.#o=!0,this.#c=!1,this.#d=this.B(new w.$Md),this.onDidDispose=this.#d.event,this.#h=this.B(new w.$Md),this.onDidChangeViewState=this.#h.event,this.#e=$,this.#t=g,this.#l=t,this.#i=n.viewType,this.#u=n.panelOptions,this.#r=n.viewColumn,this.#n=n.title,this.#a=n.active}dispose(){this.#c||(this.#c=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#l.dispose(),super.dispose())}get webview(){return this.c(),this.#l}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#n}set title($){this.c(),this.#n!==$&&(this.#n=$,this.#t.$setTitle(this.#e,$))}get iconPath(){return this.c(),this.#s}set iconPath($){this.c(),this.#s!==$&&(this.#s=$,this.#t.$setIconPath(this.#e,C.URI.isUri($)?{light:$,dark:$}:$))}get options(){return this.#u}get viewColumn(){if(this.c(),!(typeof this.#r=="number"&&this.#r<0))return this.#r}get active(){return this.c(),this.#a}get visible(){return this.c(),this.#o}_updateViewState($){this.#c||(this.active!==$.active||this.visible!==$.visible||this.viewColumn!==$.viewColumn)&&(this.#a=$.active,this.#o=$.visible,this.#r=$.viewColumn,this.#h.fire({webviewPanel:this}))}reveal($,g){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof $>"u"?void 0:A.ViewColumn.from($),preserveFocus:!!g})}c(){if(this.#c)throw new Error("Webview is disposed")}}class D extends M.$Rc{static c(){return(0,F.$dg)()}constructor($,g,t){super(),this.j=g,this.m=t,this.g=new Map,this.h=new Map,this.f=$.getProxy(k.$_J.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach($=>$.dispose()),this.g.clear()}createWebviewPanel($,g,t,n,a={}){const b=typeof n=="object"?n.viewColumn:n,E={viewColumn:A.ViewColumn.from(b),preserveFocus:typeof n=="object"&&!!n.preserveFocus},v=(0,l.$Occ)($),r=D.c();this.f.$createWebviewPanel((0,l.$Qcc)($),r,g,{title:t,panelOptions:c(a),webviewOptions:(0,l.$Rcc)($,this.m,a),serializeBuffersForPostMessage:v},E);const s=this.j.createNewWebview(r,a,$);return this.createNewWebviewPanel(r,g,t,b,a,s,!0)}$onDidChangeWebviewPanelViewStates($){const g=Object.keys($);g.sort((t,n)=>{const a=$[t],b=$[n];return a.active?1:b.active?-1:+a.visible-+b.visible});for(const t of g){const n=this.getWebviewPanel(t);if(!n)continue;const a=$[t];n._updateViewState({active:a.active,visible:a.visible,viewColumn:A.ViewColumn.to(a.position)})}}async $onDidDisposeWebviewPanel($){this.getWebviewPanel($)?.dispose(),this.g.delete($),this.j.deleteWebview($)}registerWebviewPanelSerializer($,g,t){if(this.h.has(g))throw new Error(`Serializer for '${g}' already registered`);return this.h.set(g,{serializer:t,extension:$}),this.f.$registerSerializer(g,{serializeBuffersForPostMessage:(0,l.$Occ)($)}),new f.$bK(()=>{this.h.delete(g),this.f.$unregisterSerializer(g)})}async $deserializeWebviewPanel($,g,t,n){const a=this.h.get(g);if(!a)throw new Error(`No serializer found for '${g}'`);const{serializer:b,extension:E}=a,v=this.j.createNewWebview($,t.webviewOptions,E),r=this.createNewWebviewPanel($,g,t.title,n,t.panelOptions,v,t.active);await b.deserializeWebviewPanel(r,t.state)}createNewWebviewPanel($,g,t,n,a,b,E){const v=new R($,this.f,b,{viewType:g,title:t,viewColumn:n,panelOptions:a,active:E});return this.g.set($,v),v}getWebviewPanel($){return this.g.get($)}}e.$pdc=D;function c(p){return{enableFindWidget:p.enableFindWidget,retainContextWhenHidden:p.retainContextWhenHidden}}}),define(Re[259],Me([1,0,5,6,63,8,3,7]),function(be,e,w,M,C,F,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$odc=void 0;class k extends M.$Rc{#e;#t;#i;#l;#u;#n;#s;#r;#o;constructor(D,c,p,$,g,t){super(),this.#u=!1,this.#a=this.B(new w.$Md),this.onDidChangeVisibility=this.#a.event,this.#c=this.B(new w.$Md),this.onDidDispose=this.#c.event,this.#i=p,this.#s=$,this.#e=D,this.#t=c,this.#l=g,this.#n=t}dispose(){this.#u||(this.#u=!0,this.#c.fire(),this.#l.dispose(),super.dispose())}#a;#c;get title(){return this.a(),this.#s}set title(D){this.a(),this.#s!==D&&(this.#s=D,this.#t.$setWebviewViewTitle(this.#e,D))}get description(){return this.a(),this.#r}set description(D){this.a(),this.#r!==D&&(this.#r=D,this.#t.$setWebviewViewDescription(this.#e,D))}get visible(){return this.#n}get webview(){return this.#l}get viewType(){return this.#i}_setVisible(D){D===this.#n||this.#u||(this.#n=D,this.#a.fire())}get badge(){return this.a(),this.#o}set badge(D){this.a(),!(D?.value===this.#o?.value&&D?.tooltip===this.#o?.tooltip)&&(this.#o=F.ViewBadge.from(D),this.#t.$setWebviewViewBadge(this.#e,D))}show(D){this.a(),this.#t.$show(this.#e,!!D)}a(){if(this.#u)throw new Error("Webview is disposed")}}class f{constructor(D,c){this.d=c,this.b=new Map,this.c=new Map,this.a=D.getProxy(A.$_J.MainThreadWebviewViews)}registerWebviewViewProvider(D,c,p,$){if(this.b.has(c))throw new Error(`View provider for '${c}' already registered`);return this.b.set(c,{provider:p,extension:D}),this.a.$registerWebviewViewProvider((0,C.$Qcc)(D),c,{retainContextWhenHidden:$?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,C.$Occ)(D)}),new l.$bK(()=>{this.b.delete(c),this.a.$unregisterWebviewViewProvider(c)})}async $resolveWebviewView(D,c,p,$,g){const t=this.b.get(c);if(!t)throw new Error(`No view provider found for '${c}'`);const{provider:n,extension:a}=t,b=this.d.createNewWebview(D,{},a),E=new k(D,this.a,c,p,b,!0);this.c.set(D,E),await n.resolveWebviewView(E,{state:$},g)}async $onDidChangeWebviewViewVisibility(D,c){this.e(D)._setVisible(c)}async $disposeWebviewView(D){const c=this.e(D);this.c.delete(D),c.dispose(),this.d.deleteWebview(D)}e(D){const c=this.c.get(D);if(!c)throw new Error("No webview found");return c}}e.$odc=f}),define(Re[108],Me([1,0,5,3,2,13,15,4,17,25]),function(be,e,w,M,C,F,A,l,k,f){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.$Tcc=e.$Scc=void 0;let D=class{static{R=this}static{this.a={focused:!0,active:!0}}getState(p){const $=this.d;return{get focused(){return $.focused},get active(){return(0,f.$_E)(p,"windowActivity"),$.active}}}constructor(p){this.c=new w.$Md,this.onDidChangeWindowState=this.c.event,this.d=R.a,this.b=p.getProxy(M.$_J.MainThreadWindow),this.b.$getInitialState().then(({isFocused:$,isActive:g})=>{this.onDidChangeWindowProperty("focused",$),this.onDidChangeWindowProperty("active",g)})}$onDidChangeWindowFocus(p){this.onDidChangeWindowProperty("focused",p)}$onDidChangeWindowActive(p){this.onDidChangeWindowProperty("active",p)}onDidChangeWindowProperty(p,$){$!==this.d[p]&&(this.d={...this.d,[p]:$},this.c.fire(this.d))}openUri(p,$){let g;if(typeof p=="string"){g=p;try{p=C.URI.parse(p)}catch{return Promise.reject(`Invalid uri - '${p}'`)}}return(0,A.$Ae)(p.scheme)?Promise.reject("Invalid scheme - cannot be empty"):p.scheme===F.Schemas.command?Promise.reject(`Invalid scheme '${p.scheme}'`):this.b.$openUri(p,g,$)}async asExternalUri(p,$){if((0,A.$Ae)(p.scheme))return Promise.reject("Invalid scheme - cannot be empty");const g=await this.b.$asExternalUri(p,$);return C.URI.from(g)}};e.$Scc=D,e.$Scc=D=R=qe([We(0,k.$aM)],D),e.$Tcc=(0,l.$Nh)("IExtHostWindow")}),define(Re[260],Me([1,0,226,27,17]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yfc=void 0;let F=class extends w.$Rdc{constructor(l,k){super(l,k)}f(l,k,f){k.apply(console,f)}};e.$Yfc=F,e.$Yfc=F=qe([We(0,C.$aM),We(1,M.$qM)],F)}),define(Re[261],Me([1,0,12,26,21,9,5,6,132,215,46]),function(be,e,w,M,C,F,A,l,k,f,R){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$i4b=e.ResponsiveState=e.RequestInitiator=e.$h4b=e.$g4b=void 0;function c(h,P){try{return JSON.stringify(h,P)}catch{return"null"}}const p="$$ref$$",$={[p]:-1};class g{constructor(P,W){this.jsonString=P,this.referencedBuffers=W}}function t(h,P=null,W=!1){const K=[];return{jsonString:(W?c:JSON.stringify)(h,(B,O)=>{if(typeof O>"u")return $;if(typeof O=="object"){if(O instanceof M.$ae){const N=K.push(O)-1;return{[p]:N}}if(P)return P(B,O)}return O}),referencedBuffers:K}}e.$g4b=t;function n(h,P,W){return JSON.parse(h,(K,U)=>{if(U){const B=U[p];if(typeof B=="number")return P[B];if(W&&U.$mid===1)return W.transformIncoming(U)}return U})}e.$h4b=n;function a(h,P){return JSON.stringify(h,P)}function b(h){return h?(P,W)=>W&&W.$mid===1?h.transformOutgoing(W):W:null}var E;(function(h){h[h.LocalSide=0]="LocalSide",h[h.OtherSide=1]="OtherSide"})(E||(e.RequestInitiator=E={}));var v;(function(h){h[h.Responsive=0]="Responsive",h[h.Unresponsive=1]="Unresponsive"})(v||(e.ResponsiveState=v={}));const r=()=>{},s=Symbol.for("rpcProtocol"),i=Symbol.for("rpcProxy");class o extends l.$Rc{static{D=s}static{this.a=3*1e3}constructor(P,W=null,K=null){super(),this[D]=!0,this.b=this.B(new A.$Md),this.onDidChangeResponsiveState=this.b.event,this.c=P,this.f=W,this.g=K,this.h=b(this.g),this.j=!1,this.m=[],this.s=[];for(let U=0,B=R.$hv.count;U<B;U++)this.m[U]=null,this.s[U]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new w.$5g(()=>this.H(),1e3)),this.c.onMessage(U=>this.L(U))}dispose(){this.j=!0,Object.keys(this.w).forEach(P=>{const W=this.w[P];delete this.w[P],W.resolveErr(F.$5())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(P){this.z===0&&(this.C=Date.now()+o.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(P){this.C=Date.now()+o.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(P){this.y!==P&&(this.y=P,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(P){return this.g?(0,k.$Km)(P,this.g):P}getProxy(P){const{nid:W,sid:K}=P;return this.s[W]||(this.s[W]=this.J(W,K)),this.s[W]}J(P,W){const K={get:(U,B)=>(typeof B=="string"&&!U[B]&&B.charCodeAt(0)===36&&(U[B]=(...O)=>this.U(P,B,O)),B===i?W:U[B])};return new Proxy(Object.create(null),K)}set(P,W){return this.m[P.nid]=W,W}assertRegistered(P){for(let W=0,K=P.length;W<K;W++){const U=P[W];if(!this.m[U.nid])throw new Error(`Missing proxy instance ${U.sid}`)}}L(P){if(this.j)return;const W=P.byteLength,K=d.read(P,0),U=K.readUInt8(),B=K.readUInt32();switch(U){case 1:case 2:{let{rpcId:O,method:N,args:te}=S.deserializeRequestJSONArgs(K);this.g&&(te=(0,k.$Km)(te,this.g)),this.M(W,B,O,N,te,U===2);break}case 3:case 4:{let{rpcId:O,method:N,args:te}=S.deserializeRequestMixedArgs(K);this.g&&(te=(0,k.$Km)(te,this.g)),this.M(W,B,O,N,te,U===4);break}case 5:{this.f?.logIncoming(W,B,0,"ack"),this.G(B);break}case 6:{this.N(W,B);break}case 7:{this.O(W,B,void 0);break}case 9:{let O=S.deserializeReplyOKJSON(K);this.g&&(O=(0,k.$Km)(O,this.g)),this.O(W,B,O);break}case 10:{const O=S.deserializeReplyOKJSONWithBuffers(K,this.g);this.O(W,B,O);break}case 8:{const O=S.deserializeReplyOKVSBuffer(K);this.O(W,B,O);break}case 11:{let O=S.deserializeReplyErrError(K);this.g&&(O=(0,k.$Km)(O,this.g)),this.P(W,B,O);break}case 12:{this.P(W,B,void 0);break}default:console.error("received unexpected message"),console.error(P)}}M(P,W,K,U,B,O){this.f?.logIncoming(P,W,1,`receiveRequest ${(0,R.$jv)(K)}.${U}(`,B);const N=String(W);let te,Y;if(O){const Ee=new C.$Wd;B.push(Ee.token),te=this.Q(K,U,B),Y=()=>Ee.cancel()}else te=this.Q(K,U,B),Y=r;this.u[N]=Y;const ye=S.serializeAcknowledged(W);this.f?.logOutgoing(ye.byteLength,W,1,"ack"),this.c.send(ye),te.then(Ee=>{delete this.u[N];const Pe=S.serializeReplyOK(W,Ee,this.h);this.f?.logOutgoing(Pe.byteLength,W,1,"reply:",Ee),this.c.send(Pe)},Ee=>{delete this.u[N];const Pe=S.serializeReplyErr(W,Ee);this.f?.logOutgoing(Pe.byteLength,W,1,"replyErr:",Ee),this.c.send(Pe)})}N(P,W){this.f?.logIncoming(P,W,1,"receiveCancel");const K=String(W);this.u[K]?.()}O(P,W,K){this.f?.logIncoming(P,W,0,"receiveReply:",K);const U=String(W);if(!this.w.hasOwnProperty(U))return;const B=this.w[U];delete this.w[U],B.resolveOk(K)}P(P,W,K){this.f?.logIncoming(P,W,0,"receiveReplyErr:",K);const U=String(W);if(!this.w.hasOwnProperty(U))return;const B=this.w[U];delete this.w[U];let O;K&&(K.$isError?(O=new Error,O.name=K.name,O.message=K.message,O.stack=K.stack):O=K),B.resolveErr(O)}Q(P,W,K){try{return Promise.resolve(this.S(P,W,K))}catch(U){return Promise.reject(U)}}S(P,W,K){const U=this.m[P];if(!U)throw new Error("Unknown actor "+(0,R.$jv)(P));const B=U[W];if(typeof B!="function")throw new Error("Unknown method "+W+" on actor "+(0,R.$jv)(P));return B.apply(U,K)}U(P,W,K){if(this.j)return new f.$f4b;let U=null;if(K.length>0&&C.CancellationToken.isCancellationToken(K[K.length-1])&&(U=K.pop()),U&&U.isCancellationRequested)return Promise.reject(F.$5());const B=S.serializeRequestArguments(K,this.h),O=++this.t,N=String(O),te=new f.$e4b,Y=new l.$Qc;U&&Y.add(U.onCancellationRequested(()=>{const Ee=S.serializeCancel(O);this.f?.logOutgoing(Ee.byteLength,O,0,"cancel"),this.c.send(S.serializeCancel(O))})),this.w[N]=new y(te,Y),this.F(O);const ye=S.serializeRequest(O,P,W,B,!!U);return this.f?.logOutgoing(ye.byteLength,O,0,`request: ${(0,R.$jv)(P)}.${W}(`,K),this.c.send(ye),te}}e.$i4b=o;class y{constructor(P,W){this.a=P,this.b=W}resolveOk(P){this.a.resolveOk(P),this.b.dispose()}resolveErr(P){this.a.resolveErr(P),this.b.dispose()}}class d{static alloc(P,W,K){const U=new d(M.$ae.alloc(K+1+4),0);return U.writeUInt8(P),U.writeUInt32(W),U}static read(P,W){return new d(P,W)}get buffer(){return this.a}constructor(P,W){this.a=P,this.b=W}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(P){this.a.writeUInt8(P,this.b),this.b+=1}readUInt8(){const P=this.a.readUInt8(this.b);return this.b+=1,P}writeUInt32(P){this.a.writeUInt32BE(P,this.b),this.b+=4}readUInt32(){const P=this.a.readUInt32BE(this.b);return this.b+=4,P}static sizeShortString(P){return 1+P.byteLength}writeShortString(P){this.a.writeUInt8(P.byteLength,this.b),this.b+=1,this.a.set(P,this.b),this.b+=P.byteLength}readShortString(){const P=this.a.readUInt8(this.b);this.b+=1;const K=this.a.slice(this.b,this.b+P).toString();return this.b+=P,K}static sizeLongString(P){return 4+P.byteLength}writeLongString(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readLongString(){const P=this.a.readUInt32BE(this.b);this.b+=4;const K=this.a.slice(this.b,this.b+P).toString();return this.b+=P,K}writeBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}static sizeVSBuffer(P){return 4+P.byteLength}writeVSBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readVSBuffer(){const P=this.a.readUInt32BE(this.b);this.b+=4;const W=this.a.slice(this.b,this.b+P);return this.b+=P,W}static sizeMixedArray(P){let W=0;W+=1;for(let K=0,U=P.length;K<U;K++){const B=P[K];switch(W+=1,B.type){case 1:W+=this.sizeLongString(B.value);break;case 2:W+=this.sizeVSBuffer(B.value);break;case 3:W+=this.sizeUInt32,W+=this.sizeLongString(B.value);for(let O=0;O<B.buffers.length;++O)W+=this.sizeVSBuffer(B.buffers[O]);break;case 4:break}}return W}writeMixedArray(P){this.a.writeUInt8(P.length,this.b),this.b+=1;for(let W=0,K=P.length;W<K;W++){const U=P[W];switch(U.type){case 1:this.writeUInt8(1),this.writeLongString(U.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(U.value);break;case 3:this.writeUInt8(3),this.writeUInt32(U.buffers.length),this.writeLongString(U.value);for(let B=0;B<U.buffers.length;++B)this.writeBuffer(U.buffers[B]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const P=this.a.readUInt8(this.b);this.b+=1;const W=new Array(P);for(let K=0;K<P;K++)switch(this.readUInt8()){case 1:W[K]=this.readLongString();break;case 2:W[K]=this.readVSBuffer();break;case 3:{const B=this.readUInt32(),O=this.readLongString(),N=[];for(let te=0;te<B;++te)N.push(this.readVSBuffer());W[K]=new R.$kv(n(O,N,null));break}case 4:W[K]=void 0;break}return W}}var I;(function(h){h[h.Simple=0]="Simple",h[h.Mixed=1]="Mixed"})(I||(I={}));class S{static a(P){for(let W=0,K=P.length;W<K;W++)if(P[W]instanceof M.$ae||P[W]instanceof R.$kv||typeof P[W]>"u")return!0;return!1}static serializeRequestArguments(P,W){if(this.a(P)){const K=[];for(let U=0,B=P.length;U<B;U++){const O=P[U];if(O instanceof M.$ae)K[U]={type:2,value:O};else if(typeof O>"u")K[U]={type:4};else if(O instanceof R.$kv){const{jsonString:N,referencedBuffers:te}=t(O.value,W);K[U]={type:3,value:M.$ae.fromString(N),buffers:te}}else K[U]={type:1,value:M.$ae.fromString(a(O,W))}}return{type:1,args:K}}return{type:0,args:a(P,W)}}static serializeRequest(P,W,K,U,B){switch(U.type){case 0:return this.b(P,W,K,U.args,B);case 1:return this.c(P,W,K,U.args,B)}}static b(P,W,K,U,B){const O=M.$ae.fromString(K),N=M.$ae.fromString(U);let te=0;te+=d.sizeUInt8(),te+=d.sizeShortString(O),te+=d.sizeLongString(N);const Y=d.alloc(B?2:1,P,te);return Y.writeUInt8(W),Y.writeShortString(O),Y.writeLongString(N),Y.buffer}static deserializeRequestJSONArgs(P){const W=P.readUInt8(),K=P.readShortString(),U=P.readLongString();return{rpcId:W,method:K,args:JSON.parse(U)}}static c(P,W,K,U,B){const O=M.$ae.fromString(K);let N=0;N+=d.sizeUInt8(),N+=d.sizeShortString(O),N+=d.sizeMixedArray(U);const te=d.alloc(B?4:3,P,N);return te.writeUInt8(W),te.writeShortString(O),te.writeMixedArray(U),te.buffer}static deserializeRequestMixedArgs(P){const W=P.readUInt8(),K=P.readShortString(),U=P.readMixedArray(),B=new Array(U.length);for(let O=0,N=U.length;O<N;O++){const te=U[O];typeof te=="string"?B[O]=JSON.parse(te):B[O]=te}return{rpcId:W,method:K,args:B}}static serializeAcknowledged(P){return d.alloc(5,P,0).buffer}static serializeCancel(P){return d.alloc(6,P,0).buffer}static serializeReplyOK(P,W,K){if(typeof W>"u")return this.d(P);if(W instanceof M.$ae)return this.e(P,W);if(W instanceof R.$kv){const{jsonString:U,referencedBuffers:B}=t(W.value,K,!0);return this.g(P,U,B)}else return this.f(P,c(W,K))}static d(P){return d.alloc(7,P,0).buffer}static e(P,W){let K=0;K+=d.sizeVSBuffer(W);const U=d.alloc(8,P,K);return U.writeVSBuffer(W),U.buffer}static deserializeReplyOKVSBuffer(P){return P.readVSBuffer()}static f(P,W){const K=M.$ae.fromString(W);let U=0;U+=d.sizeLongString(K);const B=d.alloc(9,P,U);return B.writeLongString(K),B.buffer}static g(P,W,K){const U=M.$ae.fromString(W);let B=0;B+=d.sizeUInt32,B+=d.sizeLongString(U);for(const N of K)B+=d.sizeVSBuffer(N);const O=d.alloc(10,P,B);O.writeUInt32(K.length),O.writeLongString(U);for(const N of K)O.writeBuffer(N);return O.buffer}static deserializeReplyOKJSON(P){const W=P.readLongString();return JSON.parse(W)}static deserializeReplyOKJSONWithBuffers(P,W){const K=P.readUInt32(),U=P.readLongString(),B=[];for(let O=0;O<K;++O)B.push(P.readVSBuffer());return new R.$kv(n(U,B,W))}static serializeReplyErr(P,W){const K=W?c(F.$2(W),null):void 0;if(typeof K!="string")return this.h(P);const U=M.$ae.fromString(K);let B=0;B+=d.sizeLongString(U);const O=d.alloc(11,P,B);return O.writeLongString(U),O.buffer}static deserializeReplyErrError(P){const W=P.readLongString();return JSON.parse(W)}static h(P){return d.alloc(12,P,0).buffer}}var u;(function(h){h[h.RequestJSONArgs=1]="RequestJSONArgs",h[h.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",h[h.RequestMixedArgs=3]="RequestMixedArgs",h[h.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",h[h.Acknowledged=5]="Acknowledged",h[h.Cancel=6]="Cancel",h[h.ReplyOKEmpty=7]="ReplyOKEmpty",h[h.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",h[h.ReplyOKJSON=9]="ReplyOKJSON",h[h.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",h[h.ReplyErrError=11]="ReplyErrError",h[h.ReplyErrEmpty=12]="ReplyErrEmpty"})(u||(u={}));var m;(function(h){h[h.String=1]="String",h[h.VSBuffer=2]="VSBuffer",h[h.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",h[h.Undefined=4]="Undefined"})(m||(m={}))}),define(Re[262],Me([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1fc=void 0;const w=function(F){const A=l=>{globalThis.removeEventListener("message",A);const k=l.data;Object.defineProperties(globalThis,{postMessage:{value(f,R){k.postMessage(f,R)}},onmessage:{get(){return k.onmessage},set(f){k.onmessage=f}}}),k.addEventListener("message",f=>{globalThis.dispatchEvent(new MessageEvent("message",{data:f.data,ports:f.ports?[...f.ports]:void 0}))}),k.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(F)};globalThis.addEventListener("message",A)}.toString();class M extends EventTarget{constructor(F,A,l){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const k=`((${w})('${A}'))`,f=new Blob([k],{type:"application/javascript"}),R=URL.createObjectURL(f),D=new MessageChannel,c=R,p={type:"_newWorker",id:c,port:D.port2,url:R,options:l};F(p,[D.port2]),this.postMessage=D.port1.postMessage.bind(D.port1),this.terminate=()=>{F({type:"_terminateWorker",id:c}),URL.revokeObjectURL(R),D.port1.close(),D.port2.close()},Object.defineProperties(this,{onmessage:{get(){return D.port1.onmessage},set($){D.port1.onmessage=$}},onmessageerror:{get(){return D.port1.onmessageerror},set($){D.port1.onmessageerror=$}}}),D.port1.addEventListener("messageerror",$=>{const g=new MessageEvent("messageerror",{data:$.data});this.dispatchEvent(g)}),D.port1.addEventListener("message",$=>{const g=new MessageEvent("message",{data:$.data});this.dispatchEvent(g)}),D.port1.start()}}e.$1fc=M}),define(Re[263],Me([1,0,5,30,32,4]),function(be,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vJ=e.$uJ=e.OutputChannelUpdateMode=e.$tJ=e.$sJ=e.$rJ=e.$qJ=e.$pJ=e.$oJ=e.$nJ=e.$mJ=e.$lJ=e.$kJ=void 0,e.$kJ="text/x-code-output",e.$lJ="output",e.$mJ="Log",e.$nJ="text/x-code-log-output",e.$oJ="log",e.$pJ="workbench.panel.output",e.$qJ=new C.$5i("inOutput",!1),e.$rJ=new C.$5i("activeLogOutput",!1),e.$sJ=new C.$5i("outputView.scrollLock",!1),e.$tJ=(0,F.$Nh)("outputService");var A;(function(k){k[k.Append=1]="Append",k[k.Replace=2]="Replace",k[k.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.$uJ={OutputChannels:"workbench.contributions.outputChannels"};class l{constructor(){this.a=new Map,this.b=new w.$Md,this.onDidRegisterChannel=this.b.event,this.c=new w.$Md,this.onDidRemoveChannel=this.c.event}registerChannel(f){this.a.has(f.id)||(this.a.set(f.id,f),this.b.fire(f.id))}getChannels(){const f=[];return this.a.forEach(R=>f.push(R)),f}getChannel(f){return this.a.get(f)}removeChannel(f){this.a.delete(f),this.c.fire(f)}}M.$bn.add(e.$uJ.OutputChannels,new l),e.$vJ=new C.$5i("activeOutputChannel","")}),define(Re[109],Me([1,0,3,4,17,20,14,263,61,27,39,129,26,16,38,5,6]),function(be,e,w,M,C,F,A,l,k,f,R,D,c,p,$,g,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dcc=e.$Ccc=void 0;class n extends A.$bj{get disposed(){return this.n}constructor(v,r,s,i,o){super(),this.id=v,this.name=r,this.r=s,this.s=i,this.extension=o,this.m=0,this.n=!1,this.visible=!1,this.setLevel(s.getLevel()),this.B(s.onDidChangeLogLevel(y=>this.setLevel(y)))}get logLevel(){return this.getLevel()}appendLine(v){this.append(v+`
`)}append(v){this.info(v)}clear(){const v=this.m;this.r.flush(),this.s.$update(this.id,l.OutputChannelUpdateMode.Clear,v)}replace(v){const r=this.m;this.info(v),this.s.$update(this.id,l.OutputChannelUpdateMode.Replace,r),this.visible&&this.r.flush()}show(v,r){this.r.flush(),this.s.$reveal(this.id,!!(typeof v=="boolean"?v:r))}hide(){this.s.$close(this.id)}g(v,r){this.m+=c.$ae.fromString(r).byteLength,(0,A.log)(this.r,v,r),this.visible&&(this.r.flush(),this.s.$update(this.id,l.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class a extends n{appendLine(v){this.append(v)}}let b=class{constructor(v,r,s,i,o,y){this.i=r,this.j=s,this.k=i,this.l=o,this.m=y,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=v.getProxy(w.$_J.MainThreadOutputService),this.b=this.k.extUri.joinPath(r.logsLocation,`output_logging_${(0,D.$am)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(v){this.h=v;for(const[r,s]of this.g)s.visible=r===this.h}createOutputChannel(v,r,s){if(v=v.trim(),!v)throw new Error("illegal argument `name`. must not be falsy");const i=typeof r=="object"&&r.log,o=(0,p.$xf)(r)?r:void 0;if((0,p.$xf)(o)&&!o.trim())throw new Error("illegal argument `languageId`. must not be empty");let y;const d=this.i.environment.extensionLogLevel?.find(([S])=>F.$2l.equals(s.identifier,S))?.[1];d&&(y=(0,A.$lj)(d));const I=i?this.o(v,y,s):this.n(v,o,s);return I.then(S=>{this.g.set(S.id,S),S.visible=S.id===this.h}),i?this.r(v,y??this.m.getLevel(),I):this.q(v,I)}async n(v,r,s){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const i=await this.c,o=this.k.extUri.joinPath(i,`${this.f++}-${v.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),y=this.l.createLogger(o,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),d=await this.a.$register(v,o,r,s.identifier.value);return new n(d,v,y,this.a,s)}async o(v,r,s){const i=await this.p(s),o=v.replace(/[\\/:\*\?"<>\|]/g,""),y=this.k.extUri.joinPath(i,`${o}.log`),d=`${s.identifier.value}.${o}`,I=this.l.createLogger(y,{id:d,name:v,logLevel:r,extensionId:s.identifier.value});return new a(d,v,I,this.a,s)}p(v){let r=this.d.get(v.identifier.value);if(!r){const s=this.k.extUri.joinPath(this.i.logsLocation,v.identifier.value);this.d.set(v.identifier.value,r=(async()=>{try{await this.j.value.createDirectory(s)}catch(i){if((0,$.$lk)(i)!==$.FileSystemProviderErrorCode.FileExists)throw i}return s})())}return r}q(v,r){let s=!1;const i=()=>{if(s)throw new Error("Channel has been closed")};return{get name(){return v},append(o){i(),r.then(y=>y.append(o))},appendLine(o){i(),r.then(y=>y.appendLine(o))},clear(){i(),r.then(o=>o.clear())},replace(o){i(),r.then(y=>y.replace(o))},show(o,y){i(),r.then(d=>d.show(o,y))},hide(){i(),r.then(o=>o.hide())},dispose(){s=!0,r.then(o=>o.dispose())}}}r(v,r,s){const i=new t.$Qc,o=()=>{if(i.isDisposed)throw new Error("Channel has been closed")},y=i.add(new g.$Md);function d(I){r=I,y.fire(I)}return s.then(I=>{i.add(I),I.logLevel!==r&&d(I.logLevel),i.add(I.onDidChangeLogLevel(S=>d(S)))}),{...this.q(v,s),get logLevel(){return r},onDidChangeLogLevel:y.event,trace(I,...S){o(),s.then(u=>u.trace(I,...S))},debug(I,...S){o(),s.then(u=>u.debug(I,...S))},info(I,...S){o(),s.then(u=>u.info(I,...S))},warn(I,...S){o(),s.then(u=>u.warn(I,...S))},error(I,...S){o(),s.then(u=>u.error(I,...S))},dispose(){i.dispose()}}}};e.$Ccc=b,e.$Ccc=b=qe([We(0,C.$aM),We(1,f.$qM),We(2,k.$fcc),We(3,R.$Mbc),We(4,A.$9i),We(5,A.$8i)],b),e.$Dcc=(0,M.$Nh)("IExtHostOutputService")}),define(Re[264],Me([1,0,4,12]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qm=e.$pm=void 0,e.$pm=(0,w.$Nh)("remoteAgentService"),e.$qm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(C){let F=1/0;for(let l=0;l<this.maxSampleCount;l++){const k=await C.getRoundTripTime();if(k===void 0)return;F=Math.min(F,k/2),await(0,M.$Tg)(this.sampleDelay)}this.average.push(F),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(F):A=this.initial.reduce((l,k)=>l+k,0)/this.initial.length,this.lastMeasurement={initial:A,current:F,average:this.average.reduce((l,k)=>l+k,0)/this.average.length,high:(()=>typeof A>"u"?!1:F>this.highLatencyMaxThreshold||F>this.highLatencyMinThreshold&&F>A*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Re[265],Me([1,0,42,13,19,22,23,2,4,186,54,208,264]),function(be,e,w,M,C,F,A,l,k,f,R,D,c){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$OJ=e.$NJ=void 0,e.$NJ=(0,k.$Nh)("pathService");let $=p=class{constructor(t,n,a,b){this.d=t,this.e=n,this.f=a,this.g=b,this.a=(async()=>(await this.e.getEnvironment())?.os||F.OS)(),this.b=(async()=>{const E=await this.e.getEnvironment();return this.c=E?.userHome??t})()}hasValidBasename(t,n,a){return typeof n=="string"||typeof n>"u"?this.a.then(b=>this.h(t,b,n)):this.h(t,n,a)}h(t,n,a){return t.scheme===M.Schemas.file||t.scheme===M.Schemas.vscodeRemote?(0,w.$Uf)(a??(0,A.$rg)(t),n===1):!0}get defaultUriScheme(){return p.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(t,n){if(t.remoteAuthority)return M.Schemas.vscodeRemote;const a=(0,f.$KJ)(n.getWorkspace());if(a)return a;const b=n.getWorkspace().folders[0];if(b)return b.uri.scheme;const E=n.getWorkspace().configuration;return E?E.scheme:M.Schemas.file}userHome(t){return t?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(t=>t===1?C.$ec:C.$fc)}async fileURI(t){let n="";if(await this.a===1&&(t=t.replace(/\\/g,"/")),t[0]==="/"&&t[1]==="/"){const b=t.indexOf("/",2);b===-1?(n=t.substring(2),t="/"):(n=t.substring(2,b),t=t.substring(b)||"/")}return l.URI.from({scheme:M.Schemas.file,authority:n,path:t,query:"",fragment:""})}};e.$OJ=$,e.$OJ=$=p=qe([We(1,c.$pm),We(2,D.$wJ),We(3,R.$Wh)],$)}),define(Re[110],Me([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$xI=e.$wI=void 0;class w{constructor(A,l){this.line=A,this.character=l}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,l){return new w(0,0)}with(A){return new w(0,0)}}e.$wI=w;class M{constructor(A,l,k,f){this.isEmpty=!1,this.isSingleLine=!1,this.start=new w(A,l),this.end=new w(k,f)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new M(0,0,0,0)}with(A){return new M(0,0,0,0)}}e.$xI=M;var C;(function(F){F[F.Information=1]="Information",F[F.Warning=2]="Warning"})(C||(e.TextSearchCompleteMessageType=C={}))}),define(Re[47],Me([1,0,18,37,24,42,15,4,19,9,110,12]),function(be,e,w,M,C,F,A,l,k,f,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YI=e.$XI=e.$WI=e.$VI=e.$UI=e.$TI=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.SearchErrorCode=e.$MI=e.$LI=e.SearchSortOrder=e.ViewMode=e.$KI=e.$JI=e.$II=e.$HI=e.SearchCompletionExitCode=e.$GI=e.$FI=e.$EI=e.QueryType=e.SearchProviderType=e.$DI=e.$CI=e.$BI=e.$AI=e.$zI=e.$yI=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.$yI="workbench.view.search",e.$zI="workbench.panel.search",e.$AI="workbench.view.search",e.$BI="search-result",e.$CI="search.exclude";const c="\u27EA ",p=" characters skipped \u27EB",$=(c.length+p.length+5)*2;e.$DI=(0,l.$Nh)("searchService");var g;(function(X){X[X.file=0]="file",X[X.text=1]="text"})(g||(e.SearchProviderType=g={}));var t;(function(X){X[X.File=1]="File",X[X.Text=2]="Text"})(t||(e.QueryType=t={}));function n(X){return!!X.preview}e.$EI=n;function a(X){return!!X.resource}e.$FI=a;function b(X){return!!X.message}e.$GI=b;var E;(function(X){X[X.Normal=0]="Normal",X[X.NewSearchStarted=1]="NewSearchStarted"})(E||(e.SearchCompletionExitCode=E={}));class v{constructor(ae){this.resource=ae,this.results=[]}}e.$HI=v;class r{constructor(ae,Se,ue,$e){this.ranges=Se,this.webviewIndex=$e;const ie=Array.isArray(Se)?Se:[Se];if(ue&&ue.matchLines===1&&s(ie)){ae=(0,A.$qf)(ae,ue.matchLines);let z="",V=0,le=0;const we=Math.floor(ue.charsPerLine/5),ve=[];for(const me of ie){const De=Math.max(me.startColumn-we,0),re=me.startColumn+ue.charsPerLine;if(De>le+we+$){const he=c+(De-le)+p;z+=he+ae.slice(De,re),V+=De-(le+he.length)}else z+=ae.slice(le,re);ve.push(new o(0,me.startColumn-V,me.endColumn-V)),le=re}this.preview={text:z,matches:Array.isArray(this.ranges)?ve:ve[0]}}else{const z=Array.isArray(Se)?Se[0].startLineNumber:Se.startLineNumber;this.preview={text:ae,matches:(0,w.$1b)(Se,V=>new i(V.startLineNumber-z,V.startColumn,V.endLineNumber-z,V.endColumn))}}}}e.$II=r;function s(X){const ae=X[0].startLineNumber;for(const Se of X)if(Se.startLineNumber!==ae||Se.endLineNumber!==ae)return!1;return!0}class i{constructor(ae,Se,ue,$e){this.startLineNumber=ae,this.startColumn=Se,this.endLineNumber=ue,this.endColumn=$e}}e.$JI=i;class o extends i{constructor(ae,Se,ue){super(ae,Se,ae,ue)}}e.$KI=o;var y;(function(X){X.List="list",X.Tree="tree"})(y||(e.ViewMode=y={}));var d;(function(X){X.Default="default",X.FileNames="fileNames",X.Type="type",X.Modified="modified",X.CountDescending="countDescending",X.CountAscending="countAscending"})(d||(e.SearchSortOrder=d={}));function I(X,ae=!0){const Se=X&&X.files&&X.files.exclude,ue=ae&&X&&X.search&&X.search.exclude;if(!Se&&!ue)return;if(!Se||!ue)return Se||ue;let $e=Object.create(null);return $e=C.$5m($e,C.$2m(Se)),$e=C.$5m($e,C.$2m(ue),!0),$e}e.$LI=I;function S(X,ae){return X.excludePattern&&M.$tj(X.excludePattern,ae)?!1:X.includePattern||X.usingSearchPaths?X.includePattern&&M.$tj(X.includePattern,ae)?!0:X.usingSearchPaths?!!X.folderQueries&&X.folderQueries.some(Se=>{const ue=Se.folder.fsPath;if(F.$Wf(ae,ue)){const $e=k.$kc(ue,ae);return!Se.includePattern||!!M.$tj(Se.includePattern,$e)}else return!1}):!1:!0}e.$MI=S;var u;(function(X){X[X.unknownEncoding=1]="unknownEncoding",X[X.regexParseError=2]="regexParseError",X[X.globParseError=3]="globParseError",X[X.invalidLiteral=4]="invalidLiteral",X[X.rgProcessError=5]="rgProcessError",X[X.other=6]="other",X[X.canceled=7]="canceled"})(u||(e.SearchErrorCode=u={}));class m extends Error{constructor(ae,Se){super(ae),this.code=Se}}e.$NI=m;function h(X){const ae=X.message;if((0,f.$3)(X))return new m(ae,u.canceled);try{const Se=JSON.parse(ae);return new m(Se.message,Se.code)}catch{return new m(ae,u.other)}}e.$OI=h;function P(X){const ae={message:X.message,code:X.code};return new Error(JSON.stringify(ae))}e.$PI=P;function W(X){return X.type==="error"?!0:X.type==="success"}e.$QI=W;function K(X){return X.type==="success"}e.$RI=K;function U(X){return!!X.path}e.$SI=U;function B(X,ae){const Se=X.searchPath?X.searchPath:X.relativePath;return(0,A.$nf)(Se,ae)}e.$TI=B;class O{constructor(ae){this.path=ae,this.results=[]}addMatch(ae){this.results.push(ae)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$UI=O;function N(X,ae){const Se={...X||{},...ae||{}};return Object.keys(Se).filter(ue=>{const $e=Se[ue];return typeof $e=="boolean"&&$e})}e.$VI=N;class te{constructor(ae,Se){this.c=null,this.a={...ae.excludePattern||{},...Se.excludePattern||{}},this.b=M.$uj(this.a);let ue=ae.includePattern;Se.includePattern&&(ue?ue={...ue,...Se.includePattern}:ue=Se.includePattern),ue&&(this.c=M.$uj(ue))}matchesExcludesSync(ae,Se,ue){return!!(this.b&&this.b(ae,Se,ue))}includedInQuerySync(ae,Se,ue){return!(this.b&&this.b(ae,Se,ue)||this.c&&!this.c(ae,Se,ue))}includedInQuery(ae,Se,ue){const $e=this.b(ae,Se,ue),ie=()=>this.c?!!this.c(ae,Se,ue):!0;return(0,D.$Fg)($e)?$e.then(z=>z?!1:ie()):ie()}hasSiblingExcludeClauses(){return Y(this.a)}}e.$WI=te;function Y(X){for(const ae in X)if(typeof X[ae]!="boolean")return!0;return!1}function ye(X){if(!X)return;let ae;return Se=>(ae||(ae=(X()||Promise.resolve([])).then(ue=>ue?Pe(ue):{})),ae.then(ue=>!!ue[Se]))}e.$XI=ye;function Ee(X){if(!X)return;let ae;return Se=>{if(!ae){const ue=X();ae=ue?Pe(ue):{}}return!!ae[Se]}}e.$YI=Ee;function Pe(X){const ae={};for(const Se of X)ae[Se]=!0;return ae}}),define(Re[33],Me([1,0,18,12,21,5,6,49,13,117,23,15,2,158,4,14,175,54,39,27,17,8,7,55,47,3]),function(be,e,w,M,C,F,A,l,k,f,R,D,c,p,$,g,t,n,a,b,E,v,r,s,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zbc=e.$Ybc=void 0;function y(W,K,U){return new R.$jg(B=>u(B,U)).isEqual(W,K)}function d(W,K,U){return y(W.uri,K.uri,U)?0:(0,D.$Te)(W.uri.toString(),K.uri.toString())}function I(W,K,U){return W.index!==K.index?W.index<K.index?-1:1:y(W.uri,K.uri,U)?(0,D.$Te)(W.name,K.name):(0,D.$Te)(W.uri.toString(),K.uri.toString())}function S(W,K,U,B){const O=W.slice(0).sort((te,Y)=>U(te,Y,B)),N=K.slice(0).sort((te,Y)=>U(te,Y,B));return(0,w.$Db)(O,N,(te,Y)=>U(te,Y,B))}function u(W,K){const U=K.getCapabilities(W.scheme);return!(U&&U&1024)}class m extends n.$7h{static toExtHostWorkspace(K,U,B,O){if(!K)return{workspace:null,added:[],removed:[]};const{id:N,name:te,folders:Y,configuration:ye,transient:Ee,isUntitled:Pe}=K,X=[],ae=U;U?Y.forEach((ie,z)=>{const V=c.URI.revive(ie.uri),le=m.o(B||U,V,O);le?(le.name=ie.name,le.index=ie.index,X.push(le)):X.push({uri:V,name:ie.name,index:z})}):X.push(...Y.map(({uri:ie,name:z,index:V})=>({uri:c.URI.revive(ie),name:z,index:V}))),X.sort((ie,z)=>ie.index<z.index?-1:1);const Se=new m(N,te,X,!!Ee,ye?c.URI.revive(ye):null,!!Pe,ie=>u(ie,O)),{added:ue,removed:$e}=S(ae?ae.workspaceFolders:[],Se.workspaceFolders,d,O);return{workspace:Se,added:ue,removed:$e}}static o(K,U,B){for(let O=0;O<K.folders.length;O++){const N=K.workspaceFolders[O];if(y(N.uri,U,B))return N}}constructor(K,U,B,O,N,te,Y){super(K,B.map(ye=>new n.$8h(ye)),O,N,Y),this.t=U,this.u=te,this.q=[],this.s=l.$Th.forUris(Y),B.forEach(ye=>{this.q.push(ye),this.s.set(ye.uri,ye)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(K,U){return U&&this.s.get(K)&&(K=(0,R.$tg)(K)),this.s.findSubstr(K)}resolveWorkspaceFolder(K){return this.s.get(K)}}let h=class{constructor(K,U,B,O,N){this.c=new F.$Md,this.onDidChangeWorkspace=this.c.event,this.g=new F.$Md,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new F.$Od,this.B=new Map,this.h=O,this.s=B,this.t=N,this.j=new f.$Ml,this.k=new M.$Rg,this.o=K.getProxy(o.$_J.MainThreadWorkspace),this.q=K.getProxy(o.$_J.MainThreadMessageService);const te=U.workspace;this.l=te?new m(te.id,te.name,[],!!te.transient,te.configuration?c.URI.revive(te.configuration):null,!!te.isUntitled,Y=>u(Y,B)):void 0}$initializeWorkspace(K,U){this.v=U,this.$acceptWorkspaceData(K),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?c.URI.from({scheme:k.Schemas.untitled,path:(0,R.$rg)((0,R.$tg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(K,U,B,...O){const N=[];if(Array.isArray(O)&&O.forEach(Pe=>{c.URI.isUri(Pe.uri)&&!N.some(X=>y(X.uri,Pe.uri,this.s))&&N.push({uri:Pe.uri,name:Pe.name||(0,R.$qg)(Pe.uri)})}),this.n||[U,B].some(Pe=>typeof Pe!="number"||Pe<0)||B===0&&N.length===0)return!1;const te=this.x?this.x.workspaceFolders:[];if(U+B>te.length)return!1;const Y=te.slice(0);Y.splice(U,B,...N.map(Pe=>({uri:Pe.uri,name:Pe.name||(0,R.$qg)(Pe.uri),index:void 0})));for(let Pe=0;Pe<Y.length;Pe++){const X=Y[Pe];if(Y.some((ae,Se)=>Se!==Pe&&y(X.uri,ae.uri,this.s)))return!1}Y.forEach((Pe,X)=>Pe.index=X);const{added:ye,removed:Ee}=S(te,Y,I,this.s);if(ye.length===0&&Ee.length===0)return!1;if(this.o){const Pe=K.displayName||K.name;this.o.$updateWorkspaceFolders(Pe,U,B,N).then(void 0,X=>{this.n=void 0;const ae={source:{identifier:K.identifier,label:K.displayName||K.name}};this.q.$showMessage(t.Severity.Error,(0,p.localize)(0,null,Pe,X.toString()),ae,[])})}return this.y(Y),!0}getWorkspaceFolder(K,U){if(this.x)return this.x.getWorkspaceFolder(K,U)}async getWorkspaceFolder2(K,U){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(K,U)}async resolveWorkspaceFolder(K){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(K)}getPath(){if(!this.x)return;const{folders:K}=this.x;if(K.length!==0)return K[0].uri.fsPath}getRelativePath(K,U){let B,O="";if(typeof K=="string"?(B=c.URI.file(K),O=K):typeof K<"u"&&(B=K,O=K.fsPath),!B)return O;const N=this.getWorkspaceFolder(B,!0);if(!N)return O;typeof U>"u"&&this.x&&(U=this.x.folders.length>1);let te=(0,R.$wg)(N.uri,B);return U&&N.name&&(te=`${N.name}/${te}`),te}y(K){this.x&&(this.n=m.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:K,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(K){const{workspace:U,added:B,removed:O}=m.toExtHostWorkspace(K,this.l,this.n,this.s);this.l=U||void 0,this.n=void 0,this.c.fire(Object.freeze({added:B,removed:O}))}findFiles(K,U,B,O,N=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${O.value}, entryPoint: findFiles`);let te;if(U===null?te=!1:U&&(typeof U=="string"?te=U:te=U.pattern),N&&N.isCancellationRequested)return Promise.resolve([]);const{includePattern:Y,folder:ye}=P(v.GlobPattern.from(K));return this.o.$startFileSearch(Y??null,ye??null,te??null,B??null,N).then(Ee=>Array.isArray(Ee)?Ee.map(Pe=>c.URI.revive(Pe)):[])}async findTextInFiles(K,U,B,O,N=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${O.value}, entryPoint: findTextInFiles`);const te=this.j.getNext(),Y=typeof U.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:U.previewOptions,{includePattern:ye,folder:Ee}=P(v.GlobPattern.from(U.include)),Pe=typeof U.exclude=="string"?U.exclude:U.exclude?U.exclude.pattern:void 0,X={ignoreSymlinks:typeof U.followSymlinks=="boolean"?!U.followSymlinks:void 0,disregardIgnoreFiles:typeof U.useIgnoreFiles=="boolean"?!U.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof U.useGlobalIgnoreFiles=="boolean"?!U.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof U.useParentIgnoreFiles=="boolean"?!U.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof U.useDefaultExcludes=="boolean"?!U.useDefaultExcludes:!0,fileEncoding:U.encoding,maxResults:U.maxResults,previewOptions:Y,afterContext:U.afterContext,beforeContext:U.beforeContext,includePattern:ye,excludePattern:Pe},ae=!1;if(this.u[te]=Se=>{if(ae)return;const ue=c.URI.revive(Se.resource);Se.results.forEach($e=>{(0,i.$EI)($e)?B({uri:ue,preview:{text:$e.preview.text,matches:(0,w.$1b)($e.preview.matches,ie=>new r.$dK(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))},ranges:(0,w.$1b)($e.ranges,ie=>new r.$dK(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))}):B({uri:ue,text:$e.text,lineNumber:$e.lineNumber})})},N.isCancellationRequested)return{};try{const Se=await this.o.$startTextSearch(K,Ee??null,X,te,N);return delete this.u[te],Se||{}}catch(Se){throw delete this.u[te],Se}}$handleTextSearchResult(K,U){this.u[U]?.(K)}async save(K){const U=await this.o.$save(K,{saveAs:!1});return c.URI.revive(U)}async saveAs(K){const U=await this.o.$save(K,{saveAs:!0});return c.URI.revive(U)}saveAll(K){return this.o.$saveAll(K)}resolveProxy(K){return this.o.$resolveProxy(K)}get trusted(){return this.v}requestWorkspaceTrust(K){return this.o.$requestWorkspaceTrust(K)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(K,U){if(this.w.has(K))throw new Error(`A provider has already been registered for scheme ${K}`);this.w.set(K,U);const B=this.t.transformOutgoingScheme(K),O=this.z++;return this.o.$registerEditSessionIdentityProvider(O,B),(0,A.$Pc)(()=>{this.w.delete(K),this.o.$unregisterEditSessionIdentityProvider(O)})}async $getEditSessionIdentifier(K,U){this.h.info("Getting edit session identifier for workspaceFolder",K);const B=await this.resolveWorkspaceFolder(c.URI.revive(K));if(!B){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",B);const O=this.w.get(B.uri.scheme);if(this.h.info(`Provider for scheme ${B.uri.scheme} is defined: `,!!O),!O)return;const N=await O.provideEditSessionIdentity(B,U);if(this.h.info("Provider returned edit session identifier: ",N),!!N)return N}async $provideEditSessionIdentityMatch(K,U,B,O){this.h.info("Getting edit session identifier for workspaceFolder",K);const N=await this.resolveWorkspaceFolder(c.URI.revive(K));if(!N){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",N);const te=this.w.get(N.uri.scheme);if(this.h.info(`Provider for scheme ${N.uri.scheme} is defined: `,!!te),!te)return;const Y=await te.provideEditSessionIdentityMatch?.(U,B,O);if(this.h.info("Provider returned edit session identifier match result: ",Y),!!Y)return Y}getOnWillCreateEditSessionIdentityEvent(K){return(U,B,O)=>{const N=function(Y){U.call(B,Y)};return N.extension=K,this.A.event(N,void 0,O)}}async $onWillCreateEditSessionIdentity(K,U,B){const O=await this.resolveWorkspaceFolder(c.URI.revive(K));if(O===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:O},U,async(N,te)=>{const Y=Date.now();await Promise.resolve(N),Date.now()-Y>B&&this.h.warn("SLOW edit session create-participant",te.extension.identifier)}),U.isCancellationRequested}registerCanonicalUriProvider(K,U){if(this.B.has(K))throw new Error(`A provider has already been registered for scheme ${K}`);this.B.set(K,U);const B=this.t.transformOutgoingScheme(K),O=this.z++;return this.o.$registerCanonicalUriProvider(O,B),(0,A.$Pc)(()=>{this.B.delete(K),this.o.$unregisterCanonicalUriProvider(O)})}async provideCanonicalUri(K,U,B){const O=this.B.get(K.scheme);if(!O)return;const N=await O.provideCanonicalUri?.(c.URI.revive(K),U,B);if(N)return N}async $provideCanonicalUri(K,U,B){return this.provideCanonicalUri(c.URI.revive(K),{targetScheme:U},B)}};e.$Ybc=h,e.$Ybc=h=qe([We(0,E.$aM),We(1,b.$qM),We(2,a.$Mbc),We(3,g.$8i),We(4,s.$Wbc)],h),e.$Zbc=(0,$.$Nh)("IExtHostWorkspace");function P(W){let K,U;return W&&(typeof W=="string"?K=W:(K=W.pattern,U=c.URI.revive(W.baseUri))),{includePattern:K,folder:U}}}),define(Re[34],Me([1,0,24,5,33,3,7,177,96,16,12,4,17,14,2]),function(be,e,w,M,C,F,A,l,k,f,R,D,c,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3bc=e.$2bc=e.$1bc=void 0;function g(s,i){if(i){const o=i.split(".");let y=s;for(let d=0;y&&d<o.length;d++)y=y[o[d]];return y}}function t(s){return s instanceof $.URI}function n(s){return s&&s.uri instanceof $.URI&&s.languageId&&typeof s.languageId=="string"}function a(s){return s&&!s.uri&&s.languageId&&typeof s.languageId=="string"}function b(s){return s&&s.uri instanceof $.URI&&(!s.name||typeof s.name=="string")&&(!s.index||typeof s.index=="number")}function E(s){if(t(s))return{resource:s};if(n(s))return{resource:s.uri,overrideIdentifier:s.languageId};if(a(s))return{overrideIdentifier:s.languageId};if(b(s))return{resource:s.uri};if(s===null)return{resource:null}}let v=class{constructor(i,o,y){this.a=i.getProxy(F.$_J.MainThreadConfiguration),this.c=o,this.b=y,this.d=new R.$Rg,this.e=null}getConfigProvider(){return this.d.wait().then(i=>this.e)}$initializeConfiguration(i){this.e=new r(this.a,this.c,i,this.b),this.d.open()}$acceptConfigurationChanged(i,o){this.getConfigProvider().then(y=>y.$acceptConfigurationChanged(i,o))}};e.$1bc=v,e.$1bc=v=qe([We(0,c.$aM),We(1,C.$Zbc),We(2,p.$8i)],v);class r{constructor(i,o,y,d){this.a=new M.$Md,this.b=i,this.f=d,this.c=o,this.e=l.$zn.parse(y),this.d=this.k(y.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(i,o){const y={data:this.e.toData(),workspace:this.c.workspace};this.e=l.$zn.parse(i),this.d=this.k(i.configurationScopes),this.a.fire(this.j(o,y))}getConfiguration(i,o,y){const d=E(o)||{},I=this.g(i?g(this.e.getValue(void 0,d,this.c.workspace),i):this.e.getValue(void 0,d,this.c.workspace));i&&this.h(i,d,y?.identifier);function S(m){if(m==null)return null;if(typeof m=="boolean")return m?2:5;switch(m){case A.ConfigurationTarget.Global:return 2;case A.ConfigurationTarget.Workspace:return 5;case A.ConfigurationTarget.WorkspaceFolder:return 6}}const u={has(m){return typeof g(I,m)<"u"},get:(m,h)=>{this.h(i?`${i}.${m}`:m,d,y?.identifier);let P=g(I,m);if(typeof P>"u")P=h;else{let W;const K=(U,B)=>{if((0,f.$zf)(U)){let O;const N=()=>{W=W||(0,w.$2m)(I),O=O||g(W,B)};return new Proxy(U,{get:(te,Y)=>{if(typeof Y=="string"&&Y.toLowerCase()==="tojson")return N(),()=>O;if(W)return O=O||g(W,B),O[Y];const ye=te[Y];return typeof Y=="string"?K(ye,`${B}.${Y}`):ye},set:(te,Y,ye)=>(N(),O&&(O[Y]=ye),!0),deleteProperty:(te,Y)=>(N(),O&&delete O[Y],!0),defineProperty:(te,Y,ye)=>(N(),O&&Object.defineProperty(O,Y,ye),!0)})}return Array.isArray(U)?(0,w.$2m)(U):U};P=K(P,m)}return P},update:(m,h,P,W)=>{m=i?`${i}.${m}`:m;const K=S(P);return h!==void 0?this.b.$updateConfigurationOption(K,m,h,d,W):this.b.$removeConfigurationOption(K,m,d,W)},inspect:m=>{m=i?`${i}.${m}`:m;const h=this.e.inspect(m,d,this.c.workspace);if(h)return{key:m,defaultValue:(0,w.$2m)(h.policy?.value??h.default?.value),globalValue:(0,w.$2m)(h.user?.value??h.application?.value),workspaceValue:(0,w.$2m)(h.workspace?.value),workspaceFolderValue:(0,w.$2m)(h.workspaceFolder?.value),defaultLanguageValue:(0,w.$2m)(h.default?.override),globalLanguageValue:(0,w.$2m)(h.user?.override??h.application?.override),workspaceLanguageValue:(0,w.$2m)(h.workspace?.override),workspaceFolderLanguageValue:(0,w.$2m)(h.workspaceFolder?.override),languageIds:(0,w.$2m)(h.overrideIdentifiers)}}};return typeof I=="object"&&(0,w.$5m)(u,I,!1),Object.freeze(u)}g(i){const o=y=>(0,f.$zf)(y)?new Proxy(y,{get:(d,I)=>o(d[I]),set:(d,I,S)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(I)}' of object`)},deleteProperty:(d,I)=>{throw new Error(`TypeError: Cannot delete read only property '${String(I)}' of object`)},defineProperty:(d,I)=>{throw new Error(`TypeError: Cannot define property '${String(I)}' for a readonly object`)},setPrototypeOf:d=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):y;return o(i)}h(i,o,y){const d=k.$qn.test(i)?4:this.d.get(i),I=y?`[${y.value}] `:"";if(d===4){typeof o?.resource>"u"&&this.f.warn(`${I}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${i}', provide the URI of a resource or 'null' for any resource.`);return}if(d===3){o?.resource&&this.f.warn(`${I}Accessing a window scoped configuration for a resource is not expected. To associate '${i}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(i,o){const y=new l.$Bn(i,o,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(d,I)=>y.affectsConfiguration(d,E(I))})}k(i){return i.reduce((o,y)=>(o.set(y[0],y[1]),o),new Map)}}e.$2bc=r,e.$3bc=(0,D.$Nh)("IExtHostConfiguration")}),define(Re[111],Me([1,0,2,12,5,3,7,33,59,34,21,62,17,27,4,13,22,14,80,214,9]),function(be,e,w,M,C,F,A,l,k,f,R,D,c,p,$,g,t,n,a,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1cc=e.$Zcc=e.$Ycc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var v;(function(K){function U(O){if(O!=null)return O}K.from=U;function B(O){if(O!=null)return O}K.to=B})(v||(v={}));var r;(function(K){function U(O){if(O!=null)return O}K.from=U;function B(O){if(O!=null)return O}K.to=B})(r||(r={}));var s;(function(K){function U(O){if(O!=null)return O}K.from=U;function B(O){if(O!=null)return O}K.to=B})(s||(s={}));var i;(function(K){function U(N){if(N){const te=N;return te&&!!te.process}else return!1}K.is=U;function B(N){if(N==null)return;const te={process:N.process,args:N.args};return N.options&&(te.options=s.from(N.options)),te}K.from=B;function O(N){if(N!=null)return new A.$VK(N.process,N.args,N.options)}K.to=O})(i||(i={}));var o;(function(K){function U(O){if(O!=null)return O}K.from=U;function B(O){if(O!=null)return O}K.to=B})(o||(o={}));var y;(function(K){function U(N){if(N){const te=N;return te&&(!!te.commandLine||!!te.command)}else return!1}K.is=U;function B(N){if(N==null)return;const te={};return N.commandLine!==void 0?te.commandLine=N.commandLine:(te.command=N.command,te.args=N.args),N.options&&(te.options=o.from(N.options)),te}K.from=B;function O(N){if(!(N==null||N.command===void 0&&N.commandLine===void 0))return N.commandLine?new A.$WK(N.commandLine,N.options):new A.$WK(N.command,N.args?N.args:[],N.options)}K.to=O})(y||(y={}));var d;(function(K){function U(N){if(N){const te=N;return te&&te.customExecution==="customExecution"}else return!1}K.is=U;function B(N){return{customExecution:"customExecution"}}K.from=B;function O(N,te){return te.get(N)}K.to=O})(d||(e.CustomExecutionDTO=d={}));var I;(function(K){function U(B,O){let N;return B.scope!==void 0&&typeof B.scope!="number"?N=B.scope.uri:B.scope!==void 0&&typeof B.scope=="number"&&(B.scope===A.TaskScope.Workspace&&O&&O.workspaceFile?N=O.workspaceFile:N=b.$NF),{id:B._id,workspaceFolder:N}}K.from=U})(I||(e.TaskHandleDTO=I={}));var S;(function(K){function U(B){if(B!=null)return{_id:B.id,isDefault:B.isDefault}}K.from=U})(S||(S={}));var u;(function(K){function U(N,te){if(N==null)return[];const Y=[];for(const ye of N){const Ee=B(ye,te);Ee&&Y.push(Ee)}return Y}K.fromMany=U;function B(N,te){if(N==null)return;let Y;N.execution instanceof A.$VK?Y=i.from(N.execution):N.execution instanceof A.$WK?Y=y.from(N.execution):N.execution&&N.execution instanceof A.$XK&&(Y=d.from(N.execution));const ye=v.from(N.definition);let Ee;return N.scope?typeof N.scope=="number"?Ee=N.scope:Ee=N.scope.uri:Ee=A.TaskScope.Workspace,!ye||!Ee?void 0:{_id:N._id,definition:ye,name:N.name,source:{extensionId:te.identifier.value,label:N.source,scope:Ee},execution:Y,isBackground:N.isBackground,group:S.from(N.group),presentationOptions:r.from(N.presentationOptions),problemMatchers:N.problemMatchers,hasDefinedMatchers:N.hasDefinedMatchers,runOptions:N.runOptions?N.runOptions:{reevaluateOnRerun:!0},detail:N.detail}}K.from=B;async function O(N,te,Y){if(N==null)return;let ye;i.is(N.execution)?ye=i.to(N.execution):y.is(N.execution)?ye=y.to(N.execution):d.is(N.execution)&&(ye=d.to(N._id,Y));const Ee=v.to(N.definition);let Pe;if(N.source&&(N.source.scope!==void 0?typeof N.source.scope=="number"?Pe=N.source.scope:Pe=await te.resolveWorkspaceFolder(w.URI.revive(N.source.scope)):Pe=A.TaskScope.Workspace),!Ee||!Pe)return;const X=new A.$YK(Ee,Pe,N.name,N.source.label,ye,N.problemMatchers);return N.isBackground!==void 0&&(X.isBackground=N.isBackground),N.group!==void 0&&(X.group=A.$UK.from(N.group._id),X.group&&N.group.isDefault&&(X.group=new A.$UK(X.group.id,X.group.label),N.group.isDefault===!0&&(X.group.isDefault=N.group.isDefault))),N.presentationOptions&&(X.presentationOptions=r.to(N.presentationOptions)),N._id&&(X._id=N._id),N.detail&&(X.detail=N.detail),X}K.to=O})(u||(e.TaskDTO=u={}));var m;(function(K){function U(O){return O}K.from=U;function B(O){if(O)return Object.assign(Object.create(null),O)}K.to=B})(m||(m={}));class h{#e;constructor(U,B,O){this._id=B,this.a=O,this.#e=U}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(U){}fireDidEndProcess(U){}}let P=class{constructor(U,B,O,N,te,Y,ye,Ee){this.q=new C.$Md,this.r=new C.$Md,this.s=new C.$Md,this.t=new C.$Md,this.a=U.getProxy(F.$_J.MainThreadTask),this.b=O,this.c=N,this.d=te,this.e=Y,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ye,this.g=Ee,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(U,B,O){if(!O)return new A.$bK(()=>{});const N=this.w();return this.j.set(N,{type:B,provider:O,extension:U}),this.a.$registerTaskProvider(N,B),new A.$bK(()=>{this.j.delete(N),this.a.$unregisterTaskProvider(N)})}registerTaskSystem(U,B){this.a.$registerTaskSystem(U,B)}fetchTasks(U){return this.a.$fetchTasks(m.from(U)).then(async B=>{const O=[];for(const N of B){const te=await u.to(N,this.b,this.m);te&&O.push(te)}return O})}get taskExecutions(){const U=[];return this.k.forEach(B=>U.push(B)),U}terminateTask(U){if(!(U instanceof h))throw new Error("No valid task execution provided");return this.a.$terminateTask(U._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(U,B,O){const N=this.m.get(U.id);N&&(this.o.set(U.id,N),this.e.attachPtyToTerminal(B,await N.callback(O))),this.p=U.id,this.q.fire({execution:await this.y(U)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(U){const B=await this.y(U);this.l.delete(U.id),this.k.delete(U.id),this.A(U),this.r.fire({execution:B})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(U){const B=await this.y(U.id);this.s.fire({execution:B,processId:U.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(U){const B=await this.y(U.id);this.t.fire({execution:B,exitCode:U.exitCode})}$provideTasks(U,B){const O=this.j.get(U);if(!O)return Promise.reject(new Error("no handler found"));const N=[],te=(0,M.$Lg)(()=>O.provider.provideTasks(R.CancellationToken.None)).then(Y=>this.u(B,N,O,Y));return new Promise(Y=>{te.then(ye=>{Promise.all(N).then(()=>{Y(ye)})})})}async $resolveTask(U,B){const O=this.j.get(U);if(!O)return Promise.reject(new Error("no handler found"));if(B.definition.type!==O.type)throw new Error(`Unexpected: Task of type [${B.definition.type}] cannot be resolved by provider of type [${O.type}].`);const N=await u.to(B,this.b,this.m);if(!N)throw new Error("Unexpected: Task cannot be resolved.");const te=await O.provider.resolveTask(N,R.CancellationToken.None);if(!te)return;this.z(te,O);const Y=u.from(te,O.extension);if(!Y)throw new Error("Unexpected: Task cannot be resolved.");if(te.definition!==N.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return d.is(Y.execution)&&await this.x(Y,te,!0),await this.v(Y)}w(){return this.h++}async x(U,B,O){const N=await this.a.$createTaskId(U);!O&&!this.m.has(N)&&(this.n.add(N),this.o.set(N,B.execution)),this.m.set(N,B.execution)}async y(U,B){if(typeof U=="string"){const te=this.l.get(U);if(!te)throw new E.$ab("Unexpected: The specified task is missing an execution");return te}const O=this.l.get(U.id);if(O)return O;const N=new Promise((te,Y)=>{function ye(Ee,Pe,X){X?te(new h(Ee,Pe.id,X)):Y("Unexpected: Task does not exist.")}B?ye(this,U,B):u.to(U.task,this.b,this.m).then(Ee=>ye(this,U,Ee))});return this.l.set(U.id,N),N.then(te=>(this.k.set(U.id,te),te),te=>Promise.reject(te))}z(U,B){U._deprecated&&this.g.report("Task.constructor",B.extension,"Use the Task constructor that takes a `scope` instead.")}A(U){this.o.get(U.id)&&this.o.delete(U.id),this.n.has(U.id)&&this.p!==U.id&&(this.m.delete(U.id),this.n.delete(U.id));const O=this.n.values();let N=O.next();for(;!N.done;)!this.o.has(N.value)&&this.p!==N.value&&(this.m.delete(N.value),this.n.delete(N.value)),N=O.next()}};e.$Ycc=P,e.$Ycc=P=qe([We(0,c.$aM),We(1,p.$qM),We(2,l.$Zbc),We(3,k.$lM),We(4,f.$3bc),We(5,D.$icc),We(6,n.$8i),We(7,a.$Pbc)],P);let W=class extends P{constructor(U,B,O,N,te,Y,ye,Ee){super(U,B,O,N,te,Y,ye,Ee),this.registerTaskSystem(g.Schemas.vscodeRemote,{scheme:g.Schemas.vscodeRemote,authority:"",platform:t.$i(0)})}async executeTask(U,B){if(!B.execution)throw new Error("Tasks to execute must include an execution");const O=u.from(B,U);if(O===void 0)throw new Error("Task is not valid");if(d.is(O.execution))await this.x(O,B,!1);else throw new E.$$;const N=await this.y(await this.a.$getTaskExecution(O),B);return this.a.$executeTask(O).catch(te=>{throw new Error(te)}),N}u(U,B,O,N){const te=[];if(N)for(const Y of N){this.z(Y,O),(!Y.definition||!U[Y.definition.type])&&this.f.warn(`The task [${Y.source}, ${Y.name}] uses an undefined task type. The task will be ignored in the future.`);const ye=u.from(Y,O.extension);ye&&d.is(ye.execution)?(te.push(ye),B.push(this.x(ye,Y,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:te,extension:O.extension}}async v(U){if(d.is(U.execution))return U;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(U,B){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(U,B,O){}};e.$Zcc=W,e.$Zcc=W=qe([We(0,c.$aM),We(1,p.$qM),We(2,l.$Zbc),We(3,k.$lM),We(4,f.$3bc),We(5,D.$icc),We(6,n.$8i),We(7,a.$Pbc)],W),e.$1cc=(0,$.$Nh)("IExtHostTask")}),define(Re[266],Me([1,0,19,21,41,37,23,58,47]),function(be,e,w,M,C,F,A,l,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$cc=void 0;class f{constructor(c,p,$){this.k=c,this.l=p,this.o=$,this.e=!1,this.f=0,this.g=!1,this.a=c.filePattern,this.b=c.includePattern&&F.$uj(c.includePattern),this.c=c.maxResults||void 0,this.d=c.exists,this.h=new Set,this.j=c.excludePattern&&F.$uj(c.excludePattern)}cancel(){this.g=!0,this.h.forEach(c=>c.cancel()),this.h=new Set}search(c){const p=this.k.folderQueries||[];return new Promise(($,g)=>{const t=n=>{this.f++,c(n)};if(this.g)return $({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(n=>{const a=n.toString(),b=w.$mc(a);this.j&&this.j(a,b)||this.v(t,{base:n,basename:b})}),Promise.all(p.map(n=>this.p(n,t))).then(n=>{$({limitHit:this.e,stats:n[0]||void 0})},n=>{g(new Error((0,C.$yi)(n)))})})}async p(c,p){const $=new M.$Wd,g=this.q(c),t=this.r(),n=new k.$WI(this.k,c),a=!n.hasSiblingExcludeClauses();let b;try{this.h.add($),b=l.$Id.create();const E=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},g,$.token),v=b.elapsed(),r=l.$Id.create();return this.g&&!this.e||(E&&E.forEach(s=>{const i=w.$fc.relative(c.folder.path,s.path);if(a){const o=w.$mc(s.path);this.v(p,{base:c.folder,relativePath:i,basename:o});return}this.s(t,c.folder,i,p)}),this.g&&!this.e)?null:(this.u(t,n,p),{providerTime:v,postProcessTime:r.elapsed()})}finally{$.dispose(),this.h.delete($)}}q(c){const p=(0,k.$VI)(this.k.includePattern,c.includePattern),$=(0,k.$VI)(this.k.excludePattern,c.excludePattern);return{folder:c.folder,excludes:$,includes:p,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!c.disregardParentIgnoreFiles,followSymlinks:!c.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const c={rootEntries:[],pathToEntries:Object.create(null)};return c.pathToEntries["."]=c.rootEntries,c}s({pathToEntries:c},p,$,g){if($===this.a){const n=w.$mc(this.a);this.v(g,{base:p,relativePath:this.a,basename:n})}function t(n){const a=w.$mc(n),b=w.$lc(n);let E=c[b];E||(E=c[b]=[],t(b)),E.push({base:p,relativePath:n,basename:a})}t($)}u({rootEntries:c,pathToEntries:p},$,g){const t=this,n=this.a;function a(b){const E=(0,k.$YI)(()=>b.map(v=>v.basename));for(let v=0,r=b.length;v<r;v++){const s=b[v],{relativePath:i,basename:o}=s;if($.matchesExcludesSync(i,o,n!==o?E:void 0))continue;const y=p[i];if(y)a(y);else{if(i===n)continue;t.v(g,s)}if(t.e)break}}a(c)}v(c,p){(!this.b||p.relativePath&&this.b(p.relativePath,p.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||c(p))}}class R{constructor(){this.b=new Map}static{this.a=512}fileSearch(c,p,$,g){const t=this.c(c.cacheKey),n=new f(c,p,t&&t.token);let a=0;const b=E=>{a+=E.length,$(E.map(v=>this.d(v)))};return this.e(n,R.a,b,g).then(E=>({limitHit:E.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:a,detailStats:E.stats}}))}clearCache(c){this.c(c)?.cancel()}c(c){if(c)return this.b.has(c)||this.b.set(c,new M.$Wd),this.b.get(c)}d(c){return c.relativePath?{resource:A.$ug(c.base,c.relativePath)}:{resource:c.base}}e(c,p,$,g){const t=g.onCancellationRequested(()=>{c.cancel()}),n=b=>{b&&(a.push(b),p>0&&a.length>=p&&($(a),a=[]))};let a=[];return c.search(n).then(b=>(a.length&&$(a),t.dispose(),b),b=>(a.length&&$(a),t.dispose(),Promise.reject(b)))}}e.$$cc=R}),define(Re[267],Me([1,0,18,231,37,90,28,13,19,23,15,16,2,282,167,43,14,54,102,265,47]),function(be,e,w,M,C,F,A,l,k,f,R,D,c,p,$,g,t,n,a,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QJ=e.$PJ=void 0;let v=class{constructor(m,h,P,W,K){this.a=m,this.b=h,this.c=P,this.d=W,this.e=K}text(m,h,P={}){m=this.f(m,P);const W=this.a.getValue(),K=h&&h.some(B=>!this.a.getValue({resource:B}).search.useRipgrep);return{...this.h(h?.map(n.$9h),P),type:2,contentPattern:m,previewOptions:P.previewOptions,maxFileSize:P.maxFileSize,usePCRE2:W.search.usePCRE2||K||!1,beforeContext:P.beforeContext,afterContext:P.afterContext,userDisabledExcludesAndIgnoreFiles:P.disregardExcludeSettings&&P.disregardIgnoreFiles}}f(m,h){const P=this.a.getValue();m.isRegExp&&(m.pattern=m.pattern.replace(/\r?\n/g,"\\n"));const W={...m,wordSeparators:P.editor.wordSeparators};return this.j(m,h)&&(W.isCaseSensitive=!0),this.k(m)&&(W.isMultiline=!0),h.notebookSearchConfig?.includeMarkupInput&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookMarkdownInput=h.notebookSearchConfig.includeMarkupInput),h.notebookSearchConfig?.includeMarkupPreview&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookMarkdownPreview=h.notebookSearchConfig.includeMarkupPreview),h.notebookSearchConfig?.includeCodeInput&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookCellInput=h.notebookSearchConfig.includeCodeInput),h.notebookSearchConfig?.includeOutput&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookCellOutput=h.notebookSearchConfig.includeOutput),W}file(m,h={}){return{...this.h(m,h),type:1,filePattern:h.filePattern?h.filePattern.trim():h.filePattern,exists:h.exists,sortByScore:h.sortByScore,cacheKey:h.cacheKey}}g(m,h){return m?(m=Array.isArray(m)?m.map(y):y(m),h?this.parseSearchPaths(m):{pattern:s(...Array.isArray(m)?m:[m])}):{}}h(m=[],h={}){const P=this.g(h.includePattern,h.expandPatterns),W=this.g(h.excludePattern,h.expandPatterns),K=m.length>1,U=(P.searchPaths&&P.searchPaths.length?P.searchPaths.map(N=>this.q(N,h,W)):m.map(N=>this.r(N,h,W,K))).filter(N=>!!N),B={_reason:h._reason,folderQueries:U,usingSearchPaths:!!(P.searchPaths&&P.searchPaths.length),extraFileResources:h.extraFileResources,excludePattern:W.pattern,includePattern:P.pattern,onlyOpenEditors:h.onlyOpenEditors,maxResults:h.maxResults};if(h.onlyOpenEditors){const N=w.$Gb(w.$Qb(this.c.groups.map(ye=>ye.editors.map(Ee=>Ee.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(N));const te=N.filter(ye=>(0,E.$MI)(B,ye.fsPath)),Y=this.i(te);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(Y)),{...B,...Y}}const O=h.extraFileResources&&h.extraFileResources.filter(N=>(0,E.$MI)(B,N.fsPath));return B.extraFileResources=O&&O.length?O:void 0,B}i(m){const h=[],P=new A.$zc,W={};let K=!1;return m.forEach(U=>{if(U.scheme===l.Schemas.walkThrough)return;if((0,f.$yg)(U)){const O=this.b.getWorkspaceFolder(U)?.uri??U.with({path:k.$lc(U.fsPath)});let N=P.get(O);N||(K=!0,N={folder:O,includePattern:{}},h.push(N),P.set(O,N));const te=k.$kc(O.fsPath,U.fsPath);(0,D.$If)(N.includePattern)[te.replace(/\\/g,"/")]=!0}else U.fsPath&&(K=!0,W[U.fsPath]=!0)}),{folderQueries:h,includePattern:W,usingSearchPaths:!0,excludePattern:K?void 0:{"**/*":!0}}}j(m,h){if(h.isSmartCase){if(m.isRegExp){if(R.$of(m.pattern,!0))return!0}else if(R.$of(m.pattern))return!0}return!!m.isCaseSensitive}k(m){return m.isMultiline||m.isRegExp&&(0,p.$oB)(m.pattern)||m.pattern.indexOf(`
`)>=0?!0:!!m.isMultiline}parseSearchPaths(m){const h=Y=>k.$hc(Y)||/^\.\.?([\/\\]|$)/.test(Y),W=(Array.isArray(m)?m:i(m)).map(Y=>{const ye=this.e.resolvedUserHome;return ye?(0,F.$ov)(Y,ye.scheme===l.Schemas.file?ye.fsPath:ye.path):Y}),K=M.$J(W,Y=>h(Y)?"searchPaths":"exprSegments"),U=(K.exprSegments||[]).map(Y=>R.$Je(Y,"/")).map(Y=>R.$Je(Y,"\\")).map(Y=>(Y[0]==="."&&(Y="*"+Y),o(Y))),B={},O=this.m(K.searchPaths||[]);O&&O.length&&(B.searchPaths=O);const N=w.$Qb(U),te=s(...N);return te&&(B.pattern=te),B}l(m,h){return h.disregardExcludeSettings?void 0:(0,E.$LI)(m,!h.disregardSearchExcludeSettings)}m(m){if(!m||!m.length)return[];const h=m.flatMap(W=>{let{pathPortion:K,globPortion:U}=r(W);return U&&(U=d(U)),this.n(K).flatMap(O=>this.o(O,U))}),P=new Map;return h.forEach(W=>{const K=W.searchPath.toString(),U=P.get(K);U?W.pattern&&(U.pattern=U.pattern||{},U.pattern[W.pattern]=!0):P.set(K,{searchPath:W.searchPath,pattern:W.pattern?s(W.pattern):void 0})}),Array.from(P.values())}n(m){if(k.$hc(m)){const h=this.b.getWorkspace().folders;return h[0]&&h[0].uri.scheme!==l.Schemas.file?[{searchPath:h[0].uri.with({path:m})}]:[{searchPath:c.URI.file(k.$gc(m))}]}if(this.b.getWorkbenchState()===2){const h=this.b.getWorkspace().folders[0].uri;if(m=y(m),m.startsWith("../")||m===".."){const W=k.$fc.resolve(h.path,m);return[{searchPath:h.with({path:W})}]}const P=d(m);return[{searchPath:h,pattern:P}]}else{if(m==="./"||m===".\\")return[];{const h=m.replace(/^\.[\/\\]/,""),W=this.b.getWorkspace().folders.map(K=>{const U=h.match(new RegExp(`^${R.$Ee(K.name)}(?:/(.*)|$)`));return U?{match:U,folder:K}:null}).filter(D.$Ff);if(W.length)return W.map(K=>{const U=K.match[1];return{searchPath:K.folder.uri,pattern:U&&d(U)}});{const K=m.match(/\.[\/\\](.+)[\/\\]?/),U=K?K[1]:m,B=$.localize(0,null,U);throw new Error(B)}}}}o(m,h){const P=m.pattern&&h?`${m.pattern}/${h}`:m.pattern||h,W=[{searchPath:m.searchPath,pattern:P}];return P&&!P.endsWith("**")&&W.push({searchPath:m.searchPath,pattern:P+"/**"}),W}q(m,h,P){const W=this.r((0,n.$9h)(m.searchPath),h,P,!1);return W?{...W,includePattern:m.pattern}:null}r(m,h,P,W){let K;const U=c.URI.isUri(m)?m:m.uri;if(P.searchPaths){const Y=P.searchPaths.filter(ye=>(0,f.$ng)(ye.searchPath,U))[0];if(Y&&!Y.pattern)return null;Y&&(K=Y.pattern)}const B=this.a.getValue({resource:U}),N={...this.l(B,h)||{},...K||{}},te=c.URI.isUri(m)?(0,f.$rg)(m):m.name;return{folder:U,folderName:W?te:void 0,excludePattern:Object.keys(N).length>0?N:void 0,fileEncoding:B.files&&B.files.encoding,disregardIgnoreFiles:typeof h.disregardIgnoreFiles=="boolean"?h.disregardIgnoreFiles:!B.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof h.disregardGlobalIgnoreFiles=="boolean"?h.disregardGlobalIgnoreFiles:!B.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof h.disregardParentIgnoreFiles=="boolean"?h.disregardParentIgnoreFiles:!B.search.useParentIgnoreFiles,ignoreSymlinks:typeof h.ignoreSymlinks=="boolean"?h.ignoreSymlinks:!B.search.followSymlinks}}};e.$PJ=v,e.$PJ=v=qe([We(0,g.$hi),We(1,n.$Wh),We(2,a.$$B),We(3,t.$8i),We(4,b.$NJ)],v);function r(u){const m=u.match(/[\*\{\}\(\)\[\]\?]/);if(m){const h=m.index,P=u.substr(0,h).match(/[/|\\][^/\\]*$/);if(P){let W=u.substr(0,P.index);return W.match(/[/\\]/)||(W+="/"),{pathPortion:W,globPortion:u.substr((P.index||0)+1)}}}return{pathPortion:u}}function s(...u){return u.length?u.reduce((m,h)=>(m[h]=!0,m),Object.create(null)):void 0}function i(u){return C.$sj(u,",").map(m=>m.trim()).filter(m=>!!m.length)}function o(u){return[`**/${u}/**`,`**/${u}`].map(h=>h.replace(/\*\*\/\*\*/g,"**"))}function y(u){return u.replace(/\\/g,"/")}function d(u){return y(u).replace(/^\.\//,"").replace(/\/+$/g,"")}function I(u){return u.replace(/([?*[\]])/g,"[$1]")}function S(u,m){u=w.$Lb(u,W=>W.toString());const h=[],P=m.getWorkspace();return u&&u.forEach(W=>{let K;if(m.getWorkbenchState()===2)K=(0,f.$wg)(P.folders[0].uri,W),K&&K!=="."&&(K="./"+K);else{const U=m.getWorkspaceFolder(W);if(U){const B=U.name;if(P.folders.filter(N=>N.name===B).length===1){const N=(0,f.$wg)(U.uri,W);N===""?K=`./${U.name}`:K=`./${U.name}/${N}`}else K=W.fsPath}}K&&h.push(I(K))}),h}e.$QJ=S}),define(Re[268],Me([1,0,23,2,21,9,4,267,47,54]),function(be,e,w,M,C,F,A,l,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$slb=e.$rlb=void 0;const R=7e3;function D(g,t){const n=t.activationEvents;if(!n)return Promise.resolve(void 0);const a=[],b=[];for(const o of n)if(/^workspaceContains:/.test(o)){const y=o.substr(18);y.indexOf("*")>=0||y.indexOf("?")>=0||g.forceUsingSearch?b.push(y):a.push(y)}if(a.length===0&&b.length===0)return Promise.resolve(void 0);let E;const v=new Promise((o,y)=>{E=o}),r=o=>E({activationEvent:o}),s=Promise.all(a.map(o=>c(g,o,r))).then(()=>{}),i=p(g,t.identifier,b,r);return Promise.all([s,i]).then(()=>{E(void 0)}),v}e.$rlb=D;async function c(g,t,n){for(const a of g.folders)if(await g.exists(w.$ug(M.URI.revive(a),t))){n(`workspaceContains:${t}`);return}}async function p(g,t,n,a){if(n.length===0)return Promise.resolve(void 0);const b=new C.$Wd,E=g.checkExists(g.folders,n,b.token),v=setTimeout(async()=>{b.cancel(),g.logService.info(`Not activating extension '${t.value}': Timed out while searching for 'workspaceContains' pattern ${n.join(",")}`)},R);let r=!1;try{r=await E}catch(s){F.$3(s)||F.$Z(s)}b.dispose(),clearTimeout(v),r&&a(`workspaceContains:${n.join(",")}`)}function $(g,t,n,a){const b=g.get(A.$Mh),E=g.get(k.$DI),r=b.createInstance(l.$PJ).file(t.map(s=>(0,f.$9h)(M.URI.revive(s))),{_reason:"checkExists",includePattern:n,exists:!0});return E.fileSearch(r,a).then(s=>!!s.limitHit,s=>F.$3(s)?!1:Promise.reject(s))}e.$slb=$}),define(Re[35],Me([1,0,148,19,87,23,12,6,49,2,14,3,34,209,84,33,25,106,9,20,26,188,7,97,4,27,85,17,70,86,62,5,268,83,190,13,81,58,22,82]),function(be,e,w,M,C,F,A,l,k,f,R,D,c,p,$,g,t,n,a,b,E,v,r,s,i,o,y,d,I,S,u,m,h,P,W,K,U,B,O,N){"use strict";var te;Object.defineProperty(e,"__esModule",{value:!0}),e.$xcc=e.$wcc=e.$vcc=e.$ucc=e.$tcc=void 0,e.$tcc=(0,i.$Nh)("IHostUtils");let Y=te=class extends l.$Rc{constructor(ie,z,V,le,we,ve,me,De,re,he,se,oe){super(),this.X=oe,this.a=this.B(new m.$Md),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=z,this.g=V,this.f=me,this.j=le,this.m=we,this.s=ve,this.t=re,this.u=he,this.w=se,this.y=this.g.getProxy(D.$_J.MainThreadWorkspace),this.z=this.g.getProxy(D.$_J.MainThreadTelemetry),this.C=this.g.getProxy(D.$_J.MainThreadExtensionService),this.D=new A.$Rg,this.F=new A.$Rg,this.G=new A.$Rg,this.H=new A.$Rg,this.I=new ue(this.f.extensions.activationEvents),this.L=new n.$_3b(this.I,this.f.extensions.allExtensions);const de=new b.$3l(this.f.extensions.myExtensions);this.J=new n.$_3b(this.I,ae(this.L,de)),O.$t&&(this.s.info(`Creating extension host with the following global extensions: ${Pe(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${Pe(this.J)}`)),this.M=new $.$acc(this.g,this.s),this.N=new P.$mcc(this.g),this.O=De,this.h=ie.createChild(new I.$Lh([$.$bcc,this.M],[P.$ncc,this.N])),this.P=this.B(new p.$_bc(this.J,this.L,{onExtensionActivationError:(Ie,T,q)=>{this.C.$onExtensionActivationError(Ie,a.$2(T),q)},actualActivateExtension:async(Ie,T)=>{if(n.$_3b.isHostExtension(Ie,this.J,this.L))return await this.C.$activateExtension(Ie,T),new p.$$bc;const q=this.J.getExtensionDescription(Ie);return this.db(q,T)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),C.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(ie){a.$Z(ie)}}async Y(){this.O.onWillDeactivateAll();let ie=[];try{ie=this.J.getAllExtensionDescriptions().map(we=>we.identifier).filter(we=>this.isActivated(we)).map(we=>this.cb(we))}catch{}await Promise.all(ie)}terminate(ie,z=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${ie}`),this.s.flush(),this.u.dispose(),this.P.dispose(),a.setUnexpectedErrorHandler(le=>{this.s.error(le)}),this.g.dispose();const V=this.Y();Promise.race([(0,A.$Tg)(5e3),V]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${z}`):this.s.info(`Extension host exiting with code ${z}`),this.s.flush(),this.s.dispose(),this.c.exit(z)})}isActivated(ie){return this.G.isOpen()?this.P.isActivated(ie):!1}async getExtension(ie){const z=await this.C.$getExtension(ie);return z&&{...z,identifier:new b.$2l(z.identifier.value),extensionLocation:f.URI.revive(z.extensionLocation)}}Z(ie,z){return this.P.activateByEvent(ie,z)}$(ie,z){return this.P.activateById(ie,z)}activateByIdWithErrors(ie,z){return this.$(ie,z).then(()=>{const V=this.P.getActivatedExtension(ie);if(V.activationFailed)return Promise.reject(V.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(ie=>this.J)}getExtensionExports(ie){if(this.G.isOpen())return this.P.getActivatedExtension(ie).exports;try{return this.P.getActivatedExtension(ie).exports}catch{return null}}async ab(ie){if(ie.scheme===K.Schemas.file&&this.c.fsRealpath){const z=await this.c.fsRealpath(ie.fsPath);return f.URI.file(z)}return ie}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(ie=>new Se(ie))),this.Q}async bb(ie){const z=k.$Th.forUris(V=>F.$lg.ignorePathCasing(V));return await Promise.all(ie.map(async V=>{if(this.ub(V)){const le=await this.ab(V.extensionLocation);z.set(le,V)}})),z}cb(ie){let z=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(ie))return z;const V=this.P.getActivatedExtension(ie);if(!V)return z;try{typeof V.module.deactivate=="function"&&(z=Promise.resolve(V.module.deactivate()).then(void 0,le=>(this.s.error(le),Promise.resolve(void 0))))}catch(le){this.s.error(`An error occurred when deactivating the extension '${ie.value}':`),this.s.error(le)}try{(0,l.$Mc)(V.subscriptions)}catch(le){this.s.error(`An error occurred when deactivating the subscriptions for extension '${ie.value}':`),this.s.error(le)}return z}async db(ie,z){return this.f.remote.isRemote?this.C.$onWillActivateExtension(ie.identifier):await this.C.$onWillActivateExtension(ie.identifier),this.fb(ie,z).then(V=>{const le=V.activationTimes;return this.C.$onDidActivateExtension(ie.identifier,le.codeLoadingTime,le.activateCallTime,le.activateResolvedTime,z),this.eb(ie,z,"success",le),V},V=>{throw this.eb(ie,z,"failure"),V})}eb(ie,z,V,le){const we=Ee(ie,z);this.z.$publicLog2("extensionActivationTimes",{...we,...le||{},outcome:V})}fb(ie,z){const V=Ee(ie,z);this.z.$publicLog2("activatePlugin",V);const le=this.ub(ie);if(!le)return Promise.resolve(new p.$0bc(p.$7bc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${ie.identifier.value}, startup: ${z.startup}, activationEvent: '${z.activationEvent}'${ie.identifier.value!==z.extensionId.value?`, root cause: ${z.extensionId.value}`:""}`),this.s.flush();const we=new p.$8bc(z.startup);return Promise.all([this.vb(ie,(0,F.$ug)(ie.extensionLocation,le),we),this.gb(ie)]).then(ve=>(C.mark(`code/extHost/willActivateExtension/${ie.identifier.value}`),te.hb(this.s,ie.identifier,ve[0],ve[1],we))).then(ve=>(C.mark(`code/extHost/didActivateExtension/${ie.identifier.value}`),ve))}gb(ie){const z=new v.$dcc(ie,this.M),V=new v.$ccc(ie.identifier.value,!1,this.M),le=new W.$occ(ie,this.N),we=ie.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?r.ExtensionMode.Test:r.ExtensionMode.Development:r.ExtensionMode.Production,ve=this.f.remote.isRemote?r.ExtensionKind.Workspace:r.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${ie.identifier.value}`),Promise.all([z.whenReady,V.whenReady,this.O.whenReady]).then(()=>{const me=this;let De,re;const he=(0,t.$$E)(ie,"ipc")?this.f.messagePorts?.get(b.$2l.toKey(ie.identifier)):void 0;return Object.freeze({globalState:z,workspaceState:V,secrets:le,subscriptions:[],get extensionUri(){return ie.extensionLocation},get extensionPath(){return ie.extensionLocation.fsPath},asAbsolutePath(se){return M.$ic(ie.extensionLocation.fsPath,se)},get storagePath(){return me.O.workspaceValue(ie)?.fsPath},get globalStoragePath(){return me.O.globalValue(ie).fsPath},get logPath(){return M.$ic(me.f.logsLocation.fsPath,ie.identifier.value)},get logUri(){return f.URI.joinPath(me.f.logsLocation,ie.identifier.value)},get storageUri(){return me.O.workspaceValue(ie)},get globalStorageUri(){return me.O.globalValue(ie)},get extensionMode(){return we},get extension(){return De===void 0&&(De=new X(me,ie.identifier,ie,ve,!1)),De},get extensionRuntime(){return(0,t.$_E)(ie,"extensionRuntime"),me.extensionRuntime},get environmentVariableCollection(){return me.u.getEnvironmentVariableCollection(ie)},get messagePassingProtocol(){if(!re){if(!he)return;const se=m.Event.buffer(m.Event.fromDOMEventEmitter(he,"message",oe=>oe.data));he.start(),re={onDidReceiveMessage:se,postMessage:he.postMessage.bind(he)}}return re}})})}static hb(ie,z,V,le,we){return V=V||{activate:void 0,deactivate:void 0},this.ib(ie,z,V,le,we).then(ve=>new p.$9bc(!1,null,we.build(),V,ve,le.subscriptions))}static ib(ie,z,V,le,we){if(typeof V.activate=="function")try{we.activateCallStart(),ie.trace(`ExtensionService#_callActivateOptional ${z.value}`);const ve=typeof global=="object"?global:self,me=V.activate.apply(ve,[le]);return we.activateCallStop(),we.activateResolveStart(),Promise.resolve(me).then(De=>(we.activateResolveStop(),De))}catch(ve){return Promise.reject(ve)}else return Promise.resolve(V)}jb(ie,z){this.$(ie.identifier,{startup:!1,extensionId:ie.identifier,activationEvent:z}).then(void 0,V=>{this.s.error(V)})}kb(ie,z=0){const le=Date.now();(0,O.$B)(()=>{for(let we=z;we<ie.length;we+=1){const ve=ie[we];for(const me of ve.activationEvents??[])if(me==="onStartupFinished")if(Date.now()-le>50){this.kb(ie,we);break}else this.jb(ve,me)}})}lb(){this.C.$setPerformanceMarks(C.getMarks()),this.m.getConfigProvider().then(ie=>{const z=ie.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),V=this.J.getAllExtensionDescriptions();if(z)this.kb(V);else for(const le of V)if(le.activationEvents)for(const we of le.activationEvents)we==="onStartupFinished"&&this.jb(le,we)})}mb(){const ie=this.Z("*",!0).then(void 0,ve=>{this.s.error(ve)});this.B(this.j.onDidChangeWorkspace(ve=>this.nb(ve.added)));const z=this.j.workspace?this.j.workspace.folders:[],V=this.nb(z),le=this.pb(),we=Promise.all([le,ie,V]).then(()=>{});return Promise.race([we,(0,A.$Tg)(1e4)]).then(()=>{this.lb()}),we}nb(ie){return ie.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(z=>this.ob(ie,z))).then(()=>{})}async ob(ie,z){if(this.isActivated(z.identifier))return;const V=!this.f.remote.isRemote&&!!this.f.remote.authority,le={logService:this.s,folders:ie.map(ve=>ve.uri),forceUsingSearch:V||!this.c.fsExists,exists:ve=>this.c.fsExists(ve.fsPath),checkExists:(ve,me,De)=>this.y.$checkExists(ve,me,De)},we=await(0,h.$rlb)(le,z);if(we)return this.$(z.identifier,{startup:!0,extensionId:z.identifier,activationEvent:we.activationEvent}).then(void 0,ve=>this.s.error(ve))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(ie){throw console.error(ie),ie}}async qb(){const{extensionDevelopmentLocationURI:ie,extensionTestsLocationURI:z}=this.f.environment;if(!ie||!z)throw new Error(w.localize(0,null));const V=await this.vb(null,z,new p.$8bc(!1));if(!V||typeof V.run!="function")throw new Error(w.localize(1,null,z.toString()));return new Promise((le,we)=>{const ve=(re,he)=>{re?(O.$t&&this.s.error("Test runner called back with error",re),we(re)):(O.$t&&(he?this.s.info(`Test runner called back with ${he} failures.`):this.s.info("Test runner called back with successful outcome.")),le(typeof he=="number"&&he>0?1:0))},me=(0,F.$ig)(z),De=V.run(me,ve);De&&De.then&&De.then(()=>{O.$t&&this.s.info("Test runner finished successfully."),le(0)}).catch(re=>{O.$t&&this.s.error("Test runner finished with error",re),we(re instanceof Error&&re.stack?re.stack:String(re))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,A.$Tg)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(ie,z){return this.R[ie]=z,(0,l.$Pc)(()=>{delete this.R[ie]})}async getRemoteExecServer(ie){const{resolver:z}=await this.sb(ie);return z?.resolveExecServer?.(ie,{resolveAttempt:0})}async sb(ie){const z=ie.indexOf("+");if(z===-1)throw new r.$hK("Not an authority that can be resolved!",s.RemoteAuthorityResolverErrorCode.InvalidAuthority);const V=ie.substr(0,z);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${V}`,!1),{authorityPrefix:V,resolver:this.R[V]}}async $resolveAuthority(ie,z){const V=B.$Id.create(!1),le=()=>`[resolveAuthority(${(0,s.$Qk)(ie)},${z})][${V.elapsed()}ms] `,we=Q=>this.s.info(`${le()}${Q}`),ve=Q=>this.s.warn(`${le()}${Q}`),me=(Q,H=void 0)=>this.s.error(`${le()}${Q}`,H),De=Q=>{if(Q instanceof r.$hK)return{type:"error",error:{code:Q._code,message:Q._message,detail:Q._detail}};throw Q},re=async Q=>{we(`activating resolver for ${Q}...`);const{resolver:H,authorityPrefix:x}=await this.sb(Q);if(!H)throw me(`no resolver for ${x}`),new r.$hK(`No remote extension installed to resolve ${x}.`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:H,authorityPrefix:x,remoteAuthority:Q}},he=ie.split(/@|%40/g).reverse();we(`activating remote resolvers ${he.join(" -> ")}`);let se;try{se=await Promise.all(he.map(re)).catch(async Q=>{if(!(Q instanceof r.$hK)||Q._code!==s.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw Q;return ve(`resolving nested authorities failed: ${Q.message}`),[await re(ie)]})}catch(Q){return De(Q)}const oe=new A.$4g;oe.cancelAndSet(()=>we("waiting..."),1e3);let de,Ie;for(const[Q,{authorityPrefix:H,resolver:x,remoteAuthority:ce}]of se.entries())try{if(Q===se.length-1)we("invoking final resolve()..."),C.mark(`code/extHost/willResolveAuthority/${H}`),de=await x.resolve(ce,{resolveAttempt:z,execServer:Ie}),C.mark(`code/extHost/didResolveAuthorityOK/${H}`),we("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(x,r.$gK.isManagedResolvedAuthority(de)?de:void 0));else{if(we(`invoking resolveExecServer() for ${ce}`),C.mark(`code/extHost/willResolveExecServer/${H}`),Ie=await x.resolveExecServer?.(ce,{resolveAttempt:z,execServer:Ie}),!Ie)throw new r.$hK(`Exec server was not available for ${ce}`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);C.mark(`code/extHost/didResolveExecServerOK/${H}`)}}catch(Fe){return C.mark(`code/extHost/didResolveAuthorityError/${H}`),me("returned an error",Fe),oe.dispose(),De(Fe)}oe.dispose();const T={environmentTunnels:de.environmentTunnels,features:de.tunnelFeatures},q={extensionHostEnv:de.extensionHostEnv,isTrusted:de.isTrusted,authenticationSession:de.authenticationSessionForInitializingExtensions?{id:de.authenticationSessionForInitializingExtensions.id,providerId:de.authenticationSessionForInitializingExtensions.providerId}:void 0};we(`returned ${r.$gK.isManagedResolvedAuthority(de)?"managed authority":`${de.host}:${de.port}`}`);let J;if(r.$gK.isManagedResolvedAuthority(de)){const Q=z;this.X.setFactory(Q,de.makeConnection),J={authority:ie,connectTo:new s.$Nk(Q),connectionToken:de.connectionToken}}else J={authority:ie,connectTo:new s.$Ok(de.host,de.port),connectionToken:de.connectionToken};return{type:"ok",value:{authority:J,options:q,tunnelInformation:T}}}async $getCanonicalURI(ie,z){this.s.info(`$getCanonicalURI invoked for authority (${(0,s.$Qk)(ie)})`);const{resolver:V}=await this.sb(ie);if(!V)return null;const le=f.URI.revive(z);if(typeof V.getCanonicalURI>"u")return le;const we=await(0,A.$Lg)(()=>V.getCanonicalURI(le));return we||le}$startExtensionHost(ie){ie.toAdd.forEach(le=>le.extensionLocation=f.URI.revive(le.extensionLocation));const{globalRegistry:z,myExtensions:V}=ye(this.I,this.L,this.J,ie);return this.L.set(z.getAllExtensionDescriptions()),this.J.set(V),O.$t&&(this.s.info(`$startExtensionHost: global extensions: ${Pe(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${Pe(this.J)}`)),this.rb()}$activateByEvent(ie,z){return z===1?this.D.wait().then(V=>this.Z(ie,!1)):this.G.wait().then(V=>this.Z(ie,!1))}async $activate(ie,z){return await this.G.wait(),this.J.getExtensionDescription(ie)?(await this.$(ie,z),!0):!1}async $deltaExtensions(ie){ie.toAdd.forEach(ve=>ve.extensionLocation=f.URI.revive(ve.extensionLocation));const{globalRegistry:z,myExtensions:V}=ye(this.I,this.L,this.J,ie),le=await this.bb(V);return(await this.getExtensionPathIndex()).setSearchTree(le),this.L.set(z.getAllExtensionDescriptions()),this.J.set(V),O.$t&&(this.s.info(`$deltaExtensions: global extensions: ${Pe(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${Pe(this.J)}`)),Promise.resolve(void 0)}async $test_latency(ie){return ie}async $test_up(ie){return ie.byteLength}async $test_down(ie){const z=E.$ae.alloc(ie),V=Math.random()%256;for(let le=0;le<ie;le++)z.writeUInt8(V,le);return z}async $updateRemoteConnectionData(ie){this.W=ie,this.a.fire()}};e.$ucc=Y,e.$ucc=Y=te=qe([We(0,i.$Mh),We(1,e.$tcc),We(2,d.$aM),We(3,g.$Zbc),We(4,c.$3bc),We(5,R.$8i),We(6,o.$qM),We(7,y.$gcc),We(8,S.$Wvb),We(9,u.$icc),We(10,U.$qcc),We(11,N.$rcc)],Y);function ye($e,ie,z,V){$e.addActivationEvents(V.addActivationEvents);const le=new n.$_3b($e,ie.getAllExtensionDescriptions());le.deltaExtensions(V.toAdd,V.toRemove);const we=new b.$3l(z.getAllExtensionDescriptions().map(me=>me.identifier));for(const me of V.myToRemove)we.delete(me);for(const me of V.myToAdd)we.add(me);const ve=ae(le,we);return{globalRegistry:le,myExtensions:ve}}function Ee($e,ie){return{id:$e.identifier.value,name:$e.name,extensionVersion:$e.version,publisherDisplayName:$e.publisher,activationEvents:$e.activationEvents?$e.activationEvents.join(","):null,isBuiltin:$e.isBuiltin,reason:ie.activationEvent,reasonId:ie.extensionId.value}}function Pe($e){return $e.getAllExtensionDescriptions().map(ie=>ie.identifier.value).join(",")}e.$vcc=(0,i.$Nh)("IExtHostExtensionService");class X{#e;#t;#i;constructor(ie,z,V,le,we){this.#e=ie,this.#t=z,this.#i=V.identifier,this.id=V.identifier.value,this.extensionUri=V.extensionLocation,this.extensionPath=M.$gc((0,F.$ig)(V.extensionLocation)),this.packageJSON=V,this.extensionKind=le,this.isFromDifferentExtensionHost=we}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$wcc=X;function ae($e,ie){return $e.getAllExtensionDescriptions().filter(z=>ie.has(z.identifier))}class Se{constructor(ie){this.a=ie}setSearchTree(ie){this.a=ie}findSubstr(ie){return this.a.findSubstr(ie)}forEach(ie){return this.a.forEach(ie)}}e.$xcc=Se;class ue{constructor(ie){this.a=new b.$4l,this.addActivationEvents(ie)}readActivationEvents(ie){return this.a.get(ie.identifier)}addActivationEvents(ie){for(const z of Object.keys(ie))this.a.set(z,ie[z])}}}),define(Re[269],Me([1,0,87,2,3,34,25,20,17,27,4,35,14,15]),function(be,e,w,M,C,F,A,l,k,f,R,D,c,p){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$Tdc=void 0;let g=class{constructor(E,v,r,s,i,o,y){this.c=E,this.d=v,this.e=r,this.f=s,this.g=i,this.h=o,this.i=y,this.a=new Map,this.b=[]}async install(){this.j(),w.mark("code/extHost/willWaitForConfig");const E=await this.f.getConfigProvider();w.mark("code/extHost/didWaitForConfig");const v=await this.g.getExtensionPathIndex();this.register(new n(this.c,v,this.d,E,this.i)),this.register(this.e.createInstance(t)),this.h.remote.isRemote&&this.register(this.e.createInstance(a,v,this.h.environment.appUriScheme))}register(E){if("nodeModuleName"in E)if(Array.isArray(E.nodeModuleName))for(const v of E.nodeModuleName)this.a.set(v,E);else this.a.set(E.nodeModuleName,E);typeof E.alternativeModuleName=="function"&&this.b.push(v=>E.alternativeModuleName(v))}};e.$Tdc=g,e.$Tdc=g=qe([We(2,R.$Mh),We(3,F.$3bc),We(4,D.$vcc),We(5,f.$qM),We(6,c.$8i)],g);let t=class{static{$=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(E){if(E.environment.appRoot&&$.a.size){const v=(0,p.$Ee)(this.c(E.environment.appRoot.fsPath)),r="[a-z0-9_.-]",s=`@${r}+\\/${r}+|${r}+`,i="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${v}/${i}\\/)(${s})(.*)$`,"i")}}alternativeModuleName(E){if(!this.b)return;const v=this.b.exec(this.c(E));if(!v)return;const[,r,s,i]=v,o=$.a.get(s);if(o!==void 0)return console.warn(`${s} as been renamed to ${o}, please update your imports`),r+o+i}c(E){return E.replace(/\\/g,"/")}};t=$=qe([We(0,f.$qM)],t);class n{constructor(E,v,r,s,i){this.c=E,this.d=v,this.e=r,this.f=s,this.g=i,this.nodeModuleName="vscode",this.a=new l.$4l}load(E,v){const r=this.d.findSubstr(v);if(r){let s=this.a.get(r.identifier);return s||(s=this.c(r,this.e,this.f),this.a.set(r.identifier,s)),s}if(!this.b){let s="";this.d.forEach((i,o)=>s+=`	${o} -> ${i.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${v}. These are the extension path mappings: 
${s}`),this.b=this.c(A.$6E,this.e,this.f)}return this.b}}let a=class{constructor(E,v,r){this.e=E,this.f=v,this.nodeModuleName=["open","opn"],this.d=r.getProxy(C.$_J.MainThreadTelemetry);const s=r.getProxy(C.$_J.MainThreadWindow);this.c=(i,o)=>{const y=M.URI.parse(i);return o?this.g(i,o):y.scheme==="http"||y.scheme==="https"?s.$openUri(y,i,{allowTunneling:!0}):y.scheme==="mailto"||y.scheme===this.f?s.$openUri(y,i,{}):this.g(i,o)}}load(E,v,r){const s=this.e.findSubstr(v);return s&&(this.a=s.identifier.value,this.h()),this.b=r(E),this.c}g(E,v){return this.i(),this.b(E,v)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};a=qe([We(2,k.$aM)],a)}),define(Re[112],Me([1,0,48,6,19,73,4,59,60,35,7,33,200,34]),function(be,e,w,M,C,F,A,l,k,f,R,D,c,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5cc=e.$4cc=void 0,e.$4cc=(0,A.$Nh)("IExtHostVariableResolverProvider");class $ extends c.$bN{constructor(n,a,b,E,v,r,s){function i(){if(b){const o=b.activeEditor();if(o)return o.document.uri;const y=E.tabGroups.all.find(d=>d.isActive)?.activeTab;if(y!==void 0){if(y.input instanceof R.$TL||y.input instanceof R.$YL)return y.input.modified;if(y.input instanceof R.$SL||y.input instanceof R.$XL||y.input instanceof R.$VL)return y.input.uri}}}super({getFolderUri:o=>{const y=r.folders.filter(d=>d.name===o);if(y&&y.length>0)return y[0].uri},getWorkspaceFolderCount:()=>r.folders.length,getConfigurationValue:(o,y)=>v.getConfiguration(void 0,o).get(y),getAppRoot:()=>F.cwd(),getExecPath:()=>F.env.VSCODE_EXEC_PATH,getFilePath:()=>{const o=i();if(o)return C.$gc(o.fsPath)},getWorkspaceFolderPathForFile:()=>{if(a){const o=i();if(o){const y=a.getWorkspaceFolder(o);if(y)return C.$gc(y.uri.fsPath)}}},getSelectedText:()=>{if(b){const o=b.activeEditor();if(o&&!o.selection.isEmpty)return o.document.getText(o.selection)}},getLineNumber:()=>{if(b){const o=b.activeEditor();if(o)return String(o.selection.end.line+1)}},getExtension:o=>n.getExtension(o)},void 0,s?Promise.resolve(s):void 0,Promise.resolve(F.env))}}let g=class extends M.$Rc{constructor(n,a,b,E,v){super(),this.b=n,this.c=a,this.g=b,this.h=E,this.j=v,this.a=new w.$U(async()=>{const r=await this.h.getConfigProvider(),i={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async o=>{i.folders=await this.c.getWorkspaceFolders2()||[]})),new $(this.b,this.c,this.g,this.j,r,i,this.m())})}getResolver(){return this.a.value}m(){}};e.$5cc=g,e.$5cc=g=qe([We(0,f.$vcc),We(1,D.$Zbc),We(2,l.$lM),We(3,p.$3bc),We(4,k.$2cc)],g)}),define(Re[113],Me([1,0,12,5,2,4,3,60,35,17,7,33,193,195,34,112]),function(be,e,w,M,C,F,A,l,k,f,R,D,c,p,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0cc=e.$9cc=e.$8cc=e.$7cc=e.$6cc=void 0,e.$6cc=(0,F.$Nh)("IExtHostDebugService");let t=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(s,i,o,y,d,I){this.E=i,this.F=o,this.G=y,this.H=d,this.I=I,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new M.$Md,this.n=new M.$Md,this.o=new M.$Md,this.u=new M.$Md,this.k=s.getProxy(A.$_J.MainThreadDebugService),this.y=new M.$Md,this.A=new M.$Md,this.v=new a(this.k),this.w=new Map,this.F.getExtensionRegistry().then(S=>{S.onDidChange(u=>{this.J(S)}),this.J(S)})}asDebugSourceUri(s,i){const o=s;if(typeof o.sourceReference=="number"&&o.sourceReference>0){let y=`debug:${encodeURIComponent(o.path||"")}`,d="?";return i&&(y+=`${d}session=${encodeURIComponent(i.id)}`,d="&"),y+=`${d}ref=${o.sourceReference}`,C.URI.parse(y)}else{if(o.path)return C.URI.file(o.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(s){const i=[];for(const o of s.getAllExtensionDescriptions())if(o.contributes){const y=o.contributes.debuggers;if(y&&y.length>0)for(const d of y)(0,p.$qF)(d)&&i.push(d.type)}this.k.$registerDebugTypes(i)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const s=[];return this.w.forEach(i=>s.push(i)),s}addBreakpoints(s){const i=s.filter(d=>{const I=d.id;return this.w.has(I)?!1:(this.w.set(I,d),!0)});this.U(i,[],[]);const o=[],y=new Map;for(const d of i)if(d instanceof R.$aL){let I=y.get(d.location.uri.toString());I||(I={type:"sourceMulti",uri:d.location.uri,lines:[]},y.set(d.location.uri.toString(),I),o.push(I)),I.lines.push({id:d.id,enabled:d.enabled,condition:d.condition,hitCondition:d.hitCondition,logMessage:d.logMessage,line:d.location.range.start.line,character:d.location.range.start.character})}else d instanceof R.$bL&&o.push({type:"function",id:d.id,enabled:d.enabled,hitCondition:d.hitCondition,logMessage:d.logMessage,condition:d.condition,functionName:d.functionName});return this.k.$registerBreakpoints(o)}removeBreakpoints(s){const i=s.filter(I=>this.w.delete(I.id));this.U([],i,[]);const o=i.filter(I=>I instanceof R.$aL).map(I=>I.id),y=i.filter(I=>I instanceof R.$bL).map(I=>I.id),d=i.filter(I=>I instanceof R.$cL).map(I=>I.id);return this.k.$unregisterBreakpoints(o,y,d)}startDebugging(s,i,o){return this.k.$startDebugging(s?s.uri:void 0,i,{parentSessionID:o.parentSession?o.parentSession.id:void 0,lifecycleManagedByParent:o.lifecycleManagedByParent,repl:o.consoleMode===R.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:o.noDebug,compact:o.compact,suppressSaveBeforeStart:o.suppressSaveBeforeStart,suppressDebugStatusbar:o.suppressDebugStatusbar??o.debugUI?.simple,suppressDebugToolbar:o.suppressDebugToolbar??o.debugUI?.simple,suppressDebugView:o.suppressDebugView??o.debugUI?.simple})}stopDebugging(s){return this.k.$stopDebugging(s?s.id:void 0)}registerDebugConfigurationProvider(s,i,o){if(!i)return new R.$bK(()=>{});const y=this.d++;return this.f.push({type:s,handle:y,provider:i}),this.k.$registerDebugConfigurationProvider(s,o,!!i.provideDebugConfigurations,!!i.resolveDebugConfiguration,!!i.resolveDebugConfigurationWithSubstitutedVariables,y),new R.$bK(()=>{this.f=this.f.filter(d=>d.provider!==i),this.k.$unregisterDebugConfigurationProvider(y)})}registerDebugAdapterDescriptorFactory(s,i,o){if(!o)return new R.$bK(()=>{});if(!this.Q(s,i))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${i}' debugger.`);if(this.N(i))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const y=this.g++;return this.h.push({type:i,handle:y,factory:o}),this.k.$registerDebugAdapterDescriptorFactory(i,y),new R.$bK(()=>{this.h=this.h.filter(d=>d.factory!==o),this.k.$unregisterDebugAdapterDescriptorFactory(y)})}registerDebugAdapterTrackerFactory(s,i){if(!i)return new R.$bK(()=>{});const o=this.i++;return this.j.push({type:s,handle:o,factory:i}),new R.$bK(()=>{this.j=this.j.filter(y=>y.factory!==i)})}async $runInTerminal(s,i){return Promise.resolve(void 0)}async $substituteVariables(s,i){let o;const y=await this.W(s);return y&&(o={uri:y.uri,name:y.name,index:y.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(o,i)}K(s,i){if(s.type==="implementation")return new E(s.implementation)}L(){}async $startDASession(s,i){const o=this,y=await this.V(i);return this.S(this.N(y.type),y).then(d=>{if(!d)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${y.type}' (extension might have failed to activate)`);const I=this.M(d),S=this.K(I,y);if(!S)throw new Error(`Couldn't create a debug adapter for type '${y.type}'.`);const u=S;return this.B.set(s,u),this.R(y).then(m=>(m&&this.C.set(s,m),u.onMessage(async h=>{if(h.type==="request"&&h.command==="handshake"){const P=h,W={type:"response",seq:0,command:P.command,request_seq:P.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const K=await this.D.sign(P.arguments.value);W.body={signature:K},u.sendResponse(W)}else throw new Error("no signer")}catch(K){W.success=!1,W.message=K.message,u.sendResponse(W)}}else m&&m.onDidSendMessage&&m.onDidSendMessage(h),h=(0,p.$vF)(h,!0),o.k.$acceptDAMessage(s,h)}),u.onError(h=>{m&&m.onError&&m.onError(h),this.k.$acceptDAError(s,h.name,h.message,h.stack)}),u.onExit(h=>{m&&m.onExit&&m.onExit(h??void 0,void 0),this.k.$acceptDAExit(s,h??void 0,void 0)}),m&&m.onWillStartSession&&m.onWillStartSession(),u.startSession()))})}$sendDAMessage(s,i){i=(0,p.$uF)(i,!1);const o=this.C.get(s);o&&o.onWillReceiveMessage&&o.onWillReceiveMessage(i),this.B.get(s)?.sendMessage(i)}$stopDASession(s){const i=this.C.get(s);this.C.delete(s),i&&i.onWillStopSession&&i.onWillStopSession();const o=this.B.get(s);return this.B.delete(s),o?o.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(s){const i=[],o=[],y=[];if(s.added)for(const d of s.added){const I=d.id;if(I&&!this.w.has(I)){let S;if(d.type==="function")S=new R.$bL(d.functionName,d.enabled,d.condition,d.hitCondition,d.logMessage);else if(d.type==="data")S=new R.$cL(d.label,d.dataId,d.canPersist,d.enabled,d.hitCondition,d.condition,d.logMessage);else{const u=C.URI.revive(d.uri);S=new R.$aL(new R.$nK(u,new R.$cK(d.line,d.character)),d.enabled,d.condition,d.hitCondition,d.logMessage)}(0,R.$$K)(S,I),this.w.set(I,S),i.push(S)}}if(s.removed)for(const d of s.removed){const I=this.w.get(d);I&&(this.w.delete(d),o.push(I))}if(s.changed){for(const d of s.changed)if(d.id){const I=this.w.get(d.id);if(I){if(I instanceof R.$bL&&d.type==="function"){const S=I;S.enabled=d.enabled,S.condition=d.condition,S.hitCondition=d.hitCondition,S.logMessage=d.logMessage,S.functionName=d.functionName}else if(I instanceof R.$aL&&d.type==="source"){const S=I;S.enabled=d.enabled,S.condition=d.condition,S.hitCondition=d.hitCondition,S.logMessage=d.logMessage,S.location=new R.$nK(C.URI.revive(d.uri),new R.$cK(d.line,d.character))}y.push(I)}}}this.U(i,o,y)}async $acceptStackFrameFocus(s){let i;const o=s.sessionId?await this.V(s.sessionId):void 0;if(!o)throw new Error("no DebugSession found for debug focus context");s.kind==="thread"?i=new R.$iL(o,s.threadId):i=new R.$hL(o,s.threadId,s.frameId),this.z=i,this.A.fire(this.z)}$provideDebugConfigurations(s,i,o){return(0,w.$Lg)(async()=>{const y=this.P(s);if(!y)throw new Error("no DebugConfigurationProvider found");if(!y.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const d=await this.W(i);return y.provideDebugConfigurations(d,o)}).then(y=>{if(!y)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return y})}$resolveDebugConfiguration(s,i,o,y){return(0,w.$Lg)(async()=>{const d=this.P(s);if(!d)throw new Error("no DebugConfigurationProvider found");if(!d.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const I=await this.W(i);return d.resolveDebugConfiguration(I,o,y)})}$resolveDebugConfigurationWithSubstitutedVariables(s,i,o,y){return(0,w.$Lg)(async()=>{const d=this.P(s);if(!d)throw new Error("no DebugConfigurationProvider found");if(!d.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const I=await this.W(i);return d.resolveDebugConfigurationWithSubstitutedVariables(I,o,y)})}async $provideDebugAdapter(s,i){const o=this.O(s);if(!o)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const y=await this.V(i);return this.S(o,y).then(d=>{if(!d)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${y.type}'`);return this.M(d)})}async $acceptDebugSessionStarted(s){const i=await this.V(s);this.m.fire(i)}async $acceptDebugSessionTerminated(s){const i=await this.V(s);i&&(this.n.fire(i),this.l.delete(i.id))}async $acceptDebugSessionActiveChanged(s){this.q=s?await this.V(s):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(s,i){(await this.V(s))?._acceptNameChanged(i)}async $acceptDebugSessionCustomEvent(s,i){const y={session:await this.V(s),event:i.event,body:i.body};this.u.fire(y)}M(s){if(s instanceof R.$dL)return{type:"executable",command:s.command,args:s.args,options:s.options};if(s instanceof R.$eL)return{type:"server",port:s.port,host:s.host};if(s instanceof R.$fL)return{type:"pipeServer",path:s.path};if(s instanceof R.$gL)return{type:"implementation",implementation:s.implementation};throw new Error("convertToDto unexpected type")}N(s){const i=this.h.filter(o=>o.type===s);if(i.length>0)return i[0].factory}O(s){const i=this.h.filter(o=>o.handle===s);if(i.length>0)return i[0].factory}P(s){const i=this.f.filter(o=>o.handle===s);if(i.length>0)return i[0].provider}Q(s,i){if(s.contributes){const o=s.contributes.debuggers;if(o&&o.length>0){for(const y of o)if(y.label&&y.type&&y.type===i)return!0}}return!1}R(s){const o=s.configuration.type,y=this.j.filter(d=>d.type===o||d.type==="*").map(d=>(0,w.$Lg)(()=>d.factory.createDebugAdapterTracker(s)).then(I=>I,I=>null));return Promise.race([Promise.all(y).then(d=>{const I=d.filter(S=>!!S);if(I.length>0)return new b(I)}),new Promise(d=>setTimeout(()=>d(void 0),1e3))]).catch(d=>{})}async S(s,i){const o=i.configuration.debugServer;if(typeof o=="number")return Promise.resolve(new R.$eL(o));if(s){const d=await this.F.getExtensionRegistry();return(0,w.$Lg)(()=>s.createDebugAdapterDescriptor(i,this.T(i,d))).then(I=>{if(I)return I})}const y=await this.F.getExtensionRegistry();return Promise.resolve(this.T(i,y))}T(s,i){}U(s,i,o){(s.length>0||i.length>0||o.length>0)&&this.y.fire(Object.freeze({added:s,removed:i,changed:o}))}async V(s){if(s)if(typeof s=="string"){const i=this.l.get(s);if(i)return i}else{let i=this.l.get(s.id);if(!i){const o=await this.W(s.folderUri),y=s.parent?this.l.get(s.parent):void 0;i=new n(this.k,s.id,s.type,s.name,o,s.configuration,y),this.l.set(i.id,i),this.k.$sessionCached(i.id)}return i}throw new Error("cannot find session")}W(s){if(s){const i=C.URI.revive(s);return this.E.resolveWorkspaceFolder(i)}return Promise.resolve(void 0)}};e.$7cc=t,e.$7cc=t=qe([We(0,f.$aM),We(1,D.$Zbc),We(2,k.$vcc),We(3,$.$3bc),We(4,l.$2cc),We(5,g.$4cc)],t);class n{constructor(s,i,o,y,d,I,S){this.d=s,this.f=i,this.g=o,this.h=y,this.i=d,this.j=I,this.k=S}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(s){this.h=s,this.d.$setDebugSessionName(this.f,s)}get parentSession(){return this.k}_acceptNameChanged(s){this.h=s}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(s,i){return this.d.$customDebugAdapterRequest(this.f,s,i)}getDebugProtocolBreakpoint(s){return this.d.$getDebugProtocolBreakpoint(this.f,s.id)}}e.$8cc=n;class a{constructor(s){this.value=Object.freeze({append(i){s.$appendDebugConsole(i)},appendLine(i){this.append(i+`
`)}})}}e.$9cc=a;class b{constructor(s){this.d=s}onWillStartSession(){this.d.forEach(s=>s.onWillStartSession?s.onWillStartSession():void 0)}onWillReceiveMessage(s){this.d.forEach(i=>i.onWillReceiveMessage?i.onWillReceiveMessage(s):void 0)}onDidSendMessage(s){this.d.forEach(i=>i.onDidSendMessage?i.onDidSendMessage(s):void 0)}onWillStopSession(){this.d.forEach(s=>s.onWillStopSession?s.onWillStopSession():void 0)}onError(s){this.d.forEach(i=>i.onError?i.onError(s):void 0)}onExit(s,i){this.d.forEach(o=>o.onExit?o.onExit(s,i):void 0)}}class E extends c.$Xcb{constructor(s){super(),this.h=s,s.onDidSendMessage(i=>{this.acceptMessage(i)})}startSession(){return Promise.resolve(void 0)}sendMessage(s){this.h.handleMessage(s)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let v=class extends t{constructor(s,i,o,y,d,I){super(s,i,o,y,d,I)}};e.$0cc=v,e.$0cc=v=qe([We(0,f.$aM),We(1,D.$Zbc),We(2,k.$vcc),We(3,$.$3bc),We(4,l.$2cc),We(5,g.$4cc)],v)}),define(Re[270],Me([1,0,9,87,2,3,261,14,69,70,27,172,17,55,35,57]),function(be,e,w,M,C,F,A,l,k,f,R,D,c,p,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vdc=e.$Udc=void 0;class t{static async installEarlyHandler(b){Error.stackTraceLimit=100;const E=b.get(l.$8i),r=b.get(c.$aM).getProxy(F.$_J.MainThreadErrors);w.setUnexpectedErrorHandler(s=>{E.error(s);const i=w.$2(s);r.$onUnexpectedError(i)})}static async installFullHandler(b){const E=b.get(l.$8i),v=b.get(c.$aM),r=b.get($.$vcc),s=b.get(g.$uM),i=v.getProxy(F.$_J.MainThreadExtensionService),o=v.getProxy(F.$_J.MainThreadErrors),y=await r.getExtensionPathIndex(),d=new WeakMap;function I(m,h){if(d.has(m))return d.get(m).stack;let P="",W,K;for(const B of h)P+=`
	at ${B.toString()}`,K=B.getFileName(),!W&&K&&(W=y.findSubstr(C.URI.file(K)));const U=`${m.name||"Error"}: ${m.message||""}${P}`;return d.set(m,{extensionIdentifier:W?.identifier,stack:U}),U}const S=Symbol("prepareStackTrace wrapped");let u=I;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return u},set(m){if(m===I||!m||m[S]){u=m||I;return}u=function(h,P){return I(h,P),m.call(Error,h,P)},Object.assign(u,{[S]:!0})}}),w.setUnexpectedErrorHandler(m=>{E.error(m);const h=w.$2(m),P=d.get(m);if(!P?.extensionIdentifier){o.$onUnexpectedError(h);return}i.$onExtensionRuntimeError(P.extensionIdentifier,h);const W=s.onExtensionError(P.extensionIdentifier,m);E.trace("forwarded error to extension?",W,P)})}}e.$Udc=t;class n{constructor(b,E,v,r,s){this.a=v,this.b=new A.$i4b(b,null,r),E=n.e(E,this.b);const i=new f.$Lh(...(0,k.$tr)());i.set(R.$qM,{_serviceBrand:void 0,...E,messagePorts:s}),i.set(c.$aM,new c.$bM(this.b)),i.set(p.$Wbc,new p.$Xbc(r)),i.set($.$tcc,v);const o=new D.$_p(i,!0);o.invokeFunction(t.installEarlyHandler),this.d=o.invokeFunction(y=>y.get(l.$8i)),M.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",E),this.c=o.invokeFunction(y=>y.get($.$vcc)),this.c.initialize(),o.invokeFunction(t.installFullHandler)}async asBrowserUri(b){const E=this.b.getProxy(F.$_J.MainThreadExtensionService);return C.URI.revive(await E.$asBrowserUri(b))}terminate(b){this.c.terminate(b)}static e(b,E){b.extensions.allExtensions.forEach(r=>{r.extensionLocation=C.URI.revive(E.transformIncomingURIs(r.extensionLocation))}),b.environment.appRoot=C.URI.revive(E.transformIncomingURIs(b.environment.appRoot));const v=b.environment.extensionDevelopmentLocationURI;return v&&(b.environment.extensionDevelopmentLocationURI=v.map(r=>C.URI.revive(E.transformIncomingURIs(r)))),b.environment.extensionTestsLocationURI=C.URI.revive(E.transformIncomingURIs(b.environment.extensionTestsLocationURI)),b.environment.globalStorageHome=C.URI.revive(E.transformIncomingURIs(b.environment.globalStorageHome)),b.environment.workspaceStorageHome=C.URI.revive(E.transformIncomingURIs(b.environment.workspaceStorageHome)),b.environment.extensionTelemetryLogResource=C.URI.revive(E.transformIncomingURIs(b.environment.extensionTelemetryLogResource)),b.nlsBaseUrl=C.URI.revive(E.transformIncomingURIs(b.nlsBaseUrl)),b.logsLocation=C.URI.revive(E.transformIncomingURIs(b.logsLocation)),b.workspace=E.transformIncomingURIs(b.workspace),b}}e.$Vdc=n}),define(Re[271],Me([1,0,18,12,21,41,13,19,23,2,47]),function(be,e,w,M,C,F,A,l,k,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cdc=e.$bdc=e.$adc=e.$_cc=void 0;class D{constructor(a,b,E,v){this.d=a,this.e=b,this.f=E,this.g=v,this.a=null,this.b=!1,this.c=0}search(a,b){const E=this.d.folderQueries||[],v=new C.$Wd(b);return new Promise((r,s)=>{this.a=new p(a);let i=!1;const o=(y,d)=>{if(!i&&!this.b){const I=this.h(y);g(y)&&typeof this.d.maxResults=="number"&&this.c+I>this.d.maxResults&&(this.b=!0,i=!0,v.cancel(),y=this.j(y,this.d.maxResults-this.c));const S=this.h(y);this.c+=S,(S>0||!g(y))&&this.a.add(y,d)}};Promise.all(E.map((y,d)=>this.k(y,I=>o(I,d),v.token))).then(y=>{v.dispose(),this.a.flush();const d=y.some(I=>!!I&&!!I.limitHit);r({limitHit:this.b||d,messages:(0,w.$Qb)(y.map(I=>I?.message?Array.isArray(I.message)?I.message:[I.message]:[])),stats:{type:this.g}})},y=>{v.dispose();const d=(0,F.$yi)(y);s(new Error(d))})})}h(a){return g(a)?Array.isArray(a.ranges)?a.ranges.length:1:0}j(a,b){const E=Array.isArray(a.ranges)?a.ranges:[a.ranges],v=Array.isArray(a.preview.matches)?a.preview.matches:[a.preview.matches];return{ranges:E.slice(0,b),preview:{matches:v.slice(0,b),text:a.preview.text},uri:a.uri}}async k(a,b,E){const v=new R.$WI(this.d,a),r=[],s={report:y=>{if(!this.l(y))return;const d=a.folder.scheme===A.Schemas.file?(0,R.$XI)(()=>this.f.readdir(k.$tg(y.uri))):void 0,I=k.$wg(a.folder,y.uri);if(I){const S=v.includedInQuery(I,l.$mc(I),d);(0,M.$Fg)(S)?r.push(S.then(u=>{u&&b(y)})):S&&b(y)}}},i=this.n(a),o=await this.e.provideTextSearchResults(c(this.d.contentPattern),i,s,E);return r.length&&await Promise.all(r),o}l(a){if(g(a)){if(Array.isArray(a.ranges)){if(!Array.isArray(a.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(a.preview.matches.length!==a.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(a.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(a){const b=(0,R.$VI)(this.d.includePattern,a.includePattern),E=(0,R.$VI)(this.d.excludePattern,a.excludePattern),v={folder:f.URI.from(a.folder),excludes:E,includes:b,useIgnoreFiles:!a.disregardIgnoreFiles,useGlobalIgnoreFiles:!a.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!a.disregardParentIgnoreFiles,followSymlinks:!a.ignoreSymlinks,encoding:a.fileEncoding&&this.f.toCanonicalName(a.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return v.usePCRE2=this.d.usePCRE2,v}}e.$_cc=D;function c(n){return{isCaseSensitive:n.isCaseSensitive||!1,isRegExp:n.isRegExp||!1,isWordMatch:n.isWordMatch||!1,isMultiline:n.isMultiline||!1,pattern:n.pattern}}class p{constructor(a){this.e=a,this.b=-1,this.d=null,this.a=new t(512,b=>this.g(b))}add(a,b){this.d&&(this.b!==b||!k.$ng(this.c,a.uri))&&(this.f(),this.d=null),this.d||(this.b=b,this.d={resource:a.uri,results:[]}),this.d.results.push($(a))}f(){const a=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,a)}flush(){this.f(),this.a.flush()}g(a){this.e(a)}}e.$adc=p;function $(n){return g(n)?{preview:{matches:(0,w.$1b)(n.preview.matches,a=>({startLineNumber:a.start.line,startColumn:a.start.character,endLineNumber:a.end.line,endColumn:a.end.character})),text:n.preview.text},ranges:(0,w.$1b)(n.ranges,a=>({startLineNumber:a.start.line,startColumn:a.start.character,endLineNumber:a.end.line,endColumn:a.end.character}))}:{text:n.text,lineNumber:n.lineNumber}}function g(n){return!!n.preview}e.$bdc=g;class t{static{this.a=4e3}static{this.b=50}constructor(a,b){this.g=a,this.h=b,this.c=0,this.d=[],this.e=0}addItem(a,b){a&&this.j(a,b)}addItems(a,b){a&&this.k(a,b)}j(a,b){this.d.push(a),this.e+=b,this.l()}k(a,b){this.d=this.d.concat(a),this.e+=b,this.l()}l(){this.c<t.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},t.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$cdc=t}),define(Re[114],Me([1,0,6,3,4,266,17,55,14,2,271]),function(be,e,w,M,C,F,A,l,k,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fdc=e.$edc=e.$ddc=void 0,e.$ddc=(0,C.$Nh)("IExtHostSearch");let D=class{constructor(g,t,n){this.k=g,this.l=t,this.n=n,this.c=this.k.getProxy(M.$_J.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new F.$$cc}o(g){return this.l.transformOutgoingScheme(g)}registerTextSearchProvider(g,t){if(this.g.has(g))throw new Error(`a text search provider for the scheme '${g}' is already registered`);this.g.add(g);const n=this.d++;return this.e.set(n,t),this.c.$registerTextSearchProvider(n,this.o(g)),(0,w.$Pc)(()=>{this.g.delete(g),this.e.delete(n),this.c.$unregisterProvider(n)})}registerFileSearchProvider(g,t){if(this.i.has(g))throw new Error(`a file search provider for the scheme '${g}' is already registered`);this.i.add(g);const n=this.d++;return this.h.set(n,t),this.c.$registerFileSearchProvider(n,this.o(g)),(0,w.$Pc)(()=>{this.i.delete(g),this.h.delete(n),this.c.$unregisterProvider(n)})}$provideFileSearchResults(g,t,n,a){const b=c(n),E=this.h.get(g);if(E)return this.j.fileSearch(b,E,v=>{this.c.$handleFileMatch(g,t,v.map(r=>r.resource))},a);throw new Error("unknown provider: "+g)}$clearCache(g){return this.j.clearCache(g),Promise.resolve(void 0)}$provideTextSearchResults(g,t,n,a){const b=this.e.get(g);if(!b||!b.provideTextSearchResults)throw new Error(`Unknown provider ${g}`);const E=c(n);return this.q(E,b).search(r=>this.c.$handleTextMatch(g,t,r),a)}$enableExtensionHostSearch(){}q(g,t){return new R.$_cc(g,t,{readdir:n=>Promise.resolve([]),toCanonicalName:n=>n},"textSearchProvider")}};e.$edc=D,e.$edc=D=qe([We(0,A.$aM),We(1,l.$Wbc),We(2,k.$8i)],D);function c($){return{...$,folderQueries:$.folderQueries&&$.folderQueries.map(p),extraFileResources:$.extraFileResources&&$.extraFileResources.map(g=>f.URI.revive(g))}}e.$fdc=c;function p($){return{...$,folder:f.URI.revive($.folder)}}}),define(Re[272],Me([1,0,21,9,5,29,2,135,283,124,133,38,3,79,224,223,31,225,34,227,228,229,203,230,59,35,233,234,239,240,242,109,207,248,249,251,84,62,253,210,8,7,53,256,63,108,33,20,198,238,52,107,111,113,114,14,55,17,27,243,196,86,80,217,254,85,61,259,257,258,218,39,252,255,83,60,57,244,110,245,13,95,206,189,236,6,25,194,81,185,246,247,219,235,205,237,82,250,221,222,216,232,220]),function(be,e,w,M,C,F,A,l,k,f,R,D,c,p,$,g,t,n,a,b,E,v,r,s,i,o,y,d,I,S,u,m,h,P,W,K,U,B,O,N,te,Y,ye,Ee,Pe,X,ae,Se,ue,$e,ie,z,V,le,we,ve,me,De,re,he,se,oe,de,Ie,T,q,J,Q,H,x,ce,Fe,Ue,Qe,Ge,_e,Xe,xe,it,tt,ze,st,_,Z,pe,je,Oe,Ze,rt,mt,wt,Ct,Yt,qt,vt,jt,Ft,Bt,Pt,At,Nt,Wt,Ht){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pdc=void 0;function Kt(at){const ut=at.get(re.$qM),Jt=at.get(Fe.$Mbc),It=at.get(J.$fcc),Et=at.get(o.$vcc),dt=at.get(ae.$Zbc),kt=at.get(Xe.$uM),Lt=at.get(a.$3bc),yt=at.get(me.$Wbc),Ke=at.get(De.$aM),Ot=at.get(U.$bcc),zt=at.get(q.$gcc),Ce=at.get(ve.$9i),Ae=at.get(ve.$8i),ge=at.get(oe.$Wvb),G=at.get(de.$Pbc),Te=at.get(X.$Tcc),Be=at.get(Ge.$ncc),Je=at.get(_e.$2cc),Ve=at.get(Ft.$rcc);Ke.set(c.$aK.ExtHostFileSystemInfo,Jt),Ke.set(c.$aK.ExtHostLogLevelServiceShape,Ce),Ke.set(c.$aK.ExtHostWorkspace,dt),Ke.set(c.$aK.ExtHostConfiguration,Lt),Ke.set(c.$aK.ExtHostExtensionService,Et),Ke.set(c.$aK.ExtHostStorage,Ot),Ke.set(c.$aK.ExtHostTunnelService,ge),Ke.set(c.$aK.ExtHostWindow,Te),Ke.set(c.$aK.ExtHostSecretState,Be),Ke.set(c.$aK.ExtHostTelemetry,kt),Ke.set(c.$aK.ExtHostEditorTabs,Je),Ke.set(c.$aK.ExtHostManagedSockets,Ve);const et=Ke.set(c.$aK.ExtHostDecorations,at.get(z.$Xcc)),gt=Ke.set(c.$aK.ExtHostDocumentsAndEditors,at.get(i.$lM)),ft=Ke.set(c.$aK.ExtHostCommands,at.get(t.$wM)),pt=Ke.set(c.$aK.ExtHostTerminalService,at.get(B.$icc)),ht=Ke.set(c.$aK.ExtHostDebugService,at.get(le.$6cc)),Rt=Ke.set(c.$aK.ExtHostSearch,at.get(we.$ddc)),Gt=Ke.set(c.$aK.ExtHostTask,at.get(V.$1cc)),Ei=Ke.set(c.$aK.ExtHostOutputService,at.get(m.$Dcc)),Vt=Ke.set(c.$aK.ExtHostLocalization,at.get(rt.$qcc)),mi=Ke.set(c.$aK.ExtHostUrls,new Ee.$Mcc(Ke)),St=Ke.set(c.$aK.ExtHostDocuments,new s.$Kbc(Ke,gt)),Di=Ke.set(c.$aK.ExtHostDocumentContentProviders,new v.$5bc(Ke,gt,Ae)),Ki=Ke.set(c.$aK.ExtHostDocumentSaveParticipant,new r.$6bc(Ae,St,Ke.getProxy(c.$_J.MainThreadBulkEdits))),Dt=Ke.set(c.$aK.ExtHostNotebook,new he.$jdc(Ke,ft,gt,St,It)),ii=Ke.set(c.$aK.ExtHostNotebookDocuments,new Z.$Bdc(Dt)),$i=Ke.set(c.$aK.ExtHostNotebookEditors,new _.$Adc(Ae,Dt)),oi=Ke.set(c.$aK.ExtHostNotebookKernels,new xe.$xdc(Ke,ut,Dt,ft,Ae)),ki=Ke.set(c.$aK.ExtHostNotebookRenderers,new tt.$zdc(Ke,Dt)),Si=Ke.set(c.$aK.ExtHostNotebookDocumentSaveParticipant,new vt.$Hdc(Ae,Dt,Ke.getProxy(c.$_J.MainThreadBulkEdits))),Mt=Ke.set(c.$aK.ExtHostEditors,new O.$Kcc(Ke,gt)),pi=Ke.set(c.$aK.ExtHostTreeViews,new N.$Lcc(Ke.getProxy(c.$_J.MainThreadTreeViews),ft,Ae)),Ii=Ke.set(c.$aK.ExtHostEditorInsets,new ue.$Ucc(Ke.getProxy(c.$_J.MainThreadEditorInsets),Mt,ut.remote)),ai=Ke.set(c.$aK.ExtHostDiagnostics,new b.$Obc(Ke,Ae,Jt,gt)),ci=Ke.set(c.$aK.ExtHostLanguages,new S.$Acc(Ke,St,ft.converter,yt)),ct=Ke.set(c.$aK.ExtHostLanguageFeatures,new I.$Sbc(Ke,yt,St,ft,ai,Ae,G,kt)),Vi=Ke.set(c.$aK.ExtHostFileSystem,new y.$ycc(Ke,ct)),Xt=Ke.set(c.$aK.ExtHostFileSystemEventService,new d.$zcc(Ke,Ae,gt)),ni=Ke.set(c.$aK.ExtHostQuickOpen,(0,P.$Fcc)(Ke,dt,ft)),vi=Ke.set(c.$aK.ExtHostSCM,new W.$Hcc(Ke,ft,St,Ae)),Ci=Ke.set(c.$aK.ExtHostQuickDiff,new Ct.$Edc(Ke,yt)),qi=Ke.set(c.$aK.ExtHostShare,new Bt.$Jdc(Ke,yt)),Pi=Ke.set(c.$aK.ExtHostComments,(0,n.$Vbc)(Ke,ft,St)),bi=Ke.set(c.$aK.ExtHostProgress,new h.$Ecc(Ke.getProxy(c.$_J.MainThreadProgress))),Hi=Ke.set(c.$aK.ExtHosLabelService,new $e.$Vcc(Ke)),Ai=Ke.set(c.$aK.ExtHostTheming,new se.$kdc(Ke)),ui=Ke.set(c.$aK.ExtHostAuthentication,new Ie.$ldc(Ke)),Gi=Ke.set(c.$aK.ExtHostTimeline,new T.$ndc(Ke,ft)),wi=Ke.set(c.$aK.ExtHostWebviews,new Pe.$Pcc(Ke,ut.remote,dt,Ae,G)),Ri=Ke.set(c.$aK.ExtHostWebviewPanels,new x.$pdc(Ke,wi,dt)),cn=Ke.set(c.$aK.ExtHostCustomEditors,new H.$qdc(Ke,St,zt,wi,Ri)),Mi=Ke.set(c.$aK.ExtHostWebviewViews,new Q.$odc(Ke,wi)),ri=Ke.set(c.$aK.ExtHostTesting,new Ue.$sdc(Ke,ft,gt)),un=Ke.set(c.$aK.ExtHostUriOpeners,new Qe.$wdc(Ke)),ln=Ke.set(c.$aK.ExtHostProfileContentHandlers,new wt.$Ddc(Ke));Ke.set(c.$aK.ExtHostInteractive,new pe.$Cdc(Ke,Dt,gt,ft,Ae));const Ji=Ke.set(c.$aK.ExtHostInlineChat,new qt.$Gdc(Ke,ft,St,Ae)),fi=Ke.set(c.$aK.ExtHostChatProvider,new Pt.$Kdc(Ke,Ae)),Qi=Ke.set(c.$aK.ExtHostChatAgents,new Ht.$Odc(Ke,fi,Ae)),Zi=Ke.set(c.$aK.ExtHostChatVariables,new At.$Ldc(Ke)),gi=Ke.set(c.$aK.ExtHostChat,new Yt.$Fdc(Ke,Ae)),Yi=Ke.set(c.$aK.ExtHostAiRelatedInformation,new Nt.$Mdc(Ke)),Ti=Ke.set(c.$aK.ExtHostAiEmbeddingVector,new Wt.$Ndc(Ke)),Xi=Ke.set(c.$aK.ExtHostIssueReporter,new jt.$Idc(Ke)),_t=Ke.set(c.$aK.ExtHostStatusBar,new K.$Jcc(Ke,ft.converter)),yi=Object.values(c.$aK);Ke.assertRegistered(yi);const hn=new ce.$rdc(Ke,gt),Qt=new g.$Ubc(Ke),li=new u.$Bcc(Ke,Ae),Li=new E.$4bc(Ke);return $.$Tbc.register(ft),function(Ne,xt,Fi){const $t=function(){let ee=!Ne.isUnderDevelopment;function fe(){ee||(Ae.info(`Extension '${Ne.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ee=!0)}return function Le(nt){if(Array.isArray(nt))nt.forEach(Le);else if(typeof nt=="string")fe();else{const bt=nt;typeof bt.scheme>"u"&&fe(),typeof bt.exclusive=="boolean"&&(0,Oe.$_E)(Ne,"documentFiltersExclusive")}return nt}}(),_i={getSession(ee,fe,Le){return ui.getSession(Ne,ee,fe,Le)},getSessions(ee,fe){return(0,Oe.$_E)(Ne,"authGetSessions"),ui.getSessions(Ne,ee,fe)},async hasSession(ee,fe){return(0,Oe.$_E)(Ne,"authSession"),!!await ui.getSession(Ne,ee,fe,{silent:!0})},get onDidChangeSessions(){return ui.onDidChangeSessions},registerAuthenticationProvider(ee,fe,Le,nt){return ui.registerAuthenticationProvider(ee,fe,Le,nt)}},xi={registerCommand(ee,fe,Le){return ft.registerCommand(!0,ee,fe,Le,void 0,Ne)},registerTextEditorCommand(ee,fe,Le){return ft.registerCommand(!0,ee,(...nt)=>{const bt=Mt.getActiveTextEditor();if(!bt){Ae.warn("Cannot execute "+ee+" because there is no active text editor.");return}return bt.edit(Tt=>{fe.apply(Le,[bt,Tt,...nt])}).then(Tt=>{Tt||Ae.warn("Edits from command "+ee+" were not applied.")},Tt=>{Ae.warn("An error occurred while running command "+ee,Tt)})},void 0,void 0,Ne)},registerDiffInformationCommand:(ee,fe,Le)=>((0,Oe.$_E)(Ne,"diffCommand"),ft.registerCommand(!0,ee,async(...nt)=>{const bt=gt.activeEditor(!0);if(!bt){Ae.warn("Cannot execute "+ee+" because there is no active text editor.");return}const Tt=await Mt.getDiffInformation(bt.id);fe.apply(Le,[Tt,...nt])},void 0,void 0,Ne)),executeCommand(ee,...fe){return ft.executeCommand(ee,...fe)},getCommands(ee=!1){return ft.getCommands(ee)}},en={get machineId(){return ut.telemetryInfo.machineId},get sessionId(){return ut.telemetryInfo.sessionId},get language(){return ut.environment.appLanguage},get appName(){return ut.environment.appName},get appRoot(){return ut.environment.appRoot?.fsPath??""},get appHost(){return ut.environment.appHost},get uriScheme(){return ut.environment.appUriScheme},get clipboard(){return Qt.value},get shell(){return pt.getDefaultShell(!1)},get onDidChangeShell(){return pt.onDidChangeShell},get isTelemetryEnabled(){return kt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return kt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Oe.$_E)(Ne,"telemetry"),kt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Oe.$_E)(Ne,"telemetry"),kt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,Xe.$tM)(ut.telemetryInfo.firstSessionDate)},createTelemetryLogger(ee,fe){return Xe.$sM.validateSender(ee),kt.instantiateLogger(Ne,ee,fe)},openExternal(ee,fe){return Te.openUri(ee,{allowTunneling:!!ut.remote.authority,allowContributedOpeners:fe?.allowContributedOpeners})},async asExternalUri(ee){if(ee.scheme===ut.environment.appUriScheme)return mi.createAppUri(ee);try{return await Te.asExternalUri(ee,{allowTunneling:!!ut.remote.authority})}catch(fe){if((0,st.$9T)(ee,ze.Schemas.http)||(0,st.$9T)(ee,ze.Schemas.https))return ee;throw fe}},get remoteName(){return(0,ie.$Sk)(ut.remote.authority)},get remoteAuthority(){return(0,Oe.$_E)(Ne,"resolvers"),ut.remote.authority},get uiKind(){return ut.uiKind},get logLevel(){return Ae.getLevel()},get onDidChangeLogLevel(){return Ae.onDidChangeLogLevel},registerIssueUriRequestHandler(ee){return(0,Oe.$_E)(Ne,"handleIssueUri"),Xi.registerIssueUriRequestHandler(Ne,ee)},get appQuality(){return(0,Oe.$_E)(Ne,"resolvers"),ut.quality},get appCommit(){return(0,Oe.$_E)(Ne,"resolvers"),ut.commit}};ut.environment.extensionTestsLocationURI||Object.freeze(en);const dn={createTestController(ee,fe,Le){return ri.createTestController(Ne,ee,fe,Le)},createTestObserver(){return(0,Oe.$_E)(Ne,"testObserver"),ri.createTestObserver()},runTests(ee){return(0,Oe.$_E)(Ne,"testObserver"),ri.runTests(ee)},get onDidChangeTestResults(){return(0,Oe.$_E)(Ne,"testObserver"),ri.onResultsChanged},get testResults(){return(0,Oe.$_E)(Ne,"testObserver"),ri.results}},hi=ut.remote.isRemote?Y.ExtensionKind.Workspace:Y.ExtensionKind.UI,tn={getExtension(ee,fe){(0,Oe.$$E)(Ne,"extensionsAny")||(fe=!1);const Le=xt.mine.getExtensionDescription(ee);if(Le)return new o.$wcc(Et,Ne.identifier,Le,hi,!1);if(fe){const nt=xt.all.getExtensionDescription(ee);if(nt)return new o.$wcc(Et,Ne.identifier,nt,hi,!0)}},get all(){const ee=[];for(const fe of xt.mine.getAllExtensionDescriptions())ee.push(new o.$wcc(Et,Ne.identifier,fe,hi,!1));return ee},get allAcrossExtensionHosts(){(0,Oe.$_E)(Ne,"extensionsAny");const ee=new Se.$3l(xt.mine.getAllExtensionDescriptions().map(Le=>Le.identifier)),fe=[];for(const Le of xt.all.getAllExtensionDescriptions()){const nt=!ee.has(Le.identifier);fe.push(new o.$wcc(Et,Ne.identifier,Le,hi,nt))}return fe},get onDidChange(){return(0,Oe.$$E)(Ne,"extensionsAny")?C.Event.any(xt.mine.onDidChange,xt.all.onDidChange):xt.mine.onDidChange}},nn={createDiagnosticCollection(ee){return ai.createDiagnosticCollection(Ne.identifier,ee)},get onDidChangeDiagnostics(){return ai.onDidChangeDiagnostics},getDiagnostics:ee=>ai.getDiagnostics(ee),getLanguages(){return ci.getLanguages()},setTextDocumentLanguage(ee,fe){return ci.changeLanguage(ee.uri,fe)},match(ee,fe){const Le=St.getDocumentData(fe.uri)?.notebook;return(0,R.$mE)(te.LanguageSelector.from(ee),fe.uri,fe.languageId,!0,Le?.uri,Le?.notebookType)},registerCodeActionsProvider(ee,fe,Le){return ct.registerCodeActionProvider(Ne,$t(ee),fe,Le)},registerDocumentPasteEditProvider(ee,fe,Le){return(0,Oe.$_E)(Ne,"documentPaste"),ct.registerDocumentPasteEditProvider(Ne,$t(ee),fe,Le)},registerCodeLensProvider(ee,fe){return ct.registerCodeLensProvider(Ne,$t(ee),fe)},registerDefinitionProvider(ee,fe){return ct.registerDefinitionProvider(Ne,$t(ee),fe)},registerDeclarationProvider(ee,fe){return ct.registerDeclarationProvider(Ne,$t(ee),fe)},registerImplementationProvider(ee,fe){return ct.registerImplementationProvider(Ne,$t(ee),fe)},registerTypeDefinitionProvider(ee,fe){return ct.registerTypeDefinitionProvider(Ne,$t(ee),fe)},registerHoverProvider(ee,fe){return ct.registerHoverProvider(Ne,$t(ee),fe,Ne.identifier)},registerEvaluatableExpressionProvider(ee,fe){return ct.registerEvaluatableExpressionProvider(Ne,$t(ee),fe,Ne.identifier)},registerInlineValuesProvider(ee,fe){return ct.registerInlineValuesProvider(Ne,$t(ee),fe,Ne.identifier)},registerDocumentHighlightProvider(ee,fe){return ct.registerDocumentHighlightProvider(Ne,$t(ee),fe)},registerLinkedEditingRangeProvider(ee,fe){return ct.registerLinkedEditingRangeProvider(Ne,$t(ee),fe)},registerReferenceProvider(ee,fe){return ct.registerReferenceProvider(Ne,$t(ee),fe)},registerRenameProvider(ee,fe){return ct.registerRenameProvider(Ne,$t(ee),fe)},registerDocumentSymbolProvider(ee,fe,Le){return ct.registerDocumentSymbolProvider(Ne,$t(ee),fe,Le)},registerWorkspaceSymbolProvider(ee){return ct.registerWorkspaceSymbolProvider(Ne,ee)},registerDocumentFormattingEditProvider(ee,fe){return ct.registerDocumentFormattingEditProvider(Ne,$t(ee),fe)},registerDocumentRangeFormattingEditProvider(ee,fe){return ct.registerDocumentRangeFormattingEditProvider(Ne,$t(ee),fe)},registerOnTypeFormattingEditProvider(ee,fe,Le,...nt){return ct.registerOnTypeFormattingEditProvider(Ne,$t(ee),fe,[Le].concat(nt))},registerDocumentSemanticTokensProvider(ee,fe,Le){return ct.registerDocumentSemanticTokensProvider(Ne,$t(ee),fe,Le)},registerDocumentRangeSemanticTokensProvider(ee,fe,Le){return ct.registerDocumentRangeSemanticTokensProvider(Ne,$t(ee),fe,Le)},registerSignatureHelpProvider(ee,fe,Le,...nt){return typeof Le=="object"?ct.registerSignatureHelpProvider(Ne,$t(ee),fe,Le):ct.registerSignatureHelpProvider(Ne,$t(ee),fe,typeof Le>"u"?[]:[Le,...nt])},registerCompletionItemProvider(ee,fe,...Le){return ct.registerCompletionItemProvider(Ne,$t(ee),fe,Le)},registerInlineCompletionItemProvider(ee,fe,Le){return fe.handleDidShowCompletionItem&&(0,Oe.$_E)(Ne,"inlineCompletionsAdditions"),fe.handleDidPartiallyAcceptCompletionItem&&(0,Oe.$_E)(Ne,"inlineCompletionsAdditions"),Le&&(0,Oe.$_E)(Ne,"inlineCompletionsAdditions"),ct.registerInlineCompletionsProvider(Ne,$t(ee),fe,Le)},registerDocumentLinkProvider(ee,fe){return ct.registerDocumentLinkProvider(Ne,$t(ee),fe)},registerColorProvider(ee,fe){return ct.registerColorProvider(Ne,$t(ee),fe)},registerFoldingRangeProvider(ee,fe){return ct.registerFoldingRangeProvider(Ne,$t(ee),fe)},registerSelectionRangeProvider(ee,fe){return ct.registerSelectionRangeProvider(Ne,ee,fe)},registerCallHierarchyProvider(ee,fe){return ct.registerCallHierarchyProvider(Ne,ee,fe)},registerTypeHierarchyProvider(ee,fe){return ct.registerTypeHierarchyProvider(Ne,ee,fe)},setLanguageConfiguration:(ee,fe)=>ct.setLanguageConfiguration(Ne,ee,fe),getTokenInformationAtPosition(ee,fe){return(0,Oe.$_E)(Ne,"tokenInformation"),ci.tokenAtPosition(ee,fe)},registerInlayHintsProvider(ee,fe){return ct.registerInlayHintsProvider(Ne,ee,fe)},createLanguageStatusItem(ee,fe){return ci.createLanguageStatusItem(Ne,ee,fe)},registerDocumentDropEditProvider(ee,fe,Le){return ct.registerDocumentOnDropEditProvider(Ne,ee,fe,(0,Oe.$$E)(Ne,"dropMetadata")?Le:void 0)}},rn={get activeTextEditor(){return Mt.getActiveTextEditor()},get visibleTextEditors(){return Mt.getVisibleTextEditors()},get activeTerminal(){return pt.activeTerminal},get terminals(){return pt.terminals},async showTextDocument(ee,fe,Le){const nt=await(A.URI.isUri(ee)?Promise.resolve(sn.openTextDocument(ee)):Promise.resolve(ee));return Mt.showTextDocument(nt,fe,Le)},createTextEditorDecorationType(ee){return Mt.createTextEditorDecorationType(Ne,ee)},onDidChangeActiveTextEditor(ee,fe,Le){return Mt.onDidChangeActiveTextEditor(ee,fe,Le)},onDidChangeVisibleTextEditors(ee,fe,Le){return Mt.onDidChangeVisibleTextEditors(ee,fe,Le)},onDidChangeTextEditorSelection(ee,fe,Le){return Mt.onDidChangeTextEditorSelection(ee,fe,Le)},onDidChangeTextEditorOptions(ee,fe,Le){return Mt.onDidChangeTextEditorOptions(ee,fe,Le)},onDidChangeTextEditorVisibleRanges(ee,fe,Le){return Mt.onDidChangeTextEditorVisibleRanges(ee,fe,Le)},onDidChangeTextEditorViewColumn(ee,fe,Le){return Mt.onDidChangeTextEditorViewColumn(ee,fe,Le)},onDidCloseTerminal(ee,fe,Le){return pt.onDidCloseTerminal(ee,fe,Le)},onDidOpenTerminal(ee,fe,Le){return pt.onDidOpenTerminal(ee,fe,Le)},onDidChangeActiveTerminal(ee,fe,Le){return pt.onDidChangeActiveTerminal(ee,fe,Le)},onDidChangeTerminalDimensions(ee,fe,Le){return(0,Oe.$_E)(Ne,"terminalDimensions"),pt.onDidChangeTerminalDimensions(ee,fe,Le)},onDidChangeTerminalState(ee,fe,Le){return pt.onDidChangeTerminalState(ee,fe,Le)},onDidWriteTerminalData(ee,fe,Le){return(0,Oe.$_E)(Ne,"terminalDataWriteEvent"),pt.onDidWriteTerminalData(ee,fe,Le)},onDidExecuteTerminalCommand(ee,fe,Le){return(0,Oe.$_E)(Ne,"terminalExecuteCommandEvent"),pt.onDidExecuteTerminalCommand(ee,fe,Le)},get state(){return Te.getState(Ne)},onDidChangeWindowState(ee,fe,Le){return Te.onDidChangeWindowState(ee,fe,Le)},showInformationMessage(ee,...fe){return li.showMessage(Ne,F.default.Info,ee,fe[0],fe.slice(1))},showWarningMessage(ee,...fe){return li.showMessage(Ne,F.default.Warning,ee,fe[0],fe.slice(1))},showErrorMessage(ee,...fe){return li.showMessage(Ne,F.default.Error,ee,fe[0],fe.slice(1))},showQuickPick(ee,fe,Le){return ni.showQuickPick(Ne,ee,fe,Le)},showWorkspaceFolderPick(ee){return ni.showWorkspaceFolderPick(ee)},showInputBox(ee,fe){return ni.showInput(ee,fe)},showOpenDialog(ee){return Li.showOpenDialog(Ne,ee)},showSaveDialog(ee){return Li.showSaveDialog(ee)},createStatusBarItem(ee,fe,Le){let nt,bt,Tt;return typeof ee=="string"?(nt=ee,bt=fe,Tt=Le):(bt=ee,Tt=fe),_t.createStatusBarEntry(Ne,nt,bt,Tt)},setStatusBarMessage(ee,fe){return _t.setStatusBarMessage(ee,fe)},withScmProgress(ee){return G.report("window.withScmProgress",Ne,"Use 'withProgress' instead."),bi.withProgress(Ne,{location:Y.ProgressLocation.SourceControl},(fe,Le)=>ee({report(nt){}}))},withProgress(ee,fe){return bi.withProgress(Ne,ee,fe)},createOutputChannel(ee,fe){return Ei.createOutputChannel(ee,fe,Ne)},createWebviewPanel(ee,fe,Le,nt){return Ri.createWebviewPanel(Ne,ee,fe,Le,nt)},createWebviewTextEditorInset(ee,fe,Le,nt){return(0,Oe.$_E)(Ne,"editorInsets"),Ii.createWebviewEditorInset(ee,fe,Le,nt,Ne)},createTerminal(ee,fe,Le){return typeof ee=="object"?"pty"in ee?pt.createExtensionTerminal(ee):pt.createTerminalFromOptions(ee):pt.createTerminal(ee,fe,Le)},registerTerminalLinkProvider(ee){return pt.registerLinkProvider(ee)},registerTerminalProfileProvider(ee,fe){return pt.registerProfileProvider(Ne,ee,fe)},registerTerminalQuickFixProvider(ee,fe){return(0,Oe.$_E)(Ne,"terminalQuickFixProvider"),pt.registerTerminalQuickFixProvider(ee,Ne.identifier.value,fe)},registerTreeDataProvider(ee,fe){return pi.registerTreeDataProvider(ee,fe,Ne)},createTreeView(ee,fe){return pi.createTreeView(ee,fe,Ne)},registerWebviewPanelSerializer:(ee,fe)=>Ri.registerWebviewPanelSerializer(Ne,ee,fe),registerCustomEditorProvider:(ee,fe,Le={})=>cn.registerCustomEditorProvider(Ne,ee,fe,Le),registerFileDecorationProvider(ee){return et.registerFileDecorationProvider(ee,Ne)},registerUriHandler(ee){return mi.registerUriHandler(Ne,ee)},createQuickPick(){return ni.createQuickPick(Ne)},createInputBox(){return ni.createInputBox(Ne)},get activeColorTheme(){return Ai.activeColorTheme},onDidChangeActiveColorTheme(ee,fe,Le){return Ai.onDidChangeActiveColorTheme(ee,fe,Le)},registerWebviewViewProvider(ee,fe,Le){return Mi.registerWebviewViewProvider(Ne,ee,fe,Le?.webviewOptions)},get activeNotebookEditor(){return Dt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ee,fe,Le){return Dt.onDidChangeActiveNotebookEditor(ee,fe,Le)},get visibleNotebookEditors(){return Dt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return Dt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ee,fe,Le){return $i.onDidChangeNotebookEditorSelection(ee,fe,Le)},onDidChangeNotebookEditorVisibleRanges(ee,fe,Le){return $i.onDidChangeNotebookEditorVisibleRanges(ee,fe,Le)},showNotebookDocument(ee,fe){return Dt.showNotebookDocument(ee,fe)},registerExternalUriOpener(ee,fe,Le){return(0,Oe.$_E)(Ne,"externalUriOpener"),un.registerExternalUriOpener(Ne.identifier,ee,fe,Le)},registerProfileContentHandler(ee,fe){return(0,Oe.$_E)(Ne,"profileContentHandlers"),ln.registrProfileContentHandler(Ne,ee,fe)},registerQuickDiffProvider(ee,fe,Le,nt){return(0,Oe.$_E)(Ne,"quickDiffProvider"),Ci.registerQuickDiffProvider($t(ee),fe,Le,nt)},get tabGroups(){return Je.tabGroups},registerShareProvider(ee,fe){return(0,Oe.$_E)(Ne,"shareProvider"),qi.registerShareProvider($t(ee),fe)}},sn={get rootPath(){return G.report("workspace.rootPath",Ne,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),dt.getPath()},set rootPath(ee){throw new M.$8("rootPath")},getWorkspaceFolder(ee){return dt.getWorkspaceFolder(ee)},get workspaceFolders(){return dt.getWorkspaceFolders()},get name(){return dt.name},set name(ee){throw new M.$8("name")},get workspaceFile(){return dt.workspaceFile},set workspaceFile(ee){throw new M.$8("workspaceFile")},updateWorkspaceFolders:(ee,fe,...Le)=>dt.updateWorkspaceFolders(Ne,ee,fe||0,...Le),onDidChangeWorkspaceFolders:function(ee,fe,Le){return dt.onDidChangeWorkspace(ee,fe,Le)},asRelativePath:(ee,fe)=>dt.getRelativePath(ee,fe),findFiles:(ee,fe,Le,nt)=>dt.findFiles(ee,fe,Le,Ne.identifier,nt),findTextInFiles:(ee,fe,Le,nt)=>{(0,Oe.$_E)(Ne,"findTextInFiles");let bt,Tt;return typeof fe=="object"?(bt=fe,Tt=Le):(bt={},Tt=fe,nt=Le),dt.findTextInFiles(ee,bt||{},Tt,Ne.identifier,nt)},save:ee=>((0,Oe.$_E)(Ne,"saveEditor"),dt.save(ee)),saveAs:ee=>((0,Oe.$_E)(Ne,"saveEditor"),dt.saveAs(ee)),saveAll:ee=>dt.saveAll(ee),applyEdit(ee,fe){return hn.applyWorkspaceEdit(ee,Ne,fe)},createFileSystemWatcher:(ee,fe,Le,nt)=>Xt.createFileSystemWatcher(dt,Ne,ee,fe,Le,nt),get textDocuments(){return St.getAllDocumentData().map(ee=>ee.document)},set textDocuments(ee){throw new M.$8("textDocuments")},openTextDocument(ee){let fe;const Le=ee;if(typeof ee=="string")fe=Promise.resolve(A.URI.file(ee));else if(A.URI.isUri(ee))fe=Promise.resolve(ee);else if(!Le||typeof Le=="object")fe=St.createDocumentData(Le);else throw new Error("illegal argument - uriOrFileNameOrOptions");return fe.then(nt=>St.ensureDocumentData(nt).then(bt=>bt.document))},onDidOpenTextDocument:(ee,fe,Le)=>St.onDidAddDocument(ee,fe,Le),onDidCloseTextDocument:(ee,fe,Le)=>St.onDidRemoveDocument(ee,fe,Le),onDidChangeTextDocument:(ee,fe,Le)=>St.onDidChangeDocument(ee,fe,Le),onDidSaveTextDocument:(ee,fe,Le)=>St.onDidSaveDocument(ee,fe,Le),onWillSaveTextDocument:(ee,fe,Le)=>Ki.getOnWillSaveTextDocumentEvent(Ne)(ee,fe,Le),get notebookDocuments(){return Dt.notebookDocuments.map(ee=>ee.apiNotebook)},async openNotebookDocument(ee,fe){let Le;if(A.URI.isUri(ee))Le=ee,await Dt.openNotebookDocument(ee);else if(typeof ee=="string")Le=A.URI.revive(await Dt.createNotebookDocument({viewType:ee,content:fe}));else throw new Error("Invalid arguments");return Dt.getNotebookDocument(Le).apiNotebook},onDidSaveNotebookDocument(ee,fe,Le){return ii.onDidSaveNotebookDocument(ee,fe,Le)},onDidChangeNotebookDocument(ee,fe,Le){return ii.onDidChangeNotebookDocument(ee,fe,Le)},onWillSaveNotebookDocument(ee,fe,Le){return Si.getOnWillSaveNotebookDocumentEvent(Ne)(ee,fe,Le)},get onDidOpenNotebookDocument(){return Dt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Dt.onDidCloseNotebookDocument},registerNotebookSerializer(ee,fe,Le,nt){return Dt.registerNotebookSerializer(Ne,ee,fe,Le,(0,Oe.$$E)(Ne,"notebookLiveShare")?nt:void 0)},onDidChangeConfiguration:(ee,fe,Le)=>Fi.onDidChangeConfiguration(ee,fe,Le),getConfiguration(ee,fe){return fe=arguments.length===1?void 0:fe,Fi.getConfiguration(ee,fe,Ne)},registerTextDocumentContentProvider(ee,fe){return Di.registerTextDocumentContentProvider(ee,fe)},registerTaskProvider:(ee,fe)=>(G.report("window.registerTaskProvider",Ne,"Use the corresponding function on the 'tasks' namespace instead"),Gt.registerTaskProvider(Ne,ee,fe)),registerFileSystemProvider(ee,fe,Le){return(0,je.$Oc)(Vi.registerFileSystemProvider(Ne,ee,fe,Le),It.addFileSystemProvider(ee,fe,Le))},get fs(){return It.value},registerFileSearchProvider:(ee,fe)=>((0,Oe.$_E)(Ne,"fileSearchProvider"),Rt.registerFileSearchProvider(ee,fe)),registerTextSearchProvider:(ee,fe)=>((0,Oe.$_E)(Ne,"textSearchProvider"),Rt.registerTextSearchProvider(ee,fe)),registerRemoteAuthorityResolver:(ee,fe)=>((0,Oe.$_E)(Ne,"resolvers"),Et.registerRemoteAuthorityResolver(ee,fe)),registerResourceLabelFormatter:ee=>((0,Oe.$_E)(Ne,"resolvers"),Hi.$registerResourceLabelFormatter(ee)),getRemoteExecServer:ee=>((0,Oe.$_E)(Ne,"resolvers"),Et.getRemoteExecServer(ee)),onDidCreateFiles:(ee,fe,Le)=>Xt.onDidCreateFile(ee,fe,Le),onDidDeleteFiles:(ee,fe,Le)=>Xt.onDidDeleteFile(ee,fe,Le),onDidRenameFiles:(ee,fe,Le)=>Xt.onDidRenameFile(ee,fe,Le),onWillCreateFiles:(ee,fe,Le)=>Xt.getOnWillCreateFileEvent(Ne)(ee,fe,Le),onWillDeleteFiles:(ee,fe,Le)=>Xt.getOnWillDeleteFileEvent(Ne)(ee,fe,Le),onWillRenameFiles:(ee,fe,Le)=>Xt.getOnWillRenameFileEvent(Ne)(ee,fe,Le),openTunnel:ee=>((0,Oe.$_E)(Ne,"tunnels"),ge.openTunnel(Ne,ee).then(fe=>{if(!fe)throw new Error("cannot open tunnel");return fe})),get tunnels(){return(0,Oe.$_E)(Ne,"tunnels"),ge.getTunnels()},onDidChangeTunnels:(ee,fe,Le)=>((0,Oe.$_E)(Ne,"tunnels"),ge.onDidChangeTunnels(ee,fe,Le)),registerPortAttributesProvider:(ee,fe)=>((0,Oe.$_E)(Ne,"portsAttributes"),ge.registerPortsAttributesProvider(ee,fe)),registerTunnelProvider:(ee,fe)=>((0,Oe.$_E)(Ne,"tunnelFactory"),ge.registerTunnelProvider(ee,fe)),registerTimelineProvider:(ee,fe)=>((0,Oe.$_E)(Ne,"timeline"),Gi.registerTimelineProvider(ee,fe,Ne.identifier,ft.converter)),get isTrusted(){return dt.trusted},requestWorkspaceTrust:ee=>((0,Oe.$_E)(Ne,"workspaceTrust"),dt.requestWorkspaceTrust(ee)),onDidGrantWorkspaceTrust:(ee,fe,Le)=>dt.onDidGrantWorkspaceTrust(ee,fe,Le),registerEditSessionIdentityProvider:(ee,fe)=>((0,Oe.$_E)(Ne,"editSessionIdentityProvider"),dt.registerEditSessionIdentityProvider(ee,fe)),onWillCreateEditSessionIdentity:(ee,fe,Le)=>((0,Oe.$_E)(Ne,"editSessionIdentityProvider"),dt.getOnWillCreateEditSessionIdentityEvent(Ne)(ee,fe,Le)),registerCanonicalUriProvider:(ee,fe)=>((0,Oe.$_E)(Ne,"canonicalUriProvider"),dt.registerCanonicalUriProvider(ee,fe)),getCanonicalUri:(ee,fe,Le)=>((0,Oe.$_E)(Ne,"canonicalUriProvider"),dt.provideCanonicalUri(ee,fe,Le))},fn={get inputBox(){return G.report("scm.inputBox",Ne,"Use 'SourceControl.inputBox' instead"),vi.getLastInputBox(Ne)},createSourceControl(ee,fe,Le){return vi.createSourceControl(Ne,ee,fe,Le)}},on={createCommentController(ee,fe){return Pi.createCommentController(Ne,ee,fe)}},an={get activeDebugSession(){return ht.activeDebugSession},get activeDebugConsole(){return ht.activeDebugConsole},get breakpoints(){return ht.breakpoints},get stackFrameFocus(){return ht.stackFrameFocus},onDidStartDebugSession(ee,fe,Le){return ht.onDidStartDebugSession(ee,fe,Le)},onDidTerminateDebugSession(ee,fe,Le){return ht.onDidTerminateDebugSession(ee,fe,Le)},onDidChangeActiveDebugSession(ee,fe,Le){return ht.onDidChangeActiveDebugSession(ee,fe,Le)},onDidReceiveDebugSessionCustomEvent(ee,fe,Le){return ht.onDidReceiveDebugSessionCustomEvent(ee,fe,Le)},onDidChangeBreakpoints(ee,fe,Le){return ht.onDidChangeBreakpoints(ee,fe,Le)},onDidChangeStackFrameFocus(ee,fe,Le){return(0,Oe.$_E)(Ne,"debugFocus"),ht.onDidChangeStackFrameFocus(ee,fe,Le)},registerDebugConfigurationProvider(ee,fe,Le){return ht.registerDebugConfigurationProvider(ee,fe,Le||Ze.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ee,fe){return ht.registerDebugAdapterDescriptorFactory(Ne,ee,fe)},registerDebugAdapterTrackerFactory(ee,fe){return ht.registerDebugAdapterTrackerFactory(ee,fe)},startDebugging(ee,fe,Le){return!Le||typeof Le=="object"&&"configuration"in Le?ht.startDebugging(ee,fe,{parentSession:Le}):ht.startDebugging(ee,fe,Le||{})},stopDebugging(ee){return ht.stopDebugging(ee)},addBreakpoints(ee){return ht.addBreakpoints(ee)},removeBreakpoints(ee){return ht.removeBreakpoints(ee)},asDebugSourceUri(ee,fe){return ht.asDebugSourceUri(ee,fe)}},Ni={registerTaskProvider:(ee,fe)=>Gt.registerTaskProvider(Ne,ee,fe),fetchTasks:ee=>Gt.fetchTasks(ee),executeTask:ee=>Gt.executeTask(Ne,ee),get taskExecutions(){return Gt.taskExecutions},onDidStartTask:(ee,fe,Le)=>Gt.onDidStartTask(ee,fe,Le),onDidEndTask:(ee,fe,Le)=>Gt.onDidEndTask(ee,fe,Le),onDidStartTaskProcess:(ee,fe,Le)=>Gt.onDidStartTaskProcess(ee,fe,Le),onDidEndTaskProcess:(ee,fe,Le)=>Gt.onDidEndTaskProcess(ee,fe,Le)},Oi={createNotebookController(ee,fe,Le,nt,bt){return oi.createNotebookController(Ne,ee,fe,Le,nt,(0,Oe.$$E)(Ne,"notebookMessaging")?bt:void 0)},registerNotebookCellStatusBarItemProvider:(ee,fe)=>Dt.registerNotebookCellStatusBarItemProvider(Ne,ee,fe),createRendererMessaging(ee){return ki.createRendererMessaging(Ne,ee)},createNotebookControllerDetectionTask(ee){return(0,Oe.$_E)(Ne,"notebookKernelSource"),oi.createNotebookControllerDetectionTask(Ne,ee)},registerKernelSourceActionProvider(ee,fe){return(0,Oe.$_E)(Ne,"notebookKernelSource"),oi.registerKernelSourceActionProvider(Ne,ee,fe)},onDidChangeNotebookCellExecutionState(ee,fe,Le){return(0,Oe.$_E)(Ne,"notebookCellExecutionState"),oi.onDidChangeNotebookCellExecutionState(ee,fe,Le)}},zi={t(...ee){if(typeof ee[0]=="string"){const fe=ee.shift(),Le=!ee||typeof ee[0]!="object"?ee:ee[0];return Vt.getMessage(Ne.identifier.value,{message:fe,args:Le})}return Vt.getMessage(Ne.identifier.value,ee[0])},get bundle(){return Vt.getBundle(Ne.identifier.value)},get uri(){return Vt.getBundleUri(Ne.identifier.value)}},di={_version:1,registerInteractiveEditorSessionProvider(ee,fe){return(0,Oe.$_E)(Ne,"interactive"),Ji.registerProvider(Ne,ee,fe={label:fe?.label??Ne.displayName??Ne.name})},registerInteractiveSessionProvider(ee,fe){return(0,Oe.$_E)(Ne,"interactive"),gi.registerChatProvider(Ne,ee,fe)},sendInteractiveRequestToProvider(ee,fe){return(0,Oe.$_E)(Ne,"interactive"),gi.sendInteractiveRequestToProvider(ee,fe)},get onDidPerformUserAction(){return(0,Oe.$_E)(Ne,"interactiveUserActions"),gi.onDidPerformUserAction},transferChatSession(ee,fe){return(0,Oe.$_E)(Ne,"interactive"),gi.transferChatSession(ee,fe)}},Ui={getRelatedInformation(ee,fe){return(0,Oe.$_E)(Ne,"aiRelatedInformation"),Yi.getRelatedInformation(Ne,ee,fe)},registerRelatedInformationProvider(ee,fe){return(0,Oe.$_E)(Ne,"aiRelatedInformation"),Yi.registerRelatedInformationProvider(Ne,ee,fe)},registerEmbeddingVectorProvider(ee,fe){return(0,Oe.$_E)(Ne,"aiRelatedInformation"),Ti.registerEmbeddingVectorProvider(Ne,ee,fe)}},ji={registerChatResponseProvider(ee,fe,Le){return(0,Oe.$_E)(Ne,"chatProvider"),fi.registerProvider(Ne.identifier,ee,fe,Le)},requestChatAccess(ee){return(0,Oe.$_E)(Ne,"chatRequestAccess"),fi.requestChatResponseProvider(Ne.identifier,ee)},registerVariable(ee,fe,Le){return(0,Oe.$_E)(Ne,"chatVariables"),Zi.registerVariableResolver(Ne,ee,fe,Le)},registerMappedEditsProvider(ee,fe){return(0,Oe.$_E)(Ne,"mappedEditsProvider"),ct.registerMappedEditsProvider(Ne,ee,fe)},registerAgent(ee,fe,Le){return(0,Oe.$_E)(Ne,"chatAgents"),Qi.registerAgent(Ne.identifier,ee,fe,Le)}};return{version:ut.version,ai:Ui,authentication:_i,commands:xi,comments:on,chat:ji,debug:an,env:en,extensions:tn,interactive:di,l10n:zi,languages:nn,notebooks:Oi,scm:fn,tasks:Ni,tests:dn,window:rn,workspace:sn,Breakpoint:Y.$_K,TerminalOutputAnchor:Y.TerminalOutputAnchor,ChatMessage:Y.$2L,ChatMessageRole:Y.ChatMessageRole,ChatVariableLevel:Y.ChatVariableLevel,CallHierarchyIncomingCall:Y.$yK,CallHierarchyItem:Y.$xK,CallHierarchyOutgoingCall:Y.$zK,CancellationError:M.$4,CancellationTokenSource:w.$Wd,CandidatePortSource:c.CandidatePortSource,CodeAction:Y.$uK,CodeActionKind:Y.$vK,CodeActionTriggerKind:Y.CodeActionTriggerKind,CodeLens:Y.$AK,Color:Y.$NK,ColorInformation:Y.$OK,ColorPresentation:Y.$PK,ColorThemeKind:Y.ColorThemeKind,CommentMode:Y.CommentMode,CommentState:Y.CommentState,CommentThreadCollapsibleState:Y.CommentThreadCollapsibleState,CommentThreadState:Y.CommentThreadState,CompletionItem:Y.$HK,CompletionItemKind:Y.CompletionItemKind,CompletionItemTag:Y.CompletionItemTag,CompletionList:Y.$IK,CompletionTriggerKind:Y.CompletionTriggerKind,ConfigurationTarget:Y.ConfigurationTarget,CustomExecution:Y.$XK,DebugAdapterExecutable:Y.$dL,DebugAdapterInlineImplementation:Y.$gL,DebugAdapterNamedPipeServer:Y.$fL,DebugAdapterServer:Y.$eL,DebugConfigurationProviderTriggerKind:Ze.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Y.DebugConsoleMode,DecorationRangeBehavior:Y.DecorationRangeBehavior,Diagnostic:Y.$pK,DiagnosticRelatedInformation:Y.$oK,DiagnosticSeverity:Y.DiagnosticSeverity,DiagnosticTag:Y.DiagnosticTag,Disposable:Y.$bK,DocumentHighlight:Y.$rK,DocumentHighlightKind:Y.DocumentHighlightKind,DocumentLink:Y.$MK,DocumentSymbol:Y.$tK,EndOfLine:Y.EndOfLine,EnvironmentVariableMutatorType:Y.EnvironmentVariableMutatorType,EvaluatableExpression:Y.$jL,InlineValueText:Y.$kL,InlineValueVariableLookup:Y.$lL,InlineValueEvaluatableExpression:Y.$mL,InlineCompletionTriggerKind:Y.InlineCompletionTriggerKind,EventEmitter:C.$Md,ExtensionKind:Y.ExtensionKind,ExtensionMode:Y.ExtensionMode,ExternalUriOpenerPriority:Y.ExternalUriOpenerPriority,FileChangeType:Y.FileChangeType,FileDecoration:Y.$wL,FileDecoration2:Y.$wL,FileSystemError:Y.$oL,FileType:D.FileType,FilePermission:D.FilePermission,FoldingRange:Y.$pL,FoldingRangeKind:Y.FoldingRangeKind,FunctionBreakpoint:Y.$bL,InlineCompletionItem:Y.$JK,InlineCompletionList:Y.$KK,Hover:Y.$qK,IndentAction:f.IndentAction,Location:Y.$nK,MarkdownString:Y.$BK,OverviewRulerLane:k.OverviewRulerLane,ParameterInformation:Y.$CK,PortAutoForwardAction:Y.PortAutoForwardAction,Position:Y.$cK,ProcessExecution:Y.$VK,ProgressLocation:Y.ProgressLocation,QuickInputButtons:Y.$vL,Range:Y.$dK,RelativePattern:Y.$0K,Selection:Y.$eK,SelectionRange:Y.$wK,SemanticTokens:Y.$sL,SemanticTokensBuilder:Y.$rL,SemanticTokensEdit:Y.$tL,SemanticTokensEdits:Y.$uL,SemanticTokensLegend:Y.$qL,ShellExecution:Y.$WK,ShellQuoting:Y.ShellQuoting,SignatureHelp:Y.$EK,SignatureHelpTriggerKind:Y.SignatureHelpTriggerKind,SignatureInformation:Y.$DK,SnippetString:Y.$mK,SourceBreakpoint:Y.$aL,StandardTokenType:Y.StandardTokenType,StatusBarAlignment:Y.StatusBarAlignment,SymbolInformation:Y.$sK,SymbolKind:Y.SymbolKind,SymbolTag:Y.SymbolTag,Task:Y.$YK,TaskGroup:Y.$UK,TaskPanelKind:Y.TaskPanelKind,TaskRevealKind:Y.TaskRevealKind,TaskScope:Y.TaskScope,TerminalLink:Y.$QK,TerminalQuickFixExecuteTerminalCommand:Y.$SK,TerminalQuickFixOpener:Y.$RK,TerminalLocation:Y.TerminalLocation,TerminalProfile:Y.$TK,TerminalExitReason:Y.TerminalExitReason,TextDocumentSaveReason:Y.TextDocumentSaveReason,TextEdit:Y.$iK,SnippetTextEdit:Y.$kK,TextEditorCursorStyle:l.TextEditorCursorStyle,TextEditorLineNumbersStyle:Y.TextEditorLineNumbersStyle,TextEditorRevealType:Y.TextEditorRevealType,TextEditorSelectionChangeKind:Y.TextEditorSelectionChangeKind,SyntaxTokenType:Y.SyntaxTokenType,TextDocumentChangeReason:Y.TextDocumentChangeReason,ThemeColor:Y.$9K,ThemeIcon:Y.$8K,TreeItem:Y.$ZK,TreeItemCheckboxState:Y.TreeItemCheckboxState,TreeItemCollapsibleState:Y.TreeItemCollapsibleState,TypeHierarchyItem:Y.$RL,UIKind:p.UIKind,Uri:A.URI,ViewColumn:Y.ViewColumn,WorkspaceEdit:Y.$lK,DocumentDropEdit:Y.$6K,DocumentPasteEdit:Y.$7K,InlayHint:Y.$GK,InlayHintLabelPart:Y.$FK,InlayHintKind:Y.InlayHintKind,RemoteAuthorityResolverError:Y.$hK,ResolvedAuthority:Y.$fK,ManagedResolvedAuthority:Y.$gK,SourceControlInputBoxValidationType:Y.SourceControlInputBoxValidationType,ExtensionRuntime:Y.ExtensionRuntime,TimelineItem:Y.$GL,NotebookRange:Y.$yL,NotebookCellKind:Y.NotebookCellKind,NotebookCellExecutionState:Y.NotebookCellExecutionState,NotebookCellData:Y.$zL,NotebookData:Y.$AL,NotebookRendererScript:Y.$EL,NotebookCellStatusBarAlignment:Y.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Y.NotebookEditorRevealType,NotebookCellOutput:Y.$CL,NotebookCellOutputItem:Y.$BL,NotebookCellStatusBarItem:Y.$DL,NotebookControllerAffinity:Y.NotebookControllerAffinity,NotebookControllerAffinity2:Y.NotebookControllerAffinity2,NotebookEdit:Y.$jK,NotebookKernelSourceAction:Y.$FL,PortAttributes:Y.$IL,LinkedEditingRanges:Y.$HL,TestResultState:Y.TestResultState,TestRunRequest:Y.$JL,TestMessage:Y.$KL,TestMessage2:Y.$KL,TestTag:Y.$LL,TestRunProfileKind:Y.TestRunProfileKind,TextSearchCompleteMessageType:it.TextSearchCompleteMessageType,DataTransfer:Y.$5K,DataTransferItem:Y.$1K,CoveredCount:Y.$ML,FileCoverage:Y.$NL,StatementCoverage:Y.$OL,BranchCoverage:Y.$PL,FunctionCoverage:Y.$QL,WorkspaceTrustState:Y.WorkspaceTrustState,LanguageStatusSeverity:Y.LanguageStatusSeverity,QuickPickItemKind:Y.QuickPickItemKind,InputBoxValidationSeverity:Y.InputBoxValidationSeverity,TabInputText:Y.$SL,TabInputTextDiff:Y.$TL,TabInputTextMerge:Y.$UL,TabInputCustom:Y.$VL,TabInputNotebook:Y.$XL,TabInputNotebookDiff:Y.$YL,TabInputWebview:Y.$WL,TabInputTerminal:Y.$ZL,TabInputInteractiveWindow:Y.$1L,TelemetryTrustedValue:ye.$fo,LogLevel:ve.LogLevel,EditSessionIdentityMatch:mt.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Y.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:Y.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:Y.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Y.$hL,ThreadFocus:Y.$iL,RelatedInformationType:Y.RelatedInformationType}}}e.$Pdc=Kt}),define(Re[273],Me([1,0,69,109,33,107,34,31,59,62,111,113,114,84,86,80,108,61,39,83,57,60,241,14,112,81,82]),function(be,e,w,M,C,F,A,l,k,f,R,D,c,p,$,g,t,n,a,b,E,v,r,s,i,o,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,w.$sr)(o.$qcc,o.$pcc,1),(0,w.$sr)(s.$9i,r.$Qdc,1),(0,w.$sr)(g.$Pbc,g.$Qbc,1),(0,w.$sr)(l.$wM,l.$vM,0),(0,w.$sr)(A.$3bc,A.$1bc,0),(0,w.$sr)(n.$fcc,n.$ecc,0),(0,w.$sr)(D.$6cc,D.$0cc,0),(0,w.$sr)(F.$Xcc,F.$Wcc,0),(0,w.$sr)(k.$lM,k.$kM,0),(0,w.$sr)(y.$rcc,y.$scc,0),(0,w.$sr)(a.$Mbc,a.$Lbc,0),(0,w.$sr)(M.$Dcc,M.$Ccc,1),(0,w.$sr)(c.$ddc,c.$edc,0),(0,w.$sr)(p.$bcc,p.$acc,0),(0,w.$sr)(R.$1cc,R.$Zcc,0),(0,w.$sr)(f.$icc,f.$lcc,0),(0,w.$sr)($.$Wvb,$.$Xvb,0),(0,w.$sr)(t.$Tcc,t.$Scc,0),(0,w.$sr)(C.$Zbc,C.$Ybc,0),(0,w.$sr)(b.$ncc,b.$mcc,0),(0,w.$sr)(E.$uM,E.$rM,0),(0,w.$sr)(v.$2cc,v.$3cc,0),(0,w.$sr)(i.$4cc,i.$5cc,0)}),define(Re[274],Me([1,0,272,35,2,269,7,12,260]),function(be,e,w,M,C,F,A,l,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zfc=void 0;class f extends F.$Tdc{j(){}getModule(p,$){for(const g of this.b){const t=g(p);if(t){p=t;break}}if(this.a.has(p))return this.a.get(p).load(p,$,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class R extends M.$ucc{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Webworker}async tb(){this.h.createInstance(k.$Yfc);const p=this.h.invokeFunction(w.$Pdc);this.r=this.h.createInstance(f,p,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.zb()}ub(p){return p.browser}async vb(p,$,g){$=$.with({path:D($.path,".js")});const t=p?.identifier.value;t&&performance.mark(`code/extHost/willFetchExtensionCode/${t}`);const n=C.URI.revive(await this.C.$asBrowserUri($)),a=await fetch(n.toString(!0));if(t&&performance.mark(`code/extHost/didFetchExtensionCode/${t}`),a.status!==200)throw new Error(a.statusText);const b=await a.text(),E=`${$.toString(!0)}#vscode-extension`,v=`${b}
//# sourceURL=${E}`;let r;try{r=new Function("module","exports","require",v)}catch(y){throw console.error(t?`Loading code for extension ${t} failed: ${y.message}`:`Loading code failed: ${y.message}`),console.error(`${$.toString(!0)}${typeof y.line=="number"?` line ${y.line}`:""}${typeof y.column=="number"?` column ${y.column}`:""}`),console.error(y),y}p&&await this.w.initializeLocalizedMessages(p);const s={},i={exports:s},o=y=>{const d=this.r.getModule(y,$);if(d===void 0)throw new Error(`Cannot load module '${y}'`);return d};try{return g.codeLoadingStart(),t&&performance.mark(`code/extHost/willLoadExtensionCode/${t}`),r(i,s,o),i.exports!==s?i.exports:s}finally{t&&performance.mark(`code/extHost/didLoadExtensionCode/${t}`),g.codeLoadingStop()}}async $setRemoteEnvironment(p){}async zb(p=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const $=Date.now()+p;for(;Date.now()<$&&!("__jsDebugIsReady"in globalThis);)await(0,l.$Tg)(10)}}e.$Zfc=R;function D(c,p){return c.endsWith(p)?c:c+p}}),define(Re[275],Me([1,0,68,69,14,35,187,85,274]),function(be,e,w,M,C,F,A,l,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,M.$sr)(C.$8i,new w.$Kh(A.$Sdc,[!0],!0)),(0,M.$sr)(F.$vcc,k.$Zfc,0),(0,M.$sr)(l.$gcc,l.$hcc,0)}),define(Re[284],Me([1,0,26,5,79,270,262,19,87,13,2,273,275]),function(be,e,w,M,C,F,A,l,k,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const D=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const c=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function p(r){return/^(file|vscode-remote):/i.test(r)}const $=fetch.bind(self);function g(r){self.fetch=async function(s,i){return s instanceof Request||p(String(s))&&(s=(await r(R.URI.parse(String(s)))).toString(!0)),$(s,i)},self.XMLHttpRequest=class extends XMLHttpRequest{open(s,i,o,y,d){(async()=>(p(i.toString())&&(i=(await r(R.URI.parse(i.toString()))).toString(!0)),super.open(s,i,o??!0,y,d)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const r=self.Worker;Worker=function(s,i){if(/^file:/i.test(s.toString()))s=f.$bg.uriToBrowserUri(R.URI.parse(s.toString())).toString(!0);else if(/^vscode-remote:/i.test(s.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const y=`(${function(u){function m(W){return typeof W=="string"||W instanceof URL?String(W).replace(/^file:\/\//i,"vscode-file://vscode-app"):W}const h=fetch.bind(self);self.fetch=function(W,K){return W instanceof Request?h(W,K):h(m(W),K)},self.XMLHttpRequest=class extends XMLHttpRequest{open(W,K,U,B,O){return super.open(W,m(K),U??!0,B,O)}};const P=importScripts.bind(self);self.importScripts=(...W)=>{P(...W.map(m))},P(u)}.toString()}('${s}'))`;i=i||{},i.name=i.name||l.$mc(s.toString());const d=new Blob([y],{type:"application/javascript"}),I=URL.createObjectURL(d);return new r(I,i)}}else self.Worker=class extends A.$1fc{constructor(r,s){super(c,r,{name:l.$mc(r.toString()),...s})}};const t=new class{constructor(){this.pid=void 0}exit(r){D()}};class n{constructor(){const s=new MessageChannel,i=new M.$Md;let o=!1;c(s.port2,[s.port2]),s.port1.onmessage=y=>{const{data:d}=y;if(!(d instanceof ArrayBuffer)){console.warn("UNKNOWN data received",d);return}const I=w.$ae.wrap(new Uint8Array(d,0,d.byteLength));if((0,C.$$l)(I,2)){o=!0,b("received terminate message from renderer");return}i.fire(I)},this.protocol={onMessage:i.event,send:y=>{if(!o){const d=y.buffer.buffer.slice(y.buffer.byteOffset,y.buffer.byteOffset+y.buffer.byteLength);s.port1.postMessage(d,[d])}}}}}function a(r){return new Promise(s=>{const i=r.onMessage(o=>{i.dispose();const y=JSON.parse(o.toString());r.send((0,C.$0l)(0)),s({protocol:r,initData:y})});r.send((0,C.$0l)(1))})}let b=r=>D();function E(r){return!!r&&typeof r=="object"&&r.type==="vscode.init"&&r.data instanceof Map}function v(){k.mark("code/extHost/willConnectToRenderer");const r=new n;return{onmessage(s){E(s)&&a(r.protocol).then(i=>{k.mark("code/extHost/didWaitForInitData");const o=new F.$Vdc(i.protocol,i.initData,t,null,s.data);g(y=>o.asBrowserUri(y)),b=y=>o.terminate(y)})}}}e.create=v})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/eb4f3c149f34d82b9763a08230907cf79e7fc103/core/vs/workbench/api/worker/extensionHostWorker.js.map
